dos_header:

db "MZ"

dw 0, 1, 0, 4/*Header size in paragraphs*/, 0, 0
dw 0, 0xFFFE  // stack
dw 0  // csum
dw offset dos_main, 0  // ip, cs
dw 0, 0
dw 0, 0, 0, 0, 0, 0
dd 0, 0, 0, 0, 0
dd offset pe_header  // lfanew

[bits 16]

dos_str: db "Requires 32 bit OS\0"

dos_writez:

l_dos_writez_1:
  mov al, [cs:si]
  inc si
  or al, al
  jz l_dos_writez_9
    mov ah, 0Eh
    xor bh, bh
    int 10h
    jmp l_dos_writez_1

l_dos_writez_9:
ret


dos_main:
mov si, offset dos_str
call dos_writez

dos_end:
mov ax, 4C00h
int 21h

MAX_PATH = 260

// Error Codes
ERC_HARDWARE            = 2
ERC_OUT_OF_RANGE        = 5
ERC_DISK_CHANGED        = 6
ERC_NOT_FLUSHED         = 7
ERC_DISK_IO             = 8
ERC_INVALID_DISK_NUMBER = 10h
ERC_NOT_FOUND_IN_CACHE  = 12h  // internal
ERC_UNKNOWN_GEOMETRY    = 15h
ERC_DISK_FULL           = 16h

ERC_INVALID_CHANNEL_NUMBER = 18h
ERC_INVALID_MEMORY_ADDRESS = 19h
ERC_INVALID_COUNT          = 1Ah

ERC_NOT_ENOUGH_MEMORY = 21h
ERC_ALIGN             = 24h
ERC_ALREADY_FREE      = 25h
ERC_OVERFLOW          = 26h
ERC_UNDERFLOW         = 27h

ERC_MSG_QUEUE_EMPTY    = 30h
ERC_MSG_QUEUE_FULL     = 31h
ERC_MSG_INVALID_TARGET = 32h

ERC_TOO_MANY_WINDOWS = 33h
ERC_INVALID_WINDOW   = 34h
ERC_CANT_MOVESIZE    = 35h
ERC_UNKNOWN_CLASS    = 36h

ERC_TOO_MANY_PROCS   = 40h
ERC_TOO_MANY_THREADS = 41h

ERC_TIMER_FULL      = 42
ERC_TIMER_NOT_FOUND = 43

ERC_PATH_NOT_FOUND = 44h
ERC_FILE_NOT_FOUND = 45h
ERC_TOO_MANY_OPEN_FILES = 46h
ERC_DIR_ALREADY_EXISTS = 47h
ERC_UNKNOWN_FILESYSTEM = 48h
ERC_DIR_NOT_EMPTY = 49h
ERC_CANT_REMOVE = 4Ah
ERC_DUPLICATE_NAME = 4Bh
ERC_INVALID_FHANDLE = 4Ch
ERC_INVALID_THREAD = 4Dh
ERC_FS = 4Eh
ERC_READ_ONLY = 4Fh
ERC_IN_USE = 50h
ERC_OUT_OF_DISK = 51h
ERC_TOO_MANY_SEARCHES = 52h
ERC_INVALID_SHANDLE = 53h
ERC_CANT_RENAME = 54h

ERC_INVALID_PID = 55h
ERC_STACK_OVERFLOW = 56h
ERC_PE_INVALID_HEADER = 57h
ERC_INVALID_SERVICE = 58h

ERC_TOO_LONG = 59h
ERC_ONLY_STARTER = 5Ah
ERC_INVALID_MEMORY_LOCATION = 5Bh
ERC_INVALID_THREADID = 5Ch
ERC_ACCESS_DENIED = 5Dh
ERC_INVALID_PRIORITY = 5Eh
ERC_INVALID_ATRBS = 5Fh
ERC_INVALID_VALUE = 60h
ERC_INVALID_POINTER = 61h
ERC_INVALID_CHAR = 62h
ERC_DISK_REMOVED = 63h
ERC_TOO_BIG_HOLE = 64h  // internal
ERC_UTF8 = 65h
ERC_BUSY = 66h
ERC_DIR_TOO_BIG = 67h
ERC_LINK = 68h  // internal
ERC_NOT_A_LINK = 69h
ERC_INFINITE_LINK = 70h
ERC_CANT_MOVE = 71h
ERC_FILE_TOO_BIG = 72h
ERC_NOT_FIT_IN_MFT = 73h
ERC_INVALID_LINK = 74h

ERC_PE_IMPORT_DEPTH_OVERFLOW = 75h
ERC_PE_INVALID_ADR = 76h
ERC_PE_NOT_FOUND = 77h
ERC_PE_ORDINAL = 78h

ERC_INVALID_IMAGE = 79h

ERC_NOT_IMPLEMENTED     = 0FFh

// Window = 32 B (winid)
struct WinRec{
  int2 x, y, w, h
  uns4 flags, cr3, hwnd, pbitmap, pid
  uns1 kbd, parent
  uns1 ncheight, desktop
}

// Window Ex (hwnd)
struct WindowExRec{
  uns4 next, prev, first_child, pmenu, ptext, pclass, menusx
  int2 x, y, w, h
  uns4 winid, pid, hinstance
  uns4 exstyle, style, id, parent, wndproc
}

struct WndClassRec{
  int4 cbSize
  uns4 style
  ptr4 lpfnWndProc
  int4 cbClsExtra
  int4 cbWndExtra
  uns4 hInstance
  ptr4 hIcon
  ptr4 hCursor
  uns4 hbrBackground
  ptr4 lpszMenuName
  ptr4 lpszClassName
  ptr4 hIconSm
  ptr4 next // only tryskos
}

struct PointRec{
  int4 x, y
}

struct MessageRec{
  ptr4 hwnd
  uns4 message
  uns4 wParam
  uns4 lParam
  uns4 time
  PointRec pt
}

struct DCRec{
  int2 x0, y0, x1, y1, x2, y2, x, y
  ptr4 pbitmap, pen, brush, rgn, font, lppaintstruct
  uns4 textcolor
}

struct RectRec{
  int4 left, top, right, bottom
}

GDIOBJ_PEN = 1
GDIOBJ_BRUSH = 2
GDIOBJ_RGN = 3
GDIOBJ_FONT = 4

struct PenRec{
  uns4 type, color, size
}

struct BrushRec{
  uns4 type, flags, color1, color2, pbrushfn
  int2 x1, y1, x2, y2
}

struct RgnRec{
  uns4 type, flags
  int2 left, top, right, bottom
}

struct FontRec{
  uns4 type, rotation, pfont
  bool bold, italics, underline, strike
  char name[64]
}

struct PaintStruct {
	ptr4 hdc; // 0
	uns4 fErase; // 4
	RectRec rcPaint; // 8
	uns4 fRestore; // 24
	uns4 fIncUpdate; // 28
	uns1 rgbReserved[32]; // 32
}

// BitBlt
BLACKNESS = 0x42
NOTSRCERASE = 0x1100A6
NOTSRCCOPY = 0x330008
SRCERASE = 0x440328
DSTINVERT = 0x550009
PATINVERT = 0x5A0049
SRCINVERT = 0x660046
SRCAND = 0x8800C6
MERGEPAINT = 0xBB0226
MERGECOPY = 0xC000CA
SRCCOPY = 0xCC0020
SRCMERGE = 0xDD0022
SRCPAINT = 0xEE0086
WHITENESS = 0xFF0062

// GetStockObject
BLACK_BRUSH = 4
DKGRAY_BRUSH = 3
GRAY_BRUSH = 2
HOLLOW_BRUSH = 5
LTGRAY_BRUSH = 1
NULL_BRUSH = 5
WHITE_BRUSH = 0
BLACK_PEN = 7
NULL_PEN = 8
WHITE_PEN = 6
ANSI_FIXED_FONT = 11
ANSI_VAR_FONT = 12
DEVICE_DEFAULT_FONT = 14
DEFAULT_GUI_FONT = 17
OEM_FIXED_FONT = 10
SYSTEM_FONT = 13
SYSTEM_FIXED_FONT = 16
DEFAULT_PALETTE = 15

struct DateTime8{
  uns8 datetime
}

struct SearchRec{
  uns4 FileAttributes
  DateTime8 CreationTime
  DateTime8 LastAccessTime
  DateTime8 LastWriteTime
  uns8 FileSize
  uns8 Reserved
  char FileName[MAX_PATH]
  char AlternateFileName[14]
}

struct SystemTime{
  uns2 wYear
  uns2 wMonth
  uns2 wDayOfWeek
  uns2 wDay
  uns2 wHour
  uns2 wMinute
  uns2 wSecond
  uns2 wMilliseconds
}

MAX_WIN = 255
WIN_NONE = 255
WIN_MAINPANELH = 0
WIN_HEADER = 16
WIN_BORDER = 6
WIN_CORNER = 16
WIN_MINW = 64 + (WIN_BORDER * 2)
WIN_MINH = WIN_HEADER + (WIN_BORDER * 2)
WIN_MENUH = 16

WIN_DEFAULT_X_STEP = 32
WIN_DEFAULT_Y_STEP = 32
WIN_DEFAULT_X_MAX = 250
WIN_DEFAULT_Y_MAX = 250
WIN_BORDERCOLOR = 0xFF0080FF
WIN_HEADERCOLOR = 0xFF0080FF
WIN_FRAMECOLOR = 0xFF000000
WIN_ACTIVEFRAMECOLOR = 0xFFFFFF00
WIN_CLOSECOLOR = 0xFFE04040
WIN_MAXIMIZECOLOR = 0xFFA0A0A0
WIN_LIGHT = 0xFFFFFFFF
WIN_DARK = 0xFF606060

WINFLAGS_VALID = 1
WINFLAGS_FULLSCREEN = 2
WINFLAGS_ALWAYSONTOP = 8
WINFLAGS_CLOSEPRESSED    = 0x10
WINFLAGS_MAXIMIZEPRESSED = 0x20
WINFLAGS_MINIMIZEPRESSED = 0x40

// wp of mousemove
MK_LBUTTON  = 0x0001
MK_RBUTTON  = 0x0002
MK_SHIFT    = 0x0004
MK_CONTROL  = 0x0008
MK_MBUTTON  = 0x0010
MK_XBUTTON1 = 0x0020
MK_XBUTTON2 = 0x0040

WS_TABSTOP     = 0x00010000
WS_MAXIMIZEBOX = 0x00010000
WS_GROUP       = 0x00020000
WS_MINIMIZEBOX = 0x00020000
WS_SIZEBOX     = 0x00040000
WS_SYSMENU     = 0x00080000
WS_HSCROLL     = 0x00100000
WS_VSCROLL     = 0x00200000
WS_DLGFRAME    = 0x00400000
WS_BORDER      = 0x00800000
WS_CAPTION     = 0x00C00000
WS_MAXIMIZE    = 0x01000000
WS_DISABLED    = 0x08000000
WS_VISIBLE     = 0x10000000
WS_MINIMIZE    = 0x20000000
WS_CHILD       = 0x40000000
WS_POPUP       = 0x80000000
WS_OVERLAPPEDWINDOW = WS_CAPTION | WS_SYSMENU | WS_SIZEBOX | WS_MINIMIZEBOX | WS_MAXIMIZEBOX
WS_POPUPWINDOW = WS_POPUP | WS_BORDER | WS_SYSMENU

CW_USEDEFAULT = -1

SWP_NOSIZE = 1
SWP_NOMOVE = 2
SWP_NOZORDER = 4
SWP_NOREDRAW = 8
SWP_NOACTIVATE = 0x10
SWP_DRAWFRAME = 0x20
SWP_FRAMECHANGED = 0x20
SWP_SHOWWINDOW = 0x40
SWP_HIDEWINDOW = 0x80
SWP_NOCOPYBITS = 0x100
SWP_NOOWNERZORDER = 0x200
SWP_NOREPOSITION = 0x200
SWP_NOSENDCHANGING = 0x400
SWP_RELSIZE = 0x1000
SWP_RELMOVE = 0x2000

SW_HIDE = 0
SW_NORMAL = 1
SW_MAXIMIZE = 3
SW_SHOW = 5
SW_MINIMIZE = 6
SW_RESTORE = 9

RDW_INVALIDATE = 1
RDW_INTERNALPAINT = 2
RDW_ERASE = 4
RDW_VALIDATE = 8
RDW_NOINTERNALPAINT = 16
RDW_NOERASE = 32
RDW_NOCHILDREN = 64
RDW_ALLCHILDREN = 128
RDW_UPDATENOW = 256
RDW_ERASENOW = 512
RDW_FRAME = 1024
RDW_NOFRAME = 2048

WM_NULL = 0
WM_CREATE = 1
WM_DESTROY = 2
WM_MOVE = 3
WM_SIZE = 5
WM_ACTIVATE = 6
WM_SETFOCUS = 7
WM_KILLFOCUS = 8
WM_ENABLE = 10
WM_SETREDRAW = 11
WM_SETTEXT = 12
WM_GETTEXT = 13
WM_GETTEXTLENGTH = 14
WM_PAINT = 15
WM_CLOSE = 16
WM_QUERYENDSESSION = 17
WM_QUIT = 18
WM_QUERYOPEN = 19
WM_ERASEBKGND = 20
WM_SYSCOLORCHANGE = 21
WM_ENDSESSION = 22
WM_SHOWWINDOW = 24
WM_WINDOWPOSCHANGED = 47h
WM_NCPAINT = 85h
WM_NCMOUSEMOVE = 0A0h
WM_NCLBUTTONDOWN = 0A1h
WM_NCLBUTTONUP = 0A2h
WM_NCLBUTTONDBLCLK = 0A3h
WM_NCRBUTTONDOWN = 0A4h
WM_NCRBUTTONUP = 0A5h
WM_NCRBUTTONDBLCLK = 0A6h
WM_NCMBUTTONDOWN = 0A7h
WM_NCMBUTTONUP = 0A8h
WM_NCMBUTTONDBLCLK = 0A9h
WM_NCXBUTTONDOWN = 0ABh
WM_NCXBUTTONUP = 0ACh
WM_NCXBUTTONDBLCLK = 0ADh
WM_KEYDOWN    = 100h
WM_KEYUP      = 101h
WM_CHAR       = 102h
WM_SYSKEYDOWN = 104h
WM_SYSKEYUP   = 105h
WM_COMMAND = 111h
WM_TIMER   = 113h
WM_TERMINATED   = 180h
WM_NEW_CLIP     = 181h
WM_WINDOWCLOSED = 182h
WM_SCROLL       = 183h
WM_MOUSEBUTTON  = 184h
WM_MAINPANELHCHANGED = 185h
WM_NCMOUSEOVER  = 186h
WM_CHARIO       = 187h
WM_PAINTBUTTONS = 188h
WM_MOUSEOVER    = 189h
WM_DISKCHANGED  = 18Ah
WM_USB_INT = 1A0h
WM_MOUSEMOVE = 200h
WM_LBUTTONDOWN = 201h
WM_LBUTTONUP = 202h
WM_LBUTTONDBLCLK = 203h
WM_RBUTTONDOWN = 204h
WM_RBUTTONUP = 205h
WM_RBUTTONDBLCLK = 206h
WM_MBUTTONDOWN = 207h
WM_MBUTTONUP = 208h
WM_MBUTTONDBLCLK = 209h
WM_MOUSEWHEEL = 20Ah
WM_XBUTTONDOWN = 20Bh
WM_XBUTTONUP = 20Ch
WM_XBUTTONDBLCLK = 20Dh
WM_MOUSEHWHEEL = 20Eh
WM_DEVICECHANGE = 219h

IMAGE_BASE = 0x7DAB0000

COFS = IMAGE_BASE + 0x1000 - 0x400
CRVA = 0x1000 - 0x400

FOPEN_READ = 1
FOPEN_WRITE = 3
FOPEN_APPEND = 10h
FOPEN_CREATE = 20h

ACCESS_R = 4 //read
ACCESS_W = 2 //write
ACCESS_X = 1 //execute

struct StringBuilder{
  uns4 len, max
  ptr4 data
}

[dorg 0x7DAB8000]

uns8 num, time
uns4 time_zone

[align 32]

pe_header:

db "PE"

dw 0, 14Ch, 2/*Number of sections*/
dd 0, 0/*Pointer to symbol table*/, 0/*Number of symbols*/
dw 224 /*Size of optional header*/, 0 /*Characteristics*/

// Optional header
dw 0/*OH magic*/

db 0, 0
dd offset lastoffset /*Size of code*/
dd 0/*Size of initialized data*/, # - 0x7DAB8000/*Size of uninitialized data*/
dd offset main + CRVA/*Address of entry point*/
dd 0/*Base of code*/, 0x10000/*Base of data*/

dd IMAGE_BASE/*Image base*/
dd 0x1000 /*Section alignment*/, 0x200 /*File alignment*/
dw 4, 0 /*OS version*/, 0, 0 /*Image version*/, 4, 0 /*Subsystem version*/
dd 0, 0x10000/*Size of image*/, 0x400/*Size of headers*/
dd 0 /*Checksum*/
dw 1/*Subsystem*/, 0/*DLL characteristics*/
dd 0x100000/*stack*/, 0x1000
dd 0x100000/*heap*/, 0x1000
dd 0/*Loader flags*/, 16/*RVA and sizes*/

// export
dd offset export + CRVA, 0x1000//...size of export
// import
dd 0,0
// other directories
dd 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0

// Section table [lfanew + 18h + sizeOfOptionalHeader]
db ".text   "
dd offset lastoffset // VSize
dd 0x1000 // RVA
dd offset lastoffset // Size of raw data
dd 0x400 // Pointer to raw data
dd 0 // Pointer to relocations
dd 0 // Pointer to line numbers
dw 0 // Number of relocations
dw 0 // Number of line numbers
dd 0x60000060 // Characteristics

db ".data   "
dd # - 0x7DAB8000 // VSize
dd 0x8000 // RVA
dd 0 // Size of raw data
dd 0 // Pointer to raw data
dd 0 // Pointer to relocations
dd 0 // Pointer to line numbers
dw 0 // Number of relocations
dw 0 // Number of line numbers
dd 0xC0000040 // Characteristics

times 0x400 - $, 0

[bits 32]

jmp main

// IN: dl = x, dh = y
curto:
push ecx
 push esi
  push edx
   push edi
    push ebx
  
     mov ah, 3
     int 20h
  
    pop ebx
   pop edi
  pop edx
 pop esi
pop ecx
ret

// IN: esi -> string, ecx = length, bl = color
write:
push edx
 push edi
  push ebx
  
  mov ah, 2
  int 20h
  
  pop ebx
 pop edi
pop edx
ret

// IN: eax = number, ecx = system, bl = color
writen:
push ecx
 push edx
  push esi
   push edi

    sub esp, 36

	// Parse digits from the number

	mov esi, esp
	add esi, 36
	cmp ecx, 2
	jnb l_writen_1
		mov ecx, 10		// ecx must be >= 2

	l_writen_1:
		xor edx, edx
		div ecx
		cmp dl, 10
		jnb l_writen_2
			add dl, '0'
			jmp short l_writen_3

		l_writen_2:
			add dl, 55

		l_writen_3:
		dec esi
		mov [esi], dl
		or eax, eax
		jnz l_writen_1
	
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	mov dl, ' '
	
      dec esi
      inc ecx
      mov [esi], dl
      
	call write
	
    add esp, 36

    pop edi
  pop esi
 pop edx
pop ecx
ret

// IN: eax = number, ecx = system, bl = color, bh = minlen
writemin:
push ecx
 push edx
  push esi
   push edi

    sub esp, 36

	// Parse digits from the number

	mov esi, esp
	add esi, 36
	cmp ecx, 2
	jnb l_writemin_1
		mov ecx, 10		// ecx must be >= 2

	l_writemin_1:
		xor edx, edx
		div ecx
		cmp dl, 10
		jnb l_writemin_2
			add dl, '0'
			jmp short l_writemin_3

		l_writemin_2:
			add dl, 55

		l_writemin_3:
		dec esi
		mov [esi], dl
		or eax, eax
		jnz l_writemin_1
	
	cmp bh, 36
	jb l_writemin_4
	  mov bh, 36
	  
	l_writemin_4:
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	mov dl, ' '
	
	l_writemin_5:
	  cmp cl, bh
	  jnb l_writemin_6
          dec esi
          inc ecx
          mov [esi], dl
          jmp short l_writemin_5
      
	l_writemin_6:	  
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	
	call write
	
    add esp, 36

    pop edi
  pop esi
 pop edx
pop ecx
ret

THOUSAND_SEPARATOR = ','

// IN: edx:eax = number, ecx = system, bl = color
writen8:
push ecx
 push esi
  push edi

    sub esp, 72

    // Parse digits from the number
    mov esi, esp
    add esi, 72

    mov dword ptr num[0], eax
    mov dword ptr num[4], edx
    xor bh, bh

    cmp ecx, 2
    jnb l_writen8_1
      mov ecx, 10		// ecx must be >= 2
    
    l_writen8_1:
      cmp bh, 3
      jb l_writen_12
        dec esi
        mov byte ptr [esi], THOUSAND_SEPARATOR
        xor bh, bh
        
      l_writen_12:
      inc bh
      xor edx, edx
      mov eax, dword ptr num[4]
      div ecx
      mov dword ptr num[4], eax
      mov eax, dword ptr num[0]
      div ecx
      mov dword ptr num[0], eax
      
      cmp dl, 10
      jnb l_writen8_2
        add dl, '0'
        jmp short l_writen8_3
      
      l_writen8_2:
        add dl, 55
      
      l_writen8_3:
      dec esi
      mov [esi], dl
      
      mov eax, dword ptr num[0]
      mov edx, dword ptr num[4]
      test eax, eax
      jnz l_writen8_1
        test edx, edx
        jnz l_writen8_1
      
    mov ecx, esp
    add ecx, 72
    sub ecx, esi  // ecx = len
    mov dl, ' '
    
    dec esi
    inc ecx
    mov [esi], dl
     
    call write
     
    add esp, 72
    
  pop edi
 pop esi
pop ecx
ret

// IN: edx -> path & mask, edi -> SearchRec
// OUT: al = 0 || erc
find_first:
mov ah, 22
int 20h
cmp al, ERC_BUSY
jnz l_find_first_9
  call noop
  jmp short find_first
  
l_find_first_9:
ret

// IN: edi -> SearchRec
// OUT: al = 0 || erc
find_next:
mov ah, 23
int 20h
cmp al, ERC_BUSY
jnz l_find_next_9
  call noop
  jmp short find_next
  
l_find_next_9:
ret

// IN: edi -> SearchRec
find_close:
mov ah, 48
int 20h
ret

// IN: edx -> pathz
cdir:
mov ah, 16
int 20h
cmp al, ERC_BUSY
jnz l_cdir_9
  call noop
  jmp short cdir
  
l_cdir_9:
ret

// IN: edi -> buffer[MAX_PATH]
// OUT: al = 0 || erc
get_current_directory:
mov ah, 52
int 20h
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fopen:
mov esi, 3
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fopen_9
  call noop
  jmp short fopen
  
l_fopen_9:
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fopenread:
mov esi, 1
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fopenread_9
  call noop
  jmp short fopenread
  
l_fopenread_9:
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fcreate:
mov esi, 20h
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fcreate_9
  call noop
  jmp short fcreate
  
l_fcreate_9:
ret

// IN: ebx = fhandle
// OUT: edx:ecx = fpos
fgetpos:
mov ah, 14
int 20h
cmp al, ERC_BUSY
jnz l_fgetpos_9
  call noop
  jmp short fgetpos
  
l_fgetpos_9:
ret

// IN: ebx = fhandle, edx:edi = file offset
// OUT: al = erc
fsetpos:
mov ah, 12
int 20h
cmp al, ERC_BUSY
jnz l_fsetpos_9
  call noop
  jmp short fsetpos
  
l_fsetpos_9:
ret

// IN: ebx = fhandle
// OUT: edx:ecx = fsize
fgetsize:
mov ah, 15
int 20h
cmp al, ERC_BUSY
jnz l_fgetsize_9
  call noop
  jmp short fgetsize
  
l_fgetsize_9:
ret

// IN: ebx = fhandle
fclose:
mov ah, 9
int 20h
cmp al, ERC_BUSY
jnz l_fclose_9
  call noop
  jmp short fclose
  
l_fclose_9:
ret

// IN: ebx = fhandle, edi -> data, ecx = size
// OUT: al = erc, ecx = size read
fread:
mov ah, 10
int 20h
cmp al, ERC_BUSY
jnz l_fread_9
  call noop
  jmp short fread
  
l_fread_9:
ret

// IN: ebx = fhandle, edi -> data, ecx = size
// OUT: al = erc, ecx = size write
fwrite:
mov ah, 11
int 20h
cmp al, ERC_BUSY
jnz l_fwrite_9
  call noop
  jmp short fwrite
  
l_fwrite_9:
ret

// IN: edx -> filenamez
rm:
mov ah, 18
int 20h
cmp al, ERC_BUSY
jnz l_rm_9
  call noop
  jmp short rm
  
l_rm_9:
ret

// IN: edx -> filenamez
md:
mov ah, 17
int 20h
cmp al, ERC_BUSY
jnz l_md_9
  call noop
  jmp short md
  
l_md_9:
ret

// IN: edx -> path & filenamez, esi -> new filenamez
// OUT: al = erc
ren:
mov ah, 20
int 20h
cmp al, ERC_BUSY
jnz l_ren_9
  call noop
  jmp short ren
  
l_ren_9:
ret

// IN: edx -> filenamez, esi -> new path
mv:
mov ah, 21
int 20h
cmp al, ERC_BUSY
jnz l_mv_9
  call noop
  jmp short mv
  
l_mv_9:
ret

// IN: esi = ldiskn
resetdisk:
mov ah, 63
int 20h
ret

// IN: edx -> filenamez, esi = mode
// OUT: al = erc, ebx = fhandle
open_link:
mov ah, 66
int 20h
cmp al, ERC_BUSY
jnz l_open_link_9
  call noop
  jmp short open_link
  
l_open_link_9:
ret

// IN: edx -> filenamez
// OUT: al = erc
rm_link:
mov ah, 67
int 20h
cmp al, ERC_BUSY
jnz l_rm_link_9
  call noop
  jmp short rm_link
  
l_rm_link_9:
ret

// IN: al = ldiskn
// OUT: al = erc
flush:
movzx esi, al

l_flush_1:
mov ah, 39 
int 20h
cmp al, ERC_BUSY
jnz l_flush_9
  call noop
  jmp short l_flush_1
  
l_flush_9:
ret

// IN: ebx = fhandle
// OUT: al = erc, edx:ecx = ftime
get_mtime:
mov ah, 74
int 20h
cmp al, ERC_BUSY
jnz l_get_mtime_9
  call noop
  jmp short get_mtime
  
l_get_mtime_9:
ret

// IN: ebx = fhandle, edx:ecx = ftime
// OUT: al = erc
set_mtime:
mov ah, 75
int 20h
cmp al, ERC_BUSY
jnz l_set_mtime_9
  call noop
  jmp short set_mtime
  
l_set_mtime_9:
ret

// IN: edx -> filenamez, esi = atrbs
// OUT: al = errorcode
// differrent behavior for windows and linux
chmod:
mov ah, 76
int 20h
cmp al, ERC_BUSY
jnz l_chmod_9
  call noop
  jmp short chmod
  
l_chmod_9:
ret

// only starter, root
// IN: edx -> filenamez, esi = new owner
// OUT: al = erc
chown:
mov ah, 78
int 20h
cmp al, ERC_BUSY
jnz l_chown_9
  call noop
  jmp short chown
  
l_chown_9:
ret

// only starter, root or owner
// IN: edx -> filenamez, esi = new group
// OUT: al = erc
chgrp:
mov ah, 79
int 20h
cmp al, ERC_BUSY
jnz l_chgrp_9
  call noop
  jmp short chgrp
  
l_chgrp_9:
ret

// IN: edx -> filenamez
// OUT: al = erc, ecx = uid, edx = gid
fuidgid:
mov ah, 82
int 20h
cmp al, ERC_BUSY
jnz l_fuidgid_9
  call noop
  jmp short fuidgid
  
l_fuidgid_9:
ret

// only starter
// IN: edx:ebx = disk offset, ecx = size,
//     esi = logical disk number, edi -> target
disk_read:
mov ah, 36
int 20h
cmp al, ERC_BUSY
jnz l_disk_read_9
  call noop
  jmp short disk_read
  
l_disk_read_9:
ret

// only starter
// IN: edx:ebx = disk offset, ecx = size,
//     esi = logical disk number, edi -> source
disk_write:
mov ah, 37
int 20h
cmp al, ERC_BUSY
jnz l_disk_write_9
  call noop
  jmp short disk_write
  
l_disk_write_9:
ret

// OUT: al = logical disk number
get_boot_disk:
mov ah, 77
int 20h
movzx eax, al
ret

// OUT: al = logical disk number
get_users_disk:
mov ah, 83
int 20h
movzx eax, al
ret

// IN: esi = logical disk number
// OUT: al = type (2:fd, 3:cd, 4:hd), ah = pdiskn,
//      edx:ecx = disk size in sectors, edi:esi = base in sectors
get_disk_type:
mov ah, 53
int 20h
ret

// IN: esi = logical disk number
// OUT: edx:eax = disk size in bytes
get_disk_size:
mov ah, 38
int 20h
ret

// IN: al = ldiskn
// OUT: cl = erc, edx:eax = free bytes)
disk_free:
mov esi, eax

l_disk_free_1:
mov ah, 68
int 20h
cmp al, ERC_BUSY
jnz l_disk_free_9
  call noop
  jmp short l_disk_free_1
  
l_disk_free_9:
xchg eax, ecx
ret

// IN: al = ldiskn
// OUT: al = erc
reset_disk:
mov esi, eax

l_reset_disk_1:
mov ah, 63
int 20h
cmp al, ERC_BUSY
jnz l_reset_disk_9
  call noop
  jmp short l_reset_disk_1
  
l_reset_disk_9:
ret

// IN: edx:ebx = sector, ecx = count, edi -> data,
//     esi = physical HD number
disk_read_sector:
mov ah, 40
int 20h
cmp al, ERC_BUSY
jnz l_disk_read_sector_9
  call noop
  jmp short disk_read_sector
  
l_disk_read_sector_9:
ret

// IN: edx:ebx = sector, ecx = count, edi -> data,
//     esi = physical HD number
disk_write_sector:
mov ah, 41
int 20h
cmp al, ERC_BUSY
jnz l_disk_write_sector_9
  call noop
  jmp short disk_write_sector
  
l_disk_write_sector_9:
ret

noop:
mov ah, 0
int 20h
ret

// IN: ecx = size
// OUT: al = erc, ebx = ptr
malloc:
mov ah, 24
int 20h
ret

// IN: ebx = ptr
free:
mov ah, 25
int 20h
ret

// OUT: al = 0 || errorcode, ebx = wnd:sender, ecx = msg, edx = wp, esi = lp
getmsg:
mov ah, 5 // get system message
int 20h
or al, al
jz l_getmsg_9
  mov ah, 7 // get message
  int 20h
  or al, al
  jz l_getmsg_9
    mov ah, 45 // get pid, tid; OUT: edi = tid
    int 20h
    mov ah, 35 // stop thread
    int 20h
    jmp short getmsg
  
l_getmsg_9:
ret

// KEEP: ebx, ebp
waitkey:
push ebx
 push ebp

  l_waitkey_5:
    mov ah, 45 // get pid, tid; OUT: edi = tid
    int 20h
    mov ah, 35 // stop thread
    int 20h
    call getmsg
    cmp ecx, WM_KEYDOWN
    jnz l_waitkey_5

 pop ebp
pop ebx
ret

// IN: esi -> ftime, edi -> SystemTime
ftime2local:
mov eax, time_zone
mov ecx, 3600
imul ecx
mov ecx, 10000000
imul ecx

add eax, [esi]
adc edx, [esi + 4]
mov dword ptr time[0], eax
mov dword ptr time[4], edx

mov esi, offset time
mov ah, 59
int 20h
ret

// IN: ecx = uid, edi -> byte[256]
getuserinfo:
mov ah, 80
int 20h
cmp al, ERC_BUSY
jnz l_getuserinfo_9
  call noop
  jmp short getuserinfo
  
l_getuserinfo_9:
ret

// IN: ecx = gid, edi -> byte[256]
getgroupinfo:
mov ah, 81
int 20h
cmp al, ERC_BUSY
jnz l_getgroupinfo_9
  call noop
  jmp short getgroupinfo
  
l_getgroupinfo_9:
ret

// IN: esi -> StringBuilder
// KEEP: esi
sb_init:
xor eax, eax
mov [esi + offset StringBuilder.len], eax
mov [esi + offset StringBuilder.max], eax
mov [esi + offset StringBuilder.data], eax
ret

// IN: esi -> StringBuilder, edi -> data, ecx = len
// OUT: al = erc (0: ok, 1: not enough memory)
// KEEP: esi
sb_add:
mov edx, [esi + offset StringBuilder.max]
mov eax, [esi + offset StringBuilder.len]
add eax, ecx
cmp eax, edx
jna l_sb_add2
  // len + ecx > max
  cmp edx, 16
  jnb l_sb_add11
    mov edx, 16
    
  l_sb_add11:
  cmp eax, edx
  jna l_sb_add14
    shl edx, 1
    cmp edx, 0
    jnz l_sb_add11
      
      l_sb_add13:
      
      mov al, 1
      
      ret
    
  l_sb_add14:
  // allocate a new block
  push esi
   push edi
    push ecx
     push edx
      mov ecx, edx
      call malloc
      // OUT: ebx
     pop edx
    pop ecx
   pop edi
  pop esi
  or al, al
  jnz l_sb_add13
  
  // copy old data to the new block
  mov [esi + offset StringBuilder.max], edx
  push esi
   push edi
    push ecx
     push ebx
       mov ecx, [esi + offset StringBuilder.len]
       mov esi, [esi + offset StringBuilder.data]
       mov edi, ebx
       mov ebx, esi
       cld
       rep movsb
       
       // free the old block
       or ebx, ebx
       jz l_sb_add18
         call free
         
       l_sb_add18:
     pop ebx 
    pop ecx
   pop edi
  pop esi
  mov [esi + offset StringBuilder.data], ebx

l_sb_add2:
// copy data
mov ebx, edi
mov edi, [esi + offset StringBuilder.data]
add edi, [esi + offset StringBuilder.len]
add [esi + offset StringBuilder.len], ecx

push esi
  mov esi, ebx
  cld
  rep movsb
pop esi

mov al, 0

ret

// IN: esi -> StringBuilder
// KEEP: esi
sb_done:
mov ebx, [esi + offset StringBuilder.data]
or ebx, ebx
jz sb_done_2
  
  push esi
  
    call free
  
  pop esi
  
sb_done_2:
xor eax, eax
mov [esi + offset StringBuilder.len], eax
mov [esi + offset StringBuilder.max], eax
mov [esi + offset StringBuilder.data], eax
ret

// IN: esi -> stringz
// OUT: ecx
// KEEP: ebx, esi, edi
strlen:
push esi
  xor ecx, ecx
  
  l_strlen_1:
    lodsb
    cmp al, 0
    jz l_strlen_9
      inc ecx
      jmp short l_strlen_1
  
  l_strlen_9:
pop esi
ret

wregs1: db "\n | acdb = "
wregs2: db " | sbsd = "

wregs:
pushad
  mov ebp, esp
  
  mov esi, offset wregs1 + COFS
  mov ecx, 10
  mov bl, 7
  call write
  
  mov eax, [ebp + 28]
  mov ecx, 16
  mov bh, 9
  call writen
  
  mov eax, [ebp + 24]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 20]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 16]
  mov ecx, 16
  call writen
  
  
  mov esi, offset wregs2 + COFS
  mov ecx, 9
  mov bl, 7
  call write
  
  mov eax, [ebp + 12]
  mov ecx, 16
  mov bh, 9
  call writen
  
  mov eax, [ebp + 8]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 4]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 0]
  mov ecx, 16
  call writen

popad
ret

ww:
pushad
  call wregs
  call waitkey
popad
ret

main:

ret

// IN: hdc, color, left, top, right, bottom
bar:
push ebp
mov ebp, esp
sub esp, 2 * 4

mov edx, [ebp + 8]
mov ecx, [ebp + 16]
mov ebx, [ebp + 20]
mov esi, [ebp + 24]
mov edi, [ebp + 28]

// check region
mov edx, [edx + offset DCRec.rgn]
test edx, edx
jz l_bar_04
 cmp dword ptr [edx + offset RgnRec.type], GDIOBJ_RGN
 jnz l_bar_04
  movsx eax, word ptr [edx + offset RgnRec.left]
  cmp ecx, eax
  jnl l_bar_01
    // ecx < left
    mov ecx, eax
    
  l_bar_01:
  movsx eax, word ptr [edx + offset RgnRec.top]
  cmp ebx, eax
  jnl l_bar_02
    // ebx < top
    mov ebx, eax
    
  l_bar_02:
  movsx eax, word ptr [edx + offset RgnRec.right]
  cmp esi, eax
  jng l_bar_03
    // esi > right
    mov esi, eax
    
  l_bar_03:
  movsx eax, word ptr [edx + offset RgnRec.bottom]
  cmp edi, eax
  jng l_bar_04
    // edi > bottom
    mov edi, eax
    
l_bar_04:

// add x0, y0
mov edx, [ebp + 8]
movsx eax, word ptr [edx + offset DCRec.x0]
add ecx, eax
add esi, eax
movsx eax, word ptr [edx + offset DCRec.y0]
add ebx, eax
add edi, eax

// check rect
movsx eax, word ptr [edx + offset DCRec.x1]
cmp ecx, eax
jnl l_bar_11
  // ecx < x1
  mov ecx, eax
  
l_bar_11:
movsx eax, word ptr [edx + offset DCRec.y1]
cmp ebx, eax
jnl l_bar_12
  // ebx < y1
  mov ebx, eax
  
l_bar_12:
movsx eax, word ptr [edx + offset DCRec.x2]
cmp esi, eax
jng l_bar_13
  // esi > x2
  mov esi, eax
  
l_bar_13:
movsx eax, word ptr [edx + offset DCRec.y2]
cmp edi, eax
jng l_bar_14
  // edi > x2
  mov edi, eax
  
l_bar_14:
// check bitmap size
mov edx, [edx + offset DCRec.pbitmap]
test edx, edx
jz l_bar_9
  movzx eax, word ptr [edx + 0]
  dec eax
  cmp esi, eax
  jng l_bar_21
    // esi > bitmap.w - 1
    mov esi, eax
    
  l_bar_21:
  movzx eax, word ptr [edx + 4]
  dec eax
  cmp edi, eax
  jng l_bar_22
    // edi > bitmap.h - 1
    mov edi, eax
    
  l_bar_22:
  cmp ecx, esi
  jg l_bar_9
   cmp ebx, edi
   jg l_bar_9
    
    // prepare
    mov eax, edi
    sub eax, ebx
    inc eax
    mov [ebp - 4], eax  // [ebp - 4] = edi - ebx + 1
    movzx eax, word ptr [edx + 0]  // eax = bitmap.w
    add edx, 8
    mov edi, edx  // edi -> bitmap[8]
    shl eax, 2  // eax * sizeof ARGB
    mov [ebp - 8], eax  // [ebp - 8] = bitmap.w * sizeof ARGB
    mul ebx  // eax * ebx
    mov edx, ecx
    shl edx, 2
    add eax, edx  // eax + (ecx * sizeof ARGB)
    add edi, eax  // edi + eax
    neg ecx
    add ecx, esi
    inc ecx  // ecx = esi - ecx + 1
    mov eax, [ebp + 12]  // eax = color
    
    l_bar_5:
    sub dword ptr [ebp - 4], 1
    jc l_bar_8
      push ecx
       push edi
        rep stosd
       pop edi
      pop ecx
      add edi, [ebp - 8]
      jmp short l_bar_5
      
    l_bar_8:
    
l_bar_9:
mov esp, ebp
pop ebp
ret 18h

// IN: hdc, x, y, w, h, hdcSrc, x1, y1, rop
bitblt:
push ebp
mov ebp, esp

sub esp, 6 * 4

// mov eax, [ebp + 8] // hdc
// mov eax, [ebp + 12] // x
// mov eax, [ebp + 16] // y
// mov eax, [ebp + 20] // w
// mov eax, [ebp + 24] // h
// mov eax, [ebp + 28] // hdcSrc
// mov eax, [ebp + 32] // x1
// mov eax, [ebp + 36] // y1
// mov eax, [ebp + 40] // rop

// check limits
mov edi, [ebp + 8]  // edi = hdc
mov ebx, [edi + offset DCRec.rgn]  // ebx = rgn

mov eax, [ebp + 12]  // x
movsx edx, word ptr [edi + offset DCRec.x0]
add eax, edx
mov [ebp + 12], eax  // x = x + dcx0
mov edx, [ebp + 20]  // w
add edx, eax
dec edx  // edx = x + w - 1
mov [ebp + 20], edx  // w

movsx ecx, word ptr [ebx + offset RgnRec.left]
movsx esi, word ptr [edi + offset DCRec.x0]
add ecx, esi  // ecx = rgn.left + dcx0
movsx esi, word ptr [edi + offset DCRec.x1]
cmp ecx, esi
jg __11
  mov ecx, esi
  
__11:  // ecx = max(ecx, dcx1)
cmp edx, ecx
jl near __9  // edx < ecx => 9

cmp eax, ecx
jnl __12
  sub ecx, eax
  add eax, ecx
  add [ebp + 32], ecx  // x1 = x1 + ecx - x
  mov [ebp + 12], eax  // x = ecx
  
__12:  // IN: edi = hdc, ebx = rgn, eax = x, edx = x + w - 1
movsx ecx, word ptr [ebx + offset RgnRec.right]
movsx esi, word ptr [edi + offset DCRec.x0]
add ecx, esi  // ecx = rgn.right + dcx0
movsx esi, word ptr [edi + offset DCRec.x2]
cmp ecx, esi
jl __13
  mov ecx, esi
  
__13:  // ecx = min(ecx, dcx2)
cmp eax, ecx
jg near __9  // x > ecx => 9

cmp edx, ecx
jng __14
  mov edx, ecx
  mov [ebp + 20], edx  // w = min(ecx, edx)
  
__14:
// y IN: edi = hdc, ebx = rgn
mov eax, [ebp + 16]  // y
movsx edx, word ptr [edi + offset DCRec.y0]
add eax, edx
mov [ebp + 16], eax  // y = y + dcy0
mov edx, [ebp + 24]  // h
add edx, eax
dec edx  // edx = y + h - 1
mov [ebp + 24], edx  // h

movsx ecx, word ptr [ebx + offset RgnRec.top]
movsx esi, word ptr [edi + offset DCRec.y0]
add ecx, esi  // ecx = rgn.top + dcy0
movsx esi, word ptr [edi + offset DCRec.y1]
cmp ecx, esi
jg __15
  mov ecx, esi
  
__15:  // ecx = max(ecx, dcy1)
cmp edx, ecx
jl near __9  // edx < ecx => 9

cmp eax, ecx
jnl __16
  sub ecx, eax
  add eax, ecx
  add [ebp + 36], ecx  // y1 = y1 + ecx - y
  mov [ebp + 16], eax  // y = ecx
  
__16:  // IN: edi = hdc, ebx = rgn, eax = y, edx = y + h - 1
movsx ecx, word ptr [ebx + offset RgnRec.bottom]
movsx esi, word ptr [edi + offset DCRec.y0]
add ecx, esi  // ecx = rgn.bottom + dcy0
movsx esi, word ptr [edi + offset DCRec.y2]
cmp ecx, esi
jl __17
  mov ecx, esi
  
__17:  // ecx = min(ecx, dcy2)
cmp eax, ecx
jg near __9  // y > ecx => 9

cmp edx, ecx
jng __18
  mov edx, ecx
  mov [ebp + 24], edx  // h = min(ecx, edx)
  
__18:
// prepare values  IN: edi = hdc
mov ebx, [edi + offset DCRec.pbitmap]  // ebx = pbitmap
test ebx, ebx
jz near __9

movzx eax, word ptr [ebx + 0]  // bitmap.w
mov ecx, eax  // ecx = bitmap.w
mov edx, [ebp + 16]  // y
mul edx
add eax, [ebp + 12]  // x
shl eax, 2
add eax, 8
add eax, ebx  // eax = (bmw * y + x) * 4 + 8 + ebx
mov [ebp - 4], eax  // bmofs

shl ecx, 2
mov [ebp - 8], ecx  // bmrowsize

mov ecx, [ebp + 20]  // w
sub ecx, [ebp + 12]  // x
inc ecx
mov [ebp - 12], ecx  // count in row

mov ecx, [ebp + 24]  // h
sub ecx, [ebp + 16]  // y
inc ecx
mov [ebp - 16], ecx  // count of rows

// no hdcSrc
mov eax, [ebp + 40]  // rop
cmp eax, BLACKNESS
jz near __blackness
cmp eax, WHITENESS
jz near __whiteness
cmp eax, DSTINVERT
jz near __dstinvert
//...

// hdcSrc check limits
mov esi, [ebp + 28]  // esi = hdcSrc
mov ebx, [esi + offset DCRec.pbitmap]  // ebx = pbitmapSrc
test ebx, ebx
jz near __9

movsx eax, word ptr [esi + offset DCRec.x0]
add eax, [ebp + 32]  // x1
mov [ebp + 32], eax  // x1 = x1 + dcx0
cmp ax, [esi + offset DCRec.x2]
jg near __9

mov edx, [ebp - 12]  // count in row
add edx, eax
dec edx  // edx = x1 + w - 1
movsx ecx, word ptr [esi + offset DCRec.x2]
cmp edx, ecx
jng __61
  sub edx, ecx
  sub [ebp - 12], edx  // count in row
  
__61:  // IN: esi = hdcSrc
movsx eax, word ptr [esi + offset DCRec.y0]
add eax, [ebp + 36]  // y1
mov [ebp + 36], eax  // y1 = y1 + dcy0
cmp ax, [esi + offset DCRec.y2]
jg near __9

mov edx, [ebp - 16]  // count of rows
add edx, eax
dec edx  // edx = y1 + h - 1
movsx ecx, word ptr [esi + offset DCRec.y2]
cmp edx, ecx
jng __62
  sub edx, ecx
  sub [ebp - 16], edx  // count of rows
  
__62:

// hdcSrc prepare values  IN: esi = hdcSrc, ebx = pbitmapSrc
movzx eax, word ptr [ebx + 0]  // bitmap.w
mov ecx, eax
mov edx, [ebp + 36]  // y1
mul edx
add eax, [ebp + 32]  // x1
shl eax, 2
add eax, 8
add eax, ebx  // eax = (y1 * bmwSrc + x1) * 4 + 8 + ebx
mov [ebp - 20], eax  // bmpSrcOfs

shl ecx, 2
mov [ebp - 24], ecx  // srcRowSize

// with hdcSrc
mov eax, [ebp + 40]  // rop
cmp eax, SRCCOPY
jz near __srccopy
cmp eax, SRCMERGE
jz near __srcmerge
//...

__9:
mov esp, ebp
pop ebp
ret 24h



// blackness
__blackness:
mov eax, 0xFF000000

__putcolor:
mov edi, [ebp - 4]  // bmofs
mov ecx, [ebp - 12]  // count in row
mov ebx, [ebp - 16]  // count of rows

__blackness_5:
  sub ebx, 1
  jc near __9
    push ecx
     push edi
      rep stosd
     pop edi
    pop ecx
    add edi, [ebp - 8]  // bmrowsize
    jmp short __blackness_5

// whiteness
__whiteness:
mov eax, 0xFFFFFFFF
jmp __putcolor

// dstinvert
__dstinvert:
mov edi, [ebp - 4]  // bmofs
mov ecx, [ebp - 12]  // count in row
mov ebx, [ebp - 16]  // count of rows

__dstinvert_5:
  sub ebx, 1
  jc near __9
    push ecx
     push edi
      
      __dstinvert_6:
        mov eax, [edi]
        xor eax, 0xFFFFFF
        stosd
        loop __dstinvert_6
     pop edi
    pop ecx
    add edi, [ebp - 8]  // bmrowsize
    jmp short __dstinvert_5


// srccopy
__srccopy:
mov edi, [ebp - 4]  // bmofs
mov ecx, [ebp - 12]  // count in row
mov ebx, [ebp - 16]  // count of rows
mov esi, [ebp - 20]  // bmpSrcOfs

__srccopy_5:
  sub ebx, 1
  jc near __9
    push ecx
     push edi
      push esi
        rep movsd
      pop esi
     pop edi
    pop ecx
    add edi, [ebp - 8]  // bmrowsize
    add esi, [ebp - 24]  // srcRowSize
    jmp short __srccopy_5

// srcmerge
__srcmerge:
mov edi, [ebp - 4]  // bmofs
mov ecx, [ebp - 12]  // count in row
mov ebx, [ebp - 16]  // count of rows
mov esi, [ebp - 20]  // bmpSrcOfs

__srcmerge_5:
  sub ebx, 1
  jc near __9
    push ecx
     push edi
      push esi
        l_srcmerge_51:
          lodsd
          test eax, eax
          jnz l_srcmerge_52
            // argb = 0: empty
            add edi, 4
            loop l_srcmerge_51
              jmp short l_srcmerge_58
              
          l_srcmerge_52:
          cmp eax, 0xFF000000
          jb l_srcmerge_53
            // argb = full
            stosd
            loop l_srcmerge_51
              jmp short l_srcmerge_58
            
          l_srcmerge_53:
          cmp eax, 1
          jnz l_srcmerge_54
            // inverted
            mov eax, [edi]
            xor eax, 0x00FFFFFF
            stosd
            loop l_srcmerge_51
              jmp short l_srcmerge_58
            
          l_srcmerge_54:
          // merge
          push ebx
           push ecx
            mov ebx, eax  // ebx = argb
            mov ecx, eax
            shr ecx, 24  // cl = a
            mov ch, cl
            xor ch, 255  // ch = 255 - a
            
            mul cl
            mov dx, ax  // dx = b * cl
            mov al, [edi]
            mul ch
            add ax, dx  // ax = dx + (b2 * ch)
            shr eax, 8
            stosb
            
            mov al, bh
            mul cl
            mov dx, ax  // dx = g * cl
            mov al, [edi]
            mul ch
            add ax, dx  // ax = dx + (g2 * ch)
            shr eax, 8
            stosb
            
            mov eax, ebx
            shr eax, 16
            mul cl
            mov dx, ax  // dx = r * cl
            mov al, [edi]
            mul ch
            add ax, dx  // ax = dx + (r2 * ch)
            shr eax, 8
            stosb
           pop ecx
          pop ebx
          inc edi // a
          loop l_srcmerge_51
        
        l_srcmerge_58:
      pop esi
     pop edi
    pop ecx
    add edi, [ebp - 8]  // bmrowsize
    add esi, [ebp - 24]  // srcRowSize
    jmp __srcmerge_5



/*
BLACKNESS
	Fills the destination rectangle using the color associated with index 0 in the physical palette. (This color is black for the default physical palette.)
CAPTUREBLT
	Includes any windows that are layered on top of your window in the resulting image. By default, the image only contains your window. Note that this generally cannot be used for printing device contexts.
DSTINVERT
	Inverts the destination rectangle.
MERGECOPY
	Merges the colors of the source rectangle with the brush currently selected in hdcDest, by using the Boolean AND operator.
MERGEPAINT
	Merges the colors of the inverted source rectangle with the colors of the destination rectangle by using the Boolean OR operator.
NOMIRRORBITMAP
	Prevents the bitmap from being mirrored.
NOTSRCCOPY
	Copies the inverted source rectangle to the destination.
NOTSRCERASE
	Combines the colors of the source and destination rectangles by using the Boolean OR operator and then inverts the resultant color.
PATCOPY
	Copies the brush currently selected in hdcDest, into the destination bitmap.
PATINVERT
	Combines the colors of the brush currently selected in hdcDest, with the colors of the destination rectangle by using the Boolean XOR operator.
PATPAINT
	Combines the colors of the brush currently selected in hdcDest, with the colors of the inverted source rectangle by using the Boolean OR operator. The result of this operation is combined with the colors of the destination rectangle by using the Boolean OR operator.
SRCAND
	Combines the colors of the source and destination rectangles by using the Boolean AND operator.
SRCCOPY
	Copies the source rectangle directly to the destination rectangle.
SRCERASE
	Combines the inverted colors of the destination rectangle with the colors of the source rectangle by using the Boolean AND operator.
SRCINVERT
	Combines the colors of the source and destination rectangles by using the Boolean XOR operator.
SRCPAINT
	Combines the colors of the source and destination rectangles by using the Boolean OR operator.
WHITENESS
	Fills the destination rectangle using the color associated with index 1 in the physical palette. (This color is white for the default physical palette.)

BLACKNESS = 0x42
NOTSRCERASE = 0x1100A6
NOTSRCCOPY = 0x330008
SRCERASE = 0x440328
DSTINVERT = 0x550009
PATINVERT = 0x5A0049
SRCINVERT = 0x660046
SRCAND = 0x8800C6
MERGEPAINT = 0xBB0226
MERGECOPY = 0xC000CA
SRCCOPY = 0xCC0020
SRCPAINT = 0xEE0086
WHITENESS = 0xFF0062

*/

// IN: hdc, w, h
// OUT: eax = hbitmap
createcompatiblebitmap:
movzx eax, word ptr [esp + 8]
movzx edx, word ptr [esp + 12]
cmp eax, 8
jnb l_createcompatiblebitmap_1
  mov eax, 8
  mov [esp + 8], eax
  
l_createcompatiblebitmap_1:
cmp edx, 8
jnb l_createcompatiblebitmap_2
  mov edx, 8
  mov [esp + 12], edx
  
l_createcompatiblebitmap_2:
mul edx
shl eax, 2
add eax, 8
mov ecx, eax

call malloc

test ebx, ebx
jz l_createcompatiblebitmap_9
  // set w, h
  movzx eax, word ptr [esp + 8]
  movzx edx, word ptr [esp + 12]
  mov [ebx + 0], eax
  mov [ebx + 4], edx
  // clear
  mul edx
  mov ecx, eax
  mov edi, ebx
  add edi, 8
  mov eax, 0xFF000000
  cld
  rep stosd
  
l_createcompatiblebitmap_9:
mov eax, ebx
ret 0Ch

// IN: hdc
// OUT: eax = hdc
createcompatibledc:
mov ecx, sizeof DCRec
call malloc
test ebx, ebx
jz l_createcompatibledc_9
  mov edi, ebx
  mov ecx, sizeof DCRec / 4
  xor eax, eax
  cld
  rep stosd
  
  mov eax, ebx
  call getdc_def
  
l_createcompatibledc_9:
mov eax, ebx
ret 4


// !!! see also user32
getdc_def:
mov dword ptr [eax + offset DCRec.pen], offset defpen + COFS
mov dword ptr [eax + offset DCRec.brush], offset defbrush + COFS
mov dword ptr [eax + offset DCRec.rgn], offset defrgn + COFS
ret

defpen: dd GDIOBJ_PEN, 0xFF000000, 1
defbrush: dd GDIOBJ_BRUSH, 1, 0xFFFFFFFF, 0, 0, 0, 0
defrgn: dd GDIOBJ_RGN, 1, 0, 32767 << 16 + 32767

// IN: penstyle, size, color
// OUT: hgdipen
createpen:
mov ecx, sizeof PenRec
call malloc
test ebx, ebx
jz l_createpen_9
  //mov eax, [esp + 4]  // penstyle
  mov ecx, [esp + 8]  // size
  mov edx, [esp + 12]  // color
  mov dword ptr [ebx + offset PenRec.type], GDIOBJ_PEN
  or edx, 0xFF000000
  mov [ebx + offset PenRec.color], edx
  mov [ebx + offset PenRec.size], ecx
  
l_createpen_9:
mov eax, ebx
ret 0Ch

// IN: x1, y1, x2, y2
// OUT: hgdirgn
createrectrgn:
mov ecx, sizeof RgnRec
call malloc
test ebx, ebx
jz l_createrectrgn_9
  mov dword ptr [ebx + offset RgnRec.type], GDIOBJ_RGN
  mov dword ptr [ebx + offset RgnRec.flags], 1
  mov eax, [esp + 4]  // x1
  mov [ebx + offset RgnRec.left], eax
  mov eax, [esp + 8]  // y1
  mov [ebx + offset RgnRec.top], eax
  mov eax, [esp + 12]  // x2
  mov [ebx + offset RgnRec.right], eax
  mov eax, [esp + 16]  // y2
  mov [ebx + offset RgnRec.bottom], eax
  
l_createrectrgn_9:
mov eax, ebx
ret 10h

// IN: color
// OUT: hgdibrush
createsolidbrush:
mov ecx, sizeof BrushRec
call malloc
test ebx, ebx
jz l_createsolidbrush_9
  mov edi, ebx
  mov ecx, sizeof BrushRec / 4
  xor eax, eax
  cld
  rep stosd
  
  mov dword ptr [ebx + offset BrushRec.type], GDIOBJ_BRUSH
  mov edx, [esp + 4]  // color
  or edx, 0xFF000000
  mov [ebx + offset BrushRec.color1], edx
  mov dword ptr [ebx + offset BrushRec.flags], 1
  mov dword ptr [ebx + offset BrushRec.pbrushfn], offset solidbrushfn + COFS
  
l_createsolidbrush_9:
mov eax, ebx
ret 4

// IN: edx = hdc, ecx = x1, ebx = y1, esi = x2, edi = y2
solidbrushfn:
push edi
push esi
push ebx
push ecx
mov eax, [edx + offset DCRec.brush]
push dword ptr [eax + offset BrushRec.color1]
push edx
call bar
ret

// IN: hgdiobj
deleteobject:
mov ebx, [esp + 4]
call free
ret 4

// IN: id
getstockobject:
//...
ret 4

/*
BLACK_BRUSH
	Black brush.
DKGRAY_BRUSH
	Dark gray brush.
DC_BRUSH
	Solid color brush. The default color is white. The color can be changed by using the SetDCBrushColor function. For more information, see the Remarks section.
GRAY_BRUSH
	Gray brush.
HOLLOW_BRUSH
	Hollow brush (equivalent to NULL_BRUSH).
LTGRAY_BRUSH
	Light gray brush.
NULL_BRUSH
	Null brush (equivalent to HOLLOW_BRUSH).
WHITE_BRUSH
	White brush.
BLACK_PEN
	Black pen.
DC_PEN
	Solid pen color. The default color is white. The color can be changed by using the SetDCPenColor function. For more information, see the Remarks section.
NULL_PEN
	Null pen. The null pen draws nothing.
WHITE_PEN
	White pen.
ANSI_FIXED_FONT
	Windows fixed-pitch (monospace) system font.
ANSI_VAR_FONT
	Windows variable-pitch (proportional space) system font.
DEVICE_DEFAULT_FONT
	Device-dependent font.
DEFAULT_GUI_FONT
	Default font for user interface objects such as menus and dialog boxes. It is not recommended that you use DEFAULT_GUI_FONT or SYSTEM_FONT to obtain the font used by dialogs and windows; for more information, see the remarks section.
    The default font is Tahoma.
OEM_FIXED_FONT
	Original equipment manufacturer (OEM) dependent fixed-pitch (monospace) font.
SYSTEM_FONT
	System font. By default, the system uses the system font to draw menus, dialog box controls, and text. It is not recommended that you use DEFAULT_GUI_FONT or SYSTEM_FONT to obtain the font used by dialogs and windows; for more information, see the remarks section.
    The default system font is Tahoma.
SYSTEM_FIXED_FONT
	Fixed-pitch (monospace) system font. This stock object is provided only for compatibility with 16-bit Windows versions earlier than 3.0.
DEFAULT_PALETTE
	Default palette. This palette consists of the static colors in the system palette. 

BLACK_BRUSH = 4
DKGRAY_BRUSH = 3
GRAY_BRUSH = 2
HOLLOW_BRUSH = 5
LTGRAY_BRUSH = 1
NULL_BRUSH = 5
WHITE_BRUSH = 0
BLACK_PEN = 7
NULL_PEN = 8
WHITE_PEN = 6
ANSI_FIXED_FONT = 11
ANSI_VAR_FONT = 12
DEVICE_DEFAULT_FONT = 14
DEFAULT_GUI_FONT = 17
OEM_FIXED_FONT = 10
SYSTEM_FONT = 13
SYSTEM_FIXED_FONT = 16
DEFAULT_PALETTE = 15

*/

// IN: hdc, left, top, right, bottom
rectangle:
push ebp
mov ebp, esp

dec dword ptr [ebp + 24]  //? bottom
dec dword ptr [ebp + 20]  //? right

mov esi, [ebp + 8]  // hdc
mov ebx, [esi + offset DCRec.brush]
test ebx, ebx
jz l_rectangle_2
 cmp dword ptr [ebx + offset BrushRec.type], GDIOBJ_BRUSH
 jnz l_rectangle_2
  test byte ptr [ebx + offset BrushRec.flags], 1
  jz l_rectangle_2
    mov edx, esi  // hdc
    mov eax, [ebx + offset BrushRec.pbrushfn]
    mov edi, [ebp + 24]  // bottom
    dec edi //?
    mov esi, [ebp + 20]  // right
    dec esi //?
    mov ebx, [ebp + 16]  // top
    mov ecx, [ebp + 12]  // left
    test eax, eax
    jz l_rectangle_16
      call eax
      jmp short l_rectangle_2
      
    l_rectangle_16:
      call solidbrushfn
      
l_rectangle_2:
mov esi, [ebp + 8]  // hdc
mov ebx, [esi + offset DCRec.pen]
test ebx, ebx
jz near l_rectangle_8
 mov edx, [ebx + offset PenRec.size]
 test edx, edx
 jz near l_rectangle_8
  mov ecx, edx
  shr ecx, 1
  
  // bar(dc, pencolor, left - ecx, top - ecx, right - ecx + edx - 1, top - ecx + edx - 1)
  mov eax, [ebp + 16]  // top
  sub eax, ecx
  add eax, edx
  dec eax
  push eax
  mov eax, [ebp + 20]  // right
  sub eax, ecx
  add eax, edx
  dec eax
  push eax
  mov eax, [ebp + 16]  // top
  sub eax, ecx
  push eax
  mov eax, [ebp + 12]  // left
  sub eax, ecx
  push eax
  push dword ptr [ebx + offset PenRec.color]
  push esi
  call bar
  
  mov esi, [ebp + 8]  // hdc
  mov ebx, [esi + offset DCRec.pen]
  mov edx, [ebx + offset PenRec.size]
  mov ecx, edx
  shr ecx, 1
  
  // bar(dc, pencolor, left - ecx, top - ecx + edx, left - ecx + edx - 1, bottom - ecx)
  mov eax, [ebp + 24]  // bottom
  sub eax, ecx
  push eax
  mov eax, [ebp + 12]  // left
  sub eax, ecx
  add eax, edx
  dec eax
  push eax
  mov eax, [ebp + 16]  // top
  sub eax, ecx
  add eax, edx
  push eax
  mov eax, [ebp + 12]  // left
  sub eax, ecx
  push eax
  push dword ptr [ebx + offset PenRec.color]
  push esi
  call bar
  
  mov esi, [ebp + 8]  // hdc
  mov ebx, [esi + offset DCRec.pen]
  mov edx, [ebx + offset PenRec.size]
  mov ecx, edx
  shr ecx, 1
  
  // bar(dc, pencolor, left - ecx, bottom - ecx, right - ecx + edx - 1, bottom - ecx + edx - 1)
  mov eax, [ebp + 24]  // bottom
  sub eax, ecx
  add eax, edx
  dec eax
  push eax
  mov eax, [ebp + 20]  // right
  sub eax, ecx
  add eax, edx
  dec eax
  push eax
  mov eax, [ebp + 24]  // bottom
  sub eax, ecx
  push eax
  mov eax, [ebp + 12]  // left
  sub eax, ecx
  push eax
  push dword ptr [ebx + offset PenRec.color]
  push esi
  call bar
  
  mov esi, [ebp + 8]  // hdc
  mov ebx, [esi + offset DCRec.pen]
  mov edx, [ebx + offset PenRec.size]
  mov ecx, edx
  shr ecx, 1
  
  // bar(dc, pencolor, right - ecx, top - ecx + edx, right - ecx + edx - 1, bottom - ecx)
  mov eax, [ebp + 24]  // bottom
  sub eax, ecx
  push eax
  mov eax, [ebp + 20]  // right
  sub eax, ecx
  add eax, edx
  dec eax
  push eax
  mov eax, [ebp + 16]  // top
  sub eax, ecx
  add eax, edx
  push eax
  mov eax, [ebp + 20]  // right
  sub eax, ecx
  push eax
  push dword ptr [ebx + offset PenRec.color]
  push esi
  call bar
  
l_rectangle_8:
mov esp, ebp
pop ebp
ret 14h

// IN: hdc, hgdiobj
// OUT: old_hgdiobj
selectobject:
mov esi, [esp + 4]
mov ebx, [esp + 8]
test esi, esi
jz l_selectobject_9
 test ebx, ebx
 jz l_selectobject_9
  mov eax, [ebx]
  cmp eax, GDIOBJ_PEN
  jnz l_selectobject_11
    xchg [esi + offset DCRec.pen], ebx
    jmp short l_selectobject_9
    
  l_selectobject_11:
  cmp eax, GDIOBJ_BRUSH
  jnz l_selectobject_12
    xchg [esi + offset DCRec.brush], ebx
    jmp short l_selectobject_9
    
  l_selectobject_12:
  cmp eax, GDIOBJ_RGN
  jnz l_selectobject_13
    xchg [esi + offset DCRec.rgn], ebx
    jmp short l_selectobject_9
    
  l_selectobject_13:
  cmp eax, GDIOBJ_FONT
  jnz l_selectobject_14
    xchg [esi + offset DCRec.font], ebx
    jmp short l_selectobject_9
    
  l_selectobject_14:
  mov edi, ebx
  xchg [esi + offset DCRec.pbitmap], ebx
  mov word ptr [esi + offset DCRec.x0], 0
  mov word ptr [esi + offset DCRec.y0], 0
  mov word ptr [esi + offset DCRec.x1], 0
  mov word ptr [esi + offset DCRec.y1], 0
  test edi, edi
  jz l_selectobject_9
    mov ax, [edi + 0]  // bitmap.w
    dec eax
    mov [esi + offset DCRec.x2], ax
    mov ax, [edi + 4]  // bitmap.h
    dec eax
    mov [esi + offset DCRec.y2], ax
    
l_selectobject_9:
mov eax, ebx
ret 8

[fill 0x1000]

export:
dd 0/*export flags*/, 0/*dtm stamp*/
dw 0, 0/*major, minor version*/
dd offset dll_name + CRVA/*name RVA*/
dd 1/*ordinal base*/
dd 11/* !!! number of address table entries*/
dd 11/* !!! number of name pointers*/
dd offset export_table + CRVA/*export address table RVA*/
dd offset name_pointers + CRVA/*name pointers RVA*/
dd offset ordinal_table + CRVA/*ordinal table RVA*/

export_table:
dd offset bar + CRVA
dd offset bitblt + CRVA
dd offset createcompatiblebitmap + CRVA
dd offset createcompatibledc + CRVA
dd offset createpen + CRVA
dd offset createrectrgn + CRVA
dd offset createsolidbrush + CRVA
dd offset deleteobject  + CRVA
dd offset getstockobject + CRVA
dd offset rectangle + CRVA
dd offset selectobject + CRVA

name_pointers:
dd offset np_bar + CRVA
dd offset np_bitblt + CRVA
dd offset np_createcompatiblebitmap + CRVA
dd offset np_createcompatibledc + CRVA
dd offset np_createpen + CRVA
dd offset np_createrectrgn + CRVA
dd offset np_createsolidbrush + CRVA
dd offset np_deleteobject  + CRVA
dd offset np_getstockobject + CRVA
dd offset np_rectangle + CRVA
dd offset np_selectobject + CRVA

ordinal_table:
dw 0
dw 1
dw 2
dw 3
dw 4
dw 5
dw 6
dw 7
dw 8
dw 9
dw 10

np_bar: db "Bar\0"
np_bitblt: db "BitBlt\0"
np_createcompatiblebitmap: db "CreateCompatibleBitmap\0"
np_createcompatibledc: db "CreateCompatibleDC\0"
np_createpen: db "CreatePen\0"
np_createrectrgn: db "CreateRectRgn\0"
np_createsolidbrush: db "CreateSolidBrush\0"
np_deleteobject: db "DeleteObject\0"
np_getstockobject: db "GetStockObject\0"
np_rectangle: db "Rectangle\0"
np_selectobject: db "SelectObject\0"

dll_name: db "gdi32.dll\0"

export_lastoffset:

lastoffset:

