dos_header:

db "MZ"

dw 0, 1, 0, 4/*Header size in paragraphs*/, 0, 0
dw 0, 0xFFFE  // stack
dw 0  // csum
dw offset dos_main, 0  // ip, cs
dw 0, 0
dw 0, 0, 0, 0, 0, 0
dd 0, 0, 0, 0, 0
dd offset pe_header  // lfanew

[bits 16]

dos_str: db "Requires 32 bit OS\0"

dos_writez:

l_dos_writez_1:
  mov al, [cs:si]
  inc si
  or al, al
  jz l_dos_writez_9
    mov ah, 0Eh
    xor bh, bh
    int 10h
    jmp l_dos_writez_1

l_dos_writez_9:
ret


dos_main:
mov si, offset dos_str
call dos_writez

dos_end:
mov ax, 4C00h
int 21h

MAX_PATH = 260

// Error Codes
ERC_HARDWARE            = 2
ERC_OUT_OF_RANGE        = 5
ERC_DISK_CHANGED        = 6
ERC_NOT_FLUSHED         = 7
ERC_DISK_IO             = 8
ERC_INVALID_DISK_NUMBER = 10h
ERC_NOT_FOUND_IN_CACHE  = 12h  // internal
ERC_UNKNOWN_GEOMETRY    = 15h
ERC_DISK_FULL           = 16h

ERC_INVALID_CHANNEL_NUMBER = 18h
ERC_INVALID_MEMORY_ADDRESS = 19h
ERC_INVALID_COUNT          = 1Ah

ERC_NOT_ENOUGH_MEMORY = 21h
ERC_ALIGN             = 24h
ERC_ALREADY_FREE      = 25h
ERC_OVERFLOW          = 26h
ERC_UNDERFLOW         = 27h

ERC_MSG_QUEUE_EMPTY    = 30h
ERC_MSG_QUEUE_FULL     = 31h
ERC_MSG_INVALID_TARGET = 32h

ERC_TOO_MANY_WINDOWS = 33h
ERC_INVALID_WINDOW   = 34h
ERC_CANT_MOVESIZE    = 35h
ERC_UNKNOWN_CLASS    = 36h

ERC_TOO_MANY_PROCS   = 40h
ERC_TOO_MANY_THREADS = 41h

ERC_TIMER_FULL      = 42
ERC_TIMER_NOT_FOUND = 43

ERC_PATH_NOT_FOUND = 44h
ERC_FILE_NOT_FOUND = 45h
ERC_TOO_MANY_OPEN_FILES = 46h
ERC_DIR_ALREADY_EXISTS = 47h
ERC_UNKNOWN_FILESYSTEM = 48h
ERC_DIR_NOT_EMPTY = 49h
ERC_CANT_REMOVE = 4Ah
ERC_DUPLICATE_NAME = 4Bh
ERC_INVALID_FHANDLE = 4Ch
ERC_INVALID_THREAD = 4Dh
ERC_FS = 4Eh
ERC_READ_ONLY = 4Fh
ERC_IN_USE = 50h
ERC_OUT_OF_DISK = 51h
ERC_TOO_MANY_SEARCHES = 52h
ERC_INVALID_SHANDLE = 53h
ERC_CANT_RENAME = 54h

ERC_INVALID_PID = 55h
ERC_STACK_OVERFLOW = 56h
ERC_PE_INVALID_HEADER = 57h
ERC_INVALID_SERVICE = 58h

ERC_TOO_LONG = 59h
ERC_ONLY_STARTER = 5Ah
ERC_INVALID_MEMORY_LOCATION = 5Bh
ERC_INVALID_THREADID = 5Ch
ERC_ACCESS_DENIED = 5Dh
ERC_INVALID_PRIORITY = 5Eh
ERC_INVALID_ATRBS = 5Fh
ERC_INVALID_VALUE = 60h
ERC_INVALID_POINTER = 61h
ERC_INVALID_CHAR = 62h
ERC_DISK_REMOVED = 63h
ERC_TOO_BIG_HOLE = 64h  // internal
ERC_UTF8 = 65h
ERC_BUSY = 66h
ERC_DIR_TOO_BIG = 67h
ERC_LINK = 68h  // internal
ERC_NOT_A_LINK = 69h
ERC_INFINITE_LINK = 70h
ERC_CANT_MOVE = 71h
ERC_FILE_TOO_BIG = 72h
ERC_NOT_FIT_IN_MFT = 73h
ERC_INVALID_LINK = 74h

ERC_PE_IMPORT_DEPTH_OVERFLOW = 75h
ERC_PE_INVALID_ADR = 76h
ERC_PE_NOT_FOUND = 77h
ERC_PE_ORDINAL = 78h

ERC_INVALID_IMAGE = 79h

ERC_NOT_IMPLEMENTED     = 0FFh

// Window = 32 B (winid)
struct WinRec{
  int2 x, y, w, h
  uns4 flags, cr3, hwnd, pbitmap, pid
  uns1 kbd, parent
  uns1 ncheight, desktop
}

// Window Ex (hwnd)
struct WindowExRec{
  uns4 next, prev, first_child, pmenu, ptext, pclass, menusx
  int2 x, y, w, h
  uns4 winid, pid, hinstance
  uns4 exstyle, style, id, parent, wndproc
}

struct WndClassRec{
  int4 cbSize
  uns4 style
  ptr4 lpfnWndProc
  int4 cbClsExtra
  int4 cbWndExtra
  uns4 hInstance
  ptr4 hIcon
  ptr4 hCursor
  uns4 hbrBackground
  ptr4 lpszMenuName
  ptr4 lpszClassName
  ptr4 hIconSm
  ptr4 next // only tryskos
}

struct PointRec{
  int4 x, y
}

struct MessageRec{
  ptr4 hwnd
  uns4 message
  uns4 wParam
  uns4 lParam
  uns4 time
  PointRec pt
}

struct DCRec{
  int2 x0, y0, x1, y1, x2, y2, x, y
  ptr4 pbitmap, pen, brush, rgn, font, lppaintstruct
  uns4 textcolor
}

struct RectRec{
  int4 left, top, right, bottom
}

GDIOBJ_PEN = 1
GDIOBJ_BRUSH = 2
GDIOBJ_RGN = 3
GDIOBJ_FONT = 4

struct PenRec{
  uns4 type, color, size
}

struct BrushRec{
  uns4 type, flags, color1, color2, pbrushfn
  int2 x1, y1, x2, y2
}

struct RgnRec{
  uns4 type, flags
  int2 left, top, right, bottom
}

struct FontRec{
  uns4 type, rotation, pfont
  bool bold, italics, underline, strike
  char name[64]
}

struct PaintStruct {
	ptr4 hdc; // 0
	uns4 fErase; // 4
	RectRec rcPaint; // 8
	uns4 fRestore; // 24
	uns4 fIncUpdate; // 28
	uns1 rgbReserved[32]; // 32
}

// BitBlt
BLACKNESS = 0x42
NOTSRCERASE = 0x1100A6
NOTSRCCOPY = 0x330008
SRCERASE = 0x440328
DSTINVERT = 0x550009
PATINVERT = 0x5A0049
SRCINVERT = 0x660046
SRCAND = 0x8800C6
MERGEPAINT = 0xBB0226
MERGECOPY = 0xC000CA
SRCCOPY = 0xCC0020
SRCMERGE = 0xDD0022
SRCPAINT = 0xEE0086
WHITENESS = 0xFF0062

// GetStockObject
BLACK_BRUSH = 4
DKGRAY_BRUSH = 3
GRAY_BRUSH = 2
HOLLOW_BRUSH = 5
LTGRAY_BRUSH = 1
NULL_BRUSH = 5
WHITE_BRUSH = 0
BLACK_PEN = 7
NULL_PEN = 8
WHITE_PEN = 6
ANSI_FIXED_FONT = 11
ANSI_VAR_FONT = 12
DEVICE_DEFAULT_FONT = 14
DEFAULT_GUI_FONT = 17
OEM_FIXED_FONT = 10
SYSTEM_FONT = 13
SYSTEM_FIXED_FONT = 16
DEFAULT_PALETTE = 15

struct DateTime8{
  uns8 datetime
}

struct SearchRec{
  uns4 FileAttributes
  DateTime8 CreationTime
  DateTime8 LastAccessTime
  DateTime8 LastWriteTime
  uns8 FileSize
  uns8 Reserved
  char FileName[MAX_PATH]
  char AlternateFileName[14]
}

struct SystemTime{
  uns2 wYear
  uns2 wMonth
  uns2 wDayOfWeek
  uns2 wDay
  uns2 wHour
  uns2 wMinute
  uns2 wSecond
  uns2 wMilliseconds
}

MAX_WIN = 255
WIN_NONE = 255
WIN_MAINPANELH = 0
WIN_HEADER = 16
WIN_BORDER = 6
WIN_CORNER = 16
WIN_MINW = 64 + (WIN_BORDER * 2)
WIN_MINH = WIN_HEADER + (WIN_BORDER * 2)
WIN_MENUH = 16

WIN_DEFAULT_X_STEP = 32
WIN_DEFAULT_Y_STEP = 32
WIN_DEFAULT_X_MAX = 250
WIN_DEFAULT_Y_MAX = 250
WIN_BORDERCOLOR = 0xFF0080FF
WIN_HEADERCOLOR = 0xFF0080FF
WIN_FRAMECOLOR = 0xFF000000
WIN_ACTIVEFRAMECOLOR = 0xFFFFFF00
WIN_CLOSECOLOR = 0xFFE04040
WIN_MAXIMIZECOLOR = 0xFFA0A0A0
WIN_LIGHT = 0xFFFFFFFF
WIN_DARK = 0xFF606060

WINFLAGS_VALID = 1
WINFLAGS_FULLSCREEN = 2
WINFLAGS_ALWAYSONTOP = 8
WINFLAGS_CLOSEPRESSED    = 0x10
WINFLAGS_MAXIMIZEPRESSED = 0x20
WINFLAGS_MINIMIZEPRESSED = 0x40

// wp of mousemove
MK_LBUTTON  = 0x0001
MK_RBUTTON  = 0x0002
MK_SHIFT    = 0x0004
MK_CONTROL  = 0x0008
MK_MBUTTON  = 0x0010
MK_XBUTTON1 = 0x0020
MK_XBUTTON2 = 0x0040

WS_TABSTOP     = 0x00010000
WS_MAXIMIZEBOX = 0x00010000
WS_GROUP       = 0x00020000
WS_MINIMIZEBOX = 0x00020000
WS_SIZEBOX     = 0x00040000
WS_SYSMENU     = 0x00080000
WS_HSCROLL     = 0x00100000
WS_VSCROLL     = 0x00200000
WS_DLGFRAME    = 0x00400000
WS_BORDER      = 0x00800000
WS_CAPTION     = 0x00C00000
WS_MAXIMIZE    = 0x01000000
WS_DISABLED    = 0x08000000
WS_VISIBLE     = 0x10000000
WS_MINIMIZE    = 0x20000000
WS_CHILD       = 0x40000000
WS_POPUP       = 0x80000000
WS_OVERLAPPEDWINDOW = WS_CAPTION | WS_SYSMENU | WS_SIZEBOX | WS_MINIMIZEBOX | WS_MAXIMIZEBOX
WS_POPUPWINDOW = WS_POPUP | WS_BORDER | WS_SYSMENU

CW_USEDEFAULT = -1

SWP_NOSIZE = 1
SWP_NOMOVE = 2
SWP_NOZORDER = 4
SWP_NOREDRAW = 8
SWP_NOACTIVATE = 0x10
SWP_DRAWFRAME = 0x20
SWP_FRAMECHANGED = 0x20
SWP_SHOWWINDOW = 0x40
SWP_HIDEWINDOW = 0x80
SWP_NOCOPYBITS = 0x100
SWP_NOOWNERZORDER = 0x200
SWP_NOREPOSITION = 0x200
SWP_NOSENDCHANGING = 0x400
SWP_RELSIZE = 0x1000
SWP_RELMOVE = 0x2000

SW_HIDE = 0
SW_NORMAL = 1
SW_MAXIMIZE = 3
SW_SHOW = 5
SW_MINIMIZE = 6
SW_RESTORE = 9

RDW_INVALIDATE = 1
RDW_INTERNALPAINT = 2
RDW_ERASE = 4
RDW_VALIDATE = 8
RDW_NOINTERNALPAINT = 16
RDW_NOERASE = 32
RDW_NOCHILDREN = 64
RDW_ALLCHILDREN = 128
RDW_UPDATENOW = 256
RDW_ERASENOW = 512
RDW_FRAME = 1024
RDW_NOFRAME = 2048

WM_NULL = 0
WM_CREATE = 1
WM_DESTROY = 2
WM_MOVE = 3
WM_SIZE = 5
WM_ACTIVATE = 6
WM_SETFOCUS = 7
WM_KILLFOCUS = 8
WM_ENABLE = 10
WM_SETREDRAW = 11
WM_SETTEXT = 12
WM_GETTEXT = 13
WM_GETTEXTLENGTH = 14
WM_PAINT = 15
WM_CLOSE = 16
WM_QUERYENDSESSION = 17
WM_QUIT = 18
WM_QUERYOPEN = 19
WM_ERASEBKGND = 20
WM_SYSCOLORCHANGE = 21
WM_ENDSESSION = 22
WM_SHOWWINDOW = 24
WM_WINDOWPOSCHANGED = 47h
WM_NCPAINT = 85h
WM_NCMOUSEMOVE = 0A0h
WM_NCLBUTTONDOWN = 0A1h
WM_NCLBUTTONUP = 0A2h
WM_NCLBUTTONDBLCLK = 0A3h
WM_NCRBUTTONDOWN = 0A4h
WM_NCRBUTTONUP = 0A5h
WM_NCRBUTTONDBLCLK = 0A6h
WM_NCMBUTTONDOWN = 0A7h
WM_NCMBUTTONUP = 0A8h
WM_NCMBUTTONDBLCLK = 0A9h
WM_NCXBUTTONDOWN = 0ABh
WM_NCXBUTTONUP = 0ACh
WM_NCXBUTTONDBLCLK = 0ADh
WM_KEYDOWN    = 100h
WM_KEYUP      = 101h
WM_CHAR       = 102h
WM_SYSKEYDOWN = 104h
WM_SYSKEYUP   = 105h
WM_COMMAND = 111h
WM_TIMER   = 113h
WM_TERMINATED   = 180h
WM_NEW_CLIP     = 181h
WM_WINDOWCLOSED = 182h
WM_SCROLL       = 183h
WM_MOUSEBUTTON  = 184h
WM_MAINPANELHCHANGED = 185h
WM_NCMOUSEOVER  = 186h
WM_CHARIO       = 187h
WM_PAINTBUTTONS = 188h
WM_MOUSEOVER    = 189h
WM_DISKCHANGED  = 18Ah
WM_USB_INT = 1A0h
WM_MOUSEMOVE = 200h
WM_LBUTTONDOWN = 201h
WM_LBUTTONUP = 202h
WM_LBUTTONDBLCLK = 203h
WM_RBUTTONDOWN = 204h
WM_RBUTTONUP = 205h
WM_RBUTTONDBLCLK = 206h
WM_MBUTTONDOWN = 207h
WM_MBUTTONUP = 208h
WM_MBUTTONDBLCLK = 209h
WM_MOUSEWHEEL = 20Ah
WM_XBUTTONDOWN = 20Bh
WM_XBUTTONUP = 20Ch
WM_XBUTTONDBLCLK = 20Dh
WM_MOUSEHWHEEL = 20Eh
WM_DEVICECHANGE = 219h

COFS = 0x401000 - 0x400 // !!! see also Pointer to raw data, Head
CRVA = 0x1000 - 0x400   // !!! see also Pointer to raw data, Head
HINSTANCE = 0x400000

MAX_BUFFER = 10000  // >= 512

WIN_DOUBLECLICKTIME = 300 // ms
WIN_DOUBLECLICKTIMERID = 44h

MAINPANEL_H = 32
MAINBGCOLOR = 0xFFA0A0A0
MAINMINALL_W = 8
MAINMINALLCOLOR = 0xFFC0C0C0
MAINICONWIDTH = 40
MAINSELCOLOR = 0xFF000000

START_W = 400
START_H = 400
START_MID = 240
STARTBGCOLOR1 = 0xFFC0C0C0
STARTBGCOLOR2 = 0xF0404040
SELECTBGCOLOR = 0xFFA0A0A0
SELECTEDBGCOLOR = 0xFF00FFFF
SELECTTIMERTIME = 33
SELECTTIMERID = 2433

MAX_MINIATURES = 255

MINIATURE_W = 120
MINIATURE_H = 90
MINIATURE_FRAMESIZE = 20
MINIATURE_SXSTEP = 20

MAX_KEYBS = 4

KEYSTATE_ALT = 1
KEYSTATE_WIN = 2
KEYSTATE_ALTTAB = 0x10
KEYSTATE_ALTSHIFT = 0x20

STATE_LEFT = 1
STATE_RIGHT = 2
STATE_UP = 4
STATE_DOWN = 8
STATE_CLOSE = 0x10
STATE_MAX = 0x20
STATE_MIN = 0x40
STATE_MOVE = 0x80
STATE_MENU = 0x100

ERC_NOT_FILE = 3
ERC_WRITE_ERROR = 4

VK_LEFT = 37
VK_RIGHT = 39
VK_UP = 38
VK_DOWN = 40
VK_ENTER = 13
VK_ESC = 27
VK_BSP = 8
VK_TAB = 9
VK_HOME = 36
VK_END = 35
VK_PGUP = 33
VK_PGDN = 34
VK_INS = 45
VK_DEL = 46

KBD_RSH  = 1
KBD_LSH  = 2
KBD_CTRL = 4
KBD_ALT  = 8
KBD_SCRLK = 0x10
KBD_NUMLK = 0x20
KBD_CPSLK = 0x40
KBD_INS   = 0x80
KBD_RCTRL = 0x400
KBD_RALT  = 0x800
KBD_VCTRL = 0x1000

FOPEN_READ = 1
FOPEN_WRITE = 3
FOPEN_APPEND = 10h
FOPEN_CREATE = 20h

FILE_ATTRIBUTE_READONLY  = 0x00000001
FILE_ATTRIBUTE_HIDDEN    = 0x00000002
FILE_ATTRIBUTE_SYSTEM    = 0x00000004
FILE_ATTRIBUTE_DIRECTORY = 0x00000010
FILE_ATTRIBUTE_ARCHIVE   = 0x00000020
FILE_ATTRIBUTE_DEVICE    = 0x00000040
FILE_ATTRIBUTE_NORMAL    = 0x00000080
FILE_ATTRIBUTE_TEMPORARY     = 0x00000100
FILE_ATTRIBUTE_SPARSE_FILE   = 0x00000200
FILE_ATTRIBUTE_REPARSE_POINT = 0x00000400
FILE_ATTRIBUTE_COMPRESSED    = 0x00000800
FILE_ATTRIBUTE_OFFLINE       = 0x00001000
FILE_ATTRIBUTE_NOT_CONTENT_INDEXED = 0x00002000
FILE_ATTRIBUTE_ENCRYPTED       = 0x00004000
FILE_ATTRIBUTE_VALID_FLAGS     = 0x00007fb7
FILE_ATTRIBUTE_VALID_SET_FLAGS = 0x000031a7
FILE_ATTRIBUTE_LINUX = 0x08000000
FILE_ATTRIBUTE_LINK  = 0x04000000

ACCESS_R = 4 //read
ACCESS_W = 2 //write
ACCESS_X = 1 //execute

FSID_EXT2 = 82h
FSID_NTFS = 7
FSID_FAT12 = 0F0h
FSID_CD = 30h

EXT2_FEATURE_RO_COMPAT_SPARSE_SUPER = 0x0001 // Sparse Superblock
EXT2_FEATURE_RO_COMPAT_LARGE_FILE = 0x0002   // 64-bit file size
EXT2_FEATURE_RO_COMPAT_BTREE_DIR = 0x0004    // Binary tree sorted directories

struct StringBuilder{
  uns4 len, max
  ptr4 data
}

struct FileInfo{
  uns4 FileAttributes
  uns8 FileSize
  uns8 CreationTime
  uns8 LastAccessTime
  uns8 LastWriteTime
  char FileName[MAX_PATH]
}

struct SuperBlock{
  uns4 s_inodes_count, s_blocks_count, s_r_blocks_count, s_free_blocks_count
  uns4 s_free_inodes_count, s_first_data_block, s_log_block_size
  uns4 s_log_frag_size, s_blocks_per_group, s_frags_per_group
  uns4 s_inodes_per_group, s_mtime, s_wtime
  uns2 s_mnt_count, s_max_mnt_count, s_magic, s_state, s_errors
  uns2 s_minor_rev_level
  uns4 s_lastcheck, s_checkinterval, s_creator_os, s_rev_level
  uns2 s_def_resuid, s_def_resgid
  uns4 s_first_ino
  uns2 s_inode_size, s_block_group_nr
  uns4 s_feature_compat, s_feature_incompat, s_feature_ro_compat
  //...
}

struct GroupBlock{
  uns4 bg_block_bitmap, bg_inode_bitmap, bg_inode_table
  uns2 bg_free_blocks_count, bg_free_inodes_count
  uns2 bg_used_dirs_count, bg_pad
  uns1 bg_reserved[12]
}

struct INode{
  uns2 i_mode, i_uid
  uns4 i_size, i_atime, i_ctime, i_mtime, i_dtime
  uns2 i_gid, i_links_count
  uns4 i_blocks, i_flags, i_osd1
  uns4 i_block[15]
  uns4 i_generation, i_file_acl, i_dir_acl/*size 32-63*/, i_faddr
  uns1 i_osd[12]
}

// HeapRec (16)
struct HeapRec{
  uns4 next, prev, size, type
}

[dorg 0x500000]

int2 mx, my, mb, old_mx, old_my, old_mb, state_old_mx, state_old_my

[dalign 32]
uns4 keystate
int2 mainpos, main_x1, main_x2
bool ignorestart, mainactive

[dalign 32]
MessageRec msg
WinRec win1
uns4 mainpanel, startwin, selectwin, selected
uns4 keybs, pkeyb[MAX_KEYBS], keybsize[MAX_KEYBS], specialkey

uns4 state, old_state, tmp_state, old_button, button_ofs, tid, doubleclicktime
uns1 state_win, tmp_state_win

// desktop block -->
[dalign 32]
uns1 wcount, wdesktop, wactive, wover
uns1 wpos[MAX_WIN], w_rsv2
WinRec win[MAX_WIN]
// <-- desktop block

WndClassRec wcl
uns4 miniature_timer, miniature_count, pminiature[MAX_MINIATURES]
int4 miniature_sx
uns1 tmp_miniature_winid, miniature_winid[MAX_MINIATURES]


[dalign 32]
SearchRec srch

FileInfo finfo

[dalign 32]
uns4 i, tab_ofs, first, last, f1, f2, pos1, pos2, c1, c2
uns4 ptrfi, atrv
int4 time_zone
uns8 time, num
SystemTime localtime
char temp[10]

char disks[32]
uns1 disks_count

uns1 color, sort_by, sort_by_inner, x0, y0, x, y, len, atri

char path[MAX_PATH], path2[MAX_PATH]

char buffer[MAX_BUFFER]

char fs_formatfn[63]
uns1 format_disk, fs_count, fs_filesystems, fs_filesystem
uns1 fs_cluzi, fs_systemdisk, fs_partition_type, fs_pdiskn
uns1 fs_buffer[512], fs_bootsect[512]
bool fs_formatsystem

[dalign 32]
uns4 fs_ofs_format, fs_setup_size, fs_kernel_size, fs_bootsofs
uns4 fs_value, fs_gb_diskofs, fs_syssect
uns4 e2_groups, e2_gblocks, e2_tmp

uns4 uid, gid
StringBuilder info_sb

[dalign 64]
uns8 e2_disksize

SuperBlock e2_sb
GroupBlock e2_gb
INode e2_inode

[dalign 32]
uns4 picon, hdcicon
uns4 pimg, hdcimg, hdcbg

[align 32]

pe_header:

db "PE"

dw 0, 14Ch, 2/*Number of sections*/
dd 0, 0/*Pointer to symbol table*/, 0/*Number of symbols*/
dw 224 /*Size of optional header*/, 0 /*Characteristics*/

// Optional header
dw 0/*OH magic*/

db 0, 0
dd offset lastoffset /*Size of code*/
dd 0/*Size of initialized data*/, #/*Size of uninitialized data*/
dd 0x1000/*Address of entry point*/
dd 0/*Base of code*/, 0x10000/*Base of data*/

dd 0x400000/*Image base*/
dd 0x1000 /*Section alignment*/, 0x200 /*File alignment*/
dw 4, 0 /*OS version*/, 0, 0 /*Image version*/, 4, 0 /*Subsystem version*/
dd 0, 0x10000/*Size of image*/, 0x400/*Size of headers*/
dd 0 /*Checksum*/
dw 2/*Subsystem*/, 0/*DLL characteristics*/
dd 0x100000/*stack*/, 0x1000
dd 0x100000/*heap*/, 0x1000
dd 0/*Loader flags*/, 16

// export
dd 0,0
// import
dd offset import + CRVA, 0x1000
// other directories
dd 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0

// Section table [lfanew + 18h + sizeOfOptionalHeader]
db ".text   "
dd offset lastoffset // VSize
dd 0x1000 // VAdr
dd offset lastoffset // Size of raw data
dd 0x400 // Pointer to raw data  !!! see also Head, COFS, CRVA
dd 0 // Pointer to relocations
dd 0 // Pointer to line numbers
dw 0 // Number of relocations
dw 0 // Number of line numbers
dd 0x60000060 // Characteristics

db ".data   "
dd # - 0x500000 // VSize
dd 0x100000 // VAdr
dd 0 // Size of raw data
dd 0 // Pointer to raw data
dd 0 // Pointer to relocations
dd 0 // Pointer to line numbers
dw 0 // Number of relocations
dw 0 // Number of line numbers
dd 0xC0000040 // Characteristics

times 0x400 - $, 0 // !!! see also Pointer to raw data, COFS, CRVA

[bits 32]

jmp main

[fill 0x1000]

import:

import_table:
dd offset user32_lookup + CRVA
dd 0 // dtm_stamp
dd 0 // forwarder_chain
dd offset user32_name + CRVA // user32_name_rva
dd offset user32_lookup + CRVA // import_adr_table_rva

dd offset gdi32_lookup + CRVA
dd 0 // dtm_stamp
dd 0 // forwarder_chain
dd offset gdi32_name + CRVA // user32_name_rva
dd offset gdi32_lookup + CRVA // import_adr_table_rva

//...

dd 0,0,0,0,0


user32_name: db "user32.dll\0"

user32_lookup:
ibeginpaint: dd offset ubeginpaint + CRVA // bit 31 must be 0
icreatewin: dd offset ucreatewin + CRVA // bit 31 must be 0
idefwndproc: dd offset udefwndproc + CRVA // bit 31 must be 0
idestroywin: dd offset udestroywin + CRVA // bit 31 must be 0
idrawicon: dd offset udrawicon + CRVA // bit 31 must be 0
iendpaint: dd offset uendpaint + CRVA // bit 31 must be 0
igetclientrect: dd offset ugetclientrect + CRVA // bit 31 must be 0
igetdc: dd offset ugetdc + CRVA // bit 31 must be 0
igetmsg: dd offset ugetmsg + CRVA // bit 31 must be 0
igetwindowdc: dd offset ugetwindowdc + CRVA // bit 31 must be 0
idispatchmsg: dd offset udispatchmsg + CRVA // bit 31 must be 0
iloadbitmap: dd offset uloadbitmap + CRVA // bit 31 must be 0
iloadicon: dd offset uloadicon + CRVA // bit 31 must be 0
ipostquit: dd offset upostquit + CRVA // bit 31 must be 0
iredrawwindow: dd offset uredrawwindow + CRVA // bit 31 must be 0
iregister: dd offset uregister + CRVA // bit 31 must be 0
ireleasedc: dd offset ureleasedc + CRVA // bit 31 must be 0
isetwinpos: dd offset usetwinpos + CRVA // bit 31 must be 0
ishowwindow: dd offset ushowwindow + CRVA // bit 31 must be 0
//...
dd 0

ubeginpaint:
dw 0 // hint
db "BeginPaint\0"
[fill 2]

ucreatewin:
dw 0 // hint
db "CreateWindowExA\0"
[fill 2]

udefwndproc:
dw 0 // hint
db "DefWindowProcA\0"
[fill 2]

udestroywin:
dw 0 // hint
db "DestroyWindow\0"
[fill 2]

udrawicon:
dw 0 // hint
db "DrawIcon\0"
[fill 2]

uendpaint:
dw 0 // hint
db "EndPaint\0"
[fill 2]

ugetclientrect:
dw 0 // hint
db "GetClientRect\0"
[fill 2]

ugetdc:
dw 0 // hint
db "GetDC\0"
[fill 2]

ugetmsg:
dw 0 // hint
db "GetMessageA\0"
[fill 2]

ugetwindowdc:
dw 0 // hint
db "GetWindowDC\0"
[fill 2]

udispatchmsg:
dw 0 // hint
db "DispatchMessageA\0"
[fill 2]

uloadbitmap:
dw 0 // hint
db "LoadBitmapA\0"
[fill 2]

uloadicon:
dw 0 // hint
db "LoadIconA\0"
[fill 2]

upostquit:
dw 0 // hint
db "PostQuitMessage\0"
[fill 2]

uredrawwindow:
dw 0 // hint
db "RedrawWindow\0"
[fill 2]

uregister:
dw 0 // hint
db "RegisterClassExA\0"
[fill 2]

ureleasedc:
dw 0 // hint
db "ReleaseDC\0"
[fill 2]

usetwinpos:
dw 0 // hint
db "SetWindowPos\0"
[fill 2]

ushowwindow:
dw 0 // hint
db "ShowWindow\0"
[fill 2]


gdi32_name: db "gdi32.dll\0"

gdi32_lookup:
ibar: dd offset ubar + CRVA // bit 31 must be 0
ibitblt: dd offset ubitblt + CRVA
icreatecompatiblebitmap: dd offset ucreatecompatiblebitmap + CRVA
icreatecompatibledc: dd offset ucreatecompatibledc + CRVA
icreatepen: dd offset ucreatepen + CRVA
icreaterectrgn: dd offset ucreaterectrgn + CRVA
icreatesolidbrush: dd offset ucreatesolidbrush + CRVA
ideleteobject: dd offset udeleteobject + CRVA
igetstockobject: dd offset ugetstockobject + CRVA
irectangle: dd offset urectangle + CRVA
iselectobject: dd offset uselectobject + CRVA
//...
dd 0

ubar:
dw 0 // hint
db "Bar\0"
[fill 2]

ubitblt:
dw 0 // hint
db "BitBlt\0"
[fill 2]

ucreatecompatiblebitmap:
dw 0 // hint
db "CreateCompatibleBitmap\0"
[fill 2]

ucreatecompatibledc:
dw 0 // hint
db "CreateCompatibleDC\0"
[fill 2]

ucreatepen:
dw 0 // hint
db "CreatePen\0"
[fill 2]

ucreaterectrgn:
dw 0 // hint
db "CreateRectRgn\0"
[fill 2]

ucreatesolidbrush:
dw 0 // hint
db "CreateSolidBrush\0"
[fill 2]

udeleteobject:
dw 0 // hint
db "DeleteObject\0"
[fill 2]

ugetstockobject:
dw 0 // hint
db "GetStockObject\0"
[fill 2]

urectangle:
dw 0 // hint
db "Rectangle\0"
[fill 2]

uselectobject:
dw 0 // hint
db "SelectObject\0"
[fill 2]

//...

import_lastoffset:

// IN: dl = x, dh = y
curto:
push ecx
 push esi
  push edx
   push edi
    push ebx
  
     mov ah, 3
     int 20h
  
    pop ebx
   pop edi
  pop edx
 pop esi
pop ecx
ret

// IN: esi -> string, ecx = length, bl = color
write:
push edx
 push edi
  push ebx
  
  mov ah, 2
  int 20h
  
  pop ebx
 pop edi
pop edx
ret

// IN: eax = number, ecx = system, bl = color
writen:
push ecx
 push edx
  push esi
   push edi

    sub esp, 36

	// Parse digits from the number

	mov esi, esp
	add esi, 36
	cmp ecx, 2
	jnb l_writen_1
		mov ecx, 10		// ecx must be >= 2

	l_writen_1:
		xor edx, edx
		div ecx
		cmp dl, 10
		jnb l_writen_2
			add dl, '0'
			jmp short l_writen_3

		l_writen_2:
			add dl, 55

		l_writen_3:
		dec esi
		mov [esi], dl
		or eax, eax
		jnz l_writen_1
	
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	mov dl, ' '
	
      dec esi
      inc ecx
      mov [esi], dl
      
	call write
	
    add esp, 36

    pop edi
  pop esi
 pop edx
pop ecx
ret

// IN: eax = number, ecx = system, bl = color, bh = minlen
writemin:
push ecx
 push edx
  push esi
   push edi

    sub esp, 36

	// Parse digits from the number

	mov esi, esp
	add esi, 36
	cmp ecx, 2
	jnb l_writemin_1
		mov ecx, 10		// ecx must be >= 2

	l_writemin_1:
		xor edx, edx
		div ecx
		cmp dl, 10
		jnb l_writemin_2
			add dl, '0'
			jmp short l_writemin_3

		l_writemin_2:
			add dl, 55

		l_writemin_3:
		dec esi
		mov [esi], dl
		or eax, eax
		jnz l_writemin_1
	
	cmp bh, 36
	jb l_writemin_4
	  mov bh, 36
	  
	l_writemin_4:
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	mov dl, ' '
	
	l_writemin_5:
	  cmp cl, bh
	  jnb l_writemin_6
          dec esi
          inc ecx
          mov [esi], dl
          jmp short l_writemin_5
      
	l_writemin_6:	  
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	
	call write
	
    add esp, 36

    pop edi
  pop esi
 pop edx
pop ecx
ret

THOUSAND_SEPARATOR = ','

// IN: edx:eax = number, ecx = system, bl = color
writen8:
push ecx
 push esi
  push edi

    sub esp, 72

    // Parse digits from the number
    mov esi, esp
    add esi, 72

    mov dword ptr num[0], eax
    mov dword ptr num[4], edx
    xor bh, bh

    cmp ecx, 2
    jnb l_writen8_1
      mov ecx, 10		// ecx must be >= 2
    
    l_writen8_1:
      cmp bh, 3
      jb l_writen_12
        dec esi
        mov byte ptr [esi], THOUSAND_SEPARATOR
        xor bh, bh
        
      l_writen_12:
      inc bh
      xor edx, edx
      mov eax, dword ptr num[4]
      div ecx
      mov dword ptr num[4], eax
      mov eax, dword ptr num[0]
      div ecx
      mov dword ptr num[0], eax
      
      cmp dl, 10
      jnb l_writen8_2
        add dl, '0'
        jmp short l_writen8_3
      
      l_writen8_2:
        add dl, 55
      
      l_writen8_3:
      dec esi
      mov [esi], dl
      
      mov eax, dword ptr num[0]
      mov edx, dword ptr num[4]
      test eax, eax
      jnz l_writen8_1
        test edx, edx
        jnz l_writen8_1
      
    mov ecx, esp
    add ecx, 72
    sub ecx, esi  // ecx = len
    mov dl, ' '
    
    dec esi
    inc ecx
    mov [esi], dl
     
    call write
     
    add esp, 72
    
  pop edi
 pop esi
pop ecx
ret

// IN: edx -> path & mask, edi -> SearchRec
// OUT: al = 0 || erc
find_first:
mov ah, 22
int 20h
cmp al, ERC_BUSY
jnz l_find_first_9
  call noop
  jmp short find_first
  
l_find_first_9:
ret

// IN: edi -> SearchRec
// OUT: al = 0 || erc
find_next:
mov ah, 23
int 20h
cmp al, ERC_BUSY
jnz l_find_next_9
  call noop
  jmp short find_next
  
l_find_next_9:
ret

// IN: edi -> SearchRec
find_close:
mov ah, 48
int 20h
ret

// IN: edx -> pathz
cdir:
mov ah, 16
int 20h
cmp al, ERC_BUSY
jnz l_cdir_9
  call noop
  jmp short cdir
  
l_cdir_9:
ret

// IN: edi -> buffer[MAX_PATH]
// OUT: al = 0 || erc
get_current_directory:
mov ah, 52
int 20h
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fopen:
mov esi, 3
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fopen_9
  call noop
  jmp short fopen
  
l_fopen_9:
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fopenread:
mov esi, 1
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fopenread_9
  call noop
  jmp short fopenread
  
l_fopenread_9:
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fcreate:
mov esi, 20h
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fcreate_9
  call noop
  jmp short fcreate
  
l_fcreate_9:
ret

// IN: ebx = fhandle
// OUT: edx:ecx = fpos
fgetpos:
mov ah, 14
int 20h
cmp al, ERC_BUSY
jnz l_fgetpos_9
  call noop
  jmp short fgetpos
  
l_fgetpos_9:
ret

// IN: ebx = fhandle, edx:edi = file offset
// OUT: al = erc
fsetpos:
mov ah, 12
int 20h
cmp al, ERC_BUSY
jnz l_fsetpos_9
  call noop
  jmp short fsetpos
  
l_fsetpos_9:
ret

// IN: ebx = fhandle
// OUT: edx:ecx = fsize
fgetsize:
mov ah, 15
int 20h
cmp al, ERC_BUSY
jnz l_fgetsize_9
  call noop
  jmp short fgetsize
  
l_fgetsize_9:
ret

// IN: ebx = fhandle
fclose:
mov ah, 9
int 20h
cmp al, ERC_BUSY
jnz l_fclose_9
  call noop
  jmp short fclose
  
l_fclose_9:
ret

// IN: ebx = fhandle, edi -> data, ecx = size
// OUT: al = erc, ecx = size read
fread:
mov ah, 10
int 20h
cmp al, ERC_BUSY
jnz l_fread_9
  call noop
  jmp short fread
  
l_fread_9:
ret

// IN: ebx = fhandle, edi -> data, ecx = size
// OUT: al = erc, ecx = size write
fwrite:
mov ah, 11
int 20h
cmp al, ERC_BUSY
jnz l_fwrite_9
  call noop
  jmp short fwrite
  
l_fwrite_9:
ret

// IN: edx -> filenamez
rm:
mov ah, 18
int 20h
cmp al, ERC_BUSY
jnz l_rm_9
  call noop
  jmp short rm
  
l_rm_9:
ret

// IN: edx -> filenamez
md:
mov ah, 17
int 20h
cmp al, ERC_BUSY
jnz l_md_9
  call noop
  jmp short md
  
l_md_9:
ret

// IN: edx -> path & filenamez, esi -> new filenamez
// OUT: al = erc
ren:
mov ah, 20
int 20h
cmp al, ERC_BUSY
jnz l_ren_9
  call noop
  jmp short ren
  
l_ren_9:
ret

// IN: edx -> filenamez, esi -> new path
mv:
mov ah, 21
int 20h
cmp al, ERC_BUSY
jnz l_mv_9
  call noop
  jmp short mv
  
l_mv_9:
ret

// IN: esi = ldiskn
resetdisk:
mov ah, 63
int 20h
ret

// IN: edx -> filenamez, esi = mode
// OUT: al = erc, ebx = fhandle
open_link:
mov ah, 66
int 20h
cmp al, ERC_BUSY
jnz l_open_link_9
  call noop
  jmp short open_link
  
l_open_link_9:
ret

// IN: edx -> filenamez
// OUT: al = erc
rm_link:
mov ah, 67
int 20h
cmp al, ERC_BUSY
jnz l_rm_link_9
  call noop
  jmp short rm_link
  
l_rm_link_9:
ret

// IN: al = ldiskn
// OUT: al = erc
flush:
movzx esi, al

l_flush_1:
mov ah, 39 
int 20h
cmp al, ERC_BUSY
jnz l_flush_9
  call noop
  jmp short l_flush_1
  
l_flush_9:
ret

// IN: ebx = fhandle
// OUT: al = erc, edx:ecx = ftime
get_mtime:
mov ah, 74
int 20h
cmp al, ERC_BUSY
jnz l_get_mtime_9
  call noop
  jmp short get_mtime
  
l_get_mtime_9:
ret

// IN: ebx = fhandle, edx:ecx = ftime
// OUT: al = erc
set_mtime:
mov ah, 75
int 20h
cmp al, ERC_BUSY
jnz l_set_mtime_9
  call noop
  jmp short set_mtime
  
l_set_mtime_9:
ret

// IN: edx -> filenamez, esi = atrbs
// OUT: al = errorcode
// differrent behavior for windows and linux
chmod:
mov ah, 76
int 20h
cmp al, ERC_BUSY
jnz l_chmod_9
  call noop
  jmp short chmod
  
l_chmod_9:
ret

// only starter, root
// IN: edx -> filenamez, esi = new owner
// OUT: al = erc
chown:
mov ah, 78
int 20h
cmp al, ERC_BUSY
jnz l_chown_9
  call noop
  jmp short chown
  
l_chown_9:
ret

// only starter, root or owner
// IN: edx -> filenamez, esi = new group
// OUT: al = erc
chgrp:
mov ah, 79
int 20h
cmp al, ERC_BUSY
jnz l_chgrp_9
  call noop
  jmp short chgrp
  
l_chgrp_9:
ret

// IN: edx -> filenamez
// OUT: al = erc, ecx = uid, edx = gid
fuidgid:
mov ah, 82
int 20h
cmp al, ERC_BUSY
jnz l_fuidgid_9
  call noop
  jmp short fuidgid
  
l_fuidgid_9:
ret

// only starter
// IN: edx:ebx = disk offset, ecx = size,
//     esi = logical disk number, edi -> target
disk_read:
mov ah, 36
int 20h
cmp al, ERC_BUSY
jnz l_disk_read_9
  call noop
  jmp short disk_read
  
l_disk_read_9:
ret

// only starter
// IN: edx:ebx = disk offset, ecx = size,
//     esi = logical disk number, edi -> source
disk_write:
mov ah, 37
int 20h
cmp al, ERC_BUSY
jnz l_disk_write_9
  call noop
  jmp short disk_write
  
l_disk_write_9:
ret

// OUT: al = logical disk number
get_boot_disk:
mov ah, 77
int 20h
movzx eax, al
ret

// OUT: al = logical disk number
get_users_disk:
mov ah, 83
int 20h
movzx eax, al
ret

// IN: esi = logical disk number
// OUT: al = type (2:fd, 3:cd, 4:hd), ah = pdiskn,
//      edx:ecx = disk size in sectors, edi:esi = base in sectors
get_disk_type:
mov ah, 53
int 20h
ret

// IN: esi = logical disk number
// OUT: edx:eax = disk size in bytes
get_disk_size:
mov ah, 38
int 20h
ret

// IN: al = ldiskn
// OUT: cl = erc, edx:eax = free bytes)
disk_free:
mov esi, eax

l_disk_free_1:
mov ah, 68
int 20h
cmp al, ERC_BUSY
jnz l_disk_free_9
  call noop
  jmp short l_disk_free_1
  
l_disk_free_9:
xchg eax, ecx
ret

// IN: al = ldiskn
// OUT: al = erc
reset_disk:
mov esi, eax

l_reset_disk_1:
mov ah, 63
int 20h
cmp al, ERC_BUSY
jnz l_reset_disk_9
  call noop
  jmp short l_reset_disk_1
  
l_reset_disk_9:
ret

// IN: edx:ebx = sector, ecx = count, edi -> data,
//     esi = physical HD number
disk_read_sector:
mov ah, 40
int 20h
cmp al, ERC_BUSY
jnz l_disk_read_sector_9
  call noop
  jmp short disk_read_sector
  
l_disk_read_sector_9:
ret

// IN: edx:ebx = sector, ecx = count, edi -> data,
//     esi = physical HD number
disk_write_sector:
mov ah, 41
int 20h
cmp al, ERC_BUSY
jnz l_disk_write_sector_9
  call noop
  jmp short disk_write_sector
  
l_disk_write_sector_9:
ret

// IN: bl = 0 || WINFLAGS_ALWAYSONTOP, ecx = {int2 x, y},
//     edx = {int2 w, h}, esi = hwnd
// OUT: al = erc, edx = wdesktop:winid
createwin:
mov ah, 86
int 20h
ret

// IN: dl = winid
// OUT: al = erc
destroywin:
mov ah, 87
int 20h
ret

// IN: ecx = x1, ebx = y1, esi = x2, edi = y2
paint:
mov ah, 88
int 20h
ret

// OUT: ecx = screen width, edx = screen height, edi -> background
ginfo:
mov ah, 89
int 20h
ret

// IN: ecx = main panel height
// OUT: al = erc
setmainpanelh:
mov ah, 92
int 20h
ret

// OUT: cl = w, ch = h, bl = shift x, bh = shift y
getmouseinfo:
mov ah, 97
int 20h
ret

// IN: ecx = x, ebx = y
// OUT: al = erc, edx = winid
getwinat:
mov ah, 93
int 20h
ret

// IN: dl = winid, dh = 1(alt+tab) || 2(click)
// OUT: al = erc
activate:
mov ah, 94
int 20h
ret

// IN: dl = winid
// OUT: al = erc
setover:
mov ah, 95
int 20h
ret

// IN: dl = winid, edi -> WinRec
// OUT: al = erc
getwin:
mov ah, 98
int 20h
ret

// OUT: ecx = active winid, edx = over winid,
//      esi = active hwnd, edi = over hwnd
getactiveover:
mov ah, 99
int 20h
ret

// IN: edi -> variable of size 8420 B
getwindows:
mov ah, 102
int 20h
ret

// IN: edi -> variable of size 8420 B
setwindows:
mov ah, 103
int 20h
ret

// IN: dl = winid, cl = pressed button mask (0x10, 0x20, 0x40)
setbuttons:
mov ah, 110
int 20h
ret

// IN: dl = winid, dh = SW_*
// OUT: al = erc
showwindow:
mov al, dh
movzx edi, dl
inc edi
push eax
push edi
call dword ptr [ishowwindow + COFS]
ret

// IN: dl = winid, ecx = w, ebx = h
// OUT: edi -> variable at global heap
getminiature:
mov ah, 106
int 20h
ret

minimizeall:
mov ah, 107
int 20h
ret

// IN: edx -> filenamez, esi -> args, edi -> env_var
// OUT: al = erc, ebx = pid
create_proc:
mov ah, 28
int 20h
ret

// IN: ebx = pid
// OUT: al = erc
kill_proc:
mov ah, 29
int 20h
ret

// IN: ecx = stack size, esi = new eip
// OUT: al = erc, ebx = threadid
create_thread:
mov ah, 30
int 20h
ret

// IN: ebx = threadid
// OUT: al = erc
kill_thread:
mov ah, 31
int 20h
ret

// IN: edi = pid || (16384 + threadid)
start:
mov ah, 34
int 20h
ret

// IN: edi = pid || (16384 + threadid)
stop:
mov ah, 35
int 20h
ret

// OUT: ebx = pid, edx = ppid, edi = threadid
getpid:
mov ah, 45
int 20h
ret

// KEEP: ebx, ebp
waitkey:
push ebx
 push ebp

  l_waitkey_5:
    call getmsg
    cmp ecx, WM_KEYDOWN
    jnz l_waitkey_5

 pop ebp
pop ebx
ret

// IN: dl = winid
// OUT: al = kbdid
getkbd:
mov ah, 112
int 20h
ret

// only starter, IN: dl = winid, cl = kbdid
setkbd:
mov ah, 113
int 20h
ret

noop:
mov ah, 0
int 20h
ret

// IN: ecx = size
// OUT: al = erc, ebx = ptr
malloc:
mov ah, 24
int 20h
ret

// IN: ebx = ptr
free:
mov ah, 25
int 20h
ret

// OUT: ebx = wndid:sender, ecx = msg, edx = wp, esi = lp
getmsg:
mov ah, 5 // get system message
int 20h
or al, al
jz l_getmsg_9
  mov ah, 7 // get message
  int 20h
  or al, al
  jz l_getmsg_9
    mov ah, 45 // get pid, tid; OUT: edi = tid
    int 20h
    or edi, 16384
    mov ah, 35 // stop thread
    int 20h
    jmp short getmsg
  
l_getmsg_9:
ret

// only system or starter
// IN: ebx = winid:processid(16384+threadid), ecx = msg, edx = wp, esi = lp
// OUT: al = erc
postsysmsg:
mov ah, 4
int 20h
ret

// only system or starter
// IN: bl = winid, ecx = msg, edx = wp, esi = lp
// OUT: al = erc
postwin:
cmp bl, MAX_WIN
jnb l_postwin_8
  mov ah, 104
  int 20h
  ret
  
l_postwin_8:
mov al, ERC_INVALID_WINDOW
ret

// only system or starter
// IN: bl = winid, ecx = msg, edx = wp, esi = lp
// OUT: al = erc
postwind:
cmp bl, MAX_WIN
jnb l_postwind_8
  mov ah, 104
  int 20h
  ret
  
l_postwind_8:
// desktop
call mbdesktop
ret

// IN: esi -> ftime, edi -> SystemTime
ftime2local:
mov eax, time_zone
mov ecx, 3600
imul ecx
mov ecx, 10000000
imul ecx

add eax, [esi]
adc edx, [esi + 4]
mov dword ptr time[0], eax
mov dword ptr time[4], edx

mov esi, offset time
mov ah, 59
int 20h
ret

// IN: ecx = uid, edi -> byte[256]
getuserinfo:
mov ah, 80
int 20h
cmp al, ERC_BUSY
jnz l_getuserinfo_9
  call noop
  jmp short getuserinfo
  
l_getuserinfo_9:
ret

// IN: ecx = gid, edi -> byte[256]
getgroupinfo:
mov ah, 81
int 20h
cmp al, ERC_BUSY
jnz l_getgroupinfo_9
  call noop
  jmp short getgroupinfo
  
l_getgroupinfo_9:
ret

// IN: ecx = delay_ms
sleep:
mov ah, 32
int 20h
ret

// IN: ecx = ms(max 3600000), dx = winid, ebx = id, edi = ofs
// OUT: al = erc
addtimer:
mov ah, 64
int 20h
ret

// IN: dx = winid, ebx = id
// OUT: al = erc
rmtimer:
mov ah, 65
int 20h
ret

// IN: esi -> StringBuilder
// KEEP: esi
sb_init:
xor eax, eax
mov [esi + offset StringBuilder.len], eax
mov [esi + offset StringBuilder.max], eax
mov [esi + offset StringBuilder.data], eax
ret

// IN: esi -> StringBuilder, edi -> data, ecx = len
// OUT: al = erc (0: ok, 1: not enough memory)
// KEEP: esi
sb_add:
mov edx, [esi + offset StringBuilder.max]
mov eax, [esi + offset StringBuilder.len]
add eax, ecx
cmp eax, edx
jna l_sb_add2
  // len + ecx > max
  cmp edx, 16
  jnb l_sb_add11
    mov edx, 16
    
  l_sb_add11:
  cmp eax, edx
  jna l_sb_add14
    shl edx, 1
    cmp edx, 0
    jnz l_sb_add11
      
      l_sb_add13:
      
      mov al, 1
      
      ret
    
  l_sb_add14:
  // allocate a new block
  push esi
   push edi
    push ecx
     push edx
      mov ecx, edx
      call malloc
      // OUT: ebx
     pop edx
    pop ecx
   pop edi
  pop esi
  or al, al
  jnz l_sb_add13
  
  // copy old data to the new block
  mov [esi + offset StringBuilder.max], edx
  push esi
   push edi
    push ecx
     push ebx
       mov ecx, [esi + offset StringBuilder.len]
       mov esi, [esi + offset StringBuilder.data]
       mov edi, ebx
       mov ebx, esi
       cld
       rep movsb
       
       // free the old block
       or ebx, ebx
       jz l_sb_add18
         call free
         
       l_sb_add18:
     pop ebx 
    pop ecx
   pop edi
  pop esi
  mov [esi + offset StringBuilder.data], ebx

l_sb_add2:
// copy data
mov ebx, edi
mov edi, [esi + offset StringBuilder.data]
add edi, [esi + offset StringBuilder.len]
add [esi + offset StringBuilder.len], ecx

push esi
  mov esi, ebx
  cld
  rep movsb
pop esi

mov al, 0

ret

// IN: esi -> StringBuilder
// KEEP: esi
sb_done:
mov ebx, [esi + offset StringBuilder.data]
or ebx, ebx
jz sb_done_2
  
  push esi
  
    call free
  
  pop esi
  
sb_done_2:
xor eax, eax
mov [esi + offset StringBuilder.len], eax
mov [esi + offset StringBuilder.max], eax
mov [esi + offset StringBuilder.data], eax
ret

formatpath: "c:/system/format/\0"
formatbootsect: "bootsect.dat\0"
formatbootscd: "bootscd.dat\0"
formatbootshd: "bootshd.dat\0"
formatsetup: "setup.dat\0"
formatkernel: "kernel.dat\0"
formatstarter: "starter.exe\0"
formatsystem: "c:/system\0"
formatsystemstarter: "c:/system/starter.exe\0"

// IN: fs_bootsofs, fs_formatsystem
// OUT: al = erc, fs_ofs_format, fs_bootsect,
//      fs_kernel_size in sectors, fs_setup_size in sectors
// KEEP: edi
format_sizes:

push edi
  
  xor eax, eax
  mov fs_kernel_size, eax
  mov fs_setup_size, eax
  
  // clear buffer
  mov ecx, 512 / 4
  mov edi, offset fs_bootsect
  cld
  rep stosd
  
  // system?
  test fs_formatsystem, 1
  jz near l_format_sizes_9  // al = 0
  
  mov edi, offset fs_formatfn
  
  // path
  mov esi, offset formatpath + COFS
  
  l_format_sizes_11:
  lodsb
  test al, al
  jz l_format_sizes_12
    stosb
    jmp short l_format_sizes_11
  
  l_format_sizes_12:
  mov fs_ofs_format, edi
  
  // bootsect
  mov esi, fs_bootsofs
  
  l_format_sizes_13:
    lodsb
    stosb
    test al, al
    jnz l_format_sizes_13
    
  // read from file
  mov edx, offset fs_formatfn
  call fopenread
pop edi
test al, al
jnz near l_format_sizes_9
push edi
  push ebx
    mov edi, offset fs_bootsect
    mov ecx, 512
    call fread
  pop ebx
  call fclose
  
  // end of sector marker
  mov word ptr fs_bootsect[510], 0AA55h
  
  // setup size
  mov edi, fs_ofs_format
  mov esi, offset formatsetup + COFS
  
  l_format_sizes_14:
    lodsb
    stosb
    test al, al
    jnz l_format_sizes_14
  
  mov edx, offset fs_formatfn
  call fopenread
pop edi
test al, al
jnz near l_format_sizes_9
push edi
  push ebx
    call fgetsize
  pop ebx
  push ecx
    call fclose
    
    // kernel size
    mov edi, fs_ofs_format
    mov esi, offset formatkernel + COFS
    
    l_format_sizes_15:
      lodsb
      stosb
      test al, al
      jnz l_format_sizes_15
    
    mov edx, offset fs_formatfn
    call fopenread
  pop ecx
pop edi
test al, al
jnz near l_format_sizes_9
push edi
  push ecx
    push ebx
      call fgetsize
    pop ebx
    push ecx
      call fclose
    pop ecx
    add ecx, 511
    shr ecx, 9
    mov fs_kernel_size, ecx
  pop eax
  add eax, 511
  shr eax, 9
  mov fs_setup_size, eax
  add eax, ecx
  inc eax  // bootsect
  
  cmp eax, 512
  jna l_format_sizes_8
    mov al, ERC_FILE_TOO_BIG
    jmp short l_format_sizes_9
  
  l_format_sizes_8:
    mov al, 0
  
  l_format_sizes_9:

pop edi

ret

// IN: fs_formatfn, format_disk,
//     ecx = sector count, esi = first sector number
// USES: fs_buffer
format_copy:
mov edx, offset fs_formatfn
push esi
 push ecx
  call fopenread
 pop ecx
pop esi
test al, al
jnz l_format_copy_9

l_format_copy_5:
  push ebx
   push ecx
   
    push esi
      mov edi, offset fs_buffer
      mov ecx, 512
      call fread
    pop esi
    
    push esi
      xor edx, edx
      mov ebx, esi
      shl ebx, 9
      mov ecx, 512
      mov edi, offset fs_buffer
      movzx esi, format_disk
      call disk_write
    pop esi
    
   pop ecx
  pop ebx
  inc esi
  loop l_format_copy_5
  
call fclose
mov al, 0

l_format_copy_9:
ret

// IN: format_disk, fs_partition_type
// USES: fs_pdiskn
format_correct_partition:
movzx esi, format_disk
// IN: esi = logical disk number
// OUT: al = type (2:fd, 3:cd, 4:hd), ah = pdiskn,
//      edx:ecx = disk size in sectors, edi:esi = base in sectors
call get_disk_type
mov fs_pdiskn, ah
cmp al, 4
jnz l_format_correct_partition_9
 cmp edi, 0
 jnz l_format_correct_partition_9
  push esi
    movzx esi, fs_pdiskn
    xor edx, edx
    xor ebx, ebx
    mov ecx, 1
    mov edi, offset fs_buffer
    // IN: edx:ebx = sector, ecx = count, edi -> data,
    //     esi = physical HD number
    call disk_read_sector
  pop esi
  
  mov ebx, 1BEh
  
  l_format_correct_partition_5:
    mov eax, dword ptr fs_buffer[ebx + 8]  // partition offset in sectors
    cmp eax, esi
    jnz l_format_correct_partition_6
      // current partition
      mov al, fs_partition_type
      cmp al, fs_buffer[ebx + 4]  // partition type
      jz l_format_correct_partition_9
        mov fs_buffer[ebx + 4], al
        
        movzx esi, fs_pdiskn
        xor edx, edx
        xor ebx, ebx
        mov ecx, 1
        mov edi, offset fs_buffer
        // IN: edx:ebx = sector, ecx = count, edi -> data,
        //     esi = physical HD number
        call disk_write_sector
        jmp short l_format_correct_partition_9
        
    l_format_correct_partition_6:
    add ebx, 16
    cmp ebx, 1FEh
    jb l_format_correct_partition_5
  
l_format_correct_partition_9:
ret

[bits 16]

format_notsys:
push 7C0h
pop ds
mov si, offset format_notsysmsg - offset format_notsys + 32
call format_notsys_writez
mov ah, 0
int 16h
//int 18h
format_notsys1: jmp short format_notsys1

format_notsys_writez:
lodsb
test al, al
jz l_format_notsys_9
  xor bh, bh
  mov ah, 0Eh
  int 10h
  jmp short format_notsys_writez
  
l_format_notsys_9:
ret

format_notsysmsg: db "Not system disk\0"
format_notsysend:

[bits 32]

format_copystarter:
mov edi, fs_ofs_format
mov esi, offset formatstarter + COFS

l_format_copystarter_1:
  lodsb
  stosb
  test al, al
  jnz l_format_copystarter_1

mov al, format_disk
or al, 64
mov [offset formatsystem + COFS], al
mov [offset formatsystemstarter + COFS], al

// md system
mov edx, offset formatsystem + COFS
call md

// copy format/starter.exe
mov edx, offset fs_formatfn
call fopenread
test al, al
jnz l_format_copystarter_9
  mov f1, ebx
  
  mov edx, offset formatsystemstarter + COFS
  call fcreate
  test al, al
  jnz l_format_copystarter_8
    mov f2, ebx
    
    l_format_copystarter_5:
      mov ebx, f1
      mov edi, offset buffer
      mov ecx, MAX_BUFFER
      push edi
        call fread
      pop edi
      test al, al
      jnz l_format_copystarter_7
      
      mov ebx, f2
      call fwrite
      test al, al
      jnz l_format_copystarter_7
      cmp ecx, MAX_BUFFER
      jz l_format_copystarter_5
      
    l_format_copystarter_7:
    mov ebx, f2
    call fclose
    
    mov al, 0
    
  l_format_copystarter_8:
  push eax
    mov ebx, f1
    call fclose
  pop eax
  
l_format_copystarter_9:
ret

FAT12_MAX_ROOT = 224

SETUP_SIZE_OFS = 32
KERNEL_SIZE_OFS = 36

// IN: al = ldiskn, fs_formatsystem, fs_systemdisk
//     edi = logblocksize (0..3 = 1024..8192)
// OUT: al = erc, format_disk, fs_bootsect
// USES: fs_buffer, fs_bootsect
FAT12_format:
and al, 31
mov format_disk, al

mov al, fs_systemdisk
or al, 64
mov [offset formatpath + COFS], al

cmp edi, 4
jb l_FAT12_format_1
  mov al, ERC_INVALID_VALUE
  ret
  
l_FAT12_format_1:

// * first sector *
mov fs_bootsofs, offset formatbootsect + COFS
call format_sizes
test al, al
jnz near l_FAT12_format_9

mov eax, fs_kernel_size
mov dword ptr fs_bootsect[KERNEL_SIZE_OFS], eax
mov eax, fs_setup_size
mov dword ptr fs_bootsect[SETUP_SIZE_OFS], eax

test fs_formatsystem, 1
jnz near l_FAT12_format_19

l_FAT12_format_18:
  // not system
  push edi
    mov dword ptr fs_bootsect[0], 1DE9h  // jmp main
    // [32]
    mov esi, offset format_notsys + COFS
    mov edi, offset fs_bootsect + 32
    mov ecx, offset format_notsysend - offset format_notsys
    cld
    rep movsb
  pop edi

l_FAT12_format_19:
mov dword ptr fs_bootsect[3], "TR32"  // OEM id
mov dword ptr fs_bootsect[7], "    "
mov word ptr fs_bootsect[11], 200h  // sector size
mov ecx, edi
mov eax, 1
shl eax, cl
mov byte ptr fs_bootsect[13], al  // cluster size in sectors
mov ax, 1
test fs_formatsystem, 1
jz l_FAT12_format_2
  mov ax, 512
  
l_FAT12_format_2:
mov word ptr fs_bootsect[14], ax  // reserved sectors
mov byte ptr fs_bootsect[16], 2  // number of FATs
mov word ptr fs_bootsect[17], FAT12_MAX_ROOT
movzx esi, format_disk
push edi
  call get_disk_size
pop edi
test eax, eax
jnz l_FAT12_format_3
  mov al, ERC_INVALID_DISK_NUMBER
  ret
  
l_FAT12_format_3:
shr eax, 9
mov word ptr fs_bootsect[19], ax  // number of sectors
mov byte ptr fs_bootsect[21], 0F0h  // media descriptor
mov ecx, edi
movzx edx, word ptr fs_bootsect[14]
sub eax, edx
shr eax, cl  // eax = clusters
mov edx, eax
inc edx
shr edx, 1
add eax, edx  // eax = eax * 1.5
add eax, 511
shr eax, 9
mov word ptr fs_bootsect[22], ax  // size of FAT in sectors

mov ax, word ptr fs_bootsect[19]  // number of sectors
cmp ax, 720
jnz l_FAT12_format_31
  mov ax, 9
  jmp short l_FAT12_format_39
  
l_FAT12_format_31:
cmp ax, 2400
jnz l_FAT12_format_32
  mov ax, 15
  jmp short l_FAT12_format_39
  
l_FAT12_format_32:
cmp ax, 1440
jnz l_FAT12_format_33
  mov ax, 9
  jmp short l_FAT12_format_39
  
l_FAT12_format_33:
cmp ax, 2880
jnz l_FAT12_format_34
  mov ax, 18
  jmp short l_FAT12_format_39
  
l_FAT12_format_34:
cmp ax, 5760
jnz l_FAT12_format_35
  mov ax, 36
  jmp short l_FAT12_format_39
  
l_FAT12_format_35:
mov ax, 18

l_FAT12_format_39:
mov word ptr fs_bootsect[24], ax  // sectors per track
mov word ptr fs_bootsect[26], 2  // number of surfaces
xor eax, eax
mov dword ptr fs_bootsect[28], eax  // partition offset
mov word ptr fs_bootsect[510], 0AA55h  // end of sector marker

l_FAT12_format_4:
  xor edx, edx
  xor ebx, ebx
  mov ecx, 512
  mov edi, offset fs_bootsect
  movzx esi, format_disk
  call disk_write
  cmp al, ERC_DISK_CHANGED
  jz l_FAT12_format_4
  
test al, al
jnz near l_FAT12_format_9

// * FATs *
movzx ebx, word ptr fs_bootsect[14]  // reserved sectors
xor eax, eax
mov edi, offset fs_buffer
mov ecx, 512 / 4
cld
rep stosd
movzx ecx, word ptr fs_bootsect[22]  // size of FAT in sectors
test ecx, ecx
jnz l_FAT12_format_48
  mov al, ERC_FS
  jmp l_FAT12_format_9
  
l_FAT12_format_48:
mov fs_count, 2

l_FAT12_format_5:
  mov dword ptr fs_buffer[0], 0xFFFFF0
  
  push ebx
   push ecx
    xor edx, edx
    shl ebx, 9
    mov ecx, 512
    mov edi, offset fs_buffer
    movzx esi, format_disk
    call disk_write
   pop ecx
  pop ebx  
  test al, al
  jnz near l_FAT12_format_9
  
  inc ebx
  mov dword ptr fs_buffer[0], 0
  
  push ecx
    dec ecx
    jecxz l_FAT12_format_69
    
    l_FAT12_format_6:
      push ebx
       push ecx
        xor edx, edx
        shl ebx, 9
        mov ecx, 512
        mov edi, offset fs_buffer
        movzx esi, format_disk
        call disk_write
       pop ecx
      pop ebx
      test al, al
      jnz l_FAT12_format_69
      
      inc ebx
      loop l_FAT12_format_6
    
    l_FAT12_format_69:
  pop ecx
  test al, al
  jnz near l_FAT12_format_9
  
  dec fs_count
  cmp fs_count, 0
  ja l_FAT12_format_5

// clear root directory
mov ecx, FAT12_MAX_ROOT
shl ecx, 5  // log2 sizeof DirRec
add ecx, 511
shr ecx, 9

l_FAT12_format_7:
  push ebx
   push ecx
    xor edx, edx
    shl ebx, 9
    mov ecx, 512
    mov edi, offset fs_buffer
    movzx esi, format_disk
    call disk_write
   pop ecx
  pop ebx
  test al, al
  jnz near l_FAT12_format_9
  
  inc ebx
  loop l_FAT12_format_7

test fs_formatsystem, 1
jz near l_FAT12_format_9
  
  // copy setup
  mov edi, fs_ofs_format
  mov esi, offset formatsetup + COFS
  
  l_FAT12_format_81:
    lodsb
    stosb
    test al, al
    jnz l_FAT12_format_81
  
  mov ecx, fs_setup_size
  xor esi, esi
  inc esi
  call format_copy
  test al, al
  jnz l_FAT12_format_9
    
    // copy kernel
    mov edi, fs_ofs_format
    mov esi, offset formatkernel + COFS
    
    l_FAT12_format_83:
      lodsb
      stosb
      test al, al
      jnz l_FAT12_format_83
    
    mov ecx, fs_kernel_size
    mov esi, fs_setup_size
    inc esi
    call format_copy
    
l_FAT12_format_9:
ret

SETUP_SIZE_OFS_HD = 20
KERNEL_SIZE_OFS_HD = 24
BOOT_DISK_OFS_HD = 28
SYSTEM_BOOT_OFS_HD = 32

EXT2_FIRST_INO = 11
EXT2_ROOT_INO = 2

RESERVED_INODES = EXT2_FIRST_INO - 1
LOG_INODES = 10 + 2

EXT2_S_IFDIR  = 0x4000 //directory
ACCESS_DEFAULT = (ACCESS_R|ACCESS_W|ACCESS_X)<<6 | ((ACCESS_R|ACCESS_X)<<3) | ACCESS_R|ACCESS_X


// IN: al = ldiskn, fs_formatsystem, fs_systemdisk
//     edi = logblocksize (0..3 = 1024..8192), 
// OUT: al = erc, format_disk
// USES: fs_buffer, fs_bootsect, e2_disksize, fs_syssect
e2_format:
and al, 31
mov format_disk, al

mov al, fs_systemdisk
or al, 64
mov [offset formatpath + COFS], al

// edi
cmp edi, 4
jb l_e2_format_1
  mov al, ERC_INVALID_VALUE
  ret
  
l_e2_format_1:
add edi, 10

// system sizes
mov fs_bootsofs, offset formatbootshd + COFS
call format_sizes  // keep edi
test al, al
jnz near l_e2_format_9

// bootsect
mov eax, fs_setup_size
mov dword ptr fs_bootsect[SETUP_SIZE_OFS_HD], eax
mov eax, fs_kernel_size
mov dword ptr fs_bootsect[KERNEL_SIZE_OFS_HD], eax
mov al, format_disk
mov fs_bootsect[BOOT_DISK_OFS_HD], al

// disk size
push edi
  movzx esi, format_disk
  call get_disk_size
  mov dword ptr e2_disksize[0], eax
  mov dword ptr e2_disksize[4], edx
pop edi

// super block
mov eax, dword ptr e2_disksize[0]
mov edx, dword ptr e2_disksize[4]
shr eax, LOG_INODES
mov ebx, edx
shr edx, LOG_INODES
shl ebx, 32 - LOG_INODES
or eax, ebx
mov e2_sb.s_inodes_count, eax

l_e2_format_10:
mov ecx, edi
mov ebx, 1
shl ebx, cl
mov eax, dword ptr e2_disksize[4]
xor edx, edx
div ebx
test eax, eax
jz l_e2_format_11
  inc edi
  cmp edi, 3
  jna l_e2_format_10
    dec edi
    mov eax, -1
    jmp short l_e2_format_12

l_e2_format_11:
mov eax, dword ptr e2_disksize[0]
div ebx  // assert blocks_count < 4 Gi

l_e2_format_12:
mov e2_sb.s_blocks_count, eax

mov e2_sb.s_r_blocks_count, 0
mov ecx, edi
sub cl, 10
jecxz l_e2_format_21
  mov e2_sb.s_first_data_block, 0 // 1024 1, else 0
  jmp short l_e2_format_22
  
l_e2_format_21:
  mov e2_sb.s_first_data_block, 1 // 1024 1, else 0

l_e2_format_22:
mov e2_sb.s_log_block_size, ecx
mov e2_sb.s_log_frag_size, ecx
mov ebx, 1
add cl, 10 + 3 // 8192 * block_size
shl ebx, cl
mov e2_sb.s_blocks_per_group, ebx
mov e2_sb.s_frags_per_group, ebx
mov e2_sb.s_inode_size, 128

mov e2_sb.s_feature_ro_compat, EXT2_FEATURE_RO_COMPAT_LARGE_FILE

// calc groups
mov eax, e2_sb.s_blocks_count
dec eax
dec eax
xor edx, edx
div e2_sb.s_blocks_per_group
inc eax
mov e2_groups, eax

// calc gblocks
mov eax, e2_groups
shl eax, 5  // assert sizeof GroupBlock = 32
mov ecx, edi
mov ebx, 1
shl ebx, cl
dec ebx  // ebx = block_size - 1
add eax, ebx
shr eax, cl
mov e2_gblocks, eax

// calc inodes per group, free inodes
mov eax, e2_sb.s_inodes_count
xor edx, edx
div e2_groups
shl eax, 7  // log s_inode_size
dec eax
or eax, ebx
inc eax
shr eax, 7  // log s_inode_size
mov e2_sb.s_inodes_per_group, eax
mul e2_groups
mov e2_sb.s_inodes_count, eax
sub eax, RESERVED_INODES
mov e2_sb.s_free_inodes_count, eax

// group blocks, free blocks
xor eax, eax
mov e2_sb.s_free_blocks_count, eax
xor esi, esi

l_e2_format_5:
  xor ebx, ebx
  cmp esi, 0
  jnz l_e2_format_52
    // group 0
    mov ebx, e2_gblocks
    add ebx, e2_sb.s_first_data_block
    jmp short l_e2_format_53
    
  l_e2_format_52:
  cmp esi, 1
  jnz l_e2_format_53
    // group 1
    mov ebx, e2_gblocks
    inc ebx
    
  l_e2_format_53:
  mov eax, esi
  mul e2_sb.s_blocks_per_group
  inc eax
  add eax, ebx
  
  mov e2_gb.bg_block_bitmap, eax
  // zero bitmap, keep eax, ebx, esi, edi
  push esi
   push edi
    push eax
     push ebx
      
      push edi
        mov edi, offset fs_buffer
        xor eax, eax
        mov ecx, 512 / 4
        cld
        rep stosd
      pop ecx
      
      mov ch, cl
      mov ebx, e2_gb.bg_block_bitmap
      mov edx, ebx
      shl ebx, cl
      xor cl, 31
      inc cl
      shr edx, cl  // edx:ebx = block_bitmap << block_size_log
      
      mov cl, ch
      sub cl, 9
      mov eax, 1
      shl eax, cl
      xchg eax, ecx  // ecx = sectors512
      
      l_e2_format_535:
        push ecx
         push edx
          push ebx
            mov ecx, 512
            mov edi, offset fs_buffer
            movzx esi, format_disk
            call disk_write
          pop ebx
         pop edx
        pop ecx
        add ebx, 512
        loop l_e2_format_535
        
     pop ebx
    pop eax
   pop edi
  pop esi

  inc eax
  mov e2_gb.bg_inode_bitmap, eax
  // zero bitmap, keep eax, ebx, esi, edi
  push esi
   push edi
    push eax
     push ebx
      
      mov ecx, edi
      
      mov ch, cl
      mov ebx, e2_gb.bg_inode_bitmap
      mov edx, ebx
      shl ebx, cl
      xor cl, 31
      inc cl
      shr edx, cl  // edx:ebx = inode_bitmap << block_size_log
      
      mov cl, ch
      sub cl, 9
      mov eax, 1
      shl eax, cl
      xchg eax, ecx  // ecx = sectors512
      
      l_e2_format_536:
        push ecx
         push edx
          push ebx
            mov ecx, 512
            mov edi, offset fs_buffer
            movzx esi, format_disk
            call disk_write
          pop ebx
         pop edx
        pop ecx
        add ebx, 512
        loop l_e2_format_536
        
     pop ebx
    pop eax
   pop edi
  pop esi

  
  // reserved inodes
  test esi, esi
  jnz l_e2_format_546
    push esi
     push edi
      push eax
       push ebx
        mov e2_tmp, (1 << RESERVED_INODES) - 1  // inodes reserved
        xor edx, edx
        mov ebx, eax
        mov ecx, edi
        shl ebx, cl
        mov ecx, 4
        mov edi, offset e2_tmp
        movzx esi, format_disk
        call disk_write
       pop ebx
      pop eax
     pop edi
    pop esi
    
  l_e2_format_546:
  inc eax
  mov e2_gb.bg_inode_table, eax
  
  mov eax, e2_sb.s_inodes_per_group
  movzx ecx, e2_sb.s_inode_size
  mul ecx
  mov ecx, edi
  shr eax, cl
  
  mov edx, e2_sb.s_blocks_per_group
  sub edx, eax
  sub edx, ebx
  sub edx, 2  // edx = blocks_per_group - size_inode_table - ebx - 2
  mov e2_gb.bg_free_blocks_count, dx
  
  mov eax, e2_sb.s_inodes_per_group
  test esi, esi
  jnz l_e2_format_548
    sub eax, RESERVED_INODES  // inodes reserved
    
  l_e2_format_548:
  mov e2_gb.bg_free_inodes_count, ax
  
  mov e2_gb.bg_used_dirs_count, 0
  
  // last group, KEEP esi  IN ebx  OUT edx
  mov eax, esi
  inc eax
  cmp eax, e2_groups
  jnz l_e2_format_56
    dec eax
    mul e2_sb.s_blocks_per_group
    inc eax
    mov edx, e2_sb.s_blocks_count
    sub edx, eax  // edx = blocks_count - (esi * blocks_per_group) - 1
    mov eax, ebx
    add eax, 2  // eax = ebx + 2
    cmp edx, eax
    jnb l_e2_format_55
      xor eax, eax
      xor edx, edx
      mov e2_gb.bg_free_inodes_count, ax
      mov e2_gb.bg_free_blocks_count, dx
      jmp short l_e2_format_558
      
    l_e2_format_55:
    sub edx, eax  // edx - eax
    mov ebx, edx
    mov eax, e2_sb.s_inodes_per_group
    movzx ecx, e2_sb.s_inode_size
    mul ecx
    mov ecx, edi
    shr eax, cl  // eax = inodes_per_group * inode_size / block_size
    cmp ebx, eax
    jnb l_e2_format_551
      shl eax, cl
      xor edx, edx
      div ecx
      mov e2_gb.bg_free_inodes_count, ax
      xor edx, edx
      mov e2_gb.bg_free_blocks_count, dx
      jmp short l_e2_format_558
    
    l_e2_format_551:
    sub ebx, eax  // ebx = edx - eax
    mov edx, ebx
    mov e2_gb.bg_free_blocks_count, dx
    
    l_e2_format_558:  // new edx
  
  l_e2_format_56:
  // sb free blocks
  add e2_sb.s_free_blocks_count, edx
  
  // write gb, KEEP esi, edi
  push esi
   push edi
    mov ebx, esi
    shl ebx, 5  // assert sizeof GroupBlock = 32
    mov ecx, edi
    mov edx, 1
    shl edx, cl
    cmp cl, 10
    jnz l_e2_format_57
      add edx, 1024
      
    l_e2_format_57:
    add ebx, edx
    xor edx, edx
    mov edi, offset e2_gb
    mov ecx, sizeof GroupBlock
    movzx esi, format_disk
    call disk_write
   pop edi
  pop esi
  test al, al
  jnz near l_e2_format_9
    
  // next esi
  inc esi
  cmp esi, e2_groups
  jb near l_e2_format_5

// reserved inodes
push edi
  mov edi, offset e2_inode
  mov ecx, sizeof INode / 4
  xor eax, eax
  cld
  rep stosd
pop edi

mov ebx, e2_gblocks
add ebx, e2_sb.s_first_data_block
add ebx, 1 + 1 + 1  // boot_block, block_bitmap, inode_bitmap
mov ecx, edi
shl ebx, cl

mov ecx, RESERVED_INODES

push edi
  jecxz l_e2_format_578
  
  l_e2_format_571:
  cmp ecx, RESERVED_INODES - EXT2_ROOT_INO + 1
  jnz l_e2_format_572
    mov e2_inode.i_mode, EXT2_S_IFDIR | ACCESS_DEFAULT
    jmp short l_e2_format_573
    
  l_e2_format_572:
    mov e2_inode.i_mode, 0
  
  l_e2_format_573:
  push ecx
   push ebx
    xor edx, edx
    mov edi, offset e2_inode
    mov ecx, sizeof INode
    movzx esi, format_disk
    call disk_write
   pop ebx
   movzx eax, e2_sb.s_inode_size
   add ebx, eax
  pop ecx
  loop l_e2_format_571
  
  l_e2_format_578:
pop edi

// write sb
push edi
  mov edi, offset e2_sb
  mov ecx, sizeof SuperBlock
  mov ebx, 1024
  xor edx, edx
  movzx esi, format_disk
  call disk_write
pop edi
test al, al
jnz near l_e2_format_9

test fs_formatsystem, 1
jnz near l_e2_format_60
  // * not system *
  push edi
    mov dword ptr fs_bootsect[0], 1DE9h  // jmp main
    // [32]
    mov esi, offset format_notsys + COFS
    mov edi, offset fs_bootsect + 32
    mov ecx, offset format_notsysend - offset format_notsys
    cld
    rep movsb
  pop edi
  
  mov dword ptr fs_bootsect[3], "TR32"  // OEM id
  mov dword ptr fs_bootsect[7], "    "
  mov word ptr fs_bootsect[11], 200h  // sector size
  mov ecx, edi
  mov eax, 1
  shl eax, cl
  mov byte ptr fs_bootsect[13], al  // cluster size in sectors
  jmp l_e2_format_8

l_e2_format_60:

// * copy system *

// read the first gb
xor ebx, ebx
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
mov edx, 1
shl edx, cl
cmp cl, 10
jnz l_e2_format_61
  add edx, 1024
  
l_e2_format_61:
add ebx, edx
xor edx, edx
mov edi, offset e2_gb
mov ecx, sizeof GroupBlock
movzx esi, format_disk
mov fs_gb_diskofs, ebx  // fs_gb_diskofs
call disk_read
test al, al
jnz near l_e2_format_9

// check sizes
mov eax, fs_setup_size
add eax, fs_kernel_size
cmp eax, 512
jna l_e2_format_62
  mov al, ERC_FILE_TOO_BIG
  jmp l_e2_format_9
  
l_e2_format_62:
// system size
mov cl, byte ptr e2_sb.s_log_block_size
mov eax, 256  // 512 sectors
shr eax, cl

sub e2_sb.s_free_blocks_count, eax  // needs to be saved
sub e2_gb.bg_free_blocks_count, ax  // needs to be saved
jnc l_e2_format_63
  mov al, ERC_DISK_FULL
  jmp l_e2_format_9
  
l_e2_format_63:
// load block bitmap
push eax
  xor edx, edx
  mov ebx, e2_gb.bg_block_bitmap
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  shl ebx, cl
  mov edi, offset fs_buffer
  mov ecx, 512
  movzx esi, format_disk
  call disk_read
pop edx
test al, al
jnz near l_e2_format_9

// allocate bitmap
add edx, 7
shr edx, 3

xor eax, eax
mov ecx, 512
sub ecx, edx

l_e2_format_631:
  cmp byte ptr fs_buffer[eax], 0  // find first 0
  jz l_e2_format_633
    inc eax
    cmp eax, ecx
    jb l_e2_format_631

l_e2_format_632:
mov al, ERC_FS
jmp l_e2_format_9

l_e2_format_633:
mov fs_syssect, eax // fs_syssect = first in 8 clusters
mov ecx, edx

l_e2_format_635:
  cmp byte ptr fs_buffer[eax], 0
  jnz l_e2_format_632
    mov byte ptr fs_buffer[eax], 255  // occupy 8 clusters
    inc eax
    loop l_e2_format_635

// save block bitmap
mov ebx, e2_gb.bg_block_bitmap
xor edx, edx
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
shl ebx, cl
mov edi, offset fs_buffer
mov ecx, 512
movzx esi, format_disk
call disk_write

// first_block_in_group = (s_inodes_per_group * s_inode_size)
//   >> (s_log_block_size + 10) + bg_inode_table
mov eax, e2_sb.s_inodes_per_group
movzx ecx, e2_sb.s_inode_size
mul ecx
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
shr eax, cl
add eax, e2_gb.bg_inode_table

mov ebx, fs_syssect
shl ebx, 3
add eax, ebx
sub cl, 9
shl eax, cl
mov edx, eax

// copy setup
mov edi, fs_ofs_format
mov esi, offset formatsetup + COFS

l_e2_format_641:
  lodsb
  stosb
  test al, al
  jnz l_e2_format_641

mov ecx, fs_setup_size
mov esi, edx
mov fs_syssect, edx  // fs_syssect
push edx
  call format_copy
pop edx

test al, al
jnz near l_e2_format_9

// copy kernel
mov edi, fs_ofs_format
mov esi, offset formatkernel + COFS

l_e2_format_643:
  lodsb
  stosb
  test al, al
  jnz l_e2_format_643

mov ecx, fs_kernel_size
add edx, fs_setup_size
mov esi, edx
call format_copy

test al, al
jnz near l_e2_format_9

// save gb
mov ebx, fs_gb_diskofs
xor edx, edx
mov edi, offset e2_gb
mov ecx, sizeof GroupBlock
movzx esi, format_disk
call disk_write
test al, al
jnz l_e2_format_9

// save sb
mov edi, offset e2_sb
mov ecx, sizeof SuperBlock
mov ebx, 1024
xor edx, edx
movzx esi, format_disk
call disk_write
test al, al
jnz l_e2_format_9

// save bootsect
mov eax, fs_syssect
mov dword ptr fs_bootsect[SYSTEM_BOOT_OFS_HD], eax

l_e2_format_8:
mov edi, offset fs_bootsect
mov ecx, 512
xor ebx, ebx
xor edx, edx
movzx esi, format_disk
call disk_write

l_e2_format_9:
ret

wregs1: db "\n | acdb = "
wregs2: db " | sbsd = "

wregs:
pushad
  mov ebp, esp
  
  mov esi, offset wregs1 + COFS
  mov ecx, 10
  mov bl, 7
  call write
  
  mov eax, [ebp + 28]
  mov ecx, 16
  mov bh, 9
  call writen
  
  mov eax, [ebp + 24]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 20]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 16]
  mov ecx, 16
  call writen
  
  
  mov esi, offset wregs2 + COFS
  mov ecx, 9
  mov bl, 7
  call write
  
  mov eax, [ebp + 12]
  mov ecx, 16
  mov bh, 9
  call writen
  
  mov eax, [ebp + 8]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 4]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 0]
  mov ecx, 16
  call writen

popad
ret

// IN: edx -> filenamez
// OUT: al = erc, al=0 => edi = pkeyb, ecx = size
load_keyb:
call fopenread
test al, al
jnz l_load_keyb_9
  push ebx
    call fgetsize
    xor edi, edi
    jecxz l_load_keyb_1
      cmp ecx, 4096
      ja l_load_keyb_1
        push ecx
          call malloc
          mov edi, ebx
        pop ecx
        
    l_load_keyb_1:
  pop ebx
  
  mov al, ERC_INVALID_POINTER
  test edi, edi
  jz l_load_keyb_9
    push ebx
     push edi
      push ecx
        call fread
      pop ecx
     pop edi
    pop ebx
    push eax
     push edi
      push ecx
        call fclose
      pop ecx
     pop edi
    pop eax
    
l_load_keyb_9:
ret

movekeys: db 36, 38, 33, 109, 37, 12, 39, 107, 35,40,34,45,46
numkeys:  db 103,104,105,109, 100,101,102,107, 97,98,99,96,110
anumkeys: db "789-456+1230."

// IN: eax = escan key, edx = locks
// OUT: eax = VK, ecx = UTF-16 key
// USES: esi, edx
keys:
xor ecx, ecx
cmp eax, 135h // "/" on num
jnz l_keys_1
  mov eax, 111
  mov ecx, "/"
  jmp l_keys_9
  
l_keys_1:
test dl, KBD_NUMLK // num lock
jz l_keys_2
  test dl, KBD_RSH | KBD_LSH  // any shift
  jnz l_keys_2

    cmp al, 47h
    jb l_keys_2
      cmp al, 53h
      ja l_keys_2

        cmp ah, 1  // not num
        jz l_keys_2
          // num keys
          movzx ecx, byte ptr [cs:offset anumkeys + COFS + eax - 47h]
          movzx eax, byte ptr [cs:offset numkeys + COFS + eax - 47h]
          jmp l_keys_9

l_keys_2:
and eax, 127

cmp al, 47h
jb l_keys_3
  cmp al, 53h
  ja l_keys_3
    // move keys
    movzx eax, byte ptr [cs:offset movekeys + COFS + eax - 47h]
    cmp al, 109
    jnz l_keys_21
      mov ecx, '-'
      jmp l_keys_9
      
    l_keys_21:
    cmp al, 107
    jnz near l_keys_9
      mov ecx, '+'
      jmp l_keys_9

l_keys_3:
cmp al, 3Ah // Caps lock
jnb near l_keys_4
  
  mov esi, eax
  shl esi, 1
  add esi, pkeyb
  
  // vkey
  movzx eax, word ptr [esi + 128]

  // UTF-16 key
  test dx, KBD_CTRL
  jz l_keys_31
    // ctrl
    sub esi, pkeyb
    shr esi, 1
    add esi, pkeyb
    movzx ecx, byte ptr [esi + 64]
    jmp l_keys_9
    
  l_keys_31:
  test dx, KBD_RALT
  jz l_keys_32
    // right alt
    test dx, KBD_RSH | KBD_LSH
    jnz l_keys_312
      movzx ecx, word ptr [esi + 256 + 256 + 256]
      jmp l_keys_9
      
    l_keys_312:
    movzx ecx, word ptr [esi + 256 + 256 + 256 + 128]
    jmp short l_keys_9
    
  l_keys_32:
  test dx, KBD_CPSLK
  jnz l_keys_34
    test dx, KBD_RSH | KBD_LSH
    jnz l_keys_33
      // not caps lock, not shift
      movzx ecx, word ptr [esi + 256]
      jmp short l_keys_9
      
    l_keys_33:
    // shift
    movzx ecx, word ptr [esi + 256 + 128]
    jmp short l_keys_9
    
  l_keys_34:
  test dx, KBD_RSH | KBD_LSH
  jnz l_keys_36
    // caps lock
    movzx ecx, word ptr [esi + 256 + 256]
    jmp short l_keys_9
    
  l_keys_36:
  // caps lock + shift
  movzx ecx, word ptr [esi + 256 + 256 + 128]
  jmp short l_keys_9

l_keys_4:
jnz l_keys_5
  // Caps lock
  mov eax, 20
  jmp short l_keys_9
  
l_keys_5:
cmp al, 3Bh  // F1
jb l_keys_52
  cmp al, 44h  // F10
  ja l_keys_52
    add eax, 112 - 3Bh
    jmp short l_keys_9

l_keys_52:
cmp al, 57h  // F11
jnz l_keys_53
  mov eax, 122
  jmp short l_keys_9
  
l_keys_53:
cmp al, 58h  // F12
jnz l_keys_54
  mov eax, 123
  jmp short l_keys_9

l_keys_54:
cmp al, 45h
jnz l_keys_9
  test dx, KBD_VCTRL
  jnz l_keys_6
    // num lock
    mov eax, 144
    jmp short l_keys_9
  
  l_keys_6:
  // break
  mov eax, 19
  
  
l_keys_9:
mov edx, specialkey
test edx, edx
jz l_keys_96
  // special key
  sub edx, 0xFFF0
  shl edx, 1 + 6  // 64 words
  add edx, 1024  // 256 + 256 + 256 + 256
  cmp ecx, 64
  jb l_keys_96
   cmp ecx, 127
   ja l_keys_96
    and ecx, 63
    shl ecx, 1
    add edx, ecx
    cmp edx, keybsize
    jnb l_keys_94
      add ecx, pkeyb
      movzx ecx, word ptr [edx]
      jmp l_keys_96
      
    l_keys_94:
    xor ecx, ecx
    
l_keys_96:
// special key?
mov specialkey, 0
cmp ecx, 0xFFF0
jb l_keys_99
  cmp ecx, 0xFFF7
  ja l_keys_99
    mov specialkey, ecx
    xor ecx, ecx
    
l_keys_99:
ret

// IN: esi -> stringz
// OUT: ecx
// KEEP: ebx, esi, edi
strlen:
push esi
  xor ecx, ecx
  
  l_strlen_1:
    lodsb
    cmp al, 0
    jz l_strlen_9
      inc ecx
      jmp short l_strlen_1
  
  l_strlen_9:
pop esi
ret

// IN: edx = winid, mx, my
// OUT: eax = state
getstate:
cmp dl, MAX_WIN
jb l_getstate_00
  
  xor eax, eax
  ret
  
l_getstate_00:
mov edi, offset win1
call getwin

movsx ecx, mx
movsx ebx, my
movsx eax, win1.x
movsx edx, win1.y
sub ecx, eax
sub ebx, edx

xor eax, eax

cmp ecx, 0
jl near l_getstate_9
cmp ebx, 0
jl near l_getstate_9
  mov esi, win1.flags
  test esi, WS_CAPTION
  jz near l_getstate_8 // no caption
  
  test esi, WS_MAXIMIZE
  jz l_getstate_08
    // maximized
    cmp ebx, WIN_HEADER
    jnl near l_getstate_8
      
      // header
      movsx edx, win1.w
      
      l_getstate_01:  // IN: edx = w, esi = flags
      sub edx, WIN_HEADER
      cmp ecx, edx
      jl l_getstate_02
        mov eax, STATE_CLOSE
        jmp l_getstate_8
        
      l_getstate_02:
      test esi, WS_MAXIMIZEBOX
      jz l_getstate_03
        sub edx, WIN_HEADER
        cmp ecx, edx
        jl l_getstate_03
          mov eax, STATE_MAX
          jmp l_getstate_8
          
      l_getstate_03:
      test esi, WS_MINIMIZEBOX
      jz l_getstate_04
        sub edx, WIN_HEADER
        cmp ecx, edx
        jl l_getstate_04
          mov eax, STATE_MIN
          jmp l_getstate_8
          
      l_getstate_04:
      mov eax, STATE_MOVE
      jmp l_getstate_8
      
  l_getstate_08:
  // x
  cmp ecx, WIN_BORDER
  jnl l_getstate_1
    // left border
    mov eax, STATE_LEFT
    
    l_getstate_091:
    cmp ebx, WIN_CORNER
    jnl l_getstate_096
      or eax, STATE_UP
      jmp short l_getstate_8
      
    l_getstate_096:
    movsx edx, win1.h
    sub edx, WIN_CORNER
    cmp ebx, edx
    jl l_getstate_8
      or eax, STATE_DOWN
      jmp short l_getstate_8
      
  l_getstate_1:
  movsx edx, win1.w
  sub edx, WIN_BORDER
  cmp ecx, edx
  jl l_getstate_2
    // right border
    mov eax, STATE_RIGHT
    jmp short l_getstate_091
    
  l_getstate_2:
  // y
  cmp ebx, WIN_BORDER
  jnl l_getstate_3
    // top border
    mov eax, STATE_UP
    
    l_getstate_21:
    cmp ecx, WIN_CORNER
    jnl l_getstate_26
      or eax, STATE_LEFT
      jmp short l_getstate_8
      
    l_getstate_26:
    movsx edx, win1.w
    sub edx, WIN_CORNER
    cmp ecx, edx
    jl l_getstate_8
      or eax, STATE_RIGHT
      jmp short l_getstate_8
    
  l_getstate_3:
  cmp ebx, WIN_BORDER + WIN_HEADER
  jnl l_getstate_4
    // header
    movsx edx, win1.w
    sub edx, WIN_BORDER
    jmp l_getstate_01  // IN: edx = w, esi = flags
    
  l_getstate_4:
  movsx edx, win1.h
  sub edx, WIN_BORDER
  cmp ebx, edx
  jl l_getstate_8
    // bottom border
    mov eax, STATE_DOWN
    jmp short l_getstate_21
  
l_getstate_8:
test eax, eax
jnz l_getstate_9
  // pmenu != 0 && eax == 0
  movzx edx, win1.ncheight
  cmp ebx, edx
  jnl l_getstate_9
    mov eax, STATE_MENU

l_getstate_9:
ret

// IN: bl = winid, tmp_state, msg.lParam
// OUT: esi = lParam
// KEEP: ebx
correctxy:
mov dl, bl
mov edi, offset win1
push ebx
  call getwin
pop ebx
mov eax, tmp_state
test win1.flags, WS_CAPTION
jz l_correctxy_22

test eax, eax
jz l_correctxy_24
  
  l_correctxy_22:
  // nc - correct x, y
  mov eax, msg.lParam
  mov edx, eax
  shr edx, 16
  sub ax, win1.x
  sub dx, win1.y
  shl edx, 16
  mov dx, ax
  mov esi, edx  // esi = (y-win1.y):(x-win1.x)
  jmp short l_correctxy_8
  
l_correctxy_24:
  // client - correct x, y
  mov eax, msg.lParam
  mov edx, eax
  shr edx, 16
  movzx eax, ax
  sub ax, win1.x
  sub dx, win1.y
  
  movzx ecx, win1.ncheight
  sub dx, cx
  test win1.flags, WS_MAXIMIZE
  jnz l_correctxy_25
    // not maximized
    sub ax, WIN_BORDER
    
  l_correctxy_25:
  shl edx, 16
  mov dx, ax
  mov esi, edx  // esi = (y-win1.y-ncheight):(x-win1.x-?)

l_correctxy_8:
ret

// IN: ebx = winid, esi = lParam, msg.wParam, old_button, button_ofs
double:
push esi
 push ebx

  mov ah, 45 // get pid, tid; OUT: edi = tid
  int 20h
  mov tid, edi
  
  mov edx, edi
  shl edx, 16
  mov dx, WIN_NONE
  mov ebx, WIN_DOUBLECLICKTIMERID
  call rmtimer

 pop ebx
pop esi

mov eax, msg.wParam
test eax, eax
jz l_double_9
  cmp eax, old_button
  jnz l_double_8
    mov ecx, button_ofs
    add ecx, 2  // doubleclick
    test tmp_state, -1
    jz l_double_6  // client
      // nc
      sub ecx, 200h - 0A0h
      cmp ecx, 20Bh - 0A0h
      jb l_double_6
        sub ecx, 2
      
    l_double_6:
    mov edx, msg.wParam
    call postwind
    
  l_double_8:
  mov eax, msg.wParam
  mov old_button, eax
  
  mov ecx, doubleclicktime
  mov edx, tid
  shl edx, 16
  mov dx, WIN_NONE
  mov ebx, WIN_DOUBLECLICKTIMERID
  xor edi, edi
  call addtimer
  
l_double_9:
ret

// IN: keystate
endsyskey:
// alt/win/menu key dropped
cmp keystate, KEYSTATE_ALTTAB
jnz l_endsyskey_6
  // alt key dropped after ALT+TAB
  mov eax, selected
  cmp eax, miniature_count
  jnb l_endsyskey_9
  
  mov al, miniature_winid[eax]
  
  push eax
    call destroyselect
  pop edx
  
  // activate selected
  cmp dl, MAX_WIN
  jb l_endsyskey_3
    push edx
      call minimizeall
    pop edx
    
  l_endsyskey_3:
  mov dh, 1  // alt+tab
  call activate
  jmp l_endsyskey_9

l_endsyskey_6:
cmp keystate, KEYSTATE_WIN
jnz l_endsyskey_9
  // win key dropped
  mov esi, startwin
  test esi, esi
  jnz l_endsyskey_613
    push eax
      call createstart
    pop eax
    jmp short l_endsyskey_9
    
  l_endsyskey_613:
  push eax
    call destroystart
  pop eax
  
l_endsyskey_9:
ret

paintkbd:
//...
ret

// IN: msg, old_mx, old_my
mousemove:
mov esi, msg.lParam
mov mx, si
shr esi, 16
mov my, si

// paint mouse
movsx ecx, mx
cmp cx, old_mx
jl l_mousemove_11
  mov cx, old_mx
  movsx esi, mx
  jmp short l_mousemove_12
  
l_mousemove_11:
  movsx esi, old_mx
  
l_mousemove_12:
movsx ebx, my
cmp bx, old_my
jl l_mousemove_13
  mov bx, old_my
  movsx edi, my
  jmp short l_mousemove_14
  
l_mousemove_13:
  movsx edi, old_my
  
l_mousemove_14:
push ecx
 push ebx
  push esi
   push edi
    call getmouseinfo
   pop edi
  pop esi
  movzx eax, cl
  add esi, eax
  dec esi
  movzx eax, ch
  add edi, eax
  dec edi
  movsx eax, bl
  movsx edx, bh
 pop ebx
pop ecx
sub ecx, eax
sub ebx, edx
sub esi, eax
sub edi, edx
call paint

// state
movsx ecx, mx
movsx ebx, my
cmp state, 0
jnz near l_mousemove_3
  // state 0
  // mouse over  IN: ecx, ebx
  call getwinat  // OUT edx
  push edx
    call setover
  pop edx
  push edx
    call getstate  // OUT eax
    mov tmp_state, eax
  pop ebx
  // post WM_MOUSEMOVE to window wover
  cmp bl, MAX_WIN
  jnb near l_mousemove_28
    
    mov edx, old_state
    push eax
      
      test eax, eax
      jz l_mousemove_24
        // state ~0
        test edx, edx
        jnz l_mousemove_22
          // oldstate 0
          mov ecx, WM_MOUSEOVER
          xor edx, edx
          xor esi, esi
          push ebx
           push eax
            call postwin
           pop eax
          pop ebx
          
        l_mousemove_22:
        call correctxy  // keep ebx
        // msg
        mov ecx, WM_NCMOUSEMOVE
        jmp short l_mousemove_26
        
      l_mousemove_24:
        // state 0
        test edx, edx
        jz l_mousemove_25
          // oldstate ~0
          mov ecx, WM_MOUSEOVER
          mov edx, 1
          xor esi, esi
          push ebx
           push eax
            call postwin
           pop eax
          pop ebx
          
        l_mousemove_25:
        call correctxy  // keep ebx
        // msg
        mov ecx, WM_MOUSEMOVE
        
      l_mousemove_26:
      mov edx, msg.wParam
      call postwin
    
    pop old_state
    jmp l_mousemove_8
    
  l_mousemove_28:
  // desktop
  call mmdesktop
  jmp l_mousemove_8
  
l_mousemove_3:
movsx eax, state_old_mx
movsx edx, state_old_my
sub ecx, eax
sub ebx, edx

cmp state_win, MAX_WIN
jnb near l_mousemove_8
 cmp state, STATE_MOVE
 jnz l_mousemove_31
  // move
  push SWP_NOSIZE | SWP_NOMOVE | SWP_NOZORDER | SWP_RELMOVE // flags
  xor eax, eax
  push eax  // cy
  push eax  // cx
  push ebx  // y
  push ecx  // x
  push 0    // hwndInsertAfter
  movzx edx, state_win
  inc edx
  push edx  // winid + 1
  call dword ptr [isetwinpos + COFS]
  jmp l_mousemove_7
  
l_mousemove_31:
test state, STATE_LEFT | STATE_RIGHT | STATE_UP | STATE_DOWN
jz near l_mousemove_39
  // size
  xor eax, eax
  mov win1.x, ax
  mov win1.y, ax
  mov win1.w, ax
  mov win1.h, ax
  
  test state, STATE_LEFT
  jz l_mousemove_32
    sub win1.w, cx
    add win1.x, cx
    
  l_mousemove_32:
  test state, STATE_RIGHT
  jz l_mousemove_33
    add win1.w, cx
    
  l_mousemove_33:
  test state, STATE_UP
  jz l_mousemove_34
    sub win1.h, bx
    add win1.y, bx
    
  l_mousemove_34:
  test state, STATE_DOWN
  jz l_mousemove_35
    add win1.h, bx
    
  l_mousemove_35:
  push SWP_NOSIZE | SWP_NOMOVE | SWP_NOZORDER | SWP_RELSIZE | SWP_RELMOVE // flags
  movsx eax, win1.h
  push eax  // cy
  movsx eax, win1.w
  push eax  // cx
  movsx eax, win1.y
  push eax  // y
  movsx eax, win1.x
  push eax  // x
  push 0    // hwndInsertAfter
  movzx edx, state_win
  inc edx
  push edx  // winid + 1
  call dword ptr [isetwinpos + COFS]
  jmp short l_mousemove_7
  
l_mousemove_39:
// ?box
movzx edx, state_win
call getstate
cmp eax, state
jz l_mousemove_44
  xor esi, esi
  
  l_mousemove_42:
  movzx ebx, state_win
  cmp bl, MAX_WIN
  jnb l_mousemove_8
    mov ecx, WM_PAINTBUTTONS
    xor edx, edx
    call postwin
    jmp short l_mousemove_8
    
l_mousemove_44:
movzx esi, al
jmp short l_mousemove_42

l_mousemove_7:
// state old
test al, al
jnz l_mousemove_8
  mov ax, mx
  mov dx, my
  mov state_old_mx, ax
  mov state_old_my, dx

l_mousemove_8:
// old
mov cx, mx
mov bx, my
mov old_mx, cx
mov old_my, bx
ret

// IN: msg
mousebutton:
call getactiveover
mov tmp_state_win, dl
call getstate
mov tmp_state, eax

mov eax, msg.wParam
mov mb, ax
mov ah, byte ptr old_mb

test al, MK_LBUTTON
jz near l_mousebutton_2
  test ah, MK_LBUTTON
  jnz near l_mousebutton_4
    // click left
    mov dl, tmp_state_win
    mov state_win, dl
    mov dh, 2
    call activate
    mov eax, tmp_state
    mov state, eax
    
    test state, STATE_CLOSE | STATE_MAX | STATE_MIN
    jz l_mousebutton_18
      movzx ebx, state_win
      cmp bl, MAX_WIN
      jnb l_mousebutton_18
        mov ecx, WM_PAINTBUTTONS
        xor edx, edx
        mov esi, state
        call postwin
        
    l_mousebutton_18:
    mov ax, mx
    mov dx, my
    mov state_old_mx, ax
    mov state_old_my, dx
    jmp l_mousebutton_4
    
l_mousebutton_2:
test ah, MK_LBUTTON
jz near l_mousebutton_4
  // drop left
  test state, STATE_CLOSE | STATE_MAX | STATE_MIN
  jz near l_mousebutton_22
    // drop buttons
    movzx edx, state_win
    xor ecx, ecx
    call setbuttons
    // still over the pressed button?
    //movzx edx, state_win
    mov eax, tmp_state
    cmp eax, state
    jnz near l_mousebutton_22
      test eax, STATE_CLOSE
      jz l_mousebutton_201
        // wm_close
        movzx ebx, state_win
        mov ecx, WM_CLOSE
        xor edx, edx
        xor esi, esi
        call postwin
        jmp short l_mousebutton_22
        
      l_mousebutton_201:
      test eax, STATE_MAX
      jz l_mousebutton_202
        // maximize/normal
        movzx edx, state_win        
        mov edi, offset win1
        call getwin
        test win1.flags, WS_MAXIMIZE
        jnz l_mousebutton_2014
          // maximize
          movzx edx, state_win
          mov dh, SW_MAXIMIZE
          call showwindow
          jmp short l_mousebutton_22
          
        l_mousebutton_2014:
        // normal
        movzx edx, state_win
        mov dh, SW_NORMAL
        call showwindow
        jmp short l_mousebutton_22
        
      l_mousebutton_202:
      test eax, STATE_MIN
      jz l_mousebutton_22
        // minimize
        movzx edx, state_win
        mov dh, SW_MINIMIZE
        call showwindow        
        //jmp short l_mousebutton_22
      
  l_mousebutton_22:
  mov state, 0  // state = 0
  mov state_win, WIN_NONE
  //jmp l_mousebutton_4
  
  
l_mousebutton_4:
mov eax, msg.wParam
mov ah, byte ptr old_mb

mov button_ofs, 0
test al, MK_LBUTTON
jz l_mousebutton_41
  test ah, MK_LBUTTON
  jnz l_mousebutton_41
    mov button_ofs, WM_LBUTTONDOWN
    
l_mousebutton_41:
test al, MK_LBUTTON
jnz l_mousebutton_42
  test ah, MK_LBUTTON
  jz l_mousebutton_42
    mov button_ofs, WM_LBUTTONUP
    
l_mousebutton_42:
test al, MK_RBUTTON
jz l_mousebutton_43
  test ah, MK_RBUTTON
  jnz l_mousebutton_43
    mov button_ofs, WM_RBUTTONDOWN
    
l_mousebutton_43:
test al, MK_RBUTTON
jnz l_mousebutton_44
  test ah, MK_RBUTTON
  jz l_mousebutton_44
    mov button_ofs, WM_RBUTTONUP
    
l_mousebutton_44:
test al, MK_MBUTTON
jz l_mousebutton_45
  test ah, MK_MBUTTON
  jnz l_mousebutton_45
    mov button_ofs, WM_MBUTTONDOWN
    
l_mousebutton_45:
test al, MK_MBUTTON
jnz l_mousebutton_46
  test ah, MK_MBUTTON
  jz l_mousebutton_46
    mov button_ofs, WM_MBUTTONUP
    
l_mousebutton_46:
test al, MK_XBUTTON1 | MK_XBUTTON2
jz l_mousebutton_47
  test ah, MK_XBUTTON1 | MK_XBUTTON2
  jnz l_mousebutton_47
    mov button_ofs, WM_XBUTTONDOWN
    
l_mousebutton_47:
test al, MK_XBUTTON1 | MK_XBUTTON2
jnz l_mousebutton_48
  test ah, MK_XBUTTON1 | MK_XBUTTON2
  jz l_mousebutton_48
    mov button_ofs, WM_XBUTTONUP
    
l_mousebutton_48:
// correct
movzx ebx, tmp_state_win
push eax
  call correctxy  // keep ebx, out esi
pop eax
mov ecx, button_ofs
test tmp_state, -1
jz l_mousebutton_61  // client
  // nc
  sub ecx, 200h - 0A0h
  cmp ecx, 20Bh - 0A0h
  jb l_mousebutton_61
    sub ecx, 2
  
l_mousebutton_61:  // ecx = wm, esi = corrected lParam
cmp al, ah
jna l_mousebutton_66
  // click
  movzx ebx, tmp_state_win
  mov edx, msg.wParam
  push esi
    call postwind
  pop esi
  
  // double
  movzx ebx, tmp_state_win
  call double
  jmp short l_mousebutton_68
  
l_mousebutton_66:
// drop
movzx ebx, tmp_state_win
mov edx, msg.wParam
call postwind

l_mousebutton_68:

l_mousebutton_9:
mov ax, mb
mov old_mb, ax
ret

keydown:
mov eax, msg.wParam
mov edx, msg.lParam
call keys
push eax
 push ecx
  call getactiveover
  mov ebx, ecx
 pop ecx
pop eax

push ecx
 push ebx
  
  // keystate, keep eax
  mov esi, keystate
  test esi, esi
  jz near l_keydown_60
    // ALT/WIN
    cmp al, 9 // TAB
    jnz l_keydown_56
      // ALT+TAB
      cmp esi, KEYSTATE_ALTTAB
      jz l_keydown_54
        // first ALT+TAB, keep eax
        mov keystate, KEYSTATE_ALTTAB
        push eax
          call destroystart
          call createselect
        pop eax
        
        pop ebx  // !!!
        pop edx
        jmp l_keydown_9
        
      l_keydown_54:
        // next ALT+TAB, keep eax
        push eax
          // select next window
          inc selected
          mov eax, selected
          cmp eax, miniature_count
          jb l_keydown_55
            mov selected, 0
            
          l_keydown_55:
          // redraw
          push 0  // rdw
          push 0  // hrgn_update
          push 0  // lprc_update
          push dword ptr selectwin  // hwnd
          call dword ptr [iredrawwindow + COFS]
          
        pop eax
        
        pop ebx  // !!!
        pop edx
        jmp l_keydown_9
      
    l_keydown_56:
    cmp al, 10h // Shift
    jnz l_keydown_58
      // ALT+SHIFT
      push eax
        // select next keyboard
        call getactiveover
        mov dl, cl
        push edx
          call getkbd
        pop edx
        inc al
        cmp al, byte ptr keybs
        jb l_keydown_57
          mov al, 0
          
        l_keydown_57:
        mov cl, al
        call setkbd
        call paintkbd
      pop eax
      mov ecx, WM_KEYDOWN
      jmp l_keydown_68
      
    l_keydown_58:
    cmp al, 73h // F4
    jnz l_keydown_59
      // ALT+F4
      push eax
        // send WM_CLOSE message
        call getactiveover
        mov bl, cl
        mov ecx, WM_CLOSE
        xor edx, edx
        xor esi, esi
        call postwin
      pop eax
      mov ecx, WM_KEYDOWN
      jmp l_keydown_68
      
    l_keydown_59:
    cmp al, 'D'
    jnz l_keydown_60
      cmp keystate, KEYSTATE_WIN
      jnz l_keydown_60
        // WIN+D
        call minimizeall
        xor eax, eax
        mov keystate, eax
        
        pop ebx  // !!!
        pop edx
        jmp l_keydown_9
        
  l_keydown_60:
  
  // keys, keep eax
  cmp al, 12h // ALT
  jnz l_keydown_62
    mov keystate, KEYSTATE_ALT
    
    l_keydown_61:
    // syskey
    mov ecx, WM_SYSKEYDOWN
    jmp short l_keydown_68
    
    l_keydown_612:
    // win key
    push eax
      call destroyselect
    pop eax
    mov keystate, KEYSTATE_WIN
    jmp short l_keydown_61
    
  l_keydown_62:
  cmp al, 5Bh // win
  jz l_keydown_612
  cmp al, 5Ch // win
  jz l_keydown_612
  cmp al, 5Dh // menu
  jz l_keydown_61
  
  mov ecx, WM_KEYDOWN
  
  l_keydown_68:
  // post wm_keydown / wm_syskeydown
  mov edx, eax
  mov esi, msg.lParam
 pop ebx
 push ebx
  call postwind
 pop ebx
pop edx
// wm_char
test edx, edx
jz l_keydown_9
  mov ecx, WM_CHAR
  mov esi, msg.lParam
  call postwind
  
l_keydown_9:
ret

keyup:
mov eax, msg.wParam
mov edx, msg.lParam
call keys
push eax
 push ecx
  call getactiveover
  mov ebx, ecx
 pop ecx
pop eax

cmp al, 12h // ALT
jnz l_keyup_62
  
  l_keyup_61:
  // syskey
  push eax
   push ebx
    call endsyskey
   pop ebx
  pop eax
  mov keystate, 0
  
  mov ecx, WM_SYSKEYUP
  jmp short l_keyup_68
  
l_keyup_62:
cmp al, 5Bh // win
jz l_keyup_61
cmp al, 5Ch // win
jz l_keyup_61
cmp al, 5Dh // menu
jz l_keyup_61

mov ecx, WM_KEYUP

l_keyup_68:
mov edx, eax
mov esi, msg.lParam
call postwind
ret

// IN: ecx = message, edx = wp, esi = lp
mmdesktop:
//...
ret

// IN: ecx = message, edx = wp, esi = lp
mbdesktop:
//...
ret

wheapmsg: db "\nHeap:\0"

wheap:
mov esi, offset wheapmsg + COFS
call strlen
mov bl, 7
call write

mov esi, 0x80000000
mov edi, 0xC0000000

l_wheap_5:
  mov eax, esi
  mov ecx, 16
  mov bl, 7
  call writen
  mov eax, [esi + offset HeapRec.size]
  mov ecx, 16
  mov bl, 11
  call writen
  mov esi, [esi + offset HeapRec.next]
  cmp esi, edi
  jb l_wheap_5
  
ret

test_miniature:
// register
mov wcl.cbSize, sizeof WndClassRec
mov wcl.style, WS_OVERLAPPEDWINDOW
mov wcl.lpfnWndProc, offset wndproc1 + COFS
mov wcl.cbClsExtra, 0
mov wcl.cbWndExtra, 0
mov wcl.hInstance, HINSTANCE
mov wcl.hIcon, 0
mov wcl.hCursor, 0
mov wcl.hbrBackground, 0xFF808080
mov wcl.lpszMenuName, 0
mov wcl.lpszClassName, offset clname + COFS
mov wcl.hIconSm, 0

push offset wcl
call dword ptr [iregister + COFS]

// create
push 0 // lpCreateParams
push HINSTANCE // hInstance
push 0 // hMenu
push 0 // hwndParent
push 300 // h
push 500 // w
push 100 // y
push 100 // x
push WS_OVERLAPPEDWINDOW | WS_VISIBLE // style
push 0 // lpszName
push offset clname + COFS // lpszClass
push 0 // dwExStyle
call dword ptr [icreatewin + COFS]

// get miniature
mov dl, [eax + offset WindowExRec.winid]
mov ecx, MINIATURE_W
mov ebx, MINIATURE_H
call getminiature
mov esi, edi

// OUT: ecx = screen width, edx = screen height, edi -> background
push esi
  call ginfo
pop esi

test esi, esi
jz l_test_miniature_8

add edi, 8
add esi, 8
mov ebx, edi
shl ecx, 2
mov edx, MINIATURE_H

l_test_miniature_5:
  test edx, edx
  jz l_test_miniature_8
    dec edx
    push ecx
      mov ecx, MINIATURE_W
      rep movsd
    pop ecx
    add ebx, ecx
    mov edi, ebx
    jmp short l_test_miniature_5
    
l_test_miniature_8:

// paint
xor ecx, ecx
xor ebx, ebx
mov esi, 200
mov edi, 200
call paint
ret

test_msg_inistr: db "Press a key\n\0"
test_msg_str: db "\nMSG\0"

test_msg:
// test proc
mov edx, offset ptest1 + COFS
xor esi, esi
xor edi, edi
call create_proc
mov edi, ebx
call start
call noop

mov edx, offset ptest1 + COFS
mov esi, offset pargs + COFS
xor edi, edi
call create_proc
mov edi, ebx
call start
call noop

// write inistr
mov esi, offset test_msg_inistr + COFS
call strlen
mov bl, 7
call write

// main loop
l_test_msg_1:
push 0
push 0
push 0
push offset msg
call dword ptr [igetmsg + COFS]
//call getmsg

push ebx
  push esi
    push edx
      push ecx
        mov esi, offset test_msg_str + COFS
        call strlen
        mov bl, 0Ah
        call write
      pop eax
      
      mov bl, 0Eh
      
      mov ecx, 16
      call writen
    pop eax
    mov bl, 0Ah
    mov ecx, 16
    call writen
  pop eax
  mov ecx, 16
  call writen
pop eax
mov bl, 7
mov ecx, 16
call writen

jmp l_test_msg_1
//ret

clname: db "class1\0"
ptest1: db "/system/test1.exe\0"
pargs: db "arg1 arg2\0"

test:
/*
// register
mov wcl.cbSize, sizeof WndClassRec
mov wcl.style, WS_OVERLAPPEDWINDOW
mov wcl.lpfnWndProc, offset wndproc1 + COFS
mov wcl.cbClsExtra, 0
mov wcl.cbWndExtra, 0
mov wcl.hInstance, HINSTANCE
mov wcl.hIcon, 0
mov wcl.hCursor, 0
mov wcl.hbrBackground, 0xFF808080
mov wcl.lpszMenuName, 0
mov wcl.lpszClassName, offset clname + COFS
mov wcl.hIconSm, 0

push offset wcl
call dword ptr [iregister + COFS]

// create
push 0 // lpCreateParams
push HINSTANCE // hInstance
push 0 // hMenu
push 0 // hwndParent
push 300 // h
push 400 // w
push CW_USEDEFAULT // y
push CW_USEDEFAULT // x
push WS_OVERLAPPEDWINDOW | WS_VISIBLE // style
push 0 // lpszName
push offset clname + COFS // lpszClass
push 0 // dwExStyle
call dword ptr [icreatewin + COFS]

// create
push 0 // lpCreateParams
push HINSTANCE // hInstance
push 0 // hMenu
push 0 // hwndParent
push 300 // h
push 400 // w
push CW_USEDEFAULT // y
push CW_USEDEFAULT // x
push WS_OVERLAPPEDWINDOW | WS_VISIBLE // style
push 0 // lpszName
push offset clname + COFS // lpszClass
push 0 // dwExStyle
call dword ptr [icreatewin + COFS]
mov hwnddestroy, eax

// create
push 0 // lpCreateParams
push HINSTANCE // hInstance
push 0 // hMenu
push 0 // hwndParent
push 300 // h
push 400 // w
push CW_USEDEFAULT // y
push CW_USEDEFAULT // x
push WS_OVERLAPPEDWINDOW | WS_VISIBLE // style
push 0 // lpszName
push offset clname + COFS // lpszClass
push 0 // dwExStyle
call dword ptr [icreatewin + COFS]
*/

// test proc
mov edx, offset ptest1 + COFS
xor esi, esi
xor edi, edi
call create_proc
mov edi, ebx
call start
call noop

mov edx, offset ptest1 + COFS
mov esi, offset pargs + COFS
xor edi, edi
call create_proc
mov edi, ebx
call start
call noop


// sleep & destroywin
//mov ecx, 2000
//call sleep

//push hwnddestroy
//call dword ptr [idestroywin + COFS]

// count
//mov count, (16 + 6) * 400 * 4 + 6
ret



wndproc1:
push ebp
mov ebp, esp
  mov edi, [ss:ebp + 8]  // hwnd
  mov ecx, [ss:ebp + 12] // wm
  mov edx, [ss:ebp + 16] // wp
  mov esi, [ss:ebp + 20] // lp
  
  /*
  mov dl, [edi + offset WindowExRec.winid]
  mov edi, offset win1
  call getwin
  mov edi, win1.pbitmap
  test edi, edi
  jz __19
    add edi, 8
    add edi, count
    add count, 4
    mov eax, 0xFFFFFFFF
    mov [edi], eax
    
    movsx ecx, win1.x
    movsx ebx, win1.y
    movsx esi, win1.w
    add esi, ecx
    dec esi
    movsx edi, win1.h
    add edi, ebx
    dec edi
    call paint
    
  __19:
  */
  
  //...
  
  // call defwndproc
  push dword ptr [ss:ebp + 20]
  push dword ptr [ss:ebp + 16]
  push dword ptr [ss:ebp + 12]
  push dword ptr [ss:ebp + 8]
  call dword ptr [idefwndproc + COFS]
  //call wregs//$$$
  
mov esp, ebp
pop ebp
ret 10h

selectclname: db "selectclass\0"

registerselect:
mov wcl.cbSize, sizeof WndClassRec
mov wcl.style, 0
mov wcl.lpfnWndProc, offset wndprocselect + COFS
mov wcl.cbClsExtra, 0
mov wcl.cbWndExtra, 0
mov wcl.hInstance, HINSTANCE
mov wcl.hIcon, 0
mov wcl.hCursor, 0
mov wcl.hbrBackground, 0xFF808080
mov wcl.lpszMenuName, 0
mov wcl.lpszClassName, offset selectclname + COFS
mov wcl.hIconSm, 0

push offset wcl
call dword ptr [iregister + COFS]

xor eax, eax
mov selectwin, eax
ret

// IN: dl = winid || WIN_NONE
// KEEP: ecx
loadminiature:
mov tmp_miniature_winid, dl
push ecx
  mov ecx, MINIATURE_W
  mov ebx, MINIATURE_H
  call getminiature
pop ecx
test edi, edi
jz l_loadminiature_9
  push ecx
   push edi
    mov ecx, MINIATURE_W * MINIATURE_H * 4 + 8
    call malloc
   pop edi
  pop ecx
  test ebx, ebx
  jnz l_loadminiature_16
    
    l_loadminiature_14:
    mov ebx, edi
    mov ah, 27
    push ecx
      int 20h
    pop ecx
    jmp l_loadminiature_9
    
  l_loadminiature_16:
  mov eax, miniature_count
  cmp eax, MAX_MINIATURES
  jb l_loadminiature_17
    push ecx
     push edi
      call free
     pop edi
    pop ecx
    jmp short l_loadminiature_14
    
  l_loadminiature_17:
  mov esi, edi
  mov edi, ebx
  
  mov dl, tmp_miniature_winid
  
  mov miniature_winid[eax], dl
  shl eax, 2
  mov pminiature[eax], edi
  inc miniature_count
  push ecx
   push esi
    mov ecx, (MINIATURE_W * MINIATURE_H * 4 + 8) / 4
    rep movsd
   pop ebx
  pop ecx
  mov ah, 27
  push ecx
    int 20h
  pop ecx
  
l_loadminiature_9:
ret

// IN: keystate
// OUT: selectwin
createselect:
cmp selectwin, 0
jnz near l_createselect_9
  // load miniatures
  mov edi, offset wcount
  call getwindows
  mov miniature_count, 0
  movzx ecx, wcount
  
  l_createselect_15:
    sub ecx, 1
    jc near l_createselect_18
      mov dl, wpos[ecx]
      movzx esi, dl
      shl esi, 5  // assert sizeof WinRec = 32
      test win.flags[esi], WINFLAGS_ALWAYSONTOP
      jnz l_createselect_15
       cmp win.parent[esi], WIN_NONE
       jnz l_createselect_15
          call loadminiature  // keep ecx
          jmp l_createselect_15
          
  l_createselect_18:
  mov dl, WIN_NONE
  call loadminiature
  
  // init values
  xor eax, eax
  mov miniature_timer, eax
  mov miniature_sx, eax
  mov selected, 1
  
  // create
  push 0 // lpCreateParams
  push HINSTANCE // hInstance
  push 0 // hMenu
  push 0 // hwndParent
  
  call ginfo
  push 160 // h
  push ecx // w
  shr edx, 1
  sub edx, 160 / 2
  push edx // y
  push 0 // x
  
  push WS_VISIBLE | WINFLAGS_ALWAYSONTOP // style
  push 0 // lpszName
  push offset selectclname + COFS // lpszClass
  push 0 // dwExStyle
  call dword ptr [icreatewin + COFS]
  mov selectwin, eax
  
l_createselect_9:
ret

// IN: selectwin
destroyselect:
cmp selectwin, 0
jz l_destroyselect_9
  // free miniatures
  l_destroyselect_5:
    cmp miniature_count, 0
    jz l_destroyselect_6
      dec miniature_count
      mov eax, miniature_count
      shl eax, 2
      mov ebx, pminiature[eax]
      call free
      jmp l_destroyselect_5
      
  l_destroyselect_6:
  // remove timer
  cmp miniature_timer, 0
  jz l_destroyselect_8
    mov esi, selectwin
    movzx edx, byte ptr [esi + offset WindowExRec.winid]
    mov ebx, SELECTTIMERID
    call rmtimer
    xor eax, eax
    mov miniature_timer, eax
    
  l_destroyselect_8:
  // destroy win
  push selectwin
  call dword ptr [idestroywin + COFS]
  xor eax, eax
  mov selectwin, eax
  
l_destroyselect_9:
ret

select_starttimer:
mov ecx, SELECTTIMERTIME
mov esi, selectwin
movzx edx, byte ptr [esi + offset WindowExRec.winid]
mov ebx, SELECTTIMERID
mov miniature_timer, ebx
xor edi, edi
call addtimer
ret

wndprocselect:
push ebp
mov ebp, esp
  
  sub esp, sizeof PaintStruct + 4 + sizeof RectRec + 4
  
  mov edi, [ss:ebp + 8]  // hwnd
  mov ecx, [ss:ebp + 12] // wm
  mov edx, [ss:ebp + 16] // wp
  mov esi, [ss:ebp + 20] // lp
  
  cmp ecx, WM_PAINT
  jnz near l_wndprocselect_2
    // paint

    // beginpaint
    mov eax, ebp
    sub eax, sizeof PaintStruct
    push eax
    push edi
    call dword ptr [ibeginpaint + COFS]
    mov [ebp - sizeof PaintStruct - 4], eax  // hdc
    
    // getclientrect
    mov eax, ebp
    sub eax, sizeof PaintStruct + 4 + sizeof RectRec
    push eax  // lprect
    push dword ptr [ebp + 8]  // hwnd
    call dword ptr [igetclientrect + COFS]
    
    // bar
    mov eax, [ebp - sizeof PaintStruct - 4 - sizeof RectRec + offset RectRec.bottom]
    push eax  // bottom
    mov eax, [ebp - sizeof PaintStruct - 4 - sizeof RectRec + offset RectRec.right]
    push eax  // right
    push 0  // top
    push 0  // left
    push SELECTBGCOLOR  // color
    push dword ptr [ebp - sizeof PaintStruct - 4]  // hdc
    call dword ptr [ibar + COFS]
    
    // selected bar
    mov eax, MINIATURE_W + MINIATURE_FRAMESIZE
    mov edx, selected
    cmp edx, miniature_count
    jb l_wndprocselect_10
      xor edx, edx
      mov selected, edx
      
    l_wndprocselect_10:
    mul edx
    cmp eax, miniature_sx
    jnl l_wndprocselect_11
      mov miniature_sx, eax
      
    l_wndprocselect_11:
    add eax, MINIATURE_FRAMESIZE / 2
    mov ebx, eax  // ebx = left
    add eax, MINIATURE_W + MINIATURE_FRAMESIZE
    
    mov edx, [ebp - sizeof PaintStruct - 4 - sizeof RectRec + offset RectRec.right]
    shr edx, 1
    mov ecx, ebx
    sub ecx, miniature_sx
    cmp ecx, edx
    jl l_wndprocselect_12
      add miniature_sx, MINIATURE_SXSTEP
      push eax
       push ebx
        call select_starttimer
       pop ebx
      pop eax
      
    l_wndprocselect_12:
    sub eax, miniature_sx
    sub ebx, miniature_sx
    
    push MINIATURE_H + MINIATURE_FRAMESIZE + (MINIATURE_FRAMESIZE / 2) // bottom
    push eax  // right
    push MINIATURE_FRAMESIZE / 2  // top
    push ebx  // left
    push SELECTEDBGCOLOR  // color
    push dword ptr [ebp - sizeof PaintStruct - 4]  // hdc
    call dword ptr [ibar + COFS]
    
    // * miniatures *
    // create hdc2
    push dword ptr [ebp - sizeof PaintStruct - 4]  // hdc
    call dword ptr [icreatecompatibledc + COFS]
    mov [ebp - sizeof PaintStruct - 4 - sizeof RectRec - 4], eax  // hdc2
    
    mov ecx, miniature_count
    
    l_wndprocselect_5:
    sub ecx, 1
    jc near l_wndprocselect_6
     push ecx
      
      // selectobject
      mov esi, ecx
      shl esi, 2
      mov ebx, pminiature[esi]
      
      push ebx
      push dword ptr [ebp - sizeof PaintStruct - 4 - sizeof RectRec - 4]  // hdc2
      call dword ptr [iselectobject + COFS]
      
      // bitblt
     pop ecx
     push ecx
      
      push SRCMERGE
      push 0 // y1
      push 0 // x1
      push dword ptr [ebp - sizeof PaintStruct - 4 - sizeof RectRec - 4]  // hdc2
      push MINIATURE_H // h
      push MINIATURE_W // w
      push MINIATURE_FRAMESIZE // y
      mov eax, MINIATURE_W + MINIATURE_FRAMESIZE
      mul ecx
      add eax, MINIATURE_FRAMESIZE
      sub eax, miniature_sx
      push eax // x
      push dword ptr [ebp - sizeof PaintStruct - 4]  // hdc
      call dword ptr [ibitblt + COFS]
      
     pop ecx
     jmp l_wndprocselect_5
     
    l_wndprocselect_6:
    // release hdc2
    push dword ptr [ebp - sizeof PaintStruct - 4 - sizeof RectRec - 4]  // hdc2
    push dword ptr [ebp + 8]  // hwnd
    call dword ptr [ireleasedc + COFS]
    
    // * endpaint *
    mov eax, ebp
    sub eax, sizeof PaintStruct
    push eax
    push dword ptr [ebp + 8]  // hwnd
    call dword ptr [iendpaint + COFS]
    
    jmp l_wndprocselect_9
    
  l_wndprocselect_2:
  cmp ecx, WM_TIMER
  jnz l_wndprocselect_3
    // * timer *
    cmp edx, SELECTTIMERID
    jnz l_wndprocselect_3
      
      xor eax, eax
      mov miniature_timer, eax
      
      // redraw
      push 0  // rdw
      push 0  // hrgn_update
      push 0  // lprc_update
      push dword ptr [ebp + 8]  // hwnd
      call dword ptr [iredrawwindow + COFS]
      
      jmp l_wndprocselect_9
      
  l_wndprocselect_3:
  
  //...
  
  l_wndprocselect_9:
mov esp, ebp
pop ebp
ret 10h

startclname: db "startclass\0"

registerstart:
mov wcl.cbSize, sizeof WndClassRec
mov wcl.style, 0
mov wcl.lpfnWndProc, offset wndprocstart + COFS
mov wcl.cbClsExtra, 0
mov wcl.cbWndExtra, 0
mov wcl.hInstance, HINSTANCE
mov wcl.hIcon, 0
mov wcl.hCursor, 0
mov wcl.hbrBackground, 0xFF808080
mov wcl.lpszMenuName, 0
mov wcl.lpszClassName, offset startclname + COFS
mov wcl.hIconSm, 0

push offset wcl
call dword ptr [iregister + COFS]

xor eax, eax
mov startwin, eax
mov ignorestart, 0
ret

createstart:
cmp startwin, 0
jnz l_createstart_9
  // create
  push 0 // lpCreateParams
  push HINSTANCE // hInstance
  push 0 // hMenu
  push 0 // hwndParent
  call ginfo
  sub edx, MAINPANEL_H + START_H
  push START_H // h
  push START_W // w
  push edx // y
  push 0 // x
  push WS_VISIBLE | WINFLAGS_ALWAYSONTOP // style
  push 0 // lpszName
  push offset startclname + COFS // lpszClass
  push 0 // dwExStyle
  call dword ptr [icreatewin + COFS]
  mov startwin, eax
  
l_createstart_9:
ret

destroystart:
cmp startwin, 0
jz l_destroystart_9
  push startwin
  call dword ptr [idestroywin + COFS]
  xor eax, eax
  mov startwin, eax
  
l_destroystart_9:
ret

wndprocstart:
push ebp
mov ebp, esp
  
  sub esp, sizeof PaintStruct + 4 + sizeof RectRec
  
  mov edi, [ss:ebp + 8]  // hwnd
  mov ecx, [ss:ebp + 12] // wm
  mov edx, [ss:ebp + 16] // wp
  mov esi, [ss:ebp + 20] // lp
  
  cmp ecx, WM_ACTIVATE
  jnz l_wndprocstart_2
    cmp edx, 0
    jnz l_wndprocstart_2
      // autodestruction
      call destroystart
      mov ignorestart, 0
      mov eax, mainpanel
      cmp eax, [ss:ebp + 20] // lp
      jnz near l_wndprocstart_9
        mov ignorestart, 1
        jmp l_wndprocstart_9
        
  l_wndprocstart_2:
  cmp ecx, WM_PAINT
  jnz near l_wndprocstart_3
    // * paint *
    // getwin
    push edi
      mov dl, [edi + offset WindowExRec.winid]
      mov edi, offset win1
      call getwin
    pop edi
    
    // beginpaint
    mov eax, ebp
    sub eax, sizeof PaintStruct
    push eax
    push edi
    call dword ptr [ibeginpaint + COFS]
    mov [ebp - sizeof PaintStruct - 4], eax  // hdc
    
    // getclientrect
    mov eax, ebp
    sub eax, sizeof PaintStruct + 4 + sizeof RectRec
    push eax  // lprect
    push dword ptr [ebp + 8]  // hwnd
    call dword ptr [igetclientrect + COFS]
    
    // bar 1
    push dword ptr [ebp - sizeof PaintStruct - 4 - sizeof RectRec + offset RectRec.bottom]  // bottom
    push START_MID - 1  // right
    push 0  // top
    push 0  // left
    push STARTBGCOLOR1  // color
    push dword ptr [ebp - sizeof PaintStruct - 4]
    call dword ptr [ibar + COFS]
    
    // bar 2
    push dword ptr [ebp - sizeof PaintStruct - 4 - sizeof RectRec + offset RectRec.bottom]  // bottom
    push dword ptr [ebp - sizeof PaintStruct - 4 - sizeof RectRec + offset RectRec.right]  // right
    push 0  // top
    push START_MID  // left
    push STARTBGCOLOR2  // color
    push dword ptr [ebp - sizeof PaintStruct - 4]
    call dword ptr [ibar + COFS]
    
    //...
    
    // endpaint
    mov eax, ebp
    sub eax, sizeof PaintStruct
    push eax
    push dword ptr [ebp + 8]  // hwnd
    call dword ptr [iendpaint + COFS]
    
    jmp l_wndprocstart_9
    
  l_wndprocstart_3:
  cmp ecx, WM_KEYDOWN
  jnz l_wndprocstart_4
    cmp edx, VK_DOWN
    jnz l_wndprocstart_4
      call destroystart
      
      mov mainpos, 0
      mov mainactive, 1
      
      mov eax, mainpanel
      mov dl, [eax + offset WindowExRec.winid]
      mov dh, 2
      call activate
      jmp l_wndprocstart_9
      
  l_wndprocstart_4:
  //...
  
  l_wndprocstart_9:
mov esp, ebp
pop ebp
ret 10h

mainclname: db "mainclass\0"

registermain:
mov wcl.cbSize, sizeof WndClassRec
mov wcl.style, 0
mov wcl.lpfnWndProc, offset wndprocmain + COFS
mov wcl.cbClsExtra, 0
mov wcl.cbWndExtra, 0
mov wcl.hInstance, HINSTANCE
mov wcl.hIcon, 0
mov wcl.hCursor, 0
mov wcl.hbrBackground, 0xFF808080
mov wcl.lpszMenuName, 0
mov wcl.lpszClassName, offset mainclname + COFS
mov wcl.hIconSm, 0

push offset wcl
call dword ptr [iregister + COFS]
ret

createmain:
mov mainpos, 0
mov mainactive, 0

push 0 // lpCreateParams
push HINSTANCE // hInstance
push 0 // hMenu
push 0 // hwndParent
call ginfo
sub edx, MAINPANEL_H
push MAINPANEL_H // h
push ecx // w
push edx // y
push 0 // x
push WS_VISIBLE | WINFLAGS_ALWAYSONTOP // style
push 0 // lpszName
push offset mainclname + COFS // lpszClass
push 0 // dwExStyle
call dword ptr [icreatewin + COFS]
mov mainpanel, eax
ret

destroymain:
push mainpanel
call dword ptr [idestroywin + COFS]
ret

// IN: ebp from paint
paintsel:
test mainactive, 255
jz near l_paintsel_9
  movsx eax, mainpos
  cmp ax, -1
  jnz __2
    // show desktop button
    mov main_x1, 0
    mov main_x2, MAINMINALL_W
    jmp __8
    
  __2:
  cmp ax, 0
  jnl __3
    // timedate
    mov eax, [ebp - sizeof PaintStruct - 4 - 4 - sizeof RectRec + offset RectRec.right]  // right
    mov main_x2, ax
    sub ax, 64  //...
    mov main_x1, ax
    jmp __8
    
  __3:
  movzx eax, mainpos
  //inc eax
  mov ecx, MAINICONWIDTH
  mul ecx
  add ax, MAINMINALL_W
  mov main_x1, ax
  add ax, MAINICONWIDTH - 1
  mov main_x2, ax
  
  __8:
  push 0  // bottom
  movsx eax, main_x2  // right
  dec eax
  push eax
  push 0  // top
  movsx eax, main_x1
  inc eax
  push eax  // left
  push MAINSELCOLOR  // color
  push dword ptr [ebp - sizeof PaintStruct - 4]
  call dword ptr [ibar + COFS]
  
  push dword ptr [ebp - sizeof PaintStruct - 4 - 4 - sizeof RectRec + offset RectRec.bottom]  // bottom
  movsx eax, main_x2  // right
  dec eax
  push eax
  push dword ptr [ebp - sizeof PaintStruct - 4 - 4 - sizeof RectRec + offset RectRec.bottom]  // top
  movsx eax, main_x1
  inc eax
  push eax  // left
  push MAINSELCOLOR  // color
  push dword ptr [ebp - sizeof PaintStruct - 4]
  call dword ptr [ibar + COFS]
  
  mov eax, [ebp - sizeof PaintStruct - 4 - 4 - sizeof RectRec + offset RectRec.bottom]  // bottom
  dec eax
  push eax
  movsx eax, main_x1  // right
  push eax
  push 1  // top
  movsx eax, main_x1
  push eax  // left
  push MAINSELCOLOR  // color
  push dword ptr [ebp - sizeof PaintStruct - 4]
  call dword ptr [ibar + COFS]
  
  mov eax, [ebp - sizeof PaintStruct - 4 - 4 - sizeof RectRec + offset RectRec.bottom]  // bottom
  dec eax
  push eax
  movsx eax, main_x2  // right
  push eax
  push 1  // top
  movsx eax, main_x2
  push eax  // left
  push MAINSELCOLOR  // color
  push dword ptr [ebp - sizeof PaintStruct - 4]
  call dword ptr [ibar + COFS]
  
  /*
  push dword ptr [ebp - sizeof PaintStruct - 4 - 4 - sizeof RectRec + offset RectRec.bottom]  // bottom
  movsx eax, main_x2  // right
  push eax
  push 0  // top
  movsx eax, main_x1
  push eax  // left
  push MAINSELCOLOR  // color
  push dword ptr [ebp - sizeof PaintStruct - 4]
  call dword ptr [ibar + COFS]
  */

l_paintsel_9:
ret

// IN: edi = hwnd, ecx = wm, edx = wp, esi = lp
paintmain:
push ebp
mov ebp, esp
  
  sub esp, sizeof PaintStruct + 4 + 4 + sizeof RectRec
  
  mov [ebp - sizeof PaintStruct - 8], edi  // hwnd
  
  // beginpaint
  mov eax, ebp
  sub eax, sizeof PaintStruct
  push eax
  push edi  // hwnd
  call dword ptr [ibeginpaint + COFS]
  mov [ebp - sizeof PaintStruct - 4], eax  // hdc
  
  // getclientrect
  mov eax, ebp
  sub eax, sizeof PaintStruct + 4 + 4 + sizeof RectRec
  push eax  // lprect
  push dword ptr [ebp - sizeof PaintStruct - 8]  // hwnd
  call dword ptr [igetclientrect + COFS]
  
  // bar
  push dword ptr [ebp - sizeof PaintStruct - 4 - 4 - sizeof RectRec + offset RectRec.bottom]  // bottom
  push dword ptr [ebp - sizeof PaintStruct - 4 - 4 - sizeof RectRec + offset RectRec.right]  // right
  push 0  // top
  push 0  // left
  push MAINBGCOLOR  // color
  push dword ptr [ebp - sizeof PaintStruct - 4]
  call dword ptr [ibar + COFS]
  
  // bar - minimize all
  push dword ptr [ebp - sizeof PaintStruct - 4 - 4 - sizeof RectRec + offset RectRec.bottom]  // bottom
  push MAINMINALL_W  // right
  push 0  // top
  push 0  // left
  push MAINMINALLCOLOR  // color
  push dword ptr [ebp - sizeof PaintStruct - 4]
  call dword ptr [ibar + COFS]
  
  // bar - start
  push 26  // bottom
  push MAINMINALL_W + 26 + 2  // right
  push 6  // top
  push MAINMINALL_W + 6 + 2  // left
  push 0xFF000000  // color
  push dword ptr [ebp - sizeof PaintStruct - 4]
  call dword ptr [ibar + COFS]
  
  // bar - test 1
  push 26  // bottom
  push MAINMINALL_W + 26 + 2 + (MAINICONWIDTH * 1) // right
  push 6  // top
  push MAINMINALL_W + 6 + 2 + (MAINICONWIDTH * 1)  // left
  push 0xFF000080  // color
  push dword ptr [ebp - sizeof PaintStruct - 4]
  call dword ptr [ibar + COFS]
  
  // bar - test 2
  push 26  // bottom
  push MAINMINALL_W + 26 + 2 + (MAINICONWIDTH * 2) // right
  push 6  // top
  push MAINMINALL_W + 6 + 2 + (MAINICONWIDTH * 2)  // left
  push 0xFF800000  // color
  push dword ptr [ebp - sizeof PaintStruct - 4]
  call dword ptr [ibar + COFS]
  
  // bar - test 3
  push 26  // bottom
  push MAINMINALL_W + 26 + 2 + (MAINICONWIDTH * 3) // right
  push 6  // top
  push MAINMINALL_W + 6 + 2 + (MAINICONWIDTH * 3)  // left
  push 0xFF008000  // color
  push dword ptr [ebp - sizeof PaintStruct - 4]
  call dword ptr [ibar + COFS]
  
  // draw icon
  push picon
  push 0  // y
  push 200 // x
  push [ebp - sizeof PaintStruct - 4]  // hdc
  call [idrawicon + COFS]
  
  //...
  
  call paintsel
  
  // endpaint
  mov eax, ebp
  sub eax, sizeof PaintStruct
  push eax
  push dword ptr [ebp - sizeof PaintStruct - 8]  // hwnd
  call dword ptr [iendpaint + COFS]
  
mov esp, ebp
pop ebp
ret

ptest2: db "/system/test2.exe\0"
ptest3: db "/system/test3.exe\0"

// IN: edi = hwnd, ecx = wm, edx = wp, esi = lp
clickmain:
movzx eax, si
sub eax, MAINMINALL_W
jnc l_clickmain_1
  // show desktop (minimize all)
  mov ignorestart, 0
  call minimizeall
  jmp l_clickmain_9
  
l_clickmain_1:
xor edx, edx
mov ecx, MAINICONWIDTH
div ecx
cmp ax, 0
jnz l_clickmain_21
  // start win
  cmp ignorestart, 0
  jnz l_clickmain_16
    call destroyselect
    call createstart
    jmp l_clickmain_9
    
  l_clickmain_16:
  mov ignorestart, 0
  jmp l_clickmain_9
  
l_clickmain_21:
mov ignorestart, 0

run_main:  // !!! also from key, IN: ax = n
cmp ax, 1
jnz l_clickmain_532
  // run test1
  mov edx, offset ptest1 + COFS
  xor esi, esi
  xor edi, edi
  call create_proc
  mov edi, ebx
  call start
  call noop
  jmp l_clickmain_9
  
l_clickmain_532:
cmp ax, 2
jnz l_clickmain_533
  // run test2
  mov edx, offset ptest2 + COFS
  xor esi, esi
  xor edi, edi
  call create_proc
  mov edi, ebx
  call start
  call noop
  jmp l_clickmain_9
  
l_clickmain_533:
cmp ax, 3
jnz l_clickmain_534
  // run test3
  mov edx, offset ptest3 + COFS
  xor esi, esi
  xor edi, edi
  call create_proc
  mov edi, ebx
  call start
  call noop
  jmp l_clickmain_9
  
l_clickmain_534:

//...

l_clickmain_9:
ret

// IN: edi = hwnd, ecx = wm, edx = wp, esi = lp
keymain:
cmp dl, VK_LEFT
jnz l_keymain_2
  cmp mainpos, -2
  jng near l_keymain_9
    dec mainpos
    
    l_keymain_22:
    push edi
      call paintmain
    pop edi
    // getwin
    mov dl, [edi + offset WindowExRec.winid]
    mov edi, offset win1
    mov ah, 98  // get win
    int 20h
    test al, al
    jnz near l_keymain_9
      // repaint win
      movsx ecx, win1.x
      movsx ebx, win1.y
      movsx esi, win1.w
      add esi, ecx
      dec esi
      movsx edi, win1.h
      add edi, ebx
      dec edi
      mov ah, 88  // repaint
      int 20h
      
    jmp l_keymain_9
    
l_keymain_2:
cmp dl, VK_RIGHT
jnz l_keymain_3
  cmp mainpos, 3  //...
  jnl near l_keymain_9
    inc mainpos
    jmp l_keymain_22
    
l_keymain_3:
cmp dl, VK_ENTER
jnz l_keymain_4
  mov ax, mainpos
  call run_main
  jmp l_keymain_9
  
l_keymain_4:

//...

l_keymain_9:
ret

// wndproc
wndprocmain:
push ebp
mov ebp, esp
  mov edi, [ss:ebp + 8]  // hwnd
  mov ecx, [ss:ebp + 12] // wm
  mov edx, [ss:ebp + 16] // wp
  mov esi, [ss:ebp + 20] // lp
  
  cmp ecx, WM_NCPAINT
  jnz l_wndprocmain_51
    jmp l_wndprocmain_9
    
  l_wndprocmain_51:
  cmp ecx, WM_PAINT
  jnz l_wndprocmain_52
    // paint
    call paintmain
    jmp l_wndprocmain_9
    
  l_wndprocmain_52:
  cmp ecx, WM_ACTIVATE
  jnz l_wndprocmain_53
    
    cmp dl, 0
    jnz l_wndprocmain_521
      mov mainactive, 0
    
    l_wndprocmain_521:  // also from WM_NCMOUSEOVER
    push edi
      call paintmain
    pop edi
    // getwin
    mov dl, [edi + offset WindowExRec.winid]
    mov edi, offset win1
    mov ah, 98  // get win
    int 20h
    test al, al
    jnz near l_wndprocmain_9
      // repaint win
      movsx ecx, win1.x
      movsx ebx, win1.y
      movsx esi, win1.w
      add esi, ecx
      dec esi
      movsx edi, win1.h
      add edi, ebx
      dec edi
      mov ah, 88  // repaint
      int 20h
      jmp l_wndprocmain_9
    
  l_wndprocmain_53:
  cmp ecx, WM_NCMOUSEOVER
  jz l_wndprocmain_521
  
  cmp ecx, WM_LBUTTONDOWN
  jnz l_wndprocmain_54
    call clickmain
    jmp l_wndprocmain_9
    
  l_wndprocmain_54:
  cmp ecx, WM_KEYDOWN
  jnz l_wndprocmain_55
    call keymain
    jmp l_wndprocmain_9
    
  l_wndprocmain_55:
  cmp ecx, WM_WINDOWPOSCHANGED
  jz l_wndprocmain_9
  cmp ecx, WM_CLOSE
  jz l_wndprocmain_9
  
  //...
  
  // call defwndproc
  push dword ptr [ss:ebp + 20]
  push dword ptr [ss:ebp + 16]
  push dword ptr [ss:ebp + 12]
  push dword ptr [ss:ebp + 8]
  call dword ptr [idefwndproc + COFS]
  
  l_wndprocmain_9:
mov esp, ebp
pop ebp
ret 10h

defkeyb: db "/system/keybs/en-us.kbd\0"

testicon: db "/system/images/expand.ico\0"
testimg: db "/system/images/test1.bmp\0"


main:
mov time_zone, 0
mov doubleclicktime, WIN_DOUBLECLICKTIME
xor eax, eax
mov old_mx, ax
mov old_my, ax
mov state, 0

call ginfo
mov esi, ecx
dec esi
mov edi, edx
dec edi
xor ecx, ecx
xor ebx, ebx
call paint

// test
//call wregs//$$$
//call test_miniature
//call test_msg
//call test

// register
call registerselect
call registerstart
call registermain

// keyboard
mov edx, offset defkeyb + COFS
call load_keyb
mov pkeyb[0], edi
mov keybsize[0], ecx
mov keybs, 1
mov specialkey, 0

// test icon
//call wheap
push offset testicon + COFS
push HINSTANCE
call [iloadicon + COFS]
mov picon, eax
/*
call wheap
push offset testicon + COFS
push HINSTANCE
call [iloadicon + COFS]
mov picon, eax
call wheap
*/

// test image
push offset testimg + COFS
push HINSTANCE
call [iloadbitmap + COFS]
mov pimg, eax

// create compatible dc
push 0 // hdc
call [icreatecompatibledc + COFS]
mov hdcbg, eax
push 0 // hdc
call [icreatecompatibledc + COFS]
mov hdcimg, eax

// select object bg
call ginfo
push edi
push hdcbg
call [iselectobject + COFS]

// select object image
push pimg
push hdcimg
call [iselectobject + COFS]

// IN: hdc, x, y, w, h, hdcSrc, x1, y1, rop
push SRCCOPY
push 0 // y1
push 0 // x1
push hdcimg  // hdc
push 50 // h
push 50 // w
push 100  // y
push 100  // x
push hdcbg  // hdc
call [ibitblt + COFS]

// delete object
push hdcimg
call [ideleteobject + COFS]
push hdcbg
call [ideleteobject + COFS]

//$$$
jmp l_main_58

// * login *

l_main_5:
// GetMessageA
push 0
push 0
push 0
push offset msg
call dword ptr [igetmsg + COFS]
test al, al
jz near l_main_5

mov eax, msg.hwnd
test eax, eax
jz l_main_50
  // DispatchMessageA
  push offset msg
  call dword ptr [idispatchmsg + COFS]
  jmp l_main_5
  
l_main_50:
// no hwnd
cmp msg.message, WM_MOUSEMOVE
jnz l_main_51
  call mousemove
  jmp l_main_5
  
l_main_51:
cmp msg.message, WM_MOUSEBUTTON
jnz l_main_52
  call mousebutton
  jmp l_main_5

l_main_52:
cmp msg.message, WM_KEYDOWN
jnz l_main_53
  call keydown
  jmp l_main_5
  
l_main_53:
cmp msg.message, WM_KEYUP
jnz l_main_54
  call keyup
  jmp l_main_5
  
l_main_54:

//...

jmp l_main_5

// * main windows *
l_main_58:
call createmain
mov ecx, MAINPANEL_H
call setmainpanelh

// paint bg
call ginfo
mov esi, ecx
dec esi
mov edi, edx
dec edi
xor ecx, ecx
xor ebx, ebx
call paint

l_main_6:
// GetMessageA
push 0
push 0
push 0
push offset msg
call dword ptr [igetmsg + COFS]
test al, al
jz l_main_6

mov eax, msg.hwnd
test eax, eax
jz l_main_60
  // DispatchMessageA
  push offset msg
  call dword ptr [idispatchmsg + COFS]
  jmp l_main_6
  
l_main_60:
// no hwnd
cmp msg.message, WM_MOUSEMOVE
jnz l_main_61
  call mousemove
  jmp l_main_6
  
l_main_61:
cmp msg.message, WM_MOUSEBUTTON
jnz l_main_62
  call mousebutton
  jmp l_main_6

l_main_62:
cmp msg.message, WM_KEYDOWN
jnz l_main_63
  call keydown
  jmp l_main_6
  
l_main_63:
cmp msg.message, WM_KEYUP
jnz l_main_64
  call keyup
  jmp l_main_6
  
l_main_64:
cmp msg.message, WM_TIMER
jnz l_main_65
  // timer
  cmp msg.wParam, WIN_DOUBLECLICKTIMERID
  jnz l_main_65
    xor eax, eax
    mov old_button, eax
    jmp l_main_6
    
l_main_65:

//...

jmp l_main_6

//ret

lastoffset:

