dos_header:

db "MZ"

dw 0, 1, 0, 4/*Header size in paragraphs*/, 0, 0
dw 0, 0xFFFE  // stack
dw 0  // csum
dw offset dos_main, 0  // ip, cs
dw 0, 0
dw 0, 0, 0, 0, 0, 0
dd 0, 0, 0, 0, 0
dd offset pe_header  // lfanew

[bits 16]

dos_str: db "Requires 32 bit OS\0"

dos_writez:

l_dos_writez_1:
  mov al, [cs:si]
  inc si
  or al, al
  jz l_dos_writez_9
    mov ah, 0Eh
    xor bh, bh
    int 10h
    jmp l_dos_writez_1

l_dos_writez_9:
ret


dos_main:
mov si, offset dos_str
call dos_writez

dos_end:
mov ax, 4C00h
int 21h

MAX_PATH = 260

// Window = 32 B (winid)
struct WinRec{
  int2 x, y, w, h
  uns4 flags, cr3, hwnd, pbitmap, pid
  uns1 kbd, parent
  uns1 ncheight, desktop
}

// Window Ex (hwnd)
struct WindowExRec{
  uns4 next, prev, first_child, pmenu, ptext, pclass, menusx
  int2 x, y, w, h
  uns4 winid, pid, hinstance
  uns4 exstyle, style, id, parent, wndproc
}

struct WndClassRec{
  int4 cbSize
  uns4 style
  ptr4 lpfnWndProc
  int4 cbClsExtra
  int4 cbWndExtra
  uns4 hInstance
  ptr4 hIcon
  ptr4 hCursor
  uns4 hbrBackground
  ptr4 lpszMenuName
  ptr4 lpszClassName
  ptr4 hIconSm
  ptr4 next // only tryskos
}

struct PointRec{
  int4 x, y
}

struct MessageRec{
  ptr4 hwnd
  uns4 message
  uns4 wParam
  uns4 lParam
  uns4 time
  PointRec pt
}

struct DCRec{
  int2 x0, y0, x1, y1, x2, y2, x, y
  ptr4 pbitmap, pen, brush, rgn, font, lppaintstruct
  uns4 textcolor
}

struct RectRec{
  int4 left, top, right, bottom
}

GDIOBJ_PEN = 1
GDIOBJ_BRUSH = 2
GDIOBJ_RGN = 3
GDIOBJ_FONT = 4

struct PenRec{
  uns4 type, color, size
}

struct BrushRec{
  uns4 type, flags, color1, color2, pbrushfn
  int2 x1, y1, x2, y2
}

struct RgnRec{
  uns4 type, flags
  int2 left, top, right, bottom
}

struct FontRec{
  uns4 type, rotation, pfont
  bool bold, italics, underline, strike
  char name[64]
}

struct PaintStruct {
	ptr4 hdc; // 0
	uns4 fErase; // 4
	RectRec rcPaint; // 8
	uns4 fRestore; // 24
	uns4 fIncUpdate; // 28
	uns1 rgbReserved[32]; // 32
}

// BitBlt
BLACKNESS = 0x42
NOTSRCERASE = 0x1100A6
NOTSRCCOPY = 0x330008
SRCERASE = 0x440328
DSTINVERT = 0x550009
PATINVERT = 0x5A0049
SRCINVERT = 0x660046
SRCAND = 0x8800C6
MERGEPAINT = 0xBB0226
MERGECOPY = 0xC000CA
SRCCOPY = 0xCC0020
SRCMERGE = 0xDD0022
SRCPAINT = 0xEE0086
WHITENESS = 0xFF0062

// GetStockObject
BLACK_BRUSH = 4
DKGRAY_BRUSH = 3
GRAY_BRUSH = 2
HOLLOW_BRUSH = 5
LTGRAY_BRUSH = 1
NULL_BRUSH = 5
WHITE_BRUSH = 0
BLACK_PEN = 7
NULL_PEN = 8
WHITE_PEN = 6
ANSI_FIXED_FONT = 11
ANSI_VAR_FONT = 12
DEVICE_DEFAULT_FONT = 14
DEFAULT_GUI_FONT = 17
OEM_FIXED_FONT = 10
SYSTEM_FONT = 13
SYSTEM_FIXED_FONT = 16
DEFAULT_PALETTE = 15

struct DateTime8{
  uns8 datetime
}

struct SearchRec{
  uns4 FileAttributes
  DateTime8 CreationTime
  DateTime8 LastAccessTime
  DateTime8 LastWriteTime
  uns8 FileSize
  uns8 Reserved
  char FileName[MAX_PATH]
  char AlternateFileName[14]
}

struct SystemTime{
  uns2 wYear
  uns2 wMonth
  uns2 wDayOfWeek
  uns2 wDay
  uns2 wHour
  uns2 wMinute
  uns2 wSecond
  uns2 wMilliseconds
}

MAX_WIN = 255
WIN_NONE = 255
WIN_MAINPANELH = 0
WIN_HEADER = 16
WIN_BORDER = 6
WIN_CORNER = 16
WIN_MINW = 64 + (WIN_BORDER * 2)
WIN_MINH = WIN_HEADER + (WIN_BORDER * 2)
WIN_MENUH = 16

WIN_DEFAULT_X_STEP = 32
WIN_DEFAULT_Y_STEP = 32
WIN_DEFAULT_X_MAX = 250
WIN_DEFAULT_Y_MAX = 250
WIN_BORDERCOLOR = 0xFF0080FF
WIN_HEADERCOLOR = 0xFF0080FF
WIN_FRAMECOLOR = 0xFF000000
WIN_ACTIVEFRAMECOLOR = 0xFFFFFF00
WIN_CLOSECOLOR = 0xFFE04040
WIN_MAXIMIZECOLOR = 0xFFA0A0A0
WIN_LIGHT = 0xFFFFFFFF
WIN_DARK = 0xFF606060

WINFLAGS_VALID = 1
WINFLAGS_FULLSCREEN = 2
WINFLAGS_ALWAYSONTOP = 8
WINFLAGS_CLOSEPRESSED    = 0x10
WINFLAGS_MAXIMIZEPRESSED = 0x20
WINFLAGS_MINIMIZEPRESSED = 0x40

// wp of mousemove
MK_LBUTTON  = 0x0001
MK_RBUTTON  = 0x0002
MK_SHIFT    = 0x0004
MK_CONTROL  = 0x0008
MK_MBUTTON  = 0x0010
MK_XBUTTON1 = 0x0020
MK_XBUTTON2 = 0x0040

WS_TABSTOP     = 0x00010000
WS_MAXIMIZEBOX = 0x00010000
WS_GROUP       = 0x00020000
WS_MINIMIZEBOX = 0x00020000
WS_SIZEBOX     = 0x00040000
WS_SYSMENU     = 0x00080000
WS_HSCROLL     = 0x00100000
WS_VSCROLL     = 0x00200000
WS_DLGFRAME    = 0x00400000
WS_BORDER      = 0x00800000
WS_CAPTION     = 0x00C00000
WS_MAXIMIZE    = 0x01000000
WS_DISABLED    = 0x08000000
WS_VISIBLE     = 0x10000000
WS_MINIMIZE    = 0x20000000
WS_CHILD       = 0x40000000
WS_POPUP       = 0x80000000
WS_OVERLAPPEDWINDOW = WS_CAPTION | WS_SYSMENU | WS_SIZEBOX | WS_MINIMIZEBOX | WS_MAXIMIZEBOX
WS_POPUPWINDOW = WS_POPUP | WS_BORDER | WS_SYSMENU

CW_USEDEFAULT = -1

SWP_NOSIZE = 1
SWP_NOMOVE = 2
SWP_NOZORDER = 4
SWP_NOREDRAW = 8
SWP_NOACTIVATE = 0x10
SWP_DRAWFRAME = 0x20
SWP_FRAMECHANGED = 0x20
SWP_SHOWWINDOW = 0x40
SWP_HIDEWINDOW = 0x80
SWP_NOCOPYBITS = 0x100
SWP_NOOWNERZORDER = 0x200
SWP_NOREPOSITION = 0x200
SWP_NOSENDCHANGING = 0x400
SWP_RELSIZE = 0x1000
SWP_RELMOVE = 0x2000

SW_HIDE = 0
SW_NORMAL = 1
SW_MAXIMIZE = 3
SW_SHOW = 5
SW_MINIMIZE = 6
SW_RESTORE = 9

RDW_INVALIDATE = 1
RDW_INTERNALPAINT = 2
RDW_ERASE = 4
RDW_VALIDATE = 8
RDW_NOINTERNALPAINT = 16
RDW_NOERASE = 32
RDW_NOCHILDREN = 64
RDW_ALLCHILDREN = 128
RDW_UPDATENOW = 256
RDW_ERASENOW = 512
RDW_FRAME = 1024
RDW_NOFRAME = 2048

WM_NULL = 0
WM_CREATE = 1
WM_DESTROY = 2
WM_MOVE = 3
WM_SIZE = 5
WM_ACTIVATE = 6
WM_SETFOCUS = 7
WM_KILLFOCUS = 8
WM_ENABLE = 10
WM_SETREDRAW = 11
WM_SETTEXT = 12
WM_GETTEXT = 13
WM_GETTEXTLENGTH = 14
WM_PAINT = 15
WM_CLOSE = 16
WM_QUERYENDSESSION = 17
WM_QUIT = 18
WM_QUERYOPEN = 19
WM_ERASEBKGND = 20
WM_SYSCOLORCHANGE = 21
WM_ENDSESSION = 22
WM_SHOWWINDOW = 24
WM_WINDOWPOSCHANGED = 47h
WM_NCPAINT = 85h
WM_NCMOUSEMOVE = 0A0h
WM_NCLBUTTONDOWN = 0A1h
WM_NCLBUTTONUP = 0A2h
WM_NCLBUTTONDBLCLK = 0A3h
WM_NCRBUTTONDOWN = 0A4h
WM_NCRBUTTONUP = 0A5h
WM_NCRBUTTONDBLCLK = 0A6h
WM_NCMBUTTONDOWN = 0A7h
WM_NCMBUTTONUP = 0A8h
WM_NCMBUTTONDBLCLK = 0A9h
WM_NCXBUTTONDOWN = 0ABh
WM_NCXBUTTONUP = 0ACh
WM_NCXBUTTONDBLCLK = 0ADh
WM_KEYDOWN    = 100h
WM_KEYUP      = 101h
WM_CHAR       = 102h
WM_SYSKEYDOWN = 104h
WM_SYSKEYUP   = 105h
WM_COMMAND = 111h
WM_TIMER   = 113h
WM_TERMINATED   = 180h
WM_NEW_CLIP     = 181h
WM_WINDOWCLOSED = 182h
WM_SCROLL       = 183h
WM_MOUSEBUTTON  = 184h
WM_MAINPANELHCHANGED = 185h
WM_NCMOUSEOVER  = 186h
WM_CHARIO       = 187h
WM_PAINTBUTTONS = 188h
WM_MOUSEOVER    = 189h
WM_DISKCHANGED  = 18Ah
WM_USB_INT = 1A0h
WM_MOUSEMOVE = 200h
WM_LBUTTONDOWN = 201h
WM_LBUTTONUP = 202h
WM_LBUTTONDBLCLK = 203h
WM_RBUTTONDOWN = 204h
WM_RBUTTONUP = 205h
WM_RBUTTONDBLCLK = 206h
WM_MBUTTONDOWN = 207h
WM_MBUTTONUP = 208h
WM_MBUTTONDBLCLK = 209h
WM_MOUSEWHEEL = 20Ah
WM_XBUTTONDOWN = 20Bh
WM_XBUTTONUP = 20Ch
WM_XBUTTONDBLCLK = 20Dh
WM_MOUSEHWHEEL = 20Eh
WM_DEVICECHANGE = 219h

COFS = 0x401000 - 0x400
CRVA = 0x1000 - 0x400

MAX_DIRS = 1024
MAX_FILES = 4096
MAX_BUFFER = 10000  // >= 512

ERC_NOT_FILE = 3
ERC_WRITE_ERROR = 4

TAB_H = 20

VK_LEFT = 37
VK_RIGHT = 39
VK_UP = 38
VK_DOWN = 40
VK_ENTER = 13
VK_ESC = 27
VK_BSP = 8
VK_TAB = 9
VK_HOME = 36
VK_END = 35
VK_PGUP = 33
VK_PGDN = 34
VK_INS = 45
VK_DEL = 46

KBD_RSH  = 1
KBD_LSH  = 2
KBD_CTRL = 4
KBD_ALT  = 8
KBD_SCRLK = 0x10
KBD_NUMLK = 0x20
KBD_CPSLK = 0x40
KBD_INS   = 0x80
KBD_RCTRL = 0x400
KBD_RALT  = 0x800
KBD_VCTRL = 0x1000

FOPEN_READ = 1
FOPEN_WRITE = 3
FOPEN_APPEND = 10h
FOPEN_CREATE = 20h

FILE_ATTRIBUTE_READONLY  = 0x00000001
FILE_ATTRIBUTE_HIDDEN    = 0x00000002
FILE_ATTRIBUTE_SYSTEM    = 0x00000004
FILE_ATTRIBUTE_DIRECTORY = 0x00000010
FILE_ATTRIBUTE_ARCHIVE   = 0x00000020
FILE_ATTRIBUTE_DEVICE    = 0x00000040
FILE_ATTRIBUTE_NORMAL    = 0x00000080
FILE_ATTRIBUTE_TEMPORARY     = 0x00000100
FILE_ATTRIBUTE_SPARSE_FILE   = 0x00000200
FILE_ATTRIBUTE_REPARSE_POINT = 0x00000400
FILE_ATTRIBUTE_COMPRESSED    = 0x00000800
FILE_ATTRIBUTE_OFFLINE       = 0x00001000
FILE_ATTRIBUTE_NOT_CONTENT_INDEXED = 0x00002000
FILE_ATTRIBUTE_ENCRYPTED       = 0x00004000
FILE_ATTRIBUTE_VALID_FLAGS     = 0x00007fb7
FILE_ATTRIBUTE_VALID_SET_FLAGS = 0x000031a7
FILE_ATTRIBUTE_LINUX = 0x08000000
FILE_ATTRIBUTE_LINK  = 0x04000000

ACCESS_R = 4 //read
ACCESS_W = 2 //write
ACCESS_X = 1 //execute

FSID_EXT2 = 82h
FSID_NTFS = 7
FSID_FAT12 = 0F0h
FSID_CD = 30h

EXT2_FEATURE_RO_COMPAT_SPARSE_SUPER = 0x0001 // Sparse Superblock
EXT2_FEATURE_RO_COMPAT_LARGE_FILE = 0x0002   // 64-bit file size
EXT2_FEATURE_RO_COMPAT_BTREE_DIR = 0x0004    // Binary tree sorted directories

struct StringBuilder{
  uns4 len, max
  ptr4 data
}

struct CreateRec{
  ptr4 lpCreateParams
  uns4 hInstance
  uns4 hMenu
  uns4 hwndParent
  int4 cy, cx, y, x
  uns4 style
  ptr4 lpszName
  ptr4 lpszClass
  uns4 dwExStyle
}

struct ViewRec{
  uns4 path_len, dirs_count, files_count, sy, y, x, w
  char path[MAX_PATH]
  uns4 pdirs[MAX_DIRS]
  uns4 pfiles[MAX_FILES]
  StringBuilder dirs, files
}

struct FileInfo{
  uns4 FileAttributes
  uns8 FileSize
  uns8 CreationTime
  uns8 LastAccessTime
  uns8 LastWriteTime
  char FileName[MAX_PATH]
}

struct SuperBlock{
  uns4 s_inodes_count, s_blocks_count, s_r_blocks_count, s_free_blocks_count
  uns4 s_free_inodes_count, s_first_data_block, s_log_block_size
  uns4 s_log_frag_size, s_blocks_per_group, s_frags_per_group
  uns4 s_inodes_per_group, s_mtime, s_wtime
  uns2 s_mnt_count, s_max_mnt_count, s_magic, s_state, s_errors
  uns2 s_minor_rev_level
  uns4 s_lastcheck, s_checkinterval, s_creator_os, s_rev_level
  uns2 s_def_resuid, s_def_resgid
  uns4 s_first_ino
  uns2 s_inode_size, s_block_group_nr
  uns4 s_feature_compat, s_feature_incompat, s_feature_ro_compat
  //...
}

struct GroupBlock{
  uns4 bg_block_bitmap, bg_inode_bitmap, bg_inode_table
  uns2 bg_free_blocks_count, bg_free_inodes_count
  uns2 bg_used_dirs_count, bg_pad
  uns1 bg_reserved[12]
}

struct INode{
  uns2 i_mode, i_uid
  uns4 i_size, i_atime, i_ctime, i_mtime, i_dtime
  uns2 i_gid, i_links_count
  uns4 i_blocks, i_flags, i_osd1
  uns4 i_block[15]
  uns4 i_generation, i_file_acl, i_dir_acl/*size 32-63*/, i_faddr
  uns1 i_osd[12]
}

[dorg 0x500000]

MessageRec msg

uns8 num, time
uns4 time_zone, args, env_vars

WinRec win1
WndClassRec wcl

uns4 mainwin, subwin

ERC_OUT_OF_RANGE        = 5
ERC_DISK_CHANGED        = 6
ERC_NOT_FLUSHED         = 7
ERC_DISK_IO             = 8
ERC_INVALID_DISK_NUMBER = 10h
ERC_NOT_FOUND_IN_CACHE  = 12h
ERC_UNKNOWN_GEOMETRY    = 15h
ERC_DISK_FULL           = 16h

ERC_NOT_IMPLEMENTED     = 0FFh

ERC_INVALID_CHANNEL_NUMBER = 18h
ERC_INVALID_MEMORY_ADDRESS = 19h
ERC_INVALID_COUNT          = 1Ah

ERC_NOT_ENOUGH_MEMORY = 21h
ERC_ALIGN             = 24h
ERC_ALREADY_FREE      = 25h
ERC_OVERFLOW          = 26h
ERC_UNDERFLOW         = 27h

ERC_MSG_QUEUE_EMPTY    = 30h
ERC_MSG_QUEUE_FULL     = 31h
ERC_MSG_INVALID_TARGET = 32h

ERC_TOO_MANY_PROCS   = 40h
ERC_TOO_MANY_THREADS = 41h

ERC_TIMER_FULL      = 42
ERC_TIMER_NOT_FOUND = 43

ERC_PATH_NOT_FOUND = 44h
ERC_FILE_NOT_FOUND = 45h
ERC_TOO_MANY_OPEN_FILES = 46h
ERC_DIR_ALREADY_EXISTS = 47h
ERC_UNKNOWN_FILESYSTEM = 48h
ERC_DIR_NOT_EMPTY = 49h
ERC_CANT_REMOVE = 4Ah
ERC_DUPLICATE_NAME = 4Bh
ERC_INVALID_FHANDLE = 4Ch
ERC_INVALID_THREAD = 4Dh
ERC_FS = 4Eh
ERC_READ_ONLY = 4Fh
ERC_IN_USE = 50h
ERC_OUT_OF_DISK = 51h
ERC_TOO_MANY_SEARCHES = 52h
ERC_INVALID_SHANDLE = 53h
ERC_CANT_RENAME = 54h

ERC_INVALID_PID = 55h
ERC_STACK_OVERFLOW = 56h
ERC_INVALID_HEADER = 57h
ERC_INVALID_SERVICE = 58h

ERC_TOO_LONG = 59h
ERC_ONLY_STARTER = 5Ah
ERC_INVALID_MEMORY_LOCATION = 5Bh
ERC_INVALID_THREADID = 5Ch
ERC_ACCESS_DENIED = 5Dh
ERC_INVALID_PRIORITY = 5Eh
ERC_INVALID_ATRBS = 5Fh
ERC_INVALID_VALUE = 60h
ERC_INVALID_POINTER = 61h
ERC_INVALID_CHAR = 62h
ERC_DISK_REMOVED = 63h
ERC_TOO_BIG_HOLE = 64h
ERC_UTF8 = 65h
ERC_BUSY = 66h
ERC_DIR_TOO_BIG = 67h
ERC_LINK = 68h
ERC_NOT_A_LINK = 69h
ERC_INFINITE_LINK = 70h
ERC_CANT_MOVE = 71h
ERC_FILE_TOO_BIG = 72h

[align 32]

pe_header:

db "PE"

dw 0, 14Ch, 2/*Number of sections*/
dd 0, 0/*Pointer to symbol table*/, 0/*Number of symbols*/
dw 224 /*Size of optional header*/, 0 /*Characteristics*/

// Optional header
dw 0/*OH magic*/

db 0, 0
dd offset lastoffset /*Size of code*/
dd 0/*Size of initialized data*/, #/*Size of uninitialized data*/
dd 0x1000/*Address of entry point*/
dd 0/*Base of code*/, 0x10000/*Base of data*/

dd 0x400000/*Image base*/
dd 0x1000 /*Section alignment*/, 0x200 /*File alignment*/
dw 4, 0 /*OS version*/, 0, 0 /*Image version*/, 4, 0 /*Subsystem version*/
dd 0, 0x10000/*Size of image*/, 0x400/*Size of headers*/
dd 0 /*Checksum*/
dw 2/*Subsystem*/, 0/*DLL characteristics*/
dd 0x100000/*stack*/, 0x1000
dd 0x100000/*heap*/, 0x1000
dd 0/*Loader flags*/, 16

// export
dd 0,0
// import
dd offset import + CRVA, 0x1000
// other directories
dd 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0

// Section table [lfanew + 18h + sizeOfOptionalHeader]
db ".text   "
dd offset lastoffset // VSize
dd 0x1000 // VAdr
dd offset lastoffset // Size of raw data
dd 0x400 // Pointer to raw data
dd 0 // Pointer to relocations
dd 0 // Pointer to line numbers
dw 0 // Number of relocations
dw 0 // Number of line numbers
dd 0x60000060 // Characteristics

db ".data   "
dd # - 0x500000 // VSize
dd 0x100000 // VAdr
dd 0 // Size of raw data
dd 0 // Pointer to raw data
dd 0 // Pointer to relocations
dd 0 // Pointer to line numbers
dw 0 // Number of relocations
dw 0 // Number of line numbers
dd 0xC0000040 // Characteristics

times 0x400 - $, 0

[bits 32]

jmp main

[fill 0x1000]

import:

import_table:
dd offset user32_lookup + CRVA
dd 0 // dtm_stamp
dd 0 // forwarder_chain
dd offset user32_name + CRVA // user32_name_rva
dd offset user32_lookup + CRVA // import_adr_table_rva

dd offset gdi32_lookup + CRVA
dd 0 // dtm_stamp
dd 0 // forwarder_chain
dd offset gdi32_name + CRVA // user32_name_rva
dd offset gdi32_lookup + CRVA // import_adr_table_rva

//...

dd 0,0,0,0,0


user32_name: db "user32.dll\0"

user32_lookup:
ibeginpaint: dd offset ubeginpaint + CRVA // bit 31 must be 0
icreatewin: dd offset ucreatewin + CRVA // bit 31 must be 0
idefwndproc: dd offset udefwndproc + CRVA // bit 31 must be 0
idestroywin: dd offset udestroywin + CRVA // bit 31 must be 0
iendpaint: dd offset uendpaint + CRVA // bit 31 must be 0
igetclientrect: dd offset ugetclientrect + CRVA // bit 31 must be 0
igetdc: dd offset ugetdc + CRVA // bit 31 must be 0
igetmsg: dd offset ugetmsg + CRVA // bit 31 must be 0
igetwindowdc: dd offset ugetwindowdc + CRVA // bit 31 must be 0
idispatchmsg: dd offset udispatchmsg + CRVA // bit 31 must be 0
ipostquit: dd offset upostquit + CRVA // bit 31 must be 0
iredrawwindow: dd offset uredrawwindow + CRVA // bit 31 must be 0
iregister: dd offset uregister + CRVA // bit 31 must be 0
ireleasedc: dd offset ureleasedc + CRVA // bit 31 must be 0
isetwinpos: dd offset usetwinpos + CRVA // bit 31 must be 0
ishowwindow: dd offset ushowwindow + CRVA // bit 31 must be 0
//...
dd 0

ubeginpaint:
dw 0 // hint
db "BeginPaint\0"
[fill 2]

ucreatewin:
dw 0 // hint
db "CreateWindowExA\0"
[fill 2]

udefwndproc:
dw 0 // hint
db "DefWindowProcA\0"
[fill 2]

udestroywin:
dw 0 // hint
db "DestroyWindow\0"
[fill 2]

uendpaint:
dw 0 // hint
db "EndPaint\0"
[fill 2]

ugetclientrect:
dw 0 // hint
db "GetClientRect\0"
[fill 2]

ugetdc:
dw 0 // hint
db "GetDC\0"
[fill 2]

ugetmsg:
dw 0 // hint
db "GetMessageA\0"
[fill 2]

ugetwindowdc:
dw 0 // hint
db "GetWindowDC\0"
[fill 2]

udispatchmsg:
dw 0 // hint
db "DispatchMessageA\0"
[fill 2]

upostquit:
dw 0 // hint
db "PostQuitMessage\0"
[fill 2]

uredrawwindow:
dw 0 // hint
db "RedrawWindow\0"
[fill 2]

uregister:
dw 0 // hint
db "RegisterClassExA\0"
[fill 2]

ureleasedc:
dw 0 // hint
db "ReleaseDC\0"
[fill 2]

usetwinpos:
dw 0 // hint

db "SetWindowPos\0"
[fill 2]

ushowwindow:
dw 0 // hint
db "ShowWindow\0"
[fill 2]


gdi32_name: db "gdi32.dll\0"

gdi32_lookup:
ibar: dd offset ubar + CRVA // bit 31 must be 0
ibitblt: dd offset ubitblt + CRVA // bit 31 must be 0
icreatepen: dd offset ucreatepen + CRVA // bit 31 must be 0
icreaterectrgn: dd offset ucreaterectrgn + CRVA // bit 31 must be 0
icreatesolidbrush: dd offset ucreatesolidbrush + CRVA // bit 31 must be 0
ideleteobject: dd offset udeleteobject + CRVA // bit 31 must be 0
igetstockobject: dd offset ugetstockobject + CRVA // bit 31 must be 0
irectangle: dd offset urectangle + CRVA // bit 31 must be 0
iselectobject: dd offset uselectobject + CRVA // bit 31 must be 0
//...
dd 0

ubar:
dw 0 // hint
db "Bar\0"
[fill 2]

ubitblt:
dw 0 // hint
db "BitBlt\0"
[fill 2]

ucreatepen:
dw 0 // hint
db "CreatePen\0"
[fill 2]

ucreaterectrgn:
dw 0 // hint
db "CreateRectRgn\0"
[fill 2]

ucreatesolidbrush:
dw 0 // hint
db "CreateSolidBrush\0"
[fill 2]

udeleteobject:
dw 0 // hint
db "DeleteObject\0"
[fill 2]

ugetstockobject:
dw 0 // hint
db "GetStockObject\0"
[fill 2]

urectangle:
dw 0 // hint
db "Rectangle\0"
[fill 2]

uselectobject:
dw 0 // hint
db "SelectObject\0"
[fill 2]

//...

import_lastoffset:

// IN: dl = x, dh = y
curto:
push ecx
 push esi
  push edx
   push edi
    push ebx
  
     mov ah, 3
     int 20h
  
    pop ebx
   pop edi
  pop edx
 pop esi
pop ecx
ret

// IN: esi -> string, ecx = length, bl = color
write:
push edx
 push edi
  push ebx
  
  mov ah, 2
  int 20h
  
  pop ebx
 pop edi
pop edx
ret

// IN: eax = number, ecx = system, bl = color
writen:
push ecx
 push edx
  push esi
   push edi

    sub esp, 36

	// Parse digits from the number

	mov esi, esp
	add esi, 36
	cmp ecx, 2
	jnb l_writen_1
		mov ecx, 10		// ecx must be >= 2

	l_writen_1:
		xor edx, edx
		div ecx
		cmp dl, 10
		jnb l_writen_2
			add dl, '0'
			jmp short l_writen_3

		l_writen_2:
			add dl, 55

		l_writen_3:
		dec esi
		mov [esi], dl
		or eax, eax
		jnz l_writen_1
	
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	mov dl, ' '
	
      dec esi
      inc ecx
      mov [esi], dl
      
	call write
	
    add esp, 36

    pop edi
  pop esi
 pop edx
pop ecx
ret

// IN: eax = number, ecx = system, bl = color, bh = minlen
writemin:
push ecx
 push edx
  push esi
   push edi

    sub esp, 36

	// Parse digits from the number

	mov esi, esp
	add esi, 36
	cmp ecx, 2
	jnb l_writemin_1
		mov ecx, 10		// ecx must be >= 2

	l_writemin_1:
		xor edx, edx
		div ecx
		cmp dl, 10
		jnb l_writemin_2
			add dl, '0'
			jmp short l_writemin_3

		l_writemin_2:
			add dl, 55

		l_writemin_3:
		dec esi
		mov [esi], dl
		or eax, eax
		jnz l_writemin_1
	
	cmp bh, 36
	jb l_writemin_4
	  mov bh, 36
	  
	l_writemin_4:
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	mov dl, ' '
	
	l_writemin_5:
	  cmp cl, bh
	  jnb l_writemin_6
          dec esi
          inc ecx
          mov [esi], dl
          jmp short l_writemin_5
      
	l_writemin_6:	  
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	
	call write
	
    add esp, 36

    pop edi
  pop esi
 pop edx
pop ecx
ret

THOUSAND_SEPARATOR = ','

// IN: edx:eax = number, ecx = system, bl = color
writen8:
push ecx
 push esi
  push edi

    sub esp, 72

    // Parse digits from the number
    mov esi, esp
    add esi, 72

    mov dword ptr num[0], eax
    mov dword ptr num[4], edx
    xor bh, bh

    cmp ecx, 2
    jnb l_writen8_1
      mov ecx, 10		// ecx must be >= 2
    
    l_writen8_1:
      cmp bh, 3
      jb l_writen_12
        dec esi
        mov byte ptr [esi], THOUSAND_SEPARATOR
        xor bh, bh
        
      l_writen_12:
      inc bh
      xor edx, edx
      mov eax, dword ptr num[4]
      div ecx
      mov dword ptr num[4], eax
      mov eax, dword ptr num[0]
      div ecx
      mov dword ptr num[0], eax
      
      cmp dl, 10
      jnb l_writen8_2
        add dl, '0'
        jmp short l_writen8_3
      
      l_writen8_2:
        add dl, 55
      
      l_writen8_3:
      dec esi
      mov [esi], dl
      
      mov eax, dword ptr num[0]
      mov edx, dword ptr num[4]
      test eax, eax
      jnz l_writen8_1
        test edx, edx
        jnz l_writen8_1
      
    mov ecx, esp
    add ecx, 72
    sub ecx, esi  // ecx = len
    mov dl, ' '
    
    dec esi
    inc ecx
    mov [esi], dl
     
    call write
     
    add esp, 72
    
  pop edi
 pop esi
pop ecx
ret

// IN: edx -> path & mask, edi -> SearchRec
// OUT: al = 0 || erc
find_first:
mov ah, 22
int 20h
cmp al, ERC_BUSY
jnz l_find_first_9
  call noop
  jmp short find_first
  
l_find_first_9:
ret

// IN: edi -> SearchRec
// OUT: al = 0 || erc
find_next:
mov ah, 23
int 20h
cmp al, ERC_BUSY
jnz l_find_next_9
  call noop
  jmp short find_next
  
l_find_next_9:
ret

// IN: edi -> SearchRec
find_close:
mov ah, 48
int 20h
ret

// IN: edx -> pathz
cdir:
mov ah, 16
int 20h
cmp al, ERC_BUSY
jnz l_cdir_9
  call noop
  jmp short cdir
  
l_cdir_9:
ret

// IN: edi -> buffer[MAX_PATH]
// OUT: al = 0 || erc
get_current_directory:
mov ah, 52
int 20h
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fopen:
mov esi, 3
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fopen_9
  call noop
  jmp short fopen
  
l_fopen_9:
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fopenread:
mov esi, 1
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fopenread_9
  call noop
  jmp short fopenread
  
l_fopenread_9:
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fcreate:
mov esi, 20h
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fcreate_9
  call noop
  jmp short fcreate
  
l_fcreate_9:
ret

// IN: ebx = fhandle
// OUT: edx:ecx = fpos
fgetpos:
mov ah, 14
int 20h
cmp al, ERC_BUSY
jnz l_fgetpos_9
  call noop
  jmp short fgetpos
  
l_fgetpos_9:
ret

// IN: ebx = fhandle, edx:edi = file offset
// OUT: al = erc
fsetpos:
mov ah, 12
int 20h
cmp al, ERC_BUSY
jnz l_fsetpos_9
  call noop
  jmp short fsetpos
  
l_fsetpos_9:
ret

// IN: ebx = fhandle
// OUT: edx:ecx = fsize
fgetsize:
mov ah, 15
int 20h
cmp al, ERC_BUSY
jnz l_fgetsize_9
  call noop
  jmp short fgetsize
  
l_fgetsize_9:
ret

// IN: ebx = fhandle
fclose:
mov ah, 9
int 20h
cmp al, ERC_BUSY
jnz l_fclose_9
  call noop
  jmp short fclose
  
l_fclose_9:
ret

// IN: ebx = fhandle, edi -> data, ecx = size
// OUT: al = erc, ecx = size read
fread:
mov ah, 10
int 20h
cmp al, ERC_BUSY
jnz l_fread_9
  call noop
  jmp short fread
  
l_fread_9:
ret

// IN: ebx = fhandle, edi -> data, ecx = size
// OUT: al = erc, ecx = size write
fwrite:
mov ah, 11
int 20h
cmp al, ERC_BUSY
jnz l_fwrite_9
  call noop
  jmp short fwrite
  
l_fwrite_9:
ret

// IN: edx -> filenamez
rm:
mov ah, 18
int 20h
cmp al, ERC_BUSY
jnz l_rm_9
  call noop
  jmp short rm
  
l_rm_9:
ret

// IN: edx -> filenamez
md:
mov ah, 17
int 20h
cmp al, ERC_BUSY
jnz l_md_9
  call noop
  jmp short md
  
l_md_9:
ret

// IN: edx -> path & filenamez, esi -> new filenamez
// OUT: al = erc
ren:
mov ah, 20
int 20h
cmp al, ERC_BUSY
jnz l_ren_9
  call noop
  jmp short ren
  
l_ren_9:
ret

// IN: edx -> filenamez, esi -> new path
mv:
mov ah, 21
int 20h
cmp al, ERC_BUSY
jnz l_mv_9
  call noop
  jmp short mv
  
l_mv_9:
ret

// IN: esi = ldiskn
resetdisk:
mov ah, 63
int 20h
ret

// IN: edx -> filenamez, esi = mode
// OUT: al = erc, ebx = fhandle
open_link:
mov ah, 66
int 20h
cmp al, ERC_BUSY
jnz l_open_link_9
  call noop
  jmp short open_link
  
l_open_link_9:
ret

// IN: edx -> filenamez
// OUT: al = erc
rm_link:
mov ah, 67
int 20h
cmp al, ERC_BUSY
jnz l_rm_link_9
  call noop
  jmp short rm_link
  
l_rm_link_9:
ret

// IN: al = ldiskn
// OUT: al = erc
flush:
movzx esi, al

l_flush_1:
mov ah, 39 
int 20h
cmp al, ERC_BUSY
jnz l_flush_9
  call noop
  jmp short l_flush_1
  
l_flush_9:
ret

// IN: ebx = fhandle
// OUT: al = erc, edx:ecx = ftime
get_mtime:
mov ah, 74
int 20h
cmp al, ERC_BUSY
jnz l_get_mtime_9
  call noop
  jmp short get_mtime
  
l_get_mtime_9:
ret

// IN: ebx = fhandle, edx:ecx = ftime
// OUT: al = erc
set_mtime:
mov ah, 75
int 20h
cmp al, ERC_BUSY
jnz l_set_mtime_9
  call noop
  jmp short set_mtime
  
l_set_mtime_9:
ret

// IN: edx -> filenamez, esi = atrbs
// OUT: al = errorcode
// differrent behavior for windows and linux
chmod:
mov ah, 76
int 20h
cmp al, ERC_BUSY
jnz l_chmod_9
  call noop
  jmp short chmod
  
l_chmod_9:
ret

// only starter, root
// IN: edx -> filenamez, esi = new owner
// OUT: al = erc
chown:
mov ah, 78
int 20h
cmp al, ERC_BUSY
jnz l_chown_9
  call noop
  jmp short chown
  
l_chown_9:
ret

// only starter, root or owner
// IN: edx -> filenamez, esi = new group
// OUT: al = erc
chgrp:
mov ah, 79
int 20h
cmp al, ERC_BUSY
jnz l_chgrp_9
  call noop
  jmp short chgrp
  
l_chgrp_9:
ret

// IN: edx -> filenamez
// OUT: al = erc, ecx = uid, edx = gid
fuidgid:
mov ah, 82
int 20h
cmp al, ERC_BUSY
jnz l_fuidgid_9
  call noop
  jmp short fuidgid
  
l_fuidgid_9:
ret

// only starter
// IN: edx:ebx = disk offset, ecx = size,
//     esi = logical disk number, edi -> target
disk_read:
mov ah, 36
int 20h
cmp al, ERC_BUSY
jnz l_disk_read_9
  call noop
  jmp short disk_read
  
l_disk_read_9:
ret

// only starter
// IN: edx:ebx = disk offset, ecx = size,
//     esi = logical disk number, edi -> source
disk_write:
mov ah, 37
int 20h
cmp al, ERC_BUSY
jnz l_disk_write_9
  call noop
  jmp short disk_write
  
l_disk_write_9:
ret

// OUT: al = logical disk number
get_boot_disk:
mov ah, 77
int 20h
movzx eax, al
ret

// OUT: al = logical disk number
get_users_disk:
mov ah, 83
int 20h
movzx eax, al
ret

// IN: esi = logical disk number
// OUT: al = type (2:fd, 3:cd, 4:hd), ah = pdiskn,
//      edx:ecx = disk size in sectors, edi:esi = base in sectors
get_disk_type:
mov ah, 53
int 20h
ret

// IN: esi = logical disk number
// OUT: edx:eax = disk size in bytes
get_disk_size:
mov ah, 38
int 20h
ret

// IN: al = ldiskn
// OUT: cl = erc, edx:eax = free bytes)
disk_free:
mov esi, eax

l_disk_free_1:
mov ah, 68
int 20h
cmp al, ERC_BUSY
jnz l_disk_free_9
  call noop
  jmp short l_disk_free_1
  
l_disk_free_9:
xchg eax, ecx
ret

// IN: al = ldiskn
// OUT: al = erc
reset_disk:
mov esi, eax

l_reset_disk_1:
mov ah, 63
int 20h
cmp al, ERC_BUSY
jnz l_reset_disk_9
  call noop
  jmp short l_reset_disk_1
  
l_reset_disk_9:
ret

// IN: edx:ebx = sector, ecx = count, edi -> data,
//     esi = physical HD number
disk_read_sector:
mov ah, 40
int 20h
cmp al, ERC_BUSY
jnz l_disk_read_sector_9
  call noop
  jmp short disk_read_sector
  
l_disk_read_sector_9:
ret

// IN: edx:ebx = sector, ecx = count, edi -> data,
//     esi = physical HD number
disk_write_sector:
mov ah, 41
int 20h
cmp al, ERC_BUSY
jnz l_disk_write_sector_9
  call noop
  jmp short disk_write_sector
  
l_disk_write_sector_9:
ret

// IN: dl = wndid, edi -> WinRec
// OUT: al = erc
getwin:
mov ah, 98
int 20h
ret

noop:
mov ah, 0
int 20h
ret

// IN: ecx = size
// OUT: al = erc, ebx = ptr
malloc:
mov ah, 24
int 20h
ret

// IN: ebx = ptr
free:
mov ah, 25
int 20h
ret

// OUT: al = 0 || errorcode, ebx = wnd:sender, ecx = msg, edx = wp, esi = lp
getmsg:
mov ah, 5 // get system message
int 20h
or al, al
jz l_getmsg_9
  mov ah, 7 // get message
  int 20h
  or al, al
  jz l_getmsg_9
    mov ah, 45 // get pid, tid; OUT: edi = tid
    int 20h
    mov ah, 35 // stop thread
    int 20h
    jmp short getmsg
  
l_getmsg_9:
ret

waitkey:
pushad
  
  l_waitkey_5:
  mov ah, 45 // get pid, tid; OUT: edi = tid
  int 20h
  mov ah, 35 // stop thread
  int 20h
  call getmsg
  cmp ecx, WM_KEYDOWN
  jnz l_waitkey_5
  
popad
ret

// IN: esi -> ftime, edi -> SystemTime
ftime2local:
mov eax, time_zone
mov ecx, 3600
imul ecx
mov ecx, 10000000
imul ecx

add eax, [esi]
adc edx, [esi + 4]
mov dword ptr time[0], eax
mov dword ptr time[4], edx

mov esi, offset time
mov ah, 59
int 20h
ret

// IN: ecx = uid, edi -> byte[256]
getuserinfo:
mov ah, 80
int 20h
cmp al, ERC_BUSY
jnz l_getuserinfo_9
  call noop
  jmp short getuserinfo
  
l_getuserinfo_9:
ret

// IN: ecx = gid, edi -> byte[256]
getgroupinfo:
mov ah, 81
int 20h
cmp al, ERC_BUSY
jnz l_getgroupinfo_9
  call noop
  jmp short getgroupinfo
  
l_getgroupinfo_9:
ret

// OUT: esi -> args, edi -> env_vars
getargs:
mov ah, 90
int 20h
ret

exit:
mov ah, 1
int 20h
//ret

// IN: ecx = ms
sleep:
mov ah, 32
int 20h
ret

// IN: esi -> StringBuilder
// KEEP: esi
sb_init:
xor eax, eax
mov [esi + offset StringBuilder.len], eax
mov [esi + offset StringBuilder.max], eax
mov [esi + offset StringBuilder.data], eax
ret

// IN: esi -> StringBuilder, edi -> data, ecx = len
// OUT: al = erc (0: ok, 1: not enough memory)
// KEEP: esi
sb_add:
mov edx, [esi + offset StringBuilder.max]
mov eax, [esi + offset StringBuilder.len]
add eax, ecx
cmp eax, edx
jna l_sb_add2
  // len + ecx > max
  cmp edx, 16
  jnb l_sb_add11
    mov edx, 16
    
  l_sb_add11:
  cmp eax, edx
  jna l_sb_add14
    shl edx, 1
    cmp edx, 0
    jnz l_sb_add11
      
      l_sb_add13:
      
      mov al, 1
      
      ret
    
  l_sb_add14:
  // allocate a new block
  push esi
   push edi
    push ecx
     push edx
      mov ecx, edx
      call malloc
      // OUT: ebx
     pop edx
    pop ecx
   pop edi
  pop esi
  or al, al
  jnz l_sb_add13
  
  // copy old data to the new block
  mov [esi + offset StringBuilder.max], edx
  push esi
   push edi
    push ecx
     push ebx
       mov ecx, [esi + offset StringBuilder.len]
       mov esi, [esi + offset StringBuilder.data]
       mov edi, ebx
       mov ebx, esi
       cld
       rep movsb
       
       // free the old block
       or ebx, ebx
       jz l_sb_add18
         call free
         
       l_sb_add18:
     pop ebx 
    pop ecx
   pop edi
  pop esi
  mov [esi + offset StringBuilder.data], ebx

l_sb_add2:
// copy data
mov ebx, edi
mov edi, [esi + offset StringBuilder.data]
add edi, [esi + offset StringBuilder.len]
add [esi + offset StringBuilder.len], ecx

push esi
  mov esi, ebx
  cld
  rep movsb
pop esi

mov al, 0

ret

// IN: esi -> StringBuilder
// KEEP: esi
sb_done:
mov ebx, [esi + offset StringBuilder.data]
or ebx, ebx
jz sb_done_2
  
  push esi
  
    call free
  
  pop esi
  
sb_done_2:
xor eax, eax
mov [esi + offset StringBuilder.len], eax
mov [esi + offset StringBuilder.max], eax
mov [esi + offset StringBuilder.data], eax
ret

vkeys:    db 0,27,"1234567890\xBD\xBB",8,9,"QWERTYUIOP\xDB\xDD",13
          db 17,"ASDFGHJKL\xBA\xDE\xDC",
          db 16,"\xE2","ZXCVBNM\xBC\xBE\xBF",16,106,18," "

movekeys: db 36, 38, 33, 109, 37, 12, 39, 107, 35,40,34,45,46
numkeys:  db 103,104,105,109, 100,101,102,107, 97,98,99,96,110
anumkeys: db "789-456+1230."

akeys0:   dw 0,27,"1\02\03\04\05\06\07\08\09\00\0-\0=\0",8
          dw 9,"q\0w\0e\0r\0t\0y\0u\0i\0o\0p\0[\0]\0",13
          dw 0,"a\0s\0d\0f\0g\0h\0j\0k\0l\0;\0'\0`\0"
          dw 0,"\\","z\0x\0c\0v\0b\0n\0m\0,\0.\0/\0",0,"*",0," "

akeys1:   dw 0,27,"!\0@\0#\0$\0%\0^\0&\0*\0(\0)\0_\0+\0",8
          dw 9,"Q\0W\0E\0R\0T\0Y\0U\0I\0O\0P\0{\0}\0",13
          dw 0,"A\0S\0D\0F\0G\0H\0J\0K\0L\0:\0\"\0~\0"
          dw 0,"|","Z\0X\0C\0V\0B\0N\0M\0<\0>\0?\0",0,"*",0," "

akeys2:   dw 0,27,"1\02\03\04\05\06\07\08\09\00\0-\0=\0",8
          dw 9,"Q\0W\0E\0R\0T\0Y\0U\0I\0O\0P\0[\0]\0",13
          dw 0,"A\0S\0D\0F\0G\0H\0J\0K\0L\0;\0'\0`\0"
          dw 0,"\\","Z\0X\0C\0V\0B\0N\0M\0,\0.\0/\0",0,"*",0," "

akeys3:   dw 0,27,"!\0@\0#\0$\0%\0^\0&\0*\0(\0)\0_\0+\0",8
          dw 9,"q\0w\0e\0r\0t\0y\0u\0i\0o\0p\0{\0}\0",13
          dw 0,"a\0s\0d\0f\0g\0h\0j\0k\0l\0:\0\"\0~\0"
          dw 0,"|","z\0x\0c\0v\0b\0n\0m\0<\0>\0?\0",0,"*",0," "

ctrlkeys: dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,127
          dw 0,17,23,5,18,20,25,21,9,15,16,27,29,10
          dw 0,1,19,4,6,7,8,10,11,12,0,0,28
          dw 0,28,26,24,3,22,2,14,13,0,0,0,0,"*",0," "

// IN: eax = escan key, edx = locks
// OUT: eax = VK, ecx = UTF-16 key
keys:
xor ecx, ecx
cmp eax, 135h // "/" on num
jnz l_keys_1
  mov eax, 111
  mov ecx, "/"
  jmp l_keys_9
  
l_keys_1:
test dl, KBD_NUMLK // num lock
jz l_keys_2
  test dl, KBD_RSH | KBD_LSH  // any shift
  jnz l_keys_2

    cmp al, 47h
    jb l_keys_2
      cmp al, 53h
      ja l_keys_2

        cmp ah, 1  // not num
        jz l_keys_2
          // num keys
          movzx ecx, byte ptr [cs:offset anumkeys + COFS + eax - 47h]
          movzx eax, byte ptr [cs:offset numkeys + COFS + eax - 47h]
          jmp l_keys_9

l_keys_2:
and eax, 127

cmp al, 47h
jb l_keys_3
  cmp al, 53h
  ja l_keys_3
    // move keys
    movzx eax, byte ptr [cs:offset movekeys + COFS + eax - 47h]
    cmp al, 109
    jnz l_keys_21
      mov ecx, '-'
      jmp l_keys_9
      
    l_keys_21:
    cmp al, 107
    jnz near l_keys_9
      mov ecx, '+'
      jmp l_keys_9

l_keys_3:
cmp al, 3Ah // Caps lock
jnb l_keys_4
  mov ecx, eax
  shl ecx, 1
  // vkey
  movzx eax, byte ptr [cs:offset vkeys + COFS + eax]
  // UTF-16 key
  test dx, KBD_CTRL
  jz l_keys_31
    movzx ecx, word ptr [cs:offset ctrlkeys + COFS + ecx]
    jmp l_keys_9
    
  l_keys_31:
  test dx, KBD_CPSLK
  jnz l_keys_34
    test dx, KBD_RSH | KBD_LSH
    jnz l_keys_32
      movzx ecx, word ptr [cs:offset akeys0 + COFS + ecx]
      jmp short l_keys_9
      
    l_keys_32:
    movzx ecx, word ptr [cs:offset akeys1 + COFS + ecx]
    jmp short l_keys_9
    
  l_keys_34:
  test dx, KBD_RSH | KBD_LSH
  jnz l_keys_36
    movzx ecx, word ptr [cs:offset akeys2 + COFS + ecx]
    jmp short l_keys_9
    
  l_keys_36:
  movzx ecx, word ptr [cs:offset akeys3 + COFS + ecx]
  jmp short l_keys_9

l_keys_4:
jnz l_keys_5
  // Caps lock
  mov eax, 20
  jmp short l_keys_9
  
l_keys_5:
cmp al, 3Bh  // F1
jb l_keys_52
  cmp al, 44h  // F10
  ja l_keys_52
    add eax, 112 - 3Bh
    jmp short l_keys_9

l_keys_52:
cmp al, 57h  // F11
jnz l_keys_53
  mov eax, 122
  jmp short l_keys_9
  
l_keys_53:
cmp al, 58h  // F12
jnz l_keys_54
  mov eax, 123
  jmp short l_keys_9

l_keys_54:
cmp al, 45h
jnz l_keys_9
  test dx, KBD_VCTRL
  jnz l_keys_6
    // num lock
    mov eax, 144
    jmp short l_keys_9
  
  l_keys_6:
  // break
  mov eax, 19
  
l_keys_9:
ret

/*
8 BACKSPACE
9 TAB
12 *5
13 ENTER
16 SHIFT
17 CTRL
19 BREAK
20 CAPS
27 ESC

33 PGUP
34 PGDN
35 END
36 HOME
37 <-
38 A
39 ->
40 V
45 INS
46 DEL

91 LWIN
92 RWIN
93 MENU

96 0
97 1
98 2
99 3
100 4
101 5
102 6
103 7
104 8
105 9
106 *
107 +
109 -
110 .
111 /

112 F1
113 F2
114 F3
115 F4
116 F5
117 F6
118 F7
119 F8
120 F9
121 F10
122 F11
123 F12

144 NUM

KBD_RSH  = 1
KBD_LSH  = 2
KBD_CTRL = 4
KBD_ALT  = 8
KBD_SCRLK = 0x10
KBD_NUMLK = 0x20
KBD_CPSLK = 0x40
KBD_INS   = 0x80
KBD_RCTRL = 0x400
KBD_RALT  = 0x800
KBD_VCTRL = 0x1000
*/

// IN: esi -> stringz
// OUT: ecx
// KEEP: ebx, esi, edi
strlen:
push esi
  xor ecx, ecx
  
  l_strlen_1:
    lodsb
    cmp al, 0
    jz l_strlen_9
      inc ecx
      jmp short l_strlen_1
  
  l_strlen_9:
pop esi
ret

wregs1: db "\n | acdb = "
wregs2: db " | sbsd = "

wregs:
pushad
  mov ebp, esp
  
  mov esi, offset wregs1 + COFS
  mov ecx, 10
  mov bl, 7
  call write
  
  mov eax, [ebp + 28]
  mov ecx, 16
  mov bh, 9
  call writen
  
  mov eax, [ebp + 24]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 20]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 16]
  mov ecx, 16
  call writen
  
  
  mov esi, offset wregs2 + COFS
  mov ecx, 9
  mov bl, 7
  call write
  
  mov eax, [ebp + 12]
  mov ecx, 16
  mov bh, 9
  call writen
  
  mov eax, [ebp + 8]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 4]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 0]
  mov ecx, 16
  call writen

popad
ret

ww:
call wregs
call waitkey
ret

fullclname: db "fullclass\0"

fullscr:
// register
mov wcl.cbSize, sizeof WndClassRec
mov wcl.style, WS_OVERLAPPEDWINDOW
mov wcl.lpfnWndProc, offset wndprocfull + COFS
mov wcl.cbClsExtra, 0
mov wcl.cbWndExtra, 0
mov wcl.hInstance, 0x400000
mov wcl.hIcon, 0
mov wcl.hCursor, 0
mov wcl.hbrBackground, 0xFF808080
mov wcl.lpszMenuName, 0
mov wcl.lpszClassName, offset fullclname + COFS
mov wcl.hIconSm, 0

push offset wcl
call dword ptr [iregister + COFS]

// create
push 0 // lpCreateParams
push 0x400000 // hInstance
push 0 // hMenu
push 0 // hwndParent
push -1 // h
push -1 // w
push -1 // y
push -1 // x
push WS_OVERLAPPEDWINDOW | WS_VISIBLE | WINFLAGS_FULLSCREEN // style
push 0 // lpszName
push offset fullclname + COFS // lpszClass
push 0 // dwExStyle
call dword ptr [icreatewin + COFS]
//mov fullwin, eax
ret


wndprocfull:
push ebp
mov ebp, esp
  
  //sub esp, sizeof PaintStruct + 4 + (4 * 4) + sizeof RectRec + (2 * 4)
  
  mov edi, [ss:ebp + 8]  // hwnd
  mov ecx, [ss:ebp + 12] // wm
  mov edx, [ss:ebp + 16] // wp
  mov esi, [ss:ebp + 20] // lp
  
  //...
  
  // call defwndproc
  push dword ptr [ss:ebp + 20]
  push dword ptr [ss:ebp + 16]
  push dword ptr [ss:ebp + 12]
  push dword ptr [ss:ebp + 8]
  call dword ptr [idefwndproc + COFS]
  
mov esp, ebp
pop ebp
ret 10h

wndprocmain:
push ebp
mov ebp, esp
  
  sub esp, sizeof PaintStruct + 4 + (4 * 4) + sizeof RectRec + (2 * 4)
  
  mov edi, [ss:ebp + 8]  // hwnd
  mov ecx, [ss:ebp + 12] // wm
  mov edx, [ss:ebp + 16] // wp
  mov esi, [ss:ebp + 20] // lp
  
  cmp ecx, WM_PAINT
  jnz near __18
    // * paint *
    // getwin
    push edi
      mov dl, [edi + offset WindowExRec.winid]
      mov edi, offset win1
      call getwin
    pop edi
    
    // beginpaint
    mov eax, ebp
    sub eax, sizeof PaintStruct
    push eax
    push edi
    call dword ptr [ibeginpaint + COFS]
    mov [ebp - sizeof PaintStruct - 4], eax  // hdc
    
    // bar
    push 32767  // bottom
    push 32767  // right
    push 0  // top
    push 0  // left
    push 0  // color
    push dword ptr [ebp - sizeof PaintStruct - 4]
    call dword ptr [ibar + COFS]
    
    // create pen, brush, rgn
    push 0x808000
    push 10
    push 1
    call dword ptr [icreatepen + COFS]
    mov [ebp - sizeof PaintStruct - 8], eax  // pen
    
    push 0xFFFF00
    call dword ptr [icreatesolidbrush + COFS]
    mov [ebp - sizeof PaintStruct - 12], eax  // brush
    
    /*
    push 200
    push 200
    push 30
    push 30
    call dword ptr [icreaterectrgn + COFS]
    mov [ebp - sizeof PaintStruct - 4 - (4 * 4) - sizeof RectRec - 4], eax  // rgn
    */
    
    // selectobject pen, brush, rgn
    push dword ptr [ebp - sizeof PaintStruct - 8]
    push dword ptr [ebp - sizeof PaintStruct - 4]
    call dword ptr [iselectobject + COFS]
    mov [ebp - sizeof PaintStruct - 16], eax  // oldpen
    
    push dword ptr [ebp - sizeof PaintStruct - 12]
    push dword ptr [ebp - sizeof PaintStruct - 4]
    call dword ptr [iselectobject + COFS]
    mov [ebp - sizeof PaintStruct - 20], eax  // oldbrush
    
    /*
    push dword ptr [ebp - sizeof PaintStruct - 4 - (4 * 4) - sizeof RectRec - 4]
    push dword ptr [ebp - sizeof PaintStruct - 4]
    call dword ptr [iselectobject + COFS]
    mov [ebp - sizeof PaintStruct - 4 - (4 * 4) - sizeof RectRec - 8], eax  // oldrgn
    */
    
    // getclientrect
    mov eax, ebp
    sub eax, sizeof PaintStruct + 4 + (4 * 4) + sizeof RectRec
    push eax  // lprect
    push dword ptr [ebp + 8]  // hwnd
    call dword ptr [igetclientrect + COFS]
    
    // rectangle
    mov eax, [ebp - sizeof PaintStruct - 4 - (4 * 4) - sizeof RectRec + offset RectRec.bottom]
    sub eax, 20
    push eax  // bottom
    mov eax, [ebp - sizeof PaintStruct - 4 - (4 * 4) - sizeof RectRec + offset RectRec.right]
    sub eax, 20
    push eax  // right
    push 20  // top
    push 20  // left
    push dword ptr [ebp - sizeof PaintStruct - 4]  // hdc
    call dword ptr [irectangle + COFS]
    
    //...
    
    // select old/delete pen, brush, rgn
    push dword ptr [ebp - sizeof PaintStruct - 16]
    push dword ptr [ebp - sizeof PaintStruct - 4]
    call dword ptr [iselectobject + COFS]
    
    push dword ptr [ebp - sizeof PaintStruct - 8]
    call dword ptr [ideleteobject + COFS]
    
    push dword ptr [ebp - sizeof PaintStruct - 20]
    push dword ptr [ebp - sizeof PaintStruct - 4]
    call dword ptr [iselectobject + COFS]
    
    push dword ptr [ebp - sizeof PaintStruct - 12]
    call dword ptr [ideleteobject + COFS]
    
    /*
    push dword ptr [ebp - sizeof PaintStruct - 4 - (4 * 4) - sizeof RectRec - 8]
    push dword ptr [ebp - sizeof PaintStruct - 4]
    call dword ptr [iselectobject + COFS]
    
    push dword ptr [ebp - sizeof PaintStruct - 4 - (4 * 4) - sizeof RectRec - 4]
    call dword ptr [ideleteobject + COFS]
    */
    
    // rectangle2
    push 400  // bottom
    push 400  // right
    push 220  // top
    push 220  // left
    push dword ptr [ebp - sizeof PaintStruct - 4]  // hdc
    call dword ptr [irectangle + COFS]
    
    // bitblt
    push SRCCOPY
    push 200 // y1
    push 200 // x1
    push dword ptr [ebp - sizeof PaintStruct - 4]  // hdc
    push 40 // h
    push 60 // w
    push 10 // y
    push 20 // x
    push dword ptr [ebp - sizeof PaintStruct - 4]  // hdc
    call dword ptr [ibitblt + COFS]
    
    //...
    
    // endpaint
    mov eax, ebp
    sub eax, sizeof PaintStruct
    push eax
    push dword ptr [ebp + 8]  // hwnd
    call dword ptr [iendpaint + COFS]
    
    jmp __9
    
  __18:
  cmp ecx, WM_CLOSE
  jnz __28
    push 0 
    call dword ptr [ipostquit + COFS]
    jmp __9
    
  __28:
  
  //...
  
  // call defwndproc
  push dword ptr [ss:ebp + 20]
  push dword ptr [ss:ebp + 16]
  push dword ptr [ss:ebp + 12]
  push dword ptr [ss:ebp + 8]
  call dword ptr [idefwndproc + COFS]
  
  __9:  
mov esp, ebp
pop ebp
ret 10h

mainclname: db "mainclass\0"

createmain:
// register
mov wcl.cbSize, sizeof WndClassRec
mov wcl.style, WS_OVERLAPPEDWINDOW
mov wcl.lpfnWndProc, offset wndprocmain + COFS
mov wcl.cbClsExtra, 0
mov wcl.cbWndExtra, 0
mov wcl.hInstance, 0x400000
mov wcl.hIcon, 0
mov wcl.hCursor, 0
mov wcl.hbrBackground, 0xFF808080
mov wcl.lpszMenuName, 0
mov wcl.lpszClassName, offset mainclname + COFS
mov wcl.hIconSm, 0

push offset wcl
call dword ptr [iregister + COFS]

// create
push 0 // lpCreateParams
push 0x400000 // hInstance
push 0 // hMenu
push 0 // hwndParent
push 300 // h
push 400 // w
push -1 // y
push -1 // x
push WS_OVERLAPPEDWINDOW | WS_VISIBLE // style
push 0 // lpszName
push offset mainclname + COFS // lpszClass
push 0 // dwExStyle
call dword ptr [icreatewin + COFS]
mov mainwin, eax

// create sub
push 0 // lpCreateParams
push 0x400000 // hInstance
push 0 // hMenu
push mainwin // hwndParent
push 200 // h
push 600 // w
push -1 // y
push -1 // x
push WS_OVERLAPPEDWINDOW | WS_VISIBLE // style
push 0 // lpszName
push offset mainclname + COFS // lpszClass
push 0 // dwExStyle
call dword ptr [icreatewin + COFS]
mov subwin, eax

ret

int4 i

main:
/*
//$$$
mov eax, i
mov ecx, 10
mov bl, 0Eh
call writen
inc i
jmp main
*/

call fullscr
call createmain

l_main_5:
// GetMessageA
push 0
push 0
push 0
push offset msg
call dword ptr [igetmsg + COFS]
test al, al
jz near l_main_9

mov eax, msg.hwnd
test eax, eax
jz l_main_50
  // DispatchMessageA
  push offset msg
  call dword ptr [idispatchmsg + COFS]
  jmp l_main_5
  
l_main_50:
// no hwnd
jmp l_main_5

l_main_9:
call exit
//ret

lastoffset:

