// KERNEL.ASM 2.0 generated by Dingo Source Manager 3.6
// Licence: GPL

[org 0]
[bits 32]

MAX_PATH = 260

// Error Codes
ERC_HARDWARE            = 2
ERC_OUT_OF_RANGE        = 5
ERC_DISK_CHANGED        = 6
ERC_NOT_FLUSHED         = 7
ERC_DISK_IO             = 8
ERC_INVALID_DISK_NUMBER = 10h
ERC_NOT_FOUND_IN_CACHE  = 12h  // internal
ERC_UNKNOWN_GEOMETRY    = 15h
ERC_DISK_FULL           = 16h

ERC_INVALID_CHANNEL_NUMBER = 18h
ERC_INVALID_MEMORY_ADDRESS = 19h
ERC_INVALID_COUNT          = 1Ah

ERC_NOT_ENOUGH_MEMORY = 21h
ERC_ALIGN             = 24h
ERC_ALREADY_FREE      = 25h
ERC_OVERFLOW          = 26h
ERC_UNDERFLOW         = 27h

ERC_MSG_QUEUE_EMPTY    = 30h
ERC_MSG_QUEUE_FULL     = 31h
ERC_MSG_INVALID_TARGET = 32h

ERC_TOO_MANY_WINDOWS = 33h
ERC_INVALID_WINDOW   = 34h
ERC_CANT_MOVESIZE    = 35h
ERC_UNKNOWN_CLASS    = 36h

ERC_TOO_MANY_PROCS   = 40h
ERC_TOO_MANY_THREADS = 41h

ERC_TIMER_FULL      = 42
ERC_TIMER_NOT_FOUND = 43

ERC_PATH_NOT_FOUND = 44h
ERC_FILE_NOT_FOUND = 45h
ERC_TOO_MANY_OPEN_FILES = 46h
ERC_DIR_ALREADY_EXISTS = 47h
ERC_UNKNOWN_FILESYSTEM = 48h
ERC_DIR_NOT_EMPTY = 49h
ERC_CANT_REMOVE = 4Ah
ERC_DUPLICATE_NAME = 4Bh
ERC_INVALID_FHANDLE = 4Ch
ERC_INVALID_THREAD = 4Dh
ERC_FS = 4Eh
ERC_READ_ONLY = 4Fh
ERC_IN_USE = 50h
ERC_OUT_OF_DISK = 51h
ERC_TOO_MANY_SEARCHES = 52h
ERC_INVALID_SHANDLE = 53h
ERC_CANT_RENAME = 54h

ERC_INVALID_PID = 55h
ERC_STACK_OVERFLOW = 56h
ERC_PE_INVALID_HEADER = 57h
ERC_INVALID_SERVICE = 58h

ERC_TOO_LONG = 59h
ERC_ONLY_STARTER = 5Ah
ERC_INVALID_MEMORY_LOCATION = 5Bh
ERC_INVALID_THREADID = 5Ch
ERC_ACCESS_DENIED = 5Dh
ERC_INVALID_PRIORITY = 5Eh
ERC_INVALID_ATRBS = 5Fh
ERC_INVALID_VALUE = 60h
ERC_INVALID_POINTER = 61h
ERC_INVALID_CHAR = 62h
ERC_DISK_REMOVED = 63h
ERC_TOO_BIG_HOLE = 64h  // internal
ERC_UTF8 = 65h
ERC_BUSY = 66h
ERC_DIR_TOO_BIG = 67h
ERC_LINK = 68h  // internal
ERC_NOT_A_LINK = 69h
ERC_INFINITE_LINK = 70h
ERC_CANT_MOVE = 71h
ERC_FILE_TOO_BIG = 72h
ERC_NOT_FIT_IN_MFT = 73h
ERC_INVALID_LINK = 74h

ERC_PE_IMPORT_DEPTH_OVERFLOW = 75h
ERC_PE_INVALID_ADR = 76h
ERC_PE_NOT_FOUND = 77h
ERC_PE_ORDINAL = 78h

ERC_INVALID_IMAGE = 79h

ERC_NOT_IMPLEMENTED     = 0FFh

// Window = 32 B (winid)
struct WinRec{
  int2 x, y, w, h
  uns4 flags, cr3, hwnd, pbitmap, pid
  uns1 kbd, parent
  uns1 ncheight, desktop
}

// Window Ex (hwnd)
struct WindowExRec{
  uns4 next, prev, first_child, pmenu, ptext, pclass, menusx
  int2 x, y, w, h
  uns4 winid, pid, hinstance
  uns4 exstyle, style, id, parent, wndproc
}

struct WndClassRec{
  int4 cbSize
  uns4 style
  ptr4 lpfnWndProc
  int4 cbClsExtra
  int4 cbWndExtra
  uns4 hInstance
  ptr4 hIcon
  ptr4 hCursor
  uns4 hbrBackground
  ptr4 lpszMenuName
  ptr4 lpszClassName
  ptr4 hIconSm
  ptr4 next // only tryskos
}

struct PointRec{
  int4 x, y
}

struct MessageRec{
  ptr4 hwnd
  uns4 message
  uns4 wParam
  uns4 lParam
  uns4 time
  PointRec pt
}

struct DCRec{
  int2 x0, y0, x1, y1, x2, y2, x, y
  ptr4 pbitmap, pen, brush, rgn, font, lppaintstruct
  uns4 textcolor
}

struct RectRec{
  int4 left, top, right, bottom
}

GDIOBJ_PEN = 1
GDIOBJ_BRUSH = 2
GDIOBJ_RGN = 3
GDIOBJ_FONT = 4

struct PenRec{
  uns4 type, color, size
}

struct BrushRec{
  uns4 type, flags, color1, color2, pbrushfn
  int2 x1, y1, x2, y2
}

struct RgnRec{
  uns4 type, flags
  int2 left, top, right, bottom
}

struct FontRec{
  uns4 type, rotation, pfont
  bool bold, italics, underline, strike
  char name[64]
}

struct PaintStruct {
	ptr4 hdc; // 0
	uns4 fErase; // 4
	RectRec rcPaint; // 8
	uns4 fRestore; // 24
	uns4 fIncUpdate; // 28
	uns1 rgbReserved[32]; // 32
}

// BitBlt
BLACKNESS = 0x42
NOTSRCERASE = 0x1100A6
NOTSRCCOPY = 0x330008
SRCERASE = 0x440328
DSTINVERT = 0x550009
PATINVERT = 0x5A0049
SRCINVERT = 0x660046
SRCAND = 0x8800C6
MERGEPAINT = 0xBB0226
MERGECOPY = 0xC000CA
SRCCOPY = 0xCC0020
SRCMERGE = 0xDD0022
SRCPAINT = 0xEE0086
WHITENESS = 0xFF0062

// GetStockObject
BLACK_BRUSH = 4
DKGRAY_BRUSH = 3
GRAY_BRUSH = 2
HOLLOW_BRUSH = 5
LTGRAY_BRUSH = 1
NULL_BRUSH = 5
WHITE_BRUSH = 0
BLACK_PEN = 7
NULL_PEN = 8
WHITE_PEN = 6
ANSI_FIXED_FONT = 11
ANSI_VAR_FONT = 12
DEVICE_DEFAULT_FONT = 14
DEFAULT_GUI_FONT = 17
OEM_FIXED_FONT = 10
SYSTEM_FONT = 13
SYSTEM_FIXED_FONT = 16
DEFAULT_PALETTE = 15

struct DateTime8{
  uns8 datetime
}

struct SearchRec{
  uns4 FileAttributes
  DateTime8 CreationTime
  DateTime8 LastAccessTime
  DateTime8 LastWriteTime
  uns8 FileSize
  uns8 Reserved
  char FileName[MAX_PATH]
  char AlternateFileName[14]
}

struct SystemTime{
  uns2 wYear
  uns2 wMonth
  uns2 wDayOfWeek
  uns2 wDay
  uns2 wHour
  uns2 wMinute
  uns2 wSecond
  uns2 wMilliseconds
}

MAX_WIN = 255
WIN_NONE = 255
WIN_MAINPANELH = 0
WIN_HEADER = 16
WIN_BORDER = 6
WIN_CORNER = 16
WIN_MINW = 64 + (WIN_BORDER * 2)
WIN_MINH = WIN_HEADER + (WIN_BORDER * 2)
WIN_MENUH = 16

WIN_DEFAULT_X_STEP = 32
WIN_DEFAULT_Y_STEP = 32
WIN_DEFAULT_X_MAX = 250
WIN_DEFAULT_Y_MAX = 250
WIN_BORDERCOLOR = 0xFF0080FF
WIN_HEADERCOLOR = 0xFF0080FF
WIN_FRAMECOLOR = 0xFF000000
WIN_ACTIVEFRAMECOLOR = 0xFFFFFF00
WIN_CLOSECOLOR = 0xFFE04040
WIN_MAXIMIZECOLOR = 0xFFA0A0A0
WIN_LIGHT = 0xFFFFFFFF
WIN_DARK = 0xFF606060

WINFLAGS_VALID = 1
WINFLAGS_FULLSCREEN = 2
WINFLAGS_ALWAYSONTOP = 8
WINFLAGS_CLOSEPRESSED    = 0x10
WINFLAGS_MAXIMIZEPRESSED = 0x20
WINFLAGS_MINIMIZEPRESSED = 0x40

// wp of mousemove
MK_LBUTTON  = 0x0001
MK_RBUTTON  = 0x0002
MK_SHIFT    = 0x0004
MK_CONTROL  = 0x0008
MK_MBUTTON  = 0x0010
MK_XBUTTON1 = 0x0020
MK_XBUTTON2 = 0x0040

WS_TABSTOP     = 0x00010000
WS_MAXIMIZEBOX = 0x00010000
WS_GROUP       = 0x00020000
WS_MINIMIZEBOX = 0x00020000
WS_SIZEBOX     = 0x00040000
WS_SYSMENU     = 0x00080000
WS_HSCROLL     = 0x00100000
WS_VSCROLL     = 0x00200000
WS_DLGFRAME    = 0x00400000
WS_BORDER      = 0x00800000
WS_CAPTION     = 0x00C00000
WS_MAXIMIZE    = 0x01000000
WS_DISABLED    = 0x08000000
WS_VISIBLE     = 0x10000000
WS_MINIMIZE    = 0x20000000
WS_CHILD       = 0x40000000
WS_POPUP       = 0x80000000
WS_OVERLAPPEDWINDOW = WS_CAPTION | WS_SYSMENU | WS_SIZEBOX | WS_MINIMIZEBOX | WS_MAXIMIZEBOX
WS_POPUPWINDOW = WS_POPUP | WS_BORDER | WS_SYSMENU

CW_USEDEFAULT = -1

SWP_NOSIZE = 1
SWP_NOMOVE = 2
SWP_NOZORDER = 4
SWP_NOREDRAW = 8
SWP_NOACTIVATE = 0x10
SWP_DRAWFRAME = 0x20
SWP_FRAMECHANGED = 0x20
SWP_SHOWWINDOW = 0x40
SWP_HIDEWINDOW = 0x80
SWP_NOCOPYBITS = 0x100
SWP_NOOWNERZORDER = 0x200
SWP_NOREPOSITION = 0x200
SWP_NOSENDCHANGING = 0x400
SWP_RELSIZE = 0x1000
SWP_RELMOVE = 0x2000

SW_HIDE = 0
SW_NORMAL = 1
SW_MAXIMIZE = 3
SW_SHOW = 5
SW_MINIMIZE = 6
SW_RESTORE = 9

RDW_INVALIDATE = 1
RDW_INTERNALPAINT = 2
RDW_ERASE = 4
RDW_VALIDATE = 8
RDW_NOINTERNALPAINT = 16
RDW_NOERASE = 32
RDW_NOCHILDREN = 64
RDW_ALLCHILDREN = 128
RDW_UPDATENOW = 256
RDW_ERASENOW = 512
RDW_FRAME = 1024
RDW_NOFRAME = 2048

WM_NULL = 0
WM_CREATE = 1
WM_DESTROY = 2
WM_MOVE = 3
WM_SIZE = 5
WM_ACTIVATE = 6
WM_SETFOCUS = 7
WM_KILLFOCUS = 8
WM_ENABLE = 10
WM_SETREDRAW = 11
WM_SETTEXT = 12
WM_GETTEXT = 13
WM_GETTEXTLENGTH = 14
WM_PAINT = 15
WM_CLOSE = 16
WM_QUERYENDSESSION = 17
WM_QUIT = 18
WM_QUERYOPEN = 19
WM_ERASEBKGND = 20
WM_SYSCOLORCHANGE = 21
WM_ENDSESSION = 22
WM_SHOWWINDOW = 24
WM_WINDOWPOSCHANGED = 47h
WM_NCPAINT = 85h
WM_NCMOUSEMOVE = 0A0h
WM_NCLBUTTONDOWN = 0A1h
WM_NCLBUTTONUP = 0A2h
WM_NCLBUTTONDBLCLK = 0A3h
WM_NCRBUTTONDOWN = 0A4h
WM_NCRBUTTONUP = 0A5h
WM_NCRBUTTONDBLCLK = 0A6h
WM_NCMBUTTONDOWN = 0A7h
WM_NCMBUTTONUP = 0A8h
WM_NCMBUTTONDBLCLK = 0A9h
WM_NCXBUTTONDOWN = 0ABh
WM_NCXBUTTONUP = 0ACh
WM_NCXBUTTONDBLCLK = 0ADh
WM_KEYDOWN    = 100h
WM_KEYUP      = 101h
WM_CHAR       = 102h
WM_SYSKEYDOWN = 104h
WM_SYSKEYUP   = 105h
WM_COMMAND = 111h
WM_TIMER   = 113h
WM_TERMINATED   = 180h
WM_NEW_CLIP     = 181h
WM_WINDOWCLOSED = 182h
WM_SCROLL       = 183h
WM_MOUSEBUTTON  = 184h
WM_MAINPANELHCHANGED = 185h
WM_NCMOUSEOVER  = 186h
WM_CHARIO       = 187h
WM_PAINTBUTTONS = 188h
WM_MOUSEOVER    = 189h
WM_DISKCHANGED  = 18Ah
WM_USB_INT = 1A0h
WM_MOUSEMOVE = 200h
WM_LBUTTONDOWN = 201h
WM_LBUTTONUP = 202h
WM_LBUTTONDBLCLK = 203h
WM_RBUTTONDOWN = 204h
WM_RBUTTONUP = 205h
WM_RBUTTONDBLCLK = 206h
WM_MBUTTONDOWN = 207h
WM_MBUTTONUP = 208h
WM_MBUTTONDBLCLK = 209h
WM_MOUSEWHEEL = 20Ah
WM_XBUTTONDOWN = 20Bh
WM_XBUTTONUP = 20Ch
WM_XBUTTONDBLCLK = 20Dh
WM_MOUSEHWHEEL = 20Eh
WM_DEVICECHANGE = 219h

// Shared Symbolic Constants -->

BPB_FLOPPYSIZE = 13h
BPB_SECS       = 18h
BPB_SFS        = 1Ah
BPB_SETUPSECS  = 40h
BPB_KERNELSECS = 44h
BPB_BOOTDISK   = 48h

// Setup Memory Model
SIZE_BOOTSECT = 512

PA_BOOT         = 7C00h
PA_BOOTSECTCOPY = 600h

PA_SETUP_CODE   = 80000h
PA_SETUP_DATA   = 88000h
PA_SETUP_STACK  = 88000h

SIZE_SETUP_STACK = 8000h - 16

// Kernel Memory Model (physical memory - PA)
PA_IDT         =   800h // size 2 KiB (800h)
PA_PD0         =  1000h // size 4 KiB (1000h)
PA_KERNEL_DATA =  2000h // size 0E000h
PA_GDT         = 10000h // size 32 KiB (8000h)
PA_PT_PROCS    = 18000h // size 4 KiB (1000h)
PA_PT_THREADS  = 19000h // size 4 KiB (1000h)
PA_PT_SD       = 1A000h // size 4 KiB (1000h)
PA_PT_VAR      = 1E000h // size 4 KiB (1000h)
PA_PT_SYS      = 1F000h // size 4 KiB (1000h)
PA_KERNEL_CODE = 20000h // size 256 KiB (40000h)
PA_TMR         = 60000h // size 16 KiB (4000h)
PA_DMA_BUFFERS = 70000h // size 20000h

SIZE_KERNEL_DATA = PA_GDT - PA_KERNEL_DATA
SIZE_GDT         = PA_PT_PROCS - PA_GDT
SIZE_TMR         = 4000h

// Selectors (must match KERNEL_GDT)
SELECTOR_SETUP_CODE  =  8
SELECTOR_KERNEL_CODE = 10h
SELECTOR_KERNEL_DATA = 18h
SELECTOR_USER_CODE   = 20h
SELECTOR_USER_DATA   = 28h
SELECTOR_ALL_CODE    = 30h
SELECTOR_ALL_DATA    = 38h
SELECTOR_VIDEO       = 40h
SELECTOR_TEXTVIDEO   = 48h
SELECTOR_TSS         = 50h
SELECTOR_LDT         = 58h

// Paging
VA_GLOBAL      = 0xC0000000
VA_ACCESS      = 0xD0000000
VA_RAMDISK     = 0xD0000000
VA_GRAPHICS    = 0xE0000000
VA_SYSTEM      = 0xF0000000
VA_PROCS       = 0xF8000000
VA_THREADS     = 0xF9000000
VA_VAR         = 0xFA000000
VA_SD          = 0xFB000000
VA_TIBS        = 0xFC000000
VA_USB         = 0xFD000000
VA_USB_MMIO    = 0xFD100000
VA_KERNEL_HEAP = 0xFE000000

PG_MASK_P   = 1
PG_MASK_W   = 2
PG_MASK_U   = 4
PG_MASK_PWT = 8
PG_MASK_PCD = 16
PG_MASK_A   = 32
PG_MASK_D   = 64
PG_MASK_PS  = 128
PG_MASK_G   = 256

// Initialization constants
KERNEL_IDT_OFS  = 0
KERNEL_IDT_SIZE = 40h * 8
KERNEL_GDT_OFS  = KERNEL_IDT_OFS + KERNEL_IDT_SIZE
KERNEL_GDT_SIZE = 16 * 8

IRQ0INT = 30h
IRQ8INT = 38h

START_SYSTEM_INT = 27h

M_INFO_MAXCOUNT  = 32
M_INFO_ENTRYSIZE = 24

MAX_PROCS   = 512
MAX_THREADS = 1024  // max 1024

// <-- Shared Symbolic Constants


// Shared Structures -->

struct VbeInfoBlock {
   char VbeSignature[4] // == "VESA"
   uns2 VbeVersion      // == 0x0300 for VBE 3.0
   uns4 OemStringPtr    // isa vbeFarPtr
   uns1 Capabilities[4]
   uns4 VideoModePtr    // real mode far ptr to array of words terminated -1
   uns2 TotalMemory     // as # of 64KB blocks
   
   uns2 OemSoftwareRev    // VBE implementation Software revision
   uns4 OemVendorNamePtr  // Pointer to Vendor Name String
   uns4 OemProductNamePtr // Pointer to Product Name String
   uns4 OemProductRevPtr  // Pointer to Product Revision String
   uns1 Reserved[222]     // Reserved for VBE implementation
   uns1 OemData[256]      // Data Area for OEM Strings     
}

struct ModeInfoBlock {
  uns2 attributes
  uns1 winA, winB
  uns2 granularity
  uns2 winsize
  uns2 segmentA, segmentB
  uns4 realFctPtr  // Pointer to window function
  uns2 pitch       // Bytes per scan line
  
  // VBE 1.2
  uns2 xres, yres
  uns1 xchar, ychar, planes, bpp, banks
  uns1 memory_model, bank_size, image_pages
  uns1 reserved0
 
  uns1 red_mask, red_position
  uns1 green_mask, green_position
  uns1 blue_mask, blue_position
  uns1 rsv_mask, rsv_position
  uns1 directcolor_attributes
  
  // VBE 2.0
  uns4 physbase  // LFB (Linear Framebuffer) address
  uns4 OffScreenMemOffset
  uns2 OffScreenMemSize
  
  uns1 reserved[206]
}

// <-- Shared Structures

PL0_STACK_SIZE = 1024
P_MSG_MAX = 32

THREAD_FLAGS_VALID = 1
THREAD_FLAGS_USE_FPU = 4  // first byte!
THREAD_FLAGS_DONT_WAKE_BY_MESSAGE = 8  // first byte!
THREAD_FLAGS_M_BUSY = 10h  // first byte!
THREAD_FLAGS_M_HEAP_BUSY = 20h  // first byte!
THREAD_FLAGS_DISK_BUSY = 40h  // first byte!
THREAD_FLAGS_P_LOAD_BUSY = 80h  // first word!
THREAD_FLAGS_G_BUSY = 100h  // first word!

PROC_FLAGS_VALID = 1
PROC_FLAGS_KILL_WITH_PARENT = 10000h

HEAP_START = 0x80000000
HEAP_END   = 0xC0000000
HEAP_START_GLOBAL = 0xC0000000
HEAP_END_GLOBAL   = 0xC0000000 + (4096 * 1024)
HEAP_START_KERNEL = VA_KERNEL_HEAP
HEAP_END_KERNEL   = VA_KERNEL_HEAP + (4096 * 1024)

FOPEN_READ = 1
FOPEN_WRITE = 3
FOPEN_APPEND = 10h
FOPEN_CREATE = 20h
FOPEN_LINK = 40h  // internal

DISK_MAX = 32

FSID_EXT2 = 82h
FSID_NTFS = 7
FSID_FAT12 = 0F0h
FSID_CD = 30h

MAX_FILES = 128
MAX_SRCH = 64

X_FLAG_VALID = 1
X_FLAG_SYSTEM = 2

STDOUT_WIN  = 0x10000
STDOUT_FILE = 0x20000
STDOUT_MSG  = 0x40000

// MemInfo (24)
struct MemInfoRec{
 uns8 base, size
 uns1 type[8]
}

// HeapRec (16)
struct HeapRec{
  uns4 next, last, size, type
}

// TMR (16)
struct TmrRec{
 uns4 ticks, threadid_wnd, id, ofs
}

// MSG (16)
struct MsgRec{
 uns2 poster, wndid
 uns4 msg, wp, lp
}

// CAH (16)
struct CatchRec{
  uns4 esp, ebp, eip, flags
}

// TSS (104)
struct TssRec{
 uns2 bptr, rsv0
 uns4 esp0
 uns2 ss0, rsv1
 uns4 esp1
 uns2 ss1, rsv2
 uns4 esp2
 uns2 ss2, rsv3
 uns4 cr3
 uns4 eip, eflags
 uns4 eax, ecx, edx, ebx, esp, ebp, esi, edi
 uns2 es, rsv4
 uns2 cs, rsv5
 uns2 ss, rsv6
 uns2 ds, rsv7
 uns2 fs, rsv8
 uns2 gs, rsv9
 uns2 ldt, rsv10
 uns2 TSS_RSV11, portsofs
}

// Process (512)
struct ProcessRec{
  uns4 cr3, mainthread, previnstance, args, env_vars, flags
  uns4 memused  // size of allocated pages
  char filename[512 - (7 * 4)]
}

// Thread (4 KiB)
struct ThreadRec{
 TssRec tss
 uns4 next, last, flags, process

 uns1 fstate[108]
 uns4 uid, gid
 uns4 erc, ero
 uns4 tmr_spent
 uns4 priority
 uns4 stack3_ptr, stack3_aligned
 uns4 new_eip, new_esp
 uns4 curdir, curdirsize
 uns1 curdisk
 char curdirtext[MAX_PATH]
 uns4 stdin, stdout, stderr
 //...
 [dalign 32]
 CatchRec catch
 // messages
 uns4 msgw, msgr, msgusrw, msgusrr
 MsgRec msg[P_MSG_MAX]     // (512)
 MsgRec msgusr[P_MSG_MAX]  // (512)
 // PL0 stack
 uns4 pl0stack[PL0_STACK_SIZE / 4]    // (1024)
}

// Logical disk info
struct DiskInfoRec{
  uns1 type, fsid, number, partition
  uns4 main  // offset of function ?d_main
  uns8 base_sectors, size_sectors, flags
}

// fopen
struct OpenFileRec{
 uns8 size, pos, sectn
 uns1 disk, mode
 uns2 threadid
 uns4 file
}

// Text Window
struct TextWinRec{
  WindowExRec wnd
  uns1 curx, cury, state, rsv1
  uns4 pwintext, curofs, winofs, winsize, winmax, thread
}

// windowposchanged
struct WindowPosRec{
  uns4 hwnd, hwndinsertafter
  int4 x, y, cx, cy
  uns4 flags
}

// Shared Kernel Variables -->

[dorg 2000h] // PA_KERNEL_DATA

// set by the setup

uns2 cur_pos

uns2 boot_disk  // 0x300 = cd

[dalign 32]
uns4 m_RAMSize
uns4 m_info_count
uns1 m_info[M_INFO_MAXCOUNT * M_INFO_ENTRYSIZE]

[dalign 32]
uns4 m_lastbyte, m_bitmap_base, m_bitmap_size, m_first_alloc

ModeInfoBlock g_info
uns2 g_mode

// <-- Shared Kernel Variables

ThreadRec tss
uns4 ldt[2]

// Memory
[dalign 32]
uns4 m_free

// Process
uns4 p_current, p_idle
uns4 p_procs_max_size, p_threads_max_size

// Locks
bool m_busy, m_heap_busy, fs_busy, p_load_busy

// Disks
[dalign 32]
DiskInfoRec disk_info[DISK_MAX]

uns2 hdt_port_base
uns1 hdt_slave_bit, link_depth
bool take_link

// Keyboard
[dalign 32]
uns1 kbd_state[128]

// Timer
[dalign 32]
uns4 tmr_total
uns2 tmr_ms

// Filesystem
[dalign 32]
OpenFileRec files[MAX_FILES]

// Time
int4 time_zone

// Graphics
uns1 g_busy
// desktop block -->
[dalign 32]
uns1 wcount, wdesktop, wactive, wover
uns1 wpos[MAX_WIN], w_rsv2
WinRec win[MAX_WIN]
// <-- desktop block
uns4 g_bg, g_miniature_w, g_miniature_h
int4 g_mainpanelh
int2 default_x, default_y, g_x1, g_y1, g_x2, g_y2
uns1 g_depth, g_topwinid, g_wactivenew

// Mouse
[dalign 32]
uns4 ms_cursor
int1 ms_shift_x, ms_shift_y

// Users
uns1 users_disk

// This table is copied to PA_IDT by the setup.
idt:	// [KERNEL_IDT_OFS] (KERNEL_IDT_SIZE)

// processor interrupts
dw offset isr0,  10h, 8F00h, 0
dw offset isr1,  10h, 8F00h, 0
dw offset isr2,  10h, 8F00h, 0
dw offset isr3,  10h, 8F00h, 0
dw offset isr4,  10h, 8F00h, 0
dw offset isr5,  10h, 8F00h, 0
dw offset isr6,  10h, 8F00h, 0
dw offset isr7,  10h, 8F00h, 0
dw offset isr8,  10h, 8F00h, 0
dw offset isr9,  10h, 8F00h, 0
dw offset isr0A, 10h, 8F00h, 0
dw offset isr0B, 10h, 8F00h, 0
dw offset isr0C, 10h, 8F00h, 0
dw offset isr0D, 10h, 8F00h, 0
dw offset isr0E, 10h, 8F00h, 0
dw offset isr0F, 10h, 8F00h, 0
dw offset isr10, 10h, 8F00h, 0
dw offset isr11, 10h, 8F00h, 0
dw offset isr12, 10h, 8F00h, 0
dw offset isr13, 10h, 8F00h, 0
dw offset isr14, 10h, 8F00h, 0
dw offset isr15, 10h, 8F00h, 0
dw offset isr16, 10h, 8F00h, 0
dw offset isr17, 10h, 8F00h, 0
dw offset isr18, 10h, 8F00h, 0
dw offset isr19, 10h, 8F00h, 0
dw offset isr1A, 10h, 8F00h, 0
dw offset isr1B, 10h, 8F00h, 0
dw offset isr1C, 10h, 8F00h, 0
dw offset isr1D, 10h, 8F00h, 0
dw offset isr1E, 10h, 8F00h, 0
dw offset isr1F, 10h, 8F00h, 0

// OS interrupts
dw offset services,	10h, 0EF00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset start_system,	10h, 8F00h, 0

dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0
dw offset invalid_int,	10h, 8F00h, 0

// IRQ interrupts
dw offset IRQ0, 10h, 8E00h, 0
dw offset IRQ1, 10h, 8E00h, 0
dw offset IRQ2, 10h, 8E00h, 0
dw offset IRQ3, 10h, 8E00h, 0
dw offset IRQ4, 10h, 8E00h, 0
dw offset IRQ5, 10h, 8E00h, 0
dw offset IRQ6, 10h, 8E00h, 0
dw offset IRQ7, 10h, 8E00h, 0

dw offset IRQ8, 10h, 8E00h, 0
dw offset IRQ9, 10h, 8E00h, 0
dw offset IRQ10, 10h, 8E00h, 0
dw offset IRQ11, 10h, 8E00h, 0
dw offset IRQ12, 10h, 8E00h, 0
dw offset IRQ13, 10h, 8E00h, 0
dw offset IRQ14, 10h, 8E00h, 0
dw offset IRQ15, 10h, 8E00h, 0

// This table is copied to PA_GDT by the setup.
gdt:	// [KERNEL_GDT_OFS] (KERNEL_GDT_SIZE)

EXT_GRANULARITY = 80h
EXT_SIZE        = 40h

RIGHTS_CODE = 18h | 80h | 2
RIGHTS_DATA = 10h | 80h | 2
RIGHTS_TSS  =  1  | 80h | 8 //| 60h
RIGHTS_LDT  =  2  | 80h

RIGHTS_CODE_USER = RIGHTS_CODE | 60h
RIGHTS_DATA_USER = RIGHTS_DATA | 60h

EXT_DEFAULT = EXT_GRANULARITY | EXT_SIZE | 0Fh

// dw limit & 0FFFFh, base & 0FFFFh, ((base / 10000h) & 0FFh) | (rights * 100h), extend | ((base / 10000h) & 0FF00h)

// invalid selector
dw 0, 0, 0, 0
// setup code
dw 0FFFFh, PA_SETUP_CODE & 0FFFFh, (PA_SETUP_CODE / 10000h) | (RIGHTS_CODE * 100h), EXT_SIZE

// kernel code, data (base + 0xF0000000 when paging is on)
dw 3Fh, PA_KERNEL_CODE & 0FFFFh, (PA_KERNEL_CODE / 10000h) | (RIGHTS_CODE * 100h), EXT_DEFAULT
dw 0FFFFh, 0, (RIGHTS_DATA * 100h), EXT_DEFAULT

// user code, data
dw 0FFFFh, 0, (RIGHTS_CODE_USER * 100h), EXT_DEFAULT
dw 0FFFFh, 0, (RIGHTS_DATA_USER * 100h), EXT_DEFAULT

// all memory code, data
dw 0FFFFh, 0, (RIGHTS_CODE * 100h), EXT_DEFAULT
dw 0FFFFh, 0, (RIGHTS_DATA * 100h), EXT_DEFAULT

// video, hardware mapped memory
dw 05Fh, 0, 0Ah | (RIGHTS_DATA * 100h), EXT_GRANULARITY | EXT_SIZE
// text video
dw 07FFFh, 8000h, 0Bh | (RIGHTS_DATA * 100h), EXT_SIZE

// TSS
dw sizeof ThreadRec - 1, offset tss & 0FFFFh, (offset tss / 10000h) | (RIGHTS_TSS * 100h), EXT_SIZE

// LDT
dw 7, offset ldt, RIGHTS_LDT * 100h, EXT_SIZE

dw 0, 0, 0, 0
dw 0, 0, 0, 0
dw 0, 0, 0, 0
dw 0, 0, 0, 0

str_fn: db "/system/starter.exe\0"
start_system:

// Cancel mapping 0 -> 0
mov ebx, PA_PD0
xor eax, eax
mov [ebx], eax

// Set selectors
mov dx, SELECTOR_KERNEL_DATA
mov ds, dx
mov ax, SELECTOR_ALL_DATA
mov es, ax

// Init
call irqs_init
call h_dma_init
call m_init
call p_init
call h_pci_init
call h_disks_init  // Must be before g_init
call h_usb_init    // Must be before g_init
call fs_init       // Must be before g_init
call g_init
//call loginit

call h_mouse_init
call h_kbd_init
call h_timer_init

//call test_mouse
//call test_dtm
//call test_msg
//call test_win
//call test_kernel_data
//call test_usb
//call test_post
//call test_args
//call wregs
//call test_graphic
//call test_dll
//call test_nt
//call test_ext2
//call test_sd
//call test_search
//call test_memory
//call main

sti


mov eax, p_current
mov edi, [es:eax + offset ThreadRec.process]
add edi, offset ProcessRec.filename

mov esi, eax
add esi, offset ThreadRec.curdirtext

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset str_fn

push edi
  call fs_merge
pop edx

xor esi, esi
xor edi, edi

call p_new_proc

// System halted

l_start_system_8:
jmp l_start_system_8
//iretd

uns1 irqs[16]

irqs_init:

push es

 push ds
 pop es
 mov edi, offset irqs
 xor eax, eax
 mov ecx, 16
 cld
 rep stosb

pop es

mov al, 0  // enable all irqs 0-7
out 0A1h, al
call delay

mov al, 0  // enable all irqs 8-15
out 21h, al
call delay

//sti      // enable interrupts

ret

ERROR_COLOR = 0Ch

msg_fail: db "\n Error\0"

fault:
fault2: // IN: bl = erc, edx = LA, ecx = errorword
  push ds
   push es
    mov ax, SELECTOR_KERNEL_DATA
    mov ds, ax  // ds = KERNEL_DATA
    mov ax, SELECTOR_ALL_DATA
    mov es, ax  // es = ALL
    
    // release g_busy
    mov edi, p_current
    test word ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_G_BUSY
    jz l_fault2_2
      mov g_busy, 0
      and word ptr [es:edi + offset ThreadRec.flags], -1 - THREAD_FLAGS_G_BUSY
      
    l_fault2_2:
    
    // write erc
    movzx ebx, bl    
    push ecx
     push edx
      push ebx
       mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset msg_fail
       call strlen
       mov bl, ERROR_COLOR
       call s_write
      pop eax
      mov ecx, 16
      mov bl, ERROR_COLOR
      call writen
     pop eax
     mov ecx, 16
     call writen
    pop eax
    mov ecx, 16
    call writen

// wait for key or mouse click
l_fail_after:
call s_chkstarter
jz near fdie
  
  l_fault_5:
  call p_msg_get
  test al, al
  jz l_fault_6
    call p_noop
    jmp l_fault_5
    
  l_fault_6:
  cmp ecx, WM_KEYDOWN
  jz l_fault_7
    cmp ecx, WM_LBUTTONDOWN
    jnz l_fault_5
    
  l_fault_7:
  call s_getpid
  call p_kill_process  

// fdie
fdie: jmp fdie


ignore_int:
iretd

invalid_int:
    pushad
    mov bl, 0FFh
    jmp fault


isr0: pushad
	mov bl, 80h
	jmp fault		// zero divide
isr5: pushad
	mov bl, 85h
	jmp fault		// BOUND
isr6: pushad
	mov bl, 86h
	mov edx, [ss:esp + (8 * 4)]
	mov ecx, esp
	jmp fault		// invalid opcode
isr7: pushad
	mov bl, 87h
	jmp fault		// coprocessor not available
isr10:pushad
	mov bl, 0D0h
	jmp fault

//	fault handlers w/error code (EIP -> on)
isr0A:  pushad
	mov bl, 8Ah
	jmp fault2		// bad TSS
isr0B:  pushad
	mov bl, 8Bh
	jmp fault2		// segment not present
isr0C:  pushad
	mov bl, 8Ch
	jmp fault2		// stack fault	//... brief 17

isr0D:
 pushad
 mov eax, esp
 mov edx, [ss:eax + (8 * 4)] // error code
 mov bl, 8Dh
 jmp fault2		// GPF

//	aborts (EIP = ?)
isr9: pushad
    	mov bl, 89h	// coprocessor segment overrun
	jmp fault

//	aborts w/error code (EIP = ?)
isr8: pushad
	mov bl, 88h		// double fault	//... brief 16
	jmp fault2

//	traps (EIP -> after)
isr1:   pushad
	mov bl, 81h
	jmp fault		// debug (XXX - may be fault or trap)
isr2:   pushad
	mov bl, 82h
	jmp fault		// non-maskable interrupt
isr3:   pushad
	mov bl, 83h
	jmp fault		// INT3
isr4:   pushad
	mov bl, 84h
	jmp fault		// INTO
isr0F:  pushad
	mov bl, 8Fh
	jmp fault		// coprocessor error
isr11:  pushad
	mov bl, 91h
	jmp fault		// alignment check
isr12:  pushad
	mov bl, 92h
	jmp fault
isr13:  pushad
	mov bl, 93h
	jmp fault
isr14:  pushad
	mov bl, 94h
	jmp fault
isr15:  pushad
	mov bl, 95h
	jmp fault
isr16:  pushad
	mov bl, 96h
	jmp fault
isr17:  pushad
	mov bl, 97h
	jmp fault
isr18:  pushad
	mov bl, 98h
	jmp fault
isr19:  pushad
	mov bl, 99h
	jmp fault
isr1A:  pushad
	mov bl, 9Ah
	jmp fault
isr1B:  pushad
	mov bl, 9Bh
	jmp fault
isr1C:  pushad
	mov bl, 9Ch
	jmp fault
isr1D:  pushad
	mov bl, 9Dh
	jmp fault
isr1E:  pushad
	mov bl, 9Eh
	jmp fault
isr1F:  pushad
	mov bl, 9Fh
	jmp fault

// page fault
isr0E:
// error code in stack
pushad
 
 mov ebx, cr2
 
 mov ecx, [ss:esp + (8 * 4)] // error code
 
 push ds
  push es
    
    mov dx, SELECTOR_KERNEL_DATA
    mov ds, dx  // ds = KERNEL_DATA
    mov ax, SELECTOR_ALL_DATA
    mov es, ax  // es = ALL
    
    //$$$
    /*
    mov eax, ecx
    mov ecx, 16
    call writen  // error code
    */
    
    test cl, 1  // PF_P - protection fault
    jnz near l_isr0E_6
    
    cmp ebx, HEAP_END_GLOBAL
    jb l_isr0E_3
      // too high address
      cmp ebx, HEAP_END_KERNEL
      jnb l_isr0E_2
        cmp ebx, HEAP_START_KERNEL
        jb l_isr0E_5
          // kernel heap
          mov edx, PG_MASK_P | PG_MASK_W
          mov ecx, 1
          push ebx
            call m_pages_alloc_edx
          pop ebx
          test al, al
          jnz l_isr0E_4 // not enough memory
            jmp short l_isr0E_9
            
      l_isr0E_2:
      cmp ebx, VA_TIBS
      jb l_isr0E_5
        cmp ebx, VA_TIBS + (MAX_THREADS * 4096)
        jnb l_isr0E_5
          // tibs
          mov ecx, 1
          push ebx
            call m_pages_alloc
          pop ebx
          test al, al
          jnz l_isr0E_4 // not enough memory
            call p_tib_init
            jmp short l_isr0E_9
            
    l_isr0E_3:
    cmp ebx, HEAP_START
    jb l_isr0E_5  // too low address
    
    // local heap or global heap
    and ebx, -1 - 4095
    mov edi, p_current
    cmp ebx, [es:edi + offset ThreadRec.stack3_aligned]
    jz l_isr0E_7  // stack fault
    
    mov ecx, 1
    call m_pages_alloc
    test al, al
    jz l_isr0E_9
      
      l_isr0E_4:
      // alloc error - not enough memory
      mov edx, ebx
      mov bl, al
      jmp fault2
      
      l_isr0E_5:
      // LA error
      mov edx, ebx
      mov bl, ERC_INVALID_MEMORY_LOCATION
      jmp fault2
      
      l_isr0E_6:
      // Protection fault
      mov edx, ebx
      mov bl, 8Eh
      jmp fault2
      
      l_isr0E_7:
      // stack fault
      mov edx, ebx
      mov bl, ERC_STACK_OVERFLOW
      jmp fault2
    
    l_isr0E_9:
    
  pop es
 pop ds

popad
add esp, 4  // error word
iretd

// BEFORE: pushad
IRQall:

 push ds
  push es
    
    movzx ecx, bl
    
    mov dx, SELECTOR_KERNEL_DATA
    mov ds, dx  // ds = KERNEL_DATA
    mov bx, SELECTOR_ALL_DATA
    mov es, bx  // es = ALLMEM
    
    mov al, 20h
    test cl, 8
    jz l_IRQall_6
      out 0A0h, al
      
    l_IRQall_6:
    out 20h, al
    
    //and cl, 15
    //inc irqs[ecx]
    
/*
    //$$$
    mov eax, ecx
    mov ecx, 10
    call writen
*/
  pop es
 pop ds

popad
iretd

IRQ2:
    pushad
    mov bl, 2
    jmp IRQall

IRQ3:
    pushad
    mov bl, 3
    jmp IRQall

IRQ4:
    pushad
    mov bl, 4
    jmp IRQall


IRQ7:
    pushad
    mov bl, 7
    jmp IRQall

IRQ8:
    pushad
    mov bl, 8
    jmp IRQall

IRQ9:
    pushad
    mov bl, 9
    jmp IRQall

IRQ10:
    pushad
    mov bl, 10
    jmp IRQall

IRQ11:
    pushad
    mov bl, 11
    jmp IRQall

IRQ13:
    pushad
    mov bl, 13
    jmp IRQall

[align 32]

services_offsets:

dd offset p_noop // 0
dd offset s_exit // 1
dd offset s_write  // 2
dd offset s_cursorto // 3

dd offset s_p_msg_post // 4
dd offset p_msg_get // 5
dd offset p_msg_usr_post // 6
dd offset p_msg_usr_get // 7

dd offset s_fs_fopen // 8
dd offset s_fs_fclose // 9
dd offset s_fs_fread // 10
dd offset s_fs_fwrite // 11

dd offset s_fs_fsetpos // 12
dd offset s_fs_fcut // 13
dd offset s_fgetpos // 14
dd offset s_fgetsize // 15

dd offset s_cd // 16
dd offset s_md // 17
dd offset s_rm // 18
dd offset s_getcurpos // 19

dd offset s_rename // 20
dd offset s_move // 21
dd offset s_find_first // 22
dd offset fs_find_next // 23

dd offset m_heap_alloc_local // 24
dd offset m_heap_free_local // 25
dd offset m_heap_alloc_global // 26
dd offset m_heap_free_global // 27

dd offset p_create_process // 28
dd offset p_kill_process // 29
dd offset p_create_thread // 30
dd offset p_kill_thread // 31

dd offset p_sleep // 32
dd offset s_getpriority // 33
dd offset s_p_start // 34
dd offset s_p_stop // 35

dd offset s_diskread // 36
dd offset s_diskwrite // 37
dd offset s_disksize // 38
dd offset s_diskflush // 39

dd offset s_hdread // 40
dd offset s_hdwrite // 41
dd offset s_procinfo // 42
dd offset s_setpriority // 43

dd offset s_getprocname // 44
dd offset s_getpid // 45
dd offset s_reloaddisks // 46
dd offset s_identify // 47

dd offset fs_find_close // 48
dd offset s_getkeystate // 49
dd offset s_login // 50
dd offset s_logrp // 51

dd offset s_getcurdir // 52
dd offset s_disktype // 53
dd offset s_getuid // 54
dd offset s_getgid // 55

dd offset s_gettimezone // 56
dd offset s_settimezone // 57
dd offset s_systime2ftime // 58
dd offset s_ftime2systime // 59

dd offset s_getlocal // 60
dd offset s_setlocal // 61
dd offset s_getsystem // 62
dd offset fs_resetdisk // 63

dd offset s_timer_add // 64
dd offset s_timer_rm // 65
dd offset s_link_open // 66
dd offset s_link_rm // 67

dd offset fs_diskfree // 68
dd offset s_posttoall // 69
dd offset s_memfree // 70
dd offset s_create_ramdisk // 71

dd offset p_clip_set // 72
dd offset p_clip_get // 73
dd offset fs_get_mtime // 74
dd offset fs_set_mtime // 75

dd offset fs_chmod // 76
dd offset s_get_boot_disk // 77
dd offset fs_chown // 78
dd offset fs_chgrp // 79

dd offset s_get_user // 80
dd offset s_get_group // 81
dd offset fs_fuidgid // 82
dd offset get_users_disk // 83

dd offset s_get_std // 84
dd offset s_set_std // 85
dd offset g_create_win // 86
dd offset s_g_destroy_win // 87

dd offset g_paint // 88
dd offset s_g_info // 89
dd offset s_argsenv // 90
dd 0  //offset s_reboot // 91

dd offset s_g_setmainpanelh // 92
dd offset g_getwinat // 93
dd offset s_g_activate // 94
dd offset s_g_setover // 95

dd offset s_g_paint_caption // 96
dd offset s_get_mouse_info // 97
dd offset g_getwin // 98
dd offset s_getactiveover // 99

dd offset g_wmove // 100
dd offset g_wsize // 101
dd offset s_save_desktop // 102
dd offset s_load_desktop // 103

dd offset s_postwin // 104
dd offset s_postwinusr // 105
dd offset g_miniature // 106
dd offset g_minall // 107

dd offset s_g_toback // 108
dd offset g_wshow // 109
dd offset s_g_setbuttons // 110
dd offset s_g_setncheight // 111

dd offset s_getkbd // 112
dd offset s_setkbd // 113

//...

services_offsets_end:

// ChkStarter
// OUT: al = 0 || ERC_ONLY_STARTER, jz = ok
// KEEP: ecx, edx, ebx, esi, edi
s_chkstarter:
mov eax, p_current
mov eax, [es:eax + offset ThreadRec.process]
sub eax, VA_PROCS
jz l_s_chkstarter_8
  mov al, ERC_ONLY_STARTER

l_s_chkstarter_8:  
ret

// ChkThread
// IN: edi = pid || (threadid + 16384)
// OUT: al = erc
s_chkthread:
pushfd
cli
mov esi, edi
test edi, 16384
jnz l_s_chkthread_08
  // pid
  shl edi, 9  // assert sizeof ProcessRec = 512
  cmp edi, p_procs_max_size
  jb l_s_chkthread_03
    
    l_s_chkthread_02:
    mov al, ERC_INVALID_PID
    popfd
    ret
    
  l_s_chkthread_03:
  add edi, VA_PROCS
  mov eax, [es:edi + offset ProcessRec.flags]
  test al, PROC_FLAGS_VALID
  jz l_s_chkthread_02
  
  mov edi, [es:edi + offset ProcessRec.mainthread]
  sub edi, VA_THREADS
  shr edi, 12
  
l_s_chkthread_08:
// threadid
and edi, 16383
shl edi, 12  // assert sizeof ThreadRec = 4096
cmp edi, p_threads_max_size
jb l_s_chkthread_3
  
  l_s_chkthread_2:
  mov al, ERC_INVALID_THREADID
  popfd
  ret

l_s_chkthread_3:
add edi, VA_THREADS
test byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_VALID
jz l_s_chkthread_2

mov eax, p_current
mov eax, [es:eax + offset ThreadRec.process]
cmp eax, [es:edi + offset ThreadRec.process]
jz l_s_chkthread_8
  test esi, 16384
  jnz l_s_chkthread_6
    // pid
    mov esi, [es:edi + offset ThreadRec.process]
    mov esi, [es:esi + offset ProcessRec.previnstance]
    cmp eax, esi
    jz l_s_chkthread_8
    
  l_s_chkthread_6:
  mov al, ERC_ACCESS_DENIED
  popfd
  ret

l_s_chkthread_8:
mov al, 0
popfd
ret

// IN: ebx = pid
// OUT: al = erc, es:ebx -> process
s_get_proc_ptr:
shl ebx, 9  // assert sizeof ProcessRec = 512
cmp ebx, p_procs_max_size
jb l_s_get_proc_ptr_5

  l_s_get_proc_ptr_3:
  mov al, ERC_INVALID_PID
  jmp short l_s_get_proc_ptr_9

l_s_get_proc_ptr_5:
add ebx, VA_PROCS

test byte ptr [es:ebx + offset ProcessRec.flags], PROC_FLAGS_VALID
jz l_s_get_proc_ptr_3

mov al, 0

l_s_get_proc_ptr_9:
ret

// IN: dh = old winid, dl = new winid, ah = 1(alt+tab) || 2(click) || 4(other window closed)
// KEEP: edx
s_post_ada:
cmp dl, dh
jz near l_s_post_ada_9
  cmp dh, MAX_WIN
  jnb l_s_post_ada_5
    push eax
     push edx
      cmp dl, MAX_WIN
      jnb l_s_post_ada_3
        movzx esi, dl
        shl esi, 5  // assert sizeof WinRec = 32
        mov ebx, cr3
        cmp ebx, win.cr3[esi]
        jnz l_s_post_ada_3
          mov esi, win.hwnd[esi]
          jmp short l_s_post_ada_4
          
      l_s_post_ada_3:
        xor esi, esi
        
      l_s_post_ada_4:
      movzx ebx, dh
      mov eax, ebx
      shl ebx, 16
      shl eax, 5 // assert sizeof WinRec = 32
      mov bx, word ptr win.pid[eax]
      mov ecx, WM_ACTIVATE
      xor edx, edx
      call p_msg_post
     pop edx
    pop eax
    
  l_s_post_ada_5:
  cmp dl, MAX_WIN
  jnb l_s_post_ada_9
    push edx
      cmp dh, MAX_WIN
      jnb l_s_post_ada_6
        movzx esi, dh
        shl esi, 5  // assert sizeof WinRec = 32
        mov ebx, cr3
        cmp ebx, win.cr3[esi]
        jnz l_s_post_ada_6
          mov esi, win.hwnd[esi]
          jmp short l_s_post_ada_7
          
      l_s_post_ada_6:
        xor esi, esi
        
      l_s_post_ada_7:
      movzx ebx, dl
      movzx edx, ah
      mov eax, ebx
      shl ebx, 16
      shl eax, 5 // assert sizeof WinRec = 32
      mov bx, word ptr win.pid[eax]
      mov ecx, WM_ACTIVATE
      call p_msg_post
    pop edx
    
l_s_post_ada_9:
ret

// activate top, post ada, keep ecx..edi
// BEFORE: g_enter
s_activatetop:
push ecx
  movzx ecx, wcount
  
  l_g_destroy_win_85:
    sub ecx, 1
    jc near l_g_destroy_win_89
      movzx eax, wpos[ecx]
      shl eax, 5  // assert sizeof WinRec = 32
      test win.flags[eax], WINFLAGS_ALWAYSONTOP
      jnz l_g_destroy_win_85
        test win.flags[eax], WS_MINIMIZE
        jnz l_g_destroy_win_85
        
    pop ecx
    // post wm_activate
    shr eax, 5  // assert sizeof WinRec = 32
    mov dl, al
    mov dh, WIN_NONE //wactive
    mov wactive, al
    mov ah, 4 // !!!
    push ecx
     push ebx
      push esi
       push edi
        // post activate/deactivate
        call s_post_ada  // keep edx
       pop edi
      pop esi
     pop ebx
    pop ecx
    
    ret
    
  l_g_destroy_win_89:
  mov wactive, WIN_NONE
pop ecx
ret

// is window visible?
// IN: esi -> win[]
// OUT: jc => visible
// KEEP: ecx, edx, ebx, esi, edi
s_isvisible:
mov eax, win.flags[esi]
test eax, WS_VISIBLE
jz l_s_isvisible_no
  test eax, WS_MINIMIZE
  jnz l_s_isvisible_no
    mov al, win.desktop[esi]
    cmp al, wdesktop
    jz l_s_isvisible_yes
      cmp al, WIN_NONE
      jz l_s_isvisible_yes
      
l_s_isvisible_no:
clc
ret

l_s_isvisible_yes:
stc
ret

// Exit
s_exit:
mov ebx, p_current
mov ebx, [es:ebx + offset ThreadRec.process]
sub ebx, VA_PROCS
shr ebx, 9 // assert sizeof ProcessRec = 512
jmp p_kill_process
//ret

// IN: ebx = winid:threadid, ecx = msg, edx = wp, esi = lp
s_p_msg_post:
call s_chkstarter
jz near p_msg_post
ret

// IN: edi = pid || (threadid + 16384)
s_p_start: // 34
call s_chkthread
test al, al
jz near p_start
ret

// IN: edi = pid || (threadid + 16384)
s_p_stop: // 35
call s_chkthread
test al, al
jz near p_stop
ret

// IN: edi = threadid
// OUT: al = erc, edx = priority
s_getpriority: // 33
shl edi, 12  // assert sizeof ThreadRec = 4096
cmp edi, p_threads_max_size
jb l_s_getpriority_1
  mov al, ERC_INVALID_THREADID
  ret

l_s_getpriority_1:
add edi, VA_THREADS
cmp byte[es:edi + offset ThreadRec.flags], 0
jnz l_s_getpriority_2
  mov al, ERC_INVALID_THREADID
  ret

l_s_getpriority_2:
mov eax, [es:edi + offset ThreadRec.priority]
xor edx, edx
mov ecx, 1193
div ecx
xchg eax, edx

mov al, 0
ret

// IN: ebx = pid
// OUT: ecx = cpu ticks, edx = total ticks, ebx = used memory, esi = flags
s_procinfo: // 42
call s_get_proc_ptr
or al, al
jnz l_s_procinfo_9

xor esi, esi
xor ecx, ecx
xor edi, edi
l_s_procinfo_6:
  add edi, VA_THREADS
    mov eax, [es:edi + offset ThreadRec.flags]
    or eax, eax
    jz l_s_procinfo_7
      cmp [es:edi + offset ThreadRec.process], ebx
      jnz l_s_procinfo_7
        or esi, eax
        add ecx, [es:edi + offset ThreadRec.tmr_spent]

    l_s_procinfo_7:
  sub edi, VA_THREADS - 4096
  cmp edi, p_threads_max_size
  jb l_s_procinfo_6

mov ebx, [es:ebx + offset ProcessRec.memused]

mov al, 0

l_s_procinfo_9:
mov edx, tmr_total
ret

// IN: edi = threadid, dl = priority
// OUT: al = erc
s_setpriority: // 43
movzx eax, dl
cmp al, 1
jb l_s_setpriority_8
  cmp al, 50
  ja l_s_setpriority_8
  
mov edx, 1193
mul edx  // eax = ticks

shl edi, 12 // assert sizeof ThreadRec = 4096
cmp edi, p_threads_max_size
jb l_s_setpriority_1
  mov al, ERC_INVALID_THREADID
  jmp short l_s_setpriority_9

l_s_setpriority_1:
add edi, VA_THREADS
cmp dword[es:edi + offset ThreadRec.flags], 0
jnz l_s_setpriority_15
  mov al, ERC_INVALID_THREADID
  jmp short l_s_setpriority_9

l_s_setpriority_15:
mov ebx, p_current
cmp edi, ebx
jnz l_s_setpriority_2
  // self
  cmp eax, [es:edi + offset ThreadRec.priority]
  ja l_s_setpriority_2
    
    l_s_setpriority_16:
    mov [es:edi + offset ThreadRec.priority], eax
    mov al, 0
    jmp short l_s_setpriority_9

l_s_setpriority_2:
// starter
push eax
  call s_chkstarter
pop eax
jz l_s_setpriority_16

mov al, ERC_ACCESS_DENIED
jmp short l_s_setpriority_9

l_s_setpriority_8:
mov al, ERC_INVALID_PRIORITY

l_s_setpriority_9:
ret

// IN: ebx = pid, es:edi -> target
s_getprocname: // 44
call s_get_proc_ptr
or al, al
jnz l_s_getprocname_9

cmp edi, VA_ACCESS
jb l_s_getprocname_5
  mov al, ERC_INVALID_MEMORY_LOCATION
  jmp short l_s_getprocname_9

l_s_getprocname_5:
mov esi, ebx
add esi, offset ProcessRec.filename
mov ecx, MAX_PATH

l_s_getprocname_6:
  mov al, [esi]
  inc esi
  stosb
  cmp al, 0
  jz l_s_getprocname_8
    loop l_s_getprocname_6

l_s_getprocname_8:
mov al, 0

l_s_getprocname_9:
ret

// OUT: ebx = pid, edx = ppid, edi = threadid
s_getpid: // 45
mov edi, p_current
mov ebx, [es:edi + offset ThreadRec.process]
mov edx, [es:ebx + offset ProcessRec.previnstance]
sub edi, VA_THREADS
sub ebx, VA_PROCS
sub edx, VA_PROCS
shr edi, 12 // assert sizeof ThreadRec == 4096
shr ebx, 9  // assert sizeof ProcessRec == 512
shr edx, 9  // assert sizeof ProcessRec == 512
ret

// IN: ecx = WM_DEVICECHANGE, edx = ldiskn, esi = 0 removed | 1 inserted
// OUT: al = erc
s_posttoall: // 69
call s_chkstarter
jnz l_s_posttoall_9
  jmp p_msg_post_to_all

l_s_posttoall_9:
ret

// OUT: eax = free bytes
s_memfree: // 70
mov eax, m_free
shl eax, 12
ret

// IN: bl = 0: stdin, 1:stdout, 2:stderr
// OUT: eax = -1 || std
s_get_std: // 84
movzx ebx, bl
cmp bl, 3
jb l_s_get_std_1
  xor eax, eax
  dec eax
  ret
  
l_s_get_std_1:
shl ebx, 2
add ebx, p_current
mov eax, [es:ebx + offset ThreadRec.stdin]
ret

// IN: bl = 0: stdin, 1:stdout, 2:stderr, dx = pid_target, edi = pid_to_set
// OUT: al = erc
s_set_std: // 85
movzx ebx, bl
cmp bl, 3
jb l_s_set_std_1
  mov al, ERC_INVALID_VALUE
  ret
  
l_s_set_std_1:
shl edi, 9  // assert sizeof ProcessRec = 512
cmp edi, p_procs_max_size
jb l_s_set_std_12
  
  l_s_set_std_11:
  mov al, ERC_INVALID_PID
  ret
  
l_s_set_std_12:
add edi, VA_PROCS  // es:edi -> process
mov eax, [es:edi + offset ProcessRec.flags]
test al, PROC_FLAGS_VALID
jz l_s_set_std_11

mov eax, [es:edi + offset ProcessRec.previnstance]
mov ecx, p_current
cmp eax, [es:ecx + offset ThreadRec.process]
jz l_s_set_std_14
  cmp edi, ecx
  jz l_s_set_std_14
    mov al, ERC_ACCESS_DENIED
    ret
    
l_s_set_std_14:
mov edi, [es:edi + offset ProcessRec.mainthread]  // es:edi -> pid.mainthread
shl ebx, 2
add ebx, edi
mov eax, [es:ebx + offset ThreadRec.stdin]
test eax, eax
jz l_s_set_std_3
  test eax, STDOUT_MSG
  jnz l_s_set_std_3
    mov al, ERC_INVALID_VALUE
    ret
    
l_s_set_std_3:
movzx edx, dx
or edx, STDOUT_MSG
mov [es:ebx + offset ThreadRec.stdin], edx
mov al, 0
ret

// args, env_vars
s_argsenv: // 90
mov edi, p_current
mov edi, [es:edi + offset ThreadRec.process]
mov esi, [es:edi + offset ProcessRec.args]
mov edi, [es:edi + offset ProcessRec.env_vars]
ret

// post a system message to window, only starter
// IN: bl = winid, ecx = WM, edx = wp, esi = lp
// OUT: al = erc
s_postwin: // 104
call s_chkstarter
jnz l_s_postwin_9
  cmp bl, MAX_WIN
  jnb l_s_postwin_8
    movzx ebx, bl
    mov eax, ebx
    shl ebx, 16
    shl eax, 5 // assert sizeof WinRec = 32
    mov bx, word ptr win.pid[eax]
    jmp p_msg_post
    
l_s_postwin_8:
mov al, ERC_INVALID_WINDOW

l_s_postwin_9:
ret

// post an user message to window
// IN: bl = winid, ecx = WM, edx = wp, esi = lp
// OUT: al = erc
s_postwinusr: // 105
cmp bl, MAX_WIN
jnb l_s_postwinusr_8
  movzx ebx, bl
  mov eax, ebx
  shl ebx, 16
  shl eax, 5 // assert sizeof WinRec = 32
  mov bx, word ptr win.pid[eax]
  jmp p_msg_usr_post
  
l_s_postwinusr_8:
mov al, ERC_INVALID_WINDOW
ret

// IN: esi = mode, es:edx -> fname
// OUT: al = erc, ebx = fhandle
// mode: 1 read, 3 write, 10h append, 20h rewrite
s_fs_fopen:
mov eax, esi
mov ah, 0  // fs_takelink
mov bl, 0  // fs_hack
call fs_fopen
mov ebx, esi
ret

// IN: ebx = fhandle
s_fs_fclose:
mov esi, ebx
call fs_fclose
ret

// IN: ebx = fhandle, es:edi -> data, ecx = size
s_fs_fread: // 10
mov esi, ebx
mov eax, edi
add eax, ecx
cmp eax, VA_ACCESS
ja l_fs_fread_8
  cmp eax, edi
  jnb near fs_fread

l_fs_fread_8:  // also s_fs_write
mov al, ERC_INVALID_POINTER
xor ecx, ecx
ret

// IN: ebx = fhandle, es:edi -> data, ecx = size
s_fs_fwrite: // 11
mov esi, ebx
mov eax, edi
add eax, ecx
cmp eax, VA_ACCESS
ja l_fs_fread_8
  cmp eax, edi
  jb l_fs_fread_8
jmp fs_fwrite

// IN: ebx = fhandle, edx:edi = file offset
s_fs_fsetpos:
mov esi, ebx
mov ebx, edi
jmp fs_fsetpos

// IN: ebx = fhandle
s_fs_fcut:
mov esi, ebx
jmp fs_fcut

// IN: ebx = fhandle
// OUT: edx:ecx = fpos
s_fgetpos: // 14
mov esi, ebx
call fs_check_thread_esi
or al, al
jnz l_s_fgetpos_9
  mov ecx, dword files.pos[esi]
  mov edx, dword files.pos[esi + 4]
  mov al, 0

l_s_fgetpos_9:
ret

// IN: ebx = fhandle
// OUT: edx:ecx = fsize
s_fgetsize: // 15
mov esi, ebx
call fs_check_thread_esi
or al, al
jnz l_s_fgetsize_9
  mov ecx, dword files.size[esi]
  mov edx, dword files.size[esi + 4]
  mov al, 0

l_s_fgetsize_9:
ret

s_cd: // 16
mov ah, 0
jmp fs_cd
//ret

s_md: // 17
mov ah, 0
jmp fs_md
//ret

s_rm: // 18
mov ah, 0
jmp fs_rm
//ret

s_rename: // 20
mov ah, 1
jmp fs_rename
//ret

s_move: // 21
mov ah, 0
jmp fs_move
//ret

s_find_first: // 22
mov ah, 0
jmp fs_find_first
//ret

// IN: edi -> char[MAX_PATH]
s_getcurdir: // 52
cmp edi, VA_ACCESS
jb l_s_getcurdir_2
  mov al, ERC_INVALID_MEMORY_LOCATION
  ret
  
l_s_getcurdir_2:
mov esi, p_current
add esi, offset ThreadRec.curdirtext
mov ecx, MAX_PATH
cld

l_s_getcurdir_5:
  mov al, [es:esi]
  inc esi
  stosb
  cmp al, 0
  jz l_s_getcurdir_7
    loop l_s_getcurdir_5

  mov al, ERC_TOO_LONG

l_s_getcurdir_7:
ret

// IN: esi = mode, es:edx -> fname
// OUT: al = erc, ebx = fhandle
// mode: 1 read, 3 write, 10h append, 20h rewrite
s_link_open: // 66
mov eax, esi
mov ah, 1  // fs_takelink
mov bl, 0  // fs_hack
call fs_fopen
mov ebx, esi
ret

// IN: es:edx -> filename
// OUT: al = erc
s_link_rm: // 67
mov ah, 1
jmp fs_rm
//ret

// IN: edx:ebx = disk offset, ecx = size, esi = ldiskn, edi -> target
s_diskread:  // 36
call fs_enter
call s_chkstarter
jnz l_s_diskread_9
  and esi, 31
  mov eax, esi
  shl esi, 5  // assert sizeof DiskInfoRec = 32
  mov esi, disk_info.main[esi]
  or esi, esi
  jz l_s_diskread_2
    mov ah, 2
    call esi
    jmp short l_s_diskread_9

l_s_diskread_2:
mov al, ERC_INVALID_DISK_NUMBER

l_s_diskread_9:
call fs_leave
ret

// IN: edx:ebx = disk offset, ecx = size, esi = ldiskn, edi -> target
s_diskwrite:  // 37
call fs_enter
call s_chkstarter
jnz l_s_diskwrite_9
  and esi, 31
  mov eax, esi
  shl esi, 5  // assert sizeof DiskInfoRec = 32
  mov esi, disk_info.main[esi]
  or esi, esi
  jz l_s_diskwrite_2
    mov ah, 3
    call esi
    jmp short l_s_diskwrite_9

l_s_diskwrite_2:
mov al, ERC_INVALID_DISK_NUMBER

l_s_diskwrite_9:
call fs_leave
ret

// IN: esi = ldiskn
// OUT: edx:eax = disk size in bytes
s_disksize:  // 38
call fs_enter
and esi, 31
mov eax, esi
shl esi, 5  // assert sizeof DiskInfoRec = 32
mov esi, disk_info.main[esi]
or esi, esi
jz l_s_disksize_2
  mov ah, 4
  call esi
  jmp short l_s_disksize_9

l_s_disksize_2:
xor eax, eax
xor edx, edx

l_s_disksize_9:
call fs_leave
ret

// IN: esi = ldiskn
s_diskflush:  // 39
call fs_enter
and esi, 31
mov eax, esi
shl esi, 5  // assert sizeof DiskInfoRec = 32
mov esi, disk_info.main[esi]
or esi, esi
jz l_s_diskflush_2
  mov ah, 5
  call esi
  jmp short l_s_diskflush_9

l_s_diskflush_2:
mov al, ERC_INVALID_DISK_NUMBER

l_s_diskflush_9:
call fs_leave
ret

// IN: edx:ebx = sector, ecx = count, edi -> data, esi = physical HD number
s_hdread: // 40
call fs_enter
mov eax, esi
//and al, 3
call h_hd_prepare_port_slave
call h_hd_p_read
call fs_leave
ret

// IN: edx:ebx = sector, ecx = count, edi -> data, esi = physical HD number
s_hdwrite: // 41
call fs_enter
mov eax, esi
//and al, 3
call h_hd_prepare_port_slave
call h_hd_p_write
call fs_leave
ret

s_reloaddisks: // 46
call s_chkstarter
jnz l_s_reloaddisks_9
  call fs_enter
  call h_disks_reset
  call fs_leave

l_s_reloaddisks_9:
ret

// IN: esi = pdiskn, es:edi -> buffer[512]
s_identify:
cmp edi, VA_ACCESS
jnb l_s_identify_28

mov eax, esi
cld

test al, 40h
jz l_s_identify_20
  // sata hard disk
  call h_sd_p_identify
  test al, al
  jz l_s_identify_29
    jmp short l_s_identify_28
  
l_s_identify_20:
// hard disk
call h_hd_prepare_port_slave

mov dx, hdt_port_base
or dx, 7
in al, dx
cmp al, 0FFh
jz l_s_identify_28
  
  push edi
    call h_hd_p_identify
  pop edi
  test al, al
  jz l_s_identify_29 // HD
  
  cmp al, ERC_INVALID_DISK_NUMBER
  jz l_s_identify_28
    // CD/other (erc = 104h)
    call h_hd_p_identifyp
    jmp short l_s_identify_29
  
l_s_identify_28:
xor eax, eax
mov ecx, 512/4
rep stosd

l_s_identify_29:
ret

// IN: esi -> ldiskn
s_disktype: // 53
and esi, 31
shl esi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.type[esi]
mov ah, disk_info.number[esi]
mov bl, disk_info.fsid[esi]
mov bh, disk_info.partition[esi]
mov ecx, dword ptr disk_info.size_sectors[esi]
mov edx, dword ptr disk_info.size_sectors[esi + 4]
mov edi, dword ptr disk_info.base_sectors[esi + 4]
mov esi, dword ptr disk_info.base_sectors[esi]
ret

// IN: ecx = RAM disk size (max 256 MiB)
// OUT: al = erc, dl = ldiskn
s_create_ramdisk: // 71
call s_chkstarter
jnz l_s_create_ramdisk_9
  call h_rd_create  // OUT al
  test al, al
  jnz l_s_create_ramdisk_3
    mov al, ERC_NOT_ENOUGH_MEMORY
    jmp short l_s_create_ramdisk_9
    
  l_s_create_ramdisk_3:
  push eax
    mov edi, 0  // 1024
    call e2_format
  pop edx
  mov al, 0
  
l_s_create_ramdisk_9:
ret

// OUT: al = boot disk
s_get_boot_disk: // 77
mov al, byte ptr boot_disk
ret

// IN: eax = scan key
// OUT: eax = state
s_getkeystate: // 49
//and eax, 127
//movzx eax, byte kbd_state[eax]
xor eax, eax
ret

// IN: dl = winid
// OUT: al = kbdid
s_getkbd: // 112
movzx esi, dl
shl esi, 5  // assert sizeof WinRec = 32
mov al, win.kbd[esi]
ret

// IN: dl = winid, cl = kbdid
s_setkbd: // 113
call s_chkstarter
jnz l_s_setkbd_9
  cmp dl, MAX_WIN
  jnb l_s_setkbd_9
    movzx esi, dl
    shl esi, 5  // assert sizeof WinRec = 32
    mov win.kbd[esi], cl
    
l_s_setkbd_9:
ret

// IN: ebx = uid
s_login: // 50
call s_chkstarter
jnz l_s_login_9
  mov eax, p_current
  mov [es:eax + offset ThreadRec.uid], ebx
  
l_s_login_9:
ret

// IN: ebx = gid
s_logrp: // 51
call s_chkstarter
jnz l_s_logrp_9
  mov eax, p_current
  mov [es:eax + offset ThreadRec.gid], ebx
  
l_s_logrp_9:
ret

// OUT: eax = uid
s_getuid: // 54
mov eax, p_current
mov eax, [es:eax + offset ThreadRec.uid]
ret

// OUT: eax = gid
s_getgid: // 55
mov eax, p_current
mov eax, [es:eax + offset ThreadRec.gid]
ret

// IN: ecx = uid, edi -> byte[256]
s_get_user: // 80
cmp edi, VA_ACCESS
jb l_s_get_user_1
  mov al, ERC_INVALID_POINTER
  jmp short l_s_get_user_9
  
l_s_get_user_1:
call get_user

l_s_get_user_9:
ret

// IN: ecx = gid, edi -> byte[256]
s_get_group: // 81
cmp edi, VA_ACCESS
jb l_s_get_group_1
  mov al, ERC_INVALID_POINTER
  jmp short l_s_get_group_9
  
l_s_get_group_1:
call get_group

l_s_get_group_9:
ret

// OUT: eax = time zone
s_gettimezone: // 56
mov eax, time_zone
ret

// IN: edx = time zone, OUT: al = erc
s_settimezone: // 57
call s_chkstarter
jnz l_s_settimezone_8
  xchg eax, edx
  cmp eax, -24
  jl l_s_settimezone_7
    cmp eax, 24
    jg l_s_settimezone_7
      mov time_zone, eax
      mov al, 0
      jmp short l_s_settimezone_9

l_s_settimezone_7:
mov al, ERC_INVALID_VALUE
jmp short l_s_settimezone_9

l_s_settimezone_8:
mov al, ERC_ONLY_STARTER

l_s_settimezone_9:
ret

// IN: es:edi -> SystemTime, es:esi -> ftime, max year = 32767
s_systime2ftime: // 58
cmp edi, VA_ACCESS
jb l_s_systime2ftime_1
  mov al, ERC_INVALID_POINTER
  ret
  
l_s_systime2ftime_1:
cmp esi, VA_ACCESS
jb l_s_systime2ftime_2
  mov al, ERC_INVALID_POINTER
  ret

l_s_systime2ftime_2:
jmp t_systime2ftime
//ret

// IN: es:esi -> ftime, es:edi -> SystemTime
s_ftime2systime: // 59
cmp edi, VA_ACCESS
jb l_s_ftime2systime_1
  mov al, ERC_INVALID_POINTER
  ret

l_s_ftime2systime_1:
cmp esi, VA_ACCESS
jb l_s_ftime2systime_2
  mov al, ERC_INVALID_POINTER
  ret
  
l_s_ftime2systime_2:
jmp t_ftime2systime
//ret

// IN: es:edi -> SystemTime
s_getlocal: // 60
cmp edi, VA_ACCESS
jb l_s_getlocal_1
  mov al, ERC_INVALID_POINTER
  ret
  
l_s_getlocal_1:
jmp t_getlocal
//ret

// IN: es:edi -> SystemTime
s_setlocal: // 61
call s_chkstarter
jz l_s_setlocal_1
  mov al, ERC_ONLY_STARTER
  ret
  
l_s_setlocal_1:
cmp edi, VA_ACCESS
jb l_s_setlocal_2
  mov al, ERC_INVALID_POINTER
  ret

l_s_setlocal_2:
jmp t_setlocal
//ret

// IN: es:edi -> SystemTime
s_getsystem: // 62
cmp edi, VA_ACCESS
jb l_s_getsystem_1
  mov al, ERC_INVALID_POINTER
  ret
  
l_s_getsystem_1:
jmp t_getsystem
//ret

// IN: ecx = ms, dx = winid, ebx = id, edi = ofs
// OUT: al = 0 || errorcode
s_timer_add: // 64
push edx
  mov eax, 1193
  mul ecx
pop edx
xchg eax, ecx
mov eax, p_current
sub eax, VA_THREADS
shr eax, 12  // sizeof ThreadRec = 4096
shl eax, 16
movzx edx, dx
or edx, eax
jmp h_timer_add
//ret

// IN: dx = winid, ebx = id
// OUT: al = 0 || errorcode
s_timer_rm: // 65
mov eax, p_current
sub eax, VA_THREADS
shr eax, 12  // sizeof ThreadRec = 4096
shl eax, 16
movzx edx, dx
or edx, eax
jmp h_timer_remove
//ret

// IN: dl = winid
// OUT: al = erc
s_g_destroy_win: // 87
movzx ebx, dl
shl ebx, 5  // assert sizeof WinRec = 32
mov eax, p_current
mov eax, [es:eax + offset TssRec.cr3]
cmp win.cr3[ebx], eax
jnz l_s_g_destroy_win_8
  jmp g_destroy_win
  
l_s_g_destroy_win_8:
mov al, ERC_INVALID_WINDOW
ret

// info
s_g_info: // 89
movzx ecx, g_info.xres
movzx edx, g_info.yres
mov esi, g_mainpanelh
mov edi, g_bg
ret

// setmainpanelh
s_g_setmainpanelh: // 92
call s_chkstarter
jz l_s_g_setmainpanelh_1
  mov al, ERC_ONLY_STARTER
  ret
  
l_s_g_setmainpanelh_1:
mov g_mainpanelh, ecx
mov edx, ecx
mov ecx, WM_MAINPANELHCHANGED
xor esi, esi
call p_msg_post_to_all
mov al, 0
ret

// IN: dl = winid, dh = 1(alt+tab) || 2(click) || 4(other window closed)
// OUT: al = erc
s_g_activate: // 94
call g_enter
mov g_depth, 0
mov g_topwinid, WIN_NONE
mov g_x1, 32767
mov g_y1, 32767
mov g_x2, -1
mov g_y2, -1
cmp dl, MAX_WIN
jnb l_s_g_activate_2
  push edx
    call g_activate
  pop edx
  
l_s_g_activate_2:
mov ah, dh  // ah = dh
mov dh, wactive
mov dl, g_topwinid
mov wactive, dl
movsx ecx, g_x1
movsx ebx, g_y1
movsx esi, g_x2
movsx edi, g_y2
call g_leave

cmp dl, dh
jz near l_s_g_activate_9
  push ecx
   push ebx
    push esi
     push edi
      push eax
        call s_post_ada  // keep edx
      pop eax
     pop edi
    pop esi
   pop ebx
  pop ecx
  
  // paint
  cmp ecx, esi
  jnl l_s_g_activate_9
    call g_paint
    
l_s_g_activate_9:
ret

// IN: dl = winid
s_g_setover: // 95
mov dh, wover
mov wover, dl
cmp dl, dh
jz l_s_g_setover_9
  cmp dh, MAX_WIN
  jnb l_s_g_setover_5
    push edx
      movzx ebx, dh
      mov eax, ebx
      shl ebx, 16
      shl eax, 5 // assert sizeof WinRec = 32
      mov bx, word ptr win.pid[eax]
      mov ecx, WM_NCMOUSEOVER
      xor edx, edx
      xor esi, esi
      call p_msg_post
    pop edx
    
  l_s_g_setover_5:
  cmp dl, MAX_WIN
  jnb l_s_g_setover_9
    movzx ebx, dl
    mov eax, ebx
    shl ebx, 16
    shl eax, 5 // assert sizeof WinRec = 32
    mov bx, word ptr win.pid[eax]
    mov ecx, WM_NCMOUSEOVER
    mov edx, 1
    xor esi, esi
    call p_msg_post

l_s_g_setover_9:
ret

// OUT: cl = w, ch = h, bl = shift x, bh = shift y
s_get_mouse_info: // 97
mov esi, ms_cursor
test esi, esi
jnz l_s_get_mouse_info_1
  xor ecx, ecx
  jmp short l_s_get_mouse_info_2
  
l_s_get_mouse_info_1:
mov cl, [es:esi]
mov ch, [es:esi + 4]

l_s_get_mouse_info_2:
mov bl, ms_shift_x
mov bh, ms_shift_y
ret

// OUT: ecx = active winid, edx = over winid,
//      esi = active hwnd, edi = over hwnd
s_getactiveover: // 99
movzx ecx, wactive
movzx edx, wover
xor esi, esi
xor edi, edi
cmp cl, MAX_WIN
jnb l_s_getactiveover_5
  mov eax, ecx
  shl eax, 5  // assert sizeof WinRec = 32
  mov esi, win.hwnd[eax]
  
l_s_getactiveover_5:
cmp dl, MAX_WIN
jnb l_s_getactiveover_9
  mov eax, edx
  shl eax, 5  // assert sizeof WinRec = 32
  mov edi, win.hwnd[eax]
  
l_s_getactiveover_9:
ret

// IN: es:edi -> variable of size 8420 B
// OUT: al = erc
s_save_desktop: // 102
call s_chkstarter
jnz l_s_save_desktop_9
  mov al, ERC_INVALID_POINTER
  cmp edi, VA_ACCESS - 8420
  ja l_s_save_desktop_9
    call g_enter
    pushfd
      cli
      mov esi, offset wcount
      mov ecx, 8420 >> 2
      cld
      rep movsd
    popfd
    call g_leave
    mov al, 0
    
l_s_save_desktop_9:
ret

// IN: es:edi -> variable of size 8420 B
// OUT: al = erc
s_load_desktop: // 103
call s_chkstarter
jnz l_s_load_desktop_9
  mov al, ERC_INVALID_POINTER
  cmp edi, VA_ACCESS - 8420
  ja l_s_load_desktop_9
    call g_enter
    push ds
      push es
      pop ds
      pushfd
        cli
        mov esi, edi
        mov edi, VA_SYSTEM + offset wcount
        mov ecx, 8420 >> 2
        cld
        rep movsd
      popfd
    pop ds
    call g_leave
    mov al, 0
    
l_s_load_desktop_9:
ret

// IN: dl = winid
// OUT: al = erc
s_g_toback: // 108
call g_enter
mov g_depth, 0
mov g_x1, 32767
mov g_y1, 32767
mov g_x2, -1
mov g_y2, -1
cmp dl, MAX_WIN
jnb l_s_g_toback_2
  call g_toback
  
l_s_g_toback_2:
movsx ecx, g_x1
movsx ebx, g_y1
movsx esi, g_x2
movsx edi, g_y2
// topwinid
call s_activatetop

call g_leave

// paint
cmp ecx, esi
jnl l_s_g_toback_9
  call g_paint
  
l_s_g_toback_9:
ret


// IN: dl = winid, cl = pressed button mask (0x10, 0x20, 0x40)
s_g_setbuttons: // 110
movzx edx, dl
cmp dl, MAX_WIN
jnb l_s_g_setbuttons_9
  shl edx, 5  // assert sizeof WinRec = 32
  mov eax, win.flags[edx]
  and al, 8Fh
  and cl, 70h
  or al, cl
  mov win.flags[edx], eax
l_s_g_setbuttons_9:
ret


// IN: dl = winid, ecx = ncheight
s_g_setncheight: // 111
movzx esi, dl
shl esi, 5  // assert sizeof WinRec = 32
call s_chkstarter  // keep esi, ecx
jnz l_s_g_setncheight_9
  
  l_s_g_setncheight_6:
  mov win.ncheight[esi], cl
  mov al, 0
  ret
  
l_s_g_setncheight_9:
mov edx, cr3
cmp edx, win.cr3[esi]
jz l_s_g_setncheight_6
ret

// IN: edi -> bitmap[?], ebx = bitmap_width, esi = color, dl = pressed
// OUT: edi -> next button, ebx
s_g_button:
// top
test dl, 1
jnz l_s_g_button_1
  mov eax, WIN_LIGHT
  jmp short l_s_g_button_2
  
l_s_g_button_1:
  mov eax, WIN_DARK
  
l_s_g_button_2:
push edi
  add edi, 4
  mov ecx, WIN_HEADER - 2
  cld
  rep stosd
pop edi
mov eax, ebx
shl eax, 2
add edi, eax

// body
mov ecx, WIN_HEADER - 2

l_s_g_button_5:
  push ecx
    push edi
      test dl, 1
      jnz l_s_g_button_51
        mov eax, WIN_LIGHT
        jmp short l_s_g_button_52
        
      l_s_g_button_51:
        mov eax, WIN_DARK
        
      l_s_g_button_52:
      stosd
        
      mov eax, esi
      mov ecx, WIN_HEADER - 2
      rep stosd
      
      test dl, 1
      jnz l_s_g_button_53
        mov eax, WIN_DARK
        jmp short l_s_g_button_54
        
      l_s_g_button_53:
        mov eax, WIN_LIGHT
        
      l_s_g_button_54:
      stosd
    pop edi
    mov eax, ebx
    shl eax, 2
    add edi, eax
  pop ecx
  loop l_s_g_button_5
  
// bottom
test dl, 1
jnz l_s_g_button_71
  mov eax, WIN_DARK
  jmp short l_s_g_button_72
  
l_s_g_button_71:
  mov eax, WIN_LIGHT
  
l_s_g_button_72:
push edi
  add edi, 4
  mov ecx, WIN_HEADER - 2
  cld
  rep stosd
pop edi

// next button edi
mov eax, WIN_HEADER - 1
mul ebx
add eax, WIN_HEADER
shl eax, 2
sub edi, eax

ret

// IN: edx -> WindowExRec, esi = offset in pbitmap
s_g_buttons:
movzx edx, byte ptr [es:edx + offset TextWinRec.wnd.winid]
shl edx, 5  // assert sizeof WinRec = 32
mov edi, win.pbitmap[edx]
movzx ebx, word ptr [es:edi]
add edi, 8
add edi, esi
mov esi, win.flags[edx]

// close
push esi
  mov dl, 0
  test esi, WINFLAGS_CLOSEPRESSED
  jz l_s_g_buttons_81
    mov dl, 1
    
  l_s_g_buttons_81:
  mov esi, WIN_CLOSECOLOR
  call s_g_button
  //... paint x
pop esi

// maximize
test esi, WS_MAXIMIZEBOX
jz l_s_g_buttons_84
  push esi
    mov dl, 0
    test esi, WINFLAGS_MAXIMIZEPRESSED
    jz l_s_g_buttons_82
      mov dl, 1
      
    l_s_g_buttons_82:
    mov esi, WIN_MAXIMIZECOLOR
    call s_g_button
    //...
  pop esi
  
l_s_g_buttons_84:
// minimize
test esi, WS_MINIMIZEBOX
jz l_s_g_buttons_86
  mov dl, 0
  test esi, WINFLAGS_MINIMIZEPRESSED
  jz l_s_g_buttons_85
    mov dl, 1
    
  l_s_g_buttons_85:
  mov esi, WIN_MAXIMIZECOLOR
  call s_g_button
  //...
  
l_s_g_buttons_86:
ret

// IN: edx = hwnd
// OUT: win[].ncheight
// KEEP: edx
s_g_paint_caption:
push edx
  cmp edx, VA_ACCESS
  jnb l_s_g_paint_caption_9
    movzx ebx, byte ptr [es:edx + offset TextWinRec.wnd.winid]
    
    cmp bl, wactive
    jz l_s_g_paint_caption_2
      cmp bl, wover
      jz l_s_g_paint_caption_2
        mov esi, WIN_FRAMECOLOR
        jmp short l_s_g_paint_caption_3
        
    l_s_g_paint_caption_2:
      mov esi, WIN_ACTIVEFRAMECOLOR
    
    l_s_g_paint_caption_3:
    shl ebx, 5  // assert sizeof WinRec = 32
    xor eax, eax
    mov ecx, win.flags[ebx]
    mov edi, win.pbitmap[ebx]
    mov win.ncheight[ebx], al  // ncheight
    test edi, edi
    jz l_s_g_paint_caption_9
      cmp edi, VA_ACCESS
      jnb l_s_g_paint_caption_9
        movzx ebx, word ptr [es:edi]
        movzx edx, word ptr [es:edi + 4]
        push edx
          mov eax, ebx
          mul edx
        pop edx
        shl eax, 2
        add eax, edi
        cmp eax, VA_ACCESS
        jnb l_s_g_paint_caption_9
          mov eax, ecx
          add edi, 8
          cmp ebx, WIN_MINW
          jb l_s_g_paint_caption_9
            cmp edx, WIN_MINH
            jnb l_s_g_paint_caption_6
            
  l_s_g_paint_caption_9:
pop edx
ret


l_s_g_paint_caption_6:  // IN: eax, edi, ebx, edx
test eax, WS_MAXIMIZE
jnz near l_s_g_paint_caption_7
test eax, WS_CHILD
jnz l_s_g_paint_caption_9
test eax, WS_POPUP
jnz l_s_g_paint_caption_9

// ncheight
pop eax  // :KLUDGE:
push eax
movzx eax, byte ptr [es:eax + offset TextWinRec.wnd.winid]
shl eax, 5  // assert sizeof WinRec = 32
mov win.ncheight[eax], WIN_BORDER + WIN_HEADER

// top line
mov eax, esi
mov ecx, ebx
cld
rep stosd

// top border
mov ecx, WIN_BORDER - 2

l_s_g_paint_caption_615:
  push ecx
    mov eax, esi
    stosd
    mov eax, WIN_BORDERCOLOR
    mov ecx, ebx
    sub ecx, 2
    rep stosd
    mov eax, esi
    stosd
  pop ecx
  loop l_s_g_paint_caption_615

// end top border
mov eax, esi
stosd

mov eax, WIN_BORDERCOLOR
mov ecx, WIN_BORDER - 2
rep stosd

mov eax, WIN_FRAMECOLOR
mov ecx, ebx
sub ecx, WIN_BORDER * 2 - 2
rep stosd

mov eax, WIN_BORDERCOLOR
mov ecx, WIN_BORDER - 2
rep stosd

mov eax, esi
stosd

// header
mov ecx, WIN_HEADER

l_s_g_paint_caption_625:
  push ecx
    mov eax, esi
    stosd
    
    mov eax, WIN_BORDERCOLOR
    mov ecx, WIN_BORDER - 2
    rep stosd
    
    mov eax, WIN_FRAMECOLOR
    stosd
    
    mov eax, WIN_HEADERCOLOR
    mov ecx, ebx
    sub ecx, WIN_BORDER * 2
    rep stosd
    
    mov eax, WIN_FRAMECOLOR
    stosd
    
    mov eax, WIN_BORDERCOLOR
    mov ecx, WIN_BORDER - 2
    rep stosd
    
    mov eax, esi
    stosd
  pop ecx
  loop l_s_g_paint_caption_625

// body
mov ecx, edx
sub ecx, WIN_HEADER + (WIN_BORDER * 2)
jecxz l_s_g_paint_caption_636

l_s_g_paint_caption_635:
  push ecx
    mov eax, esi
    stosd
    
    mov eax, WIN_BORDERCOLOR
    mov ecx, WIN_BORDER - 2
    rep stosd
    
    mov eax, WIN_FRAMECOLOR
    stosd
    
    mov eax, ebx
    sub eax, WIN_BORDER * 2
    shl eax, 2
    add edi, eax
    
    mov eax, WIN_FRAMECOLOR
    stosd
    
    mov eax, WIN_BORDERCOLOR
    mov ecx, WIN_BORDER - 2
    rep stosd
    
    mov eax, esi
    stosd
  pop ecx
  loop l_s_g_paint_caption_635

l_s_g_paint_caption_636:

// top bottom
mov eax, esi
stosd

mov eax, WIN_BORDERCOLOR
mov ecx, WIN_BORDER - 2
rep stosd

mov eax, WIN_FRAMECOLOR
mov ecx, ebx
sub ecx, WIN_BORDER * 2 - 2
rep stosd

mov eax, WIN_BORDERCOLOR
mov ecx, WIN_BORDER - 2
rep stosd

mov eax, esi
stosd

// bottom border
mov ecx, WIN_BORDER - 2

l_s_g_paint_caption_645:
  push ecx
    mov eax, esi
    stosd
    mov eax, WIN_BORDERCOLOR
    mov ecx, ebx
    sub ecx, 2
    rep stosd
    mov eax, esi
    stosd
  pop ecx
  loop l_s_g_paint_caption_645

// bottom line
mov eax, esi
mov ecx, ebx
rep stosd

// prepare buttons  IN: ebx
mov esi, ebx
sub esi, WIN_HEADER + WIN_BORDER
mov eax, WIN_BORDER
mul ebx
add esi, eax
shl esi, 2
jmp l_s_g_paint_caption_8


// * maximized *
l_s_g_paint_caption_7:  // IN: edi, ebx, edx
// ncheight
pop eax  // :KLUDGE:
push eax
movzx eax, byte ptr [es:eax + offset TextWinRec.wnd.winid]
shl eax, 5  // assert sizeof WinRec = 32
mov win.ncheight[eax], WIN_HEADER

mov ecx, WIN_HEADER

l_s_g_paint_caption_725:
  push ecx
    mov eax, WIN_HEADERCOLOR
    mov ecx, ebx
    cld
    rep stosd
  pop ecx
  loop l_s_g_paint_caption_725

mov esi, ebx
sub esi, WIN_HEADER
shl esi, 2
jmp l_s_g_paint_caption_8


// * buttons *
l_s_g_paint_caption_8:  // IN: esi, ebx
pop edx
push edx
call s_g_buttons
jmp l_s_g_paint_caption_9

TEXTWIN_W = (80 * 8 + (WIN_BORDER * 2))
TEXTWIN_H = 25 * 16 + WIN_HEADER + (WIN_BORDER * 2)

BLINK_SLEEP = 500 // ms

VA_TEXTHWND = 0x80000000 - 0x1000
VA_TEXTHWNDVAR = VA_TEXTHWND + 0x800

[align 32]

colors:
dd 0xFF000000
dd 0xFF000080
dd 0xFF008000
dd 0xFF008080
dd 0xFF800000
dd 0xFF800080
dd 0xFF808000
dd 0xFFC0C0C0
dd 0xFF808080
dd 0xFF0000FF
dd 0xFF00FF00
dd 0xFF00FFFF
dd 0xFFFF0000
dd 0xFFFF00FF
dd 0xFFFFFF00
dd 0xFFFFFFFF

text_bitmap:  // 256 * 16

db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 7Eh, 81h, 0A5h, 81h, 81h, 0BDh, 99h, 81h, 81h, 7Eh, 0, 0, 0, 0
db 0, 0, 7Eh, 0FFh, 0DBh, 0FFh, 0FFh, 0C3h, 0E7h, 0FFh, 0FFh, 7Eh, 0, 0, 0, 0
db 0, 0, 0, 0, 6Ch, 0FEh, 0FEh, 0FEh, 0FEh, 7Ch, 38h, 10h, 0, 0, 0, 0
db 0, 0, 0, 0, 10h, 38h, 7Ch, 0FEh, 7Ch, 38h, 10h, 0, 0, 0, 0, 0
db 0, 0, 0, 18h, 3Ch, 3Ch, 0E7h, 0E7h, 0E7h, 18h, 18h, 3Ch, 0, 0, 0, 0
db 0, 0, 0, 18h, 3Ch, 7Eh, 0FFh, 0FFh, 7Eh, 18h, 18h, 3Ch, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0, 18h, 3Ch, 3Ch, 18h, 0, 0, 0, 0, 0, 0
db 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0E7h, 0C3h, 0C3h, 0E7h, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
db 0, 0, 0, 0, 0, 3Ch, 66h, 42h, 42h, 66h, 3Ch, 0, 0, 0, 0, 0
db 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0C3h, 99h, 0BDh, 0BDh, 99h, 0C3h, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
db 0, 0, 1Eh, 0Eh, 1Ah, 32h, 78h, 0CCh, 0CCh, 0CCh, 0CCh, 78h, 0, 0, 0, 0
db 0, 0, 3Ch, 66h, 66h, 66h, 66h, 3Ch, 18h, 7Eh, 18h, 18h, 0, 0, 0, 0
db 0, 0, 3Fh, 33h, 3Fh, 30h, 30h, 30h, 30h, 70h, 0F0h, 0E0h, 0, 0, 0, 0
db 0, 0, 7Fh, 63h, 7Fh, 63h, 63h, 63h, 63h, 67h, 0E7h, 0E6h, 0C0h, 0, 0, 0
db 0, 0, 0, 18h, 18h, 0DBh, 3Ch, 0E7h, 3Ch, 0DBh, 18h, 18h, 0, 0, 0, 0

db 0, 80h, 0C0h, 0E0h, 0F0h, 0F8h, 0FEh, 0F8h, 0F0h, 0E0h, 0C0h, 80h, 0, 0, 0, 0
db 0, 2, 6, 0Eh, 1Eh, 3Eh, 0FEh, 3Eh, 1Eh, 0Eh, 6, 2, 0, 0, 0, 0
db 0, 0, 18h, 3Ch, 7Eh, 18h, 18h, 18h, 7Eh, 3Ch, 18h, 0, 0, 0, 0, 0
db 0, 0, 66h, 66h, 66h, 66h, 66h, 66h, 66h, 0, 66h, 66h, 0, 0, 0, 0
db 0, 0, 7Fh, 0DBh, 0DBh, 0DBh, 7Bh, 1Bh, 1Bh, 1Bh, 1Bh, 1Bh, 0, 0, 0, 0
db 0, 7Ch, 0C6h, 60h, 38h, 6Ch, 0C6h, 0C6h, 6Ch, 38h, 0Ch, 0C6h, 7Ch, 0, 0, 0
db 0, 0, 0, 0, 0, 0, 0, 0, 0FEh, 0FEh, 0FEh, 0FEh, 0, 0, 0, 0
db 0, 0, 18h, 3Ch, 7Eh, 18h, 18h, 18h, 7Eh, 3Ch, 18h, 7Eh, 0, 0, 0, 0
db 0, 0, 18h, 3Ch, 7Eh, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 0, 0, 0, 0
db 0, 0, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 7Eh, 3Ch, 18h, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 18h, 0Ch, 0FEh, 0Ch, 18h, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 30h, 60h, 0FEh, 60h, 30h, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0, 0C0h, 0C0h, 0C0h, 0FEh, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 24h, 66h, 0FFh, 66h, 24h, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 10h, 38h, 38h, 7Ch, 7Ch, 0FEh, 0FEh, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0FEh, 0FEh, 7Ch, 7Ch, 38h, 38h, 10h, 0, 0, 0, 0, 0

db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 18h, 3Ch, 3Ch, 3Ch, 18h, 18h, 18h, 0, 18h, 18h, 0, 0, 0, 0
db 0, 66h, 66h, 66h, 24h, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 6Ch, 6Ch, 0FEh, 6Ch, 6Ch, 6Ch, 0FEh, 6Ch, 6Ch, 0, 0, 0, 0
db 18h, 18h, 7Ch, 0C6h, 0C2h, 0C0h, 7Ch, 6, 6, 86h, 0C6h, 7Ch, 18h, 18h, 0, 0
db 0, 0, 0, 0, 0C2h, 0C6h, 0Ch, 18h, 30h, 60h, 0C6h, 86h, 0, 0, 0, 0
db 0, 0, 38h, 6Ch, 6Ch, 38h, 76h, 0DCh, 0CCh, 0CCh, 0CCh, 76h, 0, 0, 0, 0
db 0, 30h, 30h, 30h, 60h, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0Ch, 18h, 30h, 30h, 30h, 30h, 30h, 30h, 18h, 0Ch, 0, 0, 0, 0
db 0, 0, 30h, 18h, 0Ch, 0Ch, 0Ch, 0Ch, 0Ch, 0Ch, 18h, 30h, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 66h, 3Ch, 0FFh, 3Ch, 66h, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 18h, 18h, 7Eh, 18h, 18h, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0, 0, 0, 0, 18h, 18h, 18h, 30h, 0, 0, 0
db 0, 0, 0, 0, 0, 0, 0, 0FEh, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18h, 18h, 0, 0, 0, 0
db 0, 0, 0, 0, 2, 6, 0Ch, 18h, 30h, 60h, 0C0h, 80h, 0, 0, 0, 0

db 0, 0, 3Ch, 66h, 0C3h, 0C3h, 0DBh, 0DBh, 0C3h, 0C3h, 66h, 3Ch, 0, 0, 0, 0
db 0, 0, 18h, 38h, 78h, 18h, 18h, 18h, 18h, 18h, 18h, 7Eh, 0, 0, 0, 0
db 0, 0, 7Ch, 0C6h, 6, 0Ch, 18h, 30h, 60h, 0C0h, 0C6h, 0FEh, 0, 0, 0, 0
db 0, 0, 7Ch, 0C6h, 6, 6, 3Ch, 6, 6, 6, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 0, 0Ch, 1Ch, 3Ch, 6Ch, 0CCh, 0FEh, 0Ch, 0Ch, 0Ch, 1Eh, 0, 0, 0, 0
db 0, 0, 0FEh, 0C0h, 0C0h, 0C0h, 0FCh, 6, 6, 6, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 0, 38h, 60h, 0C0h, 0C0h, 0FCh, 0C6h, 0C6h, 0C6h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 0, 0FEh, 0C6h, 6, 6, 0Ch, 18h, 30h, 30h, 30h, 30h, 0, 0, 0, 0
db 0, 0, 7Ch, 0C6h, 0C6h, 0C6h, 7Ch, 0C6h, 0C6h, 0C6h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 0, 7Ch, 0C6h, 0C6h, 0C6h, 7Eh, 6, 6, 6, 0Ch, 78h, 0, 0, 0, 0
db 0, 0, 0, 0, 18h, 18h, 0, 0, 0, 18h, 18h, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 18h, 18h, 0, 0, 0, 18h, 18h, 30h, 0, 0, 0, 0
db 0, 0, 0, 6, 0Ch, 18h, 30h, 60h, 30h, 18h, 0Ch, 6, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 7Eh, 0, 0, 7Eh, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 60h, 30h, 18h, 0Ch, 6, 0Ch, 18h, 30h, 60h, 0, 0, 0, 0
db 0, 0, 7Ch, 0C6h, 0C6h, 0Ch, 18h, 18h, 18h, 0, 18h, 18h, 0, 0, 0, 0

db 0, 0, 0, 7Ch, 0C6h, 0C6h, 0DEh, 0DEh, 0DEh, 0DCh, 0C0h, 7Ch, 0, 0, 0, 0
db 0, 0, 10h, 38h, 6Ch, 0C6h, 0C6h, 0FEh, 0C6h, 0C6h, 0C6h, 0C6h, 0, 0, 0, 0
db 0, 0, 0FCh, 66h, 66h, 66h, 7Ch, 66h, 66h, 66h, 66h, 0FCh, 0, 0, 0, 0
db 0, 0, 3Ch, 66h, 0C2h, 0C0h, 0C0h, 0C0h, 0C0h, 0C2h, 66h, 3Ch, 0, 0, 0, 0
db 0, 0, 0F8h, 6Ch, 66h, 66h, 66h, 66h, 66h, 66h, 6Ch, 0F8h, 0, 0, 0, 0
db 0, 0, 0FEh, 66h, 62h, 68h, 78h, 68h, 60h, 62h, 66h, 0FEh, 0, 0, 0, 0
db 0, 0, 0FEh, 66h, 62h, 68h, 78h, 68h, 60h, 60h, 60h, 0F0h, 0, 0, 0, 0
db 0, 0, 3Ch, 66h, 0C2h, 0C0h, 0C0h, 0DEh, 0C6h, 0C6h, 66h, 3Ah, 0, 0, 0, 0
db 0, 0, 0C6h, 0C6h, 0C6h, 0C6h, 0FEh, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0, 0, 0, 0
db 0, 0, 3Ch, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 3Ch, 0, 0, 0, 0
db 0, 0, 1Eh, 0Ch, 0Ch, 0Ch, 0Ch, 0Ch, 0CCh, 0CCh, 0CCh, 78h, 0, 0, 0, 0
db 0, 0, 0E6h, 66h, 66h, 6Ch, 78h, 78h, 6Ch, 66h, 66h, 0E6h, 0, 0, 0, 0
db 0, 0, 0F0h, 60h, 60h, 60h, 60h, 60h, 60h, 62h, 66h, 0FEh, 0, 0, 0, 0
db 0, 0, 0C3h, 0E7h, 0FFh, 0FFh, 0DBh, 0C3h, 0C3h, 0C3h, 0C3h, 0C3h, 0, 0, 0, 0
db 0, 0, 0C6h, 0E6h, 0F6h, 0FEh, 0DEh, 0CEh, 0C6h, 0C6h, 0C6h, 0C6h, 0, 0, 0, 0
db 0, 0, 7Ch, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 7Ch, 0, 0, 0, 0

db 0, 0, 0FCh, 66h, 66h, 66h, 7Ch, 60h, 60h, 60h, 60h, 0F0h, 0, 0, 0, 0
db 0, 0, 7Ch, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0D6h, 0DEh, 7Ch, 0Ch, 0Eh, 0, 0
db 0, 0, 0FCh, 66h, 66h, 66h, 7Ch, 6Ch, 66h, 66h, 66h, 0E6h, 0, 0, 0, 0
db 0, 0, 7Ch, 0C6h, 0C6h, 60h, 38h, 0Ch, 6, 0C6h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 0, 0FFh, 0DBh, 99h, 18h, 18h, 18h, 18h, 18h, 18h, 3Ch, 0, 0, 0, 0
db 0, 0, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 0, 0C3h, 0C3h, 0C3h, 0C3h, 0C3h, 0C3h, 0C3h, 66h, 3Ch, 18h, 0, 0, 0, 0
db 0, 0, 0C3h, 0C3h, 0C3h, 0C3h, 0C3h, 0DBh, 0DBh, 0FFh, 66h, 66h, 0, 0, 0, 0
db 0, 0, 0C3h, 0C3h, 66h, 3Ch, 18h, 18h, 3Ch, 66h, 0C3h, 0C3h, 0, 0, 0, 0
db 0, 0, 0C3h, 0C3h, 0C3h, 66h, 3Ch, 18h, 18h, 18h, 18h, 3Ch, 0, 0, 0, 0
db 0, 0, 0FFh, 0C3h, 86h, 0Ch, 18h, 30h, 60h, 0C1h, 0C3h, 0FFh, 0, 0, 0, 0
db 0, 0, 3Ch, 30h, 30h, 30h, 30h, 30h, 30h, 30h, 30h, 3Ch, 0, 0, 0, 0
db 0, 0, 0, 80h, 0C0h, 0E0h, 70h, 38h, 1Ch, 0Eh, 6, 2, 0, 0, 0, 0
db 0, 0, 3Ch, 0Ch, 0Ch, 0Ch, 0Ch, 0Ch, 0Ch, 0Ch, 0Ch, 3Ch, 0, 0, 0, 0
db 10h, 38h, 6Ch, 0C6h, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0FFh, 0, 0

db 30h, 30h, 18h, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 78h, 0Ch, 7Ch, 0CCh, 0CCh, 0CCh, 76h, 0, 0, 0, 0
db 0, 0, 0E0h, 60h, 60h, 78h, 6Ch, 66h, 66h, 66h, 66h, 7Ch, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 7Ch, 0C6h, 0C0h, 0C0h, 0C0h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 0, 1Ch, 0Ch, 0Ch, 3Ch, 6Ch, 0CCh, 0CCh, 0CCh, 0CCh, 76h, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 7Ch, 0C6h, 0FEh, 0C0h, 0C0h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 0, 38h, 6Ch, 64h, 60h, 0F0h, 60h, 60h, 60h, 60h, 0F0h, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 76h, 0CCh, 0CCh, 0CCh, 0CCh, 0CCh, 7Ch, 0Ch, 0CCh, 78h, 0
db 0, 0, 0E0h, 60h, 60h, 6Ch, 76h, 66h, 66h, 66h, 66h, 0E6h, 0, 0, 0, 0
db 0, 0, 18h, 18h, 0, 38h, 18h, 18h, 18h, 18h, 18h, 3Ch, 0, 0, 0, 0
db 0, 0, 6, 6, 0, 0Eh, 6, 6, 6, 6, 6, 6, 66h, 66h, 3Ch, 0
db 0, 0, 0E0h, 60h, 60h, 66h, 6Ch, 78h, 78h, 6Ch, 66h, 0E6h, 0, 0, 0, 0
db 0, 0, 38h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 3Ch, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0E6h, 0FFh, 0DBh, 0DBh, 0DBh, 0DBh, 0DBh, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0DCh, 66h, 66h, 66h, 66h, 66h, 66h, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 7Ch, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 7Ch, 0, 0, 0, 0

db 0, 0, 0, 0, 0, 0DCh, 66h, 66h, 66h, 66h, 66h, 7Ch, 60h, 60h, 0F0h, 0
db 0, 0, 0, 0, 0, 76h, 0CCh, 0CCh, 0CCh, 0CCh, 0CCh, 7Ch, 0Ch, 0Ch, 1Eh, 0
db 0, 0, 0, 0, 0, 0DCh, 76h, 66h, 60h, 60h, 60h, 0F0h, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 7Ch, 0C6h, 60h, 38h, 0Ch, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 0, 10h, 30h, 30h, 0FCh, 30h, 30h, 30h, 30h, 36h, 1Ch, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0CCh, 0CCh, 0CCh, 0CCh, 0CCh, 0CCh, 76h, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0C3h, 0C3h, 0C3h, 0C3h, 66h, 3Ch, 18h, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0C3h, 0C3h, 0C3h, 0DBh, 0DBh, 0FFh, 66h, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0C3h, 66h, 3Ch, 18h, 3Ch, 66h, 0C3h, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 7Eh, 6, 0Ch, 0F8h, 0
db 0, 0, 0, 0, 0, 0FEh, 0CCh, 18h, 30h, 60h, 0C6h, 0FEh, 0, 0, 0, 0
db 0, 0, 0Eh, 18h, 18h, 18h, 70h, 18h, 18h, 18h, 18h, 0Eh, 0, 0, 0, 0
db 0, 0, 18h, 18h, 18h, 18h, 0, 18h, 18h, 18h, 18h, 18h, 0, 0, 0, 0
db 0, 0, 70h, 18h, 18h, 18h, 0Eh, 18h, 18h, 18h, 18h, 70h, 0, 0, 0, 0
db 0, 0, 76h, 0DCh, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 10h, 38h, 6Ch, 0C6h, 0C6h, 0C6h, 0FEh, 0, 0, 0, 0, 0

db 0, 0, 3Ch, 66h, 0C2h, 0C0h, 0C0h, 0C0h, 0C2h, 66h, 3Ch, 0Ch, 6, 7Ch, 0, 0
db 0, 0, 0CCh, 0, 0, 0CCh, 0CCh, 0CCh, 0CCh, 0CCh, 0CCh, 76h, 0, 0, 0, 0
db 0, 0Ch, 18h, 30h, 0, 7Ch, 0C6h, 0FEh, 0C0h, 0C0h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 10h, 38h, 6Ch, 0, 78h, 0Ch, 7Ch, 0CCh, 0CCh, 0CCh, 76h, 0, 0, 0, 0
db 0, 0, 0CCh, 0, 0, 78h, 0Ch, 7Ch, 0CCh, 0CCh, 0CCh, 76h, 0, 0, 0, 0
db 0, 60h, 30h, 18h, 0, 78h, 0Ch, 7Ch, 0CCh, 0CCh, 0CCh, 76h, 0, 0, 0, 0
db 0, 38h, 6Ch, 38h, 0, 78h, 0Ch, 7Ch, 0CCh, 0CCh, 0CCh, 76h, 0, 0, 0, 0
db 0, 0, 0, 0, 3Ch, 66h, 60h, 60h, 66h, 3Ch, 0Ch, 6, 3Ch, 0, 0, 0
db 0, 10h, 38h, 6Ch, 0, 7Ch, 0C6h, 0FEh, 0C0h, 0C0h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 0, 0C6h, 0, 0, 7Ch, 0C6h, 0FEh, 0C0h, 0C0h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 60h, 30h, 18h, 0, 7Ch, 0C6h, 0FEh, 0C0h, 0C0h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 0, 66h, 0, 0, 38h, 18h, 18h, 18h, 18h, 18h, 3Ch, 0, 0, 0, 0
db 0, 18h, 3Ch, 66h, 0, 38h, 18h, 18h, 18h, 18h, 18h, 3Ch, 0, 0, 0, 0
db 0, 60h, 30h, 18h, 0, 38h, 18h, 18h, 18h, 18h, 18h, 3Ch, 0, 0, 0, 0
db 0, 0C6h, 0, 10h, 38h, 6Ch, 0C6h, 0C6h, 0FEh, 0C6h, 0C6h, 0C6h, 0, 0, 0, 0
db 38h, 6Ch, 38h, 0, 38h, 6Ch, 0C6h, 0C6h, 0FEh, 0C6h, 0C6h, 0C6h, 0, 0, 0, 0

db 18h, 30h, 60h, 0, 0FEh, 66h, 60h, 7Ch, 60h, 60h, 66h, 0FEh, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 6Eh, 3Bh, 1Bh, 7Eh, 0D8h, 0DCh, 77h, 0, 0, 0, 0
db 0, 0, 3Eh, 6Ch, 0CCh, 0CCh, 0FEh, 0CCh, 0CCh, 0CCh, 0CCh, 0CEh, 0, 0, 0, 0
db 0, 10h, 38h, 6Ch, 0, 7Ch, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 0, 0C6h, 0, 0, 7Ch, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 60h, 30h, 18h, 0, 7Ch, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 30h, 78h, 0CCh, 0, 0CCh, 0CCh, 0CCh, 0CCh, 0CCh, 0CCh, 76h, 0, 0, 0, 0
db 0, 60h, 30h, 18h, 0, 0CCh, 0CCh, 0CCh, 0CCh, 0CCh, 0CCh, 76h, 0, 0, 0, 0
db 0, 0, 0C6h, 0, 0, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 7Eh, 6, 0Ch, 78h, 0
db 0, 0C6h, 0, 7Ch, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 0C6h, 0, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 18h, 18h, 7Eh, 0C3h, 0C0h, 0C0h, 0C0h, 0C3h, 7Eh, 18h, 18h, 0, 0, 0, 0
db 0, 38h, 6Ch, 64h, 60h, 0F0h, 60h, 60h, 60h, 60h, 0E6h, 0FCh, 0, 0, 0, 0
db 0, 0, 0C3h, 66h, 3Ch, 18h, 0FFh, 18h, 0FFh, 18h, 18h, 18h, 0, 0, 0, 0
db 0, 0FCh, 66h, 66h, 7Ch, 62h, 66h, 6Fh, 66h, 66h, 66h, 0F3h, 0, 0, 0, 0
db 0, 0Eh, 1Bh, 18h, 18h, 18h, 7Eh, 18h, 18h, 18h, 18h, 18h, 0D8h, 70h, 0, 0

db 0, 18h, 30h, 60h, 0, 78h, 0Ch, 7Ch, 0CCh, 0CCh, 0CCh, 76h, 0, 0, 0, 0
db 0, 0Ch, 18h, 30h, 0, 38h, 18h, 18h, 18h, 18h, 18h, 3Ch, 0, 0, 0, 0
db 0, 18h, 30h, 60h, 0, 7Ch, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 18h, 30h, 60h, 0, 0CCh, 0CCh, 0CCh, 0CCh, 0CCh, 0CCh, 76h, 0, 0, 0, 0
db 0, 0, 76h, 0DCh, 0, 0DCh, 66h, 66h, 66h, 66h, 66h, 66h, 0, 0, 0, 0
db 76h, 0DCh, 0, 0C6h, 0E6h, 0F6h, 0FEh, 0DEh, 0CEh, 0C6h, 0C6h, 0C6h, 0, 0, 0, 0
db 0, 3Ch, 6Ch, 6Ch, 3Eh, 0, 7Eh, 0, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 38h, 6Ch, 6Ch, 38h, 0, 7Ch, 0, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 30h, 30h, 0, 30h, 30h, 60h, 0C0h, 0C6h, 0C6h, 7Ch, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0, 0FEh, 0C0h, 0C0h, 0C0h, 0C0h, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0, 0FEh, 6, 6, 6, 6, 0, 0, 0, 0, 0
db 0, 0C0h, 0C0h, 0C2h, 0C6h, 0CCh, 18h, 30h, 60h, 0CEh, 9Bh, 6, 0Ch, 1Fh, 0, 0
db 0, 0C0h, 0C0h, 0C2h, 0C6h, 0CCh, 18h, 30h, 66h, 0CEh, 96h, 3Eh, 6, 6, 0, 0
db 0, 0, 18h, 18h, 0, 18h, 18h, 18h, 3Ch, 3Ch, 3Ch, 18h, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 36h, 6Ch, 0D8h, 6Ch, 36h, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0D8h, 6Ch, 36h, 6Ch, 0D8h, 0, 0, 0, 0, 0, 0

db 11h, 44h, 11h, 44h, 11h, 44h, 11h, 44h, 11h, 44h, 11h, 44h, 11h, 44h, 11h, 44h
db 55h, 0AAh, 55h, 0AAh, 55h, 0AAh, 55h, 0AAh, 55h, 0AAh, 55h, 0AAh, 55h, 0AAh, 55h, 0AAh
db 0DDh, 77h, 0DDh, 77h, 0DDh, 77h, 0DDh, 77h, 0DDh, 77h, 0DDh, 77h, 0DDh, 77h, 0DDh, 77h
db 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h
db 18h, 18h, 18h, 18h, 18h, 18h, 18h, 0F8h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h
db 18h, 18h, 18h, 18h, 18h, 0F8h, 18h, 0F8h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h
db 36h, 36h, 36h, 36h, 36h, 36h, 36h, 0F6h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h
db 0, 0, 0, 0, 0, 0, 0, 0FEh, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h
db 0, 0, 0, 0, 0, 0F8h, 18h, 0F8h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h
db 36h, 36h, 36h, 36h, 36h, 0F6h, 6, 0F6h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h
db 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h
db 0, 0, 0, 0, 0, 0FEh, 6, 0F6h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h
db 36h, 36h, 36h, 36h, 36h, 0F6h, 6, 0FEh, 0, 0, 0, 0, 0, 0, 0, 0
db 36h, 36h, 36h, 36h, 36h, 36h, 36h, 0FEh, 0, 0, 0, 0, 0, 0, 0, 0
db 18h, 18h, 18h, 18h, 18h, 0F8h, 18h, 0F8h, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0, 0, 0F8h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h

db 18h, 18h, 18h, 18h, 18h, 18h, 18h, 1Fh, 0, 0, 0, 0, 0, 0, 0, 0
db 18h, 18h, 18h, 18h, 18h, 18h, 18h, 0FFh, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0, 0, 0FFh, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h
db 18h, 18h, 18h, 18h, 18h, 18h, 18h, 1Fh, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h
db 0, 0, 0, 0, 0, 0, 0, 0FFh, 0, 0, 0, 0, 0, 0, 0, 0
db 18h, 18h, 18h, 18h, 18h, 18h, 18h, 0FFh, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h
db 18h, 18h, 18h, 18h, 18h, 1Fh, 18h, 1Fh, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h
db 36h, 36h, 36h, 36h, 36h, 36h, 36h, 37h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h
db 36h, 36h, 36h, 36h, 36h, 37h, 30h, 3Fh, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 3Fh, 30h, 37h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h
db 36h, 36h, 36h, 36h, 36h, 0F7h, 0, 0FFh, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0FFh, 0, 0F7h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h
db 36h, 36h, 36h, 36h, 36h, 37h, 30h, 37h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h
db 0, 0, 0, 0, 0, 0FFh, 0, 0FFh, 0, 0, 0, 0, 0, 0, 0, 0
db 36h, 36h, 36h, 36h, 36h, 0F7h, 0, 0F7h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h
db 18h, 18h, 18h, 18h, 18h, 0FFh, 0, 0FFh, 0, 0, 0, 0, 0, 0, 0, 0

db 36h, 36h, 36h, 36h, 36h, 36h, 36h, 0FFh, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0FFh, 0, 0FFh, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h
db 0, 0, 0, 0, 0, 0, 0, 0FFh, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h
db 36h, 36h, 36h, 36h, 36h, 36h, 36h, 3Fh, 0, 0, 0, 0, 0, 0, 0, 0
db 18h, 18h, 18h, 18h, 18h, 1Fh, 18h, 1Fh, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 1Fh, 18h, 1Fh, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h
db 0, 0, 0, 0, 0, 0, 0, 3Fh, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h
db 36h, 36h, 36h, 36h, 36h, 36h, 36h, 0FFh, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h
db 18h, 18h, 18h, 18h, 18h, 0FFh, 18h, 0FFh, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h
db 18h, 18h, 18h, 18h, 18h, 18h, 18h, 0F8h, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0, 0, 1Fh, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h
db 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
db 0, 0, 0, 0, 0, 0, 0, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
db 0F0h, 0F0h, 0F0h, 0F0h, 0F0h, 0F0h, 0F0h, 0F0h, 0F0h, 0F0h, 0F0h, 0F0h, 0F0h, 0F0h, 0F0h, 0F0h
db 0Fh, 0Fh, 0Fh, 0Fh, 0Fh, 0Fh, 0Fh, 0Fh, 0Fh, 0Fh, 0Fh, 0Fh, 0Fh, 0Fh, 0Fh, 0Fh
db 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0, 0, 0, 0, 0, 0, 0, 0, 0

db 0, 0, 0, 0, 0, 76h, 0DCh, 0D8h, 0D8h, 0D8h, 0DCh, 76h, 0, 0, 0, 0
db 0, 0, 78h, 0CCh, 0CCh, 0CCh, 0D8h, 0CCh, 0C6h, 0C6h, 0C6h, 0CCh, 0, 0, 0, 0
db 0, 0, 0FEh, 0C6h, 0C6h, 0C0h, 0C0h, 0C0h, 0C0h, 0C0h, 0C0h, 0C0h, 0, 0, 0, 0
db 0, 0, 0, 0, 0FEh, 6Ch, 6Ch, 6Ch, 6Ch, 6Ch, 6Ch, 6Ch, 0, 0, 0, 0
db 0, 0, 0, 0FEh, 0C6h, 60h, 30h, 18h, 30h, 60h, 0C6h, 0FEh, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 7Eh, 0D8h, 0D8h, 0D8h, 0D8h, 0D8h, 70h, 0, 0, 0, 0
db 0, 0, 0, 0, 66h, 66h, 66h, 66h, 66h, 7Ch, 60h, 60h, 0C0h, 0, 0, 0
db 0, 0, 0, 0, 76h, 0DCh, 18h, 18h, 18h, 18h, 18h, 18h, 0, 0, 0, 0
db 0, 0, 0, 7Eh, 18h, 3Ch, 66h, 66h, 66h, 3Ch, 18h, 7Eh, 0, 0, 0, 0
db 0, 0, 0, 38h, 6Ch, 0C6h, 0C6h, 0FEh, 0C6h, 0C6h, 6Ch, 38h, 0, 0, 0, 0
db 0, 0, 38h, 6Ch, 0C6h, 0C6h, 0C6h, 6Ch, 6Ch, 6Ch, 6Ch, 0EEh, 0, 0, 0, 0
db 0, 0, 1Eh, 30h, 18h, 0Ch, 3Eh, 66h, 66h, 66h, 66h, 3Ch, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 7Eh, 0DBh, 0DBh, 0DBh, 7Eh, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 3, 6, 7Eh, 0DBh, 0DBh, 0F3h, 7Eh, 60h, 0C0h, 0, 0, 0, 0
db 0, 0, 1Ch, 30h, 60h, 60h, 7Ch, 60h, 60h, 60h, 30h, 1Ch, 0, 0, 0, 0
db 0, 0, 0, 7Ch, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0C6h, 0, 0, 0, 0

db 0, 0, 0, 0, 0FEh, 0, 0, 0FEh, 0, 0, 0FEh, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 18h, 18h, 7Eh, 18h, 18h, 0, 0, 0FFh, 0, 0, 0, 0
db 0, 0, 0, 30h, 18h, 0Ch, 6, 0Ch, 18h, 30h, 0, 7Eh, 0, 0, 0, 0
db 0, 0, 0, 0Ch, 18h, 30h, 60h, 30h, 18h, 0Ch, 0, 7Eh, 0, 0, 0, 0
db 0, 0, 0Eh, 1Bh, 1Bh, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h
db 18h, 18h, 18h, 18h, 18h, 18h, 18h, 18h, 0D8h, 0D8h, 0D8h, 70h, 0, 0, 0, 0
db 0, 0, 0, 0, 18h, 18h, 0, 7Eh, 0, 18h, 18h, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 76h, 0DCh, 0, 76h, 0DCh, 0, 0, 0, 0, 0, 0
db 0, 38h, 6Ch, 6Ch, 38h, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0, 0, 18h, 18h, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0, 0, 0, 18h, 0, 0, 0, 0, 0, 0, 0
db 0, 0Fh, 0Ch, 0Ch, 0Ch, 0Ch, 0Ch, 0ECh, 6Ch, 6Ch, 3Ch, 1Ch, 0, 0, 0, 0
db 0, 0D8h, 6Ch, 6Ch, 6Ch, 6Ch, 6Ch, 0, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 70h, 0D8h, 30h, 60h, 0C8h, 0F8h, 0, 0, 0, 0, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 7Ch, 7Ch, 7Ch, 7Ch, 7Ch, 7Ch, 7Ch, 0, 0, 0, 0, 0
db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

// IN: es:esi -> str, ecx = len, bl = color
s_write:
call s_g_prepare
mov edi, p_current
mov eax, [es:edi + offset ThreadRec.stdout]
test eax, STDOUT_WIN
jz near l_s_write_6
  // textwin
  cmp al, MAX_WIN
  jb l_s_write_51
    mov al, ERC_INVALID_WINDOW
    jmp l_s_write_9
    
  l_s_write_51:
  movzx edi, al
  shl edi, 5  // assert sizeof WinRec == 32
  mov edi, win.hwnd[edi]
  cmp edi, VA_ACCESS
  jb l_s_write_52
    
    l_s_write_514:
    mov al, ERC_INVALID_POINTER
    jmp l_s_write_9
    
  l_s_write_52:
  movzx edx, word ptr [es:edi + offset TextWinRec.curx]  // edx = cursor
  mov ah, bl  // ah = color
  mov ebx, [es:edi + offset TextWinRec.pwintext]  // ebx = pwintext
  test ebx, ebx
  jz l_s_write_514
  
  cmp ebx, VA_ACCESS
  jnb l_s_write_514
  
  push edi
    call s_g_calcpos
    
    l_s_write_55:
      jecxz l_s_write_58
        mov al, [es:esi]  //... utf-8?
        inc esi
        cmp al, 13  // cr
        jz l_s_write_57
          cmp al, 10  // lf
          jnz l_s_write_56
            call s_g_newline
            jmp short l_s_write_57
            
          l_s_write_56:
          stosw
          inc dl
          cmp dl, 80
          jb l_s_write_57
            call s_g_newline
            
        l_s_write_57:
        dec ecx
        jmp short l_s_write_55
        
    l_s_write_58:
  pop edi
  
  mov [es:edi + offset TextWinRec.curx], dx
  mov al, 0
  jmp l_s_write_9
  
l_s_write_6:
test eax, STDOUT_FILE
jz near l_s_write_7
  // file
  mov edi, esi
  movzx esi, ax
  call fs_fwrite
  jmp l_s_write_9
  
l_s_write_7:
test eax, STDOUT_MSG
jz near l_s_write_9
  // msg
  mov edx, -1
  mov dx, ax
  mov edi, edx
  
  l_s_write_75:
  jecxz l_s_write_78
    
    l_s_write_76:
    movzx edx, byte ptr [es:esi]  //... utf-8?
    inc esi
    push ecx
     push esi
      push ebx
       push edi
        movzx esi, bl
        mov ebx, edi
        mov ecx, WM_CHARIO
        call p_msg_usr_post
       pop edi
      pop ebx
     pop esi
    pop ecx
    cmp al, ERC_MSG_QUEUE_FULL
    jnz l_s_write_77
      // repeat post
      call p_noop
      jmp l_s_write_76
      
    l_s_write_77:
    test al, al
    jnz l_s_write_9
      dec ecx
      jmp short l_s_write_75
      
  l_s_write_78:
  mov al, 0
  
l_s_write_9:
ret

// IN: dl = x, dh = y
s_cursorto:
call s_g_prepare
mov edi, p_current
mov eax, [es:edi + offset ThreadRec.stdout]
test eax, STDOUT_WIN
jz l_s_cursorto_8
  movzx edi, al
  shl edi, 5  // assert sizeof WinRec == 32
  mov edi, win.hwnd[edi]
  cmp edi, VA_ACCESS
  jnb l_s_cursorto_8
    mov [es:edi + offset TextWinRec.curx], dx
    
l_s_cursorto_8:
ret


// OUT: dl = x, dh = y
s_getcurpos:
call s_g_prepare
mov edi, p_current
mov eax, [es:edi + offset ThreadRec.stdout]
test eax, STDOUT_WIN
jz l_s_getcurpos_8
  movzx edi, al
  shl edi, 5  // assert sizeof WinRec == 32
  mov edi, win.hwnd[edi]
  movzx edx, word ptr [es:edi + offset TextWinRec.curx]

  ret
  
l_s_getcurpos_8:
xor edx, edx
ret

s_wndproc:
push ebp
 mov ebp, esp
  sub esp, 2 * 2
  
  mov edi, [ss:ebp + 8]  // hwnd
  mov ecx, [ss:ebp + 12] // wm
  mov edx, [ss:ebp + 16] // wp
  mov esi, [ss:ebp + 20] // lp
  
  cmp ecx, WM_ACTIVATE
  jnz l_s_wndproc_2
    test dl, 2 // !!!
    jnz near l_s_wndproc_9
      
      l_s_wndproc_1:
      mov edx, edi
      push edi
        mov ah, 96 // paint text caption
        int 20h
      pop edx
      mov dl, byte ptr [edx + offset WindowExRec.winid]
      cmp dl, MAX_WIN
      jnb near l_s_wndproc_9
        // getwin
        mov edi, VA_TEXTHWNDVAR
        mov ah, 98  // get win
        int 20h
        test al, al
        jnz near l_s_wndproc_9
        // repaint win
        movsx ecx, word ptr [VA_TEXTHWNDVAR + offset WinRec.x]
        movsx ebx, word ptr [VA_TEXTHWNDVAR + offset WinRec.y]
        movsx esi, word ptr [VA_TEXTHWNDVAR + offset WinRec.w]
        add esi, ecx
        dec esi
        movsx edi, word ptr [VA_TEXTHWNDVAR + offset WinRec.h]
        add edi, ebx
        dec edi
        mov ah, 88  // repaint
        int 20h
        jmp l_s_wndproc_9
        
  l_s_wndproc_2:
  cmp ecx, WM_NCMOUSEOVER
  jz l_s_wndproc_1
  
  cmp ecx, WM_WINDOWPOSCHANGED
  jnz near l_s_wndproc_3
    mov eax, [es:esi + offset WindowPosRec.flags]
    test eax, SWP_NOSIZE
    jz near l_s_wndproc_9
     test eax, SWP_RELSIZE
     jnz near l_s_wndproc_9
      test eax, SWP_NOMOVE
      jz l_s_wndproc_202
       test eax, SWP_RELMOVE
       jz near l_s_wndproc_9
        // relative move
        mov dl, [es:edi + offset WindowExRec.winid]
        mov edi, VA_TEXTHWNDVAR
        mov ah, 98  // get win
        push esi
          int 20h
        pop esi
        test al, al
        jnz near l_s_wndproc_9
        
        movsx eax, word ptr [VA_TEXTHWNDVAR + offset WinRec.x]
        add [es:esi + offset WindowPosRec.x], eax
        movsx eax, word ptr [VA_TEXTHWNDVAR + offset WinRec.y]
        add [es:esi + offset WindowPosRec.y], eax
        jmp short l_s_wndproc_203
        
      l_s_wndproc_202:
        // move - getwin
        mov dl, [es:edi + offset WindowExRec.winid]
        mov edi, VA_TEXTHWNDVAR
        mov ah, 98  // get win
        push esi
          int 20h
        pop esi
        test al, al
        jnz near l_s_wndproc_9
        
      l_s_wndproc_203:  // both
        // save old x, y
        mov ax, word ptr [VA_TEXTHWNDVAR + offset WinRec.x]
        mov [ss:ebp - 4], ax
        mov ax, word ptr [VA_TEXTHWNDVAR + offset WinRec.y]
        mov [ss:ebp - 2], ax
        // do move
        mov edi, [ss:ebp + 8]  // hwnd
        mov dl, [es:edi + offset WindowExRec.winid]
        mov ecx, [es:esi + offset WindowPosRec.x]
        mov ebx, [es:esi + offset WindowPosRec.y]
        mov ah, 100  // wmove
        push esi
          int 20h
        pop esi
        // repaint
        mov ecx, [es:esi + offset WindowPosRec.x]
        mov ebx, [es:esi + offset WindowPosRec.y]
        movsx esi, word ptr [VA_TEXTHWNDVAR + offset WinRec.w]
        add esi, ecx
        dec esi
        movsx edi, word ptr [VA_TEXTHWNDVAR + offset WinRec.h]
        add edi, ebx
        dec edi
        
        movsx eax, word ptr [ss:ebp - 4]
        sub eax, ecx
        jnl l_s_wndproc_21
          add ecx, eax
          sub esi, eax
          jmp short l_s_wndproc_22
          
        l_s_wndproc_21:
          add esi, eax
          
        l_s_wndproc_22:
        movsx eax, word ptr [ss:ebp - 2]
        sub eax, ebx
        jnl l_s_wndproc_23
          add ebx, eax
          sub edi, eax
          jmp short l_s_wndproc_24
          
        l_s_wndproc_23:
          add edi, eax
          
        l_s_wndproc_24:
        mov ah, 88  // repaint
        int 20h
        jmp l_s_wndproc_9
        
  l_s_wndproc_3:
  cmp ecx, WM_NCPAINT
  jnz near l_s_wndproc_4
    mov edx, edi
    mov ah, 96 // paint caption
    int 20h
    jmp l_s_wndproc_9
    
  l_s_wndproc_4:
  cmp ecx, WM_PAINTBUTTONS
  jnz near l_s_wndproc_5
    // set buttons
    mov ecx, esi
    mov dl, [es:edi + offset WindowExRec.winid]
    push edi
      mov ah, 110
      int 20h
    pop edi
    
    // paint caption
    push edi
      mov edx, edi
      mov ah, 96
      int 20h
    pop edi
    
    // repaint
    mov dl, [es:edi + offset WindowExRec.winid]
    mov edi, VA_TEXTHWNDVAR
    mov ah, 98  // get win
    int 20h
    
    movsx ecx, word ptr [VA_TEXTHWNDVAR + offset WinRec.x]
    movsx ebx, word ptr [VA_TEXTHWNDVAR + offset WinRec.y]
    movsx esi, word ptr [VA_TEXTHWNDVAR + offset WinRec.w]
    add esi, ecx
    mov ecx, esi
    sub ecx, WIN_HEADER * 3 + WIN_BORDER
    mov edi, ebx
    add edi, WIN_HEADER + WIN_BORDER        
    mov ah, 88  // repaint
    int 20h
    jmp l_s_wndproc_9
    
  l_s_wndproc_5:
  cmp ecx, WM_CLOSE
  jnz l_s_wndproc_6
    // close
    mov ebx, [es:edi + offset WindowExRec.pid]
    mov ah, 29
    int 20h
    /*
    mov ebx, [es:edi + offset TextWinRec.threadid]
    sub ebx, VA_THREADS
    shr ebx, 12  // assert sizeof ThreadRec = 4096
    push edi
      mov ah, 31
      int 20h
    pop edi
    mov dl, [es:edi + offset WindowExRec.winid]
    mov ah, 87  // destroy
    int 20h
    */
    jmp l_s_wndproc_9
    
  l_s_wndproc_6:
  cmp ecx, WM_CHARIO
  jnz l_s_wndproc_7
    /*
    mov [VA_TEXTHWNDVAR], edx
    mov ebx, esi
    mov esi, VA_TEXTHWNDVAR
    mov ecx, 1
    mov ah, 2
    int 20h
    */
    jmp l_s_wndproc_9
    
  l_s_wndproc_7:
  
  //...
  
  l_s_wndproc_9:
 mov esp, ebp
pop ebp
ret 16

s_wndprocend:

// IN: VA_TEXTHWND, s_wndproc
// OUT: eax = 0 || offset wndproc
// KEEP: ebx
s_initwndproc:
push ebx
  mov ebx, VA_TEXTHWND
  mov ecx, 1
  call m_pages_alloc
  test al, al
  jnz l_s_initwndproc_6
  
  mov esi, offset s_wndproc
  mov edi, VA_TEXTHWND
  mov ecx, offset s_wndprocend - offset s_wndproc
  cld
  
  l_s_initwndproc_5:
    mov al, [cs:esi]
    inc esi
    stosb
    loop l_s_initwndproc_5
    
  mov eax, VA_TEXTHWND
  
pop ebx
ret

l_s_initwndproc_6:
  xor eax, eax
pop ebx
ret

// KEEP: ebx, edx, ecx, esi
s_g_prepare:
push ebx
 push edx
  push ecx
   push esi
   
mov ebx, p_current
mov eax, [es:ebx + offset ThreadRec.stdout]
test eax, eax
jnz near l_s_g_prepare_99
  // * create text win *
  mov ecx, sizeof TextWinRec
  call m_heap_alloc_local
  test al, al
  jnz near l_s_g_prepare_95
    xor eax, eax
    // window
    mov [es:ebx + offset WindowExRec.next], eax
    mov [es:ebx + offset WindowExRec.prev], eax
    mov [es:ebx + offset WindowExRec.first_child], eax
    mov [es:ebx + offset WindowExRec.pmenu], eax
    mov [es:ebx + offset WindowExRec.ptext], eax
    
    mov dx, default_x
    mov [es:ebx + offset WindowExRec.x], dx
    add dx, WIN_DEFAULT_X_STEP
    cmp dx, WIN_DEFAULT_X_MAX
    jb l_s_g_prepare_21
      sub dx, WIN_DEFAULT_X_MAX
      
    l_s_g_prepare_21:
    mov default_x, dx
    
    mov dx, default_y
    mov [es:ebx + offset WindowExRec.y], dx
    add dx, WIN_DEFAULT_Y_STEP
    cmp dx, WIN_DEFAULT_Y_MAX
    jb l_s_g_prepare_22
      sub dx, WIN_DEFAULT_Y_MAX
      
    l_s_g_prepare_22:
    mov default_y, dx
    
    mov word ptr[es:ebx + offset WindowExRec.w], TEXTWIN_W
    mov word ptr[es:ebx + offset WindowExRec.h], TEXTWIN_H
    mov [es:ebx + offset WindowExRec.exstyle], eax
    mov dword ptr [es:ebx + offset WindowExRec.style], WS_VISIBLE | WS_CAPTION | WS_MINIMIZEBOX
    mov dword ptr [es:ebx + offset WindowExRec.hinstance], 0x400000
    mov [es:ebx + offset WindowExRec.id], eax
    mov [es:ebx + offset WindowExRec.parent], eax
    call s_initwndproc  // keep ebx, out eax
    mov [es:ebx + offset WindowExRec.wndproc], eax
    xor eax, eax
    // text win
    mov [es:ebx + offset TextWinRec.curx], al
    mov [es:ebx + offset TextWinRec.cury], al
    mov [es:ebx + offset TextWinRec.state], al
    mov [es:ebx + offset TextWinRec.pwintext], eax
    mov [es:ebx + offset TextWinRec.curofs], eax
    mov [es:ebx + offset TextWinRec.winofs], eax
    mov [es:ebx + offset TextWinRec.winsize], eax
    mov [es:ebx + offset TextWinRec.winmax], eax
    // create win
    push ebx
      mov ecx, dword ptr [es:ebx + offset WindowExRec.x]
      mov edx, dword ptr [es:ebx + offset WindowExRec.w]
      mov esi, ebx
      mov ebx, [es:ebx + offset WindowExRec.style]
      call g_create_win
    pop edi
    test al, al
    jnz near l_s_g_prepare_94
      // winid, pid
      mov [es:edi + offset WindowExRec.winid], edx
      mov eax, p_current
      mov eax, [es:eax + offset ThreadRec.process]
      sub eax, VA_PROCS
      shr eax, 9 // assert sizeof ProcessRec = 512
      mov [es:edi + offset WindowExRec.pid], eax
      // alloc pwintext
      mov ecx, 80 * 25 * 2
      mov [es:edi + offset TextWinRec.winsize], ecx
      mov [es:edi + offset TextWinRec.winmax], ecx
      push edi
       push edx
        call m_heap_alloc_local
       pop edx
      pop edi
      test al, al
      jnz near l_s_g_prepare_93
        mov [es:edi + offset TextWinRec.pwintext], ebx
        // cls
        push edi
          mov edi, ebx
          mov ax, 0720h
          mov ecx, 80 * 25
          rep stosw
        pop edi
        // set stdout
        mov eax, STDOUT_WIN
        or eax, edx
        mov ebx, p_current
        mov [es:ebx + offset ThreadRec.stdout], eax
        // create painting thread
        push edi
          call p_create_thread_inner
          and dword [es:edi + offset ThreadRec.flags], -1 - THREAD_FLAGS_USE_FPU
          mov ebx, edi
        pop edi
        mov [es:edi + offset TextWinRec.thread], ebx // save thread
        test al, al
        jnz l_s_g_prepare_92
          mov [es:ebx + offset TssRec.edx], edi
          mov dword ptr [es:ebx + offset TssRec.eip], offset s_painting_thread
          // WM_SIZE (alloc bitmap)
          movzx eax, word ptr [es:edi + offset WindowExRec.w]
          movzx ecx, word ptr [es:edi + offset WindowExRec.h]
          mul ecx
          xchg eax, ecx
          shl ecx, 2
          add ecx, 8  // ecx = w * h * 4 + 8
          push edi
           push ebx
            call m_heap_alloc_local
            mov esi, ebx
           pop ebx
          pop edi
          movzx eax, byte ptr [es:edi + offset WindowExRec.winid]
          shl eax, 5  // assert sizeof WinRec = 32
          mov win.pbitmap[eax], esi
          test esi, esi
          jz l_s_g_prepare_7
            movzx eax, word ptr [es:edi + offset WindowExRec.w]
            movzx ecx, word ptr [es:edi + offset WindowExRec.h]
            mov [es:esi], eax
            mov [es:esi + 4], ecx
            
          l_s_g_prepare_7:
          // start painting thread
          mov edi, ebx
          call p_start
          
          mov al, 0
          jmp short l_s_g_prepare_99

l_s_g_prepare_92:  // release pwintext
push eax
  mov ebx, [es:edi + offset TextWinRec.pwintext]
  push edi
    call m_heap_free_local
  pop edi
pop eax

l_s_g_prepare_93:  // release win
push eax
  mov al, [es:edi + offset WindowExRec.winid]
  push edi
    call g_destroy_win
  pop edi
pop eax

l_s_g_prepare_94:  // release hwnd
push eax
  mov ebx, edi
  call m_heap_free_local
pop eax

l_s_g_prepare_95:
mov ebx, p_current  // give back stdout
xor edx, edx
mov [es:ebx + offset ThreadRec.stdout], edx

l_s_g_prepare_99:

   pop esi
  pop ecx
 pop edx
pop ebx
ret

s_painting_thread:
sti
mov edi, p_current
mov edx, [es:edi + offset TssRec.edx]  // edx -> TextWinRec

call s_g_paint_caption  // keep edx

l_s_painting_thread_5:
  mov ebx, [es:edx + offset TextWinRec.wnd.winid]
  cmp bh, wdesktop
  jnz l_s_painting_thread_8
    movzx ebx, bl
    shl ebx, 5  // assert sizeof WinRec = 32
    mov edi, win.pbitmap[ebx]
    mov eax, win.flags[ebx]
    test eax, WS_MINIMIZE
    jnz l_s_painting_thread_8
      mov esi, [es:edx + offset TextWinRec.pwintext]
      mov ebx, [es:edx + offset TextWinRec.curx]  // x, y, state, rsv1
      test esi, esi
      jz l_s_painting_thread_8
        add esi, [es:edx + offset TextWinRec.winofs]
        test edi, edi
        jz l_s_painting_thread_8
          cmp esi, VA_ACCESS
          jnb l_s_painting_thread_8
            cmp edi, VA_ACCESS - (TEXTWIN_W * TEXTWIN_H * 4)
            jna l_s_painting_thread_6
          
  l_s_painting_thread_8:
  // sleep
  push edx
    mov ecx, BLINK_SLEEP
    call p_sleep
  pop edx
  
  inc byte ptr [es:edx + offset TextWinRec.state]
  jmp l_s_painting_thread_5


l_s_painting_thread_6:  // IN: esi, edi, ebx
push edx
  mov ax, [es:edi]
  cmp ax, TEXTWIN_W
  jnz near l_s_painting_thread_69
   mov ax, [es:edi + 4]
   cmp ax, TEXTWIN_H
   jnz near l_s_painting_thread_69
    add edi, 8 + (((WIN_HEADER + WIN_BORDER) * TEXTWIN_W + WIN_BORDER) * 4)
    xor ecx, ecx
    
    l_s_painting_thread_65:  // char
      mov ax, [es:esi]
      add esi, 2
      
      push esi
       push ecx
        
        // blinking char
        test ah, 128
        jz l_s_painting_thread_652
          test ebx, 1 << 16
          jz l_s_painting_thread_652
            // only background
            movzx eax, ah
            shr al, 4
            and al, 7
            shl al, 2
            mov eax, [cs:eax + offset colors]
            mov dl, 16
            
            l_s_painting_thread_651:
              sub dl, 1
              jc near l_s_painting_thread_659  // next char
                mov ecx, 8  // 8 pixels
                rep stosd
                add edi, (TEXTWIN_W - 8) * 4
                jmp short l_s_painting_thread_651
            
        l_s_painting_thread_652:
        
        // char
        movzx esi, al
        shl esi, 4  // * 16
        add esi, offset text_bitmap  // esi
        
        push ebx
          
          mov ch, 16
          
          l_s_painting_thread_655:  // foreach row
            sub ch, 1
            jc l_s_painting_thread_658
              
              mov al, [cs:esi]  // al
              inc esi
              
              movzx ebx, ah
              shr bl, 4
              and bl, 7
              shl ebx, 2
              mov ebx, [cs:ebx + offset colors]  // ebx
              movzx edx, ah
              and dl, 15
              shl edx, 2
              mov edx, [cs:edx + offset colors]  // edx
              
              mov cl, 8
              
              l_s_painting_thread_6555:  // foreach pixel
                sub cl, 1
                jc l_s_painting_thread_6558
                  rol al, 1
                  test al, 1
                  jnz l_s_painting_thread_6556
                    // bg
                    xchg eax, ebx
                    stosd
                    xchg eax, ebx
                    jmp short l_s_painting_thread_6555
                    
                  l_s_painting_thread_6556:
                  // fg
                  xchg eax, edx
                  stosd
                  xchg eax, edx
                  jmp short l_s_painting_thread_6555
                  
              l_s_painting_thread_6558:
              add edi, (TEXTWIN_W - 8) * 4
              jmp short l_s_painting_thread_655
              
          l_s_painting_thread_658:
          
        pop ebx
        
        l_s_painting_thread_659:
        
       pop ecx
      pop esi
      
      // cursor  IN: cx, ebx, ah
      cmp cx, bx
      jnz l_s_painting_thread_66
        test ebx, 1 << 16  // state
        jz l_s_painting_thread_66
          movzx eax, ah
          and al, 15
          shl eax, 2
          mov eax, [cs:eax + offset colors]
          
          push ecx
            sub edi, (TEXTWIN_W * 2) * 4
            mov ecx, 8
            rep stosd
            add edi, (TEXTWIN_W - 8) * 4
            mov ecx, 8
            rep stosd
            add edi, (TEXTWIN_W - 8) * 4
          pop ecx
          
      l_s_painting_thread_66:
      // next char
      sub edi, (TEXTWIN_W * 16 - 8) * 4
      
      inc cl
      cmp cl, 80
      jb near l_s_painting_thread_65

      add edi, (TEXTWIN_W * 15 + (WIN_BORDER * 2)) * 4
      
      xor cl, cl
      inc ch
      cmp ch, 25
      jb near l_s_painting_thread_65
      
  l_s_painting_thread_69:
pop edx
push edx
  // IN: ecx = x1, ebx = y1, esi = x2, edi = y2
  movsx ecx, word ptr [es:edx + offset TextWinRec.wnd.x]
  movsx ebx, word ptr [es:edx + offset TextWinRec.wnd.y]
  movsx esi, word ptr [es:edx + offset TextWinRec.wnd.w]
  movsx edi, word ptr [es:edx + offset TextWinRec.wnd.h]
  add esi, ecx
  add edi, ebx
  dec esi
  dec edi
  call g_paint
pop edx
jmp l_s_painting_thread_8

//ret

// IN: ebx -> pwintext, dx = curpos
// OUT: edi -> pwintext + curpos
// KEEP: eax, ecx, edx, ebx, esi
s_g_calcpos:
mov edi, ebx
push eax
  mov al, 80
  mul dh
  add al, dl
  adc ah, 0
  movzx eax, ax
  cmp eax, 80 * 25
  jb l_s_g_calcpos_2
    mov eax, 80 * 25 - 1
    
  l_s_g_calcpos_2:
  shl eax, 1
  add edi, eax
pop eax
ret

// IN: dx = curpos, ebx = pwintext
// OUT: edi -> pwintext + curpos
// KEEP: eax, ecx, ebx, esi
s_g_newline:
xor dl, dl
inc dh
cmp dh, 25
jb l_s_g_newline_6
  // scroll screen
  mov edi, ebx
  push esi
   push ecx
    push eax
            
      push ds
        push es
        pop ds
        mov esi, edi
        add esi, 80 * 2
        mov ecx, 80 * (25 - 1)
        cld
        rep movsw
        mov ax, 720h
        mov ecx, 80
        rep stosw
      pop ds
      
    pop eax
   pop ecx
  pop esi
  mov dh, 25 - 1
  
l_s_g_newline_6:
jmp s_g_calcpos
//ret

// IN: ah = operation
services:

 push ds
  push es
  
   push SELECTOR_KERNEL_DATA
   pop ds
   push SELECTOR_ALL_DATA
   pop es
   
   movzx eax, ah
   shl eax, 2  // sizeof addr
   add eax, offset services_offsets
   cmp eax, offset services_offsets_end
   jb services_ok
     mov al, ERC_INVALID_SERVICE
     jmp short services_9
     
   services_ok:
   call dword[cs:eax]
   
   services_9:
   
  pop es
 pop ds

iretd

delay:
jmp short l_delay_8
l_delay_8:
ret

// DESTROY: al
empty_8042:
call delay
in al, 0x64		// 8042 status port
test al, 1		// Anything to read?
jz l_empty_8042_no_output
	call delay
	in al, 0x60	// Read it
	jmp	empty_8042
l_empty_8042_no_output:
test al, 2		// Is input buffer full?
jnz	empty_8042
ret

waitkey:
pushad
  l_wk_5:
    mov edi, p_current
    call p_stop
    call p_msg_get
    cmp ecx, WM_KEYDOWN
    jnz l_wk_5
popad
ret

// IN: ecx = ms
// KEEP all
busywait:
push eax
 push ecx

  l_busywait_1:
  test ecx, ecx
  jnz l_busywait_2

 pop ecx
pop eax
ret

l_busywait_2:
dec ecx
push ecx
  mov ecx, 10000
  
  l_busywait_3:
    in al, 7
    loop l_busywait_3
  
pop ecx
jmp short l_busywait_1

// IN: dl = x, dh = y
// DESTROY: ax, cx, dx
cursorto:
mov al, dh
mov ah, 80
mul ah
add al, dl
adc ah, 0
mov cx, ax
mov dx, 3D4h
mov al, 0Fh
out dx, al
mov al, cl
inc dx
out dx, al
dec dx
mov al, 0Eh
out dx, al
mov al, ch
inc dx
out dx, al
ret

TSCR_W = 80
TSCR_H = 25

// IN: cs:esi->string, cur_pos, ds = KERNEL_DATA
// OUT: cur_pos
writec:
push es
 push edi
  push edx
   push ecx
    push eax

mov cx, SELECTOR_TEXTVIDEO
mov es, cx

mov dx, cur_pos
call writec_calc

l_writec_1:
  mov al, [cs:esi]
  inc esi
  cmp al, 0
  jz l_writec_9
    cmp al, 13
    jz l_writec_1  // ignore CR

    cmp al, 10  // LF = new line
    jnz l_writec_3
      xor dl, dl
      inc dh
      cmp dh, TSCR_H
      jnb l_writec_2
        call writec_calc
        jmp l_writec_1
      
      l_writec_2:
      call writec_over_screen
      jmp l_writec_1
      
    l_writec_3:
    stosb
    inc edi  // skip color
    inc dl
    cmp dl, TSCR_W
    jb l_writec_1
    
    xor dl, dl
    inc dh
    cmp dh, TSCR_H
    jb l_writec_1
    
    call writec_over_screen
    jmp l_writec_1

l_writec_9:
mov cur_pos, dx
call cursorto

    pop eax
   pop ecx
  pop edx
 pop edi
pop es
ret

// IN: dl = curx, dh = cury
// OUT: edi
writec_calc:
push edx
  movzx eax, dh
  mov edi, 80
  mul edi  // eax = dh * 80
pop edx
add al, dl
adc ah, 0
shl eax, 1
mov edi, eax  // edi = (dh * 80 + dl) * 2
ret

// IN: dl, dh, es = SELECTOR_TEXTVIDEO
// OUT: dl, dh, edi
writec_over_screen:  // also used by s_write
dec dh
push esi
 push ecx
  push ds
    push es
    pop ds
    mov esi, TSCR_W * 2
    xor edi, edi
    mov ecx, TSCR_W * (TSCR_H - 1) * 2 / 4
    cld
    rep movsd
    mov ax, 0x0720
    mov ecx, TSCR_W
    rep stosw
  pop ds
 pop ecx
pop esi
mov edi, TSCR_W * (TSCR_H - 1) * 2
ret

// IN: es:esi -> stringz
// OUT: ecx
// KEEP: all but ecx
strlen:
xor ecx, ecx
push esi
  
  l_strlen_5:
  cmp byte ptr [es:esi], 0
  jz l_strlen_9
    inc ecx
    inc esi
    jmp short l_strlen_5
    
  l_strlen_9:
pop esi
ret

// IN: eax = number, ecx = base, cur_pos, bl = color, ds
// OUT: cur_pos
writen:
push ecx
 push edx
  push ebx
   push esi
    push edi

sub esp, 36

// Parse digits from the number

mov esi, esp
add esi, 36

cmp ecx, 2
jnb l_writen_1
  mov ecx, 10  // ecx must be >= 2

l_writen_1:
  xor edx, edx
  div ecx
  cmp dl, 10
  jnb l_writen_2
    add dl, '0'
    jmp short l_writen_3
  
  l_writen_2:
  add dl, 55
  
  l_writen_3:
  dec esi
  mov [ss:esi], dl
  test eax, eax
  jnz l_writen_1

mov dl, ' '
dec esi
mov [ss:esi], dl

mov ecx, esp
add ecx, 36
sub ecx, esi  // ecx = len

// Write it
call s_write

add esp, 36

    pop edi
   pop esi
  pop ebx
 pop edx
pop ecx
ret

// IN: dl = x, dh = y, es:edi -> buffer
writesect:
push ds
 push esi
  push es
   push edi

	movzx eax, dh
	mov cl, 80
	mul cl
	add al, dl
	adc ah, 0
	shl ax, 1
	mov esi, edi
	push es
	pop ds		// ds:esi = es:edi
	mov edi, eax	// edi = (y*80+x)*2
	add ax, 160
	mov ebx, eax	// ebx = (y*80+x)*2 + 160
	mov dx, SELECTOR_TEXTVIDEO
	mov es, dx	// es = textvideo
	cld
	mov ecx, 16

	l_writesect_2:
	push ecx
	 mov ecx, 32
	 l_writesect_3:
		lodsb
		cmp al, 32
		jb l_writesect_61
			mov ah, 71h
			jmp short l_writesect_62
		l_writesect_61:
			add al, 64
			mov ah, 30h
		l_writesect_62:
		stosw
	 loop l_writesect_3
	 mov edi, ebx
	 add ebx, 160
	pop ecx
	loop l_writesect_2

   pop edi
  pop es
 pop esi
pop ds
ret

WREGS_COLOR = 7

wregs1: db "\n | acdb = "
wregs2: db " | sbsd = "

wregs:
pushad
  mov ebp, esp
  
  mov esi, offset wregs1 + VA_SYSTEM + PA_KERNEL_CODE
  mov ecx, 10
  mov bl, WREGS_COLOR
  call s_write
  
  mov eax, [ebp + 28]
  mov ecx, 16
  mov bl, WREGS_COLOR
  call writen
  
  mov eax, [ebp + 24]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 20]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 16]
  mov ecx, 16
  call writen
  
  
  mov esi, offset wregs2 + VA_SYSTEM + PA_KERNEL_CODE
  mov ecx, 9
  mov bl, WREGS_COLOR
  call s_write
  
  mov eax, [ebp + 12]
  mov ecx, 16
  mov bl, WREGS_COLOR
  call writen
  
  mov eax, [ebp + 8]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 4]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 0]
  mov ecx, 16
  call writen

popad
ret

ww:
call wregs

pushad
  l_ww_5:
    mov edi, p_current
    call p_stop
    call p_msg_get
    cmp ecx, WM_KEYDOWN
    jnz l_ww_5
popad

ret

// IN: es:esi -> stringz, bl = color
wrs:
pushad
  call strlen
  call s_write
popad
ret

// IN: bl = color
wrf:
pushad
  mov ebp, esp
  sub esp, 80
    
    mov esi, esp
    fst dword [ss:ebp - 4]
    mov eax, [ss:ebp - 4]
    
    // sign
    test eax, 0x80000000
    jz l_wrf_11
      mov byte ptr [ss:esi], '-'
      jmp short l_wrf_12
      
    l_wrf_11:
      mov byte ptr [ss:esi], '+'
      
    l_wrf_12:
    inc esi
    
    // M
    mov byte ptr [ss:esi], '1'
    inc esi
    mov byte ptr [ss:esi], '.'
    inc esi
    mov edx, 1 << 22
    mov ecx, 23
    
    l_wrf_15:
      test eax, edx
      jz l_wrf_151
        mov byte ptr [ss:esi], '1'
        jmp short l_wrf_152
        
      l_wrf_151:
        mov byte ptr [ss:esi], '0'
        
      l_wrf_152:
      inc esi
      shr edx, 1
      loop l_wrf_15
    
    // E
    mov byte ptr [ss:esi], 'E'
    inc esi
    shr eax, 23
    movzx eax, al
    sub eax, 127
    jnl l_wrf_22
      mov byte ptr [ss:esi], '-'
      neg eax
      jmp short l_wrf_23
      
    l_wrf_22:
      mov byte ptr [ss:esi], '+'
      
    l_wrf_23:
    inc esi
    mov ecx, 100
    xor edx, edx
    div ecx
    add al, 48
    mov byte ptr [ss:esi], al
    inc esi
    
    mov ecx, 10
    xchg eax, edx
    xor edx, edx
    div ecx
    add al, 48
    mov byte ptr [ss:esi], al
    inc esi
    
    add dl, 48
    mov byte ptr [ss:esi], dl
    inc esi
    
    // write
    mov ecx, esi
    sub ecx, esp
    mov esi, esp
    call s_write
    
  mov esp, ebp
popad
ret

TMR_MAX = SIZE_TMR / sizeof TmrRec

TMR_PREEMPT_MS = 10
TMR_MAX_MS     = 50

TMR_THREADID_WND_PREEMPT = 0FFFFF000h
TMR_THREADID_WND_WAKE    = 0F001h
TMR_THREADID_WND_FDSTOP  = 0FFFFF002h
TMR_THREADID_WND_MS      = 0FFFFF003h

TMR_FLAGS_PREEMPT = 1
TMR_FLAGS_MS = 2

[dalign 32]
uns4 tmr_len, tmr_t_ofs, tmr_usb_timerticks
uns1 tmr_flags, tmr_ms_seconds, tmr_usb_count

// Set Timer
// IN: dx = number of ticks
h_timer_set:
mov al, 30h
out 43h, al
mov al, dl
out 40h, al
mov al, dh
out 40h, al
ret

// Read Timer
// OUT: ax = number of ticks
h_timer_read:
mov al, 0
out 43h, al
in al, 40h
xchg al, ah
in al, 40h
xchg al, ah
ret

// IN: ecx = ticks, edx = threadid_wnd, ebx = id, tmr_t_ofs = ofs
// OUT: al = 0 || errorcode
// DESTROY: eax, esi, edi
h_timer_add_inner:
mov eax, tmr_len  // eax = len
cmp eax, TMR_MAX * sizeof TmrRec
jb l_h_timer_add_inner_1
  mov al, ERC_TIMER_FULL
  ret

l_h_timer_add_inner_1:
mov esi, PA_TMR
mov edi, esi
add edi, eax  // edi = base + len

cmp edi, esi
jz l_h_timer_add_inner_6	// first and only

// Insert to delta queue
l_h_timer_add_inner_2:
  cmp edi, esi
  jng l_h_timer_add_inner_6
    // edi > esi
    sub edi, sizeof TmrRec
    mov eax, [edi + offset TmrRec.ticks]  // eax = ticks
    cmp ecx, eax
    jna l_h_timer_add_inner_5
      // new_ms > old_ms: [i+1] = [i]
      sub ecx, eax  // new_ms -= old_ms
      mov [edi + sizeof TmrRec + offset TmrRec.ticks], eax
      
      mov eax, [edi + offset TmrRec.threadid_wnd]
      mov [edi + sizeof TmrRec + offset TmrRec.threadid_wnd], eax
      
      mov eax, [edi + offset TmrRec.id]
      mov [edi + sizeof TmrRec + offset TmrRec.id], eax
      
      mov eax, [edi + offset TmrRec.ofs]
      mov [edi + sizeof TmrRec + offset TmrRec.ofs], eax
      
      jmp l_h_timer_add_inner_2
      
    l_h_timer_add_inner_5:
    sub [edi + offset TmrRec.ticks], ecx  // old_ms -= new_ms
    add edi, sizeof TmrRec
    
l_h_timer_add_inner_6:
// Proper space found at edi: store new rec
mov [edi + offset TmrRec.ticks], ecx
mov [edi + offset TmrRec.threadid_wnd], edx
mov [edi + offset TmrRec.id], ebx
mov eax, tmr_t_ofs
mov [edi + offset TmrRec.ofs], eax
// tmr_len++
add tmr_len, sizeof TmrRec

mov al, 0
ret

// IN: tmr_len
// OUT: tmr_len, tmr_flags
// DESTROY: eax, ecx, edx, esi, edi
h_timer_process:
mov esi, PA_TMR
mov edi, tmr_len
add edi, esi  // edi = esi + len
mov tmr_flags, 0

l_h_timer_process_1:
  cmp edi, esi
  jg l_h_timer_process_2

l_h_timer_process_8:
ret

  l_h_timer_process_2:
    // edi > esi
    sub edi, sizeof TmrRec
    mov eax, [edi + offset TmrRec.ticks]
    test eax, eax
    jnz l_h_timer_process_8
      // last.ticks == 0
      sub tmr_len, sizeof TmrRec  // tmr_len--
      mov eax, [edi + offset TmrRec.threadid_wnd]
      cmp ax, 0F000h
      jb near l_h_timer_process_5
        
        // * System timers *
        
        cmp ax, TMR_THREADID_WND_PREEMPT
        jnz l_h_timer_process_31
          
          // Preempt
          or tmr_flags, TMR_FLAGS_PREEMPT
          jmp l_h_timer_process_1
          
        l_h_timer_process_31:
        cmp ax, TMR_THREADID_WND_WAKE
        jnz l_h_timer_process_32
                  
          // Wake
          push esi
           push edi
            mov edi, [edi + offset TmrRec.id]
            and byte ptr [es:edi + offset ThreadRec.flags], -1 - THREAD_FLAGS_DONT_WAKE_BY_MESSAGE
            call p_start  // edi = thread VA
           pop edi
          pop esi
          jmp l_h_timer_process_1
          
        l_h_timer_process_32:
        cmp ax, TMR_THREADID_WND_FDSTOP
        jnz l_h_timer_process_33
        
          // Stop FD motor
          call h_fd_stop_motor_mask
          jmp l_h_timer_process_1
          
        l_h_timer_process_33:
        cmp ax, TMR_THREADID_WND_MS
        jnz l_h_timer_process_34
        
          // inc ms
          inc tmr_ms
          mov al, 0
          out 70h, al  // RTC seconds
          in al, 71h
          cmp al, tmr_ms_seconds
          jz l_h_timer_process_331
            mov tmr_ms_seconds, al
            xor eax, eax
            mov tmr_ms, ax
          
          l_h_timer_process_331:
          or tmr_flags, TMR_FLAGS_MS
          // usb timer
          inc tmr_usb_count
          cmp tmr_usb_count, 10
          jb near l_h_timer_process_1
            mov tmr_usb_count, 0
            inc tmr_usb_timerticks
            jmp l_h_timer_process_1
          
        l_h_timer_process_34:
        //... error
        jmp l_h_timer_process_1
        
      l_h_timer_process_5:
      
      // * Window timer *
      
      // data at [edi + offset TmrRec.x]
      // Post message(ebx = winid:threadid, ecx = msg, edx = wp, esi = lp)
      push ecx
       push ebx
        push esi
         push edi
          mov ebx, eax  // ebx = threadid:winid
          mov edx, eax
          shr ebx, 16
          shl edx, 16
          or ebx, 16384
          or ebx, edx   // ebx = winid:(threadid+16384)
          mov ecx, WM_TIMER
          mov edx, [edi + offset TmrRec.id]  // wp = id
          mov esi, [edi + offset TmrRec.ofs]  // lp = ofs
          call p_msg_post
         pop edi
        pop esi
       pop ebx
      pop ecx
      jmp l_h_timer_process_1
      
// <-- h_timer_process

// IN: tmr_len, tmr_total
// OUT: tmr_total
// DESTROY: eax, edx, ebx, esi, edi
h_timer_set_first:

// Make ticks

mov esi, PA_TMR
mov edi, tmr_len  // edi = len
or edi, edi
jnz l_h_timer_set_first_2

  // No record
  mov ax, TMR_MAX_MS * 1193
  jmp short l_h_timer_set_first_6
  
l_h_timer_set_first_2:
add edi, esi
sub edi, sizeof TmrRec  // edi = esi + len - 1
mov eax, [edi + offset TmrRec.ticks]  // eax = last.ticks
cmp eax, TMR_MAX_MS * 1193
ja l_h_timer_set_first_4

  // ms <= 50; eax = ticks
  xor ebx, ebx
  mov [edi + offset TmrRec.ticks], ebx  // last.ticks = 0
  jmp short l_h_timer_set_first_6

l_h_timer_set_first_4:
  // ms > 50; eax = ticks
  sub eax, TMR_MAX_MS * 1193
  mov [edi + offset TmrRec.ticks], eax  // last.ticks -= max
  mov ax, TMR_MAX_MS * 1193

l_h_timer_set_first_6:

// Set timer by ticks; IN: ax = ticks
movzx edx, ax
call h_timer_set  // KEEP edx

// Add ticks to CurrentThread and total
mov edi, p_current
add [es:edi + offset ThreadRec.tmr_spent], edx

add tmr_total, edx

ret

// BEFORE: p_init
// IN: PA_TMR, SIZE_TMR
h_timer_init:
xor eax, eax
mov tmr_flags, al  // flags = 0
mov tmr_len, eax   // len = 0
mov tmr_total, eax // total = 0

mov tmr_ms, ax
mov tmr_ms_seconds, al

mov tmr_usb_timerticks, eax
mov tmr_usb_count, al

mov ecx, TMR_PREEMPT_MS * 1193
mov edx, TMR_THREADID_WND_PREEMPT
xor ebx, ebx
mov tmr_t_ofs, ebx
call h_timer_add_inner

mov ecx, 1194
mov edx, TMR_THREADID_WND_MS
xor ebx, ebx
mov tmr_t_ofs, ebx
call h_timer_add_inner

call h_timer_set_first

ret

// IN: ecx = ticks, edx = threadid_wnd, ebx = id, edi = ofs
// OUT: al = 0 || errorcode, esi = base
h_timer_add:
pushfd
  cli
  
  mov tmr_t_ofs, edi
  
  mov eax, tmr_len
  cmp eax, TMR_MAX * sizeof TmrRec
  jb l_h_timer_add_1
    
    popfd
    
    mov al, ERC_TIMER_FULL
    
    ret
  
  l_h_timer_add_1:
  mov esi, PA_TMR  // esi = base
  
  test eax, eax
  jz l_h_timer_add_6 // first and only
    
    mov edi, esi
    add edi, eax     // edi = base + len
    
    // Update last.ticks by timer
    xor eax, eax
    call h_timer_read
    add [edi - sizeof TmrRec + offset TmrRec.ticks], eax
    
  l_h_timer_add_6:
  // Insert to delta queue
  call h_timer_add_inner
  
  // Process 0s
  call h_timer_process
  
  // Set timer by last.ticks
  call h_timer_set_first
  
popfd

mov al, 0
ret

// IN: edx = threadid_wnd, ebx = id
// OUT: al = 0 || errorcode
h_timer_remove:

pushfd
cli

mov esi, PA_TMR  // esi = base
mov eax, tmr_len

mov edi, esi
add edi, eax     // edi = base + len
// find edx, ebx
l_h_timer_remove_2:
  cmp edi, esi
  jng l_h_timer_remove_6
    // edi > esi
    sub edi, sizeof TmrRec
    cmp edx, [edi + offset TmrRec.threadid_wnd]
    jnz l_h_timer_remove_2
      cmp ebx, [edi + offset TmrRec.id]
      jnz l_h_timer_remove_2

l_h_timer_remove_5:
// Found, esi = base
mov eax, tmr_len
sub eax, sizeof TmrRec
mov tmr_len, eax  // tmr_len--
mov ebx, esi
add ebx, eax      // ebx = base + new_len

cmp edi, esi
jna l_h_timer_remove_52
  // edi > base
  mov ecx, [edi + offset TmrRec.ticks]
  add [edi - sizeof TmrRec + offset TmrRec.ticks], ecx

l_h_timer_remove_52:
cmp edi, ebx
jnb l_h_timer_remove_7
    // edi < ebx: [i] = [i+1]
    mov ecx, [edi + sizeof TmrRec + offset TmrRec.ticks]
    mov eax, [edi + sizeof TmrRec + offset TmrRec.threadid_wnd]
    mov [edi + offset TmrRec.ticks], ecx
    mov [edi + offset TmrRec.threadid_wnd], eax
    mov ecx, [edi + sizeof TmrRec + offset TmrRec.id]
    mov eax, [edi + sizeof TmrRec + offset TmrRec.ofs]
    mov [edi + offset TmrRec.id], ecx
    mov [edi + offset TmrRec.ofs], eax
  
    add edi, sizeof TmrRec
    jmp l_h_timer_remove_52
  
  l_h_timer_remove_6:
  mov al, ERC_TIMER_NOT_FOUND
  jmp short l_h_timer_remove_9
  
l_h_timer_remove_7:
mov al, 0

l_h_timer_remove_9:

popfd

ret

// IN: edi = threadptr
// KEEP: edi
h_timer_remove_all:
push edi
 pushfd
  cli
  
  // threadptr -> threadid
  mov edx, edi
  sub edx, VA_THREADS
  shr edx, 12 // assert sizeof ThreadRec = 4096
  
  mov esi, PA_TMR
  mov edi, esi
  mov ebx, tmr_len
  add ebx, esi  // ebx = base + len
/*  
  cmp ebx, esi
  jz h_timer_remove_all_5
    
    // Update last.ticks by timer
    xor eax, eax
    call h_timer_read
    add [ebx - sizeof TmrRec + offset TmrRec.ticks], eax
*/    
  h_timer_remove_all_5:
    cmp esi, ebx
    jnb h_timer_remove_all_8
      cmp word ptr [esi + offset TmrRec.threadid_wnd + 2], dx
      jz h_timer_remove_all_6
        add edi, sizeof TmrRec
        jmp short h_timer_remove_all_7
        
      h_timer_remove_all_6:
      cmp edi, PA_TMR
      jna h_timer_remove_all_7
        mov eax, [esi + offset TmrRec.ticks]
        add [edi + offset TmrRec.ticks - sizeof TmrRec], eax
        
      h_timer_remove_all_7:
      add esi, sizeof TmrRec
      cmp esi, edi
      jz h_timer_remove_all_5
        mov eax, [esi + 0]
        mov ecx, [esi + 4]
        mov [edi + 0], eax
        mov [edi + 4], ecx
        mov eax, [esi + 8]
        mov ecx, [esi + 12]
        mov [edi + 8], eax
        mov [edi + 12], ecx
        jmp h_timer_remove_all_5
      
  h_timer_remove_all_8:
  sub edi, PA_TMR
  mov tmr_len, edi
/*  
  // Process 0s
  call h_timer_process
  
  // Set timer by last.ticks
  call h_timer_set_first
*/
 popfd
pop edi
ret

IRQ0:
pushad
 push ds
  push es
    mov dx, SELECTOR_KERNEL_DATA
    mov ds, dx  // ds = KERNEL_DATA
    mov bx, SELECTOR_ALL_DATA
    mov es, bx  // es = ALLMEM

    // Process ms == 0
    mov esi, PA_TMR
    call h_timer_process

    // System timer of preemption
    test tmr_flags, TMR_FLAGS_PREEMPT
    jz l_IRQ0_6
      mov ebx, p_current
      mov edi, [es:ebx + offset ThreadRec.next]
      mov ecx, [es:edi + offset ThreadRec.priority]
      mov edx, TMR_THREADID_WND_PREEMPT
      xor ebx, ebx
      mov tmr_t_ofs, ebx
      call h_timer_add_inner

    l_IRQ0_6:
    // ms
    test tmr_flags, TMR_FLAGS_MS
    jz l_IRQ0_7
      mov ecx, 1194
      mov edx, TMR_THREADID_WND_MS
      xor ebx, ebx
      mov tmr_t_ofs, ebx
      call h_timer_add_inner
    
    l_IRQ0_7:
    // Set timer by last.ticks
    call h_timer_set_first

    // End of ISR
    mov al, 0x20
    out 0x20, al

    // Preempt?
    test tmr_flags, TMR_FLAGS_PREEMPT
    jz l_IRQ0_8

      mov esi, p_current
      mov edi, [es:esi + offset ThreadRec.next]
      call p_switch_task

    l_IRQ0_8:

  pop es
 pop ds
popad
iretd

KBD_LED_SCROLL = 1
KBD_LED_NUM    = 2
KBD_LED_CAPS   = 4

KBD_RSH  = 1
KBD_LSH  = 2
KBD_CTRL = 4
KBD_ALT  = 8
KBD_SCRLK = 0x10
KBD_NUMLK = 0x20
KBD_CPSLK = 0x40
KBD_INS   = 0x80
KBD_RCTRL = 0x400
KBD_RALT  = 0x800
KBD_VCTRL = 0x1000

KBD_KCTRL = 0x1D
KBD_KLSH  = 0x2A
KBD_KRSH  = 0x36
KBD_KALT  = 0x38
KBD_KCPSLK = 0x3A
KBD_KNUMLK = 0x45
KBD_KSCRLK = 0x46

[dalign 32]
uns4 kbd_set_leds_ofs
uns2 kbd_shifts
uns1 kbd_special

// IN: ah = LEDs bitmap
// DESTROY: al
h_kbd_set_leds:
call empty_8042
mov al, 0xED
out 0x60, al
call empty_8042
mov al, ah
out 0x60, al
ret

// IN: al = scan code, ch & 0x80 = keyup,
//     ah = 1 || 2:special, kbd_shifts
// DESTROY: eax, ecx, edx, ebx, esi, edi
h_kbd_post_message:
test ch, 0x80
jz l_h_kbd_post_message5
  mov ecx, WM_KEYUP	// ecx = WM_KEYUP
  jmp short l_h_kbd_post_message6

l_h_kbd_post_message5:
mov ecx, WM_KEYDOWN	// ecx = WM_KEYDOWN

l_h_kbd_post_message6:
// Post Message
// IN: ebx = winid:target, ecx = msg, edx = wp, esi = lp
// OUT: al = 0 || errorcode
mov ebx, WIN_NONE << 16 + 16384 + 0
movzx edx, al          // edx = scan code + ((0 || 1) * 100h)
test ah, 2
jz l_h_kbd_post_message7
  or dx, 256

l_h_kbd_post_message7:
movzx esi, kbd_shifts  // esi = kbd_shifts
call p_msg_post
ret

// IN: al = keydown || (keyup + 80h), kbd_special, kbd_set_leds_ofs
h_kbd_process:
mov ch, al
and al, 127
movzx ebx, al
mov ah, 1
mov cl, kbd_special
shl ah, cl
test ch, 0x80
jnz l_k_kbd_process_5
  or kbd_state[ebx], ah
  jmp short l_k_kbd_process_6

l_k_kbd_process_5:
  not ah
  and kbd_state[ebx], ah
  not ah

l_k_kbd_process_6:
cmp al, KBD_KCTRL
jz l_k_kbd_process_71
 cmp al, KBD_KALT
 jz l_k_kbd_process_72
  cmp al, KBD_KLSH
  jz l_k_kbd_process_73
   cmp al, KBD_KRSH
   jz l_k_kbd_process_74
    jmp l_k_kbd_process_8

// Shifts
l_k_kbd_process_71:
test ah, 4
jz l_IRQ_715
  mov dx, KBD_VCTRL
  jmp short l_k_kbd_process_7x

l_IRQ_715:
mov dx, KBD_CTRL
test ah, 2
jz l_k_kbd_process_7x
  or dx, KBD_RCTRL
  jmp short l_k_kbd_process_7x

l_k_kbd_process_72:
mov dx, KBD_ALT
test ah, 2
jz l_k_kbd_process_7x
  or dx, KBD_RALT
  jmp short l_k_kbd_process_7x

l_k_kbd_process_73:
mov dx, KBD_LSH
jmp short l_k_kbd_process_7x

l_k_kbd_process_74:
mov dx, KBD_RSH

l_k_kbd_process_7x:
test ch, 0x80
jnz l_k_kbd_process_7x5
  or kbd_shifts, dx
  jmp short l_k_kbd_process_9

l_k_kbd_process_7x5:
  not dx
  and kbd_shifts, dx
  jmp short l_k_kbd_process_9

// Locks
l_k_kbd_process_8:
test ch, 0x80
jnz l_k_kbd_process_9
  cmp al, KBD_KNUMLK
  jnz l_k_kbd_process_81
    test kbd_shifts, KBD_VCTRL
    jnz l_k_kbd_process_9
      xor byte kbd_shifts, KBD_NUMLK
      jmp short l_k_kbd_process_8x

  l_k_kbd_process_81:
  cmp al, KBD_KCPSLK
  jnz l_k_kbd_process_82
    xor byte kbd_shifts, KBD_CPSLK
    jmp short l_k_kbd_process_8x

  l_k_kbd_process_82:
  cmp al, KBD_KSCRLK
  jnz l_k_kbd_process_9
    xor byte kbd_shifts, KBD_SCRLK
    jmp short l_k_kbd_process_8x

l_k_kbd_process_8x:
push eax
 push ecx
  mov ah, byte kbd_shifts
  shr ah, 4
  and ah, 7
  call kbd_set_leds_ofs
 pop ecx
pop eax

l_k_kbd_process_9:
call h_kbd_post_message
mov kbd_special, 0
ret

// IN: ds
h_kbd_init:
xor eax, eax
mov kbd_special, al
mov kbd_shifts, ax

push es

 push ds
 pop es
 mov edi, offset kbd_state
 mov ecx, 128
 cld
 rep stosb

pop es

ret

IRQ1:
pushad
 push ds
  push es
    mov dx, SELECTOR_KERNEL_DATA
    mov ds, dx	// ds = KERNEL_DATA
    mov bx, SELECTOR_ALL_DATA
    mov es, bx	// es = ALLMEM
    
    in al, 0x60
    cmp al, 0xE0
    jnz l_IRQ1_0
      // Special
      mov kbd_special, 1
      jmp short l_IRQ1_99

    l_IRQ1_0:
    cmp al, 0xE1
    jnz l_IRQ1_1
      mov kbd_special, 2
      jmp short l_IRQ1_99
      
    l_IRQ1_1:
    mov kbd_set_leds_ofs, offset h_kbd_set_leds
    call h_kbd_process
    
    l_IRQ1_99:
    //in al, 61h
    //out 61h, al
    mov al, 0x20
    out 0x20, al
  pop es
 pop ds
popad
iretd

MOUSE_PS2 = 1
MOUSE_ATI_XL = 2
MOUSE_82C710 = 3
MOUSE_BUS = 4
MOUSE_MSBUS = 5

// ATI XL
ATIXL_MSE_CONTROL_PORT   = 0x23C
ATIXL_MSE_DATA_PORT      = 0x23D
ATIXL_MSE_SIGNATURE_PORT = 0x23E

ATIXL_MSE_READ_BUTTONS = 0x00
ATIXL_MSE_READ_X = 0x01
ATIXL_MSE_READ_Y = 0x02

// BUS
MSE_DATA_PORT      = 0x23C
MSE_SIGNATURE_PORT = 0x23D
MSE_CONTROL_PORT   = 0x23E
MSE_INTERRUPT_PORT = 0x23E
MSE_CONFIG_PORT    = 0x23F

MSE_READ_X_LOW  = 0x80
MSE_READ_X_HIGH = 0xA0
MSE_READ_Y_LOW  = 0xC0
MSE_READ_Y_HIGH = 0xE0

MSE_CONFIG_BYTE    = 0x91
MSE_DEFAULT_MODE   = 0x90
MSE_SIGNATURE_BYTE = 0xA5

// MS BUS
MS_MSE_DATA_PORT      = 0x23D
MS_MSE_SIGNATURE_PORT = 0x23E
MS_MSE_CONTROL_PORT   = 0x23C
MS_MSE_CONFIG_PORT    = 0x23F

MS_MSE_READ_BUTTONS = 0x00
MS_MSE_READ_X = 0x01
MS_MSE_READ_Y = 0x02

MS_MSE_START = 0x80
MS_MSE_COMMAND_MODE = 0x07

uns1 ms_packetsize, ms_resolution, ms_samplerate

[dalign 32]
uns4 ms_i
int2 ms_x_sen, ms_y_sen, ms_x, ms_y, ms_z, ms_x_old, ms_y_old, ms_z_old
uns1 ms_type, ms_cnt, ms_sen, ms_btn, ms_btn_old, ms_packet[16]
bool ms_present

h_mouse_init:
mov ms_sen, 0
mov ms_resolution, 3
mov ms_samplerate, 100

mov ms_packetsize, 3

mov ms_type, 0

call h_ps2mouse_init
call h_atixlmouse_init
call h_busmouse_init

xor eax, eax
mov ms_cnt, al
mov ms_btn, al
mov word ms_z, ax
mov cl, ms_sen

mov dx, g_info.xres
shr dx, 1
mov ms_x, dx
mov ms_x_old, dx
shl dx, cl
mov word ms_x_sen, dx

mov dx, g_info.yres
shr dx, 1
mov ms_y, dx
mov ms_y_old, dx
shl dx, cl
mov word ms_y_sen, dx

ret

// IN: ms_btn, kbd_shifts, ms_x, ms_y
// OUT: edx, esi
// KEEP: eax, ecx, ebx, edi
h_mouse_prepare:
xor edx, edx
test ms_btn, 1
jz l_mouse_common_11
  or dl, MK_LBUTTON
  
l_mouse_common_11:
test ms_btn, 2
jz l_mouse_common_12
  or dl, MK_RBUTTON
  
l_mouse_common_12:
test kbd_shifts, KBD_RSH | KBD_LSH
jz l_mouse_common_13
  or dl, MK_SHIFT
  
l_mouse_common_13:
test kbd_shifts, KBD_CTRL
jz l_mouse_common_14
  or dl, MK_CONTROL
  
l_mouse_common_14:
test ms_btn, 4
jz l_mouse_common_15
  or dl, MK_MBUTTON
  
l_mouse_common_15:
test ms_btn, 8
jz l_mouse_common_16
  or dl, MK_XBUTTON1
  
l_mouse_common_16:
test ms_btn, 16
jz l_mouse_common_17
  or dl, MK_XBUTTON2
  
l_mouse_common_17:
mov si, ms_y
shl esi, 16
mov si, ms_x
ret

h_mouse_common:
mov cl, ms_sen
// screen
cmp ms_x_sen, 0
jnl l_mouse_common_01
  mov ms_x_sen, 0
  
l_mouse_common_01:
mov ax, ms_x_sen
mov dx, g_info.xres
shl dx, cl
cmp ax, dx
jl l_mouse_common_02
  dec dx
  mov ms_x_sen, dx
  
l_mouse_common_02:
cmp ms_y_sen, 0
jnl l_mouse_common_03
  mov ms_y_sen, 0
  
l_mouse_common_03:
mov ax, ms_y_sen
mov dx, g_info.yres
shl dx, cl
cmp ax, dx
jl l_mouse_common_04
  dec dx
  mov ms_y_sen, dx
  
l_mouse_common_04:
// sensitivity
mov ax, ms_x_sen
sar ax, cl
mov ms_x, ax
mov ax, ms_y_sen
sar ax, cl
mov ms_y, ax
// * Post message(s) *
mov ax, ms_x
cmp ax, ms_x_old
jnz l_mouse_common_1
  mov ax, ms_y
  cmp ax, ms_y_old
  jz l_mouse_common_2

l_mouse_common_1:
// post message WM_MOUSEMOVE
mov ebx, WIN_NONE << 16 + 16384 + 0
mov ecx, WM_MOUSEMOVE
call h_mouse_prepare
call p_msg_post

mov ax, ms_x
mov ms_x_old, ax
mov ax, ms_y
mov ms_y_old, ax

l_mouse_common_2:
mov al, ms_btn
cmp al, ms_btn_old
jz l_mouse_common_3
  // post message WM_MOUSEBUTTON
  mov ebx, WIN_NONE << 16 + 16384 + 0
  mov ecx, WM_MOUSEBUTTON
  call h_mouse_prepare
  call p_msg_post
  
  mov al, ms_btn
  mov ms_btn_old, al

l_mouse_common_3:
mov ax, ms_z
cmp ax, ms_z_old
jz l_mouse_common_4
  // post message WM_MOUSEWHEEL
  mov ebx, WIN_NONE << 16 + 16384 + 0
  mov ecx, WM_MOUSEWHEEL
  //... call h_mouse_prepare
  call p_msg_post
  
  mov ax, ms_z
  mov ms_z_old, ax

l_mouse_common_4:
ret

IRQ5:
pushad
 push ds
  push es
    mov dx, SELECTOR_KERNEL_DATA
    mov ds, dx  // ds = KERNEL_DATA
    mov bx, SELECTOR_ALL_DATA
    mov es, bx  // es = ALLMEM
    
    cmp ms_type, MOUSE_ATI_XL
    jnz l_IRQ5_2
      call h_atixlmouse_isr
      jmp short l_IRQ5_8
      
    l_IRQ5_2:
    cmp ms_type, MOUSE_BUS
    jnz l_IRQ5_3
      call h_busmouse_isr
      jmp short l_IRQ5_8
      
    l_IRQ5_3:
    cmp ms_type, MOUSE_MSBUS
    jnz l_IRQ5_4
      call h_msbusmouse_isr
      jmp short l_IRQ5_8
      
    l_IRQ5_4:
    
    //...
    
    l_IRQ5_8:
    
    call h_mouse_common
    
    l_IRQ5_9:
    mov al, 20h
    out 20h, al
  pop es
 pop ds
popad
iretd

uns1 ps2mouse_tries, ps2mouse_resends, ps2mouse_cmd_byte

// OUT: al = value, ah = 0(ok) || 1(error)
// KEEP: all but eax
h_kbd_read:
push ecx
  mov ecx, 0xFFFFF
  
  l_h_kbd_read_5:
    in al, 0x64
    test al, 1
    jnz l_h_kbd_read_ready
      loop l_h_kbd_read_5
      
      mov ah, 1
      jmp l_h_kbd_read_9
  
  l_h_kbd_read_ready:
  in al, 0x60
  xor ah, ah
  
  l_h_kbd_read_9:
pop ecx
ret

// IN: al = value
// OUT: ah = 0(ok) || 1(error)
// KEEP: all but eax
h_kbd_write:
push ecx
  mov ah, al
  mov ecx, 0xFFFFF
  
  l_h_kbd_write_5:
    in al, 0x64
    test al, 2
    jz l_h_kbd_write_ready
      loop l_h_kbd_write_5
      
      mov ah, 1
      jmp short l_h_kbd_write_9
  
  l_h_kbd_write_ready:
  mov al, ah
  out 0x60, al
  xor ah, ah
  
  l_h_kbd_write_9:
pop ecx
ret

// IN: bl = value
// OUT: ah = 0(ok) || 1(error)
// KEEP: edx, ebx, esi, edi
h_kbd_cmd:
mov ecx, 0xFFFFF

l_h_kbd_cmd_5:
  in al, 0x64
  test al, 2
  jz l_h_kbd_cmd_ready
    loop l_h_kbd_cmd_5
    
    mov ah, 1
    jmp l_h_kbd_cmd_9

l_h_kbd_cmd_ready:
mov al, bl
out 0x64, al
xor ah, ah

l_h_kbd_cmd_9:
ret

// OUT: cf = 0(ok) || 1(error), al = value
h_ps2mouse_read:
mov ps2mouse_tries, 100

l_h_ps2mouse_read_5:
  call h_kbd_read
  cmp ah, 1
  jne l_h_ps2mouse_read_9
    mov ecx, 10
    call p_sleep
    dec ps2mouse_tries
    jnz l_h_ps2mouse_read_5
stc
ret

l_h_ps2mouse_read_9:
clc
ret

// IN: al = value
// OUT: cf = 0(ok) || 1(error)
h_ps2mouse_cmd:
mov ps2mouse_cmd_byte, al
mov ps2mouse_resends, 5

l_h_ps2mouse_cmd_resend:
  mov bl, 0xD4
  call h_kbd_cmd
  cmp ah, 1
  je l_h_ps2mouse_cmd_fail
    mov al, ps2mouse_cmd_byte
    call h_kbd_write
    cmp ah, 1
    je l_h_ps2mouse_cmd_fail
      cmp ps2mouse_cmd_byte, 0xF5
      je l_h_ps2mouse_cmd_ok
        call h_ps2mouse_read
        cmp al, 0xFA  // ack
        jne l_h_ps2mouse_cmd_noack

l_h_ps2mouse_cmd_ok:
clc
ret

l_h_ps2mouse_cmd_noack:
cmp al, 0xFE  // resend
jne l_h_ps2mouse_cmd_fail
  dec ps2mouse_resends
  jnz l_h_ps2mouse_cmd_resend
  
l_h_ps2mouse_cmd_fail:
stc
ret

h_ps2mouse_detect:
mov bl, 0xA8  // enable mouse interface
call h_kbd_cmd
cmp ah, 1
jz l_h_ps2mouse_detect_fail
  mov al, 0xFF  // reset
  call h_ps2mouse_cmd
  jc l_h_ps2mouse_detect_fail
    call h_ps2mouse_read
    jc l_h_ps2mouse_detect_fail
      cmp al, 0xAA
      jne l_h_ps2mouse_detect_fail  // dead mouse
        // get device ID
        call h_ps2mouse_read
        jc l_h_ps2mouse_detect_fail
          cmp al, 0x00
          jne l_h_ps2mouse_detect_fail  // unknown device
            
            xor eax, eax
            ret
            
l_h_ps2mouse_detect_fail:
or eax, -1
ret

h_ps2mouse_try3:
mov  al, 0xF3    //Set Sample Rate
call h_ps2mouse_cmd
jc   h_ps2mouse_try3_fail
mov  al, 0xC8    //200d
call h_ps2mouse_cmd
jc   h_ps2mouse_try3_fail
mov  al, 0xF3    //Set Sample Rate
call h_ps2mouse_cmd
jc   h_ps2mouse_try3_fail
mov  al, 0x64    //100d
call h_ps2mouse_cmd
jc   h_ps2mouse_try3_fail
mov  al, 0xF3    //Set Sample Rate
call h_ps2mouse_cmd
jc   h_ps2mouse_try3_fail
mov  al, 0x50    //80d
call h_ps2mouse_cmd
jc   h_ps2mouse_try3_fail

mov  al, 0xF2    //Get device id
call h_ps2mouse_cmd
jc   h_ps2mouse_try3_fail

call h_ps2mouse_read
jc   h_ps2mouse_try3_fail
cmp  al, 0x03
jne  h_ps2mouse_try3_fail

xor  eax,eax
ret

h_ps2mouse_try3_fail:
or   eax, -1
ret

h_ps2mouse_try4:
mov  al, 0xF3    //Set Sample Rate
call h_ps2mouse_cmd
jc   h_ps2mouse_try4_fail
mov  al, 0xC8    //200d
call h_ps2mouse_cmd
jc   h_ps2mouse_try4_fail
mov  al, 0xF3    //Set Sample Rate
call h_ps2mouse_cmd
jc   h_ps2mouse_try4_fail
mov  al, 0xC8    //100d
call h_ps2mouse_cmd
jc   h_ps2mouse_try4_fail
mov  al, 0xF3    //Set Sample Rate
call h_ps2mouse_cmd
jc   h_ps2mouse_try4_fail
mov  al, 0x50    //80d
call h_ps2mouse_cmd
jc   h_ps2mouse_try4_fail

mov  al, 0xF2    //Get device id
call h_ps2mouse_cmd
jc   h_ps2mouse_try4_fail

call h_ps2mouse_read
jc   h_ps2mouse_try4_fail
cmp  al, 0x04
jne  h_ps2mouse_try4_fail

xor  eax, eax
ret

h_ps2mouse_try4_fail:
or   eax, -1
ret

h_ps2mouse_init:
pushf
  cli
  mov  bl, 0x20        // read command byte
  call h_kbd_cmd
  test ah, ah
  jnz  h_ps2mouse_fin
  call h_kbd_read
  test ah, ah
  jnz  h_ps2mouse_fin
popf
and  al, 0xFC        // disable interrupts
or   al, 0x10        // disable keyboard
push eax
  mov  bl, 0x60        // write command byte
  call h_kbd_cmd
pop  eax
call h_kbd_write

call h_ps2mouse_detect
test eax, eax
jnz  h_ps2mouse_exit

mov  ms_packetsize, 3

call h_ps2mouse_try3
test eax, eax
jnz  h_ps2mouse_stop_try
mov  ms_packetsize, 4  // scroll

call h_ps2mouse_try4
test eax, eax
jnz  h_ps2mouse_stop_try
mov  ms_packetsize, 4  // 5B

h_ps2mouse_stop_try:

mov  al, 0xF4        // enable data reporting
call h_ps2mouse_cmd

// enable keyboard and mouse interrupts
mov  bl, 0x20        // read command byte
call h_kbd_cmd
call h_kbd_read
or   al, 3           // enable interrupts
and  al, -1 - 0x10    // enable keyboard
push eax
  mov  bl, 0x60        // write command byte
  call h_kbd_cmd
pop  eax
call h_kbd_write
mov ms_type, MOUSE_PS2
ret


  h_ps2mouse_fin:
popf
//invoke DetachIntHandler, 12, irq_handler
mov  bl, 0xA7        // disable mouse interface
call h_kbd_cmd

h_ps2mouse_nothing:
xor  eax, eax
ret

h_ps2mouse_fini:
mov   al, 0xF5
call h_ps2mouse_cmd
ret

h_ps2mouse_exit:
mov  bl, 0xA7        // disable mouse interface
call h_kbd_cmd

// enable keyboard interrupt, leave mouse interrupt disabled
mov  bl, 0x20        // read command byte
call h_kbd_cmd
call h_kbd_read
or   al, 1           // enable keyboard interrupt
and  al, -1 - 0x10    // enable keyboard
push eax
  mov  bl, 0x60        // write command byte
  call h_kbd_cmd
pop  eax
call h_kbd_write

xor  eax, eax
ret

IRQ12:
pushad
 push ds
  push es
    mov dx, SELECTOR_KERNEL_DATA
    mov ds, dx  // ds = KERNEL_DATA
    mov bx, SELECTOR_ALL_DATA
    mov es, bx  // es = ALLMEM
    
    in al, 60h
/*    
    cmp ms_packetsize, 0
    jnz l_IRQ12_1
      call h_ps2mouse_init
      jmp short l_IRQ12_9
      
    l_IRQ12_1:
*/    
    movzx ebx, ms_cnt
    mov byte ptr ms_packet[ebx], al
    inc ms_cnt
    mov al, ms_cnt
    cmp al, ms_packetsize
    jnb l_IRQ12_2
/*    
    // check first byte
    cmp bl, 0
    jnz l_IRQ12_9
      test byte ptr ms_packet[0], 1000b
      jnz l_IRQ12_9
        mov byte ptr ms_cnt, 0
*/
    l_IRQ12_9:
    //in al, 61h
    //out 61h, al
    mov al, 20h
    out 0A0h, al
    out 20h, al
  pop es
 pop ds
popad
iretd

l_IRQ12_2:
mov ms_cnt, 0

// get buttons state
l_IRQ12_5:
mov al, byte ptr ms_packet[0]
and al, 7
mov cl, byte ptr ms_packet[3]
and cl, 0F0h
cmp cl, 0F0h
je l_IRQ12_no45btn
  shr cl, 1
  or  al, cl
  
l_IRQ12_no45btn:
mov ms_btn, al
// get delta X
movsx eax, byte ptr ms_packet[1]
add ms_x_sen, ax
// get delta Y
movsx eax, byte ptr ms_packet[2]
sub ms_y_sen, ax
// get delta Z
mov cl, byte ptr ms_packet[3]
and cl, 0Fh
cmp cl, 8
jb l_IRQ12_z5
  or cl, 0F0h
  
l_IRQ12_z5:
movsx eax, cl
add ms_z, ax

call h_mouse_common

jmp l_IRQ12_9

h_atixlmouse_init:
// Detect
mov dx, ATIXL_MSE_SIGNATURE_PORT
in al, dx
mov bl, al // bl = inb
in al, dx
mov bh, al // bh = inb
in al, dx  // al = inb

cmp bl, bh
jz l_h_atixlmouse_init_9
cmp bl, al
jnz l_h_atixlmouse_init_9

mov ms_type, MOUSE_ATI_XL

// Init
mov dx, ATIXL_MSE_CONTROL_PORT
mov al, 0x80  // reset the Inport device
out dx, al
mov al, 0x07  // select internal register 7
out dx, al

mov dx, ATIXL_MSE_DATA_PORT
mov al, 8 + 3 // data interrupts 1=30hz, 2=50hz, 3=100hz, 4=200hz rate
out dx, al

l_h_atixlmouse_init_9:
ret

h_atixlmouse_isr:

// read x
mov dx, ATIXL_MSE_CONTROL_PORT
mov al, ATIXL_MSE_READ_X
out dx, al
mov dx, ATIXL_MSE_DATA_PORT
in al, dx
mov byte ptr ms_packet[1], al

// read y
mov dx, ATIXL_MSE_CONTROL_PORT
mov al, ATIXL_MSE_READ_Y
out dx, al
mov dx, ATIXL_MSE_DATA_PORT
in al, dx
mov byte ptr ms_packet[2], al

// read buttons
mov dx, ATIXL_MSE_CONTROL_PORT
mov al, ATIXL_MSE_READ_BUTTONS
out dx, al
mov dx, ATIXL_MSE_DATA_PORT
in al, dx
mov ms_btn, al

// get delta X
movsx eax, byte ptr ms_packet[1]
add ms_x_sen, ax
// get delta Y
movsx eax, byte ptr ms_packet[2]
sub ms_y_sen, ax

ret

h_busmouse_init:
mov dx, MSE_CONFIG_PORT
mov al, MSE_CONFIG_BYTE
out dx, al
mov dx, MSE_SIGNATURE_PORT
mov al, MSE_SIGNATURE_BYTE
out dx, al

// wait, keep dx
mov ms_i, 0

l_h_busmouse_init_5:
  inc ms_i
  cmp ms_i, 100000
  jb l_h_busmouse_init_5

in al, dx
cmp al, MSE_SIGNATURE_BYTE
jnz l_h_busmouse_init_9
  
  mov ms_type, MOUSE_BUS
  
  mov dx, MSE_CONFIG_PORT
  mov al, MSE_DEFAULT_MODE
  out dx, al
  
l_h_busmouse_init_9:
ret

h_busmouse_isr:

// read x
mov dx, MSE_CONTROL_PORT
mov al, MSE_READ_X_LOW
out dx, al
mov dx, MSE_DATA_PORT
in al, dx
and al, 0Fh
mov ah, al

mov dx, MSE_CONTROL_PORT
mov al, MSE_READ_X_HIGH
out dx, al
mov dx, MSE_DATA_PORT
in al, dx
and al, 0Fh
shl al, 4
or al, ah

mov byte ptr ms_packet[1], al

// read y and buttons
mov dx, MSE_CONTROL_PORT
mov al, MSE_READ_Y_LOW
out dx, al
mov dx, MSE_DATA_PORT
in al, dx
and al, 0Fh
mov ah, al

mov dx, MSE_CONTROL_PORT
mov al, MSE_READ_Y_HIGH
out dx, al
mov dx, MSE_DATA_PORT
in al, dx  // read y high and buttons
mov dl, al

and al, 0Fh
shl al, 4
or al, ah

mov byte ptr ms_packet[2], al

shr dl, 5
and dl, 7
mov ms_btn, dl

// get delta X
movsx eax, byte ptr ms_packet[1]
add ms_x_sen, ax
// get delta Y
movsx eax, byte ptr ms_packet[2]
sub ms_y_sen, ax

ret

h_msbusmouse_init:
mov dx, MS_MSE_SIGNATURE_PORT
in al, dx
cmp al, 0xDE
jnz l_h_msbusmouse_init_9
  in al, dx
  mov cl, al  // mse_byte
  
  mov ms_present, 0
  mov ms_i, 0
  
  l_h_msbusmouse_init_5:
  cmp ms_i, 4
  jnb l_h_msbusmouse_init_8
    
    in al, dx
    cmp al, 0xDE
    jnz l_h_msbusmouse_init_6
      in al, dx
      cmp al, cl
      jnz l_h_msbusmouse_init_6
        mov ms_present, 1
    
    l_h_msbusmouse_init_55:
    inc ms_i
    jmp short l_h_msbusmouse_init_5
    
    l_h_msbusmouse_init_6:
    mov ms_present, 0
    jmp short l_h_msbusmouse_init_55
    
  l_h_msbusmouse_init_8:
  test ms_present, 1
  jz l_h_msbusmouse_init_9
    
    mov ms_type, MOUSE_MSBUS
    
l_h_msbusmouse_init_9:
ret

h_msbusmouse_isr:
mov dx, MS_MSE_CONTROL_PORT
mov al, MS_MSE_COMMAND_MODE
out dx, al
mov dx, MS_MSE_DATA_PORT
in al, dx
or al, 0x20
out dx, al

// read x
mov dx, MS_MSE_CONTROL_PORT
mov al, MS_MSE_READ_X
out dx, al
mov dx, MS_MSE_DATA_PORT
in al, dx
mov byte ptr ms_packet[1], al

// read y
mov dx, MS_MSE_CONTROL_PORT
mov al, MS_MSE_READ_Y
out dx, al
mov dx, MS_MSE_DATA_PORT
in al, dx
mov byte ptr ms_packet[2], al

// read buttons
mov dx, MS_MSE_CONTROL_PORT
mov al, MS_MSE_READ_BUTTONS
out dx, al
mov dx, MS_MSE_DATA_PORT
in al, dx
not al
and al, 7
mov ms_btn, al

mov dx, MS_MSE_CONTROL_PORT
mov al, MS_MSE_COMMAND_MODE
out dx, al
mov dx, MS_MSE_DATA_PORT
in al, dx
and al, 0xDF
out dx, al

// get delta X
movsx eax, byte ptr ms_packet[1]
add ms_x_sen, ax
// get delta Y
movsx eax, byte ptr ms_packet[2]
sub ms_y_sen, ax

ret

DMA_MODE_DEMAND   = 0
DMA_MODE_SINGLE   = 40h
DMA_MODE_BLOCK    = 80h
DMA_MODE_CASCADE  = 0C0h
DMA_MODE_INC      = 0
DMA_MODE_DEC      = 20h
DMA_MODE_AUTOINIT = 10h
DMA_MODE_VERIFY   = 0
DMA_MODE_READ     = 6
DMA_MODE_WRITE    = 0Ah

DMA_PORTOFS_MODE    = 0
DMA_PORTOFS_MASK    = 1
DMA_PORTOFS_CLEARFF = 2
DMA_PORTOFS_PAGE    = 3
DMA_PORTOFS_ADR     = 4
DMA_PORTOFS_COUNT   = 5

dma_ports_const:
// mode, mask, clear flip-flop, page, address, count, -, -
// DMA 0
db 0Bh, 0Ah, 0Ch, 87h, 0, 1, 0, 0
// DMA 1
db 0Bh, 0Ah, 0Ch, 83h, 2, 3, 0, 0
// DMA 2
db 0Bh, 0Ah, 0Ch, 81h, 4, 5, 0, 0
// DMA 3
db 0Bh, 0Ah, 0Ch, 82h, 6, 7, 0, 0
// DMA 4
db 0D6h, 0D4h, 0D8h, 8Fh, 0C0h, 0C2h, 0, 0
// DMA 5
db 0D6h, 0D4h, 0D8h, 8Bh, 0C4h, 0C6h, 0, 0
// DMA 6
db 0D6h, 0D4h, 0D8h, 89h, 0C8h, 0CAh, 0, 0
// DMA 7
db 0D6h, 0D4h, 0D8h, 8Ah, 0CCh, 0CEh, 0, 0

h_dma_init:
ret

// IN: al = channel, ah = mode
//     ecx = count, ebx = memory addr
// DESTROY: edx, esi
// OUT: al = 0 || errorcode
l_h_dma_read_xchn:
mov al, ERC_INVALID_CHANNEL_NUMBER
ret

l_h_dma_read_xmemadr:
mov al, ERC_INVALID_MEMORY_ADDRESS
ret

l_h_dma_read_xcount:
mov al, ERC_INVALID_COUNT
ret


h_dma_read:
or ah, DMA_MODE_READ

l_h_dma_common:
cmp al, 8
jnb l_h_dma_read_xchn

movzx esi, al
shl esi, 3     // esi = channel offset

cmp ebx, 0xFFFFFF
ja l_h_dma_read_xmemadr

dec ecx
cmp ecx, 65536
jnb l_h_dma_read_xcount

pushfd
cli

// Disable Channel
and al, 3
xor edx, edx
or al, 4	// al = 4 + (channel & 3)
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_MASK]
out dx, al

// Set Transfer Count
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_CLEARFF]
out dx, al
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_COUNT]
mov al, cl
out dx, al
call delay
mov al, ch
out dx, al

// Set Memory Address
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_CLEARFF]
out dx, al
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_ADR]
mov al, bl
out dx, al
call delay
mov al, bh
out dx, al
shr ebx, 16
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_PAGE]
mov al, bl
out dx, al

// Set Mode
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_MODE]
mov al, ah
out dx, al

// Enable Channel
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_MASK]
mov eax, esi
shr eax, 3
and al, 3
out dx, al

popfd

mov al, 0
ret

// IN: al = channel, ah = mode
//     ecx = count, ebx = memory addr
// DESTROY: edx, esi
// OUT: al = 0 || errorcode
h_dma_write:
or ah, DMA_MODE_WRITE

jmp l_h_dma_common

// IN: al = channel
// DESTROY: eax, edx, esi
h_dma_release:
and al, 7
movzx esi, al
shl esi, 3     // esi = channel offset
and al, 3
xor edx, edx
or al, 4       // al = 4 + (channel & 3)
mov dl, [cs:offset dma_ports_const + esi + DMA_PORTOFS_MASK]
out dx, al
ret

MAX_PCI = 128

struct PciInfo{
  uns4 class, adr
}

[dalign 32]
uns4 pci_count
PciInfo pci_info[MAX_PCI]

// IN: ch = bus(0..255), cl = slot/device(0..31),
//     dh = function(0..7), dl = offset(%4=0)
// OUT: eax = value
// KEEP: ecx, edx, ebx, ebp, esi, edi
h_pci_get:
push edx
  movzx eax, ch
  shl eax, 5
  or al, cl
  shl eax, 3
  or al, dh
  shl eax, 8
  or al, dl
  or eax, 0x80000000
  pushfd
    cli
    mov dx, 0xCF8
    out dx, eax
    mov dx, 0xCFC
    in eax, dx
  popfd
pop edx
ret

// IN: eax = value, ch = bus(0..255), cl = slot/device(0..31),
//     dh = function(0..7), dl = offset(%4=0)
// KEEP: eax, ecx, edx, ebx, ebp, esi, edi
h_pci_set:
push edx
 push ecx
  push eax 
    movzx eax, ch
    shl eax, 5
    or al, cl
    shl eax, 3
    or al, dh
    shl eax, 8
    or al, dl
    or eax, 0x80000000
  pop ecx
  pushfd
    cli    
    mov dx, 0xCF8
    out dx, eax
    mov dx, 0xCFC
    mov eax, ecx
    out dx, eax
  popfd
 pop ecx
pop edx
ret

h_pci_init:
xor ebx, ebx
mov pci_count, ebx
mov ch, 0
call h_pci_init_rcr
ret

// IN: ch = bus, pci_class
// OUT: pci_ecx, pci_edx
h_pci_init_rcr:
mov cl, 0
mov dh, 0

l_h_pci_init_rcr_5:
  mov dl, 0  // vendor/device
  call h_pci_get
  cmp eax, -1
  jz l_h_pci_init_rcr_next
    mov dl, 0Ch  // HeaderType
    call h_pci_get
    shr eax, 16
    and al, 127
    cmp al, 1
    jz l_h_pci_init_rcr_p2p
      cmp al, 0
      jnz l_h_pci_init_rcr_next
        // HeaderType = 0
        mov dl, 8  // class
        call h_pci_get
        mov pci_info.class[ebx], eax
        mov eax, ecx
        shl eax, 16
        mov ax, dx
        mov pci_info.adr[ebx], eax
        inc pci_count
        add ebx, sizeof PciInfo
        cmp ebx, sizeof PciInfo * MAX_PCI
        jb l_h_pci_init_rcr_next
        
        ret
        
      l_h_pci_init_rcr_p2p:
      // PCI to PCI
      push ecx
       push edx
        mov dl, 18h  // secondary bus
        call h_pci_get
        mov ch, ah
        call h_pci_init_rcr
       pop edx
      pop ecx
      
  l_h_pci_init_rcr_next:
  inc dh
  cmp dh, 8
  jb l_h_pci_init_rcr_5
    mov dh, 0
    inc cl
    cmp cl, 32
    jb l_h_pci_init_rcr_5
    
ret

// IN: ax = class_subclass
// OUT: ecx, edx(0 = not found)
h_pci_find:
xor edx, edx
mov ecx, pci_count

l_h_pci_find_5:
jecxz l_h_pci_find_9
  cmp ax, word ptr pci_info.class[edx + 2]
  jz l_h_pci_find_8
    add edx, sizeof PciInfo
    dec ecx
    jmp short l_h_pci_find_5
    
  l_h_pci_find_8:
  movzx ecx, word ptr pci_info.adr[edx + 2]
  movzx edx, word ptr pci_info.adr[edx]
  ret
  
l_h_pci_find_9:
xor ecx, ecx
xor edx, edx
ret

DISK_TYPE_FD = 2
DISK_TYPE_CD = 3
DISK_TYPE_HD = 4
DISK_TYPE_RD = 5

DISK_FLAGS_DIRTY = 1

ATA_CMD_READ         = 0x20
ATA_CMD_WRITE        = 0x30
ATA_CMD_READ_EX      = 0x24
ATA_CMD_WRITE_EX     = 0x34
ATA_CMD_FLUSH        = 0xE7
ATA_CMD_READ_DMA     = 0xC8
ATA_CMD_READ_DMA_EX  = 0x25
ATA_CMD_WRITE_DMA    = 0xCA
ATA_CMD_WRITE_DMA_EX = 0x35
ATA_CMD_PACKET       = 0xA0
ATA_CMD_IDENTIFYP    = 0xA1
ATA_CMD_FLUSH_EX     = 0xEA
ATA_CMD_IDENTIFY     = 0xEC
ATA_CMD_DIAGNOSTIC   = 0x90 // 0x90 / 0x1Dh

SCSI_COMMAND_READ10   = 28h
SCSI_COMMAND_CAPACITY = 25h

ATA_DEV_BUSY = 0x80
ATA_DEV_DRQ  = 0x08

[dalign 32]
uns4 abar, sd_base, sd_port_n, sd_port_ebx
uns4 rd_base, rd_size

[dalign 64]
uns8 sd_sect

uns1 rd_ldiskn

struct FdInfoRec{
  uns1 state, tracklen, gap3, gap3format
  uns4 size
}

struct FdCacheRec{
  uns4 sectn
  uns1 dirty, diskn
  uns2 usg
  uns1 data[512]
}

FD_CACHE_PA    = PA_DMA_BUFFERS
FD_CACHE_SIZE  = 0x8000
FD_CACHE_COUNT = FD_CACHE_SIZE / sizeof FdCacheRec

FD_STOPMOTORMS = 1000

uns1 fd_curdisk, fd_curtrack, fd_motor, fdt_pdiskn, fd_ro
bool fdt_end

[dalign 16]
uns2 fdt_relofs, fdt_endrelofs

[dalign 32]
uns4 fdt_sectn, fdt_count

FdInfoRec fd_info[2]

uns4 fdt_savecount
uns4 fdt_saveofs[FD_CACHE_COUNT]

uns1 fd_buffer[512]  // also used by cd

fd_geometries:
// valid, sectors per track, gap3, gap3format, size
// 0 - none
db 0, 18, 1Bh, 6Ch
dd 0
// 1 - 360
db 1,  9, 2Ah, 50h
dd 720
// 2 - 1.2
db 1, 15, 1Bh, 54h
dd 2400
// 3 - 720
db 1,  9, 2Ah, 50h
dd 1440
// 4 - 1.44
db 1, 18, 1Bh, 6Ch
dd 2880
// 5 - 2.88
db 1, 36, 1Bh, 54h
dd 5760

FD_COMMAND_SEEK        = 0Fh
FD_COMMAND_WRITESECTOR = 45h
FD_COMMAND_READSECTOR  = 46h
FD_COMMAND_READID      = 4Ah
FD_COMMAND_FORMATTRACK = 4Dh

FD_COMMAND_RECALIBRATE = 7
FD_COMMAND_CHECKSTATUS = 8

// Reset Controller
// DESTROY: ax, dx
h_fd_p_reset:
mov al, 0
mov dx, 3F2h
out dx, al
ret

// Start Motor
// IN: al = pdiskn
// DESTROY: al, cl, dx
h_fd_p_start_motor:
and al, 3
mov cl, al
mov al, 10h
shl al, cl
or al, 8 + 4
or al, cl
mov dx, 3F2h
out dx, al
ret

// Stop Motor
// DESTROY: al, dx
h_fd_p_stop_motor:
mov al, 8 + 4
mov dx, 3F2h
out dx, al
ret

// Wait
// DESTROY: ax, dx
h_fd_p_wait0:
mov dx, 3F4h
l_h_fd_p_wait0_1:
	//... noop(); infinite loop => throw
	in al, dx
	and al, 0C0h
	cmp al, 80h
	jnz l_h_fd_p_wait0_1
ret

// Wait
// DESTROY: ax, dx
h_fd_p_wait1:
mov dx, 3F4h
l_h_fd_u_wait1_1:
	//... noop(); infinite loop => throw
	in al, dx
	and al, 0C0h
	cmp al, 0C0h
	jnz l_h_fd_u_wait1_1
ret

// Make Type - set floppy disk geometry for given type
// IN: al & 15 = type, esi -> FdInfoRec
// OUT: esi -> fd_info[diskn]
// DESTROY: eax, ebx
h_fd_p_mktype:
and al, 15
cmp al, 6
jb l_h_fd_p_mktype_5
  mov al, 0
l_h_fd_p_mktype_5:
movzx ebx, al
shl ebx, 3
add ebx, offset fd_geometries
mov al, [cs:ebx]  // valid
mov [esi + offset FdInfoRec.state], al
inc ebx
mov al, [cs:ebx]  // sectors per track
mov [esi + offset FdInfoRec.tracklen], al
inc ebx
mov al, [cs:ebx]  // gap3
mov [esi + offset FdInfoRec.gap3], al
inc ebx
mov al, [cs:ebx]  // gap3format
mov [esi + offset FdInfoRec.gap3format], al
inc ebx
mov eax, [cs:ebx] // size
mov [esi + offset FdInfoRec.size], eax
ret

// Seek Track
// BEFORE: motor started
// IN: fdt_pdiskn, bh = head, cl = cylinder
// DESTROY: ax, dx
h_fd_p_seek:
mov dx, 3F5h
mov al, FD_COMMAND_SEEK
out dx, al	// out 0Fh

call h_fd_p_wait0

mov dx, 3F5h
mov ah, fdt_pdiskn	// ah = diskn
mov al, bh
and al, 1
shl al, 2	// al = (bh & 1) << 2
or al, ah
out dx, al	// out head << 2 + diskn

call h_fd_p_wait0

mov dx, 3F5h
mov al, cl
out dx, al	// out cylinder
ret

// IO Command - common part for read sector, write sector
// BEFORE: motor started
// IN: al = command, fdt_pdiskn, cl = cylinder,
//     bh = head, bl = sector, fd_info[fdt_pdiskn]
// OUT: al = 0 || errorcode
// DESTROY: ax, dx, bx, esi
h_fd_p_iocommand:

mov dx, 3F5h
out dx, al   // out command byte

call h_fd_p_wait0
mov dx, 3F5h
mov ah, fdt_pdiskn  // ah = diskn
mov al, bh
and al, 1
shl al, 2    // al = (bh & 1) << 2
or al, ah
out dx, al   // out head << 2 + diskn

call h_fd_p_wait0
mov dx, 3F5h
mov al, cl
out dx, al   // out cylinder

call h_fd_p_wait0
mov dx, 3F5h
mov al, bh
out dx, al   // out head

call h_fd_p_wait0
mov dx, 3F5h
mov al, bl
out dx, al   // out sector

call h_fd_p_wait0
mov dx, 3F5h
mov al, 2
out dx, al   // out 2 (sector size code for 512)

movzx esi, byte fdt_pdiskn
shl esi, 3   // esi = diskn * 8 (assert sizeof FdInfoRec == 8)
add esi, offset fd_info  // esi -> fd_info[diskn]

call h_fd_p_wait0
mov dx, 3F5h
mov al, [esi + offset FdInfoRec.tracklen]
out dx, al   // out track_length (18)

call h_fd_p_wait0
mov dx, 3F5h
mov al, [esi + offset FdInfoRec.gap3]
out dx, al   // out gap3 (1Bh = 27)

call h_fd_p_wait0
mov dx, 3F5h
mov al, 0FFh
out dx, al   // out 255 (data_length)

//... wait for IRQ6

// Wait, read result
call h_fd_p_wait1
mov dx, 3F5h
in al, dx
mov ah, al   // ah = st0

call h_fd_p_wait1
mov dx, 3F5h
in al, dx
mov bl, al   // bl = st1

call h_fd_p_wait1
mov dx, 3F5h
in al, dx
mov bh, al   // bh = st2

call h_fd_p_wait1
mov dx, 3F5h
in al, dx    // cylinder

call h_fd_p_wait1
mov dx, 3F5h
in al, dx    // head

call h_fd_p_wait1
mov dx, 3F5h
in al, dx    // sector

call h_fd_p_wait1
mov dx, 3F5h
in al, dx    // sector size code

// write protected?
test bl, 2
jz l_h_fd_p_iocommand_8
  mov al, fdt_pdiskn
  inc al
  or fd_ro, al
  mov al, ERC_READ_ONLY
  jmp short l_h_fd_p_iocommand_9

l_h_fd_p_iocommand_8:
mov al, 0

l_h_fd_p_iocommand_9:
ret

// Read Sector
// BEFORE: motor started
// IN: fdt_pdiskn, cl = cylinder, bh = head, bl = sector
//     edi = buffer PA, fd_info[diskn]
// OUT: al = 0 | errorcode
// DESTROY: ax, dx, bx, esi
h_fd_p_read0:

// Prepare DMA
push ebx
 push ecx
  mov al, 2
  mov ah, DMA_MODE_SINGLE | DMA_MODE_READ
  mov ebx, edi
  mov ecx, 512
  call h_dma_read
 pop ecx
pop ebx
test al, al
jnz l_h_fd_p_read0_x

// Read sector
mov al, FD_COMMAND_READSECTOR
jmp h_fd_p_iocommand  // !!

l_h_fd_p_read0_x:  // also from h_fd_p_write0
ret

// Write Sector
// BEFORE: motor started
// IN: fdt_pdiskn, cl = cylinder, bh = head, bl = sector
//     edi = buffer PA, fd_info[diskn]
// OUT: al = 0 | errorcode
// DESTROY: ax, dx, bx, esi
h_fd_p_write0:

// Prepare DMA
push ebx
 push ecx
  mov al, 2
  mov ah, DMA_MODE_SINGLE | DMA_MODE_WRITE
  mov ebx, edi
  mov ecx, 512
  call h_dma_write
 pop ecx
pop ebx
test al, al
jnz l_h_fd_p_read0_x  // !!

// Write sector
mov al, FD_COMMAND_WRITESECTOR
jmp h_fd_p_iocommand  // !!
//ret

// Translate logical sector to CHS using floppy disk geometry
// IN: ebx = sector, esi -> fd_info[diskn]
// OUT: bl = CHSSector, bh = CHSHead, ecx = CHSCylinder
// DESTROY: eax, edx
h_fd_p_translate:
mov eax, ebx
xor edx, edx
movzx ecx, byte fd_info.tracklen[esi]
div ecx
mov bl, dl
inc bl     // bl = ls % sectors + 1 = CHSsector
mov bh, al
and bh, 1  // bh = (ls / sectors) % 2 = CHSHead
shr eax, 1
xchg eax, ecx  // ecx = (ls / sectors) / 2 = CHSCylinder
ret

h_fd_p_recalibrate:
call h_fd_p_wait0

mov al, FD_COMMAND_RECALIBRATE
mov dx, 3F5h
out dx, al   // out command byte

call h_fd_p_wait0

mov al, 0
mov dx, 3F5h
out dx, al

call h_fd_p_wait0
ret

// IN: fdt_pdiskn
// KEEP: ecx, esi
h_fd_remove_from_cache:
xor eax, eax
dec eax       // eax = -1
xor edx, edx  // edx = 0
mov edi, FD_CACHE_PA

push es
  push ds
  pop es
  
  l_h_fd_test_disk_changed_4:
    mov bl, [edi + offset FdCacheRec.diskn]
    cmp bl, fdt_pdiskn
    jnz l_h_fd_test_disk_changed_41
      stosd  // save -1 (sectn)
      xchg eax, edx
      stosd  // save 0 (dirty, diskn, usg)
      xchg eax, edx
      add edi, sizeof FdCacheRec - 8
      jmp short l_h_fd_test_disk_changed_48
      
    l_h_fd_test_disk_changed_41:
    add edi, sizeof FdCacheRec
    
    l_h_fd_test_disk_changed_48:
    cmp edi, FD_CACHE_PA + (FD_CACHE_COUNT * sizeof FdCacheRec)
    jb l_h_fd_test_disk_changed_4

pop es

ret

// IN: fdt_pdiskn, fd_motor
// OUT: fd_motor
// KEEP: ecx, ebx, edi
h_fd_test_disk_changed:
// check disk changed
mov dx, 3F7h
in al, dx
test al, 80h
jz near l_h_fd_test_disk_changed_8
  
  push edi
   push ebx
    push ecx
    
    // remove from the cache
    call h_fd_remove_from_cache
    
    // seek & recalibrate
    mov bh, 0
    mov cl, 1
    call h_fd_p_seek
    mov fd_curtrack, 255
    call h_fd_p_recalibrate
    
    // ejected? - start motor
    mov ah, fdt_pdiskn
    mov al, fd_motor
    inc ah  // ah = diskn + 1 = mask
    or al, ah
    mov fd_motor, al
    and al, 3
    dec ah  // ah = mask - 1 = diskn
    shl al, 4
    or al, ah
    or al, 8 + 4  // al = (fd_motor << 4) + diskn + 8 + 4
    mov dx, 3F2h
    out dx, al
    // wait until motor started
    call h_fd_p_wait0
    
    // ejected?
    mov dx, 3F7h
    in al, dx
    test al, 80h
    jz l_h_fd_test_disk_changed_6
      // ejected
      mov al, ERC_DISK_REMOVED
      jmp short l_h_fd_test_disk_changed_7
    
    l_h_fd_test_disk_changed_6:
    // not ejected - doesn't work with 5.25"
    
    mov al, fdt_pdiskn
    inc al
    not al
    and fd_ro, al
    
    // post to all
    mov ecx, WM_DEVICECHANGE
    movzx edx, fdt_pdiskn
    inc edx  // edx = ldiskn
    mov esi, 1  // 1 - inserted, 0 - ejected
    call p_msg_post_to_all
    
    mov al, ERC_DISK_CHANGED
    
    l_h_fd_test_disk_changed_7:
    
    pop ecx
   pop ebx
  pop edi

  jmp short l_h_fd_test_disk_changed_9
  
l_h_fd_test_disk_changed_8:

mov al, 0

l_h_fd_test_disk_changed_9:
ret

// IN: fdt_pdiskn, fdt_end, fd_curdisk, fd_curtrack, fd_motor
// OUT: fdt_end, fd_curdisk, fd_curtrack, fd_motor
h_fd_begin:
cmp fdt_end, 0
jnz l_h_fd_begin_9

pushad

// remove stop_motor from the timer_queue
mov edx, TMR_THREADID_WND_FDSTOP
xor ebx, ebx
call h_timer_remove

// select drive & start motor, assert fdt_pdiskn < 2
mov ah, fdt_pdiskn
cmp ah, fd_curdisk
jz l_h_fd_prepare_1

  mov fd_curdisk, ah
  mov fd_curtrack, 255

l_h_fd_prepare_1:
mov al, fd_motor
inc ah  // ah = diskn + 1 = mask
test al, ah
jnz l_h_fd_prepare_2

  or al, ah
  mov fd_motor, al

l_h_fd_prepare_2:
and al, 3
dec ah  // ah = mask - 1 = diskn
shl al, 4
or al, ah
or al, 8 + 4  // al = (fd_motor << 4) + diskn + 8 + 4
mov dx, 3F2h
out dx, al

// wait until motor started
call h_fd_p_wait0

popad

mov fdt_end, 1

l_h_fd_begin_9:
ret

// IN: fdt_end
// OUT: fdt_end
// KEEP: eax
h_fd_end:
cmp fdt_end, 0
jz l_h_fd_end_9

// add stop_motor to the timer queue
push eax
  mov ecx, FD_STOPMOTORMS * 1193
  mov edx, TMR_THREADID_WND_FDSTOP
  xor ebx, ebx
  call h_timer_add
pop eax

mov fdt_end, 0

l_h_fd_end_9:
ret

// IN: ebx = ofs, ecx = size, ds
// OUT: al = 0 || errorcode, ebx = sectn, ecx = sectcount,
//      fdt_relofs, fdt_endrelofs, fdt_sectn, fdt_count
// DESTROY: eax

h_fd_prepare_values:
// prepare relofs*, sector number & count
mov eax, ebx
and ax, 511
mov fdt_relofs, ax     // fdt_relofs = ebx & 511
mov eax, ebx
add eax, ecx
dec eax
mov ecx, eax
and ax, 511
mov fdt_endrelofs, ax  // fdt_endrelofs = (ebx + ecx - 1) & 511
shr ebx, 9             // ebx = first sector
shr ecx, 9
sub ecx, ebx
inc ecx                // ecx = sector count

mov fdt_sectn, ebx
mov fdt_count, ecx
/*
//$$$
push edx
mov ax, fdt_relofs
mov dx, fdt_endrelofs
call wregs
pop edx
*/
mov al, 0
ret

// OUT: fd_motor
// DESTROY: al, dx
h_fd_stop_motor_mask:
call h_fd_p_stop_motor
mov fd_motor, 0
ret

// BEFORE: motor started
// IN: ebx = sectn, fdt_pdiskn, fd_curtrack, fd_curdisk
// OUT: esi -> disk info, bl = CHSS, bh = CHSH, cl = CHSC
//      fd_curdisk, fd_curtrack
// DESTROY: eax, edx, ebx, ecx
h_fd_seek_track:
movzx esi, fdt_pdiskn
shl esi, 3	// assert sizeof FdInfoRec = 8

// IN: ebx = sector, esi -> fd_info[diskn]
// OUT: bl = CHSSector, bh = CHSHead, ecx = CHSCylinder
// DESTROY: eax, edx
call h_fd_p_translate

call h_fd_p_wait0

// Seek track
mov al, fdt_pdiskn
cmp cl, fd_curtrack
jnz l_h_fd_seek_track_yes
  cmp al, fd_curdisk
  jz l_h_fd_seek_track_no
l_h_fd_seek_track_yes:

// BEFORE: motor started
// IN: fdt_pdiskn, bh = head, cl = cylinder
// DESTROY: ax, dx
mov fd_curdisk, al
mov fd_curtrack, cl
call h_fd_p_seek

call h_fd_p_wait0

l_h_fd_seek_track_no:
ret

// IN: ah = 0:only usg 0, 1:all, fdt_pdiskn
// BEFORE: motor started
// OUT: al = 0 || errorcode, fd_motor
// DESTROY: eax, fdt_save*
h_fd_flush:
push edx
 push ebx

xor edx, edx
mov fdt_savecount, edx
mov ebx, FD_CACHE_PA

push edi

l_h_fd_flush_1:
  mov al, [ebx + offset FdCacheRec.dirty]  // dirty
  test al, 1
  jnz l_h_fd_flush_5

  l_h_fd_flush_2:  // next buffer
  add ebx, sizeof FdCacheRec
  cmp ebx, FD_CACHE_PA + (FD_CACHE_COUNT * sizeof FdCacheRec)
  jb l_h_fd_flush_1

pop edi

mov edx, fdt_savecount
test edx, edx
jnz l_h_fd_flush_8

  mov al, 0

l_h_fd_flush_9:

 pop ebx
pop edx
ret


// Dirty Buffer Found
l_h_fd_flush_5:

test ah, 1
jnz l_h_fd_flush_6
  mov al, [ebx + offset FdCacheRec.usg]  // usg
  test al, al
  jnz l_h_fd_flush_2

l_h_fd_flush_6:
mov al, [ebx + offset FdCacheRec.diskn]  // diskn
cmp al, fdt_pdiskn
jnz l_h_fd_flush_2

call h_fd_begin

// AddSort to list of buffers to save
mov edi, fdt_savecount
shl edi, 2
add edi, offset fdt_saveofs

l_h_fd_flush_61:
cmp edi, offset fdt_saveofs
jna l_h_fd_flush_62
  mov edx, [edi - 4]   // edx = ofs to fs
  mov [edi], edx
  mov edx, [edx]       // edx = sector number
  cmp [ebx], edx
  jna l_h_fd_flush_62  // greater first
    sub edi, 4
    jmp short l_h_fd_flush_61

l_h_fd_flush_62:
mov [edi], ebx
inc fdt_savecount
jmp l_h_fd_flush_2


// Save fdt_save*
l_h_fd_flush_8:
push ecx
 push esi
  push edi

mov edi, fdt_savecount
shl edi, 2
add edi, offset fdt_saveofs  // read from the end, last saved first

l_h_fd_flush_81:
cmp edi, offset fdt_saveofs
jna l_h_fd_flush_88

sub edi, 4
mov ebx, [edi]

push ebx
 push edi

  // write protection
  mov ah, fdt_pdiskn
  inc ah
  test fd_ro, ah
  jz l_h_fd_flush_82
    mov al, ERC_READ_ONLY
    jmp short l_h_fd_flush_83
  
  l_h_fd_flush_82:

  // Save buffer[ebx+8](512) to disk[ebx+5](1)[ebx](4)

  mov edi, ebx
  add edi, offset FdCacheRec.data           // edi -> data
  mov ebx, [ebx + offset FdCacheRec.sectn]  // ebx = sectn

  // BEFORE: motor started
  // IN: ebx = sectn, fdt_pdiskn, fd_curtrack, fd_curdisk
  // OUT: esi -> disk info, bl = CHSS, bh = CHSH, cl = CHSC
  //      fd_curdisk, fd_curtrack
  // DESTROY: eax, edx, ebx, ecx
  call h_fd_seek_track

  // BEFORE: motor started
  // IN: fdt_pdiskn, cl = cylinder, bh = head, bl = sector
  //     edi = source DMA, fd_*
  // OUT: al = 0 | errorcode
  // DESTROY: ax, cx, dx, esi
  call h_fd_p_write0
  // al <> 0 => error

  l_h_fd_flush_83:

 pop edi
pop ebx

test al, al
jnz l_h_fd_flush_86
  mov byte [ebx + offset FdCacheRec.dirty], 0  // dirty = false
  jmp l_h_fd_flush_81

l_h_fd_flush_86:
// Error
mov byte [ebx + offset FdCacheRec.dirty], 2    // dirty = error
jmp short l_h_fd_flush_89  // al = errorcode

l_h_fd_flush_88:
  // All done
  xor eax, eax

l_h_fd_flush_89:

  pop edi
 pop esi
pop ecx
jmp l_h_fd_flush_9

// IN: fdt_pdiskn, fd_motor
// OUT: al = 0 || errorcode, fd_motor
// DESTROY: eax, fdt_save*
h_fd_shrusg:
push edx
 push ebx

mov esi, FD_CACHE_PA

l_h_fd_shrusg_1:
  shr byte [esi + offset FdCacheRec.usg], 1  // usg
  add esi, sizeof FdCacheRec
  cmp esi, FD_CACHE_PA + (FD_CACHE_COUNT * sizeof FdCacheRec)
  jb l_h_fd_shrusg_1

// Flush all disks
mov al, fdt_pdiskn

push eax

  mov fdt_end, 0
  mov fdt_pdiskn, 0
  mov ah, 0
  call h_fd_flush  // flush disk 0

  mov fdt_end, 0
  mov fdt_pdiskn, 1
  mov ah, 0
  call h_fd_flush  // flush disk 1

pop eax

mov fdt_pdiskn, al
mov fdt_end, 0
call h_fd_begin

 pop ebx
pop edx
ret

// IN: ds:esi -> source buffer data, es:edi -> target,
//     ecx = sector count, fdt_relofs, fdt_endrelofs
// OUT: edi++*, fdt_relofs
// DESTROY: eax, esi
h_fd_rcopy:
mov eax, 511
test ecx, ecx
jnz l_h_fd_rcopy_1
  movzx eax, word fdt_endrelofs  // Last sector
l_h_fd_rcopy_1:

push ecx

  xchg eax, ecx
  movzx eax, word fdt_relofs
  sub ecx, eax
  add esi, eax  // esi += fdt_relofs
  inc ecx       // ecx = bytes count
  test eax, eax
  jz l_h_fd_rcopy_4
    xor eax, eax
    mov fdt_relofs, ax  // Next fdt_relofs = 0
  l_h_fd_rcopy_4:
  cld
  cmp ecx, 512
  jz l_h_fd_rcopy_5
    rep movsb
    jmp short l_h_fd_rcopy_8  
  l_h_fd_rcopy_5:
    shr ecx, 2
    rep movsd
  l_h_fd_rcopy_8:

pop ecx

ret

// IN: ds:esi -> target buffer data, es:edi -> source,
//     ecx = sector count, fdt_relofs, fdt_endrelofs
// OUT: edi++*, fdt_relofs
// DESTROY: eax, edx, esi
h_fd_wcopy:
mov byte[esi - offset FdCacheRec.data + offset FdCacheRec.dirty], 1  // dirty
mov eax, 511
test ecx, ecx
jnz l_h_fd_wcopy_1
  movzx eax, word fdt_endrelofs  // Last sector
l_h_fd_wcopy_1:

push ecx

  xchg eax, ecx
  movzx eax, word fdt_relofs
  sub ecx, eax
  add esi, eax  // esi += fdt_relofs
  inc ecx       // ecx = bytes count
  test eax, eax
  jz l_h_fd_wcopy_4
    xor eax, eax
    mov fdt_relofs, ax  // Next fdt_relofs = 0
  l_h_fd_wcopy_4:

  xchg esi, edi

  push ds

    push ds
      push es
      pop ds  // ds = es0
    pop es    // es = ds0

    cld
    cmp ecx, 512
    jz l_h_fd_wcopy_5
    rep movsb
    jmp short l_h_fd_wcopy_8

    l_h_fd_wcopy_5:
    shr ecx, 2
    rep movsd

    l_h_fd_wcopy_8:

    push ds
    pop es

  pop ds

  xchg esi, edi

pop ecx

ret

// IN: ebx = sectn, ecx = sectcount, fdt_pdiskn, fdt_relofs, fdt_endrelofs
// OUT: al = 0 || ERC_NOT_FOUND_IN_CACHE || errorcode, esi -> FdCacheRec.data
// DESTROY: eax, edx
h_fd_srchbuf:
mov esi, FD_CACHE_PA

l_h_fd_srchbuf_1:
  cmp ebx, dword [esi + offset FdCacheRec.sectn]   // sectn
  jnz l_h_fd_srchbuf_12
    mov al, byte [esi + offset FdCacheRec.diskn]   // diskn
    cmp al, fdt_pdiskn
    jnz l_h_fd_srchbuf_12
      // Sector found
      // usg++
      cmp byte [esi + offset FdCacheRec.usg], 255  // usg
      jz l_h_fd_srchbuf_15
        inc byte [esi + offset FdCacheRec.usg]  // usg
        jmp short l_h_fd_srchbuf_15

  l_h_fd_srchbuf_12:
  add esi, sizeof FdCacheRec
  cmp esi, FD_CACHE_PA + (FD_CACHE_COUNT * sizeof FdCacheRec)
  jb l_h_fd_srchbuf_1

// return not found
mov al, ERC_NOT_FOUND_IN_CACHE
ret

// Found
l_h_fd_srchbuf_15:
add esi, offset FdCacheRec.data         // esi -> sector_buffer

// return ok
mov al, 0
ret

// IN: ds
// OUT: al = 0 || errorcode, edi -> FdCacheRec (victim PA)
// DESTROY: ax
h_fd_find_victim:

l_h_fd_find_victim_0:
mov edi, FD_CACHE_PA

l_h_fd_find_victim_1:
cmp edi, FD_CACHE_PA + (FD_CACHE_COUNT * sizeof FdCacheRec)
jnb l_h_fd_find_victim_6
  mov al, [edi + offset FdCacheRec.usg]  // usg
  test al, al
  jz l_h_fd_find_victim_8
    add edi, sizeof FdCacheRec
    jmp l_h_fd_find_victim_1

l_h_fd_find_victim_6:
call h_fd_shrusg
test al, al
jz l_h_fd_find_victim_0
ret  // al = errorcode

l_h_fd_find_victim_8:
mov al, 0
ret

// IN: ds, ebx = sectn, fdt_pdiskn, fd_curtrack, fd_curdisk
// OUT: al = 0 || errorcode, esi -> FdCacheRec.data
// DESTROY: eax, edx
h_fd_read_sector:

push ecx
push ebx
push edi

movzx esi, byte fdt_pdiskn
shl esi, 3  // assert sizeof FdInfoRec == 8

cmp ebx, fd_info.size[esi]
jb h_fd_read_sector_2
  
  mov al, ERC_OUT_OF_RANGE
  jmp h_fd_read_sector_x
  
h_fd_read_sector_2:

// IN: ds
// OUT: al = 0 || errorcode, edi -> FdCacheRec (victim PA)
// DESTROY: ax
call h_fd_find_victim
or al, al
jnz h_fd_read_sector_x

mov al, fdt_pdiskn
mov dword[edi + offset FdCacheRec.sectn], ebx  // sectn
mov byte[edi + offset FdCacheRec.dirty], 0     // dirty
mov byte[edi + offset FdCacheRec.diskn], al    // diskn
mov byte[edi + offset FdCacheRec.usg], 1       // usg

// BEFORE: motor started
// IN: ebx = sectn, fdt_pdiskn, fd_curtrack, fd_curdisk
// OUT: esi -> fd_info[diskn], bl = CHSS, bh = CHSH, cl = CHSC
//      fd_curdisk, fd_curtrack
// DESTROY: eax, ecx, edx, ebx
call h_fd_seek_track  // keep edi

add edi, offset FdCacheRec.data

// BEFORE: motor started
// IN: fdt_pdiskn, cl = cylinder, bh = head, bl = sector
//     edi = target buffer PA, fd_info[diskn]
// OUT: al = 0 || errorcode
// DESTROY: ax, cx, dx, esi
call h_fd_p_read0  // keep edi

mov esi, edi  // esi -> data

sub edi, offset FdCacheRec.data

or al, al
jnz h_fd_read_sector_x2

h_fd_read_sector_x:

pop edi
pop ebx
pop ecx

ret

h_fd_read_sector_x2:
xor ebx, ebx
dec ebx
mov dword[edi + offset FdCacheRec.sectn], ebx  // sectn
mov byte[edi + offset FdCacheRec.usg], 0       // usg
jmp h_fd_read_sector_x

// IN: ds, es
h_fd_init:

// Prepare cache
xor eax, eax
dec eax       // eax = -1
xor edx, edx  // edx = 0
mov edi, FD_CACHE_PA

push es
  push ds
  pop es

  l_h_fd_init_2:
    stosd  // save -1 (sectn)
    xchg eax, edx
    stosd  // save 0 (dirty, diskn, usg)
    xchg eax, edx
    add edi, sizeof FdCacheRec - 8
    cmp edi, FD_CACHE_PA + (FD_CACHE_COUNT * sizeof FdCacheRec)
    jb l_h_fd_init_2

pop es

// Get floppy disk types
mov al, 10h
out 70h, al
in al, 71h
push eax

 shr al, 4
 mov esi, offset fd_info
 call h_fd_p_mktype

pop eax
mov esi, offset fd_info + sizeof FdInfoRec
call h_fd_p_mktype

// Configure
//mov ebx, 100
//call busywait
//call h_fd_p_configure

// Init vars
mov fd_curdisk, 255
mov fd_curtrack, 255
mov fd_motor, 0
mov fd_ro, 0

// Return OK
mov al, 0
ret

l_h_fd_read_x:
mov al, ERC_INVALID_DISK_NUMBER
ret

// IN: al = pdiskn, ebx = ofs, ecx = size, es:edi -> target
// DESTROY: eax, ecx, edx, ebx, esi, edi
h_fd_read:
cmp al, 2
jnb l_h_fd_read_x

mov fdt_pdiskn, al
mov fdt_end, 0
call h_fd_begin

call h_fd_test_disk_changed
test al, al
jnz l_h_fd_read_8

call h_fd_prepare_values

l_h_fd_read_5:
  dec fdt_count
  mov ebx, fdt_sectn
  mov ecx, fdt_count
  call h_fd_srchbuf
  or al, al
  jnz l_h_fd_read_6
    
    l_h_fd_read_51:
    // found
    call h_fd_rcopy
    inc fdt_sectn
    cmp fdt_count, 0
    jz l_h_fd_read_7
      jmp short l_h_fd_read_5
  
l_h_fd_read_6:
cmp al, ERC_NOT_FOUND_IN_CACHE
jnz l_h_fd_read_8

// not found
call h_fd_read_sector
or al, al
jz l_h_fd_read_51

jmp short l_h_fd_read_8

l_h_fd_read_7:
mov al, 0

l_h_fd_read_8:

call h_fd_end  // keep eax

ret

l_h_fd_write_x:
mov al, ERC_INVALID_DISK_NUMBER

l_h_fd_write_x2:
ret

/*l_h_fd_write_x3:
mov al, ERC_READ_ONLY
ret*/

// IN: al = pdiskn, ebx = ofs, ecx = size, es:edi -> source
h_fd_write:
cmp al, 2
jnb l_h_fd_write_x
/*
mov ah, al
inc ah
test fd_ro, ah
jnz l_h_fd_write_x3
*/
movzx esi, al
inc esi
shl esi, 5  // log2(sizeof(DiskInfoRec)) = 5
or byte ptr disk_info.flags[esi], DISK_FLAGS_DIRTY

mov fdt_pdiskn, al
mov fdt_end, 0
call h_fd_begin

call h_fd_test_disk_changed
test al, al
jnz l_h_fd_read_8

call h_fd_prepare_values

l_h_fd_write_5:
  dec fdt_count
  mov ebx, fdt_sectn
  mov ecx, fdt_count
  call h_fd_srchbuf
  or al, al
  jnz l_h_fd_write_6
    
    l_h_fd_write_51:
    // found
    call h_fd_wcopy
    inc fdt_sectn
    cmp fdt_count, 0
    jz l_h_fd_write_7
      jmp short l_h_fd_write_5

l_h_fd_write_6:
cmp al, ERC_NOT_FOUND_IN_CACHE
jnz l_h_fd_write_8

// not found
jmp short l_h_fd_write_52


l_h_fd_write_7:
mov al, 0

l_h_fd_write_8:

call h_fd_end  // keep eax

ret

  l_h_fd_write_52:
  // Don't load if writing whole sector
  mov ax, fdt_relofs
  test ax, ax
  jz l_h_fd_write_62

    l_h_fd_write_54:
    // Load missing sector to cache, assert fdt_pdiskn < 2
    call h_fd_read_sector
    test al, al
    jz l_h_fd_write_51
      jmp l_h_fd_write_x2

l_h_fd_write_62:
cmp ecx, 1
ja l_h_fd_write_64
  cmp fdt_endrelofs, 511
  jnz l_h_fd_write_54

l_h_fd_write_64:
// fdt_relofs == 0 && (ecx > 1 || fdt_endrelofs == 511)

push edi
 push ecx
  push ebx

    movzx esi, byte fdt_pdiskn
    shl esi, 3  // assert sizeof FdInfoRec == 8
    // IN: ds
    // OUT: al = 0 || errorcode, edi -> FdCacheRec (victim PA)
    // DESTROY: ax
    call h_fd_find_victim
    mov esi, edi
  
  pop ebx
 pop ecx
pop edi

test al, al
jnz near l_h_fd_write_x

mov al, fdt_pdiskn
mov dword[esi + offset FdCacheRec.sectn], ebx  // sectn
mov byte[esi + offset FdCacheRec.dirty], 0     // dirty
mov byte[esi + offset FdCacheRec.diskn], al    // diskn
mov byte[esi + offset FdCacheRec.usg], 1       // usg
add esi, offset FdCacheRec.data
jmp l_h_fd_write_51

// IN: ah = operation, al = ldiskn
h_fd_main:
dec al  // 0 = A:, 1 = B:, else error (ldiskn -> pdiskn)

cmp ah, 2
jnz l_h_fd_main_3
  // read (al = pdiskn, ebx = ofs, ecx = size, es:edi -> buffer)
  jmp h_fd_read

l_h_fd_main_3:
cmp ah, 3
jnz l_h_fd_main_4
  // write (al = pdiskn, ebx = ofs, ecx = size, es:edi -> buffer)
  jmp h_fd_write

l_h_fd_main_4:
cmp ah, 4
jnz l_h_fd_main_5
  // get disk size (al = diskn)
  cmp al, 2
  jb l_h_fd_main_45
  
    l_h_fd_main_44:
    xor edx, edx
    xor eax, eax
    ret
  
  l_h_fd_main_45:
  movzx esi, al
  shl esi, 3  // esi = diskn * 8 (assert sizeof FdInfoRec == 8)
  add esi, offset fd_info  // esi -> fd_info[diskn]
  mov eax, [esi + offset FdInfoRec.size]
  shl eax, 9  // fd_size * 512
  xor edx, edx
  ret

l_h_fd_main_5:
cmp ah, 5
jnz l_h_fd_main_7
  // flush (al = diskn)
  cmp al, 2
  jb l_h_fd_main_55
    mov al, ERC_INVALID_DISK_NUMBER
    ret
  
  l_h_fd_main_55:
  mov fdt_pdiskn, al
  mov fdt_end, 0

    mov ah, 1  // flush all
    call h_fd_flush

  call h_fd_end
  ret

l_h_fd_main_7:
/*cmp ah, 7
jnz l_h_fd_main_1
	// format
	jmp h_fd_format
*/
l_h_fd_main_1:
cmp ah, 1
jnz l_h_fd_main_0
  // reset
  mov fdt_pdiskn, 0
  call h_fd_remove_from_cache
  mov fdt_pdiskn, 1
  call h_fd_remove_from_cache
  
  //call h_fd_p_reset
  
  and fd_info.state, 1
  and fd_info.state[sizeof FdInfoRec], 1
  mov fd_curdisk, 255
  mov fd_curtrack, 255
  mov fd_motor, 0
  mov al, 0
  ret

l_h_fd_main_0:
cmp ah, 0
jnz l_h_fd_main_x
  // init
  jmp h_fd_init

l_h_fd_main_x:
// error
mov al, ERC_NOT_IMPLEMENTED
ret

//msg6: db 5, " IRQ6"

IRQ6:
/*
push ds
 pushad
  push SELECTOR_KERNEL_DATA
  pop ds
  mov esi, offset msg6
  call writec
 popad
pop ds
*/
iretd

struct HdCacheRec{
  uns8 sectn
  uns2 usg
  uns1 diskn, dirty
  uns4 padding
  uns1 data[4096]
}

HD_CACHE_PA    = PA_DMA_BUFFERS + 0x10000
HD_CACHE_SIZE  = 0x10000
HD_CACHE_COUNT = HD_CACHE_SIZE / sizeof HdCacheRec

HD_PORT_DATA      = 0x1F0
HD_PORT_FEATURES  = 0x1F1
HD_PORT_ERROR     = 0x1F1
HD_PORT_COUNT     = 0x1F2
HD_PORT_SECTOR    = 0x1F3
HD_PORT_CYLLOW    = 0x1F4
HD_PORT_CYLHIGH   = 0x1F5
HD_PORT_DRIVEHEAD = 0x1F6
HD_PORT_COMMAND   = 0x1F7
HD_PORT_STATUS    = 0x1F7

HD_STATUS_BUSY      = 0x80
HD_STATUS_DATAREADY = 8
HD_STATUS_ERROR     = 1
HD_STATUS_FAULT     = 0x20

uns1 hd_busy, hdt_ldiskn, hdt_pdiskn, hd_irqs

[dalign 16]
uns2 hdt_relofs, hdt_endrelofs

[dalign 32]
uns1 hd_buffer[512]  // also used by cd

[dalign 32]
uns4 hdt_count_remain, hdt_high

[dalign 32]
uns1 hd_state[4]

uns4 hdt_savecount
uns4 hdt_saveofs[15]

uns8 hdt_tmp1, hdt_min

// IN: edx:ebx = sector, ecx = count,
//     hdt_slave_bit, hdt_port_base
// OUT: al = command_base, dx = port_base,
//      hdt_count_remain, ecx = semi count
// DESTROY: eax, edx, hdt_high
h_hd_p_mklba:
test edx, edx
jnz l_h_hd_p_mklba_48
 cmp ebx, 0x10000000		// 1 << 28
 jnb l_h_hd_p_mklba_48

// 28
mov eax, ebx
shr eax, 24
and al, 15
or al, hdt_slave_bit  // hdt_slave_bit 0 || 10h
or al, 0xE0
mov dx, hdt_port_base
or dl, 6  // dx = HD_PORT_DRIVEHEAD (6)
out dx, al
mov eax, ecx
cmp eax, 256
jb l_h_hd_p_mklba_281
  mov eax, 255

l_h_hd_p_mklba_281:
sub ecx, eax
mov hdt_count_remain, ecx
mov ecx, eax
sub dl, 4  // dx = HD_PORT_COUNT (2)
out dx, al

mov al, bl
inc dl  // dx = HD_PORT_SECTOR (3) / LBA low
out dx, al

mov al, bh
inc dl  // dx = HD_PORT_CYLLOW (4) / LBA mid
out dx, al

mov eax, ebx
shr eax, 16
inc dl  // dx = HD_PORT_CYLHIGH (5) / LBA high
out dx, al

sub dl, 5  // dx = PORT_BASE (0)

mov al, 0
ret

// 48
l_h_hd_p_mklba_48:
mov eax, ebx
shr eax, 24
shl edx, 8
or eax, edx
mov hdt_high, eax

mov al, 0xE0
or al, hdt_slave_bit  // hdt_slave_bit 0 || 10h
mov dx, hdt_port_base
or dl, 6  // dx = HD_PORT_DRIVEHEAD (6)
out dx, al

mov eax, ecx
cmp eax, 65536
jb l_h_hd_p_mklba_481
  mov eax, 65535

l_h_hd_p_mklba_481:
sub ecx, eax
mov hdt_count_remain, ecx
mov ecx, eax
mov al, ah
sub dl, 4  // dx = HD_PORT_COUNT (2)
out dx, al

mov eax, hdt_high
inc dl  // dx = HD_PORT_SECTOR (3) / LBA low
out dx, al
shr eax, 8
inc dl  // dx = HD_PORT_CYLLOW (4) / LBA mid
out dx, al
mov al, ah
inc dl  // dx = HD_PORT_CYLHIGH (5) / LBA high
out dx, al

mov al, cl
sub dl, 3  // dx = HD_PORT_COUNT (2)
out dx, al

mov eax, ebx
inc dl  // dx = HD_PORT_SECTOR (3)
out dx, al
shr eax, 8
inc dl  // dx = HD_PORT_CYLLOW (4)
out dx, al
mov al, ah
inc dl  // dx = HD_PORT_CYLHIGH (5)
out dx, al

sub dl, 5  // dx = PORT_BASE (0)

mov al, 4
ret

// IN: edx:ebx = sector, ecx = count, es:edi -> buffer,
//     hdt_pdiskn, hdt_slave_bit, hdt_port_base
// OUT: edx:ebx = next sector
// KEEP: esi
// USES: hdt_high, hdt_count_remain
h_hd_p_read:
test hdt_pdiskn, 40h
jnz near h_sd_p_read

l_h_hd_p_read0:

push edx

 call h_hd_p_mklba
 or al, ATA_CMD_READ
 or dl, 7		// dx = HD_PORT_COMMAND (7)
 out dx, al

 push ecx

// (*
 l_h_hd_p_read5:
	or dl, 7	// dx = HD_PORT_STATUS (7)
	in al, dx
	test al, HD_STATUS_BUSY
	jz l_h_hd_p_read6
		//... noop();
		jmp l_h_hd_p_read5

	l_h_hd_p_read6:
	test al, HD_STATUS_ERROR | HD_STATUS_FAULT
	jnz l_h_hd_p_error0

	push ecx
	 and dl, 0F8h	// dx = HD_PORT_DATA (0)
	 mov ecx, 512/4
	 cld
	 rep insd
	pop ecx
	loop l_h_hd_p_read5
// *)

 pop ecx
pop edx

add ebx, ecx
adc edx, 0
mov ecx, hdt_count_remain
test ecx, ecx
jnz l_h_hd_p_read0

xor eax, eax
ret


  l_h_hd_p_error0:
 pop ecx
pop edx

l_h_hd_p_error:		// write and cd jump here too
mov dx, hdt_port_base
or dl, 1	// dx = HD_PORT_ERROR (1)
in al, dx
mov ah, al
mov al, ERC_HARDWARE
ret

// IN: edx:ebx = sector, ecx = count, es:edi -> buffer,
//     hdt_pdiskn, hdt_slave_bit, hdt_port_base
// OUT: edx:ebx = next sector
// KEEP: esi
// USES: hdt_high, hdt_count_remain
h_hd_p_write:
test hdt_pdiskn, 40h
jnz near h_sd_p_write

l_h_hd_p_write0:

push edx

 call h_hd_p_mklba
 or al, ATA_CMD_WRITE
 or dl, 7		// dx = HD_PORT_COMMAND (7)
 out dx, al

 push ecx
  push ds
   push esi

	mov ax, es
	mov esi, edi
	mov ds, ax
// (*
	l_h_hd_p_write5:
		or dl, 7	// dx = HD_PORT_STATUS (7)
		in al, dx
		test al, HD_STATUS_BUSY
		jz l_h_hd_p_write6
			//... noop();
			jmp l_h_hd_p_write5

		l_h_hd_p_write6:
		test al, HD_STATUS_ERROR | HD_STATUS_FAULT
		jnz l_h_hd_p_write_error

		push ecx
	 	 and dl, 0F8h	// dx = HD_PORT_DATA (0)
		 mov ecx, 512/4
		 cld

		 l_h_hd_p_write71:
		  outsd
		  jmp short l_h_hd_p_write76
		  l_h_hd_p_write76:
		  loop l_h_hd_p_write71

		pop ecx
		loop l_h_hd_p_write5
// *)
	mov edi, esi

   pop esi
  pop ds
 pop ecx
pop edx

add ebx, ecx
adc edx, 0
mov ecx, hdt_count_remain
test ecx, ecx
jnz l_h_hd_p_write0

xor eax, eax
ret


l_h_hd_p_write_error:
   pop esi
  pop ds
 pop ecx
pop edx
jmp l_h_hd_p_error

// IN: hdt_port_base, hdt_slave_bit
h_hd_p_flush:  // E7/EA
mov dx, hdt_port_base

mov al, hdt_slave_bit  // hdt_slave_bit 0 || 10h
or dl, 6  // dx = HD_PORT_DRIVEHEAD (6)
out dx, al

or dl, 7  // dx = HD_PORT_COMMAND (7)
mov al, ATA_CMD_FLUSH_EX
out dx, al

l_h_hd_p_flush5:
  //or dl, 7  // dx = HD_PORT_STATUS (7)
  in al, dx
  test al, HD_STATUS_BUSY
  jnz l_h_hd_p_flush5

ret

// IN: hdt_slave_bit, hdt_port_base, es:edi -> buffer
h_hd_p_identify:
push edx

  mov dx, hdt_port_base

  mov al, hdt_slave_bit
  or dl, 6  // dx = HD_PORT_DRIVEHEAD (6)
  out dx, al
  
  mov al, ATA_CMD_IDENTIFY
  or dl, 7  // dx = HD_PORT_COMMAND (7)
  out dx, al
  
  in al, dx
  or al, al
  jz h_hd_p_identify_e
  
  h_hd_p_identify5:
    or dl, 7  // dx = HD_PORT_STATUS (7)
    in al, dx
    test al, HD_STATUS_BUSY
    jz h_hd_p_identify6
      //... noop();
      jmp h_hd_p_identify5
  
  h_hd_p_identify6:
  test al, HD_STATUS_ERROR | HD_STATUS_FAULT
  jnz l_h_hd_p_identifyerror
  
  push ecx
   and dl, 0F8h  // dx = HD_PORT_DATA (0)
   mov ecx, 512/4
   cld
   rep insd
  pop ecx
  
pop edx

xor eax, eax
ret

l_h_hd_p_identifyerror:
pop edx
jmp l_h_hd_p_error

h_hd_p_identify_e:
pop edx
mov al, ERC_INVALID_DISK_NUMBER
ret

// IN: al = pdiskn
// OUT: hdt_slave_bit, hdt_port_base
h_hd_prepare_port_slave:
push eax
  and al, 1
  shl al, 4
  mov hdt_slave_bit, al  // hdt_slave_bit = (pdn & 1) << 4
pop eax
test al, 2
jz l_h_hd_prepare_port_slave_2
  mov hdt_port_base, 170h
  jmp short l_h_hd_prepare_port_slave_3

l_h_hd_prepare_port_slave_2:
  mov hdt_port_base, 1F0h

l_h_hd_prepare_port_slave_3:
ret

// IN: al = pdiskn
// OUT: al = 0 || errorcode, hdt_pdiskn
//      hdt_slave_bit, hdt_port_base
// DESTROY: eax, esi
h_hd_partitions:
mov hdt_pdiskn, al
call h_hd_prepare_port_slave

// Prepare all partitions of physical disk esi

push edi
 push ecx
  push edx
   push ebx

// Read LBA 1
xor edx, edx
xor ebx, ebx
inc ebx
xor ecx, ecx
inc ecx
mov edi, VA_SYSTEM + offset hd_buffer
call h_hd_p_read	// keep esi
or al, al
jnz near l_h_hd_partitions_8

l_h_hd_partitions_21:

// GPT/MBR?
mov eax, dword hd_buffer[0]
mov edx, dword hd_buffer[4]
cmp eax, "EFI "
jnz near l_h_hd_partitions_mbr
cmp edx, "PART"
jnz near l_h_hd_partitions_mbr


// *** GPT ***

mov ecx, dword hd_buffer[80]
cmp ecx, 32
jna l_h_hd_partitions_31
  mov ecx, 32

l_h_hd_partitions_31:  // ecx = number of partitions
xor esi, esi           // esi = 0
xor ebx, ebx
inc ebx                // ebx = 1

// (*
l_h_hd_partitions_32:
  or esi, esi
  jnz l_h_hd_partitions_33
    // Read LBA 2++ (IN: es == ds)
    inc ebx  // ebx++
    push edi
     push ecx
      push ebx
        xor edx, edx
        mov edi, VA_SYSTEM + offset hd_buffer
        xor ecx, ecx
        inc ecx
        call h_hd_p_read  // keep esi
      pop ebx
     pop ecx
    pop edi
    or al, al
    jnz near l_h_hd_partitions_8

  l_h_hd_partitions_33:  // keep ebx, ecx
  push esi
   push ecx
    call h_disks_new
    mov edi, esi
   pop ecx
  pop esi
  or al, al
  jnz near l_h_hd_partitions_8

  // Store partition info
  mov byte ptr [edi + offset DiskInfoRec.type], DISK_TYPE_HD
  mov al, hdt_pdiskn
  mov [edi + offset DiskInfoRec.number], al
  mov eax, esi
  shr eax, 7  // div 128
  mov [edi + offset DiskInfoRec.partition], al
  mov dword ptr [edi + offset DiskInfoRec.main], offset h_hd_main
  
  add edi, VA_SYSTEM + offset DiskInfoRec.base_sectors

  mov eax, dword hd_buffer[esi+32]
  stosd
  mov eax, dword hd_buffer[esi+36]
  stosd  // store base8

  mov eax, dword hd_buffer[esi+40]
  mov edx, dword hd_buffer[esi+44]
  sub eax, dword hd_buffer[esi+32]
  sbb edx, dword hd_buffer[esi+36]
  add eax, 1
  adc edx, 0
  and al, -8  // align 8 (4096)
  stosd
  xchg eax, edx
  stosd  // store size8

  mov eax, dword hd_buffer[esi+48]
  stosd
  mov eax, dword hd_buffer[esi+52]
  stosd  // store attributes8

  // Next partition info
  add esi, 128
  and esi, 511
  dec ecx
  jecxz l_h_hd_partitions_38
    jmp l_h_hd_partitions_32
// *)

l_h_hd_partitions_38:
mov al, 0
jmp l_h_hd_partitions_8


// *** MBR ***

l_h_hd_partitions_mbr:
// Read LBA 0 (IN: es == ds, edi -> current physical disk info)
push edi
  xor edx, edx
  xor ebx, ebx
  xor ecx, ecx
  inc ecx
  mov edi, VA_SYSTEM + offset hd_buffer
  call h_hd_p_read  // keep es, esi
pop edi
test al, al
jnz l_h_hd_partitions_8

l_h_hd_partitions_41:
mov esi, 1BEh  // esi = 1BEh
mov ecx, 4     // ecx = 4
xor edx, edx   // edx = 0

// (*
l_h_hd_partitions_42:
 mov eax, dword hd_buffer[esi+12]
 or eax, eax
 jz l_h_hd_partitions_8
 
 push esi
  push ecx
   call h_disks_new
   mov edi, esi
  pop ecx
 pop esi

 mov byte ptr [edi + offset DiskInfoRec.type], DISK_TYPE_HD
 mov al, hdt_pdiskn
 mov [edi + offset DiskInfoRec.number], al
 mov eax, esi
 sub eax, 1BEh
 shr eax, 4  // div 16
 mov [edi + offset DiskInfoRec.partition], al
 mov dword ptr [edi + offset DiskInfoRec.main], offset h_hd_main
 //mov al, hd_buffer[esi+4] // partition type
 //mov [edi + offset DiskInfoRec.fsid], al
 
 add edi, VA_SYSTEM + offset DiskInfoRec.base_sectors
 
 xor edx, edx
 mov eax, dword hd_buffer[esi+8] // start of partition in sectors
 stosd
 xchg eax, edx
 stosd       // store base8
 xchg eax, edx
 mov eax, dword hd_buffer[esi+12] // size of partition in sectors
 and al, -8  // align 8 (4096)
 stosd
 xchg eax, edx
 stosd       // store size8
 xchg eax, edx

 // Next partition info
 add esi, 16
 loop l_h_hd_partitions_42
// *)

mov al, 0


l_h_hd_partitions_8:  // IN: al = 0 || errorcode

   pop ebx
  pop edx
 pop ecx
pop edi

ret

// IN: edx:ebx = ofs, ecx = size, hdt_ldiskn
// OUT: edx:ebx = sector number, ecx = sector count (both aligned 4096),
//      al = 0 || errorcode, hdt_relofs, hdt_endrelofs
// DESTROY: eax, esi
h_hd_prepare_values:
// relofs*
mov eax, ebx
and eax, 4095
mov hdt_relofs, ax
add eax, ecx
mov esi, eax  // esi = hdt_relofs + size
dec eax
and ax, 4095
mov hdt_endrelofs, ax
// sector count
xchg eax, esi
add eax, 4095
shr eax, 9    // log2(512)
and al, -8    // align 8
xchg ecx, eax
// sector number
mov eax, edx
shr ebx, 9    // log2(512)
shr edx, 9
shl eax, 32 - 9
or ebx, eax
and bl, -8    // align 8

// check sectn to disk size
movzx esi, byte hdt_ldiskn
cmp si, DISK_MAX
jb l_h_hd_prepare_values_2
  mov al, ERC_INVALID_DISK_NUMBER
  ret

l_h_hd_prepare_values_2:
shl esi, 5    // 5 = log2(sizeof(DiskInfoRec))
add esi, offset disk_info
push edi
  mov eax, ebx
  mov edi, edx
  add eax, ecx
  adc edi, 0  // edi:eax = after sector
  cmp edi, dword[esi + offset DiskInfoRec.size_sectors + 4]
  ja l_h_hd_prepare_values_outofrange
  jb l_h_hd_prepare_values_ok
    cmp eax, dword[esi + offset DiskInfoRec.size_sectors]
    jna l_h_hd_prepare_values_ok

  l_h_hd_prepare_values_outofrange:
pop edi
mov al, ERC_OUT_OF_RANGE
ret

 l_h_hd_prepare_values_ok:
 // add partition base
 add ebx, dword[esi + offset DiskInfoRec.base_sectors]
 adc edx, dword[esi + offset DiskInfoRec.base_sectors + 4]

pop edi

mov al, 0
ret

// IN: ah = 0: zero usg only, 1: all, hdt_ldiskn, hdt_pdiskn
// OUT: al = 0 || errorcode
// DESTROY: eax, esi
h_hd_flush:
push edi
 push edx
  push ebx
   push ecx

    xor edx, edx
    mov hdt_savecount, edx
    
    mov edi, HD_CACHE_PA
// (*
    l_h_hd_flush_1:
      mov al, [edi + offset HdCacheRec.dirty]  // dirty
      test al, 1
      jz l_h_hd_flush_next
        mov al, [edi + offset HdCacheRec.diskn]  // ldiskn
        cmp al, hdt_ldiskn
        jnz l_h_hd_flush_next
          test ah, 1
          jnz l_h_hd_flush_block
            mov dx, [edi + offset HdCacheRec.usg]  // usg
            or dx, dx
            jz l_h_hd_flush_block
      
      l_h_hd_flush_next:
      add edi, 16 + 4096
      cmp edi, HD_CACHE_PA + ((16 + 4096) * HD_CACHE_COUNT)
      jb l_h_hd_flush_1
// *)
    mov ecx, hdt_savecount
    test ecx, ecx
    jnz l_h_hd_flush_81

    l_h_hd_flush_7:
    
    mov al, 0
    
    l_h_hd_flush_8:

   pop ecx
  pop ebx
 pop edx
pop edi
ret


l_h_hd_flush_block:
// keep ah
mov esi, hdt_savecount
shl esi, 2
add esi, offset hdt_saveofs
// (*
l_h_hd_flush_61:
  cmp esi, offset hdt_saveofs
  jna l_h_hd_flush_65
    mov ebx, [esi - 4]  // ebx = ofs
    mov [esi], ebx
    mov edx, [ebx + 4]  // edx = sector number hw
    cmp [edi + 4], edx
    jnz l_h_hd_flush_62
      mov edx, [ebx]  // edx = sector number lw
      cmp [edi], edx
    
    l_h_hd_flush_62:
    jna l_h_hd_flush_65	// greater first
      sub esi, 4
      jmp short l_h_hd_flush_61
// *)
l_h_hd_flush_65:
mov [esi], edi
inc hdt_savecount
jmp l_h_hd_flush_next


l_h_hd_flush_81:
// IN: ecx = hdt_savecount
mov al, hdt_pdiskn
call h_hd_prepare_port_slave

mov esi, offset hdt_saveofs
shl ecx, 2
add esi, ecx

l_h_hd_flush_82:
 sub esi, 4
 mov edi, [esi]

 mov ebx, [edi + 0]
 mov edx, [edi + 4]
 push edi
   add edi, 16 + VA_SYSTEM
   mov ecx, 8
   call h_hd_p_write
 pop edi
 test al, al
 jnz l_h_hd_flush_8
   mov byte[edi + offset HdCacheRec.dirty], 0  // dirty = false
   cmp esi, offset hdt_saveofs
   ja l_h_hd_flush_82

jmp l_h_hd_flush_7

// OUT: al = 0 || errorcode
// DESTROY: eax
h_hd_shr_usg:
push edi
 push edx

  l_h_hd_shr_usg_0:
  mov edi, HD_CACHE_PA
  and ah, 15
// (*
  l_h_hd_shr_usg_1:
    shr word[edi + offset HdCacheRec.usg], 1  // usg
    mov dx, word[edi + offset HdCacheRec.usg] // usg == 0?
    or dx, dx
    jnz l_h_hd_shr_usg_5
      or ah, 10h

    l_h_hd_shr_usg_5:
    add edi, 16 + 4096
    cmp edi, HD_CACHE_PA + ((16 + 4096) * HD_CACHE_COUNT)
    jb l_h_hd_shr_usg_1
// *)
  test ah, 10h
  jz l_h_hd_shr_usg_0  // repeat until some usg is zero

  // Flush all disks
  mov al, hdt_pdiskn
  mov ah, hdt_ldiskn
  push eax
   mov edi, HD_CACHE_PA
// (*
   l_h_hd_shr_usg_61:
    mov al, [edi + offset HdCacheRec.dirty]  // dirty
    test al, 1
    jz l_h_hd_shr_usg_68
      mov ax, [edi + offset HdCacheRec.usg]  // usg
      or ax, ax
      jnz l_h_hd_shr_usg_68
        push esi
          mov al, [edi + offset HdCacheRec.diskn]  // ldiskn
          mov hdt_ldiskn, al
          movzx esi, al
          shl esi, 5  // assert sizeof DiskInfoRec = 32
          mov al, disk_info.number[esi]
          mov hdt_pdiskn, al
          call h_hd_prepare_port_slave
          mov ah, 0
          call h_hd_flush
        pop esi
        test al, al
        jnz l_h_hd_shr_usg_691
        
    l_h_hd_shr_usg_68:
    add edi, 16 + 4096
    cmp edi, HD_CACHE_PA + ((16 + 4096) * HD_CACHE_COUNT)
    jb l_h_hd_shr_usg_61
// *)
  pop eax
  mov hdt_ldiskn, ah
  mov hdt_pdiskn, al
  call h_hd_prepare_port_slave
  mov al, 0
  jmp short l_h_hd_shr_usg_692

   l_h_hd_shr_usg_691:
  pop edx
  mov hdt_ldiskn, dh
  mov hdt_pdiskn, dl

  l_h_hd_shr_usg_692:
 pop edx
pop edi
ret

// OUT: al = 0 || errorcode, esi -> block cache
// DESTROY: eax
h_hd_find_victim:

l_h_hd_find_victim_0:
mov esi, HD_CACHE_PA
// (*
l_h_hd_find_victim_1:
  mov ax, [esi + offset HdCacheRec.usg]  // usg
  or ax, ax
  jz l_h_hd_find_victim_81
    add esi, 16 + 4096
    cmp esi, HD_CACHE_PA + ((16 + 4096) * HD_CACHE_COUNT)
    jb l_h_hd_find_victim_1
// *)

call h_hd_shr_usg
or al, al
jnz l_h_hd_find_victim_84
  jmp short l_h_hd_find_victim_0

l_h_hd_find_victim_81:

mov al, 0

l_h_hd_find_victim_84:
ret

// IN: edx:ebx = sector, hdt_ldiskn
// OUT: al = 0 || errorcode, esi -> block cache
// DESTROY: eax
h_hd_get_block:
mov esi, HD_CACHE_PA
// (*
l_h_hd_get_block_1:
  cmp [esi + offset HdCacheRec.sectn], ebx  // sector number lw
  jnz l_h_hd_get_block_next
    cmp [esi + offset HdCacheRec.sectn + 4], edx  // sector number hw
    jnz l_h_hd_get_block_next
      mov al, [esi + offset HdCacheRec.diskn]  // ldiskn
      cmp al, hdt_ldiskn
      jnz l_h_hd_get_block_next
        // block found at esi
        cmp word[esi + offset HdCacheRec.usg], 65535  // usg
        jz l_h_hd_get_block_2
        
          inc word[esi + offset HdCacheRec.usg]  // usg++
        
        l_h_hd_get_block_2:

        mov al, 0

        ret
        
  l_h_hd_get_block_next:
  add esi, 16 + 4096
  cmp esi, HD_CACHE_PA + ((16 + 4096) * HD_CACHE_COUNT)
  jb l_h_hd_get_block_1
// *)

call h_hd_find_victim
or al, al
jnz l_h_hd_get_block_8
  mov [esi + offset HdCacheRec.sectn], ebx
  mov [esi + offset HdCacheRec.sectn + 4], edx  // sectn
  mov byte[esi + offset HdCacheRec.dirty], 0  // dirty = false
  mov al, -1
  mov [esi + offset HdCacheRec.diskn], al  // diskn, for case of error
  push esi
   push edx
    push ebx
     push ecx
  
      xchg esi, edi
      add edi, 16 + VA_SYSTEM
      mov ecx, 8
      
      // IN: edx:ebx = sector, ecx = count, es:edi -> buffer,
      //     hdt_slave_bit, hdt_port_base
      // OUT: edx:ebx = next sector
      // DESTROY: eax, ecx, hdt_high, hdt_count_remain
      call h_hd_p_read
      xchg esi, edi
      
     pop ecx
    pop ebx
   pop edx
  pop esi
  test al, al
  jnz l_h_hd_get_block_8
    mov al, hdt_ldiskn
    mov [esi + offset HdCacheRec.diskn], al  // ldiskn
    xor eax, eax
    inc eax
    mov [esi + offset HdCacheRec.usg], ax  // usg = 1
    mov byte [esi + offset HdCacheRec.dirty], 0  // dirty = false
    
    mov al, 0

l_h_hd_get_block_8:
ret

h_hd_init:

// Zero hd_busy, hd_cache

xor eax, eax
mov hd_busy, al

push es
  push ds
  pop es
  
  mov hdt_slave_bit, al
  mov hdt_port_base, 1F0h
  mov hd_busy, al
  
  // Init hd_cache
  
  mov edi, HD_CACHE_PA  // es:edi -> hd_cache
  xor eax, eax          // eax = 0
  
  l_h_hd_init_51:
    dec eax  // eax = -1
    stosd
    stosd
    inc eax  // eax = 0
    stosd
    stosd
    add edi, sizeof HdCacheRec - 16
    cmp edi, HD_CACHE_PA + (HD_CACHE_COUNT * sizeof HdCacheRec)
    jb l_h_hd_init_51
  
pop es

ret

l_h_hd_read_x:
mov al, 0
ret

// IN: al = ldiskn, edx:ebx = ofs, ecx = size, es:edi -> buffer
// OUT: al = 0 || erc
h_hd_read:
mov hdt_ldiskn, al
movzx esi, al
shl esi, 5  // log2(sizeof(DiskInfoRec)) = 5
mov al, disk_info.number[esi]
mov hdt_pdiskn, al
jecxz l_h_hd_read_x

call h_hd_prepare_port_slave
// prepared: hdt_pdiskn, hdt_slave_bit, hdt_port_base

l_h_hd_read_11:
// IN: edx:ebx = ofs, ecx = size
// OUT: edx:ebx = sector number, ecx = sector count (both aligned 4096),
//      al = 0 || errorcode, hdt_relofs, hdt_endrelofs
// DESTROY: eax, esi
call h_hd_prepare_values
or al, al
jz l_h_hd_read_111

  ret  // error

l_h_hd_read_111:

mov ax, hdt_relofs
or ax, ax
jz l_h_hd_read_20

// * Read unaligned first block *

// IN: edx:ebx = sector
// OUT: al = 0 || errorcode, esi -> block cache
// DESTROY: eax
call h_hd_get_block  // esi -> block cache
or al, al
jnz near l_h_hd_read_88

add esi, offset HdCacheRec.data
movzx eax, word hdt_relofs  // eax = hdt_relofs
add esi, eax  // esi += 16 + relofs
sub ecx, 8    // ecx - 8
push ecx
  jecxz l_h_hd_read_12
    mov ecx, 4095  // ecx = 4095
    jmp short l_h_hd_read_13

  l_h_hd_read_12:
    movzx ecx, word hdt_endrelofs  // ecx = endrelofs

  l_h_hd_read_13:
  inc ecx
  sub ecx, eax  // ecx + 1 - relofs
  cld
  rep movsb  // edi += ecx
pop ecx
add ebx, 8
adc edx, 0  // sectn + 8
// as for other blocks, relofs is always 0

l_h_hd_read_20:
or ecx, ecx
jz near l_h_hd_read_85

// * Read aligned blocks *

cmp hdt_endrelofs, 4095
jz l_h_hd_read_21
  sub ecx, 8  // ecx - 8
  or ecx, ecx
  jz near l_h_hd_read_26

// (*
l_h_hd_read_21:

// Is any sector dirty in cache?
mov esi, HD_CACHE_PA

push edi

  xor eax, eax
  dec eax  // eax = -1
  mov dword hdt_min[0], eax
  mov dword hdt_min[4], eax   // hdt_min = maxuns
  mov eax, ebx
  mov edi, edx
  add eax, ecx
  adc edi, 0
  mov dword hdt_tmp1[0], eax
  mov dword hdt_tmp1[4], edi  // hdt_tmp1 = edx:ebx + ecx

  // (*
  l_h_hd_read_22:
    mov al, [esi + offset HdCacheRec.diskn]  // ldiskn
    cmp al, hdt_ldiskn
    jnz l_h_hd_read_2_next
      test byte[esi + offset HdCacheRec.dirty], 1  // dirty
      jz l_h_hd_read_2_next
    // sectn + 8 > edx:ebx && sectn < edx:ebx + ecx
    mov eax, [esi + offset HdCacheRec.sectn]
    mov edi, [esi + offset HdCacheRec.sectn + 4]
    add eax, 8
    adc edi, 0  // edi:eax = sectn + 8
    cmp edi, edx
    jb l_h_hd_read_2_next
    ja l_h_hd_read_23
      cmp eax, ebx
      jna l_h_hd_read_2_next

    l_h_hd_read_23:  // ja: edi:eax > edx:ebx
    sub eax, 8
    sbb edi, 0       // edi:eax = sectn
    cmp edi, dword hdt_tmp1[4]
    ja l_h_hd_read_2_next
    jb l_h_hd_read_24
      cmp eax, dword hdt_tmp1[0]
      jnb l_h_hd_read_2_next

    l_h_hd_read_24:	// jb: edi:eax < edx:ebx + ecx
    // if edi:eax < hdt_min => hdt_min=edi:eax
    cmp edi, dword hdt_min[4]
    jb l_h_hd_read_24t
    ja l_h_hd_read_24f
      cmp eax, dword hdt_min[0]
      jnb l_h_hd_read_24f

    l_h_hd_read_24t:
    mov dword hdt_min[0], eax
    mov dword hdt_min[4], edi

    l_h_hd_read_24f:
    
    l_h_hd_read_2_next:
    add esi, 16 + 4096
    cmp esi, HD_CACHE_PA + ((16 + 4096) * HD_CACHE_COUNT)
    jb l_h_hd_read_22
  // *)

pop edi

// if(hdt_min != -1){ hdt_x = ecx, ecx = hdt_min - edx:ebx,
//  hdt_x -= ecx, p_read, ecx = hdt_x
//  if(ecx != 0){ copy blk; jmp l_h_hd_read_21; } }
// else p_read
xor eax, eax
dec eax  // eax = -1
cmp eax, dword hdt_min[0]
jnz l_h_hd_read_251
  cmp eax, dword hdt_min[4]
  jnz l_h_hd_read_251
    jmp l_h_hd_read_258

l_h_hd_read_251:
mov dword hdt_tmp1, ecx
mov eax, dword hdt_min[0]
sub eax, ebx
xchg ecx, eax  // ecx = hdt_min - ebx
sub dword hdt_tmp1, ecx
or ecx, ecx
jz l_h_hd_read_252
  call h_hd_p_read  // edx:ebx = next sector
  or eax, eax
  jnz l_h_hd_read_88

l_h_hd_read_252:
  mov ecx, dword hdt_tmp1
  or ecx, ecx
  jz l_h_hd_read_26
    // IN: edx:ebx = sector, fs = ALLMEM
    // OUT: al = 0 || errorcode, esi -> block cache
    // DESTROY: eax
    call h_hd_get_block  // fs:esi -> block cache
    or al, al
    jnz l_h_hd_read_88

add esi, 16
push ecx
  mov ecx, 4096 / 4
  cld
  rep movsd  //edi+=ecx
pop ecx
add ebx, 8
adc edx, 0  // sectn + 8
sub ecx, 8  // ecx - 8
or ecx, ecx
jz l_h_hd_read_26
  jmp l_h_hd_read_21
// *)

l_h_hd_read_258:
// IN: edx:ebx = sector, ecx = count, es:edi -> buffer,
//     hdt_slave_bit, hdt_port_base
// OUT: edx:ebx = next sector
// DESTROY: eax, ecx, hdt_high, hdt_count_remain
call h_hd_p_read
or al, al
jnz l_h_hd_read_88

// * Read unaligned last block *

l_h_hd_read_26:
movzx ecx, word hdt_endrelofs
cmp cx, 4095
jz l_h_hd_read_85
  // IN: edx:ebx = sector
  // OUT: al = 0 || errorcode, esi -> block cache
  // DESTROY: eax
  call h_hd_get_block   // esi -> block cache
  or al, al
  jnz l_h_hd_read_88
    add esi, 16
    inc ecx
    cld
    rep movsb
  
l_h_hd_read_85:
mov al, 0

l_h_hd_read_88:

ret

l_h_hd_write_x:
mov al, 0
ret

// IN: al = ldiskn, edx:ebx = ofs, ecx = size, es:edi -> buffer
// OUT: al = 0 || erc
h_hd_write:
mov hdt_ldiskn, al
movzx esi, al
shl esi, 5  // log2(sizeof(DiskInfoRec)) = 5
mov al, disk_info.number[esi]
mov hdt_pdiskn, al
jecxz l_h_hd_write_x

or byte ptr disk_info.flags[esi], DISK_FLAGS_DIRTY
call h_hd_prepare_port_slave
// prepared: hdt_pdiskn, hdt_slave_bit, hdt_port_base

// IN: edx:ebx = ofs, ecx = size
// OUT: edx:ebx = sector number, ecx = sector count (both aligned 4096),
//      al = 0 || errorcode, hdt_relofs, hdt_endrelofs
// DESTROY: eax, esi
call h_hd_prepare_values
or al, al
jz l_h_hd_write_111

  ret  // error

l_h_hd_write_111:

mov ax, hdt_relofs
or ax, ax
jz l_h_hd_write_20

// * Write unaligned first block *

// IN: edx:ebx = sector
// OUT: al = 0 || errorcode, esi -> block cache
// DESTROY: eax
call h_hd_get_block  // esi -> block cache
xchg esi, edi        // edi -> block cache, es:esi -> buffer
or al, al
jnz near l_h_hd_write_88

or byte[edi + offset HdCacheRec.dirty], 1  // dirty = true
add edi, offset HdCacheRec.data
movzx eax, word hdt_relofs  // eax = hdt_relofs
add edi, eax  // edi += 16 + relofs
sub ecx, 8    // ecx - 8
push ecx
  jecxz l_h_hd_write_12
    mov ecx, 4095  // ecx = 4095
    jmp short l_h_hd_write_13

  l_h_hd_write_12:
    movzx ecx, word hdt_endrelofs  // ecx = endrelofs

  l_h_hd_write_13:
  inc ecx
  sub ecx, eax  // ecx + 1 - relofs

  push ds
   push es
   pop ds
  pop es  // es<->ds

  cld
  rep movsb

  push ds
   push es
   pop ds
  pop es  // es<->ds

pop ecx
xchg esi, edi  // es:edi -> buffer+
add ebx, 8
adc edx, 0     // sectn + 8
// as for other blocks, relofs is always 0

l_h_hd_write_20:
or ecx, ecx
jz near l_h_hd_write_85

// * Write aligned blocks *

cmp hdt_endrelofs, 4095
jz l_h_hd_write_21
  sub ecx, 8  // ecx - 8
  jecxz l_h_hd_write_26

l_h_hd_write_21:
// Invalidate overwritten blocks in cache
mov esi, HD_CACHE_PA

push edi

  mov eax, ebx
  mov edi, edx
  add eax, ecx
  adc edi, 0
  mov dword hdt_tmp1[0], eax
  mov dword hdt_tmp1[4], edi  // hdt_tmp1 = edx:ebx + ecx

  // (*
  l_h_hd_write_22:
    mov al, [esi + offset HdCacheRec.diskn]  // diskn
    cmp al, hdt_ldiskn
    jnz l_h_hd_write_2_next
      // sectn + 8 > edx:ebx && sectn < edx:ebx + ecx
      mov eax, [esi + offset HdCacheRec.sectn]
      mov edi, [esi + offset HdCacheRec.sectn + 4]
      add eax, 8
      adc edi, 0  // edi:eax = sectn + 8
      cmp edi, edx
      jb l_h_hd_write_2_next
      ja l_h_hd_write_23
        cmp eax, ebx
        jna l_h_hd_write_2_next

      l_h_hd_write_23:  // ja: edi:eax > edx:ebx
      sub eax, 8
      sbb edi, 0        // edi:eax = sectn
      cmp edi, dword hdt_tmp1[4]
      ja l_h_hd_write_2_next
      jb l_h_hd_write_24
        cmp eax, dword hdt_tmp1[0]
        jnb l_h_hd_write_2_next

      l_h_hd_write_24:  // jb: edi:eax < edx:ebx + ecx
      xor eax, eax
      dec eax             // eax = -1
      mov [esi + offset HdCacheRec.sectn], eax
      mov [esi + offset HdCacheRec.sectn + 4], eax  // sectn = -1
      inc eax             // eax = 0
      mov [esi + offset HdCacheRec.usg], ax  // usg = 0
      mov [esi + offset HdCacheRec.dirty], al // dirty = false
    
    l_h_hd_write_2_next:
    add esi, 16 + 4096
    cmp esi, HD_CACHE_PA + ((16 + 4096) * HD_CACHE_COUNT)
    jb l_h_hd_write_22
  // *)

pop edi

// IN: edx:ebx = sector, ecx = count, es:edi -> buffer,
//     hdt_slave_bit, hdt_port_base
// OUT: edx:ebx = next sector
// DESTROY: eax, ecx, hdt_high, hdt_count_remain
call h_hd_p_write
or eax, eax
jnz l_h_hd_write_88

// * Write unaligned last block *

l_h_hd_write_26:
movzx ecx, word hdt_endrelofs
cmp cx, 4095
jz l_h_hd_write_85
  // IN: edx:ebx = sector
  // OUT: al = 0 || errorcode, esi -> block cache
  // DESTROY: eax
  call h_hd_get_block  // esi -> block cache
  xchg esi, edi        // edi -> block cache, es:esi -> buffer
  or al, al
  jnz l_h_hd_write_88
    or byte[edi + offset HdCacheRec.dirty], 1  // dirty = true
    add edi, 16
    inc ecx
    
    push ds
     push es
     pop ds
    pop es  // es<->ds

    cld
    rep movsb

    push ds
     push es
     pop ds
    pop es  // es<->ds

l_h_hd_write_85:
mov al, 0

l_h_hd_write_88:
 
ret

// IN: ah = operation
// ah = 0: al = ldiskn
// ah = 2: al = ldiskn, edx:ebx = ofs, ecx = size, es:edi -> buffer
// ah = 3: al = ldiskn, edx:ebx = ofs, ecx = size, es:edi -> buffer
// ah = 4: al = ldiskn
// ah = 5: al = ldiskn
h_hd_main:

cmp ah, 2
jnz l_h_hd_main_3
  // read
  jmp h_hd_read

l_h_hd_main_3:
cmp ah, 3
jnz l_h_hd_main_4
  // write
  jmp h_hd_write

l_h_hd_main_4:
cmp ah, 4
jnz l_h_hd_main_5
  // get disk size (al = ldiskn)
  movzx esi, al
  shl esi, 5  // log2(DiskInfoRec)
  cmp al, 32
  jb l_h_hd_main_44
    xor edx, edx
    xor eax, eax
    ret
  
  l_h_hd_main_44:
  add esi, offset disk_info.size_sectors
  mov eax, dword[esi]
  mov edx, dword[esi+4]
  mov esi, eax
  shl eax, 9
  shl edx, 9
  shr esi, 32-9
  or edx, esi
  ret

l_h_hd_main_5:
cmp ah, 5
jnz l_h_hd_main_7
  // flush (al = ldiskn)
  cmp al, 32
  jnb l_h_hd_main_58
    mov hdt_ldiskn, al
    movzx esi, al
    shl esi, 5  // log2(sizeof(DiskInfoRec))
    cmp disk_info.fsid[esi], FSID_EXT2
    jnz l_h_hd_main_52
      // backup EXT2
      push esi
        call e2_backup
      pop esi
      mov al, hdt_ldiskn
      
    l_h_hd_main_52:
    mov al, disk_info.number[esi]
    mov hdt_pdiskn, al
    mov ah, 1  // flush all
    call h_hd_flush
    
    // hardware flush
    mov al, hdt_pdiskn
    test al, 40h
    jnz l_h_hd_main_54
      call h_hd_prepare_port_slave
      call h_hd_p_flush
      jmp short l_h_hd_main_58
      
    l_h_hd_main_54:
    call h_sd_p_flush
    
  l_h_hd_main_58:
  ret

l_h_hd_main_7:
cmp ah, 7
jnz l_h_hd_main_1
  // format
  //...
  mov al, ERC_NOT_IMPLEMENTED
  ret

l_h_hd_main_1:
cmp ah, 1
jnz l_h_hd_main_0
  // reset
  xor eax, eax
  mov dword hd_state, eax
  mov hd_busy, al
  ret

l_h_hd_main_0:
cmp ah, 0
jnz l_h_hd_main_x
  // init
  jmp h_hd_init

l_h_hd_main_x:
// error
mov al, ERC_NOT_IMPLEMENTED
ret

//hdirq1: db "HD INT\0"

IRQ14:
IRQ15:
/*
pushad
 push ds
  push es
    push SELECTOR_KERNEL_DATA
    pop ds  // ds = KERNEL_DATA
    push SELECTOR_ALL_DATA
    pop es  // es = ALL
    
    //inc hd_irqs
    
    //mov esi, offset hdirq1
    //call writec
    
    mov al, 20h
    out 20h, al
  pop es
 pop ds
popad
*/
iretd

uns1 cd_packet[12], cd_buffer[2048]
uns4 cd_lba

// IN: hdt_slave_bit, hdt_port_base, es:edi -> buffer
h_hd_p_identifyp:
push edx

  mov dx, hdt_port_base

  mov al, hdt_slave_bit
  or dl, 6
  out dx, al

  mov al, ATA_CMD_IDENTIFYP
  or dl, 7		// dx = HD_PORT_COMMAND (7)
  out dx, al

  h_hd_p_identifyp5:
    or dl, 7	// dx = HD_PORT_STATUS (7)
    in al, dx
    test al, HD_STATUS_BUSY
    jz h_hd_p_identifyp6
      //... noop();
      jmp h_hd_p_identifyp5
  
  h_hd_p_identifyp6:
  test al, HD_STATUS_ERROR | HD_STATUS_FAULT
  jnz l_h_hd_p_identifyperror
  
  push ecx
   and dl, 0F8h	// dx = HD_PORT_DATA (0)
   mov ecx, 512/4
   cld
   rep insd
  pop ecx
  
pop edx

xor eax, eax
ret

l_h_hd_p_identifyperror:
pop edx
jmp l_h_hd_p_error

// IN: ebx = sector number, hdt_pdiskn, hdt_port_base, hdt_slave_bit
// KEEP: ebx, ecx, edi
h_cd_p_read:
mov word ptr cd_packet[0], SCSI_COMMAND_READ10

mov eax, ebx
shr eax, 16
mov byte ptr cd_packet[2], ah
mov byte ptr cd_packet[3], al
mov byte ptr cd_packet[4], bh
mov byte ptr cd_packet[5], bl

mov byte ptr cd_packet[6], 0

mov byte ptr cd_packet[7], 1 / 256
mov byte ptr cd_packet[8], 1 & 255

mov byte ptr cd_packet[9], 0
mov word ptr cd_packet[10], 0

test hdt_pdiskn, 40h
jnz near h_sd_p_cd_read

push ebx
 push ecx
  
  mov dx, hdt_port_base
  
  mov al, hdt_slave_bit
  or dl, 6  // dx = HD_PORT_DRIVEHEAD (6)
  out dx, al
  
  sub dl, 5 // dx = 1
  mov al, 0 // 0: PIO, 1:DMA
  out dx, al
  
  add dl, 3 // dx = 4
  mov al, 2048 & 255
  out dx, al
  inc dl    // dx = 5
  mov al, 2048 >> 8
  out dx, al
  
  mov al, ATA_CMD_PACKET
  or dl, 7  // dx = HD_PORT_COMMAND (7)
  out dx, al
  
  l_h_cd_p_read_5:
    or dl, 7  // dx = HD_PORT_STATUS (7)
    in al, dx
    test al, HD_STATUS_BUSY
    jz l_h_cd_p_read_6
      //... noop();
      jmp l_h_cd_p_read_5
  
  l_h_cd_p_read_6:
  test al, HD_STATUS_ERROR | HD_STATUS_FAULT
  jnz l_h_cd_p_read_error

  //mov bl, hd_irqs
  
  // write packet
  and dl, 0F8h  // dx = HD_PORT_DATA (0)
  mov esi, offset cd_packet
  mov ecx, 6
/*
  movzx eax, byte ptr cd_packet[8]
  call wregs//$$$
  mov ebx, 500
  call busywait
*/
  cld
  rep outsw
  
  // wait
  l_h_cd_p_read_7:
    or dl, 7  // dx = HD_PORT_STATUS (7)
    in al, dx
    test al, HD_STATUS_BUSY
    jz l_h_cd_p_read_8
      call p_noop
      jmp l_h_cd_p_read_7

  l_h_cd_p_read_8:
  test al, HD_STATUS_ERROR | HD_STATUS_FAULT
  jnz l_h_cd_p_read_error

  // read byte count
  and dl, 0F8h
  add dl, 4  // dx = HD_PORT_CYLLOW (4) / LBA mid
  in al, dx
  mov cl, al
  inc dl  // dx = HD_PORT_CYLHIGH (5) / LBA high
  in al, dx
  mov ch, al
  movzx ecx, cx  // assert ecx = 2048
  cmp ecx, 800h
  jz l_h_cd_p_read_85
    mov al, ERC_UNKNOWN_GEOMETRY
     pop ecx
    pop ebx
    jmp short l_h_cd_p_read_9

  l_h_cd_p_read_85:

  //mov bl, hd_irqs

  // read data
  push edi
    and dl, 0F8h  // dx = HD_PORT_DATA (0)
    mov edi, VA_SYSTEM + offset cd_buffer
    shr ecx, 2
    rep insd
  pop edi
/*
  // wait for irq
  l_h_cd_p_read_85:
  cmp bl, hd_irqs
  jnz l_h_cd_p_read_88
    call p_noop
    jmp short l_h_cd_p_read_85

  l_h_cd_p_read_88:
*/
 pop ecx
pop ebx

mov al, 0

l_h_cd_p_read_9:
ret

l_h_cd_p_read_error:
 pop ecx
pop ebx
jmp l_h_hd_p_error

h_cd_init:
mov cd_lba, -1
ret

// IN: al = ldiskn, edx:ebx = ofs, ecx = size, es:edi -> buffer
h_cd_read:
mov hdt_ldiskn, al
movzx esi, al
shl esi, 5  // log2(sizeof(DiskInfoRec)) = 5
mov al, disk_info.number[esi]
mov hdt_pdiskn, al
call h_hd_prepare_port_slave

// Prepare values
// relofs*
mov eax, ebx
and eax, 2047
mov hdt_relofs, ax
add eax, ecx
mov esi, eax  // esi = hdt_relofs + size
dec eax
and ax, 2047
mov hdt_endrelofs, ax
// sector count
xchg eax, esi
add eax, 2047
shr eax, 11    // log2(2048)
xchg ecx, eax
// sector number
mov eax, edx
shr ebx, 11    // log2(2048)
shr edx, 11
shl eax, 32 - 11
or ebx, eax

l_h_cd_read_5:
jecxz l_h_cd_read_8
  dec ecx
  
  cmp ebx, cd_lba
  jz l_h_cd_read_6
    call h_cd_p_read  // keep ebx, ecx, edi
    mov cd_lba, ebx
    
  l_h_cd_read_6:
  mov eax, offset cd_buffer
  push ecx

    movzx esi, hdt_relofs
    add esi, eax
    or ecx, ecx
    jnz l_h_cd_read_7
      movzx ecx, hdt_endrelofs
      inc ecx
      jmp short l_h_cd_read_72
    
    l_h_cd_read_7:
      mov ecx, 2048
  
    l_h_cd_read_72:
    sub cx, hdt_relofs
    cld
    rep movsb

  pop ecx
  inc ebx
  mov hdt_relofs, 0
  jmp l_h_cd_read_5

l_h_cd_read_8:
mov al, 0
ret

// IN: ah = operation
// ah = 2: al = ldiskn, edx:ebx = ofs, ecx = size, es:edi -> buffer
// ah = 4: al = ldiskn
h_cd_main:
and al, 31
cmp ah, 2
jnz l_h_cd_main_2
  jmp h_cd_read
  
l_h_cd_main_2:
cmp ah, 4
jnz l_h_cd_main_8
  movzx esi, al
  shl esi, 5  // assert sizeof DiskInfoRec = 32
  add esi, offset disk_info.size_sectors
  mov eax, dword[esi]
  mov edx, dword[esi+4]
  mov esi, eax
  shl eax, 9
  shl edx, 9
  shr esi, 32-9
  or edx, esi
  jmp short l_h_cd_main_9
  
l_h_cd_main_8:
mov al, ERC_NOT_IMPLEMENTED

l_h_cd_main_9:
ret

FIS_TYPE_REG_H2D   = 0x27	// Register FIS - host to device
FIS_TYPE_REG_D2H   = 0x34	// Register FIS - device to host
FIS_TYPE_DMA_ACT   = 0x39	// DMA activate FIS - device to host
FIS_TYPE_DMA_SETUP = 0x41	// DMA setup FIS - bidirectional
FIS_TYPE_DATA      = 0x46	// Data FIS - bidirectional
FIS_TYPE_BIST      = 0x58	// BIST activate FIS - bidirectional
FIS_TYPE_PIO_SETUP = 0x5F	// PIO setup FIS - device to host
FIS_TYPE_DEV_BITS  = 0xA1	// Set device bits FIS - device to host

HBA_PxCMD_CR  = (1 << 15) /* CR - Command list Running */
HBA_PxCMD_FR  = (1 << 14) /* FR - FIS receive Running */
HBA_PxCMD_FRE = (1 <<  4) /* FRE - FIS Receive Enable */
HBA_PxCMD_SUD = (1 <<  1) /* SUD - Spin-Up Device */
HBA_PxCMD_ST  = (1 <<  0) /* ST - Start (command processing) */

HBA_PxIS_TFES = 1 << 30

RA_SD_BUFFER = (256 * 32) + (1024 * 32) + (256 * 32)

struct HbaMemRec{
  // 0x00 - 0x2B, Generic Host Control
  uns4 cap		// 0x00, Host capability
  uns4 ghc		// 0x04, Global host control
  uns4 is		// 0x08, Interrupt status
  uns4 pi		// 0x0C, Port implemented
  uns4 vs		// 0x10, Version
  uns4 ccc_ctl	// 0x14, Command completion coalescing control
  uns4 ccc_pts	// 0x18, Command completion coalescing ports
  uns4 em_loc	// 0x1C, Enclosure management location
  uns4 em_ctl	// 0x20, Enclosure management control
  uns4 cap2		// 0x24, Host capabilities extended
  uns4 bohc		// 0x28, BIOS/OS handoff control and status
   
  // 0x2C - 0x9F, Reserved
  uns1 rsv[0xA0-0x2C];
   
  // 0xA0 - 0xFF, Vendor specific registers
  uns1 vendor[0x100-0xA0];
}

struct HbaPortRec{
  uns4 clb		// 0x00, command list base address, 1K-byte aligned
  uns4 clbu		// 0x04, command list base address upper 32 bits
  uns4 fb		// 0x08, FIS base address, 256-byte aligned
  uns4 fbu		// 0x0C, FIS base address upper 32 bits
  uns4 is		// 0x10, interrupt status
  uns4 ie		// 0x14, interrupt enable
  uns4 cmd		// 0x18, command and status
  uns4 rsv0		// 0x1C, Reserved
  uns4 tfd		// 0x20, task file data
  uns4 sig		// 0x24, signature
  uns4 ssts		// 0x28, SATA status (SCR0:SStatus)
  uns4 sctl		// 0x2C, SATA control (SCR2:SControl)
  uns4 serr		// 0x30, SATA error (SCR1:SError)
  uns4 sact		// 0x34, SATA active (SCR3:SActive)
  uns4 ci		// 0x38, command issue
  uns4 sntf		// 0x3C, SATA notification (SCR4:SNotification)
  uns4 fbs		// 0x40, FIS-based switch control
  uns4 rsv1[11]	// 0x44 ~ 0x6F, Reserved
  uns4 vendor[4]	// 0x70 ~ 0x7F, vendor specific
}

struct HbaCmdHeader{
  // DWORD 0
  uns1 cflawp
  // 0-4: Command FIS length in DWORDS, 2 ~ 16
  // 5: ATAPI
  // 6: Write
  // 7: Prefetchable
  uns1 rbcpmp
  // 0: reset
  // 1: BIST
  // 2: Clear busy upon R_OK
  // 4-7: port multiplier
  uns2 prdtl	// Physical region descriptor table length in entries
  
  // DWORD 1
  uns4 prdbc	// Physical region descriptor byte count transferred
  
  // DWORD 2, 3
  uns4 ctba		// Command table descriptor base address
  uns4 ctbau	// Command table descriptor base address upper 32 bits
  
  // DWORD 4 - 7
  uns4 rsv[4];	// Reserved
}

struct HbaCmdTbl{
  uns1 cfis[64]	// 0x00, Command FIS
  uns1 acmd[16]	// 0x40, ATAPI command, 12 or 16 bytes
  uns1 rsv[48]	// 0x50, Reserved
  // 0x80, HbaPrdtEntry prdt_entry[prdtl]
  // Physical region descriptor table entries, 0..65535
}

struct HbaPrdtEntry{
  uns4 dba	// Data base address
  uns4 dbau	// Data base address upper 32 bits
  uns4 rsv	// Reserved 
  uns4 dbci
  // 0 - 21: Byte count - 1, 4M max, always odd
  // 22-30: reserved
  // 31: Interrupt on completion
}

struct FisRegH2D{
  // DWORD 0
  uns1 fis_type  // FIS_TYPE_REG_H2D
  uns1 pmportc
  // 0-4: Port multiplier
  // 80h: Command, 0: Control
  uns1 command   // Command register
  uns1 featurel  // Feature register, 7:0
  
  // DWORD 1
  uns1 lba0		// LBA low register, 7:0
  uns1 lba1		// LBA mid register, 15:8
  uns1 lba2		// LBA high register, 23:16
  uns1 device	// Device register
  
  // DWORD 2
  uns1 lba3		// LBA register, 31:24
  uns1 lba4		// LBA register, 39:32
  uns1 lba5		// LBA register, 47:40
  uns1 featureh	// Feature register, 15:8
  
  // DWORD 3
  uns1 countl	// Count register, 7:0
  uns1 counth	// Count register, 15:8
  uns1 icc		// Isochronous command completion
  uns1 control	// Control register
  
  // DWORD 4
  uns1 rsv[4]	// Reserved
}

// IN: hdt_pdiskn, edx:ebx = sector, ecx = count, es:edi -> buffer
// OUT: al = erc, edx:ebx = next sector
// KEEP: esi
// USES: hdt_count_remain, sd_sect
h_sd_p_read:
push esi
 push ecx
  mov dword ptr sd_sect[0], ebx
  mov dword ptr sd_sect[4], edx
  mov esi, edi
  
  l_h_sd_p_read_1:
  xor eax, eax
  cmp ecx, 8
  jna l_h_sd_p_read_11
    mov eax, ecx
    sub eax, 8
    mov ecx, 8
    
  l_h_sd_p_read_11:
  mov hdt_count_remain, eax
  
  mov al, hdt_pdiskn
  and al, 31
  movzx eax, al
  mov sd_port_n, eax
  shl eax, 7  // * 80h
  add eax, abar
  add eax, 100h
  mov sd_port_ebx, eax
  
  mov ebx, eax
  add ebx, offset HbaPortRec.is
  mov eax, -1
  push ecx
    call m_phys_set  // destroys ecx
  pop ecx
  
  mov eax, sd_port_n
  shl eax, 10  // * 1024
  add eax, 256 * 32 + VA_SD
  mov edi, eax  // es:edi -> cmdheader
  
  mov al, sizeof FisRegH2D / 4
  //or al, 20h  // ATAPI
  //or al, 40h  // write
  or al, 80h  // Prefetch
  mov [es:edi + offset HbaCmdHeader.cflawp], al
  mov word ptr [es:edi + offset HbaCmdHeader.prdtl], 1  // prdtl - prdt count
  mov dword ptr [es:edi + offset HbaCmdHeader.prdbc], 4095  // byte count - 1
  
  mov edi, [es:edi + offset HbaCmdHeader.ctba]
  sub edi, sd_base
  add edi, VA_SD
  
  mov al, FIS_TYPE_REG_H2D
  mov [es:edi + offset FisRegH2D.fis_type], al
  mov al, 80h  // command
  mov [es:edi + offset FisRegH2D.pmportc], al
  mov al, ATA_CMD_READ_DMA_EX
  mov [es:edi + offset FisRegH2D.command], al
  
  mov al, byte ptr sd_sect[0]
  mov [es:edi + offset FisRegH2D.lba0], al
  mov al, byte ptr sd_sect[1]
  mov [es:edi + offset FisRegH2D.lba1], al
  mov al, byte ptr sd_sect[2]
  mov [es:edi + offset FisRegH2D.lba2], al
  mov al, 1 << 6  // LBA mode
  mov [es:edi + offset FisRegH2D.device], al
  mov al, byte ptr sd_sect[3]
  mov [es:edi + offset FisRegH2D.lba3], al
  mov al, byte ptr sd_sect[4]
  mov [es:edi + offset FisRegH2D.lba4], al
  mov al, byte ptr sd_sect[5]
  mov [es:edi + offset FisRegH2D.lba5], al
  
  mov [es:edi + offset FisRegH2D.countl], cx  // sector count
  
  add edi, 80h  // es:edi -> PRDT
  mov eax, sd_base
  add eax, RA_SD_BUFFER
  mov [es:edi + offset HbaPrdtEntry.dba], eax
  mov eax, ecx
  shl eax, 9
  dec eax
  //or eax, 1 << 31  // int on completion
  mov [es:edi + offset HbaPrdtEntry.dbci], eax
  
  // wait not busy
  l_h_sd_p_read_65:
    mov ebx, sd_port_ebx
    add ebx, offset HbaPortRec.tfd
    call m_phys_get
    test eax, ATA_DEV_BUSY | ATA_DEV_DRQ
    jnz l_h_sd_p_read_65
  
  // issue command
  mov eax, 1  // 1 << slot
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.ci
  push ecx
    call m_phys_set  // destroys ecx
  pop ecx
  
  // wait for completion
  l_h_sd_p_read_75:
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.ci
  call m_phys_get
  test eax, 1  // 1 << slot
  jz l_h_sd_p_read_78
    mov ebx, sd_port_ebx
    add ebx, offset HbaPortRec.is
    call m_phys_get
    test eax, HBA_PxIS_TFES
    jz l_h_sd_p_read_75
      // error
      mov al, ERC_DISK_IO
      jmp short l_h_sd_p_read_9
      
  l_h_sd_p_read_78:
  // copy
  shl ecx, 9 - 2  // 512 / 4
  mov edi, esi
  mov esi, RA_SD_BUFFER + VA_SD
  push ds
    push es
    pop ds
    cld
    rep movsd
  pop ds
  mov esi, edi
  
  // remaining sectors
  mov ecx, hdt_count_remain
  or ecx, ecx
  jnz near l_h_sd_p_read_1
  
  mov al, 0
  
  l_h_sd_p_read_9:
 pop ecx
pop esi
mov ebx, dword ptr sd_sect[0]
mov edx, dword ptr sd_sect[4]
add ebx, ecx
adc edx, 0
ret

// IN: hdt_pdiskn, edx:ebx = sector, ecx = count, es:edi -> buffer
// OUT: al = erc, edx:ebx = next sector
// KEEP: esi
// USES: hdt_count_remain, sd_sect
h_sd_p_write:
push esi
 push ecx
  mov dword ptr sd_sect[0], ebx
  mov dword ptr sd_sect[4], edx
  mov esi, edi
  
  l_h_sd_p_write_1:
  xor eax, eax
  cmp ecx, 8
  jna l_h_sd_p_write_11
    mov eax, ecx
    sub eax, 8
    mov ecx, 8
    
  l_h_sd_p_write_11:
  mov hdt_count_remain, eax
  
  // copy
  push ecx
    shl ecx, 9 - 2  // 512 / 4
    mov edi, RA_SD_BUFFER + VA_SD
    push ds
      push es
      pop ds
      cld
      rep movsd
    pop ds
  pop ecx
  
  // prepare IO
  mov al, hdt_pdiskn
  and al, 31
  movzx eax, al
  mov sd_port_n, eax
  shl eax, 7  // * 80h
  add eax, abar
  add eax, 100h
  mov sd_port_ebx, eax
  
  mov ebx, eax
  add ebx, offset HbaPortRec.is
  mov eax, -1
  push ecx
    call m_phys_set  // destroys ecx
  pop ecx
  
  mov eax, sd_port_n
  shl eax, 10  // * 1024
  add eax, 256 * 32 + VA_SD
  mov edi, eax  // es:edi -> cmdheader
  
  mov al, sizeof FisRegH2D / 4
  //or al, 20h  // ATAPI
  or al, 40h  // write
  //or al, 80h  // Prefetch
  mov [es:edi + offset HbaCmdHeader.cflawp], al
  mov word ptr [es:edi + offset HbaCmdHeader.prdtl], 1  // prdtl - prdt count
  mov dword ptr [es:edi + offset HbaCmdHeader.prdbc], 4095  // byte count - 1
  
  mov edi, [es:edi + offset HbaCmdHeader.ctba]
  sub edi, sd_base
  add edi, VA_SD
  
  mov al, FIS_TYPE_REG_H2D
  mov [es:edi + offset FisRegH2D.fis_type], al
  mov al, 80h  // command
  mov [es:edi + offset FisRegH2D.pmportc], al
  mov al, ATA_CMD_WRITE_DMA_EX
  mov [es:edi + offset FisRegH2D.command], al
  
  mov al, byte ptr sd_sect[0]
  mov [es:edi + offset FisRegH2D.lba0], al
  mov al, byte ptr sd_sect[1]
  mov [es:edi + offset FisRegH2D.lba1], al
  mov al, byte ptr sd_sect[2]
  mov [es:edi + offset FisRegH2D.lba2], al
  mov al, 1 << 6  // LBA mode
  mov [es:edi + offset FisRegH2D.device], al
  mov al, byte ptr sd_sect[3]
  mov [es:edi + offset FisRegH2D.lba3], al
  mov al, byte ptr sd_sect[4]
  mov [es:edi + offset FisRegH2D.lba4], al
  mov al, byte ptr sd_sect[5]
  mov [es:edi + offset FisRegH2D.lba5], al
  
  mov [es:edi + offset FisRegH2D.countl], cx  // sector count
  
  add edi, 80h  // es:edi -> PRDT
  mov eax, sd_base
  add eax, RA_SD_BUFFER
  mov [es:edi + offset HbaPrdtEntry.dba], eax
  mov eax, ecx
  shl eax, 9
  dec eax
  //or eax, 1 << 31  // int on completion
  mov [es:edi + offset HbaPrdtEntry.dbci], eax
  
  // wait not busy
  l_h_sd_p_write_65:
    mov ebx, sd_port_ebx
    add ebx, offset HbaPortRec.tfd
    call m_phys_get
    test eax, ATA_DEV_BUSY | ATA_DEV_DRQ
    jnz l_h_sd_p_write_65
  
  // issue command
  mov eax, 1  // 1 << slot
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.ci
  push ecx
    call m_phys_set  // destroys ecx
  pop ecx
  
  // wait for completion
  l_h_sd_p_write_75:
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.ci
  call m_phys_get
  test eax, 1  // 1 << slot
  jz l_h_sd_p_write_78
    mov ebx, sd_port_ebx
    add ebx, offset HbaPortRec.is
    call m_phys_get
    test eax, HBA_PxIS_TFES
    jz l_h_sd_p_write_75
      // error
      mov al, ERC_DISK_IO
      jmp short l_h_sd_p_write_9
      
  l_h_sd_p_write_78:
  // remaining sectors
  mov ecx, hdt_count_remain
  or ecx, ecx
  jnz near l_h_sd_p_write_1
  
  mov al, 0
  
  l_h_sd_p_write_9:
 pop ecx
pop esi
mov ebx, dword ptr sd_sect[0]
mov edx, dword ptr sd_sect[4]
add ebx, ecx
adc edx, 0
ret

SCD_BUFFER_SIZE = 800h

// IN: hdt_pdiskn, cd_packet
// KEEP: ebx, ecx, edi
h_sd_p_cd_read:
push ebx
 push ecx
  push edi
  
mov al, hdt_pdiskn
and al, 31
movzx eax, al
mov sd_port_n, eax
shl eax, 7  // * 80h
add eax, abar
add eax, 100h
mov sd_port_ebx, eax

mov ebx, eax
add ebx, offset HbaPortRec.is
mov eax, -1
call m_phys_set  // destroys ecx

mov eax, sd_port_n
shl eax, 10  // * 1024
add eax, 256 * 32 + VA_SD
mov edi, eax  // es:edi -> cmdheader

mov al, sizeof FisRegH2D / 4
or al, 20h  // ATAPI
//or al, 40h  // write
or al, 80h  // Prefetch
mov [es:edi + offset HbaCmdHeader.cflawp], al
mov word ptr [es:edi + offset HbaCmdHeader.prdtl], 1  // prdtl - prdt count
mov dword ptr [es:edi + offset HbaCmdHeader.prdbc], SCD_BUFFER_SIZE - 1  // byte count - 1

mov edi, [es:edi + offset HbaCmdHeader.ctba]
sub edi, sd_base
add edi, VA_SD

mov al, FIS_TYPE_REG_H2D
mov [es:edi + offset FisRegH2D.fis_type], al
mov al, 80h  // command
mov [es:edi + offset FisRegH2D.pmportc], al
mov al, ATA_CMD_PACKET
mov [es:edi + offset FisRegH2D.command], al

add edi, 40h // es:edi -> acmd
mov eax, dword ptr cd_packet[0]
mov [es:edi + 0], eax
mov eax, dword ptr cd_packet[4]
mov [es:edi + 4], eax
mov eax, dword ptr cd_packet[8]
mov [es:edi + 8], eax

add edi, 40h  // es:edi -> PRDT
mov eax, offset cd_buffer  // physical adr
mov [es:edi + offset HbaPrdtEntry.dba], eax
mov eax, SCD_BUFFER_SIZE - 1
//or eax, 1 << 31  // int on completion
mov [es:edi + offset HbaPrdtEntry.dbci], eax

// wait not busy
l_h_sd_p_cd_read_65:
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.tfd
  call m_phys_get
  test eax, ATA_DEV_BUSY | ATA_DEV_DRQ
  jnz l_h_sd_p_cd_read_65

// issue command
mov eax, 1  // 1 << slot
mov ebx, sd_port_ebx
add ebx, offset HbaPortRec.ci
call m_phys_set  // destroys ecx

// wait for completion
l_h_sd_p_cd_read_75:
mov ebx, sd_port_ebx
add ebx, offset HbaPortRec.ci
call m_phys_get
test eax, 1  // 1 << slot
jz l_h_sd_p_cd_read_78
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.is
  call m_phys_get
  test eax, HBA_PxIS_TFES
  jz l_h_sd_p_cd_read_75
    // error
    mov al, ERC_DISK_IO
    jmp short l_h_sd_p_cd_read_9
    
l_h_sd_p_cd_read_78:

mov al, 0

l_h_sd_p_cd_read_9:
  pop edi
 pop ecx
pop ebx
ret

// IN: ecx = port no, abar, sd_base, VA_SD
h_sd_rebase_port:
mov eax, ecx
shl eax, 8
add eax, sd_base //VA_SD
mov esi, eax  // esi = portno * 256 + sd_base

mov eax, ecx
shl eax, 10
add eax, 32 * 256
add eax, sd_base  //VA_SD
mov edi, eax  // edi = portno * 1024 + (32 * 256) + sd_base

/*
// stop
mov ebx, abar
add ebx, offset HbaMemRec.ghc
mov eax, 1 << 31
call m_phys_set
mov eax, 1 << 0
call m_phys_set
mov eax, 1 << 31
call m_phys_set
mov eax, 1 << 1
call m_phys_set
*/

push ecx

  mov ebx, ecx
  shl ebx, 7  // * 80h
  add ebx, 100h
  add ebx, abar
  mov edx, ebx  // edx -> port
  
  add ebx, offset HbaPortRec.cmd
  call m_phys_get
  and eax, -1 - HBA_PxCMD_ST - HBA_PxCMD_FRE
  call m_phys_set
  
  l_h_sd_rebase_port_1:
    call m_phys_get
    test eax, HBA_PxCMD_FR | HBA_PxCMD_CR
    jnz l_h_sd_rebase_port_1
  
  and eax, -1 - HBA_PxCMD_CR - HBA_PxCMD_FR - HBA_PxCMD_FRE - HBA_PxCMD_ST
  call m_phys_set
  
  // set fb = esi
  mov ebx, edx
  add ebx, offset HbaPortRec.fb
  mov eax, esi  
  call m_phys_set
  add ebx, 4
  xor eax, eax
  call m_phys_set
  
  // set clb = edi
  mov ebx, edx
  add ebx, offset HbaPortRec.clb
  mov eax, edi
  call m_phys_set
  add ebx, 4
  xor eax, eax
  call m_phys_set

pop ecx
  
// make ctb
mov eax, ecx
shl eax, 8
add eax, 32 * 256 + (32 * 1024)
add eax, sd_base
mov esi, eax  // esi = portno * 256 + (32 * 256) + (32 * 1024) + sd_base

// slot 0
sub edi, sd_base
add edi, VA_SD
mov word ptr [es:edi + offset HbaCmdHeader.prdtl], 1
mov dword ptr [es:edi + offset HbaCmdHeader.ctba], esi
xor eax, eax  // eax = 0
mov dword ptr [es:edi + offset HbaCmdHeader.ctbau], eax  
add edi, sizeof HbaCmdHeader

// slots 1..31
mov ecx, 31 * 32 / 4
cld
rep stosd

// zero ctb
mov edi, esi
sub edi, sd_base
add edi, VA_SD
mov ecx, 256 / 4
rep stosd

// start
mov ebx, edx
add ebx, offset HbaPortRec.cmd

l_h_sd_rebase_port_3:
  call m_phys_get
  test eax, HBA_PxCMD_CR
  jnz l_h_sd_rebase_port_3

or eax, HBA_PxCMD_FRE | HBA_PxCMD_ST
call m_phys_set

// port.is = 0
mov ebx, edx
add ebx, offset HbaPortRec.is
xor eax, eax
call m_phys_set

// port.ie = -1
mov ebx, edx
add ebx, offset HbaPortRec.ie
xor eax, eax
dec eax
call m_phys_set

ret

// IN: hdt_pdiskn
// OUT: al = erc
h_sd_p_flush:

mov al, hdt_pdiskn
and al, 31
movzx eax, al
mov sd_port_n, eax
shl eax, 7  // * 80h
add eax, abar
add eax, 100h
mov sd_port_ebx, eax

mov ebx, eax
add ebx, offset HbaPortRec.is
mov eax, -1
call m_phys_set  // destroys ecx

mov eax, sd_port_n
shl eax, 10  // * 1024
add eax, 256 * 32 + VA_SD
mov edi, eax  // es:edi -> cmdheader

mov al, sizeof FisRegH2D / 4
//or al, 20h  // ATAPI
//or al, 40h  // write
//or al, 80h  // Prefetch
mov [es:edi + offset HbaCmdHeader.cflawp], al
mov word ptr [es:edi + offset HbaCmdHeader.prdtl], 0  // prdtl - prdt count
//mov dword ptr [es:edi + offset HbaCmdHeader.prdbc], 4095  // byte count - 1

mov edi, [es:edi + offset HbaCmdHeader.ctba]
sub edi, sd_base
add edi, VA_SD

mov al, FIS_TYPE_REG_H2D
mov [es:edi + offset FisRegH2D.fis_type], al
mov al, 80h  // command
mov [es:edi + offset FisRegH2D.pmportc], al
mov al, ATA_CMD_FLUSH_EX
mov [es:edi + offset FisRegH2D.command], al
mov byte ptr [es:edi + offset FisRegH2D.device], 0
mov word ptr [es:edi + offset FisRegH2D.countl], 0

// wait not busy
l_h_sd_p_flush_65:
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.tfd
  call m_phys_get
  test eax, ATA_DEV_BUSY | ATA_DEV_DRQ
  jnz l_h_sd_p_flush_65

// issue command
mov eax, 1  // 1 << slot
mov ebx, sd_port_ebx
add ebx, offset HbaPortRec.ci
call m_phys_set  // destroys ecx

// wait for completion
l_h_sd_p_flush_75:
mov ebx, sd_port_ebx
add ebx, offset HbaPortRec.ci
call m_phys_get
test eax, 1  // 1 << slot
jz l_h_sd_p_flush_78
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.is
  call m_phys_get
  test eax, HBA_PxIS_TFES
  jz l_h_sd_p_flush_75
    // error
    mov al, ERC_DISK_IO
    jmp short l_h_sd_p_flush_9
    
l_h_sd_p_flush_78:

mov al, 0

l_h_sd_p_flush_9:
ret

// IN: al = pdiskn, es:edi -> buffer
// OUT: al = erc
h_sd_p_identify:
mov esi, edi

mov hdt_pdiskn, al
and al, 31
movzx eax, al
mov sd_port_n, eax
shl eax, 7  // * 80h
add eax, abar
add eax, 100h
mov sd_port_ebx, eax

mov ebx, eax
add ebx, offset HbaPortRec.is
mov eax, -1
call m_phys_set  // destroys ecx

mov eax, sd_port_n
shl eax, 10  // * 1024
add eax, 256 * 32 + VA_SD
mov edi, eax  // es:edi -> cmdheader

mov al, sizeof FisRegH2D / 4
//or al, 20h  // ATAPI
//or al, 40h  // write
//or al, 80h  // Prefetch
mov [es:edi + offset HbaCmdHeader.cflawp], al
mov word ptr [es:edi + offset HbaCmdHeader.prdtl], 1  // prdtl - prdt count
mov dword ptr [es:edi + offset HbaCmdHeader.prdbc], 511  // byte count - 1

mov edi, [es:edi + offset HbaCmdHeader.ctba]
sub edi, sd_base
add edi, VA_SD

mov al, FIS_TYPE_REG_H2D
mov [es:edi + offset FisRegH2D.fis_type], al
mov al, 80h  // command
mov [es:edi + offset FisRegH2D.pmportc], al
mov al, ATA_CMD_IDENTIFY
mov [es:edi + offset FisRegH2D.command], al
mov byte ptr [es:edi + offset FisRegH2D.device], 0
mov word ptr [es:edi + offset FisRegH2D.countl], 1  // sector count

add edi, 80h  // es:edi -> PRDT
mov eax, sd_base
add eax, RA_SD_BUFFER
mov [es:edi + offset HbaPrdtEntry.dba], eax
mov eax, 1  // sector count
shl eax, 9
dec eax
//or eax, 1 << 31  // int on completion
mov [es:edi + offset HbaPrdtEntry.dbci], eax

// wait not busy
l_h_sd_p_identify_65:
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.tfd
  call m_phys_get
  test eax, ATA_DEV_BUSY | ATA_DEV_DRQ
  jnz l_h_sd_p_identify_65

// issue command
mov eax, 1  // 1 << slot
mov ebx, sd_port_ebx
add ebx, offset HbaPortRec.ci
call m_phys_set  // destroys ecx

// wait for completion
l_h_sd_p_identify_75:
mov ebx, sd_port_ebx
add ebx, offset HbaPortRec.ci
call m_phys_get
test eax, 1  // 1 << slot
jz l_h_sd_p_identify_78
  mov ebx, sd_port_ebx
  add ebx, offset HbaPortRec.is
  call m_phys_get
  test eax, HBA_PxIS_TFES
  jz l_h_sd_p_identify_75
    // error
    mov al, ERC_DISK_IO
    jmp short l_h_sd_p_identify_9
    
l_h_sd_p_identify_78:
// copy
mov ecx, 512 / 4
mov edi, esi
mov esi, RA_SD_BUFFER + VA_SD
push ds
  push es
  pop ds
  cld
  rep movsd
pop ds
mov esi, edi

mov al, 0

l_h_sd_p_identify_9:
ret

h_sd_init:

ret

// OUT: abar
h_sd_find:
mov ax, 0106h
call h_pci_find
test edx, edx
jz l_h_sd_find_9
  mov dl, 24h
  call h_pci_get
  mov abar, eax
  
l_h_sd_find_9:
ret

h_sd_setup_mapping:
cmp sd_base, 0
jnz near l_h_sd_setup_mapping_9
  mov cl, 1  // 64 KiB
  call m_alloc_dma
  test al, al
  jnz near l_h_sd_setup_mapping_9
  
  mov sd_base, esi
  or esi, PG_MASK_P | PG_MASK_W | PG_MASK_G
  
  mov dword ptr [PA_PD0 + (VA_SD >> 20)], PA_PT_SD | PG_MASK_P | PG_MASK_G
  
  mov ecx, 16  // 64 KiB / 4096
  xor edi, edi
  
  l_h_sd_setup_mapping_5:
    mov [PA_PT_SD + edi], esi
    mov eax, edi
    shl eax, 10  // * 4096 / 4
    invlpg [es:VA_SD + eax]
    
    add esi, 4096
    add edi, 4
    loop l_h_sd_setup_mapping_5
  
  // Zero memory
  mov edi, VA_SD
  xor eax, eax
  mov ecx, 64 * 1024 / 4  // 64 KiB / 4
  cld
  rep stosd
  
  // Rebase ports
  xor ecx, ecx
  
  l_sd_setup_mapping_5:
    push ecx
      call h_sd_rebase_port
    pop ecx
    inc ecx
    cmp cl, 32
    jb l_sd_setup_mapping_5
  
l_h_sd_setup_mapping_9:
ret

h_rd_init:
xor eax, eax
mov rd_base, eax
mov rd_size, eax
mov rd_ldiskn, al
ret

// IN: ecx = size
// OUT: al = ldiskn
h_rd_create:
mov al, 0
cmp ecx, 0x10000000
ja l_h_rd_create_9

mov ebx, VA_RAMDISK
mov rd_base, ebx
mov rd_size, ecx
add ecx, 4095
shr ecx, 12

mov edx, PG_MASK_P | PG_MASK_W
call m_pages_alloc_edx
test al, al
jz l_h_rd_create_6
  mov al, 0
  jmp short l_h_rd_create_9
  
l_h_rd_create_6:
// OUT: al = disk letter, ds:esi -> DiskInfoRec
// DESTROY: ecx
call h_disks_new
mov rd_ldiskn, al
test al, al
jz l_h_rd_create_9
  mov byte ptr [esi + offset DiskInfoRec.type], DISK_TYPE_RD
  mov byte ptr [esi + offset DiskInfoRec.fsid], FSID_EXT2
  mov [esi + offset DiskInfoRec.number], al
  mov dword ptr [esi + offset DiskInfoRec.main], offset h_rd_main
  
l_h_rd_create_9:
ret

// IN: ah = operation
// ah = 2: ebx = ofs, ecx = size, es:edi -> buffer
// ah = 3: ebx = ofs, ecx = size, es:edi -> buffer
// ah = 4: edx:eax = disk size
h_rd_main:
cmp ah, 2
jnz l_h_rd_main_2
  // read
  mov esi, rd_base
  cmp ebx, rd_size
  jb l_h_rd_main_12
    
    l_h_rd_main_11:
    mov al, ERC_OUT_OF_RANGE
    jmp l_h_rd_main_9
    
  l_h_rd_main_12:
  mov eax, ebx
  add eax, ecx
  cmp eax, rd_size
  ja l_h_rd_main_11
  
  cmp eax, ebx
  jb l_h_rd_main_11
  /*
  cmp edi, VA_ACCESS
  jnb l_h_rd_main_11
  
  mov eax, edi
  add eax, ecx
  cmp eax, VA_ACCESS
  ja l_h_rd_main_11
  */
  add esi, ebx
  jecxz l_h_rd_main_16
  
  l_h_rd_main_15:
    mov al, [es:esi]
    mov [es:edi], al
    inc esi
    inc edi
    loop l_h_rd_main_15
  
  l_h_rd_main_16:
  mov al, 0
  jmp l_h_rd_main_9
  
l_h_rd_main_2:
cmp ah, 3
jnz l_h_rd_main_3
  // write
  mov al, rd_ldiskn
  movzx esi, al
  shl esi, 5  // log2(sizeof(DiskInfoRec)) = 5
  or byte ptr disk_info.flags[esi], DISK_FLAGS_DIRTY
  
  mov esi, rd_base
  cmp ebx, rd_size
  jnb l_h_rd_main_11
    
  mov eax, ebx
  add eax, ecx
  cmp eax, rd_size
  ja l_h_rd_main_11
  
  cmp eax, ebx
  jb l_h_rd_main_11
  /*
  cmp edi, VA_ACCESS
  jnb l_h_rd_main_11
  
  mov eax, edi
  add eax, ecx
  cmp eax, VA_ACCESS
  ja l_h_rd_main_11
  */
  add esi, ebx
  jecxz l_h_rd_main_16
  
  l_h_rd_main_25:
    mov al, [es:edi]
    mov [es:esi], al
    inc edi
    inc esi
    loop l_h_rd_main_25
  
  jmp short l_h_rd_main_16
  
l_h_rd_main_3:
cmp ah, 4
jnz l_h_rd_main_4
  // disk size
  xor edx, edx
  mov eax, rd_size
  jmp short l_h_rd_main_9
  
l_h_rd_main_4:
// other
mov al, ERC_NOT_IMPLEMENTED

l_h_rd_main_9:
ret

// IN: boot_disk, al = ldiskn
// DESTROY: ebx, (al)
h_disks_bootcd:
cmp boot_disk, 0x300
jnz l_h_disks_bootcd_9
  mov byte ptr boot_disk, al
  mov ebx, p_current
  mov [es:ebx + offset ThreadRec.curdisk], al
  or al, 64
  mov [es:ebx + offset ThreadRec.curdirtext], al
  and al, 31

l_h_disks_bootcd_9:
ret

h_disks_init:
xor eax, eax
mov sd_base, eax
mov rd_base, eax
mov rd_size, eax
//ret - fall through

h_disks_reset:
mov users_disk, 0

// Zero all
push es
  push ds
  pop es
  
  mov edi, offset disk_info
  mov ecx, sizeof DiskInfoRec * DISK_MAX / 4
  xor eax, eax
  cld
  rep stosd
pop es

// Boot CD reset
cmp byte ptr boot_disk[1], 3
jnz l_h_disks_reset_1
  mov byte ptr boot_disk[0], 0
  
l_h_disks_reset_1:

// Init by types
call h_fd_init
call h_hd_init
call h_cd_init
call h_sd_init
call h_rd_init
//... other types: VD, ND, UD

// FD
mov esi, offset fd_info
mov eax, [esi + offset FdInfoRec.size]
mov edi, sizeof DiskInfoRec
or eax, eax
jnz l_h_disks_reset_22

l_h_disks_reset_2:
mov esi, offset fd_info + sizeof FdInfoRec
add edi, sizeof DiskInfoRec
mov eax, [esi + offset FdInfoRec.size]
or eax, eax
jz l_h_disks_reset_25
  
  l_h_disks_reset_22:
  mov disk_info[edi + offset DiskInfoRec.type], DISK_TYPE_FD
  mov disk_info[edi + offset DiskInfoRec.main], offset h_fd_main
  shr eax, 9
  mov dword ptr disk_info[edi + offset DiskInfoRec.size_sectors], eax
  mov byte ptr disk_info[edi + offset DiskInfoRec.fsid], FSID_FAT12

l_h_disks_reset_25:

// HD: IDE ATA/ATAPI
xor eax, eax

l_h_disks_reset_26:
  
  push eax
  
    call h_hd_prepare_port_slave
    
    mov dx, hdt_port_base
    or dx, 7
    in al, dx
    cmp al, 0FFh
    jz near l_h_disks_reset_28
    
    mov edi, VA_SYSTEM + offset hd_buffer
    call h_hd_p_identify
    or eax, eax
    jnz l_h_disks_reset_27
      // HD
      pop eax
      push eax
      call h_hd_partitions
      jmp l_h_disks_reset_28
      
    l_h_disks_reset_27:
    cmp al, ERC_INVALID_DISK_NUMBER
    jz l_h_disks_reset_28
      // CD/other (erc = 104h)
      mov edi, VA_SYSTEM + offset hd_buffer
      call h_hd_p_identifyp
      
      pop eax
      push eax
      mov hdt_pdiskn, al
      
      call h_disks_new
      or al, al
      jz l_h_disks_reset_28
        
        call h_disks_bootcd  // KEEP esi

        // Store disk info
        mov byte ptr [esi + offset DiskInfoRec.type], DISK_TYPE_CD
        mov byte ptr [esi + offset DiskInfoRec.fsid], FSID_CD
        mov al, hdt_pdiskn
        mov [esi + offset DiskInfoRec.number], al
        mov dword ptr [esi + offset DiskInfoRec.main], offset h_cd_main
        xor eax, eax
        mov dword ptr [esi + offset DiskInfoRec.flags], eax
        mov dword ptr [esi + offset DiskInfoRec.flags + 4], eax
        
        // Size: max(LBA28, LBA48)
        add esi, offset DiskInfoRec.size_sectors
        /*
        mov ebx, dword ptr hd_buffer[120]
        mov eax, dword ptr hd_buffer[204]
        mov edx, dword ptr hd_buffer[208]
        or edx, edx
        jnz l_h_disks_reset_275
          cmp eax, ebx
          ja l_h_disks_reset_275
            mov eax, ebx
          
        l_h_disks_reset_275:
        */
        xor eax, eax
        xor edx, edx
        
        mov [esi], eax
        mov [esi + 4], edx
    
    l_h_disks_reset_28:
    
  pop eax
  
  inc eax
  cmp eax, 4
  jb near l_h_disks_reset_26

// SD: AHCI SATA/SATAPI
xor eax, eax
mov abar, eax

mov ch, 0
call h_sd_find

mov ebx, abar
or ebx, ebx
jz near l_h_disks_reset_38
  
  // * sd_base *
  push ebx
    call h_sd_setup_mapping
  pop ebx
  
  // * find SATA/SATAPI disks *
  mov edi, ebx
  add edi, 100h
  mov ecx, 32
  mov hdt_pdiskn, 40h
  
  l_h_disks_reset_32:
    mov ebx, edi
    add ebx, offset HbaPortRec.ssts
    call m_phys_get
    and eax, 0F0Fh
    cmp eax, 0103h  // present, active
    jnz l_h_disks_reset_36
      mov ebx, edi
      add ebx, offset HbaPortRec.sig
      call m_phys_get

      cmp eax, 0EB140101h  // SATAPI
      jnz l_h_disks_reset_34
        // CD/DVD
        push ecx
          call h_disks_new  // KEEP: edi
        pop ecx
        or al, al
        jz l_h_disks_reset_36
        
        call h_disks_bootcd  // KEEP: ecx, edi
        
        // Store disk info
        mov byte ptr [esi + offset DiskInfoRec.type], DISK_TYPE_CD
        mov byte ptr [esi + offset DiskInfoRec.fsid], FSID_CD
        mov al, hdt_pdiskn
        or al, 20h
        mov [esi + offset DiskInfoRec.number], al
        mov dword ptr [esi + offset DiskInfoRec.main], offset h_cd_main
        xor eax, eax
        mov dword ptr [esi + offset DiskInfoRec.flags], eax
        mov dword ptr [esi + offset DiskInfoRec.flags + 4], eax
        jmp short l_h_disks_reset_36
        
      l_h_disks_reset_34:
      cmp eax, 101h  // SATA
      jnz l_h_disks_reset_36
        // HD
        mov al, hdt_pdiskn
        push ecx
         push edi
          call h_hd_partitions
         pop edi
        pop ecx
        
    l_h_disks_reset_36:
    add edi, 80h
    inc hdt_pdiskn
    loop l_h_disks_reset_32
  
l_h_disks_reset_38:
ret

// OUT: al = disk letter, ds:esi -> DiskInfoRec
// DESTROY: ecx
h_disks_new:
pushfd
  cli
  mov esi, offset disk_info + (sizeof DiskInfoRec * 3)
  
  l_h_disks_new_1:
    mov al, [esi + offset DiskInfoRec.type]
    or al, al
    jz l_h_disks_new_8
      add esi, sizeof DiskInfoRec
      cmp esi, offset disk_info + (sizeof DiskInfoRec * DISK_MAX)
      jb l_h_disks_new_1

        mov esi, offset disk_info
        mov al, 0
        jmp l_h_disks_new_9
  
  l_h_disks_new_8:
  mov eax, esi
  sub eax, offset disk_info
  xor edx, edx
  mov ecx, sizeof DiskInfoRec
  div ecx
  
  l_h_disks_new_9:
popfd
ret

// IN: al = diskn, es = allmem
h_disks_remove:
pushfd
  cli
  and al, 31
  movzx eax, al
  mov ecx, sizeof DiskInfoRec
  mul ecx
  add eax, offset disk_info + VA_SYSTEM
  mov edi, eax
  mov ecx, sizeof DiskInfoRec / 4
  xor eax, eax
  rep stosd
popfd
ret

USB_SIZE = 128 * 1024
USB_BITMAPSIZE = 4096
USB_MAX_IRQS = 16
USB_MAX_CONTROLLERS_PER_IRQ_LOG2 = 3  // 8

USBHC_VERSION = 2
USB_CONNECT_DELAY = 10  // tick = 10 ms
USB_RESET_TIME = 2
USB_RESET_RECOVERY_TIME = 2

WP_NORMAL = 8
WP_ABORT_PIPE = 9
WP_KEYBOARD = 10

// USB pipe types
CONTROL_PIPE = 0
ISOCHRONOUS_PIPE = 1
BULK_PIPE = 2
INTERRUPT_PIPE = 3

// status codes
USB_STATUS_OK           = 0   // no error
USB_STATUS_CRC          = 1   // CRC error
USB_STATUS_BITSTUFF     = 2   // bit stuffing violation
USB_STATUS_TOGGLE       = 3   // data toggle mismatch
USB_STATUS_STALL        = 4   // device returned STALL
USB_STATUS_NORESPONSE   = 5   // device not responding
USB_STATUS_PIDCHECK     = 6   // invalid PID check bits
USB_STATUS_WRONGPID     = 7   // unexpected PID value
USB_STATUS_OVERRUN      = 8   // too many data from endpoint
USB_STATUS_UNDERRUN     = 9   // too few data from endpoint
USB_STATUS_BUFOVERRUN   = 12  // overflow of internal controller buffer
USB_STATUS_BUFUNDERRUN  = 13  // underflow of internal controller buffer
USB_STATUS_CLOSED       = 16  // pipe closed
USB_STATUS_CANCELLED    = 17  // transfer cancelled with USBAbortPipe

// Possible speeds of USB devices
USB_SPEED_FS = 0 // full-speed
USB_SPEED_LS = 1 // low-speed
USB_SPEED_HS = 2 // high-speed

// flags for UsbPipe.flags
USB_FLAG_CLOSED     = 1  // pipe is closed, no new transfers
USB_FLAG_CAN_FREE   = 2  // pipe is closed via call to usb_close_pipe
USB_FLAG_EXTRA_WAIT = 4
// The pipe was in wait list, while another event occured;
// when the first wait will be done, reinsert the pipe to wait list
USB_FLAG_DISABLED   = 8
// The pipe is temporarily disabled so that it is not visible to hardware
// but still remains in software list. Used for usb_abort_pipe.
USB_FLAG_CLOSED_BIT = 0  // USB_FLAG_CLOSED = 1 shl USB_FLAG_CLOSED_BIT

// USB standard request codes
USB_GET_STATUS        = 0
USB_CLEAR_FEATURE     = 1
USB_SET_FEATURE       = 3
USB_SET_ADDRESS       = 5
USB_GET_DESCRIPTOR    = 6
USB_SET_DESCRIPTOR    = 7
USB_GET_CONFIGURATION = 8
USB_SET_CONFIGURATION = 9
USB_GET_INTERFACE     = 10
USB_SET_INTERFACE     = 11
USB_SYNCH_FRAME       = 12
 
// USB standard descriptor types
USB_DEVICE_DESCR             = 1
USB_CONFIG_DESCR             = 2
USB_STRING_DESCR             = 3
USB_INTERFACE_DESCR          = 4
USB_ENDPOINT_DESCR           = 5
USB_DEVICE_QUALIFIER_DESCR   = 6
USB_OTHER_SPEED_CONFIG_DESCR = 7
USB_INTERFACE_POWER_DESCR    = 8
 
// According to the USB specification (9.2.6.3),
// any device must response to SET_ADDRESS in 50 ms, or 5 timer ticks.
// Of course, our world is far from ideal.
// I have seen devices that just NAK everything when being reset from working
// state, but start to work after second reset.
// Our strategy is as follows: give 2 seconds for the first attempt,
// this should be enough for normal devices and not too long to detect buggy ones.
// If the device continues NAKing, reset it and retry several times,
// doubling the interval: 2s -> 4s -> 8s -> 16s. Give up after that.
// Numbers are quite arbitrary.
TIMEOUT_SET_ADDRESS_INITIAL = 200
TIMEOUT_SET_ADDRESS_LAST    = 1600

// Description of controller-specific data and functions.
struct UsbHardwareFunc{
  uns4 version     // Must be USBHC_VERSION
  uns4 id          // '*HCI'
  uns4 data_size   // sizeof(*hci_controller)
  uns4 before_init // Early initialization: take ownership from BIOS.
                   // IN: usb_ecx, usb_edx
  uns4 init        // Initialize controller-specific part of controller data.
  // IN: eax -> *hciController to initialize, [es:ebp-4] = (bus << 8) + devfn
  // OUT: eax = 0 <=> failed, otherwise eax -> UsbController
  uns4 process_deferred   // Called regularly from the main loop of USB thread
  // (either due to timeout from a previous call, or due to explicit wakeup).
  // IN: esi -> UsbController
  // OUT: eax = maximum timeout for next call (-1 = infinity)
  uns4 set_device_address // IN: esi -> UsbController, ebx -> UsbPipe, cl = address
  uns4 get_device_address // IN: esi -> UsbController, ebx -> UsbPipe, OUT: eax = address
  uns4 port_disable       // Disable the given port in the root hub.
  // IN: esi -> UsbController, ecx = port (zero-based)
  uns4 initiate_reset     // Start reset signalling on the given port.
  // IN: esi -> UsbController, ecx = port (zero-based)
  uns4 set_endpoint_packet_size  //in: esi -> UsbController, ebx -> UsbPipe, ecx = packet size
  uns4 alloc_pipe         // out: eax = pointer to allocated UsbPipe
  uns4 free_pipe  //void stdcall with one argument = pointer to previously allocated UsbPipe
  uns4 init_pipe
  // IN: edi -> UsbPipe for target, ecx -> UsbPipe for config pipe,
  //     esi -> UsbController, eax -> UsbGtd for the first TD,
  // [ebp+12] = endpoint, [ebp+16] = maxpacket, [ebp+20] = type
  uns4 unlink_pipe  // IN: esi -> UsbController, ebx -> UsbPipe
  uns4 alloc_gtd  // OUT: eax = pointer to allocated UsbGtd
  uns4 free_gtd  // void stdcall with one argument = pointer to previously allocated UsbGtd
  uns4 alloc_transfer  // Allocate and initialize one stage of a transfer.
  // IN: ebx -> UsbPipe, other parameters are passed through the stack:
  // buffer, size = data to transfer
  // flags = same as in UsbOpenPipe: bit 0 = allow short transfer, other bits reserved
  // td = pointer to the current end-of-queue descriptor
  // direction =
  //   0000b for normal transfers,
  //   1000b for control SETUP transfer,
  //   1101b for control OUT transfer,
  //   1110b for control IN transfer
  // OUT: eax = pointer to the new end-of-queue descriptor
  // (not included in the queue itself) or 0 on error
  uns4 insert_transfer
  // Activate previously initialized transfer (maybe with multiple stages).
  // IN: esi -> UsbController, ebx -> UsbPipe,
  //     [ss:esp + 4] -> first UsbGtd for the transfer,
  //     ecx -> last descriptor for the transfer
  uns4 new_device
  // Initiate configuration of a new device (create pseudo-pipe describing that
  // device and call usb_new_device).
  // IN: esi -> UsbController, eax = speed (one of USB_SPEED_* constants).
  uns4 disable_pipe
  // This procedure temporarily removes the given pipe from hardware queue.
  // IN: esi -> UsbController, ebx -> UsbPipe
  uns4 enable_pipe
  // This procedure reinserts the given pipe to hardware queue
  // after DisablePipe, with clearing transfer queue.
  // esi -> UsbController, ebx -> UsbPipe
  // edx -> current descriptor, eax -> new last descriptor
}

// Controller descriptor.
// This structure represents the common (controller-independent) part
// of a controller for the USB code. The corresponding controller-dependent
// part *hci_controller is located immediately before usb_controller.
struct UsbController{
  // Two following fields organize all controllers in the global linked list.
  uns4 next
  uns4 prev
  uns4 hardware_func
  // Pointer to UsbHardwareFunc structure with controller-specific functions.
  uns4 num_ports  // Number of ports in the root hub.
  uns4 pci_coordinates  // Device:function and bus number from PCI.
  // The hardware is allowed to cache some data from hardware structures.
  // Regular operations are designed considering this,
  // but sometimes it is required to wait for synchronization of hardware cache
  // with modified structures in memory.
  // The code keeps two queues of pipes waiting for synchronization,
  // one for asynchronous (bulk/control) pipes, one for periodic pipes, hardware
  // cache is invalidated under different conditions for those types.
  // Both queues are organized in the same way, as single-linked lists.
  // There are three special positions: the head of list (new pipes are added
  // here), the first pipe to be synchronized at the current iteration,
  // the tail of list (all pipes starting from here are synchronized).
  uns4 wait_pipe_list_async
  uns4 wait_pipe_list_periodic
  // List heads.
  uns4 wait_pipe_request_async
  uns4 wait_pipe_request_periodic
  // Pending request to hardware to refresh cache for items from wait_pipe_list*.
  // (Pointers to some items in wait_pipe_list_* or NULLs).
  uns4 ready_pipe_head_async
  uns4 ready_pipe_head_periodic
  // Items of removing_list_* which were released by hardware and are ready
  // for further processing.
  // (Pointers to some items in wait_pipe_list_* or NULLs).
  uns4 new_connected
  // bit mask of recently connected ports of the root hub,
  // bit set = a device was recently connected to the corresponding port;
  // after USB_CONNECT_DELAY ticks of stable status these ports are moved to
  // PendingPorts
  uns4 new_disconnected
  // bit mask of disconnected ports of the root hub,
  // bit set = a device in the corresponding port was disconnected,
  // disconnect processing is required.
  uns4 pending_ports  // bit mask of ports which are ready to be initialized
  uns4 control_lock   // mutex which guards all operations with control queue
  uns4 bulk_lock      // mutex which guards all operations with bulk queue
  uns4 periodic_lock  // mutex which guards all operations with periodic queues
  
  void wait_spinlock
  // spinlock guarding wait_pipe_request/ready_pipe_head (but not wait_pipe_list)
  uns4 start_wait_frame
  // USB frame number when wait_pipe_request* was registered.
  uns4 resetting_hub
  // Pointer to UsbHub responsible for the currently resetting port, if any.
  // NULL for the root hub.
  uns1 resetting_port  // Port that is currently resetting, 0-based.
  uns1 resetting_speed // Speed of currently resetting device.
  uns1 resetting_status
  // Status of port reset. 0 = no port is resetting, -1 = reset failed,
  // 1 = reset in progress, 2 = reset recovery in progress.
  [dalign 32]
  uns4 reset_time
  // Time when reset signalling or reset recovery has been started.
  uns1 set_address_buffer[8]  // Buffer for USB control command SET_ADDRESS.
  uns4 existing_addresses[128/32]
  // Bitmask for 128 bits; bit i is cleared <=> address i is free for allocating
  // for new devices. Bit 0 is always set.
  uns4 connected_time[16]
  // Time, in timer ticks, when the port i has signalled the connect event.
  // Valid only if bit i in new_connected is set.
  uns4 devices_by_port[16]
  // Pointers to UsbPipe for zero endpoint (which serves as device handle)
}

// Pipe descriptor.
// * An USB pipe is described by two structures, for hardware and for software.
// * This is the software part. The hardware part is defined in a driver
//   of the corresponding controller.
// * The hardware part is located immediately before usb_pipe,
//   both are allocated at once by controller-specific code
//   (it knows the total length, which depends on the hardware part).
struct UsbPipe{
  uns4 controller
  // Pointer to UsbController structure corresponding to this pipe.
  // Must be the first dword after hardware part, see *hci_new_device.
  //
  // Every endpoint is included into one of processing lists:
  // * Bulk list contains all Bulk endpoints.
  // * Control list contains all Control endpoints.
  // * Several Periodic lists serve Interrupt endpoints with different interval.
  //   - There are N=2^n "leaf" periodic lists for N ms interval, one is processed
  //     in the frames 0,N,2N,..., another is processed in the frames
  //     1,1+N,1+2N,... and so on. The hardware starts processing of periodic
  //     endpoints in every frame from the list identified by lower n bits of the
  //     frame number// the addresses of these N lists are written to the
  //     controller data area during the initialization.
  //   - We assume that n=5, N=32 to simplify the code and compact the data.
  //     OHCI works in this way. UHCI and EHCI actually have n=10, N=1024,
  //     but this is an overkill for interrupt endpoints// the large value of N is
  //     useful only for isochronous transfers in UHCI and EHCI. UHCI/EHCI code
  //     initializes "leaf" lists k,k+32,k+64,...,k+(1024-32) to the same value,
  //     giving essentially N=32.
  //     This restriction means that the actual maximum interval of polling any
  //     interrupt endpoint is 32ms, which seems to be a reasonable value.
  //   - Similarly, there are 16 lists for 16-ms interval, 8 lists for 8-ms
  //     interval and so on. Finally, there is one list for 1ms interval. Their
  //     addresses are not directly known to the controller.
  //   - The hardware serves endpoints following a physical link from the hardware
  //     part.
  //   - The hardware links are organized as follows. If the list item is not the
  //     last, it's hardware link points to the next item. The hardware link of
  //     the last item points to the first item of the "next" list.
  //   - The "next" list for k-th and (k+M)-th periodic lists for interval 2M ms
  //     is the k-th periodic list for interval M ms, M >= 1. In this scheme,
  //     if two "previous" lists are served in the frames k,k+2M,k+4M,...
  //     and k+M,k+3M,k+5M,... correspondingly, the "next" list is served in
  //     the frames k,k+M,k+2M,k+3M,k+4M,k+5M,..., which is exactly what we want.
  //   - The links between Periodic, Control, Bulk lists and the processing of
  //     Isochronous endpoints are controller-specific.
  // * The head of every processing list is a static entry which does not
  //   correspond to any real pipe. It is described by usb_static_ep
  //   structure, not usb_pipe. For OHCI and UHCI, sizeof.usb_static_ep plus
  //   sizeof hardware part is 20h, the total number of lists is
  //   32+16+8+4+2+1+1+1 = 65, so all these structures fit in one page,
  //   leaving space for other data. This is another reason for 32ms limit.
  // * Static endpoint descriptors are kept in *hci_controller structure.
  // * All items in every processing list, including the static head, are
  //   organized in a double-linked list using .NextVirt and .PrevVirt fields.
  // * [[item.NextVirt].PrevVirt] = [[item.PrevVirt].NextVirt] for all items.
  uns4 next_virt
  // Next endpoint in the processing list.
  // See also PrevVirt field and the description before NextVirt field.
  uns4 prev_virt
  // Previous endpoint in the processing list.
  // See also NextVirt field and the description before NextVirt field.
  uns4 base_list
  // Pointer to head of the processing list.
  //
  // Every pipe has the associated transfer queue, that is, the double-linked
  // list of Transfer Descriptors aka TD. For Control, Bulk and Interrupt
  // endpoints this list consists of usb_gtd structures
  // (GTD = General Transfer Descriptors), for Isochronous endpoints
  // this list consists of usb_itd structures, which are not developed yet.
  // The pipe needs to know only the last TD; the first TD can be
  // obtained as [[pipe.LastTD].NextVirt].
  uns4 last_td
  // Last TD in the transfer queue.
  //
  // All opened pipes corresponding to the same physical device are organized in
  // the double-linked list using next_sibling and prev_sibling fields.
  // The head of this list is kept in UsbDevData structure (opened_pipe_list).
  // This list is used when the device is disconnected and all pipes for the
  // device should be closed.
  // Also, all pipes closed due to disconnect must remain valid at least until
  // driver-provided disconnect function returns; all should-be-freed-but-not-now
  // pipes for one device are organized in another double-linked list with
  // the head in usb_device_data.ClosedPipeList; this list uses the same link
  // fields, one pipe can never be in both lists.
  uns4 next_sibling
  // Next pipe for the physical device.
  uns4 prev_sibling
  // Previous pipe for the physical device.
  //
  // When the hardware part of the pipe is changed, some time is needed before
  // further actions so that hardware reacts on this change. During that time,
  // all changed pipes are organized in single-linked list with the head
  // UsbController.wait_pipe_list* and link field next_wait.
  // Currently there are two possible reasons to change:
  // change of address/packet size in initial configuration,
  // close of the pipe. They are distinguished by USB_FLAG_CLOSED.
  uns4 next_wait
  uns4 lock  // Mutex that guards operations with transfer queue for this pipe.
  uns4 type  // Type of pipe, one of {CONTROL,ISOCHRONOUS,BULK,INTERRUPT}_PIPE.
  uns4 flags // Combination of flags, USB_FLAG_*.
  
  [dalign 32]
  uns4 device_data
  // Pointer to UsbDevData, common for all pipes for one device.
}

// Device-specific data.
struct UsbDevData{
  uns4 pipe_list_lock
  // Mutex guarding opened_pipe_list. Must be the first item of the structure,
  // the code passes pointer to UsbDevData as is to mutex_lock/unlock.
  uns4 opened_pipe_list[2]
  // List of all opened pipes for the device.
  // Used when the device is disconnected, so all pipes should be closed.
  uns4 closed_pipe_list[2]
  // List of all closed, but still valid pipes for the device.
  // A pipe closed with USBClosePipe is just deallocated,
  // but a pipe closed due to disconnect must remain valid until driver-provided
  // disconnect handler returns; this list links all such pipes to deallocate them
  // after disconnect processing.
  uns4 num_pipes  // Number of not-yet-closed pipes.
  uns4 hub  // NULL if connected to the root hub, pointer to usb_hub otherwise.
  uns4 tt_hub
  // Pointer to usb_hub for (the) hub with Transaction Translator for the device,
  // NULL if the device operates in the same speed as the controller.
  uns4 port  // Port on the hub, zero-based.
  uns4 tt_port  // Port on the TTHub, zero-based.
  uns4 device_descr_size  // Size of device descriptor.
  uns4 speed  // Device speed, one of USB_SPEED_*.
  uns4 timer  // Handle of timer that handles request timeout.
  uns4 num_interfaces  // Number of interfaces.
  uns4 config_data_size
  // Total size of data associated with the configuration descriptor
  // (including the configuration descriptor itself).
  uns4 interfaces
  // Offset from the beginning of this structure to interfaces field.
  // Variable-length fields:
  // device_descriptor:
  //  device descriptor starts here
  // config_descriptor = device_descriptor + device_descr_size
  //  configuration descriptor with all associated data
  // interfaces = ALIGN_UP(config_descriptor + config_data_size, 4)
  //  array of num_interfaces elements of type UsbInterfaceData
  void device_descriptor  // = sizeof UsbDevData
}

// This structure describes the static head of every list of pipes.
struct UsbStaticEp{
  // software fields
  uns4 bandwidth
  // valid only for interrupt/isochronous USB1 lists
  // The offsets of the following two fields must be the same in this structure
  // and in UsbPipe.
  uns4 next_virt
  uns4 prev_virt
}

// This structure represents one transfer descriptor
// ('g' stands for "general" as opposed to isochronous usb_itd).
// Note that one transfer can have several descriptors:
// a control transfer has three stages.
// Additionally, every controller has a limit on transfer length with
// one descriptor (packet size for UHCI, 1K for OHCI, 4K for EHCI),
// large transfers must be split into individual packets according to that limit.
struct UsbGtd{
  uns4 callback
  // Zero for intermediate descriptors, pointer to callback function
  // for final descriptor. See the docs for description of the callback.
  uns4 user_data
  // Dword which is passed to Callback as is, not used by USB code itself.
  // Two following fields organize all descriptors for one pipe in
  // the linked list.
  uns4 next_virt
  uns4 prev_virt
  uns4 pipe    // Pointer to the parent UsbPipe.
  uns4 buffer  // Pointer to data for this descriptor.
  uns4 length  // Length of data for this descriptor.
}

// Interface-specific data. Several interfaces of one device can operate
// independently, each is controlled by some driver and is identified by
// some driver-specific data passed as is to the driver.
struct UsbInterfaceData{
  uns4 driver_data  // Passed as is to the driver.
  uns4 driver_func  // Pointer to USBSRV structure for the driver.
}

// This structure contains all used data for one hub
struct UsbHub{
  // All configured hubs are organized in the global usb_hub_list.
  // Two following fields give next/prev items in that list.
  // While the hub is unconfigured, they point to usb_hub itself.
  uns4 next
  uns4 prev
  uns4 controller
  // Pointer to usb_controller for the bus.
  //
  // Handles of two pipes: configuration control pipe for zero endpoint opened by
  // the common code and status interrupt pipe opened by us.
  uns4 config_pipe
  uns4 status_pipe
  uns4 num_ports
  // Number of downstream ports; from 1 to 255.
  uns4 max_packet_size
  // Maximum packet size for interrupt endpoint.
  // Usually equals ceil((1+NumPorts)/8), but some hubs give additional bytes.
  uns4 actions
  // Bitfield with HUB_* constants.
  uns4 powered_on_time
  // Time (in ticks) when all downstream ports were powered up.
  uns4 reset_time
  // Time (in ticks) when the current port was reset//
  // when a port is resetting, contains the last tick of status check//
  // when reset recovery for a port is active, contains the time when
  // reset was completed.
  //
  // There are two possible reasons for configuration requests:
  // synchronous, when certain time is passed after something,
  // and asynchronous, when the hub is notifying about some change and
  // config request needs to be issued in order to query details.
  // Use two different buffers to avoid unnecessary dependencies.
  uns1 config_buffer[8]
  // Buffer for configuration requests for synchronous events.
  uns1 change_config_buffer[8]
  // Buffer for configuration requests for status changes.
  uns1 acc_status_change
  // Accumulated status change. See 11.12.3 of USB2 spec or comments in code.
  uns2 hub_characteristics
  // Copy of usb_hub_descr.wHubCharacteristics.
  uns1 power_on_interval
  // Copy of usb_hub_descr.bPwrOn2PwrGood.
  //
  // Two following fields are written at once by GET_STATUS request
  // and must remain in this order.
  uns2 status_data
  // Bitfield with 1 shl PORT_* indicating status of the current port.
  uns2 status_change
  // Bitfield with 1 shl PORT_* indicating change in status of the current port.
  // Two following fields are written at once by GET_STATUS request
  // and must remain in this order.
  // The meaning is the same as of StatusData/StatusChange// two following fields
  // are used by the synchronous requests to avoid unnecessary interactions with
  // the asynchronous handler.
  uns2 reset_status_data
  uns2 reset_status_change
  uns4 status_change_ptr
  // Pointer to StatusChangeBuf.
  uns4 connected_devices_ptr
  // Pointer to ConnectedDevices.
  uns4 connected_time_ptr
  // Pointer to ConnectedTime.
  //
  // Variable-length parts:
  // DeviceRemovable rb (NumPorts+8)/8
  //  Bit i+1 = device at port i (zero-based) is non-removable.
  // StatusChangeBuf rb (NumPorts+8)/8
  //  Buffer for status interrupt pipe. Bit 0 = hub status change,
  //  other bits = status change of the corresponding ports.
  // ConnectedDevices rd NumPorts
  //  Pointers to config pipes for connected devices or zero if no device connected.
  // ConnectedTime rd NumPorts
  //  For initial debounce interval:
  //   time (in ticks) when a device was connected at that port.
  //  Normally: -1
}

struct UsbDescr{
  uns1 bLength  // Size of this descriptor in bytes
  uns1 bDescriptorType  // One of USB_*_DESCR constants.
}

// Hub descriptor
struct UsbHubDescr{
  UsbDescr base
  uns1 bNbrPorts
  // Number of downstream ports.
  uns2 wHubCharacteristics
  // Bit 0: 0 = all ports are powered at once, 1 = individual port power switching
  // Bit 1: reserved, must be zero
  // Bit 2: 1 = the hub is part of a compound device
  // Bits 3-4: 00 = global overcurrent protection,
  //           01 = individual port overcurrent protection,
  //           1x = no overcurrent protection
  // Bits 5-6: Transaction Translator Think Time, 8*(value+1) full-speed bit times
  // Bit 7: 1 = port indicators supported
  // Other bits are reserved.
  uns1 bPwrOn2PwrGood
  // Time in 2ms intervals between powering up a port and a port becoming ready.
  uns1 bHubContrCurrent
  // Maximum current requirements of the Hub Controller electronics in mA.
  // DeviceRemovable - variable length
  //  Bit 0 is reserved, bit i+1 = device at port i is non-removable.
  // PortPwrCtrlMask - variable length
  //  Obsolete, exists for compatibility. We ignore it.
}

struct UsbDeviceDescr{
  UsbDescr base
  uns2 bcd_usb  // USB Specification Release number in BCD, e.g. 110h = USB 1.1
  uns1 bDeviceClass  // USB Device Class Code
  uns1 bDeviceSubClass  // USB Device Subclass Code
  uns1 bDeviceProtocol  // USB Device Protocol Code
  uns1 bMaxPacketSize0  // Maximum packet size for zero endpoint
  uns2 idVendor  // Vendor ID
  uns2 idProduct  // Product ID
  uns2 bcdDevice  // Device release number in BCD
  uns1 iManufacturer  // Index of string descriptor describing manufacturer
  uns1 iProduct  // Index of string descriptor describing product
  uns1 iSerialNumber  // Index of string descriptor describing serial number
  uns1 bNumConfigurations  // Number of possible configurations
}

// USB configuration descriptor
struct UsbConfigDescr{  
  UsbDescr base
  uns2 wTotalLength
  // Total length of data returned for this configuration
  uns1 bNumInterfaces
  // Number of interfaces in this configuration
  uns1 bConfigurationValue
  // Value for SET_CONFIGURATION control request
  uns1 iConfiguration
  // Index of string descriptor describing this configuration
  uns1 bmAttributes
  // Bit 6 is SelfPowered, bit 5 is RemoteWakeupSupported,
  // bit 7 must be 1, other bits must be 0
  uns1 bMaxPower
  // Maximum power consumption from the bus in 2mA units
}

// USB interface descriptor
struct UsbInterfaceDescr{
  UsbDescr base
  // The following two fields work in pair. Sometimes one interface can work
  // in different modes; e.g. videostream from web-cameras requires different
  // bandwidth depending on resolution/quality/compression settings.
  // Each mode of each interface has its own descriptor with its own endpoints
  // following; all descriptors for one interface have the same bInterfaceNumber,
  // and different bAlternateSetting.
  // By default, any interface operates in mode with bAlternateSetting = 0.
  // Often this is the only mode. If there are another modes, the active mode
  // is selected by SET_INTERFACE(bAlternateSetting) control request.
  uns1 bInterfaceNumber
  uns1 bAlternateSetting
  uns1 bNumEndpoints
  // Number of endpoints used by this interface, excluding zero endpoint
  uns1 bInterfaceClass
  // USB Interface Class Code
  uns1 bInterfaceSubClass
  // USB Interface Subclass Code
  uns1 bInterfaceProtocol
  // USB Interface Protocol Code
  uns1 iInterface
  // Index of string descriptor describing this interface
}

// USB endpoint descriptor
struct UsbEndpointDescr{
  UsbDescr base
  uns1 bEndpointAddress
  // Lower 4 bits form endpoint number,
  // upper bit is 0 for OUT endpoints and 1 for IN endpoints,
  // other bits must be zero
  uns1 bmAttributes
  // Lower 2 bits form transfer type, one of *_PIPE,
  // other bits must be zero for non-isochronous endpoints//
  // refer to the USB specification for meaning in isochronous case
  uns2 wMaxPacketSize
  // Lower 11 bits form maximum packet size,
  // next two bits specify the number of additional transactions per microframe
  // for high-speed periodic endpoints, other bits must be zero.
  uns1 bInterval
  // Interval for polling endpoint for data transfers.
  // Isochronous and high-speed interrupt endpoints: poll every 2^(bInterval-1)
  // (micro)frames
  // Full/low-speed interrupt endpoints: poll every bInterval frames
  // High-speed bulk/control OUT endpoints: maximum NAK rate
}

struct KeyboardDeviceData{
  uns4 handle          // keyboard handle from RegKeyboard
  uns4 timer           // auto-repeat timer handle
  uns1 repeatkey       // auto-repeat key code
  [dalign 32]
  uns4 usbdev          // pointer to device_data of USB and HID layers
  uns4 modifiers       // state of LCtrl ... RWin
  uns4 led_report      // output report for LEDs state
  uns4 numlock_bit     // position of NumLock bit in LED output report
  uns4 capslock_bit
  uns4 scrolllock_bit
}

[dalign 32]
uns4 hid_delay1, hid_delay2  // keyboard repeat key

uns4 usb_controllers[USB_MAX_IRQS][1 << USB_MAX_CONTROLLERS_PER_IRQ_LOG2]
uns4 usb_thread, usb_base, usb_mmio, usb_ecx, usb_edx
uns4 usb_test_controller  //$$$
bool usb_ready

// IN: ecx = size (B)
// OUT: cl = log2(ceil(size / 16)), al = 0 || erc
// KEEP: edx, ebx, esi, edi
h_usb_sizelog:
push edx
  mov edx, ecx
  mov eax, 16
  mov cl, 0
  
  l_h_usb_sizelog_5:
    cmp edx, eax
    jna l_h_usb_sizelog_8
      shl eax, 1
      jz l_h_usb_sizelog_6
        inc cl
        jmp short l_h_usb_sizelog_5
        
  l_h_usb_sizelog_6: // error
  mov al, 1
  jmp short l_h_usb_sizelog_9
  
  l_h_usb_sizelog_8: // ok
  mov al, 0
  
  l_h_usb_sizelog_9:
pop edx
ret

// IN: ecx = size
// OUT: ebx = ofs || 0
// KEEP: edx, esi, edi
h_usb_alloc:
pushfd
  cli
  
  push edx
   push esi
     
    call h_usb_sizelog
    test al, al
    jnz near l_h_usb_alloc_9
      mov ebx, VA_USB
      
      cmp cl, 0
      jnz l_h_usb_alloc_2
        // 16 B
        
        l_h_usb_alloc_15:
          cmp ebx, VA_USB + ((USB_SIZE - USB_BITMAPSIZE) >> 4 >> 3)
          jnb near l_h_usb_alloc_9
            mov al, [es:ebx]
            cmp al, 255
            jnz l_h_usb_alloc_16
              inc ebx
              jmp short l_h_usb_alloc_15
          
        l_h_usb_alloc_16:
        mov ah, al
        mov cl, 0
        
        l_h_usb_alloc_165:
          test ah, 1
          jz l_h_usb_alloc_166
            shr ah, 1
            inc cl
            jmp short l_h_usb_alloc_165
            
        l_h_usb_alloc_166:
        mov ah, 1
        
        l_h_usb_alloc_168:
        shl ah, cl
        or al, ah
        mov [es:ebx], al
        movzx eax, cl
        
        l_h_usb_alloc_170:
        sub ebx, VA_USB
        shl ebx, 3
        add ebx, eax
        shl ebx, 4
        add ebx, VA_USB + USB_BITMAPSIZE
        jmp l_h_usb_alloc_99
        
      l_h_usb_alloc_2:
      cmp cl, 1
      jnz l_h_usb_alloc_3
        // 32 B
        
        l_h_usb_alloc_25:
          cmp ebx, VA_USB + ((USB_SIZE - USB_BITMAPSIZE) >> 4 >> 3)
          jnb near l_h_usb_alloc_9
            mov al, [es:ebx]
            
            mov ah, al
            mov cl, 0
            
            l_h_usb_alloc_255:
              test ah, 3
              jz l_h_usb_alloc_26
                shr ah, 2
                add cl, 2
                cmp cl, 8
                jb l_h_usb_alloc_255
                
            inc ebx
            jmp short l_h_usb_alloc_25
            
        l_h_usb_alloc_26:
        mov ah, 3
        jmp l_h_usb_alloc_168
        
      l_h_usb_alloc_3:
      cmp cl, 2
      jnz l_h_usb_alloc_4
        // 64 B
        
        l_h_usb_alloc_35:
          cmp ebx, VA_USB + ((USB_SIZE - USB_BITMAPSIZE) >> 4 >> 3)
          jnb near l_h_usb_alloc_9
            mov al, [es:ebx]
            
            mov ah, al
            mov cl, 0
            
            l_h_usb_alloc_355:
              test ah, 15
              jz l_h_usb_alloc_36
                shr ah, 4
                add cl, 4
                cmp cl, 8
                jb l_h_usb_alloc_355
                
            inc ebx
            jmp short l_h_usb_alloc_35
            
        l_h_usb_alloc_36:
        mov ah, 15
        jmp l_h_usb_alloc_168
        
      l_h_usb_alloc_4:
      cmp cl, 3
      jnz l_h_usb_alloc_5
        // 128 B
        
        l_h_usb_alloc_45:
          cmp ebx, VA_USB + ((USB_SIZE - USB_BITMAPSIZE) >> 4 >> 3)
          jnb near l_h_usb_alloc_9
            mov al, [es:ebx]
            test al, al
            jz l_h_usb_alloc_46
              inc ebx
              jmp short l_h_usb_alloc_45
              
        l_h_usb_alloc_46:
        mov byte ptr [es:ebx], 255
        xor eax, eax
        jmp l_h_usb_alloc_170
        
      l_h_usb_alloc_5:
      // 256 B ++
      sub cl, 3  // cl = log2(number of bytes in bitmap)
      mov edx, (USB_SIZE - USB_BITMAPSIZE) >> 4 >> 3
      xor eax, eax
      inc eax
      shl eax, cl
      mov ecx, eax  // ecx = number of bytes in bitmap
      sub edx, ecx
      add edx, ebx
      
      l_h_usb_alloc_55:
        cmp ebx, edx
        jnb l_h_usb_alloc_9
          xor esi, esi
          
          l_h_usb_alloc_555:
            mov al, [es:ebx + esi]
            test al, al
            jnz l_h_usb_alloc_58
              inc esi
              cmp esi, ecx
              jb l_h_usb_alloc_555
                // found free space
                xor esi, esi
                
                l_h_usb_alloc_565:
                  mov byte ptr [es:ebx + esi], 255
                  inc esi
                  cmp esi, ecx
                  jb l_h_usb_alloc_565
                  
                sub ebx, VA_USB
                shl ebx, 4 + 3
                add ebx, VA_USB + USB_BITMAPSIZE
                jmp l_h_usb_alloc_99
            
          l_h_usb_alloc_58:
          add ebx, ecx  // assert ecx != 0
          jmp short l_h_usb_alloc_55
      
    l_h_usb_alloc_9:
    xor ebx, ebx
    
    l_h_usb_alloc_99:
   pop esi
  pop edx
popfd
ret

// IN: ebx = ofs, ecx = size
// KEEP: edx, esi, edi
h_usb_free:
pushfd
 cli
 
 push edx
  test ebx, ebx
  jz l_h_usb_free_9
    call h_usb_sizelog
    test al, al
    jnz l_h_usb_free_9
      sub ebx, VA_USB + USB_BITMAPSIZE
      cmp ebx, USB_SIZE - USB_BITMAPSIZE
      jnb l_h_usb_free_9
        cmp cl, 0
        jnz l_h_usb_free_2
          // 16 B
          mov al, 1
          
          l_h_usb_free_22:
          shr ebx, 4
          mov cl, bl
          shr ebx, 3
          and cl, 7
          shl al, cl
          not al
          and [es:VA_USB + ebx], al
          jmp l_h_usb_free_9
          
        l_h_usb_free_2:
        cmp cl, 1
        jnz l_h_usb_free_3
          // 32 B
          mov al, 3
          jmp short l_h_usb_free_22
          
        l_h_usb_free_3:
        cmp cl, 2
        jnz l_h_usb_free_4
          // 64 B
          mov al, 15
          jmp short l_h_usb_free_22
          
        l_h_usb_free_4:
        // 128 B ++
        sub cl, 3  // cl = log2(number of bytes in bitmap)
        mov edx, (USB_SIZE - USB_BITMAPSIZE) >> 4 >> 3
        xor eax, eax
        inc eax
        shl eax, cl
        mov ecx, eax  // ecx = number of bytes in bitmap
        sub edx, ecx
        
        shr ebx, 4 + 3
        cmp ebx, edx
        jnb l_h_usb_free_9
          add ebx, VA_USB
          mov edx, ebx
          add edx, ecx
          
          l_h_usb_free_45:
            cmp ebx, edx
            jnb l_h_usb_free_9
              mov byte ptr [es:ebx], 0
              inc ebx
              jmp short l_h_usb_free_45
              
  l_h_usb_free_9:
 pop edx
popfd
ret

// IN: eax = VA
// OUT: eax = 0 || PA
// KEEP: all but eax
h_usb_getphysadr:
test eax, eax
jz l_h_usb_getphysadr_9
  cmp eax, VA_USB
  jb l_h_usb_getphysadr_9
    cmp eax, VA_USB + USB_SIZE
    jnb l_h_usb_getphysadr_9
      sub eax, VA_USB
      add eax, usb_base
      
      ret
  
l_h_usb_getphysadr_9:
xor eax, eax
ret

[align 32]
h_usb_controllers_list:
VA_USB_CONTROLLERS_LIST = offset h_usb_controllers_list + PA_KERNEL_CODE + VA_SYSTEM
dd VA_USB_CONTROLLERS_LIST
dd VA_USB_CONTROLLERS_LIST

h_usb_hubs_list:
VA_USB_HUBS_LIST = offset h_usb_hubs_list + PA_KERNEL_CODE + VA_SYSTEM
dd VA_USB_HUBS_LIST
dd VA_USB_HUBS_LIST

// IN: eax -> UsbController, usb_ecx, usb_edx
// KEEP: all
h_usb_init_controller:
push ebx
  // PCI coordinates
  xor ebx, ebx
  mov bh, byte ptr usb_ecx[1]
  mov bl, byte ptr usb_ecx[0]
  shl bl, 3
  or bl, byte ptr usb_edx[1]
  mov [es:eax + offset UsbController.pci_coordinates], ebx
  // usb_controllers_list (called only from usb_thread, no need for mutex)
  mov ebx, VA_USB_CONTROLLERS_LIST
  push edx
    mov edx, [es:ebx + offset UsbController.prev]
    mov [es:eax + offset UsbController.next], ebx
    mov [es:eax + offset UsbController.prev], edx
    mov [es:edx + offset UsbController.next], eax
    mov [es:ebx + offset UsbController.prev], eax
  pop edx
  // existing adresses, resetting_port
  mov edi, eax
  xor eax, eax
  dec eax  // eax = -1
  mov [es:edi + offset UsbController.existing_addresses + 4], eax
  mov [es:edi + offset UsbController.existing_addresses + 8], eax
  mov [es:edi + offset UsbController.existing_addresses + 12], eax
  mov [es:edi + offset UsbController.resetting_port], al
  dec eax  // eax = -2
  mov [es:edi + offset UsbController.existing_addresses + 0], eax
  // locks
  lea ecx, [edi + offset UsbController.periodic_lock]
  call p_mutex_init
  add ecx, offset UsbController.control_lock - offset UsbController.periodic_lock
  call p_mutex_init
  add ecx, offset UsbController.bulk_lock - offset UsbController.control_lock
  call p_mutex_init
  
  l_h_usb_init_controller_9:
pop ebx
ret

// Helper procedure for USB1 scheduler: calculate bandwidth on the bus.
// IN: low 11 bits of eax = payload size in bytes
//     cl = 0:full-speed, else:high-speed
//     ch = 0:OUT, else:IN
// OUT: eax = maximal bandwidth in FS-bits
h_usb_calc_bandwidth:
and eax, (1 << 11) - 1     // get payload for one transaction
add eax, 3  // add 3 bytes for other fields in data packet, PID+CRC16
test cl, cl
jnz l_h_usb_calc_bandwidth_low_speed
  // Multiply by 8 for bytes -> bits, by 7/6 to accomodate bit stuffing
  // and by 401/400 for IN transfers to accomodate timers difference
  // 9+107/300 for IN transfers, 9+1/3 for OUT transfers
  // For 0 <= eax < 09249355h, floor(eax * 107/300) = floor(eax * 5B4E81B5h / 2^32).
  // For 0 <= eax < 80000000h, floor(eax / 3) = floor(eax * 55555556h / 2^32).
  mov edx, 55555556h
  test ch, ch
  jz l_h_usb_calc_bandwidth_2
    mov edx, 5B4E81B5h
    
  l_h_usb_calc_bandwidth_2:
  lea ecx, [eax * 8 + eax]
  mul edx
  // Add 93 extra bits: 39 bits for Token packet (8 for SYNC, 24 for token+address,
  // 4 extra bits for possible bit stuffing in token+address, 3 for EOP),
  // 18 bits for bus turn-around, 11 bits for SYNC+EOP in Data packet plus 1 bit
  // for possible timers difference, 2 bits for inter-packet delay, 20 bits for
  // Handshake packet, 2 bits for another inter-packet delay.
  lea eax, [ecx + edx + 93]
  
  ret
  
l_h_usb_calc_bandwidth_low_speed:
// Multiply by 8 for bytes -> bits, by 7/6 to accomodate bit stuffing,
// by 8 for LS -> FS and by 406/50 for IN transfers to accomodate timers difference.
// 75+59/75 for IN transfers, 74+2/3 for OUT transfers.
mov edx, 0AAAAAABh
test ch, ch
mov ecx, 74
jz l_h_usb_calc_bandwidth_3
  mov edx, 0C962FC97h
  inc ecx
  
l_h_usb_calc_bandwidth_3:
imul ecx, eax
mul edx
// Add 778 extra bits:
// 16 bits for PRE packet, 4 bits for hub delay, 8*39 bits for Token packet
// 8*18 bits for bus turn-around
// (406/50)*11 bits for SYNC+EOP in Data packet,
// 8*2 bits for inter-packet delay,
// 16 bits for PRE packet, 4 bits for hub delay, 8*20 bits for Handshake packet,
// 8*2 bits for another inter-packet delay.
lea eax, [ecx + edx + 778]
ret

// Pipe is removing, update the corresponding lists.
// We do not reorder anything, so just update book-keeping variable
// in the list header.
// IN: ebx -> UsbPipe, stack { maxpacket, (lowspeed && direction) }
h_usb_interrupt_list_unlink:
// calculate bandwidth on the bus
mov eax, [ss:esp + 4]  //.maxpacket
mov ecx, [ss:esp + 8]  //.lowspeed
call h_usb_calc_bandwidth
mov edx, [es:ebx + offset UsbPipe.base_list]
// subtract pipe bandwidth
sub [es:edx + offset UsbStaticEp.bandwidth], eax
ret 8

// UHCI register declarations
UHCI_REG_COMMAND     = 0
UHCI_REG_STATUS      = 2
UHCI_REG_INTERRUPT   = 4
UHCI_REG_FRAMENUM    = 6
UHCI_REG_BASEADR     = 8
UHCI_REG_SOFMODIFY   = 0Ch
UHCI_REG_PORT1STATUS = 10h
// possible PIDs for USB data transfers
USB_PID_SETUP = 2Dh
USB_PID_IN    = 69h
USB_PID_OUT   = 0E1h
// UHCI does not support an interrupt on root hub status change. We must poll
// the controller periodically. This is the period in timer ticks (10ms).
// We use the value 100 ticks: it is small enough to be responsive to connect
// events and large enough to not load CPU too often.
UHCI_POLL_INTERVAL = 100
// the following constant is an invalid encoding for length fields in
// uhci_gtd; it is used to check whether an inactive TD has been
// completed (actual length of the transfer is valid) or not processed at all
// (actual length of the transfer is UHCI_INVALID_LENGTH).
// Valid values are 0-4FFh and 7FFh. We use 700h as an invalid value.
UHCI_INVALID_LENGTH = 700h

// UHCI-specific part of a pipe descriptor.
// * The structure corresponds to the Queue Head aka QH from the UHCI
//   specification with some additional fields.
// * The hardware uses first two fields (8 bytes). Next two fields are used for
//   software book-keeping.
// * The hardware requires 16-bytes alignment of the hardware part.
//   Since the allocator (usb_allocate_common) allocates memory sequentially
//   from page start (aligned on 0x1000 bytes), block size for the allocator
//   must be divisible by 16; usb1_allocate_endpoint ensures this.
struct UhciPipe{
  uns4 next_qh
  // 1. First bit (bit 0) is Terminate bit. 1 = there is no next QH.
  // 2. Next bit (bit 1) is QH/TD select bit. 1 = NextQH points to QH.
  // 3. Next two bits (bits 2-3) are reserved.
  // 4. With masked 4 lower bits, this is the physical address of the next QH in
  //    the QH list.
  // See also the description before NextVirt field of the usb_pipe
  // structure. Additionally to that description, the following is specific for
  // the UHCI controller:
  // * n=10, N=1024. However, this number is quite large.
  // * 1024 lists are used only for individual transfer descriptors for
  //   Isochronous endpoints. This means that the software can sleep up to 1024 ms
  //   before initiating the next portion of a large isochronous transfer, which
  //   is a sufficiently large value.
  // * We use the 32ms upper limit for interrupt endpoint polling interval.
  //   This seems to be a reasonable value.
  // * The "next" list for last Periodic list is the Control list.
  // * The "next" list for Control list is Bulk list and the "next"
  //   list for Bulk list is Control list. This loop is used for bandwidth
  //   reclamation: the hardware traverses lists until end-of-frame.
  uns4 head_td
  // 1. First bit (bit 0) is Terminate bit. 1 = there is no TDs in this QH.
  // 2. Next bit (bit 1) is QH/TD select bit. 1 = HeadTD points to QH.
  // 3. Next two bits (bits 2-3) are reserved.
  // 4. With masked 4 lower bits, this is the physical address of the first TD in
  //    the TD queue for this QH.
  uns4 token
  // This field is a template for uhci_gtd.Token field in transfer
  // descriptors. The meaning of individual bits is the same as for
  // uhci_gtd.Token, except that PID bitfield is always
  // USB_PID_SETUP/IN/OUT for control/in/out pipes,
  // the MaximumLength bitfield encodes maximum packet size,
  // the Reserved bit 20 is LowSpeedDevice bit.
  uns4 error_td
  // Usually NULL. If nonzero, it is a pointer to descriptor which was errored
  // and should be freed sometime in the future (the hardware could still use it).
}

// This structure describes the static head of every list of pipes.
// The hardware requires 16-bytes alignment of this structure.
// All instances of this structure are located sequentially in uhci_controller,
// uhci_controller is page-aligned, so it is sufficient to make this structure
// 16-bytes aligned and verify that the first instance is 16-bytes aligned
// inside uhci_controller.
struct UhciStaticEp{
  uns4 next_qh   // Same as uhci_pipe.NextQH
  uns4 head_td   // Same as uhci_pipe.HeadTD
  uns4 next_list  // Virtual address of the next list
  uns4 rsv1      // Not used
  uns1 software_part[sizeof UsbStaticEp]
  // Common part for all controllers, described by usb_static_ep structure.
  uns4 rsv2  // Padding for 16-byte alignment.
}

// UHCI-specific part of controller data.
// * The structure includes two parts, the hardware part and the software part.
// * The hardware part consists of first 4096 bytes and corresponds to
//   the Frame List from UHCI specification.
// * The hardware requires page-alignment of the hardware part, so
//   the entire descriptor must be page-aligned.
//   This structure is allocated with kernel_alloc (see usb_init_controller),
//   this gives page-aligned data.
struct UhciController{
  // ------------------------------ hardware fields ------------------------------
  uns4 frame_list[1024]
  // Entry n corresponds to the head of the frame list to be executed in
  // the frames n,n+1024,n+2048,n+3072,...
  // The first bit of each entry is Terminate bit, 1 = the frame is empty.
  // The second bit of each entry is QH/TD select bit, 1 = the entry points to
  // QH, 0 = to TD.
  // With masked 2 lower bits, the entry is a physical address of the first QH/TD
  // to be executed.
  // ------------------------------ software fields ------------------------------
  // Every list has the static head, which is an always empty QH.
  // The following fields are static heads, one per list:
  // 32+16+8+4+2+1 = 63 for Periodic lists, 1 for Control list and 1 for Bulk list.
  UhciStaticEp int_eds[63]
  UhciStaticEp control_ed
  UhciStaticEp bulk_ed
  uns4 io_base
  // Base port in I/O space for UHCI controller.
  // UHCI register UhciXxx is addressed as in/out to IOBase + UhciXxx,
  // see declarations in the beginning of this source.
  uns4 deferred_actions
  // Bitmask of bits from UhciStatusReg which need to be processed
  // by uhci_process_deferred. Bit 0 = a transaction with IOC bit
  // has completed. Bit 1 = a transaction has failed. Set by uhci_irq,
  // cleared by uhci_process_deferred.
  uns4 last_poll_time
  // See the comment before UHCI_POLL_INTERVAL. This variable keeps the
  // last time, in timer ticks, when the polling was done.
  uns4 ehci_companion
  // Pointer to usb_controller for EHCI companion, if any, or NULL.
}

// UHCI general transfer descriptor.
// * The structure describes non-Isochronous data transfers
//   for the UHCI controller.
// * The structure includes two parts, the hardware part and the software part.
// * The hardware part consists of first 16 bytes and corresponds to the
//   Transfer Descriptor aka TD from UHCI specification.
// * The hardware requires 16-bytes alignment of the hardware part, so
//   the entire descriptor must be 16-bytes aligned. Since the allocator
//   (uhci_allocate_common) allocates memory sequentially from page start
//   (aligned on 0x1000 bytes), block size for the allocator must be
//   divisible by 16// usb1_allocate_general_td ensures this.
struct UhciGtd{
  uns4 next_td
  // 1. First bit (bit 0) is Terminate bit. 1 = there is no next TD.
  // 2. Next bit (bit 1) is QH/TD select bit. 1 = NextTD points to QH.
  //    This bit is always set to 0 in the implementation.
  // 3. Next bit (bit 2) is Depth/Breadth select bit. 1 = the controller should
  //    proceed to the NextTD after this TD is complete. 0 = the controller
  //    should proceed to the next endpoint after this TD is complete.
  //    The implementation sets this bit to 0 for final stages of all transactions
  //    and to 1 for other stages.
  // 4. Next bit (bit 3) is reserved and must be zero.
  // 5. With masked 4 lower bits, this is the physical address of the next TD
  //    in the TD list.
  uns4 control_status
  // 1. Lower 11 bits (bits 0-10) are ActLen. This is written by the controller
  //    at the conclusion of a USB transaction to indicate the actual number of
  //    bytes that were transferred minus 1.
  // 2. Next 6 bits (bits 11-16) are reserved.
  // 3. Next bit (bit 17) signals Bitstuff error.
  // 4. Next bit (bit 18) signals CRC/Timeout error.
  // 5. Next bit (bit 19) signals NAK receive.
  // 6. Next bit (bit 20) signals Babble error.
  // 7. Next bit (bit 21) signals Data Buffer error.
  // 8. Next bit (bit 22) signals Stall error.
  // 9. Next bit (bit 23) is Active field. 1 = this TD should be processed.
  // 10. Next bit (bit 24) is InterruptOnComplete bit. 1 = the controller should
  //     issue an interrupt on completion of the frame in which this TD is
  //     executed.
  // 11. Next bit (bit 25) is IsochronousSelect bit. 1 = this TD is isochronous.
  // 12. Next bit (bit 26) is LowSpeedDevice bit. 1 = this TD is for low-speed.
  // 13. Next two bits (bits 27-28) are ErrorCounter field. This field is
  //     decremented by the controller on every non-fatal error with this TD.
  //     Babble and Stall are considered fatal errors and immediately deactivate
  //     the TD without decrementing this field. 0 = no error limit,
  //     n = deactivate the TD after n errors.
  // 14. Next bit (bit 29) is ShortPacketDetect bit. 1 = short packet is an error.
  //     Note: the specification defines this bit as input for the controller,
  //     but does not specify the value written by controller.
  //     Some controllers (e.g. Intel) keep the value, some controllers (e.g. VIA)
  //     set the value to whether a short packet was actually detected
  //     (or something like that).
  //     Thus, we duplicate this bit as bit 0 of OrigBufferInfo.
  // 15. Upper two bits (bits 30-31) are reserved.
  uns4 token
  // 1. Lower 8 bits (bits 0-7) are PID, one of USB_PID_*.
  // 2. Next 7 bits (bits 8-14) are DeviceAddress field. This is the address of
  //    the target device on the USB bus.
  // 3. Next 4 bits (bits 15-18) are Endpoint field. This is the target endpoint
  //    number.
  // 4. Next bit (bit 19) is DataToggle bit. n = issue/expect DATAn token.
  // 5. Next bit (bit 20) is reserved.
  // 6. Upper 11 bits (bits 21-31) are MaximumLength field. This field specifies
  //    the maximum number of data bytes for the transfer minus 1 byte. Null data
  //    packet is encoded as 0x7FF, maximum possible non-null data packet is 1280
  //    bytes, encoded as 0x4FF.
  uns4 buffer
  // Physical address of the data buffer for this TD.
  uns4 orig_buffer_info
  // Usually NULL. If the original buffer crosses a page boundary, this is a
  // pointer to the structure uhci_original_buffer for this request.
  // bit 0: 1 = short packet is NOT allowed
  // (before the TD is processed, it is the copy of bit 29 of ControlStatus;
  //  some controllers modify that bit, so we need a copy in a safe place)
}

// UHCI requires that the entire transfer buffer should be on one page.
// If the actual buffer crosses page boundary, uhci_alloc_packet
// allocates additional memory for buffer for hardware.
// This structure describes correspondence between two buffers.
struct UhciOriginalBuffer{
  uns4 orig_buffer
  uns4 used_buffer
}

// This procedure is called in the USB thread from uhci_process_deferred
// every UHCI_POLL_INTERVAL ticks. It polls the controller for
// connect/disconnect events.
// IN: esi -> UsbController
// KEEP: ebx, esi
h_uhci_poll_roothub:
push ebx  // save used register to be stdcall
  // 1. Prepare for the loop for every port.
  xor ecx, ecx
  
  l_h_uhci_poll_roothub_5:
    // 2. Some implementations of UHCI set ConnectStatusChange bit in a response to
    // PortReset. Thus, we must ignore this change for port which is resetting.
    cmp cl, [es:esi + offset UsbController.resetting_port]
    jz l_h_uhci_poll_roothub_6
      // 3. Read port status.
      mov edx, [es:esi + offset UhciController.io_base - sizeof UhciController]
      lea edx, [edx + ecx * 2 + UHCI_REG_PORT1STATUS]
      in ax, dx
      // 4. If no change bits are set, continue to the next port.
      test al, 0Ah
      jz l_h_uhci_poll_roothub_6
        // 5. Clear change bits and read the status again.
        // (It is possible, although quite unlikely, that some event occurs between
        // the first read and the clearing, invalidating the old status. If an event
        // occurs after the clearing, we will not miss it, looking in the next scan.
        out dx, ax
        mov ebx, eax
        in ax, dx
        // 6. Process connect change notifications.
        // Note: if connect status has changed, ignore enable status change//
        // it is normal to disable a port at disconnect event.
        // Some controllers set enable status change bit, some don't.
        test bl, 2
        jz l_h_uhci_poll_roothub_noconnectchange
          // yep. Regardless of the current status, note disconnect event//
          // if there is something connected, store the connect time and note connect event.
          // In any way, do not process
          bts [es:esi + offset UsbController.new_disconnected], ecx
          test al, 1
          jz l_h_uhci_poll_roothub_disconnect
            mov eax, tmr_usb_timerticks  // GetTimerTicks
            mov [es:esi + offset UsbController.connected_time + ecx * 4], eax
            bts [es:esi + offset UsbController.new_connected], ecx
            jmp short l_h_uhci_poll_roothub_6
            
          l_h_uhci_poll_roothub_disconnect:
          btr [es:esi + offset UsbController.new_connected], ecx
          jmp short l_h_uhci_poll_roothub_6
          
        l_h_uhci_poll_roothub_noconnectchange:
        // 7. Process enable change notifications.
        // Note: that needs work.
        test bl, 8
        jz l_h_uhci_poll_roothub_6
          test al, 4
          jnz l_h_uhci_poll_roothub_6
            // dbgstr 'Port disabled'
        
    l_h_uhci_poll_roothub_6:
    // 8. Continue the loop for every port.
    inc ecx
    cmp ecx, [es:esi + offset UsbController.num_ports]
    jb l_h_uhci_poll_roothub_5
    
pop ebx  // restore used register to be stdcall
ret

// Helper procedure for restarting transfer queue.
// When transfers are queued, their toggle bit is filled assuming that
// everything will go without errors. On error, some packets needs to be
// skipped, so toggle bits may become incorrect.
// This procedure fixes toggle bits.
// IN: ebx -> last packet to be skipped, error_td -> last processed packet
h_uhci_fix_toggle:
// 1. Nothing to do for control pipes: in that case,
// toggle bits for different transfer stages are independent.
mov ecx, [es:ebx + offset UsbGtd.pipe]
cmp dword ptr [es:ecx + offset UsbPipe.type], CONTROL_PIPE
jz l_h_uhci_fix_toggle_9
  // 2. The hardware expects next packet with toggle = (error_td.toggle xor 1),
  // the current value in next packet is (ebx.toggle xor 1).
  // Nothing to do if ErrorTD.toggle == ebx.toggle.
  mov eax, [es:ecx + offset UhciPipe.error_td - sizeof UhciPipe]
  mov eax, [es:eax + offset UhciGtd.token - sizeof UhciGtd]
  xor eax, [es:ebx + offset UhciGtd.token - sizeof UhciGtd]
  test eax, 1 << 19
  jz l_h_uhci_fix_toggle_9
    // 3. Lock the transfer queue.
    add ecx, offset UsbPipe.lock
    call p_mutex_lock
    // 4. Flip the toggle bit in all packets from ebx.next_virt to ecx.last_td
    // (inclusive).
    mov eax, [es:ebx + offset UsbGtd.next_virt]
    
    l_h_uhci_fix_toggle_5:
      xor byte ptr [es:eax + offset UhciGtd.token - sizeof UhciGtd + 2], 1 << (19 - 16)
      cmp eax, [es:ecx + offset UsbPipe.last_td - offset UsbPipe.lock]
      mov eax, [es:eax + offset UsbGtd.next_virt]
      jnz l_h_uhci_fix_toggle_5
      
    // 5. Flip the toggle bit in uhci_pipe structure.
    xor byte ptr [es:ecx + offset UhciPipe.token - sizeof UhciPipe - offset UsbPipe.lock + 2], 1 << (19 - 16)
    // 6. Unlock the transfer queue.
    call p_mutex_unlock
    
l_h_uhci_fix_toggle_9:
ret

// This procedure is called from uhci_process_updated_list, which is itself
// called from uhci_process_updated_schedule, see comments there.
// It processes one completed descriptor.
// IN: esi -> UsbController, ebx -> UsbGtd
// OUT: ebx -> next UsbGtd
h_uhci_process_finalized_td:

// 1. Remove this descriptor from the list of descriptors for this pipe.
call h_usb_unlink_td

// 2. If this is IN transfer into special buffer, copy the data
// to target location.
mov edx, [es:ebx + offset UhciGtd.orig_buffer_info - sizeof UhciGtd]
and edx, -2  // clear lsb (used for another goal)
jz l_h_uhci_process_finalized_td_nocopy
  cmp byte ptr [es:ebx + offset UhciGtd.token - sizeof UhciGtd], USB_PID_IN
  jnz l_h_uhci_process_finalized_td_nocopy
    // Note: we assume that pointer to buffer is valid in the memory space of
    // the USB thread. This means that buffer must reside in kernel memory
    // (shared by all processes).
    push esi
     push edi
      mov esi, [es:edx + offset UhciOriginalBuffer.used_buffer]
      mov edi, [es:edx + offset UhciOriginalBuffer.orig_buffer]
      mov ecx, [es:ebx + offset UhciGtd.control_status - sizeof UhciGtd]
      inc ecx
      and ecx, 7FFh
      mov edx, ecx
      shr ecx, 2
      and edx, 3
      push ds
        push es
        pop ds
        cld
        rep movsd
        mov ecx, edx
        rep movsb
      pop ds
     pop edi
    pop esi
    
l_h_uhci_process_finalized_td_nocopy:
// 3. Calculate actual number of bytes transferred.
// 3a. Read the state.
mov eax, [es:ebx + offset UhciGtd.control_status - sizeof UhciGtd]
mov ecx, [es:ebx + offset UhciGtd.token - sizeof UhciGtd]
// 3b. Get number of bytes processed.
lea edx, [eax + 1]
and edx, 7FFh
// 3c. Subtract number of bytes in this packet.
add ecx, 1 << 21
shr ecx, 21
sub edx, ecx
// 3d. Add total length transferred so far.
add edx, [es:ebx + offset UsbGtd.length]
// Actions on error and on success are slightly different.
// 4. Test for error. On error, proceed to step 5, otherwise go to step 6
// with ecx = 0 (no error).
// USB transaction error is always considered as such.
// If short packets are not allowed, UHCI controllers do not set an error bit,
// but stop (clear Active bit and do not advance) the queue.
// Short packet is considered as an error if the packet is actually short
// (actual length is less than maximal one) and the code creating the packet
// requested that behaviour (so bit 0 of OrigBufferInfo is set// this could be
// because the caller disallowed short packets or because the packet is not
// the last one in the corresponding transfer).
xor ecx, ecx
test eax, 1 << 22
jnz l_h_uhci_process_finalized_td_error
  test byte ptr [es:ebx + offset UhciGtd.orig_buffer_info - sizeof UhciGtd], 1
  jz near l_h_uhci_process_finalized_td_notify
    cmp edx, [es:ebx + offset UsbGtd.length]
    jz near l_h_uhci_process_finalized_td_notify
    
l_h_uhci_process_finalized_td_error:
// 5. There was an error while processing this packet.
// The hardware has stopped processing the queue.
// 5a. Save the status and length.
push edx
 push eax
  mov eax, [es:ebx + offset UsbGtd.pipe]
  // 5b. Store the current TD as an error packet.
  // If an error packet is already stored for this pipe,
  // it is definitely not used already, so free the old packet.
  mov eax, [es:eax + offset UhciPipe.error_td - sizeof UhciPipe]
  test eax, eax
  jz l_h_uhci_process_finalized_td_error_1
    
    push eax
    call h_uhci_free_gtd
    
  l_h_uhci_process_finalized_td_error_1:
  mov eax, [es:ebx + offset UsbGtd.pipe]
  mov [es:eax + offset UhciPipe.error_td - sizeof UhciPipe], ebx
  // 5c. Traverse the list of descriptors looking for the final packet
  // for this transfer.
  // Free and unlink non-final descriptors, except the current one.
  // Final descriptor will be freed in step 7.
  
  call h_usb_is_final_packet
  
  jnc l_h_uhci_process_finalized_td_found_final
    mov ebx, [es:ebx + offset UsbGtd.next_virt]
  
  l_h_uhci_process_finalized_td_look_final:
    call h_usb_unlink_td
    call h_usb_is_final_packet
    jnc l_h_uhci_process_finalized_td_found_final
      push dword ptr [es:ebx + offset UsbGtd.next_virt]
        
        push ebx
        call h_uhci_free_gtd
        
      pop ebx
      jmp short l_h_uhci_process_finalized_td_look_final
      
  l_h_uhci_process_finalized_td_found_final:
  // 5d. Restore the status saved in 5a and transform it to the error code.
 pop eax  // error code
 shr eax, 16
 // Notes:
 // * any USB transaction error results in Stalled bit// if it is not set,
 //   but we are here, it must be due to short packet//
 // * babble is considered a fatal USB transaction error,
 //   other errors just lead to retrying the transaction//
 //   if babble is detected, return the corresponding error//
 // * if several non-fatal errors have occured during transaction retries,
 //   all corresponding bits are set. In this case, return some error code,
 //   the order is quite arbitrary.
 mov ecx, USB_STATUS_UNDERRUN
 test al, 1 << (22 - 16)       // not Stalled?
 jz l_h_uhci_process_finalized_td_know_error
   mov cl, USB_STATUS_OVERRUN
   test al, 1 << (20 - 16)       // Babble detected?
   jnz l_h_uhci_process_finalized_td_know_error
     mov cl, USB_STATUS_BITSTUFF
     test al, 1 << (17 - 16)       // Bitstuff error?
     jnz l_h_uhci_process_finalized_td_know_error
       mov cl, USB_STATUS_NORESPONSE
       test al, 1 << (18 - 16)       // CRC/TimeOut error?
       jnz l_h_uhci_process_finalized_td_know_error
         mov cl, USB_STATUS_BUFOVERRUN
         test al, 1 << (21 - 16)       // Data Buffer error?
         jnz l_h_uhci_process_finalized_td_know_error
           mov cl, USB_STATUS_STALL
        
 l_h_uhci_process_finalized_td_know_error:
 // 5e. If error code is USB_STATUS_UNDERRUN
 // and the last TD allows short packets, it is not an error.
 // Note: all TDs except the last one in any transfer stage are marked
 // as short-packet-is-error to stop controller from further processing
 // of that stage// we need to restart processing from a TD following the last.
 // After that, go to step 6 with ecx = 0 (no error).
 cmp ecx, USB_STATUS_UNDERRUN
 jnz l_h_uhci_process_finalized_td_58
  test byte ptr [es:ebx + offset UhciGtd.orig_buffer_info - sizeof UhciGtd], 1
  jnz l_h_uhci_process_finalized_td_58
    // The controller has stopped this queue on the error packet.
    // Update uhci_pipe.HeadTD to point to the next packet in the queue.
    call h_uhci_fix_toggle
    xor ecx, ecx

 l_h_uhci_process_finalized_td_control:
 mov eax, [es:ebx + offset UhciGtd.next_td - sizeof UhciGtd]
 and al, -16
 mov edx, [es:ebx + offset UsbGtd.pipe]
 mov [es:edx + offset UhciPipe.head_td - sizeof UhciPipe], eax
pop edx  // length
jmp l_h_uhci_process_finalized_td_notify

 l_h_uhci_process_finalized_td_58:
 // 5f. Abort the entire transfer.
 // There are two cases: either there is only one transfer stage
 // (everything except control transfers), then ebx points to the last TD and
 // all previous TD were unlinked and dismissed (if possible),
 // or there are several stages (a control transfer) and ebx points to the last
 // TD of Data or Status stage (usb_is_final_packet does not stop in Setup stage,
 // because Setup stage can not produce short packets)// for Data stage, we need
 // to unlink and free (if possible) one more TD and advance ebx to the next one.
 cmp dword ptr [es:ebx + offset UsbGtd.callback], 0
 jnz l_h_uhci_process_finalized_td_normal
   // We cannot free error_td yet, it could still be used by the hardware.
   push ecx
    mov eax, [es:ebx + offset UsbGtd.pipe]
    push dword ptr [es:ebx + offset UsbGtd.next_virt]
     cmp ebx, [es:eax + offset UhciPipe.error_td - sizeof UhciPipe]
     jz l_h_uhci_process_finalized_td_588
       
       push ebx
       call h_uhci_free_gtd
       
     l_h_uhci_process_finalized_td_588:
    pop ebx
   
   call h_usb_unlink_td
   
   pop ecx
   
 l_h_uhci_process_finalized_td_normal:
 // 5g. For bulk/interrupt transfers we have no choice but halt the queue,
 // the driver should intercede (through some API which is not written yet).
 // Control pipes normally recover at the next SETUP transaction (first stage
 // of any control transfer), so we hope on the best and just advance the queue
 // to the next transfer. (According to the standard, "A control pipe may also
 // support functional stall as well, but this is not recommended.").
 mov edx, [es:ebx + offset UsbGtd.pipe]
 cmp dword ptr [es:edx + offset UsbPipe.type], CONTROL_PIPE
 jz l_h_uhci_process_finalized_td_control
 // Bulk/interrupt transfer; halt the queue.
 mov eax, [es:ebx + offset UhciGtd.next_td - sizeof UhciGtd]
 and al, -16
 inc eax  // set Halted bit
 mov [es:edx + offset UhciPipe.head_td - sizeof UhciPipe], eax
pop edx  // restore length saved in step 5a

l_h_uhci_process_finalized_td_notify:
// 6. Either the descriptor in ebx was processed without errors,
// or all necessary error actions were taken and ebx points to the last
// related descriptor.

call h_usb_process_gtd

// 7. Free the current descriptor (if allowed) and return the next one.
// 7a. Save pointer to the next descriptor.
push dword ptr [es:ebx + offset UsbGtd.next_virt]
  // 7b. Free the descriptor, unless it is saved as ErrorTD.
  mov eax, [es:ebx + offset UsbGtd.pipe]
  cmp [es:eax + offset UhciPipe.error_td - sizeof UhciPipe], ebx
  jz l_h_uhci_process_finalized_td_66
    
    push ebx    
    call h_uhci_free_gtd
    
  l_h_uhci_process_finalized_td_66:
// 7c. Restore pointer to the next descriptor and return.
pop ebx
ret

// This procedure is called from uhci_process_updated_schedule,
// see comments there.
// It processes one list
// IN: esi -> UsbController, edi -> UsbStaticEp
// OUT: edi -> next head
// KEEP: esi, ebx
h_uhci_process_updated_list:
push ebx  // save used register to be stdcall
  // 1. Perform the external loop over all pipes.
  mov ebx, [es:edi + offset UsbStaticEp.next_virt]
  
  l_h_uhci_process_updated_list_15:
    cmp ebx, edi
    jz l_h_uhci_process_updated_list_8
      // store pointer to the next pipe in the stack
      push dword ptr [es:ebx + offset UsbStaticEp.next_virt]
        // 2. For every pipe, perform the internal loop over all descriptors.
        // All descriptors are organized in the queue// we process items from the start
        // of the queue until a) the last descriptor (not the part of the queue itself)
        // or b) an active (not yet processed by the hardware) descriptor is reached.
        lea ecx, [ebx + offset UsbPipe.lock]
        call p_mutex_lock
        
        mov ebx, [es:ebx + offset UsbPipe.last_td]
        push ebx
          mov ebx, [es:ebx + offset UsbGtd.next_virt]
          
          l_h_uhci_process_updated_list_25:
            // 3. For every descriptor, test active flag and check for end-of-queue;
            // if either of conditions holds, exit from the internal loop.
            cmp ebx, [ss:esp]
            jz l_h_uhci_process_updated_list_28
              mov eax, [es:ebx + offset UhciGtd.control_status - sizeof UhciGtd]
              test eax, 1 << 23   // active?
              jnz l_h_uhci_process_updated_list_28
                // Release the queue lock while processing one descriptor:
                // callback function could (and often would) schedule another transfer.
                push ecx
                  call p_mutex_unlock
                  call h_uhci_process_finalized_td
                pop ecx
                call p_mutex_lock
                jmp l_h_uhci_process_updated_list_25
          
          l_h_uhci_process_updated_list_28:
          call p_mutex_unlock
        pop ebx
        // End of internal loop, restore pointer to the next pipe
        // and continue the external loop.
      pop ebx
      jmp l_h_uhci_process_updated_list_15
      
  l_h_uhci_process_updated_list_8:
pop ebx  // restore used register to be stdcall
add edi, sizeof UhciStaticEp
ret

// This procedure is called in the USB thread from uhci_process_deferred
// when UHCI IRQ handler has signalled that new IOC-packet was processed.
// It scans all lists for completed packets and calls uhci_process_finalized_td
// for those packets.
// IN: esi -> UsbController
h_uhci_process_updated_schedule:
// Important note: we cannot hold the list lock during callbacks,
// because callbacks sometimes open and/or close pipes and thus acquire/release
// the corresponding lock itself.
// Fortunately, pipes can be finally freed only by another step of
// uhci_process_deferred, so all pipes existing at the start of this function
// will be valid while this function is running. Some pipes can be removed
// from the corresponding list, some pipes can be inserted// insert/remove
// functions guarantee that traversing one list yields all pipes that were in
// that list at the beginning of the traversing (possibly with some new pipes,
// possibly without some new pipes, that doesn't matter).
// 1. Process all Periodic lists.
lea edi, [esi + offset UhciController.int_eds - sizeof UhciController]
lea ebx, [esi + offset UhciController.int_eds + (63 * sizeof UhciStaticEp) - sizeof UhciController]

l_h_uhci_process_updated_schedule_5:
  call h_uhci_process_updated_list
  cmp edi, ebx
  jnz l_h_uhci_process_updated_schedule_5
  
// 2. Process the Control list.
call h_uhci_process_updated_list
// 3. Process the Bulk list.
call h_uhci_process_updated_list
ret

// This procedure is called from uhci_process_deferred when
// reset signalling for a port needs to be finished.
h_uhci_port_reset_done:
// 1. Stop reset signalling.
movzx ecx, byte ptr [es:esi + offset UsbController.resetting_port]
mov edx, [es:esi + offset UhciController.io_base - sizeof UhciController]
lea edx, [edx + ecx * 2 + UHCI_REG_PORT1STATUS]
in ax, dx
and ah, -1 - 2
out dx, ax
// 2. Status bits in UHCI are invalid during reset signalling.
// Wait a millisecond while status bits become valid again.
pushad
  mov ecx, 1
  call p_sleep
popad
// 3. ConnectStatus bit is zero during reset and becomes 1 during step 2//
// some controllers interpret this as a (fake) connect event.
// Enable port and clear status change notification.
in ax, dx
or al, 6   // enable port, clear status change
out dx, ax
// 4. Store the current time and set status to 2 = reset recovery active.
mov eax, tmr_usb_timerticks
mov [es:esi + offset UsbController.reset_time], eax
mov byte ptr [es:esi + offset UsbController.resetting_status], 2
ret

// This procedure is called from uhci_process_deferred when
// a new device has been reset, recovered after reset and
// needs to be configured.
// IN: esi -> usb_controller
h_uhci_port_init:
// 1. Read port status.
mov byte ptr [es:esi + offset UsbController.resetting_status], 0
movzx ecx, byte ptr [es:esi + offset UsbController.resetting_port]
mov edx, [es:esi + offset UhciController.io_base - sizeof UhciController]
lea edx, [edx + ecx * 2 + UHCI_REG_PORT1STATUS]
in ax, dx
// 2. If the device has been disconnected, stop the initialization.
test al, 1
jz near h_usb_test_pending_port

// 3. Copy LowSpeed bit to bit 0 of eax and call the worker procedure
// to notify the protocol layer about new UHCI device.
push edx
  mov al, ah
  call h_uhci_new_device
pop edx
test eax, eax
jnz l_h_uhci_port_init_9
  // 4. If something at the protocol layer has failed
  // (no memory, no bus address), disable the port and stop the initialization.
  in ax, dx
  and al, -1 - 4
  out dx, ax  // disable the port
  jmp h_usb_test_pending_port
  
l_h_uhci_port_init_9:
ret

// Select a list for a new pipe.
// IN: esi -> usb_controller
//     ecx = 2 * maximal interval = total number of periodic lists + 1
//     edx -> {u|o}hci_static_ep for the first list
//     eax -> byte past {u|o}hci_static_ep for the last list in the first group
// OUT: edx -> usb_static_ep for the selected list or zero if failed
h_uhci_select_interrupt_list:
/*
// inherit some variables from h_usb_open_pipe
virtual at ebp-12
ebp-12 speed
ebp-8 bandwidth
ebp-4 target
ebp+8 config_pipe
ebp+12 endpoint
ebp+16 maxpacket
ebp+20 type
ebp+24 interval
end virtual
*/

push ebx
 push edi  // save used registers to be stdcall
  push eax  // save eax for checks in step 3
    // 1. Only intervals 2^k ms can be supported.
    // The core specification says that the real interval should not be greater
    // than the interval given by the endpoint descriptor, but can be less.
    // Determine the actual interval as 2^k ms.
    mov eax, ecx
    // 1a. Set [.interval] to 1 if it was zero// leave it as is otherwise
    cmp dword ptr [es:ebp + 24], 1  // interval
    adc dword ptr [es:ebp + 24], 0  // interval
    // 1b. Divide ecx by two while it is strictly greater than [.interval].
    
    l_h_uhci_select_interrupt_list_15:
      shr ecx, 1
      cmp [es:ebp + 24], ecx  // interval
      jb l_h_uhci_select_interrupt_list_15
      
    // ecx = the actual interval
    //
    // For example, let ecx = 8, eax = 64.
    // The scheduler space is 32 milliseconds,
    // we need to schedule something every 8 ms//
    // there are 8 variants: schedule at times 0,8,16,24,
    // schedule at times 1,9,17,25,..., schedule at times 7,15,23,31.
    // Now concentrate: there are three nested loops,
    // * the innermost loop calculates the total periodic bandwidth scheduled
    //   in the given millisecond,
    // * the intermediate loop calculates the maximum over all milliseconds
    //   in the given variant, that is the quantity we're trying to minimize,
    // * the outermost loop checks all variants.
    
    // 2. Calculate offset between the first list and the first list for the
    // selected interval, in bytes; save in the stack for step 4.
    sub eax, ecx
    sub eax, ecx
    imul eax, sizeof UhciStaticEp
    push eax
      imul ebx, ecx, sizeof UhciStaticEp
      // 3. Select the best variant.
      // 3a. The outermost loop.
      // Prepare for the loop: set the current optimal bandwidth to maximum
      // possible value (so that any variant will pass the first comparison),
      // calculate delta for the intermediate loop.
      or dword ptr [es:ebp - 8], -1  // bandwidth
      
      l_h_uhci_select_interrupt_list_5:
        // 3b. The intermediate loop.
        // Prepare for the loop: set the maximum to be calculated to zero,
        // save counter of the outermost loop.
        xor edi, edi
        push edx
          /*
          virtual at esp
          .cur_variant    dd      ?       // step 3b
          .result_delta   dd      ?       // step 2
          .group1_limit   dd      ?       // function prolog
          end virtual
          */
          
          l_h_uhci_select_interrupt_list_calc_max_bandwidth:
          // 3c. The innermost loop. Sum over all lists.
          xor eax, eax
          push edx
            
            l_h_uhci_select_interrupt_list_calc_bandwidth:
            add eax, [es:edx + offset UhciStaticEp.software_part + offset UsbStaticEp.bandwidth]
            mov edx, [es:edx + offset UhciStaticEp.next_list]
            test edx, edx
            jnz l_h_uhci_select_interrupt_list_calc_bandwidth
            
          pop edx
          // 3d. The intermediate loop continued: update maximum.
          cmp eax, edi
          jb l_h_uhci_select_interrupt_list_56
            mov edi, eax
            
          l_h_uhci_select_interrupt_list_56:
          // 3e. The intermediate loop continued: advance counter.
          add edx, ebx
          cmp edx, [ss:esp + 8]  // group1_limit
          jb l_h_uhci_select_interrupt_list_calc_max_bandwidth
          
          // 3e. The intermediate loop done: restore counter of the outermost loop.
        pop edx
        // 3f. The outermost loop continued: if the current variant is
        // better (maybe not strictly) then the previous optimum, update
        // the optimal bandwidth and resulting list.
        cmp edi, [es:ebp - 8]  // bandwidth
        ja l_h_uhci_select_interrupt_list_57
          mov [es:ebp - 8], edi  // bandwidth
          mov [es:ebp - 4], edx  // target
          
        l_h_uhci_select_interrupt_list_57:
        // 3g. The outermost loop continued: advance counter.
        add edx, sizeof UhciStaticEp
        dec ecx
        jnz l_h_uhci_select_interrupt_list_5
        
      // 4. Calculate bandwidth for the new pipe.
      mov eax, [es:ebp + 16]  // maxpacket
      mov cl, [es:ebp - 12]  // speed
      mov ch, [es:ebp + 12]  // endpoint
      and ch, 80h
      call h_usb_calc_bandwidth
      // 5. Get the pointer to the best list.
    pop edx  // restore value from step 2
  pop ecx  // purge stack var from prolog
  add edx, [es:ebp - 4]  // target
  // 6. Check that bandwidth for the new pipe plus old bandwidth
  // still fits to maximum allowed by the core specification, 90% of 12000 bits.
  mov ecx, eax
  add ecx, [es:ebp - 8]  // bandwidth
  cmp ecx, 10800
  ja l_h_uhci_select_interrupt_list_no_bandwidth
    // 7. Convert {o|u}hci_static_ep to usb_static_ep, update bandwidth and return.
    add edx, offset UhciStaticEp.software_part
    add [es:edx + offset UsbStaticEp.bandwidth], eax
 pop edi
pop ebx  // restore used registers to be stdcall
ret
  
  l_h_uhci_select_interrupt_list_no_bandwidth:
  xor edx, edx
 pop edi
pop ebx  // restore used registers to be stdcall
ret

// Helper procedure for uhci_alloc_transfer. Allocates one packet.
// IN: ebx -> UsbPipe
h_uhci_alloc_packet:
/*
24 buffer:dword, 28 size:dword, 32 flags:dword, 36 td:dword, 40 direction:dword
20 ret_adr
16 token
12 origTD
8 packetSize
4 ret_adr
0 eax
*/

// 1. In UHCI all data for one packet must be on the same page.
// Thus, if the given buffer splits page boundary, we need a temporary buffer
// and code that transfers data between the given buffer and the temporary one.
xor eax, eax
cmp [ss:esp + 8 - 4], eax  // packetSize
jz near l_h_uhci_alloc_packet_notempbuf
 // 1b. A temporary buffer is not required if the first and the last bytes
 // of the given buffer are the same except lower 12 bits.
 mov edx, [ss:esp + 24 - 4]  // buffer
 add edx, [ss:esp + 8 - 4]  // packetSize
 dec edx
 xor edx, [ss:esp + 24 - 4]  // buffer
 test edx, -0x1000
 jz near l_h_uhci_alloc_packet_notempbuf
  // 1c. We need a temporary buffer. Allocate [packetSize]*2 bytes, so that
  // there must be [packetSize] bytes on one page,
  // plus space for a header UhciOriginalBuffer.
  mov ecx, [ss:esp + 8 - 4]  // packetSize
  add ecx, ecx
  add ecx, sizeof UhciOriginalBuffer
  push ebx
    call m_heap_alloc_kernel
    xchg eax, ebx
  pop ebx
  // 1d. If failed, return zero.
  test eax, eax
  jz near l_h_uhci_alloc_packet_9
  
  // 1e. Test whether [packetSize] bytes starting from
  // eax + sizeof.uhci_original_buffer are in the same page.
  // If so, use eax + sizeof.uhci_original_buffer as a temporary buffer.
  // Otherwise, use the beginning of the next page as a temporary buffer
  // (since we have overallocated, sufficient space must remain).
  lea ecx, [eax + sizeof UhciOriginalBuffer]
  mov edx, ecx
  add edx, [ss:esp + 8 - 4] // packetSize
  dec edx
  xor edx, ecx
  test edx, -0x1000
  jz l_h_uhci_alloc_packet_1
    mov ecx, eax
    or ecx, 0xFFF
    inc ecx
    
  l_h_uhci_alloc_packet_1:
  mov [es:eax + offset UhciOriginalBuffer.used_buffer], ecx
  mov ecx, [ss:esp + 24 - 4]  // buffer
  mov [es:eax + offset UhciOriginalBuffer.orig_buffer], ecx
  // 1f. For SETUP and OUT packets, copy data from the given buffer
  // to the temporary buffer now. For IN packets, data go in other direction
  // when the transaction completes.
  cmp byte ptr [ss:esp + 16 - 4], USB_PID_IN  // token
  jz l_h_uhci_alloc_packet_nocopy
    push esi
     push edi
      mov esi, ecx
      mov edi, [es:eax + offset UhciOriginalBuffer.used_buffer]
      mov ecx, [ss:esp + 8 + 4]  // packetSize
      mov edx, ecx
      shr ecx, 2
      and edx, 3
      push ds
        push es
        pop ds
        cld
        rep movsd
        mov ecx, edx
        rep movsb
      pop ds
     pop edi
    pop esi
    
  l_h_uhci_alloc_packet_nocopy:
l_h_uhci_alloc_packet_notempbuf:
// 2. Allocate the next TD.
push eax
  call h_uhci_alloc_gtd
pop edx
test eax, eax
jz near l_h_uhci_alloc_packet_fail
  // 3. Initialize controller-independent parts of both TDs.
  push edx
    
    call h_usb_init_transfer
    
    // 4. Initialize the next TD:
    // mark it as last one (this will be changed when further packets will be
    // allocated), copy Token field from uhci_pipe.Token zeroing bit 20,
    // generate ControlStatus field, mark as Active
    // (for last descriptor, this will be changed by uhci_insert_transfer),
    // zero OrigBufferInfo (otherwise uhci_free_td would try to free it).
    and dword ptr [es:eax + offset UhciGtd.orig_buffer_info - sizeof UhciGtd], 0
    mov dword ptr [es:eax + offset UhciGtd.next_td - sizeof UhciGtd], 1  // no next TD
    mov edx, [es:ebx + offset UhciPipe.token - sizeof UhciPipe]
    mov [es:eax + offset UhciGtd.token - sizeof UhciGtd], edx
    and byte ptr [es:eax + offset UhciGtd.token + 2 - sizeof UhciGtd], -1 - (1 << (20 - 16))
    and edx, 1 << 20
    shl edx, 6
    or edx, UHCI_INVALID_LENGTH + (1 << 23) + (3 << 27)
      // not processed, active, allow 3 errors
    mov [es:eax + offset UhciGtd.control_status - sizeof UhciGtd], edx
    // 5. Initialize remaining fields of the current TD.
    // 5a. Store pointer to the buffer allocated in step 1 (or zero).
  pop [es:ecx + offset UhciGtd.orig_buffer_info - sizeof UhciGtd]
  // 5b. Store physical address of the next TD.
  push eax
    sub eax, sizeof UhciGtd
    call h_usb_getphysadr
    // for Control/Bulk pipes, use Depth traversal unless this is the first TD
    // in the transfer stage;
    // uhci_insert_transfer will set Depth traversal for the first TD and clear
    // it in the last TD
    test byte ptr [es:ebx + offset UsbPipe.type], 1
    jnz l_h_uhci_alloc_packet_51
      cmp ecx, [es:ebx + offset UsbPipe.last_td]
      jz l_h_uhci_alloc_packet_51
        or eax, 4
        
    l_h_uhci_alloc_packet_51:
    mov [es:ecx + offset UhciGtd.next_td - sizeof UhciGtd], eax
    // 5c. Store physical address of the buffer: zero if no data present,
    // the temporary buffer if it was allocated, the given buffer otherwise.
    push ebx
      mov ebx, [ss:esp + 24 + 4]  // buffer
      call m_pages_getphysadr  // keep ecx
      xchg eax, ebx
    pop ebx
    mov [es:ecx + offset UhciGtd.buffer - sizeof UhciGtd], eax
    // 5d. For IN transfers, disallow short packets.
    // This will be overridden, if needed, by uhci_alloc_transfer.
    mov eax, [ss:esp + 16]  // token
    mov edx, [ss:esp + 8]  // packetSize
    dec edx
    cmp al, USB_PID_IN
    jnz l_h_uhci_alloc_packet_2
      or byte ptr [es:ecx + offset UhciGtd.control_status + 3 - sizeof UhciGtd], 1 << (29 - 24)  // disallow short packets
      or byte ptr [es:ecx + offset UhciGtd.orig_buffer_info - sizeof UhciGtd], 1
      
    l_h_uhci_alloc_packet_2:
    // 5e. Get Token field: combine [token] with [packetSize].
    shl edx, 21
    or edx, eax
    mov [es:ecx + offset UhciGtd.token - sizeof UhciGtd], edx
    // 6. Flip toggle bit in [token].
    xor eax, 1 << 19
    mov [ss:esp + 16], eax  // token
    // 7. Return pointer to the next TD.
  pop eax
  
  l_h_uhci_alloc_packet_9:
  ret
  
l_h_uhci_alloc_packet_fail:
push ebx
  mov ebx, edx
  mov ecx, [ss:esp + 8]  // packetSize
  add ecx, ecx
  add ecx, sizeof UhciOriginalBuffer
  call h_usb_free
pop ebx
xor eax, eax
ret

[align 32]
h_uhci_hardware_func:
dd 110h
dd 'UHCI'
dd sizeof UhciController
dd offset h_uhci_kickoff_bios
dd offset h_uhci_init
dd offset h_uhci_process_deferred
dd offset h_uhci_set_adr
dd offset h_uhci_get_adr
dd offset h_uhci_disable_port
dd offset h_uhci_new_port_reset
dd offset h_uhci_set_ep_packet_size
dd offset h_uhci_alloc_pipe
dd offset h_uhci_free_pipe
dd offset h_uhci_init_pipe
dd offset h_uhci_unlink_pipe
dd offset h_uhci_alloc_gtd
dd offset h_uhci_free_gtd
dd offset h_uhci_alloc_transfer
dd offset h_uhci_insert_transfer
dd offset h_uhci_new_device
dd offset h_uhci_disable_pipe
dd offset h_uhci_enable_pipe

h_uhci_name: db 'UHCI\0'

// IN: usb_ecx, usb_edx
// OUT: eax -> UsbController || 0
// KEEP: usb_ecx, usb_edx
h_uhci_init:
// alloc
mov ecx, sizeof UhciController + sizeof UsbController
call h_usb_alloc
xchg eax, ebx
push eax
  add eax, sizeof UhciController
  mov dword ptr [es:eax + offset UsbController.hardware_func], offset h_uhci_hardware_func + PA_KERNEL_CODE + VA_SYSTEM
  call h_usb_init_controller
pop eax
push eax
  mov edi, eax
  mov esi, eax
  // 2. Initialize uhci_controller.FrameList.
  // Note that FrameList is located in the beginning of uhci_controller,
  // so esi and edi now point to uhci_controller.FrameList.
  // First 32 entries of FrameList contain physical addresses
  // of first 32 Periodic static heads, further entries duplicate these.
  // See the description of structures for full info.
  // Note that all static heads fit in one page, so one call to
  // get_phys_addr is sufficient.
  //if (uhci_controller.IntEDs / 0x1000) <> (uhci_controller.BulkED / 0x1000)
  //.err assertion failed
  //end if
  // 2a. Get physical address of first static head.
  // Note that 1) it is located in the beginning of a page
  // and 2) all other static heads fit in the same page,
  // so one call to get_phys_addr without correction of lower 12 bits
  // is sufficient.
  //if (uhci_controller.IntEDs mod 0x1000) <> 0
  //.err assertion failed
  //end if
  add eax, offset UhciController.int_eds
  call h_usb_getphysadr  // assert eax % 4096 = 0
  // 2b. Fill first 32 entries.
  inc eax
  inc eax     // set QH bit for UhciPipe.next_qh
  mov ecx, 32
  mov edx, ecx
  
  l_h_uhci_init_15:
    stosd
    add eax, sizeof UhciStaticEp
    loop l_h_uhci_init_15
    
  // 2c. Fill the rest entries.
  mov ecx, 1024 - 32
  push ds
    push es
    pop ds
    cld
    rep movsd
  pop ds
  // 3. Initialize static heads uhci_controller.*ED.
  // Use the loop over groups: first group consists of first 32 Periodic
  // descriptors, next group consists of next 16 Periodic descriptors,
  // ..., last group consists of the last Periodic descriptor.
  // 3a. Prepare for the loop.
  // make esi point to the second group, other registers are already set.
  add esi, (32 * 4) + (32 * sizeof UhciStaticEp)
  // 3b. Loop over groups. On every iteration:
  // edx = size of group, edi = pointer to the current group,
  // esi = pointer to the next group, eax = physical address of the next group.
  
  l_h_uhci_init_25:
    // 3c. Get the size of next group.
    shr edx, 1
    // 3d. Exit the loop if there is no next group.
    jz l_h_uhci_init_28
      // 3e. Initialize the first half of the current group.
      // Advance edi to the second half.
      push eax
       push esi
        call h_uhci_init_static_ep_group
       pop esi
      pop eax
      // 3f. Initialize the second half of the current group
      // with the same values.
      // Advance edi to the next group, esi/eax to the next of the next group.
      call h_uhci_init_static_ep_group
      jmp l_h_uhci_init_25
      
  l_h_uhci_init_28:
  // 3g. Initialize the last static head.
  xor esi, esi
  call h_uhci_init_static_ep
  // 3i. Initialize the head of Control list.
  add eax, sizeof UhciStaticEp
  call h_uhci_init_static_ep
  // 3j. Initialize the head of Bulk list.
  sub eax, sizeof UhciStaticEp
  call h_uhci_init_static_ep

  // IRQ
pop esi
push esi
  add esi, sizeof UhciController
  sub esi, VA_USB
  //or esi, 0 << 24  // 0:UHCI
  mov ecx, usb_ecx
  mov edx, usb_edx
  mov dl, 3Ch  // IRQ
  call h_pci_get
  // IN: al = IRQ, esi = controller RA | (0:uhci, 1:ohci, 2:ehci << 24)
  call h_usb_irqs_init
pop esi
push esi
  
  // 4. Get I/O base address and size from PCI bus.
  // 4a. Read&save PCI command state.
  mov ecx, usb_ecx
  mov edx, usb_edx
  mov dl, 4
  call h_pci_get
  push eax
    // 4b. Disable IO access.
    and al, -2
    call h_pci_set
    // 4c. Read&save IO base address.
    mov dl, 20h  // BAR4
    call h_pci_get
    and al, -4
    xchg eax, edi  // edi = IO base
    mov [es:esi + offset UhciController.io_base], edi
    // 4d. Write 0xFFFF to IO base address.
    xor eax, eax
    dec eax
    call h_pci_set
    // 4e. Read IO base address.
    call h_pci_get
    and al, -4
    cwde
    not eax
    inc eax
    xchg eax, esi  // esi = IO size
    // 4f. Restore IO base address.
    mov eax, edi
    call h_pci_set
    // 4g. Restore PCI command state and enable io & bus master access.
  pop eax
  or al, 5
  mov dl, 4
  call h_pci_set
  // 5. Reset the controller.
  // 5e. Host reset.
  mov edx, edi
  mov ax, 2
  out dx, ax
  // 5f. Wait up to 10ms.
  mov ecx, 10
  
  l_h_uhci_init_55:
    pushad
      mov ecx, 1
      call p_sleep
    popad
    in ax, dx
    test al, 2
    loopnz  l_h_uhci_init_55
    
  jz l_h_uhci_init_6
    
    l_h_uhci_init_34:
    pop edi
    xor eax, eax
    
    ret
    
  l_h_uhci_init_6:
  // 6. Get number of ports & disable all ports.
  add esi, edi
  lea edx, [edi + UHCI_REG_PORT1STATUS]
  
  l_h_uhci_init_65:
    cmp edx, esi
    jnb l_h_uhci_init_68
      in ax, dx
      cmp ax, 0xFFFF
      jz l_h_uhci_init_68
        test al, al
        jns l_h_uhci_init_68
          xor eax, eax
          out dx, ax
          inc edx
          inc edx
          jmp short l_h_uhci_init_65
          
  l_h_uhci_init_68:
  lea esi, [edx - UHCI_REG_PORT1STATUS]
  sub esi, edi
  shr esi, 1  // esi = number of ports
  jz near l_h_uhci_init_34
  
  // 7. Setup the rest of uhci_controller.
  xchg esi, [ss:esp]  // restore the pointer to UhciController from the step 1
  add esi, sizeof UhciController
pop dword ptr [es:esi + offset UsbController.num_ports]
mov [es:esi + offset UhciController.io_base - sizeof UhciController], edi
mov eax, tmr_usb_timerticks  // GetTimerTicks
mov [es:esi + offset UhciController.last_poll_time - sizeof UhciController], eax
// 8. Find the EHCI companion.
// If there is one, check whether all ports are covered by that companion.
// Note: this assumes that EHCI is initialized before USB1 companions.
xor ebx, ebx
mov bh, byte ptr usb_ecx[1]
mov bl, byte ptr usb_ecx[0]
shl bl, 3
or bl, byte ptr usb_edx[1]
call h_usb_find_ehci_companion
mov [es:esi + offset UhciController.ehci_companion - sizeof UhciController], eax

// 10. Setup controller registers.
xor eax, eax
mov edx, [es:esi + offset UhciController.io_base - sizeof UhciController]
// 10a. UHCI_REG_STATUS := 3Fh: clear all status bits
// (for this register 1 clears the corresponding bit, 0 does not change it).
inc edx
inc edx     // UHCI_REG_STATUS == 2
mov al, 3Fh
out dx, ax
// 10b. UHCI_REG_INTERRUPT := 0Dh.
inc edx
inc edx     // UHCI_REG_INTERRUPT == 4
mov al, 0Dh
out dx, ax
// 10c. UHCI_REG_FRAMENUM := 0.
inc edx
inc edx     // UHCI_REG_FRAMENUM == 6
mov al, 0
out dx, ax
// 10d. UHCI_REG_BASEADR := physical address of UhciController.
inc edx
inc edx     // UHCI_REG_BASEADR == 8
lea eax, [esi - sizeof UhciController]
call h_usb_getphysadr
out dx, eax
// 10e. UHCI_REG_COMMAND := Run + Configured + (MaxPacket is 64 bytes)
sub edx, UHCI_REG_BASEADR // UHCI_REG_COMMAND == 0
mov ax, 0C1h        // Run, Configured, MaxPacket = 64b
out dx, ax
// 11. Do initial scan of existing devices.
call h_uhci_poll_roothub  // keep esi
push esi
  // set timer
  mov ecx, UHCI_POLL_INTERVAL * 10 * 1193
  mov edx, usb_thread
  shl edx, 16
  mov dx, WIN_NONE
  mov ebx, WP_NORMAL  // wp
  xor edi, edi
  call h_timer_add  
  // 12. Return pointer to UsbController.
pop eax
ret


// Helper procedure for step 3 of uhci_init.
// Initializes the static head of one list.
// IN: eax = physical address of the "next" list
//     esi = pointer to the "next" list,
//     edi = pointer to head to initialize.
// Advances edi to the next head, keeps eax/esi.
h_uhci_init_static_ep:
mov [es:edi + offset UhciStaticEp.next_qh], eax
mov byte ptr [es:edi + offset UhciStaticEp.head_td], 1
mov [es:edi + offset UhciStaticEp.next_list], esi
add edi, offset UhciStaticEp.software_part

mov [es:edi + offset UsbStaticEp.next_virt], edi
mov [es:edi + offset UsbStaticEp.prev_virt], edi

add edi, sizeof UhciStaticEp - offset UhciStaticEp.software_part
ret

 
// Helper procedure for step 3 of uhci_init, see comments there.
// Initializes one half of group of static heads.
// edx = size of the next group = half of size of the group,
// edi = pointer to the group, eax = physical address of the next group,
// esi = pointer to the next group.
// Advances eax, esi, edi to next group, keeps edx.
h_uhci_init_static_ep_group:
push edx
  
  l_h_uhci_init_5:
    call h_uhci_init_static_ep
    add eax, sizeof UhciStaticEp
    add esi, sizeof UhciStaticEp
    dec edx
    jnz l_h_uhci_init_5
    
pop edx
ret

h_uhci_irq_04:
ret

// IN: esi -> UsbController
h_uhci_irq:
// 1. Read UhciStatusReg.
mov edx, [es:esi + offset UhciController.io_base - sizeof UhciController]
inc edx
inc edx     // UHCI_REG_STATUS == 2
in ax, dx
// 2. Test whether it is our interrupt; if so, at least one status bit is set.
test al, 0x1F
jz h_uhci_irq_04
// 3. Clear all status bits.
out dx, ax
// 4. Sanity check.
test al, 0x3C
jnz h_uhci_irq_04
// 5. We can't do too much from an interrupt handler, e.g. we can't take
// any mutex locks since our code could be called when another code holds the
// lock and has no chance to release it. Thus, only inform the processing thread
// that it should scan the queue and wake it if needed.
lock or byte [es:esi + offset UhciController.deferred_actions - sizeof UhciController], al
// post message
// IN: ebx = winid:(threadid+16384), ecx = msg, edx = wp, esi = lp
// OUT: al = 0 || errorcode
mov ebx, usb_thread
mov ecx, WM_USB_INT
xor edx, edx
// esi -> UsbController
call p_msg_post
ret

// IN: usb_ecx, usb_edx
h_uhci_kickoff_bios:
// 1. Get the I/O address.
//mov edx, [es:esi + offset UhciController.io_base - sizeof UhciController]
mov ecx, usb_ecx
mov edx, usb_edx
mov dl, 20h
call h_pci_get
and eax, 0xFFFC
xchg eax, edx
// 2. Stop the controller and disable all interrupts.
in ax, dx
and al, -2
out dx, ax
add edx, UHCI_REG_INTERRUPT
xor eax, eax
out dx, ax
// 3. Disable all bits for SMI routing, clear SMI routing status,
// enable master interrupt bit.

mov edx, usb_edx

mov dl, 0C0h
call h_pci_get
mov ax, 0AF00h
call h_pci_set
ret

// This procedure is called from usb_set_address_callback
// and stores USB device address in the UhciPipe structure.
// IN: esi -> usb_controller, ebx -> usb_pipe, cl = address
h_uhci_set_adr:
mov byte ptr [es:ebx + offset UhciPipe.token + 1 - sizeof UhciPipe], cl
jmp h_usb_subscription_done

// This procedure returns USB device address from the UhciPipe structure.
// IN: esi -> usb_controller, ebx -> usb_pipe
// OUT: eax = endpoint address
h_uhci_get_adr:
mov al, byte ptr [es:ebx + offset UhciPipe.token + 1 - sizeof UhciPipe]
and eax, 7Fh
ret

// This procedure is called from usb_set_address_callback
// if the device does not accept SET_ADDRESS command and needs
// to be disabled at the port level.
// IN: esi -> UsbController, ecx = port (zero-based)
h_uhci_disable_port:
mov edx, [es:esi + offset UhciController.io_base - sizeof UhciController]
lea edx, [edx + UHCI_REG_PORT1STATUS + ecx * 2]
in ax, dx
and al, -1 - 4
out dx, ax
ret

// This procedure is called from usb_get_descr8_callback when
// the packet size for zero endpoint becomes known and
// stores the packet size in UhciPipe structure.
// IN: esi -> usb_controller, ebx -> usb_pipe, ecx = packet size
h_uhci_set_ep_packet_size:
dec ecx
shl ecx, 21
and dword ptr [es:ebx + offset UhciPipe.token - sizeof UhciPipe], (1 << 21) - 1
or [es:ebx + offset UhciPipe.token - sizeof UhciPipe], ecx
// UhciPipe.token field is purely for software bookkeeping and does not affect
// the hardware; thus, we can continue initialization immediately.
jmp h_usb_subscription_done

// This procedure is called from API usb_open_pipe and processes
// the controller-specific part of this API. See docs.
// IN: edi -> usb_pipe for target, ecx -> usb_pipe for config pipe,
//     esi -> usb_controller, eax -> usb_gtd for the first TD,
//     [ebp+12] = endpoint, [ebp+16] = maxpacket, [ebp+20] = type
// OUT: eax = PA UhciPipe
h_uhci_init_pipe:
/*
// inherit some variables from h_usb_open_pipe
virtual at ebp-12
ebp-12 speed
ebp-8 bandwidth
ebp-4 target
ebp+8 config_pipe
ebp+12 endpoint
ebp+16 maxpacket
ebp+20 type
ebp+24 interval
end virtual
*/

// 1. Initialize ErrorTD to zero.
and dword ptr [es:edi + offset UhciPipe.error_td - sizeof UhciPipe], 0
// 2. Initialize HeadTD to the physical address of the first TD.
push eax     // store pointer to the first TD for step 4
  sub eax, sizeof UhciGtd
  call h_usb_getphysadr
  mov [es:edi + offset UhciPipe.head_td - sizeof UhciPipe], eax
  // 3. Initialize Token field:
  // take DeviceAddress and LowSpeedDevice from the parent pipe,
  // take Endpoint and MaximumLength fields from API arguments,
  // set PID depending on pipe type and provided pipe direction,
  // set DataToggle to zero.
  mov eax, [es:ecx + offset UhciPipe.token - sizeof UhciPipe]
  and eax, 0x107F00   // keep DeviceAddress and LowSpeedDevice
  mov edx, [es:ebp + 12]  // endpoint
  and edx, 15
  shl edx, 15
  or eax, edx
  mov edx, [es:ebp + 16]  // maxpacket
  dec edx
  shl edx, 21
  or eax, edx
  mov al, USB_PID_SETUP
  cmp dword ptr [es:ebp + 20], CONTROL_PIPE  // type
  jz l_h_uhci_init_pipe_1
    mov al, USB_PID_OUT
    test byte ptr [es:ebp + 12], 80h  // endpoint
    jz l_h_uhci_init_pipe_1
      mov al, USB_PID_IN
      
  l_h_uhci_init_pipe_1:
  mov [es:edi + offset UhciPipe.token - sizeof UhciPipe], eax
  bt eax, 20
  setc byte ptr [es:ebp - 12]  // speed
  // 4. Initialize the first TD:
  // copy Token from uhci_pipe.Token zeroing reserved bit 20,
  // set ControlStatus for future transfers, bit make it inactive,
  // set bit 0 in NextTD = "no next TD",
  // zero OrigBufferInfo.
pop edx     // restore pointer saved in step 2
mov [es:edx + offset UhciGtd.token - sizeof UhciGtd], eax
and byte ptr [es:edx + offset UhciGtd.token + 2 - sizeof UhciGtd], -1 - (1 << (20 - 16))
and eax, 1 << 20
shl eax, 6
or eax, UHCI_INVALID_LENGTH + (3 << 27)  // not processed, inactive, allow 3 errors
and dword ptr [es:edx + offset UhciGtd.orig_buffer_info - sizeof UhciGtd], 0
mov [es:edx + offset UhciGtd.control_status - sizeof UhciGtd], eax
mov dword ptr [es:edx + offset UhciGtd.next_td - sizeof UhciGtd], 1
// 5. Select the corresponding list and insert to the list.
// 5a. Use Control list for control pipes, Bulk list for bulk pipes.
lea edx, [esi + offset UhciController.control_ed + offset UhciStaticEp.software_part - sizeof UhciController]
cmp dword ptr [es:ebp + 20], BULK_PIPE  // type
jb l_h_uhci_init_pipe_insert // control pipe
  lea edx, [esi + offset UhciController.bulk_ed + offset UhciStaticEp.software_part - sizeof UhciController]
  jz l_h_uhci_init_pipe_insert // bulk pipe
    
    // interrupt_pipe:
    // 5b. For interrupt pipes, let the scheduler select the appropriate list
    // based on the current bandwidth distribution and the requested bandwidth.
    // This could fail if the requested bandwidth is not available;
    // if so, return an error.
    lea edx, [esi + offset UhciController.int_eds - sizeof UhciController]
    lea eax, [esi + offset UhciController.int_eds + (32 * sizeof UhciStaticEp) - sizeof UhciController]
    mov ecx, 64
    mov ebx, sizeof UhciStaticEp
    call h_uhci_select_interrupt_list
    test edx, edx
    jz l_h_uhci_init_pipe_90
    
l_h_uhci_init_pipe_insert:
mov [es:edi + offset UsbPipe.base_list], edx
// Insert to the head of the corresponding list.
// Note: inserting to the head guarantees that the list traverse in
// uhci_process_updated_schedule, once started, will not interact with new pipes.
// However, we still need to ensure that links in the new pipe (edi.NextVirt)
// are initialized before links to the new pipe (edx.NextVirt).
// 5c. Insert in the list of virtual addresses.
mov ecx, [es:edx + offset UsbPipe.next_virt]
mov [es:edi + offset UsbPipe.next_virt], ecx
mov [es:edi + offset UsbPipe.prev_virt], edx
mov [es:ecx + offset UsbPipe.prev_virt], edi
mov [es:edx + offset UsbPipe.next_virt], edi
// 5d. Insert in the hardware list: copy previous NextQH to the new pipe,
// store the physical address of the new pipe to previous NextQH.
mov ecx, [es:edx + offset UhciStaticEp.next_qh - offset UhciStaticEp.software_part]
mov [es:edi + offset UhciPipe.next_qh - sizeof UhciPipe], ecx
lea eax, [edi - sizeof UhciPipe]
call h_usb_getphysadr
inc eax
inc eax
mov [es:edx + offset UhciStaticEp.next_qh - offset UhciStaticEp.software_part], eax
// 6. Return with nonzero eax.
ret

l_h_uhci_init_pipe_90:
xor eax, eax
ret

// This procedure is called from uhci_process_deferred when
// a new device was connected at least USB_CONNECT_DELAY ticks
// and therefore is ready to be configured.
// IN: esi -> usb_controller, ecx = port (zero-based)
h_uhci_new_port:
// test whether we are configuring another port
// if so, postpone configuring and return
bts dword ptr [es:esi + offset UsbController.pending_ports], ecx
cmp byte ptr [es:esi + offset UsbController.resetting_port], -1
jnz l_h_uhci_new_port_9
  btr dword ptr [es:esi + offset UsbController.pending_ports], ecx
  // fall through to uhci_new_port.reset
   
  // This function is called from uhci_new_port and uhci_test_pending_port.
  // It starts reset signalling for the port. Note that in USB first stages
  // of configuration can not be done for several ports in parallel.
  h_uhci_new_port_reset:
  // 1. Store information about resetting hub (roothub) and port.
  and dword ptr [es:esi + offset UsbController.resetting_hub], 0
  mov [es:esi + offset UsbController.resetting_port], cl
  // 2. Initiate reset signalling.
  mov edx, [es:esi + offset UhciController.io_base - sizeof UhciController]
  lea edx, [edx + ecx * 2 + UHCI_REG_PORT1STATUS]
  in ax, dx
  or ah, 2
  out dx, ax
  // 3. Store the current time and set status to 1 = reset signalling active.
  mov eax, tmr_usb_timerticks
  mov [es:esi + offset UsbController.reset_time], eax
  mov byte ptr[es:esi + offset UsbController.resetting_status], 1
  
l_h_uhci_new_port_9:
ret

// Allocates one general transfer descriptor structure for UHCI.
// Returns pointer to software part (UsbGtd) in eax.
// OUT: eax = new td va
// KEEP: ebx, ecx
h_uhci_alloc_gtd:
push ebx
 push ecx
  mov ecx, sizeof UhciGtd + sizeof UsbGtd
  call h_usb_alloc
  xchg eax, ebx
  test eax, eax
  jz l_h_uhci_alloc_td_9
    add eax, sizeof UhciGtd
    
  l_h_uhci_alloc_td_9:
 pop ecx
pop ebx
ret

// Free all memory associated with one TD.
// For UHCI, this includes memory for UhciGtd itself
// and the temporary buffer, if present.
// IN: stack UsbGtd
h_uhci_free_gtd:
mov eax, [ss:esp + 4]
mov eax, [es:eax + offset UhciGtd.orig_buffer_info - sizeof UhciGtd]
and eax, -1 - 1
jz l_h_uhci_free_gtd_nobuf
  xchg ebx, eax
  call m_heap_free_kernel
  
l_h_uhci_free_gtd_nobuf:
mov ebx, [ss:esp + 4]
sub ebx, sizeof UhciGtd
mov ecx, sizeof UhciGtd + sizeof UsbGtd
call h_usb_free
ret 4  // ret 4?

// This procedure is called in the USB thread from usb_thread,
// processes regular actions and those actions which can't be safely done
// from interrupt handler.
// Returns maximal time delta before the next call.
// IN: esi -> UsbController
h_uhci_process_deferred:
push ebx
 push edi  // save used registers to be stdcall
  // 1. Initialize the return value.
  push -1
    // 2. Poll the root hub every UHCI_POLL_INTERVAL ticks.
    // Also force polling if some transaction has completed with errors;
    // the error can be caused by disconnect, try to detect it.
    test byte ptr [es:esi + offset UhciController.deferred_actions - sizeof UhciController], 2
    jnz l_h_uhci_process_deferred_force_poll
      mov eax, tmr_usb_timerticks
      sub eax, [es:esi + offset UhciController.last_poll_time - sizeof UhciController]
      sub eax, UHCI_POLL_INTERVAL
      jl l_h_uhci_process_deferred_nopoll
      
    l_h_uhci_process_deferred_force_poll:
      mov eax, tmr_usb_timerticks
      mov [es:esi + offset UhciController.last_poll_time - sizeof UhciController], eax
      call h_uhci_poll_roothub
      mov eax, -UHCI_POLL_INTERVAL
      
    l_h_uhci_process_deferred_nopoll:
    neg eax
    cmp [ss:esp], eax
    jb l_h_uhci_process_deferred_2
      mov [ss:esp], eax
      
    l_h_uhci_process_deferred_2:
    // 3. Process wait lists.
    // 3a. Test whether there is a wait request.
    mov eax, [es:esi + offset UsbController.wait_pipe_request_async]
    cmp eax, [es:esi + offset UsbController.ready_pipe_head_async]
    jnz l_h_uhci_process_deferred_check_removed
      mov eax, [es:esi + offset UsbController.wait_pipe_request_periodic]
      cmp eax, [es:esi + offset UsbController.ready_pipe_head_periodic]
      jz l_h_uhci_process_deferred_31
      
    l_h_uhci_process_deferred_check_removed:
      // 3b. Yep. Find frame and compare it with the saved one.
      mov edx, [es:esi + offset UhciController.io_base - sizeof UhciController]
      add edx, UHCI_REG_FRAMENUM
      in ax, dx
      cmp word ptr [es:esi + offset UsbController.start_wait_frame], ax
      jnz     l_h_uhci_process_deferred_removed
        // 3c. The same frame; wake up in 0.01 sec.
        mov dword [ss:esp], 1
        jmp short l_h_uhci_process_deferred_31
        
      l_h_uhci_process_deferred_removed:
        // 3d. The frame is changed, old contents is guaranteed to be forgotten.
        mov eax, [es:esi + offset UsbController.wait_pipe_request_async]
        mov [es:esi + offset UsbController.ready_pipe_head_async], eax
        mov eax, [es:esi + offset UsbController.wait_pipe_request_periodic]
        mov [es:esi + offset UsbController.ready_pipe_head_periodic], eax
        
    l_h_uhci_process_deferred_31:
    // 4. Process disconnect events. This should be done after step 2
    // (which includes the first stage of disconnect processing).
    
    call h_usb_disconnect_stage2
    
    // 5. Test whether USB_CONNECT_DELAY for a connected device is over.
    // Call h_uhci_new_port for all such devices.
    xor ecx, ecx
    cmp [es:esi + offset UsbController.new_connected], ecx
    jz l_h_uhci_process_deferred_skip_newconnected
    
    l_h_uhci_process_deferred_35:
      bt [es:esi + offset UsbController.new_connected], ecx
      jnc l_h_uhci_process_deferred_nextport
        // If this port is shared with the EHCI companion and we see the connect event,
        // then the device is USB1 dropped by EHCI,
        // so EHCI has already waited for debounce delay, we can proceed immediately.
        cmp dword ptr [es:esi + offset UhciController.ehci_companion - sizeof UhciController], 0
        jnz l_h_uhci_process_deferred_connected
          mov eax, tmr_usb_timerticks
          sub eax, [es:esi + offset UsbController.connected_time + ecx * 4]
          sub eax, USB_CONNECT_DELAY
          jge l_h_uhci_process_deferred_connected
            neg eax
            cmp [ss:esp], eax
            jb l_h_uhci_process_deferred_nextport
              mov [ss:esp], eax
              jmp short l_h_uhci_process_deferred_nextport
        
        l_h_uhci_process_deferred_connected:
        btr [es:esi + offset UsbController.new_connected], ecx
        call h_uhci_new_port
        
      l_h_uhci_process_deferred_nextport:
      inc ecx
      cmp ecx, [es:esi + offset UsbController.num_ports]
      jb l_h_uhci_process_deferred_35
      
    l_h_uhci_process_deferred_skip_newconnected:
    // 6. Test for processed packets.
    // This should be done after step 4, so transfers which were failed due
    // to disconnect are marked with the exact reason, not just
    // 'device not responding'.
    xor eax, eax
    xchg al, [es:esi + offset UhciController.deferred_actions - sizeof UhciController]
    test al, 3
    jz l_h_uhci_process_deferred_noioc
      call h_uhci_process_updated_schedule
      
    l_h_uhci_process_deferred_noioc:
    // 7. Test whether reset signalling has been started. If so,
    // either should be stopped now (if time is over) or schedule wakeup (otherwise).
    // This should be done after step 6, because a completed SET_ADDRESS command
    // could result in reset of a new port.
    l_h_uhci_process_deferred_test_reset:
      // 7a. Test whether reset signalling is active.
      cmp byte ptr [es:esi + offset UsbController.resetting_status], 1
      jnz l_h_uhci_process_deferred_no_reset_in_progress
        // 7b. Yep. Test whether it should be stopped.
        mov eax, tmr_usb_timerticks
        sub eax, [es:esi + offset UsbController.reset_time]
        sub eax, USB_RESET_TIME
        jge l_h_uhci_process_deferred_reset_done
          // 7c. Not yet, but initiate wakeup in -eax ticks and exit this step.
          neg eax
          cmp [ss:esp], eax
          jb l_h_uhci_process_deferred_skip_reset
            mov [ss:esp], eax
            jmp l_h_uhci_process_deferred_skip_reset
            
        l_h_uhci_process_deferred_reset_done:
        // 7d. Yep, call the worker function and proceed to 7e.
        call h_uhci_port_reset_done
        
      l_h_uhci_process_deferred_no_reset_in_progress:
      // 7e. Test whether reset process is done, either successful or failed.
      cmp byte ptr [es:esi + offset UsbController.resetting_status], 0
      jz l_h_uhci_process_deferred_skip_reset
        // 7f. Yep. Test whether it should be stopped.
        mov eax, tmr_usb_timerticks
        sub eax, [es:esi + offset UsbController.reset_time]
        sub eax, USB_RESET_RECOVERY_TIME
        jge l_h_uhci_process_deferred_reset_recovery_done
          // 7g. Not yet, but initiate wakeup in -eax ticks and exit this step.
          neg eax
          cmp [ss:esp], eax
          jb l_h_uhci_process_deferred_skip_reset
            mov [ss:esp], eax
            jmp l_h_uhci_process_deferred_skip_reset
          
        l_h_uhci_process_deferred_reset_recovery_done:
        // 7h. Yep, call the worker function. This could initiate another reset,
        // so return to the beginning of this step.
        call h_uhci_port_init
        jmp l_h_uhci_process_deferred_test_reset
        
    l_h_uhci_process_deferred_skip_reset:
    // 8. Process wait-done notifications, test for new wait requests.
    // Note: that must be done after steps 4 and 6 which could create new requests.
    // 8a. Call the worker function.
    
    call h_usb_process_wait_lists
    
    // 8b. If no new requests, skip the rest of this step.
    test eax, eax
    jz l_h_uhci_process_deferred_8
      // 8c. UHCI is not allowed to cache anything; we don't know what is
      // processed right now, but we can be sure that the controller will not
      // use any removed structure starting from the next frame.
      // Request removal of everything disconnected until now,
      // schedule wakeup in 0.01 sec.
      mov eax, [es:esi + offset UsbController.wait_pipe_list_async]
      mov [es:esi + offset UsbController.wait_pipe_request_async], eax
      mov eax, [es:esi + offset UsbController.wait_pipe_list_periodic]
      mov [es:esi + offset UsbController.wait_pipe_request_periodic], eax
      mov edx, [es:esi + offset UhciController.io_base - sizeof UhciController]
      add edx, UHCI_REG_FRAMENUM
      in ax, dx
      mov word ptr [es:esi + offset UsbController.start_wait_frame], ax
      mov dword ptr [ss:esp], 1
      
    l_h_uhci_process_deferred_8:
    // 9. Return the value from the top of stack.
  pop eax
 pop edi
pop ebx  // restore used registers to be stdcall.
ret

// Allocates one endpoint structure for OHCI.
// Returns pointer to software part (UsbPipe) in eax.
h_uhci_alloc_pipe:
push ebx
 push ecx
  mov ecx, sizeof UhciPipe + sizeof UsbPipe
  call h_usb_alloc
  xchg eax, ebx
  test eax, eax
  jz l_h_uhci_alloc_pipe_6
    add eax, sizeof UhciPipe
    
  l_h_uhci_alloc_pipe_6:
 pop ecx
pop ebx
ret

// Free memory associated with pipe.
// For UHCI, this includes usb_pipe structure and ErrorTD, if present.
// IN: stack UsbPipe
h_uhci_free_pipe:
mov eax, [ss:esp + 4]
mov eax, [es:eax + offset UhciPipe.error_td - sizeof UhciPipe]
test eax, eax
jz l_h_uhci_free_pipe_1
  push eax
  call h_uhci_free_gtd
  
l_h_uhci_free_pipe_1:
mov ebx, [ss:esp + 4]
sub ebx, sizeof UhciPipe
mov ecx, sizeof UhciPipe + sizeof UsbPipe
call h_usb_free
ret 4  // ret 4?

// This procedure is called when a pipe is closing (either due to API call
// or due to disconnect); it unlinks a pipe from the corresponding list.
// IN: ebx -> UsbPipe

//if uhci_static_ep.SoftwarePart <> sizeof.uhci_pipe
//.err uhci_unlink_pipe assumes that uhci_static_ep.SoftwarePart == sizeof.uhci_pipe
//end if
h_uhci_unlink_pipe:
cmp dword ptr [es:ebx + offset UsbPipe.type], INTERRUPT_PIPE
jnz l_h_uhci_unlink_pipe_9
  mov eax, [es:ebx + offset UhciPipe.token - sizeof UhciPipe]
  cmp al, USB_PID_IN
  setz ch
  bt eax, 20
  setc cl
  add eax, 1 << 21
  shr eax, 21
  
  push ecx
   push eax
  call h_usb_interrupt_list_unlink
  
l_h_uhci_unlink_pipe_9:
ret

// This procedure is called from the several places in main USB code
// and allocates required packets for the given transfer stage.
// IN: ebx -> UsbPipe
h_uhci_alloc_transfer:
// 16 buffer:dword, 20 size:dword, 24 flags:dword, 28 td:dword, 32 direction:dword
/*
12 ret_adr
8 token
4 origTD
0 packetSize  // must be the last variable, see h_usb_init_transfer
*/
sub esp, 12

// 1. [td] will be the first packet in the transfer.
// Save it to allow unrolling if something will fail.
mov eax, [ss:esp + 28]  // td
mov [ss:esp + 4], eax  // origTD
// In UHCI one TD describes one packet, transfers should be split into parts
// with size <= endpoint max packet size.
// 2. Get the maximum packet size for endpoint from uhci_pipe.Token
// and generate Token field for TDs.
mov edi, [es:ebx + offset UhciPipe.token - sizeof UhciPipe]
mov eax, edi
shr edi, 21
inc edi
// zero packet size (it will be set for every packet individually),
// zero reserved bit 20,
and eax, (1 << 20) - 1
mov [ss:esp + 0], edi  // packetSize
// set the correct PID if it is different from the pipe-wide PID
// (Data and Status stages of control transfers)
mov ecx, [ss:esp + 32]  // direction
and ecx, 3
jz l_h_uhci_alloc_transfer_1
  mov al, USB_PID_OUT
  dec ecx
  jz l_h_uhci_alloc_transfer_1
    mov al, USB_PID_IN
    
l_h_uhci_alloc_transfer_1:
// set the toggle bit for control transfers
mov ecx, [ss:esp + 32]  // direction
test cl, 1 << 3
jz l_h_uhci_alloc_transfer_2
  and ecx, 1 << 2
  and eax, -1 - (1 << 19)
  shl ecx, 19 - 2
  or eax, ecx
  
l_h_uhci_alloc_transfer_2:
// store the resulting Token in the stack variable.
mov [ss:esp + 8], eax  // token
// 3. While the remaining data cannot fit in one packet,
// allocate full packets (of maximal possible size).
l_h_uhci_alloc_transfer_fullpackets:
  cmp [ss:esp + 20], edi  // size
  jna l_h_uhci_alloc_transfer_lastpacket
    call h_uhci_alloc_packet  // keep edi
    test eax, eax
    jz l_h_uhci_alloc_transfer_fail
      mov [ss:esp + 28], eax  // td
      add [ss:esp + 16], edi  // buffer
      sub [ss:esp + 20], edi  // size
      jmp short l_h_uhci_alloc_transfer_fullpackets
      
l_h_uhci_alloc_transfer_lastpacket:
// 4. The remaining data can fit in one packet;
// allocate the last packet with size = size of remaining data.
mov eax, [ss:esp + 20]  // size
mov [ss:esp + 0], eax  // packetSize
call h_uhci_alloc_packet
test eax, eax
jz l_h_uhci_alloc_transfer_fail

// 5. Clear 'short packets are not allowed' bit for the last packet,
// if the caller requested this.
// Note: even if the caller says that short transfers are ok,
// all packets except the last one are marked as 'must be complete':
// if one of them will be short, the software intervention is needed
// to skip remaining packets; uhci_process_finalized_td will handle this
// transparently to the caller.
test byte ptr [ss:esp + 24], 1  // flags
jz l_h_uhci_alloc_transfer_3
  and byte ptr [es:ecx + offset UhciGtd.control_status + 3 - sizeof UhciGtd], -1 - (1 << (29 - 24))
  and byte ptr [es:ecx + offset UhciGtd.orig_buffer_info - sizeof UhciGtd], -1 - 1
  
l_h_uhci_alloc_transfer_3:
// 6. Update toggle bit in uhci_pipe structure from current value of [token].
mov edx, [ss:esp + 8]  // token
xor edx, [es:ebx + offset UhciPipe.token - sizeof UhciPipe]
and edx, 1 << 19
xor [es:ebx + offset UhciPipe.token - sizeof UhciPipe], edx

add esp, 12
ret 20


l_h_uhci_alloc_transfer_fail:
mov esi, [es:ebx + offset UsbPipe.controller]
mov edi, [es:esi + offset UsbController.hardware_func]
mov eax, [ss:esp + 28]  // td
push dword ptr [ss:esp + 4]  // origTD
call h_usb_undo_tds
xor eax, eax

add esp, 12
ret 20

// This procedure is called from the several places in main USB code
// and activates the transfer which was previously allocated by
// h_uhci_alloc_transfer.
// IN: eax -> UsbGtd, ecx -> last descriptor for the transfer, ebx -> UsbPipe
//     [ss:esp + 4] -> UsbGtd
h_uhci_insert_transfer:
and byte ptr [es:eax + offset UhciGtd.control_status + 2 - sizeof UhciGtd], 255 - (1 << (23 - 16))  // clear Active bit
or byte ptr [es:ecx + offset UhciGtd.control_status + 3 - sizeof UhciGtd], 1 << (24 - 24)  // set InterruptOnComplete bit
mov eax, [ss:esp + 4]
or byte ptr [es:eax + offset UhciGtd.control_status + 2 - sizeof UhciGtd], 1 << (23 - 16)  // set Active bit
test byte ptr [es:ebx + offset UsbPipe.type], 1
jnz l_h_uhci_insert_transfer_9
  or byte ptr [es:eax + offset UhciGtd.next_td - sizeof UhciGtd], 4  // set Depth bit
  
l_h_uhci_insert_transfer_9:
ret

// This procedure is called from uhci_port_init and from hub support code
// when a new device is connected and has been reset.
// It calls h_usb_new_device at the protocol layer with correct parameters.
// IN: esi -> UsbController, eax = speed
// UHCI is USB1 device, so only low bit of eax (LowSpeed) is used.
h_uhci_new_device:
// 1. Clear all bits of speed except bit 0.
and eax, 1
// 2. Store the speed for the protocol layer.
mov [es:esi + offset UsbController.resetting_speed], al
// 3. Create pseudo-pipe in the stack.
// See uhci_init_pipe: only .Controller and .Token fields are used.
push esi     // fill .Controller field
  mov ecx, esp
  shl eax, 20 // bit 20 = LowSpeedDevice
  push eax     // ignored (ErrorTD)
    push eax     // .Token field: DeviceAddress is zero, bit 20 = LowSpeedDevice
      // 4. Notify the protocol layer.
      call h_usb_new_device
      
// 5. Cleanup the stack after step 3 and return.
add esp, 12
ret

// This procedure temporarily removes the given pipe from hardware queue,
// keeping it in software lists.
// IN: esi -> UsbController, ebx -> UsbPipe
h_uhci_disable_pipe:
mov eax, [es:ebx + offset UhciPipe.next_qh - sizeof UhciPipe]
mov edx, [es:ebx + offset UsbPipe.prev_virt]
// Note: edx could be either UsbPipe or UsbStaticEp;
// fortunately, next_qh and software_part have same offsets in both.
mov [es:edx + offset UhciPipe.next_qh - sizeof UhciPipe], eax
ret

// This procedure reinserts the given pipe from hardware queue
// after ehci_disable_pipe, with clearing transfer queue.
// IN: esi -> UsbController, ebx -> UsbPipe
//     edx -> current descriptor, eax -> new last descriptor
h_uhci_enable_pipe:
// 1. Copy DataToggle bit from edx to pipe.
mov ecx, [es:edx + offset UhciGtd.token - sizeof UhciGtd]
xor ecx, [es:ebx + offset UhciPipe.token - sizeof UhciPipe]
and ecx, 1 << 19
xor [es:ebx + offset UhciPipe.token - sizeof UhciPipe], ecx
// 2. Store new last descriptor as the current HeadTD.
sub eax, sizeof UhciGtd
call h_usb_getphysadr
mov [es:ebx + offset UhciPipe.head_td - sizeof UhciPipe], eax
// 3. Reinsert the pipe to hardware queue.
lea eax, [ebx - sizeof UhciPipe]
call h_usb_getphysadr
inc eax
inc eax
mov edx, [es:ebx + offset UsbPipe.prev_virt]
mov ecx, [es:edx + offset UhciPipe.next_qh - sizeof UhciPipe]
mov [es:ebx + offset UhciPipe.next_qh - sizeof UhciPipe], ecx
mov [es:edx + offset UhciPipe.next_qh - sizeof UhciPipe], eax
ret

// control and status registers
OHCI_REG_REVISION = 0
OHCI_REG_CONTROL = 4
OHCI_REG_COMMANDSTATUS = 8
OHCI_REG_INTERRUPTSTATUS = 0Ch
OHCI_REG_INTERRUPTENABLE = 10h
OHCI_REG_INTERRUPTDISABLE = 14h

// memory pointer registers
OHCI_REG_HCCA = 18h
OHCI_REG_PERIODCURED = 1Ch
OHCI_REG_CONTROLHEADED = 20h
OHCI_REG_CONTROLCURED = 24h
OHCI_REG_BULKHEADED = 28h
OHCI_REG_BULKCURED = 2Ch
OHCI_REG_DONEHEAD = 30h

// frame counter registers
OHCI_REG_FMINTERVAL = 34h
OHCI_REG_FMREMAINING = 38h
OHCI_REG_FMNUMBER = 3Ch
OHCI_REG_PERIODICSTART = 40h
OHCI_REG_LSTRESHOLD = 44h

// root hub registers
OHCI_REG_RHA = 48h
OHCI_REG_RHB = 4Ch
OHCI_REG_RHSTATUS = 50h
OHCI_REG_RHPORTSTATUS = 54h

struct OhciPipe{
  // All addresses are physical. Must be 16 B aligned.
  uns4 flags
  // 1. Lower 7 bits (bits 0-6) are FunctionAddress. This is the USB address of
  //    the function containing the endpoint that this ED controls.
  // 2. Next 4 bits (bits 7-10) are EndpointNumber. This is the USB address of
  //    the endpoint within the function.
  // 3. Next 2 bits (bits 11-12) are Direction. This 2-bit field indicates the
  //    direction of data flow: 1 = OUT, 2 = IN. If neither IN nor OUT is
  //    specified, then the direction is determined from the PID field of the TD.
  //    For CONTROL endpoints, the transfer direction is different
  //    for different transfers, so the value of this field is 0
  //    (3 would have the same effect) and the actual direction
  //    of one transfer is encoded in the Transfer Descriptor.
  // 4. Next bit (bit 13) is Speed bit. It indicates the speed of the endpoint:
  //    full-speed (S = 0) or low-speed (S = 1).
  // 5. Next bit (bit 14) is sKip bit. When this bit is set, the hardware
  //    continues on to the next ED on the list without attempting access
  //    to the TD queue or issuing any USB token for the endpoint.
  //    Always cleared.
  // 6. Next bit (bit 15) is Format bit. It must be 0 for Control, Bulk and
  //    Interrupt endpoints and 1 for Isochronous endpoints.
  // 7. Next 11 bits (bits 16-26) are MaximumPacketSize. This field indicates
  //    the maximum number of bytes that can be sent to or received from the
  //    endpoint in a single data packet.
  uns4 tail_p
  // Physical address of the tail descriptor in the TD queue.
  // The descriptor itself is not in the queue. See also HeadP.
  uns4 head_p
  // 1. First bit (bit 0) is Halted bit. This bit is set by the hardware to
  //    indicate that processing of the TD queue on the endpoint is halted.
  // 2. Second bit (bit 1) is toggleCarry bit. Whenever a TD is retired, this
  //    bit is written to contain the last data toggle value from the retired TD.
  // 3. Next two bits (bits 2-3) are reserved and always zero.
  // 4. With masked 4 lower bits, this is HeadP itself: physical address of the
  //    head descriptor in the TD queue, that is, next TD to be processed for this
  //    endpoint. Note that a TD must be 16-bytes aligned.
  //    Empty queue is characterized by the condition HeadP == TailP.
  uns4 next_ed
  // If nonzero, then this entry is a physical address of the next ED to be
  // processed. See also the description before NextVirt field of the usb_pipe
  // structure. Additionally to that description, the following is specific for
  // the OHCI controller:
  // * n=5, N=32, there are 32 "leaf" periodic lists.
  // * The 1ms periodic list also serves Isochronous endpoints, which should be
  //   in the end of the list.
  // * There is no "next" list for Bulk and Control lists, they are processed
  //   separately from others.
  // * There is no "next" list for Periodic list for 1ms interval.
}

struct OhciStaticEp{  // Must be 16 B aligned
  // same as OhciPipe.flags
  // sKip bit is set, so the hardware ignores other fields except NextED
  uns4 flags
  // corresponds to OhciPipe.tail_p, not used
  uns4 rsv1
  // virtual address of the next list
  uns4 next_list
  // same as OhciPipe.next_ed
  uns4 next_ed
  // software part, common for all controllers
  uns4 software_part[sizeof UsbStaticEp/4], rsv2 // padding for 16 B alignment
}

struct OhciController{
  // must be 4096 aligned !!!
  
  // * HARDWARE FIELDS *
  
  // Pointers to interrupt EDs. The hardware starts processing of periodic lists
  // within the frame N from the ED pointed to by [InterruptTable+(N and 31)*4].
  // See also the description of periodic lists inside ohci_pipe structure
  uns4 interrupt_table[32]
  // The current frame number. This field is written by hardware only.
  // This field is read by ohci_process_deferred and ohci_irq to
  // communicate when control/bulk processing needs to be temporarily
  // stopped/restarted
  uns2 frame_number, padding
  // Physical pointer to the start of Done Queue.
  // When the hardware updates this field, it sets bit 0 to one if there is
  // unmasked interrupt pending
  uns4 done_head
  // Reserved for the hardware
  uns1 hw[120]
  
  // * SOFTWARE FIELDS *
  
  // heads of 63 Periodic lists, see the description in UsbPipe
  OhciStaticEp int_eds[63]
  // head of Control list, see the description in UsbPipe
  OhciStaticEp control_ed
  // head of Bulk list, see the description in UsbPipe
  OhciStaticEp bulk_ed
  // virtual address of memory-mapped area with OHCI registers OHCI_REG_*
  uns4 mmio_base
  // 1 in normal work, 0 during early phases of the initialization.
  // This field is initialized to zero during memory allocation
  // (see usb_init_controller), set to one by ohci_init when ports of the
  // root hub are powered up, so connect/disconnect events can be handled
  uns1 powered, rsv1[3]
  // list of descriptors which were processed by the controller and now need
  // to be finalized
  uns4 done_list
  // pointer to dword which should receive a pointer to the next item in
  // done_list. If done_list is empty, this is a pointer to DoneList itself
  // otherwise, this is a pointer to next_td field of the last item in done_list
  uns4 done_list_end_p
  // pointer to UsbController for EHCI, if any, or NULL
  uns4 ehci_companion
}

struct OhciGtd{
  
  // * HARDWARE FIELDS *
  
  // all addresses in this part are physical
  uns4 flags
  // 1. Lower 18 bits (bits 0-17) are ignored and not modified by the hardware.
  // 2. Next bit (bit 18) is bufferRounding bit. If this bit is 0, then the last
  //    data packet must exactly fill the defined data buffer. If this bit is 1,
  //    then the last data packet may be smaller than the defined buffer without
  //    causing an error condition on the TD.
  // 3. Next 2 bits (bits 19-20) are Direction field. This field indicates the
  //    direction of data flow. If the Direction field in the ED is OUT or IN,
  //    this field is ignored and the direction from the ED is used instead.
  //    Otherwise, 0 = SETUP, 1 = OUT, 2 = IN, 3 is reserved.
  // 4. Next 3 bits (bits 21-23) are DelayInterrupt field. This field contains
  //    the interrupt delay count for this TD. When a TD is complete, the hardware
  //    may wait up to DelayInterrupt frames before generating an interrupt.
  //    If DelayInterrupt is 7 (maximum possible), then there is no interrupt
  //    associated with completion of this TD.
  // 5. Next 2 bits (bits 24-25) are DataToggle field. This field is used to
  //    generate/compare the data PID value (DATA0 or DATA1). It is updated after
  //    each successful transmission/reception of a data packet. The bit 25
  //    is 0 when the data toggle value is acquired from the toggleCarry field in
  //    the ED and 1 when the data toggle value is taken from the bit 24.
  // 6. Next 2 bits (bits 26-27) are ErrorCount field. For each transmission
  //    error, this value is incremented. If ErrorCount is 2 and another error
  //    occurs, the TD is retired with error. When a transaction completes without
  //    error, ErrorCount is reset to 0.
  // 7. Upper 4 bits (bits 28-31) are ConditionCode field. This field contains
  //    the status of the last attempted transaction, one of USB_STATUS_* values.
  uns4 cur_buf_ptr
  // Physical address of the next memory location that will be accessed for
  // transfer to/from the endpoint. 0 means zero-length data packet or that all
  // bytes have been transferred.
  uns4 next_td
  // This field has different meanings depending on the status of the descriptor.
  // When the descriptor is queued for processing, but not yet processed:
  //   Physical address of the next TD for the endpoint.
  // When the descriptor is processed by hardware, but not yet by software:
  //   Physical address of the previous processed TD.
  // When the descriptor is processed by the IRQ handler, but not yet completed:
  //   Virtual pointer to the next processed TD.
  uns4 buf_end
  // Physical address of the last byte in the buffer for this TD.
  uns4 rsv1  // padding to align with uhci_gtd
}

struct OhciItd{
  uns2 starting_frame
  // This field contains the low order 16 bits of the frame number in which the
  // first data packet of the Isochronous TD is to be sent.
  uns2 flags
  // 1. Lower 5 bits (bits 0-4) are ignored and not modified by the hardware.
  // 2. Next 3 bits (bits 5-7) are DelayInterrupt field.
  // 3. Next 3 bits (bits 8-10) are FrameCount field. The TD describes
  //    FrameCount+1 data packets.
  // 4. Next bit (bit 11) is ignored and not modified by the hardware.
  // 5. Upper 4 bits (bits 12-15) are ConditionCode field. This field contains
  //    the completion code, one of USB_STATUS_* values, when the TD is moved to
  //    the Done Queue.
  uns4 buf_page0
  // Lower 12 bits are ignored and not modified by the hardware.
  // With masked 12 bits this field is the physical page containing all buffers
  uns4 next_td
  // physical address of the next TD in the transfer queue
  uns4 buf_end
  // physical address of the last byte in the buffer
  uns2 offset_array[8]
  // Initialized by software, read by hardware: Offset for packet 0..7.
  // Used to determine size and starting address of an isochronous data packet.
  // Written by hardware, read by software: PacketStatusWord for packet 0..7.
  // Contains completion code and, if applicable, size received for an isochronous
  // data packet
}

[dalign 32]
uns4 ohci_gtd_first_page

// Select a list for a new pipe.
// IN: esi -> usb_controller
//     ecx = 2 * maximal interval = total number of periodic lists + 1
//     edx -> {u|o}hci_static_ep for the first list
//     eax -> byte past {u|o}hci_static_ep for the last list in the first group
//     [ebp+12] = endpoint, [ebp+16] = maxpacket, [ebp+20] = type, [ebp+24] = interval
// OUT: edx -> usb_static_ep for the selected list or zero if failed
h_ohci_select_interrupt_list:
/*
// inherit some variables from h_usb_open_pipe
virtual at ebp-12
ebp-12 speed
ebp-8 bandwidth
ebp-4 target
ebp+8 config_pipe
ebp+12 endpoint
ebp+16 maxpacket
ebp+20 type
ebp+24 interval
end virtual
*/

push ebx
 push edi  // save used registers to be stdcall
  push eax  // save eax for checks in step 3
    // 1. Only intervals 2^k ms can be supported.
    // The core specification says that the real interval should not be greater
    // than the interval given by the endpoint descriptor, but can be less.
    // Determine the actual interval as 2^k ms.
    mov eax, ecx
    // 1a. Set [.interval] to 1 if it was zero// leave it as is otherwise
    cmp dword ptr [es:ebp + 24], 1  // interval
    adc dword ptr [es:ebp + 24], 0  // interval
    // 1b. Divide ecx by two while it is strictly greater than [.interval].
    
    l_h_ohci_select_interrupt_list_15:
      shr ecx, 1
      cmp [es:ebp + 24], ecx  // interval
      jb l_h_ohci_select_interrupt_list_15
      
    // ecx = the actual interval
    //
    // For example, let ecx = 8, eax = 64.
    // The scheduler space is 32 milliseconds,
    // we need to schedule something every 8 ms//
    // there are 8 variants: schedule at times 0,8,16,24,
    // schedule at times 1,9,17,25,..., schedule at times 7,15,23,31.
    // Now concentrate: there are three nested loops,
    // * the innermost loop calculates the total periodic bandwidth scheduled
    //   in the given millisecond,
    // * the intermediate loop calculates the maximum over all milliseconds
    //   in the given variant, that is the quantity we're trying to minimize,
    // * the outermost loop checks all variants.
    
    // 2. Calculate offset between the first list and the first list for the
    // selected interval, in bytes; save in the stack for step 4.
    sub eax, ecx
    sub eax, ecx
    imul eax, sizeof OhciStaticEp
    push eax
      imul ebx, ecx, sizeof OhciStaticEp
      // 3. Select the best variant.
      // 3a. The outermost loop.
      // Prepare for the loop: set the current optimal bandwidth to maximum
      // possible value (so that any variant will pass the first comparison),
      // calculate delta for the intermediate loop.
      or dword ptr [es:ebp - 8], -1  // bandwidth
      
      l_h_ohci_select_interrupt_list_5:
        // 3b. The intermediate loop.
        // Prepare for the loop: set the maximum to be calculated to zero,
        // save counter of the outermost loop.
        xor edi, edi
        push edx
          /*
          virtual at esp
          .cur_variant    dd      ?       // step 3b
          .result_delta   dd      ?       // step 2
          .group1_limit   dd      ?       // function prolog
          end virtual
          */
          
          l_h_ohci_select_interrupt_list_calc_max_bandwidth:
          // 3c. The innermost loop. Sum over all lists.
          xor eax, eax
          push edx
            
            l_h_ohci_select_interrupt_list_calc_bandwidth:
            add eax, [es:edx + offset OhciStaticEp.software_part + offset UsbStaticEp.bandwidth]
            mov edx, [es:edx + offset OhciStaticEp.next_list]
            test edx, edx
            jnz l_h_ohci_select_interrupt_list_calc_bandwidth
            
          pop edx
          // 3d. The intermediate loop continued: update maximum.
          cmp eax, edi
          jb l_h_ohci_select_interrupt_list_56
            mov edi, eax
            
          l_h_ohci_select_interrupt_list_56:
          // 3e. The intermediate loop continued: advance counter.
          add edx, ebx
          cmp edx, [ss:esp + 8]  // group1_limit
          jb l_h_ohci_select_interrupt_list_calc_max_bandwidth
          
          // 3e. The intermediate loop done: restore counter of the outermost loop.
        pop edx
        // 3f. The outermost loop continued: if the current variant is
        // better (maybe not strictly) then the previous optimum, update
        // the optimal bandwidth and resulting list.
        cmp edi, [es:ebp - 8]  // bandwidth
        ja l_h_ohci_select_interrupt_list_57
          mov [es:ebp - 8], edi  // bandwidth
          mov [es:ebp - 4], edx  // target
          
        l_h_ohci_select_interrupt_list_57:
        // 3g. The outermost loop continued: advance counter.
        add edx, sizeof OhciStaticEp
        dec ecx
        jnz l_h_ohci_select_interrupt_list_5
        
      // 4. Calculate bandwidth for the new pipe.
      mov eax, [es:ebp + 16]  // maxpacket
      mov cl, [es:ebp - 12]  // speed
      mov ch, [es:ebp + 12]  // endpoint
      and ch, 80h
      call h_usb_calc_bandwidth
      // 5. Get the pointer to the best list.
    pop edx  // restore value from step 2
  pop ecx  // purge stack var from prolog
  add edx, [es:ebp - 4]  // target
  // 6. Check that bandwidth for the new pipe plus old bandwidth
  // still fits to maximum allowed by the core specification, 90% of 12000 bits.
  mov ecx, eax
  add ecx, [es:ebp - 8]  // bandwidth
  cmp ecx, 10800
  ja l_h_ohci_select_interrupt_list_no_bandwidth
    // 7. Convert {o|u}hci_static_ep to usb_static_ep, update bandwidth and return.
    add edx, offset OhciStaticEp.software_part
    add [es:edx + offset UsbStaticEp.bandwidth], eax
 pop edi
pop ebx  // restore used registers to be stdcall
ret
  
  l_h_ohci_select_interrupt_list_no_bandwidth:
  xor edx, edx
 pop edi
pop ebx  // restore used registers to be stdcall
ret

// Helper procedure for ohci_alloc_transfer.
// Allocates and initializes one transfer descriptor.
// fills the current last descriptor and
// returns eax = next descriptor (not filled).
// IN: ebx -> UsbPipe
// KEEP: ebx, edi
h_ohci_alloc_packet:
/*
24 buffer:dword, 28 size:dword, 32 flags:dword, 36 td:dword, 40 direction:dword
20 ret_adr
16 token
12 origTD
8 packetSize  // must be the last variable, see h_usb_init_transfer
4 ret_adr
0 eax
*/

// 1. Allocate the next TD.
call h_ohci_alloc_gtd
test eax, eax
jz l_h_ohci_alloc_packet_9
// 2. Initialize controller-independent parts of both TDs.
push eax
  call h_usb_init_transfer  // out ecx
pop eax
// 3. Save the returned value (next descriptor).
push eax
  // 4. Store the physical address of the next descriptor.
  sub eax, sizeof OhciGtd
  call h_usb_getphysadr  // keep ecx, edi
  mov [es:ecx + offset OhciGtd.next_td - sizeof OhciGtd], eax
  // 5. For zero-length transfers, store zero in both fields for buffer addresses.
  // Otherwise, fill them with real values.
  xor eax, eax
  mov [es:ecx + offset OhciGtd.cur_buf_ptr - sizeof OhciGtd], eax
  mov [es:ecx + offset OhciGtd.buf_end - sizeof OhciGtd], eax
  cmp [ss:esp + 28], eax  // size
  jz l_h_ohci_alloc_packet_6
    push ebx
     push edi
      mov ebx, [ss:esp + 24 + 8]  // buffer
      call m_pages_getphysadr  // keep ecx
      mov [es:ecx + offset OhciGtd.cur_buf_ptr - sizeof OhciGtd], ebx
      mov eax, [ss:esp + 24 + 8]  // buffer
      add eax, [ss:esp + 8 + 8]  // packetSize
      dec eax
      mov ebx, eax
      call m_pages_getphysadr  // keep ecx
      mov [es:ecx + offset OhciGtd.buf_end - sizeof OhciGtd], ebx
     pop edi
    pop ebx
    
  l_h_ohci_alloc_packet_6:
  // 6. Generate Flags field:
  // - set bufferRounding (bit 18) to zero = disallow short transfers
  //   for the last transfer in a row, ohci_alloc_transfer would set the real value
  // - set Direction (bits 19-20) to lower 2 bits of [.direction]
  // - set DelayInterrupt (bits 21-23) to 7 = do not generate interrupt
  //   for the last transfer in a row, ohci_alloc_transfer would set the real value
  // - set DataToggle (bits 24-25) to next 2 bits of [.direction]
  // - set ConditionCode (bits 28-31) to 1111b as a indicator that there was no
  //   attempts to perform this transfer yet
  // - zero all other bits.
  mov eax, [ss:esp + 40]  // direction
  mov edx, eax
  and eax, 3
  shl eax, 19
  and edx, (3 << 2)
  shl edx, 24 - 2
  lea eax, [eax + edx + (7 << 21) + (15 << 28)]
  mov [es:ecx + offset OhciGtd.flags - sizeof OhciGtd], eax
  // 7. Restore the returned value saved in step 3.
pop eax

l_h_ohci_alloc_packet_9:
ret

// This function is called from ohci_process_deferred when
// a new device has been reset and needs to be configured.
// IN: esi -> UsbController
h_ohci_port_after_reset:
// 1. Get the status.
// If reset has been failed (device disconnected during reset),
// continue to next device (if there is one).
xor eax, eax
xchg al, [es:esi + offset UsbController.resetting_status]
test al, al
jns l_h_ohci_port_after_reset_1
  jmp h_usb_test_pending_port
  
l_h_ohci_port_after_reset_1:
// If the controller has disabled the port (e.g. overcurrent),
// continue to next device (if there is one).
movzx ecx, byte ptr [es:esi + offset UsbController.resetting_port]
mov eax, [es:edi + OHCI_REG_RHPORTSTATUS + ecx * 4]
test al, 2
jnz l_h_ohci_port_after_reset_2
  //DEBUGF 1,'K : USB port disabled after reset, status=%x\n',eax
  jmp h_usb_test_pending_port
  
l_h_ohci_port_after_reset_2:
push ecx
  // 2. Get LowSpeed bit to bit 0 of eax and call the worker procedure
  // to notify the protocol layer about new OHCI device.
  mov eax, [es:edi + OHCI_REG_RHPORTSTATUS + ecx * 4]
  shr eax, 9
  call h_ohci_new_device
pop ecx
// 3. If something at the protocol layer has failed
// (no memory, no bus address), disable the port and stop the initialization.
test eax, eax
jnz l_h_ohci_port_after_reset_9
  mov dword ptr [es:edi + OHCI_REG_RHPORTSTATUS + ecx * 4], 1
  jmp h_usb_test_pending_port
  
l_h_ohci_port_after_reset_9:
ret

// Helper procedure for ohci_process_deferred. Processes one completed TD.
// IN: esi -> UsbController, ebx -> UsbGtd
// OUT: ebx -> next usb_gtd.
h_ohci_process_finalized_td:
//       DEBUGF 1,'K : processing %x\n',ebx
// 1. Check whether the pipe has been closed, either due to API call or due to
// disconnect; if so, the callback will be called by usb_pipe_closed with
// correct status, so go to step 6 with ebx = 0 (do not free the TD).
mov edx, [es:ebx + offset UsbGtd.pipe]
test dword ptr [es:edx + offset UsbPipe.flags], USB_FLAG_CLOSED
jz l_h_ohci_process_finalized_td_1
  lea eax, [ebx + offset OhciGtd.next_td - sizeof OhciGtd]
  xor ebx, ebx
  jmp l_h_ohci_process_finalized_td_next_td2
  
l_h_ohci_process_finalized_td_1:
// 2. Remove the descriptor from the descriptors queue.

call h_usb_unlink_td

// 3. Get number of bytes that remain to be transferred.
// If CurBufPtr is zero, everything was transferred.
xor edx, edx
cmp [es:ebx + offset OhciGtd.cur_buf_ptr - sizeof OhciGtd], edx
jz l_h_ohci_process_finalized_td_gotlen
  // Otherwise, the remaining length is
  // (BufEnd and 0xFFF) - (CurBufPtr and 0xFFF) + 1,
  // plus 0x1000 if BufEnd and CurBufPtr are in different pages.
  mov edx, [es:ebx + offset OhciGtd.buf_end - sizeof OhciGtd]
  mov eax, [es:ebx + offset OhciGtd.cur_buf_ptr - sizeof OhciGtd]
  mov ecx, edx
  and edx, 0xFFF
  inc edx
  xor ecx, eax
  and ecx, -0x1000
  jz l_h_ohci_process_finalized_td_2
    add edx, 0x1000
    
  l_h_ohci_process_finalized_td_2:
  and eax, 0xFFF
  sub edx, eax
  
l_h_ohci_process_finalized_td_gotlen:
// The actual length is Length - (remaining length).
sub edx, [es:ebx + offset UsbGtd.length]
neg edx
// 4. Check for error. If so, go to 7.
push ebx
  mov ecx, [es:ebx + offset OhciGtd.flags - sizeof OhciGtd]
  shr ecx, 28
  jnz near l_h_ohci_process_finalized_td_error
  
  l_h_ohci_process_finalized_td_notify:
  // 5. Successful completion.
  
  call h_usb_process_gtd
  
  l_h_ohci_process_finalized_td_next_td:
  // 6. Free the current descriptor and advance to the next item.
  // If the current item is the last in the list,
  // set DoneListEndPtr to pointer to DoneList.
  cmp ebx, [ss:esp]
  jz l_h_ohci_process_finalized_td_6
    push ebx
    call h_ohci_free_gtd
    
  l_h_ohci_process_finalized_td_6:
pop ebx
lea eax, [ebx + offset OhciGtd.next_td - sizeof OhciGtd]

l_h_ohci_process_finalized_td_next_td2:
push ebx
  mov ebx, eax
  lea edx, [esi + offset OhciController.done_list - sizeof OhciController]
  xor ecx, ecx // no next item
  lock cmpxchg [es:esi + offset OhciController.done_list_end_p - sizeof OhciController], edx
  jz l_h_ohci_process_finalized_td_last
    // The current item is not the last.
    // It is possible, although very rare, that ohci_irq has already advanced
    // DoneListEndPtr, but not yet written NextTD. Wait until NextTD is nonzero.
    l_h_ohci_process_finalized_td_65:
      mov ecx, [es:ebx]
      jecxz l_h_ohci_process_finalized_td_65
      
  l_h_ohci_process_finalized_td_last:
pop ebx
// ecx = the next item
push ecx
  // Free the current item, set ebx to the next item, continue to 5a.
  test ebx, ebx
  jz l_h_ohci_process_finalized_td_67
    push ebx
    call h_ohci_free_gtd
    
  l_h_ohci_process_finalized_td_67:
pop ebx
ret

l_h_ohci_process_finalized_td_error:
// 7. There was an error while processing this descriptor.
// The hardware has stopped processing the queue.
// 7a. Save status and length.
push ecx
 push edx
  // 7b. Traverse the list of descriptors looking for the final packet
  // for this transfer.
  // Free and unlink non-final descriptors, except the current one.
  // Final descriptor will be freed in step 6.
  
  call h_usb_is_final_packet
  
  jnc l_h_ohci_process_finalized_td_found_final
    mov ebx, [es:ebx + offset UsbGtd.next_virt]
  /*    
  virtual at esp
  .length         dd      ?
  .error_code     dd      ?
  .current_item   dd      ?
  end virtual
  */
  l_h_ohci_process_finalized_td_look_final:
    call h_usb_unlink_td
    call h_usb_is_final_packet
    jnc l_h_ohci_process_finalized_td_found_final
    push dword ptr [es:ebx + offset UsbGtd.next_virt]
      push ebx
      call h_ohci_free_gtd
    pop ebx
    jmp short l_h_ohci_process_finalized_td_look_final
    
  l_h_ohci_process_finalized_td_found_final:
  // 7c. If error code is USB_STATUS_UNDERRUN and the last TD allows short packets,
  // it is not an error.
  // Note: all TDs except the last one in any transfer stage are marked
  // as short-packet-is-error to stop controller from further processing
  // of that stage// we need to restart processing from a TD following the last.
  // After that, go to step 5 with eax = 0 (no error).
  cmp dword ptr [ss:esp + 4], USB_STATUS_UNDERRUN  //.error_code
  jnz l_h_ohci_process_finalized_td_no_underrun
   test byte ptr [es:ebx + offset OhciGtd.flags + 2 - sizeof OhciGtd], 1 << (18 - 16)
   jz l_h_ohci_process_finalized_td_no_underrun
    and dword ptr [ss:esp + 4], 0  //.error_code
    mov ecx, [es:ebx + offset UsbGtd.pipe]
    mov edx, [es:ecx + offset OhciPipe.head_p - sizeof OhciPipe]
    and edx, 2
    
    l_h_ohci_process_finalized_td_advance_queue:
      mov eax, [es:ebx + offset UsbGtd.next_virt]
      sub eax, sizeof OhciGtd
      call h_usb_getphysadr
      or eax, edx
      mov [es:ecx + offset OhciPipe.head_p - sizeof OhciPipe], eax
      push ebx
        mov ebx, ecx
        call h_ohci_notify_new_work  //@h_ohci_insert_transfer
      pop ebx
 pop edx
pop ecx
jmp l_h_ohci_process_finalized_td_notify

  // 7d. Abort the entire transfer.
  // There are two cases: either there is only one transfer stage
  // (everything except control transfers), then ebx points to the last TD and
  // all previous TD were unlinked and dismissed (if possible),
  // or there are several stages (a control transfer) and ebx points to the last
  // TD of Data or Status stage (usb_is_final_packet does not stop in Setup stage,
  // because Setup stage can not produce short packets)// for Data stage, we need
  // to unlink and free (if possible) one more TD and advance ebx to the next one.
  l_h_ohci_process_finalized_td_no_underrun:
  cmp dword ptr [es:ebx + offset UsbGtd.callback], 0
  jnz l_h_ohci_process_finalized_td_halted
    cmp ebx, [ss:esp + 8]  //.current_item
    push dword ptr [es:ebx + offset UsbGtd.next_virt]
      jz l_h_ohci_process_finalized_td_71
        push ebx
        call h_ohci_free_gtd
        
      l_h_ohci_process_finalized_td_71:
    pop ebx
    call h_usb_unlink_td
    
  l_h_ohci_process_finalized_td_halted:
  // 7e. For bulk/interrupt transfers we have no choice but halt the queue,
  // the driver should intercede (through some API which is not written yet).
  // Control pipes normally recover at the next SETUP transaction (first stage
  // of any control transfer), so we hope on the best and just advance the queue
  // to the next transfer. (According to the standard, "A control pipe may also
  // support functional stall as well, but this is not recommended.").
  // Advance the transfer queue to the next descriptor.
  mov ecx, [es:ebx + offset UsbGtd.pipe]
  mov edx, [es:ecx + offset OhciPipe.head_p - sizeof OhciPipe]
  and edx, 2  // keep toggleCarry bit
  cmp dword ptr [es:ecx + offset UsbPipe.type], CONTROL_PIPE
  jz l_h_ohci_process_finalized_td_72
    inc edx     // set Halted bit
    
  l_h_ohci_process_finalized_td_72:
  jmp l_h_ohci_process_finalized_td_advance_queue

 [align 32]
h_ohci_hardware_func:
dd 110h
dd 'OHCI'
dd sizeof OhciController
dd offset h_ohci_kickoff_bios
dd offset h_ohci_init
dd offset h_ohci_process_deferred
dd offset h_ohci_set_adr
dd offset h_ohci_get_adr
dd offset h_ohci_disable_port
dd offset h_ohci_new_port_reset
dd offset h_ohci_set_ep_packet_size
dd offset h_ohci_alloc_pipe
dd offset h_ohci_free_pipe
dd offset h_ohci_init_pipe
dd offset h_ohci_unlink_pipe
dd offset h_ohci_alloc_gtd
dd offset h_ohci_free_gtd
dd offset h_ohci_alloc_transfer
dd offset h_ohci_insert_transfer
dd offset h_ohci_new_device
dd offset h_ohci_disable_pipe
dd offset h_ohci_enable_pipe

h_ohci_name: db 'OHCI\0'

// IN: usb_ecx, usb_edx
h_ohci_kickoff_bios:
mov ecx, usb_ecx
mov edx, usb_edx
mov dl, 10h
call h_pci_get

mov ebx, usb_mmio
//add usb_mmio, 4096
mov ecx, 1
mov edx, eax
push ebx
  call m_pages_alloc_hard
pop eax  // eax = mmio_va

//mov eax, [es:esi + offset OhciController.mmio_base - sizeof OhciController]

pushfd
  cli
  mov edx, 100h
  test dword ptr [es:eax + OHCI_REG_CONTROL], edx
  jz l_h_ohci_kickoff_bios_6
    mov dword ptr [es:eax + OHCI_REG_COMMANDSTATUS], 8
    mov ecx, 50
    
    l_h_ohci_kickoff_bios_5:
      test dword ptr [es:eax + OHCI_REG_CONTROL], edx
      jz l_h_ohci_kickoff_bios_6
        pushad
          mov ecx, 1
          call p_sleep
        popad
        loop l_h_ohci_kickoff_bios_5
    // take ownership timeout
    
  l_h_ohci_kickoff_bios_6:
  // disable all controller interrupts until the system will be ready to process them
  mov dword ptr [es:eax + OHCI_REG_INTERRUPTDISABLE], 0C000007Fh
popfd
ret

// IN: usb_ecx, usb_edx
// OUT: eax -> UsbController || 0
// KEEP: usb_ecx, usb_edx
h_ohci_init:
// alloc
mov ecx, sizeof OhciController + sizeof UsbController
call h_usb_alloc
xchg eax, ebx
push eax
  add eax, sizeof OhciController
  mov dword ptr [es:eax + offset UsbController.hardware_func], offset h_ohci_hardware_func + PA_KERNEL_CODE + VA_SYSTEM
  call h_usb_init_controller
pop eax
push eax
  mov edi, eax
  // zero
  xor eax, eax
  mov ohci_gtd_first_page, eax
  // fill OhciController.interrupt_table with physical addresses of int_eds
  lea eax, [edi + offset OhciController.int_eds + (32 * sizeof OhciStaticEp)]
  push eax
    call h_usb_getphysadr
  pop esi
  and eax, -4096
  add eax, offset OhciController.int_eds
  mov ecx, 32
  mov edx, ecx
  
  l_h_ohci_init_25:
    stosd
    add eax, sizeof OhciStaticEp
    loop l_h_ohci_init_25
  
  sub edi, -128  // edi += 128: edi now points to software fields
  
  // init int_eds
  l_h_ohci_init_35:
    shr edx, 1
    jz l_h_ohci_init_39
      push eax
       push esi
        call h_ohci_init_static_ep_group
       pop esi
      pop eax
      call h_ohci_init_static_ep_group
      jmp l_h_ohci_init_35
      
  l_h_ohci_init_39:
  xor eax, eax
  xor esi, esi
  call h_ohci_init_static_ep  //?
  call h_ohci_init_static_ep  // control_ed
  call h_ohci_init_static_ep  // bulk_ed
  
  // PCI - map mmio
  push edi
    
    mov ecx, usb_ecx
    mov edx, usb_edx    
    mov dl, 10h
    call h_pci_get  // eax = mmio_pa
    
    mov ebx, usb_mmio
    add usb_mmio, 4096
    mov ecx, 1
    mov edx, eax
    push ebx
      call m_pages_alloc_hard
    pop eax  // eax = mmio_va
    
  pop edi
  stosd
  xchg eax, edi  // edi = mmio_va
  
  // enable memory access
  mov ecx, usb_ecx
  mov edx, usb_edx    
  mov dl, 4  // command
  call h_pci_get  // keep edi
  or al, 6
  call h_pci_set  // keep edi
  
  // IRQ
pop esi
push esi
  push edi
    add esi, sizeof OhciController
    sub esi, VA_USB
    or esi, 1 << 24  // 1:OHCI
    
    mov ecx, usb_ecx
    mov edx, usb_edx    
    mov dl, 3Ch  // IRQ
    call h_pci_get  // keep esi
    
    // IN: al = IRQ, esi = controller RA | (0:uhci, 1:ohci, 2:ehci << 24)
    call h_usb_irqs_init
  pop edi
  
  // reset?
  mov eax, [es:edi + OHCI_REG_CONTROL]
  and al, 3 << 6
  cmp al, 2 << 6
  jz l_h_ohci_init_operational
    // reset
    
    push dword ptr [es:edi + OHCI_REG_FMINTERVAL]
      
      mov ecx, 1
      mov [es:edi + OHCI_REG_COMMANDSTATUS], ecx
      pushad
        call p_sleep  // ecx = 1 ms, which is more than enough for 10 us
      popad
      test [es:edi + OHCI_REG_COMMANDSTATUS], ecx
      jz l_h_ohci_init_49
          // timeout
          
          pop edx  // fminterval
          pop eax  // controller
          
          ret
          
      l_h_ohci_init_49:
      
    pop eax
    
    mov edx, eax
    and edx, 3FFFh
    jz l_h_ohci_init_6
      cmp dx, 2EDFh
      jnz l_h_ohci_init_7
      
    l_h_ohci_init_6:
      mov eax, 27792EDFh
      
    l_h_ohci_init_7:
    mov [es:edi + OHCI_REG_FMINTERVAL], eax
    movzx eax, ax
    mov edx, 0E6666667h
    mul edx
    mov [es:edi + OHCI_REG_PERIODICSTART], edx
    
  l_h_ohci_init_operational:
  // set HCCA
pop eax
push eax  // eax = VA OhciController
  call h_usb_getphysadr
  mov [es:edi + OHCI_REG_HCCA], eax
  // set control reg
  mov ecx, 2 << 6
  mov [es:edi + OHCI_REG_CONTROL], ecx
  // physical addresses of head of Control and Bulk lists
  add eax, offset OhciController.control_ed
  mov [es:edi + OHCI_REG_CONTROLHEADED], eax
  add eax, offset OhciController.bulk_ed - offset OhciController.control_ed
  mov [es:edi + OHCI_REG_BULKHEADED], eax
  // zero Head registers: there are no active Control and Bulk descriptors yet
  xor eax, eax
  mov [es:edi + OHCI_REG_CONTROLCURED], eax
  mov [es:edi + OHCI_REG_BULKCURED], eax
  // enable processing of all lists with control:bulk ratio = 1:1
  mov dword ptr [es:edi + OHCI_REG_CONTROL], 10111100b
  // find EHCI
  xor ebx, ebx
  mov bh, byte ptr usb_ecx[1]
  mov bl, byte ptr usb_ecx[0]
  shl bl, 3
  or bl, byte ptr usb_edx[1]
  call h_usb_find_ehci_companion
pop esi
mov [es:esi + offset OhciController.ehci_companion], eax
// get number of ports
mov eax, [es:edi + OHCI_REG_RHA]
and eax, 15
mov [es:esi + sizeof OhciController + offset UsbController.num_ports], eax
// initialize DoneListEndPtr to point to DoneList
lea eax, [esi + offset OhciController.done_list]
mov [es:esi + offset OhciController.done_list_end_p], eax
// enable controller interrupt on HcDoneHead writeback and RootHubStatusChange
mov dword ptr [es:edi + OHCI_REG_INTERRUPTENABLE], 80000042h

// * init ports * (esi + sizeof OhciController)

// initiate power up, disable all ports, clear all changed bits
mov dword [es:edi + OHCI_REG_RHSTATUS], 10000h  // SetGlobalPower
xor ecx, ecx

l_h_ohci_init_75:
  mov dword ptr [es:edi + OHCI_REG_RHPORTSTATUS + ecx * 4], 1F0101h  // SetPortPower + ClearPortEnable + clear changed bits
  inc ecx
  cmp ecx, [es:esi + sizeof OhciController + offset UsbController.num_ports]
  jb l_h_ohci_init_75

// Wait for power up
mov ecx, [es:edi + OHCI_REG_RHA]
shr ecx, 24
shl ecx, 1
jz l_h_ohci_init_76
  pushad
    call p_sleep  // sleep ecx ms
  popad
  
l_h_ohci_init_76:
// ports are powered up; now it is ok to process connect/disconnect events
mov byte ptr [es:esi + offset OhciController.powered], 1
xor ecx, ecx

l_h_ohci_init_85:
  test dword ptr [es:edi + OHCI_REG_RHPORTSTATUS], 1
  jz l_h_ohci_init_86
    mov eax, tmr_usb_timerticks  // GetTimerTicks
    mov [es:esi + sizeof OhciController + offset UsbController.connected_time + ecx * 4], eax
    lock bts [es:esi + sizeof OhciController + offset UsbController.new_connected], ecx
    
  l_h_ohci_init_86:
  inc ecx
  cmp ecx, [es:esi + sizeof OhciController + offset UsbController.num_ports]
  jb l_h_ohci_init_85

xchg eax, esi
add eax, sizeof OhciController

/*
//$$$
cli
call wregs
l02:jmp l02
*/

l_h_ohci_init_9:
ret

// IN: eax = physical address of the next list
//     esi = pointer to the next list
//     edi = pointer to head to initialize
// KEEP: eax, esi
// advances edi to the next head
h_ohci_init_static_ep:
mov byte ptr [es:edi + offset OhciStaticEp.flags + 1], 1 << (14 - 8) // sKip this endpoint
mov [es:edi + offset OhciStaticEp.next_ed], eax
mov [es:edi + offset OhciStaticEp.next_list], esi
add edi, offset OhciStaticEp.software_part

mov [es:edi + offset UsbStaticEp.next_virt], edi
mov [es:edi + offset UsbStaticEp.prev_virt], edi

add edi, sizeof OhciStaticEp - offset OhciStaticEp.software_part

//$$$
//cli
//call wregs
//l00:jmp l00

ret

// IN: edx = size of the next group = half of size of the group
//     edi = pointer to the group, eax = physical address of the next group,
//     esi = pointer to the next group.
// KEEP: edx
// advances eax, esi, edi to the next group
h_ohci_init_static_ep_group:
push edx
  
  l_ohci_init_static_ep_group_5:
    call h_ohci_init_static_ep
    add eax, sizeof OhciStaticEp
    add esi, sizeof OhciStaticEp
    dec edx
    jnz l_ohci_init_static_ep_group_5
    
pop edx
ret

h_ohci_irq_04:
ret

// IN: esi -> UsbController
h_ohci_irq:
xor ebx, ebx
mov edi, [es:esi + offset OhciController.mmio_base - sizeof OhciController]
mov eax, [es:edi + OHCI_REG_INTERRUPTSTATUS]
and eax, [es:edi + OHCI_REG_INTERRUPTENABLE]
jz h_ohci_irq_04

mov ecx, [es:esi + offset OhciController.done_head - sizeof OhciController]
and ecx, -2
mov [es:edi + OHCI_REG_INTERRUPTSTATUS], eax
push eax
  test al, 2
  jz l_h_ohci_irq_skip_donehead
    
    // * process "done" *
    
    push ebx
      xor ebx, ebx
      test ecx, ecx
      jz l_h_ohci_irq_tddone
        mov eax, ohci_gtd_first_page  //?
        call usb_td_to_virt
        test eax, eax
        jz l_h_ohci_irq_tddone
          lea edx, [eax + offset OhciGtd.next_td]
          
          l_h_ohci_irq_25:
            mov ecx, [es:eax + offset OhciGtd.next_td]
            mov [es:eax + offset OhciGtd.next_td], ebx
            lea ebx, [eax + sizeof OhciGtd]
            test ecx, ecx
            jz l_h_ohci_irq_tddone
              mov eax, ohci_gtd_first_page  //?
              call usb_td_to_virt
              test eax, eax
              jnz l_h_ohci_irq_25
        
      l_h_ohci_irq_tddone:
      mov ecx, ebx
    pop ebx
    test ecx, ecx
    jz l_h_ohci_irq_skip_donehead
      
      l_h_ohci_irq_35:
        mov eax, [es:esi + offset OhciController.done_list_end_p - sizeof OhciController]
        lock cmpxchg [es:esi + offset OhciController.done_list_end_p - sizeof OhciController], edx
        jnz l_h_ohci_irq_35
      
      mov [es:eax], ecx
      inc ebx
    
  l_h_ohci_irq_skip_donehead:
  test byte ptr [ss:esp], 4
  jz l_h_ohci_irq_skip_sof
    
    // * process start of frame events *
    
    movzx eax, word ptr [es:esi + offset OhciController.frame_number - sizeof OhciController]
    cmp eax, [es:esi + offset UsbController.start_wait_frame]
    jz l_h_ohci_irq_sof_unlock
      // copy wait_pipe_request* to ready_pipe_head*.
      mov eax, [es:esi + offset UsbController.wait_pipe_request_async]
      mov [es:esi + offset UsbController.ready_pipe_head_async], eax
      mov eax, [es:esi + offset UsbController.wait_pipe_request_periodic]
      mov [es:esi + offset UsbController.ready_pipe_head_periodic], eax
      
      // It is possible that pipe change is due to removal and
      // Control/BulkCurrentED registers still point to one of pipes to be removed.
      // The code responsible for disconnect events has temporarily stopped
      // Control/Bulk processing, so it is safe to clear Control/BulkCurrentED.
      // After that, restart processing.
      xor edx, edx
      mov [es:edi + OHCI_REG_CONTROLCURED], edx
      mov [es:edi + OHCI_REG_BULKCURED], edx
      mov dword ptr [es:edi + OHCI_REG_COMMANDSTATUS], 6
      or dword ptr [es:edi + OHCI_REG_CONTROL], 30h
      
      // disable further interrupts on SOF
      mov dword ptr [es:edi + OHCI_REG_INTERRUPTDISABLE], 4

      // notify the USB thread that there is new work (with pipes from ready_pipe_head*)
      inc ebx      
      
    l_h_ohci_irq_sof_unlock:
    
  l_h_ohci_irq_skip_sof:
  test byte ptr [ss:esp], 40h
  jz near l_h_ohci_irq_skip_rh
    
    // * handle roothub events *
    
    mov dword ptr [es:edi + OHCI_REG_RHSTATUS], 80020000h  // clear roothub events
    
    // check the status of individual ports
    xor ecx, ecx
    
    l_h_ohci_irq_45:
      xor eax, eax
      
      l_h_ohci_irq_455:
        mov edx, [es:edi + OHCI_REG_RHPORTSTATUS + ecx*4]
        xor ax, ax
        or eax, edx
        test edx, 1F0000h
        jz  l_h_ohci_irq_458
          mov dword ptr [es:edi + OHCI_REG_RHPORTSTATUS + ecx*4], 1F0000h
          jmp short l_h_ohci_irq_455
          
      l_h_ohci_irq_458:
      // Ignore any events until all ports are powered up. They will be processed by ohci_init.
      cmp byte ptr [es:esi + offset OhciController.powered - sizeof OhciController], 0
      jz l_h_ohci_irq_nextport
        test eax, 10000h
        jz l_h_ohci_irq_nocsc
          cmp cl, [es:esi + offset UsbController.resetting_port]
          jnz l_h_ohci_irq_4581
            mov byte ptr [es:esi + offset UsbController.resetting_status], -1
            inc ebx
            
          l_h_ohci_irq_4581:
          lock bts dword ptr [es:esi + offset UsbController.new_disconnected], ecx
          inc ebx
          test al, 1
          jz l_h_ohci_irq_discon
            mov eax, tmr_usb_timerticks  // GetTimerTicks
            mov [es:esi + offset UsbController.connected_time], eax
            lock bts dword [es:esi + offset UsbController.new_connected], ecx
            jmp short l_h_ohci_irq_nextport
            
          l_h_ohci_irq_discon:
          lock btr dword [es:esi + offset UsbController.new_connected], ecx
          jmp short l_h_ohci_irq_nextport
          
        l_h_ohci_irq_nocsc:
        test eax, 100000h
        jz l_h_ohci_irq_nextport
          test al, 10h
          jnz l_h_ohci_irq_nextport
            mov eax, tmr_usb_timerticks  // GetTimerTicks
            mov [es:esi + offset UsbController.reset_time], eax
            mov byte ptr [es:esi + offset UsbController.resetting_status], 2
            inc ebx
            
        l_h_ohci_irq_nextport:
        inc ecx
        cmp ecx, [es:esi + offset UsbController.num_ports]
        jb l_h_ohci_irq_45
      
  l_h_ohci_irq_skip_rh:
pop eax
// post message
// IN: ebx = winid:(threadid+16384), ecx = msg, edx = wp, esi = lp
// OUT: al = 0 || errorcode
mov ebx, usb_thread
mov ecx, WM_USB_INT
xor edx, edx
// esi -> UsbController
call p_msg_post
ret


// IN: eax = pa_td
// OUT: eax = va_td
usb_td_to_virt:
test eax, eax
jz l_usb_td_to_virt_9
  sub eax, usb_base
  add eax, VA_USB
  
l_usb_td_to_virt_9:
ret

// This procedure is called in the USB thread from usb_thread,
// processes regular actions and those actions which can't be safely done
// from interrupt handler.
// Returns maximal time delta before the next call.
// IN: esi -> UsbController
h_ohci_process_deferred:
push ebx
 push edi // save used registers to be stdcall
  // 1. Initialize the return value.
  push -1
   // 2. Process disconnect events.
   // Capture NewConnected mask in the state before disconnect processing;
   // IRQ handler could asynchronously signal disconnect+connect event,
   // connect events should be handled after disconnect events.
   push dword ptr [es:esi + offset UsbController.new_connected]
    call h_usb_disconnect_stage2
    
    // 3. Check for connected devices.
    // If there is a connected device which was connected less than
    // USB_CONNECT_DELAY ticks ago, plan to wake up when the delay will be over.
    // Otherwise, call ohci_new_port.
    mov edi, [es:esi + offset OhciController.mmio_base - sizeof OhciController]
    xor ecx, ecx
    cmp [ss:esp], ecx
    jz l_h_ohci_process_deferred_skip_newconnected
    
      l_h_ohci_process_deferred_portloop:
        bt [ss:esp], ecx
        jnc l_h_ohci_process_deferred_noconnect
          // If this port is shared with the EHCI companion and we see the connect event,
          // then the device is USB1 dropped by EHCI,
          // so EHCI has already waited for debounce delay, we can proceed immediately.
          cmp dword ptr [es:esi + offset OhciController.ehci_companion - sizeof OhciController], 0
          jz l_h_ohci_process_deferred_portloop_test_time
            //dbgstr 'port is shared with EHCI, skipping initial debounce'
            jmp l_h_ohci_process_deferred_connected
            
          l_h_ohci_process_deferred_portloop_test_time:
          mov eax, tmr_usb_timerticks
          sub eax, [es:esi + offset UsbController.connected_time + ecx * 4]
          sub eax, USB_CONNECT_DELAY
          jge l_h_ohci_process_deferred_connected
            neg eax
            cmp [ss:esp + 4], eax
            jb l_h_ohci_process_deferred_nextport
              mov [ss:esp + 4], eax
              jmp l_h_ohci_process_deferred_nextport
              
          l_h_ohci_process_deferred_connected:
          lock btr [es:esi + offset UsbController.new_connected], ecx
          jnc l_h_ohci_process_deferred_nextport
            call h_ohci_new_port
            
        l_h_ohci_process_deferred_noconnect:
        l_h_ohci_process_deferred_nextport:
        inc ecx
        cmp ecx, [es:esi + offset UsbController.num_ports]
        jb l_h_ohci_process_deferred_portloop
        
    l_h_ohci_process_deferred_skip_newconnected:
   pop eax
   // 4. Check for end of reset signalling. If so, call h_ohci_port_after_reset.
   cmp byte ptr [es:esi + offset UsbController.resetting_status], 2
   jnz l_h_ohci_process_deferred_no_reset_recovery
     mov eax, tmr_usb_timerticks
     sub eax, [es:esi + offset UsbController.reset_time]
     sub eax, USB_RESET_RECOVERY_TIME
     jge l_h_ohci_process_deferred_reset_done
       neg eax
       cmp [ss:esp], eax
       jb l_h_ohci_process_deferred_skip_roothub
         mov [ss:esp], eax
         jmp l_h_ohci_process_deferred_skip_roothub
         
   l_h_ohci_process_deferred_no_reset_recovery:
   cmp byte ptr [es:esi + offset UsbController.resetting_status], 0
   jz l_h_ohci_process_deferred_skip_roothub
     
     l_h_ohci_process_deferred_reset_done:
     call h_ohci_port_after_reset
    
   l_h_ohci_process_deferred_skip_roothub:
   // 5. Finalize transfers processed by hardware.
   // It is better to perform this step after processing disconnect events,
   // although not strictly obligatory. This way, an active transfer aborted
   // due to disconnect would be handled with more specific USB_STATUS_CLOSED,
   // not USB_STATUS_NORESPONSE.
   // Loop over all items in DoneList, call h_ohci_process_finalized_td for each.
   xor ebx, ebx
   xchg ebx, [es:esi + offset OhciController.done_list - sizeof OhciController]
   
   l_h_ohci_process_deferred_tdloop:
    test ebx, ebx
    jz l_h_ohci_process_deferred_tddone
      call h_ohci_process_finalized_td  // keep esi, edi, in/out ebx
      jmp short l_h_ohci_process_deferred_tdloop
      
   l_h_ohci_process_deferred_tddone:
   // 6. Process wait-done notifications, test for new wait requests.
   // Note: that must be done after steps 2 and 5 which could create new requests.
   // 6a. Call the worker function from main USB code.
   
   call h_usb_process_wait_lists
   
   // 6b. If no new requests, skip the rest of this step.
   test eax, eax
   jz l_h_ohci_process_deferred_7
    // 6c. OHCI is not allowed to cache anything; we don't know what is
    // processed right now, but we can be sure that the controller will not
    // use any removed structure starting from the next frame.
    // Schedule SOF event.
    
    pushfd
      cli
      mov eax, [es:esi + offset UsbController.wait_pipe_list_async]
      mov [es:esi + offset UsbController.wait_pipe_request_async], eax
      mov eax, [es:esi + offset UsbController.wait_pipe_list_periodic]
      mov [es:esi + offset UsbController.wait_pipe_request_periodic], eax
      // temporarily stop bulk and interrupt processing;
      // this is required for handler of SOF event
      and dword ptr [es:edi + OHCI_REG_CONTROL], -1 - 30h
      // remember the frame number when processing has been stopped
      // (needs to be done after stopping)
      movzx eax, word ptr [es:esi + offset OhciController.frame_number - sizeof OhciController]
      mov [es:esi + offset UsbController.start_wait_frame], eax
      // make sure that the next SOF will happen after the request
      mov dword ptr [es:edi + OHCI_REG_INTERRUPTSTATUS], 4
      // enable interrupt on SOF
      // Note: OhciInterruptEnableReg/OhciInterruptDisableReg have unusual semantics,
      // so there should be 'mov' here, not 'or'
      mov dword ptr [es:edi + OHCI_REG_INTERRUPTENABLE], 4
    popfd
    
   l_h_ohci_process_deferred_7:
   // 7. Restore the return value and return.
  pop eax
 pop edi
pop ebx // restore used registers to be stdcall
ret

// IN: esi -> UsbController, ebx -> UsbPipe, cl = address
h_ohci_set_adr:
mov byte ptr [es:ebx + offset OhciPipe.flags - sizeof OhciPipe], cl
// wait until the hardware will forget the old value
jmp h_usb_subscribe_control

// IN: esi -> UsbController, ebx -> UsbPipe
// OUT: eax = endpoint address
h_ohci_get_adr:
mov eax, [es:ebx + offset OhciPipe.flags - sizeof OhciPipe]
and eax, 7Fh
ret

// This procedure is called from usb_set_address_callback
// if the device does not accept SET_ADDRESS command and needs
// to be disabled at the port level.
// IN: esi -> UsbController, ecx = port
h_ohci_disable_port:
mov edx, [es:esi + offset OhciController.mmio_base - sizeof OhciController]
mov dword [es:edx + OHCI_REG_RHPORTSTATUS + ecx * 4], 1
ret

// This procedure is called from usb_get_descr8_callback when
// the packet size for zero endpoint becomes known and
// stores the packet size in ohci_pipe structure.
// IN: esi -> UsbController, ebx -> UsbPipe, ecx = packet size
h_ohci_set_ep_packet_size:
mov byte ptr [es:ebx + offset OhciPipe.flags + 2 - sizeof OhciPipe], cl
// Wait until the hardware will forget the old value.
jmp h_usb_subscribe_control

h_ohci_alloc_pipe:
push ebx
 push ecx
  mov ecx, sizeof OhciPipe + sizeof UsbPipe
  call h_usb_alloc
  xchg eax, ebx
  test eax, eax
  jz l_h_ohci_alloc_pipe_6
    add eax, sizeof OhciPipe
    
  l_h_ohci_alloc_pipe_6:
 pop ecx
pop ebx
ret

h_ohci_free_pipe:
mov ebx, [ss:esp + 4]
sub ebx, sizeof OhciPipe
mov ecx, sizeof OhciPipe + sizeof UsbPipe
call h_usb_free
ret 4  // ret 4?

// IN: edi -> target UsbPipe, ecx -> config UsbPipe
//     esi -> UsbController, eax -> UsbGtd for the 1st TD
//     [ebp+12] = endpoint, [ebp+16] = maxpacket, [ebp+20] = type
h_ohci_init_pipe:
/*
// inherit some variables from h_usb_open_pipe
virtual at ebp-12
ebp-12 speed
ebp-8 bandwidth
ebp-4 target
ebp+8 config_pipe
ebp+12 endpoint
ebp+16 maxpacket
ebp+20 type
ebp+24 interval
end virtual
*/

// initialize the queue of transfer descriptors: empty
sub eax, sizeof OhciGtd
call h_usb_getphysadr
mov [es:edi + offset OhciPipe.tail_p - sizeof OhciPipe], eax
mov [es:edi + offset OhciPipe.head_p - sizeof OhciPipe], eax
// generate OhciPipe.flags
mov eax, [es:ecx + offset OhciPipe.flags - sizeof OhciPipe]
and eax, 0x207F     // keep Speed bit and FunctionAddress
mov edx, [es:ebp + 12]  // endpoint
and edx, 15
shl edx, 7
or eax, edx
mov [es:edi + offset OhciPipe.flags - sizeof OhciPipe], eax

bt eax, 13
setc byte ptr [es:ebp - 12]  // speed
mov eax, [es:ebp + 16]  // maxpacket
mov word ptr [es:edi + offset OhciPipe.flags + 2 - sizeof OhciPipe], ax
cmp dword ptr [es:ebp + 20], CONTROL_PIPE  // type
jz l_h_ohci_init_pipe_1
  test byte ptr [es:ebp + 12], 80h  // endpoint
  setnz al
  inc eax
  shl al, 3
  or byte ptr [es:edi + offset OhciPipe.flags + 1 - sizeof OhciPipe], al
  
l_h_ohci_init_pipe_1:
// insert the new pipe to the corresponding list of endpoints
lea edx, [esi + offset OhciController.control_ed.software_part - sizeof OhciController]
cmp dword ptr [es:ebp + 20], BULK_PIPE  // type
jb l_h_ohci_init_pipe_insert // control pipe
  lea edx, [esi + offset OhciController.bulk_ed.software_part - sizeof OhciController]
  jz l_h_ohci_init_pipe_insert // bulk pipe  
    // interrupt_pipe:
    // for interrupt pipes, let the scheduler select the appropriate list
    // based on the current bandwidth distribution and the requested bandwidth.
    // This could fail if the requested bandwidth is not available;
    // if so, return an error.
    lea edx, [esi + offset OhciController.int_eds - sizeof OhciController]
    lea eax, [esi + offset OhciController.int_eds + (32 * sizeof OhciStaticEp) - sizeof OhciController]
    mov ecx, 64
    call h_ohci_select_interrupt_list
    test edx, edx
    jz l_h_ohci_init_pipe_return0
    
// Insert endpoint at edi to the head of list in edx.
l_h_ohci_init_pipe_insert:
mov [es:edi + offset UsbPipe.base_list], edx
mov ecx, [es:edx + offset UsbPipe.next_virt]
mov [es:edi + offset UsbPipe.next_virt], ecx
mov [es:edi + offset UsbPipe.prev_virt], edx
mov [es:ecx + offset UsbPipe.prev_virt], edi
mov [es:edx + offset UsbPipe.next_virt], edi
mov ecx, [es:edx + offset OhciPipe.next_ed - sizeof OhciPipe]
mov [es:edi + offset OhciPipe.next_ed - sizeof OhciPipe], ecx
lea eax, [edi - sizeof OhciPipe]
call h_usb_getphysadr
mov [es:edx + offset OhciPipe.next_ed - sizeof OhciPipe], eax
ret

l_h_ohci_init_pipe_return0:
xor eax, eax
ret

// This procedure is called when a pipe is closing (either due to API call
// or due to disconnect); it unlinks the pipe from the corresponding list.
// IN: esi -> UsbController, ebx -> UsbPipe
h_ohci_unlink_pipe:
cmp dword ptr [es:ebx + offset UsbPipe.type], INTERRUPT_PIPE
jnz l_h_ohci_unlink_pipe_9
  mov eax, [es:ebx + offset OhciPipe.flags - sizeof OhciPipe]
  bt eax, 13
  setc cl
  bt eax, 12
  setc ch
  shr eax, 16
  
  push ecx
  push eax
  call h_usb_interrupt_list_unlink
  
l_h_ohci_unlink_pipe_9:
ret

// This function is called from ohci_process_deferred when
// a new device was connected at least USB_CONNECT_DELAY ticks
// and therefore is ready to be configured.
// IN: ecx = port, esi -> UsbController
h_ohci_new_port:
// test whether we are configuring another port
// if so, postpone configuring and return
bts dword ptr [es:esi + offset UsbController.pending_ports], ecx
cmp byte ptr [es:esi + offset UsbController.resetting_port], -1
jnz l_h_ohci_new_port_nothing
  btr dword ptr [es:esi + offset UsbController.pending_ports], ecx
  // fall through to h_ohci_new_port_reset
   
  // This function is called from usb_test_pending_port.
  // It starts reset signalling for the port. Note that in USB first stages
  // of configuration can not be done for several ports in parallel.
  
  h_ohci_new_port_reset:
  // reset port
  and dword ptr [es:esi + offset UsbController.resetting_hub], 0
  mov [es:esi + offset UsbController.resetting_port], cl
  // Note: setting status must be the last action:
  // it is possible that the device has been disconnected
  // after timeout of USB_CONNECT_DELAY but before call to ohci_new_port.
  // In this case, ohci_irq would not set reset status to 'failed',
  // because ohci_irq would not know that this port is to be reset.
  // However, the hardware would generate another interrupt
  // in a response to reset a disconnected port, and this time
  // ohci_irq knows that it needs to generate 'reset failed' event
  // (because ResettingPort is now filled).
  push edi
    mov edi, [es:esi + offset OhciController.mmio_base - sizeof OhciController]
    mov dword ptr [es:edi + OHCI_REG_RHPORTSTATUS + ecx * 4], 10h
  pop edi
  
l_h_ohci_new_port_nothing:
ret

// Allocates one general transfer descriptor structure for OHCI.
// Returns pointer to software part (UsbGtd) in eax.
h_ohci_alloc_gtd:
push ebx
 push ecx
  mov ecx, sizeof OhciGtd + sizeof UsbGtd
  call h_usb_alloc
  xchg eax, ebx
  test eax, eax
  jz l_h_ohci_alloc_gtd_6
    add eax, sizeof OhciGtd
    
  l_h_ohci_alloc_gtd_6:
 pop ecx
pop ebx
ret

// IN: stack UsbGtd
h_ohci_free_gtd:
push ebx
 push ecx
  mov ebx, [ss:esp + 8 + 4]
  sub ebx, sizeof OhciGtd
  mov ecx, sizeof OhciGtd + sizeof UsbGtd
  call h_usb_free
 pop ecx
pop ebx
ret 4  // ret 4?

// This procedure is called from the several places in main USB code
// and allocates required packets for the given transfer.
// buffer, size = data to transfer
// flags = same as in usb_open_pipe: bit 0 = allow short transfer, other bits reserved
// td = pointer to the current end-of-queue descriptor
// direction =
//   0000b for normal transfers,
//   1000b for control SETUP transfer,
//   1101b for control OUT transfer,
//   1110b for control IN transfer
// returns eax = pointer to the new end-of-queue descriptor
// (not included in the queue itself) or 0 on error
// IN: ebx = pipe
// USES: edi
h_ohci_alloc_transfer:
// 16 buffer:dword, 20 size:dword, 24 flags:dword, 28 td:dword, 32 direction:dword
/*
12 ret_adr
8 token  // not used
4 origTD
0 packetSize
*/
sub esp, 12

// 1. Save original value of td:
// it will be useful for rollback if something would fail.
mov eax, [ss:esp + 28]  // td
mov [ss:esp + 4], eax  // origTD
// One transfer descriptor can describe up to two pages.
// In the worst case (when the buffer is something*1000h+0FFFh)
// this corresponds to 1001h bytes. If the requested size is
// greater, we should split the transfer into several descriptors.
// Boundaries to split must be multiples of endpoint transfer size
// to avoid short packets except in the end of the transfer.
cmp dword ptr [ss:esp + 20], 1001h  // size
jna l_h_ohci_alloc_transfer_lastpacket
  // 2. While the remaining data cannot fit in one packet,
  // allocate full-sized descriptors.
  // 2a. Calculate size of one descriptor: must be a multiple of transfer size
  // and must be not greater than 1001h.
  movzx ecx, word ptr [es:ebx + offset OhciPipe.flags + 2 - sizeof OhciPipe]
  mov eax, 1001h
  xor edx, edx
  mov edi, eax
  div ecx
  sub edi, edx
  // 2b. Allocate in loop.
  mov [ss:esp + 0], edi  // packetSize
  
  l_h_ohci_alloc_transfer_fullpackets:
    call h_ohci_alloc_packet  // keep edi
    test eax, eax
    jz l_h_ohci_alloc_transfer_fail
      mov [ss:esp + 28], eax  // td
      add [ss:esp + 16], edi  // buffer
      sub [ss:esp + 20], edi  // size
      cmp dword ptr [ss:esp + 20], 1001h  // size
      ja l_h_ohci_alloc_transfer_fullpackets
      
  // 3. The remaining data can fit in one descriptor;
  // allocate the last descriptor with size = size of remaining data.
l_h_ohci_alloc_transfer_lastpacket:
mov eax, [ss:esp + 20]  // size
mov [ss:esp + 0], eax  // packetSize
call h_ohci_alloc_packet
test eax, eax
jz l_h_ohci_alloc_transfer_fail
  // 4. Enable an immediate interrupt on completion of the last packet.
  and byte ptr [es:ecx + offset OhciGtd.flags + 2 - sizeof OhciGtd], 255 - (7 << (21 - 16))
  // 5. If a short transfer is ok for a caller, set the corresponding bit in
  // the last descriptor, but not in others.
  // Note: even if the caller says that short transfers are ok,
  // all packets except the last one are marked as 'must be complete':
  // if one of them will be short, the software intervention is needed
  // to skip remaining packets; ohci_process_finalized_td will handle this
  // transparently to the caller.
  test dword ptr [es:esp + 24], 1  // flags
  jz l_h_ohci_alloc_transfer_4
    or byte ptr [es:ecx + offset OhciGtd.flags + 2 - sizeof OhciGtd], 1 << (18 - 16)
    
  l_h_ohci_alloc_transfer_4:
  
  add esp, 12
  ret 20
  
l_h_ohci_alloc_transfer_fail:
mov esi, [es:ebx + offset UsbPipe.controller]
mov edi, [es:esi + offset UsbController.hardware_func]
mov eax, [ss:esp + 28]  // td
push dword ptr [ss:esp + 4]  // origTD
call h_usb_undo_tds
xor eax, eax

add esp, 12
ret 20

// This procedure is called from the several places in main USB code
// and activates the transfer which was previously allocated by
// ohci_alloc_transfer.
// IN: ecx -> last descriptor for the transfer, ebx -> UsbPipe
h_ohci_insert_transfer:
// 1. Advance the queue of transfer descriptors.
mov eax, [es:ecx + offset OhciGtd.next_td - sizeof OhciGtd]
mov [es:ebx + offset OhciPipe.tail_p - sizeof OhciPipe], eax
// 2. For control and bulk pipes, notify the controller that
// there is new work in control/bulk queue respectively.

h_ohci_notify_new_work:
mov edx, [es:ebx + offset UsbPipe.controller]
mov edx, [es:edx + offset OhciController.mmio_base - sizeof OhciController]
cmp dword ptr [es:ebx + offset UsbPipe.type], CONTROL_PIPE
jz l_h_ohci_insert_transfer_control
  cmp dword ptr [es:ebx + offset UsbPipe.type], BULK_PIPE
  jnz l_h_ohci_insert_transfer_9
    
    l_h_ohci_insert_transfer_bulk:
    mov dword ptr [es:edx + OHCI_REG_COMMANDSTATUS], 4
    jmp l_h_ohci_insert_transfer_9
    
l_h_ohci_insert_transfer_control:
  mov dword ptr [es:edx + OHCI_REG_COMMANDSTATUS], 2

l_h_ohci_insert_transfer_9:
ret

// This procedure is called from uhci_port_init and from hub support code
// when a new device is connected and has been reset.
// It calls h_usb_new_device at the protocol layer with correct parameters.
// IN: esi -> UsbController, eax = speed
// OHCI is USB1 device, so only low bit of eax (LowSpeed) is used.
h_ohci_new_device:
// 1. Clear all bits of speed except bit 0.
and eax, 1
// 2. Store the speed for the protocol layer.
mov [es:esi + offset UsbController.resetting_speed], al
// 3. Create pseudo-pipe in the stack.
// See ohci_init_pipe: only .Controller and .Flags fields are used.
shl eax, 13
push esi     // .Controller
 mov ecx, esp
 sub esp, 12 // ignored fields
 push eax     // .Flags
  // 4. Notify the protocol layer.
  
  call h_usb_new_device
  
  // 5. Cleanup the stack after step 3 and return.
add esp, 20
ret

// This procedure temporarily removes the given pipe from hardware queue,
// keeping it in software lists.
// IN: esi -> UsbController, ebx -> UsbPipe
h_ohci_disable_pipe:
mov eax, [es:ebx + offset OhciPipe.next_ed - sizeof OhciPipe]
mov edx, [es:ebx + offset UsbPipe.prev_virt]
mov [es:edx + offset OhciPipe.next_ed - sizeof OhciPipe], eax
ret

// This procedure reinserts the given pipe from hardware queue
// after ehci_disable_pipe, with clearing transfer queue.
// IN: esi -> UsbController, ebx -> UsbPipe
//     edx -> current descriptor, eax -> new last descriptor
h_ohci_enable_pipe:
sub eax, sizeof OhciGtd
call h_usb_getphysadr
mov edx, [es:ebx + offset OhciPipe.head_p - sizeof OhciPipe]
and edx, 2
or eax, edx
mov [es:ebx + offset OhciPipe.head_p - sizeof OhciPipe], eax
lea eax, [ebx - sizeof OhciPipe]
call h_usb_getphysadr
mov edx, [es:ebx + offset UsbPipe.prev_virt]
mov ecx, [es:edx + offset OhciPipe.next_ed - sizeof OhciPipe]
mov [es:ebx + offset OhciPipe.next_ed - sizeof OhciPipe], ecx
mov [es:edx + offset OhciPipe.next_ed - sizeof OhciPipe], eax
ret

// EHCI register declarations.
// Part 1. Capability registers.
// Base is MMIO from the PCI space.
EHCI_REG_CAPLENGTH    = 0
EHCI_REG_VERSION      = 2
EHCI_REG_STRUCTPARAMS = 4
EHCI_REG_CAPPARAMS    = 8
EHCI_REG_PORTROUTE    = 0Ch
// Part 2. Operational registers.
// Base is (base for part 1) + (value of EHCI_REG_CAPLENGTH).
EHCI_REG_COMMAND      = 0
EHCI_REG_STATUS       = 4
EHCI_REG_INTERRUPT    = 8
EHCI_REG_FRAMEINDEX   = 0Ch
EHCI_REG_CTRLDATASEG  = 10h
EHCI_REG_PERIODICLIST = 14h
EHCI_REG_ASYNCLIST    = 18h
EHCI_REG_CONFIGFLAG   = 40h
EHCI_REG_PORTS        = 44h

// Local variables of h_ehci_select_tt_interrupt_list
struct UsbSplitInfo{
  uns4 microframe_mask  //lower byte is S-mask, second byte is C-mask
  uns4 ssplit_bandwidth
  uns4 csplit_bandwidth  
}

struct EhciTT{
  UsbSplitInfo info
  uns2 new_budget
  uns2 total_budget
  uns4 possible_microframes
  uns4 tthub
  uns2 budget[8]
  uns2 hs_bandwidth[8]
  uns2 max_hs_bandwidth[8]
  uns2 max_fs_bandwidth
  uns2 best_fs_bandwidth
  uns4 variant
  uns4 variant_delta
  uns4 target_delta
}

// Hardware part of EHCI general transfer descriptor.
struct EhciHardwareTd{
  uns4 next_td
  // Bit 0 is Terminate bit, 1 = there is no next TD.
  // Bits 1-4 must be zero.
  // With masked 5 lower bits, this is the physical address of the next TD, if any.
  uns4 alternate_next_td
  // Similar to NextTD, used if the transfer terminates with a short packet.
  uns4 token
  // 1. Lower byte is Status field:
  // bit 0 = ping state for USB2 endpoints, ERR handshake signal for USB1 endpoints
  // bit 1 = split transaction state, meaningless for USB2 endpoints
  // bit 2 = missed micro-frame
  // bit 3 = transaction error
  // bit 4 = babble detected
  // bit 5 = data buffer error
  // bit 6 = halted
  // bit 7 = active
  // 2. Next two bits (bits 8-9) are PID code, 0 = OUT, 1 = IN, 2 = SETUP.
  // 3. Next two bits (bits 10-11) is ErrorCounter. Initialized as 3, decremented
  //    on each error; if it goes to zero, transaction is stopped.
  // 4. Next 3 bits (bits 12-14) are CurrentPage field.
  // 5. Next bit (bit 15) is InterruptOnComplete bit.
  // 6. Next 15 bits (bits 16-30) are TransferLength field,
  //    number of bytes to transfer.
  // 7. Upper bit (bit 31) is DataToggle bit.
  uns4 buffer_pointers[5]
  // The buffer to be transferred can be spanned on up to 5 physical pages.
  // The first item of this array is the physical address of the first byte in
  // the buffer, other items are physical addresses of next pages. Lower 12 bits
  // in other items must be set to zero; ehci_pipe.Overlay reuses some of them.
  uns4 buffer_pointers_high[5]
  // Upper dwords of BufferPointers for controllers with 64-bit memory access.
  // Always zero.
}

// EHCI general transfer descriptor.
// * The structure describes transfers to be performed on Control, Bulk or
//   Interrupt endpoints.
// * The structure includes two parts, the hardware part and the software part.
// * The hardware part consists of first 52 bytes and corresponds to
//   the Queue Element Transfer Descriptor from EHCI specification.
// * The hardware requires 32-bytes alignment of the hardware part, so
//   the entire descriptor must be 32-bytes aligned. Since the allocator
//   (usb_allocate_common) allocates memory sequentially from page start
//   (aligned on 0x1000 bytes), block size for the allocator must be divisible
//   by 32; ehci_alloc_td ensures this.
// * The hardware also requires that the hardware part must not cross page
//   boundary// the allocator satisfies this automatically.
struct EhciGtd{
  EhciHardwareTd htd
  uns4 flags  // Copy of flags from the call to usb_*_transfer_async
}

// EHCI-specific part of a pipe descriptor.
// * This structure corresponds to the Queue Head from the EHCI specification.
// * The hardware requires 32-bytes alignment of the hardware part.
//   Since the allocator (usb_allocate_common) allocates memory sequentially
//   from page start (aligned on 0x1000 bytes), block size for the allocator
//   must be divisible by 32; ehci_alloc_pipe ensures this.
// * The hardware requires also that the hardware part must not cross page
//   boundary; the allocator satisfies this automatically.
struct EhciPipe{
  uns4 next_qh
  // 1. First bit (bit 0) is Terminate bit, 1 = there is no next QH.
  // 2. Next two bits (bits 1-2) are Type field of the next QH,
  //    one of EHCI_TYPE_* constants.
  // 3. Next two bits (bits 3-4) are reserved, must be zero.
  // 4. With masked 5 lower bits, this is the physical address of the next object
  //    to be processed, usually next QH.
  uns4 token
  // 1. Lower 7 bits are DeviceAddress field. This is the address of the
  //    target device on the USB bus.
  // 2. Next bit (bit 7) is Inactivate-on-next-transaction bit. Can be nonzero
  //    only for interrupt/isochronous USB1 endpoints.
  // 3. Next 4 bits (bits 8-11) are Endpoint field. This is the target endpoint
  //    number.
  // 4. Next 2 bits (bits 12-13) are EndpointSpeed field, one of EHCI_SPEED_*.
  // 5. Next bit (bit 14) is DataToggleControl bit,
  //    0 = use DataToggle bit from QH, 1 = from TD.
  // 6. Next bit (bit 15) is Head-of-reclamation-list. The head of Control list
  //    has 1 here, all other QHs have zero.
  // 7. Next 11 bits (bits 16-26) are MaximumPacketLength field for the target
  //    endpoint.
  // 8. Next bit (bit 27) is ControlEndpoint bit, must be 1 for USB1 control
  //    endpoints and 0 for all others.
  // 9. Upper 4 bits (bits 28-31) are NakCountReload field.
  //    Zero for USB1 endpoints, zero for periodic endpoints.
  //    For control/bulk USB2 endpoints, the code sets it to 4,
  //    which is rather arbitrary.
  uns4 flags
  // 1. Lower byte is S-mask, each bit corresponds to one microframe per frame//
  //    bit is set <=> enable transactions in this microframe.
  // 2. Next byte is C-mask, each bit corresponds to one microframe per frame//
  //    bit is set <=> enable complete-split transactions in this microframe.
  //    Meaningful only for USB1 endpoints.
  // 3. Next 14 bits give address of the target device as hub:port, bits 16-22
  //    are the USB address of the hub, bits 23-29 are the port number.
  //    Meaningful only for USB1 endpoints.
  // 4. Upper 2 bits define number of consequetive transactions per micro-frame
  //    which host is allowed to permit for this endpoint.
  //    For control/bulk endpoints, it must be 1.
  //    For periodic endpoints, the value is taken from the endpoint descriptor.
  uns4 head_td
  // The physical address of the first TD for this pipe.
  // Lower 5 bits must be zero.
  EhciHardwareTd overlay
  // Working area for the current TD, if there is any.
  // When TD is retired, it is written to that TD and Overlay is loaded
  // from the new TD, if any.
}

// This structure describes the static head of every list of pipes.
// The hardware requires 32-bytes alignment of this structure.
// All instances of this structure are located sequentially in ehci_controller,
// ehci_controller is page-aligned, so it is sufficient to make this structure
// 32-bytes aligned and verify that the first instance is 32-bytes aligned
// inside ehci_controller.
// The hardware also requires that 44h bytes (size of 64-bit Queue Head
// Descriptor) starting at the beginning of this structure must not cross page
// boundary. If not, most hardware still behaves correctly (in fact, the last
// dword can have any value and this structure is never written), but on some
// hardware some things just break in mysterious ways.
struct EhciStaticEp{
  // Hardware fields are the same as in ehci_pipe.
  // Only NextQH and Overlay.Token are actually used.
  // NB: some emulators ignore Token.Halted bit (probably assuming that it is set
  // only when device fails and emulation never fails) and always follow
  // [Alternate]NextTD when they see that OverlayToken.Active bit is zero;
  // so it is important to also set [Alternate]NextTD to 1.
  uns4 next_qh
  uns4 token
  uns4 flags
  uns4 head_td
  uns4 next_td
  uns4 alternate_next_td
  uns4 overlay_token
  uns4 next_list
  uns4 software_part[sizeof UsbStaticEp / 4]
  uns2 bandwidths[8]
  uns4 rsv1
}

//if sizeof.ehci_static_ep mod 32
//.err ehci_static_ep must be 32-bytes aligned
//end if
 
//if ehci_static_ep.OverlayToken <> ehci_pipe.Overlay.Token
//.err ehci_static_ep.OverlayToken misplaced
//end if

EHCI_CONTROLLER_DELTA = 2000h - (1000h + (63 * sizeof EhciStaticEp))

// EHCI-specific part of controller data.
// * The structure includes two parts, the hardware part and the software part.
// * The hardware part consists of first 4096 bytes and corresponds to
//   the Periodic Frame List from the EHCI specification.
// * The hardware requires page-alignment of the hardware part, so
//   the entire descriptor must be page-aligned.
//   This structure is allocated with kernel_alloc (see usb_init_controller),
//   this gives page-aligned data.
// * The controller is described by both ehci_controller and usb_controller
//   structures, for each controller there is one ehci_controller and one
//   usb_controller structure. These structures are located sequentially
//   in the memory: beginning from some page start, there is ehci_controller
//   structure - this enforces hardware alignment requirements - and then
//   usb_controller structure.
// * The code keeps pointer to usb_controller structure. The ehci_controller
//   structure is addressed as [ptr + ehci_controller.field - sizeof.ehci_controller].
struct EhciController{
  // ------------------------------ hardware fields ------------------------------
  uns4 frame_list[1024]
  // Entry n corresponds to the head of the frame list to be executed in
  // the frames n,n+1024,n+2048,n+3072,...
  // The first bit of each entry is Terminate bit, 1 = the frame is empty.
  // Bits 1-2 are Type field, one of EHCI_TYPE_* constants.
  // Bits 3-4 must be zero.
  // With masked 5 lower bits, the entry is a physical address of the first QH/TD
  // to be executed.
  // ------------------------------ software fields ------------------------------
  // Every list has the static head, which is an always halted QH.
  // The following fields are static heads, one per list:
  // 32+16+8+4+2+1 = 63 for Periodic lists, 1 for Control list and 1 for Bulk list.
  EhciStaticEp int_eds[63]
  // !!!
  // 44h bytes at any static head
  // must not cross page boundary. Without that, the code "works on my machine"...
  // but fails on some hardware in seemingly unrelated ways.
  // One hardware TD (without any software fields) fit in the rest of the page.
  EhciHardwareTd stop_queue_td  
  // Used as AlternateNextTD for transfers when short packet is considered
  // as an error; short packet must stop the queue in this case, not advance
  // to the next transfer.
  
  // Padding for page-alignment
  uns1 rsv1[EHCI_CONTROLLER_DELTA - sizeof EhciHardwareTd]
  
  EhciStaticEp control_ed
  EhciStaticEp bulk_ed
  uns4 mmio_base1
  // Virtual address of memory-mapped area with part 1 of EHCI registers EhciXxxReg.
  uns4 mmio_base2
  // Pointer inside memory-mapped area MMIOBase1; points to part 2 of EHCI registers.
  uns4 structural_params
  // Copy of EhciStructParamsReg value.
  uns4 capability_params
  // Copy of EhciCapParamsReg value.
  uns4 deferred_actions
  // Bitmask of events from EhciStatusReg which were observed by the IRQ handler
  // and needs to be processed in the IRQ thread.
  uns1 port_routes[16]
  // Companion port route description.
  // Each byte describes routing of one port, value = PCI function.
  // This field must be the last one:
  // UHCI/OHCI code uses this field without knowing the entire structure.
}
 
//if ehci_controller.IntEDs mod 32
//.err Static endpoint descriptors must be 32-bytes aligned inside ehci_controller
//end if

// Helper procedure for USB2 scheduler: calculate bandwidth on the bus.
// IN: low 11 bits of eax = payload size in bytes
// OUT: eax = maximal bandwidth in HS-bits
h_ehci_calc_hs_bandwidth:
and eax, (1 << 11) - 1  // get payload for one transaction
add eax, 3  // add 3 bytes for other fields in data packet, PID+CRC16
// Multiply by 8 for bytes -> bits and then by 7/6 to accomodate bit stuffing;
// total 28/3 = 9+1/3
mov edx, 55555556h
lea ecx, [eax * 8 + eax]
mul edx
// Add 989 extra bits: 68 bits for Token packet (32 for SYNC, 24 for token+address,
// 4 extra bits for possible bit stuffing in token+address, 8 for EOP),
// 736 bits for bus turn-around, 40 bits for SYNC+EOP in Data packet,
// 8 bits for inter-packet delay, 49 bits for Handshake packet,
// 88 bits for another inter-packet delay.
lea eax, [ecx + edx + 989]
ret

// IN: esi -> usb_controller,
//     [ebp+12] = endpoint, [ebp+16] = maxpacket, [ebp+20] = type, [ebp+24] = interval
// OUT: edx -> usb_static_ep, eax = S-Mask
h_ehci_select_hs_interrupt_list:
/*
// inherit some variables from h_usb_open_pipe
virtual at ebp-12
ebp-12 speed
ebp-8 bandwidth
ebp-4 target
ebp+8 config_pipe
ebp+12 endpoint
ebp+16 maxpacket
ebp+20 type
ebp+24 interval
end virtual
*/

// prolog, initialize local vars
or dword ptr [es:ebp - 8], -1  // bandwidth
or dword ptr [es:ebp - 4], -1  // target
or dword ptr [es:ebp - 12], -1  // speed
push ebx
 push edi         // save used registers to be stdcall
  // 1. In EHCI, every list describes one millisecond = 8 microframes.
  // Thus, there are two significantly different branches:
  // for pipes with interval >= 8 microframes, advance to 2,
  // for pipes which should be planned in every frame (one or more microframes),
  // go to 9.
  // Note: the actual interval for high-speed devices is 2^([.interval]-1),
  // (the core specification forbids [.interval] == 0)
  mov ecx, [es:ebp + 24]  // interval
  dec ecx
  cmp ecx, 3
  jb near l_h_ehci_sel_hs_every_frame
    // 2. Determine the actual interval in milliseconds.
    sub ecx, 3
    cmp ecx, 5  // maximum 32ms
    jna l_h_ehci_sel_hs_1
      mov ecx, 5
      
    l_h_ehci_sel_hs_1:
    // There are four nested loops,
    // * Loop #4 (the innermost one) calculates the total periodic bandwidth
    //   scheduled in the given microframe of the given millisecond.
    // * Loop #3 calculates the maximum over all milliseconds
    //   in the given variant, that is the quantity we're trying to minimize.
    // * Loops #1 and #2 check all variants//
    //   loop #1 is responsible for the target millisecond,
    //   loop #2 is responsible for the microframe within millisecond.
    // 3. Prepare for loops.
    // ebx = number of iterations of loop #1
    // [ss:esp] = delta of counter for loop #3, in bytes
    // [ss:esp+4] = delta between the first group and the target group, in bytes
    mov ebx, 1
    mov edx, sizeof EhciStaticEp
    shl ebx, cl
    shl edx, cl
    mov eax, 64 * sizeof EhciStaticEp
    sub eax, edx
    sub eax, edx
    push eax
     push edx
      // 4. Select the best variant.
      // 4a. Loop #1: initialize counter = pointer to EhciStaticEp for
      // the target millisecond in the first group.
      lea edx, [esi + offset EhciController.int_eds - sizeof EhciController]
      
      l_h_ehci_sel_hs_5:
      // 4b. Loop #2: initialize counter = microframe within the target millisecond.
      xor ecx, ecx
      
      l_h_ehci_sel_hs_55:
      // 4c. Loop #3: save counter of loop #1,
      // initialize counter with the value of loop #1 counter,
      // initialize maximal bandwidth = zero.
      xor edi, edi
      push edx
        //virtual at esp
        //.saved_counter1         dd      ?       // step 4c
        //.loop3_delta            dd      ?       // step 3
        //.target_delta           dd      ?       // step 3
        //end virtual
        
        l_h_ehci_sel_hs_calc_max_bandwidth:
        // 4d. Loop #4: initialize counter with the value of loop #3 counter,
        // initialize total bandwidth = zero.
        xor eax, eax
        push edx
          
          l_h_ehci_sel_hs_calc_bandwidth:
          // 4e. Loop #4: add the bandwidth from the current list
          // and advance to the next list, while there is one.
          add ax, [es:edx + offset EhciStaticEp.bandwidths + ecx * 2]
          mov edx, [es:edx + offset EhciStaticEp.next_list]
          test edx, edx
          jnz l_h_ehci_sel_hs_calc_bandwidth
          
        // 4f. Loop #4 end: restore counter of loop #3.
        pop     edx
        // 4g. Loop #3: update maximal bandwidth.
        cmp eax, edi
        jb l_h_ehci_sel_hs_551
          mov edi, eax
          
        l_h_ehci_sel_hs_551:
        // 4h. Loop #3: advance the counter and repeat while within the first group.
        lea eax, [esi + offset EhciController.int_eds + (32 * sizeof EhciStaticEp) - sizeof EhciController]
        add edx, [ss:esp + 4] //.loop3_delta
        cmp edx, eax
        jb l_h_ehci_sel_hs_calc_max_bandwidth
        
        // 4i. Loop #3 end: restore counter of loop #1.
      pop edx
      // 4j. Loop #2: if the current variant is better (maybe not strictly)
      // then the previous optimum, update the optimal bandwidth and the target.
      cmp edi, [es:ebp - 8]  // bandwidth
      ja l_h_ehci_sel_hs_552
        jb l_h_ehci_sel_hs_update
          cmp ecx, [es:ebp - 12]  // speed
          jb l_h_ehci_sel_hs_552
          
        l_h_ehci_sel_hs_update:
        mov [es:ebp - 8], edi  // bandwidth
        mov [es:ebp - 4], edx  // target
        mov [es:ebp - 12], ecx  // speed
        
      l_h_ehci_sel_hs_552:
      // 4k. Loop #2: continue 8 times for every microframe.
      inc ecx
      cmp ecx, 8
      jb near l_h_ehci_sel_hs_55
      
      // 4l. Loop #1: advance counter and repeat ebx times,
      // ebx was calculated in step 3.
      add edx, sizeof EhciStaticEp
      dec ebx
      jnz l_h_ehci_sel_hs_5
      
      // 5. Calculate bandwidth for the new pipe.
      mov eax, [es:ebp + 16]  // maxpacket
      call h_ehci_calc_hs_bandwidth
      mov ecx, [es:ebp + 16]  // maxpacket
      shr ecx, 11
      inc ecx
      and ecx, 3
      imul eax, ecx
      // 6. Get the pointer to the best list.
     pop edx  // restore value from step 3
    pop edx  // get delta calculated in step 3
    add edx, [es:ebp - 4]  // target
    // 7. Check that bandwidth for the new pipe plus old bandwidth
    // still fits to maximum allowed by the core specification
    // current [.bandwidth] + new bandwidth <= limit//
    // USB2 specification allows maximum 60000*80% bit times for periodic microframe
    mov ecx, [es:ebp - 8]  // bandwidth
    add ecx, eax
    cmp ecx, 48000
    ja l_h_ehci_sel_hs_no_bandwidth
      // 8. Convert {o|u}hci_static_ep to usb_static_ep, update bandwidth and return.
      mov ecx, [es:ebp - 12]  // speed
      add [es:edx + offset EhciStaticEp.bandwidths + ecx * 2], ax
      add edx, offset EhciStaticEp.software_part
      mov eax, 1
      shl eax, cl
 pop edi
pop ebx  // restore used registers

ret

    l_h_ehci_sel_hs_no_bandwidth:
    xor eax, eax
    xor edx, edx
 pop edi
pop ebx

ret

  l_h_ehci_sel_hs_every_frame:
  // The pipe should be scheduled every frame in two or more microframes.
  // 9. Calculate maximal bandwidth for every microframe: three nested loops.
  // 9a. The outermost loop: ebx = microframe to calculate.
  xor ebx, ebx
  
  l_h_ehci_sel_hs_calc_all_bandwidths:
  // 9b. The intermediate loop:
  // edx = pointer to EhciStaticEp in the first group, [ss:esp] = counter,
  // edi = maximal bandwidth
  lea edx, [esi + offset EhciController.int_eds - sizeof EhciController]
  xor edi, edi
  push 32
    
    l_h_ehci_sel_hs_calc_max_bandwidth2:
    // 9c. The innermost loop: calculate bandwidth for the given microframe
    // in the given frame.
    xor eax, eax
    push edx
      
      l_h_ehci_sel_hs_calc_bandwidth2:
      add ax, [es:edx + offset EhciStaticEp.bandwidths + ebx * 2]
      mov edx, [es:edx + offset EhciStaticEp.next_list]
      test edx, edx
      jnz l_h_ehci_sel_hs_calc_bandwidth2
      
    pop edx
    // 9d. The intermediate loop continued: update maximal bandwidth.
    cmp eax, edi
    jb l_h_ehci_sel_hs_6
      mov edi, eax
      
    l_h_ehci_sel_hs_6:
    add edx, sizeof EhciStaticEp
    dec dword ptr [ss:esp]
    jnz l_h_ehci_sel_hs_calc_max_bandwidth2
    
  pop eax
  // 9e. Push the calculated maximal bandwidth and continue the outermost loop.
  push edi  // !!! pushes 8*
    inc ebx
    cmp ebx, 8
    jb l_h_ehci_sel_hs_calc_all_bandwidths
    
    /*
    virtual at esp
    .bandwidth7     dd      ?
    .bandwidth6     dd      ?
    .bandwidth5     dd      ?
    .bandwidth4     dd      ?
    .bandwidth3     dd      ?
    .bandwidth2     dd      ?
    .bandwidth1     dd      ?
    .bandwidth0     dd      ?
    end virtual
    */
    
    // 10. Select the best variant.
    // edx = S-Mask = bitmask of scheduled microframes
    mov edx, 0x11
    cmp ecx, 1
    ja l_h_ehci_sel_hs_71
      mov dl, 0x55
      jz l_h_ehci_sel_hs_71
        mov dl, 0xFF
        
    l_h_ehci_sel_hs_71:
    // try all variants edx, edx shl 1, edx shl 2, ...
    // while they fit in the lower byte (8 microframes per frame)
    
    l_h_ehci_sel_hs_select_best_mframe:
      xor edi, edi
      mov ecx, edx
      mov eax, esp
      
      l_h_ehci_sel_hs_calc_mframe:
        add cl, cl
        jnc l_h_ehci_sel_hs_72
          cmp edi, [ss:eax]
          jnb l_h_ehci_sel_hs_72
            mov edi, [ss:eax]
            
        l_h_ehci_sel_hs_72:
        add eax, 4
        test cl, cl
        jnz l_h_ehci_sel_hs_calc_mframe
      
      cmp [es:ebp - 8], edi  // bandwidth
      jb l_h_ehci_sel_hs_73
        mov [es:ebp - 8], edi  // bandwidth
        mov [es:ebp - 12], edx  // speed
        
      l_h_ehci_sel_hs_73:
      add dl, dl
      jnc l_h_ehci_sel_hs_select_best_mframe
      
    // 11. Restore stack after step 9.
  add esp, 8 * 4
  // 12. Get the pointer to the target list (responsible for every microframe).
  lea edx, [esi + offset EhciController.int_eds.software_part + (62 * sizeof EhciStaticEp) - sizeof EhciController]
  // 13. Calculate bandwidth on the bus.
  mov eax, [es:ebp + 16]  // maxpacket
  call h_ehci_calc_hs_bandwidth
  mov ecx, [es:ebp + 16]  // maxpacket
  shr ecx, 11
  inc ecx
  and ecx, 3
  imul eax, ecx
  // 14. Check that current [.bandwidth] + new bandwidth <= limit//
  // USB2 specification allows maximum 60000*80% bit times for periodic microframe.
  mov ecx, [es:ebp - 8]  // bandwidth
  add ecx, eax
  cmp ecx, 48000
  ja near l_h_ehci_sel_hs_no_bandwidth
  
  // 15. Update bandwidths including the new pipe.
  mov ecx, [es:ebp - 12]  // speed
  lea edi, [edx + offset EhciStaticEp.bandwidths - offset EhciStaticEp.software_part]
  
  l_h_ehci_sel_hs_update_bandwidths:
    shr ecx, 1
    jnc l_h_ehci_sel_hs_81
      add [es:edi], ax
      
    l_h_ehci_sel_hs_81:
    add edi, 2
    test ecx, ecx
    jnz l_h_ehci_sel_hs_update_bandwidths
    
  // 16. Return target list and target S-Mask.
  mov eax, [es:ebp - 12]  // speed
 pop edi 
pop ebx  // restore used registers
ret

// Helper procedure for ehci_select_tt_interrupt_list.
// Calculates "best-case budget" according to the core spec,
// that is, number of bytes (not bits) corresponding to "optimistic" transaction
// time, including inter-packet delays/bus turn-around time,
// but without bit stuffing and timers drift.
// One extra TT-specific delay is added: TT think time from the hub descriptor.
// Similar to calc_usb1_bandwidth with corresponding changes.
// IN: eax -> UsbHub with TT, ebx -> UsbPipe
// OUT: eax
h_ehci_tt_calc_budget:
call h_usb_get_tt_think_time // OUT: ecx = TT think time in FS-bytes
mov eax, [es:ebx + offset EhciPipe.token - sizeof EhciPipe]
shr eax, 16
and eax, (1 << 11) - 1  // get data length
bt dword ptr [es:ebx + offset EhciPipe.token - sizeof EhciPipe], 12
jc l_h_ehci_tt_calc_budget_low_speed
  // Full-speed interrupt IN/OUT:
  // 33 bits for Token packet (8 for SYNC, 24 for token+address, 3 for EOP),
  // 18 bits for bus turn-around, 11 bits for SYNC+EOP in Data packet,
  // 2 bits for inter-packet delay, 19 bits for Handshake packet,
  // 2 bits for another inter-packet delay. 85 bits total, pad to 11 bytes.
  lea eax, [eax + 11 + ecx]
  // 1 byte is minimal TT think time in addition to ecx.
  ret
  
l_h_ehci_tt_calc_budget_low_speed:
// Low-speed interrupt IN/OUT:
// multiply by 8 for LS -> FS,
// add 85 bytes as in full-speed interrupt and extra 5 bytes for two PRE packets
// and two hub delays.
// 1 byte is minimal TT think time in addition to ecx.
lea eax, [eax * 8 + 90 + ecx]
ret

// Helper procedure for TT scheduler.
// Calculates Start-Split/Complete-Split masks and HS bandwidths.
// IN: ebx -> UsbPipe, ss:edi -> UsbSplitInfo
h_ehci_tt_fill_split_info:
// Interrupt endpoints.
// The core spec says in 5.7.3 "Interrupt Transfer Packet Size Constraints" that:
// The maximum allowable interrupt data payload size is 64 bytes or less for full-speed.
// Low-speed devices are limited to eight bytes or less maximum data payload size.
// This is important for scheduling, it guarantees that in any case transaction fits
// in two microframes (usually one, two if transaction has started too late in the first
// microframe), so check it.
mov eax, [es:ebx + offset EhciPipe.token - sizeof EhciPipe]
mov ecx, 8
bt eax, 12
jc l_h_ehci_tt_fill_split_info_1
  mov ecx, 64
  
l_h_ehci_tt_fill_split_info_1:
shr eax, 16
and eax, (1 << 11) - 1  // get data length
cmp eax, ecx
ja l_h_ehci_tt_fill_split_info_error
  add eax, 3  // add 3 bytes for other fields in data packet, PID+CRC16
  // Multiply by 8 for bytes -> bits and then by 7/6 to accomodate bit stuffing//
  // total 28/3 = 9+1/3
  mov edx, 55555556h
  lea ecx, [eax * 8 + eax]
  mul edx
  // One start-split, three complete-splits (unless the last is too far,
  // but this is handled by the caller).
  mov eax, [es:ebx + offset UsbPipe.last_td]
  mov dword ptr [ss:edi + offset EhciTT.info.microframe_mask], 0x1C01
  // Structure and HS bandwidth of packets depends on the direction.
  bt dword ptr [es:eax + offset EhciGtd.htd.token - sizeof EhciGtd], 8
  jc l_h_ehci_tt_fill_split_info_in
      
    l_h_ehci_tt_fill_split_info_out:
    // Start-Split phase:
    // 77 bits for SPLIT packet (32 for SYNC, 8 for EOP, 32 for data, 5 for bit stuffing),
    // 88 bits for inter-packet delay, 68 bits for Token packet,
    // 88 bits for inter-packet delay, 40 bits for SYNC+EOP in Data packet,
    // 88 bits for last inter-packet delay, total 449 bits.
    lea eax, [edx + ecx + 449]
    mov [ss:edi + offset EhciTT.info.ssplit_bandwidth], eax
    // Complete-Split phase:
    // 77 bits for SPLIT packet,
    // 88 bits for inter-packet delay, 68 bits for Token packet,
    // 736 bits for bus turn-around, 49 bits for Handshake packet,
    // 8 bits for inter-packet delay, total 1026 bits.
    mov dword ptr [ss:edi + offset EhciTT.info.csplit_bandwidth], 1026
    
    ret
    
  l_h_ehci_tt_fill_split_info_in:
  // Start-Split phase:
  // 77 bits for SPLIT packet, 88 bits for inter-packet delay,
  // 68 bits for Token packet, 88 bits for another inter-packet delay,
  // total 321 bits.
  mov dword ptr [ss:edi + offset EhciTT.info.ssplit_bandwidth], 321
  // Complete-Split phase:
  // 77 bits for SPLIT packet, 88 bits for inter-packet delay,
  // 68 bits for Token packet, 736 bits for bus turn-around,
  // 40 bits for SYNC+EOP in Data packet, 8 bits for inter-packet delay,
  // total 1017 bits.
  lea eax, [edx + ecx + 1017]
  mov [ss:edi + offset EhciTT.info.csplit_bandwidth], eax
  
  ret
  
l_h_ehci_tt_fill_split_info_error:
xor eax, eax
ret

// TT scheduler: add new pipe.
// IN: esi -> UsbController, edi -> UsbPipe,
//     [ebp+12] = endpoint, [ebp+16] = maxpacket, [ebp+20] = type, [ebp+24] = interval
// OUT: edx -> UsbStaticEp, eax = S-Mask
h_ehci_select_tt_interrupt_list:
/*
// inherit some variables from h_usb_open_pipe
virtual at ebp-12
ebp-12 speed
ebp-8 bandwidth
ebp-4 target
ebp+8 config_pipe
ebp+12 endpoint
ebp+16 maxpacket
ebp+20 type
ebp+24 interval
end virtual
*/

push ebx
 push edi
  sub esp, sizeof EhciTT
  
  mov eax, [es:edi + offset EhciPipe.token - sizeof EhciPipe]
  shr eax, 16
  and eax, (1 << 11) - 1
  // 1. Compute the real interval. FS/LS devices encode the interval as
  // number of milliseconds. Use the maximal power of two that is not greater than
  // the given interval and EHCI scheduling area = 32 frames.
  cmp dword ptr [es:ebp + 24], 1  // interval
  adc dword ptr [es:ebp + 24], 0  // interval
  mov ecx, 64
  mov eax, 64 * sizeof EhciStaticEp
  
  l_h_ehci_select_tt_11:
    shr ecx, 1
    cmp [es:ebp + 24], ecx  // interval
    jb l_h_ehci_select_tt_11
    
  mov [es:ebp + 24], ecx  // interval
  // 2. Compute variables for further calculations.
  // 2a. [.variant_delta] is delta between two lists from the first group
  // that correspond to the same variant.
  imul ecx, sizeof EhciStaticEp
  mov [ss:esp + offset EhciTT.variant_delta], ecx
  // 2b. [.target_delta] is delta between the final answer from the group
  // corresponding to [.interval] and the item from the first group.
  sub eax, ecx
  sub eax, ecx
  mov [ss:esp + offset EhciTT.target_delta], eax
  // 2c. [.variant] is the first list from the first group that corresponds
  // to the current variant.
  lea eax, [esi + offset EhciController.int_eds - sizeof EhciController]
  mov [ss:esp + offset EhciTT.variant], eax
  // 2d. [.tthub] identifies TT hub for new pipe, [.new_budget] is FS budget
  // for new pipe.
  mov eax, [es:edi + offset UsbPipe.device_data]
  mov eax, [es:eax + offset UsbDevData.tt_hub]
  mov ebx, edi
  mov [ss:esp + offset EhciTT.tthub], eax
  call h_ehci_tt_calc_budget
  mov [ss:esp + offset EhciTT.new_budget], ax
  // 2e. [.usb_split_info] describes bandwidth used by new pipe on HS bus.
  lea edi, [esp + offset EhciTT.info.microframe_mask]
  call h_ehci_tt_fill_split_info
  test eax, eax
  jz near l_h_ehci_select_tt_no_bandwidth
   // 2f. There is no best variant yet, put maximal possible values,
   // so any variant would be better than the "current".
   or word ptr [ss:esp + offset EhciTT.best_fs_bandwidth], -1
   or dword ptr [es:ebp - 4], -1  // target
   or dword ptr [es:ebp - 8], -1  // bandwidth
   or dword ptr [es:ebp - 12], -1  // speed
   // 3. Loop over all variants, for every variant decide whether it is acceptable,
   // select the best variant from all acceptable variants.
   
   l_h_ehci_select_tt_check_variants:
    
    //tt_calc_statistics_for_one_variant
    xor eax, eax
    mov dword ptr [ss:esp + offset EhciTT.max_hs_bandwidth], eax
    mov dword ptr [ss:esp + offset EhciTT.max_hs_bandwidth + 4], eax
    mov dword ptr [ss:esp + offset EhciTT.max_hs_bandwidth + 8], eax
    mov dword ptr [ss:esp + offset EhciTT.max_hs_bandwidth + 12], eax
    mov [ss:esp + offset EhciTT.max_fs_bandwidth], ax
    mov dword ptr [ss:esp + offset EhciTT.possible_microframes], 0x3F
    // Loop over all frames starting with [.variant] advancing by [.variant_delta].
    mov edi, [ss:esp + offset EhciTT.variant]
    
    l_h_ehci_select_tt_frames:
    // 2. Calculate statistics for one frame.
    
    // * tt_calc_bandwidth_in_frame *
    
      // 1. Zero everything.
      xor eax, eax
      mov edx, edi
      
      mov dword ptr [ss:esp + offset EhciTT.budget], eax
      mov dword ptr [ss:esp + offset EhciTT.budget + 4], eax
      mov dword ptr [ss:esp + offset EhciTT.budget + 8], eax
      mov dword ptr [ss:esp + offset EhciTT.budget + 12], eax
      
      mov dword ptr [ss:esp + offset EhciTT.hs_bandwidth], eax
      mov dword ptr [ss:esp + offset EhciTT.hs_bandwidth + 4], eax
      mov dword ptr [ss:esp + offset EhciTT.hs_bandwidth + 8], eax
      mov dword ptr [ss:esp + offset EhciTT.hs_bandwidth + 12], eax
      
      mov [ss:esp + offset EhciTT.total_budget], ax
      // Loop over all lists for the given frame.
      l_h_ehci_select_tt_lists:
        // 2. Total HS bandwidth for all pipes in one list is kept inside list header,
        // add it. Note that overflow is impossible, so we may add entire dwords.
        mov ebx, [es:edx + offset EhciStaticEp.software_part + offset UsbStaticEp.next_virt]
        
        mov eax, dword [es:edx + offset EhciStaticEp.bandwidths]
        add [ss:esp + offset EhciTT.hs_bandwidth], eax
        mov eax, dword [es:edx + offset EhciStaticEp.bandwidths + 4]
        add [ss:esp + offset EhciTT.hs_bandwidth + 4], eax
        mov eax, dword [es:edx + offset EhciStaticEp.bandwidths + 8]
        add [ss:esp + offset EhciTT.hs_bandwidth + 8], eax
        mov eax, dword [es:edx + offset EhciStaticEp.bandwidths + 12]
        add [ss:esp + offset EhciTT.hs_bandwidth + 12], eax
        
        // Loop over all pipes in the given list.
        add edx, offset EhciStaticEp.software_part
        
        l_h_ehci_select_tt_pipes:
         cmp ebx, edx
         jz l_h_ehci_select_tt_pipes8
          // 3. For every pipe in every list for the given frame:
          // 3a. Check whether the pipe resides on the same FS/LS bus as the new pipe.
          // If not, skip this pipe.
          mov eax, [es:ebx + offset UsbPipe.device_data]
          mov eax, [es:eax + offset UsbDevData.tt_hub]
          cmp eax, [ss:esp + offset EhciTT.tthub]
          jnz l_h_ehci_select_tt_pipes2
            // 3b. Calculate FS/LS budget for the opened pipe.
            // Note that eax = TTHub after 3a.
            call h_ehci_tt_calc_budget
            // 3c. Update total budget: add the value from 3b
            // to the budget of the first microframe scheduled for this pipe.
            bsf ecx, [es:ebx + offset EhciPipe.flags - sizeof EhciPipe]
            add [ss:esp + offset EhciTT.budget + ecx * 2], ax
            
          l_h_ehci_select_tt_pipes2:
          mov ebx, [es:ebx + offset UsbPipe.next_virt]
          jmp l_h_ehci_select_tt_pipes
          
        l_h_ehci_select_tt_pipes8:
        mov edx, [es:edx + offset EhciStaticEp.next_list - offset EhciStaticEp.software_part]
        test edx, edx
        jnz l_h_ehci_select_tt_lists
        
      // 4. If the budget for some microframe is exceeded, carry it to the following
      // microframe(s). The actual size of one microframe is 187.5 raw bytes;
      // the core spec says that 188 bytes should be scheduled in every microframe.
      xor eax, eax
      xor ecx, ecx
      l_h_ehci_select_tt_carry:
        xor edx, edx
        add ax, [ss:esp + offset EhciTT.budget + ecx * 2]
        cmp ax, 188
        jna l_h_ehci_select_tt_carry2
          mov dx, ax
          mov ax, 188
          sub dx, ax
          
        l_h_ehci_select_tt_carry2:
        mov [ss:esp + offset EhciTT.budget + ecx * 2], ax
        add [ss:esp + offset EhciTT.total_budget], ax
        mov ax, dx
        inc ecx
        cmp ecx, 8
        jb l_h_ehci_select_tt_carry
      // end * tt_calc_bandwidth_in_frame *
          
      // 3. Update maximal FS budget.
      mov ax, [ss:esp + offset EhciTT.total_budget]
      cmp ax, [ss:esp + offset EhciTT.max_fs_bandwidth]
      jb l_h_ehci_select_tt_32
        mov [ss:esp + offset EhciTT.max_fs_bandwidth], ax
        
      l_h_ehci_select_tt_32:
      // 4. For every microframe, update maximal HS bandwidth
      // and check whether the microframe is allowed for scheduling.
      xor ecx, ecx
      
      l_h_ehci_select_tt_microframes:
        mov ax, [ss:esp + offset EhciTT.hs_bandwidth + ecx * 2]
        cmp ax, [ss:esp + offset EhciTT.max_hs_bandwidth + ecx * 2]
        jb l_h_ehci_select_tt_42
          mov [ss:esp + offset EhciTT.max_hs_bandwidth + ecx * 2], ax
          
        l_h_ehci_select_tt_42:
        
        // * tt_exclude_microframe_if_no_budget *
        
        // 1. If the new budget plus the current budget does not exceed 188 bytes,
        // the variant is possible.
        mov ax, [ss:esp + offset EhciTT.budget + ecx * 2]
        mov edx, ecx
        add ax, [ss:esp + offset EhciTT.new_budget]
        sub ax, 188
        jna l_h_ehci_select_tt_good
        // 2. Otherwise,
        // a) nothing should be scheduled in some following microframes,
        // b) after adding the new budget everything should fit in first 6 microframes,
        //    this guarantees that even in the worst case 90% limit is satisfied.
        l_h_ehci_select_tt_45:
          cmp edx, 5
          jnb l_h_ehci_select_tt_bad
          cmp word ptr [ss:esp + offset EhciTT.budget + edx * 2 + 2], 0
          jnz l_h_ehci_select_tt_bad
          inc edx
          sub ax, 188
          ja l_h_ehci_select_tt_45
          
        l_h_ehci_select_tt_bad:
        btr dword ptr [ss:esp + offset EhciTT.possible_microframes], ecx
        
        l_h_ehci_select_tt_good:
        // end * tt_exclude_microframe_if_no_budget *
        
        inc ecx
        cmp ecx, 8
        jb l_h_ehci_select_tt_microframes
        
      // Stop loop when outside of first descriptor group.
      lea eax, [esi + offset EhciController.int_eds + (32 * sizeof EhciStaticEp) - sizeof EhciController]
      add edi, [ss:esp + offset EhciTT.variant_delta]
      cmp edi, eax
      jb near l_h_ehci_select_tt_frames
      
    // end * tt_calc_bandwidth_in_frame *
    
    xor ecx, ecx
    
    l_h_ehci_select_tt_check_microframes:
      
      // * tt_check_variant_microframe *
      
      // 1. If the current microframe does not fit in existing FS budget, do nothing.
      bt dword ptr [ss:esp + offset EhciTT.possible_microframes], ecx
      jnc near l_h_ehci_select_tt_cs9
        // 2. Calculate maximal HS bandwidth over all affected microframes.
        // 2a. Start-split phase: one or more microframes starting with ecx,
        // coded in lower byte of .info.microframe_mask.
        xor ebx, ebx
        xor edx, edx
        
        l_h_ehci_select_tt_ssplit:
          lea eax, [ecx + edx]
          movzx eax, word ptr [ss:esp + offset EhciTT.max_hs_bandwidth + eax * 2]
          add eax, [ss:esp + offset EhciTT.info.ssplit_bandwidth]
          cmp ebx, eax
          ja l_h_ehci_select_tt_ssplit2
            mov ebx, eax
            
          l_h_ehci_select_tt_ssplit2:
          inc edx
          bt dword ptr [ss:esp + offset EhciTT.info.microframe_mask], edx
          jc l_h_ehci_select_tt_ssplit
          
        // 2b. Complete-split phase: zero or more microframes starting with
        // ecx+(last start-split microframe)+2,
        // coded in second byte of .info.microframe_mask.
        add edx, 8
        
        l_h_ehci_select_tt_csplit:
          inc edx
          bt [ss:esp + offset EhciTT.info.microframe_mask], edx
          jnc l_h_ehci_select_tt_csplit8
            lea eax, [ecx + edx]
            cmp eax, 8
            jnb l_h_ehci_select_tt_csplit8
              movzx eax, word ptr [ss:esp + offset EhciTT.max_hs_bandwidth + eax * 2 - 16]
              add eax, [ss:esp + offset EhciTT.info.csplit_bandwidth]
              cmp ebx, eax
              ja l_h_ehci_select_tt_csplit
                mov ebx, eax
                jmp l_h_ehci_select_tt_csplit
              
        l_h_ehci_select_tt_csplit8:
        // 3. Check that current HS bandwidth + new bandwidth <= limit;
        // USB2 specification allows maximum 60000*80% bit times for periodic microframe.
        cmp ebx, 48000
        ja l_h_ehci_select_tt_cs9
          // 4. This variant is possible for scheduling.
          // Check whether it is better than the currently selected one.
          // 4a. The primary criteria: FS/LS bandwidth.
          mov ax, [ss:esp + offset EhciTT.max_fs_bandwidth]
          cmp ax, [ss:esp + offset EhciTT.best_fs_bandwidth]
          ja l_h_ehci_select_tt_cs9
           jb l_h_ehci_select_tt_update
            // 4b. The secondary criteria: prefer microframes which are closer to start of frame.
            cmp ecx, [es:ebp - 12]  // speed
            ja l_h_ehci_select_tt_cs9
             jb l_h_ehci_select_tt_update
              // 4c. The last criteria: HS bandwidth.
              cmp ebx, [es:ebp - 8]  // bandwidth
              ja l_h_ehci_select_tt_cs9
              
          l_h_ehci_select_tt_update:
          // 5. This variant is better than the previously selected.
          // Update the best variant with current data.
          mov [ss:esp + offset EhciTT.best_fs_bandwidth], ax
          mov [es:ebp - 8], ebx  // bandwidth
          mov [es:ebp - 12], ecx  // speed
          mov eax, [ss:esp + offset EhciTT.variant]
          mov [es:ebp - 4], eax  // target
          
      l_h_ehci_select_tt_cs9:
      // end * tt_check_variant_microframe *
      
      inc ecx
      cmp ecx, 6
      jb near l_h_ehci_select_tt_check_microframes
      
    add dword ptr [ss:esp + offset EhciTT.variant], sizeof EhciStaticEp
    dec dword ptr [es:ebp + 24]  // interval
    jnz near l_h_ehci_select_tt_check_variants
    
  // 4. If there is no acceptable variants, return error.
  mov ecx, [es:ebp - 12]  // speed
  mov edx, [es:ebp - 4]  // target
  cmp ecx, -1
  jz l_h_ehci_select_tt_no_bandwidth
    // 5. Calculate the answer: edx -> selected list, eax = S-Mask and C-Mask.
    mov eax, [ss:esp + offset EhciTT.info.microframe_mask]
    add edx, [ss:esp + offset EhciTT.target_delta]
    shl eax, cl
    and eax, 0xFFFF
    // 6. Update HS bandwidths in the selected list.
    xor ecx, ecx
    mov ebx, [ss:esp + offset EhciTT.info.ssplit_bandwidth]
    
    l_h_ehci_select_tt_update_ssplit:
      bt eax, ecx
      jnc l_h_ehci_select_tt_61
        add [es:edx + offset EhciStaticEp.bandwidths + ecx * 2], bx
        
      l_h_ehci_select_tt_61:
      inc ecx
      cmp ecx, 8
      jb l_h_ehci_select_tt_update_ssplit
      
    mov ebx, [ss:esp + offset EhciTT.info.csplit_bandwidth]
    
    l_h_ehci_select_tt_update_csplit:
      bt eax, ecx
      jnc l_h_ehci_select_tt_62
        add [es:edx + offset EhciStaticEp.bandwidths + ecx * 2 - 16], bx
        
      l_h_ehci_select_tt_62:
      inc ecx
      cmp ecx, 16
      jb l_h_ehci_select_tt_update_csplit
      
  // 7. Return.
  add edx, offset EhciStaticEp.software_part
  
  l_h_ehci_select_tt_9:
  add esp, sizeof EhciTT
 pop edi
pop ebx
ret

  l_h_ehci_select_tt_no_bandwidth:
  xor eax, eax
  xor edx, edx
  jmp short l_h_ehci_select_tt_9

// Pipe is removing, update the corresponding lists.
// We do not reorder anything, so just update book-keeping variable
// in the list header.
h_ehci_hs_interrupt_list_unlink:
movzx eax, word ptr [es:ebx + offset EhciPipe.token - sizeof EhciPipe + 2]
// calculate bandwidth
call h_ehci_calc_hs_bandwidth
mov ecx, [es:ebx + offset EhciPipe.flags - sizeof EhciPipe]
shr ecx, 30
imul eax, ecx
movzx ecx, byte ptr [es:ebx + offset EhciPipe.flags - sizeof EhciPipe]
// get target list
mov edx, [es:ebx + offset UsbPipe.base_list]
// update bandwidth

l_h_ehci_hs_interrupt_list_unlink_5:
  shr ecx, 1
  jnc l_h_ehci_hs_interrupt_list_unlink_6
    sub [es:edx + offset EhciStaticEp.bandwidths - offset EhciStaticEp.software_part], ax
    
  l_h_ehci_hs_interrupt_list_unlink_6:
  add edx, 2
  test ecx, ecx
  jnz l_h_ehci_hs_interrupt_list_unlink_5
  
// return
ret
 
// Pipe is removing, update the corresponding lists.
// We do not reorder anything, so just update book-keeping variable
// in the list header.
h_ehci_fs_interrupt_list_unlink:
// calculate bandwidth
push edi
  sub esp, sizeof UsbSplitInfo
  mov edi, esp
  call h_ehci_tt_fill_split_info
  // get target list
  mov edx, [es:ebx + offset UsbPipe.base_list]
  // update bandwidth for Start-Split
  mov eax, [es:edi + offset UsbSplitInfo.ssplit_bandwidth]
  xor ecx, ecx
  
  l_h_ehci_fs_interrupt_list_unlink_dec_bandwidth_1:
    bt dword ptr [es:ebx + offset EhciPipe.flags - sizeof EhciPipe], ecx
    jnc l_h_ehci_fs_interrupt_list_unlink_3
      sub word ptr [es:edx + ecx * 2 + offset EhciStaticEp.bandwidths - offset EhciStaticEp.software_part], ax
      
    l_h_ehci_fs_interrupt_list_unlink_3:
    inc ecx
    cmp ecx, 8
    jb l_h_ehci_fs_interrupt_list_unlink_dec_bandwidth_1
    
  // update bandwidth for Complete-Split
  mov eax, [es:edi + offset UsbSplitInfo.csplit_bandwidth]
  
  l_h_ehci_fs_interrupt_list_unlink_dec_bandwidth_2:
    bt dword ptr [es:ebx + offset EhciPipe.flags - sizeof EhciPipe], ecx
    jnc l_h_ehci_fs_interrupt_list_unlink_4
      sub word ptr [es:edx + ecx * 2 - 16 + offset EhciStaticEp.bandwidths - offset EhciStaticEp.software_part], ax
      
    l_h_ehci_fs_interrupt_list_unlink_4:
    inc ecx
    cmp ecx, 16
    jb l_h_ehci_fs_interrupt_list_unlink_dec_bandwidth_2
    
  add esp, sizeof UsbSplitInfo
pop edi
ret

// Helper procedure for ehci_alloc_transfer.
// Allocates and initializes one transfer descriptor.
// fills the current last descriptor
// IN: ebx -> UsbPipe
// OUT: eax = next descriptor (not filled).
h_ehci_alloc_packet:
/*
24 buffer:dword, 28 size:dword, 32 flags:dword, 36 td:dword, 40 direction:dword
20 ret_adr
16 token
12 origTD
8 packetSize  // must be last variable, see usb_init_transfer
4 ret_adr
0 eax
*/

// 1. Allocate the next TD.
call h_ehci_alloc_gtd
test eax, eax
jz near l_h_ehci_alloc_packet_9

// 2. Initialize controller-independent parts of both TDs.
push eax
  call h_usb_init_transfer  // out ecx
pop eax
// 3. Copy PID to the new descriptor.
mov edx, [es:ecx + offset EhciGtd.htd.token - sizeof EhciGtd]
mov [es:eax + offset EhciGtd.htd.token - sizeof EhciGtd], edx
mov dword ptr [es:eax + offset EhciGtd.htd.next_td - sizeof EhciGtd], 1
mov dword ptr [es:eax + offset EhciGtd.htd.alternate_next_td - sizeof EhciGtd], 1
// 4. Save the returned value (next descriptor).
push eax
  // 5. Store the physical address of the next descriptor.
  sub eax, sizeof EhciGtd
  call h_usb_getphysadr
  mov [es:ecx + offset EhciGtd.htd.next_td - sizeof EhciGtd], eax
  // 6. For zero-length transfers, store zero in all fields for buffer addresses.
  // Otherwise, fill them with real values.
  xor eax, eax
  mov [es:ecx + offset EhciGtd.flags - sizeof EhciGtd], eax
  
  mov [es:ecx + offset EhciGtd.htd.buffer_pointers - sizeof EhciGtd], eax
  mov [es:ecx + offset EhciGtd.htd.buffer_pointers - sizeof EhciGtd + 4], eax
  mov [es:ecx + offset EhciGtd.htd.buffer_pointers - sizeof EhciGtd + 8], eax
  mov [es:ecx + offset EhciGtd.htd.buffer_pointers - sizeof EhciGtd + 12], eax
  mov [es:ecx + offset EhciGtd.htd.buffer_pointers - sizeof EhciGtd + 16], eax
  mov [es:ecx + offset EhciGtd.htd.buffer_pointers - sizeof EhciGtd + 20], eax
  mov [es:ecx + offset EhciGtd.htd.buffer_pointers - sizeof EhciGtd + 24], eax
  mov [es:ecx + offset EhciGtd.htd.buffer_pointers - sizeof EhciGtd + 28], eax
  mov [es:ecx + offset EhciGtd.htd.buffer_pointers - sizeof EhciGtd + 32], eax
  mov [es:ecx + offset EhciGtd.htd.buffer_pointers - sizeof EhciGtd + 36], eax
  
  push esi
   push edi
    cmp [ss:esp + 8 + 8], eax  // packetSize
    jz near l_h_ehci_alloc_packet_6
    
    mov eax, [ss:esp + 24 + 8]  // buffer
    push ebx
      xchg eax, ebx
      call m_pages_getphysadr
      xchg eax, ebx
    pop ebx
    mov [es:ecx + offset EhciGtd.htd.buffer_pointers - sizeof EhciGtd], eax
    and eax, 0xFFF
    mov edx, [ss:esp + 8 + 8]  // packetSize
    add edx, eax
    sub edx, 0x1000
    jna near l_h_ehci_alloc_packet_6
    
    mov eax, [ss:esp + 24 + 8]  // buffer
    add eax, 0x1000
    push ebx
      xchg eax, ebx
      call m_pages_getphysadr
      xchg eax, ebx
    pop ebx
    and eax, -0x1000
    mov [es:ecx + offset EhciGtd.htd.buffer_pointers + 4 - sizeof EhciGtd], eax
    sub edx, 0x1000
    jna l_h_ehci_alloc_packet_6
    
    mov eax, [ss:esp + 24 + 8]  // buffer
    add eax, 0x2000
    push ebx
      xchg eax, ebx
      call m_pages_getphysadr
      xchg eax, ebx
    pop ebx
    and eax, -0x1000
    mov [es:ecx + offset EhciGtd.htd.buffer_pointers + 8 - sizeof EhciGtd], eax
    sub edx, 0x1000
    jna l_h_ehci_alloc_packet_6
    
    mov eax, [ss:esp + 24 + 8]  // buffer
    add eax, 0x3000
    push ebx
      xchg eax, ebx
      call m_pages_getphysadr
      xchg eax, ebx
    pop ebx
    and eax, -0x1000
    mov [es:ecx + offset EhciGtd.htd.buffer_pointers + 12 - sizeof EhciGtd], eax
    sub edx, 0x1000
    jna l_h_ehci_alloc_packet_6
    
    mov eax, [ss:esp + 24 + 8]  // buffer
    add eax, 0x4000
    push ebx
      xchg eax, ebx
      call m_pages_getphysadr
      xchg eax, ebx
    pop ebx
    and eax, -0x1000
    mov [es:ecx + offset EhciGtd.htd.buffer_pointers + 16 - sizeof EhciGtd], eax
    
    l_h_ehci_alloc_packet_6:
   pop edi
  pop esi
  // 7. Fill Token field:
  // set Status = 0 (inactive, ehci_insert_transfer would mark everything active)//
  // keep current PID if [.direction] is zero, use two lower bits of [.direction]
  // otherwise shifted as (0|1|2) -> (2|0|1)//
  // set error counter to 3//
  // set current page to 0//
  // do not interrupt on complete (ehci_insert_transfer sets this bit where needed)//
  // set DataToggle to bit 2 of [.direction].
  mov eax, [es:ecx + offset EhciGtd.htd.token - sizeof EhciGtd]
  and eax, 300h  // keep PID code
  mov edx, [ss:esp + 40]  // direction
  test edx, edx
  jz l_h_ehci_alloc_packet_haspid
    and edx, 3
    dec edx
    jns l_h_ehci_alloc_packet_7
      add edx, 3
      
    l_h_ehci_alloc_packet_7:
    mov ah, dl
    mov edx, [ss:esp + 40]  // direction
    and edx, -1 - 3
    shl edx, 29
    or eax, edx
    
  l_h_ehci_alloc_packet_haspid:
  or eax, 0C00h
  mov edx, [ss:esp + 8]  // packetSize
  shl edx, 16
  or eax, edx
  mov [es:ecx + offset EhciGtd.htd.token - sizeof EhciGtd], eax
  // 4. Restore the returned value saved in step 2.
pop eax

l_h_ehci_alloc_packet_9:
ret

// This procedure is called from ehci_process_updated_list, which is itself
// called from ehci_process_updated_schedule, see comments there.
// It processes one completed descriptor.
// IN: ebx -> UsbGtd, out: ebx -> next UsbGtd.
h_ehci_process_updated_td:
// 1. Remove this descriptor from the list of descriptors for this pipe.

call h_usb_unlink_td

// 2. Calculate actual number of bytes transferred.
mov eax, [es:ebx + offset EhciGtd.htd.token - sizeof EhciGtd]
lea edx, [eax + eax]
shr edx, 17
sub edx, [es:ebx + offset UsbGtd.length]
neg edx
// 3. Check whether we need some special processing beyond notifying the driver.
// Transfer errors require special processing.
// Short packets require special processing if
// a) this is not the last descriptor for transfer stage
// (in this case we need to process subsequent descriptors for the stage too)
// or b) the caller considers short transfers to be an error.
// ehci_alloc_transfer sets bit 0 of ehci_gtd.Flags to 0 if short packet
// in this descriptor requires special processing and to 1 otherwise.
// If special processing is not needed, advance to 4 with ecx = 0.
// Otherwise, go to 6.
xor ecx, ecx
test al, 40h
jnz l_h_ehci_process_updated_td_error
  test byte ptr [es:ebx + offset EhciGtd.flags - sizeof EhciGtd], 1
  jnz l_h_ehci_process_updated_td_notify
    cmp edx, [es:ebx + offset UsbGtd.length]
    jnz l_h_ehci_process_updated_td_special
  
  l_h_ehci_process_updated_td_notify:
  // 4. Either the descriptor in ebx was processed without errors,
  // or all necessary error actions were taken and ebx points to the last
  // related descriptor.
  
  call h_usb_process_gtd
  
  // 5. Free the current descriptor and return the next one.
  push dword ptr [es:ebx + offset UsbGtd.next_virt]
    push ebx
    call h_ehci_free_gtd
  pop ebx
  
  ret
  
l_h_ehci_process_updated_td_error:
l_h_ehci_process_updated_td_special:
// 6. Special processing is needed.
// 6a. Save the status and length.
push edx
  push eax
    // 6b. Traverse the list of descriptors looking for the final descriptor
    // for this transfer. Free and unlink non-final descriptors.
    // Final descriptor will be freed in step 5.
    l_h_ehci_process_updated_td_look_final:
      call h_usb_is_final_packet
      jnc l_h_ehci_process_updated_td_found_final
        push dword ptr [es:ebx + offset UsbGtd.next_virt]
          push ebx
          call h_ehci_free_gtd
        pop ebx
        call h_usb_unlink_td
        jmp l_h_ehci_process_updated_td_look_final
        
    l_h_ehci_process_updated_td_found_final:
    // 6c. Restore the status saved in 6a and transform it to the error code.
    // Notes:
    // * any USB transaction error results in Halted bit// if it is not set,
    //   but we are here, it must be due to short packet//
    // * babble is considered a fatal USB transaction error,
    //   other errors just lead to retrying the transaction//
    //   if babble is detected, return the corresponding error//
    // * if several non-fatal errors have occured during transaction retries,
    //   all corresponding bits are set. In this case, return some error code,
    //   the order is quite arbitrary.
  pop eax  // status
  mov ecx, USB_STATUS_UNDERRUN
  test al, 40h         // not Halted?
  jz l_h_ehci_process_updated_td_know_error
   mov cl, USB_STATUS_OVERRUN
   test al, 10h         // Babble detected?
   jnz l_h_ehci_process_updated_td_know_error
    mov cl, USB_STATUS_BUFOVERRUN
    test al, 20h         // Data Buffer error?
    jnz l_h_ehci_process_updated_td_know_error
     mov cl, USB_STATUS_NORESPONSE
     test al, 8           // Transaction Error?
     jnz l_h_ehci_process_updated_td_know_error
      mov cl, USB_STATUS_STALL
      
  l_h_ehci_process_updated_td_know_error:
  // 6d. If error code is USB_STATUS_UNDERRUN and the last TD allows short packets,
  // it is not an error// in this case, go to 4 with ecx = 0.
  cmp ecx, USB_STATUS_UNDERRUN
  jnz l_h_ehci_process_updated_td_61
    test byte ptr [es:ebx + offset EhciGtd.flags - sizeof EhciGtd], 1
    jz l_h_ehci_process_updated_td_61
      xor ecx, ecx
      
      pop edx     // length
      
      jmp l_h_ehci_process_updated_td_notify
      
  l_h_ehci_process_updated_td_61:
  // 6e. Abort the entire transfer.
  // There are two cases: either there is only one transfer stage
  // (everything except control transfers), then ebx points to the last TD and
  // all previous TD were unlinked and dismissed (if possible),
  // or there are several stages (a control transfer) and ebx points to the last
  // TD of Data or Status stage (usb_is_final_packet does not stop in Setup stage,
  // because Setup stage can not produce short packets)// for Data stage, we need
  // to unlink and free (if possible) one more TD and advance ebx to the next one.
  cmp dword ptr [es:ebx + offset UsbGtd.callback], 0
  jnz l_h_ehci_process_updated_td_normal
    push ecx
      push dword ptr [es:ebx + offset UsbGtd.next_virt]
        push ebx
        call h_ehci_free_gtd
      pop ebx
      call h_usb_unlink_td
    pop ecx
    
l_h_ehci_process_updated_td_normal:
// 6f. For bulk/interrupt transfers we have no choice but halt the queue,
// the driver should intercede (through some API which is not written yet).
// Control pipes normally recover at the next SETUP transaction (first stage
// of any control transfer), so we hope on the best and just advance the queue
// to the next transfer. (According to the standard, "A control pipe may also
// support functional stall as well, but this is not recommended.").
mov edx, [es:ebx + offset UsbGtd.pipe]
mov eax, [es:ebx + offset EhciGtd.htd.next_td - sizeof EhciGtd]
or al, 1
mov [es:edx + offset EhciPipe.overlay.next_td - sizeof EhciPipe], eax
mov [es:edx + offset EhciPipe.overlay.alternate_next_td - sizeof EhciPipe], eax
cmp dword ptr [es:edx + offset UsbPipe.type], CONTROL_PIPE
jz l_h_ehci_process_updated_td_control
  // Bulk/interrupt transfer; halt the queue
  mov dword ptr [es:edx + offset EhciPipe.overlay.token - sizeof EhciPipe], 40h
  
  pop edx
  
  jmp l_h_ehci_process_updated_td_notify
  
  // Control transfer
l_h_ehci_process_updated_td_control:
and dword ptr [es:edx + offset EhciPipe.overlay.token - sizeof EhciPipe], 0
dec dword ptr [es:edx + offset EhciPipe.overlay.next_td - sizeof EhciPipe]

pop edx

jmp l_h_ehci_process_updated_td_notify

// This procedure is called from ehci_process_updated_schedule, see comments there.
// It processes one list, esi -> UsbController, edi -> UsbStaticEp,
// and advances edi to next head.
h_ehci_process_updated_list:
push ebx
  // 1. Perform the external loop over all pipes.
  mov ebx, [es:edi + offset UsbStaticEp.next_virt]
  
  l_h_ehci_process_updated_list_5:
   cmp ebx, edi
   jz l_h_ehci_process_updated_list_8
    // store pointer to the next pipe in the stack
    push dword ptr [es:ebx + offset UsbStaticEp.next_virt]
      // 2. For every pipe, perform the internal loop over all descriptors.
      // All descriptors are organized in the queue// we process items from the start
      // of the queue until a) the last descriptor (not the part of the queue itself)
      // or b) an active (not yet processed by the hardware) descriptor is reached.
      lea ecx, [ebx + offset UsbPipe.lock]
      call p_mutex_lock
      mov ebx, [es:ebx + offset UsbPipe.last_td]
      push ebx
        mov ebx, [es:ebx + offset UsbGtd.next_virt]
        
        l_h_ehci_process_updated_list_td5:
        // 3. For every descriptor, test active flag and check for end-of-queue//
        // if either of conditions holds, exit from the internal loop.
        cmp ebx, [ss:esp]
        jz l_h_ehci_process_updated_list_td8
         cmp byte ptr [es:ebx + offset EhciGtd.htd.token - sizeof EhciGtd], 0
         js l_h_ehci_process_updated_list_td8
          // Release the queue lock while processing one descriptor:
          // callback function could (and often would) schedule another transfer.
          push ecx
            call p_mutex_unlock
            call h_ehci_process_updated_td
          pop ecx
          call p_mutex_lock
          jmp l_h_ehci_process_updated_list_td5
          
        l_h_ehci_process_updated_list_td8:
        call p_mutex_unlock
      pop ebx
      // End of internal loop, restore pointer to the next pipe
      // and continue the external loop.
    pop ebx
    jmp l_h_ehci_process_updated_list_5
    
  l_h_ehci_process_updated_list_8:
pop ebx
add edi, sizeof EhciStaticEp
ret

// This procedure is called in the USB thread from ehci_process_deferred
// when EHCI IRQ handler has signalled that new IOC-packet was processed.
// It scans all lists for completed packets and calls ehci_process_finalized_td
// for those packets.
h_ehci_process_updated_schedule:
// Important note: we cannot hold the list lock during callbacks,
// because callbacks sometimes open and/or close pipes and thus acquire/release
// the corresponding lock itself.
// Fortunately, pipes can be finally freed only by another step of
// ehci_process_deferred, so all pipes existing at the start of this function
// will be valid while this function is running. Some pipes can be removed
// from the corresponding list, some pipes can be inserted// insert/remove
// functions guarantee that traversing one list yields all pipes that were in
// that list at the beginning of the traversing (possibly with some new pipes,
// possibly without some new pipes, that doesn't matter).
push edi
  // 1. Process all Periodic lists.
  lea edi, [esi + offset EhciController.int_eds - sizeof EhciController + offset EhciStaticEp.software_part]
  lea ebx, [esi + offset EhciController.int_eds + (63 * sizeof EhciStaticEp) - sizeof EhciController + offset EhciStaticEp.software_part]
  
  l_h_ehci_process_updated_schedule_5:
    call h_ehci_process_updated_list
    cmp edi, ebx
    jnz l_h_ehci_process_updated_schedule_5
    
  // 2. Process the Control list.
  add edi, EHCI_CONTROLLER_DELTA
  call h_ehci_process_updated_list
  // 3. Process the Bulk list.
  call h_ehci_process_updated_list
  // 4. Return.
pop     edi
ret

// This function is called from ehci_process_deferred when
// reset signalling for a new device needs to be finished.
// IN: esi -> UsbController
h_ehci_port_reset_done:
movzx ecx, byte ptr [es:esi + offset UsbController.resetting_port]
and dword ptr [es:edi + EHCI_REG_PORTS + ecx * 4], -1 - 12Ah
mov eax, tmr_usb_timerticks
mov [es:esi + offset UsbController.reset_time], eax
mov byte ptr [es:esi + offset UsbController.resetting_status], 2
ret

// This function is called from ehci_process_deferred when
// a new device has been reset, recovered after reset and needs to be configured.
h_ehci_port_init:
// 1. Get the status and set it to zero.
// If reset has been failed (device disconnected during reset),
// continue to next device (if there is one).
xor eax, eax
xchg al, [es:esi + offset UsbController.resetting_status]
test al, al
jns l_h_ehci_port_init_1
  jmp h_usb_test_pending_port
  
l_h_ehci_port_init_1:
// 2. Get the port status. High-speed devices should be now enabled,
// full-speed devices are left disabled//
// if the port is disabled, release it to a companion and continue to
// next device (if there is one).
movzx ecx, byte ptr [es:esi + offset UsbController.resetting_port]
mov eax, [es:edi + EHCI_REG_PORTS + ecx * 4]
test al, 4
jnz l_h_ehci_port_init_2
  or ah, 20h
  mov [es:edi + EHCI_REG_PORTS + ecx * 4], eax
  jmp h_usb_test_pending_port
  
l_h_ehci_port_init_2:
// 3. Call the worker procedure to notify the protocol layer
// about new EHCI device. It is high-speed.
mov eax, USB_SPEED_HS
call h_ehci_new_device
test eax, eax
jnz l_h_ehci_port_init_9
  // 4. If something at the protocol layer has failed
  // (no memory, no bus address), disable the port and stop the initialization.
  and dword ptr [es:edi + EHCI_REG_PORTS + ecx * 4], -1 - (4 | 2Ah)
  jmp h_usb_test_pending_port
  
l_h_ehci_port_init_9:
ret

[align 32]
h_ehci_hardware_func:
dd 200h
dd 'EHCI'
dd sizeof EhciController
dd offset h_ehci_kickoff_bios
dd offset h_ehci_init
dd offset h_ehci_process_deferred
dd offset h_ehci_set_adr
dd offset h_ehci_get_adr
dd offset h_ehci_disable_port
dd offset h_ehci_new_port_reset
dd offset h_ehci_set_ep_packet_size
dd offset h_ehci_alloc_pipe
dd offset h_ehci_free_pipe
dd offset h_ehci_init_pipe
dd offset h_ehci_unlink_pipe
dd offset h_ehci_alloc_gtd
dd offset h_ehci_free_gtd
dd offset h_ehci_alloc_transfer
dd offset h_ehci_insert_transfer
dd offset h_ehci_new_device
dd offset h_ehci_disable_pipe
dd offset h_ehci_enable_pipe

h_ehci_name: db 'EHCI',0

// Controller-specific pre-initialization function: take ownership from BIOS.
// Some BIOSes, although not all of them, use USB controllers themselves
// to support USB flash drives. In this case,
// we must notify the BIOS that we don't need that emulation and know how to
// deal with USB devices.
// IN: usb_ecx, usb_edx
h_ehci_kickoff_bios:
// 1. Get the physical address of MMIO registers.
mov ecx, usb_ecx
mov edx, usb_edx
mov dl, 10h
call h_pci_get  // out eax

mov ebx, usb_mmio
//add usb_mmio, 4096
mov ecx, 1
mov edx, eax
push ebx
  call m_pages_alloc_hard
pop eax  // eax = mmio_va

//mov eax, [es:esi + offset EhciController.mmio_base1 - sizeof EhciController]
push eax  // push argument for step 8
  // 3. Some BIOSes enable controller interrupts as a result of giving
  // controller away. At this point the system knows nothing about how to serve
  // EHCI interrupts, so such an interrupt will send the system into an infinite
  // loop handling the same IRQ again and again. Thus, we need to block EHCI
  // interrupts. We can't do this at the controller level until step 5,
  // because the controller is currently owned by BIOS, so we block all hardware
  // interrupts on this processor until step 5.
  pushfd
    cli
    // 4. Take the ownership over the controller.
    // 4a. Locate take-ownership capability in the PCI configuration space.
    // Limit the loop with 100h iterations; since the entire configuration space is
    // 100h bytes long, hitting this number of iterations means that something is
    // corrupted.
    // Use a value from MMIO as a starting point.
    mov edx, [es:eax + EHCI_REG_CAPPARAMS]
    movzx edi, byte ptr [es:eax + EHCI_REG_CAPLENGTH]
    add edi, eax
    push 0
      mov bl, dh  // get Extended Capabilities Pointer
      test bl, bl
      jz near l_h_ehci_kickoff_has_ownership2
        cmp bl, 40h
        jb l_h_ehci_kickoff_no_capability
          
          l_h_ehci_kickoff_look_bios_handoff:
          test bl, 3
          jnz l_h_ehci_kickoff_no_capability
            // In each iteration, read the current dword
            mov ecx, usb_ecx
            mov edx, usb_edx
            mov dl, bl  // bl % 4 = 0
            call h_pci_get
            // check, whether the capability ID is take-ownership ID = 1
            cmp al, 1
            jz l_h_ehci_kickoff_found_bios_handoff
              // if not, advance to next-capability link and continue loop.
              dec byte ptr [ss:esp]
              jz l_h_ehci_kickoff_no_capability
                mov bl, ah
                cmp bl, 40h
                jnb l_h_ehci_kickoff_look_bios_handoff
                
        l_h_ehci_kickoff_no_capability:
        jmp l_h_ehci_kickoff_has_ownership2
        
        l_h_ehci_kickoff_found_bios_handoff:
        // 4b. Check whether BIOS has ownership.
        // Some BIOSes release ownership before loading OS, but forget to unwatch for
        // change-ownership requests// they cannot handle ownership request, so
        // such a request sends the system into infinite loop of handling the same SMI
        // over and over. Avoid this.
        inc ebx
        inc ebx
        test eax, 0x10000
        jz near l_h_ehci_kickoff_has_ownership
          // 4c. Request ownership.
          inc ebx
          mov ecx, usb_ecx
          mov edx, usb_edx
          mov dl, bl  // bl % 4 = 3
          and dl, -4
          call h_pci_get
          and eax, 0x00FFFFFF
          or eax, 1 << (3 * 8)
          call h_pci_set
          //invoke PciWrite8, dword [esi+PCIDEV.bus], dword [esi+PCIDEV.devfn], ebx, 1
          
          // 4d. Some BIOSes set ownership flag, but forget to watch for change-ownership
          // requests; if so, there is no sense in waiting.
          inc ebx  // bl % 4 = 0
          mov dl, bl
          call h_pci_get
          //invoke PciRead32, dword [esi+PCIDEV.bus], dword [esi+PCIDEV.devfn], ebx
          dec ebx
          dec ebx
          test ah, 20h
          jz l_h_ehci_kickoff_force_ownership
            // 4e. Wait for result no more than 1 s, checking for status every 1 ms.
            // If successful, go to 5.
            mov dword ptr [ss:esp], 1000
            
            l_h_ehci_kickoff_45:
              mov ecx, usb_ecx
              mov edx, usb_edx
              mov dl, bl  // bl % 4 = 2
              and dl, -4
              call h_pci_get
              shr eax, 2 * 8
              //invoke  PciRead8, dword [esi+PCIDEV.bus], dword [esi+PCIDEV.devfn], ebx
              test al, 1
              jz l_h_ehci_kickoff_has_ownership
                
                sti
                push ebx
                 push edi
                  mov ecx, 1
                  call p_sleep
                 pop edi
                pop ebx
                cli
                
                dec dword ptr [ss:esp]
                jnz l_h_ehci_kickoff_45
                
          l_h_ehci_kickoff_force_ownership:
          // 4f. BIOS has not responded within the timeout.
          // Let's just clear BIOS ownership flag and hope that everything will be ok.
          mov ecx, usb_ecx
          mov edx, usb_edx
          mov dl, bl  // bl % 4 = 2
          and dl, -4
          call h_pci_get
          and eax, 0xFF00FFFF
          call h_pci_set
          //invoke PciWrite8, dword [esi+PCIDEV.bus], dword [esi+PCIDEV.devfn], ebx, 0
          
        l_h_ehci_kickoff_has_ownership:
        // 5. Just in case clear all SMI event sources except change-ownership.
        inc ebx
        inc ebx  // bl % 4 = 0
        mov ecx, usb_ecx
        mov edx, usb_edx
        mov dl, bl
        call h_pci_get
        //invoke  PciRead16, dword [esi+PCIDEV.bus], dword [esi+PCIDEV.devfn], ebx
        and ax, 2000h
        call h_pci_set
        //invoke  PciWrite16, dword [esi+PCIDEV.bus], dword [esi+PCIDEV.devfn], ebx, eax
        
      l_h_ehci_kickoff_has_ownership2:
    pop ecx
    // 6. Disable all controller interrupts until the system will be ready to
    // process them.
    mov dword ptr [es:edi + EHCI_REG_INTERRUPT], 0
    // 7. Now we can unblock interrupts in the processor.
  popf
pop ecx
ret

// Controller-specific initialization function.
// Called from usb_init_controller. Initializes the hardware and
// EHCI-specific parts of software structures.
// IN: usb_ecx, usb_edx
// OUT: eax -> UsbController || 0
// KEEP: usb_ecx, usb_edx
h_ehci_init:
// alloc
mov ecx, sizeof EhciController + sizeof UsbController
call h_usb_alloc
xchg eax, ebx
push eax
  add eax, sizeof EhciController
  mov dword ptr [es:eax + offset UsbController.hardware_func], offset h_ehci_hardware_func + PA_KERNEL_CODE + VA_SYSTEM
  call h_usb_init_controller
pop eax
// 1. Store pointer to ehci_controller for further use.
push eax
  mov edi, eax
  mov esi, eax
  // 2. Initialize ehci_controller.FrameList.
  // Note that FrameList is located in the beginning of ehci_controller,
  // so esi and edi now point to ehci_controller.FrameList.
  // First 32 entries of FrameList contain physical addresses
  // of first 32 Periodic static heads, further entries duplicate these.
  // See the description of structures for full info.
  // 2a. Get physical address of first static head.
  // Note that 1) it is located in the beginning of a page
  // and 2) first 32 static heads fit in the same page,
  // so one call to get_phys_addr without correction of lower 12 bits
  // is sufficient.
  
  //if (ehci_controller.IntEDs / 0x1000) <> ((ehci_controller.IntEDs + 32 * sizeof.ehci_static_ep) / 0x1000)
  //.err assertion failed
  //end if
  //if (ehci_controller.IntEDs mod 0x1000) <> 0
  //.err assertion failed
  //end if
  add eax, offset EhciController.int_eds
  call h_usb_getphysadr
  // 2b. Fill first 32 entries.
  inc eax
  inc eax  // set Type to EHCI_TYPE_QH
  mov ecx, 32
  mov edx, ecx
  cld
  
  l_h_ehci_init_25:
    stosd
    add eax, sizeof EhciStaticEp
    loop l_h_ehci_init_25
    
  // 2c. Fill the rest entries.
  push ds
    push es
    pop ds
    mov ecx, 1024 - 32
    rep movsd
  pop ds
  // 3. Initialize static heads ehci_controller.*ED.
  // Use the loop over groups: first group consists of first 32 Periodic
  // descriptors, next group consists of next 16 Periodic descriptors,
  // ..., last group consists of the last Periodic descriptor.
  // 3a. Prepare for the loop.
  // make esi point to the second group, other registers are already set.
  add esi, (32 * 4) + (32 * sizeof EhciStaticEp)
  // 3b. Loop over groups. On every iteration:
  // edx = size of group, edi = pointer to the current group,
  // esi = pointer to the next group.
  
  l_h_ehci_init_static_eds:
    // 3c. Get the size of next group.
    shr edx, 1
    // 3d. Exit the loop if there is no next group.
    jz l_h_ehci_init_static_eds_done
      // 3e. Initialize the first half of the current group.
      // Advance edi to the second half.
      push esi
        call h_ehci_init_static_ep_group
      pop esi
      // 3f. Initialize the second half of the current group
      // with the same values.
      // Advance edi to the next group, esi/eax to the next of the next group.
      call h_ehci_init_static_ep_group
      jmp l_h_ehci_init_static_eds
      
  l_h_ehci_init_static_eds_done:
  // 3g. Initialize the last static head.
  xor esi, esi
  call h_ehci_init_static_endpoint
  // While we are here, initialize StopQueueTD.
  //if (ehci_controller.StopQueueTD <> ehci_controller.IntEDs + 63 * sizeof.ehci_static_ep)
  //.err assertion failed
  //end if
  inc dword ptr [es:edi + offset EhciHardwareTd.next_td]   // 0 -> 1
  inc dword ptr [es:edi + offset EhciHardwareTd.alternate_next_td]  // 0 -> 1
  // leave other fields as zero, including Active bit
  // 3i. Initialize the head of Control list.
  add edi, EHCI_CONTROLLER_DELTA
  lea esi, [edi + sizeof EhciStaticEp]
  call h_ehci_init_static_endpoint
  or byte ptr [es:edi - sizeof EhciStaticEp + offset EhciStaticEp.token + 1], 80h
  // 3j. Initialize the head of Bulk list.
  sub esi, sizeof EhciStaticEp
  call h_ehci_init_static_endpoint
  // 4. Create a virtual memory area to talk with the controller
  
  // enable memory access
  mov ecx, usb_ecx
  mov edx, usb_edx    
  mov dl, 4  // command
  call h_pci_get  // keep edi
  or al, 6
  call h_pci_set  // keep edi
  
  // PCI - map mmio
  mov ecx, usb_ecx
  mov edx, usb_edx    
  mov dl, 10h
  call h_pci_get  // eax = mmio_pa
  
  mov ebx, usb_mmio
  add usb_mmio, 4096
  mov ecx, 1
  mov edx, eax
  push ebx
   push edi
    call m_pages_alloc_hard
   pop edi
  pop eax  // eax = mmio_va
  
  stosd  // fill EhciController.mmio_base1
  
  // 5. Read basic parameters of the controller.
  // 5a. Structural parameters.
  mov ebx, [es:eax + EHCI_REG_STRUCTPARAMS]
  // 5b. Port routing rules.
  // If bit 7 in HCSPARAMS is set, read and unpack EhciPortRouteReg.
  // Otherwise, bits 11:8 are N_PCC = number of ports per companion,
  // bits 15:12 are number of companions, maybe zero,
  // first N_PCC ports are routed to the first companion and so on.
  xor esi, esi
  test bl, bl
  js l_h_ehci_init_read_routes
    test bh, 0x0F
    jz l_h_ehci_init_no_companions
     test bh, 0xF0
     jz l_h_ehci_init_no_companions
      xor edx, edx
      
      l_h_ehci_init_5:
        movzx ecx, bh
        and ecx, 15
        
        l_h_ehci_init_55:
          mov [es:edi + esi + offset EhciController.port_routes - (offset EhciController.mmio_base1 + 4)], dl
          inc esi
          cmp esi, 16
          jz l_h_ehci_init_routes_filled
            dec ecx
            jnz l_h_ehci_init_55
        
        movzx ecx, bh
        shr ecx, 4
        inc edx
        cmp edx, ecx
        jb l_h_ehci_init_5
        
    l_h_ehci_init_no_companions:
      mov byte ptr [es:edi + esi + offset EhciController.port_routes - (offset EhciController.mmio_base1 + 4)], 0xFF
      inc esi
      cmp esi, 16
      jnz l_h_ehci_init_no_companions
    
    jmp short l_h_ehci_init_routes_filled
    
  l_h_ehci_init_read_routes:
  mov ecx, [es:eax + EHCI_REG_PORTROUTE]
  
  l_h_ehci_init_61:
    mov edx, ecx
    shr ecx, 4
    and edx, 15
    mov [es:edi + esi + offset EhciController.port_routes - (offset EhciController.mmio_base1 + 4)], dl
    inc esi
    cmp esi, 8
    jnz l_h_ehci_init_61
    
  mov ecx, [es:eax + EHCI_REG_PORTROUTE + 4]
  
  l_h_ehci_init_62:
    mov edx, ecx
    shr ecx, 4
    and edx, 15
    mov [es:edi + esi + offset EhciController.port_routes - (offset EhciController.mmio_base1 + 4)], dl
    inc esi
    cmp esi, 16
    jnz l_h_ehci_init_62

  l_h_ehci_init_routes_filled:
  movzx ecx, byte ptr [es:eax + EHCI_REG_CAPLENGTH]
  mov edx, [es:eax + EHCI_REG_CAPPARAMS]
  add eax, ecx
  //if ehci_controller.MMIOBase2 <> ehci_controller.MMIOBase1 + 4
  //.err assertion failed
  //end if
  
  stosd   // fill EhciController.mmio_base2
  
  //if ehci_controller.StructuralParams <> ehci_controller.MMIOBase2 + 4
  //.err assertion failed
  //end if
  //if ehci_controller.CapabilityParams <> ehci_controller.StructuralParams + 4
  //.err assertion failed
  //end if
  mov [es:edi], ebx      // fill EhciController.structural_params
  mov [es:edi + 4], edx  // fill EhciController.capability_params
  and ebx, 15
  mov [es:edi + offset UsbController.num_ports + sizeof EhciController - offset EhciController.structural_params], ebx
  mov edi, eax
  // now edi = MMIOBase2
  // 6. Transfer the controller to a known state.
  // 6b. Stop the controller if it is running.
  mov ecx, 10
  test dword ptr [es:edi + EHCI_REG_STATUS], 1 << 12
  jnz l_h_ehci_init_stopped
    and dword ptr [es:edi + EHCI_REG_COMMAND], -1 - 1
    
    l_h_ehci_init_65:
      pushad
        mov ecx, 1
        call p_sleep
      popad
      test dword ptr [es:edi + EHCI_REG_STATUS], 1 << 12
      jnz l_h_ehci_init_stopped
        loop l_h_ehci_init_65
      
    jmp l_h_ehci_init_fail_unmap
    
  l_h_ehci_init_stopped:
  // 6c. Reset the controller. Wait up to 50 ms checking status every 1 ms.
  or dword ptr [es:edi + EHCI_REG_COMMAND], 2
  mov ecx, 50
  
  l_h_ehci_init_66:
    pushad
      mov ecx, 1
      call p_sleep
    popad
    test dword ptr [es:edi + EHCI_REG_COMMAND], 2
    jz l_h_ehci_init_reset_ok
      loop l_h_ehci_init_66
  
  jmp l_h_ehci_init_fail_unmap
  
  l_h_ehci_init_reset_ok:
  // 7. Configure the controller.
pop esi
// 7a. If the controller is 64-bit, say to it that all structures are located
// in first 4G.
test byte ptr [es:esi + offset EhciController.capability_params], 1
jz l_h_ehci_init_71
  and dword ptr [es:edi + EHCI_REG_CTRLDATASEG], 0
  
l_h_ehci_init_71:
// 7b. Hook interrupt and enable appropriate interrupt sources.
// IRQ
add esi, sizeof EhciController
push esi
  sub esi, VA_USB
  or esi, 2 << 24  // 2:EHCI
  
  mov ecx, usb_ecx
  mov edx, usb_edx    
  mov dl, 3Ch  // IRQ
  call h_pci_get  // keep esi
  
  // IN: al = IRQ, esi = controller RA | (0:uhci, 1:ohci, 2:ehci << 24)
  call h_usb_irqs_init  // keep edi
pop esi

// disable Frame List Rollover interrupt, enable all other sources
mov dword ptr [es:edi + EHCI_REG_INTERRUPT], 110111b
// 7c. Inform the controller of the address of periodic lists head.
lea eax, [esi - sizeof EhciController]
call h_usb_getphysadr
mov dword ptr [es:edi + EHCI_REG_PERIODICLIST], eax
// 7d. Inform the controller of the address of asynchronous lists head.
lea eax, [esi + offset EhciController.control_ed - sizeof EhciController]
call h_usb_getphysadr
mov dword ptr [es:edi + EHCI_REG_ASYNCLIST], eax
// 7e. Configure operational details and run the controller.
mov dword ptr [es:edi + EHCI_REG_COMMAND], (1 << 16) + (1 << 5) + (1 << 4) + 1
// (1 << 16) - interrupt threshold = 1 microframe = 0.125ms
// (0 << 11) - disable Async Park Mode
// (0 << 8) - zero Async Park Mode Count
// (1 << 5) - Async Schedule Enable
// (1 << 4) - Periodic Schedule Enable
// (0 << 2) - 1024 elements in FrameList
// 1 - Run

// 7f. Route all ports to this controller, not companion controllers.
mov dword ptr [es:edi + EHCI_REG_CONFIGFLAG], 1
// 8. Apply port power, if needed, and disable all ports.
xor ecx, ecx

l_h_ehci_init_85:
  mov dword ptr [es:edi + EHCI_REG_PORTS + ecx * 4], 1000h  // Port Power enabled, all other bits disabled
  inc ecx
  cmp ecx, [es:esi + offset UsbController.num_ports]
  jb l_h_ehci_init_85
  
test byte ptr [es:esi + offset EhciController.structural_params - sizeof EhciController], 10h
jz l_h_ehci_init_88
  pushad
    mov ecx, 20
    call p_sleep
  popad
  
l_h_ehci_init_88:
// 9. Return pointer to usb_controller.
xchg eax, esi
ret


// On error, pop the pointer saved at step 1 and return zero.
// Note that the main code branch restores the stack at step 7 and never fails
// after step 7.
l_h_ehci_init_fail_unmap:
pop ebx
mov ecx, sizeof EhciController + sizeof UsbController
call h_usb_free
xor eax, eax
ret

l_h_ehci_init_fail:
pop ecx
xor eax, eax
ret


// Helper procedure for step 3 of ehci_init, see comments there.
// Initializes the static head of one list.
// IN: esi = pointer to the "next" list, edi = pointer to head to initialize.
// Advances edi to the next head, keeps esi.
h_ehci_init_static_endpoint:
xor eax, eax
inc eax  // set Terminate bit
mov [es:edi + offset EhciStaticEp.next_td], eax
mov [es:edi + offset EhciStaticEp.alternate_next_td], eax
test esi, esi
jz l_h_ehci_init_static_endpoint_1
  mov eax, esi
  call h_usb_getphysadr
  inc eax
  inc eax  // set Type to EHCI_TYPE_QH
  
l_h_ehci_init_static_endpoint_1:
mov [es:edi + offset EhciStaticEp.next_qh], eax
mov [es:edi + offset EhciStaticEp.next_list], esi
mov byte ptr [es:edi + offset EhciStaticEp.overlay_token], 1 << 6  // halted
add edi, offset EhciStaticEp.software_part

mov [es:edi + offset UsbStaticEp.next_virt], edi
mov [es:edi + offset UsbStaticEp.prev_virt], edi

add edi, sizeof EhciStaticEp - offset EhciStaticEp.software_part
ret

// Helper procedure for step 3 of ehci_init, see comments there.
// Initializes one half of group of static heads.
// edx = size of the next group = half of size of the group,
// edi = pointer to the group, esi = pointer to the next group.
// Advances esi, edi to next group, keeps edx.
h_ehci_init_static_ep_group:
push edx
  
  l_h_ehci_init_static_ep_group_5:
    call h_ehci_init_static_endpoint
    add esi, sizeof EhciStaticEp
    dec edx
    jnz l_h_ehci_init_static_ep_group_5
    
pop edx
ret

h_ehci_irq_04:
ret

// IN: esi -> UsbController
h_ehci_irq:
// 2. Get the mask of events which should be processed.
mov edi, [es:esi + offset EhciController.mmio_base2 - sizeof EhciController]
mov eax, [es:edi + EHCI_REG_STATUS]
// 3. Check whether that interrupt has been generated by our controller.
// (One IRQ can be shared by several devices.)
and eax, [es:edi + EHCI_REG_INTERRUPT]
jz h_ehci_irq_04
// 4. Clear the events we know of.
// Note that this should be done before processing of events:
// new events could arise while we are processing those, this way we won't lose
// them (the controller would generate another interrupt after completion
// of this one).
mov [es:edi + EHCI_REG_STATUS], eax
// We can't do too much from an interrupt handler. Inform the processing thread
// that it should perform appropriate actions.
or [es:esi + offset EhciController.deferred_actions - sizeof EhciController], eax

// post message
// IN: ebx = winid:(threadid+16384), ecx = msg, edx = wp, esi = lp
// OUT: al = 0 || errorcode
mov ebx, usb_thread
mov ecx, WM_USB_INT
xor edx, edx
// esi -> UsbController
call p_msg_post
ret

// This procedure is called in the USB thread from usb_thread,
// processes regular actions and those actions which can't be safely done
// from interrupt handler.
// Returns maximal time delta before the next call.
// IN: esi -> UsbController
h_ehci_process_deferred:
push ebx
 push edi
  mov edi, [es:esi + offset EhciController.mmio_base2 - sizeof EhciController]
  // 1. Get the mask of events to process.
  xor eax, eax
  xchg eax, [es:esi + offset EhciController.deferred_actions - sizeof EhciController]
  push eax
    // 2. Initialize the return value.
    push -1
      // Handle roothub events.
      // 3a. Test whether there are such events.
      test al, 4
      jz l_h_ehci_process_deferred_skip_roothub
      // Status of some port has changed. Loop over all ports.
      // 3b. Prepare for the loop: start from port 0.
      xor ecx, ecx
      
      l_h_ehci_process_deferred_35:
        // 3c. Get the port status and changes of it.
        // If there are no changes, just continue to the next port.
        mov eax, [es:edi + EHCI_REG_PORTS + ecx * 4]
        test al, 2Ah
        jz l_h_ehci_process_deferred_nextport
        // 3d. Clear change bits and read the status again.
        // (It is possible, although quite unlikely, that some event occurs between
        // the first read and the clearing, invalidating the old status. If an event
        // occurs after the clearing, we will not miss it, looking in the next scan.
        mov [es:edi + EHCI_REG_PORTS + ecx * 4], eax
        mov ebx, eax
        mov eax, [es:edi + EHCI_REG_PORTS + ecx * 4]
        // 3e. Handle overcurrent.
        // Note: that needs work.
        test bl, 20h // overcurrent change
        jz l_h_ehci_process_deferred_noovercurrent
          test al, 10h // overcurrent active
          jz l_h_ehci_process_deferred_noovercurrent
          
        l_h_ehci_process_deferred_noovercurrent:
        // 3f. Handle changing of connection status.
        test bl, 2
        jz l_h_ehci_process_deferred_nocsc
          // There was a connect or disconnect event at this port.
          // 3g. Disconnect the old device on this port, if any.
          // If the port was resetting, indicate fail// later stages will process it.
          // Ignore connect event immediately after resetting.
          cmp dword ptr [es:esi + offset UsbController.resetting_hub], 0
          jnz l_h_ehci_process_deferred_csc_noreset
            cmp cl, [es:esi + offset UsbController.resetting_port]
            jnz l_h_ehci_process_deferred_csc_noreset
              cmp byte ptr [es:esi + offset UsbController.resetting_status], 2
              jnz l_h_ehci_process_deferred_36
                test al, 1
                jnz l_h_ehci_process_deferred_nextport
                
              l_h_ehci_process_deferred_36:
              mov byte ptr [es:esi + offset UsbController.resetting_status], -1
              
          l_h_ehci_process_deferred_csc_noreset:
          bts dword ptr [es:esi + offset UsbController.new_disconnected], ecx
          // 3h. Change connected status. For the connection event, also store
          // the connection time// any further processing is permitted only after
          // USB_CONNECT_DELAY ticks.
          test al, 1
          jz l_h_ehci_process_deferred_disconnect
            mov eax, tmr_usb_timerticks  // GetTimerTicks
            mov [es:esi + offset UsbController.connected_time + ecx * 4], eax
            bts [es:esi + offset UsbController.new_connected], ecx
            jmp short l_h_ehci_process_deferred_nextport
            
          l_h_ehci_process_deferred_disconnect:
          btr [es:esi + offset UsbController.new_connected], ecx
          jmp short l_h_ehci_process_deferred_nextport
          
        l_h_ehci_process_deferred_nocsc:
        // 3i. Handle port disabling.
        // Note: that needs work.
        test al, 8
        jz l_h_ehci_process_deferred_37
          test al, 4
          jz l_h_ehci_process_deferred_37
          
        l_h_ehci_process_deferred_37:
        // 3j. Continue the loop for the next port.
        l_h_ehci_process_deferred_nextport:
        inc ecx
        cmp ecx, [es:esi + offset UsbController.num_ports]
        jb l_h_ehci_process_deferred_35
        
      l_h_ehci_process_deferred_skip_roothub:
      // 4. Process disconnect events. This should be done after step 3
      // (which includes the first stage of disconnect processing).
      
      call h_usb_disconnect_stage2
      
      // 5. Check for previously connected devices.
      // If there is a connected device which was connected less than
      // USB_CONNECT_DELAY ticks ago, plan to wake up when the delay will be over.
      // Otherwise, call ehci_new_port.
      // This should be done after step 3.
      xor ecx, ecx
      cmp [es:esi + offset UsbController.new_connected], ecx
      jz l_h_ehci_process_deferred_skip_newconnected
      
      l_h_ehci_process_deferred_55:
        bt dword ptr [es:esi + offset UsbController.new_connected], ecx
        jnc l_h_ehci_process_deferred_noconnect
          mov eax, tmr_usb_timerticks  // GetTimerTicks
          sub eax, [es:esi + offset UsbController.connected_time + ecx * 4]
          sub eax, USB_CONNECT_DELAY
          jge l_h_ehci_process_deferred_connected
            neg eax
            cmp [ss:esp], eax
            jb l_h_ehci_process_deferred_nextport2
              mov [ss:esp], eax
              jmp short l_h_ehci_process_deferred_nextport2
            
          l_h_ehci_process_deferred_connected:
          btr dword ptr [es:esi + offset UsbController.new_connected], ecx
          call h_ehci_new_port
          jmp short l_h_ehci_process_deferred_55
          
        l_h_ehci_process_deferred_noconnect:
        l_h_ehci_process_deferred_nextport2:
        inc ecx
        cmp ecx, [es:esi + offset UsbController.num_ports]
        jb l_h_ehci_process_deferred_55
        
      l_h_ehci_process_deferred_skip_newconnected:
      // 6. Process wait lists.
      // 6a. Periodic endpoints.
      // If a request is pending >8 microframes, satisfy it.
      // If a request is pending <=8 microframes, schedule next wakeup in 0.01s.
      mov eax, [es:esi + offset UsbController.wait_pipe_request_periodic]
      cmp eax, [es:esi + offset UsbController.ready_pipe_head_periodic]
      jz l_h_ehci_process_deferred_noperiodic
        mov edx, [es:edi + EHCI_REG_FRAMEINDEX]
        sub edx, [es:esi + offset UsbController.start_wait_frame]
        and edx, 0x3FFF
        cmp edx, 8
        jna l_h_ehci_process_deferred_61
          mov [es:esi + offset UsbController.ready_pipe_head_periodic], eax
          jmp short l_h_ehci_process_deferred_noperiodic
          
        l_h_ehci_process_deferred_61:
    pop eax
    push 1  // wakeup in 0.01 sec for the next test
      
      l_h_ehci_process_deferred_noperiodic:
      // 6b. Asynchronous endpoints.
      // Satisfy a request when InterruptOnAsyncAdvance fired.
      test byte ptr [ss:esp + 4], 20h
      jz l_h_ehci_process_deferred_62
        mov eax, [es:esi + offset UsbController.wait_pipe_request_async]
        mov [es:esi + offset UsbController.ready_pipe_head_async], eax
        
      l_h_ehci_process_deferred_62:
      // Some hardware in some (rarely) conditions set the status bit,
      // but just does not generate the corresponding interrupt.
      // Force checking the status here.
      mov eax, [es:esi + offset UsbController.wait_pipe_request_async]
      cmp [es:esi + offset UsbController.ready_pipe_head_async], eax
      jz l_h_ehci_process_deferred_noasync
        
        pushfd
          cli
          mov edx, [es:edi + EHCI_REG_STATUS]
          test dl, 20h
          jz l_h_ehci_process_deferred_63
            mov dword ptr [es:edi + EHCI_REG_STATUS], 20h
            and dword ptr [es:esi + offset EhciController.deferred_actions - sizeof EhciController], -1 - 20h
            mov [es:esi + offset UsbController.ready_pipe_head_async], eax
            
            popfd
            
            jmp short l_h_ehci_process_deferred_noasync
            
          l_h_ehci_process_deferred_63:
        popfd
        
        cmp dword ptr [ss:esp], 100
        jb l_h_ehci_process_deferred_noasync
          mov dword [ss:esp], 100
        
      l_h_ehci_process_deferred_noasync:
      // 7. Finalize transfers processed by hardware.
      // It is better to perform this step after step 4 (disconnect events),
      // although not strictly obligatory. This way, an active transfer aborted
      // due to disconnect would be handled with more specific USB_STATUS_CLOSED,
      // not USB_STATUS_NORESPONSE.
      test byte ptr [ss:esp + 4], 3
      jz l_h_ehci_process_deferred_71
        call h_ehci_process_updated_schedule
        
      l_h_ehci_process_deferred_71:
      // 8. Test whether reset signalling has been started and should be stopped now.
      // This must be done after step 7, because completion of some transfer could
      // result in resetting a new port.
      l_h_ehci_process_deferred_test_reset:
      // 8a. Test whether reset signalling is active.
      cmp byte ptr [es:esi + offset UsbController.resetting_status], 1
      jnz l_h_ehci_process_deferred_no_reset
        // 8b. Yep. Test whether it should be stopped.
        mov eax, tmr_usb_timerticks  // GetTimerTicks
        sub eax, [es:esi + offset UsbController.reset_time]
        sub eax, USB_RESET_TIME
        jnl l_h_ehci_process_deferred_reset_done
          // 8c. Not yet, but initiate wakeup in -eax ticks and exit this step.
          neg eax
          cmp [ss:esp], eax
          jb l_h_ehci_process_deferred_skip_reset
            mov [ss:esp], eax
            jmp short l_h_ehci_process_deferred_skip_reset
          
        l_h_ehci_process_deferred_reset_done:
        // 8d. Yep, call the worker function and proceed to 8e.
        call h_ehci_port_reset_done
        
      l_h_ehci_process_deferred_no_reset:
      // 8e. Test whether reset process is done, either successful or failed.
      cmp byte ptr [es:esi + offset UsbController.resetting_status], 0
      jz l_h_ehci_process_deferred_skip_reset
        // 8f. Yep. Test whether it should be stopped.
        mov eax, tmr_usb_timerticks
        sub eax, [es:esi + offset UsbController.reset_time]
        sub eax, USB_RESET_RECOVERY_TIME
        jnl l_h_ehci_process_deferred_reset_recovery_done
          // 8g. Not yet, but initiate wakeup in -eax ticks and exit this step.
          neg eax
          cmp [ss:esp], eax
          jb l_h_ehci_process_deferred_skip_reset
            mov [ss:esp], eax
            jmp short l_h_ehci_process_deferred_skip_reset
            
        l_h_ehci_process_deferred_reset_recovery_done:
        // 8h. Yep, call the worker function. This could initiate another reset,
        // so return to the beginning of this step.
        call h_ehci_port_init
        jmp l_h_ehci_process_deferred_test_reset
        
      l_h_ehci_process_deferred_skip_reset:
      // 9. Process wait-done notifications, test for new wait requests.
      // Note: that must be done after steps 4 and 7 which could create new requests.
      // 9a. Call the worker function.
      
      call h_usb_process_wait_lists
      
      // 9b. If it reports that an asynchronous endpoint should be removed,
      // doorbell InterruptOnAsyncAdvance and schedule wakeup in 1s
      // (sometimes it just does not fire).
      test al, 1 << CONTROL_PIPE
      jz l_h_ehci_process_deferred_81
        mov edx, [es:esi + offset UsbController.wait_pipe_list_async]
        mov [es:esi + offset UsbController.wait_pipe_request_async], edx
        or dword ptr [es:edi + EHCI_REG_COMMAND], 1 << 6
        cmp dword ptr [ss:esp], 100
        jb l_h_ehci_process_deferred_81
          mov dword ptr [ss:esp], 100
          
      l_h_ehci_process_deferred_81:
      // 9c. If it reports that a periodic endpoint should be removed,
      // save the current frame and schedule wakeup in 0.01 sec.
      test al, 1 << INTERRUPT_PIPE
      jz l_h_ehci_process_deferred_82
        mov eax, [es:esi + offset UsbController.wait_pipe_list_periodic]
        mov [es:esi + offset UsbController.wait_pipe_request_periodic], eax
        mov edx, [es:edi + EHCI_REG_FRAMEINDEX]
        mov [es:esi + offset UsbController.start_wait_frame], edx
        mov dword ptr [ss:esp], 1  // wakeup in 0.01 sec for next test
        
      l_h_ehci_process_deferred_82:
      // 10. Pop the return value, restore the stack after step 1 and return.
    pop eax
  pop ecx
 pop edi
pop ebx
ret

// This procedure is called from usb_set_address_callback
// and stores USB device address in the ehci_pipe structure.
// IN: esi -> UsbController, ebx -> UsbPipe, cl = address
h_ehci_set_adr:
mov byte ptr [es:ebx + offset EhciPipe.token - sizeof EhciPipe], cl
jmp h_usb_subscribe_control

// This procedure returns USB device address from the EhciPipe structure.
// IN: esi -> UsbController, ebx -> UsbPipe
// OUT: eax = endpoint address
h_ehci_get_adr:
mov eax, [es:ebx + offset EhciPipe.token - sizeof EhciPipe]
and eax, 7Fh
ret

// This procedure is called from usb_set_address_callback
// if the device does not accept SET_ADDRESS command and needs
// to be disabled at the port level.
// IN: esi -> UsbController, ecx = port (zero-based)
h_ehci_disable_port:
mov eax, [es:esi + offset EhciController.mmio_base2 - sizeof EhciController]
and dword ptr [es:eax + EHCI_REG_PORTS + ecx * 4], -1 - (4 | 2Ah)
ret

// This function is called from ehci_process_deferred when
// a new device was connected at least USB_CONNECT_DELAY ticks
// and therefore is ready to be configured.
// IN: ecx = port, esi -> EhciController, edi -> EHCI MMIO 2
h_ehci_new_port:
// 1. If the device operates at low-speed, just release it to a companion.
mov eax, [es:edi + EHCI_REG_PORTS + ecx * 4]
mov edx, eax
and ah, 0Ch
cmp ah, 4
jz l_h_ehci_new_port_low_speed
  // 2. Devices operating at full-speed and high-speed must now have ah == 8.
  // Some broken hardware asserts both D+ and D- even after initial decoupling;
  // if so, stop initialization here, no sense in further actions.
  cmp ah, 0Ch
  jz l_h_ehci_new_port_9
    // 3. If another port is resetting right now, mark this port as 'reset pending'
    // and return.
    bts dword ptr [es:esi + offset UsbController.pending_ports], ecx
    cmp byte ptr [es:esi + offset UsbController.resetting_port], -1
    jnz l_h_ehci_new_port_9
      btr dword ptr [es:esi + offset UsbController.pending_ports], ecx
      // Otherwise, fall through to h_ehci_new_port_reset.
      
// This function is called from ehci_new_port and usb_test_pending_port.
// It starts reset signalling for the port. Note that in USB first stages
// of configuration can not be done for several ports in parallel.
h_ehci_new_port_reset:
push edi
  mov edi, [es:esi + offset EhciController.mmio_base2 - sizeof EhciController]
  mov eax, [es:edi + EHCI_REG_PORTS + ecx * 4]
  // 1. Store information about resetting hub (roothub) and port.
  and dword ptr [es:esi + offset UsbController.resetting_hub], 0
  mov byte ptr [es:esi + offset UsbController.resetting_port], cl
  // 2. Initiate reset signalling.
  or ah, 1
  and al, -1 - (4 | 2Ah)
  mov [es:edi + EHCI_REG_PORTS + ecx * 4], eax
  // 3. Store the current time and set status to 1 = reset signalling active.
  mov eax, tmr_usb_timerticks  // GetTimerTicks
  mov [es:esi + offset UsbController.reset_time], eax
  mov byte ptr [es:esi + offset UsbController.resetting_status], 1
pop edi

l_h_ehci_new_port_9:
ret

l_h_ehci_new_port_low_speed:
or dh, 20h
and dl, -1 - 2Ah
mov [es:edi + EHCI_REG_PORTS + ecx * 4], edx
ret

// This procedure is called from usb_get_descr8_callback when
// the packet size for zero endpoint becomes known and
// stores the packet size in ehci_pipe structure.
// IN: esi -> UsbController, ebx -> UsbPipe, ecx = packet size
h_ehci_set_ep_packet_size:
mov eax, [es:ebx + offset EhciPipe.token - sizeof EhciPipe]
and eax, -1 - (0x7FF << 16)
shl ecx, 16
or eax, ecx
mov [es:ebx + offset EhciPipe.token - sizeof EhciPipe], eax
// Wait until hardware cache is evicted.
jmp h_usb_subscribe_control

// This procedure allocates memory for pipe.
// Both hardware+software parts must be allocated
// OUT: eax -> UsbPipe || 0
h_ehci_alloc_pipe:
push ecx
 push ebx
  mov ecx, sizeof EhciPipe + sizeof UsbPipe
  call h_usb_alloc
  xchg eax, ebx
  test eax, eax
  jz l_h_ehci_alloc_pipe_9
    add eax, sizeof EhciPipe
    
  l_h_ehci_alloc_pipe_9:
 pop ebx
pop ecx
ret

// This procedure frees memory for pipe allocated by h_ehci_alloc_pipe.
// IN: stack UsbPipe
h_ehci_free_pipe:
mov ebx, [ss:esp + 4]
test ebx, ebx
jz l_h_ehci_free_pipe_9
  push ecx
    sub ebx, sizeof EhciPipe
    mov ecx, sizeof EhciPipe + sizeof UsbPipe
    call h_usb_free
  pop ecx
  
l_h_ehci_free_pipe_9:
ret 4  // ret 4?

// This procedure is called from API usb_open_pipe and processes
// the controller-specific part of this API. See docs.
// IN: edi -> target UsbPipe, ecx -> config UsbPipe
//     esi -> UsbController, eax -> UsbGtd for the 1st TD
//     [ebp+12] = endpoint, [ebp+16] = maxpacket, [ebp+20] = type, [ebp+24] = interval
h_ehci_init_pipe:
/*
// inherit some variables from h_usb_open_pipe
virtual at ebp-12
ebp-12 speed
ebp-8 bandwidth
ebp-4 target
ebp+8 config_pipe
ebp+12 endpoint
ebp+16 maxpacket
ebp+20 type
ebp+24 interval
end virtual
*/

// 1. Zero all fields in the hardware part.
push eax
 push ecx
  sub edi, sizeof EhciPipe
  xor eax, eax
  mov ecx, sizeof EhciPipe / 4
  cld
  rep stosd
 pop ecx
pop eax
// 2. Setup PID in the first TD and make sure that it is not active.
xor edx, edx
test byte ptr [es:ebp + 12], 80h  // endpoint
setnz dh
mov [es:eax + offset EhciGtd.htd.token - sizeof EhciGtd], edx
mov dword ptr [es:eax + offset EhciGtd.htd.next_td - sizeof EhciGtd], 1
mov dword ptr [es:eax + offset EhciGtd.htd.alternate_next_td - sizeof EhciGtd], 1
// 3. Store the physical address of the first TD.
sub eax, sizeof EhciGtd
call h_usb_getphysadr
mov [es:edi + offset EhciPipe.overlay.next_td - sizeof EhciPipe], eax
// 4. Fill EhciPipe.flags except for S and C masks.
// Copy location from the config pipe.
mov eax, [es:ecx + offset EhciPipe.flags - sizeof EhciPipe]
and eax, 3FFF0000h
// Use 1 requests per microframe for control/bulk endpoints,
// use value from the endpoint descriptor for periodic endpoints
mov edx, 1
test dword ptr [es:ebp + 20], 1  // type
jz l_h_ehci_init_pipe_2
  mov edx, [es:ebp + 16]  // maxpacket
  shr edx, 11
  inc edx
  
l_h_ehci_init_pipe_2:
shl edx, 30
or eax, edx
mov [es:edi + offset EhciPipe.flags - sizeof EhciPipe], eax
// 5. Fill EhciPipe.token.
mov eax, [es:ecx + offset EhciPipe.token - sizeof EhciPipe]
// copy following fields from the config pipe:
// DeviceAddress, EndpointSpeed, ControlEndpoint if new type is control
mov ecx, eax
and eax, 307Fh
and ecx, 8000000h
or ecx, 4000h
mov edx, [es:ebp + 12]  // endpoint
and edx, 15
shl edx, 8
or eax, edx
mov edx, [es:ebp + 16]  // maxpacket
shl edx, 16
or eax, edx
// for control endpoints, use DataToggle from TD, otherwise use DataToggle from QH
cmp dword ptr [es:ebp + 20], CONTROL_PIPE  // type
jnz l_h_ehci_init_pipe_3
  or eax, ecx
  
l_h_ehci_init_pipe_3:
// for control/bulk USB2 endpoints, set NakCountReload to 4
test eax, USB_SPEED_HS << 12
jz l_h_ehci_init_pipe_nonak
  cmp dword ptr [es:ebp + 20], CONTROL_PIPE  // type
  jz l_h_ehci_init_pipe_4
    cmp dword ptr [es:ebp + 20], BULK_PIPE  // type
    jnz l_h_ehci_init_pipe_nonak
    
  l_h_ehci_init_pipe_4:
  or eax, 40000000h
  
l_h_ehci_init_pipe_nonak:
mov [es:edi + offset EhciPipe.token - sizeof EhciPipe], eax
// 5. Select the corresponding list and insert to the list.
// 5a. Use Control list for control pipes, Bulk list for bulk pipes.
lea edx, [esi + offset EhciController.control_ed.software_part - sizeof EhciController]
cmp dword ptr [es:ebp + 20], BULK_PIPE  // type
jb l_h_ehci_init_pipe_insert // control pipe
  lea edx, [esi + offset EhciController.bulk_ed.software_part - sizeof EhciController]
  jz l_h_ehci_init_pipe_insert // bulk pipe

l_h_ehci_init_pipe_interrupt_pipe:
  // 5b. For interrupt pipes, let the scheduler select the appropriate list
  // and the appropriate microframe(s) (which goes to S-mask and C-mask)
  // based on the current bandwidth distribution and the requested bandwidth.
  // There are two schedulers, one for high-speed devices,
  // another for split transactions.
  // This could fail if the requested bandwidth is not available;
  // if so, return an error.
  test word ptr [es:edi + offset EhciPipe.flags - sizeof EhciPipe + 2], 3FFFh
  jnz l_h_ehci_init_pipe_interrupt_tt
    call h_ehci_select_hs_interrupt_list
    jmp short l_h_ehci_init_pipe_interrupt_common
    
  l_h_ehci_init_pipe_interrupt_tt:
    call h_ehci_select_tt_interrupt_list
    
  l_h_ehci_init_pipe_interrupt_common:
  test edx, edx
  jz l_h_ehci_init_pipe_94
    mov word ptr [es:edi + offset EhciPipe.flags - sizeof EhciPipe], ax
  
l_h_ehci_init_pipe_insert:
mov [es:edi + offset UsbPipe.base_list], edx
// Insert to the head of the corresponding list.
// Note: inserting to the head guarantees that the list traverse in
// ehci_process_updated_schedule, once started, will not interact with new pipes.
// However, we still need to ensure that links in the new pipe (edi.NextVirt)
// are initialized before links to the new pipe (edx.NextVirt).
// 5c. Insert in the list of virtual addresses.
mov ecx, [es:edx + offset UsbPipe.next_virt]
mov [es:edi + offset UsbPipe.next_virt], ecx
mov [es:edi + offset UsbPipe.prev_virt], edx
mov [es:ecx + offset UsbPipe.prev_virt], edi
mov [es:edx + offset UsbPipe.next_virt], edi
// 5d. Insert in the hardware list: copy previous NextQH to the new pipe,
// store the physical address of the new pipe to previous NextQH.
mov ecx, [es:edx + offset EhciStaticEp.next_qh - offset EhciStaticEp.software_part]
mov [es:edi + offset EhciPipe.next_qh - sizeof EhciPipe], ecx
lea eax, [edi - sizeof EhciPipe]
call h_usb_getphysadr
inc eax
inc eax
mov [es:edx + offset EhciStaticEp.next_qh - offset EhciStaticEp.software_part], eax
// 6. Return with nonzero eax.
ret

l_h_ehci_init_pipe_94:
xor eax, eax
ret

// This procedure unlinks the pipe from the corresponding pipe list.
// esi -> UsbController, ebx -> UsbPipe
h_ehci_unlink_pipe:
cmp dword ptr [es:ebx + offset UsbPipe.type], INTERRUPT_PIPE
jnz l_h_ehci_unlink_pipe_9
  test word ptr [es:ebx + offset EhciPipe.flags - sizeof EhciPipe + 2], 3FFFh
  jnz l_h_ehci_unlink_pipe_fs
    call h_ehci_hs_interrupt_list_unlink
    jmp short l_h_ehci_unlink_pipe_9
    
  l_h_ehci_unlink_pipe_fs:
    call h_ehci_fs_interrupt_list_unlink
  
l_h_ehci_unlink_pipe_9:
ret

h_ehci_alloc_gtd:
push ecx
 push ebx
  mov ecx, sizeof EhciGtd + sizeof UsbGtd
  call h_usb_alloc
  xchg eax, ebx
  test eax, eax
  jz l_h_ehci_alloc_td_9
    add eax, sizeof EhciGtd
    
  l_h_ehci_alloc_td_9:
 pop ebx
pop ecx
ret

// IN: stack UsbGtd
h_ehci_free_gtd:
push ebx
 push ecx
  mov ebx, [ss:esp + 8 + 4]
  sub ebx, sizeof EhciGtd
  mov ecx, sizeof EhciGtd + sizeof UsbGtd
  call h_usb_free
 pop ecx
pop ebx
ret 4  // ret 4?

// This procedure is called from several places in main USB code
// and allocates required packets for the given transfer.
// IN: ebx -> UsbPipe
// buffer, size = data to transfer
// flags = same as in usb_open_pipe: bit 0 = allow short transfer, other bits reserved
// td = pointer to the current end-of-queue descriptor
// direction =
//   0000b for normal transfers,
//   1000b for control SETUP transfer,
//   1101b for control OUT transfer,
//   1110b for control IN transfer
// returns eax = pointer to the new end-of-queue descriptor
// (not included in the queue itself) or 0 on error
h_ehci_alloc_transfer:
// 16 buffer:dword, 20 size:dword, 24 flags:dword, 28 td:dword, 32 direction:dword
/*
12 ret_adr
8 token  // not used
4 origTD
0 packetSize  // must be last variable, see usb_init_transfer
*/
sub esp, 12

// 1. Save original value of td:
// it will be useful for rollback if something would fail.
mov eax, [ss:esp + 28]  // td
mov [ss:esp + 4], eax  // origTD
// One transfer descriptor can describe up to 5 pages.
// In the worst case (when the buffer is something*1000h+0FFFh)
// this corresponds to 4001h bytes. If the requested size is
// greater, we should split the transfer into several descriptors.
// Boundaries to split must be multiples of endpoint transfer size
// to avoid short packets except in the end of the transfer.
cmp dword ptr [ss:esp + 20], 4001h  // size
jna l_h_ehci_alloc_transfer_lastpacket
  // 2. While the remaining data cannot fit in one descriptor,
  // allocate full descriptors (of maximal possible size).
  // 2a. Calculate size of one descriptor: must be a multiple of transfer size
  // and must be not greater than 4001h.
  movzx ecx, word ptr [es:ebx + offset EhciPipe.token + 2 - sizeof EhciPipe]
  and ecx, (1 << 11) - 1
  mov eax, 4001h
  xor edx, edx
  mov edi, eax
  div ecx
  sub edi, edx
  mov [ss:esp + 0], edi  // packetSize
  
  l_h_ehci_alloc_transfer_5:
    call h_ehci_alloc_packet
    test eax, eax
    jz l_h_ehci_alloc_transfer_fail
      mov [ss:esp + 28], eax  // td
      add [ss:esp + 16], edi  // buffer
      sub [ss:esp + 20], edi  // size
      cmp dword ptr [ss:esp + 20], 4001h  // size
      ja l_h_ehci_alloc_transfer_5
      
// 3. The remaining data can fit in one packet;
// allocate the last descriptor with size = size of remaining data.
l_h_ehci_alloc_transfer_lastpacket:
mov eax, [ss:esp + 20]  // size
mov [ss:esp + 0], eax  // packetSize
call h_ehci_alloc_packet  // out ecx
test eax, eax
jz l_h_ehci_alloc_transfer_fail
  // 9. Update flags in the last packet.
  mov edx, [ss:esp + 24]  // flags
  mov [es:ecx + offset EhciGtd.flags - sizeof EhciGtd], edx
  // 10. Fill AlternateNextTD field in all allocated TDs.
  // If the caller says that short transfer is ok, the queue must advance to
  // the next descriptor, which is in eax.
  // Otherwise, the queue should stop, so make AlternateNextTD point to
  // always-inactive descriptor StopQueueTD.
  push eax
    test dl, 1
    jz l_h_ehci_alloc_transfer_disable_short
      sub eax, sizeof EhciGtd
      jmp short l_h_ehci_alloc_transfer_61
      
    l_h_ehci_alloc_transfer_disable_short:
    mov eax, [es:ebx + offset UsbPipe.controller]
    add eax, offset EhciController.stop_queue_td - sizeof EhciController
    
    l_h_ehci_alloc_transfer_61:
    call h_usb_getphysadr
    mov edx, [ss:esp + 4 + 4]  // origTD
    
    l_h_ehci_alloc_transfer_65:
      cmp edx, [ss:esp]
      jz l_h_ehci_alloc_transfer_68
        mov [es:edx + offset EhciGtd.htd.alternate_next_td - sizeof EhciGtd], eax
        mov edx, [es:edx + offset UsbGtd.next_virt]
        jmp short l_h_ehci_alloc_transfer_65
        
    l_h_ehci_alloc_transfer_68:
  pop eax
  
  add esp, 12
  ret 20
  
l_h_ehci_alloc_transfer_fail:
mov esi, [es:ebx + offset UsbPipe.controller]
mov edi, [es:esi + offset UsbController.hardware_func]
mov eax, [ss:esp + 28]  // td
push dword ptr [ss:esp + 4]  // origTD
call h_usb_undo_tds
xor eax, eax

add esp, 12
ret 20

// This procedure is called from several places in main USB code
// and activates the transfer which was previously allocated by
// h_ehci_alloc_transfer.
// IN: eax = ?([ss:esp+4]), ecx -> last descriptor for the transfer, ebx -> usb_pipe
h_ehci_insert_transfer:
or byte ptr [es:ecx + offset EhciGtd.htd.token + 1 - sizeof EhciGtd], 80h  // set IOC bit

l_h_ehci_insert_transfer_5:
  or byte ptr [es:eax + offset EhciGtd.htd.token - sizeof EhciGtd], 80h    // set Active bit
  cmp eax, ecx
  mov eax, [es:eax + offset UsbGtd.next_virt]
  jnz l_h_ehci_insert_transfer_5
  
ret

// This procedure is called from ehci_port_init and from hub support code
// when a new device is connected and has been reset.
// It calls h_usb_new_device at the protocol layer with correct parameters.
// IN: esi -> UsbController, eax = speed.
h_ehci_new_device:
push ebx
 push ecx
  // 1. Store the speed for the protocol layer.
  mov [es:esi + offset UsbController.resetting_speed], al
  // 2. Shift speed bits to the proper place in EhciPipe.Token.
  shl eax, 12
  // 3. For high-speed devices, go to step 5 with edx = 0.
  xor edx, edx
  cmp ah, USB_SPEED_HS << (12 - 8)
  jz l_h_ehci_new_device_common
    // 4. For low-speed and full-speed devices, fill address:port
    // of the last high-speed hub (the closest to the device hub)
    // for split transactions, and set ControlEndpoint bit in eax//
    // ehci_init_pipe assumes that the parent pipe is a control pipe.
    push eax
      movzx ecx, byte ptr [es:esi + offset UsbController.resetting_port]
      mov edx, [es:esi + offset UsbController.resetting_hub]
      call h_usb_get_tt
      inc ecx
      mov edx, [es:edx + offset EhciPipe.token - sizeof EhciPipe]
      shl ecx, 23
      and edx, 7Fh
      shl edx, 16
      or edx, ecx        // EhciPipe.flags
    pop eax
    or eax, 1 << 27   // EhciPipe.token
    
  l_h_ehci_new_device_common:
  // 5. Create pseudo-pipe in the stack.
  // See ehci_init_pipe: only .Controller, .Token, .Flags fields are used.
  push esi     // UsbPipe.controller
    mov ecx, esp
    sub esp, sizeof EhciPipe - offset EhciPipe.flags - 4
     push edx     // EhciPipe.flags
      push eax     // EhciPipe.token
      // 6. Notify the protocol layer.
      
      call h_usb_new_device
      
      // 7. Cleanup the stack after step 5 and return.
  add esp, sizeof EhciPipe - offset EhciPipe.flags + 8
 pop ecx
pop ebx
ret

// This procedure temporarily removes the given pipe from hardware queue.
// IN: esi -> UsbController, ebx -> UsbPipe
h_ehci_disable_pipe:
mov eax, [es:ebx + offset EhciPipe.next_qh - sizeof EhciPipe]
mov ecx, [es:ebx + offset UsbPipe.prev_virt]
mov edx, esi
sub edx, ecx
cmp edx, sizeof EhciController
jb l_h_ehci_disable_pipe_prev_is_static
  mov [es:ecx + offset EhciPipe.next_qh - sizeof EhciPipe], eax
  ret
  
l_h_ehci_disable_pipe_prev_is_static:
mov [es:ecx + offset EhciStaticEp.next_qh - offset EhciStaticEp.software_part], eax
ret

// This procedure reinserts the given pipe to hardware queue
// after ehci_disable_pipe, with clearing transfer queue.
// IN: esi -> UsbController, ebx -> UsbPipe
//     edx -> current descriptor, eax -> new last descriptor
h_ehci_enable_pipe:
// 1. Clear transfer queue.
// 1a. Clear status bits so that the controller will try to advance the queue
// without doing anything, keep DataToggle and PID bits.
and dword ptr [es:ebx + offset EhciPipe.overlay.token - sizeof EhciPipe], 80000000h
// 1b. Set [Alternate]NextTD to physical address of the new last descriptor.
sub eax, sizeof EhciGtd
call h_usb_getphysadr
mov [es:ebx + offset EhciPipe.head_td - sizeof EhciPipe], eax
mov [es:ebx + offset EhciPipe.overlay.next_td - sizeof EhciPipe], eax
mov [es:ebx + offset EhciPipe.overlay.alternate_next_td - sizeof EhciPipe], eax
// 2. Reinsert the pipe to hardware queue.
lea eax, [ebx - sizeof EhciPipe]
call h_usb_getphysadr
inc eax
inc eax
mov ecx, [es:ebx + offset UsbPipe.prev_virt]
mov edx, esi
sub edx, ecx
cmp edx, sizeof EhciController
jb l_h_ehci_enable_pipe_prev_is_static
  mov edx, [es:ecx + offset EhciPipe.next_qh - sizeof EhciPipe]
  mov [es:ebx + offset EhciPipe.next_qh - sizeof EhciPipe], edx
  mov [es:ecx + offset EhciPipe.next_qh - sizeof EhciPipe], eax
  ret
  
l_h_ehci_enable_pipe_prev_is_static:
mov edx, [es:ecx + offset EhciStaticEp.next_qh - offset EhciStaticEp.software_part]
mov [es:ebx + offset EhciPipe.next_qh - sizeof EhciPipe], edx
mov [es:ecx + offset EhciStaticEp.next_qh - offset EhciStaticEp.software_part], eax
ret

// Put the given control/bulk pipe in the wait list;
// called when the pipe structure is changed and a possible hardware cache
// needs to be synchronized. When it will be known that the cache is updated,
// usb_subscription_done procedure will be called.
h_usb_subscribe_control:
cmp dword ptr [es:ebx + offset UsbPipe.next_wait], -1
jnz l_h_usb_subscribe_control_9
  mov eax, [es:esi + offset UsbController.wait_pipe_list_async]
  mov [es:ebx + offset UsbPipe.next_wait], eax
  mov [es:esi + offset UsbController.wait_pipe_list_async], ebx
  
l_h_usb_subscribe_control_9:
ret

// Same as usb_subscribe_control, but for interrupt/isochronous pipe.
h_usb_subscribe_periodic:
cmp dword ptr [es:ebx + offset UsbPipe.next_wait], -1
jnz l_h_usb_subscribe_periodic_9
  mov eax, [es:esi + offset UsbController.wait_pipe_list_periodic]
  mov [es:ebx + offset UsbPipe.next_wait], eax
  mov [es:esi + offset UsbController.wait_pipe_list_periodic], ebx
  
l_h_usb_subscribe_periodic_9:
ret

// Initial stage of disconnect processing: called when device is disconnected.
// IN: ebx -> UsbPipe
h_usb_device_disconnected:
// Loop over all pipes, close everything, wait until hardware reacts.
// The final handling is done in usb_pipe_closed.
push ebx
  mov ecx, [es:ebx + offset UsbPipe.device_data]
  call p_mutex_lock
  lea eax, [ecx + offset UsbDevData.opened_pipe_list - offset UsbPipe.next_sibling]
  push eax
    mov ebx, [es:eax + offset UsbPipe.next_sibling]
    
    l_h_usb_device_disconnected_5:
      call h_usb_close_pipe_nolock
      mov ebx, [es:ebx + offset UsbPipe.next_sibling]
      cmp ebx, [ss:esp]
      jnz l_h_usb_device_disconnected_5
      
  pop eax
pop ebx
mov ecx, [es:ebx + offset UsbPipe.device_data]
call p_mutex_unlock
ret

// This procedure is regularly called from controller-specific ProcessDeferred,
// it checks whether there are disconnected events and if so, process them.
// IN: esi -> UsbController
h_usb_disconnect_stage2:
bsf ecx, [es:esi + offset UsbController.new_disconnected]
jz l_h_usb_disconnect_stage2_9
  lock btr [es:esi + offset UsbController.new_disconnected], ecx
  btr [es:esi + offset UsbController.pending_ports], ecx
  xor ebx, ebx
  xchg ebx, [es:esi + offset UsbController.devices_by_port + ecx * 4]
  test ebx, ebx
  jz h_usb_disconnect_stage2
  
  call h_usb_device_disconnected
  jmp short h_usb_disconnect_stage2
  
l_h_usb_disconnect_stage2_9:
ret

// Helper procedure for usb_process_wait_lists
// does the same for one wait queue.
// IN: esi -> UsbController,
//     edx: 0 for *async, 4 for *periodic list
// OUT: CF = issue new request
h_usb_process_one_wait_list:
// 1. Check whether there is a pending request. If so, do nothing.
mov ebx, [es:esi + offset UsbController.wait_pipe_request_async + edx]
cmp ebx, [es:esi + offset UsbController.ready_pipe_head_async + edx]
clc
jnz l_h_usb_process_one_wait_list_9

// 2. Check whether there are new data. If so, issue a new request.
cmp ebx, [es:esi + offset UsbController.wait_pipe_list_async + edx]
stc
jnz l_h_usb_process_one_wait_list_9

test ebx, ebx
jz l_h_usb_process_one_wait_list_9

// 3. Clear all lists.
xor ecx, ecx
mov [es:esi + offset UsbController.wait_pipe_list_async + edx], ecx
mov [es:esi + offset UsbController.wait_pipe_request_async + edx], ecx
mov [es:esi + offset UsbController.ready_pipe_head_async + edx], ecx
// 4. Loop over all pipes from the wait list.

l_h_usb_process_one_wait_list_5:
  // For every pipe:
  // 5. Save edx and next pipe in the list.
  push edx
   push dword ptr [es:ebx + offset UsbPipe.next_wait]
    // 6. If USB_FLAG_EXTRA_WAIT is set, reinsert the pipe to the list and continue.
    test dword ptr [es:ebx + offset UsbPipe.flags], USB_FLAG_EXTRA_WAIT
    jz l_h_usb_process_one_wait_list_process
      mov eax, [es:esi + offset UsbController.wait_pipe_list_async + edx]
      mov [es:ebx + offset UsbPipe.next_wait], eax
      mov [es:esi + offset UsbController.wait_pipe_list_async + edx], ebx
      jmp short l_h_usb_process_one_wait_list_continue
      
    l_h_usb_process_one_wait_list_process:
    // 7. Call the handler depending on USB_FLAG_CLOSED and USB_FLAG_DISABLED.
    or dword ptr [es:ebx + offset UsbPipe.next_wait], -1
    test dword ptr [es:ebx + offset UsbPipe.flags], USB_FLAG_CLOSED
    jz l_h_usb_process_one_wait_list_nodisconnect
      call h_usb_pipe_closed
      jmp short l_h_usb_process_one_wait_list_continue
      
    l_h_usb_process_one_wait_list_nodisconnect:
    test dword ptr [es:ebx + offset UsbPipe.flags], USB_FLAG_DISABLED
    jz l_h_usb_process_one_wait_list_nodisabled
      call h_usb_pipe_disabled
      jmp short l_h_usb_process_one_wait_list_continue
      
    l_h_usb_process_one_wait_list_nodisabled:
    call h_usb_subscription_done
    
    l_h_usb_process_one_wait_list_continue:
    // 8. Restore edx and next pipe saved in step 5 and continue the loop.
   pop ebx
  pop edx
  test ebx, ebx
  jnz l_h_usb_process_one_wait_list_5
  
// 9. Set CF depending on whether WaitPipeList* is nonzero.
cmp dword ptr [es:esi + offset UsbController.wait_pipe_list_async + edx], 1
cmc

l_h_usb_process_one_wait_list_9:
ret

// Called from controller-specific ProcessDeferred,
// processes wait-pipe-done notifications,
// returns whether there are more items in wait queues.
// IN: esi -> UsbController
// OUT: eax = bitmask of pipe types with non-empty wait queue
h_usb_process_wait_lists:
xor edx, edx
push edx
  call h_usb_process_one_wait_list
  jnc l_h_usb_process_wait_lists_1
    or byte ptr [ss:esp], 1 << CONTROL_PIPE
    
  l_h_usb_process_wait_lists_1:
  mov edx, 4
  call h_usb_process_one_wait_list
  jnc l_h_usb_process_wait_lists_2
    or byte ptr [ss:esp], 1 << INTERRUPT_PIPE
    
  l_h_usb_process_wait_lists_2:
  xor edx, edx
  call h_usb_process_one_wait_list
  jnc l_h_usb_process_wait_lists_3
    or byte ptr [ss:esp], 1 << CONTROL_PIPE
    
  l_h_usb_process_wait_lists_3:
pop eax
ret

// Called from USB1 controller-specific initialization.
// Finds EHCI companion controller for given USB1 controller.
// IN: bl = PCI device:function for USB1 controller, bh = PCI bus
// OUT: eax -> UsbController for EHCI companion || 0
h_usb_find_ehci_companion:
// 1. Loop over all registered controllers.
mov eax, VA_USB_CONTROLLERS_LIST

l_h_usb_find_ehci_companion_5:
  mov eax, [es:eax + offset UsbController.next]
  cmp eax, VA_USB_CONTROLLERS_LIST
  jz l_h_usb_find_ehci_companion_notfound
    // 2. For every controller, check the type, ignore everything that is not EHCI.
    mov edx, [es:eax + offset UsbController.hardware_func]
    cmp dword ptr [es:edx + offset UsbHardwareFunc.id], 'EHCI'
    jnz l_h_usb_find_ehci_companion_5
    
    // 3. For EHCI controller, compare PCI coordinates with input data:
    // bus and device must be the same, function can be different.
    mov edx, [es:eax + offset UsbController.pci_coordinates]
    xor edx, ebx
    cmp dx, 8
    jnb l_h_usb_find_ehci_companion_5
    
  ret
  
l_h_usb_find_ehci_companion_notfound:
xor eax, eax
ret

// This function is called when a new device has either passed
// or failed first stages of configuration, so the next device
// can enter configuration process.
// IN: esi -> UsbController
h_usb_test_pending_port:
mov byte ptr [es:esi + offset UsbController.resetting_port], -1
cmp dword ptr [es:esi + offset UsbController.pending_ports], 0
jz l_h_usb_test_pending_port_9
  bsf ecx, [es:esi + offset UsbController.pending_ports]
  btr [es:esi + offset UsbController.pending_ports], ecx
  mov eax, [es:esi + offset UsbController.hardware_func]
  jmp dword ptr [es:eax + offset UsbHardwareFunc.initiate_reset]  // new_port
  
l_h_usb_test_pending_port_9:
ret

// Called after synchronization of hardware cache with software changes.
// Continues process of device enumeration based on when it was delayed
// due to call to usb_subscribe_control.
// IN: ebx -> UsbPipe
h_usb_subscription_done:
mov eax, [es:ebx + offset UsbPipe.device_data]
cmp dword ptr [es:eax + offset UsbDevData.device_descr_size], 0
jz near h_usb_after_set_address
jmp h_usb_after_set_endpoint_size

// Find Transaction Translator hub and port for the given device.
// IN: edx = parent hub for the device, ecx = port for the device
// OUT: edx = TT hub for the device, ecx = TT port for the device.
h_usb_get_tt:
// If the parent hub is high-speed, it is TT for the device.
// Otherwise, the parent hub itself is behind TT, and the device
// has the same TT hub+port as the parent hub.
mov eax, [es:edx + offset UsbHub.config_pipe]
mov eax, [es:eax + offset UsbPipe.device_data]
cmp dword ptr [es:eax + offset UsbDevData.speed], USB_SPEED_HS
jz l_h_usb_get_tt_1
  mov ecx, [es:eax + offset UsbDevData.tt_port]
  mov edx, [es:eax + offset UsbDevData.tt_hub]
  
l_h_usb_get_tt_1:
mov edx, [es:edx + offset UsbHub.config_pipe]
ret

// Part of API for drivers, see documentation for USBOpenPipe.
// OUT: eax -> UsbPipe
h_usb_open_pipe:
// ebp+8 config_pipe, ebp+12 endpoint, ebp+16 maxpacket, ebp+20 type, ebp+24 interval
/*
ebp-108 tt_vars    rd 24  // should be enough for ehci_select_tt_interrupt_list
ebp-12 targetsmask dd ?   // S-Mask for USB2
ebp-8 bandwidth    dd ?
ebp-4 target       dd ?
*/

push ebp
mov ebp, esp
sub esp, 108

// 1. Verify type of pipe: it must be one of *_PIPE constants.
// Isochronous pipes are not supported yet.
mov eax, [ss:ebp + 20] // type
cmp eax, INTERRUPT_PIPE
ja l_h_usb_open_pipe_badtype
  cmp al, ISOCHRONOUS_PIPE
  jnz l_h_usb_open_pipe_goodtype
  
l_h_usb_open_pipe_badtype:
xor eax, eax
jmp l_h_usb_open_pipe_9

l_h_usb_open_pipe_goodtype:
// 2. Allocate memory for pipe and transfer queue.
// Empty transfer queue consists of one inactive TD.
mov ebx, [ss:ebp + 8]  // config_pipe
mov esi, [es:ebx + offset UsbPipe.controller]
mov edx, [es:esi + offset UsbController.hardware_func]
call dword ptr [es:edx + offset UsbHardwareFunc.alloc_pipe]  // keep esi
test eax, eax
jz near l_h_usb_open_pipe_9

mov edi, eax
mov edx, [es:esi + offset UsbController.hardware_func]
call dword ptr [es:edx + offset UsbHardwareFunc.alloc_gtd]  // keep esi, edi
test eax, eax
jz l_h_usb_open_pipe_free_and_return0

// 3. Initialize transfer queue: pointer to transfer descriptor,
// pointers in transfer descriptor, queue lock.
mov [es:edi + offset UsbPipe.last_td], eax
mov [es:eax + offset UsbGtd.next_virt], eax
mov [es:eax + offset UsbGtd.prev_virt], eax
mov [es:eax + offset UsbGtd.pipe], edi
lea ecx, [edi + offset UsbPipe.lock]
call p_mutex_init  // keep all
// 4. Initialize software part of pipe structure, except device-related fields.
mov al, byte ptr [es:ebp + 20] // type
mov [es:edi + offset UsbPipe.type], al
xor eax, eax
mov [es:edi + offset UsbPipe.flags], al
mov [es:edi + offset UsbPipe.device_data], eax
mov [es:edi + offset UsbPipe.controller], esi
or dword ptr [es:edi + offset UsbPipe.next_wait], -1
// 5. Initialize device-related fields:
// for zero endpoint, set .NextSibling = .PrevSibling = this//
// for other endpoins, copy device data, take the lock guarding pipe list
// for the device and verify that disconnect processing has not yet started
// for the device. (Since disconnect processing also takes that lock,
// either it has completed or it will not start until we release the lock.)
// Note: usb_device_disconnected should not see the new pipe until
// initialization is complete, so that lock will be held during next steps
// (disconnect processing should either not see it at all, or see fully
// initialized pipe).
cmp [ss:ebp + 12], eax  // endpoint
jz l_h_usb_open_pipe_zero_endpoint
  
  mov ebx, [ss:ebp + 8]  // config_pipe
  mov ecx, [es:ebx + offset UsbPipe.device_data]
  mov [es:edi + offset UsbPipe.device_data], ecx
  call p_mutex_lock
  test dword ptr [es:ebx + offset UsbPipe.flags], USB_FLAG_CLOSED
  jz l_h_usb_open_pipe_common
    
    l_h_usb_open_pipe_fail:
    // If disconnect processing has completed, unlock the mutex, free memory
    // allocated in step 2 and return zero.
    call p_mutex_unlock
    mov edx, [es:esi + offset UsbController.hardware_func]
    push dword ptr [es:edi + offset UsbPipe.last_td]
    call dword ptr [es:edx + offset UsbHardwareFunc.free_gtd]  // keep esi
    
    l_h_usb_open_pipe_free_and_return0:
    mov edx, [es:esi + offset UsbController.hardware_func]
    push edi
    call dword ptr [es:edx + offset UsbHardwareFunc.free_pipe]
    xor eax, eax
    jmp l_h_usb_open_pipe_9
    
l_h_usb_open_pipe_zero_endpoint:
mov [es:edi + offset UsbPipe.next_sibling], edi
mov [es:edi + offset UsbPipe.prev_sibling], edi

l_h_usb_open_pipe_common:
// 6. Initialize hardware part of pipe structure.
// 6a. Acquire the corresponding mutex.
lea ecx, [esi + offset UsbController.control_lock]
cmp dword ptr [ss:ebp + 20], BULK_PIPE  // type
jb l_h_usb_open_pipe_61  // control pipe
  lea ecx, [esi + offset UsbController.bulk_lock]
  jz l_h_usb_open_pipe_61  // bulk pipe
    lea ecx, [esi + offset UsbController.periodic_lock]
    
l_h_usb_open_pipe_61:
call p_mutex_lock
// 6b. Let the controller-specific code do its job.
push ecx
  mov edx, [es:esi + offset UsbController.hardware_func]
  mov eax, [es:edi + offset UsbPipe.last_td]
  mov ecx, [ss:ebp + 8]  // config_pipe
  call dword ptr [es:edx + offset UsbHardwareFunc.init_pipe]  // out eax, keep edi, ebx
pop ecx
// 6c. Release the mutex.
call p_mutex_unlock  // keep all
// 6d. If controller-specific code indicates failure,
// release the lock taken in step 5, free memory allocated in step 2
// and return zero.
test eax, eax
jz l_h_usb_open_pipe_fail

// 7. The pipe is initialized. If this is not the first pipe for the device,
// insert it to the tail of pipe list for the device,
// increment number of pipes,
// release the lock taken at step 5.
mov ecx, [es:edi + offset UsbPipe.device_data]
jecxz l_h_usb_open_pipe_8
  mov eax, [es:ebx + offset UsbPipe.prev_sibling]
  mov [es:edi + offset UsbPipe.next_sibling], ebx
  mov [es:edi + offset UsbPipe.prev_sibling], eax
  mov [es:ebx + offset UsbPipe.prev_sibling], edi
  mov [es:eax + offset UsbPipe.next_sibling], edi
  inc dword ptr [es:ecx + offset UsbDevData.num_pipes]
  call p_mutex_unlock
  
l_h_usb_open_pipe_8:
// 8. Return pointer to UsbPipe.
mov eax, edi

l_h_usb_open_pipe_9:
mov esp, ebp
pop ebp
ret 20

// Part of API for drivers, see documentation for USBAbortPipe.
// IN: stack -> UsbPipe
h_usb_abort_pipe:
push ebx
 push esi  // save used registers to be stdcall
  mov ebx, [ss:esp + 12]  // pipe
  // 1. Acquire pipe lock.
  lea ecx, [ebx + offset UsbPipe.lock]
  call p_mutex_lock
  // 2. If the pipe is already closed or abort is in progress,
  // just release pipe lock and return.
  test dword ptr [es:ebx + offset UsbPipe.flags], USB_FLAG_CLOSED + USB_FLAG_DISABLED
  jnz near l_h_usb_abort_pipe_9
  
  // 3. Mark the pipe as aborting.
  or dword ptr [es:ebx + offset UsbPipe.flags], USB_FLAG_DISABLED
  // 4. We cannot do anything except adding new transfers concurrently with hardware.
  // Ask the controller driver to (temporarily) remove the pipe from hardware queue.
  mov esi, [es:ebx + offset UsbPipe.controller]
  // 4a. Acquire queue lock.
  lea ecx, [esi + offset UsbController.control_lock]
  cmp dword ptr [es:ebx + offset UsbPipe.type], BULK_PIPE
  jb l_h_usb_abort_pipe_1  // control pipe
    lea ecx, [esi + offset UsbController.bulk_lock]
    jz l_h_usb_abort_pipe_1  // bulk pipe
      lea ecx, [esi + offset UsbController.periodic_lock]
      
  l_h_usb_abort_pipe_1:
  call p_mutex_lock
  push ecx
    // 4b. Call the driver.
    mov eax, [es:esi + offset UsbController.hardware_func]
    call dword ptr [es:eax + offset UsbHardwareFunc.disable_pipe]  // keep ebx
    // 4c. Remove the pipe from software list.
    mov eax, [es:ebx + offset UsbPipe.next_virt]
    mov edx, [es:ebx + offset UsbPipe.prev_virt]
    mov [es:eax + offset UsbPipe.prev_virt], edx
    mov [es:edx + offset UsbPipe.next_virt], eax
    // 4c. Register the pipe in corresponding wait list.
    test byte ptr [es:ebx + offset UsbPipe.type], 1
    jz l_h_usb_abort_pipe_control_bulk
      call h_usb_subscribe_periodic
      jmp short l_h_usb_abort_pipe_4
      
    l_h_usb_abort_pipe_control_bulk:
    call h_usb_subscribe_control
    
    l_h_usb_abort_pipe_4:
    // 4d. Release queue lock.
  pop ecx
  call p_mutex_unlock
  // 4e. Notify the USB thread about new work.
  call h_usb_notify
  // That's all for now. To be continued in usb_pipe_disabled.
  // 5. Release pipe lock acquired at step 1 and return.
  
  l_h_usb_abort_pipe_9:
  lea ecx, [ebx + offset UsbPipe.lock]
  call p_mutex_unlock
 pop esi
pop ebx
ret 4

// Notify the USB thread about new work
// IN: ebx -> UsbPipe
h_usb_notify:
push ebx
 push esi
  push edi
    mov esi, [es:ebx + offset UsbPipe.controller]
    mov ebx, usb_thread
    or ebx, WIN_NONE << 16
    mov ecx, WM_USB_INT
    xor edx, edx
    call p_msg_post
  pop edi
 pop esi
pop ebx
ret

// Helper procedure for controller-specific code:
// removes one TD from the transfer queue
// IN: ebx -> UsbGtd to remove
h_usb_unlink_td:
mov ecx, [es:ebx + offset UsbGtd.pipe]
add ecx, offset UsbPipe.lock
call p_mutex_lock
mov eax, [es:ebx + offset UsbGtd.prev_virt]
mov edx, [es:ebx + offset UsbGtd.next_virt]
mov [es:edx + offset UsbGtd.prev_virt], eax
mov [es:eax + offset UsbGtd.next_virt], edx
call p_mutex_unlock
ret

// Helper procedure for handling short packets in controller-specific code.
// IN: es:ebx -> UsbGtd
// OUT: CF cleared if this is the final packet in some stage:
//      for control transfers that means one of Data and Status stages,
//      for other transfers - the final packet in the only stage.
h_usb_is_final_packet:
cmp dword ptr [es:ebx + offset UsbGtd.callback], 0
jnz l_h_usb_is_final_packet_nothing
  mov eax, [es:ebx + offset UsbGtd.next_virt]
  cmp dword ptr [es:eax + offset UsbGtd.callback], 0
  jz l_h_usb_is_final_packet_stc
    mov eax, [es:ebx + offset UsbGtd.pipe]
    cmp dword ptr [es:eax + offset UsbPipe.type], CONTROL_PIPE
    jz l_h_usb_is_final_packet_nothing
    
  l_h_usb_is_final_packet_stc:
  stc
  
l_h_usb_is_final_packet_nothing:
ret

// One part of transfer is completed, run the associated callback
// or update total length in the next part of the transfer.
// IN: ebx -> UsbGtd, ecx = status, edx = length
h_usb_process_gtd:
// 1. Test whether it is the last descriptor in the transfer
// <=> it has an associated callback.
mov eax, [es:ebx + offset UsbGtd.callback]
test eax, eax
jz l_h_usb_process_gtd_nocallback
  // 2. It has an associated callback; call it with corresponding parameters.
  push ebx
   push esi
    push edi
        
      push dword ptr [es:ebx + offset UsbGtd.user_data]
       push edx
        push dword ptr [es:ebx + offset UsbGtd.buffer]
         push ecx
          push dword ptr [es:ebx + offset UsbGtd.pipe]
      call eax
      
    pop edi
   pop esi
  pop ebx
  ret
  
l_h_usb_process_gtd_nocallback:
// 3. It is an intermediate descriptor. Add its length to the length
// in the following descriptor.
mov eax, [es:ebx + offset UsbGtd.next_virt]
add [es:eax + offset UsbGtd.length], edx
ret

// Initialize software part of UsbGtd. Called from controller-specific code
// somewhere in alloc_transfer
// IN: eax -> next (inactive) UsbGtd, ebx -> UsbPipe
//     [.td] -> current (initializing) UsbGtd
// OUT: ecx = [.td]
// KEEP: ebx, esi, edi
h_usb_init_transfer:
/*
// 28 buffer:dword, 32 size:dword, 36 flags:dword, 40 td:dword, 44 direction:dword
24 ret_adr
20 token
16 origTD
12 packetSize
8 ret_adr
4 eax
0 ret_adr

virtual at ebp-4
.Size   dd      ?
rd      2
.Buffer dd      ?
dd      ?
.Flags  dd      ?
.td     dd      ?
end virtual
*/
mov [es:eax + offset UsbGtd.pipe], ebx
mov ecx, [ss:esp + 40]  // td / origTD?
mov [es:eax + offset UsbGtd.prev_virt], ecx
mov edx, [es:ecx + offset UsbGtd.next_virt]
mov [es:ecx + offset UsbGtd.next_virt], eax
mov [es:eax + offset UsbGtd.next_virt], edx
mov [es:edx + offset UsbGtd.prev_virt], eax
mov edx, [ss:esp + 12]  // size / packetSize?
mov [es:ecx + offset UsbGtd.length], edx
xor edx, edx
mov [es:ecx + offset UsbGtd.callback], edx
mov [es:ecx + offset UsbGtd.user_data], edx
ret

// This procedure is called several times during initial device configuration,
// when usb_device_data structure is reallocated.
// It (re)initializes all pointers in UsbDevData.
// IN: ebx -> UsbPipe
// KEEP: eax, edx, ebx, esi, edi
h_usb_reinit_pipe_list:
push eax
  // 1. (Re)initialize the lock guarding pipe list.
  mov ecx, [es:ebx + offset UsbPipe.device_data]
  call p_mutex_init
  // 2. Initialize list of opened pipes: two entries, the head and ebx.
  add ecx, offset UsbDevData.opened_pipe_list - offset UsbPipe.next_sibling
  mov [es:ecx + offset UsbPipe.next_sibling], ebx
  mov [es:ecx + offset UsbPipe.prev_sibling], ebx
  mov [es:ebx + offset UsbPipe.next_sibling], ecx
  mov [es:ebx + offset UsbPipe.prev_sibling], ecx
  // 3. Initialize list of closed pipes: empty list, only the head is present.
  add ecx, offset UsbDevData.closed_pipe_list - offset UsbDevData.opened_pipe_list
  mov [es:ecx + offset UsbPipe.next_sibling], ecx
  mov [es:ecx + offset UsbPipe.prev_sibling], ecx
pop eax
ret

// Worker function for pipe closing. Called by usb_close_pipe API and
// from disconnect processing.
// The lock guarding pipe list for the device should be held by the caller.
// IN: ebx -> UsbPipe, esi -> UsbController
h_usb_close_pipe_nolock:
// 1. Set the flag "pipe is closed, ignore new transfers".
// If it was already set, do nothing.
lea ecx, [ebx + offset UsbPipe.lock]
call p_mutex_lock
bts dword ptr [es:ebx + offset UsbPipe.flags], USB_FLAG_CLOSED_BIT
jc l_h_usb_close_pipe_nolock_closed

call p_mutex_unlock
// 2. Remove the pipe from the list of opened pipes.
mov eax, [es:ebx + offset UsbPipe.next_sibling]
mov edx, [es:ebx + offset UsbPipe.prev_sibling]
mov [es:eax + offset UsbPipe.prev_sibling], edx
mov [es:edx + offset UsbPipe.next_sibling], eax
// 3. Unlink the pipe from hardware structures.
// 3a. Acquire the corresponding lock.
lea edx, [esi + offset UsbController.wait_pipe_list_async]
lea ecx, [esi + offset UsbController.control_lock]
cmp dword ptr [es:ebx + offset UsbPipe.type], BULK_PIPE
jb l_h_usb_close_pipe_nolock_1  // control pipe
  lea ecx, [esi + offset UsbController.bulk_lock]
  jz l_h_usb_close_pipe_nolock_1  // bulk pipe
    add edx, offset UsbController.wait_pipe_list_periodic - offset UsbController.wait_pipe_list_async
    lea ecx, [esi + offset UsbController.periodic_lock]
    
l_h_usb_close_pipe_nolock_1:
push edx
  call p_mutex_lock
  push ecx
    // 3b. Let the controller-specific code do its job.
    test dword ptr [es:ebx + offset UsbPipe.flags], USB_FLAG_DISABLED
    jnz l_h_usb_close_pipe_nolock_2
      mov eax, [es:esi + offset UsbController.hardware_func]
      call dword ptr [es:eax + offset UsbHardwareFunc.disable_pipe]  // keep ebx, esi
      
    l_h_usb_close_pipe_nolock_2:
    mov eax, [es:esi + offset UsbController.hardware_func]
    call dword ptr [es:eax + offset UsbHardwareFunc.unlink_pipe]  // keep ebx
    mov edx, [es:ebx + offset UsbPipe.next_virt]
    mov eax, [es:ebx + offset UsbPipe.prev_virt]
    mov [es:edx + offset UsbPipe.prev_virt], eax
    mov [es:eax + offset UsbPipe.next_virt], edx
    // 3c. Release the corresponding lock.
  pop ecx
  call p_mutex_unlock
  // 4. Put the pipe into wait queue.
pop edx
cmp dword ptr [es:ebx + offset UsbPipe.next_wait], -1
jz l_h_usb_close_pipe_nolock_insert_new
  or dword ptr [es:ebx + offset UsbPipe.flags], USB_FLAG_EXTRA_WAIT
  jmp short l_h_usb_close_pipe_nolock_inserted
  
l_h_usb_close_pipe_nolock_insert_new:
mov eax, [es:edx]
mov [es:ebx + offset UsbPipe.next_wait], eax
mov [es:edx], ebx

l_h_usb_close_pipe_nolock_inserted:
// 5. Return.
ret

l_h_usb_close_pipe_nolock_closed:
call p_mutex_unlock
xor eax, eax
ret

// This procedure is called when a pipe with USB_FLAG_CLOSED is removed from the
// corresponding wait list. It means that the hardware has fully forgot about it.
// IN: ebx -> UsbPipe, esi -> UsbController
h_usb_pipe_closed:
push edi
  mov edi, [es:esi + offset UsbController.hardware_func]
  // 1. Notify all registered callbacks with status USB_STATUS_CLOSED, if any,
  // and free all transfer descriptors, including the last one.
  lea ecx, [ebx + offset UsbPipe.lock]
  call p_mutex_lock
  mov edx, [es:ebx + offset UsbPipe.last_td]
  test edx, edx
  jz l_h_usb_pipe_closed_no_transfer
    mov eax, [es:edx + offset UsbGtd.next_virt]
    push edx
     push eax
      call p_mutex_unlock
      push USB_STATUS_CLOSED
    call h_usb_pipe_aborted
    // It is safe to free LastTD here:
    // usb_*_transfer_async do not enqueue new transfers if USB_FLAG_CLOSED is set
    push dword ptr [es:ebx + offset UsbPipe.last_td]
    call dword ptr [es:edi + offset UsbHardwareFunc.free_gtd]
    jmp short l_h_usb_pipe_closed_2
    
  l_h_usb_pipe_closed_no_transfer:
  call p_mutex_unlock
  
  l_h_usb_pipe_closed_2:
  // 2. Decrement number of pipes for the device.
  // If this pipe is the last pipe, go to 5.
  mov ecx, [es:ebx + offset UsbPipe.device_data]
  call p_mutex_lock
  dec dword ptr [es:ecx + offset UsbDevData.num_pipes]
  jz l_h_usb_pipe_closed_last_pipe
  
  call p_mutex_unlock
  // 3. If the flag "the driver has abandoned this pipe" is set,
  // free memory and return.
  test dword ptr [es:ebx + offset UsbPipe.flags], USB_FLAG_CAN_FREE
  jz l_h_usb_pipe_closed_nofree
  
  push ebx
  call dword ptr [es:edi + offset UsbHardwareFunc.free_pipe]
pop edi
ret

  // 4. Otherwise, add it to the list of closed pipes and return.
  l_h_usb_pipe_closed_nofree:
  add ecx, offset UsbDevData.closed_pipe_list - offset UsbPipe.next_sibling
  mov edx, [es:ecx + offset UsbPipe.prev_sibling]
  mov [es:ebx + offset UsbPipe.next_sibling], ecx
  mov [es:ebx + offset UsbPipe.prev_sibling], edx
  mov [es:ecx + offset UsbPipe.prev_sibling], ebx
  mov [es:edx + offset UsbPipe.next_sibling], ebx
pop edi
ret

  l_h_usb_pipe_closed_last_pipe:
  // That was the last pipe for the device.
  // 5. Notify device driver(s) about disconnect.
  call p_mutex_unlock
  mov eax, [es:ecx + offset UsbDevData.num_interfaces]
  test eax, eax
  jz l_h_usb_pipe_closed_notify_done
    add ecx, [es:ecx + offset UsbDevData.interfaces]
    
    l_h_usb_pipe_closed_5:
      mov edx, [es:ecx + offset UsbInterfaceData.driver_func]
      test edx, edx
      jz l_h_usb_pipe_closed_51
        //mov edx, [es:edx+USBSRV.usb_func]
        //cmp [es:edx+USBFUNC.strucsize], USBFUNC.device_disconnect + 4
        //jb l_h_usb_pipe_closed_51
          mov edx, [cs:edx + 8]  // disconnect
          test edx, edx
          jz l_h_usb_pipe_closed_51
            push eax
             push ecx
              push dword ptr [es:ecx + offset UsbInterfaceData.driver_data]
              call dword ptr edx
             pop ecx
            pop eax
            
      l_h_usb_pipe_closed_51:
      add ecx, sizeof UsbInterfaceData
      dec eax
      jnz l_h_usb_pipe_closed_5
      
  l_h_usb_pipe_closed_notify_done:
  // 6. Kill the timer, if active.
  // (Usually not; possible if device is disconnected
  // while processing SET_ADDRESS request).
  mov eax, [es:ebx + offset UsbPipe.device_data]
  cmp dword ptr [es:eax + offset UsbDevData.timer], 0
  jz l_h_usb_pipe_closed_61
    push esi
     push edi
      push eax
       push ebx
        mov edx, usb_thread
        shl edx, 16
        mov dx, WIN_NONE
        mov ebx, [es:eax + offset UsbDevData.timer]
        call h_timer_remove
       pop ebx
      pop eax    
     pop edi
    pop esi
    mov dword ptr [es:eax + offset UsbDevData.timer], 0
    
  l_h_usb_pipe_closed_61:
  // 7. Bus address, if assigned, can now be reused.
  call dword ptr [es:edi + offset UsbHardwareFunc.get_device_address]
  test eax, eax
  jz l_h_usb_pipe_closed_62
    bts dword ptr [es:esi + offset UsbController.existing_addresses], eax
    
  l_h_usb_pipe_closed_62:
  //dbgstr 'USB device disconnected'
  // 8. All drivers have returned from disconnect callback,
  // so all drivers should not use any device-related pipes.
  // Free the remaining pipes.
  mov eax, [es:ebx + offset UsbPipe.device_data]
  add eax, offset UsbDevData.closed_pipe_list - offset UsbPipe.next_sibling
  push eax
    mov eax, [es:eax + offset UsbPipe.next_sibling]
    
    l_h_usb_pipe_closed_65:
    cmp eax, [ss:esp]
    jz l_h_usb_pipe_closed_68
      push dword ptr [es:eax + offset UsbPipe.next_sibling]
        push eax
        call dword ptr [es:edi + offset UsbHardwareFunc.free_pipe]
      pop eax
      jmp l_h_usb_pipe_closed_65
    
    l_h_usb_pipe_closed_68:
    push ebx
    call dword ptr [es:edi + offset UsbHardwareFunc.free_pipe]
  pop eax
  // 9. Free the UsbDevData structure
  sub eax, offset UsbDevData.closed_pipe_list - offset UsbPipe.next_sibling
  push ebx
    xchg ebx, eax
    call m_heap_free_kernel
  pop ebx
  // 10. Return
  l_h_usb_pipe_closed_9:
pop edi
ret

// This procedure is called when a pipe with USB_FLAG_DISABLED is removed from the
// corresponding wait list. It means that the hardware has fully forgot about it.
// ebx -> usb_pipe, esi -> usb_controller
h_usb_pipe_disabled:
push edi
  mov edi, [es:esi + offset UsbController.hardware_func]
  // 1. Acquire pipe lock.
  lea ecx, [ebx + offset UsbPipe.lock]
  call p_mutex_lock
  // 2. Clear USB_FLAG_DISABLED in pipe state.
  and dword ptr [es:ebx + offset UsbPipe.flags], -1 - USB_FLAG_DISABLED
  // 3. Sanity check: ignore uninitialized pipes.
  cmp dword ptr [es:ebx + offset UsbPipe.last_td], 0
  jz near l_h_usb_pipe_disabled_no_transfer
  
  // 4. Acquire the first and last to-be-cancelled transfer descriptor,
  // save them in stack for the step 6,
  // ask the controller driver to enable the pipe for hardware,
  // removing transfers between first and last to-be-cancelled descriptors.
  lea ecx, [esi + offset UsbController.control_lock]
  cmp dword ptr [es:ebx + offset UsbPipe.type], BULK_PIPE
  jb l_h_usb_pipe_disabled_1  // control pipe
    lea ecx, [esi + offset UsbController.bulk_lock]
    jz l_h_usb_pipe_disabled_1  // bulk pipe
      lea ecx, [esi + offset UsbController.periodic_lock]
  
  l_h_usb_pipe_disabled_1:
  call p_mutex_lock
  mov eax, [es:ebx + offset UsbPipe.base_list]
  mov edx, [es:eax + offset UsbPipe.next_virt]
  mov [es:ebx + offset UsbPipe.next_virt], edx
  mov [es:ebx + offset UsbPipe.prev_virt], eax
  mov [es:edx + offset UsbPipe.prev_virt], ebx
  mov [es:eax + offset UsbPipe.next_virt], ebx
  mov eax, [es:ebx + offset UsbPipe.last_td]
  mov edx, [es:eax + offset UsbGtd.next_virt]
  mov [es:eax + offset UsbGtd.next_virt], eax
  mov [es:eax + offset UsbGtd.prev_virt], eax
  push eax
   push edx
    push ecx
     call dword ptr [es:edi + offset UsbHardwareFunc.enable_pipe]
    pop ecx
    call p_mutex_unlock
    // 5. Release pipe lock acquired at step 1.
    // Callbacks called at step 6 can insert new transfers,
    // so we cannot call usb_pipe_aborted while holding pipe lock.
    lea ecx, [ebx + offset UsbPipe.lock]
    call p_mutex_unlock
    // 6. Notify all registered callbacks with status USB_STATUS_CANCELLED, if any.
    // Two arguments describing transfers range were pushed at step 4.
    push USB_STATUS_CANCELLED
  call h_usb_pipe_aborted
pop edi
ret

  l_h_usb_pipe_disabled_no_transfer:
  call p_mutex_unlock
pop edi
ret

// This procedure is called when all transfers are aborted
// either due to call to usb_abort_pipe or due to pipe closing.
// It notifies all callbacks and frees all transfer descriptors.
// IN: ebx -> UsbPipe, esi -> UsbController, edi -> UsbHardwareFunc
// three stack parameters: status code for callback functions
// and descriptors where to start and stop.
h_usb_pipe_aborted:
/*
4 status  // USB_STATUS_CLOSED or USB_STATUS_CANCELLED
8 first_td
12 last_td
*/

// Loop over all transfers, calling the driver with the given status
// and freeing all descriptors except the last one.
l_h_usb_pipe_aborted_5:
  mov edx, [ss:esp + 8]  //.first_td
  cmp edx, [ss:esp + 12]  //.last_td
  jz l_h_usb_pipe_aborted_9
    mov ecx, [es:edx + offset UsbGtd.callback]
    test ecx, ecx
    jz l_h_usb_pipe_aborted_no_callback
      push dword ptr [es:edx + offset UsbGtd.user_data]
       push 0
        push dword ptr [es:edx + offset UsbGtd.buffer]
         push dword ptr [ss:esp + 4 + 12]  //.status (+STDCALL_VERIFY_EXTRA)
          push ebx
      call ecx
      mov edx, [ss:esp + 8]  //.first_td
      
    l_h_usb_pipe_aborted_no_callback:
    mov eax, [es:edx + offset UsbGtd.next_virt]
    mov [ss:esp + 8], eax  //.first_td
    push edx
    call dword ptr [es:edi + offset UsbHardwareFunc.free_gtd]
    jmp short l_h_usb_pipe_aborted_5
    
l_h_usb_pipe_aborted_9:
ret 12

// Free all TDs for the current transfer if something has failed
// during initialization (e.g. no memory for the next TD).
// Stdcall with one stack argument = first TD for the transfer
// IN: eax = last initialized TD for the transfer, edi -> HardwareFunc
h_usb_undo_tds:
push dword ptr [es:eax + offset UsbGtd.next_virt]
  
  l_h_usb_undo_tds_5:
    cmp eax, [esp + 8]
    jz l_h_usb_undo_tds_6
      push dword ptr [es:eax + offset UsbGtd.prev_virt]
        push eax
        call dword ptr [es:edi + offset UsbHardwareFunc.free_gtd]
      pop eax
      jmp short l_h_usb_undo_tds_5
      
  l_h_usb_undo_tds_6:
pop ecx
mov [es:eax + offset UsbGtd.next_virt], ecx
mov [es:ecx + offset UsbGtd.prev_virt], eax
ret 4

// Part of API for drivers, see documentation for USBNormalTransferAsync.
// USES: ebx, edi
h_usb_normal_transfer_async:
// 4 pipe:dword, 8 buffer:dword, 12 size:dword, 16 callback:dword,
// 20 calldata:dword, 24 flags:dword

// 1. Sanity check: callback must be nonzero.
// (It is important for other parts of code.)
xor eax, eax
cmp [ss:esp + 16], eax  // callback
jz l_h_usb_normal_transfer_async_9
  // 2. Lock the transfer queue.
  mov ebx, [ss:esp + 4]  // pipe
  lea ecx, [ebx + offset UsbPipe.lock]
  call p_mutex_lock
  // 3. If the pipe has already been closed (presumably due to device disconnect),
  // release the lock taken in step 2 and return zero.
  xor eax, eax
  test dword ptr [es:ebx + offset UsbPipe.flags], USB_FLAG_CLOSED
  jnz l_h_usb_normal_transfer_async_unlock
    // 4. Allocate and initialize TDs for the transfer.
    mov edx, [es:ebx + offset UsbPipe.controller]
    mov edi, [es:edx + offset UsbController.hardware_func]
    
    push edi
      
      push 0
       push dword ptr [es:ebx + offset UsbPipe.last_td]
        push dword ptr [ss:esp + 24 + 12]  // flags
         push dword ptr [ss:esp + 12 + 16]  // size
          push dword ptr [ss:esp + 8 + 20]  // buffer
      call dword ptr [es:edi + offset UsbHardwareFunc.alloc_transfer]
      
    pop edi
    
    // If failed, release the lock taken in step 2 and return zero.
    test eax, eax
    jz l_h_usb_normal_transfer_async_unlock
      // 5. Store callback and its parameters in the last descriptor for this transfer.
      mov ecx, [es:eax + offset UsbGtd.prev_virt]
      mov edx, [ss:esp + 16]  // callback
      mov [es:ecx + offset UsbGtd.callback], edx
      mov edx, [ss:esp + 20]  // calldata
      mov [es:ecx + offset UsbGtd.user_data], edx
      mov edx, [ss:esp + 8]  // buffer
      mov [es:ecx + offset UsbGtd.buffer], edx
      // 6. Advance LastTD pointer and activate transfer.
      push dword ptr [es:ebx + offset UsbPipe.last_td]
        mov [es:ebx + offset UsbPipe.last_td], eax
        call dword ptr [es:edi + offset UsbHardwareFunc.insert_transfer]
      pop eax
      // 7. Release the lock taken in step 2 and
      // return pointer to the first descriptor for the new transfer.
      
  l_h_usb_normal_transfer_async_unlock:
  push eax
    lea ecx, [ebx + offset UsbPipe.lock]
    call p_mutex_unlock
  pop eax
  
l_h_usb_normal_transfer_async_9:
ret 24

// Part of API for drivers, see documentation for USBControlTransferAsync.
// USES: ebx, edi
h_usb_control_async:
push 0  // last_td
// 8 pipe:dword, 12 config:dword, 16 buffer:dword, 20 size:dword,
// 24 callback:dword, 28 calldata:dword, 32 flags:dword

// 1. Sanity check: callback must be nonzero.
// (It is important for other parts of code.)
cmp dword ptr [ss:esp + 24], 0  // callback
jz near l_h_usb_control_async_return0

// 2. Lock the transfer queue.
mov ebx, [ss:esp + 8]  // pipe
lea ecx, [ebx + offset UsbPipe.lock]
call p_mutex_lock
// 3. If the pipe has already been closed (presumably due to device disconnect),
// release the lock taken in step 2 and return zero.
test dword ptr [es:ebx + offset UsbPipe.flags], USB_FLAG_CLOSED
jnz near l_h_usb_control_async_unlock_return0

// A control transfer contains two or three stages:
// Setup stage, optional Data stage, Status stage.
// 4. Allocate and initialize TDs for the Setup stage.
// Payload is 8 bytes from [config].
mov edx, [es:ebx + offset UsbPipe.controller]
mov edi, [es:edx + offset UsbController.hardware_func]
push edi
  
  push (2 << 2) + 0
   push dword ptr [es:ebx + offset UsbPipe.last_td]
    push 0
     push 8
      push dword ptr [ss:esp + 12 + 20]  // config
  call dword ptr [es:edi + offset UsbHardwareFunc.alloc_transfer]
  
pop edi
// short transfer is an error, direction is DATA0, token is SETUP
mov [ss:esp], eax  // last_td
test eax, eax
jz near l_h_usb_control_async_fail

// 5. Allocate and initialize TDs for the Data stage, if [size] is nonzero.
// Payload is [size] bytes from [buffer].
mov edx, [ss:esp + 12]  // config
mov ecx, (3 << 2) + 1  // DATA1, token is OUT
cmp byte ptr [es:edx], 0
jns l_h_usb_control_async_1
  cmp dword ptr [ss:esp + 20], 0  // size
  jz l_h_usb_control_async_1
    inc ecx  // token is IN
  
l_h_usb_control_async_1:
cmp dword ptr [ss:esp + 20], 0  // size
jz l_h_usb_control_async_nodata
  push ecx
   push edi
    
    push ecx
     push eax
      push dword ptr [ss:esp + 32 + 16]  // flags
       push dword ptr [ss:esp + 20 + 20]  // size
        push dword ptr [ss:esp + 16 + 24]  // buffer
    call dword ptr [es:edi + offset UsbHardwareFunc.alloc_transfer]
    
   pop edi
  pop ecx
  test eax, eax
  jz l_h_usb_control_async_fail
    mov [ss:esp], eax  // last_td
    
l_h_usb_control_async_nodata:
// 6. Allocate and initialize TDs for the Status stage.
// No payload.
xor ecx, 3  // IN becomes OUT, OUT becomes IN
push edi
  
  push ecx
   push eax
    push 0
     push 0
      push 0
  call dword ptr [es:edi + offset UsbHardwareFunc.alloc_transfer]
  
pop edi
test eax, eax
jz l_h_usb_control_async_fail
  // 7. Store callback and its parameters in the last descriptor for this transfer.
  mov ecx, [es:eax + offset UsbGtd.prev_virt]
  mov edx, [ss:esp + 24]  // callback
  mov [es:ecx + offset UsbGtd.callback], edx
  mov edx, [ss:esp + 28]  // calldata
  mov [es:ecx + offset UsbGtd.user_data], edx
  mov edx, [ss:esp + 16]  // buffer
  mov [es:ecx + offset UsbGtd.buffer], edx
  // 8. Advance LastTD pointer and activate transfer.
  push dword ptr [es:ebx + offset UsbPipe.last_td]
    mov [es:ebx + offset UsbPipe.last_td], eax
    call dword ptr [es:edi + offset UsbHardwareFunc.insert_transfer]
    // 9. Release the lock taken in step 2 and
    // return pointer to the first descriptor for the new transfer.
    lea ecx, [ebx + offset UsbPipe.lock]
    call p_mutex_unlock
  pop eax
  
  pop edx  // last_td
  
  ret 28
  
l_h_usb_control_async_fail:
mov eax, [ss:esp]  // last_td
test eax, eax
jz l_h_usb_control_async_unlock_return0
  push dword ptr [es:ebx + offset UsbPipe.last_td]
  call h_usb_undo_tds

l_h_usb_control_async_unlock_return0:
lea ecx, [ebx + offset UsbPipe.lock]
call p_mutex_unlock

l_h_usb_control_async_return0:
xor eax, eax

pop edx  // last_td

ret 28

USB_HUB_DESCRIPTOR = 29h
 
// Features for CLEAR_FEATURE commands to the hub.
C_HUB_LOCAL_POWER   = 0
C_HUB_OVER_CURRENT  = 1
 
// Bits in result of GET_STATUS command for a port.
// Also suitable for CLEAR_FEATURE/SET_FEATURE commands, where applicable,
// except TEST/INDICATOR.
PORT_CONNECTION     = 0
PORT_ENABLE         = 1
PORT_SUSPEND        = 2
PORT_OVER_CURRENT   = 3
PORT_RESET          = 4
PORT_POWER          = 8
PORT_LOW_SPEED      = 9
PORT_HIGH_SPEED     = 10
PORT_TEST_BIT       = 11
PORT_INDICATOR_BIT  = 12
C_PORT_CONNECTION   = 16
C_PORT_ENABLE       = 17
C_PORT_SUSPEND      = 18
C_PORT_OVER_CURRENT = 19
C_PORT_RESET        = 20
PORT_TEST_FEATURE   = 21
PORT_INDICATOR_FEATURE = 22
 
// Internal constants
// Bits in usb_hub.Actions
HUB_WAIT_POWERED      = 1
// ports were powered, wait until power is stable
HUB_WAIT_CONNECT      = 2
// some device was connected, wait initial debounce interval
HUB_RESET_IN_PROGRESS = 4
// reset in progress, so buffer for config requests is owned
// by reset process// this includes all stages from initial disconnect test
// to end of setting address (fail on any stage should lead to disabling port,
// which requires a config request)
HUB_RESET_WAITING     = 8
// the port is ready for reset, but another device somewhere on the bus
// is resetting. Implies HUB_RESET_IN_PROGRESS
HUB_RESET_SIGNAL      = 10h
// reset signalling is active for some port in the hub
// Implies HUB_RESET_IN_PROGRESS
HUB_RESET_RECOVERY    = 20h
// reset recovery is active for some port in the hub
// Implies HUB_RESET_IN_PROGRESS

[align 32]
h_usb_hub_fn:
dd 12
dd offset h_usb_hub_init
dd offset h_usb_hub_disconnect

// This procedure is called in the USB thread from usb_thread,
// contains synchronous code which should be activated at certain time
// (e.g. reset a recently connected device after debounce interval 100ms).
// Returns the number of ticks when it should be called next time.
// IN: esi -> UsbHub
h_usb_hub_process_deferred:
// 1. Top-of-stack will contain return value; initialize to infinite timeout.
push -1
  // 2. If wait or stable power is active, then
  // either reschedule wakeup (if time is not over)
  // or start processing notifications.
  test byte ptr [es:esi + offset UsbHub.actions], HUB_WAIT_POWERED
  jz l_h_usb_hub_process_deferred_no_powered
    movzx eax, byte ptr [es:esi + offset UsbHub.power_on_interval]
    // three following instructions are equivalent to edx = ceil(eax / 5) + 1
    // 1 extra tick is added to make sure that the interval is at least as needed
    // (it is possible that PoweredOnTime was set just before timer interrupt, and
    // this test goes on just after timer interrupt)
    add eax, 9
    // two following instructions are equivalent to edx = floor(eax / 5)
    // for any 0 <= eax < 40000000h
    mov ecx, 33333334h
    mul ecx
    mov eax, tmr_usb_timerticks
    sub eax, [es:esi + offset UsbHub.powered_on_time]
    sub eax, edx
    jnl l_h_usb_hub_process_deferred_powered_on
      neg eax
      pop ecx
      push eax
      jmp short l_h_usb_hub_process_deferred_no_powered
      
    l_h_usb_hub_process_deferred_powered_on:
    and dword ptr [es:esi + offset UsbHub.actions], -1 - HUB_WAIT_POWERED
    mov eax, esi
    call h_usb_hub_wait_change
    
  l_h_usb_hub_process_deferred_no_powered:
  // 3. If reset is pending, check whether we can start it and start it, if so.
  test byte ptr [es:esi + offset UsbHub.actions], HUB_RESET_WAITING
  jz l_h_usb_hub_process_deferred_no_wait_reset
    mov eax, [es:esi + offset UsbHub.controller]
    cmp byte ptr [es:eax + offset UsbController.resetting_port], -1
    jnz l_h_usb_hub_process_deferred_no_wait_reset
      call h_usb_hub_initiate_reset
      
  l_h_usb_hub_process_deferred_no_wait_reset:
  // 4. If reset signalling is active, wait for end of reset signalling
  // and schedule wakeup in 1 tick.
  test byte ptr [es:esi + offset UsbHub.actions], HUB_RESET_SIGNAL
  jz l_h_usb_hub_process_deferred_no_resetting_port
    // It has no sense to query status several times per tick.
    mov eax, tmr_usb_timerticks
    cmp eax, [es:esi + offset UsbHub.reset_time]
    jz l_h_usb_hub_process_deferred_41
      mov [es:esi + offset UsbHub.reset_time], eax
      movzx ecx, byte ptr [es:esi + offset UsbHub.config_buffer + 4]
      mov eax, offset h_usb_hub_resetting_port_status
      call h_usb_hub_query_port_status
      
    l_h_usb_hub_process_deferred_41:
    
    pop eax
    
    push 1
    
  l_h_usb_hub_process_deferred_no_resetting_port:
  // 5. If reset recovery is active and time is not over, reschedule wakeup.
  test byte ptr [es:esi + offset UsbHub.actions], HUB_RESET_RECOVERY
  jz l_h_usb_hub_process_deferred_no_reset_recovery
    mov eax, tmr_usb_timerticks
    sub eax, [es:esi + offset UsbHub.reset_time]
    sub eax, USB_RESET_RECOVERY_TIME
    jnl l_h_usb_hub_process_deferred_reset_done
      neg eax
      cmp [ss:esp], eax
      jb l_h_usb_hub_process_deferred_51
        mov [ss:esp], eax
        
      l_h_usb_hub_process_deferred_51:
      jmp short l_h_usb_hub_process_deferred_no_reset_recovery
      
    l_h_usb_hub_process_deferred_reset_done:
    // 6. If reset recovery is active and time is over, clear 'reset recovery' flag,
    // notify other code about a new device and let it do further steps.
    // If that fails, stop reset process for this port and disable that port.
    and dword ptr [es:esi + offset UsbHub.actions], -1 - HUB_RESET_RECOVERY
    // Bits 9-10 of port status encode port speed.
    // If PORT_LOW_SPEED is set, the device is low-speed. Otherwise,
    // PORT_HIGH_SPEED bit distinguishes full-speed and high-speed devices.
    // This corresponds to values of USB_SPEED_FS=0, USB_SPEED_LS=1, USB_SPEED_HS=2.
    mov eax, dword ptr [es:esi + offset UsbHub.reset_status_data]
    shr eax, PORT_LOW_SPEED
    and eax, 3
    test al, 1
    jz l_h_usb_hub_process_deferred_61
      mov al, 1
      
    l_h_usb_hub_process_deferred_61:
    push esi
      mov esi, [es:esi + offset UsbHub.controller]
      cmp byte ptr [es:esi + offset UsbController.resetting_status], -1
      jz l_h_usb_hub_process_deferred_disconnected_while_reset
        mov edx, [es:esi + offset UsbController.hardware_func]
        call dword ptr [es:edx + offset UsbHardwareFunc.new_device]
      
      pop esi
      
      test eax, eax
      jnz l_h_usb_hub_process_deferred_no_reset_recovery
        mov eax, esi
        call h_usb_hub_disable_resetting_port
        jmp short l_h_usb_hub_process_deferred_no_reset_recovery
        
      l_h_usb_hub_process_deferred_disconnected_while_reset:
      
    pop esi
    
    mov eax, esi
    call h_usb_hub_reset_aborted
    
  l_h_usb_hub_process_deferred_no_reset_recovery:
  // 7. Handle recent connection events.
  // Note: that should be done after step 6, because step 6 can clear
  // HUB_RESET_IN_PROGRESS flag.
  // 7a. Test whether there is such an event pending. If no, skip this step.
  test byte ptr [es:esi + offset UsbHub.actions], HUB_WAIT_CONNECT
  jz l_h_usb_hub_process_deferred_79
  
  // 7b. If we have started reset process for another port in the same hub,
  // skip this step: the buffer for config requests can be used for that port.
  test byte ptr [es:esi + offset UsbHub.actions], HUB_RESET_IN_PROGRESS
  jnz l_h_usb_hub_process_deferred_79
  
  // 7c. Clear flag 'there are connection events which should be processed'.
  // If there are another connection events, this flag will be set again.
  and dword ptr [es:esi + offset UsbHub.actions], -1 - HUB_WAIT_CONNECT
  // 7d. Prepare for loop over all ports.
  xor ecx, ecx
  
  l_h_usb_hub_process_deferred_75:
    // 7e. For every port test for recent connection event.
    // If none, continue the loop for the next port.
    mov edx, [es:esi + offset UsbHub.connected_time_ptr]
    mov eax, [es:edx + ecx * 4]
    cmp eax, -1
    jz l_h_usb_hub_process_deferred_78
      or dword ptr [es:esi + offset UsbHub.actions], HUB_WAIT_CONNECT
      // 7f. Test whether initial delay is over.
      sub eax, tmr_usb_timerticks
      neg eax
      sub eax, USB_CONNECT_DELAY
      jnl l_h_usb_hub_process_deferred_connect_delay_over
        // 7g. The initial delay is not over//
        // set the corresponding flag again, reschedule wakeup and continue the loop.
        neg eax
        cmp [ss:esp], eax
        jb l_h_usb_hub_process_deferred_751
          mov [ss:esp], eax
          
        l_h_usb_hub_process_deferred_751:
        jmp short l_h_usb_hub_process_deferred_78
        
      l_h_usb_hub_process_deferred_connect_delay_over:
      // The initial delay is over.
      // It is possible that there was disconnect event during that delay, probably
      // with connect event after that. If so, we should restart the waiting. However,
      // on the hardware level connect/disconnect events from hubs are implemented
      // using polling with interval selected by the hub, so it is possible that
      // we have not yet observed that disconnect event.
      // Thus, we query port status+change data before all further processing.
      // 7h. Send the request for status+change data.
      push ecx
        // Hub requests expect 1-based port number, not zero-based we operate with.
        inc ecx
        mov eax, offset h_usb_hub_connect_port_status
        call h_usb_hub_query_port_status
      pop ecx
      // 7i. If request has been submitted successfully, set the flag
      // 'reset in progress, config buffer is owned by reset process' and break
      // from the loop.
      test eax, eax
      jz l_h_usb_hub_process_deferred_78
        or dword ptr [es:esi + offset UsbHub.actions], HUB_RESET_IN_PROGRESS
        jmp short l_h_usb_hub_process_deferred_79
        
    l_h_usb_hub_process_deferred_78:
    // 7j. Continue the loop for next port.
    inc ecx
    cmp ecx, [es:esi + offset UsbHub.num_ports]
    jb l_h_usb_hub_process_deferred_75
    
  l_h_usb_hub_process_deferred_79:
  // 8. Pop return value from top-of-stack and return.
pop eax
ret

// Requests notification about any changes in hub/ports configuration.
// Called when initial configuration is done and when a previous notification
// has been processed.
// IN: eax -> UsbHub
h_usb_hub_wait_change:
push 1
 push eax
  push offset h_usb_hub_changed
   push dword ptr [es:eax + offset UsbHub.max_packet_size]
    push dword ptr [es:eax + offset UsbHub.status_change_ptr]
     push dword ptr [es:eax + offset UsbHub.status_pipe]
call h_usb_normal_transfer_async
ret

// Helper procedure for usb_hub_process_deferred. Initiates reset signalling
// on the current port (given by 1-based value [ConfigBuffer+4]).
// IN: esi -> UsbHub, eax -> UsbController
h_usb_hub_initiate_reset:
// 1. Store hub+port data in the controller structure.
movzx ecx, byte ptr [es:esi + offset UsbHub.config_buffer + 4]
dec ecx
mov [es:eax + offset UsbController.resetting_port], cl
mov [es:eax + offset UsbController.resetting_hub], esi
// 2. Store the current time and set 'reset signalling active' flag.
mov eax, tmr_usb_timerticks
mov [es:esi + offset UsbHub.reset_time], eax
and dword ptr [es:esi + offset UsbHub.actions], -1 - HUB_RESET_WAITING
or dword ptr [es:esi + offset UsbHub.actions], HUB_RESET_SIGNAL
// 3. Send request to the hub to initiate request signalling.
lea edx, [esi + offset UsbHub.config_buffer]
mov dword ptr [es:edx], 23h + (USB_SET_FEATURE << 8) + (PORT_RESET << 16)
and dword ptr [es:edx + 4], 0xFF

push 0
 push esi
  push offset h_usb_hub_reset_started
   push 0
    push 0
     push edx
      push dword ptr [es:esi + offset UsbHub.config_pipe]
call h_usb_control_async

test eax, eax
jnz l_h_usb_hub_initiate_reset_9
  mov eax, esi
  call h_usb_hub_reset_aborted
  
l_h_usb_hub_initiate_reset_9:
ret

// This procedure is called when the request to query port status
// initiated by usb_hub_process_deferred for testing reset status is completed,
// either successfully or unsuccessfully.
h_usb_hub_resetting_port_status:
// 4 pipe:dword, 8 status:dword, 12 buffer:dword, 16 length:dword, 20 calldata:dword

// 1. If the request has failed, do nothing.
cmp dword ptr [ss:esp + 8], 0  // status
jnz l_h_usb_hub_resetting_port_status_9
  // 2. If reset signalling is still active, do nothing.
  mov eax, [ss:esp + 20]  // calldata
  test byte ptr [es:eax + offset UsbHub.reset_status_data], 1 << PORT_RESET
  jnz l_h_usb_hub_resetting_port_status_9
    // 3. Store the current time to start reset recovery interval
    // and clear 'reset signalling active' flag.
    mov edx, tmr_usb_timerticks
    mov [es:eax + offset UsbHub.reset_time], edx
    and dword ptr [es:eax + offset UsbHub.actions], -1 - HUB_RESET_SIGNAL
    // 4. If the device has not been disconnected, set 'reset recovery active' bit.
    // Otherwise, terminate reset process.
    test byte ptr [es:eax + offset UsbHub.reset_status_change], 1 << PORT_CONNECTION
    jnz l_h_usb_hub_resetting_port_status_disconnected
      or dword ptr [es:eax + offset UsbHub.actions], HUB_RESET_RECOVERY
      
      l_h_usb_hub_resetting_port_status_common:
      // In any case, clear change of resetting status.
      lea edx, [eax + offset UsbHub.config_buffer]
      mov cl, C_PORT_RESET
      call h_usb_hub_clear_port_change_buffer
      
l_h_usb_hub_resetting_port_status_9:

ret 20


l_h_usb_hub_resetting_port_status_disconnected:
call h_usb_hub_reset_aborted
jmp short l_h_usb_hub_resetting_port_status_common

// Helper procedure for several parts of hub code.
// Sends a request to clear the given feature of the port.
// eax -> usb_hub, cl = feature;
// as is should be called from async code, sync code should set
// edx to ConfigBuffer and call usb_hub_clear_port_change.buffer;
// port number (1-based) should be filled in [edx+4] by previous requests.
h_usb_hub_clear_port_change:
lea edx, [eax + offset UsbHub.change_config_buffer]

h_usb_hub_clear_port_change_buffer:
mov dword ptr [es:edx], 23h + (USB_CLEAR_FEATURE << 8)
mov byte ptr [es:edx + 2], cl
and dword ptr [es:edx + 4], 0xFF

push 0
 push eax
  push offset h_usb_hub_port_changed
   push 0
    push edx
     push edx
      push dword ptr [es:eax + offset UsbHub.config_pipe]
call h_usb_control_async

ret

// Helper procedure for usb_hub_process_deferred.
// Sends a request to query port status.
// IN: esi -> UsbHub, eax = callback, ecx = 1-based port.
h_usb_hub_query_port_status:
add ecx, 4 << 16  // data length = 4
lea edx, [esi + offset UsbHub.config_buffer]
mov dword ptr [es:edx], 0A3h + (USB_GET_STATUS << 8)
mov dword ptr [es:edx + 4], ecx
lea ecx, [esi + offset UsbHub.reset_status_data]

push 0
 push esi
  push eax
   push 4
    push ecx
     push edx
      push dword ptr [es:esi + offset UsbHub.config_pipe]
call h_usb_control_async

ret

// This procedure is called by the protocol layer if something has failed during
// initial stages of the configuration process, so the device should be disabled
// at hub level.
h_usb_hub_disable_resetting_port:
and dword ptr [es:eax + offset UsbHub.actions], -1 - HUB_RESET_IN_PROGRESS
lea edx, [eax + offset UsbHub.config_buffer]
mov cl, PORT_ENABLE
jmp h_usb_hub_clear_port_change_buffer

// This procedure is called when the request to query port status
// initiated by usb_hub_process_deferred for testing connection is completed,
// either successfully or unsuccessfully.
h_usb_hub_connect_port_status:
// 8 pipe:dword, 12 status:dword, 16 buffer:dword, 20 length:dword, 24 calldata:dword
push esi  // save used register
  mov eax, [ss:esp + 24]  // calldata
  mov esi, [ss:esp + 8]  // pipe
  // 1. In any case, clear 'reset in progress' flag.
  // If everything is ok, it would be set again.
  and dword ptr [es:eax + offset UsbHub.actions], -1 - HUB_RESET_IN_PROGRESS
  // 2. If the request has failed, stop reset process.
  cmp dword ptr [ss:esp + 12], 0  // status
  jnz l_h_usb_hub_connect_port_status_9
    mov edx, [es:eax + offset UsbHub.connected_time_ptr]
    movzx ecx, byte ptr [es:eax + offset UsbHub.config_buffer + 4]
    dec ecx
    // 3. Test whether there was a disconnect event.
    test byte ptr [es:eax + offset UsbHub.reset_status_change], 1 << PORT_CONNECTION
    jz l_h_usb_hub_connect_port_status_reset
      // 4. There was a disconnect event.
      // There is another handler of connect/disconnect events, usb_hub_port_status.
      // However, we do not know whether it has already processed this event
      // or it will process it sometime later.
      // If ConnectedTime is -1, then another handler has already run,
      // there was no connection event, so just leave the value as -1.
      // Otherwise, there are two possibilities: either another handler has not yet
      // run (which is quite likely), or there was a connection event and the other
      // handler has run exactly while our request was processed (otherwise our
      // request would not been submitted// this is quite unlikely due to timing
      // requirements, but not impossible). In this case, set ConnectedTime to the
      // current time: in the likely case it prevents usb_hub_process_deferred from immediate
      // issuing of another requests (which would be just waste of time)//
      // in the unlikely case it is still correct (although slightly increases
      // the debounce interval).
      cmp dword ptr [es:edx + ecx * 4], -1
      jz l_h_usb_hub_connect_port_status_9
        call h_usb_hub_store_connected_time
        jmp short l_h_usb_hub_connect_port_status_9
        
    l_h_usb_hub_connect_port_status_reset:
    // 5. The device remained connected for the entire debounce interval//
    // we can proceed with initialization.
    // Clear connected time for this port and notify usb_hub_process_deferred that
    // the new port is waiting for reset.
    or dword ptr [es:edx + ecx * 4], -1
    or dword ptr [es:eax + offset UsbHub.actions], HUB_RESET_IN_PROGRESS + HUB_RESET_WAITING
    
  l_h_usb_hub_connect_port_status_9:
pop esi  // restore used register
ret 20

// This procedure is called when the request to start reset signalling initiated
// by usb_hub_initiate_reset is completed, either successfully or unsuccessfully.
h_usb_hub_reset_started:
// 4 pipe:dword, 8 status:dword, 12 buffer:dword, 16 length:dword, 20 calldata:dword

// If the request is successful, do nothing.
// Otherwise, clear 'reset signalling' flag and abort reset process.
mov eax, [ss:esp + 20]  // calldata
cmp dword ptr [ss:esp + 8], 0  // status
jz l_h_usb_hub_reset_started_9
  and dword ptr [es:eax + offset UsbHub.actions], -1 - HUB_RESET_SIGNAL
  call h_usb_hub_reset_aborted
  
l_h_usb_hub_reset_started_9:
ret 20

// Helper procedure for other code. Called when reset process is aborted.
h_usb_hub_reset_aborted:
// Clear 'reset in progress' flag and test for other devices which could be
// waiting for reset.
and dword ptr [es:eax + offset UsbHub.actions], -1 - HUB_RESET_IN_PROGRESS
push esi
  mov esi, [es:eax + offset UsbHub.controller]
  call h_usb_test_pending_port
pop esi
ret

// This procedure is called when something has changed on the hub.
h_usb_hub_changed:
// 4 pipe:dword, 8 status:dword, 12 buffer:dword, 16 length:dword, 20 calldata:dword

// 1. Check whether our request has failed.
// If so, say something to the debug board and stop processing notifications.
xor ecx, ecx
cmp [ss:esp + 8], ecx  // status
jnz near l_h_usb_hub_changed_failed
  // 2. If no data were retrieved, restart waiting.
  mov eax, [ss:esp + 20]  // calldata
  cmp [ss:esp + 16], ecx  // length
  jz l_h_usb_hub_changed_continue
    // 3. If size of data retrieved is less than maximal, pad with zeroes//
    // this corresponds to 'state of other ports was not changed'
    mov ecx, [es:eax + offset UsbHub.num_ports]
    shr ecx, 3
    inc ecx
    sub ecx, [ss:esp + 16]  // length
    jna h_usb_hub_changed_restart
      push eax
       push edi
        mov edi, [ss:esp + 12]  // buffer
        add edi, [ss:esp + 16]  // length
        xor eax, eax
        cld
        rep stosb
       pop edi
      pop eax
      
    
    h_usb_hub_changed_restart:
    // State of some elements of the hub was changed.
    // Find the first element that was changed,
    // ask the hub about nature of the change,
    // clear the corresponding change,
    // reask the hub about status+change (it is possible that another change
    // occurs between the first ask and clearing the change; we won't see that
    // change, so we need to query the status after clearing the change),
    // continue two previous steps until nothing changes,
    // process all changes which were registered.
    // When all changes for one element will be processed, return to here and look
    // for other changed elements.
    mov edx, [es:eax + offset UsbHub.status_change_ptr]
    // We keep all observed changes in the special var usb_hub.AccStatusChange;
    // it will be logical OR of all observed StatusChange's.
    // 4. No observed changes yet, zero usb_hub.AccStatusChange.
    xor ecx, ecx
    mov [es:eax + offset UsbHub.acc_status_change], cl
    // 5. Test whether there was a change in the hub itself.
    // If so, query hub state.
    btr dword ptr [es:edx], ecx
    jnc l_h_usb_hub_changed_no_hub_change
      
      
      h_usb_hub_changed_next_hub_change:
      lea edx, [eax + offset UsbHub.change_config_buffer]
      lea ecx, [eax + offset UsbHub.status_data]
      mov dword ptr [es:edx], 0A0h + (USB_GET_STATUS << 8)
      mov dword ptr [es:edx + 4], 4 << 16 // get 4 bytes
      
      push 0
       push eax
        push offset h_usb_hub_status
         push 4
          push ecx
           push edx
            push dword ptr [es:eax + offset UsbHub.config_pipe]
      call h_usb_control_async
      
      jmp l_h_usb_hub_changed_9
      
    l_h_usb_hub_changed_no_hub_change:
    // 6. Find the first port with changed state and clear the corresponding bit
    // (so next scan after .restart will not consider this port again).
    // If found, go to 8. Otherwise, advance to 7.
    inc ecx
    
    l_h_usb_hub_changed_test_port_change:
      btr dword ptr [es:edx], ecx
      jc l_h_usb_hub_changed_found_port_change
        inc ecx
        cmp ecx, [es:eax + offset UsbHub.num_ports]
        jna l_h_usb_hub_changed_test_port_change
        
  l_h_usb_hub_changed_continue:
  // 7. All changes have been processed. Wait for next notification.
  call h_usb_hub_wait_change
  
  l_h_usb_hub_changed_9:
  
  ret 20
  
  
  l_h_usb_hub_changed_found_port_change:
  mov dword ptr [es:eax + offset UsbHub.change_config_buffer + 4], ecx
  
  
  h_usb_hub_changed_next_port_change:
  // 8. Query port state. Continue work in usb_hub_port_status callback.
  lea edx, [eax + offset UsbHub.change_config_buffer]
  mov dword ptr [es:edx], 0A3h + (USB_GET_STATUS << 8)
  mov byte ptr [es:edx + 6], 4  // data length = 4 bytes
  lea ecx, [eax + offset UsbHub.status_data]
  
  push 0
   push eax
    push offset h_usb_hub_port_status
     push 4
      push ecx
       push edx
        push dword ptr [es:eax + offset UsbHub.config_pipe]
  call h_usb_control_async
  
  jmp short l_h_usb_hub_changed_9
  
l_h_usb_hub_changed_failed:
jmp short l_h_usb_hub_changed_9

// This procedure is called when the request to clear port change is completed,
// either successfully or unsuccessfully.
h_usb_hub_port_changed:
// 4 pipe:dword, 8 status:dword, 12 buffer:dword, 16 length:dword, 20 calldata:dword

// 1. Check whether our request has failed.
// If so, say something to the debug board and stop processing notifications.
cmp dword ptr [ss:esp + 8], 0  // status
jnz l_h_usb_hub_port_changed_9
  // 2. If the request was originated by synchronous code, no further processing
  // is required.
  mov eax, [ss:esp + 20]  // calldata
  lea edx, [eax + offset UsbHub.config_buffer]
  cmp [ss:esp + 12], edx  // buffer
  jz l_h_usb_hub_port_changed_9
    // 3. If there is a change which was observed, but not yet cleared,
    // go to the code which clears it.
    cmp word ptr [es:eax + offset UsbHub.status_change], 0
    jnz near h_usb_hub_port_status_next_change
    // 4. Otherwise, go to the code which queries the status.
    jmp h_usb_hub_changed_next_port_change
    
l_h_usb_hub_port_changed_9:
ret 20

// Helper procedure to store current time in ConnectedTime,
// advancing -1 to zero if needed.
// IN: edx, ecx
h_usb_hub_store_connected_time:
mov eax, tmr_usb_timerticks
// transform -1 to 0, leave other values as is
cmp eax, -1
sbb eax, -1
mov [es:edx + ecx * 4], eax
ret

// This procedure is called when the request of hub status is completed,
// either successfully or unsuccessfully.
h_usb_hub_status:
// 4 pipe:dword, 8 status:dword, 12 buffer:dword, 16 length:dword, 20 calldata:dword

// 1. Check whether our request has failed.
// If so, say something to the debug board and stop processing notifications.
cmp dword ptr [ss:esp + 8], 0  // status
jnz l_h_usb_hub_status_failed

// 2. Accumulate observed changes.
mov eax, [ss:esp + 20]  // calldata
mov dl, byte ptr [es:eax + offset UsbHub.status_change]
or [es:eax + offset UsbHub.acc_status_change], dl


h_usb_hub_status_next_change:
// 3. Find the first change. If found, advance to 4. Otherwise, go to 5.
mov cl, C_HUB_OVER_CURRENT
btr dword ptr [es:eax + offset UsbHub.status_change], 1
jc l_h_usb_hub_status_clear_hub_change
  mov cl, C_HUB_LOCAL_POWER
  btr dword ptr [es:eax + offset UsbHub.status_change], 0
  jnc l_h_usb_hub_status_final
  
l_h_usb_hub_status_clear_hub_change:
// 4. Clear the change and continue in usb_hub_change_cleared callback.
lea edx, [eax + offset UsbHub.change_config_buffer]
mov dword ptr [es:edx], 20h + (USB_CLEAR_FEATURE << 8)
mov [es:edx + 2], cl  // feature selector
and dword ptr [es:edx + 4], 0

push 0
 push eax
  push offset h_usb_hub_change_cleared
   push 0
    push 0
     push edx
      push dword ptr [es:eax + offset UsbHub.config_pipe]
call h_usb_control_async

l_h_usb_hub_status_9:
ret 20


l_h_usb_hub_status_final:
// 5. All changes cleared and accumulated, now process them.
// Note: that needs work.
test byte ptr [es:eax + offset UsbHub.acc_status_change], 1
jz l_h_usb_hub_status_no_local_power
  test word ptr [es:eax + offset UsbHub.status_data], 1
  jnz l_h_usb_hub_status_no_local_power    
    // local_power_lost
  
l_h_usb_hub_status_no_local_power:
test byte ptr [es:eax + offset UsbHub.acc_status_change], 2
jz l_h_usb_hub_status_no_overcurrent
  test word ptr [es:eax + offset UsbHub.status_data], 2
  jz l_h_usb_hub_status_no_overcurrent
    // hub global overcurrent
    
l_h_usb_hub_status_no_overcurrent:
// 6. Process possible changes for other ports.
jmp h_usb_hub_changed_restart

l_h_usb_hub_status_failed:
jmp l_h_usb_hub_status_9

// This procedure is called when the request of port status is completed,
// either successfully or unsuccessfully.
h_usb_hub_port_status:
// 4 pipe:dword, 8 status:dword, 12 buffer:dword, 16 length:dword, 20 calldata:dword

// 1. Check whether our request has failed.
// If so, say something to the debug board and stop processing notifications.
cmp dword ptr [ss:esp + 8], 0  // status
jnz near l_h_usb_hub_port_status_failed

// 2. Accumulate observed changes.
mov eax, [ss:esp + 20]  // calldata
mov dl, [es:eax + offset UsbHub.status_change]
or [es:eax + offset UsbHub.acc_status_change], dl


h_usb_hub_port_status_next_change:
// 3. Find the first change. If found, advance to 4. Otherwise, go to 5.
// Ignore change in reset status// it is cleared by synchronous code
// (usb_hub_process_deferred), so avoid unnecessary interference.
//       mov     cl, C_PORT_RESET
btr dword ptr [es:eax + offset UsbHub.status_change], PORT_RESET
// jc l_h_usb_hub_port_status_clear_port_change
mov cl, C_PORT_OVER_CURRENT
btr dword ptr [es:eax + offset UsbHub.status_change], PORT_OVER_CURRENT
jc l_h_usb_hub_port_status_clear_port_change
  mov cl, C_PORT_SUSPEND
  btr dword ptr [es:eax + offset UsbHub.status_change], PORT_SUSPEND
  jc l_h_usb_hub_port_status_clear_port_change
    mov cl, C_PORT_ENABLE
    btr dword ptr [es:eax + offset UsbHub.status_change], PORT_ENABLE
    jc l_h_usb_hub_port_status_clear_port_change
      mov cl, C_PORT_CONNECTION
      btr dword ptr [es:eax + offset UsbHub.status_change], PORT_CONNECTION
      jnc l_h_usb_hub_port_status_final
      
l_h_usb_hub_port_status_clear_port_change:
// 4. Clear the change and continue in usb_hub_port_changed callback.
call h_usb_hub_clear_port_change
jmp l_h_usb_hub_port_status_9

l_h_usb_hub_port_status_final:
// All changes cleared and accumulated, now process them.
movzx ecx, byte ptr [es:eax + offset UsbHub.change_config_buffer + 4]
dec ecx
// 5. Process connect/disconnect events.
// 5a. Test whether there is such event.
test byte ptr [es:eax + offset UsbHub.acc_status_change], 1 << PORT_CONNECTION
jz l_h_usb_hub_port_status_nodisconnect
  // 5b. If there was a connected device, notify the main code about disconnect.
  push ebx
    mov edx, [es:eax + offset UsbHub.connected_devices_ptr]
    xor ebx, ebx
    xchg ebx, [es:edx + ecx * 4]
    test ebx, ebx
    jz l_h_usb_hub_port_status_51
      push eax
       push ecx
        call h_usb_device_disconnected
       pop ecx
      pop eax
      
    l_h_usb_hub_port_status_51:
  pop ebx
  // 5c. If the disconnect event corresponds to the port which is currently
  // resetting, then another request from synchronous code could be in the fly,
  // so aborting reset immediately would lead to problems with those requests.
  // Thus, just set the corresponding status and let the synchronous code process.
  test byte ptr [es:eax + offset UsbHub.actions], (HUB_RESET_SIGNAL | HUB_RESET_RECOVERY)
  jz l_h_usb_hub_port_status_52
    mov edx, [es:eax + offset UsbHub.controller]
    cmp [es:edx + offset UsbController.resetting_port], cl
    jnz l_h_usb_hub_port_status_52
      mov byte ptr [es:edx + offset UsbController.resetting_status], -1
    
  l_h_usb_hub_port_status_52:
  // 5d. If the current status is 'connected', store the current time as connect
  // time and set the corresponding bit for usb_hub_process_deferred.
  // Otherwise, set connect time to -1.
  // If current time is -1, pretend that the event occured one tick later and
  // store zero.
  mov edx, [es:eax + offset UsbHub.connected_time_ptr]
  test byte ptr [es:eax + offset UsbHub.status_data], 1 << PORT_CONNECTION
  jz l_h_usb_hub_port_status_disconnected
    or dword ptr [es:eax + offset UsbHub.actions], HUB_WAIT_CONNECT
    push eax
      call h_usb_hub_store_connected_time
    pop eax
    jmp short l_h_usb_hub_port_status_53
    
  l_h_usb_hub_port_status_disconnected:
  or dword ptr [es:edx + ecx * 4], -1
  
  l_h_usb_hub_port_status_53:
  
l_h_usb_hub_port_status_nodisconnect:
// 6. Process port disabling.
test byte ptr [es:eax + offset UsbHub.acc_status_change], 1 << PORT_ENABLE
jz l_h_usb_hub_port_status_nodisable
  test byte ptr [es:eax + offset UsbHub.status_data], 1 << PORT_ENABLE
  jnz l_h_usb_hub_port_status_nodisable
    // Port disabled
    
l_h_usb_hub_port_status_nodisable:
// 7. Process port overcurrent.
test byte ptr [es:eax + offset UsbHub.acc_status_change], 1 << PORT_OVER_CURRENT
jz l_h_usb_hub_port_status_noovercurrent
  test byte ptr [es:eax + offset UsbHub.status_data], 1 << PORT_OVER_CURRENT
  jz l_h_usb_hub_port_status_noovercurrent
    // Port over-current
    
l_h_usb_hub_port_status_noovercurrent:
// 8. Process possible changes for other ports.
jmp h_usb_hub_changed_restart

l_h_usb_hub_port_status_failed:

l_h_usb_hub_port_status_9:
ret 20

// This procedure is called when the request to clear hub change is completed,
// either successfully or unsuccessfully.
h_usb_hub_change_cleared:
// 4 pipe:dword, 8 status:dword, 12 buffer:dword, 16 length:dword, 20 calldata:dword

// 1. Check whether our request has failed.
// If so, say something to the debug board and stop processing notifications.
cmp dword ptr [ss:esp + 8], 0  // status
jnz l_h_usb_hub_change_cleared_failed
  // 2. If there is a change which was observed, but not yet cleared,
  // go to the code which clears it.
  mov eax, [ss:esp + 20] // calldata
  cmp word ptr [es:eax + offset UsbHub.status_change], 0
  jnz near h_usb_hub_status_next_change
    // 3. Otherwise, go to the code which queries the status.
    jmp h_usb_hub_changed_next_hub_change
    
l_h_usb_hub_change_cleared_failed:
ret 20

// Helper function for USB2 scheduler.
// IN: eax -> UsbHub
// OUT: ecx = TT think time for the hub in FS-bytes
h_usb_get_tt_think_time:
movzx ecx, word ptr [es:eax + offset UsbHub.hub_characteristics]
shr ecx, 5
and ecx, 3
inc ecx
ret

// This procedure is called when new hub is detected.
// It initializes the device.
// Technically, initialization implies sending several USB queries,
// so it is split in several procedures. The first is h_usb_hub_init,
// other are callbacks which will be called at some time in the future,
// when the device will respond.
// IN: edx = UsbInterfaceDescr, ecx = length rest
//     stack: pipe, config, interface
h_usb_hub_init:
push ebx
 push esi  // save used registers to be stdcall
  /*
  0             // saved registers
  8             // return address
  12 pipe       // handle of the config pipe
  16 config     // pointer to UsbConfigDescr
  20 interface  // pointer to UsbInterfaceDescr
  */
  
  // 1. Check that the maximal nesting is not exceeded:
  // 5 non-root hubs is the maximum according to the spec.
  mov ebx, [ss:esp + 12]  // pipe
  push 5
    mov eax, ebx
    
    l_h_usb_hub_init_count_parents:
    mov eax, [es:eax + offset UsbPipe.device_data]
    mov eax, [es:eax + offset UsbDevData.hub]
    test eax, eax
    jz l_h_usb_hub_init_depth_ok
      mov eax, [es:eax + offset UsbHub.config_pipe]
      dec dword ptr [ss:esp]
      jnz l_h_usb_hub_init_count_parents
      
      pop eax
      
      jmp l_h_usb_hub_init_return0
      
    l_h_usb_hub_init_depth_ok:
  pop eax
  // Hubs use one IN interrupt endpoint for polling the device
  // 2. Locate the descriptor of the interrupt endpoint.
  // Loop over all descriptors owned by this interface.
  
  l_h_usb_hub_init_lookep:
    // 2a. Skip the current descriptor.
    movzx eax, byte ptr [es:edx + offset UsbDescr.bLength]
    add edx, eax
    sub ecx, eax
    jb near l_h_usb_hub_init_errorep
      // 2b. Length of data left must be at least sizeof UsbEndpointDescr.
      cmp ecx, sizeof UsbEndpointDescr
      jb near l_h_usb_hub_init_errorep
        // 2c. If we have found another interface descriptor but not found our endpoint,
        // this is an error: all subsequent descriptors belong to that interface
        // (or further interfaces).
        cmp byte ptr [es:edx + offset UsbDescr.bDescriptorType], USB_INTERFACE_DESCR
        jz near l_h_usb_hub_init_errorep
          // 2d. Ignore all interface-related descriptors except endpoint descriptor.
          cmp byte ptr [es:edx + offset UsbDescr.bDescriptorType], USB_ENDPOINT_DESCR
          jnz l_h_usb_hub_init_lookep
            // 2e. Length of endpoint descriptor must be at least sizeof.usb_endpoint_descr.
            cmp byte ptr [es:edx + offset UsbDescr.bLength], sizeof UsbEndpointDescr
            jb near l_h_usb_hub_init_errorep
              // 2f. Ignore all endpoints except for INTERRUPT IN.
              cmp byte ptr [es:edx + offset UsbEndpointDescr.bEndpointAddress], 0
              jge l_h_usb_hub_init_lookep
                mov al, [es:edx + offset UsbEndpointDescr.bmAttributes]
                and al, 3
                cmp al, INTERRUPT_PIPE
                jnz l_h_usb_hub_init_lookep
  // We have located the descriptor for INTERRUPT IN endpoint,
  // the pointer is in edx.
  // 3. Allocate memory for the hub descriptor.
  // Maximum length (assuming 255 downstream ports) is 40 bytes.
  // Allocate 4 extra bytes to keep wMaxPacketSize.
  // 3a. Save registers
  push edx
   push ebx
    // 3b. Call the allocator.
    mov ecx, 44
    call m_heap_alloc_kernel
    xchg eax, ebx
    // 3c. Restore registers
   pop ebx
  pop ecx
  // 3d. If failed, say something to the debug board and return error.
  test eax, eax
  jz l_h_usb_hub_init_nomemory
  
  // 3e. Store the pointer in esi. xchg eax,r32 is one byte shorter than mov.
  xchg esi, eax
  // 4. Open a pipe for the status endpoint with descriptor found in step 1.
  movzx eax, byte ptr [es:ecx + offset UsbEndpointDescr.bEndpointAddress]
  movzx edx, byte ptr [es:ecx + offset UsbEndpointDescr.bInterval]
  movzx ecx, word ptr [es:ecx + offset UsbEndpointDescr.wMaxPacketSize]
  test ecx, (1 << 11) - 1
  jz l_h_usb_hub_init_free
  
  push ecx
   push esi
   
    push edx
     push INTERRUPT_PIPE
      push ecx
       push eax
        push ebx
    call h_usb_open_pipe
    
   pop esi
  pop ecx
  // If failed, free the memory allocated in step 3,
  // say something to the debug board and return error.
  test eax, eax
  jz l_h_usb_hub_init_free
  
  // 5. Send control query for the hub descriptor,
  // pass status pipe as a callback parameter,
  // allow short packets.
  and ecx, (1 << 11) - 1
  mov [es:esi + 40], ecx
  mov dword ptr [es:esi], 0xA0 + (USB_GET_DESCRIPTOR << 8) + (0 << 16) + (USB_HUB_DESCRIPTOR << 24)
  mov dword ptr [es:esi + 4], 40 << 16
  
  push esi
    
    push 1
     push eax
      push offset h_usb_hub_got_config
       push 40
        push esi
         push esi
          push ebx
    call h_usb_control_async
    
  pop esi
  // 6. If failed, free the memory allocated in step 3,
  // say something to the debug board and return error.
  test eax, eax
  jz l_h_usb_hub_init_free
  
  // Otherwise, return 1. h_usb_hub_got_config will overwrite it later.
  xor eax, eax
  inc eax
  jmp short l_h_usb_hub_init_9
    
    l_h_usb_hub_init_free:
    mov ebx, esi
    call m_heap_free_kernel
    //jmp short l_h_usb_hub_init_return0
    
    l_h_usb_hub_init_errorep:
    l_h_usb_hub_init_nomemory:
    l_h_usb_hub_init_return0:
    xor eax, eax
    
  l_h_usb_hub_init_9:
 pop esi
pop ebx  // restore used registers to be stdcall
ret 12

// This procedure is called when the hub is disconnected.
h_usb_hub_disconnect:
//virtual at esp
//                dd      ?       // return address
//.hubdata        dd      ?
//end virtual

// 1. If the hub is disconnected during initial configuration,
// 1 is stored as hub data and there is nothing to do.
mov eax, [ss:esp + 4]  // hubdata
cmp eax, 1
jz l_h_usb_hub_disconnect_nothing
// 2. Remove the hub from the overall list.
mov ecx, [es:eax + offset UsbHub.next]
mov edx, [es:eax + offset UsbHub.prev]
mov [es:ecx + offset UsbHub.prev], edx
mov [es:edx + offset UsbHub.next], ecx
// 3. If some child is in reset process, abort reset.
push esi
  mov esi, [es:eax + offset UsbHub.controller]
  cmp [es:esi + offset UsbController.resetting_hub], eax
  jnz l_h_usb_hub_disconnect_1
    cmp dword ptr [es:esi + offset UsbController.resetting_port], -1
    jz l_h_usb_hub_disconnect_1
      push eax
        call h_usb_test_pending_port
      pop eax
      
  l_h_usb_hub_disconnect_1:
pop esi
// 4. Loop over all children and notify other code that they were disconnected.
push ebx
  xor ecx, ecx
  
  l_h_usb_hub_disconnect_disconnect_children:
    mov ebx, [es:eax + offset UsbHub.connected_devices_ptr]
    mov ebx, [es:ebx + ecx * 4]
    test ebx, ebx
    jz l_h_usb_hub_disconnect_2
      push eax
       push ecx
        call h_usb_device_disconnected
       pop ecx
      pop eax
      
    l_h_usb_hub_disconnect_2:
    inc ecx
    cmp ecx, [es:eax + offset UsbHub.num_ports]
    jb l_h_usb_hub_disconnect_disconnect_children
  // 5. Free memory allocated for the hub data.
  mov ebx, eax
  call m_heap_free_kernel
pop ebx

l_h_usb_hub_disconnect_nothing:
ret 4

l_h_usb_hub_got_config_invalid:
jmp l_h_usb_hub_got_config_freebuf

// This procedure is called when the request for the hub descriptor initiated
// by usb_hub_init is finished, either successfully or unsuccessfully.
h_usb_hub_got_config:
// 8 pipe:dword, 12 status:dword, 16 buffer:dword, 20 length:dword, 24 calldata:dword
push ebx  // save used registers to be stdcall
  // 1. If failed, say something to the debug board, free the buffer
  // and stop the initialization.
  cmp dword ptr [ss:esp + 12], 0  // status
  jnz l_h_usb_hub_got_config_invalid
  
  // 2. The length must be at least sizeof.usb_hub_descr.
  // Note that [length] includes 8 bytes of setup packet.
  cmp dword ptr [ss:esp + 20], 8 + sizeof UsbHubDescr  // length
  jb l_h_usb_hub_got_config_invalid
  
  // 3. Sanity checks for the hub descriptor.
  mov eax, [ss:esp + 16]  // buffer
  cmp byte ptr [es:eax + offset UsbDescr.bLength], sizeof UsbHubDescr
  jb l_h_usb_hub_got_config_invalid
  
  cmp byte ptr [es:eax + offset UsbDescr.bDescriptorType], USB_HUB_DESCRIPTOR
  jnz l_h_usb_hub_got_config_invalid
  
  movzx ecx, byte ptr [es:eax + offset UsbHubDescr.bNbrPorts]
  test ecx, ecx
  jz l_h_usb_hub_got_config_invalid
  
  // 4. We use sizeof.usb_hub_descr bytes plus DeviceRemovable info//
  // size of DeviceRemovable is (NumPorts+1) bits, this gives
  // floor(NumPorts/8)+1 bytes. Check that all data are present in the
  // descriptor and were successfully read.
  mov edx, ecx
  shr edx, 3
  add edx, sizeof UsbHubDescr + 1
  cmp [es:eax + offset UsbDescr.bLength], dl
  jb l_h_usb_hub_got_config_invalid
  
  sub dword ptr [ss:esp + 20], 8  // length
  cmp [ss:esp + 20], edx  // length
  jb l_h_usb_hub_got_config_invalid
  
  // 5. Allocate the memory for usb_hub structure.
  // Total size of variable-length data is ALIGN_UP(floor(NumPorts/8)+1+MaxPacketSize,4)+8*NumPorts.
  add edx, [es:eax + 40]
  add edx, sizeof UsbHub - sizeof UsbHubDescr + 3
  and edx, -4
  lea eax, [edx + ecx * 8]
  push ecx
   push edx
    push ebx
      mov ecx, eax
      call m_heap_alloc_kernel
      xchg eax, ebx
    pop ebx
   pop edx
  pop ecx
  test eax, eax
  jz near l_h_usb_hub_got_config_nomemory
  
  xchg eax, ebx
  // 6. Fill UsbHub structure.
  mov [es:ebx + offset UsbHub.num_ports], ecx
  add edx, ebx
  mov [es:ebx + offset UsbHub.connected_devices_ptr], edx
  mov eax, [ss:esp + 8]  // pipe
  mov [es:ebx + offset UsbHub.config_pipe], eax
  mov edx, [es:eax + offset UsbPipe.controller]
  mov [es:ebx + offset UsbHub.controller], edx
  mov eax, [ss:esp + 24]  // calldata
  mov [es:ebx + offset UsbHub.status_pipe], eax
  push esi
   push edi
    mov esi, [ss:esp + 16]  // buffer
    mov eax, [es:esi + 40]
    mov [es:ebx + offset UsbHub.max_packet_size], eax
    // The following commands load bNbrPorts, wHubCharacteristics, bPwrOn2PwrGood.
    mov edx, dword ptr [es:esi + offset UsbHubDescr.bNbrPorts]
    mov dl, 0
    // The following command zeroes AccStatusChange and stores
    // HubCharacteristics and PowerOnInterval.
    mov [es:ebx + offset UsbHub.acc_status_change], edx
    xor eax, eax
    mov [es:ebx + offset UsbHub.actions], eax
    // Copy DeviceRemovable data.
    lea edi, [ebx + sizeof UsbHub]
    add esi, sizeof UsbHubDescr
    mov edx, ecx
    shr ecx, 3
    inc ecx
    push ds
      push es
      pop ds
      cld
      rep movsb
      mov [es:ebx + offset UsbHub.status_change_ptr], edi
      // Zero ConnectedDevices.
      mov edi, [es:ebx + offset UsbHub.connected_devices_ptr]
      mov ecx, edx
      rep stosd
      mov [es:ebx + offset UsbHub.connected_time_ptr], edi
      // Set ConnectedTime to -1.
      dec eax
      mov ecx, edx
      rep stosd
    pop ds
   pop edi
  pop esi
  // 7. Replace value of 1 returned from usb_hub_init to the real value.
  // Note: hubs are part of the core USB code, so this code can work with
  // internals of other parts. Another way, the only possible one for external
  // drivers, is to use two memory allocations: one (returned from AddDevice and
  // fixed after that) for pointer, another for real data. That would work also,
  // but wastes one allocation.
  mov eax, [ss:esp + 8]  // pipe
  mov eax, [es:eax + offset UsbPipe.device_data]
  add eax, [es:eax + offset UsbDevData.interfaces]
  
  l_h_usb_hub_got_config_scan:
    cmp dword ptr [es:eax + offset UsbInterfaceData.driver_data], 1
    jnz l_h_usb_hub_got_config_71
      cmp dword ptr [es:eax + offset UsbInterfaceData.driver_func], offset h_usb_hub_fn
      jz l_h_usb_hub_got_config_scan_found
      
    l_h_usb_hub_got_config_71:
    add eax, sizeof UsbInterfaceData
    jmp short l_h_usb_hub_got_config_scan
    
  l_h_usb_hub_got_config_scan_found:
  mov [es:eax + offset UsbInterfaceData.driver_data], ebx
  // 8. Insert the hub structure to the tail of the overall list of all hubs.
  mov ecx, VA_USB_HUBS_LIST
  mov edx, [es:ecx + offset UsbHub.prev]
  mov [es:ecx + offset UsbHub.prev], ebx
  mov [es:edx + offset UsbHub.next], ebx
  mov [es:ebx + offset UsbHub.prev], edx
  mov [es:ebx + offset UsbHub.next], ecx
  // 9. Start powering up all ports.
  lea eax, [ebx + offset UsbHub.config_buffer]
  xor ecx, ecx
  mov dword ptr [es:eax], 23h + (USB_SET_FEATURE << 8) + (PORT_POWER << 16)
  mov edx, [es:ebx + offset UsbHub.num_ports]
  mov dword ptr [es:eax + 4], edx
  
  push ecx
   push ebx
    push offset h_usb_hub_port_powered
     push ecx
      push ecx
       push eax
        push dword ptr [es:ebx + offset UsbHub.config_pipe]
  call h_usb_control_async
  
  l_h_usb_hub_got_config_freebuf:
  // 10. Free the buffer for hub descriptor and return.
  mov ebx, [ss:esp + 16]  // buffer
  call m_heap_free_kernel
pop ebx  // restore used registers to be stdcall
ret 20

l_h_usb_hub_got_config_nomemory:
jmp short l_h_usb_hub_got_config_freebuf

l_h_usb_hub_port_powered_invalid:
jmp l_h_usb_hub_port_powered_9

// This procedure is called when the request to power up some port is completed,
// either successfully or unsuccessfully.
h_usb_hub_port_powered:
// 4 pipe:dword, 8 status:dword, 12 buffer:dword, 16 length:dword, 20 calldata:dword
// 1. Check whether the operation was successful.
// If not, say something to the debug board and stop the initialization.
cmp dword ptr [ss:esp + 4], 0    // status
jnz l_h_usb_hub_port_powered_invalid

// 2. Check whether all ports were powered.
// If so, go to 4. Otherwise, proceed to 3.
mov eax, [ss:esp + 20]  // calldata
dec dword ptr [es:eax + offset UsbHub.config_buffer + 4]
jz l_h_usb_hub_port_powered_done
  // 3. Power up the next port and return.
  lea edx, [eax + offset UsbHub.config_buffer]
  xor ecx, ecx
  
  push ecx
   push eax
    push offset h_usb_hub_port_powered
     push ecx
      push ecx
       push edx
        push [es:eax + offset UsbHub.config_pipe]
  call h_usb_control_async
  
  jmp short l_h_usb_hub_port_powered_9
  
l_h_usb_hub_port_powered_done:
// 4. All ports were powered.
// The hub requires some delay until power will be stable, the delay value
// is provided in the hub descriptor// we have copied that value to
// usb_hub.PowerOnInterval. Note the time and set the corresponding flag
// for usb_hub_process_deferred.
mov ecx, tmr_usb_timerticks
mov [es:eax + offset UsbHub.powered_on_time], ecx
or dword ptr [es:eax + offset UsbHub.actions], HUB_WAIT_POWERED

l_h_usb_hub_port_powered_9:
ret 20

// This function is called from controller-specific part
// when a new device is ready to be configured.
// IN: ecx -> pseudo-pipe, part of UsbPipe
//     esi -> UsbController
//     [esi+usb_controller.ResettingHub] is the pointer to usb_hub for device,
//       NULL if the device is connected to the root hub
//     [esi+usb_controller.ResettingPort] is the port for the device, zero-based
//     [esi+usb_controller.ResettingSpeed] is the speed of the device, one of
//       USB_SPEED_xx.
// OUT: eax = 0 <=> failed, the caller should disable the port.
h_usb_new_device:
push ebx
 push edi  // save used registers to be stdcall
  // 1. Check whether we're here because we were trying to reset
  // already-registered device in hope to fix something serious.
  // If so, skip allocation and go to 6.
  movzx eax, byte ptr [es:esi + offset UsbController.resetting_port]
  mov edx, [es:esi + offset UsbController.resetting_hub]
  test edx, edx
  jz l_h_usb_new_device_test_roothub
    mov edx, [es:edx + offset UsbHub.connected_devices_ptr]
    mov ebx, [es:edx + eax * 4]
    jmp l_h_usb_new_device_1
    
  l_h_usb_new_device_test_roothub:
    mov ebx, [es:esi + offset UsbController.devices_by_port + eax * 4]
    
  l_h_usb_new_device_1:
  test ebx, ebx
  jnz near l_h_usb_new_device_try_set_address
  // 2. Allocate resources. Any device uses the following resources:
  // - device address in the bus
  // - memory for device data
  // - pipe for zero endpoint
  // If some allocation fails, we must undo our actions. Closing the pipe
  // is a hard task, so we avoid it and open the pipe as the last resource.
  // The order for other two allocations is quite arbitrary.
  // 2a. Allocate a bus address.
  push ecx
    call h_usb_set_address_request
  pop ecx
  // 2b. If failed, just return zero.
  test eax, eax
  jz near l_h_usb_new_device_9
    // 2c. Allocate memory for device data.
    // For now, we need sizeof.usb_device_data and extra 8 bytes for GET_DESCRIPTOR
    // input and output, see usb_after_set_address. Later we will reallocate it
    // to actual size needed for descriptors.
    push ebx
     push ecx
      mov ecx, sizeof UsbDevData + 8
      call m_heap_alloc_kernel
      xchg eax, ebx
     pop ecx
    pop ebx
    // 2d. If failed, free the bus address and return zero.
    test eax, eax
    jz near l_h_usb_new_device_nomemory
    
    // 2e. Open pipe for endpoint zero.
    // For now, we do not know the actual maximum packet size;
    // for full-speed devices it can be any of 8, 16, 32, 64 bytes,
    // low-speed devices must have 8 bytes, high-speed devices must have 64 bytes.
    // Thus, we must use some fake "maximum packet size" until the actual size
    // will be known. However, the maximum packet size must be at least 8, and
    // initial stages of the configuration process involves only packets of <= 8
    // bytes, they will be transferred correctly as long as
    // the fake "maximum packet size" is also at least 8.
    // Thus, any number >= 8 is suitable for actual hardware.
    // However, software emulation of EHCI in VirtualBox assumes that high-speed
    // control transfers are those originating from pipes with max packet size = 64,
    // even on early stages of the configuration process. This is incorrect,
    // but we have no specific preferences, so let VirtualBox be happy and use 64
    // as the fake "maximum packet size".
    push eax
      // We will need many zeroes.
      // "push edi" is one byte, "push 0" is two bytes; save space, use edi.
      xor edi, edi
      
      push edi
       push edi
        push 64
         push edi
          push ecx
      call h_usb_open_pipe
      
      // Put pointer to pipe into ebx. "xchg eax,reg" is one byte, mov is two bytes.
      xchg eax, ebx
    pop eax
    // 2f. If failed, free the memory, the bus address and return zero.
    test ebx, ebx
    jz near l_h_usb_new_device_freememory
    
    // 3. Store pointer to device data in the pipe structure.
    mov [es:ebx + offset UsbPipe.device_data], eax
    // 4. Init device data, using UsbController.resetting* variables.
    mov [es:eax + offset UsbDevData.timer], edi
    mov dword ptr [es:eax + offset UsbDevData.device_descriptor], TIMEOUT_SET_ADDRESS_INITIAL
    mov [es:eax + offset UsbDevData.tt_hub], edi
    mov dword ptr [es:eax + offset UsbDevData.tt_port], 0
    mov [es:eax + offset UsbDevData.num_interfaces], edi
    mov dword ptr [es:eax + offset UsbDevData.device_descr_size], 0
    mov dl, [es:esi + offset UsbController.resetting_speed]
    mov [es:eax + offset UsbDevData.speed], dl
    mov dword ptr [es:eax + offset UsbDevData.num_pipes], 1
    push ebx
      cmp dl, USB_SPEED_HS
      jz l_h_usb_new_device_nott
        mov ebx, [es:esi + offset UsbController.resetting_hub]
        test ebx, ebx
        jz l_h_usb_new_device_nott
          mov cl, [es:esi + offset UsbController.resetting_port]
          mov edx, [es:ebx + offset UsbHub.config_pipe]
          mov edx, [es:edx + offset UsbPipe.device_data]
          cmp dword ptr [es:edx + offset UsbDevData.tt_hub], 0
          jz l_h_usb_new_device_41
            mov cl, [es:edx + offset UsbDevData.tt_port]
            mov ebx, [es:edx + offset UsbDevData.tt_hub]
            jmp short l_h_usb_new_device_has_tt
            
          l_h_usb_new_device_41:
          cmp byte ptr [es:edx + offset UsbDevData.speed], USB_SPEED_HS
          jnz l_h_usb_new_device_nott
          
          l_h_usb_new_device_has_tt:
          mov [es:eax + offset UsbDevData.tt_hub], ebx
          mov [es:eax + offset UsbDevData.tt_port], cl
          
      l_h_usb_new_device_nott:
    pop ebx
    mov [es:eax + offset UsbDevData.config_data_size], edi
    mov [es:eax + offset UsbDevData.interfaces], edi
    movzx ecx, byte ptr [es:esi + offset UsbController.resetting_port]
    mov [es:eax + offset UsbDevData.port], cl
    mov edx, [es:esi + offset UsbController.resetting_hub]
    mov [es:eax + offset UsbDevData.hub], edx
    // 5. Store pointer to the config pipe in the hub data.
    // Config pipe serves as device identifier.
    // Root hubs use the array inside usb_controller structure,
    // non-root hubs use the array immediately after usb_hub structure.
    test edx, edx
    jz l_h_usb_new_device_roothub
      mov edx, [es:edx + offset UsbHub.connected_devices_ptr]
      mov [es:edx + ecx * 4], ebx
      jmp l_h_usb_new_device_51
      
    l_h_usb_new_device_roothub:
    mov [es:esi + offset UsbController.devices_by_port + ecx * 4], ebx
    
    l_h_usb_new_device_51:
    call h_usb_reinit_pipe_list
    // 6. Issue SET_ADDRESS control request, using buffer filled in step 2a.
    // 6a. Configure timer to force reset after timeout.
    // Note: we can't use self-destructing timer, because we need to be able to cancel it,
    // and for self-destructing timer we could have race condition in cancelling/destructing.
    //        DEBUGF 1,'K : pipe %x\n',ebx
    
    l_h_usb_new_device_try_set_address:
    xor edi, edi
    mov edx, [es:ebx + offset UsbPipe.device_data]
    
    push ebx
     push esi
      mov ecx, [es:edx + offset UsbDevData.device_descriptor]
      mov eax, 10 * 1193  //?
      mul ecx
      xchg ecx, eax
      mov edx, usb_thread
      shl edx, 16
      mov dx, WIN_NONE
      mov edi, ebx  // edi -> UsbPipe
      mov ebx, WP_ABORT_PIPE
      call h_timer_add
     pop esi
    pop ebx
    /*
    push ebx
     push offset h_usb_abort_pipe
      push 7FFFFFFFh
       push dword ptr [es:edx + offset UsbDevData.device_descriptor]
    call timer_hs  // keep ebx, esi
    */
    
    test al, al
    jnz l_h_usb_new_device_9
      mov edx, [es:ebx + offset UsbPipe.device_data]
      mov [es:edx + offset UsbDevData.timer], ebx  // timer = ebx
      // 6b. If it succeeded, setup timer to configure wait timeout.
      lea eax, [esi + offset UsbController.set_address_buffer]
      xor edi, edi
      
      push edi
       push edi
        push offset h_usb_set_address_callback
         push edi
          push edi
           push eax
            push ebx
      call h_usb_control_async
      
      // Use the return value from usb_control_async as our return value//
      // if it is zero, then something has failed.
      
  l_h_usb_new_device_9:
  // 7. Return.
 pop edi
pop ebx  // restore used registers to be stdcall
ret


// Handlers of failures in steps 2b, 2d, 2f.
l_h_usb_new_device_freememory:
xchg ebx, eax
//mov ecx, sizeof UsbDevData + 8
call m_heap_free_kernel

l_h_usb_new_device_nomemory:
mov ecx, [es:esi + offset UsbController.set_address_buffer + 2]
bts dword ptr [es:esi + offset UsbController.existing_addresses], ecx
xor eax, eax
jmp short l_h_usb_new_device_9

// This procedure is called from usb_subscription_done when the hardware cache
// is cleared after request from usb_set_address_callback.
// IN: ebx -> UsbPipe
h_usb_after_set_address:
// Issue control transfer GET_DESCRIPTOR(DEVICE_DESCR) for first 8 bytes.
// Remember, we still do not know the actual packet size;
// 8-bytes-request is safe.
// usb_new_device has allocated 8 extra bytes besides sizeof.usb_device_data;
// use them for both input and output.
mov eax, [es:ebx + offset UsbPipe.device_data]
add eax, offset UsbDevData.device_descriptor
mov dword ptr [es:eax], 80h + (USB_GET_DESCRIPTOR << 8) + (USB_DEVICE_DESCR << 24)
mov dword ptr [es:eax + 4], 8 << 16  // data length

push 0
 push eax
  push offset h_usb_get_descr8_callback
   push 8
    push eax
     push eax
      push ebx
call h_usb_control_async

ret

// This procedure is called from usb_subscription_done when the hardware cache
// is cleared after request from usb_get_descr8_callback.
// in: ebx -> usb_pipe
h_usb_after_set_endpoint_size:
// 1. Reallocate memory for device data:
// add memory for now-known size of device descriptor and extra 8 bytes
// for further actions.
// 1a. Allocate new memory.
mov eax, [es:ebx + offset UsbPipe.device_data]
movzx eax, byte ptr [es:eax + offset UsbDevData.device_descriptor + offset UsbDeviceDescr.base.bLength]
// save length for step 2
push eax
  add eax, sizeof UsbDevData + 8
  push ebx
   push ecx
    mov ecx, eax
    call m_heap_alloc_kernel
    xchg eax, ebx
   pop ecx
  pop ebx
  // 1b. If failed, stop the initialization.
  test eax, eax
  jz l_h_usb_after_set_endpoint_size_nomem
  
  // 1c. Copy data from old memory to new memory and switch the pointer in usb_pipe.
  push eax
    push esi
     push edi
      mov esi, [es:ebx + offset UsbPipe.device_data]
      mov [es:ebx + offset UsbPipe.device_data], eax
      mov edi, eax
      mov eax, esi
      mov ecx, sizeof UsbDevData / 4
      push ds
        push es
        pop ds
        cld
        rep movsd
      pop ds
     pop edi
    pop esi
    call h_usb_reinit_pipe_list  // keep eax
    // 1d. Free the old memory.
    push ebx
      xchg ebx, eax
      call m_heap_free_kernel
    pop ebx
  pop eax
  // 2. Issue control transfer GET_DESCRIPTOR(DEVICE) for full descriptor.
  // restore length saved in step 1a
pop edx
add eax, sizeof UsbDevData
mov dword ptr [es:eax], 80h + (USB_GET_DESCRIPTOR << 8) + (USB_DEVICE_DESCR << 24)
and dword ptr [es:eax + 4], 0
mov [es:eax + 6], dl  // data length

push 0
 push eax
  push offset h_usb_get_descr_callback
   push edx
    push eax
     push eax
      push ebx
call h_usb_control_async

// 3. Return.
ret

  l_h_usb_after_set_endpoint_size_nomem:
pop edx
xor eax, eax
ret

// Helper procedure for usb_new_device.
// Allocates a new USB address and fills usb_controller.SetAddressBuffer
// with data for SET_ADDRESS(allocated_address) request.
// IN: esi -> UsbController
// OUT: eax = 0 <=> failed
// DESTROY: edi
h_usb_set_address_request:
// There are 128 bits, one for each possible address.
// Note: only the USB thread works with usb_controller.ExistingAddresses,
// so there is no need for synchronization.
// We must find a bit set to 1 and clear it.
// 1. Find the first dword which has a nonzero bit = which is nonzero.
mov ecx, 128 / 32
lea edi, [esi + offset UsbController.existing_addresses]
xor eax, eax
repe scasd
// 2. If all dwords are zero, return an error.
jz l_h_usb_set_address_request_error
  // 3. The dword at [edi-4] is nonzero. Find the lowest nonzero bit.
  bsf eax, [es:edi - 4]
  // Now eax = bit number inside the dword at [edi - 4].
  // 4. Clear the bit.
  btr [es:edi - 4], eax
  // 5. Generate the address by edi = memory address and eax = bit inside dword.
  // Address = eax + 8 * (edi-4 - (esi+usb_controller.ExistingAddress)).
  sub edi, esi
  lea edi, [eax + edi * 8 - 32 - (offset UsbController.existing_addresses * 8)]
  // 6. Store the allocated address in SetAddressBuffer and fill remaining fields.
  // Note that usb_controller is zeroed at allocation, so only command byte needs
  // to be filled.
  mov byte ptr [es:esi + offset UsbController.set_address_buffer + 1], USB_SET_ADDRESS
  mov dword ptr [es:esi + offset UsbController.set_address_buffer + 2], edi
  // 7. Return non-zero value in eax.
  inc eax
  
  l_h_usb_set_address_request_9:
  ret
  
l_h_usb_set_address_request_error:
xor eax, eax
jmp short l_h_usb_set_address_request_9

// This procedure is called by USB stack when SET_ADDRESS request initiated by
// usb_new_device is completed, either successfully or unsuccessfully.
// IN: esi -> UsbController
h_usb_set_address_callback:
// 8 pipe:dword, 12 status:dword, 16 buffer:dword, 20 length:dword, 24 calldata:dword
push ebx  // save ebx to be stdcall
mov ebx, [ss:esp + 8]  // pipe
// 1. In any case, cancel the timer.
mov eax, [es:ebx + offset UsbPipe.device_data]
test eax, eax
jz l_h_usb_set_address_callback_1
  push esi
   push edi
    push ebx
      mov edx, usb_thread
      shl edx, 16
      mov dx, WIN_NONE
      mov ebx, WP_ABORT_PIPE
      call h_timer_remove
    pop ebx
   pop edi
  pop esi
  
l_h_usb_set_address_callback_1:
mov eax, [es:ebx + offset UsbPipe.device_data]
mov dword ptr [es:eax + offset UsbDevData.timer], 0
// Load data to registers for further references.
mov ecx, dword ptr [es:esi + offset UsbController.set_address_buffer + 2]
mov eax, [es:esi + offset UsbController.hardware_func]
// 2. Check whether the device has accepted new address. If so, proceed to 3.
// Otherwise, go to 4 if killed by usb_set_address_timeout or to 5 otherwise.
cmp dword ptr [ss:esp + 12], USB_STATUS_CANCELLED  // status
jz l_h_usb_set_address_callback_timeout
  cmp dword ptr [ss:esp + 12], 0
  jnz l_h_usb_set_address_callback_error
  // 3. Address accepted.
  // 3a. The controller-specific structure for the control pipe still uses
  // zero address. Call the controller-specific function to change it to
  // the actual address.
  // Note that the hardware could cache the controller-specific structure,
  // so setting the address could take some time until the cache is evicted.
  // Thus, the call is asynchronous// meet us in usb_after_set_address when it will
  // be safe to continue.
  //        dbgstr 'address set in device'
  call dword ptr [es:eax + offset UsbHardwareFunc.set_device_address]
  // 3b. If the port is in non-root hub, clear 'reset in progress' flag.
  // In any case, proceed to 6.
  mov eax, [es:esi + offset UsbController.resetting_hub]
  test eax, eax
  jz l_h_usb_set_address_callback_return
    and dword ptr [es:eax + offset UsbHub.actions], -1 - HUB_RESET_IN_PROGRESS
    
  l_h_usb_set_address_callback_return:
  // 6. Address configuration done, we can proceed with other ports.
  // Call the worker function for that.
  call h_usb_test_pending_port
  
  l_h_usb_set_address_callback_wakeup:
  call h_usb_notify
  
  l_h_usb_set_address_callback_9:
  
  pop ebx  // restore ebx to be stdcall
  
  ret 20


l_h_usb_set_address_callback_timeout:
// 4. Device continues to NAK the request. Reset it and retry.
mov edx, [es:ebx + offset UsbPipe.device_data]
mov ecx, [es:edx + offset UsbDevData.device_descriptor]
add ecx, ecx
cmp ecx, TIMEOUT_SET_ADDRESS_LAST
ja l_h_usb_set_address_callback_error
  mov [es:edx + offset UsbDevData.device_descriptor], ecx
  cmp dword ptr [es:esi + offset UsbController.resetting_hub], 0
  jz l_h_usb_set_address_callback_reset_roothub
    push esi
      mov esi, [es:esi + offset UsbController.resetting_hub]
      call h_usb_hub_initiate_reset
    pop esi
    jmp l_h_usb_set_address_callback_9
    
  l_h_usb_set_address_callback_reset_roothub:
  movzx ecx, byte ptr [es:esi + offset UsbController.resetting_port]
  call dword ptr [es:eax + offset UsbHardwareFunc.initiate_reset]
  jmp l_h_usb_set_address_callback_wakeup
  
l_h_usb_set_address_callback_error:
// 5. Device error: device not responding, disconnect etc.
// 5a. The address has not been accepted. Mark it as free.
bts dword ptr [es:esi + offset UsbController.existing_addresses], ecx
// 5b. Disable the port with bad device.
// For the root hub, call the controller-specific function and go to 6.
// For non-root hubs, let the hub code do its work and return (the request
// could take some time, the hub code is responsible for proceeding).
cmp dword ptr [es:esi + offset UsbController.resetting_hub], 0
jz l_h_usb_set_address_callback_roothub
  mov eax, [es:esi + offset UsbController.resetting_hub]
  call h_usb_hub_disable_resetting_port
  jmp l_h_usb_set_address_callback_9
  
l_h_usb_set_address_callback_roothub:
movzx ecx, byte ptr [es:esi + offset UsbController.resetting_port]
call dword ptr [es:eax + offset UsbHardwareFunc.port_disable]
jmp l_h_usb_set_address_callback_9

// This procedure is called by USB stack when GET_DESCRIPTOR(DEVICE_DESCR)
// request initiated by usb_after_set_address is completed, either successfully
// or unsuccessfully.
// Note that USB stack uses esi -> UsbController.
h_usb_get_descr8_callback:
// 12 pipe:dword, 16 status:dword, 20 buffer:dword, 24 length:dword, 28 calldata:dword
push edi
 push ebx  // save used registers to be stdcall
  mov ebx, [ss:esp + 12]  // pipe
  // 1. Check whether the operation was successful.
  // If not, say something to the debug board and stop the initialization.
  cmp dword ptr [ss:esp + 16], 0  // status
  jnz l_h_usb_get_descr8_callback_error
  
  // 2. Length of descriptor must be at least sizeof.usb_device_descr bytes.
  // If not, say something to the debug board and stop the initialization.
  mov eax, [es:ebx + offset UsbPipe.device_data]
  cmp byte ptr [es:eax + offset UsbDevData.device_descriptor + offset UsbDescr.bLength], sizeof UsbDeviceDescr
  jb l_h_usb_get_descr8_callback_error
  
  // 3. Now first 8 bytes of device descriptor are known;
  // set DeviceDescrSize accordingly.
  mov dword ptr [es:eax + offset UsbDevData.device_descr_size], 8
  // 4. The controller-specific structure for the control pipe still uses
  // the fake "maximum packet size". Call the controller-specific function to
  // change it to the actual packet size from the device.
  // Note that the hardware could cache the controller-specific structure,
  // so changing it could take some time until the cache is evicted.
  // Thus, the call is asynchronous; meet us in usb_after_set_endpoint_size
  // when it will be safe to continue.
  movzx ecx, byte ptr [es:eax + offset UsbDevData.device_descriptor + offset UsbDeviceDescr.bMaxPacketSize0]
  mov eax, [es:esi + offset UsbController.hardware_func]
  call [es:eax + offset UsbHardwareFunc.set_endpoint_packet_size]
  
  l_h_usb_get_descr8_callback_9:
  // 5. Return.
 pop ebx
pop edi  // restore used registers to be stdcall
ret 20

l_h_usb_get_descr8_callback_error:
jmp l_h_usb_get_descr8_callback_9

// This procedure is called by USB stack when GET_DESCRIPTOR(DEVICE)
// request initiated by usb_after_set_endpoint_size is completed,
// either successfully or unsuccessfully.
h_usb_get_descr_callback:
// 12 pipe:dword, 16 status:dword, 20 buffer:dword, 24 length:dword, 28 calldata:dword
// Note: the prolog is the same as in usb_get_descr8_callback.
push edi
 push ebx  // save used registers to be stdcall
  // 1. Check whether the operation was successful.
  // If not, say something to the debug board and stop the initialization.
  cmp dword ptr [ss:esp + 16], 0  // status
  jnz l_h_usb_get_descr8_callback_error
  
  // 2. Check that bLength is the same as was in the previous request.
  // If not, say something to the debug board and stop the initialization.
  // It is important, because usb_after_set_endpoint_size has allocated memory
  // according to the old bLength. Note that [length] for control transfers
  // includes 8 bytes of setup packet, so data length = [length] - 8.
  mov eax, [ss:esp + 20]  // buffer
  movzx ecx, byte ptr [es:eax + offset UsbDescr.bLength]
  add ecx, 8
  cmp [ss:esp + 24], ecx  // length
  jnz l_h_usb_get_descr8_callback_error
  
  // Amuse the user if she is watching the debug board.
  mov cl, [es:eax + offset UsbDeviceDescr.bNumConfigurations]
  // 3. If there are no configurations, stop the initialization.
  cmp byte ptr [es:eax + offset UsbDeviceDescr.bNumConfigurations], 0
  jz l_h_usb_get_descr_callback_9
  
  // 4. Copy length of device descriptor to device data structure.
  movzx edx, byte ptr [es:eax + offset UsbDescr.bLength]
  mov [es:eax + offset UsbDevData.device_descr_size - offset UsbDevData.device_descriptor], dl
  // 5. Issue control transfer GET_DESCRIPTOR(CONFIGURATION). We do not know
  // the full length of that descriptor, so start with first 8 bytes, they contain
  // the full length.
  // usb_after_set_endpoint_size has allocated 8 extra bytes after the
  // device descriptor, use them for both input and output.
  add eax, edx
  mov dword ptr [es:eax], 80h + (USB_GET_DESCRIPTOR << 8) + (USB_CONFIG_DESCR << 24)
  mov dword ptr [es:eax + 4], 8 << 16  // data length
  
  push 0
   push eax
    push offset h_usb_know_length_callback
     push 8
      push eax
       push eax
        push [ss:esp + 12]  // pipe
  call h_usb_control_async
  
  l_h_usb_get_descr_callback_9:
  // 6. Return.
 pop ebx
pop edi  // restore used registers to be stdcall
ret 20

// This procedure is called by USB stack when GET_DESCRIPTOR(CONFIGURATION)
// request initiated by usb_get_descr_callback is completed,
// either successfully or unsuccessfully.
h_usb_know_length_callback:
// 8 pipe:dword, 12 status:dword, 16 buffer:dword, 20 length:dword, 24 calldata:dword
push ebx  // save used registers to be stdcall
  // 1. Check whether the operation was successful.
  // If not, say something to the debug board and stop the initialization.
  cmp dword ptr [ss:esp + 12], 0  // status
  jnz near l_h_usb_know_length_callback_error
  
  // 2. Get the total length of data associated with config descriptor and store
  // it in device data structure. The total length must be at least
  // sizeof.usb_config_descr bytes// if not, say something to the debug board and
  // stop the initialization.
  mov eax, [ss:esp + 16]  // buffer
  mov edx, [ss:esp + 8]  // pipe
  movzx ecx, word ptr [es:eax + offset UsbConfigDescr.wTotalLength]
  mov eax, [es:edx + offset UsbPipe.device_data]
  cmp ecx, sizeof UsbConfigDescr
  jb near l_h_usb_know_length_callback_error
  
  mov [es:eax + offset UsbDevData.config_data_size], ecx
  // 3. Reallocate memory for device data:
  // include usb_device_data structure, device descriptor,
  // config descriptor with all associated data, and extra bytes
  // sufficient for 8 bytes control packet and for one usb_interface_data struc.
  // Align extra bytes to dword boundary.
  // 3a. Allocate new memory.
  mov edx, [es:eax + offset UsbDevData.device_descr_size]
  lea eax, [es:ecx + edx + sizeof UsbDevData + 8 + 3]
  and eax, -4
  push eax
    xchg ecx, eax
    call m_heap_alloc_kernel
    xchg eax, ebx
  pop edx
  // 3b. If failed, say something to the debug board and stop the initialization.
  test eax, eax
  jz l_h_usb_know_length_callback_nomemory
  // 3c. Copy data from old memory to new memory and switch the pointer in usb_pipe.
  push eax
    mov ebx, [ss:esp + 8 + 4]  // pipe
    push esi
     push edi
      mov esi, [es:ebx + offset UsbPipe.device_data]
      mov edi, eax
      mov [es:ebx + offset UsbPipe.device_data], eax
      mov eax, esi  // eax -> device_data
      mov ecx, [es:esi + offset UsbDevData.device_descr_size]
      sub edx, 8
      mov [es:esi + offset UsbDevData.interfaces], edx
      add ecx, sizeof UsbDevData + 8
      mov edx, ecx
      shr ecx, 2
      and edx, 3
      push ds
        push es
        pop ds
        cld
        rep movsd
        mov ecx, edx
        rep movsb
      pop ds
     pop edi
    pop esi
    call h_usb_reinit_pipe_list
    // 3d. Free old memory.
    xchg ebx, eax
    call m_heap_free_kernel
  pop eax
  // 4. Issue control transfer GET_DESCRIPTOR(CONFIGURATION) for full descriptor.
  mov ecx, [es:eax + offset UsbDevData.device_descr_size]
  mov edx, [es:eax + offset UsbDevData.config_data_size]
  lea eax, [eax + ecx + sizeof UsbDevData]
  mov dword ptr [es:eax], 80h + (USB_GET_DESCRIPTOR << 8) + (USB_CONFIG_DESCR << 24)
  and dword ptr [es:eax + 4], 0
  mov [es:eax + 6], dx  // data length
  
  push 0
   push eax
    push offset h_usb_set_config_callback
     push edx
      push eax
       push eax
        push [ss:esp + 8]  // pipe
  call h_usb_control_async
  
  l_h_usb_know_length_callback_9:
  // 5. Return.
pop ebx             // restore used registers to be stdcall
ret 20

  l_h_usb_know_length_callback_error:
  jmp l_h_usb_know_length_callback_9
  
  l_h_usb_know_length_callback_nomemory:
  jmp l_h_usb_know_length_callback_9

// This procedure is called by USB stack when GET_DESCRIPTOR(CONFIGURATION)
// request initiated by usb_know_length_callback is completed,
// either successfully or unsuccessfully.
h_usb_set_config_callback:
// 8 pipe:dword, 12 status:dword, 16 buffer:dword, 20 length:dword, 24 calldata:dword
// Note that the prolog is the same as in usb_know_length_callback.
push ebx  // save used registers to be stdcall
  // 1. Check whether the operation was successful.
  // If not, say something to the debug board and stop the initialization.
  xor ecx, ecx
  mov ebx, [ss:esp + 8]  // pipe
  cmp [ss:esp + 12], ecx  // status
  jnz l_h_usb_know_length_callback_error
  
  // 2. Issue control transfer SET_CONFIGURATION to activate this configuration.
  // Usually this is the only configuration.
  // Use extra bytes allocated by usb_know_length_callback//
  // offset from device data start is stored in Interfaces.
  mov eax, [es:ebx + offset UsbPipe.device_data]
  mov edx, [ss:esp + 16]  // buffer
  add eax, [es:eax + offset UsbDevData.interfaces]
  mov dl, [es:edx + offset UsbConfigDescr.bConfigurationValue]
  mov dword ptr [es:eax], USB_SET_CONFIGURATION << 8
  mov dword ptr [es:eax + 4], ecx
  mov [es:eax + 2], dl
  
  push ecx
   push [ss:esp + 16]  // buffer
    push offset h_usb_got_config_callback
     push ecx
      push ecx
       push eax
        push [ss:esp + 8]  // pipe
  call h_usb_control_async
  
pop ebx  // restore used registers to be stdcall
ret 20

// This procedure is called by USB stack when SET_CONFIGURATION
// request initiated by usb_set_config_callback is completed,
// either successfully or unsuccessfully.
// If successfully, the device is configured and ready to work,
// pass the device to the corresponding driver(s).
h_usb_got_config_callback:
// 24 pipe:dword, 28 status:dword, 32 buffer:dword, 36 length:dword, 40 calldata:dword
/*
16 interfacesData  dd      ?
12 numInterfaces   dd      ?
8 driver          dd      ?
4 ebx
0 edi
*/

// 1. If there was an error, say something to the debug board and stop the
// initialization.
cmp dword ptr [ss:esp + 8], 0  // status
jz l_h_usb_got_config_callback_1
  ret 20
  
l_h_usb_got_config_callback_1:
sub esp, 12
push ebx
 push edi  // save used registers to be stdcall
  // 2. Sanity checks: the total length must be the same as before (because we
  // have allocated memory assuming the old value), length of config descriptor
  // must be at least sizeof UsbConfigDescr (we use fields from it),
  // there must be at least one interface.
  mov ebx, [ss:esp + 24]  // pipe
  mov ebx, [es:ebx + offset UsbPipe.device_data]
  mov eax, [ss:esp + 40]  // calldata
  mov edx, [es:ebx + offset UsbDevData.config_data_size]
  cmp [es:eax + offset UsbConfigDescr.wTotalLength], dx
  jnz l_h_usb_got_config_callback_invalid
    cmp byte ptr [es:eax + offset UsbDescr.bLength], 9
    jb l_h_usb_got_config_callback_invalid
      movzx edx, byte ptr [es:eax + offset UsbConfigDescr.bNumInterfaces]
      test edx, edx
      jnz l_h_usb_got_config_callback_2
      
  l_h_usb_got_config_callback_invalid:
  jmp l_h_usb_got_config_callback_9
  
  l_h_usb_got_config_callback_2:
  // 3. Store the number of interfaces in device data structure.
  mov [es:ebx + offset UsbDevData.num_interfaces], edx
  // 4. If there is only one interface (which happens quite often),
  // the memory allocated in usb_know_length_callback is sufficient.
  // Otherwise (which also happens quite often), reallocate device data.
  // 4a. Check whether there is only one interface. If so, skip this step.
  cmp edx, 1
  jz l_h_usb_got_config_callback_has_memory
    // 4b. Allocate new memory.
    mov eax, [es:ebx + offset UsbDevData.interfaces]
    lea ecx, [eax + edx * 8]  // assert sizeof UsbInterfaceData = 8
    push ebx
      call m_heap_alloc_kernel
      xchg eax, ebx
    pop ebx
    // 4c. If failed, say something to the debug board and
    // stop the initialization.
    test eax, eax
    jz near l_h_usb_got_config_callback_9
    
    // 4d. Copy data from old memory to new memory and switch the pointer in usb_pipe.
    push eax
      push esi
        mov ebx, [ss:esp + 24]  // pipe
        mov edi, eax
        mov esi, [es:ebx + offset UsbPipe.device_data]
        mov [es:ebx + offset UsbPipe.device_data], eax
        mov eax, esi
        mov ecx, [es:esi + offset UsbDevData.interfaces]
        shr ecx, 2
        push ds
          push es
          pop ds
          cld
          rep movsd
        pop ds
      pop esi
      call h_usb_reinit_pipe_list
      // 4e. Free old memory.
      xchg ebx, eax
      call m_heap_free_kernel
    pop ebx
    
  l_h_usb_got_config_callback_has_memory:
  // 5. Initialize interfaces table: zero all contents.
  mov edi, [es:ebx + offset UsbDevData.interfaces]
  add edi, ebx
  mov [ss:esp + 16], edi  // interfacesData
  mov ecx, [es:ebx + offset UsbDevData.num_interfaces]
  add ecx, ecx
  xor eax, eax
  cld
  rep stosd
  // No interfaces are found yet.
  mov [ss:esp + 12], eax  // numInterfaces
  // 6. Get the pointer to config descriptor data.
  // Note: if there was reallocation, [buffer] is not valid anymore,
  // so calculate value based on usb_device_data.
  mov eax, [es:ebx + offset UsbDevData.device_descr_size]
  lea eax, [eax + ebx + sizeof UsbDevData]
  mov [ss:esp + 40], eax  // calldata
  mov ecx, [es:ebx + offset UsbDevData.config_data_size]
  // 7. Loop over all descriptors,
  // scan for interface descriptors with bAlternateSetting = 0,
  // load the corresponding driver, call its AddDevice function.
  
  l_h_usb_got_config_callback_5:
    // While in loop: eax points to the current descriptor,
    // ecx = number of bytes left, the iteration starts only if ecx is nonzero,
    // edx = size of the current descriptor.
    // 7a. The first byte is always accessible// it contains the length of
    // the current descriptor. Validate that the length is at least 2 bytes,
    // and the entire descriptor is readable (the length is at most number of
    // bytes left).
    movzx edx, byte ptr [es:eax + offset UsbDescr.bLength]
    cmp edx, sizeof UsbDescr
    jb near l_h_usb_got_config_callback_invalid
    
    cmp ecx, edx
    jb near l_h_usb_got_config_callback_invalid
    
    // 7b. Check descriptor type. Ignore all non-INTERFACE descriptor.
    cmp byte ptr [es:eax + offset UsbDescr.bDescriptorType], USB_INTERFACE_DESCR
    jz l_h_usb_got_config_callback_interface
    
    l_h_usb_got_config_callback_next_descriptor:
    // 7c. Advance pointer, decrease length left, if there is still something left,
    // continue the loop.
    add eax, edx
    sub ecx, edx
    jnz l_h_usb_got_config_callback_5
    
  l_h_usb_got_config_callback_9:
 pop edi
pop ebx         // restore used registers to be stdcall
add esp, 12
ret 20


l_h_usb_got_config_callback_interface:
// 7d. Validate the descriptor length.
cmp edx, sizeof UsbInterfaceDescr
jb l_h_usb_got_config_callback_next_descriptor

// 7e. If bAlternateSetting is nonzero, this descriptor actually describes
// another mode of already known interface and belongs to the already loaded
// driver// amuse the user and continue to 7c.
cmp byte ptr [es:eax + offset UsbInterfaceDescr.bAlternateSetting], 0
jnz l_h_usb_got_config_callback_next_descriptor

l_h_usb_got_config_callback_71:
// 7f. Check that the new interface does not overflow allocated table.
mov edx, [ss:esp + 12]  // numInterfaces
inc edx
cmp edx, [es:ebx + offset UsbDevData.num_interfaces]
ja near l_h_usb_got_config_callback_invalid

// 7g. We have found a new interface. Advance bookkeeping vars.
mov [ss:esp + 12], edx  // numInterfaces
add dword ptr [ss:esp + 16], sizeof UsbInterfaceData  // interfacesData
// 7h. Save length left and pointer to the current interface descriptor.
push ecx
 push eax
  // 7i. Select the correct driver based on interface class.
  // For hubs, go to 7j. Otherwise, go to 7k.
  // Note: this should be rewritten as table-based lookup when more drivers will
  // be available.
  cmp byte ptr [es:eax + offset UsbInterfaceDescr.bInterfaceClass], 9
  jz l_h_usb_got_config_callback_found_hub
    
    mov edx, offset h_hid_fn
    cmp byte ptr [es:eax + offset UsbInterfaceDescr.bInterfaceClass], 3
    jz l_h_usb_got_config_callback_load_driver
      /*
      //...
      mov edx, offset h_usb_print_name + PA_KERNEL_CODE + VA_SYSTEM
      cmp byte ptr [es:eax + offset UsbInterfaceDescr.bInterfaceClass], 7
      jz l_h_usb_got_config_callback_load_driver
        mov edx, offset h_usb_stor_name + PA_KERNEL_CODE + VA_SYSTEM
        cmp byte ptr [es:eax + offset UsbInterfaceDescr.bInterfaceClass], 8
        jz l_h_usb_got_config_callback_load_driver
      */  
          xor edx, edx
          jmp short l_h_usb_got_config_callback_load_driver
          
  l_h_usb_got_config_callback_found_hub:
  // 7j. Hubs are a part of USB stack, thus, integrated into the kernel.
  // Use the pointer to hub callbacks and go to 7m.
  mov eax, offset h_usb_hub_fn
  jmp l_h_usb_got_config_callback_driver_loaded
    
    l_h_usb_got_config_callback_load_driver:
    mov eax, edx
    
  l_h_usb_got_config_callback_driver_loaded:
  // 7m. Call AddDevice function of the driver.
  // Note that top of stack contains a pointer to the current interface,
  // saved by step 7h.
  mov [ss:esp + 8 + 8], eax  // driver
 pop edx
 push edx
  // Note: usb_hub_init assumes that edx points to usb_interface_descr,
  // ecx = length rest; if you change the code, modify usb_hub_init also.
  
  push edx
   push [ss:esp + 40 + 8 + 4]  // calldata
    push [ss:esp + 24 + 8 + 8]  // pipe
  call [cs:eax + 4]  // add device, OUT eax = driver data
  
  // 7n. If failed, say something to the debug board and go to 7p.
  test eax, eax
  jnz l_h_usb_got_config_callback_store_data
    jmp l_h_usb_got_config_callback_next_descriptor2
    
  l_h_usb_got_config_callback_store_data:
  // 7o. Store the returned value and the driver handle to InterfacesData.
  // Note that step 7g has already advanced InterfacesData.
  mov edx, [ss:esp + 16 + 8]  // interfacesData
  mov [es:edx + offset UsbInterfaceData.driver_data - sizeof UsbInterfaceData], eax
  mov eax, [ss:esp + 8 + 8]  // driver
  mov [es:edx + offset UsbInterfaceData.driver_func - sizeof UsbInterfaceData], eax
  
  l_h_usb_got_config_callback_next_descriptor2:
  // 7p. Restore registers saved in step 7h, get the descriptor length and
  // continue to 7c.
 pop eax
pop ecx
movzx edx, byte ptr [es:eax + offset UsbDescr.bLength]
jmp l_h_usb_got_config_callback_next_descriptor

h_usb_init:
// zero
xor eax, eax
mov usb_ready, al
// init USB MMIO
mov usb_mmio, VA_USB_MMIO
mov edx, 0
mov ebx, usb_mmio
mov ecx, 1
call m_pages_alloc_hard
// alloc USB
mov cl, USB_SIZE >> 16  // 128 KiB
call m_alloc_dma
test al, al
jnz l_h_usb_init_9
  // map virtual VA_USB to physical usb_base
  mov usb_base, esi
  mov edx, esi
  mov ebx, VA_USB
  mov ecx, USB_SIZE >> 12  // 128 KiB
  call m_pages_alloc_hard
  test al, al
  jnz l_h_usb_init_9
    
    // clean
    mov edi, VA_USB
    mov ecx, USB_SIZE / 4
    xor eax, eax
    cld
    rep stosd
    
    // for faster allocation of small blocks
    mov ecx, 1
    call h_usb_alloc
    
    // create usb thread
    call p_create_thread_inner
    and dword [es:edi + offset ThreadRec.flags], -1 - THREAD_FLAGS_USE_FPU
    mov eax, edi
    sub eax, VA_THREADS
    shr eax, 12
    or ax, 16384
    mov usb_thread, eax
    
    mov dword ptr [es:edi + offset TssRec.eip], offset h_usb_thread
    call p_start  // really starts after enabling interrupts
    
    call h_hid_init
    
l_h_usb_init_9:
ret

h_usb_thread:
sti
// * KickOff BIOS *
xor ebx, ebx
mov ecx, pci_count

l_h_usb_thread_15:
  jecxz l_h_usb_thread_18
    mov eax, pci_info.class[ebx]
    push ecx
     push ebx
      movzx ecx, word ptr pci_info.adr[ebx + 2]
      movzx edx, word ptr pci_info.adr[ebx]
      mov usb_ecx, ecx
      mov usb_edx, edx
      
      shr eax, 8
      cmp eax, 0x0C0320
      jnz l_h_usb_thread_161
        // ehci
        call h_ehci_kickoff_bios
        jmp short l_h_usb_thread_168
        
      l_h_usb_thread_161:
      cmp eax, 0x0C0310
      jnz l_h_usb_thread_162
        // ohci
        call h_ohci_kickoff_bios
        jmp short l_h_usb_thread_168
        
      l_h_usb_thread_162:
      cmp eax, 0x0C0300
      jnz l_h_usb_thread_168
        // uhci
        call h_uhci_kickoff_bios
        
      l_h_usb_thread_168:
     pop ebx
    pop ecx
    add ebx, sizeof PciInfo
    dec ecx
    jmp short l_h_usb_thread_15
    
l_h_usb_thread_18:

// * init *
// init ehci
xor ebx, ebx
mov ecx, pci_count

l_h_usb_thread_25:
  jecxz l_h_usb_thread_28
    mov eax, pci_info.class[ebx]
    shr eax, 8
    cmp eax, 0x0C0320
    jnz l_h_usb_thread_26
      push ecx
       push ebx
        // ehci
        movzx ecx, word ptr pci_info.adr[ebx + 2]
        movzx edx, word ptr pci_info.adr[ebx]
        mov usb_ecx, ecx
        mov usb_edx, edx
        call h_ehci_init
       pop ebx
      pop ecx
      
    l_h_usb_thread_26:
    add ebx, sizeof PciInfo
    dec ecx
    jmp short l_h_usb_thread_25
    
l_h_usb_thread_28:

// init uhci/ohci
xor ebx, ebx
mov ecx, pci_count

l_h_usb_thread_35:
  jecxz l_h_usb_thread_38
    mov eax, pci_info.class[ebx]
    push ecx
     push ebx
      movzx ecx, word ptr pci_info.adr[ebx + 2]
      movzx edx, word ptr pci_info.adr[ebx]
      mov usb_ecx, ecx
      mov usb_edx, edx
      
      shr eax, 8
      cmp eax, 0x0C0310
      jnz l_h_usb_thread_362
        // ohci
        call h_ohci_init
        mov usb_test_controller, eax  //$$$
        jmp short l_h_usb_thread_368
        
      l_h_usb_thread_362:
      cmp eax, 0x0C0300
      jnz l_h_usb_thread_368
        // uhci
        call h_uhci_init
        mov usb_test_controller, eax  //$$$
        
      l_h_usb_thread_368:
     pop ebx
    pop ecx
    add ebx, sizeof PciInfo
    dec ecx
    jmp short l_h_usb_thread_35
    
l_h_usb_thread_38:

// enable usb
mov usb_ready, 1


// * Message Loop *

l_h_usb_thread_5:
  // Get Message
  // OUT: al = 0 || errorcode, ebx = winid:poster, ecx = msg,
  //      edx = wp, esi = lp, edi = hwnd
  call p_msg_get
  test al, al
  jnz near l_h_usb_thread_8
    // ecx = WM
    cmp ecx, WM_USB_INT
    jnz near l_h_usb_thread_6
      
      // WM_USB_INT: esi -> UsbController
      
      // may remove old timer //?
      mov edx, usb_thread
      shl edx, 16
      mov dx, WIN_NONE
      mov ebx, WP_NORMAL
      call h_timer_remove
      
      // call process_deferred
      l_h_usb_thread_51:
      push -1
        // controllers
        mov esi, VA_USB_CONTROLLERS_LIST
        
        l_h_usb_thread_515:
          mov esi, [es:esi + offset UsbController.next]
          cmp esi, VA_USB_CONTROLLERS_LIST
          jz l_h_usb_thread_516  
            mov edi, [es:esi + offset UsbController.hardware_func]
            call [es:edi + offset UsbHardwareFunc.process_deferred]
            cmp eax, [ss:esp]
            jnb l_h_usb_thread_515
              mov [ss:esp], eax
              jmp short l_h_usb_thread_515
              
        l_h_usb_thread_516:
        // hubs
        mov esi, VA_USB_HUBS_LIST
        
        l_h_usb_thread_525:
          mov esi, [es:esi + offset UsbHub.next]
          cmp esi, VA_USB_HUBS_LIST
          jz l_h_usb_thread_526
            call h_usb_hub_process_deferred
            cmp eax, [ss:esp]
            jnb l_h_usb_thread_525
              mov [ss:esp], eax
              jmp short l_h_usb_thread_525
              
        l_h_usb_thread_526:
      pop eax
      
      cmp eax, -1
      jz near l_h_usb_thread_5
        // set timer
        mov ecx, 10 * 1193  //?
        mul ecx
        xchg ecx, eax
        mov edx, usb_thread
        shl edx, 16
        mov dx, WIN_NONE
        mov ebx, WP_NORMAL  // wp
        xor edi, edi
        call h_timer_add
        jmp l_h_usb_thread_5
      
    l_h_usb_thread_6:
    cmp ecx, WM_TIMER
    jnz l_h_usb_thread_7
      
      // WM_TIMER: wp = operation, lp = UsbController/UsbPipe/KeyboardDeviceData
      
      cmp dl, WP_NORMAL
      jnz l_h_usb_thread_61
        // normal
        jmp l_h_usb_thread_51
        
      l_h_usb_thread_61:
      cmp dl, WP_ABORT_PIPE
      jnz l_h_usb_thread_62
        // abort pipe
        push esi  // UsbPipe
        call h_usb_abort_pipe
        jmp l_h_usb_thread_5
        
      l_h_usb_thread_62:
      cmp dl, WP_KEYBOARD
      jnz l_h_usb_thread_63
        // keyboard repeat
        movzx ecx, byte ptr [es:esi + offset KeyboardDeviceData.repeatkey]
        btr ecx, 7
        push esi
          call h_hid_kbd_input_field_send_key
        pop esi
        mov ecx, hid_delay2
        mov edx, usb_thread
        shl edx, 16
        or dx, WIN_NONE
        mov ebx, WP_KEYBOARD
        mov edi, esi
        call h_timer_add
        jmp l_h_usb_thread_5

      l_h_usb_thread_63:
      jmp l_h_usb_thread_5
      
    l_h_usb_thread_7:
    jmp l_h_usb_thread_5
    
  // no message
  l_h_usb_thread_8:
  mov ah, 45 // get pid, tid; OUT: edi = tid
  int 20h
  or edi, 16384
  mov ah, 35 // stop thread
  int 20h
  jmp l_h_usb_thread_5

[align 32]
h_usb_irqs:
dd 0  // IRQ0
dd 0  // IRQ1
dd offset h_usb_irq2
dd offset h_usb_irq3
dd offset h_usb_irq4
dd 0  // IRQ5
dd 0  // IRQ6
dd offset h_usb_irq7
dd offset h_usb_irq8
dd offset h_usb_irq9
dd offset h_usb_irq10
dd offset h_usb_irq11
dd 0  // IRQ12
dd offset h_usb_irq13
dd offset h_usb_irq14
dd offset h_usb_irq15


// IN: al = IRQ, esi = controller RA | (0:uhci, 1:ohci, 2:ehci << 24)
h_usb_irqs_init:
movzx eax, al
mov ebx, eax
shl ebx, 2
mov ebx, [cs:ebx + offset h_usb_irqs]
test ebx, ebx
jz l_h_usb_irqs_init_9
  push eax
    
    add al, IRQ0INT
    shl eax, 3  // * 8 (sizeof IDT.record)
    mov word ptr [PA_IDT + eax], bx  // :KLUDGE: assert HIWORD(ebx) = 0
    
  pop ebx
  shl ebx, 2 + USB_MAX_CONTROLLERS_PER_IRQ_LOG2  // * 4 * 8
  mov edx, ebx
  add edx, 1 << (2 + USB_MAX_CONTROLLERS_PER_IRQ_LOG2)
  
  l_h_usb_irqs_init_5:
    mov eax, usb_controllers[ebx]
    test eax, eax
    jnz l_h_usb_irqs_init_6
      mov usb_controllers[ebx], esi
      jmp short l_h_usb_irqs_init_9
      
    l_h_usb_irqs_init_6:
    add ebx, 4
    cmp ebx, edx
    jb l_h_usb_irqs_init_5
    
l_h_usb_irqs_init_9:
ret


// IN: pushad, bl = IRQ
h_usb_irq_all:
 push ds
  push es
    mov dx, SELECTOR_KERNEL_DATA
    mov ds, dx	// ds = KERNEL_DATA
    mov ax, SELECTOR_ALL_DATA
    mov es, ax	// es = ALLMEM
    
    movzx ebx, bl
    shl ebx, 2 + USB_MAX_CONTROLLERS_PER_IRQ_LOG2  // * 4 * 8
    mov edx, ebx
    add edx, 1 << (2 + USB_MAX_CONTROLLERS_PER_IRQ_LOG2)
    
    l_h_usb_irq_all_5:
      mov esi, usb_controllers[ebx]
      test esi, esi
      jz l_h_usb_irq_all_6
        push ebx
         push edx
          // esi = controller RA | (0:uhci, 1:ohci, 2:ehci << 24)
          mov eax, esi
          and esi, 0x00FFFFFF
          add esi, VA_USB
          shr eax, 24
          
          cmp al, 2  // ehci
          jnz l_h_usb_irq_all_51
            call h_ehci_irq
            jmp short l_h_usb_irq_all_59
            
          l_h_usb_irq_all_51:
          cmp al, 1  // ohci
          jnz l_h_usb_irq_all_52
            call h_ohci_irq
            jmp short l_h_usb_irq_all_59
            
          l_h_usb_irq_all_52:
          cmp al, 0  // uhci
          jnz l_h_usb_irq_all_59
            call h_uhci_irq
            
          l_h_usb_irq_all_59:
         pop edx
        pop ebx
        
      l_h_usb_irq_all_6:
      add ebx, 4
      cmp ebx, edx
      jb l_h_usb_irq_all_5
      
  pop es
 pop ds
popad
iret


h_usb_irq2:
pushad
mov bl, 2
jmp h_usb_irq_all

h_usb_irq3:
pushad
mov bl, 3
jmp h_usb_irq_all

h_usb_irq4:
pushad
mov bl, 4
jmp h_usb_irq_all

h_usb_irq7:
pushad
mov bl, 7
jmp h_usb_irq_all

h_usb_irq8:
pushad
mov bl, 8
jmp h_usb_irq_all

h_usb_irq9:
pushad
mov bl, 9
jmp h_usb_irq_all

h_usb_irq10:
pushad
mov bl, 10
jmp h_usb_irq_all

h_usb_irq11:
pushad
mov bl, 11
jmp h_usb_irq_all

h_usb_irq13:
pushad
mov bl, 13
jmp h_usb_irq_all

h_usb_irq14:
pushad
mov bl, 14
jmp h_usb_irq_all

h_usb_irq15:
pushad
mov bl, 15
jmp h_usb_irq_all

DEVICE_DESCR_TYPE           = 1
CONFIG_DESCR_TYPE           = 2
STRING_DESCR_TYPE           = 3
INTERFACE_DESCR_TYPE        = 4
ENDPOINT_DESCR_TYPE         = 5
DEVICE_QUALIFIER_DESCR_TYPE = 6
 
HID_DESCR_TYPE      = 21h
REPORT_DESCR_TYPE   = 22h
PHYSICAL_DESCR_TYPE = 23h

// Generic Desktop usage page
USAGE_GD_POINTER     = 10001h
USAGE_GD_MOUSE       = 10002h
USAGE_GD_JOYSTICK    = 10004h
USAGE_GD_GAMEPAD     = 10005h
USAGE_GD_KEYBOARD    = 10006h
USAGE_GD_KEYPAD      = 10007h
 
USAGE_GD_X           = 10030h
USAGE_GD_Y           = 10031h
USAGE_GD_Z           = 10032h
USAGE_GD_RX          = 10033h
USAGE_GD_RY          = 10034h
USAGE_GD_RZ          = 10035h
USAGE_GD_SLIDER      = 10036h
USAGE_GD_DIAL        = 10037h
USAGE_GD_WHEEL       = 10038h
 
USAGE_GD_CONS_CTRL   = 0C0001h // Consumer control (media keys)
 
// Keyboard/Keypad usage page
USAGE_KBD_NOEVENT    = 70000h
USAGE_KBD_ROLLOVER   = 70001h
USAGE_KBD_POSTFAIL   = 70002h
USAGE_KBD_FIRST_KEY  = 70004h // this is 'A', actually
USAGE_KBD_LCTRL      = 700E0h
USAGE_KBD_LSHIFT     = 700E1h
USAGE_KBD_LALT       = 700E2h
USAGE_KBD_LWIN       = 700E3h
USAGE_KBD_RCTRL      = 700E4h
USAGE_KBD_RSHIFT     = 700E5h
USAGE_KBD_RALT       = 700E6h
USAGE_KBD_RWIN       = 700E7h
 
// LED usage page
USAGE_LED_NUMLOCK    = 80001h
USAGE_LED_CAPSLOCK   = 80002h
USAGE_LED_SCROLLLOCK = 80003h
 
// Button usage page
// First button is USAGE_BUTTON_PAGE+1, second - USAGE_BUTTON_PAGE+2 etc.
USAGE_BUTTON_PAGE    = 90000h
 
// Consumer control usage page
USAGE_CONSUMER       = 0C0000h
 
// Flags for input/output/feature fields
HID_FIELD_CONSTANT   = 1 // if not, then Data field
HID_FIELD_VARIABLE   = 2 // if not, then Array field
HID_FIELD_RELATIVE   = 4 // if not, then Absolute field
HID_FIELD_WRAP       = 8
HID_FIELD_NONLINEAR  = 10h
HID_FIELD_NOPREFERRED= 20h // no preferred state
HID_FIELD_HASNULL    = 40h // has null state
HID_FIELD_VOLATILE   = 80h // for output/feature fields
HID_FIELD_BUFBYTES   = 100h// buffered bytes
 
// Report descriptor can easily describe gigabytes of (meaningless) data.
// Keep report size reasonable to avoid excessive memory allocations and
// calculation overflows; 1 Kb is more than enough (typical size is 3-10 bytes).
MAX_REPORT_BYTES = 1024

struct ParseDescrLocals{
  uns4 cur_item_size  // encoded size of data for current item
  uns1 report_ok  // 0 on error, 1 if everything is ok
  uns1 field_type  // 0/1/2 for input/output/feature fields
  [dalign 32]
  uns4 field_data  // data for current item when it describes a field group
  uns4 last_reports[3]  // pointers to last input/output/feature records
  uns4 usage_minimum  // current value of Usage Minimum
  uns4 usage_list  // list head of usage_list_item
  uns4 usage_tail  // list tail of usage_list_item
  uns4 num_usage_ranges  // number of usage ranges, size of usage_list
  uns4 delimiter_depth  // normally 0// 1 inside of Delimiter();
                        // nested Delimiter()s are not allowed
  uns4 usage_variant  // 0 outside of Delimiter()s and for first Usage inside Delimiter(),
                      // incremented with each new Usage inside Delimiter()
  uns4 cur_collection  // current collection
  uns4 last_collection  // last top-level collection
}

// Local variables for parse_input.
struct ParseInputLocals{
  uns4 count_inside_group  // Number of fields left in the current field.
  uns4 field_offset  // Offset of the current field from report start, in bits.
  uns4 field_range_size  // Size of range with valid values, Logical Maximum - Logical Minimum + 1.
  uns4 cur_usage  // Pointer to current usage for Variable field groups.
  uns4 num_values // Number of values in the current instantiation of Array field group.
  uns4 values_base  // Pointer to memory allocated for array with current values.
  uns4 values_prev  // Pointer to memory allocated for array with previous values.
  uns4 values_cur_ptr  // Pointer to the next value in [values_base] array.
  uns4 values_end  // End of data in array with current values.
  uns4 values_prev_ptr  // Pointer to the next value in [values_prev_ptr] array.
  uns4 values_prev_end
}

struct ReportSet{
  uns4 data
  // If .numbered is zero, this is zero for the empty set and
  // a pointer to the (only) report structure otherwise.
  // If .numbered is nonzero, this is a pointer to 256-dword array of pointers
  // to reports organized by report ID.
  uns4 first_report
  // Pointer to the first report or 0 for the empty set.
  uns1 numbered
  // If zero, report IDs are not used, there can be at most one report in the set.
  // If nonzero, first byte of the report is report ID.
  [dalign 32]
}

struct HidData{
  ReportSet input
  ReportSet output
  ReportSet feature
  uns4 first_collection
}

struct UsbDeviceData{
  HidData hid
  uns4 epdescr              // endpoint descriptor
  uns4 hiddescr             // HID descriptor
  uns4 interface_number     // copy of interface_descr.bInterfaceNumber
  uns4 config_pipe          // config pipe handle
  uns4 intpipe              // interrupt pipe handle
  uns4 input_transfer_size  // input transfer size
  uns4 input_buffer         // buffer for input transfers
  uns1 control[8]           // control packet to device
}

// USB HID structures
struct HidDescr{
  uns1 bLength
  uns1 bDescriptorType
  uns2 bcdHID
  uns1 bCountryCode
  uns1 bNumDescriptors
  void base_sizeof
  // now two fields are repeated bNumDescriptors times:
  uns1 subDescriptorType
  uns2 subDescriptorLength
}

// USB structures
struct ConfigDescr{
  uns1 bLength
  uns1 bDescriptorType
  uns2 wTotalLength
  uns1 bNumInterfaces
  uns1 bConfigurationValue
  uns1 iConfiguration
  uns1 bmAttributes
  uns1 bMaxPower
}

struct InterfaceDescr{
  uns1 bLength
  uns1 bDescriptorType
  uns1 bInterfaceNumber
  uns1 bAlternateSetting
  uns1 bNumEndpoints
  uns1 bInterfaceClass
  uns1 bInterfaceSubClass
  uns1 bInterfaceProtocol
  uns1 iInterface
}

struct EndpointDescr{
  uns1 bLength
  uns1 bDescriptorType
  uns1 bEndpointAddress
  uns1 bmAttributes
  uns2 wMaxPacketSize
  uns1 bInterval
}

// * Report *

// Every meaningful report field group has one or more associated usages.
// Usages can be individual or joined into continuous ranges.
// This structure describes one range or one individual usage in a large array//
// individual usage is equivalent to a range of length 1.
struct UsageRange{
  uns4 offset
  // Sum of range sizes over all previous array items.
  // Size of range a equals
  // [a + sizeof.usage_range + usage_range.offset] - [a + usage_range.offset].
  // The total sum over all array items immediately follows the array,
  // this field must be the first so that the formula above works for the last item.
  uns4 first_usage
  // Usage code for first item in the range.
}

// This structure describes one group of report fields with identical properties.
struct ReportFieldGroup{
  uns4 next
  // All field groups in one report are organized in a single-linked list.
  // This is the next group in the report or 0 for the last group.
  uns4 size
  // Size in bits of one field. Cannot be zero or greater than 32.
  uns4 count  // field count, cannot be zero
  uns4 offset  // offset from report start, in bits
  // Following fields are decoded from report descriptor, see HID spec for details.
  uns4 flags
  uns4 logical_minimum
  uns4 logical_maximum
  uns4 physical_minimum
  uns4 physical_maximum
  uns4 unit_exponent
  uns4 unit
  // Following fields are used to speedup extract_field_value.
  uns4 mask
  // Bitmask for all data bits except sign bit:
  // (1 shl .size) - 1 for unsigned fields, (1 shl (.size-1)) - 1 for signed fields
  uns4 sign_mask
  // Zero for unsigned fields. Bitmask with sign bit set for signed fields.
  void common_sizeof
  // Variable and Array field groups differ significantly.
  // Variable field groups are simple. There are .count fields, each field has
  // predefined Usage, the content of a field is its value. Each field is
  // always present in the report. For Variable field groups, we just keep
  // additional .count dwords with usages for individual fields.
  // Array field groups are complicated. There are .count uniform fields.
  // The content of a field determines Usage// Usages which are currently presented
  // in the report have value = 1, other Usages have value = 0. The number of
  // possible Usages is limited only by field .size; 32-bit field could encode any
  // Usage, so it is unreasonable to keep all Usages in the plain array, as with
  // Variable fields. However, many unrelated Usages in one group are meaningless,
  // so usually possible values are grouped in sequential ranges; number of ranges
  // is limited by report descriptor size (max 0xFFFF bytes should contain all
  // information, including usage ranges and field descriptions).
  // Also, for Array variables we pass changes in state to drivers, not the state
  // itself, because sending information about all possible Usages is inpractical//
  // so we should remember the previous state in addition to the current state.
  // Thus, for Array variables keep the following information, in this order:
  // * some members listed below// note that they do NOT exist for Variable groups//
  // * array of usage ranges in form of usage_range structures, including
  //   an additional dword after array described in usage_range structure;
  // * allocated memory for current values of the report;
  // * values of the previous report.
  uns4 num_values_prev  // number of values in the previous report
  uns4 num_usage_ranges  // number of usage_range, always nonzero
  void usages
}

// This structure describes one report.
// All reports of one type are organized into a single-linked list.
struct Report{
  uns4 next  // pointer to next report of the same type, if any
  uns4 size  // total size in bits
  uns4 first_field  // pointer to first ReportFieldGroup for this report
  uns4 last_field
  // pointer to last ReportFieldGroup for this report, if any;
  // address of .first_field, if .first_field is 0
  uns4 id
  // Report ID, if assigned. Zero otherwise.
  uns4 top_level_collection  // top-level collection for this report
}

// This structure describes a range of reports of one type that belong to
// some collection.
struct CollectionReportSet{
  uns4 first_report
  uns4 first_field
  uns4 last_report
  uns4 last_field
}

// This structure defines driver callbacks which are used while
// device is active// i.e. all callbacks except add_device.
struct HidDriverActiveCallbacks{
  uns4 disconnect
  // Called when an existing HID device is disconnected.
  //
  // Four following functions are called when a new input packet arrives
  // in the following order: .begin_packet, then .input_field several times
  // for each input field, interleaved with .array_overflow? for array groups,
  // then .end_packet.
  uns4 begin_packet
  // edi -> driver data
  uns4 array_overflow
  // edi -> driver data
  // out: CF cleared <=> ignore this array
  uns4 input_field
  // edi -> driver data, ecx = usage, edx = value
  uns4 end_packet
  // edi -> driver data
}

// This structure describes one collection.
struct Collection{
  uns4 next  // pointer to the next collection in the same level, must be the first field
  uns4 parent  // pointer to nesting collection
  uns4 first_child  // pointer to the first nested collection
  uns4 last_child  // pointer to the last nested collection
                   // or to .first_child, if .first_child is zero
  uns4 type  // Application, Physical etc
  uns4 usage  // associated Usage code
  // Next fields are filled only for top-level collections.
  HidDriverActiveCallbacks callbacks
  uns4 driver_data  // value to be passed as is to driver callbacks
  CollectionReportSet input, output, feature
}

// This structure defines callbacks required from the driver.
struct HidDriverCallbacks{
  uns4 add_device
  HidDriverActiveCallbacks active
}

// Two following structures describe temporary data;
// the corresponding objects cease to exist when HID parser completes
// state of Global items
struct GlobalItems{
  uns4 next
  uns4 usage_page
  uns4 logical_minimum
  uns4 logical_maximum
  uns4 physical_minimum
  uns4 physical_maximum
  uns4 unit_exponent
  uns4 unit
  uns4 report_size
  uns4 report_id
  uns4 report_count
}

// one range of Usages
struct UsageListItem{
  uns4 next
  uns4 first_usage
  uns4 num_usages
}

[align 32]
h_hid_fn:
dd 12
dd offset h_hid_add_device
dd offset h_hid_disconnect

h_hid_init:
mov hid_delay1, 250 * 1193
mov hid_delay2, 50 * 1193
ret

// IN: edx = UsbInterfaceDescr, ecx = length rest
//     stack: pipe, config, interface
h_hid_add_device:
/*
4 config_pipe
8 config_descr
12 interface
*/
mov ecx, sizeof UsbDeviceData
call m_heap_alloc_kernel
xchg eax, ebx
test eax, eax
jz near l_h_hid_add_device_return0

// zero-initialize it
mov edi, eax
xchg eax, ebx
xor eax, eax
mov ecx, sizeof UsbDeviceData / 4
rep stosd
mov edx, [ss:esp + 12]  // interface
// HID devices use one IN interrupt endpoint for polling the device
// and an optional OUT interrupt endpoint. We do not use the later,
// but must locate the first. Look for the IN interrupt endpoint.
// Also, look for the HID descriptor; according to HID spec, it must be
// located before endpoint descriptors.
// 2. Get the upper bound of all descriptors' data.
mov eax, [ss:esp + 8]  // config_descr
movzx ecx, word ptr [es:eax + offset ConfigDescr.wTotalLength]
add eax, ecx
// 3. Loop over all descriptors until
// either end-of-data reached - this is fail
// or interface descriptor found - this is fail, all further data
//    correspond to that interface
// or endpoint descriptor for IN endpoint is found
// (HID descriptor must be located before the endpoint descriptor).
// 3a. Loop start: edx points to the interface descriptor.

l_h_hid_add_device_lookep:
  // 3b. Get next descriptor.
  movzx ecx, byte ptr [es:edx] // the first byte of all descriptors is length
  test ecx, ecx
  jz l_h_hid_add_device_cfgerror
  
  add edx, ecx
  // 3c. Check that at least two bytes are readable. The opposite is an error.
  inc edx
  cmp edx, eax
  jae l_h_hid_add_device_cfgerror
  
  dec edx
  // 3d. Check that this descriptor is not interface descriptor. The opposite is
  // an error.
  cmp byte ptr [es:edx + offset EndpointDescr.bDescriptorType], INTERFACE_DESCR_TYPE
  jz l_h_hid_add_device_cfgerror
  
  // 3e. For HID descriptor, proceed to 4.
  // For endpoint descriptor, go to 5.
  // For other descriptors, continue the loop.
  // Note: bDescriptorType is in the same place in all descriptors.
  cmp byte ptr [es:edx + offset EndpointDescr.bDescriptorType], ENDPOINT_DESCR_TYPE
  jz l_h_hid_add_device_foundep
  
  cmp byte ptr [es:edx + offset EndpointDescr.bDescriptorType], HID_DESCR_TYPE
  jnz l_h_hid_add_device_lookep
  
// 4a. Check that the descriptor contains all required data and all data are
// readable. The opposite is an error.
  movzx ecx, byte ptr [es:edx + offset HidDescr.bLength]
  cmp ecx, offset HidDescr.base_sizeof + 3
  jb l_h_hid_add_device_cfgerror
  
  add ecx, edx
  cmp ecx, eax
  ja l_h_hid_add_device_cfgerror
  
  // 4b. Store the pointer in usb_device_data structure for further references.
  mov [es:ebx + offset UsbDeviceData.hiddescr], edx
  // 4c. Continue the loop.
  jmp short l_h_hid_add_device_lookep
  
l_h_hid_add_device_foundep:
// 5a. Check that the descriptor contains all required data and all data are
// readable. The opposite is an error.
cmp byte ptr [es:edx + offset EndpointDescr.bLength], sizeof EndpointDescr
jb l_h_hid_add_device_cfgerror

lea ecx, [edx + sizeof EndpointDescr]
cmp ecx, eax
jbe l_h_hid_add_device_7
  
  // 6. An error occured during processing endpoint descriptor.
  l_h_hid_add_device_cfgerror:
  
  // 6b. Free memory allocated for device data.
  l_h_hid_add_device_free:
  call m_heap_free_kernel  // IN: ebx
  
  l_h_hid_add_device_return0:
  // 6c. Return an error.
  xor eax, eax
  
  l_h_hid_add_device_nothing:
  ret 12
  
  
l_h_hid_add_device_7:
// 5b. If this is not IN interrupt endpoint, ignore it and continue the loop.
test byte ptr [es:edx + offset EndpointDescr.bEndpointAddress], 80h
jz l_h_hid_add_device_lookep

mov cl, [es:edx + offset EndpointDescr.bmAttributes]
and cl, 3
cmp cl, INTERRUPT_PIPE
jnz l_h_hid_add_device_lookep

// 5c. Store the pointer in usb_device_data structure for futher references.
mov [es:ebx + offset UsbDeviceData.epdescr], edx
// 5d. Check that HID descriptor was found. If not, go to 6.
cmp dword ptr [es:ebx + offset UsbDeviceData.hiddescr], 0
jz l_h_hid_add_device_cfgerror

l_h_hid_add_device_descriptors_found:
// 6. Configuration descriptor seems to be ok.
// Send SET_IDLE command disabling auto-repeat feature (it is quite useless)
// and continue configuring in SET_IDLE callback.
lea edx, [ebx + offset UsbDeviceData.control]
mov eax, [ss:esp + 12]  // interface
mov dword ptr [es:edx], 21h + (0Ah << 8) + (0 << 16) + (0 << 24)
movzx eax, byte ptr [es:eax + offset InterfaceDescr.bInterfaceNumber]
mov [es:ebx + offset UsbDeviceData.interface_number], eax
mov [es:edx + 4], eax            // set interface number, zero length
mov eax, [ss:esp + 4]  // config_pipe
mov [es:ebx + offset UsbDeviceData.config_pipe], eax
xor ecx, ecx

push ecx
 push ebx
  push offset h_hid_idle_set
   push ecx
    push ecx
     push edx
      push eax
call h_usb_control_async

// 7. Return pointer to UsbDeviceData.
xchg eax, ebx
jmp l_h_hid_add_device_nothing

// IN: stack: device_data
h_hid_disconnect:
mov ebx, [ss:esp + 4]
call m_heap_free_kernel
ret 4

// This procedure is called by USB stack when SET_IDLE request initiated by
// h_hid_add_device is completed, either successfully or unsuccessfully.
h_hid_idle_set:
push ebx
 push esi  // save used registers to be stdcall
  /*
  0 esi, ebx
  8 return address
  12 pipe           dd      ?
  16 status         dd      ?
  20 buffer         dd      ?
  24 length         dd      ?
  28 calldata       dd      ?
  */
  
  // Ignore status. Support for SET_IDLE is optional, so the device is free to
  // STALL the request; config pipe should remain functional without explicit cleanup.
  mov ebx, [ss:esp + 28]  // calldata
  // 1. HID descriptor contains length of Report descriptor. Parse it.
  mov esi, [es:ebx + offset UsbDeviceData.hiddescr]
  movzx ecx, byte ptr [es:esi + offset HidDescr.bNumDescriptors]
  lea eax, [offset HidDescr.base_sizeof + ecx * 2 + ecx]
  cmp eax, 100h
  jae l_h_hid_idle_set_cfgerror
  
  cmp al, [es:esi + offset HidDescr.bLength]
  jb l_h_hid_idle_set_cfgerror
  
  l_h_hid_idle_set_look_report:
    dec ecx
    js l_h_hid_idle_set_cfgerror
    
    cmp byte ptr [es:esi + offset HidDescr.subDescriptorType], REPORT_DESCR_TYPE
    jz l_h_hid_idle_set_found_report
    
    add esi, 3
    jmp short l_h_hid_idle_set_look_report
    
  l_h_hid_idle_set_cfgerror:
  jmp short l_h_hid_idle_set_nothing
  
  l_h_hid_idle_set_found_report:
  // 2. Send request for the Report descriptor.
  // 2a. Allocate memory.
  movzx ecx, word ptr [es:esi + offset HidDescr.subDescriptorLength]
  test ecx, ecx
  jz l_h_hid_idle_set_cfgerror
  
  push ebx
   push ecx
    call m_heap_alloc_kernel
    xchg eax, ebx
   pop ecx
  pop ebx
  // If failed, stop initialization.
  test eax, eax
  jz l_h_hid_idle_set_nothing
  
  // 2b. Submit the request.
  xchg eax, esi
  lea edx, [ebx + offset UsbDeviceData.control]
  mov eax, [es:ebx + offset UsbDeviceData.interface_number]
  mov dword ptr [es:edx], 81h + (6 << 8) + (0 << 16) + (REPORT_DESCR_TYPE << 24)
  mov [es:edx + 4], ax  // Interface number
  mov [es:edx + 6], cx  // descriptor length
  
  push 0
   push ebx
    push offset h_hid_got_report
     push ecx
      push esi
       push edx
        push [es:ebx + offset UsbDeviceData.config_pipe]
  call h_usb_control_async
  
  // 2c. If failed, free the buffer and stop initialization.
  test eax, eax
  jnz l_h_hid_idle_set_nothing
    mov ebx, esi
    call m_heap_free_kernel
    
  l_h_hid_idle_set_nothing:
 pop esi
pop ebx         // restore used registers to be stdcall
ret 20

[align 32]
l_h_hid_fetch_jumps:
dd offset l_h_hid_fetch_none
dd offset l_h_hid_fetch_byte
dd offset l_h_hid_fetch_word
dd offset l_h_hid_fetch_dword

l_h_hid_type_jumps:
dd offset l_h_hid_parse_main
dd offset l_h_hid_parse_global
dd offset l_h_hid_parse_local
dd offset l_h_hid_parse_reserved

l_h_hid_main_jumps:
dd offset l_h_hid_input          // 80...83
dd offset l_h_hid_output         // 90...93
dd offset l_h_hid_collection     // A0...A3
dd offset l_h_hid_feature        // B0...B3
dd offset l_h_hid_end_collection // C0...C3
NUM_MAIN_ITEMS = 5

l_h_hid_global_jumps:
dd offset l_h_hid_usage_page       // 04...07
dd offset l_h_hid_logical_minimum  // 14...17
dd offset l_h_hid_logical_maximum  // 24...27
dd offset l_h_hid_physical_minimum // 34...37
dd offset l_h_hid_physical_maximum // 44...47
dd offset l_h_hid_unit_exponent    // 54...57
dd offset l_h_hid_unit             // 64...67
dd offset l_h_hid_report_size      // 74...77
dd offset l_h_hid_report_id        // 84...87
dd offset l_h_hid_report_count     // 94...97
dd offset l_h_hid_push             // A4...A7
dd offset l_h_hid_pop              // B4...B7
NUM_GLOBAL_ITEMS = 12

l_h_hid_local_jumps:
dd offset l_h_hid_usage         // 08...0B
dd offset l_h_hid_usage_minimum // 18...1B
dd offset l_h_hid_usage_maximum // 28...2B
dd offset l_h_hid_item_parsed   // 38...3B = designator item; ignore
dd offset l_h_hid_item_parsed   // 48...4B = designator minimum; ignore
dd offset l_h_hid_item_parsed   // 58...5B = designator maximum; ignore
dd offset l_h_hid_item_parsed   // 68...6B not assigned
dd offset l_h_hid_item_parsed   // 78...7B = string index; ignore
dd offset l_h_hid_item_parsed   // 88...8B = string minimum; ignore
dd offset l_h_hid_item_parsed   // 98...9B = string maximum; ignore
dd offset l_h_hid_delimiter     // A8...AB
NUM_LOCAL_ITEMS = 11

// This procedure is called by USB stack when the report descriptor queried
// by h_hid_idle_set is completed, either successfully or unsuccessfully.
// uses ebx esi edi
h_hid_got_report:
sub esp, sizeof ParseDescrLocals
/*
0 ParseDescrLocals
+0 return address
+4 pipe
+8 status
+12 buffer
+16 length
+20 calldata
*/

// 1. Check the status// if the request has failed, say something to the debug board
// and stop initialization.
cmp dword ptr [ss:esp + sizeof ParseDescrLocals + 8], 0  // status
jnz l_h_hid_generic_fail
  // 2. Subtract size of setup packet from the total length;
  // the rest is length of the descriptor, and it must be nonzero.
  sub dword ptr [ss:esp + sizeof ParseDescrLocals + 16], 8 // length
  ja l_h_hid_has_something
  
l_h_hid_generic_fail:
jmp l_h_hid_exit

l_h_hid_has_something:
// 3. Process descriptor.
// * parse_descr *
l_h_hid_parse_descr_label:
// 1. Initialize.
// 1a. Set some variables to initial values.
xor edi, edi
mov [ss:esp + offset ParseDescrLocals.report_ok], edi
mov [ss:esp + offset ParseDescrLocals.usage_list], edi
mov [ss:esp + offset ParseDescrLocals.cur_collection], edi
mov eax, [ss:esp + sizeof ParseDescrLocals + 20]  // calldata
add eax, [es:eax + offset HidData.input.first_report]
mov [ss:esp + offset ParseDescrLocals.last_reports + 0], eax
add eax, offset HidData.output.first_report - offset HidData.input.first_report
mov [ss:esp + offset ParseDescrLocals.last_reports + 4], eax
add eax, offset HidData.feature.first_report - offset HidData.output.first_report
mov [ss:esp + offset ParseDescrLocals.last_reports + 8], eax
add eax, offset HidData.first_collection - offset HidData.feature.first_report
mov [ss:esp + offset ParseDescrLocals.last_collection], eax
// 1b. Allocate state of global items.
push ebx
  mov ecx, sizeof GlobalItems
  call m_heap_alloc_kernel
  xchg eax, ebx
pop ebx
test eax, eax
jz near l_h_hid_memory_error

// 1c. Zero-initialize it and move pointer to edi.
push eax
  xchg eax, edi
  mov ecx, sizeof GlobalItems / 4
  cld
  rep stosd
pop edi
// 1d. Load pointer to data into esi and make [length] point to end of data.
mov esi, [ss:esp + sizeof ParseDescrLocals + 12]  // buffer
add [ss:esp + sizeof ParseDescrLocals + 16], esi  // length

// 2. Clear all local items.
// This is needed in the beginning and after processing any Main item.
l_h_hid_zero_local_items:
mov eax, [ss:esp + offset ParseDescrLocals.usage_list]
push ebx
  
  l_h_hid_11:
    test eax, eax
    jz l_h_hid_12
      push [es:eax + offset UsageListItem.next]
        mov ebx, eax
        call m_heap_free_kernel
      pop eax
      jmp short l_h_hid_11
    
  l_h_hid_12:
pop ebx
lea ecx, [esp + offset ParseDescrLocals.usage_list]
mov [ss:esp + offset ParseDescrLocals.usage_tail], ecx
mov [ecx], eax
mov [ss:esp + offset ParseDescrLocals.delimiter_depth], eax
mov [ss:esp + offset ParseDescrLocals.usage_variant], eax
mov [ss:esp + offset ParseDescrLocals.usage_minimum], eax
mov [ss:esp + offset ParseDescrLocals.num_usage_ranges], eax
// 3. Parse items until end of data found.
cmp esi, [ss:esp + sizeof ParseDescrLocals + 16]  // length
jae near l_h_hid_parse_end

l_h_hid_fetch_next_item:
// --------------------------------- Parse item --------------------------------
// 4. Parse one item.
// 4a. Get item data. eax = first item byte = code+type+size (4+2+2 bits),
// ebx = item data interpreted as unsigned,
// ecx = item data interpreted as signed.
movzx eax, byte ptr [es:esi]
mov ecx, eax
and ecx, 3
mov [ss:esp + offset ParseDescrLocals.cur_item_size], ecx
jmp dword ptr [cs:offset l_h_hid_fetch_jumps + ecx * 4]

l_h_hid_invalid_report:
jmp l_h_hid_end

l_h_hid_fetch_none:
xor ebx, ebx
xor ecx, ecx
inc esi
jmp short l_h_hid_fetched

l_h_hid_fetch_byte:
add esi, 2
cmp esi, [ss:esp + sizeof ParseDescrLocals + 16]  // length
ja l_h_hid_invalid_report

movzx ebx, byte ptr [es:esi - 1]
movsx ecx, bl
jmp short l_h_hid_fetched

l_h_hid_fetch_word:
add esi, 3
cmp esi, [ss:esp + sizeof ParseDescrLocals + 16]  // length
ja l_h_hid_invalid_report

movzx ebx, word ptr [es:esi - 2]
movsx ecx, bx
jmp short l_h_hid_fetched

l_h_hid_fetch_dword:
add esi, 5
cmp esi, [ss:esp + sizeof ParseDescrLocals + 16]  // length
ja l_h_hid_invalid_report

mov ebx, dword ptr [es:esi - 4]
mov ecx, ebx

l_h_hid_fetched:
// 4b. Select the branch according to item type.
// For every type, select the concrete handler and go there.
mov edx, eax
shr edx, 2
and edx, 3
shr eax, 4
jmp dword ptr [cs:offset l_h_hid_type_jumps + edx * 4]

// -------------------------------- Main items ---------------------------------
l_h_hid_parse_main:
sub eax, 8
cmp eax, NUM_MAIN_ITEMS
jae near l_h_hid_item_parsed
jmp dword ptr [cs:offset l_h_hid_main_jumps + eax * 4]
// There are 5 Main items.
// Input/Output/Feature items create new field groups in the corresponding report//
// Collection item opens a new collection (possibly nested),
// End Collection item closes the most nested collection.

l_h_hid_output:
mov byte ptr [ss:esp + offset ParseDescrLocals.field_type], 1
jmp l_h_hid_new_field

l_h_hid_feature:
mov byte ptr [ss:esp + offset ParseDescrLocals.field_type], 2
jmp l_h_hid_new_field

l_h_hid_input:
mov byte ptr [ss:esp + offset ParseDescrLocals.field_type], 0

l_h_hid_new_field:
// Create a new field group.
mov [ss:esp + offset ParseDescrLocals.field_data], ebx
movzx ebx, byte ptr [ss:esp + offset ParseDescrLocals.field_type]
lea ebx, [ebx * 2 + ebx]
shl ebx, 2
add ebx, [ss:esp + sizeof ParseDescrLocals + 20]  // calldata
// 5. Sanity checks: field size and fields count must be nonzero,
// field size cannot be more than 32 bits,
// if field count is more than MAX_REPORT_SIZE * 8, the report would be more than
// MAX_REPORT_SIZE bytes, so it is invalid too.
// More precise check for size occurs later; this check only guarantees that
// there will be no overflows during subsequent calculations.
cmp dword ptr [es:edi + offset GlobalItems.report_size], 0
jz near l_h_hid_invalid_report
cmp dword ptr [es:edi + offset GlobalItems.report_size], 32
ja near l_h_hid_invalid_report
// There are devices with Report Count(0) + Input(Constant Variable),
// zero-length padding. Thus, do not consider descriptors with Report Count(0)
// as invalid// instead, just ignore fields with Report Count(0).
cmp dword ptr [es:edi + offset GlobalItems.report_count], 0
jz near l_h_hid_zero_local_items
cmp dword ptr [es:edi + offset GlobalItems.report_count], MAX_REPORT_BYTES * 8
ja near l_h_hid_invalid_report
// 6. Get the pointer to the place for the corresponding report in ebx.
// 6a. If report ID is not assigned, ebx already points to report_set.data,
// so go to 7.
cmp dword ptr [es:edi + offset GlobalItems.report_id], 0
jz l_h_hid_report_ptr_found
// 6b. If table for reports was already allocated,
// go to 6d skipping the next substep.
cmp byte ptr [es:ebx + offset ReportSet.numbered], 0
jnz l_h_hid_report_set_allocated
// 6c. This is the first report with ID;
// allocate and zero-initialize table for reports.
// Note: it is incorrect but theoretically possible that some fields were
// already allocated in report without ID; if so, abort processing with error.
cmp dword ptr [es:ebx + offset ReportSet.data], 0
jnz near l_h_hid_invalid_report
push ebx
  mov ecx, 256 * 4
  call m_heap_alloc_kernel
  xchg eax, ebx
pop ebx
test eax, eax
jz near l_h_hid_memory_error

mov [es:ebx + offset ReportSet.data], eax
inc byte ptr [es:ebx + offset ReportSet.numbered]
push edi
  mov edi, eax
  mov ecx, 256
  xor eax, eax
  cld
  rep stosd
pop edi
// 6d. Report ID is assigned, report table is allocated,
// get the pointer to the corresponding item in the report table.

l_h_hid_report_set_allocated:
mov ebx, [es:ebx + offset ReportSet.data]
mov ecx, [es:edi + offset GlobalItems.report_id]
lea ebx, [ebx + ecx * 4]
// 7. If the field group is the first one in the report,
// allocate and initialize report without fields.

l_h_hid_report_ptr_found:
// 7a. Check whether the report has been allocated.
cmp dword ptr [es:ebx], 0
jnz l_h_hid_report_allocated
// 7b. Allocate.
push ebx
  mov ecx, sizeof Report
  call m_heap_alloc_kernel
  xchg eax, ebx
pop ebx
test eax, eax
jz near l_h_hid_memory_error
// 7c. Initialize.
xor edx, edx
lea ecx, [eax + offset Report.first_field]
mov [es:ebx], eax
mov [es:eax + offset Report.next], edx
mov [es:eax + offset Report.size], edx
mov [es:ecx], edx
mov [es:eax + offset Report.last_field], ecx
mov [es:eax + offset Report.top_level_collection], edx
mov ecx, [es:edi + offset GlobalItems.report_id]
mov [es:eax + offset Report.id], ecx
// 7d. Append to the overall list of reports.
movzx edx, byte ptr [ss:esp + offset ParseDescrLocals.field_type]
lea edx, [offset ParseDescrLocals.last_reports + edx * 4]
mov ecx, [es:edx]
mov [es:edx], eax
mov [es:ecx], eax

l_h_hid_report_allocated:
mov ebx, [es:ebx]
// ebx points to an already existing report; add new field.
// 8. Calculate total size of the group and
// check that the new group would not overflow the report.
mov eax, [es:edi + offset GlobalItems.report_size]
mul dword ptr [es:edi + offset GlobalItems.report_count]
mov ecx, [es:ebx + offset Report.size]
add ecx, eax
cmp ecx, MAX_REPORT_BYTES * 8
ja near l_h_hid_invalid_report
// 9. If there are no usages for this group, this is padding;
// add its size to total report size and stop processing.
cmp dword ptr [ss:esp + offset ParseDescrLocals.num_usage_ranges], 0
jz near l_h_hid_padding
// 10. Allocate memory for the group: this includes field group structure
// and additional fields depending on field type.
// See comments in ReportFieldGroup structure.
push eax
  mov edx, [es:edi + offset GlobalItems.report_count]
  lea eax, [offset ReportFieldGroup.common_sizeof + edx * 4]
  test byte ptr [ss:esp + 4 + offset ParseDescrLocals.field_data], HID_FIELD_VARIABLE
  jnz l_h_hid_21
    lea eax, [eax + edx * 4]
    mov edx, [ss:esp + 4 + offset ParseDescrLocals.num_usage_ranges]
    lea eax, [eax + edx * 8 + 4]  // 8 = sizeof UsageRange
    
  l_h_hid_21:
  push ebx
    xchg eax, ecx
    call m_heap_alloc_kernel
    xchg eax, ebx
  pop ebx
pop edx
test eax, eax
jz near l_h_hid_memory_error
// 11. Update report data.
// Field offset is the current report size//
// get the current report size and update report size.
// Also store the pointer to new field in the previous last field
// and update the last field.
mov ecx, [es:ebx + offset Report.last_field]
xadd [es:ebx + offset Report.size], edx
mov [es:ebx + offset Report.last_field], eax
mov [es:ecx], eax
// 12. Initialize field data: offset was calculated in the previous step,
// copy other characteristics from global_items data,
// calculate .mask and .sign_mask.
mov [es:eax + offset ReportFieldGroup.offset], edx
xor edx, edx
mov [es:eax + offset ReportFieldGroup.next], edx
mov [es:eax + offset ReportFieldGroup.sign_mask], edx
inc edx
mov ecx, [es:edi + offset GlobalItems.report_size]
mov [es:eax + offset ReportFieldGroup.size], ecx
shl edx, cl
cmp dword ptr [es:edi + offset GlobalItems.logical_minimum], 0
jge l_h_hid_unsigned
  shr edx, 1
  mov [es:eax + offset ReportFieldGroup.sign_mask], edx
  
l_h_hid_unsigned:
dec edx
mov [es:eax + offset ReportFieldGroup.mask], edx
mov ecx, [es:edi + offset GlobalItems.report_count]
mov [es:eax + offset ReportFieldGroup.count], ecx
mov ecx, [ss:esp + offset ParseDescrLocals.field_data]
mov [es:eax + offset ReportFieldGroup.flags], ecx

mov ecx, [es:edi + offset GlobalItems.logical_minimum]
mov [es:eax + offset ReportFieldGroup.logical_minimum], ecx
mov ecx, [es:edi + offset GlobalItems.logical_maximum]
mov [es:eax + offset ReportFieldGroup.logical_maximum], ecx
mov ecx, [es:edi + offset GlobalItems.physical_minimum]
mov [es:eax + offset ReportFieldGroup.physical_minimum], ecx
mov ecx, [es:edi + offset GlobalItems.physical_maximum]
mov [es:eax + offset ReportFieldGroup.physical_maximum], ecx
mov ecx, [es:edi + offset GlobalItems.unit_exponent]
mov [es:eax + offset ReportFieldGroup.unit_exponent], ecx
mov ecx, [es:edi + offset GlobalItems.unit]
mov [es:eax + offset ReportFieldGroup.unit], ecx
// 13. Update the current collection; nesting collections will be updated by
// end-of-collection handler.
movzx edx, byte ptr [ss:esp + offset ParseDescrLocals.field_type]
shl edx, 4   // assert sizeof CollectionReportSet == 16
mov ecx, [ss:esp + offset ParseDescrLocals.cur_collection]
test ecx, ecx
jz l_h_hid_no_collection
  lea ecx, [ecx + offset Collection.input + edx]
  mov [es:ecx + offset CollectionReportSet.last_report], ebx
  mov [es:ecx + offset CollectionReportSet.last_field], eax
  cmp dword ptr [es:ecx + offset CollectionReportSet.first_field], 0
  jnz l_h_hid_no_collection
    mov [es:ecx + offset CollectionReportSet.first_report], ebx
    mov [es:ecx + offset CollectionReportSet.first_field], eax
    
l_h_hid_no_collection:
// 14. Transform usage ranges. The target format depends on field type.
test byte ptr [es:eax + offset ReportFieldGroup.flags], HID_FIELD_VARIABLE
jz l_h_hid_transform_usages_for_array
  // For Variable field groups, expand all ranges to array with .count Usages.
  // If total number of Usages in all ranges is too large, ignore excessive.
  // If total number of Usages in all ranges is too small, duplicate the last
  // Usage up to .count Usages (e.g. group of several indicators can have one usage
  // "Generic Indicator" assigned to all fields).
  mov ecx, [es:eax + offset ReportFieldGroup.count]
  mov ebx, [ss:esp + offset ParseDescrLocals.usage_list]
  
  l_h_hid_next_usage_range_for_variable:
    mov edx, [es:ebx + offset UsageListItem.first_usage]
    push [es:ebx + offset UsageListItem.num_usages]
    
    l_h_hid_next_usage_for_variable:
    mov [es:eax + offset ReportFieldGroup.common_sizeof], edx
    dec ecx
    jz l_h_hid_22
      add eax, 4
      inc edx
      dec dword ptr [ss:esp]
      jnz l_h_hid_next_usage_for_variable
      
      dec edx
      inc dword ptr [ss:esp]
      cmp dword ptr [es:ebx + offset UsageListItem.next], 0
      jz l_h_hid_next_usage_for_variable
      
      pop edx
      mov ebx, [es:ebx + offset UsageListItem.next]
      jmp short l_h_hid_next_usage_range_for_variable
      
  l_h_hid_22:
  pop ebx
  jmp l_h_hid_zero_local_items
  
l_h_hid_transform_usages_for_array:
// For Array field groups, leave ranges unexpanded, but recode in the form
// more convenient to value lookup, see comments in ReportFieldGroup structure.
mov ecx, [ss:esp + offset ParseDescrLocals.num_usage_ranges]
mov [es:eax + offset ReportFieldGroup.num_usage_ranges], ecx
and dword ptr [es:eax + offset ReportFieldGroup.num_values_prev], 0
mov ecx, [ss:esp + offset ParseDescrLocals.usage_list]
xor ebx, ebx

l_h_hid_24:
  mov edx, [es:ecx + offset UsageListItem.first_usage]
  mov [es:eax + offset ReportFieldGroup.usages + offset UsageRange.offset], ebx
  add ebx, [es:ecx + offset UsageListItem.num_usages]
  jc near l_h_hid_invalid_report
  
  mov [es:eax + offset ReportFieldGroup.usages + offset UsageRange.first_usage], edx
  add eax, sizeof UsageRange
  mov ecx, [es:ecx + offset UsageListItem.next]
  test ecx, ecx
  jnz l_h_hid_24
  
mov [es:eax + offset ReportFieldGroup.usages], ebx
// New field is initialized.
jmp l_h_hid_zero_local_items

l_h_hid_padding:
mov [es:ebx + offset Report.size], ecx
jmp l_h_hid_zero_local_items

// Create a new collection, nested in the current one.
l_h_hid_collection:
// Actions are quite straightforward:
// allocate, zero-initialize, update parent, if there is one,
// make it current.
push ebx
  mov ecx, sizeof Collection
  call m_heap_alloc_kernel
  xchg eax, ebx
pop ebx
test eax, eax
jz near l_h_hid_memory_error
push eax
 push edi
  mov ecx, sizeof Collection / 4
  xchg edi, eax
  xor eax, eax
  cld
  rep stosd
 pop edi
pop eax
mov edx, [ss:esp + offset ParseDescrLocals.cur_collection]
mov [es:eax + offset Collection.parent], edx
lea ecx, [esp + offset ParseDescrLocals.last_collection]
test edx, edx
jz l_h_hid_no_parent
  lea ecx, [edx + offset Collection.last_child]
  
l_h_hid_no_parent:
mov edx, [es:ecx]  // assert ss == es
mov [es:ecx], eax
mov [es:edx], eax
lea ecx, [eax + offset Collection.first_child]
// In theory, there must be at least one usage.
// In practice, some nested collections don't have any. Use zero in this case.
mov edx, [ss:esp + offset ParseDescrLocals.usage_list]
test edx, edx
jz l_h_hid_26
  mov edx, [es:edx + offset UsageListItem.first_usage]
  
l_h_hid_26:
mov [es:eax + offset Collection.last_child], ecx
mov [es:eax + offset Collection.type], ebx
mov [es:eax + offset Collection.usage], edx
mov [ss:esp + offset ParseDescrLocals.cur_collection], eax
jmp l_h_hid_zero_local_items

// Close the current collection.
l_h_hid_end_collection:
// There must be an opened collection.
mov eax, [ss:esp + offset ParseDescrLocals.cur_collection]
test eax, eax
jz near l_h_hid_invalid_report

// Make parent collection the current one.
mov edx, [es:eax + offset Collection.parent]
mov [ss:esp + offset ParseDescrLocals.cur_collection], edx
// Add field range of the closing collection to field range for nesting collection,
// if there is one.
test edx, edx
jz near l_h_hid_zero_local_items

push 3  // for each type: input, output, feature
  
  l_h_hid_update_ranges:
  mov ecx, [es:eax + offset Collection.input.last_report]
  test ecx, ecx
  jz l_h_hid_no_fields
    mov [es:edx + offset Collection.input.last_report], ecx
    mov ecx, [es:eax + offset Collection.input.last_field]
    mov [es:edx + offset Collection.input.last_field], ecx
    cmp dword ptr [es:edx + offset Collection.input.first_report], 0
    jnz l_h_hid_no_fields
      mov ecx, [es:eax + offset Collection.input.first_report]
      mov [es:edx + offset Collection.input.first_report], ecx
      mov ecx, [es:eax + offset Collection.input.first_field]
      mov [es:edx + offset Collection.input.first_field], ecx
      
  l_h_hid_no_fields:
  add eax, sizeof CollectionReportSet
  add edx, sizeof CollectionReportSet
  dec dword ptr [ss:esp]
  jnz l_h_hid_update_ranges
  
pop eax
jmp l_h_hid_zero_local_items

// ------------------------------- Global items --------------------------------
l_h_hid_parse_global:
cmp eax, NUM_GLOBAL_ITEMS
jae near l_h_hid_item_parsed

jmp [cs:offset l_h_hid_global_jumps + eax * 4]
// For most global items, just store the value in the current global_items structure.
// Note 1: Usage Page will be used for upper word of Usage[| Minimum|Maximum], so
// shift it in advance.
// Note 2: the HID specification allows both signed and unsigned values for
// logical and physical minimum/maximum, but does not give a method to distinguish.
// Thus, hope that minimum comes first, parse the minimum as signed value always,
// if it is less than zero, assume signed values, otherwise assume unsigned values.
// This covers both common cases Minimum(0)/Maximum(FF) and Minimum(-7F)/Maximum(7F).
// Note 3: zero value for Report ID is forbidden by the HID specification.
// It is quite convenient, we use report_id == 0 for reports without ID.

l_h_hid_usage_page:
shl ebx, 16
mov [es:edi + offset GlobalItems.usage_page], ebx
jmp l_h_hid_item_parsed

l_h_hid_logical_minimum:
mov [es:edi + offset GlobalItems.logical_minimum], ecx
jmp l_h_hid_item_parsed

l_h_hid_logical_maximum:
cmp dword ptr [es:edi + offset GlobalItems.logical_minimum], 0
jge l_h_hid_31
  mov ebx, ecx
  
l_h_hid_31:
mov [es:edi + offset GlobalItems.logical_maximum], ebx
jmp l_h_hid_item_parsed

l_h_hid_physical_minimum:
mov [es:edi + offset GlobalItems.physical_minimum], ecx
jmp l_h_hid_item_parsed

l_h_hid_physical_maximum:
cmp dword ptr [es:edi + offset GlobalItems.physical_maximum], 0
jge l_h_hid_32
  mov ebx, ecx
  
l_h_hid_32:
mov [es:edi + offset GlobalItems.physical_maximum], ebx
jmp l_h_hid_item_parsed

l_h_hid_unit_exponent:
mov [es:edi + offset GlobalItems.unit_exponent], ecx
jmp l_h_hid_item_parsed

l_h_hid_unit:
mov [es:edi + offset GlobalItems.unit], ebx
jmp l_h_hid_item_parsed

l_h_hid_report_size:
mov [es:edi + offset GlobalItems.report_size], ebx
jmp l_h_hid_item_parsed

l_h_hid_report_id:
test ebx, ebx
jz near l_h_hid_invalid_report

cmp ebx, 0x100
jae near l_h_hid_invalid_report

mov [es:edi + offset GlobalItems.report_id], ebx
jmp l_h_hid_item_parsed

l_h_hid_report_count:
mov [es:edi + offset GlobalItems.report_count], ebx
jmp l_h_hid_item_parsed

// Two special global items: Push/Pop.
l_h_hid_push:
// For Push, allocate a new GlobalItems structure,
// initialize from the current one and make it current.
push ebx
  mov ecx, sizeof GlobalItems
  call m_heap_alloc_kernel
  xchg eax, ebx
pop ebx
test eax, eax
jz near l_h_hid_memory_error
push esi
 push eax
  mov ecx, sizeof GlobalItems / 4
  mov esi, edi
  xchg eax, edi
  push ds
    push es
    pop ds
    cld
    rep movsd
  pop ds
 pop edi
pop esi
mov [es:edi + offset GlobalItems.next], eax
jmp l_h_hid_item_parsed

l_h_hid_pop:
// For Pop, restore the last GlobalItems structure and free the current one.
mov eax, [es:edi + offset GlobalItems.next]
test eax, eax
jz near l_h_hid_invalid_report
push ebx
 push eax
  mov ebx, edi
  call m_heap_free_kernel
 pop edi
pop ebx
jmp l_h_hid_item_parsed

// -------------------------------- Local items --------------------------------
l_h_hid_parse_local:
cmp eax, NUM_LOCAL_ITEMS
jae near l_h_hid_item_parsed

jmp [cs:offset l_h_hid_local_jumps + eax * 4]

l_h_hid_usage:
// Usage tag.
// If length is 0, 1, 2 bytes, append the global item Usage Page.
cmp dword ptr [ss:esp + offset ParseDescrLocals.cur_item_size], 2
ja l_h_hid_41
  or ebx, [es:edi + offset GlobalItems.usage_page]
  
l_h_hid_41:
// If inside Delimiter(), ignore everything except the first tag.
cmp dword ptr [ss:esp + offset ParseDescrLocals.delimiter_depth], 0
jz l_h_hid_usage_write
  inc dword ptr [ss:esp + offset ParseDescrLocals.usage_variant]
  cmp dword ptr [ss:esp + offset ParseDescrLocals.usage_variant], 1
  jnz near l_h_hid_item_parsed
  
l_h_hid_usage_write:
// Add new range with start = item data and length = 1.
mov [ss:esp + offset ParseDescrLocals.usage_minimum], ebx
push 1
  
  l_h_hid_new_usage:
  push ebx
    mov ecx, sizeof UsageListItem
    call m_heap_alloc_kernel
    xchg eax, ebx
  pop ebx
  
pop edx
test eax, eax
jz near l_h_hid_memory_error
inc [ss:esp + offset ParseDescrLocals.num_usage_ranges]
mov ecx, [ss:esp + offset ParseDescrLocals.usage_minimum]
and dword ptr [es:eax + offset UsageListItem.next], 0
mov [es:eax + offset UsageListItem.first_usage], ecx
mov [es:eax + offset UsageListItem.num_usages], edx
mov ecx, [ss:esp + offset ParseDescrLocals.usage_tail]
mov [ss:esp + offset ParseDescrLocals.usage_tail], eax
mov [es:ecx], eax
jmp l_h_hid_item_parsed

l_h_hid_usage_minimum:
// Usage Minimum tag. Just store in the local var.
// If length is 0, 1, 2 bytes, append the global item Usage Page.
cmp dword ptr [ss:esp + offset ParseDescrLocals.cur_item_size], 2
ja l_h_hid_42
  or ebx, [es:edi + offset GlobalItems.usage_page]
  
l_h_hid_42:
mov [ss:esp + offset ParseDescrLocals.usage_minimum], ebx
jmp l_h_hid_item_parsed

l_h_hid_usage_maximum:
// Usage Maximum tag.
// If length is 0, 1, 2 bytes, append the global item Usage Page.
cmp dword ptr [ss:esp + offset ParseDescrLocals.cur_item_size], 2
ja l_h_hid_43
  or ebx, [es:edi + offset GlobalItems.usage_page]
  
l_h_hid_43:
// Meaningless inside Delimiter().
cmp dword ptr [ss:esp + offset ParseDescrLocals.delimiter_depth], 0
jnz near l_h_hid_invalid_report

// Add new range with start = saved Usage Minimum and
// length = Usage Maximum - Usage Minimum + 1.
sub ebx, [ss:esp + offset ParseDescrLocals.usage_minimum]
inc ebx
push ebx
  jmp l_h_hid_new_usage

l_h_hid_delimiter:
// Delimiter tag.
test ebx, ebx
jz l_h_hid_delimiter_close
  
  // Delimiter(Opened).
  // Store that we are inside Delimiter(),
  // say a warning that only preferred Usage will be used.
  cmp dword ptr [ss:esp + offset ParseDescrLocals.delimiter_depth], 0
  jnz near l_h_hid_invalid_report
  
  inc dword ptr [ss:esp + offset ParseDescrLocals.delimiter_depth]
  jmp l_h_hid_item_parsed
  
l_h_hid_delimiter_close:
// Delimiter(Closed).
// Store that we are not inside Delimiter() anymore.
dec dword ptr [ss:esp + offset ParseDescrLocals.delimiter_depth]
js near l_h_hid_invalid_report

and dword ptr [ss:esp + offset ParseDescrLocals.usage_variant], 0
jmp l_h_hid_item_parsed

l_h_hid_parse_reserved:
// Ignore reserved items, except that tag 0xFE means long item
// with first data byte = length of additional data,
// second data byte = long item tag. No long items are defined yet,
// so just skip them.
cmp eax, 0xF
jnz l_h_hid_item_parsed
  cmp dword ptr [ss:esp + offset ParseDescrLocals.cur_item_size], 2
  jnz l_h_hid_item_parsed
    movzx ecx, bl
    add esi, ecx
    cmp esi, [ss:esp + sizeof ParseDescrLocals + 16]  // length
    ja near l_h_hid_invalid_report
    
l_h_hid_item_parsed:
cmp esi, [ss:esp + sizeof ParseDescrLocals + 16]  // length
jb near l_h_hid_fetch_next_item

l_h_hid_parse_end:

//-------------------------------- End of parsing ------------------------------
// If there are opened collections, it is invalid report.
cmp dword ptr [ss:esp + offset ParseDescrLocals.cur_collection], 0
jnz near l_h_hid_invalid_report

// There must be at least one input field.
mov eax, [ss:esp + sizeof ParseDescrLocals + 20] // calldata
add eax, offset HidData.input.first_report
cmp [ss:esp + offset ParseDescrLocals.last_reports], eax
jz near l_h_hid_invalid_report
// Everything is ok.
inc byte ptr [ss:esp + offset ParseDescrLocals.report_ok]
//jmp l_h_hid_end
  
  l_h_hid_memory_error:
  l_h_hid_end_str:
  
l_h_hid_end:
// Free all global_items structures.
test edi, edi
jz l_h_hid_91
  push [es:edi + offset GlobalItems.next]
    mov ebx, edi
    call m_heap_free_kernel
  pop edi
  jmp l_h_hid_end
  
l_h_hid_91:
// Free the last Usage list, if any.
mov eax, [ss:esp + offset ParseDescrLocals.usage_list]

l_h_hid_92:
  test eax, eax
  jz l_h_hid_93
    push [es:eax + offset UsageListItem.next]
      mov ebx, eax
      call m_heap_free_kernel
    pop eax
    jmp short l_h_hid_92
    
l_h_hid_93:
// * end parse_descr *

cmp byte ptr [ss:esp + offset ParseDescrLocals.report_ok], 0
jz near l_h_hid_exit
mov ebx, [ss:esp + sizeof ParseDescrLocals + 20]  // calldata

// Assign drivers to top-level HID collections.
// IN: ebx = pointer to HidData, local variable
// [has_driver], it will be initialized with 0 if no driver is present.
postprocess_descr:
// Assign drivers to top-level collections.
// Use mouse driver for Usage(GenericDesktop:Mouse),
// use keyboard driver for Usage(GenericDesktop:Keyboard)
// and Usage(GenericDesktop:Keypad)
// 1. Prepare for the loop: get the pointer to the first collection,
// store that no drivers were assigned yet.
mov edi, [es:ebx + offset HidData.first_collection]

l_h_hid_next_collection:
// 2. Test whether there is a collection to test; if no, break from the loop.
test edi, edi
jz near l_h_hid_postprocess_done
// 3. Get pointer to driver callbacks depending on [collection.usage].
// If [collection.usage] is unknown, use default driver if HID_DUMP_UNCLAIMED
// and do not assign a driver otherwise.
mov esi, offset mouse_driver
cmp dword ptr [es:edi + offset Collection.usage], USAGE_GD_POINTER
jz l_h_hid_has_driver
  cmp dword ptr [es:edi + offset Collection.usage], USAGE_GD_MOUSE
  jz l_h_hid_has_driver
    mov esi, offset keyboard_driver
    cmp dword ptr [es:edi + offset Collection.usage], USAGE_GD_KEYBOARD
    jz l_h_hid_has_driver
      cmp dword ptr [es:edi + offset Collection.usage], USAGE_GD_KEYPAD
      jz l_h_hid_has_driver
        //mov esi, multimedia_driver
        //cmp dword ptr [es:edi + offset Collection.usage], USAGE_GD_CONS_CTRL
        //jz l_h_hid_has_driver
          xor esi, esi
// 4. If no driver is assigned (possible only if not HID_DUMP_UNCLAIMED),
// go to 7 with driver data = 0;
// other code uses this as a sign that driver callbacks should not be called.
l_h_hid_has_driver:
xor eax, eax
// 5. Notify the driver about a new device.
push edi
  call [cs:esi + offset HidDriverCallbacks.add_device]
pop edi
// 6. If the driver has returned non-zero driver data,
// store that is an assigned driver.
// Otherwise, if HID_DUMP_UNCLAIMED, try to assign the default driver.
test eax, eax
jnz l_h_hid_set_driver
  xor esi, esi
  
l_h_hid_set_driver:
// 7. Store driver data. If a driver is assigned, copy driver callbacks.
mov [es:edi + offset Collection.driver_data], eax
test esi, esi
jz l_h_hid_71
  push edi
    push ds
      push cs
      pop ds
      lodsd  // skip HidDriverCallbacks.add_device
      add edi, offset Collection.callbacks
      mov ecx, sizeof HidDriverActiveCallbacks / 4
      cld
      rep movsd
    pop ds
  pop edi
  
l_h_hid_71:
// 8. Store pointer to the collection in all input reports belonging to it.
// Note that the HID spec requires that reports should not cross top-level collections.
mov eax, [es:edi + offset Collection.input.first_report]
test eax, eax
jz l_h_hid_reports_processed
  
  l_h_hid_next_report:
    mov [es:eax + offset Report.top_level_collection], edi
    cmp eax, [es:edi + offset Collection.input.last_report]
    mov eax, [es:eax + offset Report.next]
    jnz l_h_hid_next_report
    
l_h_hid_reports_processed:
mov edi, [es:edi + offset Collection.next]
jmp l_h_hid_next_collection

l_h_hid_postprocess_done:

// 5. Open interrupt IN pipe. If failed, stop initialization.
mov edx, [es:ebx + offset UsbDeviceData.epdescr]
movzx ecx, byte ptr [es:edx + offset EndpointDescr.bEndpointAddress]
movzx eax, byte ptr [es:edx + offset EndpointDescr.bInterval]
movzx edx, word ptr [es:edx + offset EndpointDescr.wMaxPacketSize]

push eax
 push INTERRUPT_PIPE
  push edx
   push ecx
    push [es:ebx + offset UsbDeviceData.config_pipe]
call h_usb_open_pipe

test eax, eax
jz l_h_hid_exit

mov [es:ebx + offset UsbDeviceData.intpipe], eax
// 6. Initialize buffer for input packet.
// 6a. Find the length of input packet.
// This is the maximal length of all input reports.
mov edx, [es:ebx + offset UsbDeviceData.hid.input.first_report]
xor eax, eax

l_h_hid_find_input_size:
test edx, edx
jz l_h_hid_found_input_size
  cmp eax, [es:edx + offset Report.size]
  jae l_h_hid_61
    mov eax, [es:edx + offset Report.size]
    
  l_h_hid_61:
  mov edx, [es:edx + offset Report.next]
  jmp short l_h_hid_find_input_size
  
l_h_hid_found_input_size:
// report.size is in bits, transform it to bytes
add eax, 7
shr eax, 3
// if reports are numbered, the first byte is report ID, include it
cmp byte ptr [es:ebx + offset UsbDeviceData.hid.input.numbered], 0
jz l_h_hid_62
  inc eax
  
l_h_hid_62:
mov [es:ebx + offset UsbDeviceData.input_transfer_size], eax
// 6b. Allocate memory for input packet: dword-align and add additional dword
// for extract_field_value.
add eax, 4 + 3
and eax, -1 - 3
push ebx
  xchg ecx, eax
  call m_heap_alloc_kernel
  xchg eax, ebx
pop ebx
test eax, eax
jz l_h_hid_exit
  mov [es:ebx + offset UsbDeviceData.input_buffer], eax
  // 7. Submit a request for input packet and wait for input.
  call h_hid_ask_for_input
  
l_h_hid_exit:
mov ebx, [ss:esp + sizeof ParseDescrLocals + 12]  // buffer
call m_heap_free_kernel

add esp, sizeof ParseDescrLocals
ret 20

// Helper procedure for got_report and got_input.
// Submits a request for the next input packet.
// IN: ebx -> UsbDeviceData
h_hid_ask_for_input:
// just call USBNormalTransferAsync with correct parameters,
// allow short packets

push 1
 push ebx
  push offset h_hid_got_input
   push [es:ebx + offset UsbDeviceData.input_transfer_size]
    push [es:ebx + offset UsbDeviceData.input_buffer]
     push [es:ebx + offset UsbDeviceData.intpipe]
call h_usb_normal_transfer_async

ret

// Sort array of unsigned dwords in non-decreasing order.
// ecx = array size, edx = array pointer.
// Destroys eax, ecx, esi, edi.
h_hid_sort:
test ecx, ecx
jz h_hid_sort_done
  mov eax, ecx
  
  h_hid_sort_1:
    push eax
      call h_hid_sort_restore
    pop eax
    dec eax
    jnz h_hid_sort_1
    
  h_hid_sort_2:
  cmp ecx, 1
  jz h_hid_sort_done
    mov esi, 1
    mov edi, ecx
    call h_hid_sort_exchange
    dec ecx
    mov eax, 1
    call h_hid_sort_restore
    jmp short h_hid_sort_2
    
h_hid_sort_done:
ret

h_hid_sort_exchange:
push eax
 push ecx
  mov eax, [es:edx + esi * 4 - 4]
  mov ecx, [es:edx + edi * 4 - 4]
  mov [es:edx + esi * 4 - 4], ecx
  mov [es:edx + edi * 4 - 4], eax
 pop ecx
pop eax
ret
 
h_hid_sort_restore:
  lea esi, [eax + eax]
  cmp esi, ecx
  ja h_hid_sort_doner
    mov edi, [es:edx + eax * 4 - 4]
    cmp [es:edx + esi * 4 - 4], edi
    ja h_hid_sort_need_xchg
      cmp esi, ecx
      jae h_hid_sort_doner
      
      mov edi, [es:edx + eax * 4 - 4]
      cmp [es:edx + esi * 4], edi
      jbe h_hid_sort_doner
      
    h_hid_sort_need_xchg:
    cmp esi, ecx
    jz h_hid_sort_do_xchg
      mov edi, [es:edx + esi * 4 - 4]
      cmp [es:edx + esi * 4], edi
      sbb esi, -1
      
    h_hid_sort_do_xchg:
    mov edi, eax
    call h_hid_sort_exchange
    mov eax, esi
    jmp h_hid_sort_restore
    
h_hid_sort_doner:
ret

// This procedure is called by USB stack when a HID device responds with input
// data packet.
h_hid_got_input:
// 4 pipe:dword, 8 status:dword, 12 buffer:dword, 16 length:dword, 20 calldata:dword
sub esp, sizeof ParseInputLocals
// 1. Validate parameters: fail on error, ignore zero-length transfers.
mov ebx, [ss:esp + sizeof ParseInputLocals + 20]  // calldata
cmp dword ptr [ss:esp + sizeof ParseInputLocals + 8], 0  // status
jnz near h_hid_got_input_fail

cmp dword ptr [ss:esp + sizeof ParseInputLocals + 16], 0  // length
jz near h_hid_got_input_done

// 2. Get pointer to report in esi.
// 2a. If there are no report IDs, use hid.input.data.
mov eax, [ss:esp + sizeof ParseInputLocals + 12]  // buffer
mov esi, [es:ebx + offset UsbDeviceData.hid.input.data]
cmp byte ptr [es:ebx + offset UsbDeviceData.hid.input.numbered], 0
jz h_hid_got_input_report_found
  // 2b. Otherwise, the first byte of report is report ID//
  // locate the report by its ID, advance buffer+length to one byte.
  movzx eax, byte ptr [es:eax]
  mov esi, [es:esi + eax * 4]
  inc dword ptr [ss:esp + sizeof ParseInputLocals + 12]  // buffer
  dec dword ptr [ss:esp + sizeof ParseInputLocals + 16]  // length
  
h_hid_got_input_report_found:
// 3. Validate: ignore transfers with unregistered report IDs
// and transfers which are too short for the corresponding report.
test esi, esi
jz near h_hid_got_input_done
  mov eax, [es:esi + offset Report.size]
  add eax, 7
  shr eax, 3
  cmp eax, [ss:esp + sizeof ParseInputLocals + 16]  // length
  ja near h_hid_got_input_done
    // 4. Pass everything to HID layer.
    // * parse_input *
    // 1. Ignore the report if there is no driver for it.
    mov ebx, [es:esi + offset Report.top_level_collection]
    mov edi, [es:ebx + offset Collection.driver_data]
    test edi, edi
    jz near h_hid_got_input_done
    
    // 2. Notify the driver that a new packet arrived.
    call [es:ebx + offset Collection.callbacks.begin_packet]
    // Loop over all field groups.
    // Report without fields is meaningless, but theoretically possible:
    // parse_descr does not create reports of zero size, but
    // a report can consist of "padding" fields without usages and have
    // no real fields.
    mov esi, [es:esi + offset Report.first_field]
    test esi, esi
    jz near h_hid_got_input_packet_processed
    
    h_hid_got_input_field_loop:
    // 3. Prepare for group handling: initialize field offset, fields count
    // and size of range for valid values.
    mov eax, [es:esi + offset ReportFieldGroup.offset]
    mov [ss:esp + offset ParseInputLocals.field_offset], eax
    mov ecx, [es:esi + offset ReportFieldGroup.count]
    mov [ss:esp + offset ParseInputLocals.count_inside_group], ecx
    mov eax, [es:esi + offset ReportFieldGroup.logical_maximum]
    inc eax
    sub eax, [es:esi + offset ReportFieldGroup.logical_minimum]
    mov [es:esp + offset ParseInputLocals.field_range_size], eax
    // 4. Select handler. Variable and Array groups are handled entirely differently//
    // for Variable groups, advance to 5, for Array groups, go to 6.
    test byte ptr [es:esi + offset ReportFieldGroup.flags], HID_FIELD_VARIABLE
    jz h_hid_got_input_array_field
      // 5. Variable groups. They are simple. Loop over all .count fields,
      // for every field extract the value and get the next usage,
      // if the value is within valid range, call the driver.
      lea eax, [es:esi + offset ReportFieldGroup.common_sizeof]
      mov [ss:esp + offset ParseInputLocals.cur_usage], eax
      
      h_hid_got_input_variable_data_loop:
        mov eax, [ss:esp + offset ParseInputLocals.field_offset]
        
        //extract_field_value [buffer]    // -> edx
        mov ecx, eax
        shr eax, 5
        shl eax, 2
        add eax, [ss:esp + sizeof ParseInputLocals + 12]  // buffer
        and ecx, 31
        mov edx, [es:eax]
        mov eax, [es:eax + 4]
        shrd edx, eax, cl
        mov ecx, [es:esi + offset ReportFieldGroup.sign_mask]
        and ecx, edx
        and edx, [es:esi + offset ReportFieldGroup.mask]
        sub edx, ecx
        
        mov ecx, [ss:esp + offset ParseInputLocals.cur_usage]
        mov ecx, [es:ecx]
        call [es:ebx + offset Collection.callbacks.input_field]
        add dword ptr [ss:esp + offset ParseInputLocals.cur_usage], 4
        mov eax, [es:esi + offset ReportFieldGroup.size]
        add [ss:esp + offset ParseInputLocals.field_offset], eax
        dec dword ptr [ss:esp + offset ParseInputLocals.count_inside_group]
        jnz h_hid_got_input_variable_data_loop
        
      // Variable group is processed; go to 12.
      jmp h_hid_got_input_field_done
      
    h_hid_got_input_array_field:
    // Array groups. They are complicated.
    // 6. Array group: extract all values in one array.
    // memory was allocated during group creation, use it
    // 6a. Prepare: get data pointer, initialize num_values with zero.
    mov eax, [es:esi + offset ReportFieldGroup.num_usage_ranges]
    lea edx, [esi + offset ReportFieldGroup.usages + eax * 8 + 4]  // assert sizeof UsageRange = 8
    mov eax, [es:esi + offset ReportFieldGroup.count]
    mov [ss:esp + offset ParseInputLocals.values_cur_ptr], edx
    mov [ss:esp + offset ParseInputLocals.values_base], edx
    lea edx, [edx + ecx * 4]
    mov [ss:esp + offset ParseInputLocals.values_prev], edx
    mov [ss:esp + offset ParseInputLocals.values_prev_ptr], edx
    mov dword ptr [ss:esp + offset ParseInputLocals.num_values], 0
    // 6b. Start loop for every field. Note that there must be at least one field,
    // parse_descr does not allow .count == 0.
    
    h_hid_got_input_array_getval_loop:
      // 6c. Extract the value of the current field.
      mov eax, [ss:esp + offset ParseInputLocals.field_offset]
      
      //extract_field_value [buffer]    // -> edx
      mov ecx, eax
      shr eax, 5
      shl eax, 2
      add eax, [ss:esp + sizeof ParseInputLocals + 12]  // buffer
      and ecx, 31
      mov edx, [es:eax]
      mov eax, [es:eax + 4]
      shrd edx, eax, cl
      mov ecx, [es:esi + offset ReportFieldGroup.sign_mask]
      and ecx, edx
      and edx, [es:esi + offset ReportFieldGroup.mask]
      sub edx, ecx
      
      // 6d. Transform the value to the usage with binary search in array of
      // usage_ranges. started at [esi+report_field_group.usages]
      // having [esi+report_field_group.num_usage_ranges] items.
      // Ignore items outside of valid range.
      sub edx, [es:esi + offset ReportFieldGroup.logical_minimum]
      cmp edx, [ss:esp + offset ParseInputLocals.field_range_size]
      jae h_hid_got_input_array_skip_item
        // If there are too few usages, use last of them.
        mov ecx, [es:esi + offset ReportFieldGroup.num_usage_ranges]  // upper bound
        xor eax, eax        // lower bound
        cmp edx, [es:esi + offset ReportFieldGroup.usages + ecx * 8 + offset UsageRange.offset]  // assert sizeof UsageRange = 8
        jae h_hid_got_input_array_last_usage
          // loop invariant: usages[eax].offset <= edx < usages[ecx].offset
          
          h_hid_got_input_array_find_usage:
            lea edi, [eax + ecx]
            shr edi, 1
            cmp edi, eax
            jz h_hid_got_input_array_found_usage_range
            
            cmp edx, [es:esi + offset ReportFieldGroup.usages + edi * 8 + offset UsageRange.offset]  // assert sizeof UsageRange = 8
            jae h_hid_got_input_update_low
              mov ecx, edi
              jmp short h_hid_got_input_array_find_usage
              
            h_hid_got_input_update_low:
            mov eax, edi
            jmp short h_hid_got_input_array_find_usage
            
        h_hid_got_input_array_last_usage:
        lea eax, [ecx - 1]
        mov edx, [es:esi + offset ReportFieldGroup.usages + ecx * 8 + offset UsageRange.offset]  // assert sizeof UsageRange = 8
        dec edx
        
        h_hid_got_input_array_found_usage_range:
        sub edx, [es:esi + offset ReportFieldGroup.usages + eax * 8 + offset UsageRange.offset]  // assert sizeof UsageRange = 8
        add edx, [es:esi + offset ReportFieldGroup.usages + eax * 8 + offset UsageRange.first_usage]  // assert sizeof UsageRange = 8
        // 6e. Store the usage, advance data pointer, continue loop started at 6b.
        mov eax, [ss:esp + offset ParseInputLocals.values_cur_ptr]
        mov [es:eax], edx
        add dword ptr [ss:esp + offset ParseInputLocals.values_cur_ptr], 4
        inc dword ptr [ss:esp + offset ParseInputLocals.num_values]
        
      h_hid_got_input_array_skip_item:
      mov eax, [es:esi + offset ReportFieldGroup.size]
      add [ss:esp + offset ParseInputLocals.field_offset], eax
      dec dword ptr [ss:esp + offset ParseInputLocals.count_inside_group]
      jnz near h_hid_got_input_array_getval_loop
      
    // 7. Array group: ask driver about array overflow.
    // If driver says that the array is invalid, stop processing this group
    // (in particular, do not update previous values).
    mov ecx, [ss:esp + offset ParseInputLocals.num_values]
    test ecx, ecx
    jz h_hid_got_input_duplicates_removed
      mov edx, [ss:esp + offset ParseInputLocals.values_base]
      mov edi, [es:ebx + offset Collection.driver_data]
      call [es:ebx + offset Collection.callbacks.array_overflow]
      jnc near h_hid_got_input_field_done
      
      // 8. Array group: sort the array with current values.
      push esi
        mov ecx, [ss:esp + offset ParseInputLocals.num_values + 4]
        mov edx, [ss:esp + offset ParseInputLocals.values_base + 4]
        call h_hid_sort
      pop esi
      // 9. Array group: remove duplicates.
      cmp dword ptr [ss:esp + offset ParseInputLocals.num_values], 1
      jbe h_hid_got_input_duplicates_removed
        mov eax, [ss:esp + offset ParseInputLocals.values_base]
        mov edx, [es:eax]
        add eax, 4
        mov ecx, eax
        
        h_hid_got_input_duplicates_loop:
          cmp edx, [es:eax]
          jz h_hid_got_input_1
            mov edx, [es:eax]
            mov [es:ecx], edx
            add ecx, 4
            
          h_hid_got_input_1:
          add eax, 4
          cmp eax, [ss:esp + offset ParseInputLocals.values_cur_ptr]
          jb h_hid_got_input_duplicates_loop
          
        mov [ss:esp + offset ParseInputLocals.values_cur_ptr], ecx
        sub ecx, [ss:esp + offset ParseInputLocals.values_base]
        shr ecx, 2
        mov [ss:esp + offset ParseInputLocals.num_values], ecx
        
    h_hid_got_input_duplicates_removed:
    // 10. Array group: compare current and previous values,
    // call driver for differences.
    mov edi, [es:ebx + offset Collection.driver_data]
    mov eax, [ss:esp + offset ParseInputLocals.values_cur_ptr]
    mov [ss:esp + offset ParseInputLocals.values_end], eax
    mov eax, [ss:esp + offset ParseInputLocals.values_base]
    mov [ss:esp + offset ParseInputLocals.values_cur_ptr], eax
    mov eax, [es:esi + offset ReportFieldGroup.num_values_prev]
    shl eax, 2
    add eax, [ss:esp + offset ParseInputLocals.values_prev]
    mov [ss:esp + offset ParseInputLocals.values_prev_end], eax
    
    h_hid_got_input_find_5:
    mov eax, [ss:esp + offset ParseInputLocals.values_cur_ptr]
    cmp eax, [ss:esp + offset ParseInputLocals.values_end]
    jae h_hid_got_input_cur_done
      mov ecx, [es:eax]
      mov eax, [ss:esp + offset ParseInputLocals.values_prev_ptr]
      cmp eax, [ss:esp + offset ParseInputLocals.values_prev_end]
      jae h_hid_got_input_prev_done
        mov edx, [es:eax]
        cmp ecx, edx
        jb h_hid_got_input_advance_cur
        ja h_hid_got_input_advance_prev
        
        // common item in both arrays; ignore
        add dword ptr [ss:esp + offset ParseInputLocals.values_cur_ptr], 4
        add dword ptr [ss:esp + offset ParseInputLocals.values_prev_ptr], 4
        jmp short h_hid_got_input_find_5
        
        h_hid_got_input_advance_cur:
        // item is present in current array but not in previous//
        // call the driver with value = 1
        add dword ptr [ss:esp + offset ParseInputLocals.values_cur_ptr], 4
        mov edx, 1
        call [es:ebx + offset Collection.callbacks.input_field]
        jmp short h_hid_got_input_find_5
        
        h_hid_got_input_advance_prev:
        // item is present in previous array but not in current//
        // call the driver with value = 0
        add dword ptr [ss:esp + offset ParseInputLocals.values_prev_ptr], 4
        mov ecx, edx
        xor edx, edx
        call [es:ebx + offset Collection.callbacks.input_field]
        jmp short h_hid_got_input_find_5
        
      h_hid_got_input_prev_done:
      // for all items which are left in current array
      // call the driver with value = 1
      mov eax, [ss:esp + offset ParseInputLocals.values_cur_ptr]
      
      h_hid_got_input_6:
        add dword ptr [ss:esp + offset ParseInputLocals.values_cur_ptr], 4
        mov ecx, [es:eax]
        mov edx, 1
        call [es:ebx + offset Collection.callbacks.input_field]
        mov eax, [ss:esp + offset ParseInputLocals.values_cur_ptr]
        cmp eax, [ss:esp + offset ParseInputLocals.values_end]
        jb h_hid_got_input_6
        
      jmp short h_hid_got_input_copy_array
      
    h_hid_got_input_cur_done:
      // for all items which are left in previous array
      // call the driver with value = 0
      mov eax, [ss:esp + offset ParseInputLocals.values_prev_ptr]
      add dword ptr [ss:esp + offset ParseInputLocals.values_prev_ptr], 4
      cmp eax, [ss:esp + offset ParseInputLocals.values_prev_end]
      jae h_hid_got_input_copy_array
        mov ecx, [es:eax]
        xor edx, edx
        call [es:ebx + offset Collection.callbacks.input_field]
        jmp h_hid_got_input_cur_done
        
    h_hid_got_input_copy_array:
    // 11. Array group: copy current values to previous values.
    push esi
     push edi
      mov ecx, [ss:esp + offset ParseInputLocals.num_values + 8]
      mov [es:esi + offset ReportFieldGroup.num_values_prev], ecx
      mov esi, [ss:esp + offset ParseInputLocals.values_base + 8]
      mov edi, [ss:esp + offset ParseInputLocals.values_prev + 8]
      push ds
       push es
       pop ds
       cld
       rep movsd
      pop ds
     pop edi
    pop esi
    // 12. Field group is processed. Repeat with the next group, if any.
    
    h_hid_got_input_field_done:
    mov esi, [es:esi + offset ReportFieldGroup.next]
    test esi, esi
    jnz near h_hid_got_input_field_loop
    
    h_hid_got_input_packet_processed:
    // 13. Packet is processed, notify the driver.
    call [es:ebx + offset Collection.callbacks.end_packet]
    // * end parse_input *
    
h_hid_got_input_done:
// 5. Query the next input.
mov ebx, [ss:esp + sizeof ParseInputLocals + 20]  // calldata
call h_hid_ask_for_input

h_hid_got_input_nothing:
add esp, sizeof ParseInputLocals
ret 20

h_hid_got_input_fail:
jmp h_hid_got_input_nothing

struct MouseDeviceData{
  uns4 buttons
  int4 dx
  int4 dy
  int4 wheel
  int4 hwheel
}

[align 32]
mouse_driver:
dd offset h_hid_mouse_add_device
dd offset h_hid_mouse_disconnect
dd offset h_hid_mouse_begin_packet
dd offset h_hid_mouse_array_overflow
dd offset h_hid_mouse_input_field
dd offset h_hid_mouse_end_packet

// This procedure is called when HID layer detects a new mouse.
// IN: ebx -> DeviceData from USB layer, edi -> collection
// OUT: eax = device-specific data or NULL on error
h_hid_mouse_add_device:
// Just allocate memory; no initialization needed.
mov ecx, sizeof MouseDeviceData
call m_heap_alloc_kernel
ret

// This procedure is called when HID layer detects disconnect of a previously
// connected mouse.
// IN: edi -> MouseDeviceData (pointer returned from h_hid_mouse_add_device)
h_hid_mouse_disconnect:
// Free the allocated memory.
mov ebx, edi
call m_heap_free_kernel
ret

// This procedure is called when HID layer starts processing a new input packet
// from a mouse.
// IN: edi -> MouseDeviceData (pointer returned from h_hid_mouse_add_device)
h_hid_mouse_begin_packet:
// Zero all variables describing the current state.
mov dword ptr [es:edi + offset MouseDeviceData.buttons], 0
mov dword ptr [es:edi + offset MouseDeviceData.dx], 0
mov dword ptr [es:edi + offset MouseDeviceData.dy], 0
mov dword ptr [es:edi + offset MouseDeviceData.wheel], 0
mov dword ptr [es:edi + offset MouseDeviceData.hwheel], 0
ret

// This procedure is called when HID layer processes every non-empty array field group.
// in: edi -> mouse_device_data (pointer returned from mouse_driver_add_device)
// in: ecx = fields count (always nonzero), edx = pointer to fields values
// in: esi -> ReportFieldGroup
// out: CF set => array is ok, CF cleared => array should be ignored
h_hid_mouse_array_overflow:
// no array fields, no overflows
stc
ret

// This procedure is called from HID layer for every field.
// IN: edi -> MouseDeviceData (pointer returned from h_hid_mouse_add_device)
//     ecx = field usage, edx = value, esi -> ReportFieldGroup
h_hid_mouse_input_field:
// 1. Determine the handler. We process x/y moving, wheel and up to 32 buttons.
// Pass other fields to the default handler - default_driver_input_field if
// HID_DUMP_UNCLAIMED is enabled, just ignore otherwise.
cmp ecx, USAGE_GD_X
jz l_h_hid_mouse_input_field_x
cmp ecx, USAGE_GD_Y
jz l_h_hid_mouse_input_field_y
cmp ecx, USAGE_GD_WHEEL
jz l_h_hid_mouse_input_field_wheel
cmp ecx, 0xC0238
jz l_h_hid_mouse_input_field_hwheel
sub ecx, USAGE_BUTTON_PAGE + 1
jb l_h_hid_mouse_input_field_unclaimed
cmp ecx, 32
jae l_h_hid_mouse_input_field_unclaimed
// 2. This is a button.
// If a button is pressed, set the corresponding bit in the state.
// If a button is not pressed, do nothing.
test edx, edx
jz l_h_hid_mouse_input_field_unclaimed
  bts [es:edi + offset MouseDeviceData.buttons], ecx
  
l_h_hid_mouse_input_field_unclaimed:
ret

l_h_hid_mouse_input_field_x:
// 3. This is x moving. For relative fields, store the value in the state.
// Pass absolute field to the default handler.
test byte ptr [es:esi + offset ReportFieldGroup.flags], HID_FIELD_RELATIVE
jz l_h_hid_mouse_input_field_absolute_x
mov [es:edi + offset MouseDeviceData.dx], edx
ret

l_h_hid_mouse_input_field_y:
// 4. This is y moving. For relative fields, store the value in the state,
// changing the sign: HID uses "mathematics" scheme with Y axis increasing from
// bottom to top, the kernel expects "programming" PS/2-style with Y axis
// increasing from top to bottom.
// Pass absolute fields to the default handler.
test byte ptr [es:esi + offset ReportFieldGroup.flags], HID_FIELD_RELATIVE
jz l_h_hid_mouse_input_field_absolute_y
neg edx
mov [es:edi + offset MouseDeviceData.dy], edx
ret

l_h_hid_mouse_input_field_wheel:
// 5. This is wheel event. For relative fields, store the value in the state,
// changing the sign. Pass absolute fields to the default handler.
test byte ptr [es:esi + offset ReportFieldGroup.flags], HID_FIELD_RELATIVE
jz l_h_hid_mouse_input_field_unclaimed
neg edx
mov [es:edi + offset MouseDeviceData.wheel], edx
ret

l_h_hid_mouse_input_field_hwheel:
test byte ptr [es:esi + offset ReportFieldGroup.flags], HID_FIELD_RELATIVE
jz l_h_hid_mouse_input_field_unclaimed
mov [es:edi + offset MouseDeviceData.hwheel], edx
ret

l_h_hid_mouse_input_field_absolute_x:
mov [es:edi + offset MouseDeviceData.dx], edx
or dword ptr [es:edi + offset MouseDeviceData.buttons], 0x80000000
ret

l_h_hid_mouse_input_field_absolute_y:
mov [es:edi + offset MouseDeviceData.dy], edx
or dword ptr [es:edi + offset MouseDeviceData.buttons], 0x40000000
ret

// This procedure is called when HID layer ends processing a new input packet
// from a mouse.
// IN: edi -> MouseDeviceData (pointer returned from h_hid_mouse_add_device)
h_hid_mouse_end_packet:
mov al, [es:edi + offset MouseDeviceData.buttons]
mov ms_btn, al
// get delta X
movsx eax, byte ptr [es:edi + offset MouseDeviceData.dx]
add ms_x_sen, ax
// get delta Y
movsx eax, byte ptr [es:edi + offset MouseDeviceData.dy]
sub ms_y_sen, ax
// get delta Z
movsx eax, byte ptr [es:edi + offset MouseDeviceData.wheel]
add ms_z, ax

call h_mouse_common
ret

EX = 80h  // if set, precede the scancode with special scancode 0xE0

control_keys:
// Usages 700E0h ... 700E7h: LCtrl, LShift, LAlt, LWin, RCtrl, RShift, RAlt, RWin
db 1Dh, 2Ah, 38h, 5Bh+EX, 1Dh+EX, 36h, 38h+EX, 5Ch+EX
// Usages 70004h ... 70004h + normal_keys_number - 1

normal_keys:
db 1Eh, 30h, 2Eh, 20h, 12h, 21h, 22h, 23h, 17h, 24h, 25h, 26h, 32h, 31h, 18h, 19h
db 10h, 13h, 1Fh, 14h, 16h, 2Fh, 11h, 2Dh, 15h, 2Ch, 02h, 03h, 04h, 05h, 06h, 07h
db 08h, 09h, 0Ah, 0Bh, 1Ch, 01h, 0Eh, 0Fh, 39h, 0Ch, 0Dh, 1Ah, 1Bh, 2Bh, 2Bh, 27h
db 28h, 29h, 33h, 34h, 35h, 3Ah, 3Bh, 3Ch, 3Dh, 3Eh, 3Fh, 40h, 41h, 42h, 43h, 44h
db 57h, 58h,37h+EX,46h,0,52h+EX,47h+EX,49h+EX,53h+EX,4Fh+EX,51h+EX,4Dh+EX,4Bh+EX,50h+EX,48h+EX,45h
db 35h+EX,37h,4Ah,4Eh,1Ch+EX,4Fh,50h, 51h, 4Bh, 4Ch, 4Dh, 47h, 48h, 49h, 52h, 53h
db 56h,5Dh+EX,5Eh+EX
NORMAL_KEYS_NUMBER = $ - offset normal_keys

[align 32]
keyboard_driver:
dd offset h_hid_kbd_add_device
dd offset h_hid_kbd_disconnect
dd offset h_hid_kbd_begin_packet
dd offset h_hid_kbd_array_overflow
dd offset h_hid_kbd_input_field
dd offset h_hid_kbd_end_packet

// IN: edi -> KeyboardDeviceData
// KEEP: ebx, esi, edi
h_hid_cancel_timer:
push ebx
 push esi
  push edi
    mov edx, usb_thread
    shl edx, 16
    or dx, WIN_NONE
    mov ebx, edi
    call h_timer_remove
  pop edi
 pop esi
pop ebx
xor eax, eax
mov [es:edi + offset KeyboardDeviceData.timer], eax
ret

// This procedure is called when HID layer detects a new keyboard.
// IN: ebx -> UsbDeviceData, edi -> Collection
// OUT: eax = device-specific data or NULL on error
h_hid_kbd_add_device:
// 1. Allocate memory for keyboard_device_data. If failed, return NULL.
push ebx
  mov ecx, sizeof KeyboardDeviceData
  call m_heap_alloc_kernel
  xchg eax, ebx
pop ebx
test eax, eax
jz near l_h_hid_kbd_add_device_nothing

// 2. Initialize KeyboardDeviceData: store pointer to USB layer data,
// zero some fields, initialize bit positions to -1.
mov [es:eax + offset KeyboardDeviceData.usbdev], ebx
xor ecx, ecx
mov [es:eax + offset KeyboardDeviceData.timer], ecx
mov [es:eax + offset KeyboardDeviceData.repeatkey], cl
mov [es:eax + offset KeyboardDeviceData.modifiers], ecx
mov [es:eax + offset KeyboardDeviceData.led_report], ecx
dec ecx
mov [es:eax + offset KeyboardDeviceData.numlock_bit], ecx
mov [es:eax + offset KeyboardDeviceData.capslock_bit], ecx
mov [es:eax + offset KeyboardDeviceData.scrolllock_bit], ecx
// 3. Look for LED report and bits corresponding to indicators.
// For now, assume that all LEDs are set by the same report.
// 3a. Save registers.
push ebx
 push esi
  // 3b. Prepare for loop over output reports: get the first output report.
  // If there are no output records, skip step 3;
  // default values of led_report and *_bit were set in step 2.
  mov edx, [es:edi + offset Collection.output.first_report]
  test edx, edx
  jz l_h_hid_kbd_add_device_led_report_set
  
  l_h_hid_kbd_add_device_scan_led_report:
  // Process one output report.
  // 3c. Prepare for loop over field groups in the current report:
  // get the first field group.
  mov ecx, [es:edx + offset Report.first_field]
  
  l_h_hid_kbd_add_device_scan_led_field:
    // Process one field group.
    // 3d. If there are no more field groups, exit the loop over field groups.
    test ecx, ecx
    jz l_h_hid_kbd_add_device_next_led_report
    
    // For now, assume that all LEDs are plain variable fields, not arrays.
    // 3e. Ignore array field groups.
    test byte ptr [es:ecx + offset ReportFieldGroup.flags], HID_FIELD_VARIABLE
    jz l_h_hid_kbd_add_device_next_led_field
      
      // 3f. Loop over all fields in the current group.
      push [es:ecx + offset ReportFieldGroup.count]
        // esi = pointer to usage of the current field
        lea esi, [ecx + offset ReportFieldGroup.common_sizeof]
        // ebx = bit position of the current field
        mov ebx, [es:ecx + offset ReportFieldGroup.offset]
        // if report is numbered, add extra byte in the start of report
        cmp dword ptr [es:edx + offset Report.id], 0
        jz l_h_hid_kbd_add_device_scan_led_usage
          add ebx, 8
          
        l_h_hid_kbd_add_device_scan_led_usage:
          // for USAGE_LED_*LOCK, store the current bit position in the corresponding field
          // and store the current report as the LED report
          cmp dword ptr [es:esi], USAGE_LED_NUMLOCK
          jz l_h_hid_kbd_add_device_numlock
          cmp dword ptr [es:esi], USAGE_LED_CAPSLOCK
          jz l_h_hid_kbd_add_device_capslock
          cmp dword ptr [es:esi], USAGE_LED_SCROLLLOCK
          jnz l_h_hid_kbd_add_device_next_field
            
            l_h_hid_kbd_add_device_scrolllock:
            mov [es:eax + offset KeyboardDeviceData.scrolllock_bit], ebx
            jmp short l_h_hid_kbd_add_device_11
            
            l_h_hid_kbd_add_device_capslock:
            mov [es:eax + offset KeyboardDeviceData.capslock_bit], ebx
            jmp short l_h_hid_kbd_add_device_11
            
            l_h_hid_kbd_add_device_numlock:
            mov [es:eax + offset KeyboardDeviceData.numlock_bit], ebx
            
            l_h_hid_kbd_add_device_11:
            mov [es:eax + offset KeyboardDeviceData.led_report], edx
            
          l_h_hid_kbd_add_device_next_field:
          add esi, 4
          add ebx, [es:ecx + offset ReportFieldGroup.size]
          dec dword ptr [ss:esp]
          jnz l_h_hid_kbd_add_device_scan_led_usage
          
      pop ebx
      
    l_h_hid_kbd_add_device_next_led_field:
    // 3g. Continue loop over field groups: get next field group.
    mov ecx, [es:ecx + offset ReportFieldGroup.next]
    jmp l_h_hid_kbd_add_device_scan_led_field
    
  l_h_hid_kbd_add_device_next_led_report:
  // 3h. If the LED report has been set, break from the loop over reports.
  // Otherwise, get the next report and continue if the current report is not
  // the last for this collection.
  cmp dword ptr [es:eax + offset KeyboardDeviceData.led_report], 0
  jnz l_h_hid_kbd_add_device_led_report_set
    cmp edx, [es:edi + offset Collection.output.last_report]
    mov edx, [es:edx + offset Report.next]
    jnz l_h_hid_kbd_add_device_scan_led_report
    
  l_h_hid_kbd_add_device_led_report_set:
  // 3i. Restore registers.
 pop esi
pop ebx

// 4. Register keyboard in the kernel.
// store pointer to offset KeyboardDeviceData in the stack
push eax
  // call kernel API
  
  //* invoke  RegKeyboard, kbd_functions, eax
  
  // restore pointer to offset KeyboardDeviceData from the stack,
  // putting keyboard handle from API to the stack
xchg eax, [ss:esp]
  // put keyboard handle from API from the stack to offset KeyboardDeviceData field
pop [es:eax + offset KeyboardDeviceData.handle]
// If failed, free offset KeyboardDeviceData and return NULL.
cmp dword ptr [es:eax + offset KeyboardDeviceData.handle], 0
jz l_h_hid_kbd_add_device_fail_free
  // 5. Return pointer to KeyboardDeviceData.
  l_h_hid_kbd_add_device_nothing:
  ret
  
l_h_hid_kbd_add_device_fail_free:
xchg ebx, eax
call m_heap_free_kernel
xor eax, eax
ret

// This procedure is called when HID layer detects disconnect of a previously
// connected keyboard.
// IN: edi -> KeyboardDeviceData (pointer returned from h_hid_kbd_add_device)
h_hid_kbd_disconnect:
// 1. If an autorepeat timer is active, stop it.
cmp dword ptr [es:edi + offset KeyboardDeviceData.timer], 0
jz l_h_hid_kbd_disconnect_1
  call h_hid_cancel_timer
  
l_h_hid_kbd_disconnect_1:
// 2. Unregister keyboard in the kernel.

//* invoke  DelKeyboard, [edi+keyboard_device_data.handle]

mov ebx, edi
call m_heap_free_kernel
ret

// This procedure is called when HID layer starts processing a new input packet
// from a keyboard.
// IN: edi -> KeyboardDeviceData (pointer returned from h_hid_kbd_add_device)
h_hid_kbd_begin_packet:
// Nothing to do.
ret

// This procedure is called when HID layer processes every non-empty array field group.
// IN: edi -> KeyboardDeviceData (pointer returned from h_hid_kbd_add_device)
//     ecx = fields count (always nonzero), edx = pointer to fields values
//     esi -> ReportFieldGroup
// OUT: CF set => group is ok, CF cleared => group should be ignored
h_hid_kbd_array_overflow:
// The keyboard signals array overflow by filling the entire array with
// USAGE_KBD_ROLLOVER codes.
mov eax, [es:edx]      // eax = first field in the array
sub eax, USAGE_KBD_ROLLOVER // eax = 0 if overflow, nonzero otherwise
neg eax     // CF cleared if eax was zero, CF set if eax was nonzero
ret

// This procedure is called from HID layer for every field.
// IN: edi -> KeyboardDeviceData (pointer returned from h_hid_kbd_add_device)
//     ecx = field usage, edx = value, esi -> ReportFieldGroup
h_hid_kbd_input_field:
// 1. Process normal keys:
// from USAGE_KBD_FIRST_KEY to USAGE_KBD_FIRST_KEY + normal_keys_number - 1,
// excluding zeroes in [normal_keys].
// 1a. Test whether usage is in the range.
lea eax, [ecx - USAGE_KBD_FIRST_KEY]
cmp eax, NORMAL_KEYS_NUMBER
jae near l_h_hid_kbd_input_field_not_normal_key
  // 1b. If the corresponding entry in [normal_keys] is zero,
  // pass this field to the default handler - if HID_DUMP_UNCLAIMED is enabled,
  // default handler is default_driver_input_field, otherwise just ignore the field.
  cmp byte ptr [cs:offset normal_keys + eax], 0
  jz l_h_hid_kbd_input_field_unclaimed
    // 1c. Get the scancode.
    movzx ecx, byte ptr [cs:offset normal_keys + eax]
    // 1d. Further actions are slightly different for key press and key release.
    // Decide what to do.
    test edx, edx
    jz l_h_hid_kbd_input_field_normal_key_released
    
    l_h_hid_kbd_input_field_normal_key_pressed:
    // The key is pressed.
    // 1e. Store the last pressed key for autorepeat.
    mov [es:edi + offset KeyboardDeviceData.repeatkey], cl
    // 1f. Copy bit 7 to CF and send scancode with bit 7 cleared.
    btr ecx, 7
    call h_hid_kbd_input_field_send_key
    // 1g. Stop the previous autorepeat timer, if any.
    mov eax, [es:edi + offset KeyboardDeviceData.timer]
    test eax, eax
    jz l_h_hid_kbd_input_field_1
      call h_hid_cancel_timer
      
    l_h_hid_kbd_input_field_1:
    // 1h. Start the new autorepeat timer with 250 ms initial delay
    // and 50 ms subsequent delays.
    push ebx
     push esi
      push edi
        mov ecx, hid_delay1
        mov edx, usb_thread
        shl edx, 16
        or dx, WIN_NONE
        mov ebx, WP_KEYBOARD
        // mov edi, edi
        call h_timer_add
        mov eax, 1
      pop edi
     pop esi
    pop ebx
    mov [es:edi + offset KeyboardDeviceData.timer], eax
    
  l_h_hid_kbd_input_field_unclaimed:
  ret
  
  l_h_hid_kbd_input_field_normal_key_released:
  // The key is released.
  // 1i. Stop the autorepeat timer if it is autorepeating the released key.
  cmp [es:edi + offset KeyboardDeviceData.repeatkey], cl
  jnz l_h_hid_kbd_input_field_no_stop_timer
    push ecx
      mov byte ptr [es:edi + offset KeyboardDeviceData.repeatkey], 0
      mov eax, [es:edi + offset KeyboardDeviceData.timer]
      test eax, eax
      jz l_h_hid_kbd_input_field_2
        call h_hid_cancel_timer
        mov dword ptr [es:edi + offset KeyboardDeviceData.timer], 0
        
      l_h_hid_kbd_input_field_2:
    pop ecx
    
  l_h_hid_kbd_input_field_no_stop_timer:
  // 1j. Copy bit 7 to CF and send scancode with bit 7 set.
  bts ecx, 7
  call h_hid_kbd_input_field_send_key
  ret
  
l_h_hid_kbd_input_field_not_normal_key:
// 2. USAGE_KBD_NOEVENT is simply a filler for free array fields,
// ignore it.
cmp ecx, USAGE_KBD_NOEVENT
jz short l_h_hid_kbd_input_field_nothing

// 3. Process modifiers: 8 keys starting at USAGE_KBD_LCTRL.
// 3a. Test whether usage is in range.
// If not, we don't know what this field means, so pass it to the default handler.
lea eax, [ecx - USAGE_KBD_LCTRL]
cmp eax, 8
jae l_h_hid_kbd_input_field_unclaimed

// 3b. Further actions are slightly different for modifier press
// and modifier release. Decide what to do.
test edx, edx
jz l_h_hid_kbd_input_field_modifier_not_pressed
  
  l_h_hid_kbd_input_field_modifier_pressed:
  // The modifier is pressed.
  // 3c. Set the corresponding status bit.
  // If it was not set, send the corresponding scancode to the kernel
  // with bit 7 cleared.
  bts [es:edi + offset KeyboardDeviceData.modifiers], eax
  jc l_h_hid_kbd_input_field_nothing
    movzx ecx, byte ptr [cs:offset control_keys + eax]
    btr ecx, 7
    call h_hid_kbd_input_field_send_key
    
  l_h_hid_kbd_input_field_nothing:
  ret
  
l_h_hid_kbd_input_field_modifier_not_pressed:
// The modifier is not pressed.
// 3d. Clear the correspodning status bit.
// If it was set, send the corresponding scancode to the kernel
// with bit 7 set.
btr [es:edi + offset KeyboardDeviceData.modifiers], eax
jnc l_h_hid_kbd_input_field_3
  movzx ecx, byte ptr [cs:offset control_keys + eax]
  bts ecx, 7
  call h_hid_kbd_input_field_send_key
  
l_h_hid_kbd_input_field_3:
ret
 
// Helper procedure. Sends scancode from cl to the kernel.
// If CF is set, precede it with special code 0xE0.
// IN: cf = special, cl = keycode
h_hid_kbd_input_field_send_key:
jnc l_h_hid_kbd_input_field_6
  mov kbd_special, 1
  jmp short l_h_hid_kbd_input_field_7
  
l_h_hid_kbd_input_field_6:
mov kbd_special, 0

l_h_hid_kbd_input_field_7:
mov kbd_set_leds_ofs, offset h_hid_set_leds_wrapper
push ebx
 push esi
  push edi
    mov al, cl
    // IN: al = keydown || (keyup + 80h), kbd_special, kbd_set_leds_ofs
    call h_kbd_process
  pop edi
 pop esi
pop ebx
ret

// This procedure is called when HID layer ends processing a new input packet
// from a keyboard.
// IN: edi -> KeyboardDeviceData (pointer returned from h_hid_kbd_add_device)
h_hid_kbd_end_packet:
ret

// This function is called from the keyboard layer
// to update LED state on the keyboard.
// IN: stack device_data, led_state
h_hid_set_leds:
sub esp, 4
// +0 size, +4 ret_adr, +8 device_data, +12 led_state

// 1. Get the pointer to the LED report.
// If there is no LED report, exit from the function.
mov ebx, [ss:esp + 8]  // device_data
mov esi, [es:ebx + offset KeyboardDeviceData.led_report]
test esi, esi
jz near l_h_hid_set_leds_nothing

// 2. Get report size in bytes.
// report.size is size in bits without possible report ID//
// if an ID is assigned, the size is one byte greater.
mov eax, [es:esi + offset Report.size]
add eax, 7
shr eax, 3
cmp dword ptr [es:esi + offset Report.id], 0
jz l_h_hid_set_leds_1
  inc eax
  
l_h_hid_set_leds_1:
mov [ss:esp], eax  // size
// 3. Allocate memory for report + 8 bytes for setup packet.
// Dword-align size for subsequent rep stosd and bts.
// If failed, exit from the function.
add eax, 8 + 3
and eax, -1 - 3
push eax
 push ebx
  mov ecx, eax
  call m_heap_alloc_kernel
  xchg eax, ebx
 pop ebx
pop ecx
test eax, eax
jz near l_h_hid_set_leds_nothing

// 4. Zero-initialize output report.
push eax
  mov edi, eax
  shr ecx, 2
  xor eax, eax
  rep stosd
pop edi
add edi, 8
// 5. Store report ID, if assigned. If not assigned, that would just write zero
// over zeroes.
mov edx, [es:esi + offset Report.id]
mov [es:edi], edx
// 6. Set report bits corresponding to active indicators.
mov eax, [ss:esp + 12]  // led_state
test al, 1  // PS/2 Scroll Lock
jz l_h_hid_set_leds_21
  mov ecx, [es:ebx + offset KeyboardDeviceData.scrolllock_bit]
  test ecx, ecx
  js l_h_hid_set_leds_21
    bts [es:edi], ecx
    
l_h_hid_set_leds_21:
test al, 2  // PS/2 Num Lock
jz l_h_hid_set_leds_22
  mov ecx, [es:ebx + offset KeyboardDeviceData.numlock_bit]
  test ecx, ecx
  js l_h_hid_set_leds_22
    bts [es:edi], ecx
    
l_h_hid_set_leds_22:
test al, 4  // PS/2 Caps Lock
jz l_h_hid_set_leds_23
  mov ecx, [es:ebx + offset KeyboardDeviceData.capslock_bit]
  test ecx, ecx
  js l_h_hid_set_leds_23
    bts [es:edi], ecx
    
l_h_hid_set_leds_23:
// 7. Fill setup packet.
shl edx, 16         // move Report ID to byte 2
or edx, 21h + (9 << 8) + (2 << 24)
lea eax, [edi - 8]
mov ebx, [es:ebx + offset KeyboardDeviceData.usbdev]
mov dword ptr [es:eax], edx
mov edx, [ss:esp]  // size
shl edx, 16  // move Size to last word
or edx, [es:ebx + offset UsbDeviceData.interface_number]
mov [es:eax + 4], edx
// 8. Submit output control request.

push 0
 push ebx
  push offset h_hid_after_set_leds
   push [ss:esp + 0 + 12]  // size
    push edi
     push eax
      push dword ptr [es:ebx + offset UsbDeviceData.config_pipe]
call h_usb_control_async

// If failed, free the buffer now.
// If succeeded, the callback will free the buffer.
test eax, eax
jnz l_h_hid_set_leds_nothing
  lea ebx, [edi - 8]
  call m_heap_free_kernel

l_h_hid_set_leds_nothing:
add esp, 4
ret 8

// This procedure is called from the USB subsystem when the request initiated by
// SetKeyboardLights is completed, either successfully or unsuccessfully.
h_hid_after_set_leds:
/*
+0 ret_adr
+4 pipe
+8 status
+12 buffer
+16 length
+20 calldata
*/
mov ebx, [ss:esp + 12]  // buffer
sub ebx, 8
call m_heap_free_kernel
ret 20

// IN: ah = LEDs bitmap, edi
h_hid_set_leds_wrapper:
push ebx
 push esi
  push edi
    
    movzx eax, ah
    push eax
     push edi
    call h_hid_set_leds
    
  pop edi
 pop esi
pop ebx
ret

[dalign 32]
uns4 m_first_free  // PA of the first free frame

m_enter:
push eax
  l_m_enter_1:
    mov al, 1
    lock xchg al, m_busy
    test al, al
    jz l_m_enter_9
      call p_noop
      jmp l_m_enter_1
  
  l_m_enter_9:
  mov eax, p_current
  or byte ptr [es:eax + offset ThreadRec.flags], THREAD_FLAGS_M_BUSY
pop eax
ret

m_leave:
push eax
  mov eax, p_current
  mov m_busy, 0
  and byte ptr [es:eax + offset ThreadRec.flags], -1 - THREAD_FLAGS_M_BUSY
pop eax
ret

m_init:
mov eax, m_first_alloc
mov m_first_free, eax

mov m_busy, 0
mov m_heap_busy, 0

// free memory
mov m_free, 0
mov ebx, m_bitmap_base
mov ecx, m_bitmap_size

l_m_init_5:
  mov al, [ebx]
  cmp al, 255
  jz l_m_init_52
    cmp al, 0
    jnz l_m_init_51
      add m_free, 8
      jmp short l_m_init_52
      
    l_m_init_51:
    mov dl, 0
    
    l_m_init_515:
      test al, 1
      jnz l_m_init_516
        inc m_free
        
      l_m_init_516:
      shr al, 1
      inc dl
      cmp dl, 8
      jb l_m_init_515
    
  l_m_init_52:
  inc ebx
  loop l_m_init_5

ret

// Allocate Frame
// OUT: al = 0 || errorcode, esi = PA || 0
// DESTROY: eax, ecx, ebx
m_alloc1:
mov esi, m_bitmap_base  // esi = bitmap_base

mov ecx, m_bitmap_size
add ecx, esi            // ecx = bitmap_base + bitmap_size

mov eax, m_first_free
shr eax, 15
add eax, esi            // eax = first_alloc_bitmap_byte_PA
// (*
l_m_alloc1_1:
cmp eax, ecx
jnb l_m_alloc1_notfound
  cmp byte[eax], 255
  jnz l_m_alloc1_found
    inc eax
    jmp l_m_alloc1_1
// *)

l_m_alloc1_notfound:
mov eax, m_lastbyte
mov m_first_free, eax
xor esi, esi
mov al, ERC_NOT_ENOUGH_MEMORY
jmp short l_m_alloc1_9

l_m_alloc1_found:
mov ebx, eax   // ebx = bitmap_byte_PA
sub eax, esi
shl eax, 15
mov m_first_free, eax
mov esi, eax   // esi = frame_8_PA (aligned down to 8 frames)
mov al, [ebx]  // al = [ebx]
mov ah, 1
xor ecx, ecx
// (*
l_m_alloc1_5:
  test al, ah
  jz l_m_alloc1_foundbit
    inc cl
    shl ah, 1
    cmp cl, 8
    jb l_m_alloc1_5
// *)
jmp short l_m_alloc1_notfound

l_m_alloc1_foundbit:
or al, ah      // al |= ah
shl ecx, 12
mov [ebx], al  // [ebx] = al
add esi, ecx   // esi += frame_0_7

dec m_free

// Zero page - keep esi, edi
mov eax, esi
push edi
  or al, PG_MASK_P | PG_MASK_W
  mov ecx, 4096 / 4
  mov [PA_PT_VAR], eax
  mov edi, VA_VAR
  invlpg [es:edi]
  xor eax, eax
  cld
  rep stosd
pop edi

xor eax, eax

l_m_alloc1_9:
ret

// Allocate Contiguous Block for DMA Transfers
// IN: cl = 0: 32 KiB, 1: 64, 2: 128, 3: 256
// OUT: al = 0 || errorcode, esi = PA || 0
// DESTROY: eax, ecx, ebx, esi
m_alloc_dma:
call m_enter

mov esi, m_bitmap_base  // esi = bitmap_base

mov ebx, m_bitmap_size
mov eax, 0x1000000 / 0x8000  // 512 (max 16 MiB)
cmp ebx, eax
jna l_m_alloc_dma_0
  mov ebx, eax
  
l_m_alloc_dma_0:
add ebx, esi            // ebx = bitmap_base + min(bitmap_size, 512)

mov eax, m_first_free
shr eax, 15
add eax, esi            // eax = first_alloc_bitmap_byte_PA

mov esi, 1
shl esi, cl             // esi = 1 << cl

// (*
l_m_alloc_dma_1:

// Align eax to esi
mov ecx, esi
dec ecx  // ecx = esi - 1
dec eax
or eax, ecx
inc eax

// Assert eax + esi <= ebx
inc ecx
add ecx, eax
cmp ecx, ebx
ja l_m_alloc_dma_notfound

  cmp byte[eax], 0
  jz l_m_alloc_dma_5

    l_m_alloc_dma_next:
    inc eax
    jmp short l_m_alloc_dma_1
// *)

  l_m_alloc_dma_5:
  mov ecx, esi

// (*
  l_m_alloc_dma_51:
  dec ecx
  jecxz l_m_alloc_dma_6
    cmp byte[eax + ecx], 0
    jnz l_m_alloc_dma_next

      jmp short l_m_alloc_dma_51
// *)

l_m_alloc_dma_6:
mov ecx, esi

mov ebx, ecx
shl ebx, 3  // * 8
sub m_free, ebx

// (*
l_m_alloc_dma_61:
dec ecx
mov byte[eax + ecx], 255
jecxz l_m_alloc_dma_62
  jmp short l_m_alloc_dma_61
// *)

l_m_alloc_dma_62:
sub eax, m_bitmap_base
shl eax, 15
mov esi, eax
mov al, 0

l_m_alloc_dma_9:

call m_leave
ret

l_m_alloc_dma_notfound:
xor esi, esi
mov al, ERC_NOT_ENOUGH_MEMORY
jmp short l_m_alloc_dma_9



// Deallocate Frame
// IN: esi = PA
// OUT: al = 0 || errorcode
// DESTROY: eax, ecx, ebx
m_free1:
mov eax, esi
test ax, 0xFFF
jnz l_m_free1_xalign

cmp eax, m_first_alloc
jb l_m_free1_xunder

cmp eax, m_first_free
jnb l_m_free1_1
  mov m_first_free, eax
  
l_m_free1_1:
shr eax, 12
mov cl, al
shr eax, 3    // eax = frame_n / 8
and cl, 7     // cl = frame_n & 7
cmp eax, m_bitmap_size
jnb l_m_free1_xsize

add eax, m_bitmap_base
mov ebx, eax  // ebx = bitmap_byte_PA
mov ah, 1
mov al, [ebx] // al = [ebx]
shl ah, cl    // ah = 1 << cl
test al, ah
jz l_m_free1_xalready

not ah
and al, ah
mov [ebx], al // [ebx] = al & !ah

inc m_free

l_m_free1_ok:
xor eax, eax

l_m_free1_9:
ret


// also used from m_free_dma
l_m_free1_xalign:
mov al, ERC_ALIGN
jmp short l_m_free1_9

l_m_free1_xunder:
mov al, ERC_UNDERFLOW
jmp short l_m_free1_9

l_m_free1_xsize:
mov al, ERC_OVERFLOW
jmp short l_m_free1_9

l_m_free1_xalready:
mov al, ERC_ALREADY_FREE
jmp short l_m_free1_9

m_pages_alloc_x1:
mov al, ERC_NOT_ENOUGH_MEMORY
jmp l_pages_alloc_9

// IN: ebx = user ofs, ecx = page count
// OUT: al = 0 || ERC
m_pages_alloc:
mov edx, PG_MASK_P | PG_MASK_W | PG_MASK_U

m_pages_alloc_edx:

// Round ebx to 4096
and ebx, -1 - 4095

call m_enter

// cr3 - page directory
mov eax, cr3
or eax, PG_MASK_P | PG_MASK_W

mov [PA_PT_VAR + 8], eax
invlpg [es:VA_VAR + (8 / 4 * 4096)]

l_pages_alloc_1:
mov edi, ebx
shr edi, 22  // bits 22..31 * 4
shl edi, 2
mov esi, [es:edi + VA_VAR + (8 / 4 * 4096)]
or esi, esi
jnz l_pages_alloc_2

  push ebx
   push ecx
    push edx
     call m_alloc1  // keep edi
    pop edx
   pop ecx
  pop ebx
  or al, al
  jnz m_pages_alloc_x1  // not enough memory
  
  // Update memused
  cmp ebx, VA_GLOBAL
  jnb l_pages_alloc_12
    mov eax, p_current
    mov eax, [es:eax + offset ThreadRec.process]
    add dword[es:eax + offset ProcessRec.memused], 4096
  
  l_pages_alloc_12:  
  or esi, edx
  mov [es:edi + VA_VAR + (8 / 4 * 4096)], esi
  
  invlpg [es:VA_VAR + (8 / 4 * 4096)]
  
l_pages_alloc_2:

// esi = Page Table
mov [PA_PT_VAR + 4], esi
invlpg [es:VA_VAR + (4 / 4 * 4096)]

mov edi, ebx
shr edi, 12  // bits 12..21 * 4
shl edi, 2
and edi, 4095
mov esi, [es:edi + VA_VAR + (4 / 4 * 4096)]
or esi, esi
jnz l_pages_alloc_3

  push ebx
   push ecx
    push edx
     call m_alloc1  // keep edi
    pop edx
   pop ecx
  pop ebx
  or al, al
  jnz near m_pages_alloc_x1  // not enough memory
  
  // Update memused
  cmp ebx, VA_GLOBAL
  jnb l_pages_alloc_22
    mov eax, p_current
    mov eax, [es:eax + offset ThreadRec.process]
    add dword[es:eax + offset ProcessRec.memused], 4096
  
  l_pages_alloc_22:
  or esi, edx
  mov [es:edi + VA_VAR + (4 / 4 * 4096)], esi
  
  invlpg [es:ebx]
  
l_pages_alloc_3:
dec ecx
jecxz l_pages_alloc_8

  add ebx, 4096
  jmp l_pages_alloc_1

l_pages_alloc_8:
xor eax, eax

l_pages_alloc_9:
call m_leave
ret

m_pages_alloc_hard_x1:
mov al, ERC_NOT_ENOUGH_MEMORY
jmp l_m_pages_alloc_hard_9

// IN: ebx = user ofs, ecx = page count, edx = physical address
// OUT: al = 0 || ERC
m_pages_alloc_hard:
// Round ebx to 4096
and ebx, -1 - 4095

call m_enter

// cr3 - page directory
mov eax, cr3
or eax, PG_MASK_P | PG_MASK_W
mov [PA_PT_VAR + 8], eax
invlpg [es:VA_VAR + (8 / 4 * 4096)]

l_m_pages_alloc_hard_1:
and edx, -1 - 4095

mov edi, ebx
shr edi, 22  // bits 22..31 * 4
shl edi, 2
mov esi, [es:edi + VA_VAR + (8 / 4 * 4096)]
or esi, esi
jnz l_m_pages_alloc_hard_2

  push ebx
   push ecx
    push edx
     call m_alloc1  // keep edi
    pop edx
   pop ecx
  pop ebx
  or al, al
  jnz m_pages_alloc_hard_x1  // not enough memory
  
  or esi, PG_MASK_P | PG_MASK_W | PG_MASK_G | PG_MASK_PWT
  mov [es:edi + VA_VAR + (8 / 4 * 4096)], esi

  invlpg [es:VA_VAR + (8 / 4 * 4096)]
  
l_m_pages_alloc_hard_2:

// esi = Page Table
mov [PA_PT_VAR + 4], esi
invlpg [es:VA_VAR + (4 / 4 * 4096)]

mov edi, ebx
shr edi, 12  // bits 12..21 * 4
shl edi, 2
and edi, 4095

or edx, PG_MASK_P | PG_MASK_W | PG_MASK_G | PG_MASK_PWT
mov [es:edi + VA_VAR + (4 / 4 * 4096)], edx

invlpg [es:ebx]

l_m_pages_alloc_hard_3:
dec ecx
jecxz l_m_pages_alloc_hard_8
  
  add ebx, 4096
  add edx, 4096
  jmp l_m_pages_alloc_hard_1
  
l_m_pages_alloc_hard_8:
xor eax, eax

l_m_pages_alloc_hard_9:
call m_leave
ret

// IN: ebx = cr3
m_pages_free_all:
call m_enter

// page directory
or ebx, PG_MASK_P | PG_MASK_W
mov [PA_PT_VAR + 8], ebx
invlpg [es:VA_VAR + (8 / 4 * 4096)]
xor edx, edx

l_pages_free_all_1:
  mov eax, [es:edx + VA_VAR + (8 / 4 * 4096)]
  test eax, eax
  jz l_pages_free_all_2
    
    push edx
      
      // page table
      mov [PA_PT_VAR + 4], eax
      invlpg [es:VA_VAR + (4 / 4 * 4096)]
      xor ecx, ecx
      
      l_pages_free_all_11:
        mov esi, [es:ecx + VA_VAR + (4 / 4 * 4096)]
        and esi, -1 - 0xFFF
        test esi, esi
        jz l_pages_free_all_15
        
          push ecx
            // free frame
            call m_free1
          pop ecx
  
        l_pages_free_all_15:
        add ecx, 4
        cmp ecx, 4096
        jb l_pages_free_all_11
      
      // free table
      mov esi, [PA_PT_VAR + 4]
      and esi, -1 - 0xFFF
      call m_free1
    
    pop edx

  l_pages_free_all_2:
  add edx, 4
  cmp edx, VA_GLOBAL >> 24 * 4096 / 256
  jb l_pages_free_all_1

// free page directory
//mov esi, [PA_PT_VAR + 8]
//and esi, -1 - 0xFFF
//call m_free1

call m_leave
ret

// IN: ebx = virtual adr
// OUT: ebx = physical adr
// KEEP: eax, ecx, edx, ebp, esi, edi
m_pages_getphysadr:
push edi
 push esi
  // cr3 - page directory
  mov edi, cr3
  or edi, PG_MASK_P | PG_MASK_W
  mov [PA_PT_VAR + 8], edi
  invlpg [es:VA_VAR + (8 / 4 * 4096)]
  
  mov edi, ebx
  shr edi, 22  // bits 22..31 * 4
  shl edi, 2
  mov esi, [es:edi + VA_VAR + (8 / 4 * 4096)]
  or esi, esi
  jz l_m_pages_getphysadr_x
  
  // esi = Page Table
  or esi, PG_MASK_P | PG_MASK_W
  mov [PA_PT_VAR + 4], esi
  invlpg [es:VA_VAR + (4 / 4 * 4096)]
  
  mov edi, ebx
  shr edi, 12  // bits 12..21 * 4
  shl edi, 2
  and edi, 4095
  mov esi, [es:edi + VA_VAR + (4 / 4 * 4096)]
  or esi, esi
  jz l_m_pages_getphysadr_x
  
  // output
  and esi, -1 - 4095
  and ebx, 4095
  or ebx, esi
 pop esi
pop edi
ret

  l_m_pages_getphysadr_x:
  xor ebx, ebx
 pop esi
pop edi
ret

m_pages_alloc_pt_x1:
mov al, ERC_NOT_ENOUGH_MEMORY
jmp l_pages_alloc_pt_9

// IN: ebx = LA
// OUT: al = erc
m_pages_alloc_pt:
mov edx, PG_MASK_P | PG_MASK_W | PG_MASK_U

// Round ebx to 4096
and ebx, -1 - 4095

call m_enter

// cr3 - page directory
mov eax, cr3
or eax, PG_MASK_P | PG_MASK_W

mov [PA_PT_VAR + 8], eax
invlpg [es:VA_VAR + (8 / 4 * 4096)]

mov edi, ebx
shr edi, 22  // bits 22..31 * 4
shl edi, 2
mov esi, [es:edi + VA_VAR + (8 / 4 * 4096)]
test esi, esi
jnz l_pages_alloc_pt_8

  push ebx
   push edx
     call m_alloc1  // keep edi
   pop edx
  pop ebx
  test al, al
  jnz m_pages_alloc_pt_x1  // not enough memory
  
  or esi, edx
  mov [es:edi + VA_VAR + (8 / 4 * 4096)], esi
  
  invlpg [es:VA_VAR + (8 / 4 * 4096)]
  
l_pages_alloc_pt_8:
xor eax, eax

l_pages_alloc_pt_9:
call m_leave
ret

// IN: ebx = LA
// KEEP: edi
m_pages_free_page:
call m_enter

// page directory
mov eax, cr3
or al, PG_MASK_P | PG_MASK_W
mov [PA_PT_VAR + 8], eax
invlpg [es:VA_VAR + (8 / 4 * 4096)]

mov edx, ebx
shr edx, 10 + 12
shl edx, 2
mov eax, [es:edx + VA_VAR + (8 / 4 * 4096)]
and eax, -1 - 0xFFF
test eax, eax
jz l_m_pages_free_page_9

  // page table
  or al, PG_MASK_P | PG_MASK_W
  mov [PA_PT_VAR + 4], eax
  invlpg [es:VA_VAR + (4 / 4 * 4096)]
  
  mov edx, ebx
  and edx, 0x3FF000
  shr edx, 12
  shl edx, 2
  mov esi, [es:edx + VA_VAR + (4 / 4 * 4096)]
  and esi, -1 - 0xFFF
  test esi, esi
  jz l_m_pages_free_page_9
    // free frame
    xor eax, eax
    mov [es:edx + VA_VAR + (4 / 4 * 4096)], eax
    call m_free1

l_m_pages_free_page_9:
call m_leave
ret

m_heap_init:
/*
mov ebx, HEAP_START
mov ecx, 1
call m_pages_alloc
*/
mov ebx, HEAP_START
xor eax, eax
mov [es:ebx + offset HeapRec.last], eax
mov dword ptr [es:ebx + offset HeapRec.next], HEAP_END
mov [es:ebx + offset HeapRec.size], eax
mov [es:ebx + offset HeapRec.type], eax
ret

m_heap_init_global:
/*
mov ebx, HEAP_START_GLOBAL
mov ecx, 1
call m_pages_alloc
*/
mov ebx, HEAP_START_GLOBAL
xor eax, eax
mov [es:ebx + offset HeapRec.last], eax
mov dword ptr [es:ebx + offset HeapRec.next], HEAP_END_GLOBAL
mov [es:ebx + offset HeapRec.size], eax
mov [es:ebx + offset HeapRec.type], eax
ret

m_heap_init_kernel:
/*
mov ebx, HEAP_START_KERNEL
mov ecx, 1
call m_pages_alloc
*/
mov ebx, HEAP_START_KERNEL
xor eax, eax
mov [es:ebx + offset HeapRec.last], eax
mov dword ptr [es:ebx + offset HeapRec.next], HEAP_END_KERNEL
mov [es:ebx + offset HeapRec.size], eax
mov [es:ebx + offset HeapRec.type], eax
ret

m_heap_enter:
push eax
  l_heap_enter_1:
    mov al, 1
    lock xchg al, m_heap_busy
    test al, al
    jz l_heap_enter_9
      call p_noop
      jmp l_heap_enter_1
  
  l_heap_enter_9:
  mov eax, p_current
  or byte ptr [es:eax + offset ThreadRec.flags], THREAD_FLAGS_M_HEAP_BUSY
pop eax
ret

m_heap_leave:
push eax
  mov eax, p_current
  mov m_heap_busy, 0
  and byte ptr [es:eax + offset ThreadRec.flags], -1 - THREAD_FLAGS_M_HEAP_BUSY
pop eax
ret

// IN: ecx = size, ebx = type, esi = heap_start, edi = heap_end
// OUT: al = 0 || erc, ebx = ptr to block
m_heap_alloc:
dec ecx
or cl, 15
inc ecx  // align ecx to 16

l_m_heap_alloc_1:
mov eax, esi
add eax, 32
add eax, [es:esi + offset HeapRec.size]
add eax, ecx
mov edx, [es:esi + offset HeapRec.next]
cmp eax, edx
jna l_m_heap_alloc_5
  cmp esi, edx
  jnb l_m_heap_alloc_2
    mov esi, edx
    cmp esi, edi
    jb l_m_heap_alloc_1

l_m_heap_alloc_2:
xor ebx, ebx
mov al, ERC_NOT_ENOUGH_MEMORY
jmp l_m_heap_alloc_9

l_m_heap_alloc_5:
// free space found, edx = next
mov eax, ebx
mov ebx, esi
add ebx, [es:esi + offset HeapRec.size]
add ebx, sizeof HeapRec
mov [es:ebx + offset HeapRec.last], esi
mov [es:ebx + offset HeapRec.next], edx
mov [es:ebx + offset HeapRec.size], ecx
mov [es:ebx + offset HeapRec.type], eax

mov [es:esi + offset HeapRec.next], ebx
cmp edx, edi
jnb l_m_heap_alloc_6
  mov [es:edx + offset HeapRec.last], ebx

l_m_heap_alloc_6:

add ebx, 16
mov al, 0

l_m_heap_alloc_9:
ret

// IN: ebx = ptr to block, esi = heap_start, edi = heap_end
m_heap_free:
test ebx, ebx
jz l_m_heap_free_5
  sub ebx, sizeof HeapRec
  mov eax, [es:ebx + offset HeapRec.last]
  mov edx, [es:ebx + offset HeapRec.next]
  cmp eax, esi
  jb l_m_heap_free_5
    
    cmp eax, edi
    jnb l_m_heap_free_4
    
      cmp [es:eax + offset HeapRec.next], ebx
      jnz l_m_heap_free_4
      
        mov [es:eax + offset HeapRec.next], edx
  
    l_m_heap_free_4:
    cmp edx, edi
    jnb l_m_heap_free_5
    
      cmp [es:edx + offset HeapRec.last], ebx
      jnz l_m_heap_free_5
  
        mov [es:edx + offset HeapRec.last], eax
    
l_m_heap_free_5:
ret

// IN: ecx = size
// OUT: al = 0 || erc, ebx = ptr to block, edx = ptr to aligned
m_heap_alloc_aligned:
mov esi, HEAP_START
mov edi, HEAP_END

dec ecx
or cx, 4095
inc ecx  // align ecx to 4096

l_m_heap_alloc_aligned_1:
mov eax, esi
add eax, 32
add eax, [es:esi + offset HeapRec.size]

dec eax
or ax, 4095
inc eax

add eax, ecx
mov edx, [es:esi + offset HeapRec.next]
cmp eax, edx
jna l_m_heap_alloc_aligned_5
  cmp esi, edx
  jnb l_m_heap_alloc_aligned_2
    mov esi, edx
    cmp esi, edi
    jb l_m_heap_alloc_aligned_1

l_m_heap_alloc_aligned_2:
xor ebx, ebx
xor edx, edx
mov al, ERC_NOT_ENOUGH_MEMORY
jmp l_m_heap_alloc_aligned_9

l_m_heap_alloc_aligned_5:
// free space found, edx = next, eax = aligned + ecx
sub eax, ecx
mov ebx, esi
add ebx, [es:esi + offset HeapRec.size]
add ebx, 16
mov [es:ebx + offset HeapRec.last], esi
mov [es:ebx + offset HeapRec.next], edx

push eax
  sub eax, ebx
  sub eax, 16
  add ecx, eax
  mov [es:ebx + offset HeapRec.size], ecx
  xor eax, eax
  mov [es:ebx + offset HeapRec.type], eax
  
  mov [es:esi + offset HeapRec.next], ebx
  cmp edx, edi
  jnb l_m_heap_alloc_aligned_6
    mov [es:edx + offset HeapRec.last], ebx
  
  l_m_heap_alloc_aligned_6:
pop edx

add ebx, 16
mov al, 0

l_m_heap_alloc_aligned_9:
ret

// IN: ecx = size
// OUT: al = 0 || erc, ebx = ptr to block
m_heap_alloc_local:
mov esi, HEAP_START
mov edi, HEAP_END
xor ebx, ebx
call m_heap_alloc
ret

// IN: ecx = size
// OUT: al = 0 || erc, ebx = ptr to block
m_heap_alloc_global:
mov ebx, p_current
mov ebx, [es:ebx + offset ThreadRec.process]

m_heap_alloc_global_ebx:
mov esi, HEAP_START_GLOBAL
mov edi, HEAP_END_GLOBAL
call m_heap_enter

  call m_heap_alloc

call m_heap_leave
ret

// IN: ebx = ptr to block
m_heap_free_local:
mov esi, HEAP_START
mov edi, HEAP_END
call m_heap_free
ret

// IN: ebx = ptr to block
m_heap_free_global:
mov esi, HEAP_START_GLOBAL
mov edi, HEAP_END_GLOBAL
call m_heap_enter
call m_heap_free
call m_heap_leave
ret

// IN: ecx = size
// OUT: al = 0 || erc, ebx = ptr to block
// KEEP: esi, edi
m_heap_alloc_kernel:
push esi
 push edi
  xor ebx, ebx
  mov esi, HEAP_START_KERNEL
  mov edi, HEAP_END_KERNEL
  call m_heap_enter
  
    call m_heap_alloc
  
  call m_heap_leave
 pop edi
pop esi
ret

// IN: ebx = ptr to block
// KEEP: esi, edi
m_heap_free_kernel:
push esi
 push edi
  mov esi, HEAP_START_KERNEL
  mov edi, HEAP_END_KERNEL
  call m_heap_enter
  
    call m_heap_free
  
  call m_heap_leave
 pop edi
pop esi
ret

// IN: ebx = PA
// OUT: eax = [PA]
m_phys_get:
mov eax, ebx
and eax, -1 - 4095
or eax, PG_MASK_P | PG_MASK_W
mov [PA_PT_VAR + 40h], eax
//invlpg [PA_PT_VAR + 40h] 
mov eax, ebx
and eax, 4095
invlpg [es:eax + VA_VAR + (40h / 4 * 4096)]
mov eax, [es:eax + VA_VAR + (40h / 4 * 4096)]
ret

// IN: ebx = PA
// OUT: al = [PA]
m_phys_getbyte:
mov eax, ebx
and eax, -1 - 4095
or eax, PG_MASK_P | PG_MASK_W
mov [PA_PT_VAR + 40h], eax
//invlpg [PA_PT_VAR + 40h] 
mov eax, ebx
and eax, 4095
invlpg [es:eax + VA_VAR + (40h / 4 * 4096)]
mov al, [es:eax + VA_VAR + (40h / 4 * 4096)]
ret

// IN: ebx = PA, eax = value
// DESTROY: ecx
m_phys_set:
mov ecx, ebx
and ecx, -1 - 4095
or ecx, PG_MASK_P | PG_MASK_W
mov [PA_PT_VAR + 40h], ecx
//invlpg [PA_PT_VAR + 40h]
mov ecx, ebx
and ecx, 4095
invlpg [es:ecx + VA_VAR + (40h / 4 * 4096)]
mov [es:ecx + VA_VAR + (40h / 4 * 4096)], eax
ret

// IN: ebx = PA, al = value
// DESTROY: ecx
m_phys_setbyte:
mov ecx, ebx
and ecx, -1 - 4095
or ecx, PG_MASK_P | PG_MASK_W
mov [PA_PT_VAR + 40h], ecx
//invlpg [PA_PT_VAR + 40h]
mov ecx, ebx
and ecx, 4095
invlpg [es:ecx + VA_VAR + (40h / 4 * 4096)]
mov [es:ecx + VA_VAR + (40h / 4 * 4096)], al
ret

SIZE_THREADREC = 4096
PRIORITY0 = 10 * 1193
MAX_LOAD_DEPTH = 8

struct SectionEntry{
  char Name[8]
  uns4 VirtualSize, VirtualAddress, SizeOfRawData, PointerToRawData
  uns4 PointerToRelocations, PointerToLinenumbers
  uns2 NumberOfRelocations, NumberOfLinenumbers
  uns4 Characteristics
}

[dalign 32]
uns4 p_clip, p_clip_type, p_adr, p_i1, p_i2
uns8 p_jmp

SectionEntry section

uns1 p_load_depth

char p_dll[MAX_PATH]

l_p_msg_post_x1:  // also usr_post, IN: edi -> thread
// Wake?
test byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_DONT_WAKE_BY_MESSAGE
jnz l_p_msg_post_x8
  
  call p_start
  
l_p_msg_post_x8:
popfd
mov al, ERC_MSG_QUEUE_FULL
ret

l_p_msg_post_x2:  // also usr_post
popfd
mov al, ERC_MSG_INVALID_TARGET
ret

// post Message
// IN: ebx = winid:(threadid+16384), ecx = msg, edx = wp, esi = lp
// OUT: al = 0 || errorcode
p_msg_post:
pushfd
  cli
  // Get threadid
  mov edi, ebx
  test edi, 16384
  jnz l_p_msg_post_2
  
    // edi = ProcessID
    movzx edi, di
    shl edi, 9  // assert sizeof ProcessRec = 512
    cmp edi, p_procs_max_size
    jnb l_p_msg_post_x2
    
    add edi, VA_PROCS
    mov edi, [es:edi + offset ProcessRec.mainthread]
    sub edi, VA_THREADS
    shr edi, 12
    
  l_p_msg_post_2:
  // edi = ThreadID
  and edi, 16383
  shl edi, 12   // assert sizeof ThreadRec = 4096 (2^12)
  cmp edi, p_threads_max_size
  jnb l_p_msg_post_x2
  
  add edi, VA_THREADS
  
  mov eax, [es:edi + offset ThreadRec.msgw]
  add eax, sizeof MsgRec
  and eax, 511  // assert sizeof MsgQueue = 512
  cmp eax, [es:edi + offset ThreadRec.msgr]
  jz l_p_msg_post_x1
  
  mov [es:edi + offset ThreadRec.msgw], eax
  
  push edi
  
    add edi, offset ThreadRec.msg
    sub eax, sizeof MsgRec
    and eax, 511
    add edi, eax
    
    mov eax, p_current
    sub eax, VA_THREADS
    shr eax, 12  // assert sizeof ThreadRec = 4096
    mov bx, ax
    
    mov [es:edi + offset MsgRec.poster], ebx
    mov [es:edi + offset MsgRec.msg], ecx
    mov [es:edi + offset MsgRec.wp], edx
    mov [es:edi + offset MsgRec.lp], esi
  
  pop edi
  
  // Wake?
  test byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_DONT_WAKE_BY_MESSAGE
  jnz l_p_msg_post_8
    
    call p_start
    
  l_p_msg_post_8:
  
  // End
  mov al, 0

popfd
ret

// post User Message
// IN: ebx = winid:threadid, ecx = msg, edx = wp, esi = lp
// OUT: al = 0 || errorcode
p_msg_usr_post:
pushfd
  cli
  // Get threadid
  mov edi, ebx
  test edi, 16384
  jnz l_p_msg_usr_post_2
  
    // edi = ProcessID
    movzx edi, di
    shl edi, 9  // assert sizeof ProcessRec = 512
    cmp edi, p_procs_max_size
    jnb near l_p_msg_post_x2
    
    add edi, VA_PROCS
    mov edi, [es:edi + offset ProcessRec.mainthread]
    sub edi, VA_THREADS
    shr edi, 12
    
  l_p_msg_usr_post_2:
  // edi = ThreadID
  and edi, 16383
  shl edi, 12   // assert sizeof ThreadRec = 4096 (2^12)
  cmp edi, p_threads_max_size
  jnb near l_p_msg_post_x2
  
  add edi, VA_THREADS
  
  mov eax, [es:edi + offset ThreadRec.msgusrw]
  add eax, sizeof MsgRec
  and eax, 511  // assert sizeof MsgUsrQueue = 512
  cmp eax, [es:edi + offset ThreadRec.msgusrr]
  jz near l_p_msg_post_x1
  
  mov [es:edi + offset ThreadRec.msgusrw], eax
  
  push edi
  
    add edi, offset ThreadRec.msgusr
    sub eax, sizeof MsgRec
    and eax, 511
    add edi, eax
    
    mov eax, p_current
    sub eax, VA_THREADS
    shr eax, 12  // assert sizeof ThreadRec = 4096
    and ebx, 0xFFFF0000
    or ebx, eax
    
    mov [es:edi + offset MsgRec.poster], ebx
    mov [es:edi + offset MsgRec.msg], ecx
    mov [es:edi + offset MsgRec.wp], edx
    mov [es:edi + offset MsgRec.lp], esi
  
  pop edi
  
  // Wake?
  test byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_DONT_WAKE_BY_MESSAGE
  jnz l_p_msg_usr_post_8
  
    call p_start
  
  l_p_msg_usr_post_8:
  
  // End
  mov al, 0

popfd
ret

// Get Message
// OUT: al = 0 || errorcode, ebx = winid:poster, ecx = msg,
//      edx = wp, esi = lp, edi = hwnd
p_msg_get:
pushfd
  cli
  
  mov edi, p_current
  mov esi, edi
  
  mov eax, [es:esi + offset ThreadRec.msgr]
  cmp eax, [es:esi + offset ThreadRec.msgw]
  jz l_p_msg_get_x
  
  add edi, offset ThreadRec.msg
  add edi, eax
  add eax, sizeof MsgRec
  and eax, 511  // assert sizeof MsgUsrQueue = 512
  mov [es:esi + offset ThreadRec.msgr], eax
  
  mov ebx, [es:edi + offset MsgRec.poster]
  mov ecx, [es:edi + offset MsgRec.msg]
  mov edx, [es:edi + offset MsgRec.wp]
  mov esi, [es:edi + offset MsgRec.lp]
  
  mov eax, ebx
  shr eax, 16
  cmp eax, MAX_WIN
  jnb l_p_msg_get_6
    shl eax, 5  // assert sizeof WinRec = 32
    test win.flags[eax], WINFLAGS_VALID
    jz l_p_msg_get_6
      mov edi, cr3
      cmp edi, win.cr3[eax]
      jnz l_p_msg_get_6
        mov edi, win.hwnd[eax]
        jmp short l_p_msg_get_8
        
  l_p_msg_get_6:
  xor edi, edi
  
  l_p_msg_get_8:
  mov al, 0
popfd
ret

l_p_msg_get_x:
popfd
mov al, ERC_MSG_QUEUE_EMPTY  // also usr_get
ret
// Get Message
// OUT: al = 0 || errorcode, ebx = winid:poster, ecx = msg,
//      edx = wp, esi = lp, edi = hwnd
p_msg_usr_get:
pushfd
  cli
  
  mov edi, p_current
  mov esi, edi
  
  mov eax, [es:esi + offset ThreadRec.msgusrr]
  cmp eax, [es:esi + offset ThreadRec.msgusrw]
  jz l_p_msg_get_x
  
  add edi, offset ThreadRec.msgusr
  add edi, eax
  add eax, sizeof MsgRec
  and eax, 511  // assert sizeof MsgUsrQueue = 512
  mov [es:esi + offset ThreadRec.msgusrr], eax
  
  mov ebx, [es:edi + offset MsgRec.poster]
  mov ecx, [es:edi + offset MsgRec.msg]
  mov edx, [es:edi + offset MsgRec.wp]
  mov esi, [es:edi + offset MsgRec.lp]
  
  mov eax, ebx
  shr eax, 16
  cmp eax, MAX_WIN
  jnb l_p_msg_usr_get_6
    shl eax, 5  // assert sizeof WinRec = 32
    test win.flags[eax], WINFLAGS_VALID
    jz l_p_msg_usr_get_6
      mov edi, cr3
      cmp edi, win.cr3[eax]
      jnz l_p_msg_usr_get_6
        mov edi, win.hwnd[eax]
        jmp short l_p_msg_usr_get_8
        
  l_p_msg_usr_get_6:
  xor edi, edi
  
  l_p_msg_usr_get_8:
  mov al, 0
popfd
ret

// IN: ecx = WM_DEVICECHANGE, edx = ldiskn, esi = 0 removed | 1 inserted
p_msg_post_to_all:
xor ebx, ebx

l_p_msg_post_to_all_1:
  cmp ebx, p_procs_max_size
  jnb l_p_msg_post_to_all_8
    mov eax, [es:ebx + VA_PROCS + offset ProcessRec.flags]
    test al, PROC_FLAGS_VALID
    jz l_p_msg_post_to_all_6
      push ecx
       push ebx
        push edx
         push esi
          shr ebx, 9 // assert sizeof ProcessRec = 512
          or ebx, WIN_NONE << 16
          call p_msg_post
         pop esi
        pop edx
       pop ebx
      pop ecx
    
    l_p_msg_post_to_all_6:
    add ebx, sizeof ProcessRec
    jmp l_p_msg_post_to_all_1
    
l_p_msg_post_to_all_8:
ret

// IN: dl = winid, ebx -> win
// KEEP: ebx
p_remove_msg:
pushfd
  cli
  
  // msg
  mov edi, p_current
  mov esi, edi
  add edi, offset ThreadRec.msg
  mov ecx, [es:esi + offset ThreadRec.msgr]
  
  l_p_remove_msg_5:
    cmp ecx, [es:esi + offset ThreadRec.msgw]
    jz l_p_remove_msg_7
      mov al, [es:edi + ecx + offset MsgRec.wndid]
      cmp al, dl
      jnz l_p_remove_msg_6
        xor eax, eax
        mov byte ptr [es:edi + ecx + offset MsgRec.wndid], WIN_NONE
        mov [es:edi + ecx + offset MsgRec.msg], eax
        
      l_p_remove_msg_6:
      add ecx, sizeof MsgRec
      and ecx, 511  // assert sizeof MsgQueue = 512
      jmp short l_p_remove_msg_5
      
  l_p_remove_msg_7:
  // usr msg
  mov edi, esi
  mov esi, edi
  add edi, offset ThreadRec.msgusr
  mov ecx, [es:esi + offset ThreadRec.msgusrr]
  
  l_p_remove_msg_75:
    cmp ecx, [es:esi + offset ThreadRec.msgusrw]
    jz l_p_remove_msg_8
      mov al, [es:edi + ecx + offset MsgRec.wndid]
      cmp al, dl
      jnz l_p_remove_msg_76
        xor eax, eax
        mov byte ptr [es:edi + ecx + offset MsgRec.wndid], WIN_NONE
        mov [es:edi + ecx + offset MsgRec.msg], eax
        
      l_p_remove_msg_76:
      add ecx, sizeof MsgRec
      and ecx, 511  // assert sizeof MsgUsrQueue = 512
      jmp short l_p_remove_msg_75
      
  l_p_remove_msg_8:
  
popfd
ret

// IN: es:ecx -> mutex
// KEEP: all
p_mutex_lock:
push eax
  
  l_p_mutex_lock_5:
    mov al, 1
    lock xchg al, [es:ecx]
    test al, al
    jz l_p_mutex_lock_9
      call p_noop
      jmp short l_p_mutex_lock_5
      
  l_p_mutex_lock_9:
pop eax
ret

// IN: es:ecx -> mutex
// KEEP: all
p_mutex_unlock:
mov byte ptr [es:ecx], 0
ret

// IN: es:ecx -> mutex
// KEEP: all
p_mutex_init:
mov byte ptr [es:ecx], 0
ret

// IN: ebx = global memory block, edx = type
p_clip_set:
cmp ebx, HEAP_START_GLOBAL
jb l_p_clip_set_9
cmp ebx, HEAP_END_GLOBAL
jnb l_p_clip_set_9

push ebx
 push edx
  mov ebx, p_clip
  call m_heap_free_global
 pop edx
pop ebx

xor eax, eax
dec eax
mov p_clip, ebx
mov [es:ebx - sizeof HeapRec + offset HeapRec.type], eax  // -1
mov p_clip_type, edx

mov ecx, WM_NEW_CLIP
xor edx, edx
xor esi, esi
call p_msg_post_to_all

l_p_clip_set_9:
ret

// OUT: ebx = global memory block, ecx = size, edx = type
p_clip_get:
mov ebx, p_clip
mov edx, p_clip_type
xor ecx, ecx
test ebx, ebx
jz l_p_clip_get_9
  mov ecx, [es:ebx - sizeof HeapRec + offset HeapRec.size]
  
l_p_clip_get_9:
ret

p_enter:
push eax
  l_p_enter_1:
    mov al, 1
    lock xchg al, p_load_busy
    test al, al
    jz l_p_enter_9
      call p_noop
      jmp l_p_enter_1
  
  l_p_enter_9:
  mov eax, p_current
  or word ptr [es:eax + offset ThreadRec.flags], THREAD_FLAGS_P_LOAD_BUSY
pop eax
ret

p_leave:
push eax
  mov eax, p_current
  mov p_load_busy, 0
  and word ptr [es:eax + offset ThreadRec.flags], -1 - THREAD_FLAGS_P_LOAD_BUSY
pop eax
ret

// IN: esi -> old thread, edi -> new thread
// BEFORE: cli
p_switch_task:
cmp esi, edi
jz near l_p_switch_task_8

// FPU
test byte ptr [es:esi + offset ThreadRec.flags], THREAD_FLAGS_USE_FPU
jz l_p_switch_task_2
  
  clts
  fsave [es:esi + offset ThreadRec.fstate]
  
l_p_switch_task_2:

// Timer
call h_timer_read
sub [es:esi + offset ThreadRec.tmr_spent], eax
add [es:edi + offset ThreadRec.tmr_spent], eax

// Switch
mov p_current, edi

// Switch - jmp
mov eax, edi
sub eax, VA_THREADS
shr eax, 12 // assert sizeof ThreadRec = 4096
shl eax, 3  // * 8
add eax, KERNEL_GDT_SIZE
mov word ptr p_jmp[4], ax
jmp far p_jmp

// FPU
test byte ptr [es:esi + offset ThreadRec.flags], THREAD_FLAGS_USE_FPU
jz l_p_switch_task_6
  
  clts
  frstor [es:esi + offset ThreadRec.fstate]
  
l_p_switch_task_6:

l_p_switch_task_8:
ret

// IN: esi = current task, edi = next task
// KEEP: esi, edi
p_set_next_preempt:
call h_timer_read
movzx eax, ax
push eax
  // Remove preempt
  mov edx, TMR_THREADID_WND_PREEMPT
  xor ebx, ebx
  push esi
   push edi
    call h_timer_remove
   pop edi
   // Add new preempt
   push edi
    mov ecx, [es:edi + offset ThreadRec.priority]
    mov edx, TMR_THREADID_WND_PREEMPT
    xor ebx, ebx
    mov edi, ebx
    call h_timer_add
   pop edi
  pop esi
  // Correct time
  call h_timer_read
  movzx eax, ax
pop edx
sub edx, eax  // edx = new_time - old_time
add [es:esi + offset ThreadRec.tmr_spent], edx
add tmr_total, edx
ret

p_idle_thread:
mov dx, SELECTOR_KERNEL_DATA
mov bx, SELECTOR_ALL_DATA
mov ds, dx
mov es, bx
sti
p_idle_thread_5:
  call p_noop
  jmp short p_idle_thread_5

// IN: ecx = stack size, es:edi -> ThreadRec
// KEEP: edi
p_alloc_stack3:
add ecx, 4096

push ecx
 push edi

  call m_heap_alloc_aligned

 pop edi
pop ecx

test al, al
jnz l_p_alloc_stack3_9

  mov [es:edi + offset ThreadRec.stack3_ptr], ebx
  mov [es:edi + offset ThreadRec.stack3_aligned], edx
  add ecx, edx
  mov [es:edi + offset ThreadRec.new_esp], ecx
  
  mov al, 0

l_p_alloc_stack3_9:
ret

l_p_create_thread_inner_x1:
popfd
mov al, ERC_TOO_MANY_THREADS
ret

l_p_create_thread_inner_x2:
popfd
mov al, ERC_NOT_ENOUGH_MEMORY
ret

// OUT: al = 0 || errorcode, [es:edi] = new ThreadRec
p_create_thread_inner:

pushfd

  cli

  // Find place in process table at VA_THREADS + (MAX_THREADS * sizeof ThreadRec)
  xor edi, edi
  l_p_create_thread_inner_11:
    cmp edi, p_threads_max_size
    jnb l_p_create_thread_inner_16
      mov eax, [es:edi + VA_THREADS + offset ThreadRec.flags]
      or eax, eax
      jz l_p_create_thread_inner_foundfree
        add edi, SIZE_THREADREC
        jmp l_p_create_thread_inner_11
  
  l_p_create_thread_inner_16:
  // Allocate a new page?
  cmp edi, MAX_THREADS * SIZE_THREADREC
  jnb l_p_create_thread_inner_x1
  
  push edi
    call m_enter
    call m_alloc1
    call m_leave
  pop edi
  or esi, esi
  jz l_p_create_thread_inner_x2
  
  or esi, PG_MASK_P | PG_MASK_W | PG_MASK_G
  shr edi, 10  // log2 4096 - log2 4
  mov [PA_PT_THREADS + edi], esi
  shl edi, 10
  add p_threads_max_size, 4096
  
  l_p_create_thread_inner_foundfree:
  // Free slot at VA_THREADS + edi
  add edi, VA_THREADS
  push edi
    // Copy ThreadRec
    mov esi, p_current
    push ds
      push es
      pop ds
      mov ecx, SIZE_THREADREC / 4
      cld
      rep movsd
    pop ds
  pop edi
  
  mov dword [es:edi + offset ThreadRec.flags], THREAD_FLAGS_VALID | THREAD_FLAGS_USE_FPU
  
  // Update new ThreadRec
  xor eax, eax
  mov [es:edi + offset ThreadRec.next], eax
  mov [es:edi + offset ThreadRec.last], eax
  mov [es:edi + offset ThreadRec.msgw], eax
  mov [es:edi + offset ThreadRec.msgr], eax
  mov [es:edi + offset ThreadRec.msgusrr], eax
  mov [es:edi + offset ThreadRec.msgusrw], eax
  mov [es:edi + offset ThreadRec.catch.flags], eax
  
popfd

// stdin  IN: eax = 0
mov [es:edi + offset ThreadRec.stdin], eax

// stdout
mov ecx, [es:edi + offset ThreadRec.stdout]
test ecx, STDOUT_WIN
jz l_create_thread_inner_66
  
  l_create_thread_inner_61:
  mov ecx, p_current
  sub ecx, VA_THREADS
  shr ecx, 12  // assert sizeof ThreadRec = 4096
  or ecx, STDOUT_MSG | 16384
  mov [es:edi + offset ThreadRec.stdout], ecx
  //mov dword ptr [es:edi + offset ThreadRec.stdout], 0 //$$$
  jmp short l_create_thread_inner_68
  
l_create_thread_inner_66:
test ecx, STDOUT_FILE
jnz l_create_thread_inner_61

l_create_thread_inner_68:

// stderr
mov ecx, [es:edi + offset ThreadRec.stderr]
test ecx, STDOUT_WIN
jz l_create_thread_inner_76
  
  l_create_thread_inner_71:
  mov ecx, p_current
  sub ecx, VA_THREADS
  shr ecx, 12  // assert sizeof ThreadRec = 4096
  or ecx, STDOUT_MSG | 16384
  mov [es:edi + offset ThreadRec.stderr], ecx
  jmp short l_create_thread_inner_78
  
l_create_thread_inner_76:
test ecx, STDOUT_FILE
jnz l_create_thread_inner_71

l_create_thread_inner_78:

// TIB
mov eax, edi
sub eax, VA_THREADS
shr eax, 12  // assert sizeof ThreadRec = 4096
shl eax, 3
or al, 3
add ax, KERNEL_GDT_SIZE + (MAX_THREADS * 8)
mov fs, ax
mov gs, ax

// selectors
mov word ptr [es:edi + offset TssRec.cs], cs
mov word ptr [es:edi + offset TssRec.ds], ds
mov word ptr [es:edi + offset TssRec.es], es
mov word ptr [es:edi + offset TssRec.fs], fs
mov word ptr [es:edi + offset TssRec.gs], gs

// stack
mov word ptr [es:edi + offset TssRec.ss0], es
mov word ptr [es:edi + offset TssRec.ss], es
mov eax, edi
add eax, offset ThreadRec.pl0stack + PL0_STACK_SIZE
mov [es:edi + offset TssRec.esp0], eax
mov [es:edi + offset TssRec.esp], eax
xor eax, eax
mov [es:edi + offset ThreadRec.new_esp], eax

mov al, 0
ret

l_p_create_process_inner_x1:
popfd
mov al, ERC_TOO_MANY_PROCS
ret

l_p_create_process_inner_x2:
mov al, ERC_NOT_ENOUGH_MEMORY

l_p_create_process_inner_x3:
popfd
ret

// OUT: al = 0 || errorcode, es:edi -> process
p_create_process_inner:

pushfd

  cli
  
  // Find place in process table at VA_PROCS
  xor edi, edi
  l_p_create_process_inner_11:
    cmp edi, p_procs_max_size
    jnb l_p_create_process_inner_16
      mov eax, [es:edi + VA_PROCS + offset ProcessRec.flags]
      test al, PROC_FLAGS_VALID
      jz l_p_create_process_inner_foundfree
        add edi, sizeof ProcessRec
        jmp l_p_create_process_inner_11
  
  l_p_create_process_inner_16:
  // Allocate a new page?
  cmp edi, MAX_PROCS * sizeof ProcessRec
  jnb l_p_create_process_inner_x1
  
  push edi
    call m_enter
    call m_alloc1
    call m_leave
  pop edi
  or esi, esi
  jz l_p_create_process_inner_x2
  
  or esi, PG_MASK_P | PG_MASK_W | PG_MASK_G
  shr edi, 10  // log2 4096 - log2 4
  mov [PA_PT_PROCS + edi], esi
  shl edi, 10
  add p_procs_max_size, 4096
  
  // Zero new page - auto in m_alloc1
  /*
  push edi
    xor eax, eax
    add edi, VA_PROCS
    mov ecx, 4096 / 4
    cld
    rep stosd
  pop edi
  */
  
  l_p_create_process_inner_foundfree:
  // Free slot at VA_PROCS + edi
  add edi, VA_PROCS
  
  push edi
    // Zero ProcessRec
    xor eax, eax
    mov ecx, sizeof ProcessRec / 4
    cld
    rep stosd
    // Create main thread
    call p_create_thread_inner
    mov esi, edi
  pop edi
  or al, al
  jnz l_p_create_process_inner_x3
  
  // PrevInstance
  mov ebx, p_current
  mov ebx, [es:ebx + offset ThreadRec.process]
  mov [es:edi + offset ProcessRec.previnstance], ebx
  
  // Update memused
  mov dword[es:edi + offset ProcessRec.memused], 2 * 4096
  
  // MainThread, process
  mov [es:edi + offset ProcessRec.mainthread], esi
  mov [es:esi + offset ThreadRec.process], edi
  
  // eip
  mov dword [es:esi + offset TssRec.eip], offset p_new_proc
  
  // Allocate page directory
  mov eax, [es:edi + offset ProcessRec.cr3]
  jnz l_p_create_process_inner_6
    push edi
     push esi
      call m_enter
      call m_alloc1
      call m_leave
     pop ebx
    pop edi
    
    test esi, esi
    jz near l_p_create_process_inner_x2
    
    mov [es:edi + offset ProcessRec.cr3], esi
    jmp short l_p_create_process_inner_7
    
  l_p_create_process_inner_6:
    mov ebx, esi
    mov esi, eax
    // Zero private part of the page directory
    push edi
      mov edi, VA_VAR
      mov ecx, VA_GLOBAL >> 20 / 4
      xor eax, eax
      cld
      rep stosd
    pop edi
    
  l_p_create_process_inner_7:
  mov [es:ebx + offset TssRec.cr3], esi
  
  // Copy the common part of the page directory
  push edi
  
    or esi, PG_MASK_P | PG_MASK_W
    mov [PA_PT_VAR], esi
    invlpg [es:VA_VAR]
    
    mov edi, VA_VAR + (VA_GLOBAL >> 20)
    mov esi, PA_PD0 + (VA_GLOBAL >> 20)
    mov ecx, (4096  - (VA_GLOBAL >> 20)) / 4
    cld
    rep movsd
  
  pop edi
  
popfd

xor eax, eax
ret

// IN: edi = threadptr, ebp
// KEEP: edi
p_kill_thread_inner:
mov ebx, edi
call fs_release_thread  // keep edi
call h_timer_remove_all // keep edi
call p_tib_remove       // keep edi

// release m_busy
test byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_M_BUSY
jz l_p_kill_thread_inner_1
  mov m_busy, 0
  
l_p_kill_thread_inner_1:

// release m_heap_busy
test byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_M_HEAP_BUSY
jz l_p_kill_thread_inner_2
  mov m_heap_busy, 0
  
l_p_kill_thread_inner_2:

// release fs_busy
test byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_DISK_BUSY
jz l_p_kill_thread_inner_3
  mov fs_busy, 0
  
l_p_kill_thread_inner_3:

// release p_load_busy
test word ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_P_LOAD_BUSY
jz l_p_kill_thread_inner_4
  mov p_load_busy, 0
  
l_p_kill_thread_inner_4:

// release g_busy
test word ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_G_BUSY
jz l_p_kill_thread_inner_5
  mov g_busy, 0
  
l_p_kill_thread_inner_5:

// release thread
xor eax, eax
mov [es:edi + offset ThreadRec.flags], eax
//... release unused ThreadRecs at the end

cmp edi, p_current
jnz l_p_kill_thread_inner_8

  mov [ss:ebp - 4], edi  // p_kill_current
  jmp short l_p_kill_thread_inner_9

l_p_kill_thread_inner_8:
push edi
  call p_stop
pop edi

l_p_kill_thread_inner_9:
ret

// IN: ebx = processptr, edx = exit code
p_kill_process_inner:

// remove children PROC_FLAGS_KILL_WITH_PARENT
xor ecx, ecx

l_p_kill_process_inner_15:
  cmp ecx, p_procs_max_size
  jnb l_p_kill_process_inner_18
    mov eax, [es:ecx + VA_PROCS + offset ProcessRec.flags]
    test eax, PROC_FLAGS_KILL_WITH_PARENT
    jz l_p_kill_process_inner_17
      mov eax, [es:ecx + VA_PROCS + offset ProcessRec.previnstance]
      cmp eax, ebx
      jnz l_p_kill_process_inner_17
        // kill ecx
        push ecx
         push ebx
          push edx
           mov ebx, ecx
           add ebx, VA_PROCS
           mov eax, [es:ebx + offset ProcessRec.flags]
           test al, PROC_FLAGS_VALID
           jz l_p_kill_process_inner_16
             xor edx, edx
             call p_kill_process_inner
             
           l_p_kill_process_inner_16:
          pop edx
         pop ebx
        pop ecx
      
    l_p_kill_process_inner_17:
    add ecx, sizeof ProcessRec
    jmp short l_p_kill_process_inner_15
    
l_p_kill_process_inner_18:
  
// remove windows
push ebx
 push edx
  call g_remove_all_windows
 pop edx
pop ebx

pushfd
  cli

  // release threads
  mov edi, VA_THREADS
  
  l_p_kill_process_inner_21:
    cmp [es:edi + offset ThreadRec.process], ebx
    jnz l_p_kill_process_inner_22

      push ebx
       push edx
        call p_kill_thread_inner  // keep edi
       pop edx
      pop ebx
  
    l_p_kill_process_inner_22:  
    add edi, 4096  // assert sizeof ThreadRec = 4096
    mov eax, p_threads_max_size
    add eax, VA_THREADS
    cmp edi, eax
    jb l_p_kill_process_inner_21
  
  // release memory global
  mov esi, HEAP_START_GLOBAL
  
  l_p_kill_process_inner_5:
    cmp esi, HEAP_END_GLOBAL
    jnb l_p_kill_process_inner_6
      mov eax, [es:esi + offset HeapRec.type]
      cmp eax, ebx
      jnz l_p_kill_process_inner_58
        push ebx
         push esi
          push edx
            mov ebx, esi
            add ebx, sizeof HeapRec
            call m_heap_free_global
          pop edx
         pop esi
        pop ebx
        
      l_p_kill_process_inner_58:
      mov eax, [es:esi + offset HeapRec.next]
      cmp eax, esi
      jna l_p_kill_process_inner_6
        mov esi, eax
        jmp l_p_kill_process_inner_5
  
  l_p_kill_process_inner_6:

  // post message to prev
  push ebx
    push edx
      mov edx, ebx
      sub edx, VA_PROCS
      shr edx, 9  // assert sizeof ProcessRec == 512
      mov ebx, [es:ebx + offset ProcessRec.previnstance]
      sub ebx, VA_PROCS
      shr ebx, 9  // assert sizeof ProcessRec == 512
      or ebx, WIN_NONE << 16
      mov ecx, WM_TERMINATED
    pop esi
    // IN: ebx = wndid:pid, ecx = msg, edx = wp, esi = lp
    call p_msg_post
  pop ebx
  
  // release memory
  push ebx
    mov ebx, [es:ebx + offset ProcessRec.cr3]
    call m_pages_free_all
  pop ebx
  
  // mark as unused
  xor eax, eax
  mov [es:ebx + offset ProcessRec.flags], eax
  
  //... release unused ProcessRecs at the end
  
  mov al, 0
  
popfd
ret

strz_load: db "c:/system/dlls/\0"

l_load_x:
mov esi, [ss:ebp - 4]
call fs_fclose
mov al, ERC_PE_INVALID_HEADER

l_load_x2:
// 77h => es:esi -> import function name
mov ebx, [ss:ebp - 12]  // image base
mov edx, [ss:ebp - 44]  // ebp - 44 -> import dll name
jmp l_load_9

// IN: es:edx -> filenamez
// OUT: al = erc, esi = new eip adr, ecx = stack size,
//      edi = export table adr, ebx = image base
// BEFORE: p_enter
p_load:
push ebp
mov ebp, esp
sub esp, 44
  
  xor eax, eax
  mov [ss:ebp - 12], eax  // image base
  
  // check depth
  inc p_load_depth
  cmp p_load_depth, MAX_LOAD_DEPTH
  jna l_load_1
    mov al, ERC_PE_IMPORT_DEPTH_OVERFLOW
    jmp l_load_x2
    
  l_load_1:
  
  // fopen
  mov al, FOPEN_READ
  mov ah, 0  // fs_takelink
  mov bl, 0  // fs_hack
  call fs_fopen
  mov [ss:ebp - 4], esi  // ebp - 4 -> fhandle
  test al, al
  jnz l_load_x2

  // CPARHDR
  xor edx, edx
  mov ebx, 8
  call fs_fsetpos

  mov esi, [ss:ebp - 4]
  mov edi, ebp
  sub edi, 8  // assert ss = es, ebp - 8 -> cparhdr
  mov ecx, 2
  call fs_fread
  cmp word[ss:ebp - 8], 4
  jnz l_load_x

  // LFANEW
  mov esi, [ss:ebp - 4]
  xor edx, edx
  mov ebx, 60
  call fs_fsetpos

  mov esi, [ss:ebp - 4]
  mov edi, ebp
  sub edi, 8  // assert ss = es, ebp - 8 -> lfanew
  mov ecx, 4
  call fs_fread

  // number of sections
  mov esi, [ss:ebp - 4]
  xor edx, edx
  mov ebx, [ss:ebp - 8]
  add ebx, 6
  call fs_fsetpos

  mov esi, [ss:ebp - 4]
  mov edi, ebp
  sub edi, 28  // assert ss = es, ebp - 28 -> number of sections
  mov ecx, 2
  call fs_fread

  // size of optional header
  mov esi, [ss:ebp - 4]
  xor edx, edx
  mov ebx, [ss:ebp - 8]
  add ebx, 14h
  call fs_fsetpos

  mov esi, [ss:ebp - 4]
  mov edi, ebp
  sub edi, 24  // assert ss = es, ebp - 24 -> size of OH
  mov ecx, 2
  call fs_fread
  cmp word[ss:ebp - 24], 224
  jb near l_load_x

  // size of optional header
  mov esi, [ss:ebp - 4]
  xor edx, edx
  mov ebx, [ss:ebp - 8]
  add ebx, 34h
  call fs_fsetpos
  
  mov esi, [ss:ebp - 4]
  mov edi, ebp
  sub edi, 12  // assert ss = es, ebp - 12 -> ImageBase
  mov ecx, 4
  call fs_fread
  /*
  cmp dword ptr [ss:ebp - 12], 0x400000
  jnb l_load_15
    add dword ptr [ss:ebp - 12], 0x60000000
    //... reloc
    
  l_load_15:
  */
  // entry point from imagebase
  mov esi, [ss:ebp - 4]
  xor edx, edx
  mov ebx, [ss:ebp - 8]
  add ebx, 28h
  call fs_fsetpos
  
  mov esi, [ss:ebp - 4]
  mov edi, ebp
  sub edi, 16  // assert ss = es, ebp - 16 -> new_eip
  mov ecx, 4
  call fs_fread
  
  // stack size
  mov esi, [ss:ebp - 4]
  xor edx, edx
  mov ebx, [ss:ebp - 8]
  add ebx, 60h
  call fs_fsetpos

  mov esi, [ss:ebp - 4]
  mov edi, ebp
  sub edi, 20  // assert ss = es, ebp - 20 -> stack_size
  mov ecx, 4
  call fs_fread
  
  // * already loaded? *
  mov ebx, [ss:ebp - 12]  // image base
  call m_pages_getphysadr
  cmp ebx, 0
  jz l_load_20
    
    // already loaded - fclose
    mov esi, [ss:ebp - 4]
    call fs_fclose
    
    jmp l_load_8
    
  l_load_20:  // not loaded
  
  // create stack3
  mov edi, p_current
  mov eax, [es:edi + offset ThreadRec.new_esp]
  test eax, eax
  jnz l_load_21
    mov ecx, [ss:ebp - 20]  // stack size
    
    call p_alloc_stack3  // set new_esp
    
    test al, al
    jz l_load_21
      push eax
        mov esi, [ss:ebp - 4]
        call fs_fclose
      pop eax
      jmp l_load_9
    
  l_load_21:
  // load header
  mov ebx, [ss:ebp - 12]  // image base
  mov ecx, 1
  call m_pages_alloc
  
  mov esi, [ss:ebp - 4]
  xor edx, edx
  xor ebx, ebx
  call fs_fsetpos
  
  mov esi, [ss:ebp - 4]
  mov edi, [ss:ebp - 12]  // image base
  mov ecx, [ss:ebp - 8]  // lfanew
  movzx eax, word[ss:ebp - 24] // size of OH
  add ecx, eax
  add ecx, 18h
  call fs_fread
  
  // * sections *
  movzx ecx, word[ss:ebp - 28]  // ebp - 28 -> number of sections
  jecxz l_load_52
  
  xor eax, eax
  mov [ss:ebp - 28], eax        // ebp - 28 -> section offset
  
  l_load_5:
  
   push ecx
   
    mov esi, [ss:ebp - 4]
    xor edx, edx
    mov ebx, [ss:ebp - 8]  // lfanew
    add ebx, 18h
    movzx eax, word[ss:ebp - 24]  // sizeof optional header
    add ebx, eax
    add ebx, [ss:ebp - 28]  // section offset
    call fs_fsetpos
    
    mov esi, [ss:ebp - 4]
    mov edi, VA_SYSTEM + offset section
    mov ecx, sizeof SectionEntry
    add [ss:ebp - 28], ecx
    call fs_fread
    
    mov eax, [ss:ebp - 12]  // image base
    mov ebx, section.VirtualAddress
    add ebx, eax
    
    cmp ebx, 0x80000000
    jb l_load_55
      // access denied
      
      l_load_51:
      pop ecx
      
      l_load_52:
      
      // fclose
      mov esi, [ss:ebp - 4]
      call fs_fclose
      
      mov al, ERC_PE_INVALID_ADR
      jmp l_load_x2
      
    l_load_55:
    mov ecx, section.VirtualSize  // section size
    
    mov eax, ebx
    add eax, ecx
    cmp eax, 0x80000000
    jnb l_load_51  // access denied
    
    cmp eax, ebx
    jb l_load_51
    
    push ebx
    
      add ecx, 4095
      shr ecx, 12
      jecxz l_load_6

        call m_pages_alloc

      l_load_6:
      mov esi, [ss:ebp - 4]
      xor edx, edx
      mov ebx, section.PointerToRawData
      call fs_fsetpos
    
    pop edi    
    
    mov esi, [ss:ebp - 4]
    mov ecx, section.SizeOfRawData
    call fs_fread
    
   pop ecx
  
  dec ecx
  test ecx, ecx
  jnz near l_load_5
  
  // fclose
  mov esi, [ss:ebp - 4]
  call fs_fclose
  
  // * imports *
  mov edi, [ss:ebp - 12]  // image base
  add edi, [ss:ebp - 8]   // lfanew
  add edi, 78h  // export table
  mov [ss:ebp - 32], edi  // ebp - 32 -> export table adr
  add edi, 8    // import table
  mov ebx, [es:edi]
  mov ecx, [es:edi + 4]
  add ebx, [ss:ebp - 12]  // image base
  
  test ecx, ecx
  jz near l_load_8
    mov esi, ebx  // esi = import table adr
    
    l_load_61:
      cmp esi, VA_ACCESS
      jb l_load_62
        
        l_load_616:
        mov al, ERC_PE_INVALID_ADR
        jmp l_load_x2
        
      l_load_62:
      mov ebx, [es:esi]  // import lookup table
      test ebx, ebx
      jz near l_load_8
        
        mov ebx, [es:esi + 16]  // import address table
        add ebx, [ss:ebp - 12]  // image base
        
        push esi
         push ebx
          // dll file name - 1st: process_dir + dll_file_name
          mov esi, p_current
          mov esi, [es:esi + offset ThreadRec.process]
          add esi, offset ProcessRec.filename
          mov edi, offset p_dll
          mov ecx, MAX_PATH
          
          l_load_635:
            mov al, [es:esi]
            mov [edi], al
            cmp al, 0
            jz l_load_638
              inc esi
              inc edi
              loop l_load_635
              
            jmp short l_load_616
            
          l_load_638:
          cmp byte ptr [edi], '/'
          jz l_load_642
            dec edi
            cmp edi, offset p_dll
            ja l_load_638
              jmp short l_load_616  // pop?
            
          l_load_642:
          inc edi
          
         pop ebx
        pop esi
        push esi
         push ebx
         
          mov esi, [es:esi + 12]  // imported dll filename
          add esi, [ss:ebp - 12]  // image base
          mov [ss:ebp - 44], esi  // ebp - 44 -> import name
          mov ecx, offset p_dll + MAX_PATH
          sub ecx, edi
          
          l_load_645:
            mov al, [es:esi]
            mov [edi], al
            cmp al, 0
            jz l_load_648
              inc esi
              inc edi
              loop l_load_645
            
            jmp l_load_616  // pop?
            
          l_load_648:
          mov edx, VA_SYSTEM + offset p_dll
          /*
          //$$$
          pushad
            mov esi, edx
            call wrs
            //call ww
          popad
          */
          call p_load
          
          test al, al
          jz l_load_70
            cmp al, ERC_FILE_NOT_FOUND
            jnz near l_load_9  // pop?
            
            l_load_650:
            // dll file name - 2nd: /system/dlls/ + dll_file_name
            mov esi, PA_KERNEL_CODE + offset strz_load
            mov edi, offset p_dll
            
            l_load_655:
              mov al, [esi]
              mov [edi], al
              cmp al, 0
              jz l_load_658
                inc esi
                inc edi
                jmp short l_load_655
              
            l_load_658:
            mov al, byte ptr boot_disk  // correct disk letter
            or al, 64
            mov p_dll[0], al
            
         pop ebx
        pop esi
        push esi
         push ebx
            
            mov esi, [es:esi + 12]  // imported dll filename
            add esi, [ss:ebp - 12]  // image base
            mov ecx, offset p_dll + MAX_PATH
            sub ecx, edi
            
            l_load_665:
              mov al, [es:esi]
              mov [edi], al
              cmp al, 0
              jz l_load_668
                inc esi
                inc edi
                loop l_load_665
              
              jmp l_load_616
              
            l_load_668:
            mov edx, VA_SYSTEM + offset p_dll
            /*
            //$$$
            pushad
              mov esi, edx
              call wrs
              //call ww
            popad
            */
            call p_load
            
            test al, al
            jnz near l_load_9  // pop?
              
          l_load_70:
          mov [ss:ebp - 36], ebx  // child image base
          mov [ss:ebp - 40], esi  // child main ofs
          
          // set adrs  IN: edi -> export table
          
         pop ebx
         push ebx  // ebx = import address table adr
          
          l_load_71:
          cmp ebx, 0x80000000
          jnb near l_load_616  // pop?
          
          mov eax, [es:ebx]
          test eax, eax
          jz near l_load_78
            test eax, 0x80000000  // not access
            jz l_load_72
              //... ordinal
              mov al, ERC_PE_ORDINAL
              jmp l_load_x2  // pop?
              
            l_load_72:
            // name
            add eax, [ss:ebp - 12]  // image base
            add eax, 2  // hint
            mov esi, eax  // es:esi -> import name
            /*
            //$$$
            pushad
              call wrs
            popad
            */
            push ebx
              mov ebx, [ss:ebp - 36]
              call p_get_fn_adr
            pop ebx
            
            cmp al, 0
            jnz l_load_notfound
              
              // found
              mov [es:ebx], edx
//call wregs//$$$
              
              add ebx, 4
              jmp l_load_71
            
            
            l_load_notfound:  
            mov esi, [es:ebx]
            add esi, 2  // hint
            add esi, [ss:ebp - 12]  // es:esi -> import name
            
            //call wrs//$$$
            
            mov al, ERC_PE_NOT_FOUND
            jmp l_load_x2  // pop?
          
          
          l_load_78:
          
          // call dll main
          
          call p_leave
          
          mov esi, [ss:ebp - 40]  // child main ofs
          //... call esi with esp3 (new_esp)
          
          call p_enter
          
         pop ebx
        pop esi
        add esi, 20
        jmp l_load_61
        
  l_load_8:
  
  // output
  mov ebx, [ss:ebp - 12]  // image base
  mov esi, [ss:ebp - 16]  // new eip
  add esi, ebx
  mov ecx, [ss:ebp - 20]  // stack size
  mov edi, [ss:ebp - 32]  // export table adr
  mov edi, [es:edi]
  add edi, ebx  // export table
  
  mov al, 0

l_load_9:
mov esp, ebp
pop ebp
ret

// IN: esi -> fn name, ebx -> hinstance(image base)
// OUT: al = erc, edx = function adr
// KEEP: esi
// BEFORE: p_enter
p_get_fn_adr:
mov edi, ebx  // image base
add edi, [es:ebx + 60]   // lfanew
add edi, 78h  // export table directory
mov edi, [es:edi]
add edi, ebx  // export table

xor eax, eax
mov p_i1, eax
mov eax, [es:edi + 24]  // name pointers count
test eax, eax
jz near l_get_fn_adr_notfound
  dec eax
  mov p_i2, eax
  mov edx, [es:edi + 32]  // name pointers rva
  add edx, ebx  // edx -> name pointers
  
  push edi
    
    // binary search
    l_get_fn_adr_1:
     push esi
     
      mov eax, p_i1
      add eax, p_i2
      //inc eax  //?
      shr eax, 1
      mov ecx, eax  // ecx = median
      shl eax, 2
      mov edi, edx
      add edi, eax
      mov edi, [es:edi]  // name pointer rva
      add edi, ebx  // es:edi -> export name
      
      /*
      //$$$
      pusha
       push edi
        mov bl, 7
        call wrs
       pop esi
       mov bl, 0Eh
       call wrs
       //call wregs
      popa
      */
      
      // compare esi, edi
      l_get_fn_adr_5:
        mov al, [es:esi]
        cmp al, [es:edi]
        jnz l_get_fn_adr_7
          test al, al
          jz l_get_fn_adr_found
            inc esi
            inc edi
            jmp short l_get_fn_adr_5
        
      l_get_fn_adr_7:
      jb l_get_fn_adr_8
        mov eax, p_i1
        cmp eax, p_i2
        jnb l_get_fn_adr_notfound
        
        inc ecx  //?
        mov p_i1, ecx

        pop esi

        jmp short l_get_fn_adr_1
        
      l_get_fn_adr_8:
        mov eax, p_i1
        cmp eax, p_i2
        jnb l_get_fn_adr_notfound
        
        mov p_i2, ecx
        
        pop esi
        
        jmp short l_get_fn_adr_1
      
    l_get_fn_adr_found:
    
    pop esi
    
  pop edi
  mov edx, [es:edi + 36]  // ordinal table rva
  add edx, ebx  // edx -> ordinals
  movzx eax, word ptr [es:ecx * 2 + edx]
  mov edx, [es:edi + 28]  // address table rva
  add edx, ebx  // edx -> adrs
  mov edx, [es:eax * 4 + edx]  // eax = adr
  add edx, ebx  // child image base
  mov al, 0
  jmp short l_get_fn_adr_9
  
    l_get_fn_adr_notfound:
    
    pop esi
  
  pop edi
  mov al, ERC_PE_NOT_FOUND
  xor edx, edx
  
l_get_fn_adr_9:
ret

// new process
// IN: ProcessRec.filename, mainthread.esi, mainthread.edi
p_new_proc:
call m_heap_init

// load

call p_enter
  
  mov p_load_depth, 0
  mov byte ptr p_dll[0], 0
  
  mov edx, p_current
  mov edx, [es:edx + offset ThreadRec.process]
  add edx, offset ProcessRec.filename
  
  call p_load  // OUT: esi, ecx, edi, ebx, edx
  
  test ebx, ebx
  jz l_p_new_proc_11
    mov ebx, edx
    
  l_p_new_proc_11:
  test al, al
  jnz near p_new_proc_error
  
  // new eip, KEEP ecx, ebx
  mov edi, p_current
  mov [es:edi + offset ThreadRec.new_eip], esi
  
call p_leave

// args
mov edx, [es:edi + offset ThreadRec.process]
mov esi, [es:edx + offset ProcessRec.args]
test esi, esi
jz l_p_new_proc_28
  call strlen
  inc ecx
  push ecx
   push esi
    push edx
      call m_heap_alloc_local
    pop edx
   pop esi
  pop ecx
  mov edi, ebx
  test edi, edi
  jz l_p_new_proc_27
    push ds
     push esi
      push es
      pop ds
      cld
      rep movsb
     pop esi
    pop ds
    
  l_p_new_proc_27:
  mov [es:edx + offset ProcessRec.args], ebx
  mov ebx, esi
  call m_heap_free_global
  
l_p_new_proc_28:

// env_vars
mov edi, p_current
mov edx, [es:edi + offset ThreadRec.process]
mov esi, [es:edx + offset ProcessRec.env_vars]
test esi, esi
jz l_p_new_proc_38
  xor ecx, ecx
  
  push esi
    
    l_p_new_proc_35:
      mov al, [es:esi]
      inc esi
      inc ecx
      mov ah, [es:esi + 1]
      test ax, ax
      jnz l_p_new_proc_35
      
  pop esi
  
  inc ecx

  push ecx
   push esi
    push edx
      call m_heap_alloc_local
    pop edx
   pop esi
  pop ecx
  mov edi, ebx
  test edi, edi
  jz l_p_new_proc_37
    push ds
     push esi
      push es
      pop ds
      cld
      rep movsb
     pop esi
    pop ds
    
  l_p_new_proc_37:
  mov [es:edx + offset ProcessRec.env_vars], ebx
  mov ebx, esi
  call m_heap_free_global
  
l_p_new_proc_38:
jmp p_new_thread



p_npe1: db "\r\nError\0"
p_npe2: db "\r\nAp: \0"
p_npe3: db "\r\nModule: \0"
p_npe4: db "\r\nFunction: \0"
p_npe5: db " - \0"

p_new_proc_error:  // IN: al, ebx, esi

push esi
  // Error
  push eax
   push ebx
    mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset p_npe1
    call strlen
    mov bl, ERROR_COLOR
    call s_write
   pop ebx
  pop eax
  push eax
   push ebx
    movzx eax, al
    mov ecx, 16
    mov bl, ERROR_COLOR
    call writen
    
    // FileName
    mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset p_npe2
    call strlen
    mov bl, ERROR_COLOR
    call s_write
    mov esi, p_current
    mov esi, [es:esi + offset ThreadRec.process]
    add esi, offset ProcessRec.filename
    call strlen
    mov bl, ERROR_COLOR
    call s_write
   
    // Module
    mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset p_npe3
    call strlen
    mov bl, ERROR_COLOR
    call s_write
   pop esi // ebx
   test esi, esi
   jz l_p_new_proc_error_3
     call strlen
     mov bl, ERROR_COLOR
     call s_write
     //mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset p_npe5
     //call strlen
     //mov bl, ERROR_COLOR
     //call s_write
     
   l_p_new_proc_error_3:
   //mov esi, VA_SYSTEM + offset p_dll
   //call strlen
   //mov bl, ERROR_COLOR
   //call s_write
   
   // leave
   call p_leave
    
  pop eax
pop esi

// erc 77h
cmp al, ERC_PE_NOT_FOUND
jnz p_new_proc_error_4
  push esi
    mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset p_npe4
    call strlen
    mov bl, ERROR_COLOR
    call s_write
  pop esi
  call strlen
  mov bl, ERROR_COLOR
  call s_write

p_new_proc_error_4:
jmp l_fail_after

p_new_thread:
mov edi, p_current
mov edx, [es:edi + offset TssRec.edx]  // transfer

// reset FPU
clts
finit

// stack0
mov eax, edi
add eax, offset ThreadRec.pl0stack + PL0_STACK_SIZE
mov esp, eax

// stack3
push SELECTOR_USER_DATA | 3
push dword ptr [es:edi + offset ThreadRec.new_esp]

// flags
push 0x200 //pushfd

// cs:eip
push SELECTOR_USER_CODE | 3
push dword ptr [es:edi + offset ThreadRec.new_eip]

// selectors
mov ax, SELECTOR_USER_DATA | 3
mov ds, ax
mov es, ax

xor eax, eax

iretd

//ret

// IN: ebx = LA, fs
p_tib_init:
mov ax, fs
test al, 4
jnz l_p_tib_init_9

cmp ax, KERNEL_GDT_SIZE + (MAX_THREADS * 8)
jb l_p_tib_init_9

cmp ax, KERNEL_GDT_SIZE + (MAX_THREADS * 8 * 2)
jnb l_p_tib_init_9

// LA
and ebx, -1 - 4095
mov [fs:0x18], ebx
// Env
mov edi, p_current
mov esi, [es:edi + offset ThreadRec.process]
mov eax, [es:esi + offset ProcessRec.env_vars]
mov [fs:0x1C], eax
// PID
mov eax, esi
sub eax, VA_PROCS
shr eax, 9  // assert sizeof ProcessRec = 512
mov [fs:0x20], eax
// TID
mov eax, edi
sub eax, VA_THREADS
shr eax, 12  // assert sizeof ThreadRec = 4096
mov [fs:0x24], eax

l_p_tib_init_9:
ret

// IN: edi = threadptr
// KEEP: edi
p_tib_remove:
mov eax, edi
sub eax, VA_THREADS
add eax, VA_TIBS
mov ebx, eax
call m_pages_free_page  // keep edi
ret

msg_p_init_x: db 29, "Process initialization failed"

l_p_init_x:
mov esi, offset msg_p_init_x
jmp fdie

p_init:
mov p_load_busy, 0

// Zero PT_PROCS, PT_THREADS
push es
  push ds
  pop es
  mov edi, PA_PT_PROCS
  mov ecx, 4096 / 4  // assert page_size = 4096
  xor eax, eax
  cld
  rep stosd

  mov edi, PA_PT_THREADS
  mov ecx, 4096 / 4  // assert page_size = 4096
  rep stosd
pop es

// Alloc 2 blocks: at VA_PROCS and at VA_THREADS
call m_alloc1
or al, al
jnz l_p_init_x
or esi, PG_MASK_P | PG_MASK_W | PG_MASK_G
mov [PA_PT_PROCS], esi

call m_alloc1
or al, al
jnz l_p_init_x
or esi, PG_MASK_P | PG_MASK_W | PG_MASK_G
mov [PA_PT_THREADS], esi

// Add proc_table to page_directory
mov eax, PA_PT_PROCS | PG_MASK_P | PG_MASK_W | PG_MASK_G
mov [PA_PD0 + (VA_PROCS >> 20)], eax
mov eax, PA_PT_THREADS | PG_MASK_P | PG_MASK_W | PG_MASK_G
mov [PA_PD0 + (VA_THREADS >> 20)], eax

// Init variables
mov eax, 4096
mov p_threads_max_size, eax
mov p_procs_max_size, eax

mov p_current, VA_THREADS

// Init ProcessRec
mov edi, VA_PROCS
mov ecx, sizeof ProcessRec / 4
xor eax, eax
rep stosd

mov eax, cr3
mov [es:VA_PROCS + offset ProcessRec.cr3], eax
mov dword ptr [es:VA_PROCS + offset ProcessRec.flags], PROC_FLAGS_VALID
mov dword ptr [es:VA_PROCS + offset ProcessRec.mainthread], VA_THREADS

// Init ThreadRec
mov edi, VA_THREADS
mov ecx, (4096 - 512) / 4
xor eax, eax
cld
rep stosd
dec eax
mov ecx, 512 / 4
rep stosd

mov word [es:VA_THREADS + offset TssRec.portsofs], 4096 - 512
//mov ax, SELECTOR_TSS
mov ax, KERNEL_GDT_SIZE
ltr ax

mov dx, SELECTOR_LDT
mov [es:VA_THREADS + offset TssRec.ldt], dx
lldt dx

mov eax, cr3
mov [es:VA_THREADS + offset TssRec.cr3], eax

mov eax, VA_THREADS
mov [es:VA_THREADS + offset ThreadRec.next], eax
mov [es:VA_THREADS + offset ThreadRec.last], eax
mov eax, 1 | THREAD_FLAGS_USE_FPU
mov [es:VA_THREADS + offset ThreadRec.flags], eax
mov eax, VA_PROCS
mov [es:VA_THREADS + offset ThreadRec.process], eax
mov eax, PRIORITY0
mov [es:VA_THREADS + offset ThreadRec.priority], eax

// curdir
mov al, byte ptr boot_disk
and al, 31
mov [es:VA_THREADS + offset ThreadRec.curdisk], al
or al, 64
mov edi, VA_THREADS + offset ThreadRec.curdirtext
cld
stosb
mov al, ':'
stosb
mov al, '/'
stosb
xor eax, eax
stosb
mov [es:VA_THREADS + offset ThreadRec.curdir], eax

// stack
mov dx, SELECTOR_ALL_DATA
mov eax, VA_THREADS + offset ThreadRec.pl0stack + PL0_STACK_SIZE
mov [es:VA_THREADS + offset TssRec.ss0], dx
mov [es:VA_THREADS + offset TssRec.ss], dx
mov [es:VA_THREADS + offset TssRec.esp0], eax
mov [es:VA_THREADS + offset TssRec.esp], eax
pop ebx  // :KLUDGE:
  mov ss, dx
  mov esp, eax
push ebx
xor eax, eax
mov [es:VA_THREADS + offset ThreadRec.new_esp], eax

// prepare TIBs
mov ebx, VA_TIBS
call m_pages_alloc_pt
mov ax, KERNEL_GDT_SIZE + (MAX_THREADS * 8)
or al, 3
mov fs, ax

// selectors
mov word[es:VA_THREADS + offset TssRec.cs], cs
mov word[es:VA_THREADS + offset TssRec.ds], ds
mov word[es:VA_THREADS + offset TssRec.es], es
mov word[es:VA_THREADS + offset TssRec.fs], fs
mov word[es:VA_THREADS + offset TssRec.gs], gs

// idle thread
call p_create_thread_inner
and dword [es:edi + offset ThreadRec.flags], -1 - THREAD_FLAGS_USE_FPU
or al, al
jnz near l_p_init_x

mov p_idle, edi
mov dword ptr [es:edi + offset TssRec.eip], offset p_idle_thread
mov dword ptr [es:edi + offset ThreadRec.next], edi
mov dword ptr [es:edi + offset ThreadRec.last], edi

mov fs, word[es:VA_THREADS + offset TssRec.fs]  // restore fs after idle

// create global heap
call m_heap_init_global

// create kernel heap
call m_heap_init_kernel

// create local heap
call m_heap_init

ret

p_noop:
pushad
 pushfd
  cli
  mov esi, p_current
  mov edi, [es:esi + offset ThreadRec.next]
  cmp esi, edi
  jz l_p_noop_8
    cmp esi, p_idle
    jnz l_p_noop_5
      // Remove idle
      mov ebx, [es:esi + offset ThreadRec.last]
      mov [es:ebx + offset ThreadRec.next], edi
      mov [es:edi + offset ThreadRec.last], ebx
      
      mov [es:esi + offset ThreadRec.last], esi
      mov [es:esi + offset ThreadRec.next], esi
      
    l_p_noop_5:
    // Next preempt
    call p_set_next_preempt  // keep esi, edi
    // Do switch
    call p_switch_task
    
  l_p_noop_8:
 popfd
popad
ret

// IN: ecx = stack size, esi = new eip, edx = transfer
// OUT: al = 0 || errorcode, ebx = threadid, es:edi -> ThreadRec
p_create_thread:
push ecx
 push esi
  push edx
    call p_create_thread_inner
  pop edx
 pop esi
pop ecx
xor ebx, ebx
test al, al
jnz l_p_create_thread_9
  
  mov [es:edi + offset ThreadRec.new_eip], esi
  mov [es:edi + offset TssRec.edx], edx  // transfer
  
  call p_alloc_stack3 // keep edi
  or al, al
  jnz l_p_create_thread_9
    
    mov dword[es:edi + offset TssRec.eip], offset p_new_thread
    
    mov ebx, edi
    sub ebx, VA_THREADS
    shr ebx, 12 // assert sizeof ThreadRec = 4096
    
    mov al, 0

l_p_create_thread_9:
ret

// IN: es:edx -> filenamez, ebx = flags, es:esi -> args, es:edi -> env_vars
// OUT: al = 0 || errorcode, ebx = pid, es:edi -> ProcessRec
p_create_process:
push edx
 push esi
  push edi
   push ebx
    call p_create_process_inner
   pop ebx
  pop ecx  // ecx -> env_var
 pop esi
pop edx
test al, al
jnz near l_p_create_process_94
  
  // flags = ebx
  or bl, PROC_FLAGS_VALID
  mov [es:edi + offset ProcessRec.flags], ebx
  
  // copy filename
  push esi
   push ecx
    push edi
      mov esi, [es:edi + offset ProcessRec.mainthread]
      add esi, offset ThreadRec.curdirtext
      
      add edi, offset ProcessRec.filename
      
      call fs_merge
    pop edi
   pop ecx
  pop esi

  // alloc stack3, set new eip - see p_new_proc
  
  // args  IN: esi -> args, edi -> process
  push ecx
   push edi
    test esi, esi
    jz l_p_create_process_28
      cmp esi, VA_ACCESS
      jnb l_p_create_process_27  // comment for test
        call strlen
        inc ecx
        push ecx
         push esi
          mov ebx, edi
          call m_heap_alloc_global_ebx
         pop esi
        pop ecx
        mov edi, ebx
        test edi, edi
        jz l_p_create_process_27
          push ds
           push edi
            push es
            pop ds
            cld
            rep movsb
           pop esi
          pop ds
          jmp short l_p_create_process_28
          
      l_p_create_process_27:
      xor esi, esi
      
    l_p_create_process_28:
   pop edi
   mov [es:edi + offset ProcessRec.args], esi
  pop esi
  
  // env_vars  IN: esi -> env_vars, edi -> process
  push edi
    xor ebx, ebx
    test esi, esi
    jz l_p_create_process_38
      cmp esi, VA_ACCESS
      jnb l_p_create_process_38  // comment for test
        xor ecx, ecx
        
        push esi
          
          l_p_create_process_35:
            mov al, [es:esi]
            inc esi
            inc ecx
            mov ah, [es:esi + 1]
            test ax, ax
            jnz l_p_create_process_35
            
        pop esi
        
        inc ecx
        
        push ecx
         push esi
          mov ebx, edi
          call m_heap_alloc_global_ebx
         pop esi
        pop ecx
        mov edi, ebx
        test edi, edi
        jz l_p_create_process_38
          push ds
           push edi
            push es
            pop ds
            cld
            rep movsb
           pop ebx
          pop ds
          
    l_p_create_process_38:
  pop edi
  mov [es:edi + offset ProcessRec.env_vars], ebx
  
  // out
  mov ebx, edi
  sub ebx, VA_PROCS
  shr ebx, 9  // assert sizeof ProcessRec = 512

  mov al, 0

l_p_create_process_9:
ret

l_p_create_process_94:
xor ebx, ebx
xor edi, edi
ret

// IN: edi = thread VA
p_start:
pushfd
  cli
  mov esi, [es:edi + offset ThreadRec.next]
  test esi, esi
  jnz l_p_start_8
    test byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_VALID
    jz l_p_start_8
      mov ebx, p_current
      mov esi, [es:ebx + offset ThreadRec.next]
      mov [es:ebx + offset ThreadRec.next], edi
      mov [es:esi + offset ThreadRec.last], edi
      mov [es:edi + offset ThreadRec.next], esi
      mov [es:edi + offset ThreadRec.last], ebx
      
  l_p_start_8:
popfd
mov al, 0
ret

// IN: edi = thread VA
p_stop:
push ebp

mov esi, edi
test esi, esi
jz l_p_stop_9
pushfd
  cli
  mov edi, [es:esi + offset ThreadRec.next]
  test edi, edi
  jz l_p_stop_8
  
  cmp edi, esi
  jnz l_p_stop_2
    mov edi, p_idle
    jmp short l_p_stop_3
  
  l_p_stop_2:
  mov ebx, [es:esi + offset ThreadRec.last]
  mov [es:ebx + offset ThreadRec.next], edi
  mov [es:edi + offset ThreadRec.last], ebx

  l_p_stop_3:
  xor eax, eax
  mov [es:esi + offset ThreadRec.next], eax
  mov [es:esi + offset ThreadRec.last], eax
  
  cmp esi, p_current
  jnz l_p_stop_8
  
    // Next preempt
    call p_set_next_preempt  // keep esi, edi
    // Do switch
    call p_switch_task
  
  l_p_stop_8:
popfd

l_p_stop_9:
mov al, 0

pop ebp
ret

// IN: ecx = delay_ms
p_sleep:
pushfd
  cli
  
  // Set timer
  mov eax, 1193
  mul ecx
  xchg eax, ecx
  
  mov edx, TMR_THREADID_WND_WAKE
  mov ebx, p_current
  
  mov eax, ebx
  sub eax, VA_THREADS
  shr eax, 12 // assert sizeof ThreadRec = 4096
  shl eax, 16
  or edx, eax
  
  xor edi, edi
  call h_timer_add // IN: ecx = ticks, edx = threadid_wnd, ebx = id, edi = ofs

  
  // Sleep thread
  mov edi, p_current
  or byte ptr [es:edi + offset ThreadRec.flags], THREAD_FLAGS_DONT_WAKE_BY_MESSAGE
  call p_stop
  
popfd
ret

// IN: ebx = threadid
// OUT: al = 0 || erc
p_kill_thread:
push ebp
mov ebp, esp
sub esp, 4

mov edi, ebx
shl edi, 12  // assert sizeof ThreadRec = 4096
cmp edi, p_threads_max_size
jb l_p_kill_thread_2

  l_p_kill_thread_1:
  mov al, ERC_INVALID_THREAD
  jmp short l_p_kill_thread_9

l_p_kill_thread_2:
add edi, VA_THREADS

cmp dword ptr [es:edi + offset ThreadRec.flags], 0
jz l_p_kill_thread_1
  
  // mainthread => kill_process
  mov esi, [es:edi + offset ThreadRec.process]
  cmp [es:esi + offset ProcessRec.mainthread], edi
  jnz l_p_kill_thread_5

    mov ebx, esi
    sub ebx, VA_PROCS
    shr ebx, 9  // assert sizeof ProcessRec = 512    
    call p_kill_process
    jmp short l_p_kill_thread_9

  l_p_kill_thread_5:
  // same process?
  mov eax, p_current
  cmp esi, [es:eax + offset ThreadRec.process]
  jnz l_p_kill_thread_1

  // release stack3
  mov ebx, [es:edi + offset ThreadRec.stack3_ptr]
  call m_heap_free_local
  
  // inner
  pushfd
    cli
      
    xor eax, eax
    mov [ss:ebp - 4], eax  // p_kill_current
    
    call p_kill_thread_inner
    
    // p_kill_current
    mov edi, [ss:ebp - 4]  // p_kill_current
    test edi, edi
    jz l_p_kill_thread_8
      
      call p_stop
      
    l_p_kill_thread_8:
  popfd
  mov al, 0
  
l_p_kill_thread_9:
mov esp, ebp
pop ebp
ret

// IN: ebx = pid
// OUT: al = 0 || erc
p_kill_process:
push ebp
mov ebp, esp
sub esp, 4

shl ebx, 9  // assert sizeof ProcessRec = 512
cmp ebx, p_procs_max_size
jb l_p_kill_process_5

  l_p_kill_process_3:
  mov al, ERC_INVALID_PID
  jmp short l_p_kill_process_9

l_p_kill_process_5:
add ebx, VA_PROCS

test byte ptr [es:ebx + offset ProcessRec.flags], PROC_FLAGS_VALID
jz l_p_kill_process_3

xor eax, eax
mov [ss:ebp - 4], eax  // p_kill_current

// do kill
call p_kill_process_inner

// stop?
mov edi, [ss:ebp - 4]  // p_kill_current
test edi, edi
jz l_p_kill_process_9
  
  call p_stop
  
l_p_kill_process_9:
mov esp, ebp
pop ebp
ret

// see shared kernel variables

[dalign 32]
uns4 g_tmp, g_base, g_base2, g_line, g_line2
int2 g_x, g_y, g_w, g_x1b, g_y1b, g_x2b, g_y2b

[align 32]
g_mouse_cursor:
dd 16, 16
dd 0xFF000000, 0xFF000000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0xFF000000, 0xFFFFFFFF, 0xFF000000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0xFF000000, 0xFFFFFFFF, 0xFFFFFFFF, 0xFF000000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0xFF000000, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFF000000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0xFF000000, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFF000000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0xFF000000, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFF000000, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0xFF000000, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFF000000, 0, 0, 0, 0, 0, 0, 0, 0
dd 0xFF000000, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFF000000, 0, 0, 0, 0, 0, 0, 0
dd 0xFF000000, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFF000000, 0, 0, 0, 0, 0, 0
dd 0xFF000000, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFF000000, 0, 0, 0, 0, 0
dd 0xFF000000, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFF000000, 0, 0, 0, 0
dd 0xFF000000, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFF000000, 0xFF000000, 0xFF000000, 0xFF000000, 0xFF000000, 0xFF000000, 0xFF000000, 0, 0, 0, 0
dd 0xFF000000, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFF000000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0xFF000000, 0xFFFFFFFF, 0xFFFFFFFF, 0xFF000000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0xFF000000, 0xFFFFFFFF, 0xFF000000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0xFF000000, 0xFF000000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

/*
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
dd 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
*/
// IN: es:esi -> bitmap, g_x1, g_y1, g_x2, g_y2
g_full2scr:
test esi, esi
jz near l_g_full2scr_8  // esi == null

movzx eax, g_info.xres
movzx ecx, g_y1  // ecx = g_y1
mul ecx

movzx ebx, g_x1  // ebx = g_x1
add eax, ebx
shl eax, 2
add eax, esi
add eax, 8
mov g_base, eax  // g_base = (xres * g_y1 + g_x1) * 4 + esi + 8

movzx eax, g_x2
sub eax, ebx
inc eax
mov g_w, ax  // g_w = g_x2 - g_x1 + 1
cmp eax, 0
jng l_g_full2scr_8
  
  movzx eax, g_info.pitch
  mul ecx
  shl ebx, 2
  add eax, ebx
  add eax, VA_GRAPHICS
  mov g_base2, eax  // g_base2 = (pitch * g_y1) + (g_x1 * 4) + VA_GRAPHICS
  
  mov cx, g_y1
  
  cld
  
  l_g_full2scr_5:
    cmp cx, g_y2
    jg l_g_full2scr_8
      
      mov esi, g_base
      mov edi, g_base2
      push ecx
        movzx eax, g_info.xres
        shl eax, 2
        add g_base, eax
        
        movzx eax, g_info.pitch
        add g_base2, eax
        
        movzx ecx, g_w
        push ds
          push es
          pop ds
          rep movsd
        pop ds
      pop ecx
      inc ecx
      jmp short l_g_full2scr_5
      
l_g_full2scr_8:
ret

// IN: es:esi = g_bg, g_x1, g_y1, g_x2, g_y2
g_copybg:
mov edi, g_tmp

movzx ebx, g_x1  // ebx = g_x1
movzx eax, g_x2
sub eax, ebx
inc eax
mov g_w, ax  // g_w = g_x2 - g_x1 + 1

movzx ecx, g_y1  // ecx = g_y1
movzx eax, g_info.xres
mul ecx
add eax, ebx
shl eax, 2  // eax = (g_y1 * xres + g_x1) * 4
add esi, eax
add edi, eax
add esi, 8
add edi, 8
mov g_base, esi
mov g_base2, edi

movzx eax, g_info.xres
shl eax, 2
mov g_line, eax

l_g_copybg_5:
  cmp cx, g_y2
  jg l_g_copybg_8
    mov esi, g_base
    mov edi, g_base2
    push ecx
      mov eax, g_line
      add g_base, eax
      add g_base2, eax
      movzx ecx, g_w
      push ds
        push es
        pop ds
        rep movsd
      pop ds
    pop ecx
    inc ecx
    jmp short l_g_copybg_5
  
l_g_copybg_8:
ret

// IN: g_x1, g_y1, g_x2, g_y2, es:esi -> winbitmap,
//     g_x = winx, g_y = winy, edi = 0(g_tmp) || 1(scr)
g_merge:
test esi, esi
jz near l_g_merge_9  // esi == null

// calc intersection
mov ax, g_x1
cmp ax, g_x
jg l_g_merge_11
  mov ax, g_x

l_g_merge_11:
mov g_x1b, ax  // g_x1b = max(g_x1, g_x)

mov ax, g_y1
cmp ax, g_y
jg l_g_merge_12
  mov ax, g_y
  
l_g_merge_12:
mov g_y1b, ax  // g_y1b = max(g_y1, g_y)

mov ax, g_x
add ax, [es:esi]
dec ax
cmp ax, g_x2
jl l_g_merge_13
  mov ax, g_x2
  
l_g_merge_13:
mov g_x2b, ax  // g_x2b = min(winx2, g_x2)

mov ax, g_y
add ax, [es:esi + 4]
dec ax
cmp ax, g_y2
jl l_g_merge_14
  mov ax, g_y2
  
l_g_merge_14:
mov g_y2b, ax  // g_y2b = min(winy2, g_y2)

// check any
mov ax, g_x2b
sub ax, g_x1b
jl near l_g_merge_9
  inc ax
  mov g_w, ax  // g_w = g_x2b - g_x1b + 1

mov ax, g_y2b
cmp ax, g_y1b
jl near l_g_merge_9

// calc bases and lines
movsx eax, g_x1b
movsx edx, g_x
sub eax, edx
mov ebx, eax  // ebx = g_x1b - g_x (>=0)

movsx eax, g_y1b
movsx edx, g_y
sub eax, edx
movzx edx, word ptr [es:esi]
mov g_line, edx
shl g_line, 2  // g_line = winw * 4
mul edx
add eax, ebx
shl eax, 2
add eax, esi
add eax, 8
mov g_base, eax  // g_base = ((g_y1b - g_y) * winw + ebx) * 4 + esi + 8

// target: scr/g_tmp
test edi, edi
jz l_g_merge_3
  movzx eax, g_info.pitch
  mov g_line2, eax  // g_line2 = pitch
  movsx edx, g_y1b
  mul edx
  movsx edx, g_x1b
  shl edx, 2
  add eax, edx
  add eax, VA_GRAPHICS
  mov g_base2, eax  // g_base2 = (g_line2 * g_y1b) + (g_x1b * 4) + VA_GRAPHICS
  jmp short l_g_merge_39
  
l_g_merge_3:
  movzx eax, g_info.xres
  shl eax, 2
  mov g_line2, eax  // g_line2 = xres * 4
  movsx edx, g_y1b
  mul edx
  movsx edx, g_x1b
  shl edx, 2
  add eax, edx
  add eax, g_tmp
  add eax, 8
  mov g_base2, eax  // g_base2 = (g_line2 * g_y1b) + (g_x1b * 4) + g_tmp + 8
  
l_g_merge_39:

// main loop
mov cx, g_y1b

l_g_merge_5:
  cmp cx, g_y2b
  jg near l_g_merge_9
    mov esi, g_base
    mov edi, g_base2
    push ecx
      mov eax, g_line
      mov edx, g_line2
      add g_base, eax
      add g_base2, edx
      movzx ecx, g_w
      push ds
        push es
        pop ds
        
        l_g_merge_51:
          lodsd
          test eax, eax
          jnz l_g_merge_52
            // argb = 0: empty
            add edi, 4
            loop l_g_merge_51
              jmp short l_g_merge_58
              
          l_g_merge_52:
          cmp eax, 0xFF000000
          jb l_g_merge_53
            // argb = full
            stosd
            loop l_g_merge_51
              jmp short l_g_merge_58
            
          l_g_merge_53:
          cmp eax, 1
          jnz l_g_merge_54
            // inverted
            mov eax, [es:edi]
            not eax
            stosd
            loop l_g_merge_51
              jmp short l_g_merge_58
            
          l_g_merge_54:
          // merge
          push ecx
            mov ebx, eax  // ebx = argb
            mov ecx, eax
            shr ecx, 24  // cl = a
            mov ch, cl
            xor ch, 255  // ch = 255 - a
            
            mul cl
            mov dx, ax  // dx = b * cl
            mov al, [es:edi]
            mul ch
            add ax, dx  // ax = dx + (b2 * ch)
            shr eax, 8
            stosb
            
            mov al, bh
            mul cl
            mov dx, ax  // dx = g * cl
            mov al, [es:edi]
            mul ch
            add ax, dx  // ax = dx + (g2 * ch)
            shr eax, 8
            stosb
            
            mov eax, ebx
            shr eax, 16
            mul cl
            mov dx, ax  // dx = r * cl
            mov al, [es:edi]
            mul ch
            add ax, dx  // ax = dx + (r2 * ch)
            shr eax, 8
            stosb
          pop ecx
          
          inc edi // a
          loop l_g_merge_51
        
        l_g_merge_58:
      pop ds      
    pop ecx
    inc ecx
    jmp l_g_merge_5

l_g_merge_9:
ret

// IN: esi -> win
// KEEP: esi
g_resize_bitmap:
mov ebx, win.pbitmap[esi]
test ebx, ebx
jz l_g_resize_bitmap_4
  push esi
    call m_heap_free_local
  pop esi
  
l_g_resize_bitmap_4:
movzx eax, word ptr win.w[esi]
movzx ecx, word ptr win.h[esi]
mul ecx
shl eax, 2
add eax, 8 // eax = w * h * 4 + 8
mov ecx, eax
push esi
  call m_heap_alloc_local
pop esi
mov win.pbitmap[esi], ebx
test ebx, ebx
jz l_g_resize_bitmap_9
  movzx eax, word ptr win.w[esi]
  movzx ecx, word ptr win.h[esi]
  mov [es:ebx], eax
  mov [es:ebx + 4], ecx
  
  mul ecx
  mov ecx, eax
  mov edi, ebx
  add edi, 8
  mov eax, 0xFF000000
  cld
  rep stosd
  
l_g_resize_bitmap_9:
ret

g_init:
mov g_busy, 0
mov wcount, 0
mov wdesktop, 0
mov wactive, WIN_NONE
mov wover, WIN_NONE
mov g_mainpanelh, WIN_MAINPANELH
mov default_x, 0
mov default_y, 0

// Alloc LFB (VA_GRAPHICS -> physbase)
movzx eax, g_info.pitch
movzx ecx, g_info.yres
mul ecx
mov ecx, eax
add ecx, 4095
shr ecx, 12

mov edx, g_info.physbase
mov ebx, VA_GRAPHICS
push ecx
 push ebx
  call m_pages_alloc_hard
 pop ebx
pop ecx
shl ecx, 12
add ebx, ecx

/*
//$$$
mov edi, VA_GRAPHICS
mov ecx, 200
mov eax, 0xFFFFFF00
cld
rep stosd
*/

// Alloc g_tmp
mov g_tmp, ebx

movzx eax, g_info.xres
movzx ecx, g_info.yres
mul ecx
shl eax, 2  // bits 32
mov ecx, eax
add ecx, 8 + 4095  // 8 = uns4 w, h
shr ecx, 12

push ecx
 push ebx
  mov edx, PG_MASK_P | PG_MASK_W | PG_MASK_G
  call m_pages_alloc_edx
 pop ebx
pop ecx
shl ecx, 12
add ebx, ecx

// Alloc g_bg
dec ebx
or ebx, 4096*1024-1
inc ebx
mov g_bg, ebx
shr ecx, 12
mov edx, PG_MASK_P | PG_MASK_W | PG_MASK_G | PG_MASK_U
call m_pages_alloc_edx

// Set sizes
movzx eax, g_info.xres
movzx ecx, g_info.yres
mov ebx, g_tmp
mov [es:ebx], eax
mov [es:ebx + 4], ecx
mov ebx, g_bg
mov [es:ebx], eax
mov [es:ebx + 4], ecx

// Set default bg
mov edi, g_bg
add edi, 8
xor ebx, ebx

l_g_init_1:
  mov eax, ebx
  movzx ecx, g_info.yres
  cmp eax, ecx
  jnb l_g_init_2
    mov edx, 255
    mul edx
    div ecx  // eax = ebx * 255 / yres
    mov ah, al
    xor al, 255
    
    movzx ecx, g_info.xres
    cld
    rep stosd

    inc ebx
    jmp short l_g_init_1
    
l_g_init_2:

// Default mouse cursor
mov ecx, 32 * 32 * 4 + 8
call m_heap_alloc_global
mov esi, PA_KERNEL_CODE + offset g_mouse_cursor
mov edi, ebx
mov ms_cursor, ebx
test ebx, ebx
jz l_g_init_3
  mov eax, [esi]
  mov edx, [esi + 4]
  mul edx
  add eax, 2
  mov ecx, eax
  cld
  rep movsd
  
l_g_init_3:
mov ms_shift_x, 0
mov ms_shift_y, 0
ret

g_enter:
push eax
  l_g_enter_1:
    mov al, 1
    lock xchg al, g_busy
    test al, al
    jz l_g_enter_9
      call p_noop
      jmp l_g_enter_1
  
  l_g_enter_9:
  mov eax, p_current
  or word ptr [es:eax + offset ThreadRec.flags], THREAD_FLAGS_G_BUSY
pop eax
ret

g_leave:
push eax
  mov eax, p_current
  mov g_busy, 0
  and word ptr [es:eax + offset ThreadRec.flags], -1 - THREAD_FLAGS_G_BUSY
pop eax
ret

// IN: ecx = x1, ebx = y1, esi = x2, edi = y2
g_paint:
call g_enter

xor eax, eax
cmp cx, ax
jnl l_g_paint_11
  mov cx, ax

l_g_paint_11:
mov g_x1, cx  // g_x1 = max(cx,0)

cmp bx, ax
jnl l_g_paint_12
  mov bx, ax
  
l_g_paint_12:
mov g_y1, bx  // g_y1 = max(bx,0)

movzx eax, g_info.xres
dec eax
cmp esi, eax
jl l_g_paint_13
  mov esi, eax
  
l_g_paint_13:
mov g_x2, si  // g_x2 = min(esi,xres-1)

movzx eax, g_info.yres
dec eax
cmp edi, eax
jl l_g_paint_14
  mov edi, eax
  
l_g_paint_14:
mov g_y2, di  // g_y2 = min(edi,yres-1)

/*
// cls
mov edi, VA_GRAPHICS
__15:
push edi
  xor eax, eax
  mov ecx, 640
  cld
  rep stosd
pop edi
movzx ecx, g_info.pitch
add edi, ecx
mov eax, 480
mul ecx
add eax, VA_GRAPHICS
cmp edi, eax
jb __15
*/

// full screen?
mov al, wactive
cmp al, MAX_WIN
jnb near l_g_paint_2
  movzx esi, al
  shl esi, 5  // assert sizeof WinRec = 32
  mov eax, win.flags[esi]
  test eax, WINFLAGS_FULLSCREEN
  jz near l_g_paint_2
   // fullscreen
   call s_isvisible  // keep esi
   jnc near l_g_paint_2
    // switch to window address space
    mov edx, cr3
    mov eax, win.cr3[esi]
    test eax, eax
    jz l_g_paint_2
    push edx
      mov ebx, p_current
      mov [es:ebx + offset TssRec.cr3], eax
      mov cr3, eax
      
      //... try
      
      // paint fullscreen window
      mov esi, win.pbitmap[esi]
      call g_full2scr
      
    pop edx
    // restore address space
    mov ebx, p_current
    mov [es:ebx + offset TssRec.cr3], edx
    mov cr3, edx
    // paint mouse
    mov esi, ms_cursor
    mov ax, ms_x
    mov cx, ms_y
    movsx edx, ms_shift_x
    sub ax, dx
    movsx edx, ms_shift_y
    sub cx, dx
    mov g_x, ax
    mov g_y, cx
    mov edi, 1
    call g_merge
    jmp l_g_paint_9

l_g_paint_2:
// not full screen
movzx ecx, wcount

l_g_paint_25:
sub ecx, 1
jc near l_g_paint_3
  movzx esi, cl
  mov dl, wpos[esi]
  movzx esi, dl
  shl esi, 5  // assert sizeof WinRec = 32
  mov edx, win.flags[esi]  // edx = winflags
  test edx, WINFLAGS_FULLSCREEN | WS_MAXIMIZE
  jz l_g_paint_25
   // fullscreen | maximized
   call s_isvisible
   jnc l_g_paint_25
    // switch to window address space
    mov ebx, cr3
    mov eax, win.cr3[esi]
    test eax, eax
    jz l_g_paint_3
    push ebx
      
      mov ebx, p_current
      mov [es:ebx + offset TssRec.cr3], eax
      mov cr3, eax

      //... try
      
      // paint window
      push ecx
       movzx eax, g_y2
       push eax
        
        test edx, WINFLAGS_FULLSCREEN
        jnz l_g_paint_26
          // maximized
          movzx eax, g_info.yres
          dec eax
          sub eax, g_mainpanelh
          cmp g_y2, ax
          jng l_g_paint_26
            // g_y2 > yres - mainpanelh - 1
            mov g_y2, ax
          
        l_g_paint_26:
        mov esi, win.pbitmap[esi]
        call g_copybg
        
       pop eax
       mov g_y2, ax
      pop ecx
      
    pop edx
    // restore address space
    mov ebx, p_current
    mov [es:ebx + offset TssRec.cr3], edx
    mov cr3, edx
    
    inc ecx
    jmp l_g_paint_30

l_g_paint_3:
// copy bg
mov esi, g_bg
call g_copybg

xor ecx, ecx

l_g_paint_30:
// foreach window from ecx

l_g_paint_31:
  cmp cl, wcount
  jnb near l_g_paint_39
    movzx esi, cl
    mov al, wpos[esi]
    movzx esi, al
    shl esi, 5  // assert sizeof WinRec = 32
    call s_isvisible
    jc l_g_paint_32
      inc ecx
      jmp short l_g_paint_31
    
    l_g_paint_32:
    mov ax, win.x[esi]
    mov g_x, ax
    mov dx, win.y[esi]
    mov g_y, dx
    
    // switch to window address space
    mov edx, cr3
    mov eax, win.cr3[esi]
    test eax, eax
    jnz l_g_paint_33
      inc ecx
      jmp short l_g_paint_31
      
    l_g_paint_33:
    push ecx
     push edx
      mov ebx, p_current
      mov [es:ebx + offset TssRec.cr3], eax
      mov cr3, eax
      
      //... try
      
      // paint window
      mov esi, win.pbitmap[esi]
      xor edi, edi
      call g_merge
      
     pop edx
    pop ecx
    // restore address space
    mov ebx, p_current
    mov [es:ebx + offset TssRec.cr3], edx
    mov cr3, edx
    inc ecx
    jmp l_g_paint_31

l_g_paint_39:
// paint mouse
mov esi, ms_cursor
mov ax, ms_x
mov cx, ms_y
movsx edx, ms_shift_x
sub ax, dx
movsx edx, ms_shift_y
sub cx, dx
mov g_x, ax
mov g_y, cx
xor edi, edi
call g_merge
// paint tmp to scr
mov esi, g_tmp
call g_full2scr

l_g_paint_9:
call g_leave
ret

// IN: ebx = WINFLAGS, ecx = {int2 x, y}, edx = {int2 w, h}, esi = hwnd
// OUT: al = erc, dh:dl = wdesktop:winid
g_create_win:
call g_enter

mov eax, ebx

// always on top only starter
test eax, WINFLAGS_ALWAYSONTOP
jz l_g_create_win_1
  push eax
    call s_chkstarter
  pop eax
  jz l_g_create_win_1
    //and eax, -1 - WINFLAGS_ALWAYSONTOP
    mov edx, WIN_NONE
    mov al, ERC_ONLY_STARTER
    jmp l_g_create_win_99
    
l_g_create_win_1:
cmp wcount, MAX_WIN
jnb near l_g_create_win_9
  // find free pos
  xor ebx, ebx
  
  l_g_create_win_5:
    cmp ebx, MAX_WIN * sizeof WinRec
    jnb near l_g_create_win_9
      test win.flags[ebx], WINFLAGS_VALID
      jz l_g_create_win_6
        add ebx, sizeof WinRec
        jmp l_g_create_win_5
        
  l_g_create_win_6:
  // set window, keep eax(WINFLAGS), ebx
  push eax
    test eax, WINFLAGS_FULLSCREEN
    jz l_g_create_win_609
      // fullscreen
      xor ecx, ecx
      mov dx, g_info.yres
      shl edx, 16
      mov dx, g_info.xres
      jmp short l_g_create_win_66
      
    l_g_create_win_609:
    // x
    cmp cx, CW_USEDEFAULT
    jnz l_g_create_win_62
      mov ax, default_x
      mov cx, ax
    
      add ax, WIN_DEFAULT_X_STEP
      cmp ax, WIN_DEFAULT_X_MAX
      jb l_g_create_win_61
        sub ax, WIN_DEFAULT_X_MAX
        
      l_g_create_win_61:
      mov default_x, ax
      
    l_g_create_win_62:
    // y
    mov eax, ecx
    shr eax, 16
    cmp ax, CW_USEDEFAULT
    jnz l_g_create_win_64
      mov ax, default_y
      mov edi, eax
      shl edi, 16
      and ecx, 0xFFFF
      or ecx, edi
    
      add ax, WIN_DEFAULT_Y_STEP
      cmp ax, WIN_DEFAULT_Y_MAX
      jb l_g_create_win_63
        sub ax, WIN_DEFAULT_Y_MAX
      
      l_g_create_win_63:
      mov default_y, ax
      
    l_g_create_win_64:
    // w
    cmp dx, CW_USEDEFAULT
    jnz l_g_create_win_65
      mov dx, 600
      
    l_g_create_win_65:
    // h
    mov eax, edx
    shr eax, 16
    cmp ax, CW_USEDEFAULT
    jnz l_g_create_win_66
      and edx, 0xFFFF
      or edx, 400 << 16
      
    l_g_create_win_66:
    mov dword ptr win.x[ebx], ecx  // :KLUDGE:
    mov dword ptr win.w[ebx], edx  // :KLUDGE:
  pop eax
  or al, WINFLAGS_VALID
  push eax
    // flags, cr3, hwnd, pbitmap
    mov win.flags[ebx], eax
    mov eax, cr3
    mov win.cr3[ebx], eax
    mov win.hwnd[ebx], esi
    xor eax, eax
    mov win.pbitmap[ebx], eax
    // pid
    mov eax, p_current
    mov eax, [es:eax + offset ThreadRec.process]
    sub eax, VA_PROCS
    shr eax, 9  // assert sizeof ProcessRec = 512
    mov win.pid[ebx], eax
    // kbd, parent
    xor eax, eax
    mov dword ptr win.kbd[ebx], eax  // :KLUDGE:
    test esi, esi
    jz l_g_create_win_68
      mov eax, [es:esi + offset WindowExRec.parent]
      test eax, eax
      jz l_g_create_win_68
        mov al, [es:eax + offset WindowExRec.winid]
        movzx esi, al
        shl esi, 5  // assert sizeof WinRec = 32
        mov ah, win.kbd[esi]
        mov win.kbd[ebx], ah
        jmp short l_g_create_win_69
        
    l_g_create_win_68:
    mov al, WIN_NONE
    
    l_g_create_win_69:
    mov win.parent[ebx], al
    mov al, wdesktop
    mov win.desktop[ebx], al
  pop eax
  
  movzx edx, wcount
  inc wcount  // wcount++
  
  test eax, WINFLAGS_ALWAYSONTOP
  jnz l_g_create_win_78
    
    // insert after always_on_top
    l_g_create_win_75:
      test edx, edx
      jz l_g_create_win_78
        movzx eax, wpos[edx - 1]
        shl eax, 5  // assert sizeof WinRec == 32
        mov eax, win.flags[eax]
        test eax, WINFLAGS_ALWAYSONTOP
        jz l_g_create_win_78
          mov al, wpos[edx - 1]
          mov wpos[edx], al
          dec edx
          jmp l_g_create_win_75
        
  l_g_create_win_78:
  shr ebx, 5  // assert sizeof WinRec == 32
  
  mov wpos[edx], bl
  mov edx, ebx
  mov dh, wactive
  mov wactive, dl
  mov ah, 1
  call s_post_ada  // keep edx

  mov dh, wdesktop
  mov al, 0
  jmp l_g_create_win_99
  
l_g_create_win_9:
mov edx, WIN_NONE
mov al, ERC_TOO_MANY_WINDOWS

l_g_create_win_99:
call g_leave
ret

// IN: dl = winid
// OUT: al = erc
g_destroy_win:
call g_enter
cmp dl, wover
jnz l_g_destroy_win_1
  mov wover, WIN_NONE
  
l_g_destroy_win_1:
movzx ebx, dl
shl ebx, 5  // assert sizeof WinRec = 32
mov eax, win.flags[ebx]
test al, WINFLAGS_VALID
jz near l_g_destroy_win_92
  
  // remove window messages
  call p_remove_msg  // keep ebx
  
  // release
  mov eax, cr3
  cmp win.cr3[ebx], eax
  jnz l_g_destroy_win_2
    push ebx
      mov ebx, win.pbitmap[ebx]
      call m_heap_free_local
    pop ebx
    xor eax, eax
    mov win.pbitmap[ebx], eax
    
  l_g_destroy_win_2:
  xor eax, eax
  mov win.flags[ebx], eax
  mov win.cr3[ebx], eax
  
  // remove stdout
  shr ebx, 5  // assert sizeof WinRec = 32
  
  mov esi, p_current
  mov eax, [es:esi + offset ThreadRec.stdout]
  test eax, STDOUT_WIN
  jz l_g_destroy_win_3
    cmp al, bl
    jnz l_g_destroy_win_3
      xor eax, eax
      mov [es:esi + offset ThreadRec.stdout], eax
      
  l_g_destroy_win_3:
  
  // remove pos  IN: ebx
  xor ecx, ecx
  
  l_g_destroy_win_5:
    cmp cl, wcount
    jnb l_g_destroy_win_8
      cmp wpos[ecx], bl
      jz l_g_destroy_win_6
        inc ecx
        jmp short l_g_destroy_win_5
      
      l_g_destroy_win_6:
      inc ecx
      cmp cl, wcount
      jnb l_g_destroy_win_8
        mov al, wpos[ecx]
        mov wpos[ecx - 1], al
        jmp short l_g_destroy_win_6
        
  l_g_destroy_win_8:
  dec wcount
  
  shl ebx, 5  // assert sizeof WinRec == 32
  
  movsx ecx, win.x[ebx]
  movsx eax, win.y[ebx]
  movsx esi, win.w[ebx]
  add esi, ecx
  dec esi
  movsx edi, win.h[ebx]
  add edi, eax
  dec edi
  mov ebx, eax
  
  // activate top, post ada, keep ecx..edi
  call s_activatetop
  
  call g_leave
  
  // paint
  call g_paint
  
  mov al, 0
  
  ret
  
l_g_destroy_win_92:
mov al, ERC_INVALID_WINDOW

l_g_destroy_win_99:
call g_leave
ret

// IN: dl = wndid, es:edi -> WinRec
// OUT: al = erc
// KEEP: edx
g_getwin:
call g_enter
movzx eax, dl

cmp edi, VA_ACCESS - sizeof WinRec
jnb l_g_getwin_91
  
  cmp al, MAX_WIN
  jnb l_g_getwin_92
    
    movzx esi, al
    shl esi, 5  // assert sizeof WinRec == 32
    add esi, offset win
    mov ecx, sizeof WinRec / 4
    cld
    rep movsd    
    mov al, 0
    jmp short l_g_getwin_99
    
l_g_getwin_91:
mov al, ERC_INVALID_POINTER
jmp short l_g_getwin_99

l_g_getwin_92:
mov al, ERC_INVALID_WINDOW

l_g_getwin_99:
call g_leave
ret

// IN: ecx = x, ebx = y
// OUT: al = erc, edx = winid
g_getwinat:
call g_enter

// full screen?
mov al, wactive
cmp al, MAX_WIN
jnb l_g_getwinat_2
  movzx esi, al
  shl esi, 5  // assert sizeof WinRec = 32
  mov edx, win.flags[esi]
  test edx, WINFLAGS_FULLSCREEN
  jz l_g_getwinat_2
   // fullscreen
   movzx edx, al
   mov al, 0
   jmp l_g_getwinat_99
   
l_g_getwinat_2:
movzx edx, wcount

l_g_getwinat_5:
  sub dl, 1
  jc near l_g_getwinat_9
    movzx esi, byte ptr wpos[edx]
    shl esi, 5  // assert sizeof WinRec = 32
    call s_isvisible  // keep edx, esi
    jnc l_g_getwinat_5
      movsx eax, word ptr win.x[esi]
      movsx edi, word ptr win.y[esi]
      cmp ecx, eax
      jl l_g_getwinat_5
        cmp ebx, edi
        jl l_g_getwinat_5
          push edx
            movsx edx, word ptr win.w[esi]
            add eax, edx
            movsx edx, word ptr win.h[esi]
            add edi, edx
          pop edx
          cmp ecx, eax
          jnl l_g_getwinat_5
            cmp ebx, edi
            jnl l_g_getwinat_5
              jmp short l_g_getwinat_6

l_g_getwinat_9:
mov al, ERC_INVALID_WINDOW
mov edx, WIN_NONE

l_g_getwinat_99:
call g_leave
ret


l_g_getwinat_6:  // IN: edx, esi, ecx, ebx
mov eax, win.cr3[esi]
test eax, eax
jz l_g_getwinat_5

push edx
  
  // switch to window address space
  mov edx, cr3
  mov edi, p_current
  mov [es:edi + offset TssRec.cr3], eax
  mov cr3, eax
  
  push edx
    
    //... try
    
    mov edi, win.pbitmap[esi]
    test edi, edi
    jz l_g_getwinat_7
      mov eax, ebx
      movsx edx, word ptr win.y[esi]
      sub eax, edx
      movzx edx, word ptr [es:edi]
      mul edx
      add eax, ecx
      movsx edx, word ptr win.x[esi]
      sub eax, edx
      shl eax, 2  // * 4
      add edi, eax
      cmp edi, VA_ACCESS
      jnb l_g_getwinat_7
        
        mov eax, [es:edi + 8]
        jmp short l_g_getwinat_8
        
    l_g_getwinat_7:
    xor eax, eax
    
    l_g_getwinat_8:
  pop edx
  
  // restore address space
  mov edi, p_current
  mov [es:edi + offset TssRec.cr3], edx
  mov cr3, edx
  
pop edx

test eax, eax
jz near l_g_getwinat_5

mov edx, esi
shr edx, 5  // assert sizeof WinRec = 32
mov al, 0
jmp l_g_getwinat_99

MAX_G_DEPTH = 4

// IN: dl = winid
// OUT: al = erc, g_x1..g_y2, g_topwinid
// BEFORE: g_enter, g_depth = 0, g_x1..g_y2, g_topwinid
g_activate:
cmp dl, MAX_WIN
jnb near l_g_activate_9

movzx esi, dl
shl esi, 5  // assert sizeof WinRec = 32

// visible, !minimize
or win.flags[esi], WS_VISIBLE
and win.flags[esi], -1 - WS_MINIMIZE
mov edi, win.hwnd[esi]
test edi, edi
jz l_g_activate_18
 cmp edi, VA_ACCESS
 jnb l_g_activate_18
  or dword ptr [es:edi + offset WindowExRec.style], WS_VISIBLE
  and dword ptr [es:edi + offset WindowExRec.style], -1 - WS_MINIMIZE
  
l_g_activate_18:
// flags
mov eax, win.flags[esi]
test eax, WINFLAGS_VALID
jz near l_g_activate_9
  // find win dl, keep eax, edx, esi
  movzx ecx, wcount
  
  l_g_activate_3:
    sub ecx, 1
    jc near l_g_activate_9
      mov bl, wpos[ecx]
      cmp bl, dl
      jnz l_g_activate_3
  
  movzx ebx, wcount
  dec ebx  // assert ebx >= 0
  
  test eax, WINFLAGS_ALWAYSONTOP
  jz l_g_activate_6
    // always on top, keep edx, esi
    l_g_activate_4:
      cmp cl, bl
      jnb l_g_activate_5
        mov al, wpos[ecx + 1]
        mov wpos[ecx], al
        inc ecx
        jmp short l_g_activate_4
        
    l_g_activate_5:
    mov wpos[ecx], dl
    jmp l_g_activate_8
  
  l_g_activate_6:
    // not on top, keep edx, esi
    cmp cl, bl
    jnb l_g_activate_5
      movzx eax, byte ptr wpos[ecx + 1]
      mov edi, eax
      shl edi, 5  // assert sizeof WinRec = 32
      test win.flags[edi], WINFLAGS_ALWAYSONTOP
      jnz l_g_activate_5
        mov wpos[ecx], al
        inc ecx
        jmp short l_g_activate_6

// add paint area, IN: edx, esi
l_g_activate_8:
mov g_topwinid, dl

mov ax, win.x[esi]
cmp ax, g_x1
jnl l_g_activate_812
  mov g_x1, ax
  
l_g_activate_812:
mov ax, win.y[esi]
cmp ax, g_y1
jnl l_g_activate_813
  mov g_y1, ax
  
l_g_activate_813:
mov ax, win.x[esi]
add ax, win.w[esi]
dec ax
cmp ax, g_x2
jng l_g_activate_814
  mov g_x2, ax
  
l_g_activate_814:
mov ax, win.y[esi]
add ax, win.h[esi]
dec ax
cmp ax, g_y2
jng l_g_activate_815
  mov g_y2, ax
  
l_g_activate_815:

// recurse
inc g_depth
cmp g_depth, MAX_G_DEPTH
ja l_g_activate_89
  mov bl, MAX_WIN
  
  l_g_activate_85:
  sub bl, 1
  jc l_g_activate_89
    movzx esi, bl
    shl esi, 5  // assert sizeof WinRec = 32
    test win.flags[esi], WINFLAGS_VALID
    jz l_g_activate_85
     //test win.flags[esi], WINFLAGS_ALWAYSONTOP
     //jnz l_g_activate_85
      cmp dl, win.parent[esi]
      jnz l_g_activate_85
        push edx
         push ebx
          mov dl, bl
          call g_activate
         pop ebx
        pop edx
        
    jmp l_g_activate_85
  
l_g_activate_89:
dec g_depth
mov al, 0
jmp short l_g_activate_99

l_g_activate_9:
mov al, ERC_INVALID_WINDOW

l_g_activate_99:
ret

// IN: dl = winid
// OUT: al = erc, g_x1..g_y2
// BEFORE: g_enter, g_depth = 0, g_x1..g_y2
g_toback:

// recurse
inc g_depth
cmp g_depth, MAX_G_DEPTH
ja l_g_toback_18
  mov bl, MAX_WIN
  
  l_g_toback_15:
  sub bl, 1
  jc l_g_toback_18
    movzx esi, bl
    shl esi, 5  // assert sizeof WinRec = 32
    test win.flags[esi], WINFLAGS_VALID
    jz l_g_toback_15
      cmp dl, win.parent[esi]
      jnz l_g_toback_15
        push edx
         push ebx
          mov dl, bl
          call g_toback
         pop ebx
        pop edx
        
    jmp l_g_toback_15
  
l_g_toback_18:
dec g_depth

// esi = winid << 5
movzx esi, dl
shl esi, 5  // assert sizeof WinRec = 32

// minimize
or win.flags[esi], WS_MINIMIZE
mov edi, win.hwnd[esi]  // edi = hwnd
test edi, edi
jz l_g_toback_21
  cmp edi, VA_ACCESS
  jnb l_g_toback_21
    or dword ptr [es:edi + offset WindowExRec.style], WS_MINIMIZE
    and dword ptr [es:edi + offset WindowExRec.style], -1 - WS_VISIBLE
    
l_g_toback_21:

// add paint area, IN: edx, esi
mov ax, win.x[esi]
cmp ax, g_x1
jnl l_g_toback_182
  mov g_x1, ax
  
l_g_toback_182:
mov ax, win.y[esi]
cmp ax, g_y1
jnl l_g_toback_183
  mov g_y1, ax
  
l_g_toback_183:
mov ax, win.x[esi]
add ax, win.w[esi]
dec ax
cmp ax, g_x2
jng l_g_toback_184
  mov g_x2, ax
  
l_g_toback_184:
mov ax, win.y[esi]
add ax, win.h[esi]
dec ax
cmp ax, g_y2
jng l_g_toback_185
  mov g_y2, ax
  
l_g_toback_185:

// to back, IN: edx, esi
mov eax, win.flags[esi]
test eax, WINFLAGS_VALID
jz l_g_toback_9
  test eax, WINFLAGS_ALWAYSONTOP
  jnz l_g_toback_9
    // find win dl, keep edx
    movzx ecx, wcount
    
    l_g_toback_3:
      sub ecx, 1
      jc l_g_toback_9
        mov bl, wpos[ecx]
        cmp bl, dl
        jnz l_g_toback_3
    
    // shift windows
    l_g_toback_6:
      cmp cl, 0
      jna l_g_toback_7
        mov al, wpos[ecx - 1]  // assert ecx > 0
        mov wpos[ecx], al
        dec ecx
        jmp short l_g_toback_6
          
    l_g_toback_7:  // assert ecx = 0
    mov wpos[ecx], dl
    mov al, 0
    jmp short l_g_toback_99
    
l_g_toback_9:
mov al, ERC_INVALID_WINDOW

l_g_toback_99:
ret

// IN: dl = winid, ecx = x, ebx = y
// OUT: al = erc
g_wmove: // 100
cmp dl, MAX_WIN
jnb l_g_wmove_91
  movzx esi, dl
  shl esi, 5  // assert sizeof WinRec = 32
  test win.flags[esi], WS_MINIMIZE | WS_MAXIMIZE | WINFLAGS_FULLSCREEN
  jnz l_g_wmove_92
   mov eax, cr3
   cmp eax, win.cr3[esi]
   jnz l_g_wmove_93
    mov edi, win.hwnd[esi]
    test edi, edi
    jz l_g_wmove_93
      cmp edi, VA_ACCESS
      jnb l_g_wmove_93
        
        call g_enter
        mov win.x[esi], cx
        mov win.y[esi], bx
        mov [es:edi + offset WindowExRec.x], cx
        mov [es:edi + offset WindowExRec.y], bx
        call g_leave
        
        mov al, 0
        ret
    
l_g_wmove_91:
mov al, ERC_INVALID_WINDOW
ret

l_g_wmove_92:
mov al, ERC_CANT_MOVESIZE
ret

l_g_wmove_93:
mov al, ERC_INVALID_POINTER
ret

// IN: dl = winid, ecx = w, ebx = h
// OUT: al = erc
g_wsize: // 101
cmp dl, MAX_WIN
jnb l_g_wsize_91
  movzx esi, dl
  shl esi, 5  // assert sizeof WinRec = 32
  test win.flags[esi], WS_MINIMIZE | WS_MAXIMIZE | WINFLAGS_FULLSCREEN
  jnz l_g_wsize_92
   mov eax, cr3
   cmp eax, win.cr3[esi]
   jnz l_g_wsize_93
    mov edi, win.hwnd[esi]
    test edi, edi
    jz l_g_wsize_93
     cmp edi, VA_ACCESS
     jnb l_g_wsize_93
      test dword ptr [es:edi + offset WindowExRec.style], WS_SIZEBOX
      jz l_g_wsize_92
        
        call g_enter
        cmp cx, WIN_MINW
        jnl l_s_g_wsize_61
          mov cx, WIN_MINW
          
        l_s_g_wsize_61:
        cmp bx, WIN_MINH
        jnl l_s_g_wsize_62
          mov bx, WIN_MINH
          
        l_s_g_wsize_62:
        mov win.w[esi], cx
        mov win.h[esi], bx
        mov [es:edi + offset WindowExRec.w], cx
        mov [es:edi + offset WindowExRec.h], bx
        
        call g_resize_bitmap
        call g_leave
        
        mov al, 0
        ret
  
l_g_wsize_91:
mov al, ERC_INVALID_WINDOW
ret

l_g_wsize_92:
mov al, ERC_CANT_MOVESIZE
ret

l_g_wsize_93:
mov al, ERC_INVALID_POINTER
ret

l_g_wshow_x:
mov al, ERC_CANT_MOVESIZE
jmp l_g_wshow_9

// IN: dl = winid, dh = SW_*
// OUT: al = erc
g_wshow:
call g_enter
cmp dl, MAX_WIN
jnb near l_g_wshow_9
  movzx esi, dl
  shl esi, 5  // assert sizeof WinRec = 32  
  mov edi, win.hwnd[esi]  // edi = hwnd
  test edi, edi
  jnz l_g_wshow_1
    
    l_g_wshow_01:
    mov al, ERC_INVALID_POINTER
    jmp l_g_wshow_9
    
  l_g_wshow_1:
  cmp edi, VA_ACCESS
  jnb l_g_wshow_01
  
  cmp dh, SW_MINIMIZE
  jz near l_g_wshow_91
  
  l_g_wshow_2:
  and win.flags[esi], -1 - WS_MINIMIZE
  and dword ptr [es:edi + offset WindowExRec.style], -1 - WS_MINIMIZE
  or dword ptr [es:edi + offset WindowExRec.style], WS_VISIBLE
  cmp dh, SW_MAXIMIZE
  jnz l_g_wshow_3
    // maximized
    test dword ptr [es:edi + offset WindowExRec.style], WS_MAXIMIZEBOX
    jz near l_g_wshow_x
     test win.flags[esi], WINFLAGS_FULLSCREEN
     jnz near l_g_wshow_x
      or win.flags[esi], WS_MAXIMIZE
      or dword ptr [es:edi + offset WindowExRec.style], WS_MAXIMIZE
      xor eax, eax
      mov win.x[esi], ax
      mov win.y[esi], ax
      mov cx, g_info.xres
      mov bx, g_info.yres
      sub bx, word ptr g_mainpanelh
      jmp short l_g_wshow_4
      
  l_g_wshow_3:
  cmp dh, SW_NORMAL
  jz l_g_wshow_33
    // restore
    mov eax, win.pbitmap[esi]
    test eax, eax
    jnz l_g_wshow_8
      call g_resize_bitmap
      jmp short l_g_wshow_8
      
  l_g_wshow_33:
  // normal
  and win.flags[esi], -1 - WS_MAXIMIZE
  and dword ptr [es:edi + offset WindowExRec.style], -1 - WS_MAXIMIZE
  mov ax, [es:edi + offset WindowExRec.x]
  mov win.x[esi], ax
  mov ax, [es:edi + offset WindowExRec.y]
  mov win.y[esi], ax
  mov cx, [es:edi + offset WindowExRec.w]
  mov bx, [es:edi + offset WindowExRec.h]
  
  l_g_wshow_4:
  // normal/maximized
  mov win.w[esi], cx
  mov win.h[esi], bx
  call g_resize_bitmap
  
  l_g_wshow_8:
  mov al, 0
  
l_g_wshow_9:
call g_leave
ret

l_g_wshow_91:
call g_leave
call s_g_toback
ret

// IN: ebx = processptr
g_remove_all_windows:
mov ecx, [es:ebx + offset ProcessRec.cr3]
xor edx, edx

l_g_remove_all_windows_5:
  cmp dl, MAX_WIN
  jnb l_g_remove_all_windows_8
    push edx
     push ecx
      movzx esi, dl
      shl esi, 5  // assert sizeof WinRec == 32
      mov eax, win.cr3[esi]
      cmp eax, ecx
      jnz l_g_remove_all_windows_59
        call g_destroy_win
        
      l_g_remove_all_windows_59:
     pop ecx
    pop edx
    inc dl
    jmp short l_g_remove_all_windows_5
    
l_g_remove_all_windows_8:
mov edx, ecx
mov ebx, WIN_NONE << 16 + 0
mov ecx, WM_WINDOWCLOSED
xor esi, esi
call p_msg_post
ret

// IN: dl = winid, ecx = w, ebx = h
// OUT: edi -> variable at global heap
g_miniature:
call g_enter

push ebp
mov ebp, esp
sub esp, 16

cld

// correct sizes
cmp ecx, 16
jnb l_g_miniature_11
  mov ecx, 16
  
l_g_miniature_11:
cmp ebx, 16
jnb l_g_miniature_12
  mov ebx, 16
  
l_g_miniature_12:
cmp ecx, 160
jna l_g_miniature_13
  mov ecx, 160
  
l_g_miniature_13:
cmp ebx, 120
jna l_g_miniature_14
  mov ebx, 120
  
l_g_miniature_14:
mov g_miniature_w, ecx
mov g_miniature_h, ebx

// alloc
push edx
  mov eax, g_miniature_w
  mul g_miniature_h
  shl eax, 2
  add eax, 8
  xchg eax, ecx
  call m_heap_alloc_global
pop edx
test ebx, ebx
jz near l_g_miniature_9

mov edi, ebx
mov eax, g_miniature_w
stosd
mov eax, g_miniature_h
stosd  // es:edi -> bitmap[8]

movzx esi, dl
shl esi, 5  // assert sizeof WinRec = 32
cmp dl, MAX_WIN
jb l_g_miniature_16
  // get ratio of bg, keep ebx
  movsx eax, g_info.xres
  movsx ecx, g_info.yres
  jmp short l_g_miniature_18
  
l_g_miniature_16:
// get ratio, keep ebx
movsx eax, win.w[esi]
movsx ecx, win.h[esi]

l_g_miniature_18:
mov [ss:ebp - 4], eax
fild dword [ss:ebp - 4]
fild g_miniature_w
fdivp st1, st0
fstp dword [ss:ebp - 8]

mov [ss:ebp - 4], ecx
fild dword [ss:ebp - 4]
fild g_miniature_h
fdivp st1, st0
fstp dword [ss:ebp - 12]

fld dword [ss:ebp - 8]
fld dword [ss:ebp - 12]
fucompp st1, st0
fnstsw ax
sahf
jb l_g_miniature_2
  mov eax, [ss:ebp - 12]
  mov [ss:ebp - 8], eax
  
l_g_miniature_2:  // [ss:ebp - 8] = min(w/80, h/60) = ratio
cmp dl, MAX_WIN
jb near l_g_miniature_29
  // paint desktop
  xor ecx, ecx
  
  l_g_miniature_21:
    cmp ecx, g_miniature_h
    jnb near l_g_miniature_9
      push ecx
       push ebx
        
        mov [ss:ebp - 4], ecx
        fild dword [ss:ebp - 4]
        fld dword [ss:ebp - 8]
        fmulp st1, st0
        fistp dword [ss:ebp - 4]  // [ss:ebp - 4] = int(ecx * ratio)
        
        mov eax, [ss:ebp - 4]
        movzx edx, g_info.yres
        movzx ecx, g_info.xres
        cmp eax, edx
        jb l_g_miniature_22
          // over yres
          mov ecx, g_miniature_w
          xor eax, eax
          rep stosd
          jmp short l_g_miniature_28
          
        l_g_miniature_22:
        mul ecx
        shl eax, 2
        add eax, 8
        add eax, g_bg
        mov ebx, eax  // ebx = int(ecx * ratio) * xres * 4 + 8 + base
        
        l_g_miniature_24:
        xor ecx, ecx
        
        l_g_miniature_25:
          cmp ecx, g_miniature_w
          jnb l_g_miniature_28
            
            mov [ss:ebp - 4], ecx
            fild dword [ss:ebp - 4]
            fld dword [ss:ebp - 8]
            fmulp st1, st0
            fistp dword [ss:ebp - 4]  // [ss:ebp - 4] = int(ecx * ratio)
            
            mov eax, [ss:ebp - 4]
            movzx edx, g_info.xres
            cmp eax, edx
            jb l_g_miniature_26
              // over xres
              neg ecx
              add ecx, g_miniature_w
              xor eax, eax
              rep stosd
              jmp short l_g_miniature_28
              
            l_g_miniature_26:
            shl eax, 2
            add eax, ebx
            mov eax, [es:eax]
            or eax, 0xFF000000
            stosd
            
            inc ecx
            jmp l_g_miniature_25
            
        l_g_miniature_28:
       pop ebx
      pop ecx
      inc ecx
      jmp l_g_miniature_21
      
l_g_miniature_29:
// switch to window address space
mov edx, cr3
mov eax, win.cr3[esi]
test eax, eax
jnz l_g_miniature_3
  movzx eax, win.w[esi]
  movzx edx, win.h[esi]
  mul edx
  xchg eax, ecx
  xor eax, eax
  rep stosd
  jmp l_g_miniature_9
  
l_g_miniature_3:
push edx
  push ebx
    mov ebx, p_current
    mov [es:ebx + offset TssRec.cr3], eax
    mov cr3, eax
  pop ebx
  
  //... try
  
  // for each row
  xor ecx, ecx
  
  l_g_miniature_5:
    cmp ecx, g_miniature_h
    jnb near l_g_miniature_8
      push ecx
       push ebx
        
        mov [ss:ebp - 4], ecx
        fild dword [ss:ebp - 4]
        fld dword [ss:ebp - 8]
        fmulp st1, st0
        fistp dword [ss:ebp - 4]  // [ss:ebp - 4] = int(ecx * ratio)
        
        mov eax, [ss:ebp - 4]
        movzx edx, win.h[esi]
        movzx ecx, win.w[esi]
        cmp eax, edx
        jb l_g_miniature_52
          // over win.h
          mov ecx, g_miniature_w
          xor eax, eax
          rep stosd
          jmp short l_g_miniature_58
          
        l_g_miniature_52:
        mul ecx
        shl eax, 2
        add eax, 8
        add eax, win.pbitmap[esi]
        mov ebx, eax  // ebx = int(ecx * ratio) * win.w * 4 + 8 + base
        
        l_g_miniature_54:
        xor ecx, ecx
        
        l_g_miniature_55:
          cmp ecx, g_miniature_w
          jnb l_g_miniature_58
            
            mov [ss:ebp - 4], ecx
            fild dword [ss:ebp - 4]
            fld dword [ss:ebp - 8]
            fmulp st1, st0
            fistp dword [ss:ebp - 4]  // [ss:ebp - 4] = int(ecx * ratio)
            
            mov eax, [ss:ebp - 4]
            movzx edx, win.w[esi]
            cmp eax, edx
            jb l_g_miniature_56
              // over win.w
              neg ecx
              add ecx, g_miniature_w
              xor eax, eax
              rep stosd
              jmp short l_g_miniature_58
              
            l_g_miniature_56:
            shl eax, 2
            add eax, ebx
            mov eax, [es:eax]
            stosd
            
            inc ecx
            jmp l_g_miniature_55
            
        l_g_miniature_58:
       pop ebx
      pop ecx
      inc ecx
      jmp l_g_miniature_5
  
  l_g_miniature_8:
pop edx
// restore address space
mov eax, p_current
mov [es:eax + offset TssRec.cr3], edx
mov cr3, edx

l_g_miniature_9:
mov edi, ebx
mov esp, ebp
pop ebp

call g_leave
ret

// only starter
g_minall:
call s_chkstarter
jnz l_g_minall_9
  
  // minimize
  call g_enter
  
  mov dh, wactive
  mov dl, WIN_NONE
  mov ah, 4
  call s_post_ada
  mov wactive, WIN_NONE
  mov wover, WIN_NONE
  
  xor esi, esi
  
  l_g_minall_5:
    mov eax, win.flags[esi]
    test eax, WINFLAGS_VALID
    jz l_g_minall_6
      test eax, WINFLAGS_ALWAYSONTOP
      jnz l_g_minall_6
        or win.flags[esi], WS_MINIMIZE
        
    l_g_minall_6:
    add esi, sizeof WinRec
    cmp esi, sizeof WinRec * MAX_WIN
    jb l_g_minall_5
    
  call g_leave
  
  // repaint
  xor ecx, ecx
  xor ebx, ebx
  movzx esi, g_info.xres
  dec esi
  movzx edi, g_info.yres
  dec edi
  call g_paint
  
l_g_minall_9:
ret

// OUT: eax = old_flags, ebx = old_eip, edx = old_esp, ecx = old_ebp
x_get:
mov edi, p_current
mov eax, [es:edi + offset ThreadRec.catch.flags]
mov ebx, [es:edi + offset ThreadRec.catch.eip]
mov edx, [es:edi + offset ThreadRec.catch.esp]
mov ecx, [es:edi + offset ThreadRec.catch.ebp]
ret

// IN: eax = flags, ebx = catch_eip, edx = esp, ebp = ebp
// OUT: eax = old_flags, ebx = old_eip, edx = old_esp, ebp = old_ebp
x_set:
mov edi, p_current
xchg eax, [es:edi + offset ThreadRec.catch.flags]
xchg ebx, [es:edi + offset ThreadRec.catch.eip]
xchg edx, [es:edi + offset ThreadRec.catch.esp]
xchg ebp, [es:edi + offset ThreadRec.catch.ebp]
ret

x_throw:
mov edi, p_current
mov eax, [es:edi + offset ThreadRec.catch.flags]
mov ebx, [es:edi + offset ThreadRec.catch.eip]
mov edx, [es:edi + offset ThreadRec.catch.esp]
mov ebp, [es:edi + offset ThreadRec.catch.ebp]

test al, X_FLAG_VALID
jnz l_x_throw_valid
  
  //... write error message: uncatched error
  
  l_x_throw_11: jmp l_x_throw_11

l_x_throw_valid:
test al, X_FLAG_SYSTEM
jz l_x_throw_user
  // system
  mov esp, edx
  jmp ebx
  
l_x_throw_user:
// stack0
mov eax, edi
add eax, offset ThreadRec.pl0stack + PL0_STACK_SIZE
mov esp, eax
mov tss.tss.ss0, ss
mov tss.tss.esp0, eax

// stack3
push SELECTOR_USER_DATA | 3
push edx

// flags
push 0x200 //pushfd

// cs:eip
push SELECTOR_USER_CODE | 3
push ebx

// selectors
mov dx, SELECTOR_USER_DATA | 3
mov ds, dx
mov es, dx

iretd

uns8 t_time, t_time2
SystemTime t_system

t_systime2ftime_months:
dw 0,31,59,90,120,151,181,212,243,273,304,334

t_systime2ftime_months_leap:
dw 0,31,60,91,121,152,182,213,244,274,305,335

// IN: eax = date (year << 9 + month << 5 + day)
// OUT: eax = days
// KEEP: esi, edi
t_systime2ftime_days:
push eax
  shr eax, 9  
  sub eax, 1600
  
  mov ebx, eax
  mov ecx, 365
  mul ecx
  
  push ebx
    shr ebx, 2
    add ebx, eax // ebx = (year - 1600) * 365 + ((year - 1600) / 4)
  pop eax
  mov ecx, 100
  xor edx, edx
  div ecx
  sub ebx, eax // ebx -= (year - 1600) / 100
  
  shr eax, 2
  add eax, ebx // eax = ebx + (year - 1600) / 400
  
  sub eax, 365 // eax -= 365 (1600->1601)
pop ebx
push ebx

  push eax

    mov eax, ebx
    shr eax, 9  // eax = date >> 9 (year)
    
    shr ebx, 5
    dec ebx
    and ebx, 15
    shl ebx, 1  // ebx = pointer to months
    
    test al, 3
    jnz l_t_systime2ftime_days_notleap
      mov ecx, 100
      xor edx, edx
      div ecx
      or edx, edx
      jnz l_t_systime2ftime_days_leap
        test al, 3
        jnz l_t_systime2ftime_days_notleap
      
    l_t_systime2ftime_days_leap:
    movzx edx, word ptr [cs:ebx + offset t_systime2ftime_months_leap]
    dec edx
    jmp short l_t_systime2ftime_days_6
    
    l_t_systime2ftime_days_notleap:
    movzx edx, word ptr [cs:ebx + offset t_systime2ftime_months]

    l_t_systime2ftime_days_6:
  
  pop eax

  add eax, edx // eax += days[month-1]
pop ebx
push ebx
  and ebx, 31
  dec ebx
  add eax, ebx  // eax += day-1
pop ebx
ret

// IN: eax = days
// OUT: eax = date (year << 9 + month << 5 + day)
// KEEP: esi, edi
t_ftime2systime_days:
add eax, 366
mov ecx, 400
mul ecx
mov ecx, 146097
div ecx
add eax, 1600
xchg eax, ebx  // ebx = year
xchg eax, edx
mov ecx, 400
xor edx, edx
div ecx  // eax = day of year

push eax

  mov eax, ebx
  test al, 3
  jnz l_t_ftime2systime_days_notleap
    mov ecx, 100
    xor edx, edx
    div ecx
    or edx, edx
    jnz l_t_ftime2systime_days_leap
      test al, 3
      jnz l_t_ftime2systime_days_notleap

l_t_ftime2systime_days_leap:

pop eax

mov ecx, 22

l_t_ftime2systime_days_leap1:
  movzx edx, word ptr [cs:ecx + offset t_systime2ftime_months_leap]
  cmp eax, edx
  jnb l_t_ftime2systime_days_8
    sub ecx, 2
    jmp short l_t_ftime2systime_days_leap1
  

l_t_ftime2systime_days_notleap:

pop eax

mov ecx, 22

l_t_ftime2systime_days_notleap1:
  movzx edx, word ptr [cs:ecx + offset t_systime2ftime_months]
  cmp eax, edx
  jnb l_t_ftime2systime_days_8
    sub ecx, 2
    jmp short l_t_ftime2systime_days_notleap1

l_t_ftime2systime_days_8:
shr ecx, 1
inc ecx
shl ebx, 4
or ebx, ecx  // ebx << 4 + month

sub eax, edx
inc eax
shl ebx, 5
or ebx, eax  // ebx << 5 + day

mov eax, ebx
ret

// IN: al = index, OUT: al = value, dh = BCD value
// KEEP: ebx, esi, edi
t_getlocal_get:
out 70h, al
in al, 71h
mov cl, al
mov dh, al
shr al, 4
and cl, 15
mov dl, 10
mul dl
add al, cl
ret

// IN: al = value, OUT: dl = hex
t_setlocal_calc:
movzx eax, al
mov ecx, 10
xor edx, edx
div ecx
shl al, 4
add dl, al
ret

// IN: ax = new hour, es:edi -> SystemTime
// OUT: eax = days
t_getsystem_makedays:
mov word ptr [es:edi + offset SystemTime.wHour], ax  // new hour
movzx eax, word ptr [es:edi + offset SystemTime.wYear]
shl eax, 4
or ax, word ptr [es:edi + offset SystemTime.wMonth]
shl eax, 5
or ax, word ptr [es:edi + offset SystemTime.wDay]
call t_systime2ftime_days
ret

// IN: eax = days, es:edi -> SystemTime
t_getsystem_makedate:
call t_ftime2systime_days
mov ecx, eax
shr eax, 9
mov word ptr [es:edi + offset SystemTime.wYear], ax
mov eax, ecx
shr eax, 5
and eax, 15
mov word ptr [es:edi + offset SystemTime.wMonth], ax
mov eax, ecx
and eax, 31
mov word ptr [es:edi + offset SystemTime.wDay], ax
ret

// IN: es:edi -> systemtime, es:esi -> ftime, max year = 32767
t_systime2ftime:
movzx eax, word ptr [es:edi + offset SystemTime.wYear]
movzx ecx, word ptr [es:edi + offset SystemTime.wMonth]
shl eax, 4
or eax, ecx
movzx ecx, word ptr [es:edi + offset SystemTime.wDay]
shl eax, 5
or eax, ecx
call t_systime2ftime_days
push eax
  movzx eax, word ptr [es:edi + offset SystemTime.wHour]
  mov ecx, 60
  mul ecx
  movzx ecx, word ptr [es:edi + offset SystemTime.wMinute]
  add eax, ecx
  mov ecx, 60
  mul ecx
  movzx ecx, word ptr [es:edi + offset SystemTime.wSecond]
  add eax, ecx
  xchg ebx, eax  // ebx = hms
pop eax
mov ecx, 86400
mul ecx
add eax, ebx
adc edx, 0

pushfd
  cli
  mov dword ptr t_time[0], eax
  xchg eax, edx
  mov ecx, 10000000
  mul ecx
  mov dword ptr t_time[4], eax
  mov eax, dword ptr t_time[0]
  mul ecx
  mov dword ptr t_time[0], eax
  add dword ptr t_time[4], edx  // t_time = edx:eax * 10000000
  
  movzx eax, word ptr [es:edi + offset SystemTime.wMilliseconds]
  mov ecx, 10000000 / 1000
  mul ecx
  add dword ptr t_time[0], eax
  adc dword ptr t_time[4], edx
  mov eax, dword ptr t_time[0]
  mov edx, dword ptr t_time[4]
popfd

mov [es:esi], eax
mov [es:esi + 4], edx
ret

// IN: es:esi -> ftime, es:edi -> systemtime
t_ftime2systime:
pushfd
  cli
  mov eax, [es:esi + 4]
  mov ecx, 10000000
  xor edx, edx
  div ecx
  mov dword ptr t_time[4], eax
  mov eax, [es:esi]
  div ecx
  mov dword ptr t_time[0], eax
  
  xchg eax, edx  // eax = ftime % 10000000
  mov ecx, 10000
  xor edx, edx
  div ecx
  mov [es:edi + offset SystemTime.wMilliseconds], ax
  
  mov eax, dword ptr t_time[4]
  mov ecx, 86400
  xor edx, edx
  div ecx
  mov dword ptr t_time[4], eax
  mov eax, dword ptr t_time[0]
  div ecx
  mov dword ptr t_time[0], eax  // t_time = days
  
  xchg eax, edx  // eax = ftime / 10000000 % 86400
  mov ecx, 60
  xor edx, edx
  div ecx
  mov [es:edi + offset SystemTime.wSecond], dx
  xor edx, edx
  div ecx
  mov [es:edi + offset SystemTime.wMinute], dx
  mov [es:edi + offset SystemTime.wHour], ax
  
  // day of week
  mov eax, dword ptr t_time[0]
  mov ecx, 7
  xor edx, edx
  div ecx
  xchg eax, edx
  add al, 1 // dow 1601-01-01
  cmp al, 7
  jb l_t_ftime2systime_1
    xor eax, eax
  
  l_t_ftime2systime_1:
  mov [es:edi + offset SystemTime.wDayOfWeek], ax
  
  // date
  mov eax, dword ptr t_time[0]
  call t_ftime2systime_days
  push eax
    and eax, 31
    mov [es:edi + offset SystemTime.wDay], ax
  pop eax
  push eax
    shr eax, 5
    and eax, 15
    mov [es:edi + offset SystemTime.wMonth], ax  
  pop eax
  shr eax, 9
  mov [es:edi + offset SystemTime.wYear], ax
popfd
ret

// IN: es:edi -> SystemTime
t_getlocal:
pushfd
  cli

  mov eax, 32h // century
  call t_getlocal_get
  mov ecx, 100
  mul ecx
  xchg eax, ebx
  
  mov eax, 9 // year
  call t_getlocal_get
  add bl, al
  adc bh, 0
  mov [es:edi + offset SystemTime.wYear], bx
  
  mov eax, 8 // month
  call t_getlocal_get
  mov [es:edi + offset SystemTime.wMonth], ax
  
  mov eax, 7 // day
  call t_getlocal_get
  mov [es:edi + offset SystemTime.wDay], ax
  
  mov eax, 6 // day of week + 1
  out 70h, al
  in al, 71h
  dec al
  mov [es:edi + offset SystemTime.wDayOfWeek], ax
  
  mov eax, 4 // hour
  call t_getlocal_get
  mov [es:edi + offset SystemTime.wHour], ax
  
  mov eax, 2 // min
  call t_getlocal_get
  mov [es:edi + offset SystemTime.wMinute], ax
  
  mov eax, 0 // sec
  call t_getlocal_get
  mov [es:edi + offset SystemTime.wSecond], ax
  
  // milliseconds
  cmp dh, tmr_ms_seconds
  jz l_t_getlocal_6
    xor ax, ax
    jmp short l_t_getlocal_7
    
  l_t_getlocal_6:
  mov ax, tmr_ms // ms
  
  l_t_getlocal_7:
  mov [es:edi + offset SystemTime.wMilliseconds], ax
  
  mov al, 0
popfd
ret

// IN: es:edi -> SystemTime
t_setlocal:
pushfd
  cli
  
  movzx eax, word ptr [es:edi + offset SystemTime.wYear]
  mov ecx, 100
  xor edx, edx
  div ecx
  mov ebx, edx
  
  call t_setlocal_calc
  mov al, 32h // century
  out 70h, al
  mov al, dl
  out 71h, al
  
  mov al, bl
  call t_setlocal_calc
  mov al, 9 // year
  out 70h, al
  mov al, dl
  out 71h, al
  
  mov ax, [es:edi + offset SystemTime.wMonth]
  call t_setlocal_calc
  mov al, 8 // month
  out 70h, al
  mov al, dl
  out 71h, al
  
  mov ax, [es:edi + offset SystemTime.wDay]
  call t_setlocal_calc
  mov al, 7 // day
  out 70h, al
  mov al, dl
  out 71h, al
  
  mov ax, [es:edi + offset SystemTime.wHour]
  call t_setlocal_calc
  mov al, 4 // hour
  out 70h, al
  mov al, dl
  out 71h, al
  
  mov ax, [es:edi + offset SystemTime.wMinute]
  call t_setlocal_calc
  mov al, 2 // min
  out 70h, al
  mov al, dl
  out 71h, al
  
  mov ax, [es:edi + offset SystemTime.wSecond]
  call t_setlocal_calc
  mov al, 0 // sec
  out 70h, al
  mov al, dl
  out 71h, al
  
  mov al, 0
popfd
ret

// IN: es:edi -> SystemTime
t_getsystem:
call t_getlocal
movzx eax, word ptr [es:edi + offset SystemTime.wHour]
sub eax, time_zone
cmp eax, 0
jl l_t_getsystem_2
cmp eax, 24
jnl l_t_getsystem_3
mov word ptr [es:edi + offset SystemTime.wHour], ax
ret

l_t_getsystem_2:
add eax, 24
call t_getsystem_makedays
dec eax
dec byte ptr [es:edi + offset SystemTime.wDayOfWeek]
cmp byte ptr [es:edi + offset SystemTime.wDayOfWeek], 7
jb l_t_getsystem_26
  add byte ptr [es:edi + offset SystemTime.wDayOfWeek], 7

l_t_getsystem_26:
call t_getsystem_makedate
ret

l_t_getsystem_3:
sub eax, 24
call t_getsystem_makedays
inc eax
inc byte ptr [es:edi + offset SystemTime.wDayOfWeek]
cmp byte ptr [es:edi + offset SystemTime.wDayOfWeek], 7
jb l_t_getsystem_36
  sub byte ptr [es:edi + offset SystemTime.wDayOfWeek], 7

l_t_getsystem_36:
call t_getsystem_makedate
ret

// OUT: eax = local UNIX time
t_getunix:
pushfd
  cli
  mov edi, VA_SYSTEM + offset t_system
  call t_getlocal
  
  movzx eax, t_system.wYear
  shl eax, 4
  mov dx, t_system.wMonth
  or al, dl
  shl eax, 5
  mov dx, t_system.wDay
  or al, dl
  
  call t_systime2ftime_days
  
  sub eax, 134774  // 1970-01-01
  
  push eax
    movzx eax, t_system.wHour
    mov ecx, 60
    mul ecx
    movzx ecx, t_system.wMinute
    add eax, ecx
    mov ecx, 60
    mul ecx
    movzx ecx, t_system.wSecond
    add eax, ecx
    xchg ebx, eax  // ebx = hms
  pop eax
  mov ecx, 86400
  mul ecx
  add eax, ebx
  adc edx, 0
  
popfd
ret

// IN: eax = UNIX time
// OUT: edx:eax = ftime
t_unix2ftime:
xor edx, edx
add eax, 134774 * 86400
adc edx, 2  // 134774 * 86400 >> 32

pushfd
  cli
  mov dword ptr t_time[0], eax
  xchg eax, edx
  mov ecx, 10000000
  mul ecx
  mov dword ptr t_time[4], eax
  mov eax, dword ptr t_time[0]
  mul ecx
  add edx, dword ptr t_time[4]
popfd

ret

// IN: edx:eax = ftime
// OUT: eax = UNIX time
t_ftime2unix:
test edx, edx
jnz l_t_ftime2unix_1
  test eax, eax
  jz l_t_ftime2unix_9
    
l_t_ftime2unix_1:
pushfd
  cli
  mov dword ptr t_time[0], eax
  xchg eax, edx
  xor edx, edx
  mov ecx, 10000000
  div ecx
  mov dword ptr t_time[4], eax
  mov eax, dword ptr t_time[0]
  div ecx
  add edx, dword ptr t_time[4]
popfd
sub eax, 134774 * 86400

l_t_ftime2unix_9:
ret

DELCHAR = 4  // 0E5h
MAX_MASK = 64

FILE_ATTRIBUTE_READONLY  = 0x00000001
FILE_ATTRIBUTE_HIDDEN    = 0x00000002
FILE_ATTRIBUTE_SYSTEM    = 0x00000004
FILE_ATTRIBUTE_DIRECTORY = 0x00000010
FILE_ATTRIBUTE_ARCHIVE   = 0x00000020
FILE_ATTRIBUTE_DEVICE    = 0x00000040
FILE_ATTRIBUTE_NORMAL    = 0x00000080
FILE_ATTRIBUTE_TEMPORARY     = 0x00000100
FILE_ATTRIBUTE_SPARSE_FILE   = 0x00000200
FILE_ATTRIBUTE_REPARSE_POINT = 0x00000400
FILE_ATTRIBUTE_COMPRESSED    = 0x00000800
FILE_ATTRIBUTE_OFFLINE       = 0x00001000
FILE_ATTRIBUTE_NOT_CONTENT_INDEXED = 0x00002000
FILE_ATTRIBUTE_ENCRYPTED       = 0x00004000
FILE_ATTRIBUTE_VALID_FLAGS     = 0x00007fb7
FILE_ATTRIBUTE_VALID_SET_FLAGS = 0x000031a7
FILE_ATTRIBUTE_LINUX = 0x08000000
FILE_ATTRIBUTE_LINK  = 0x04000000

struct InSrchRec{
  char FileMask[MAX_MASK]
  uns8 Cluster
  uns4 Size, File, Offset
  uns2 ThreadId
  uns1 Disk, Rsv1
}

InSrchRec srch[MAX_SRCH]
char fs_utf8buf[MAX_PATH], fs_link[MAX_PATH]
uns1 fs_mode, fs_i, fs_ldiskn_format
bool fs_dosplit, fs_bigendian, fs_hack

[dalign 32]
uns4 fs_rec, fs_srchofs, fs_edi0, fs_edimax, fs_fsid, fs_max
uns4 fs_diskmain_format

[dalign 64]
uns8 fs_ftime

SystemTime fs_systime

fs_enter:
push eax
  l_fs_enter_1:
    mov al, 1
    lock xchg al, fs_busy
    test al, al
    jz l_fs_enter_2
      call p_noop
      jmp short l_fs_enter_1
      
      /*
      pop eax
      pop eax
      mov al, ERC_BUSY
      ret
      */
  l_fs_enter_2:
  mov eax, p_current
  or byte ptr [es:eax + offset ThreadRec.flags], THREAD_FLAGS_DISK_BUSY
pop eax
ret

fs_leave:
push eax
  mov eax, p_current
  and byte ptr [es:eax + offset ThreadRec.flags], -1 - THREAD_FLAGS_DISK_BUSY
  mov fs_busy, 0
pop eax
ret

fs_enter2:
push eax
  l_fs_enter2_1:
    mov al, 1
    lock xchg al, fs_busy
    or al, al
    jz l_fs_enter2_2
      call p_noop
      jmp l_fs_enter2_1
      
  l_fs_enter2_2:
  mov eax, p_current
  or byte ptr [es:eax + offset ThreadRec.flags], THREAD_FLAGS_DISK_BUSY
pop eax
ret

// IN: es:edx -> file name
// OUT: al = ldiskn, ebx = dir cluster, es:edx -> after disk letter or '/'
// KEEP: ecx, esi, edi
fs_disk:
cmp byte ptr [es:edx], 0
jz l_fs_disk_2
  
  mov al, [es:edx+1]
  cmp al, ':'
  jnz l_fs_disk_2
  
    xor ebx, ebx
    mov al, [es:edx]
    cmp al, 'a'
    jb l_fs_disk_1
      cmp al, 'z'
      ja l_fs_disk_1
        sub al, 32
        
    l_fs_disk_1:
    add edx, 2
    mov cl, [es:edx]
    cmp cl, '/'
    jnz l_fs_disk_3
      inc edx
      jmp short l_fs_disk_3
  
l_fs_disk_2:
mov ebx, p_current
mov al, [es:ebx + offset ThreadRec.curdisk]
mov cl, [es:edx]
cmp cl, '/'
jnz l_fs_disk_25
  xor ebx, ebx
  inc edx
  jmp short l_fs_disk_3

l_fs_disk_25:
mov ebx, [es:ebx + offset ThreadRec.curdir]

l_fs_disk_3:
and al, 31
ret

// IN: edi = index to disk_info, al = ldiskn
// OUT: al = disk_info.fsid[edi]
// KEEP ebx, edx, esi, edi
fs_load_fsid:
push ebx
 push edx
  push esi
   push edi
    
    mov esi, disk_info.main[edi]
    mov ebx, 3
    xor edx, edx
    mov ecx, 4
    mov edi, VA_SYSTEM + offset fs_fsid
    
    test esi, esi
    jz l_fs_load_fsid_8
    
    mov ah, 2  // read
    call esi
    
    mov al, 0
    cmp fs_fsid, "NTFS"
    jnz l_fs_load_fsid_61
      mov al, FSID_NTFS
      jmp short l_fs_load_fsid_7
      
    l_fs_load_fsid_61:
    //...
    mov al, FSID_EXT2
    
    l_fs_load_fsid_7:
   pop edi
   push edi
    mov disk_info.fsid[edi], al
    
    l_fs_load_fsid_9:
    
   pop edi
  pop esi
 pop edx  
pop ebx
ret

l_fs_load_fsid_8:
mov al, 0
jmp l_fs_load_fsid_9

// IN: esi, edi, ecx = count
// OUT: al = 0(equal) || 1(not equal)
eqxcase:
l_eqxcase_1:
jecxz l_eqxcase_8
  dec ecx
  mov al, [esi]
  mov dl, [edi]
  cmp al, dl
  jz l_eqxcase_next
    cmp al, 'a'
    jb l_eqxcase_6
      cmp al, 'z'
      ja l_eqxcase_6
        sub al, 32

    l_eqxcase_6:
    cmp dl, 'a'
    jb l_eqxcase_7
      cmp dl, 'z'
      ja l_eqxcase_7
        sub dl, 32

    l_eqxcase_7:
    cmp al, dl
    jz l_eqxcase_next
      mov al, 1
      jmp l_eqxcase_9

  l_eqxcase_next:
  inc esi
  inc edi
  jmp l_eqxcase_1

l_eqxcase_8:
mov al, 0
l_eqxcase_9:
ret

// IN: esi, edi, ecx = count
// OUT: al = 0(equal) || 1(not equal)
eqxcase_qm:
l_eqxcase_qm_1:
jecxz l_eqxcase_qm_8
  dec ecx
  mov al, [esi]
  mov dl, [edi]
  cmp al, dl
  jz l_eqxcase_qm_next
    cmp al, 'a'
    jb l_eqxcase_qm_6
      cmp al, 'z'
      ja l_eqxcase_qm_6
        sub al, 32

    l_eqxcase_qm_6:
    cmp dl, 'a'
    jb l_eqxcase_qm_7
      cmp dl, 'z'
      ja l_eqxcase_qm_7
        sub dl, 32

    l_eqxcase_qm_7:
    cmp al, dl
    jz l_eqxcase_qm_next
      cmp al, '?'
      jz l_eqxcase_qm_next
        cmp dl, '?'
        jz l_eqxcase_qm_next
          mov al, 1
          jmp l_eqxcase_qm_9

  l_eqxcase_qm_next:
  inc esi
  inc edi
  jmp l_eqxcase_qm_1

l_eqxcase_qm_8:
mov al, 0
l_eqxcase_qm_9:
ret

// IN: eax
// OUT: eax
// KEEP: all but eax
fs_tolower:
cmp eax, 'A'
jb near l_fs_tolower_9
cmp eax, 'Z'
jna near l_fs_tolower_2
cmp eax, 0xC0
jb near l_fs_tolower_9
cmp eax, 0xD6
jna near l_fs_tolower_2
cmp eax, 0xD8
jb near l_fs_tolower_9
cmp eax, 0xDD
jna near l_fs_tolower_2
cmp eax, 0x100
jb near l_fs_tolower_9
cmp eax, 0x136
jna near l_fs_tolower_3
cmp eax, 0x139
jb near l_fs_tolower_9
cmp eax, 0x177
jna near l_fs_tolower_4
cmp eax, 0x179
jb near l_fs_tolower_9
cmp eax, 0x17E
jna near l_fs_tolower_4
cmp eax, 0x200
jb near l_fs_tolower_9
cmp eax, 0x21F
jna near l_fs_tolower_3
cmp eax, 0x224
jb near l_fs_tolower_9
cmp eax, 0x233
jna near l_fs_tolower_3
cmp eax, 0x391
jb near l_fs_tolower_9
cmp eax, 0x3AB
jna l_fs_tolower_2
cmp eax, 0x3D8
jb near l_fs_tolower_9
cmp eax, 0x3EF
jna l_fs_tolower_3
cmp eax, 0x400
jb l_fs_tolower_9
cmp eax, 0x40F
jna l_fs_tolower_5
cmp eax, 0x410
jb l_fs_tolower_9
cmp eax, 0x42F
jna l_fs_tolower_2
cmp eax, 0x460
jb l_fs_tolower_9
cmp eax, 0x481
jna l_fs_tolower_3
cmp eax, 0x488
jb l_fs_tolower_9
cmp eax, 0x4BF
jna l_fs_tolower_3
cmp eax, 0x4C1
jb l_fs_tolower_9
cmp eax, 0x4CE
jna l_fs_tolower_4
cmp eax, 0x4D0
jb l_fs_tolower_9
cmp eax, 0x52F
jna l_fs_tolower_3
//cmp eax, 0x531
//jb l_fs_tolower_9
//cmp eax, 0x556
//jna l_fs_tolower_6
//...
jmp short l_fs_tolower_9

l_fs_tolower_2:
add eax, 20h
jmp short l_fs_tolower_9

l_fs_tolower_3:
or al, 1
jmp short l_fs_tolower_9

l_fs_tolower_4:
test al, 1
jz l_fs_tolower_9
  inc eax
  jmp short l_fs_tolower_9

l_fs_tolower_5:
add eax, 50h
jmp short l_fs_tolower_9

l_fs_tolower_6:
add eax, 30h

l_fs_tolower_9:
ret

// IN: eax
// OUT: eax
// KEEP: all but eax
fs_toupper:
cmp eax, 'a'
jb near l_fs_toupper_9
cmp eax, 'z'
jna near l_fs_toupper_2
cmp eax, 0xE0
jb near l_fs_toupper_9
cmp eax, 0xF6
jna near l_fs_toupper_2
cmp eax, 0xF8
jb near l_fs_toupper_9
cmp eax, 0xFF
jna near l_fs_toupper_2
cmp eax, 0x177
jna near l_fs_toupper_3
cmp eax, 0x179
jb near l_fs_toupper_9
cmp eax, 0x17E
jna near l_fs_toupper_4
cmp eax, 0x200
jb near l_fs_toupper_9
cmp eax, 0x21F
jna near l_fs_toupper_4
cmp eax, 0x224
jb near l_fs_toupper_9
cmp eax, 0x233
jna near l_fs_toupper_4
cmp eax, 0x3B0
jb near l_fs_toupper_9
cmp eax, 0x3CB
jna l_fs_toupper_2
cmp eax, 0x3D8
jb l_fs_toupper_9
cmp eax, 0x3EF
jna l_fs_toupper_3
cmp eax, 0x430
jb l_fs_toupper_9
cmp eax, 0x44F
jna l_fs_toupper_2
cmp eax, 0x45F
jna l_fs_toupper_5
cmp eax, 0x481
jna l_fs_toupper_3
cmp eax, 0x48A
jb l_fs_toupper_9
cmp eax, 0x4BF
jna l_fs_toupper_3
cmp eax, 0x4C1
jb l_fs_toupper_9
cmp eax, 0x4CE
jna l_fs_toupper_4
cmp eax, 0x4D0
jb l_fs_toupper_9
cmp eax, 0x52F
jna l_fs_toupper_3
//cmp eax, 0x561
//jb l_fs_toupper_9
//cmp eax, 0x586
//jna l_fs_toupper_6
//...
jmp short l_fs_toupper_9

l_fs_toupper_2:
sub eax, 20h
jmp short l_fs_toupper_9

l_fs_toupper_3:
and al, 0xFE
jmp short l_fs_toupper_9

l_fs_toupper_4:
test al, 1
jnz l_fs_toupper_9
  dec eax
  jmp short l_fs_toupper_9

l_fs_toupper_5:
sub eax, 50h
jmp short l_fs_toupper_9

l_fs_toupper_6:
sub eax, 30h

l_fs_toupper_9:
ret

// IN: es:esi -> filenamez, es:edx -> path/filenamez
// OUT: al = 0 (equal) || 1 (asc) || -1 (desc) || erc
// KEEP: ebx, edx, ecx
fs_cmp:
push ebx
 push edx
  
  mov edi, edx
  
  l_fs_cmp_1:
  mov fs_i, 0
  
  l_fs_cmp_2:
    movzx eax, byte ptr [es:esi]
    cmp al, 0
    jz near l_fs_cmp_28
    cmp al, '/'
    jnz l_fs_cmp_21
      mov al, 0
      jmp l_fs_cmp_28
      
    l_fs_cmp_21:
    inc esi
    cmp al, 128
    jb near l_fs_cmp_28
      mov dl, al
      and dl, 11100000b
      cmp dl, 11000000b
      jnz l_fs_cmp_24
        // 2-byte char
        and al, 00011111b
        mov dl, [es:esi]
        cmp dl, 0
        jz l_fs_cmp_26
        cmp dl, '/'
        jz l_fs_cmp_26
        inc esi
        mov dh, dl
        and dh, 11000000b
        cmp dh, 10000000b
        jnz l_fs_cmp_26
        and dl, 00111111b
        shl eax, 6
        or al, dl
        jmp l_fs_cmp_28
        
      l_fs_cmp_24:
      mov dl, al
      and dl, 11110000b
      cmp dl, 11100000b
      jnz l_fs_cmp_26
        // 3-byte char
        and al, 00001111b
        mov dl, [es:esi]
        cmp dl, 0
        jz l_fs_cmp_26
        cmp dl, '/'
        jz l_fs_cmp_26
        inc esi
        mov dh, dl
        and dh, 11000000b
        cmp dh, 10000000b
        jnz l_fs_cmp_26
        and dl, 00111111b
        shl eax, 6
        or al, dl
        
        mov dl, [es:esi]
        cmp dl, 0
        jz l_fs_cmp_26
        cmp dl, '/'
        jz l_fs_cmp_26
        inc esi
        mov dh, dl
        and dh, 11000000b
        cmp dh, 10000000b
        jnz l_fs_cmp_26
        and dl, 00111111b
        shl eax, 6
        or al, dl
        
        jmp l_fs_cmp_28
        
      l_fs_cmp_26:
      mov al, ERC_UTF8
      jmp l_fs_cmp_9
      
    l_fs_cmp_28:
    xchg eax, ebx
    xchg esi, edi
    inc fs_i
    cmp fs_i, 2
    jb near l_fs_cmp_2
    
  cmp eax, ebx
  jz l_fs_cmp_31
    
    call fs_toupper
    xchg eax, ebx
    call fs_toupper
    cmp eax, ebx
    jz near l_fs_cmp_31  // equal - next char
      jnb l_fs_cmp_33
        mov al, -1  // not equal - desc
        jmp short l_fs_cmp_9
        
      l_fs_cmp_33:
      mov al, 1  // not equal - asc
      jmp short l_fs_cmp_9
  
  l_fs_cmp_31:
  test eax, eax
  jnz near l_fs_cmp_1

  l_fs_cmp_9:
 pop edx
pop ebx
ret

// IN: esi, edi, ecx = count
// OUT: al = 0 (equal) || 1 (asc) || -1 (desc) || erc
// USES: fs_max, fs_i
fs_cmp_ecx:
mov eax, esi
add eax, ecx
mov fs_max, eax

l_fs_cmp_ecx_1:
mov fs_i, 0
cmp esi, fs_max
jnb near l_fs_cmp_ecx_8

l_fs_cmp_ecx_2:
  movzx eax, byte ptr [esi]
  inc esi
  cmp al, 128
  jb near l_fs_cmp_ecx_28
    mov dl, al
    and dl, 11100000b
    cmp dl, 11000000b
    jnz l_fs_cmp_ecx_24
      // 2-byte char
      and al, 00011111b
      mov dl, [esi]
      cmp dl, 0
      jz l_fs_cmp_ecx_26
      cmp dl, '/'
      jz l_fs_cmp_ecx_26
      inc esi
      mov dh, dl
      and dh, 11000000b
      cmp dh, 10000000b
      jnz l_fs_cmp_ecx_26
      and dl, 00111111b
      shl eax, 6
      or al, dl
      jmp l_fs_cmp_ecx_28
      
    l_fs_cmp_ecx_24:
    mov dl, al
    and dl, 11110000b
    cmp dl, 11100000b
    jnz l_fs_cmp_ecx_26
      // 3-byte char
      and al, 00001111b
      mov dl, [esi]
      cmp dl, 0
      jz l_fs_cmp_ecx_26
      cmp dl, '/'
      jz l_fs_cmp_ecx_26
      inc esi
      mov dh, dl
      and dh, 11000000b
      cmp dh, 10000000b
      jnz l_fs_cmp_ecx_26
      and dl, 00111111b
      shl eax, 6
      or al, dl
      
      mov dl, [esi]
      cmp dl, 0
      jz l_fs_cmp_ecx_26
      cmp dl, '/'
      jz l_fs_cmp_ecx_26
      inc esi
      mov dh, dl
      and dh, 11000000b
      cmp dh, 10000000b
      jnz l_fs_cmp_ecx_26
      and dl, 00111111b
      shl eax, 6
      or al, dl
      
      jmp l_fs_cmp_ecx_28
      
    l_fs_cmp_ecx_26:
    mov al, ERC_UTF8
    jmp l_fs_cmp_ecx_9
    
  l_fs_cmp_ecx_28:
  xchg eax, ebx
  xchg esi, edi
  inc fs_i
  cmp fs_i, 2
  jb near l_fs_cmp_ecx_2
  
cmp eax, ebx
jz near l_fs_cmp_ecx_1
cmp eax, '?'
jz near l_fs_cmp_ecx_1
cmp ebx, '?'
jz near l_fs_cmp_ecx_1

  call fs_toupper
  xchg eax, ebx
  call fs_toupper
  cmp eax, ebx
  jz near l_fs_cmp_ecx_1  // equal - next char
    jnb l_fs_cmp_ecx_33
      mov al, -1  // not equal - desc
      jmp short l_fs_cmp_ecx_9
      
    l_fs_cmp_ecx_33:
    mov al, 1  // not equal - asc
    jmp short l_fs_cmp_ecx_9

l_fs_cmp_ecx_8:
mov al, 0

l_fs_cmp_ecx_9:
ret

// IN: esi, edi, ecx = count1, edx = count2
// OUT: al = 0 (equal) || 1 (asc) || -1 (desc) || erc
fs_cmp16:

l_fs_cmp16_1:
  jecxz l_fs_cmp16_8
  test edx, edx
  jz l_fs_cmp16_7

  dec ecx
  dec edx
  movzx eax, word ptr [esi]
  movzx ebx, word ptr [edi]
  add esi, 2
  add edi, 2
  
  call fs_toupper
  xchg eax, ebx
  call fs_toupper
  cmp eax, ebx
  jz l_fs_cmp16_1  // equal - next char
    jnb l_fs_cmp16_33
      mov al, -1  // not equal - desc
      jmp short l_fs_cmp16_9
      
    l_fs_cmp16_33:
    mov al, 1  // not equal - asc
    jmp short l_fs_cmp16_9

l_fs_cmp16_7:  // ecx != 0 && edx = 0
mov al, -1
jmp short l_fs_cmp16_9

l_fs_cmp16_8: // ecx = 0
test edx, edx
jz l_fs_cmp16_86
  mov al, 1
  jmp short l_fs_cmp16_9
  
l_fs_cmp16_86:
mov al, 0

l_fs_cmp16_9:
ret

// IN: es:edx -> path/filenamez
// OUT: es:edx -> next_dir/filenamez after '/'
// KEEP: ecx, ebx, esi, edi
fs_next_edx:
l_fs_next_edx_1:
  mov al, [es:edx]
  cmp al, '/'
  jz l_fs_next_edx_5
    cmp al, 0
    jz l_fs_next_edx_5
      inc edx
      jmp short l_fs_next_edx_1

l_fs_next_edx_5:
cmp al, 0
jz l_fs_next_edx_8
  inc edx
  mov al, 0
  
l_fs_next_edx_8:
ret

// IN: ds:esi -> source, es:edi -> target, ecx = size, fs_bigendian
// OUT: al = 0 || erc
// KEEP: edx
fs_toutf8:
push edx

l_fs_toutf8_1:
mov ebx, edi
add ebx, MAX_PATH - 1
shr ecx, 1

l_fs_toutf8_5:
jecxz l_fs_toutf8_97
dec ecx
lodsw
movzx eax, ax
test fs_bigendian, 1
jz l_fs_toutf8_52
  xchg al, ah // big endian

l_fs_toutf8_52:
cmp eax, 80h
jnb l_fs_toutf8_6
  stosb
  cmp edi, ebx
  jnb l_fs_toutf8_94
    jmp short l_fs_toutf8_5

l_fs_toutf8_6: // utf8
cmp eax, 2176
jnb l_fs_toutf8_7
  sub eax, 128
  mov ah, al
  shr al, 6
  or al, 11000000b
  stosb
  cmp edi, ebx
  jnb l_fs_toutf8_94
    mov al, ah
    and al, 00111111b
    or al, 128
    stosb
    cmp edi, ebx
    jnb l_fs_toutf8_94
      jmp short l_fs_toutf8_5
    
l_fs_toutf8_7:
sub eax, 2176
mov edx, eax
shr eax, 12
or al, 11100000b
stosb
cmp edi, ebx
jnb l_fs_toutf8_94
  mov eax, edx
  shr eax, 6
  and al, 00111111b
  or al, 128
  stosb
  cmp edi, ebx
  jnb l_fs_toutf8_94
    mov eax, edx
    and al, 00111111b
    or al, 128
    stosb
    cmp edi, ebx
    jnb l_fs_toutf8_94
      jmp short l_fs_toutf8_5
  
l_fs_toutf8_94:
mov al, ERC_TOO_LONG
jmp short l_fs_toutf8_9

l_fs_toutf8_96:
mov al, 1
jmp short l_fs_toutf8_9

l_fs_toutf8_97:
mov al, 0

l_fs_toutf8_98:
stosb

l_fs_toutf8_9:
pop edx
ret

l_fs_toutf16_x:
mov al, ERC_TOO_LONG
ret

l_fs_toutf16_end:  // eax = 0
stosw
ret  // al = 0

// IN: es:esi -> utf8z, es:edi -> utf16z
// OUT: al = erc, es:edi -> after utf16z
// KEEP: ebx
fs_toutf16:
mov ecx, 255

l_fs_toutf16_2:
  jecxz l_fs_toutf16_x
  dec ecx
  
  movzx eax, byte ptr [es:esi]
  inc esi
  test al, al
  jz l_fs_toutf16_end
  
  cmp al, 128
  jb near l_fs_toutf16_28
    mov dl, al
    and dl, 11100000b
    cmp dl, 11000000b
    jnz l_fs_toutf16_24
      // 2-byte char
      and al, 00011111b
      mov dl, [es:esi]
      cmp dl, 0
      jz l_fs_toutf16_26
      cmp dl, '/'
      jz l_fs_toutf16_26
      inc esi
      mov dh, dl
      and dh, 11000000b
      cmp dh, 10000000b
      jnz l_fs_toutf16_26
      and dl, 00111111b
      shl eax, 6
      or al, dl
      jmp l_fs_toutf16_28
      
    l_fs_toutf16_24:
    mov dl, al
    and dl, 11110000b
    cmp dl, 11100000b
    jnz l_fs_toutf16_26
      // 3-byte char
      and al, 00001111b
      mov dl, [es:esi]
      cmp dl, 0
      jz l_fs_toutf16_26
      cmp dl, '/'
      jz l_fs_toutf16_26
      inc esi
      mov dh, dl
      and dh, 11000000b
      cmp dh, 10000000b
      jnz l_fs_toutf16_26
      and dl, 00111111b
      shl eax, 6
      or al, dl
      
      mov dl, [es:esi]
      cmp dl, 0
      jz l_fs_toutf16_26
      cmp dl, '/'
      jz l_fs_toutf16_26
      inc esi
      mov dh, dl
      and dh, 11000000b
      cmp dh, 10000000b
      jnz l_fs_toutf16_26
      and dl, 00111111b
      shl eax, 6
      or al, dl
      
      jmp l_fs_toutf16_28
      
    l_fs_toutf16_26:
    mov al, ERC_UTF8
    jmp l_fs_toutf16_9

  l_fs_toutf16_28:
  stosw
  jmp l_fs_toutf16_2

l_fs_toutf16_9:
ret

// IN: esi = fhandle
// OUT: al = 0 || erc, esi = index to files
// DESTROY: eax
fs_check_thread_esi:
cmp esi, MAX_FILES
jnb l_fs_check_thread_x
shl esi, 5 // assert sizeof OpenFileRec = 32

cmp files.mode[esi], 0
jz l_fs_check_thread_x
  
  mov eax, p_current
  sub eax, VA_THREADS
  shr eax, 12  // assert sizeof ThreadRec = 4096
  cmp ax, files.threadid[esi]
  jz l_fs_check_thread_8
    mov al, ERC_INVALID_THREAD
    jmp short l_fs_check_thread_9
    
l_fs_check_thread_x:
mov al, ERC_INVALID_FHANDLE
jmp short l_fs_check_thread_9

l_fs_check_thread_8:
mov al, 0

l_fs_check_thread_9:
ret

// IN: ebx = threadptr
// KEEP: ebx, edi
fs_release_thread:
// Clear files
push ebx
  
  sub ebx, VA_THREADS
  shr ebx, 12  // assert sizeof ThreadRec = 4096
  xor esi, esi
  
  l_fs_release_thread_1:
    cmp files.threadid[esi], bx
    jnz l_fs_release_thread_2
      mov files.mode[esi], 0
    
    l_fs_release_thread_2:
    add esi, sizeof OpenFileRec
    cmp esi, sizeof OpenFileRec * MAX_FILES
    jb l_fs_release_thread_1
  
  // Clear srchrec  IN: bx
  xor esi, esi
  xor eax, eax
  dec eax  // eax = -1
  
  l_fs_release_thread_5:
    cmp srch.ThreadId[esi], bx
    jnz l_fs_release_thread_6
      mov srch.ThreadId[esi], ax
    
    l_fs_release_thread_6:
    add esi, sizeof InSrchRec
    cmp esi, sizeof InSrchRec * MAX_SRCH
    jb l_fs_release_thread_5
  
  // Clear disk busy
pop ebx
test byte ptr [es:ebx + offset ThreadRec.flags], THREAD_FLAGS_DISK_BUSY
jz l_fs_release_thread_7
  and byte ptr [es:ebx + offset ThreadRec.flags], -1 - THREAD_FLAGS_DISK_BUSY
  mov fs_busy, 0

l_fs_release_thread_7:
ret

// IN: es:esi -> curdirtext, es:edx -> filename, es:edi -> result
fs_merge:
mov ebx, edi
add ebx, MAX_PATH

// Full path
cmp byte[es:edx + 1], ':'
jnz l_fs_merge_1
  mov al, [es:edx]
  inc edx
  inc edx
  cmp byte[es:edx], '/'
  jnz l_fs_merge_05
    inc edx
  
  l_fs_merge_05:
  stosb
  mov al, ':'
  stosb
  mov al, '/'
  stosb
  
  l_fs_merge_06:
    mov al, [es:edx]
    inc edx
    stosb
    cmp al, 0
    jz near l_fs_merge_8
      cmp edi, ebx
      jb l_fs_merge_06
  
  l_fs_merge_07:
  dec edi
  mov al, 0
  stosb
  mov al, ERC_TOO_LONG
  jmp l_fs_merge_9

// Current disk
l_fs_merge_1:
cmp byte[es:edx], '/'
jnz l_fs_merge_2
  inc edx
  mov al, [es:esi]
  jmp l_fs_merge_05

// Merge
l_fs_merge_2:
  mov al, [es:esi]
  inc esi
  cmp al, 0
  jz l_fs_merge_28
    stosb
    cmp edi, ebx
    jb l_fs_merge_2
  
jmp l_fs_merge_07

l_fs_merge_28:
mov al, '/'
cmp byte[es:esi - 2], al
jz l_fs_merge_3
  stosb

// Curdir copied
l_fs_merge_3:
cmp byte[es:edx], '.'
jnz l_fs_merge_4
  cmp byte[es:edx + 1], '.'
  jnz l_fs_merge_38
    //..
    cmp byte[es:edx + 2], '/'
    jnz l_fs_merge_34
    
    add edx, 3
    
    l_fs_merge_30:
    cmp byte[es:edi - 2], ':'
    jnz l_fs_merge_31
      mov al, ERC_PATH_NOT_FOUND
      jmp l_fs_merge_9
      
    l_fs_merge_31:
    cmp byte[es:edi - 1], '/'
    jnz l_fs_merge_32
      dec edi
      
    l_fs_merge_32:
    dec edi
    cmp byte[es:edi], '/'
    jnz l_fs_merge_32
      inc edi
      jmp l_fs_merge_3

    l_fs_merge_34:
    cmp byte[es:edx + 2], 0
    jnz l_fs_merge_38
      add edx, 2
      jmp l_fs_merge_30
      
  l_fs_merge_38:
  cmp byte[es:edx + 1], '/'
  jnz l_fs_merge_39
    //.
    add edx, 2
    jmp l_fs_merge_3
  
  l_fs_merge_39:
  cmp byte[es:edx + 1], 0
  jnz l_fs_merge_4
    inc edx
    jmp l_fs_merge_3
  
l_fs_merge_4:
  mov al, [es:edx]
  inc edx
  stosb
  cmp al, 0
  jz l_fs_merge_8
    cmp edi, ebx
    jnb near l_fs_merge_07
      cmp al, '/'
      jz l_fs_merge_3
        jmp l_fs_merge_4

l_fs_merge_8:
mov al, 0

l_fs_merge_9:
ret

// IN: ds:esi -> maskz, ds:edi -> filenamez
// OUT: al = 0 (match), 1 (not match), erc
fs_ismatch:
mov fs_edi0, edi

// For compatibility
cmp dword ptr [esi], 0x2A2E2A // *.*
jnz l_fs_ismatch_00
  mov word ptr [esi], 0x2A    // *

l_fs_ismatch_00:
// Get filename len
xor ecx, ecx

l_fs_ismatch_01:
cmp byte ptr [edi + ecx], 0
jz l_fs_ismatch_08
  inc ecx
  cmp ecx, MAX_PATH
  jb l_fs_ismatch_01
    jmp l_fs_ismatch_91

l_fs_ismatch_08:
mov fs_edimax, ecx
add fs_edimax, edi

// begin
mov ecx, esi

l_fs_ismatch_11:
cmp byte ptr [ecx], 0
jz l_fs_ismatch_18
  cmp byte ptr [ecx], '*'
  jz l_fs_ismatch_18
    inc ecx
    jmp short l_fs_ismatch_11

l_fs_ismatch_18:
push ecx
 push edi
  sub ecx, esi
  push ecx
    call fs_cmp_ecx
  pop ecx
 pop edi
pop esi
add edi, ecx

or al, al
jnz l_fs_ismatch_9

cmp byte ptr [esi], 0
jnz l_fs_ismatch_20
  cmp byte ptr [edi], 0
  jz l_fs_ismatch_90
    jmp short l_fs_ismatch_91

l_fs_ismatch_20:
// assert byte ptr [esi] = '*'
inc esi
mov ecx, esi

l_fs_ismatch_21:
cmp byte ptr [ecx], 0
jz l_fs_ismatch_26
  cmp byte ptr [ecx], '*'
  jz l_fs_ismatch_28
    inc ecx
    jmp short l_fs_ismatch_21

l_fs_ismatch_26: // 0 - end
sub ecx, esi

mov edi, fs_edimax
sub edi, ecx
cmp edi, fs_edi0
jb l_fs_ismatch_91
  call fs_cmp_ecx
  jmp l_fs_ismatch_9

l_fs_ismatch_28: // '*'
sub ecx, esi
jecxz l_fs_ismatch_20

l_fs_ismatch_281:
  push edi
   push ecx
    push esi
     call fs_cmp_ecx
    pop esi
   pop ecx
  pop edi
  
  or al, al
  jnz l_fs_ismatch_29
    add edi, ecx
    add esi, ecx
    jmp short l_fs_ismatch_20
    
  l_fs_ismatch_29:
  inc edi
  mov eax, edi
  add eax, ecx
  cmp eax, fs_edimax
  jna l_fs_ismatch_281
    jmp short l_fs_ismatch_91
  
l_fs_ismatch_90:
mov al, 0
jmp short l_fs_ismatch_9

l_fs_ismatch_91:
mov al, 1

l_fs_ismatch_9:
ret

// IN: es:edx -> namez
// OUT: al = 0 || ERC_INVALID_CHAR
// KEEP: ecx, edx, ebx, esi, edi
fs_check_valid:
push edx
  
  cmp word ptr [es:edx], "."
  jz l_fs_check_valid_8
  cmp word ptr [es:edx], ".."
  jz l_fs_check_valid_8
  cmp dword ptr [es:edx], ".   "
  jz l_fs_check_valid_8
  
  l_fs_check_valid_5:
    mov al, [es:edx]
    inc edx
    cmp al, 0
    jz l_fs_check_valid_9
      cmp al, '/'
      jz l_fs_check_valid_8
      cmp al, '*'
      jz l_fs_check_valid_8
      cmp al, ';'
      jz l_fs_check_valid_8
      cmp al, ':'
      jz l_fs_check_valid_8
      cmp al, '<'
      jz l_fs_check_valid_8
      cmp al, '>'
      jz l_fs_check_valid_8
      cmp al, '|'
      jz l_fs_check_valid_8
      cmp al, 92
      jz l_fs_check_valid_8
      cmp al, '?'
      jz l_fs_check_valid_8
      cmp al, DELCHAR
      jz l_fs_check_valid_8
      jmp short l_fs_check_valid_5
      
  l_fs_check_valid_8:
  mov al, ERC_INVALID_CHAR
  
  l_fs_check_valid_9:
pop edx
ret

// IN: es:edx -> dirmask, fs_rec, fs_srchofs
// OUT: al = erc, edx, srch.FileMask[fs_srchofs], hd_buffer
// KEEP: ebx
fs_split:
mov esi, edx
mov ecx, MAX_PATH

// split dirmask to dir, mask  KEEP: ebx
l_fs_split_11:
  cmp byte ptr [es:esi], 0
  jz l_fs_split_18
    inc esi
    loop l_fs_split_11
  mov al, ERC_TOO_LONG
  jmp l_fs_split_9
  
l_fs_split_18:
mov ecx, esi

l_fs_split_21:
cmp esi, edx
jz l_fs_split_28
  cmp byte ptr [es:esi], '/'
  jz l_fs_split_27
    dec esi
    jmp short l_fs_split_21
  
  l_fs_split_27:
  inc esi
  
l_fs_split_28:
sub ecx, esi

push esi

  mov edi, VA_SYSTEM + offset srch.FileMask
  add edi, fs_srchofs
  inc ecx
  cmp ecx, MAX_MASK
  jb l_fs_split_31
    mov al, ERC_TOO_LONG
    pop esi
    jmp l_fs_split_9
    
  l_fs_split_31:
  jecxz l_fs_split_32
    mov al, [es:esi]
    inc esi
    stosb
    dec ecx
    jmp short l_fs_split_31
    
  l_fs_split_32:

pop ecx

l_fs_split_325:
sub ecx, edx  // assert ecx < MAX_PATH <= sizeof hd_buffer
cmp ecx, MAX_PATH
jb l_fs_split_326
  mov al, ERC_TOO_LONG
  jmp l_fs_split_9
  
l_fs_split_326:
mov edi, VA_SYSTEM + offset hd_buffer
mov esi, edx

l_fs_split_33:
jecxz l_fs_split_34
  mov al, [es:esi]
  inc esi
  stosb
  dec ecx
  jmp short l_fs_split_33

l_fs_split_34:
mov al, 0
stosb

mov edx, VA_SYSTEM + offset hd_buffer

l_fs_split_9:
ret

// IN: esi -> files, files, al = erc
// OUT: al = erc
// KEEP: ebx, edx, esi, edi
fs_not_share_write:
test al, al
jnz fs_not_share_write_9

push ebx

  xor ebx, ebx
  
  fs_not_share_write_1:
    cmp byte ptr files.mode[ebx], 0
    jz fs_not_share_write_5
      cmp ebx, esi
      jz fs_not_share_write_5
      
        mov eax, files.file[ebx]
        cmp eax, files.file[esi]
        jnz fs_not_share_write_5
          mov al, files.disk[ebx]
          cmp al, files.disk[esi]
          jnz fs_not_share_write_5
            
            mov al, files.mode[esi]
            and al, 3Fh
            cmp al, FOPEN_READ
            ja fs_not_share_write_4
              mov al, files.mode[ebx]
              and al, 3Fh
              cmp al, FOPEN_READ
              jna fs_not_share_write_5
        
        fs_not_share_write_4:
        
        pop ebx
        
        mov al, ERC_IN_USE
        jmp short fs_not_share_write_9
  
    fs_not_share_write_5:
    add ebx, sizeof OpenFileRec
    cmp ebx, MAX_FILES * sizeof OpenFileRec
    jb fs_not_share_write_1
    
pop ebx

mov al, 0

fs_not_share_write_9:
ret

// IN: al = disk, ebx = file number
// OUT: cl = erc
// KEEP: all but ecx
fs_not_used:

xor ecx, ecx

fs_not_used_1:
  cmp byte ptr files.mode[ecx], 0
  jz fs_not_used_5
    cmp ebx, files.file[ecx]
    jnz fs_not_used_5
      cmp al, files.disk[ecx]
      jnz fs_not_used_5          
        mov cl, ERC_IN_USE
        jmp short fs_not_used_9

  fs_not_used_5:
  add ecx, sizeof OpenFileRec
  cmp ecx, MAX_FILES * sizeof OpenFileRec
  jb fs_not_used_1
  
mov cl, 0

fs_not_used_9:
ret

FAT12_ATRB_READONLY = 1
FAT12_ATRB_HIDDEN = 2
FAT12_ATRB_SYSTEM = 4
FAT12_ATRB_VOLLBL = 8
FAT12_ATRB_DIR = 10h
FAT12_ATRB_ARCHIVE = 20h
FAT12_ATRB_DEV = 60h

FAT12_YEAR0 = 1980

struct DirRec{  // size = 32
  char Filename[8]
  char Ext[3]
  uns1 Attrib
  uns1 Reserved
  uns1 TimeCreatedMs
  uns2 TimeCreated
  uns2 DateCreated
  uns2 DateLastAccessed
  uns2 FirstClusterHiBytes
  uns2 LastModTime
  uns2 LastModDate
  uns2 FirstCluster
  uns4 FileSize
}

[dalign 32]
uns4 FAT12_diskmain, FAT12_data, FAT12_clusters, FAT12_next, FAT12_remain
uns4 FAT12_rootsect
uns2 FAT12_hidden, FAT12_sizeFAT, FAT12_tmp, FAT12_first_free
uns2 FAT12_valid, FAT12_first_cluster, FAT12_first_cluster2, FAT12_maxroot
uns1 FAT12_ldiskn, FAT12_clusize, FAT12_cntFAT, FAT12_tmp1
char FAT12_fname[12], FAT12_fname2[12]
bool FAT12_again
DirRec FAT12_dir
SystemTime FAT12_st

// IN: al = ldiskn
// OUT: al = erc
// KEEP: ebx, edi
FAT12_prepare:
push ebx
 push edi

  mov FAT12_ldiskn, al
  
  // diskmain
  movzx esi, al
  shl esi, 5  // log2(DiskInfoRec)
  mov esi, disk_info.main[esi]
  or esi, esi
  jnz l_FAT12_prepare_01
    mov al, ERC_INVALID_DISK_NUMBER
    jmp FAT12_prepare_9
  
  l_FAT12_prepare_01:
  mov FAT12_diskmain, esi
  
  // cluster size
  l_FAT12_prepare_05:
    mov ah, 2
    mov al, FAT12_ldiskn
    mov ebx, 13
    mov ecx, 1
    mov edi, VA_SYSTEM + offset FAT12_clusize
    call FAT12_diskmain
    
    cmp al, ERC_DISK_CHANGED
    jz l_FAT12_prepare_05
  
  test al, al
  jnz near FAT12_prepare_9
  
  mov cl, 0
  mov al, FAT12_clusize
  l_FAT12_prepare_1:
    mov ah, 1
    shl ah, cl
    test ah, al
    jnz l_FAT12_prepare_2
      inc cl
      cmp cl, 7
      jb l_FAT12_prepare_1
        mov al, ERC_FS
        jmp FAT12_prepare_9
  
  l_FAT12_prepare_2:
  mov FAT12_clusize, cl
  
  // hidden sectors
  mov ah, 2
  mov al, FAT12_ldiskn
  mov ebx, 14
  mov ecx, 2
  mov edi, VA_SYSTEM + offset FAT12_hidden
  call FAT12_diskmain
  
  // number of FATs
  mov ah, 2
  mov al, FAT12_ldiskn
  mov ebx, 16
  mov ecx, 1
  mov edi, VA_SYSTEM + offset FAT12_cntFAT
  call FAT12_diskmain
  
  // size of FAT
  mov ah, 2
  mov al, FAT12_ldiskn
  mov ebx, 22
  mov ecx, 2
  mov edi, VA_SYSTEM + offset FAT12_sizeFAT
  call FAT12_diskmain
  
  // max files in the root directory
  mov ah, 2
  mov al, FAT12_ldiskn
  mov ebx, 17
  mov ecx, 2
  mov edi, VA_SYSTEM + offset FAT12_maxroot
  call FAT12_diskmain
  
  // data
  movzx eax, FAT12_hidden
  movzx ecx, FAT12_cntFAT
  movzx edx, FAT12_sizeFAT
  
  l_FAT12_prepare_4:
    add eax, edx
    loop l_FAT12_prepare_4
  
  mov FAT12_rootsect, eax // rootsect
  
  movzx edx, FAT12_maxroot
  shl edx, 5  // * 32 = sizeof DirRec
  add edx, 511
  shr edx, 9
  add eax, edx
  
  mov FAT12_data, eax
  
  // number of clusters  IN: eax = data
  push eax
    mov ah, 4
    mov al, FAT12_ldiskn
    call FAT12_diskmain
  pop edx
  shr eax, 9
  sub eax, edx
  mov cl, FAT12_clusize
  shr eax, cl
  mov FAT12_clusters, eax
  
  // maxroot => data - 2clu
  movzx eax, FAT12_maxroot
  test eax, eax
  jz l_FAT12_prepare_8
    mov eax, 2
    mov cl, FAT12_clusize
    shl eax, cl
    sub FAT12_data, eax
    
  l_FAT12_prepare_8:
  
  // end
  mov FAT12_first_free, 0
  
  mov al, 0
  
  FAT12_prepare_9:
  
 pop edi
pop ebx
ret

// IN: al = ldiskn, ebx = cluster number
// OUT: al = 0 || error, ebx = cluster value
FAT12_get:
cmp FAT12_ldiskn, al
jz l_FAT12_get_0
  push ebx
    call FAT12_prepare
  pop ebx
  test al, al
  jnz l_FAT12_get_9

l_FAT12_get_0:
mov ecx, ebx
shl ebx, 1
add ebx, ecx
shr ebx, 1  // ebx * 3 / 2

push ecx
  movzx eax, FAT12_hidden
  shl eax, 9
  add ebx, eax
  mov ecx, 2
  mov edi, VA_SYSTEM + offset FAT12_tmp
  mov al, FAT12_ldiskn
  mov ah, 2  // read
  call FAT12_diskmain
pop ecx
or al, al
jnz l_FAT12_get_9

movzx eax, FAT12_tmp

test cl, 1
jnz l_FAT12_get_2
  and eax, 0xFFF
  jmp short l_FAT12_get_3

l_FAT12_get_2:
  shr eax, 4

l_FAT12_get_3:
mov ebx, eax

mov al, 0

l_FAT12_get_9:
ret

// IN: al = ldiskn, ebx = cluster number, edx = value
// OUT: al = 0 || error
FAT12_set:
cmp FAT12_ldiskn, al
jz l_FAT12_set_1
  push ebx
   push edx
    call FAT12_prepare
   pop edx
  pop ebx
  test al, al
  jnz near l_FAT12_set_9

l_FAT12_set_1:
mov ecx, ebx
shl ebx, 1
add ebx, ecx
shr ebx, 1  // ebx * 3 / 2

push ecx
 push edx
  movzx eax, FAT12_hidden
  shl eax, 9
  add ebx, eax
  push ebx
    mov ecx, 2
    mov edi, VA_SYSTEM + offset FAT12_tmp
    mov al, FAT12_ldiskn
    mov ah, 2  // read
    call FAT12_diskmain
  pop ebx
 pop edx
pop ecx

or al, al
jnz l_FAT12_set_9

movzx eax, FAT12_tmp

and edx, 0xFFF
test cl, 1
jnz l_FAT12_set_2
  and eax, -1 - 0xFFF
  or eax, edx
  jmp short l_FAT12_set_3
l_FAT12_set_2:
  and eax, 0xF
  shl edx, 4
  or eax, edx
l_FAT12_set_3:
mov FAT12_tmp, ax

movzx ecx, FAT12_cntFAT

l_FAT12_set_4:
  push ecx
   push ebx
    mov ecx, 2
    mov edi, VA_SYSTEM + offset FAT12_tmp
    mov al, FAT12_ldiskn
    mov ah, 3  // write
    call FAT12_diskmain
   pop ebx
  pop ecx

  or al, al
  jnz l_FAT12_set_9

  movzx eax, FAT12_sizeFAT
  shl eax, 9
  add ebx, eax
  loop l_FAT12_set_4

mov al, 0

l_FAT12_set_9:

ret

// IN: FAT12_ldiskn
// OUT: al = 0 || erc, ebx = free cluster number
FAT12_alloc:
push esi
  movzx esi, FAT12_first_free
  
  l_FAT12_alloc_5:
  mov al, FAT12_ldiskn
  push esi
    mov ebx, esi
    call FAT12_get
  pop esi
  or al, al
  jnz l_FAT12_alloc_9
    or ebx, ebx
    jz l_FAT12_alloc_8
      inc esi
      cmp esi, FAT12_clusters
      jb l_FAT12_alloc_5
        mov al, ERC_DISK_FULL
        jmp l_FAT12_alloc_9
    
    l_FAT12_alloc_8:
    mov ebx, esi
    mov FAT12_first_free, si
    mov al, 0
  
  l_FAT12_alloc_9:
pop esi
ret

// IN: FAT12_ldiskn, ebx = cluster number
// OUT: al = 0 || erc
FAT12_free:
cmp bx, FAT12_first_free
jnb l_FAT12_free_2
  mov FAT12_first_free, bx

l_FAT12_free_2:
mov al, FAT12_ldiskn
xor edx, edx
call FAT12_set

ret

// IN: ebx = first cluster number
// KEEP: esi, edi
FAT12_delete:
push esi
 push edi
  or ebx, ebx
  jz l_FAT12_delete_9
  
  l_FAT12_delete_1:
    cmp bx, FAT12_first_free
    jnb l_FAT12_delete_2
      mov FAT12_first_free, bx
    
    l_FAT12_delete_2:
    
    mov al, FAT12_ldiskn
    push ebx
      call FAT12_get
      mov esi, ebx
    pop ebx
  
    or esi, esi
    jz l_FAT12_delete_9
    
      mov al, FAT12_ldiskn
      xor edx, edx
      push esi
        call FAT12_set
      pop ebx
      cmp ebx, 0xFFF
      jnz l_FAT12_delete_1
  
  l_FAT12_delete_9:
 pop edi
pop esi
ret

// IN: al = ldiskn, ebx = cluster number of directory
// OUT: al = 0 || erc, ebx = offset of sector, edi = offset in sector
FAT12_srchdir:
mov FAT12_first_cluster, bx

cmp FAT12_ldiskn, al
jz l_FAT12_srchdir_1
  push ebx
   push esi
    call FAT12_prepare
   pop esi
  pop ebx
  test al, al
  jnz near l_FAT12_srchdir_9

l_FAT12_srchdir_1:
  test ebx, ebx
  jnz l_FAT12_srchdir_2
    movzx eax, FAT12_maxroot
    test eax, eax
    jz l_FAT12_srchdir_2
      // root
      mov ebx, FAT12_rootsect
      shl ebx, 9
      
      shl eax, 5  // 32
      add eax, ebx
      mov FAT12_next, eax
      jmp short l_FAT12_srchdir_4
      
  l_FAT12_srchdir_2:
  // not root
  mov cl, FAT12_clusize
  shl ebx, cl
  add ebx, FAT12_data
  shl ebx, 9  // 512
  
  mov eax, 512  
  shl eax, cl
  add eax, ebx
  mov FAT12_next, eax
  
  // both
  l_FAT12_srchdir_4:
    mov ah, 2
    mov al, FAT12_ldiskn
    push ebx
      mov ecx, 512
      mov edi, VA_SYSTEM + offset fd_buffer
      call FAT12_diskmain
    pop ebx
    or al, al
    jz l_FAT12_srchdir_45
      cmp al, ERC_DISK_CHANGED
      jnz near l_FAT12_srchdir_9
        // Disk changed
        push ebx
         push esi
          mov al, FAT12_ldiskn
          call FAT12_prepare
         pop esi
        pop ebx
        test al, al
        jnz near l_FAT12_srchdir_9
        jmp l_FAT12_srchdir_4
      
    l_FAT12_srchdir_45:
    mov esi, offset FAT12_fname
    mov edi, offset fd_buffer

    l_FAT12_srchdir_5:
      push esi
       push edi
        mov ecx, 11
        call eqxcase
       pop edi
      pop esi
      or al, al
      jz l_FAT12_srchdir_8
        add edi, 32  // assert sizeof DirRec == 32
        cmp edi, 512 + offset fd_buffer
        jb l_FAT12_srchdir_5  // next in sector
    
    add ebx, 512
    cmp ebx, FAT12_next
    jb l_FAT12_srchdir_4  // next sector in cluster
    
  mov cl, FAT12_clusize
  dec ebx
  shr ebx, 9
  sub ebx, FAT12_data
  shr ebx, cl
  // IN: al = ldiskn, ebx = cluster number
  // OUT: al = 0 || error, ebx = cluster value
  mov al, FAT12_ldiskn
  call FAT12_get
  or al, al
  jnz l_FAT12_srchdir_9
    cmp ebx, 0xFFF
    jnz near l_FAT12_srchdir_1
    
mov al, 1
jmp short l_FAT12_srchdir_9

l_FAT12_srchdir_8:
sub edi, offset fd_buffer
mov al, 0

l_FAT12_srchdir_9:
ret

// IN: es:edx -> fname
// OUT: FAT12_fname, es:edx -> 0 or after '/'
// KEEP: ebx
FAT12_load_fname:
mov edi, offset FAT12_fname
mov ecx, 8

mov al, [es:edx]
cmp al, '.'
jnz l_FAT12_load_fname_1
  mov [edi], al
  inc edx
  inc edi
  dec ecx

  mov al, [es:edx]
  cmp al, '.'
  jnz l_FAT12_load_fname_1
    mov [edi], al
    inc edx
    inc edi
    dec ecx

l_FAT12_load_fname_1:
mov al, [es:edx]
cmp al, 0
jz l_FAT12_load_fname_4
  cmp al, '/'
  jz l_FAT12_load_fname_4
    inc edx
    cmp al, '.'
    jz l_FAT12_load_fname_4
      // upper case filename
      cmp al, 'a'
      jb l_FAT12_load_fname_12
        cmp al, 'z'
        ja l_FAT12_load_fname_12
          sub al, 32
          
      l_FAT12_load_fname_12:
      mov [edi], al
      inc edi
      loop l_FAT12_load_fname_1

l_FAT12_load_fname_2:
mov al, [es:edx]
cmp al, 0
jz l_FAT12_load_fname_5
  cmp al, '/'
  jz l_FAT12_load_fname_5
    inc edx
    cmp al, '.'
    jz l_FAT12_load_fname_5
      jmp short l_FAT12_load_fname_2

l_FAT12_load_fname_4:
mov byte ptr [edi], ' '
inc edi
loop l_FAT12_load_fname_4

l_FAT12_load_fname_5:
mov ecx, 3

l_FAT12_load_fname_6:
mov al, [es:edx]
cmp al, 0
jz l_FAT12_load_fname_7
  cmp al, '/'
  jz l_FAT12_load_fname_7
    inc edx
    // upper case ext
    cmp al, 'a'
    jb l_FAT12_load_fname_62
      cmp al, 'z'
      ja l_FAT12_load_fname_62
        sub al, 32
        
    l_FAT12_load_fname_62:
    mov [edi], al
    inc edi
    loop l_FAT12_load_fname_6

jmp short l_FAT12_load_fname_8

l_FAT12_load_fname_7:
mov byte ptr [edi], ' '
inc edi
loop l_FAT12_load_fname_7

l_FAT12_load_fname_8:
mov al, [es:edx]
cmp al, 0
jz l_FAT12_load_fname_9
  inc edx
  cmp al, '/'
  jz l_FAT12_load_fname_9
    jmp short l_FAT12_load_fname_8

l_FAT12_load_fname_9:
ret

// IN: es:edx -> file name, al = ldiskn, ebx = cluster number of directory
// OUT: al = 0 || erc, edi = disk offset of DirRec || 0
FAT12_find_file:

FAT12_find_file_1:
push eax
  call FAT12_load_fname  // KEEP ebx
pop eax

FAT12_find_file_2:
push edx
  call FAT12_srchdir
pop edx
add edi, ebx
or al, al
jnz FAT12_find_file_6
  
  cmp byte ptr [es:edx], 0
  jz FAT12_find_file_5
    mov ah, 2  // read
    mov al, FAT12_ldiskn
    mov ebx, edi
    mov ecx, 32  // assert sizeof DirRec = 32
    mov edi, VA_SYSTEM + offset FAT12_dir
    push edx
      call FAT12_diskmain
    pop edx
    // test attrib dir
    test FAT12_dir.Attrib, FAT12_ATRB_DIR
    jz FAT12_find_file_6
    // dir
    movzx ebx, FAT12_dir.FirstCluster
    mov al, FAT12_ldiskn
    jmp short FAT12_find_file_1

FAT12_find_file_5:
mov al, 0
jmp short FAT12_find_file_9

FAT12_find_file_6:
xor edi, edi
cmp al, ERC_INVALID_DISK_NUMBER
jz FAT12_find_file_9
  
  cmp byte ptr [es:edx], 0
  jz FAT12_find_file_7
    mov al, ERC_PATH_NOT_FOUND
    jmp short FAT12_find_file_9
  
  FAT12_find_file_7:
  mov al, ERC_FILE_NOT_FOUND
  
FAT12_find_file_9:
ret

// IN: ebx = first cluster of directory
// OUT: al = 0 || erc, edi -> disk_adr_DirRec
FAT12_find_place:
test ebx, ebx
jnz l_FAT12_find_place_1
  // root
  mov ebx, FAT12_rootsect
  shl ebx, 9
  
  movzx eax, FAT12_maxroot
  shl eax, 5 // assert sizeof DirRec = 32
  add eax, ebx
  mov FAT12_next, eax
  jmp short l_FAT12_find_place_2
  
// not root
l_FAT12_find_place_1:
  mov cl, FAT12_clusize
  shl ebx, cl
  add ebx, FAT12_data
  shl ebx, 9 // 512

  mov eax, 512  
  shl eax, cl
  add eax, ebx
  mov FAT12_next, eax

// both
l_FAT12_find_place_2:
  mov ah, 2
  mov al, FAT12_ldiskn
  push ebx
    mov ecx, 512
    mov edi, VA_SYSTEM + offset fd_buffer
    call FAT12_diskmain
  pop ebx
  or al, al
  jnz near l_FAT12_find_place_9
    xor edi, edi
    
    l_FAT12_find_place_6:
    mov al, fd_buffer[edi]
    cmp al, DELCHAR
    jz near l_FAT12_find_place_8
      cmp al, 0
      jz near l_FAT12_find_place_8
        add edi, 32  // assert sizeof DirRec = 32
        cmp edi, 512
        jb l_FAT12_find_place_6
          
          add ebx, 512
          cmp ebx, FAT12_next
          jb l_FAT12_find_place_2

  mov cl, FAT12_clusize
  dec ebx
  shr ebx, 9
  sub ebx, FAT12_data
  shr ebx, cl
  // IN: al = ldiskn, ebx = cluster number
  // OUT: al = 0 || error, ebx = cluster value
  mov al, FAT12_ldiskn
  push ebx
    call FAT12_get
  pop edx
  or al, al
  jnz near l_FAT12_find_place_9
    cmp ebx, 0xFFF
    jnz near l_FAT12_find_place_1
      
      // End - alloc new cluster
      mov ebx, edx
      push ebx
        call FAT12_alloc
        mov edx, ebx
      pop ebx
      or al, al
      jnz near l_FAT12_find_place_9
      
      push edx
        mov al, FAT12_ldiskn
        call FAT12_set
      pop ebx
      mov edx, 0xFFF
      push ebx
        mov al, FAT12_ldiskn
        call FAT12_set
      pop ebx
      // Zero new cluster
      xor eax, eax
      mov edi, VA_SYSTEM + offset fd_buffer
      mov ecx, 512 / 4
      cld
      rep stosd
      
      mov cl, FAT12_clusize
      shl ebx, cl
      add ebx, FAT12_data
      shl ebx, 9
      
      push ebx

        mov eax, 1
        shl eax, cl
        mov ecx, eax

        l_FAT12_find_place_7:
          mov ah, 3
          mov al, FAT12_ldiskn
          push ecx
           push ebx
            mov ecx, 512
            mov edi, VA_SYSTEM + offset fd_buffer
            call FAT12_diskmain
           pop ebx
          pop ecx
          add ebx, 512
          loop l_FAT12_find_place_7
        
      pop ebx

      xor edi, edi

l_FAT12_find_place_8:
add edi, ebx

mov al, 0

l_FAT12_find_place_9:
ret

// Get datetime, change to DirRec format
// OUT: cx = time, dx = date
// KEEP: ebx, esi, edi
FAT12_datetime:
push ebx

 push edi
  mov edi, VA_SYSTEM + offset FAT12_st
  call t_getsystem
 pop edi
 
 mov al, byte ptr FAT12_st.wHour
 movzx ecx, al
 
 mov al, byte ptr FAT12_st.wMinute
 shl ecx, 6
 or cl, al
 
 mov al, byte ptr FAT12_st.wSecond
 shl ecx, 5
 shr al, 1
 or cl, al
 
 movzx edx, word ptr FAT12_st.wYear
 sub edx, FAT12_YEAR0  // edx = year
 
 mov al, byte ptr FAT12_st.wMonth
 shl edx, 4
 or dl, al
 
 mov al, byte ptr FAT12_st.wDay
 shl edx, 5
 or dl, al

pop ebx
ret

// [70h] addr, [71h] data
//0	Time.Seconds (0-59)
//2	Time.Minutes (0-59)
//4	Time.Hours (0-23)
//6	Day of week (1-7)
//7	Date of month (1-31)
//8	Month (1-12)
//9	Year (0-99)
//32h	Century

//Bits 0-4: Day (0-31)
//Bits 5-8: Month (0-12)
//Bits 9-15: Year

//Bits 0-4: Second
//Bits 5-10: Minute
//Bits 11-15: Hour

// IN: ebx = first cluster of directory, FAT12_fname, FAT12_first_cluster
// OUT: al = 0 || erc, edi = disk offset
FAT12_create_file:
// check valid chars
mov edx, VA_SYSTEM + offset FAT12_fname
mov byte ptr [es:edx + 11], 0
call fs_check_valid
or al, al
jnz near l_FAT12_create_file_9

// IN: ebx = first cluster of directory
// OUT: al = 0 || erc, edi -> disk_adr_DirRec
movzx ebx, FAT12_first_cluster
call FAT12_find_place
or al, al
jnz near l_FAT12_create_file_9

mov ebx, edi
push edi
  // copy file name
  mov esi, offset FAT12_fname
  mov edi, VA_SYSTEM + offset FAT12_dir
  mov ecx, 11
  cld
  rep movsb
  // size 0, first cluster 0
  xor eax, eax
  mov FAT12_dir.FileSize, eax
  mov FAT12_dir.FirstCluster, ax
  mov FAT12_dir.Attrib, al
  mov FAT12_dir.FirstClusterHiBytes, ax
  // TimeCreated, DateCreated; KEEP ebx
  call FAT12_datetime
  mov FAT12_dir.DateCreated, dx
  mov FAT12_dir.TimeCreated, cx
  // save
  mov ah, 3
  mov al, FAT12_ldiskn
  // ebx = disk offset
  mov ecx, 32  // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  call FAT12_diskmain
pop edi
mov al, 0

l_FAT12_create_file_9:
ret

// IN: esi = index to OpenFileRec
FAT12_postoclu:
mov eax, dword ptr files.pos[esi]
mov cl, FAT12_clusize
shr eax, 9
shr eax, cl
mov ecx, eax

movzx ebx, word ptr files.sectn[esi + 4]
mov word ptr files.sectn[esi + 6], cx
jecxz l_FAT12_postoclu_8

l_FAT12_postoclu_2:
  // IN: al = ldiskn, ebx = cluster number
  // OUT: al = 0 || error, ebx = cluster value
  mov al, files.disk[esi]
  push esi
   push ecx
    call FAT12_get
   pop ecx
  pop esi
  or al, al
  jnz l_FAT12_postoclu_9    
    loop l_FAT12_postoclu_2

l_FAT12_postoclu_8:
mov cl, FAT12_clusize
shl ebx, cl
add ebx, FAT12_data
shl ebx, 9
mov dword ptr files.sectn[esi], ebx
mov al, 0

l_FAT12_postoclu_9:
ret

FAT12_iocalc:
mov cl, FAT12_clusize
mov edx, ebx
shr edx, 9
shr edx, cl   // edx = ebx / clustersizebytes
mov eax, 512
shl eax, cl   // eax = clustersizebytes
dec eax
and ebx, eax  // ebx % clustersizebytes
inc eax

mov ecx, FAT12_remain
sub eax, ebx
ret

// IN: edx = cluster in file, esi -> files
// KEEP: esi, edi
FAT12_check_cluster:
or edx, edx
jnz near l_FAT12_check_cluster_4
  // * first cluster *
  push edi
    mov ebx, files.file[esi]
    mov al, files.disk[esi]
    mov edi, VA_SYSTEM + offset FAT12_dir
    mov ecx, 32  // assert sizeof DirRec = 32
    mov ah, 2
    push esi
      call FAT12_diskmain
    pop esi
  pop edi
  movzx eax, FAT12_dir.FirstCluster
  or eax, eax
  jz l_FAT12_check_cluster_3
    // first cluster already exists
    
    l_FAT12_check_cluster_25: // IN: eax = cluster
    mov cl, FAT12_clusize
    shl eax, cl
    add eax, FAT12_data
    shl eax, 9
    mov dword ptr files.sectn[esi], eax
    jmp l_FAT12_check_cluster_9
    
  l_FAT12_check_cluster_3:
  // first cluster needs to be allocated
  mov al, ERC_FS
  jmp short l_FAT12_check_cluster_99
  
l_FAT12_check_cluster_4:
// * next cluster *
push edi
 push esi
  mov ebx, dword ptr files.sectn[esi]
  mov cl, FAT12_clusize
  shr ebx, 9
  sub ebx, FAT12_data
  shr ebx, cl
  mov al, files.disk[esi]
  push ebx
    call FAT12_get
  pop edx
 pop esi
pop edi
mov eax, ebx
cmp eax, 0xFFF
jnz near l_FAT12_check_cluster_25

mov al, ERC_FS
jmp short l_FAT12_check_cluster_99

l_FAT12_check_cluster_9:
mov al, 0

l_FAT12_check_cluster_99:
ret

// IN: edx = cluster in file, esi -> files
// KEEP: esi, edi
FAT12_check_clusterw:
or edx, edx
jnz near l_FAT12_check_clusterw_4
  // * first cluster *
  push edi
    mov ebx, files.file[esi]
    mov al, files.disk[esi]
    mov edi, VA_SYSTEM + offset FAT12_dir
    mov ecx, 32  // assert sizeof DirRec = 32
    mov ah, 2
    push esi
      call FAT12_diskmain
    pop esi
  pop edi
  movzx eax, FAT12_dir.FirstCluster
  or eax, eax
  jz l_FAT12_check_clusterw_3
    // first cluster already exists
    
    l_FAT12_check_clusterw_25: // IN: eax = cluster
    mov cl, FAT12_clusize
    shl eax, cl
    add eax, FAT12_data
    shl eax, 9
    mov dword ptr files.sectn[esi], eax
    jmp l_FAT12_check_clusterw_9
    
  l_FAT12_check_clusterw_3:
  // first cluster needs to be allocated
  
  push edi
   push esi
    // IN: FAT12_ldiskn
    // OUT: al = 0 || erc, ebx = free cluster number
    mov al, files.disk[esi]
    mov FAT12_ldiskn, al
    call FAT12_alloc
   pop esi
   or al, al
   jnz near l_FAT12_check_clusterw_8
   push esi
    push ebx
      mov al, files.disk[esi]
      mov edx, 0xFFF
      call FAT12_set
    pop eax
   pop esi
   mov FAT12_dir.FirstCluster, ax
   mov word ptr files.sectn[esi + 4], ax  // first cluster
   push esi
    push eax
      mov ebx, files.file[esi]
      mov al, files.disk[esi]
      mov edi, VA_SYSTEM + offset FAT12_dir
      mov ecx, 32  // assert sizeof DirRec = 32
      mov ah, 3
      call FAT12_diskmain
    pop eax
   pop esi
  pop edi
  jmp short l_FAT12_check_clusterw_25
  
l_FAT12_check_clusterw_4:
// * next cluster *
push edi
 push esi
  mov ebx, dword ptr files.sectn[esi]
  mov cl, FAT12_clusize
  shr ebx, 9
  sub ebx, FAT12_data
  shr ebx, cl
  mov al, files.disk[esi]
  push ebx
    call FAT12_get
  pop edx
 pop esi
pop edi
mov eax, ebx
cmp eax, 0xFFF
jnz near l_FAT12_check_clusterw_25

push edi

 push esi
  push edx
    mov al, files.disk[esi]
    mov FAT12_ldiskn, al
    call FAT12_alloc
  pop edx
 pop esi
 or al, al
 jnz near l_FAT12_check_clusterw_8
 mov eax, edx
 
 push esi
  push ebx
    mov edx, ebx
    mov ebx, eax
    mov al, files.disk[esi]
    call FAT12_set
  pop ebx
 pop esi

 push esi  
  push ebx
    mov al, files.disk[esi]
    mov edx, 0xFFF
    call FAT12_set
  pop eax
 pop esi

pop edi
jmp l_FAT12_check_clusterw_25

l_FAT12_check_clusterw_8:
pop edi
jmp short l_FAT12_check_clusterw_99

l_FAT12_check_clusterw_9:
mov al, 0

l_FAT12_check_clusterw_99:
ret

// IN: FAT12_first_cluster
// OUT: al = 0 || erc
FAT12_reduce_dir:
movzx ebx, FAT12_first_cluster
test ebx, ebx
jz near l_FAT12_reduce_8

mov FAT12_valid, bx

l_FAT12_reduce_60:
  mov cl, FAT12_clusize
  shl ebx, cl
  add ebx, FAT12_data
  shl ebx, 9 // 512
  
  mov eax, 512  
  shl eax, cl
  add eax, ebx
  mov FAT12_next, eax

  l_FAT12_reduce_61:
  mov ah, 2  // read
  mov al, FAT12_ldiskn
  push ebx
    mov ecx, 512
    mov edi, VA_SYSTEM + offset fd_buffer
    call FAT12_diskmain
  pop ebx
  
  xor edi, edi
  l_FAT12_reduce_62:
    mov al, fd_buffer[edi]
    cmp al, 0
    jz l_FAT12_reduce_63
      cmp al, DELCHAR
      jnz l_FAT12_reduce_65

    l_FAT12_reduce_63:
    add edi, 32  // assert sizeof DirRec = 32
    cmp edi, 512
    jb l_FAT12_reduce_62
  
  add ebx, 512
  cmp ebx, FAT12_next
  jb l_FAT12_reduce_61  // next sector in cluster

l_FAT12_reduce_64:
// not valid cluster
mov cl, FAT12_clusize
dec ebx
shr ebx, 9
sub ebx, FAT12_data
shr ebx, cl

l_FAT12_reduce_645:
// IN: al = ldiskn, ebx = cluster number
// OUT: al = 0 || error, ebx = cluster value
mov al, FAT12_ldiskn
call FAT12_get
or al, al
jnz l_FAT12_reduce_8
  or ebx, ebx
  jz l_FAT12_reduce_66
    cmp ebx, 0xFFF
    jnz near l_FAT12_reduce_60
jmp short l_FAT12_reduce_7

l_FAT12_reduce_65:
// valid cluster
//mov ebx, FAT12_next
mov cl, FAT12_clusize
//dec ebx
shr ebx, 9
sub ebx, FAT12_data
shr ebx, cl

mov FAT12_valid, bx
jmp short l_FAT12_reduce_645

l_FAT12_reduce_66:
mov al, ERC_FS
jmp short l_FAT12_reduce_8

l_FAT12_reduce_7:
// delete from the last valid cluster
movzx ebx, FAT12_valid
mov al, FAT12_ldiskn
call FAT12_get
cmp ebx, 0xFFF
jz l_FAT12_reduce_8
  call FAT12_delete
  movzx ebx, FAT12_valid
  mov edx, 0xFFF
  mov al, FAT12_ldiskn
  call FAT12_set

l_FAT12_reduce_8:
ret

// IN: FAT12_fname, fs_rec, fs_srchofs
// KEEP: ebx
FAT12_fname_to_mask:
mov edi, fs_srchofs
add edi, offset InSrchRec.FileMask
mov esi, offset FAT12_fname
cmp dword ptr [esi], "*   "
jnz l_FAT12_fname_to_mask_08
  cmp byte ptr [esi + 8], ' '
  jnz l_FAT12_fname_to_mask_08
    mov byte ptr [esi + 8], '*'  // * -> *.*
    
l_FAT12_fname_to_mask_08:
mov ecx, 8

l_FAT12_fname_to_mask_1:
  lodsb
  cmp al, '*'
  jnz l_FAT12_fname_to_mask_2
    mov al, '?'
    
    l_FAT12_fname_to_mask_3:
      mov [edi], al
      inc edi
      inc esi
      loop l_FAT12_fname_to_mask_3
  
    jmp short l_FAT12_fname_to_mask_ext
    
  l_FAT12_fname_to_mask_2:
  mov [edi], al
  inc edi
  loop l_FAT12_fname_to_mask_1
  
l_FAT12_fname_to_mask_ext:
dec esi
mov ecx, 3

l_FAT12_fname_to_mask_6:
  lodsb
  cmp al, '*'
  jnz l_FAT12_fname_to_mask_7
    mov al, '?'
    
    l_FAT12_fname_to_mask_8:
      mov [edi], al
      inc edi
      loop l_FAT12_fname_to_mask_8
  
    jmp short l_FAT12_fname_to_mask_9
    
  l_FAT12_fname_to_mask_7:
  mov [edi], al
  inc edi
  loop l_FAT12_fname_to_mask_6

l_FAT12_fname_to_mask_9:
ret

// IN: eax = datetime_FAT12 (lw = time, hw = date)
// OUT: edx:eax = ftime (1.1.1601, 10 ^ -7 s)
// KEEP: edi
FAT12_datetime_to_ftime:
push eax
  
  shr eax, 16
  add eax, FAT12_YEAR0 << 9
  call t_systime2ftime_days
  mov ebx, eax  // ebx = days

pop eax
push eax  
  shr eax, 11
  and eax, 31
pop ecx
push ecx
  shr ecx, 5
  and ecx, 63
  mov edx, 60
  mul edx
  add eax, ecx  // eax = eax * 60 + minute
pop ecx

and ecx, 31
shl ecx, 1
mov edx, 60
mul edx
add eax, ecx  // eax = eax * 60 + second  

xchg eax, ebx  // eax = days, ebx = time
mov edx, 86400
mul edx
add eax, ebx
adc edx, 0  // edx:eax = days * 86400 + time

xchg ebx, eax
xchg eax, edx
mov ecx, 10000000
mul ecx
xchg ebx, eax
mul ecx
add edx, ebx
ret

// IN: al = ldiskn, FAT12_diskmain
// KEEP: esi
FAT12_doflush:
mov ah, 5 // flush
push esi
  call FAT12_diskmain
pop esi
test al, al
jz l_FAT12_doflush_8
  push eax
    call h_fd_remove_from_cache
  pop eax

l_FAT12_doflush_8:
ret

FAT12_init:
mov FAT12_ldiskn, -1
ret

// IN: es:edx -> fname, al = ldiskn, ebx = dir cluster, esi -> files
// OUT: esi = fhandle
// mode: 1 read, 3 write, 10h append, 20h rewrite
FAT12_fopen:
push esi
  call FAT12_find_file
pop esi
mov files.file[esi], edi

// check not share write
call fs_not_share_write

// file
or al, al
jz l_FAT12_fopen_5
  cmp al, ERC_FILE_NOT_FOUND
  jnz near l_FAT12_fopen_9
    test files.mode[esi], FOPEN_CREATE
    jnz l_FAT12_fopen_2
      test files.mode[esi], FOPEN_APPEND
      jz near l_FAT12_fopen_9
        
        l_FAT12_fopen_2:
        // create file
        mov al, files.disk[esi]
        push esi
          call FAT12_create_file
        pop esi
        or al, al
        jnz near l_FAT12_fopen_9
          mov files.file[esi], edi
          jmp l_FAT12_fopen_6
  
l_FAT12_fopen_5:
// load direntry
push edi
 push esi
  mov al, FAT12_ldiskn
  mov ah, 2 // read
  mov ebx, edi
  mov ecx, 32  // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  call FAT12_diskmain
 pop esi
pop edi

// check read only
test FAT12_dir.Attrib, FILE_ATTRIBUTE_READONLY
jz l_FAT12_fopen_50
  mov files.mode[esi], FOPEN_READ
  
l_FAT12_fopen_50:

// check system file
test FAT12_dir.Attrib, FILE_ATTRIBUTE_SYSTEM
jz l_FAT12_fopen_51
  call s_chkstarter  // keep esi, edi
  jz l_FAT12_fopen_51
    mov al, ERC_ONLY_STARTER
    jmp l_FAT12_fopen_9
  
l_FAT12_fopen_51:

// check not directory
test FAT12_dir.Attrib, FILE_ATTRIBUTE_DIRECTORY
jz l_FAT12_fopen_52
  mov al, ERC_FILE_NOT_FOUND
  jmp l_FAT12_fopen_9
  
l_FAT12_fopen_52:

test files.mode[esi], FOPEN_CREATE
jz l_FAT12_fopen_6
  // rewrite
  movzx ebx, FAT12_dir.FirstCluster
  call FAT12_delete  // keep esi, edi
  
  xor eax, eax
  mov FAT12_dir.FirstCluster, ax
  mov FAT12_dir.FileSize, eax
  
  mov al, FAT12_ldiskn
  mov ah, 3 // write
  mov ebx, edi
  mov ecx, 32  // assert sizeof DirRec = 32
  push edi
   push esi
    mov edi, VA_SYSTEM + offset FAT12_dir
    call FAT12_diskmain
   pop esi
  pop edi

l_FAT12_fopen_6:
// sectn
movzx eax, FAT12_dir.FirstCluster
mov word ptr files.sectn[esi + 4], ax  // first cluster
mov cl, FAT12_clusize
shl eax, 9
shl eax, cl
mov dword ptr files.sectn[esi], eax    // current cluster disk offset
xor eax, eax
dec eax
mov word ptr files.sectn[esi + 6], ax  // current cluster in file = -1

// set mtime
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_FAT12_fopen_61
  call FAT12_datetime  // keep esi, edi
  mov FAT12_dir.LastModDate, dx
  mov FAT12_dir.LastModTime, cx

  mov al, FAT12_ldiskn
  mov ah, 3 // write
  mov ebx, edi
  mov ecx, 32  // assert sizeof DirRec = 32
  push edi
   push esi
    mov edi, VA_SYSTEM + offset FAT12_dir
    call FAT12_diskmain
   pop esi
  pop edi

l_FAT12_fopen_61:

// size
mov eax, FAT12_dir.FileSize
xor edx, edx
mov dword ptr files.size[esi], eax
mov dword ptr files.size[esi + 4], edx

// pos
test files.mode[esi], FOPEN_APPEND
jz l_FAT12_fopen_72
  // append
  mov dword ptr files.pos[esi], eax
  call FAT12_postoclu  // KEEP edx, esi
  jmp short l_FAT12_fopen_73

l_FAT12_fopen_72:
mov dword ptr files.pos[esi], edx

l_FAT12_fopen_73:
mov dword ptr files.pos[esi + 4], edx

shr esi, 5 // assert sizeof OpenFileRec = 32
mov al, 0
jmp short l_FAT12_fopen_99

l_FAT12_fopen_9:
mov files.mode[esi], 0

l_FAT12_fopen_99:
ret

// IN: esi = offset to files, es:edi -> data, ecx = size
// OUT: al = 0 || erc, ecx = sizeread
FAT12_fread:
mov al, files.disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_fread_01
  push esi
   push edi
    push ecx
      call FAT12_prepare
    pop ecx
   pop edi
  pop esi

l_FAT12_fread_01:
mov ebx, dword ptr files.pos[esi]
mov edx, dword ptr files.size[esi]
cmp ebx, edx
jna l_FAT12_fread_02
  mov ebx, edx
  
l_FAT12_fread_02:
mov eax, ebx
add eax, ecx
cmp eax, edx
jna l_FAT12_fread_05
  mov ecx, edx
  sub ecx, ebx
  
l_FAT12_fread_05:
mov FAT12_remain, ecx

push ecx

  l_FAT12_fread_1:
  mov ecx, FAT12_remain
  mov ebx, dword ptr files.pos[esi]
  or ecx, ecx
  jz near l_FAT12_fread_8
    
    call FAT12_iocalc
    
    cmp ecx, eax
    jna l_FAT12_fread_2
      mov ecx, eax
  
    l_FAT12_fread_2: // ecx = remaining bytes in cluster
    cmp dx, word ptr files.sectn[esi + 6]
    jz l_FAT12_fread_3
      
      mov word ptr files.sectn[esi + 6], dx
      push ecx
       push ebx
        call FAT12_check_cluster  // keep esi, edi
       pop ebx
      pop ecx
      or al, al
      jnz l_FAT12_fread_9
      
    l_FAT12_fread_3:
  
    push esi
     push ecx
      push edi
        add ebx, dword ptr files.sectn[esi]     
        mov al, files.disk[esi]
        mov ah, 2  // read
        call FAT12_diskmain
      pop edi
     pop ecx
    pop esi
    mov eax, ecx
    
    add edi, eax
    sub FAT12_remain, eax
    add dword ptr files.pos[esi], eax
    jmp l_FAT12_fread_1
  
  l_FAT12_fread_8:
  mov al, 0
  
  l_FAT12_fread_9:
  
pop ecx

ret

l_FAT12_fwrite_x:
mov al, ERC_READ_ONLY
ret

// IN: esi = offset to files, es:edi -> data, ecx = size
// OUT: al = 0 || erc, ecx = sizewrite
FAT12_fwrite:
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_FAT12_fwrite_x

mov al, files.disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_fwrite_01
  push esi
   push edi
    push ecx
      call FAT12_prepare
    pop ecx
   pop edi
  pop esi

l_FAT12_fwrite_01:
mov ebx, dword ptr files.pos[esi]
mov edx, dword ptr files.size[esi]
cmp ebx, edx
jna l_FAT12_fwrite_02
  mov dword ptr files.pos[esi], edx
  
l_FAT12_fwrite_02:
mov FAT12_remain, ecx

push ecx

  l_FAT12_fwrite_1:
  mov ecx, FAT12_remain
  mov ebx, dword ptr files.pos[esi]
  or ecx, ecx
  jz near l_FAT12_fwrite_8
  
    call FAT12_iocalc
  
    cmp ecx, eax
    jna l_FAT12_fwrite_2
      mov ecx, eax
  
    l_FAT12_fwrite_2: // ecx = remaining bytes in cluster
    cmp dx, word ptr files.sectn[esi + 6]
    jz l_FAT12_fwrite_3
      
      mov word ptr files.sectn[esi + 6], dx
      push ecx
       push ebx
        call FAT12_check_clusterw  // keep esi, edi
       pop ebx
      pop ecx
      or al, al
      jnz l_FAT12_fwrite_98
      
    l_FAT12_fwrite_3:
    push esi
     push ecx
      push edi
        add ebx, dword ptr files.sectn[esi]     
        mov al, files.disk[esi]
        mov ah, 3  // write
        call FAT12_diskmain
      pop edi
     pop ecx
    pop esi
    mov eax, ecx
    
    add edi, eax
    sub FAT12_remain, eax
    add dword ptr files.pos[esi], eax
  
    mov eax, dword ptr files.pos[esi]
    cmp eax, dword ptr files.size[esi]
    jna near l_FAT12_fwrite_1
      mov dword ptr files.size[esi], eax
      jmp l_FAT12_fwrite_1
      
  l_FAT12_fwrite_8:  
  mov al, 0  
  
  l_FAT12_fwrite_9:

pop ecx

l_FAT12_fwrite_91:
ret

l_FAT12_fwrite_98:
pop ecx
sub ecx, FAT12_remain
ret

// IN: esi = offset to files, ebx = file offset
FAT12_fsetpos:
mov al, files.disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_fsetpos_01
  push esi
   push ebx
    call FAT12_prepare
   pop ebx
  pop esi

l_FAT12_fsetpos_01:
mov eax, dword ptr files.size[esi]
cmp ebx, eax
jna l_FAT12_fsetpos_1
  mov ebx, eax

l_FAT12_fsetpos_1:
mov dword ptr files.pos[esi], ebx
call FAT12_postoclu
ret

// IN: esi -> files
FAT12_fcut:
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_FAT12_fcut_8

mov al, files.disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_fcut_01
  push esi
    call FAT12_prepare
  pop esi

l_FAT12_fcut_01:
mov eax, dword ptr files.pos[esi]
mov dword ptr files.size[esi], eax

mov ebx, dword ptr files.sectn[esi + 0]
mov cl, FAT12_clusize
shr ebx, cl
sub ebx, FAT12_data
shr ebx, 9
mov al, files.disk[esi]
push esi
 push ebx
  call FAT12_get
 pop edx
pop esi
cmp ebx, 0xFFF
jz l_FAT12_fcut_6

push edx
  call FAT12_delete
pop ebx

mov al, files.disk[esi]
mov edx, 0xFFF
call FAT12_set

l_FAT12_fcut_6:
mov al, 0
jmp short l_FAT12_fcut_9

l_FAT12_fcut_8:
mov al, ERC_READ_ONLY

l_FAT12_fcut_9:
ret

// IN: esi = offset to files
FAT12_fclose:
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz near l_FAT12_fclose_98

mov al, files.disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_fclose_01
  push esi
    call FAT12_prepare
  pop esi

l_FAT12_fclose_01:

// read
mov ebx, files.file[esi]
mov al, files.disk[esi]
mov edi, VA_SYSTEM + offset FAT12_dir
mov ecx, 32  // assert sizeof DirRec = 32
mov ah, 2 // read
push esi
  call FAT12_diskmain
pop esi

// update
mov eax, dword ptr files.size[esi]
mov FAT12_dir.FileSize, eax
call FAT12_datetime  // keep esi
mov FAT12_dir.DateLastAccessed, dx

// write
mov ebx, files.file[esi]
mov al, files.disk[esi]
mov edi, VA_SYSTEM + offset FAT12_dir
mov ecx, 32  // assert sizeof DirRec = 32
mov ah, 3 // write
push esi
  call FAT12_diskmain
pop esi

// flush
push esi
  mov al, files.disk[esi]
  call FAT12_doflush
pop esi

l_FAT12_fclose_8:
mov files.mode[esi], 0
ret

l_FAT12_fclose_98:
mov al, 0
jmp short l_FAT12_fclose_8

// IN: es:edx -> path & dirname, al = ldiskn, ebx = dir cluster
// OUT: al = 0 || erc
FAT12_md:
call FAT12_find_file
cmp al, ERC_FILE_NOT_FOUND
jnz near l_FAT12_md_6
  // check valid chars
  mov edx, VA_SYSTEM + offset FAT12_fname
  mov byte ptr [es:edx + 11], 0
  call fs_check_valid
  or al, al
  jnz near l_FAT12_md_9
  
  // IN: ebx = first cluster of directory
  // OUT: al = 0 || erc, edi -> disk_adr_DirRec
  movzx ebx, FAT12_first_cluster
  call FAT12_find_place
  
  push edi
    // copy fname
    mov esi, offset FAT12_fname
    mov edi, VA_SYSTEM + offset FAT12_dir
    mov ecx, 11
    cld
    rep movsb
    // attrib
    mov FAT12_dir.Attrib, FAT12_ATRB_DIR
    // file size
    xor eax, eax
    mov FAT12_dir.FileSize, eax
    // first cluster
    call FAT12_alloc
    or al, al
    jnz near l_FAT12_md_7
    
    mov FAT12_dir.FirstCluster, bx
    // datetime created
    call FAT12_datetime
    mov FAT12_dir.DateCreated, dx
    mov FAT12_dir.TimeCreated, cx
  pop edi
  // write dir
  push ebx
    mov ebx, edi
    mov edi, VA_SYSTEM + offset FAT12_dir
    mov ecx, 32  // assert sizeof DirRec = 32
    mov al, FAT12_ldiskn
    mov ah, 3
    call FAT12_diskmain
  pop ebx

  // set cluster
  mov al, FAT12_ldiskn
  mov edx, 0xFFF
  push ebx
    call FAT12_set
  pop ebx

  // zero buf
  xor eax, eax
  mov ecx, 512 / 4
  mov edi, VA_SYSTEM + offset fd_buffer
  cld
  rep stosd
  
  // .
  mov fd_buffer[0], '.'
  mov al, ' '
  mov edi, VA_SYSTEM + offset fd_buffer + 1
  mov ecx, 10
  rep stosb
  // attrib
  mov byte ptr fd_buffer[offset DirRec.Attrib], FAT12_ATRB_DIR
  // first cluster
  mov word ptr fd_buffer[offset DirRec.FirstCluster], bx

  // ..
  mov fd_buffer[32], '.'  // assert sizeof DirRec = 32
  mov fd_buffer[33], '.'
  mov al, ' '
  mov edi, VA_SYSTEM + offset fd_buffer + 32 + 2
  mov ecx, 9
  rep stosb
  // attrib
  mov byte ptr fd_buffer[32 + offset DirRec.Attrib], FAT12_ATRB_DIR
  // first cluster
  mov ax, FAT12_first_cluster
  mov word ptr fd_buffer[32 + offset DirRec.FirstCluster], ax

  // save buffer
  mov cl, FAT12_clusize
  shl ebx, cl
  add ebx, FAT12_data
  shl ebx, 9
  mov ecx, 512
  mov edi, VA_SYSTEM + offset fd_buffer
  mov al, FAT12_ldiskn
  mov ah, 3 // write
  push ebx
    call FAT12_diskmain
  pop ebx
  
  // zero to end of cluster
  xor eax, eax
  mov ecx, 32 * 2 / 4
  mov edi, VA_SYSTEM + offset fd_buffer
  rep stosd
  
  mov cl, FAT12_clusize
  xor eax, eax
  inc eax
  shl eax, cl
  dec eax
  xchg eax, ecx  // ecx = count of remaining sectors
  
  l_FAT12_md_5:
  jecxz l_FAT12_md_59
    dec ecx
    push ecx
      add ebx, 512
      mov ecx, 512
      mov edi, VA_SYSTEM + offset fd_buffer
      mov al, FAT12_ldiskn
      mov ah, 3 // write
      push ebx
        call FAT12_diskmain
      pop ebx
    pop ecx
    jmp short l_FAT12_md_5
  l_FAT12_md_59:

  // flush
  mov al, FAT12_ldiskn
  call FAT12_doflush
  jmp short l_FAT12_md_9
    
l_FAT12_md_7:
pop edi
jmp l_FAT12_md_9

l_FAT12_md_6:
cmp al, 0
jnz l_FAT12_md_9
  mov al, ERC_DIR_ALREADY_EXISTS

l_FAT12_md_9:
ret

// IN: al = ldiskn, es:edx -> path
FAT12_cd:
xor ebx, ebx
call FAT12_find_file
or al, al
jnz l_FAT12_cd_9

mov ah, 2  // read
mov al, FAT12_ldiskn
mov ebx, edi
mov ecx, 32
mov edi, VA_SYSTEM + offset FAT12_dir
push ebx
  call FAT12_diskmain
pop ebx

test FAT12_dir.Attrib, FAT12_ATRB_DIR
jz l_FAT12_cd_6

  l_FAT12_cd_5:
  mov edi, p_current
  mov al, FAT12_ldiskn
  or al, 96
  mov [es:edi + offset ThreadRec.curdisk], al
  movzx ebx, FAT12_dir.FirstCluster
  mov [es:edi + offset ThreadRec.curdir], ebx
  mov al, 0
  jmp short l_FAT12_cd_9

l_FAT12_cd_6:
mov al, ERC_FILE_NOT_FOUND
jmp short l_FAT12_cd_9

l_FAT12_cd_9:
ret

// IN: es:edx -> filename, al = ldiskn, ebx = dir cluster
FAT12_rm:
call FAT12_find_file
or al, al
jnz near l_FAT12_rm_9

// Check in use
mov al, FAT12_ldiskn
call fs_not_used
test cl, cl
jnz near l_FAT12_rm_9

// read DirRec
mov al, FAT12_ldiskn
mov ebx, edi
mov ecx, 32  // assert sizeof DirRec = 32
mov edi, VA_SYSTEM + offset FAT12_dir
mov ah, 2 // read
push ebx
  call FAT12_diskmain
pop ebx

test FAT12_dir.Attrib, FAT12_ATRB_DIR
jnz l_FAT12_rm_dir

  // check system file
  test FAT12_dir.Attrib, FILE_ATTRIBUTE_SYSTEM
  jz l_FAT12_rm_21
    call s_chkstarter
    jz l_FAT12_rm_21
      mov al, ERC_ONLY_STARTER
      jmp l_FAT12_rm_9
    
  l_FAT12_rm_21:
  
  // delete file
  push ebx
    movzx ebx, FAT12_dir.FirstCluster
    call FAT12_delete
    mov FAT12_dir.Filename[0], DELCHAR
  pop ebx
  
  mov al, FAT12_ldiskn
  mov ecx, 32  // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  mov ah, 3 // write
  call FAT12_diskmain
  jmp l_FAT12_rm_6

l_FAT12_rm_dir:
// remove directory
cmp dword ptr FAT12_dir.Filename[4], "    "
jnz l_FAT12_rm_dir2
  cmp dword ptr FAT12_dir.Filename[0], ".   "
  jz near l_FAT12_rm_41
    cmp dword ptr FAT12_dir.Filename[0], "..  "
    jz near l_FAT12_rm_41

l_FAT12_rm_dir2:
push ebx
  movzx ebx, FAT12_dir.FirstCluster
  mov al, FAT12_ldiskn
  call FAT12_get
  mov edx, ebx
pop ebx
cmp edx, 0xFFF
jnz near l_FAT12_rm_42
  push ebx
    movzx ebx, FAT12_dir.FirstCluster  
    mov cl, FAT12_clusize
    shl ebx, cl
    add ebx, FAT12_data
    shl ebx, 9 // 512
    
    mov eax, 512  
    shl eax, cl
    add eax, ebx
    mov FAT12_next, eax
    
    l_FAT12_rm_31:
      mov ah, 2  // read
      mov al, FAT12_ldiskn
      push ebx
        mov ecx, 512
        mov edi, VA_SYSTEM + offset fd_buffer
        call FAT12_diskmain
      pop ebx
      
      xor edi, edi
      l_FAT12_rm_32:
        mov al, fd_buffer[edi]
        cmp al, DELCHAR
        jz l_FAT12_rm_33
          cmp al, 0
          jz l_FAT12_rm_33
            cmp al, '.'
            jnz l_FAT12_rm_notempty

        l_FAT12_rm_33:
          add edi, 32  // assert sizeof DirRec = 32
          cmp edi, 512
          jb l_FAT12_rm_32
      
      add ebx, 512
      cmp ebx, FAT12_next
      jb l_FAT12_rm_31  // next sector in cluster

  pop ebx

  mov FAT12_dir.Filename[0], DELCHAR

  mov al, FAT12_ldiskn
  mov ecx, 32  // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  mov ah, 3 // write
  call FAT12_diskmain

  movzx ebx, FAT12_dir.FirstCluster
  mov al, FAT12_ldiskn
  xor edx, edx
  call FAT12_set
  jmp l_FAT12_rm_6

l_FAT12_rm_notempty:
pop ebx
jmp short l_FAT12_rm_42

l_FAT12_rm_41:
mov al, ERC_CANT_REMOVE
jmp l_FAT12_rm_9

l_FAT12_rm_42:
mov al, ERC_DIR_NOT_EMPTY
jmp l_FAT12_rm_9

l_FAT12_rm_6:
call FAT12_reduce_dir

l_FAT12_rm_8:

// flush
mov al, FAT12_ldiskn
call FAT12_doflush

l_FAT12_rm_9:
ret

// IN: es:edx -> filename, al = ldiskn, ebx = dir cluster, es:esi -> new filename
FAT12_rename:
// IN: es:edx -> file name, al = ldiskn, ebx = cluster number of directory
// OUT: al = 0 || erc, edi = disk offset of DirRec
push esi
  call FAT12_find_file
pop edx
or al, al
jnz near l_FAT12_rename_9

cmp byte ptr FAT12_fname, '.'
jz near l_FAT12_rename_82

push edi
  call FAT12_load_fname
pop edi

push edi
  mov ebx, edi
  mov ecx, 32  // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  mov al, FAT12_ldiskn
  mov ah, 2 // read
  call FAT12_diskmain

  mov esi, offset FAT12_dir.Filename
  mov edi, offset FAT12_fname
  mov ecx, 11
  call eqxcase
pop edi
or al, al
jz l_FAT12_rename_6

// check valid chars
mov edx, VA_SYSTEM + offset FAT12_fname
mov byte ptr [es:edx + 11], 0
call fs_check_valid
or al, al
jnz near l_FAT12_rename_9

// check system file
test FAT12_dir.Attrib, FILE_ATTRIBUTE_SYSTEM
jz l_FAT12_rename_21
  call s_chkstarter
  jz l_FAT12_rename_21
    mov al, ERC_ONLY_STARTER
    jmp l_FAT12_rename_9
  
l_FAT12_rename_21:

cmp byte ptr FAT12_fname, '.'
jz l_FAT12_rename_82

push edi
  movzx ebx, FAT12_first_cluster
  mov al, FAT12_ldiskn
  call FAT12_srchdir
pop edi
or al, al
jz l_FAT12_rename_8

  l_FAT12_rename_6:

  mov ebx, edi
  mov ecx, 11
  mov edi, VA_SYSTEM + offset FAT12_fname
  mov al, FAT12_ldiskn
  mov ah, 3 // write
  call FAT12_diskmain
  
  // flush
  mov al, FAT12_ldiskn
  call FAT12_doflush
  jmp short l_FAT12_rename_9
  
l_FAT12_rename_8:
mov al, ERC_DUPLICATE_NAME
jmp short l_FAT12_rename_9

l_FAT12_rename_82:
mov al, ERC_CANT_RENAME

l_FAT12_rename_9:
ret

l_FAT12_move_x2:
mov al, ERC_PATH_NOT_FOUND

l_FAT12_move_x1:
   pop ecx
  pop edi
pop edx
jmp l_FAT12_move_9

// IN: es:edx -> filename, al = ldiskn, ebx = dir cluster, es:esi -> new path
// OUT: al = 0 || erc
FAT12_move:
push esi
 push eax
  call FAT12_find_file
  push ebx
   push edi
    mov cx, FAT12_first_cluster
    mov FAT12_first_cluster2, cx
    mov esi, offset FAT12_fname
    mov edi, VA_SYSTEM + offset FAT12_fname2
    mov ecx, 11
    cld
    rep movsb

    // check system file
    or al, al
    jnz l_FAT12_move_22

   pop edi
   push edi      
      mov al, FAT12_ldiskn
      mov ebx, edi
      mov ecx, 32  // assert sizeof DirRec = 32
      mov edi, VA_SYSTEM + offset FAT12_dir
      mov ah, 2 // read
      call FAT12_diskmain
      
      test FAT12_dir.Attrib, FILE_ATTRIBUTE_SYSTEM
      jz l_FAT12_move_21
        call s_chkstarter
        jz l_FAT12_move_21
          mov al, ERC_ONLY_STARTER
          jmp l_FAT12_move_22
        
      l_FAT12_move_21:
      mov al, 0
    
    l_FAT12_move_22:
   pop edi
  pop ebx
 pop edx  // dl = ldiskn
pop esi
or al, al
jnz near l_FAT12_move_9

push edx
  mov edx, esi
  call fs_disk  // keep esi, edi; OUT: al = disk, ebx = first cluster
  push edi
   push eax
    cmp byte ptr [es:edx], 0
    jz l_FAT12_move_31
      call FAT12_find_file
      or al, al
      jnz near l_FAT12_move_x1
      
      mov ebx, edi
      mov edi, VA_SYSTEM + offset FAT12_dir
      mov ecx, 32
      mov al, FAT12_ldiskn
      mov ah, 2 // read
      call FAT12_diskmain
      test FAT12_dir.Attrib, FAT12_ATRB_DIR
      jz near l_FAT12_move_x2
      
      movzx ebx, FAT12_dir.FirstCluster
      
    l_FAT12_move_31:
   pop ecx  // cl = ldiskn2
  pop esi  // esi = old file dir ofs
pop edx

l_FAT12_move_5:
cmp cl, dl
jz l_FAT12_move_51
  mov al, ERC_OUT_OF_DISK
  jmp l_FAT12_move_9

l_FAT12_move_51:
push esi
  mov esi, offset FAT12_fname2
  mov edi, VA_SYSTEM + offset FAT12_fname
  mov ecx, 11
  cld
  rep movsb
  
  // IN: al = ldiskn, esi -> fname, ebx = cluster number of directory
  // OUT: al = 0 || erc, ebx = offset of sector, edi = offset in sector
  mov al, FAT12_ldiskn
  mov esi, offset FAT12_fname
  call FAT12_srchdir  // OUT: FAT12_first_cluster
pop esi
cmp al, 1
jz l_FAT12_move_52
  mov al, ERC_DUPLICATE_NAME
  jmp l_FAT12_move_9

l_FAT12_move_52:
// IN: ebx = first cluster of directory
// OUT: al = 0 || erc, edi -> disk_adr_DirRec
push esi
  movzx ebx, FAT12_first_cluster
  call FAT12_find_place
pop esi
or al, al
jnz l_FAT12_move_9

push edi
 push esi
  mov ebx, esi
  mov ecx, 32 // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  mov ah, 2 // read
  mov al, FAT12_ldiskn
  call FAT12_diskmain
 pop esi
pop edi

push esi
  mov ebx, edi
  mov ecx, 32 // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  mov ah, 3 // write
  mov al, FAT12_ldiskn
  call FAT12_diskmain
pop esi

mov FAT12_dir.Filename[0], DELCHAR
mov ebx, esi
mov ecx, 32 // assert sizeof DirRec = 32
mov edi, VA_SYSTEM + offset FAT12_dir
mov ah, 3 // write
mov al, FAT12_ldiskn
call FAT12_diskmain

// reduce
mov ax, FAT12_first_cluster2
mov FAT12_first_cluster, ax
call FAT12_reduce_dir

// flush
mov al, FAT12_ldiskn
call FAT12_doflush

l_FAT12_move_9:
ret

// IN: edx -> path & mask, al = ldiskn, ebx = current directory cluster
// OUT: al = 0 || erc
FAT12_find_first:
push edx
  call FAT12_prepare  // keep ebx, edi
pop edx
test al, al
jnz near l_FAT12_find_first_9

l_FAT12_find_first_1:
call FAT12_load_fname  // keep ebx

cmp byte ptr [es:edx], 0
jz l_FAT12_find_first_5
  
  l_FAT12_find_first_2:
  mov al, FAT12_ldiskn
  push edx
    call FAT12_srchdir
  pop edx
  add edi, ebx
  or al, al
  jnz l_FAT12_find_first_9
    mov ah, 2  // read
    mov al, FAT12_ldiskn
    mov ebx, edi
    mov ecx, 32  // assert sizeof DirRec = 32
    mov edi, VA_SYSTEM + offset FAT12_dir
    push edx
      call FAT12_diskmain
    pop edx
    // test attrib dir
    test FAT12_dir.Attrib, FAT12_ATRB_DIR
    jz l_FAT12_find_first_6
      // dir
      movzx ebx, FAT12_dir.FirstCluster
      jmp short l_FAT12_find_first_1

l_FAT12_find_first_5:
// fname = mask, ebx = directory cluster
call FAT12_fname_to_mask // keep ebx

mov esi, fs_srchofs

mov al, FAT12_ldiskn
mov srch.Disk[esi], al
mov dword ptr srch.Cluster[esi], ebx
xor eax, eax
mov srch.Offset[esi], eax

call FAT12_find_next
or al, al
jz l_FAT12_find_first_99
jmp short l_FAT12_find_first_9

l_FAT12_find_first_6:
mov al, ERC_PATH_NOT_FOUND

l_FAT12_find_first_9:
mov esi, fs_srchofs
mov word ptr srch.ThreadId[esi], -1

l_FAT12_find_first_99:
ret

// IN: fs_srchofs, fs_rec
// OUT: al = 0 || erc, [fs_rec]
FAT12_find_next:
mov esi, fs_srchofs

mov al, srch.Disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_find_next_01
  push esi
    call FAT12_prepare
  pop esi

l_FAT12_find_next_01:
mov edi, fs_rec

l_FAT12_find_next_1:
mov ebx, dword ptr srch.Cluster[esi]
mov eax, srch.Offset[esi]

test ebx, ebx
jnz l_FAT12_find_next_2
  // root
  movzx edx, FAT12_maxroot
  shl edx, 5  // assert sizeof DirRec = 32
  jmp short l_FAT12_find_next_3
  
// not root
l_FAT12_find_next_2:
mov cl, FAT12_clusize
mov edx, 512  
shl edx, cl

// both
l_FAT12_find_next_3:
cmp eax, edx
jb l_FAT12_find_next_51
  test ebx, ebx
  jz l_FAT12_find_next_51e

  // IN: al = ldiskn, ebx = cluster number
  // OUT: al = 0 || error, ebx = cluster value
  mov al, srch.Disk[esi]
  push esi
   push edi
    call FAT12_get
   pop edi
  pop esi
  or al, al
  jnz near l_FAT12_find_next_9
    mov dword ptr srch.Cluster[esi], ebx
    xor eax, eax
    mov srch.Offset[esi], eax
      
l_FAT12_find_next_51:
cmp ebx, 0xFFF
jnz l_FAT12_find_next_52
  
  l_FAT12_find_next_51e:
  //mov word ptr srch.ThreadId[esi], -1
  mov al, 1 //ERC_FILE_NOT_FOUND
  jmp l_FAT12_find_next_9

l_FAT12_find_next_52:
// eax = Offset, ebx = Cluster
test ebx, ebx
jnz l_FAT12_find_next_53
  // root
  mov ebx, FAT12_rootsect
  jmp short l_FAT12_find_next_54
  
// not root
l_FAT12_find_next_53:
mov cl, FAT12_clusize
shl ebx, cl
add ebx, FAT12_data

// both
l_FAT12_find_next_54:
shl ebx, 9

add ebx, eax
add eax, sizeof DirRec
mov srch.Offset[esi], eax

push edi
 push esi
  mov ah, 2  // read
  mov al, srch.Disk[esi]
  mov ecx, sizeof DirRec
  mov edi, VA_SYSTEM + offset FAT12_dir
  call FAT12_diskmain
 pop esi
pop edi

mov al, FAT12_dir.Filename[0]
or al, al
jz near l_FAT12_find_next_1
cmp al, DELCHAR
jz near l_FAT12_find_next_1

push edi
 push esi
  add esi, offset InSrchRec.FileMask
  mov edi, offset FAT12_dir.Filename
  mov ecx, 11
  call eqxcase_qm
 pop esi
pop edi
or al, al
jnz near l_FAT12_find_next_1

// fname to name
mov ecx, 8

l_FAT12_find_next_71:
  dec ecx
  mov al, FAT12_dir.Filename[ecx]
  cmp al, ' '
  jnz l_FAT12_find_next_72
    or ecx, ecx
    jnz l_FAT12_find_next_71

l_FAT12_find_next_72:
inc ecx
mov ebx, edi
add ebx, offset SearchRec.FileName
xor esi, esi

l_FAT12_find_next_73:
  mov al, FAT12_dir.Filename[esi]
  // lower case filename
  cmp al, 'A'
  jb l_FAT12_find_next_731
    cmp al, 'Z'
    ja l_FAT12_find_next_731
      add al, 32
      
  l_FAT12_find_next_731:
  mov [es:ebx], al
  inc esi
  inc ebx
  loop l_FAT12_find_next_73

mov ecx, 3
mov esi, offset FAT12_dir.Ext
mov al, [esi]
cmp al, ' '
jz l_FAT12_find_next_75
  mov byte ptr [es:ebx], '.'
  inc ebx

l_FAT12_find_next_74:
  mov al, [esi]
  cmp al, ' '
  jz l_FAT12_find_next_75
    // lower case ext
    cmp al, 'A'
    jb l_FAT12_find_next_741
      cmp al, 'Z'
      ja l_FAT12_find_next_741
        add al, 32
        
    l_FAT12_find_next_741:
    mov [es:ebx], al
    inc esi
    inc ebx
    loop l_FAT12_find_next_74

l_FAT12_find_next_75:
mov byte ptr [es:ebx], 0

// name to alternate
mov ecx, ebx
sub ecx, edi
sub ecx, offset SearchRec.FileName
inc ecx

mov ebx, edi
add ebx, offset SearchRec.AlternateFileName

mov esi, edi
add esi, offset SearchRec.FileName

l_FAT12_find_next_76:
  mov al, [es:esi]
  inc esi
  mov [es:ebx], al
  inc ebx
  loop l_FAT12_find_next_76

// size
mov eax, FAT12_dir.FileSize
xor edx, edx
mov dword ptr [es:edi + offset SearchRec.FileSize], eax
mov dword ptr [es:edi + offset SearchRec.FileSize + 4], edx

// attribs
movzx eax, byte ptr FAT12_dir.Attrib
mov [es:edi + offset SearchRec.FileAttributes], eax

// times
mov eax, dword ptr FAT12_dir.TimeCreated
call FAT12_datetime_to_ftime
mov dword ptr [es:edi + offset SearchRec.CreationTime], eax
mov dword ptr [es:edi + offset SearchRec.CreationTime + 4], edx

mov eax, dword ptr FAT12_dir.LastModTime
call FAT12_datetime_to_ftime
mov dword ptr [es:edi + offset SearchRec.LastWriteTime], eax
mov dword ptr [es:edi + offset SearchRec.LastWriteTime + 4], edx

mov ax, FAT12_dir.DateLastAccessed
shl eax, 16
call FAT12_datetime_to_ftime
mov dword ptr [es:edi + offset SearchRec.LastAccessTime], eax
mov dword ptr [es:edi + offset SearchRec.LastAccessTime + 4], edx

// end
mov al, 0

l_FAT12_find_next_9:
ret

// IN: edx -> filename, esi = new atribs
FAT12_chmod:
mov FAT12_ldiskn, al

push esi
  call FAT12_find_file
pop esi
or al, al
jnz l_FAT12_chmod_9
  // edi -> DirRec
  add edi, offset DirRec.Attrib
  push esi
   push edi
    mov ebx, edi
    mov ecx, 1
    mov edi, VA_SYSTEM + offset FAT12_tmp1
    mov al, FAT12_ldiskn
    mov ah, 2  // read
    call FAT12_diskmain
   pop edi
  pop esi
  mov eax, esi
  xor al, FAT12_tmp1
/*
FAT12_ATRB_READONLY = 1
FAT12_ATRB_HIDDEN = 2
FAT12_ATRB_SYSTEM = 4
FAT12_ATRB_VOLLBL = 8
FAT12_ATRB_DIR = 10h
FAT12_ATRB_ARCHIVE = 20h
FAT12_ATRB_DEV = 60h
*/
  test al, 58h
  jz l_FAT12_chmod_51
    mov al, ERC_INVALID_ATRBS
    ret
    
  l_FAT12_chmod_51:
  test al, FAT12_ATRB_SYSTEM
  jz l_FAT12_chmod_52
    call s_chkstarter
    jz l_FAT12_chmod_52
      mov al, ERC_ONLY_STARTER
      ret
    
  l_FAT12_chmod_52:
  mov eax, esi
  mov FAT12_tmp1, al

  mov ebx, edi
  mov ecx, 1
  mov edi, VA_SYSTEM + offset FAT12_tmp1
  mov al, FAT12_ldiskn
  mov ah, 3  // write
  call FAT12_diskmain

  // flush
  mov al, FAT12_ldiskn
  call FAT12_doflush
  
l_FAT12_chmod_9:
ret

// IN: esi = offset to files
// OUT: al = erc, edx:ecx = ftime
FAT12_get_mtime:
mov al, files.disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_get_mtime_01
  push esi
    call FAT12_prepare
  pop esi

l_FAT12_get_mtime_01:
mov edi, files.file[esi]
// load direntry
push esi
  mov al, FAT12_ldiskn
  mov ah, 2 // read
  mov ebx, edi
  mov ecx, 32  // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  call FAT12_diskmain
pop esi
// convert datetime
mov ax, FAT12_dir.LastModDate
shl eax, 16
mov ax, FAT12_dir.LastModTime
call FAT12_datetime_to_ftime
xchg eax, ecx
mov al, 0
ret

// IN: esi = offset to files, edx:ecx = ftime
// OUT: al = erc
FAT12_set_mtime:
mov dword ptr fs_ftime[0], ecx
mov dword ptr fs_ftime[4], edx

mov al, files.disk[esi]
cmp FAT12_ldiskn, al
jz l_FAT12_set_mtime_01
  push esi
    call FAT12_prepare
  pop esi

l_FAT12_set_mtime_01:
// load direntry
push esi
  mov al, FAT12_ldiskn
  mov ah, 2 // read
  mov ebx, files.file[esi]
  mov ecx, 32  // assert sizeof DirRec = 32
  mov edi, VA_SYSTEM + offset FAT12_dir
  call FAT12_diskmain
pop esi
// convert datetime
push esi
  mov esi, VA_SYSTEM + offset fs_ftime
  mov edi, VA_SYSTEM + offset FAT12_st
  call t_ftime2systime
pop esi
mov al, byte ptr FAT12_st.wHour
movzx ecx, al
mov al, byte ptr FAT12_st.wMinute
shl ecx, 6
or cl, al
mov al, byte ptr FAT12_st.wSecond
shl ecx, 5
shr al, 1
or cl, al
movzx edx, word ptr FAT12_st.wYear
sub edx, FAT12_YEAR0  // edx = year
mov al, byte ptr FAT12_st.wMonth
shl edx, 4
or dl, al
mov al, byte ptr FAT12_st.wDay
shl edx, 5
or dl, al
mov FAT12_dir.LastModTime, cx
mov FAT12_dir.LastModDate, dx
// save direntry
mov al, FAT12_ldiskn
mov ah, 3 // write
mov ebx, files.file[esi]
mov ecx, 32  // assert sizeof DirRec = 32
mov edi, VA_SYSTEM + offset FAT12_dir
call FAT12_diskmain
ret

// IN: al = ldiskn
// OUT: al = erc, edx:ecx = free bytes
FAT12_diskfree:
cmp FAT12_ldiskn, al
jz l_FAT12_diskfree_01
  call FAT12_prepare

l_FAT12_diskfree_01:
xor ebx, ebx
xor ecx, ecx

l_FAT12_diskfree_5:
  cmp ebx, FAT12_clusters
  jnb l_FAT12_diskfree_8
    push ebx
     push ecx
      mov al, FAT12_ldiskn
      call FAT12_get
     pop ecx
     test ebx, ebx
     jnz l_FAT12_diskfree_6
       inc ecx
        
     l_FAT12_diskfree_6:
    pop ebx
    inc ebx
    jmp short l_FAT12_diskfree_5
    
l_FAT12_diskfree_8:
xor edx, edx
xchg eax, ecx
mov cl, FAT12_clusize
add cl, 9
shl eax, cl
xchg eax, ecx
mov al, 0
ret

CD_PATHTABLE_PA = PA_DMA_BUFFERS + 0x8000

CD_FLAGS_HIDDEN = 1
CD_FLAGS_DIRECTORY = 2
CD_FLAGS_ASSOCIATED = 4
CD_FLAGS_RECORD = 8
CD_FLAGS_PROTECTION = 16
CD_FLAGS_MULTIEXTENT = 128

CD_ESCAPE = 2F25h

struct PathTableRec{
  uns1 len_di, len_ext // size = 8+len_di
  uns4 ext_location
  uns2 parent
  char dir_ident[255]  
}

struct CdDirRec{
  uns1 len_dr, len_ext  // size = len_dr
  uns8 ext_location, len_file
  uns1 dtm[7]
  uns1 flags, unit_size, interleave_gap_size
  uns4 seq_num
  uns1 len_fi // filename length
  char filename[255]
}

uns1 cd_ldiskn, cd_ext
bool cd_udf

[dalign 32]
uns4 cd_diskmain, cd_tmp4, cd_ofs, cd_pathtable_size, cd_pathtable_ofs
uns4 cd_rootlb, cd_rootsize, cd_size

[dalign 64]
uns8 cd_pos8, cd_size8, cd_ftime

uns2 cd_dirn, cd_curdirn, cd_escape

uns1 cd_dtm[17]

// IN: al = ldiskn
cd_prepare:
mov cd_pathtable_size, 0
mov cd_rootlb, 0
mov cd_escape, 0
mov cd_ldiskn, al

movzx esi, al
shl esi, 5  // log2(DiskInfoRec)
mov esi, disk_info.main[esi]
or esi, esi
jnz cd_prepare_0
  mov al, ERC_INVALID_DISK_NUMBER
  jmp cd_prepare_9

cd_prepare_0:
mov cd_diskmain, esi

/*
mov ah, 2
mov al, cd_ldiskn
xor edx, edx
mov ebx, 16 * 2048 + 1
mov ecx, 4
mov edi, VA_SYSTEM + offset cd_tmp4
call cd_diskmain

cmp cd_tmp4, "CD00"
jnz near cd_prepare_udf
*/
  mov cd_udf, 0

  mov cd_ofs, 16 * 2048
  mov cd_pathtable_ofs, 0

  cd_prepare_11:
    mov ah, 2  // read
    mov al, cd_ldiskn
    xor edx, edx
    mov ebx, cd_ofs
    mov ecx, 1
    mov edi, VA_SYSTEM + offset cd_tmp4
    call cd_diskmain
    
    cmp byte ptr cd_tmp4, 1 // Primary
    jnz near cd_prepare_12
      
      cd_prepare_115:
      /*
      mov ah, 2
      mov al, cd_ldiskn
      xor edx, edx
      mov ebx, cd_ofs
      add ebx, 140 // PathTable location in blocks 2048
      mov ecx, 4
      mov edi, VA_SYSTEM + offset cd_pathtable_ofs
      call cd_diskmain
      
      mov ah, 2
      mov al, cd_ldiskn
      xor edx, edx
      mov ebx, cd_ofs
      add ebx, 132 // PathTable size in bytes
      mov ecx, 4
      mov edi, VA_SYSTEM + offset cd_pathtable_size
      call cd_diskmain
      */
      mov ah, 2  // read
      mov al, cd_ldiskn
      xor edx, edx
      mov ebx, cd_ofs
      add ebx, 80 // disk size in sectors
      mov ecx, 4
      mov edi, VA_SYSTEM + offset cd_tmp4
      call cd_diskmain
      mov eax, dword ptr cd_tmp4
      mov edx, eax
      shl eax, 2  // * 2048 / 512
      shr edx, 32 - 2
      movzx esi, cd_ldiskn
      and esi, 31
      shl esi, 5  // assert sizeof DiskInfoRec = 32
      mov dword ptr disk_info.size_sectors[esi + 0], eax
      mov dword ptr disk_info.size_sectors[esi + 4], edx
      
      mov ah, 2  // read
      mov al, cd_ldiskn
      xor edx, edx
      mov ebx, cd_ofs
      add ebx, 156 + 2 // root.lb
      mov ecx, 4
      mov edi, VA_SYSTEM + offset cd_rootlb
      call cd_diskmain
      
      mov ah, 2  // read
      mov al, cd_ldiskn
      xor edx, edx
      mov ebx, cd_ofs
      add ebx, 156 + 10 // root.size
      mov ecx, 4
      mov edi, VA_SYSTEM + offset cd_rootsize
      call cd_diskmain
      
      mov ah, 2  // read
      mov al, cd_ldiskn
      xor edx, edx
      mov ebx, cd_ofs
      add ebx, 813  // creation dtm
      mov ecx, 17
      mov edi, VA_SYSTEM + offset cd_dtm
      call cd_diskmain
      call cd_mktime
      mov dword ptr cd_ftime[0], eax
      mov dword ptr cd_ftime[4], edx
      
      //mov ecx, p_current
      //mov eax, cd_rootsize
      //mov [es:ecx + offset ThreadRec.curdirsize], eax
      
      jmp short cd_prepare_18
      
    cd_prepare_12:
    cmp byte ptr cd_tmp4, 2 // Supplementary
    jnz cd_prepare_13

      mov ah, 2  // read
      mov al, cd_ldiskn
      xor edx, edx
      mov ebx, cd_ofs
      add ebx, 58h // escapes
      mov ecx, 2
      mov edi, VA_SYSTEM + offset cd_escape
      call cd_diskmain

      jmp cd_prepare_115
      
    cd_prepare_13:
    cmp byte ptr cd_tmp4, 255 // Terminal
    jz cd_prepare_2
    
    cd_prepare_18:
    add cd_ofs, 2048
    cmp cd_ofs, 2048 * 20
    jb near cd_prepare_11
    // missing terminal
    
  cd_prepare_2:
  /*
  cmp cd_pathtable_size, 0x8000
  jna cd_prepare_21
    mov cd_pathtable_size, 0
    jmp short cd_prepare_29
    
  cd_prepare_21:
  mov ah, 2
  mov al, cd_ldiskn
  xor edx, edx
  mov ebx, cd_pathtable_ofs
  shl ebx, 11 // 2048
  mov ecx, cd_pathtable_size
  mov edi, VA_SYSTEM + CD_PATHTABLE_PA
  call cd_diskmain
  
  cd_prepare_29:
  */
  jmp cd_prepare_9
  
cd_prepare_udf:
mov cd_udf, 1
//...
mov al, ERC_NOT_IMPLEMENTED

cd_prepare_9:
ret

// IN: es:edx -> filenamez, ebx = 0 || sector, cd_ldiskn
// OUT: ebx = sector, ecx = size, al = 0 || erc
// USES: cd_pos8, cd_size8, fd_buffer
cd_find_file:
/*
cmp cd_pathtable_size, 0
jz l_cd_find_file_dir

// pathtable
mov esi, CD_PATHTABLE_PA + VA_SYSTEM
mov cd_dirn, 1
mov cd_curdirn, 1

l_cd_find_file_15:
mov eax, cd_pathtable_size
add eax, CD_PATHTABLE_PA + VA_SYSTEM
cmp esi, eax
jnb l_cd_find_file_not_found
  movzx ecx, byte ptr [es:esi]
  mov cd_ext, [es:esi + 1]
  mov ax, [es:esi + 6]
  cmp ax, cd_dirn
  jnz l_cd_find_file_next
    add esi, 8
    call cd_cmp // KEEP esi, ecx
    or al, al
    jnz l_cd_find_file_next
      mov ax, cd_curdirn
      mov cd_dirn, ax
      mov ebx, [es:esi - 8 + 2]
      
      // check dir/filename
      push edx
       push ecx
        
        mov ecx, MAX_PATH
        mov al, 0
        
        l_cd_find_file_16:
        cmp byte ptr [es:edx], 0  // zero - filename
        jz l_cd_find_file_18
          cmp byte ptr [es:edx], '/'  // slash - dirname
          jz l_cd_find_file_17
            inc edx
            loop l_cd_find_file_16
        
          l_cd_find_file_17:
          mov al, 1
        
        l_cd_find_file_18:
        
       pop ecx
      pop edx
      
      or al, al
      jnz l_cd_find_file_next
        mov ecx, //...
        jmp short l_cd_find_file_22 // find file in dir
  
  l_cd_find_file_next:
  add esi, ecx
  movzx eax, cd_ext
  add esi, eax
  inc cd_curdirn
  cmp byte ptr [es:esi], 0
  jnz l_cd_find_file_15
    inc esi
    jmp l_cd_find_file_15

l_cd_find_file_not_found:
mov al, ERC_PATH_NOT_FOUND
jmp l_cd_find_file_9
*/

// Not pathtable
l_cd_find_file_dir:
cmp byte ptr [es:edx], 0
jnz l_cd_find_file_1
  mov al, ERC_FILE_NOT_FOUND
  jmp l_cd_find_file_9
  
l_cd_find_file_1:
or ebx, ebx
jz l_cd_find_file_21
  mov ecx, p_current
  mov ecx, [es:ecx + offset ThreadRec.curdirsize]
  jmp short l_cd_find_file_22

l_cd_find_file_21:
mov ebx, cd_rootlb
mov ecx, cd_rootsize

l_cd_find_file_22:
mov eax, ebx
shl ebx, 11
shr eax, 32 - 11
mov dword ptr cd_pos8[0], ebx
mov dword ptr cd_pos8[4], eax  // cd_pos8 = offset of dir
mov dword ptr cd_size8[0], ebx
mov dword ptr cd_size8[4], eax
add dword ptr cd_size8[0], ecx
adc dword ptr cd_size8[4], 0  // cd_size8 = offset + ecx

l_cd_find_file_25:
push edx

  mov ah, 2  // read
  mov al, cd_ldiskn
  mov ebx, dword ptr cd_pos8[0]
  mov edx, dword ptr cd_pos8[4]
  mov ecx, 1
  mov edi, VA_SYSTEM + offset fd_buffer
  call cd_diskmain
  
  or al, al
  jnz near l_cd_find_file_29
  
  mov ah, 2  // read
  mov al, cd_ldiskn
  movzx ecx, byte ptr fd_buffer[0]
  dec ecx
  cmp ecx, 255
  jna l_cd_find_file_255
    mov al, ERC_FS
    jmp l_cd_find_file_29
    
  l_cd_find_file_255:
  mov ebx, dword ptr cd_pos8[0]
  mov edx, dword ptr cd_pos8[4]
  add ebx, 1
  adc edx, 0
  mov edi, VA_SYSTEM + offset fd_buffer + 1
  call cd_diskmain
  
  or al, al
  jnz near l_cd_find_file_29
  
pop edx

// Convert to UTF-8: fd_buffer -> hd_buffer
movzx ecx, byte ptr fd_buffer[32]
mov esi, offset fd_buffer + 33
mov edi, VA_SYSTEM + offset fs_utf8buf
cld
cmp cd_escape, CD_ESCAPE
jz l_l_cd_find_file_258
  // not Unicode
  rep movsb
  mov al, 0
  stosb
  jmp short l_l_cd_find_file_259
  
// Unicode
l_l_cd_find_file_258:
  mov fs_bigendian, 1
  call fs_toutf8  // keep edx

l_l_cd_find_file_259:
or al, al
jnz near l_cd_find_file_9

// compare
mov esi, VA_SYSTEM + offset fs_utf8buf
call fs_cmp  // keep edx

or al, al
jz l_cd_find_file_28

  movzx eax, byte ptr fd_buffer[0]  // LEN_DR
  cmp al, 0
  jz l_cd_find_file_26
    movzx ebx, byte ptr fd_buffer[1]  // LEN_EXT
    add eax, ebx
    add dword ptr cd_pos8[0], eax
    adc dword ptr cd_pos8[4], 0
    mov ebx, dword ptr cd_pos8[0]
    mov eax, dword ptr cd_pos8[4]
    cmp eax, dword ptr cd_size8[4]
    jb near l_cd_find_file_25
    
    ja l_cd_find_file_26
      cmp ebx, dword ptr cd_size8[0]
      jb near l_cd_find_file_25
  
  // not found
  l_cd_find_file_26:
  call fs_next_edx
  cmp byte ptr [es:edx], 0
  jz l_cd_find_file_27
    mov al, ERC_PATH_NOT_FOUND
    jmp l_cd_find_file_9
    
  l_cd_find_file_27:
  mov al, ERC_FILE_NOT_FOUND
  jmp l_cd_find_file_9

l_cd_find_file_28:
// found
mov ebx, dword ptr fd_buffer[2]
mov ecx, dword ptr fd_buffer[10]
call fs_next_edx
cmp byte ptr [es:edx], 0
jnz near l_cd_find_file_22

mov al, 0
jmp short l_cd_find_file_9

l_cd_find_file_29:
  pop edx
cmp al, ERC_FS
jz l_cd_find_file_26

l_cd_find_file_9:
ret

// IN: cd_dtm
// OUT: edx:eax = ftime
cd_mktime:
mov al, cd_dtm[0]
and al, 15
movzx eax, al
mov ecx, 10
mul ecx

movzx ebx, cd_dtm[1]
and bl, 15
add eax, ebx
mul ecx

mov bl, cd_dtm[2]
and bl, 15
add eax, ebx
mul ecx

mov bl, cd_dtm[3]
and bl, 15
add eax, ebx
mov esi, eax  // esi = year

mov al, cd_dtm[4]
and al, 15
movzx eax, al
mul ecx

mov bl, cd_dtm[5]
and bl, 15
add eax, ebx
shl esi, 4
add esi, eax  // esi = year << 4 + month

mov al, cd_dtm[6]
and al, 15
movzx eax, al
mul ecx

mov bl, cd_dtm[7]
and bl, 15
add eax, ebx
shl esi, 5
add eax, esi  // eax = (year << 4 + month) << 5 + date
call t_systime2ftime_days
mov esi, eax  // esi = days

movzx eax, byte ptr cd_dtm[8]
and al, 15
movzx eax, al
mov ecx, 10
mul ecx

movzx ebx, byte ptr cd_dtm[9]
and bl, 15
add eax, ebx
mov ebx, 60
mul ebx
mov edi, eax  // edi = hour * 60

mov al, cd_dtm[10]
and al, 15
movzx eax, al
mul ecx

mov bl, cd_dtm[11]
and bl, 15
add eax, ebx
add eax, edi
mov ebx, 60
mul ebx
mov edi, eax  // edi = (hour * 60 + min) * 60

mov al, cd_dtm[12]
and al, 15
movzx eax, al
mul ecx

mov bl, cd_dtm[13]
and bl, 15
add eax, ebx
add edi, eax  // edi = (hour * 60 + min) * 60 + second

mov eax, esi
mov ecx, 86400
mul ecx
add eax, edi
adc edx, 0

pushfd
  cli
  mov dword ptr t_time[0], eax
  xchg eax, edx
  mov ecx, 10000000
  mul ecx
  mov dword ptr t_time[4], eax
  mov eax, dword ptr t_time[0]
  mul ecx
  add edx, dword ptr t_time[4]  // edx:eax = edx:eax * 10000000
popfd

ret

cd_init:
mov cd_lba, -1
mov cd_ldiskn, -1
ret

cd_devicechange:
mov cd_lba, -1
mov cd_ldiskn, -1
ret

// IN: es:edx -> filenamez, esi -> files, al = ldiskn, ebx = sector
// OUT: al = 0 || erc, esi = fhandle
cd_fopen:
cmp al, cd_ldiskn
jz l_cd_fopen_01
  push edx
   push ebx
    push esi
      call cd_prepare
    pop esi
   pop ebx
  pop edx

l_cd_fopen_01:

mov al, files.mode[esi]
and al, 3Fh
cmp al, 3
jna l_cd_fopen_05
  mov al, ERC_READ_ONLY
  
  l_cd_fopen_x:
  mov files.mode[esi], 0
  xor esi, esi
  jmp l_cd_fopen_9
  
l_cd_fopen_05:

push esi
  call cd_find_file  
pop esi
or al, al
jnz l_cd_fopen_x

mov dword ptr files.size[esi], ecx
mov files.file[esi], ebx
mov eax, ebx
shr eax, 32 - 11
shl ebx, 11
mov dword ptr files.sectn[esi], ebx // sectn = disk ofs
mov dword ptr files.sectn[esi + 4], eax
xor eax, eax
mov dword ptr files.pos[esi], eax
mov dword ptr files.pos[esi + 4], eax

shr esi, 5 // assert sizeof OpenFileRec = 32
mov al, 0

l_cd_fopen_9:
ret

// IN: esi -> files, edx:ebx = file offset
cd_fsetpos:
cmp edx, dword ptr files.size[esi + 4]
jb l_cd_fsetpos_3
ja l_cd_fsetpos_2
cmp ebx, dword ptr files.size[esi]
jna l_cd_fsetpos_3

l_cd_fsetpos_2:
mov ebx, dword ptr files.size[esi]
mov edx, dword ptr files.size[esi + 4]

l_cd_fsetpos_3:
mov dword ptr files.pos[esi], ebx
mov dword ptr files.pos[esi + 4], edx
mov al, 0
ret

cd_fclose:
mov files.mode[esi], 0
mov al, 0
ret

// IN: esi = offset to files, es:edi -> data, ecx = size
// OUT: al = 0 || erc, ecx = sizeread
cd_fread:
mov al, files.disk[esi]
cmp al, cd_ldiskn
jz cd_find_fread_1
  push esi
   push edi
    push ecx
      call cd_prepare
    pop ecx
   pop edi
  pop esi
  
cd_find_fread_1:
mov eax, dword ptr files.pos[esi + 0]
mov edx, dword ptr files.pos[esi + 4]
add eax, ecx
adc edx, 0
cmp edx, dword ptr files.size[esi + 4]
jb l_cd_fread_5
  ja l_cd_fread_2
    cmp eax, dword ptr files.size[esi + 0]
    jna l_cd_fread_5
    
  l_cd_fread_2:
  mov eax, dword ptr files.size[esi + 0]
  //mov edx, dword ptr files.size[esi + 4]
  sub eax, dword ptr files.pos[esi + 0]
  //sbb edx, dword ptr files.pos[esi + 0]
  mov ecx, eax

l_cd_fread_5:
mov ah, 2
mov al, cd_ldiskn
mov ebx, dword ptr files.sectn[esi + 0]
mov edx, dword ptr files.sectn[esi + 4]
add ebx, dword ptr files.pos[esi + 0]
adc edx, dword ptr files.pos[esi + 4]
add dword ptr files.pos[esi + 0], ecx
adc dword ptr files.pos[esi + 4], 0
push ecx
  call cd_diskmain
pop ecx
ret

// IN: es:edx -> pathz, al = ldiskn
cd_cd:
cmp al, cd_ldiskn
jz l_cd_cd_1
  mov cd_ldiskn, al
  push edx
    call cd_prepare
  pop edx

l_cd_cd_1:
xor ebx, ebx
call cd_find_file
or al, al
jnz l_cd_cd_9
  
  mov edx, p_current
  mov al, cd_ldiskn
  mov [es:edx + offset ThreadRec.curdisk], al
  mov [es:edx + offset ThreadRec.curdir], ebx
  mov [es:edx + offset ThreadRec.curdirsize], ecx
  mov al, 0
  
l_cd_cd_9:
ret

// IN: al = ldiskn, ebx = dir, es:edx -> dirmask, fs_rec, fs_srchofs
cd_find_first:
cmp al, cd_ldiskn
jz l_cd_find_first_01
  push edx
   push ebx
    call cd_prepare
   pop ebx
  pop edx

l_cd_find_first_01:
call fs_split  // KEEP ebx
test al, al
jnz l_cd_find_first_9

// Find dir  IN: ebx, hd_buffer
mov edx, VA_SYSTEM + offset hd_buffer

cmp byte ptr [es:edx], 0
jnz l_cd_find_first_36
  
  // no path
  test ebx, ebx
  jnz l_cd_find_first_35
    // ebx = 0 => root
    mov ebx, cd_rootlb
    mov ecx, cd_rootsize
    jmp short l_cd_find_first_38
    
  l_cd_find_first_35:
  // not root, get size
  mov ecx, p_current
  mov ecx, [es:ecx + offset ThreadRec.curdirsize]
  jmp short l_cd_find_first_38
  
l_cd_find_first_36:
// find dir
call cd_find_file
or al, al
jnz l_cd_find_first_9

l_cd_find_first_38:
// set srch[fs_srchofs]
mov esi, fs_srchofs
mov dword ptr srch.Cluster[esi], ebx
mov srch.Size[esi], ecx
xor eax, eax
mov srch.Offset[esi], eax

call cd_find_next

or al, al
jz l_cd_find_first_99

l_cd_find_first_9:
mov esi, fs_srchofs
mov word ptr srch.ThreadId[esi], -1

l_cd_find_first_99:
ret

// IN: fs_rec, fs_srchofs, cd_ldiskn, cd_diskmain
// OUT: al = 0 || erc
cd_find_next:
mov esi, fs_srchofs
mov al, srch.Disk[esi]
cmp al, cd_ldiskn
jz cd_find_next_1
  call cd_prepare

// Prepare values
cd_find_next_1:
  mov esi, fs_srchofs
  mov ebx, dword ptr srch.Cluster[esi]
  mov edx, ebx
  shr edx, 32 - 11
  shl ebx, 11
  mov eax, srch.Offset[esi]
  cmp eax, dword ptr srch.Size[esi]
  jb cd_find_next_18
    mov al, 1
    jmp cd_find_next_9
    
  cd_find_next_18:
  add ebx, eax
  adc edx, 0
  
  // Load LEN_DR  IN: esi  OUT: fd_buffer, ldiskn
  mov ah, 2
  mov al, srch.Disk[esi]
  mov cd_ldiskn, al
  mov ecx, 1
  mov edi, offset fd_buffer + VA_SYSTEM
  push ebx
   push edx
    call cd_diskmain
   pop edx
  pop ebx
  
  or al, al
  jnz near cd_find_next_9
  
  // Load DirRec
  mov ah, 2
  mov al, cd_ldiskn
  movzx ecx, byte ptr fd_buffer[0]
  dec ecx
  cmp ecx, 255
  jna cd_find_next_255
    mov al, 1 // ERC_FS
    jmp cd_find_next_9
    
  cd_find_next_255:
  add ebx, 1
  adc edx, 0
  mov edi, offset fd_buffer + 1 + VA_SYSTEM
  call cd_diskmain
  
  or al, al
  jnz near cd_find_next_9
  
  // Convert to UTF-8: fd_buffer -> hd_buffer
  movzx ecx, byte ptr fd_buffer[32]
  mov esi, offset fd_buffer + 33
  mov edi, VA_SYSTEM + offset hd_buffer
  cld
  cmp cd_escape, CD_ESCAPE
  jz cd_find_next_3
    // not Unicode
    rep movsb
    mov al, 0
    stosb
    jmp cd_find_next_4
    
  // Unicode
  cd_find_next_3:
    mov fs_bigendian, 1
    call fs_toutf8  // keep edx
  
  cd_find_next_4:
  
  or al, al
  jnz cd_find_next_56
  
    // self, parent
    mov al, 1  // not found
    cmp byte ptr hd_buffer[0], 32 // space
    jb cd_find_next_56
    
      // IsMatch?
      mov esi, fs_srchofs
      add esi, offset srch.FileMask
      mov edi, offset hd_buffer
      call fs_ismatch
    
  cd_find_next_56:
  // LEN_DR
  movzx ecx, byte ptr fd_buffer[0]
  // LEN_EXT
  movzx ebx, byte ptr fd_buffer[1]
  add ecx, ebx
  
  mov esi, fs_srchofs
  add srch.Offset[esi], ecx  // Offset + LEN_DR + LEN_EXT
  
  or al, al
  jnz near cd_find_next_1
  
// Found
mov edi, fs_rec
xor eax, eax
push edi
  mov ecx, 7
  rep stosd
pop edi

// File size
mov ecx, dword ptr fd_buffer[10]
mov [es:edi + offset SearchRec.FileSize], ecx
xor edx, edx
mov [es:edi + offset SearchRec.FileSize + 4], edx

// File attributes
movzx eax, byte ptr fd_buffer[25]
and al, 2  // directory
shl al, 3
mov [es:edi + offset SearchRec.FileAttributes], eax

// File times
mov eax, dword ptr cd_ftime[0]
mov edx, dword ptr cd_ftime[4]
mov [es:edi + offset SearchRec.CreationTime], eax
mov [es:edi + offset SearchRec.CreationTime + 4], edx
mov [es:edi + offset SearchRec.LastAccessTime], eax
mov [es:edi + offset SearchRec.LastAccessTime + 4], edx
mov [es:edi + offset SearchRec.LastWriteTime], eax
mov [es:edi + offset SearchRec.LastWriteTime + 4], edx

// File name
mov esi, offset hd_buffer
mov edi, fs_rec
add edi, offset SearchRec.FileName
mov ecx, MAX_PATH

cd_find_next_61:
  lodsb
  stosb
  cmp al, 0
  jz cd_find_next_68
    loop cd_find_next_61

mov al, ERC_TOO_LONG

cd_find_next_68:
  
//mov al, 0

cd_find_next_9:
ret

// IN: esi = offset to files
// OUT: al = erc, edx:ecx = ftime
cd_get_mtime:
mov edx, dword ptr cd_ftime[4]
mov ecx, dword ptr cd_ftime[0]
ret

EXT2_BAD_INO         = 1
EXT2_ROOT_INO        = 2
EXT2_ACL_IDX_INO     = 3
EXT2_ACL_DATA_INO    = 4
EXT2_BOOT_LOADER_INO = 5
EXT2_UNDEL_DIR_INO   = 6
EXT2_FIRST_INO       = 11

EXT2_FT_UNKNOWN  = 0
EXT2_FT_REG_FILE = 1
EXT2_FT_DIR      = 2
EXT2_FT_CHRDEV   = 3
EXT2_FT_BLKDEV   = 4
EXT2_FT_FIFO     = 5
EXT2_FT_SOCK     = 6
EXT2_FT_SYMLINK  = 7

EXT2_S_IFSOCK = 0xC000 //socket (i_mode)
EXT2_S_IFLNK  = 0xA000 //symbolic link
EXT2_S_IFREG  = 0x8000 //regular file
EXT2_S_IFBLK  = 0x6000 //block device
EXT2_S_IFDIR  = 0x4000 //directory
EXT2_S_IFCHR  = 0x2000 //character device
EXT2_S_IFIFO  = 0x1000

MAX_LINK_DEPTH = 64

SINGLE_INDIRECT = 12 * 4
DOUBLE_INDIRECT = 13 * 4
TRIPLE_INDIRECT = 14 * 4

EXT2_S_ISUID = 0x0800 //Set process User ID
EXT2_S_ISGID = 0x0400 //Set process Group ID
EXT2_S_ISVTX = 0x0200 //sticky bit
EXT2_S_IFSYS = 0x0200 //system file (only starter)

EXT2_S_IRUSR = 0x0100 //user read
EXT2_S_IWUSR = 0x0080 //user write
EXT2_S_IXUSR = 0x0040 //user execute
EXT2_S_IRGRP = 0x0020 //group read
EXT2_S_IWGRP = 0x0010 //group write
EXT2_S_IXGRP = 0x0008 //group execute
EXT2_S_IROTH = 0x0004 //others read
EXT2_S_IWOTH = 0x0002 //others write
EXT2_S_IXOTH = 0x0001 //others execute

ACCESS_R = 4 //read
ACCESS_W = 2 //write
ACCESS_X = 1 //execute

ACCESS_DEFAULT = (ACCESS_R|ACCESS_W|ACCESS_X)<<6 | ((ACCESS_R|ACCESS_X)<<3) | ACCESS_R|ACCESS_X

struct SuperBlock{
  uns4 s_inodes_count, s_blocks_count, s_r_blocks_count, s_free_blocks_count
  uns4 s_free_inodes_count, s_first_data_block, s_log_block_size
  uns4 s_log_frag_size, s_blocks_per_group, s_frags_per_group
  uns4 s_inodes_per_group, s_mtime, s_wtime
  uns2 s_mnt_count, s_max_mnt_count, s_magic, s_state, s_errors
  uns2 s_minor_rev_level
  uns4 s_lastcheck, s_checkinterval, s_creator_os, s_rev_level
  uns2 s_def_resuid, s_def_resgid
  uns4 s_first_ino
  uns2 s_inode_size, s_block_group_nr
  uns4 s_feature_compat, s_feature_incompat, s_feature_ro_compat
  //...
}

struct GroupBlock{
  uns4 bg_block_bitmap, bg_inode_bitmap, bg_inode_table
  uns2 bg_free_blocks_count, bg_free_inodes_count
  uns2 bg_used_dirs_count, bg_pad
  uns1 bg_reserved[12]
}

struct INode{
  uns2 i_mode, i_uid
  uns4 i_size, i_atime, i_ctime, i_mtime, i_dtime
  uns2 i_gid, i_links_count
  uns4 i_blocks, i_flags, i_osd1
  uns4 i_block[15]
  uns4 i_generation, i_file_acl, i_dir_acl/*size 32-63*/, i_faddr
  uns1 i_osd[12]
}

struct E2DirEntry{
  uns4 ino
  uns2 rec_len
  uns1 name_len, file_type
}

uns1 e2_ldiskn, e2_ldiskn2, e2_diflink, e2_isdir, e2_islink
char e2_name2[MAX_PATH]

[dalign 32]
uns4 e2_diskmain, e2_relofs, e2_endrelofs, e2_block, e2_count, e2_tmp
uns4 e2_parentino, e2_parentino2, e2_ofs_bm, e2_group, e2_group0, e2_group1
uns4 e2_first1, e2_first2, e2_first3, e2_i1, e2_i2, e2_i3, e2_mid
uns4 e2_len, e2_ofs, e2_ofs2, e2_nameofs, e2_fileino, e2_inon
uns4 e2_groups, e2_gblocks

SuperBlock e2_sb
GroupBlock e2_gb
INode e2_inode
E2DirEntry e2_dir, e2_dir2

[dalign 64]
uns8 e2_inoa, e2_disksize

// IN: al = ldiskn
// OUT: al = erc, e2_ldiskn, e2_sb, e2_diskmain
e2_prepare:
mov e2_ldiskn, al

// diskmain
movzx esi, al
shl esi, 5  // log2(DiskInfoRec)
mov esi, disk_info.main[esi]
or esi, esi
jnz l_e2_prepare_0
  mov al, ERC_INVALID_DISK_NUMBER
  jmp short l_e2_prepare_9

l_e2_prepare_0:
mov e2_diskmain, esi

// super block
mov ah, 2  // read
mov al, e2_ldiskn
xor edx, edx
mov ebx, 1024
mov ecx, sizeof SuperBlock
mov edi, VA_SYSTEM + offset e2_sb
call e2_diskmain

test al, al
jnz l_e2_prepare_9
  mov eax, e2_sb.s_blocks_per_group
  test eax, eax
  jnz l_e2_prepare_8
    mov al, ERC_FS
    jmp short l_e2_prepare_9

l_e2_prepare_8:
mov al, 0

l_e2_prepare_9:
ret

// IN: ebx = groupn, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc, e2_gb, e2_group
e2_load_group:
mov eax, ebx
mov e2_group, eax
shl eax, 5  // group block size log
mov cl, byte ptr e2_sb.s_log_block_size
cmp cl, 0
jnz l_e2_load_group_2
  // 1024
  add eax, 2048
  jmp short l_e2_load_group_3
  
l_e2_load_group_2:
// 2048, 4096, 8192
mov ebx, 1024
shl ebx, cl
add eax, ebx

l_e2_load_group_3:
// load group descriptor
xor edx, edx
mov ebx, eax
mov ecx, 1 << 5  // group block size log
mov edi, VA_SYSTEM + offset e2_gb
mov ah, 2  // read
mov al, e2_ldiskn
call e2_diskmain
ret

// IN: ebx = groupn, e2_gb, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc
e2_save_group_and_super:
mov eax, ebx
shl eax, 5  // group block size log
mov cl, byte ptr e2_sb.s_log_block_size
cmp cl, 0
jnz l_e2_save_group_and_super_2
  // 1024
  add eax, 2048
  jmp short l_e2_save_group_and_super_3
  
l_e2_save_group_and_super_2:
// 2048, 4096, 8192
mov ebx, 1024
shl ebx, cl
add eax, ebx

l_e2_save_group_and_super_3:
// save group descriptor
xor edx, edx
mov ebx, eax
mov ecx, 6
mov edi, VA_SYSTEM + offset e2_gb + offset GroupBlock.bg_free_blocks_count
add ebx, offset GroupBlock.bg_free_blocks_count
mov ah, 3  // write
mov al, e2_ldiskn
call e2_diskmain
test al, al
jnz l_e2_save_group_and_super_9

// save superblock
xor edx, edx
mov ebx, 1024
mov ecx, 8
mov edi, VA_SYSTEM + offset e2_sb + offset SuperBlock.s_free_blocks_count
add ebx, offset SuperBlock.s_free_blocks_count
mov ah, 3  // write
mov al, e2_ldiskn
call e2_diskmain

l_e2_save_group_and_super_9:
ret

// IN: ebx = bitmap blockn, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc, e2_ofs_bm = rel
e2_add_to_bitmap:
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
mov edx, ebx
shl ebx, cl
xor cl, 31
inc cl  // cl = 32 - cl
shr edx, cl

xor eax, eax
mov e2_ofs_bm, eax

l_e2_add_to_bitmap_5:
mov cl, byte ptr e2_sb.s_log_block_size
mov eax, 1024
shl eax, cl
cmp e2_ofs_bm, eax
jnb near l_e2_add_to_bitmap_7

mov edi, VA_SYSTEM + offset hd_buffer
mov ecx, 512
mov ah, 2  // read
mov al, e2_ldiskn
push edx
 push ebx
  call e2_diskmain
 pop ebx
pop edx
test al, al
jnz near l_e2_add_to_bitmap_9

xor esi, esi

l_e2_add_to_bitmap_55:  // KEEP edx, ebx
cmp byte ptr hd_buffer[esi], 255
jnz l_e2_add_to_bitmap_6
  inc esi
  cmp esi, 512
  jb l_e2_add_to_bitmap_55
    add e2_ofs_bm, 512
    
    add ebx, 512
    adc edx, 0
    
    jmp short l_e2_add_to_bitmap_5  // not found

l_e2_add_to_bitmap_6: // free place found
add e2_ofs_bm, esi
mov ah, hd_buffer[esi]
mov al, 1
xor ecx, ecx

l_e2_add_to_bitmap_61:
  test al, ah
  jz l_e2_add_to_bitmap_64
    inc cl
    shl al, 1
    jmp short l_e2_add_to_bitmap_61

l_e2_add_to_bitmap_64:
or ah, al
mov hd_buffer[esi], ah
shl e2_ofs_bm, 3
add e2_ofs_bm, ecx  // e2_ofs_bm * 8 + cl

// write hd_buffer[esi], DESTROY ebx, edx
mov edi, VA_SYSTEM + offset hd_buffer
add edi, esi
add ebx, esi
adc edx, 0
mov ecx, 1
mov ah, 3  // write
mov al, e2_ldiskn
call e2_diskmain
jmp short l_e2_add_to_bitmap_9

l_e2_add_to_bitmap_7:
mov al, ERC_OUT_OF_RANGE

l_e2_add_to_bitmap_9:
ret

// IN: esi = relative number, edx = bitmap blockn
// OUT: al = erc
e2_rm_from_bitmap:
mov ebx, esi
shr ebx, 3
// read bitmap
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
mov eax, edx
shl eax, cl
xor cl, 31
inc cl
shr edx, cl
or ebx, eax
mov edi, VA_SYSTEM + offset e2_tmp
mov ecx, 1
mov ah, 2  // read
mov al, e2_ldiskn
push ebx
 push edx
  push esi
    call e2_diskmain
  pop ecx  // ecx = rel
 pop edx
pop ebx
test al, al
jnz l_e2_rm_from_bitmap_9

// free bitmap, KEEP edx, ebx
and cl, 7
mov al, 1
shl al, cl
test byte ptr e2_tmp, al
jnz l_e2_rm_from_bitmap_6
  mov al, ERC_FS
  jmp short l_e2_rm_from_bitmap_9
  
l_e2_rm_from_bitmap_6:
not al
and byte ptr e2_tmp, al

// write bitmap
mov edi, VA_SYSTEM + offset e2_tmp
mov ecx, 1
mov ah, 3  // write
mov al, e2_ldiskn
call e2_diskmain

l_e2_rm_from_bitmap_9:
ret

// IN: ebx = groupn, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc, ebx = new block
e2_alloc:
mov e2_group0, ebx
mov e2_group, ebx

mov eax, e2_sb.s_blocks_count
mov ecx, e2_sb.s_blocks_per_group
dec eax
dec eax
xor edx, edx
div ecx
inc eax  // eax = groups
mov e2_groups, eax

l_e2_alloc_1:
call e2_load_group
test al, al
jnz near l_e2_alloc_9

movzx eax, e2_gb.bg_free_blocks_count
test eax, eax
jz near l_e2_alloc_7  // next group

mov ebx, e2_gb.bg_block_bitmap
call e2_add_to_bitmap  // out e2_ofs_bm
test al, al
jnz near l_e2_alloc_9

// free place
dec e2_gb.bg_free_blocks_count
dec e2_sb.s_free_blocks_count

// write gb
mov ebx, e2_group
call e2_save_group_and_super
test al, al
jnz l_e2_alloc_9

// ebx = e2_ofs_bm + first_block_in_group
// first_block_in_group = (s_inodes_per_group * s_inode_size)
//   >> (s_log_block_size + 10) + bg_inode_table
mov eax, e2_sb.s_inodes_per_group
movzx ecx, e2_sb.s_inode_size
mul ecx
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
shr eax, cl
add eax, e2_gb.bg_inode_table
add eax, e2_ofs_bm
mov ebx, eax
xor eax, eax
jmp l_e2_alloc_9

l_e2_alloc_7:
// next group
inc e2_group
mov ebx, e2_group
cmp ebx, e2_group0
jnz l_e2_alloc_71
  
  l_e2_alloc_70:
  mov al, ERC_DISK_FULL
  xor ebx, ebx
  jmp short l_e2_alloc_9
  
l_e2_alloc_71:
cmp ebx, e2_groups
jb near l_e2_alloc_1

xor ebx, ebx
cmp ebx, e2_group0
jz l_e2_alloc_70

jmp l_e2_alloc_1

l_e2_alloc_9:
mov edx, e2_group0
cmp edx, e2_group
jz l_e2_alloc_99
  push eax
   push ebx
    mov ebx, edx
    call e2_load_group
   pop ebx
  pop eax

l_e2_alloc_99:
ret

// IN: ebx = groupn, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc, ebx = new block
e2_alloc_zero:
call e2_alloc
test al, al
jnz l_e2_alloc_zero_9
  push ebx
    // zero buffer
    xor eax, eax
    mov edi, VA_SYSTEM + offset hd_buffer
    mov ecx, 512 / 4
    cld
    rep stosd
    // calc sectn
    mov edx, ebx
    mov cl, byte ptr e2_sb.s_log_block_size
    add cl, 10
    shl ebx, cl
    xor cl, 31
    inc cl
    shr edx, cl
    // write buffer
    mov cl, byte ptr e2_sb.s_log_block_size
    mov eax, 2 // 1024/512
    shl eax, cl
    xchg eax, ecx
    
    l_e2_alloc_zero_5:
      push ecx
       push edx
        push ebx
          mov edi, VA_SYSTEM + offset hd_buffer
          mov ecx, 512
          mov ah, 3  // write
          mov al, e2_ldiskn
          call e2_diskmain
        pop ebx
       pop edx
      pop ecx
      test al, al
      jnz l_e2_alloc_zero_59

      add ebx, 512
      adc edx, 0
      loop l_e2_alloc_zero_5
    
    l_e2_alloc_zero_59:
  pop ebx
  
l_e2_alloc_zero_9:
ret

// IN: ebx = blockn, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc
// KEEP: ebx
e2_free:
push ebx
  mov eax, ebx
  test eax, eax
  jz near l_e2_free_9
  
  dec eax
  xor edx, edx
  div dword ptr e2_sb.s_blocks_per_group
  // eax = groupn, edx = blockn in group
  xchg eax, ebx
  push eax
    call e2_load_group
  pop ebx  // ebx = blockn
  test al, al
  jnz near l_e2_free_9

  mov eax, e2_sb.s_inodes_per_group
  movzx edx, e2_sb.s_inode_size
  mul edx
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  shr eax, cl
  add eax, e2_gb.bg_inode_table
  sub ebx, eax
  mov esi, ebx  // esi = relative block number
  
  mov edx, e2_gb.bg_block_bitmap
  call e2_rm_from_bitmap
  test al, al
  jnz l_e2_free_9
  
  // inc
  inc e2_sb.s_free_blocks_count
  inc e2_gb.bg_free_blocks_count
  mov ebx, e2_group
  call e2_save_group_and_super
  
  l_e2_free_9:
pop ebx
ret

// IN: e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc, ebx = inon
e2_alloc_inode:
mov eax, e2_sb.s_blocks_count
dec eax
xor edx, edx
div e2_sb.s_blocks_per_group
inc eax
mov esi, eax  // esi = blocks
xor ebx, ebx

l_e2_alloc_inode_1:
cmp ebx, esi
jnb l_e2_alloc_inode_6
  push esi
    call e2_load_group  // OUT e2_group
    mov ebx, e2_group
  pop esi
  cmp e2_gb.bg_free_inodes_count, 0
  jz l_e2_alloc_inode_next
    cmp e2_gb.bg_free_blocks_count, 0
    jz l_e2_alloc_inode_next
      // found
      mov ebx, e2_gb.bg_inode_bitmap
      call e2_add_to_bitmap  // OUT e2_ofs_bm
      test al, al
      jnz l_e2_alloc_inode_9
      
      // free place
      dec e2_gb.bg_free_inodes_count
      dec e2_sb.s_free_inodes_count
      
      // write gb
      mov ebx, e2_group
      call e2_save_group_and_super
      test al, al
      jnz l_e2_alloc_inode_9
      
      // out
      mov eax, e2_sb.s_inodes_per_group
      mul e2_group
      inc eax
      mov ebx, eax
      add ebx, e2_ofs_bm
      xor eax, eax
      jmp short l_e2_alloc_inode_9
      
  l_e2_alloc_inode_next:
  inc ebx
  jmp l_e2_alloc_inode_1

l_e2_alloc_inode_6:
xor ebx, ebx
mov al, ERC_DISK_FULL

l_e2_alloc_inode_9:
ret

// IN: ebx = inon, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc
// KEEP: ebx
e2_free_inode:
push ebx
  mov eax, ebx
  test eax, eax
  jz near l_e2_free_inode_9
  
  dec eax
  xor edx, edx
  div dword ptr e2_sb.s_inodes_per_group
  // eax = groupn, edx = inode in group
  xchg eax, ebx
  push edx
    call e2_load_group
  pop edx
  test al, al
  jnz near l_e2_free_inode_9
  
  mov esi, edx  // esi = relative inode number
  mov edx, e2_gb.bg_inode_bitmap
  call e2_rm_from_bitmap
  test al, al
  jnz l_e2_free_inode_9
  
  // inc
  inc e2_sb.s_free_inodes_count
  inc e2_gb.bg_free_inodes_count
  mov ebx, e2_group
  call e2_save_group_and_super
  
  l_e2_free_inode_9:
pop ebx
ret

l_e2_load_inode_x:
mov al, ERC_FS
ret

// IN: ebx = ino, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = 0 || erc, e2_inode, e2_inoa = disk offset of inode, e2_inon
e2_load_inode:
mov eax, ebx
mov e2_inon, eax
dec eax
mov ecx, e2_sb.s_inodes_per_group
xor edx, edx
jecxz l_e2_load_inode_x

div ecx  // eax = group, edx = inode in group
mov ebx, eax
push edx
  call e2_load_group
pop edi
test al, al
jnz l_e2_load_inode_9

// load inode
mov ebx, e2_gb.bg_inode_table
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
mov edx, ebx
shl ebx, cl
xor cl, 31 // cl = 32 - cl
inc cl
shr edx, cl

mov ax, e2_sb.s_inode_size
cmp ax, 128
jnz l_e2_load_inode_4
  // inode size = 128
  shl edi, 7
  jmp short l_e2_load_inode_5
  
l_e2_load_inode_4:
// inode size = 256
shl edi, 8

l_e2_load_inode_5:
add ebx, edi
adc edx, 0

mov ecx, sizeof INode
mov edi, VA_SYSTEM + offset e2_inode
mov ah, 2  // read
mov al, e2_ldiskn
mov dword ptr e2_inoa[0], ebx
mov dword ptr e2_inoa[4], edx
call e2_diskmain

l_e2_load_inode_9:
ret

// IN: e2_inoa, e2_inode, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = 0 || erc
// KEEP: edx, edi
e2_save_inode:
push edx
 push edi
  mov ecx, sizeof INode
  mov edi, VA_SYSTEM + offset e2_inode
  mov ah, 3  // write
  mov al, e2_ldiskn
  mov ebx, dword ptr e2_inoa[0]
  mov edx, dword ptr e2_inoa[4]
  call e2_diskmain
 pop edi
pop edx
ret

// IN: ebx = disk blockn, eax = subblockn, e2_ldiskn, e2_diskmain
// OUT: al = erc, ebx = disk blockn
// KEEP: edi
e2_read_blockn:
push edi
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  mov edx, ebx
  shl ebx, cl
  xor cl, 31
  inc cl
  shr edx, cl
  shl eax, 2
  add ebx, eax
  adc edx, 0
  
  mov ecx, 4
  mov ah, 2  // read
  mov al, e2_ldiskn
  mov edi, VA_SYSTEM + offset e2_tmp
  call e2_diskmain
pop edi
mov ebx, e2_tmp
ret

// IN: ebx = disk blockn, eax = subblockn, ch = zero, e2_ldiskn, e2_diskmain
// OUT: al = erc, ebx = disk blockn
// KEEP: edi
e2_rw_blockn:
push edi
 push ecx

  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  mov edx, ebx
  shl ebx, cl
  xor cl, 31
  inc cl
  shr edx, cl
  shl eax, 2
  add ebx, eax
  adc edx, 0
  
  mov ecx, 4
  mov ah, 2  // read
  mov al, e2_ldiskn
  mov edi, VA_SYSTEM + offset e2_tmp
  push edx
   push ebx
    call e2_diskmain
   pop ebx
  pop edx

 pop ecx
pop edi
test al, al
jnz l_e2_rw_blockn_9

mov esi, e2_tmp
test esi, esi
jnz l_e2_rw_blockn_9
  push edi

   push edx
    push ebx
      mov ebx, e2_group
      test ch, ch
      jnz l_e2_rw_blockn_6
        // zero
        call e2_alloc_zero
        jmp short l_e2_rw_blockn_7
      
      l_e2_rw_blockn_6:
      // not zero
      call e2_alloc
    
      l_e2_rw_blockn_7:
      mov e2_tmp, ebx
    pop ebx
   pop edx
   
   test al, al
   jnz l_e2_rw_blockn_8
     mov ecx, 4
     mov ah, 3  // write
     mov al, e2_ldiskn
     mov edi, VA_SYSTEM + offset e2_tmp
     call e2_diskmain
     
   l_e2_rw_blockn_8:
  pop edi
  
l_e2_rw_blockn_9:
mov ebx, e2_tmp
ret

// IN: ebx = disk blockn, eax = subblockn, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc
// KEEP: ebx
e2_zero_blockn:
push ebx
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  mov edx, ebx
  shl ebx, cl
  xor cl, 31
  inc cl
  shr edx, cl
  shl eax, 2
  add ebx, eax
  adc edx, 0
  
  xor eax, eax
  mov e2_tmp, eax
  
  mov ecx, 4
  mov ah, 3  // write
  mov al, e2_ldiskn
  mov edi, VA_SYSTEM + offset e2_tmp
  call e2_diskmain
pop ebx
ret

// IN: e2_block(block in file), e2_sb, e2_inode, e2_ldiskn, e2_diskmain
// OUT: al = 0 || erc, ebx = disk block
// KEEP: edi
e2_get_blockn:
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov esi, 1
shl esi, cl  // esi = block_size / 4

l_e2_get_blockn_11:
mov eax, e2_block
cmp eax, 12
jnb l_e2_get_blockn_12
  // e2_block < 12
  shl eax, 2
  mov ebx, e2_inode.i_block[eax]
  mov al, 0
  ret

l_e2_get_blockn_12:
sub eax, 12
cmp eax, esi
jnb l_e2_get_blockn_13
  // single indirect
  mov ebx, e2_inode.i_block[SINGLE_INDIRECT]
  call e2_read_blockn
  ret
  
l_e2_get_blockn_13:
sub eax, esi
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov edx, esi
shl edx, cl
cmp eax, edx
jnb near l_e2_get_blockn_14
  // double indirect
  push eax
   shr eax, cl
   mov ebx, e2_inode.i_block[DOUBLE_INDIRECT]
   call e2_read_blockn
  pop edx
  test al, al
  jnz l_e2_get_blockn_9
  
  xchg eax, edx
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10 - 2
  mov esi, 1
  shl esi, cl
  dec esi
  and eax, esi
  call e2_read_blockn
  ret
  
l_e2_get_blockn_14:
// triple indirect
sub eax, edx
push eax
 mov ebx, e2_inode.i_block[TRIPLE_INDIRECT]
 mov cl, byte ptr e2_sb.s_log_block_size
 add cl, 10 - 2
 shr eax, cl
 shr eax, cl
 call e2_read_blockn
pop edx
test al, al
jnz l_e2_get_blockn_9

xchg eax, edx
push eax
 mov cl, byte ptr e2_sb.s_log_block_size
 add cl, 10 - 2
 mov esi, 1
 shl esi, cl
 dec esi
 shr eax, cl
 and eax, esi
 call e2_read_blockn
pop edx
test al, al
jnz l_e2_get_blockn_9

xchg eax, edx 
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov esi, 1
shl esi, cl
dec esi
and eax, esi
call e2_read_blockn

l_e2_get_blockn_9:
ret

// IN: e2_block(block in file), e2_sb, e2_inode, e2_ldiskn, e2_diskmain
// OUT: al = 0 || erc, ebx = disk block, requires e2_save_inode
// KEEP: edi
e2_set_blockn:
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov esi, 1
shl esi, cl  // esi = block_size / 4

l_e2_set_blockn_11:
mov eax, e2_block
cmp eax, 12
jnb l_e2_set_blockn_12
  // e2_block < 12
  shl eax, 2
  mov ebx, e2_inode.i_block[eax]
  test ebx, ebx
  jnz near l_e2_set_blockn_8
    push eax
     push edi
      mov ebx, e2_group
      call e2_alloc
     pop edi
    pop edx
    test al, al
    jnz near l_e2_set_blockn_9
      mov e2_inode.i_block[edx], ebx
      ret

l_e2_set_blockn_12:
sub eax, 12
cmp eax, esi
jnb l_e2_set_blockn_13
  // single indirect
  mov ebx, e2_inode.i_block[SINGLE_INDIRECT]
  test ebx, ebx
  jnz l_e2_set_blockn_126
    push eax
     push edi
      mov ebx, e2_group
      call e2_alloc_zero
     pop edi
    pop edx
    test al, al
    jnz near l_e2_set_blockn_9
      mov e2_inode.i_block[SINGLE_INDIRECT], ebx
      xchg eax, edx
    
  l_e2_set_blockn_126:
  mov ch, 1
  call e2_rw_blockn
  ret
  
l_e2_set_blockn_13:
sub eax, esi
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov edx, esi
shl edx, cl
cmp eax, edx
jnb near l_e2_set_blockn_14
  // double indirect
  push eax
    shr eax, cl
    mov ebx, e2_inode.i_block[DOUBLE_INDIRECT]
    test ebx, ebx
    jnz l_e2_set_blockn_136
      push eax
       push edi
        mov ebx, e2_group
        call e2_alloc_zero
       pop edi
      pop edx
      test al, al
      jnz l_e2_set_blockn_134
        mov e2_inode.i_block[DOUBLE_INDIRECT], ebx
        xchg eax, edx
        jmp short l_e2_set_blockn_136
    
      l_e2_set_blockn_134:
      pop edx
      jmp l_e2_set_blockn_9
      
    l_e2_set_blockn_136:
    mov ch, 0
    call e2_rw_blockn
  pop edx
  test al, al
  jnz near l_e2_set_blockn_9
  
  xchg eax, edx
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10 - 2
  mov esi, 1
  shl esi, cl
  dec esi
  and eax, esi
  mov ch, 1
  call e2_rw_blockn
  ret
  
l_e2_set_blockn_14:
// triple indirect
sub eax, edx
push eax
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10 - 2
  shr eax, cl
  shr eax, cl
  
  // check overflow
  cmp eax, esi
  jb l_e2_set_blockn_141
    mov al, ERC_FILE_TOO_BIG
    xor ebx, ebx
    jmp l_e2_set_blockn_9
    
  l_e2_set_blockn_141:
  
  mov ebx, e2_inode.i_block[TRIPLE_INDIRECT]
  test ebx, ebx
  jnz l_e2_set_blockn_146
    push eax
     push edi
      mov ebx, e2_group
      call e2_alloc_zero
     pop edi
    pop edx
    test al, al
    jnz l_e2_set_blockn_144
      mov e2_inode.i_block[TRIPLE_INDIRECT], ebx
      xchg eax, edx
      jmp short l_e2_set_blockn_146
  
  l_e2_set_blockn_144:
  pop edx
  jmp l_e2_set_blockn_9
  
  l_e2_set_blockn_146:
  mov ch, 0
  call e2_rw_blockn
pop edx
test al, al
jnz l_e2_set_blockn_9

xchg eax, edx
push eax
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10 - 2
  mov esi, 1
  shl esi, cl
  dec esi
  shr eax, cl
  and eax, esi
  mov ch, 0
  call e2_rw_blockn
pop edx
test al, al
jnz l_e2_set_blockn_9

xchg eax, edx 
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov esi, 1
shl esi, cl
dec esi
and eax, esi
mov ch, 1
call e2_rw_blockn
jmp short l_e2_set_blockn_9

l_e2_set_blockn_8:
mov al, 0

l_e2_set_blockn_9:
ret

// IN: edx:ebx = file offset, ecx = size, e2_sb
// OUT: e2_block, e2_count, e2_relofs, e2_endrelofs
// KEEP: edi
e2_prepare_values:
push edi
 push ecx
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  mov esi, 1
  shl esi, cl
  dec esi  // esi = block_size - 1
  mov eax, ebx
  and eax, esi
  mov e2_relofs, eax

  mov eax, ebx
  shr eax, cl
  xor cl, 31
  inc cl
  mov edi, edx
  shl edi, cl
  or eax, edi
  mov e2_block, eax  // e2_block = file offset >> log_block_size
 pop ecx
 dec ecx
 add ebx, ecx
 adc edx, 0
 mov eax, ebx
 and eax, esi
 mov e2_endrelofs, eax

 mov cl, byte ptr e2_sb.s_log_block_size
 add cl, 10
 mov eax, ebx
 shr eax, cl
 xor cl, 31
 inc cl
 mov edi, edx
 shl edi, cl
 or eax, edi
 sub eax, e2_block
 inc eax
 mov e2_count, eax  // e2_count = (fofs + size - 1) >> log_bs - e2_block + 1
pop edi
ret

e2_read_x0:
mov al, 0
ret

// IN: e2_inode, edx:ebx = file offset, ecx = size, es:edi -> data
// OUT: al = 0 || erc
e2_read:
jecxz e2_read_x0

call e2_prepare_values  // KEEP edi

l_e2_read_2:
// read blocks
mov eax, e2_count
test eax, eax
jz l_e2_read_8
  call e2_get_blockn  // KEEP edi
  test al, al
  jnz l_e2_read_9
  
  test ebx, ebx
  jnz l_e2_read_21
    mov al, ERC_FS
    jmp short l_e2_read_9
    
  l_e2_read_21:
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  mov esi, 1
  shl esi, cl
  
  mov edx, ebx
  shl ebx, cl
  xor cl, 31
  inc cl
  shr edx, cl
  
  mov eax, e2_count
  dec eax
  test eax, eax
  jnz l_e2_read_26  
    mov ecx, e2_endrelofs
    inc ecx
    jmp short l_e2_read_27
    
  l_e2_read_26:
  mov ecx, esi
  
  l_e2_read_27:
  mov eax, e2_relofs
  add ebx, eax
  adc edx, 0
  sub ecx, eax
  
  mov ah, 2
  mov al, e2_ldiskn
  push edi
   push ecx
    call e2_diskmain
   pop ecx
  pop edi
  test al, al
  jnz l_e2_read_9
  
  add edi, ecx
  
  xor eax, eax
  mov e2_relofs, eax
  inc e2_block
  dec e2_count
  jmp l_e2_read_2
  
l_e2_read_8:
mov al, 0

l_e2_read_9:
ret

e2_write_x0:
mov al, 0
ret

// IN: e2_inode, edx:ebx = file offset, ecx = size, es:edi -> data
// OUT: al = 0 || erc
e2_write:
jecxz e2_write_x0

call e2_prepare_values  // KEEP edi
  
l_e2_write_2:
// write blocks
mov eax, e2_count
test eax, eax
jz l_e2_write_8
  call e2_set_blockn  // KEEP edi
  test al, al
  jnz l_e2_write_9
  
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  mov esi, 1
  shl esi, cl
  
  mov edx, ebx
  shl ebx, cl
  xor cl, 31
  inc cl
  shr edx, cl
  
  mov eax, e2_count
  dec eax
  test eax, eax
  jnz l_e2_write_26  
    mov ecx, e2_endrelofs
    inc ecx
    jmp short l_e2_write_27
    
  l_e2_write_26:
  mov ecx, esi
  
  l_e2_write_27:
  mov eax, e2_relofs
  add ebx, eax
  adc edx, 0
  sub ecx, eax
  
  mov ah, 3  // write
  mov al, e2_ldiskn
  push edi
   push ecx
    call e2_diskmain
   pop ecx
  pop edi
  test al, al
  jnz l_e2_write_9

  add edi, ecx
  
  xor eax, eax
  mov e2_relofs, eax
  inc e2_block
  dec e2_count
  jmp l_e2_write_2
  
l_e2_write_8:
mov al, 0

l_e2_write_9:
ret

// IN: edx:ebx = file pos, e2_inode, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc
e2_delete:
mov e2_inode.i_size, ebx
mov e2_inode.i_dir_acl, edx

mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
mov esi, 1
shl esi, cl
dec esi
add ebx, esi
adc edx, 0

shr ebx, cl
xor cl, 31
inc cl
shl edx, cl
or ebx, edx  // ebx = file blockn

mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov esi, 1
shl esi, cl  // esi = block_size / 4

mov eax, ebx
cmp eax, 12
jnb l_e2_delete_1
  mov edx, eax
  shl edx, 2
  
  l_e2_delete_05:
    mov ebx, e2_inode.i_block[edx]
    push edx
      call e2_free
    pop edx
    test al, al
    jnz near l_e2_delete_9
    
    xor eax, eax
    mov e2_inode.i_block[edx], eax
    add edx, 4
    cmp edx, 12 * 4
    jb l_e2_delete_05
  
  // eax = 0
  jmp short l_e2_delete_11
  
l_e2_delete_1:
sub eax, 12
cmp eax, esi
jnb near l_e2_delete_2
  // single indirect
  l_e2_delete_11:
  mov e2_first1, eax
  
  l_e2_delete_15:
    mov ebx, e2_inode.i_block[SINGLE_INDIRECT]
    test ebx, ebx
    jz near l_e2_delete_18
    
    push eax
      call e2_read_blockn
    pop edx
    test al, al
    jnz near l_e2_delete_9
    
    push edx
      call e2_free
    pop edx
    test al, al
    jnz near l_e2_delete_9
    
    mov ebx, e2_inode.i_block[SINGLE_INDIRECT]
    mov eax, edx
    push edx
      call e2_zero_blockn
    pop edx
    test al, al
    jnz near l_e2_delete_9
    
    xchg eax, edx
    inc eax
    
    mov cl, byte ptr e2_sb.s_log_block_size
    add cl, 10 - 2
    mov edx, 1
    shl edx, cl
    cmp eax, edx
    jb l_e2_delete_15
    
  cmp e2_first1, 0
  jnz l_e2_delete_18
    mov ebx, e2_inode.i_block[SINGLE_INDIRECT]
    call e2_free
    test al, al
    jnz near l_e2_delete_9
    
    xor eax, eax
    mov e2_inode.i_block[SINGLE_INDIRECT], eax
    
  l_e2_delete_18:
  xor eax, eax
  jmp short l_e2_delete_21
  
l_e2_delete_2:
sub eax, esi
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
mov edx, esi
shl edx, cl
cmp eax, edx
jnb near l_e2_delete_3
  // double indirect
  l_e2_delete_21:
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10 - 2
  push eax
    shr eax, cl
    mov e2_first1, eax
    mov e2_i1, eax
  pop eax
  mov esi, 1
  shl esi, cl
  dec esi
  and eax, esi
  mov e2_first2, eax
  mov e2_i2, eax
  
  l_e2_delete_22:
    mov ebx, e2_inode.i_block[DOUBLE_INDIRECT]
    test ebx, ebx
    jz near l_e2_delete_27
    
    mov eax, e2_i1
    call e2_read_blockn
    test al, al
    jnz near l_e2_delete_9
    test ebx, ebx
    jz l_e2_delete_26
    
    l_e2_delete_24:
      push ebx
        mov eax, e2_i2
        call e2_read_blockn
      pop edx
      test al, al
      jnz near l_e2_delete_9
      
      push edx
        call e2_free
      pop ebx
      test al, al
      jnz near l_e2_delete_9
      
      mov eax, e2_i2
      call e2_zero_blockn
      test al, al
      jnz near l_e2_delete_9
      
      inc e2_i2
      mov cl, byte ptr e2_sb.s_log_block_size
      add cl, 10 - 2
      mov esi, 1
      shl esi, cl  // esi = block_size / 4
      cmp e2_i2, esi
      jb l_e2_delete_24
      
    cmp e2_first2, 0
    jnz l_e2_delete_26
      call e2_free
      test al, al
      jnz near l_e2_delete_9
      
      mov ebx, e2_inode.i_block[DOUBLE_INDIRECT]
      mov eax, e2_i1
      call e2_zero_blockn
      
    l_e2_delete_26:
    mov cl, byte ptr e2_sb.s_log_block_size
    add cl, 10 - 2
    mov esi, 1
    shl esi, cl  // esi = block_size / 4
    
    inc e2_i1
    xor eax, eax
    mov e2_i2, eax
    mov e2_first2, eax
    cmp e2_i1, esi
    jb near l_e2_delete_22
    
  cmp e2_first1, 0
  jnz l_e2_delete_27
    mov ebx, e2_inode.i_block[DOUBLE_INDIRECT]
    call e2_free
    test al, al
    jnz near l_e2_delete_9
    
    xor eax, eax
    mov e2_inode.i_block[DOUBLE_INDIRECT], eax
    
  l_e2_delete_27:
  xor eax, eax
  jmp short l_e2_delete_31

l_e2_delete_3:
// triple indirect
sub eax, edx

l_e2_delete_31:
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10 - 2
push eax
  shr eax, cl
  shr eax, cl
  mov e2_first1, eax
  mov e2_i1, eax
pop eax
push eax
  shr eax, cl
  mov esi, 1
  shl esi, cl
  dec esi
  and eax, esi
  mov e2_first2, eax
  mov e2_i2, eax
pop eax
and eax, esi
mov e2_first3, eax
mov e2_i3, eax

  l_e2_delete_32:
  mov ebx, e2_inode.i_block[TRIPLE_INDIRECT]
  test ebx, ebx
  jz near l_e2_delete_37
  
  mov eax, e2_i1
  call e2_read_blockn
  test al, al
  jnz near l_e2_delete_9
  test ebx, ebx
  jz near l_e2_delete_36
  
  mov e2_mid, ebx
  
  l_e2_delete_33:
    mov ebx, e2_mid
    mov eax, e2_i2
    call e2_read_blockn
    test al, al
    jnz near l_e2_delete_9
    test ebx, ebx
    jz near l_e2_delete_35
    
    l_e2_delete_34:
      push ebx
        mov eax, e2_i3
        call e2_read_blockn
      pop edx
      test al, al
      jnz near l_e2_delete_9
      
      push edx
        call e2_free
      pop ebx
      test al, al
      jnz near l_e2_delete_9
      
      mov eax, e2_i3
      call e2_zero_blockn
      test al, al
      jnz near l_e2_delete_9
      
      // next i3
      inc e2_i3
      mov cl, byte ptr e2_sb.s_log_block_size
      add cl, 10 - 2
      mov esi, 1
      shl esi, cl  // esi = block_size / 4
      cmp e2_i3, esi
      jb l_e2_delete_34
      
    cmp e2_first3, 0
    jnz l_e2_delete_35
      call e2_free
      test al, al
      jnz near l_e2_delete_9
  
      mov ebx, e2_mid
      mov eax, e2_i2
      call e2_zero_blockn
    
    l_e2_delete_35:  // next i2
    mov cl, byte ptr e2_sb.s_log_block_size
    add cl, 10 - 2
    mov esi, 1
    shl esi, cl  // esi = block_size / 4
    
    inc e2_i2
    xor eax, eax
    mov e2_i3, eax
    mov e2_first3, eax
    cmp e2_i2, esi
    jb near l_e2_delete_33
    
  cmp e2_first2, 0
  jnz l_e2_delete_36
    mov ebx, e2_mid
    call e2_free
    test al, al
    jnz near l_e2_delete_9

    mov ebx, e2_inode.i_block[TRIPLE_INDIRECT]
    mov eax, e2_i1
    call e2_zero_blockn
  
  l_e2_delete_36:  // next i1
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10 - 2
  mov esi, 1
  shl esi, cl  // esi = block_size / 4
  
  inc e2_i1
  xor eax, eax
  mov e2_i2, eax
  mov e2_first2, eax
  cmp e2_i1, esi
  jb near l_e2_delete_32
  
cmp e2_first1, 0
jnz l_e2_delete_37
  mov ebx, e2_inode.i_block[TRIPLE_INDIRECT]
  call e2_free
  test al, al
  jnz near l_e2_delete_9
  
  xor eax, eax
  mov e2_inode.i_block[TRIPLE_INDIRECT], eax
  
l_e2_delete_37:

l_e2_delete_8:
call e2_save_inode

l_e2_delete_9:
ret

// IN: ebx = inode, edx -> path/filenamez, e2_parentino, e2_ldiskn
// OUT: al = erc, es:edx -> fs_link, ebx = dir
// USES: e2_diflink, fd_buffer
e2_follow_link:
inc link_depth
cmp link_depth, MAX_LINK_DEPTH
jna l_e2_follow_link_1
  mov al, ERC_INFINITE_LINK
  ret
  
l_e2_follow_link_04:
  // fast symlink
  mov esi, offset e2_inode.i_block
  mov edi, VA_SYSTEM + offset fd_buffer
  mov ecx, 60 / 4
  cld
  rep movsd
  mov byte ptr fd_buffer[60 - 1], 0
  
  xor ecx, ecx
  
  l_e2_follow_link_05:
    cmp byte ptr fd_buffer[ecx], 0
    jz l_e2_follow_link_62
      inc ecx
      jmp short l_e2_follow_link_05
  
l_e2_follow_link_1:
// load link to fd_buffer
push ebx
 push edx
  call e2_load_inode
  xor ebx, ebx
  xor edx, edx
  mov ecx, e2_inode.i_size
  cmp ecx, 60
  jb l_e2_follow_link_04
  
  cmp ecx, MAX_PATH - 1
  jb l_e2_follow_link_61
    mov ecx, MAX_PATH - 1
    
  l_e2_follow_link_61:
  mov edi, VA_SYSTEM + offset fd_buffer
  push ecx
    call e2_read
  pop ecx
  mov byte ptr fd_buffer[ecx], 0
  
  l_e2_follow_link_62:
 pop edx
pop ebx

// process path in fd_buffer
mov e2_diflink, 0
xor esi, esi
cmp fd_buffer[1], ':'
jnz l_e2_follow_link_64
  add esi, 2
  mov al, fd_buffer[0]
  and al, 31
  cmp al, e2_ldiskn
  jz l_e2_follow_link_64
    // differrent disk
    mov e2_diflink, ERC_LINK
    xor esi, esi
    jmp short l_e2_follow_link_66
  
l_e2_follow_link_64:
cmp byte ptr fd_buffer[esi], '/'
jnz l_e2_follow_link_65
  // starting at root
  mov ebx, EXT2_ROOT_INO
  inc esi
  jmp short l_e2_follow_link_66
  
l_e2_follow_link_65:
  // relative path
  mov ebx, e2_parentino
  
l_e2_follow_link_66:
// merge fd_buffer with edx
mov edi, VA_SYSTEM + offset fd_buffer
add edi, ecx
cmp byte ptr [es:edi - 1], '/'
jz l_e2_follow_link_668
  mov al, '/'
  stosb

l_e2_follow_link_668:
cmp byte ptr [es:edx], 0
jnz l_e2_follow_link_67
  mov byte ptr [es:edi - 1], 0
  
l_e2_follow_link_67:
  mov al, [es:edx]
  stosb
  cmp al, 0
  jz l_e2_follow_link_671
    inc edx
    cmp edi, VA_SYSTEM + offset fd_buffer + MAX_PATH
    jb l_e2_follow_link_67
      mov al, ERC_TOO_LONG
      jmp l_e2_follow_link_9
      
l_e2_follow_link_671:
// copy fd_buffer to fs_link, set edx
mov edx, VA_SYSTEM + offset fs_link
mov edi, edx
add edx, esi
mov esi, offset fd_buffer

l_e2_follow_link_672:
  lodsb
  stosb
  cmp al, 0
  jnz l_e2_follow_link_672

mov al, e2_diflink
l_e2_follow_link_9:
ret

// IN: es:edx -> filenamez, ebx = 0 || dirino, al = ldiskn
// OUT: al = 0 || erc, ebx = ino, e2_parentino, e2_nameofs
e2_find_file:
cmp al, e2_ldiskn
jz l_e2_find_file_01
  push edx
   push ebx
    call e2_prepare
   pop ebx
  pop edx
  test al, al
  jnz near l_e2_find_file_9
  
l_e2_find_file_01:
test ebx, ebx
jnz l_e2_find_file_1
  mov ebx, EXT2_ROOT_INO

l_e2_find_file_1:
mov e2_parentino, ebx
mov e2_nameofs, edx

push edx
  call e2_load_inode
pop edx
mov ax, e2_inode.i_mode
test ax, EXT2_S_IFDIR
jnz l_e2_find_file_2
  mov al, ERC_PATH_NOT_FOUND
  jmp l_e2_find_file_9

l_e2_find_file_2:
xor ebx, ebx
cmp ebx, e2_inode.i_size
jb l_e2_find_file_5
  
  l_e2_find_file_3:
    mov al, [es:edx]
    cmp al, 0
    jz l_e2_find_file_54
    cmp al, '/'
    jz l_e2_find_file_54
    inc edx
    jmp short l_e2_find_file_3
  
l_e2_find_file_5:

push edx

  mov ecx, 8
  xor edx, edx
  mov edi, VA_SYSTEM + offset fd_buffer
  push ebx
    call e2_read
  pop ebx
  test al, al
  jnz near l_e2_find_file_7
  
  movzx ecx, byte ptr fd_buffer[6]  // name_len
  push ebx
   push ecx
    add ebx, 8
    xor edx, edx
    mov edi, VA_SYSTEM + offset fd_buffer + 8
    call e2_read
   pop ecx
  pop ebx
  test al, al
  jnz l_e2_find_file_7

  mov byte ptr fd_buffer[ecx + 8], 0

pop edx

mov esi, VA_SYSTEM + offset fd_buffer + 8
push ebx
  call fs_cmp
pop ebx
test al, al
jz l_e2_find_file_6
  // not found, try next
  movzx eax, word ptr fd_buffer[4]  // rec_len
  test eax, eax
  jz l_e2_find_file_58
  
  add ebx, eax
  cmp ebx, e2_inode.i_size
  
  jb l_e2_find_file_5
    
    call fs_next_edx
    
    l_e2_find_file_54:
    // eof
    cmp byte ptr [es:edx], 0
    jz l_e2_find_file_56
      mov al, ERC_PATH_NOT_FOUND
      jmp short l_e2_find_file_9
      
    l_e2_find_file_56:
    mov al, ERC_FILE_NOT_FOUND
    jmp short l_e2_find_file_9

l_e2_find_file_58:
mov al, ERC_FS
jmp short l_e2_find_file_9

l_e2_find_file_6:
// found
call fs_next_edx
mov ebx, dword ptr fd_buffer[0]

// link?
cmp byte ptr fd_buffer[7], EXT2_FT_SYMLINK
jz l_e2_find_file_60

cmp byte ptr [es:edx], 0
jz l_e2_find_file_8
  // not end of es:edx
  jmp l_e2_find_file_1

l_e2_find_file_7:
pop edx
jmp short l_e2_find_file_9

l_e2_find_file_8:
mov al, 0

l_e2_find_file_9:  
ret


// link
l_e2_find_file_60:
test take_link, 1
jz l_e2_find_file_608
  cmp byte ptr [es:edx], 0
  jz l_e2_find_file_8
  
l_e2_find_file_608:
call e2_follow_link
test al, al
jnz l_e2_find_file_9
  jmp l_e2_find_file_1

// IN: es:edx -> filenamez, e2_parentino, e2_dir2.ino, e2_dir2.file_type
//     e2_sb, e2_ldiskn, e2_diskmain
// OUT: e2_inode
e2_add_name:
mov ebx, e2_parentino
push edx
  call e2_load_inode
pop edx

// count filename len
mov ebx, edx

l_e2_add_name_15:
  cmp byte ptr [es:ebx], 0
  jz l_e2_add_name_18
    inc ebx
    jmp l_e2_add_name_15
    
l_e2_add_name_18:
sub ebx, edx
cmp ebx, 255
jna l_e2_add_name_19
  mov ebx, 255
  
l_e2_add_name_19:
mov e2_len, ebx
mov e2_dir2.name_len, bl

// check duplicate file name  keep edx
xor eax, eax
mov e2_ofs, eax

l_e2_add_name_25:
  mov eax, e2_ofs
  cmp eax, e2_inode.i_size
  jnb near l_e2_add_name_28
    push edx
      mov ebx, e2_ofs
      xor edx, edx
      mov ecx, 8
      mov edi, VA_SYSTEM + offset e2_dir
      push ebx
        call e2_read
      pop ebx
      
      // compare name lengths
      mov al, byte ptr e2_len
      cmp al, e2_dir.name_len
      jnz l_e2_add_name_258
        add ebx, 8
        xor edx, edx
        movzx ecx, al
        mov edi, VA_SYSTEM + offset hd_buffer
        call e2_read
        
        // compare names
    pop edx
    push edx
        movzx ecx, e2_dir.name_len
        mov byte ptr hd_buffer[ecx], 0
        mov esi, VA_SYSTEM + offset hd_buffer
        call fs_cmp
        test al, al
        jnz l_e2_add_name_258
          mov al, ERC_DUPLICATE_NAME
          jmp short l_e2_add_name_26
          
      l_e2_add_name_258:
      mov al, 0
      
      l_e2_add_name_26:
    pop edx
    
    cmp al, ERC_DUPLICATE_NAME
    jz near l_e2_add_name_9
      movzx eax, e2_dir.rec_len
      test eax, eax
      jz l_e2_add_name_27
        add e2_ofs, eax
        jmp l_e2_add_name_25
        
    l_e2_add_name_27:
    mov al, ERC_FS
    jmp near l_e2_add_name_9

l_e2_add_name_28:

// find free place
xor eax, eax
mov e2_ofs, eax
mov e2_ofs2, eax

l_e2_add_name_5:
  mov eax, e2_ofs
  cmp eax, e2_inode.i_size
  jnb l_e2_add_name_54
    push edx
      mov ebx, e2_ofs
      xor edx, edx
      mov ecx, 8
      mov edi, VA_SYSTEM + offset e2_dir
      call e2_read
    pop edx
    movzx eax, e2_dir.name_len
    add eax, e2_len
    add eax, 8 + 8
    cmp ax, e2_dir.rec_len
    jna l_e2_add_name_56
      movzx eax, e2_dir.rec_len
      add e2_ofs, eax
      jmp l_e2_add_name_5

l_e2_add_name_53:
mov al, ERC_DIR_TOO_BIG
jmp l_e2_add_name_9

l_e2_add_name_54:
// not found - add to end of file
mov eax, e2_len
add eax, 8
mov e2_dir2.rec_len, ax
push edx
  mov ebx, e2_ofs
  mov e2_ofs2, ebx
  xor edx, edx
  mov ecx, 8
  mov edi, VA_SYSTEM + offset e2_dir2
  call e2_write
pop edx

mov eax, e2_ofs
add eax, 8
add eax, e2_len
cmp eax, e2_ofs
jb l_e2_add_name_53

mov e2_inode.i_size, eax
call e2_save_inode  // keep edx
jmp l_e2_add_name_58

l_e2_add_name_56:
// found - add after dir
movzx ecx, e2_dir.rec_len

sub eax, e2_len
sub eax, 8
sub ecx, eax
mov e2_dir2.rec_len, cx

mov ebx, eax
add ebx, e2_ofs
mov e2_ofs2, ebx  // e2_ofs2 = new ofs
mov e2_dir.rec_len, ax

push edx
  mov ebx, e2_ofs
  xor edx, edx
  mov ecx, 8
  mov edi, VA_SYSTEM + offset e2_dir
  call e2_write
  
  mov ebx, e2_ofs2
  xor edx, edx
  mov ecx, 8
  mov edi, VA_SYSTEM + offset e2_dir2
  call e2_write
pop edx

l_e2_add_name_58:
// both - copy name
mov edi, edx
mov ebx, e2_ofs2
add ebx, 8
xor edx, edx
mov ecx, e2_len
call e2_write

l_e2_add_name_9:
ret

// BEFORE: e2_prepare, e2_load_inode
// KEEP: edx, e2_len
// USES: fd_buffer
e2_reduce_dir:
push edx
  xor eax, eax
  mov e2_ofs, eax
  mov e2_ofs2, eax
  
  l_e2_reduce_dir_5:
  mov eax, e2_ofs
  cmp eax, e2_inode.i_size
  jnb near l_e2_reduce_dir_8
    mov ebx, eax
    xor edx, edx
    mov ecx, 8
    mov edi, VA_SYSTEM + offset e2_dir
    push ebx
      call e2_read
    pop ebx
    
    cmp ebx, e2_ofs2
    jz l_e2_reduce_dir_6
      // ofs != ofs2 => copy dir rec
      xor edx, edx
      movzx ecx, byte ptr e2_dir.name_len
      add ecx, 8
      mov edi, VA_SYSTEM + offset fd_buffer
      push ecx
        call e2_read
      pop ecx
      
      mov word ptr fd_buffer[offset E2DirEntry.rec_len], cx  // gap
      mov ebx, e2_ofs2
      xor edx, edx
      mov edi, VA_SYSTEM + offset fd_buffer
      call e2_write
      jmp l_e2_reduce_dir_7
      
    l_e2_reduce_dir_6:
    movzx eax, byte ptr e2_dir.name_len
    movzx ecx, word ptr e2_dir.rec_len
    add eax, 8
    cmp eax, ecx
    jz l_e2_reduce_dir_7
      // gap, IN: ebx
      push eax
       push ecx
        mov e2_dir.rec_len, ax
        xor edx, edx
        mov ecx, 8
        mov edi, VA_SYSTEM + offset e2_dir
        call e2_write
       pop ecx
      pop eax
      jmp short l_e2_reduce_dir_72
    
    l_e2_reduce_dir_7:
    movzx eax, byte ptr e2_dir.name_len
    movzx ecx, word ptr e2_dir.rec_len
    add eax, 8
    
    l_e2_reduce_dir_72:
    add e2_ofs, ecx
    add e2_ofs2, eax
    jmp l_e2_reduce_dir_5

  l_e2_reduce_dir_8:
  cmp eax, e2_ofs2
  jz l_e2_reduce_dir_9
    // delete rest of file
    mov ebx, e2_ofs2
    xor edx, edx
    call e2_delete
    
  l_e2_reduce_dir_9:
pop edx
ret

// IN: es:edx -> filenamez, e2_parentino, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = erc, e2_dir
// USES: hd_buffer
e2_rm_name:
mov ebx, e2_parentino
push edx
  call e2_load_inode
pop edx

// count filename len
mov ebx, edx

l_e2_rm_name_15:
  cmp byte ptr [es:ebx], 0
  jz l_e2_rm_name_18
    inc ebx
    jmp l_e2_rm_name_15
    
l_e2_rm_name_18:
sub ebx, edx
cmp ebx, 255
jna l_e2_rm_name_19
  mov ebx, 255
  
l_e2_rm_name_19:
mov e2_len, ebx

l_e2_rm_name_2:
// search
xor eax, eax
mov e2_ofs, eax  // 0
dec eax
mov e2_ofs2, eax // -1

l_e2_rm_name_5:
  mov eax, e2_ofs
  cmp eax, e2_inode.i_size
  jnb l_e2_rm_name_54
    push edx
      mov ebx, eax
      xor edx, edx
      mov ecx, 8
      mov edi, VA_SYSTEM + offset e2_dir
      push ebx
        call e2_read
      pop ebx
    pop edx
    
    // compare name lengths
    mov al, byte ptr e2_len
    cmp al, e2_dir.name_len
    jnz l_e2_rm_name_next
      push edx
        add ebx, 8
        xor edx, edx
        movzx ecx, al
        mov edi, VA_SYSTEM + offset hd_buffer
        call e2_read
      pop edx

      // compare names
      push edx
        movzx ecx, e2_dir.name_len
        mov byte ptr hd_buffer[ecx], 0
        mov esi, VA_SYSTEM + offset hd_buffer
        call fs_cmp
      pop edx
      test al, al
      jz l_e2_rm_name_56
      
    l_e2_rm_name_next:
    mov ebx, e2_ofs
    mov e2_ofs2, ebx
    movzx eax, e2_dir.rec_len
    add e2_ofs, eax
    jmp l_e2_rm_name_5
    
l_e2_rm_name_54:
// not found
mov al, ERC_FILE_NOT_FOUND
jmp l_e2_rm_name_9

l_e2_rm_name_55:
//mov al, ERC_TOO_BIG_HOLE
call e2_reduce_dir
jmp l_e2_rm_name_2

l_e2_rm_name_56:
// found
mov ebx, e2_ofs2
cmp ebx, -1
jnz l_e2_rm_name_561
  mov al, ERC_CANT_REMOVE
  jmp l_e2_rm_name_9
  
l_e2_rm_name_561:
push edx
  xor edx, edx
  mov ecx, 8
  mov edi, VA_SYSTEM + offset e2_dir2
  call e2_read
pop edx

movzx eax, e2_dir.rec_len
movzx ecx, e2_dir2.rec_len
add eax, ecx
cmp eax, 0x10000
jnb l_e2_rm_name_55

mov e2_dir2.rec_len, ax
// end of file?
add eax, e2_ofs2
cmp eax, e2_inode.i_size
jnz l_e2_rm_name_57
  // truncate file
  movzx eax, e2_dir2.name_len
  add eax, 8
  mov e2_dir2.rec_len, ax
  
  add eax, e2_ofs2
  mov ebx, eax
  xor edx, edx
  call e2_delete
  
l_e2_rm_name_57:
// save rec_len2
mov ebx, e2_ofs2
xor edx, edx
mov ecx, 8
mov edi, VA_SYSTEM + offset e2_dir2
call e2_write

l_e2_rm_name_9:
ret

// IN: bl = access rights, e2_inode, e2_ldiskn
// OUT: al = erc
// KEEP: edx
e2_check_access:
test fs_hack, 1
jnz near l_e2_check_access_8

mov esi, p_current
mov cx, e2_inode.i_mode

// system file (only starter)
mov eax, ecx
test ax, EXT2_S_IFSYS
jz l_e2_check_access_1
  mov eax, [es:esi + offset ThreadRec.process]
  cmp eax, VA_PROCS
  jz l_e2_check_access_1
    mov al, ERC_ONLY_STARTER
    jmp l_e2_check_access_9
  
l_e2_check_access_1:

// ugo
mov edi, [es:esi + offset ThreadRec.uid]
and edi, 0xFFFFFF
jz l_e2_check_access_8  // root

movzx eax, e2_inode.i_uid
cmp eax, edi
jnz l_e2_check_access_2
  // user
  shr ecx, 6
  jmp short l_e2_check_access_5

l_e2_check_access_2:
mov edi, [es:esi + offset ThreadRec.gid]
and edi, 0xFFFFFF
movzx eax, e2_inode.i_gid
cmp eax, edi
jnz l_e2_check_access_5
  // group
  shr ecx, 3
  jmp short l_e2_check_access_5

l_e2_check_access_5:
//and cl, 7
and cl, bl
cmp cl, bl
jz l_e2_check_access_8
  mov al, ERC_ACCESS_DENIED
  jmp short l_e2_check_access_9

l_e2_check_access_8:
mov al, 0

l_e2_check_access_9:
ret

e2_init:
mov e2_ldiskn, -1
ret

// IN: es:edx -> filenamez, esi -> files, al = ldiskn || 1, ebx = 0 || dirino
// OUT: al = 0 || erc, esi = fhandle
e2_fopen:
push esi
  call e2_find_file
pop esi
test al, al
jz near l_e2_fopen_2
  cmp al, ERC_FILE_NOT_FOUND
  jnz l_e2_fopen_x
    test files.mode[esi], FOPEN_CREATE
    jnz l_e2_fopen_1
      test files.mode[esi], FOPEN_APPEND
      jnz l_e2_fopen_1
  
  l_e2_fopen_x:
  mov files.mode[esi], 0
  xor esi, esi
  jmp l_e2_fopen_9

l_e2_fopen_01: // rollback name
push eax
  mov edx, e2_nameofs
  call e2_rm_name
pop eax

l_e2_fopen_02:
push eax // rollback inode
  mov ebx, e2_dir2.ino
  call e2_free_inode
pop eax

l_e2_fopen_03:
pop esi
jmp l_e2_fopen_x

l_e2_fopen_1:
// * create file *
push esi
  // check valid chars
  mov edx, e2_nameofs
  call fs_check_valid
  test al, al
  jnz l_e2_fopen_03
  // alloc inode
  call e2_alloc_inode  // out e2_gb, e2_group
  test al, al
  jnz l_e2_fopen_03
  mov e2_dir2.ino, ebx
  // add name to parent
  mov edx, e2_nameofs
  test take_link, 1
  jz l_e2_fopen_11
    mov e2_dir2.file_type, EXT2_FT_SYMLINK
    jmp short l_e2_fopen_12
  
  l_e2_fopen_11:
    mov e2_dir2.file_type, EXT2_FT_REG_FILE
  
  l_e2_fopen_12:
  call e2_add_name  // out e2_inode
  test al, al
  jnz l_e2_fopen_02
  // check access
  mov bl, ACCESS_W
  call e2_check_access
  test al, al
  jnz l_e2_fopen_01
  // zero inode
  mov ebx, e2_dir2.ino
  call e2_load_inode
  xor eax, eax
  mov ecx, sizeof INode / 4
  mov edi, VA_SYSTEM + offset e2_inode
  cld
  rep stosd
  // init inode
  test take_link, 1
  jz l_e2_fopen_13
    mov e2_inode.i_mode, EXT2_S_IFLNK | ACCESS_DEFAULT
    jmp short l_e2_fopen_14
    
  l_e2_fopen_13:
    mov e2_inode.i_mode, EXT2_S_IFREG | ACCESS_DEFAULT
  
  l_e2_fopen_14:
  mov e2_inode.i_links_count, 1  // rfc
  mov esi, p_current
  mov eax, [es:esi + offset ThreadRec.uid]
  mov e2_inode.i_uid, ax
  mov eax, [es:esi + offset ThreadRec.gid]
  mov e2_inode.i_gid, ax
  // time
  call t_getunix
  mov e2_inode.i_ctime, eax
  mov e2_inode.i_atime, eax
  mov e2_inode.i_mtime, eax
  // save inode
  call e2_save_inode
pop esi
mov ebx, e2_dir2.ino
mov files.file[esi], ebx  // ino
jmp short l_e2_fopen_20

l_e2_fopen_2:
// * open file *
mov files.file[esi], ebx  // ino
push esi
  call e2_load_inode
pop esi
test al, al
jnz near l_e2_fopen_x

mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_e2_fopen_20
  push esi
    call t_getunix
    mov e2_inode.i_mtime, eax
    // save inode
    call e2_save_inode
  pop esi
  
l_e2_fopen_20:
// check not share write
mov al, 0
call fs_not_share_write
test al, al
jnz near l_e2_fopen_x
// check not directory
mov ax, e2_inode.i_mode
and ax, 0xE000
cmp ax, EXT2_S_IFDIR
jnz l_e2_fopen_21
  mov al, ERC_FILE_NOT_FOUND
  jmp l_e2_fopen_x
  
l_e2_fopen_21:
// check link  IN: ax
test take_link, 1
jz l_e2_fopen_218
  cmp ax, EXT2_S_IFLNK
  jz l_e2_fopen_218
    mov al, ERC_NOT_A_LINK
    jmp l_e2_fopen_x
  
l_e2_fopen_218:
// check access
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_e2_fopen_22
  mov bl, ACCESS_W | ACCESS_R
  jmp short l_e2_fopen_23

l_e2_fopen_22:
  mov bl, ACCESS_R

l_e2_fopen_23:
push esi
  call e2_check_access
pop esi
test al, al
jnz near l_e2_fopen_x
// link
mov ax, e2_inode.i_mode
and ax, 0xE000
cmp ax, EXT2_S_IFLNK
jnz l_e2_fopen_24
  or files.mode[esi], FOPEN_LINK
  
l_e2_fopen_24:
test files.mode[esi], FOPEN_CREATE
jz l_e2_fopen_31
  // rewrite
  xor edx, edx
  xor ebx, ebx
  push esi
    test files.mode[esi], FOPEN_LINK
    jz l_e2_fopen_25
      cmp e2_inode.i_size, 60
      jb l_e2_fopen_26
      
    l_e2_fopen_25:
    call e2_delete
    
    l_e2_fopen_26:
    xor eax, eax
    mov e2_inode.i_size, eax
    mov e2_inode.i_dir_acl, eax
    call e2_save_inode
  pop esi
  
l_e2_fopen_31:
// load file info
mov al, e2_ldiskn
mov files.disk[esi], al

mov eax, dword ptr e2_inoa[0]
mov edx, dword ptr e2_inoa[4]
mov dword ptr files.sectn[esi], eax
mov dword ptr files.sectn[esi + 4], edx

mov eax, e2_inode.i_size
mov edx, e2_inode.i_dir_acl
mov dword ptr files.size[esi], eax
mov dword ptr files.size[esi + 4], edx

test files.mode[esi], FOPEN_APPEND
jz l_e2_fopen_32
  // append
  mov dword ptr files.pos[esi], eax
  mov dword ptr files.pos[esi + 4], edx  
  jmp short l_e2_fopen_33
  
l_e2_fopen_32:
  // not append
  xor eax, eax
  mov dword ptr files.pos[esi], eax
  mov dword ptr files.pos[esi + 4], eax

l_e2_fopen_33:
shr esi, 5 // assert sizeof OpenFileRec = 32
mov al, 0

l_e2_fopen_9:
ret

// IN: esi = offset to files, es:edi -> data, ecx = size
// OUT: al = 0 || erc, ecx = sizeread
e2_fread:
mov al, files.disk[esi]
cmp al, e2_ldiskn
jz l_e2_fread_1
  push esi
   push edi
    push ecx
     call e2_prepare
    pop ecx
   pop edi
  pop esi
  
l_e2_fread_1:
mov ebx, files.file[esi]
push esi
 push edi
  push ecx
   call e2_load_inode
  pop ecx
 pop edi
pop esi

// link
test files.mode[esi], FOPEN_LINK
jz l_e2_fread_18
  cmp e2_inode.i_size, 60
  jnb l_e2_fread_18
    cmp dword ptr files.pos[esi], 0
    jnz l_e2_fread_16
    
    cmp ecx, 60
    jnb l_e2_fread_17
      
      l_e2_fread_16:
      mov al, ERC_INVALID_LINK
      jmp l_e2_fread_9
      
    l_e2_fread_17:
    push esi
     push edi
      mov esi, offset e2_inode.i_block
      mov ecx, 60 / 4
      cld
      rep movsd
      mov byte ptr [es:edi - 1], 0
     pop edi
    pop esi
    
    xor ecx, ecx
    
    l_e2_fread_175:
      cmp byte ptr [es:edi + ecx], 0
      jz l_e2_fread_8
        inc ecx
        jmp short l_e2_fread_175
    
l_e2_fread_18:
// check not after eof
push edi
  mov ebx, dword ptr files.pos[esi]
  mov edx, dword ptr files.pos[esi + 4]
  
  mov edi, dword ptr files.size[esi + 4]
  mov eax, dword ptr files.size[esi]
  sub edi, edx
  sbb eax, ebx  // edi:eax = size - pos
  cmp edi, 0
  jnz l_e2_fread_2
    cmp eax, ecx
    jnb l_e2_fread_2
      mov ecx, eax
      
  l_e2_fread_2:
pop edi

push ecx
 push esi
  call e2_read
 pop esi
pop ecx
test al, al
jnz l_e2_fread_9

  l_e2_fread_8:
  mov ebx, dword ptr files.pos[esi]
  mov edx, dword ptr files.pos[esi + 4]
  add ebx, ecx
  adc edx, 0
  mov dword ptr files.pos[esi], ebx
  mov dword ptr files.pos[esi + 4], edx
  
  mov al, 0
  
l_e2_fread_9:
ret

l_e2_fwrite_x:
mov al, ERC_READ_ONLY
ret

// IN: esi = offset to files, es:edi -> data, ecx = size
// OUT: al = 0 || erc, ecx = sizewrite
e2_fwrite:
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_e2_fwrite_x

mov al, files.disk[esi]
cmp al, e2_ldiskn
jz l_e2_fwrite_1
  push esi
   push edi
    push ecx
     call e2_prepare
    pop ecx
   pop edi
  pop esi
  
l_e2_fwrite_1:
mov ebx, files.file[esi]
push esi
 push edi
  push ecx
    call e2_load_inode
  pop ecx
 pop edi
pop esi

// link
test files.mode[esi], FOPEN_LINK
jz l_e2_fwrite_18
  cmp dword ptr files.pos[esi], 0
  jz l_e2_fwrite_17
    
    l_e2_fwrite_16:
    mov al, ERC_INVALID_LINK
    jmp l_e2_fwrite_9
    
  l_e2_fwrite_17:
  cmp ecx, 60
  jnb l_e2_fwrite_177
    // ecx < 60
    push esi
     push edi
      push ecx
       push ds
        push es
        pop ds
        mov esi, edi
        mov edi, VA_SYSTEM + offset e2_inode.i_block
        cld
        rep movsb
        mov al, 0
        stosb
       pop ds
      pop ecx
     pop edi
    pop esi
    add dword ptr files.pos[esi], ecx
    mov dword ptr files.size[esi], ecx
    jmp l_e2_fwrite_88
    
  l_e2_fwrite_177:
  // ecx >= 60
  cmp e2_inode.i_size, 60
  jnb l_e2_fwrite_18
    // fsize < 60
    push edi
     push ecx
      xor eax, eax
      mov edi, VA_SYSTEM + offset e2_inode.i_block
      mov ecx, 60 / 4
      cld
      rep stosd
     pop ecx
    pop edi
    
l_e2_fwrite_18:
// write
mov ebx, dword ptr files.pos[esi]
mov edx, dword ptr files.pos[esi + 4]
push ecx
 push esi
  call e2_write
 pop esi
pop ecx
test al, al
jnz l_e2_fwrite_9
  mov ebx, dword ptr files.pos[esi]
  mov edx, dword ptr files.pos[esi + 4]
  add ebx, ecx
  adc edx, 0
  
  cmp edx, dword ptr files.size[esi + 4]
  jnz l_e2_fwrite_7
    cmp ebx, dword ptr files.size[esi]
    
  l_e2_fwrite_7:
  jna l_e2_fwrite_8
    // pos > size
    mov dword ptr files.size[esi], ebx
    mov dword ptr files.size[esi + 4], edx
    // save fsize
    mov e2_inode.i_size, ebx
    mov e2_inode.i_dir_acl, edx
    
  l_e2_fwrite_8:
  mov dword ptr files.pos[esi], ebx
  mov dword ptr files.pos[esi + 4], edx
  
  l_e2_fwrite_88:
  // save inode
  push ecx
    call e2_save_inode
  pop ecx
  
l_e2_fwrite_9:
ret

// IN: esi = offset to files, edx:ebx = file offset
e2_fsetpos:
cmp edx, dword ptr files.size[esi + 4]
jnz l_e2_fsetpos_1
  cmp ebx, dword ptr files.size[esi]
  
l_e2_fsetpos_1:
jna l_e2_fsetpos_2
  // pos > size
  mov ebx, dword ptr files.size[esi]
  mov edx, dword ptr files.size[esi + 4]
  
l_e2_fsetpos_2:
mov dword ptr files.pos[esi], ebx
mov dword ptr files.pos[esi + 4], edx
mov al, 0
ret

l_e2_fcut_x:
mov al, ERC_READ_ONLY
ret

// IN: esi -> files
e2_fcut:
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_e2_fcut_x

mov al, files.disk[esi]
cmp al, e2_ldiskn
jz l_e2_fcut_1
  push esi
    call e2_prepare
  pop esi
  
l_e2_fcut_1:
mov ebx, files.file[esi]
push esi
  call e2_load_inode
pop esi

mov ebx, dword ptr files.pos[esi]
mov edx, dword ptr files.pos[esi + 4]
push esi
  call e2_delete
pop esi
test al, al
jnz l_e2_fcut_9
  mov ebx, dword ptr files.pos[esi]
  mov edx, dword ptr files.pos[esi + 4]
  mov dword ptr files.size[esi], ebx
  mov dword ptr files.size[esi + 4], edx
  mov e2_inode.i_size, eax
  mov e2_inode.i_dir_acl, edx
  call e2_save_inode
  
l_e2_fcut_9:
ret

// IN: esi = offset to files
e2_fclose:
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jz l_e2_fclose_98
  mov al, files.disk[esi]
  cmp al, e2_ldiskn
  jz l_e2_fclose_1
    push esi
      call e2_prepare
    pop esi
    
  l_e2_fclose_1:
  mov ebx, files.file[esi]
  push esi
    call e2_load_inode
  pop esi
  mov eax, dword ptr files.size[esi]
  mov edx, dword ptr files.size[esi + 4]
  mov e2_inode.i_size, eax
  mov e2_inode.i_dir_acl, edx
  push esi
    // time
    call t_getunix
    mov e2_inode.i_atime, eax
    // save
    call e2_save_inode
  pop esi
  
l_e2_fclose_8:
mov files.mode[esi], 0
ret

l_e2_fclose_98:
mov al, 0
jmp l_e2_fclose_8

// IN: es:edx -> path & dirname, al = ldiskn, ebx = dir ino
// OUT: al = 0 || erc
// USES: fd_buffer
e2_md:
call e2_find_file  // OUT e2_parentino, e2_nameofs
cmp al, ERC_FILE_NOT_FOUND
jz l_e2_md_2
  cmp al, 0
  jnz near l_e2_md_9
    mov al, ERC_DIR_ALREADY_EXISTS
    jmp l_e2_md_9
  
l_e2_md_2:
// check valid chars
mov edx, e2_nameofs
call fs_check_valid
test al, al
jnz near l_e2_md_9
// alloc inode
call e2_alloc_inode  // out e2_gb, e2_group
mov esi, e2_group
mov e2_group1, esi
test al, al
jnz near l_e2_md_9
  mov e2_dir2.ino, ebx
  // set bg_used_dirs_count
  inc e2_gb.bg_used_dirs_count
  mov ebx, e2_group1
  call e2_save_group_and_super
  // add name to parent
  mov edx, e2_nameofs
  mov e2_dir2.file_type, EXT2_FT_DIR
  call e2_add_name  // out e2_inode
  test al, al
  jnz near l_e2_md_82
    // check access
    mov bl, ACCESS_W
    call e2_check_access
    test al, al
    jnz near l_e2_md_81
    // zero inode
    mov ebx, e2_dir2.ino
    call e2_load_inode
    xor eax, eax
    movzx ecx, e2_sb.s_inode_size
    shr ecx, 2
    mov edi, VA_SYSTEM + offset e2_inode
    cld
    rep stosd
    // init inode
    mov e2_inode.i_mode, EXT2_S_IFDIR | ACCESS_DEFAULT
    mov e2_inode.i_links_count, 1  // rfc
    mov esi, p_current
    mov eax, [es:esi + offset ThreadRec.uid]
    mov e2_inode.i_uid, ax
    mov eax, [es:esi + offset ThreadRec.gid]
    mov e2_inode.i_gid, ax
    // time
    call t_getunix
    mov e2_inode.i_ctime, eax
    mov e2_inode.i_atime, eax
    mov e2_inode.i_mtime, eax
    // write . ..
    mov eax, e2_dir2.ino
    mov dword ptr fd_buffer[0], eax
    mov word ptr fd_buffer[4], 9  // rec len
    mov fd_buffer[6], 1  // name len
    mov fd_buffer[7], EXT2_FT_DIR
    mov fd_buffer[8], "."
    
    mov eax, e2_parentino
    mov dword ptr fd_buffer[9+0], eax
    mov word ptr fd_buffer[9+4], 10  // rec len
    mov fd_buffer[9+6], 2  // name len
    mov fd_buffer[9+7], EXT2_FT_DIR
    mov word ptr fd_buffer[9+8], ".."
    
    mov ecx, 19  // 9 + 10
    mov e2_inode.i_size, ecx
    xor ebx, ebx
    xor edx, edx
    mov edi, VA_SYSTEM + offset fd_buffer
    call e2_write
    test al, al
    jnz l_e2_md_81
      // save inode
      call e2_save_inode
      test al, al
      jz l_e2_md_9
    
l_e2_md_81: // rollback name
push eax
  mov edx, e2_nameofs
  call e2_rm_name
pop eax

l_e2_md_82: // rollback inode, bg_used_dirs_count
push eax
  mov ebx, e2_dir2.ino
  call e2_free_inode

  mov ebx, e2_group1
  call e2_load_group
  dec e2_gb.bg_used_dirs_count
  mov ebx, e2_group1
  call e2_save_group_and_super
pop eax
  
l_e2_md_9:
ret

// IN: al = ldiskn, es:edx -> path
e2_cd:
xor ebx, ebx
call e2_find_file
or al, al
jnz l_e2_cd_9
  
  mov edx, p_current
  mov al, e2_ldiskn
  mov [es:edx + offset ThreadRec.curdisk], al
  mov [es:edx + offset ThreadRec.curdir], ebx
  mov al, 0
  
l_e2_cd_9:
ret

// IN: es:edx -> path/name, al = ldiskn, ebx = dir ino
// OUT: al = 0 || erc
e2_rm:
call e2_find_file  // out e2_parentino, e2_nameofs
test al, al
jnz near l_e2_rm_9
 
 mov al, e2_ldiskn
 call fs_not_used  // keep all but ecx
 test cl, cl
 jz l_e2_rm_02
   mov al, cl
   jmp l_e2_rm_9
  
 l_e2_rm_02:
  mov e2_fileino, ebx
  // check file access
  call e2_load_inode
  mov bl, ACCESS_W
  call e2_check_access
  test al, al
  jnz near l_e2_rm_9
  // file, dir or symlink?
  mov e2_isdir, 0
  mov e2_islink, 0
  mov ax, e2_inode.i_mode
  and ax, 0xE000
  cmp ax, EXT2_S_IFLNK
  jnz l_e2_rm_03
    // symlink
    mov e2_islink, 1
    
  l_e2_rm_03:
  cmp ax, EXT2_S_IFDIR
  jnz l_e2_rm_1
    // dir
    mov e2_isdir, 1
    // . ..
    mov edx, e2_nameofs
    mov ax, [es:edx]
    cmp ax, 2Eh
    jz l_e2_rm_06
      mov eax, [es:edx]
      and eax, 0xFFFFFF
      cmp eax, 2E2Eh
      jz l_e2_rm_06
        // dir not empty
        cmp e2_inode.i_size, 24  // 12 + 12 || 9 + 10
        jna l_e2_rm_1
          call e2_reduce_dir
          call e2_save_inode
          cmp e2_inode.i_size, 24  // 12 + 12 || 9 + 10
          jna l_e2_rm_1
            mov al, ERC_DIR_NOT_EMPTY
            jmp l_e2_rm_9
          
    l_e2_rm_06:
    mov al, ERC_CANT_REMOVE
    jmp l_e2_rm_9
    
  l_e2_rm_1:
  // used_dirs_count
  test e2_isdir, 1
  jz l_e2_rm_2
    dec e2_gb.bg_used_dirs_count
    mov ebx, e2_group
    call e2_save_group_and_super
    
  l_e2_rm_2:
  // check dir access
  mov ebx, e2_parentino
  call e2_load_inode
  mov bl, ACCESS_W
  call e2_check_access
  test al, al
  jnz near l_e2_rm_9
  // time
  call t_getunix
  mov e2_inode.i_mtime, eax
  call e2_save_inode
  // remove file name
  mov edx, e2_nameofs
  call e2_rm_name
  test al, al
  jnz l_e2_rm_9
  // dec hardlinks
  mov ebx, e2_fileino
  call e2_load_inode
  dec e2_inode.i_links_count
  cmp e2_inode.i_links_count, 0
  jz l_e2_rm_3
    call e2_save_inode
    jmp l_e2_rm_9
    
  l_e2_rm_3:
  // delete file content, also dir
  test e2_islink, 1
  jz l_e2_rm_4
    // link
    cmp e2_inode.i_size, 60
    jb l_e2_rm_6
    
  l_e2_rm_4:
  xor edx, edx
  xor ebx, ebx
  call e2_delete

  l_e2_rm_6:
  // save
  call e2_save_inode  
  // free inode
  mov ebx, e2_fileino
  call e2_free_inode
  
l_e2_rm_9:
ret

// IN: es:edx -> filename, al = ldiskn, ebx = dir cluster, es:esi -> new filename
// OUT: al = erc
e2_rename:
push esi
  call e2_find_file
pop esi
test al, al
jnz near l_e2_rename_9

// check .
mov al, ERC_CANT_RENAME
mov ebx, e2_nameofs
cmp byte ptr [es:ebx], '.'
jz l_e2_rename_9

// check valid chars
mov edx, esi
call fs_check_valid  // keep esi
test al, al
jnz l_e2_rename_9

// check access
push esi
  mov ebx, e2_parentino
  call e2_load_inode
  mov bl, ACCESS_W
  call e2_check_access
pop esi
test al, al
jnz l_e2_rename_9

// remove name
mov edx, e2_nameofs
push esi
  call e2_rm_name
pop edx
test al, al
jnz l_e2_rename_9

// set e2_dir2, add name
mov eax, e2_dir.ino
mov e2_dir2.ino, eax
mov al, e2_dir.file_type
mov e2_dir2.file_type, al
call e2_add_name
test al, al
jnz l_e2_rename_81

// time
call t_getunix
mov e2_inode.i_mtime, eax

// save
call e2_save_inode
mov al, 0
jmp short l_e2_rename_9


l_e2_rename_81:
push eax
  mov edx, e2_nameofs
  call e2_add_name
  call e2_save_inode
pop eax

l_e2_rename_9:
ret

// IN: es:edx -> filename, al = ldiskn, ebx = dir cluster, es:esi -> new path
// OUT: al = erc
e2_move:
push esi
  call e2_find_file
pop esi
test al, al
jnz near l_e2_move_9

// copy file name
mov edx, e2_nameofs
mov edi, VA_SYSTEM + offset e2_name2
mov ecx, MAX_PATH - 1

l_e2_move_1:
  mov al, [es:edx]
  inc edx
  stosb
  cmp al, 0
  jz l_e2_move_19
    loop l_e2_move_1
      mov al, ERC_TOO_LONG
      jmp l_e2_move_9

l_e2_move_19:
// check . ..
mov al, ERC_CANT_MOVE
cmp word ptr e2_name2, '.'
jz near l_e2_move_9
cmp word ptr e2_name2, '..'
jz near l_e2_move_9

// check write access
mov al, e2_ldiskn
mov e2_ldiskn2, al  // e2_ldiskn2
mov ebx, e2_parentino
mov e2_parentino2, ebx  // parentino2
push esi
  call e2_load_inode
  mov bl, ACCESS_W
  call e2_check_access
pop esi
test al, al
jnz near l_e2_move_9

// new dir
mov edx, esi

l_e2_move_2:
  // get disk from path/cd
  call fs_disk  // IN/OUT edx
  cmp byte ptr [es:edx], 0
  jnz l_e2_move_206
    mov e2_ldiskn, al
    test ebx, ebx
    jnz l_e2_move_21
      mov ebx, EXT2_ROOT_INO
      jmp short l_e2_move_21
    
  l_e2_move_206:
  // get dir
  call e2_find_file  // out ebx
  cmp al, ERC_LINK
  jz l_e2_move_2

test al, al
jnz near l_e2_move_9

l_e2_move_21:
// on the same disk
mov al, e2_ldiskn
cmp al, e2_ldiskn2
jz l_e2_move_22
  mov ah, e2_ldiskn2  // !!!
  mov al, ERC_OUT_OF_DISK
  jmp l_e2_move_9
  
l_e2_move_22:
// check directory, write access
mov e2_parentino, ebx
call e2_load_inode
mov ax, e2_inode.i_mode
test ax, EXT2_S_IFDIR
jnz l_e2_move_23
  mov al, ERC_PATH_NOT_FOUND
  jmp l_e2_move_9
  
l_e2_move_23:
mov bl, ACCESS_W
call e2_check_access
test al, al
jnz near l_e2_move_9

// remove
mov ebx, e2_parentino2
mov eax, e2_parentino
mov e2_parentino, ebx
mov e2_parentino2, eax
mov edx, VA_SYSTEM + offset e2_name2
call e2_rm_name
test al, al
jnz l_e2_move_9

// time
call t_getunix
mov e2_inode.i_mtime, eax

// save
call e2_save_inode

// add name
mov ebx, e2_parentino2
mov eax, e2_parentino
mov e2_parentino, ebx
mov e2_parentino2, eax
mov edx, VA_SYSTEM + offset e2_name2

mov eax, e2_dir.ino
mov e2_dir2.ino, eax
mov al, e2_dir.file_type
mov e2_dir2.file_type, al

call e2_add_name
test al, al
jnz l_e2_move_81

// time
call t_getunix
mov e2_inode.i_mtime, eax

// save
call e2_save_inode
jmp short l_e2_move_9


l_e2_move_81:  // rollback name  IN: e2_dir2
push eax
  mov ebx, e2_parentino2
  mov eax, e2_parentino
  mov e2_parentino, ebx
  mov e2_parentino2, eax
  mov edx, VA_SYSTEM + offset e2_name2
  call e2_add_name
pop eax

l_e2_move_9:
ret

// IN: al = ldiskn, ebx = dir, es:edx -> dir(mask)
//     fs_rec, fs_srchofs, fs_dosplit
e2_find_first:
cmp al, e2_ldiskn
jz l_e2_find_first_01
  push edx
   push ebx
    call e2_prepare
   pop ebx
  pop edx
  test al, al
  jnz near l_e2_find_first_9

l_e2_find_first_01:
test fs_dosplit, 1
jz l_e2_find_first_2
  call fs_split  // KEEP ebx
  test al, al
  jnz l_e2_find_first_9
  
l_e2_find_first_2:
// Find dir  IN: ebx
cmp byte ptr [es:edx], 0
jnz l_e2_find_first_3
  
  // no path
  test ebx, ebx
  jnz l_e2_find_first_4
    // root
    mov ebx, EXT2_ROOT_INO
    jmp short l_e2_find_first_4
  
l_e2_find_first_3:
  mov al, e2_ldiskn
  
  call e2_find_file
  
  cmp al, ERC_FILE_NOT_FOUND
  jnz l_e2_find_first_33
    mov al, ERC_PATH_NOT_FOUND
    
  l_e2_find_first_33:
  cmp al, ERC_LINK
  jz l_e2_find_first_99
  
  test al, al
  jnz l_e2_find_first_9
  
l_e2_find_first_4:
call e2_load_inode
test al, al
jnz l_e2_find_first_9

mov esi, fs_srchofs
mov eax, dword ptr e2_inoa[0]
mov ecx, dword ptr e2_inoa[4]
mov dword ptr srch.Cluster[esi], eax
mov dword ptr srch.Cluster[esi + 4], ecx
mov ecx, e2_inode.i_size
mov ebx, e2_inon
xor eax, eax
mov srch.Size[esi], ecx
mov srch.File[esi], ebx
mov srch.Offset[esi], eax

call e2_find_next

test al, al
jz l_e2_find_first_99

l_e2_find_first_9:
mov esi, fs_srchofs
mov word ptr srch.ThreadId[esi], -1

l_e2_find_first_99:
ret

// IN: fs_rec, fs_srchofs, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = 0 || erc
// USES: fd_buffer
e2_find_next:
mov esi, fs_srchofs
mov al, srch.Disk[esi]
cmp al, e2_ldiskn
jz l_e2_find_next_1
  push esi
    call e2_prepare
  pop esi
  
l_e2_find_next_1:
// load inode
mov ebx, dword ptr srch.Cluster[esi + 0]
mov edx, dword ptr srch.Cluster[esi + 4]
mov ecx, sizeof INode
mov edi, VA_SYSTEM + offset e2_inode
mov ah, 2  // read
mov al, e2_ldiskn
call e2_diskmain

l_e2_find_next_5:
// load fname
mov esi, fs_srchofs
mov ebx, srch.Offset[esi]
cmp ebx, srch.Size[esi]
jnb near l_e2_find_next_7

xor edx, edx
mov ecx, 8
mov edi, VA_SYSTEM + offset fd_buffer
push ebx
  call e2_read
pop ebx

xor edx, edx
add ebx, 8
movzx ecx, byte ptr fd_buffer[6]  // name_len
mov edi, VA_SYSTEM + offset fd_buffer + 8
call e2_read

mov esi, fs_srchofs  // esi = fs_srchofs
movzx eax, word ptr fd_buffer[4]  // rec_len
test eax, eax
jz near l_e2_find_next_6

add srch.Offset[esi], eax  // Offset + rec_len

// IsMatch?
movzx ecx, byte ptr fd_buffer[6]  // name_len
jecxz l_e2_find_next_5  // loop 5

add esi, offset srch.FileMask
mov edi, offset fd_buffer + 8

mov byte ptr fd_buffer[ecx + 8], 0  // fd_buffer[name_len + 8] = 0
call fs_ismatch
test al, al

jnz near l_e2_find_next_5  // loop 5


// * Found - copy to fs_rec *

// File name
mov esi, offset fd_buffer + 8
mov edi, fs_rec
add edi, offset SearchRec.FileName
movzx ecx, byte ptr fd_buffer[6] // name_len
inc ecx
rep movsb

// init fs_rec
mov edi, fs_rec
xor eax, eax
push edi
  mov ecx, 7
  rep stosd
pop edi

// inon
mov ebx, dword ptr fd_buffer[0]

// Link
cmp byte ptr fd_buffer[7], EXT2_FT_SYMLINK
jnz near l_e2_find_next_528
  or dword ptr [es:edi + offset SearchRec.FileAttributes], FILE_ATTRIBUTE_LINK
  mov eax, fs_srchofs
  mov eax, srch.File[eax]
  mov e2_parentino, eax
  xor eax, eax
  mov e2_tmp, eax
  mov edx, VA_SYSTEM + offset e2_tmp
  call e2_follow_link
  test al, al
  jz l_e2_find_next_526
    cmp al, ERC_LINK
    jnz near l_e2_find_next_9
      
      // * differrent disk *
      
      l_e2_find_next_51:
      // get disk from path/cd
      call fs_disk  // KEEP ecx, esi, edi
      
      // fsid
      push eax
      movzx edi, al
      shl edi, 5  // assert sizeof DiskInfoRec = 32
      mov al, disk_info.fsid[edi]
      or al, al
      jnz l_e2_find_next_520
        pop eax
        push eax
        call fs_load_fsid  // KEEP edx, ebx, esi, edi
        
      l_e2_find_next_520:
      cmp al, FSID_EXT2
      jnz l_e2_find_next_521
        pop eax
        call e2_find_file
        jmp short l_e2_find_next_528
        
      l_e2_find_next_521:
      cmp al, FSID_NTFS
      jnz l_e2_find_next_522
        pop eax
        //... NTFS_fopen
        mov al, ERC_NOT_IMPLEMENTED
        jmp l_e2_find_next_527
        
      l_e2_find_next_522:
      cmp al, FSID_FAT12
      jnz l_e2_find_next_523
        // FAT12
        pop eax
        mov al, ERC_NOT_IMPLEMENTED
        jmp l_e2_find_next_527
        
      l_e2_find_next_523:
      cmp al, FSID_CD
      jnz l_e2_find_next_524
        // CD
        pop eax
        mov al, ERC_NOT_IMPLEMENTED
        jmp l_e2_find_next_527
        
      l_e2_find_next_524:
      pop eax
      mov al, ERC_UNKNOWN_FILESYSTEM
      jmp l_e2_find_next_527
      
  l_e2_find_next_525:
  cmp al, ERC_LINK
  jz near l_e2_find_next_51
    test al, al
    jz l_e2_find_next_528
      jmp l_e2_find_next_527
  
  l_e2_find_next_526:
  // same disk
  mov take_link, 0
  mov al, e2_ldiskn
  call e2_find_file
  test al, al
  jz l_e2_find_next_528
    
    l_e2_find_next_527:
    xor eax, eax
    mov edi, VA_SYSTEM + offset e2_inode
    mov ecx, sizeof INode / 4
    cld
    rep stosd
    jmp short l_e2_find_next_529
  
l_e2_find_next_528:
call e2_load_inode

l_e2_find_next_529:
mov edi, fs_rec

// time
mov eax, e2_inode.i_ctime
call t_unix2ftime
mov [es:edi + offset SearchRec.CreationTime], eax
mov [es:edi + offset SearchRec.CreationTime + 4], edx
mov eax, e2_inode.i_atime
call t_unix2ftime
mov [es:edi + offset SearchRec.LastAccessTime], eax
mov [es:edi + offset SearchRec.LastAccessTime + 4], edx
mov eax, e2_inode.i_mtime
call t_unix2ftime
mov [es:edi + offset SearchRec.LastWriteTime], eax
mov [es:edi + offset SearchRec.LastWriteTime + 4], edx

// File size
mov ecx, e2_inode.i_size
mov [es:edi + offset SearchRec.FileSize], ecx
mov edx, e2_inode.i_dir_acl
mov [es:edi + offset SearchRec.FileSize + 4], edx

// File attributes
mov eax, FILE_ATTRIBUTE_LINUX
test e2_inode.i_mode, EXT2_S_IFDIR  // directory
jz l_e2_find_next_56
  or al, FILE_ATTRIBUTE_DIRECTORY
  
l_e2_find_next_56:
movzx edx, word ptr e2_inode.i_mode
shl edx, 8
or eax, edx  // fa += i_mode << 8

test edx, EXT2_S_IFSYS << 8
jz l_e2_find_next_57
  or al, FILE_ATTRIBUTE_SYSTEM  // ((imode >> 8) & 0E0h) = 80h => system file
  
l_e2_find_next_57:
or [es:edi + offset SearchRec.FileAttributes], eax

mov al, 0
jmp short l_e2_find_next_9

l_e2_find_next_6:
mov al, ERC_FS
jmp short l_e2_find_next_9

l_e2_find_next_7:
mov al, 1

l_e2_find_next_9:
ret

// IN: edx -> filename, esi = new atribs (<<8)
// OUT: al = erc
e2_chmod:
push esi
  call e2_find_file
pop edx
test al, al
jnz near l_e2_chmod_9
  push edx
    call e2_load_inode
  pop edx
  test al, al
  jnz l_e2_chmod_9
  // chk access
  mov eax, p_current
  mov edi, [es:eax + offset ThreadRec.uid]
  and edi, 0xFFFFFF  // root
  jz l_e2_chmod_0
    //mov al, e2_ldiskn
    //shl eax, 24
    movzx eax, e2_inode.i_uid
    cmp eax, edi
    jz l_e2_chmod_0
      mov al, ERC_ACCESS_DENIED
      jmp short l_e2_chmod_9
      
  l_e2_chmod_0:
  // atribs
  shr edx, 8
  mov ax, e2_inode.i_mode
  
  mov cx, ax
  and cx, EXT2_S_IFSYS
  mov bx, dx
  and bx, EXT2_S_IFSYS
  xor cx, bx
  jz l_e2_chmod_2
    push eax
      call s_chkstarter
    pop eax
    jz l_e2_chmod_1
      mov al, ERC_ONLY_STARTER
      jmp short l_e2_chmod_9
    
    l_e2_chmod_1:
    and ax, 0xFE00 - EXT2_S_IFSYS
    and dx, 0x01FF + EXT2_S_IFSYS
    jmp short l_e2_chmod_3
    
  l_e2_chmod_2:
  and ax, 0xFE00
  and dx, 0x01FF
  
  l_e2_chmod_3:
  or ax, dx
  mov e2_inode.i_mode, ax
  call e2_save_inode

l_e2_chmod_9:
ret

// IN: esi = offset to files
// OUT: al = erc, edx:ecx = ftime
e2_get_mtime:
mov al, files.disk[esi]
cmp al, e2_ldiskn
jz l_e2_get_mtime_2
  push esi
    call e2_prepare
  pop esi

l_e2_get_mtime_2:
mov ebx, files.file[esi]
call e2_load_inode
mov eax, e2_inode.i_mtime
call t_unix2ftime
xchg eax, ecx
mov al, 0
ret

// IN: esi = offset to files, edx:ecx = ftime
// OUT: al = erc
e2_set_mtime:
mov al, files.mode[esi]
and al, 3Fh
cmp al, FOPEN_READ
jnz l_e2_set_mtime_1
  mov al, ERC_READ_ONLY
  jmp short l_e2_set_mtime_9

l_e2_set_mtime_1:
mov dword ptr fs_ftime[0], ecx
mov dword ptr fs_ftime[4], edx
mov al, files.disk[esi]
cmp al, e2_ldiskn
jz l_e2_set_mtime_2
  push esi
    call e2_prepare
  pop esi

l_e2_set_mtime_2:
mov ebx, files.file[esi]
call e2_load_inode
mov eax, dword ptr fs_ftime[0]
mov edx, dword ptr fs_ftime[4]
call t_ftime2unix
mov e2_inode.i_mtime, eax
call e2_save_inode

l_e2_set_mtime_9:
ret

// IN: al = ldiskn
e2_backup:
cmp al, e2_ldiskn
jz l_e2_backup_1
  call e2_prepare
  
l_e2_backup_1:
movzx esi, e2_ldiskn
shl esi, 5  // assert sizeof DiskInfoRec = 32
test byte ptr disk_info.flags[esi], DISK_FLAGS_DIRTY
jnz l_e2_backup_2
  mov al, 0
  ret
  
l_e2_backup_2:
cmp disk_info.fsid[esi], FSID_EXT2
jz l_e2_backup_3
  mov al, ERC_FS
  ret
  
l_e2_backup_x:
mov al, ERC_FS
ret

l_e2_backup_3:
and byte ptr disk_info.flags[esi], -1 - DISK_FLAGS_DIRTY

// calc groups
mov eax, e2_sb.s_blocks_count
dec eax
dec eax
xor edx, edx
mov ecx, e2_sb.s_blocks_per_group
jecxz l_e2_backup_x

div ecx
inc eax
mov e2_groups, eax

// calc gblocks
mov eax, e2_groups
shl eax, 5  // assert sizeof GroupBlock = 32
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
mov edx, 1
shl edx, cl
dec edx
add eax, edx
shr eax, cl
mov e2_gblocks, eax

// foreach block
xor ebx, ebx
inc ebx

l_e2_backup_5:
  cmp ebx, e2_groups
  jnb near l_e2_backup_6
    mov e2_group0, ebx
    call e2_load_group
    // eax = first block in group
    mov eax, e2_group
    mov ecx, e2_sb.s_blocks_per_group
    mul ecx
    inc eax
    
    mov ebx, eax
    inc eax // sb
    add eax, e2_gblocks
    cmp eax, e2_gb.bg_block_bitmap
    ja near l_e2_backup_58
      // * space for backup copies at block ebx *
      // super block
      mov eax, e2_group0
      mov e2_sb.s_block_group_nr, ax
      mov cl, byte ptr e2_sb.s_log_block_size
      add cl, 10
      mov edx, ebx
      shl ebx, cl
      xor cl, 31
      inc cl
      shr edx, cl
      mov ecx, sizeof SuperBlock
      mov edi, VA_SYSTEM + offset e2_sb
      mov ah, 3  // write
      mov al, e2_ldiskn
      push edx
       push ebx
        call e2_diskmain
       pop ebx
      pop edx
      mov ecx, e2_sb.s_log_block_size
      mov eax, 1024
      shl eax, cl
      add ebx, eax  // ebx += block
      adc edx, 0
      // group blocks
      cmp cl, 0
      jnz l_e2_backup_52
        // 1024
        mov eax, 2048
        
      l_e2_backup_52:
      mov e2_ofs, eax
      
      inc ecx
      mov eax, e2_gblocks
      shl eax, cl
      xchg eax, ecx  // ecx = e2_gblocks << (log2 + 1)
      
      l_e2_backup_55:
        push edx
         push ebx
          push ecx
            xor edx, edx
            mov ebx, e2_ofs
            mov ecx, 512
            mov edi, VA_SYSTEM + offset hd_buffer
            mov ah, 2  // read
            mov al, e2_ldiskn
            call e2_diskmain
          pop ecx
         pop ebx
        pop edx
        add e2_ofs, 512
        push edx
         push ebx
          push ecx
            mov ecx, 512
            mov edi, VA_SYSTEM + offset hd_buffer
            mov ah, 3  // write
            mov al, e2_ldiskn
            call e2_diskmain
          pop ecx
         pop ebx
        pop edx
        add ebx, 512
        adc edx, 0
        loop l_e2_backup_55
      
    l_e2_backup_58:
    mov ebx, e2_group0
    inc ebx
    jmp l_e2_backup_5
  
l_e2_backup_6:
ret

// IN: al = ldiskn
// OUT: al = erc, edx:ecx = free bytes
e2_diskfree:
cmp al, e2_ldiskn
jz l_e2_diskfree_1
  call e2_prepare
  
l_e2_diskfree_1:
mov eax, e2_sb.s_free_blocks_count
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
mov edx, eax
shl eax, cl
xor cl, 31
inc cl
shr edx, cl
xchg eax, ecx
mov al, 0
ret

RESERVED_INODES = EXT2_FIRST_INO - 1
LOG_INODES = 10 + 2

// IN: al = ldiskn, edi = logblocksize (0..3)
e2_format:
and al, 31
mov fs_ldiskn_format, al

// diskmain
movzx esi, al
shl esi, 5  // log2(DiskInfoRec)
mov esi, disk_info.main[esi]
or esi, esi
jnz l_e2_format_0
  mov al, ERC_INVALID_DISK_NUMBER
  ret

l_e2_format_0:
mov fs_diskmain_format, esi

cmp edi, 4
jb l_e2_format_1
  mov al, ERC_INVALID_VALUE
  ret
  
l_e2_format_1:
add edi, 10

// disk size
push edi
  mov ah, 4
  mov al, fs_ldiskn_format
  call fs_diskmain_format
  mov dword ptr e2_disksize[0], eax
  mov dword ptr e2_disksize[4], edx
pop edi

// super block
mov eax, dword ptr e2_disksize[0]
mov edx, dword ptr e2_disksize[4]
shr eax, LOG_INODES
mov ebx, edx
shr edx, LOG_INODES
shl ebx, 32 - LOG_INODES
or eax, ebx
mov e2_sb.s_inodes_count, eax

l_e2_format_10:
mov ecx, edi
mov ebx, 1
shl ebx, cl
mov eax, dword ptr e2_disksize[4]
xor edx, edx
div ebx
test eax, eax
jz l_e2_format_11
  inc edi
  cmp edi, 3
  jna l_e2_format_10
    dec edi
    mov eax, -1
    jmp short l_e2_format_12

l_e2_format_11:
mov eax, dword ptr e2_disksize[0]
div ebx  // assert blocks_count < 4 Gi

l_e2_format_12:
mov e2_sb.s_blocks_count, eax

mov e2_sb.s_r_blocks_count, 0
mov ecx, edi
sub cl, 10
jecxz l_e2_format_21
  mov e2_sb.s_first_data_block, 0 // 1024 1, else 0
  jmp short l_e2_format_22
  
l_e2_format_21:
  mov e2_sb.s_first_data_block, 1 // 1024 1, else 0

l_e2_format_22:
mov e2_sb.s_log_block_size, ecx
mov e2_sb.s_log_frag_size, ecx
mov ebx, 1
add cl, 10 + 3 // 8192 * block_size
shl ebx, cl
mov e2_sb.s_blocks_per_group, ebx
mov e2_sb.s_frags_per_group, ebx
mov e2_sb.s_inode_size, 128

// calc groups
mov eax, e2_sb.s_blocks_count
dec eax
dec eax
xor edx, edx
div e2_sb.s_blocks_per_group
inc eax
mov e2_groups, eax

// calc gblocks
mov eax, e2_groups
shl eax, 5  // assert sizeof GroupBlock = 32
mov ecx, edi
mov ebx, 1
shl ebx, cl
dec ebx  // ebx = block_size - 1
add eax, ebx
shr eax, cl
mov e2_gblocks, eax

// calc inodes per group, free inodes
mov eax, e2_sb.s_inodes_count
xor edx, edx
div e2_groups
shl eax, 7  // log s_inode_size
dec eax
or eax, ebx
inc eax
shr eax, 7  // log s_inode_size
mov e2_sb.s_inodes_per_group, eax
mul e2_groups
mov e2_sb.s_inodes_count, eax
sub eax, RESERVED_INODES
mov e2_sb.s_free_inodes_count, eax

// group blocks, free blocks
xor eax, eax
mov e2_sb.s_free_blocks_count, eax
xor esi, esi

l_e2_format_5:
  xor ebx, ebx
  cmp esi, 0
  jnz l_e2_format_52
    // group 0
    mov ebx, e2_gblocks
    add ebx, e2_sb.s_first_data_block
    jmp short l_e2_format_53
    
  l_e2_format_52:
  cmp esi, 1
  jnz l_e2_format_53
    // group 1
    mov ebx, e2_gblocks
    inc ebx
    
  l_e2_format_53:
  mov eax, esi
  mul e2_sb.s_blocks_per_group
  inc eax
  add eax, ebx
  
  mov e2_gb.bg_block_bitmap, eax
  // zero bitmap, keep eax, ebx, esi, edi
  push esi
   push edi
    push eax
     push ebx
      
      push edi
        mov edi, VA_SYSTEM + offset hd_buffer
        xor eax, eax
        mov ecx, 512 / 4
        cld
        rep stosd
      pop ecx
      
      mov ch, cl
      mov ebx, e2_gb.bg_block_bitmap
      mov edx, ebx
      shl ebx, cl
      xor cl, 31
      inc cl
      shr edx, cl  // edx:ebx = block_bitmap << block_size_log
      
      mov cl, ch
      sub cl, 9
      mov eax, 1
      shl eax, cl
      xchg eax, ecx  // ecx = sectors512
      
      l_e2_format_535:
        push ecx
         push edx
          push ebx
            mov ecx, 512
            mov edi, VA_SYSTEM + offset hd_buffer
            mov ah, 3  // write
            mov al, fs_ldiskn_format
            call fs_diskmain_format
          pop ebx
         pop edx
        pop ecx
        add ebx, 512
        loop l_e2_format_535
        
     pop ebx
    pop eax
   pop edi
  pop esi

  inc eax
  mov e2_gb.bg_inode_bitmap, eax
  // zero bitmap, keep eax, ebx, esi, edi
  push esi
   push edi
    push eax
     push ebx
      
      mov ecx, edi
      
      mov ch, cl
      mov ebx, e2_gb.bg_inode_bitmap
      mov edx, ebx
      shl ebx, cl
      xor cl, 31
      inc cl
      shr edx, cl  // edx:ebx = inode_bitmap << block_size_log
      
      mov cl, ch
      sub cl, 9
      mov eax, 1
      shl eax, cl
      xchg eax, ecx  // ecx = sectors512
      
      l_e2_format_536:
        push ecx
         push edx
          push ebx
            mov ecx, 512
            mov edi, VA_SYSTEM + offset hd_buffer
            mov ah, 3  // write
            mov al, fs_ldiskn_format
            call fs_diskmain_format
          pop ebx
         pop edx
        pop ecx
        add ebx, 512
        loop l_e2_format_536
        
     pop ebx
    pop eax
   pop edi
  pop esi

  
  // reserved inodes
  test esi, esi
  jnz l_e2_format_546
    push esi
     push edi
      push eax
       push ebx
        mov e2_tmp, (1 << RESERVED_INODES) - 1  // inodes reserved
        xor edx, edx
        mov ebx, eax
        mov ecx, edi
        shl ebx, cl
        mov ecx, 4
        mov edi, VA_SYSTEM + offset e2_tmp
        mov ah, 3  // write
        mov al, fs_ldiskn_format
        call fs_diskmain_format
       pop ebx
      pop eax
     pop edi
    pop esi
    
  l_e2_format_546:
  inc eax
  mov e2_gb.bg_inode_table, eax
  
  mov eax, e2_sb.s_inodes_per_group
  movzx ecx, e2_sb.s_inode_size
  mul ecx
  mov ecx, edi
  shr eax, cl
  
  mov edx, e2_sb.s_blocks_per_group
  sub edx, eax
  sub edx, ebx
  sub edx, 2  // edx = blocks_per_group - size_inode_table - ebx - 2
  mov e2_gb.bg_free_blocks_count, dx
  
  mov eax, e2_sb.s_inodes_per_group
  test esi, esi
  jnz l_e2_format_548
    sub eax, RESERVED_INODES  // inodes reserved
    
  l_e2_format_548:
  mov e2_gb.bg_free_inodes_count, ax
  
  mov e2_gb.bg_used_dirs_count, 0
  
  // last group, KEEP esi  IN ebx  OUT edx
  mov eax, esi
  inc eax
  cmp eax, e2_groups
  jnz l_e2_format_56
    dec eax
    mul e2_sb.s_blocks_per_group
    inc eax
    mov edx, e2_sb.s_blocks_count
    sub edx, eax  // edx = blocks_count - (esi * blocks_per_group) - 1
    mov eax, ebx
    add eax, 2  // eax = ebx + 2
    cmp edx, eax
    jnb l_e2_format_55
      xor eax, eax
      xor edx, edx
      mov e2_gb.bg_free_inodes_count, ax
      mov e2_gb.bg_free_blocks_count, dx
      jmp short l_e2_format_558
      
    l_e2_format_55:
    sub edx, eax  // edx - eax
    mov ebx, edx
    mov eax, e2_sb.s_inodes_per_group
    movzx ecx, e2_sb.s_inode_size
    mul ecx
    mov ecx, edi
    shr eax, cl  // eax = inodes_per_group * inode_size / block_size
    cmp ebx, eax
    jnb l_e2_format_551
      shl eax, cl
      xor edx, edx
      div ecx
      mov e2_gb.bg_free_inodes_count, ax
      xor edx, edx
      mov e2_gb.bg_free_blocks_count, dx
      jmp short l_e2_format_558
    
    l_e2_format_551:
    sub ebx, eax  // ebx = edx - eax
    mov edx, ebx
    mov e2_gb.bg_free_blocks_count, dx
    
    l_e2_format_558:  // new edx
  
  l_e2_format_56:
  // sb free blocks
  add e2_sb.s_free_blocks_count, edx
  
  // write gb, KEEP esi, edi
  push esi
   push edi
    mov ebx, esi
    shl ebx, 5  // assert sizeof GroupBlock = 32
    mov ecx, edi
    mov edx, 1
    shl edx, cl
    cmp cl, 10
    jnz l_e2_format_57
      add edx, 1024
      
    l_e2_format_57:
    add ebx, edx
    xor edx, edx
    mov edi, VA_SYSTEM + offset e2_gb
    mov ecx, sizeof GroupBlock
    mov ah, 3 // write
    mov al, fs_ldiskn_format
    call fs_diskmain_format
   pop edi
  pop esi
    
  // next esi
  inc esi
  cmp esi, e2_groups
  jb near l_e2_format_5

// root inode
push edi
  mov edi, VA_SYSTEM + offset e2_inode
  mov ecx, sizeof INode / 4
  xor eax, eax
  cld
  rep stosd
  mov e2_inode.i_mode, EXT2_S_IFDIR | ACCESS_DEFAULT
pop edi

mov eax, EXT2_ROOT_INO - 1
movzx ecx, e2_sb.s_inode_size
mul ecx
mov ebx, e2_gblocks
add ebx, e2_sb.s_first_data_block
add ebx, 1 + 1 + 1  // boot_block, block_bitmap, inode_bitmap
mov ecx, edi
shl ebx, cl
add ebx, eax
xor edx, edx
mov edi, VA_SYSTEM + offset e2_inode
mov ecx, sizeof INode
mov ah, 3 // write
mov al, fs_ldiskn_format
call fs_diskmain_format

// write sb
mov edi, VA_SYSTEM + offset e2_sb
mov ecx, sizeof SuperBlock
mov ebx, 1024
xor edx, edx
mov ah, 3 // write
mov al, fs_ldiskn_format
call fs_diskmain_format

ret

// only starter, root
// IN: edx -> filename, esi = new owner
// OUT: al = erc
e2_chown:
push esi
  call e2_find_file
pop esi
test al, al
jnz l_e2_chown_9
  // chkstarter
  call s_chkstarter
  test al, al
  jnz l_e2_chown_9
    // chk root
    mov eax, p_current
    mov eax, [es:eax + offset ThreadRec.uid]
    test eax, 0xFFFFFF
    jnz l_e2_chown_7
      // change owner
      push esi
        call e2_load_inode
      pop esi
      test al, al
      jnz l_e2_chown_9
        mov e2_inode.i_uid, si
        call e2_save_inode
        jmp short l_e2_chown_9
    
    l_e2_chown_7:
    mov al, ERC_ACCESS_DENIED
  
l_e2_chown_9:
ret

// only starter, root or owner
// IN: edx -> filename, esi = new group
// OUT: al = erc
e2_chgrp:
push esi
  call e2_find_file
pop esi
test al, al
jnz l_e2_chgrp_9
  // chkstarter
  call s_chkstarter
  test al, al
  jnz l_e2_chgrp_9
    // get inode
    push esi
      call e2_load_inode
    pop esi
    test al, al
    jnz l_e2_chgrp_9
      // chk root or owner
      mov eax, p_current
      mov edi, [es:eax + offset ThreadRec.uid]
      and edi, 0xFFFFFF
      jz l_e2_chgrp_4
        //mov al, e2_ldiskn
        //shl eax, 24
        movzx eax, e2_inode.i_uid
        cmp eax, edi
        jz l_e2_chgrp_4
          mov al, ERC_ACCESS_DENIED
          jmp short l_e2_chgrp_9
          
      l_e2_chgrp_4:
      // set gid
      mov e2_inode.i_gid, si
      call e2_save_inode
  
l_e2_chgrp_9:
ret

NTFS_HEADER_SIZE = 1024
NTFS_NODE_SIZE = 4096

PA_NT_NODEBUF = PA_DMA_BUFFERS + FD_CACHE_SIZE
PA_NT_NODEBUF2 = PA_DMA_BUFFERS + FD_CACHE_SIZE + NTFS_NODE_SIZE

NT_SMALL_INDEX = -2
NT_FILE_FLAGS_DEFAULT = FILE_ATTRIBUTE_ARCHIVE + FILE_ATTRIBUTE_NORMAL
INDEX_ENTRY_MIN_SIZE = 40

NTFS_ATR_STANDARD_INFORMATION = 10h
NTFS_ATR_ATTRIBUTE_LIST = 20h
NTFS_ATR_FILE_NAME = 30h
NTFS_ATR_OBJECT_ID = 40h
NTFS_ATR_SECURITY_DESCRIPTOR = 50h
NTFS_ATR_VOLUME_NAME = 60h
NTFS_ATR_VOLUME_INFORMATION = 70h
NTFS_ATR_DATA = 80h
NTFS_ATR_INDEX_ROOT = 90h
NTFS_ATR_INDEX_ALLOCATION = 0A0h
NTFS_ATR_INDEX_BITMAP = 0B0h
NTFS_ATR_REPARSE_POINT = 0C0h
NTFS_ATR_EA_INFORMATION = 0D0h
NTFS_ATR_EA = 0E0h
NTFS_ATR_PROPERTY_SET = 0F0h
NTFS_ATR_LOGGED_UTILITY_STREAM = 100h

MFT_MFT = 0
MFT_MFTMIRR = 1
MFT_LOGFILE = 2
MFT_VOLUME = 3
MFT_ATTRDEF = 4
MFT_ROOT = 5
MFT_BITMAP = 6
MFT_BOOT = 7
MFT_BADCLUS = 8
MFT_SECURE = 9
MFT_UPCASE = 10
MFT_EXTEND = 11
MFT_FIRST_FILE = 24

struct FileDescriptor{
  uns4 signature
  uns2 offset_update_seq, size_update_seq
  uns8 log_file_seq_n
  uns2 del_count, hard_links, first_atr_ofs, flags  // 0 free, 1 file, 3 dir
  uns4 real_size, allocated
  uns8 base_file
  uns2 next_atr_id
  uns1 padding[6]
  uns2 update_seq_n
  uns2 update_seq_array[2]
  uns1 padding2[2]
}

struct StandardHeader{
  uns4 atr_type, atr_size
  bool non_resident
  uns1 name_len
  uns2 name_ofs
  uns2 flags  // 1 compressed, 4000h encrypted, 8000h sparse
  uns2 atr_id
  uns4 atr_len
  uns2 atr_ofs
  uns1 idx_flag, padding1
  // +attribute
}

struct StandardInformation{
  // +StandardHeader
  DateTime8 created
  DateTime8 modified
  DateTime8 mft_modified
  DateTime8 accessed
  uns4 permissions
  uns4 max_versions // 0 - not limited
  uns4 version
}

struct FileNameAtr{
  // +StandardHeader
  uns8 parent_dir
  DateTime8 created
  DateTime8 modified
  DateTime8 mft_modified
  DateTime8 accessed
  uns8 allocated
  uns8 size
  uns4 flags  // 1 read only, 2 hidden, 4 system, 20h arch, 40h dev,
              // 100h tmp, 200h sparse, 400h reparse, 10000000h dir
  uns4 ea_reparse
  uns1 name_len, namespace
  uns2 name[256]  
}

struct DataAtr{  // also INDEX_ALLOCATION (non-resident)
  uns4 atr_type, atr_size
  bool non_resident
  uns1 name_len
  uns2 name_ofs
  uns2 flags  // 1 compressed, 4000h encrypted, 8000h sparse
  uns2 atr_id
  uns8 init_vcn, final_vcn
  uns2 data_runs_ofs, compression_unit_len
  uns4 padding
  uns8 atr_alloc_size, atr_real_size, init_data_len
  // +name?
  // +data runs
}

struct IndexAtr{
  // +StandardHeader
  // Index Root
  uns4 atr_type, collation, alloc_index_entry_size
  uns1 clusters_per_index_record, padding[3]
  // Index Header
  uns4 ofs_first_index_entry  // from index header - 0x10
  uns4 index_entries_total_len  // from index header - 0x28
  uns4 index_entries_alloc  // from index header - 0x28
  uns1 flags  // 0 small index, 1 large index
  uns1 padding[3]
  // +IndexEntry[]
}

struct StandardIndexHeader{
  uns4 signature  // INDX
  uns2 ofs_fixup_array
  uns2 entries_in_fixup_array
  uns8 log_file
  uns8 vcn_of_this_record
}

struct NodeHeader{
  uns4 ofs_start_index_entry_list  // from node header
  uns4 ofs_end_index_entry_list  // from node header
  uns4 ofs_end_allocated  // from node header
  uns4 flags  // 1:any children
}

struct IndexEntry{
  uns8 file_ref
  uns2 index_entry_size
  uns2 filename_ofs
  uns2 index_flags  // 1:points to a subnode, 2:last index entry in the node
  uns2 padding
  uns8 parent_ref
  uns8 created, modified, mftmodified, accessed
  uns8 allocated, real_size, file_flags
  uns1 filename_len, namespace
  // +file_name
  // +[index_entry_size - 8] VCN of the subnode, aligned 64
}

struct FullIndexEntry{
  IndexEntry entry
  word filename[256]
  uns8 subnode  // after filename
}

struct AtrListEntry{
  uns4 AttributeTypeCode
  uns2 RecordLength
  uns1 AttributeNameLength
  uns1 AttributeNameOffset
  uns8 LowestVcn
  uns8 SegmentReference
  uns8 Reserved
}

uns1 nt_ldiskn, nt_cluzlog, nt_mftrecsizelog, nt_mod8, nt_negative

[dalign 32]
uns4 nt_file, nt_node, nt_diskmain, nt_tmp, nt_relofs, nt_endrelofs
uns4 nt_parentino, nt_nameofs, nt_subnode, nt_rootnode, nt_atrofs
uns4 nt_file_ref, nt_atr, nt_lastofs, nt_size, nt_curnode

[dalign 64]
uns8 nt_mft, nt_mftmirr, nt_base, nt_count, nt_oldbase, nt_vcn, nt_lcn
uns8 nt_remain, nt_rw_base, nt_rw_count, nt_bitmapbase, nt_bitmapsize
uns8 nt_first_free, nt_tmp8, nt_filesize, nt_disksize

uns1 nt_buffer[NTFS_HEADER_SIZE]

FullIndexEntry nt_fullentry

// IN: al = ldiskn
// OUT: nt_ldiskn, nt_diskmain, nt_mft, nt_cluzlog, nt_mftrecsizelog
//      nt_bitmapbase, nt_bitmapsize, nt_first_free = 0
nt_prepare:
mov nt_ldiskn, al
mov nt_file, -1
mov nt_node, -1

// diskmain
movzx esi, al
shl esi, 5  // log2(DiskInfoRec)
mov esi, disk_info.main[esi]
or esi, esi
jnz l_nt_prepare_0
  mov al, ERC_INVALID_DISK_NUMBER
  jmp l_nt_prepare_9

l_nt_prepare_0:
mov nt_diskmain, esi

// cluster size
mov ah, 2  // read
mov al, nt_ldiskn
xor edx, edx
mov ebx, 13
mov ecx, 1
mov edi, VA_SYSTEM + offset nt_cluzlog
call nt_diskmain
test al, al
jnz near l_nt_prepare_9

mov al, nt_cluzlog
mov ah, 1
xor cl, cl

l_nt_prepare_2:
  test al, ah
  jnz l_nt_prepare_28
    shl ah, 1
    inc cl
    cmp cl, 8
    jb l_nt_prepare_2
      mov al, ERC_FS
      jmp l_nt_prepare_9
  
l_nt_prepare_28:
add cl, 9
mov nt_cluzlog, cl

// MFT adr
mov ah, 2  // read
mov al, nt_ldiskn
xor edx, edx
mov ebx, 48
mov ecx, 8
mov edi, VA_SYSTEM + offset nt_mft
call nt_diskmain
test al, al
jnz near l_nt_prepare_9

mov eax, dword ptr nt_mft[0]
mov edx, dword ptr nt_mft[4]
mov ebx, eax
mov cl, nt_cluzlog
shl eax, cl
shl edx, cl
xor cl, 31
inc cl
shr ebx, cl
or edx, ebx
mov dword ptr nt_mft[0], eax
mov dword ptr nt_mft[4], edx

// MFT mirr adr
mov ah, 2  // read
mov al, nt_ldiskn
xor edx, edx
mov ebx, 56
mov ecx, 8
mov edi, VA_SYSTEM + offset nt_mftmirr
call nt_diskmain
test al, al
jnz near l_nt_prepare_9

mov eax, dword ptr nt_mftmirr[0]
mov edx, dword ptr nt_mftmirr[4]
mov ebx, eax
mov cl, nt_cluzlog
shl eax, cl
shl edx, cl
xor cl, 31
inc cl
shr ebx, cl
or edx, ebx
mov dword ptr nt_mftmirr[0], eax
mov dword ptr nt_mftmirr[4], edx
/*
// Size of MFT record
mov ah, 2  // read
mov al, nt_ldiskn
xor edx, edx
mov ebx, 64
mov ecx, 1
mov edi, VA_SYSTEM + offset nt_mftrecsizelog
call nt_diskmain
test al, al
jnz l_nt_prepare_9

mov al, nt_mftrecsizelog
cmp al, 80h
jb l_nt_prepare_3
  neg al
  mov nt_mftrecsizelog, al
  jmp short l_nt_prepare_39
  
l_nt_prepare_3:
xor cl, cl
mov ah, 1

l_nt_prepare_35:
  test al, ah
  jnz l_nt_prepare_38
    shl ah, 1
    inc cl
    cmp cl, 8
    jb l_nt_prepare_35
      mov al, ERC_FS
      jmp short l_nt_prepare_9

l_nt_prepare_38:
mov nt_mftrecsizelog, cl
*/

mov nt_mftrecsizelog, 10  // :KLUDGE:

// Bitmap
xor eax, eax
mov dword ptr nt_first_free[0], eax
mov dword ptr nt_first_free[4], eax

mov esi, MFT_BITMAP
call nt_load_file
test al, al
jnz l_nt_prepare_48

mov eax, NTFS_ATR_DATA
call nt_find_atr
test esi, esi
jz l_nt_prepare_48

xor eax, eax
mov dword ptr nt_vcn[0], eax
mov dword ptr nt_vcn[4], eax
call nt_vcn2lcn
mov eax, dword ptr nt_lcn[0]
mov edx, dword ptr nt_lcn[4]
mov ebx, eax
mov cl, nt_cluzlog
shl eax, cl
shl edx, cl
xor cl, 31
inc cl
shr ebx, cl
or edx, ebx
mov dword ptr nt_bitmapbase[0], eax
mov dword ptr nt_bitmapbase[4], edx
mov eax, dword ptr nt_remain[0]
mov edx, dword ptr nt_remain[4]
mov ebx, eax
mov cl, nt_cluzlog
shl eax, cl
shl edx, cl
xor cl, 31
inc cl
shr ebx, cl
or edx, ebx
mov dword ptr nt_bitmapsize[0], eax
mov dword ptr nt_bitmapsize[4], edx
jmp l_nt_prepare_8

l_nt_prepare_48:
xor eax, eax
mov dword ptr nt_bitmapbase[0], eax
mov dword ptr nt_bitmapbase[4], eax
mov dword ptr nt_bitmapsize[0], eax
mov dword ptr nt_bitmapsize[4], eax

l_nt_prepare_8:
mov al, 0

l_nt_prepare_9:
ret

// IN: esi = file number, nt_file
// OUT: al = erc, nt_file
// BEFORE: nt_prepare
nt_load_file:
xor eax, eax
cmp esi, nt_file
jz l_nt_load_file_8
  mov nt_file, esi
  mov nt_node, -1
  
  mov cl, nt_mftrecsizelog
  mov eax, esi
  shl esi, cl
  xor cl, 31
  inc cl
  shr eax, cl
  
  mov ebx, dword ptr nt_mft[0]
  mov edx, dword ptr nt_mft[4]
  add ebx, esi
  adc edx, eax
  mov ecx, NTFS_HEADER_SIZE
  mov edi, VA_SYSTEM + offset nt_buffer
  mov al, nt_ldiskn
  mov ah, 2  // read
  call nt_diskmain
  
  push eax
    // update sequence
    movzx ebx, word ptr nt_buffer[offset FileDescriptor.offset_update_seq]
    mov ax, word ptr nt_buffer[ebx + 2]
    mov word ptr nt_buffer[510], ax
    mov ax, word ptr nt_buffer[ebx + 4]
    mov word ptr nt_buffer[1022], ax
  pop eax
  
l_nt_load_file_8:
ret

// IN: eax = type, nt_buffer
// OUT: ds:esi = offset || 0
// KEEP: edx, ebx, edi
nt_find_atr:
mov esi, offset nt_buffer
movzx ecx, word ptr nt_buffer[offset FileDescriptor.first_atr_ofs]
add esi, ecx

l_nt_find_atr_5:
cmp eax, [esi]
jz l_nt_find_atr_9
  cmp dword ptr [esi], -1
  jz l_nt_find_atr_8
    mov ecx, [esi + 4]
    jecxz l_nt_find_atr_8
      add esi, ecx
      cmp esi, offset nt_buffer + NTFS_HEADER_SIZE
      jb l_nt_find_atr_5
    
l_nt_find_atr_8:
xor esi, esi

l_nt_find_atr_9:
ret

// IN: nt_vcn, ds:esi -> non-resident atr
// OUT: al = erc, nt_lcn, nt_remain, nt_lastofs, nt_oldbase
nt_vcn2lcn:
mov ecx, [esi + offset DataAtr.atr_size]
add ecx, esi
movzx eax, word ptr [esi + offset DataAtr.data_runs_ofs]
add esi, eax

xor eax, eax
mov dword ptr nt_oldbase[0], eax
mov dword ptr nt_oldbase[4], eax
mov nt_lastofs, eax

cmp esi, ecx
jnb near l_nt_vcn2lcn_8

l_nt_vcn2lcn_1:
mov al, [esi]
inc esi
cmp al, 0
jz near l_nt_vcn2lcn_8
  mov edx, esi
  dec edx
  mov nt_lastofs, edx
  
  mov dl, al
  mov dh, al
  and dl, 0Fh
  shr dh, 4
  xor eax, eax
  mov dword ptr nt_base[0], eax
  mov dword ptr nt_base[4], eax
  mov dword ptr nt_count[0], eax
  mov dword ptr nt_count[4], eax
  
  // size
  xor edi, edi

  l_nt_vcn2lcn_21:
  cmp dl, 0
  jz l_nt_vcn2lcn_22
    mov al, [esi]
    inc esi
    mov byte ptr nt_count[edi], al
    inc edi
    dec dl
    jmp short l_nt_vcn2lcn_21
    
  l_nt_vcn2lcn_22:
  // base
  xor edi, edi

  l_nt_vcn2lcn_23:
  cmp dh, 0
  jz l_nt_vcn2lcn_24
    mov al, [esi]
    inc esi
    mov byte ptr nt_base[edi], al
    inc edi
    cmp dh, 1
    jnz l_nt_vcn2lcn_238
      cmp al, 80h
      jb l_nt_vcn2lcn_238
        // - base
        l_nt_vcn2lcn_235:
          cmp edi, 8
          jnb l_nt_vcn2lcn_238
            mov byte ptr nt_base[edi], 0FFh
            inc edi
            jmp short l_nt_vcn2lcn_235
      
    l_nt_vcn2lcn_238:
    dec dh
    jmp short l_nt_vcn2lcn_23
    
  l_nt_vcn2lcn_24:
  // base + oldbase
  mov eax, dword ptr nt_oldbase[0]
  mov edx, dword ptr nt_oldbase[4]
  add eax, dword ptr nt_base[0]
  adc edx, dword ptr nt_base[4]
  mov dword ptr nt_oldbase[0], eax
  mov dword ptr nt_oldbase[4], edx
  mov dword ptr nt_base[0], eax
  mov dword ptr nt_base[4], edx
  
  // nt_vcn ? nt_count
  mov edx, dword ptr nt_vcn[4]
  mov eax, dword ptr nt_vcn[0]
  mov ebx, dword ptr nt_count[4]
  mov ecx, dword ptr nt_count[0]
  cmp edx, ebx
  jnz l_nt_vcn2lcn_25
    cmp eax, ecx
    
  l_nt_vcn2lcn_25:
  jb l_nt_vcn2lcn_26
    // nt_vcn >= nt_count
    sub eax, ecx
    sbb edx, ebx
    mov dword ptr nt_vcn[0], eax
    mov dword ptr nt_vcn[4], edx
    jmp l_nt_vcn2lcn_1
    
  l_nt_vcn2lcn_26:
  sub ecx, eax
  sbb ebx, edx  // count - vcn
  add eax, dword ptr nt_base[0]
  add edx, dword ptr nt_base[4]
  mov dword ptr nt_remain[0], ecx
  mov dword ptr nt_remain[4], ebx  // remain = count - vcn
  mov dword ptr nt_lcn[0], eax
  mov dword ptr nt_lcn[4], edx  // lcn = vcn + base
  
  mov al, 0
  
  ret
  
l_nt_vcn2lcn_8:
xor eax, eax
mov dword ptr nt_remain[0], eax
mov dword ptr nt_remain[4], eax
mov dword ptr nt_lcn[0], eax
mov dword ptr nt_lcn[4], eax

mov al, ERC_FS
ret

// IN: edx:ebx = file offset, ecx = size
// OUT: nt_rw_base, nt_rw_count, nt_relofs, nt_endrelofs
// BEFORE: nt_prepare, nt_load_file
// KEEP: esi, edi
nt_prepare_values:
push edi
 push ecx
  push ebx
   push edx
    mov edi, 1
    mov cl, nt_cluzlog
    shl edi, cl
    dec edi
    mov eax, ebx
    and eax, edi
    mov nt_relofs, eax
    mov eax, edx
    shr ebx, cl
    shr edx, cl
    xor cl, 31
    inc cl
    shl eax, cl
    or ebx, eax
    mov dword ptr nt_rw_base[4], edx
    mov dword ptr nt_rw_base[0], ebx
   pop edx
  pop ebx
 pop ecx
 dec ecx
 mov eax, ebx
 add eax, ecx
 and eax, edi
 mov nt_endrelofs, eax
 add ebx, ecx
 adc edx, 0
 mov cl, nt_cluzlog
 mov eax, edx
 shr ebx, cl
 shr edx, cl
 xor cl, 31
 inc cl
 shl eax, cl
 or ebx, eax
 sub ebx, dword ptr nt_rw_base[0]
 sbb edx, dword ptr nt_rw_base[4]
 add ebx, 1
 adc edx, 0
 mov dword ptr nt_rw_count[0], ebx
 mov dword ptr nt_rw_count[4], edx
pop edi
ret

l_nt_read_x0:
mov al, 0
ret

// IN: ds:esi -> atr,
//     edx:ebx = file offset, ecx = size, es:edi -> data
// OUT: al = 0 || erc, ecx = sizeread
// BEFORE: nt_prepare, nt_load_file
nt_read:
jecxz l_nt_read_x0
mov nt_atrofs, esi
mov al, [esi + offset StandardHeader.non_resident]
test al, 1
jnz l_nt_read_09
  // resident
  test edx, edx
  jz l_nt_read_01
    
    l_nt_read_00:
    mov al, ERC_OUT_OF_RANGE
    jmp l_nt_read_9
    
  l_nt_read_01:
  mov edx, [esi + offset StandardHeader.atr_len]
  cmp ebx, edx
  ja l_nt_read_00
  
  mov eax, ecx
  add eax, ebx
  cmp eax, edx
  jna l_nt_read_02
    mov eax, edx
    sub eax, ebx
    mov ecx, eax
  
  l_nt_read_02:
  movzx eax, word ptr [esi + offset StandardHeader.atr_ofs]
  add eax, ebx
  add esi, eax
  push ecx
    cld
    rep movsb
  pop ecx
  jmp l_nt_read_8
  
l_nt_read_09:
// non-resident
call nt_prepare_values  // keep esi, edi
xor eax, eax
mov nt_size, eax

l_nt_read_1:
mov ecx, nt_size
cmp dword ptr nt_rw_count[4], 0
jnz l_nt_read_2
  cmp dword ptr nt_rw_count[0], 0
  jz near l_nt_read_8  // if nt_rw_count == 0 then goto l_nt_read_8

l_nt_read_2:

mov esi, nt_atrofs
mov eax, dword ptr nt_rw_base[0]
mov edx, dword ptr nt_rw_base[4]
mov dword ptr nt_vcn[0], eax
mov dword ptr nt_vcn[4], edx
push edi
  call nt_vcn2lcn
pop edi
test al, al
jnz near l_nt_read_9

mov cl, nt_cluzlog
mov ebx, dword ptr nt_lcn[0]
mov edx, dword ptr nt_lcn[4]
mov eax, ebx
shl ebx, cl
shl edx, cl
xor cl, 31
inc cl
shr eax, cl
or edx, eax  // edx:ebx = nt_lcn << cluzlog

mov ecx, dword ptr nt_rw_count[0]
mov eax, dword ptr nt_rw_count[4]
cmp eax, dword ptr nt_remain[4]
jnz l_nt_read_61
  cmp ecx, dword ptr nt_remain[0]

l_nt_read_61:
jna l_nt_read_62
  // eax:ecx > nt_remain
  mov ecx, dword ptr nt_remain[0]
  mov eax, dword ptr nt_remain[4]

l_nt_read_62:
// eax:ecx = min(nt_rw_count, nt_remain)
sub dword ptr nt_rw_count[0], ecx
sbb dword ptr nt_rw_count[4], eax  // nt_rw_count -= eax:ecx
add dword ptr nt_rw_base[0], ecx
adc dword ptr nt_rw_base[4], eax  // nt_rw_base += eax:ecx

mov esi, ecx
mov cl, nt_cluzlog
shl esi, cl
mov ecx, esi  // ecx << cluzlog
mov eax, nt_relofs
add ebx, eax
adc edx, 0  // edx:ebx += nt_relofs
sub ecx, eax  // ecx -= nt_relofs
xor eax, eax
mov nt_relofs, eax  // nt_relofs = 0

cmp dword ptr nt_rw_count[0], 0
jnz l_nt_read_64
  cmp dword ptr nt_rw_count[4], 0
  jnz l_nt_read_64
    // nt_rw_count == 0
    push ecx
      mov esi, 1
      mov cl, nt_cluzlog
      shl esi, cl
      dec esi
      sub esi, nt_endrelofs
    pop ecx
    sub ecx, esi  // ecx -= (1 << cluzlog) - 1 - endrelofs

l_nt_read_64:
// read from disk  IN: edx:ebx, ecx, edi
add nt_size, ecx
mov al, nt_ldiskn
mov ah, 2  // read
call nt_diskmain
test al, al
jnz l_nt_read_9
  jmp l_nt_read_1

l_nt_read_8:
mov al, 0

l_nt_read_9:
ret

// IN: ebx = node, nt_cluzlog, nt_buffer, nt_node
// OUT: al = erc, [PA_NT_NODEBUF]
// BEFORE: nt_prepare
nt_load_node:
xor eax, eax
cmp ebx, nt_node
jz near l_nt_load_node_9  
  mov nt_node, ebx
  
  mov eax, NTFS_ATR_INDEX_ALLOCATION
  call nt_find_atr
  test esi, esi
  jz l_nt_load_node_92
  
  mov ebx, nt_node
  mov cl, nt_cluzlog
  mov edx, ebx
  shl ebx, cl
  xor cl, 31
  inc cl
  shr edx, cl
  mov ecx, NTFS_NODE_SIZE
  mov edi, VA_SYSTEM + PA_NT_NODEBUF
  call nt_read
  
  push eax
    
    // fixup update sequence
    movzx ebx, word ptr [offset StandardIndexHeader.ofs_fixup_array + PA_NT_NODEBUF]
    add ebx, PA_NT_NODEBUF + 2
    mov edi, PA_NT_NODEBUF + 510
    
    l_nt_load_node_5:
    cmp edi, PA_NT_NODEBUF + NTFS_NODE_SIZE
    jnb l_nt_load_node_8
      mov ax, [ebx]
      mov [edi], ax
      add ebx, 2
      add edi, 512
      jmp short l_nt_load_node_5
      
    l_nt_load_node_8:
    
  pop eax
  
l_nt_load_node_9:
ret

l_nt_load_node_92:
mov al, ERC_FS
ret

// OUT: al = erc, nt_rootnode, esi -> IndexAtr, edi -> end
// BEFORE: nt_prepare, nt_load_file
// KEEP: edx
nt_get_root_node:
mov eax, NTFS_ATR_INDEX_ROOT
call nt_find_atr
test esi, esi
jnz l_nt_get_root_node_2
  mov al, ERC_FS
  jmp l_nt_get_root_node_9
  
l_nt_get_root_node_2:
movzx eax, word ptr [esi + offset StandardHeader.atr_ofs]
add esi, eax  // esi -> root index
mov cl, byte ptr [esi + offset IndexAtr.flags]

mov eax, [esi + offset IndexAtr.ofs_first_index_entry]
mov edi, [esi + offset IndexAtr.index_entries_total_len]
add esi, eax
add edi, esi
add esi, 16  // esi -> root index entry

mov nt_rootnode, NT_SMALL_INDEX
test cl, 1  // large
jz l_nt_get_root_node_4
  
  mov eax, edi
  sub eax, esi
  cmp eax, INDEX_ENTRY_MIN_SIZE
  jnb l_nt_get_root_node_4
    movzx eax, word ptr [esi + offset IndexEntry.index_entry_size]
    add eax, esi
    mov ebx, [eax - 8]
    mov nt_rootnode, ebx
  
l_nt_get_root_node_4:

mov al, 0

l_nt_get_root_node_9:
ret

// IN: es:edx -> filenamez, ebx = 0 || dirino, al = ldiskn
// OUT: al = 0 || erc, ebx = ino, nt_parentino, nt_nameofs
nt_find_file:
cmp al, nt_ldiskn
jz l_nt_find_file_01
  push edx
   push ebx
    call nt_prepare
   pop ebx
  pop edx
  
l_nt_find_file_01:
test ebx, ebx
jnz l_nt_find_file_1
  mov ebx, MFT_ROOT


l_nt_find_file_1:
mov nt_parentino, ebx
mov nt_nameofs, edx

push edx
  mov esi, ebx
  call nt_load_file
pop edx

cmp byte ptr nt_buffer[offset FileDescriptor.flags], 3  // directory
jz l_nt_find_file_2
  mov al, ERC_PATH_NOT_FOUND
  jmp l_nt_find_file_9

l_nt_find_file_2:

// index root
call nt_get_root_node
test al, al
jnz near l_nt_find_file_9

mov ebx, nt_rootnode
cmp ebx, NT_SMALL_INDEX
jnz near l_nt_find_file_large

// small index  
l_nt_find_file_25:
  cmp esi, edi
  jnb near l_nt_find_file_notfound
    mov al, byte ptr [esi + offset IndexEntry.index_flags]
    test al, 2  // last
    jz l_nt_find_file_252
      // last
      
      l_nt_find_file_golarge:
      test al, 1  // has subnode
      jz near l_nt_find_file_notfound
        movzx eax, word ptr [esi + offset IndexEntry.index_entry_size]
        add esi, eax
        mov ebx, [esi - 8]
        jmp l_nt_find_file_large
        
    l_nt_find_file_252:
    movzx ecx, byte ptr [esi + offset IndexEntry.filename_len]
    push esi
     push edi
      add esi, sizeof IndexEntry
      mov edi, VA_SYSTEM + offset fs_utf8buf
      mov fs_bigendian, 0
      shl ecx, 1
      call fs_toutf8  // keep edx
      mov esi, VA_SYSTEM + offset fs_utf8buf
      call fs_cmp  // keep edx
     pop edi
    pop esi
    cmp al, 0  // equal
    jnz l_nt_find_file_26
      mov ebx, esi
      jmp l_nt_find_file_found
      
    l_nt_find_file_26:
    cmp al, -1  // smaller
    jnz l_nt_find_file_next
      mov al, byte ptr [esi + offset IndexEntry.index_flags]
      jmp l_nt_find_file_golarge
        
    l_nt_find_file_next:  // next
    movzx eax, word ptr [esi + offset IndexEntry.index_entry_size]
    test eax, eax
    jz near l_nt_find_file_notfound
      add esi, eax
      jmp l_nt_find_file_25
    
      
// large index
l_nt_find_file_large:  // IN: ebx = node
// read node
push edx
  call nt_load_node
pop edx
test al, al
jnz near l_nt_find_file_9

mov ebx, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_start_index_entry_list + PA_NT_NODEBUF]
add ebx, PA_NT_NODEBUF + sizeof StandardIndexHeader
mov edi, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_end_index_entry_list + PA_NT_NODEBUF]
add edi, PA_NT_NODEBUF + sizeof StandardIndexHeader

l_nt_find_file_521:
  cmp ebx, edi
  jnb l_nt_find_file_notfound  // end of node
  
  movzx esi, word ptr [ebx + offset IndexEntry.index_entry_size]
  add esi, ebx
  mov esi, dword ptr [esi - 8]  // esi = subnode
  
  mov al, [ebx + offset IndexEntry.index_flags]
  cmp al, 3  // last + subnode
  jnz l_nt_find_file_523
    
    l_nt_find_file_522:
    mov ebx, esi
    jmp l_nt_find_file_large
    
  l_nt_find_file_523:
  cmp al, 2  // last
  jz l_nt_find_file_notfound  // end of node
  
  push edx
   push edi
    push esi
      
      movzx ecx, byte ptr [ebx + offset IndexEntry.filename_len]
      mov esi, sizeof IndexEntry
      add esi, ebx
      mov edi, VA_SYSTEM + offset fs_utf8buf
      push ebx
        mov fs_bigendian, 0
        shl ecx, 1
        call fs_toutf8  // keep edx
        /*
        //$$$
        mov esi, VA_SYSTEM + offset fs_utf8buf
        call wrs
        */
        mov esi, VA_SYSTEM + offset fs_utf8buf
        call fs_cmp  // keep edx
      pop ebx
      
    pop esi
   pop edi
  pop edx
  
  cmp al, 0  // equal
  jz l_nt_find_file_found
  
  cmp al, -1  // smaller
  jnz l_nt_find_file_528
    mov al, [ebx + offset IndexEntry.index_flags]
    test al, 1
    jnz l_nt_find_file_522  // subnode
      jmp short l_nt_find_file_notfound
    
  l_nt_find_file_528:
  movzx ecx, word ptr [ebx + offset IndexEntry.index_entry_size]
  jecxz l_nt_find_file_notfound
    add ebx, ecx
    jmp l_nt_find_file_521


l_nt_find_file_notfound:
// not found
call fs_next_edx

l_nt_find_file_54:
cmp byte ptr [es:edx], 0
jz l_nt_find_file_56
  mov al, ERC_PATH_NOT_FOUND
  jmp short l_nt_find_file_9
  
l_nt_find_file_56:
mov al, ERC_FILE_NOT_FOUND
jmp short l_nt_find_file_9


l_nt_find_file_found:  // IN: ebx -> IndexEntry
// found
call fs_next_edx  // keep ebx

mov eax, dword ptr [ebx + offset IndexEntry.real_size]
mov dword ptr nt_filesize[0], eax
mov eax, dword ptr [ebx + offset IndexEntry.real_size + 4]
mov dword ptr nt_filesize[4], eax

mov ebx, dword ptr [ebx + offset IndexEntry.file_ref]

// link?
//cmp byte ptr fd_buffer[7], EXT2_FT_SYMLINK
//jz l_nt_find_file_60

cmp byte ptr [es:edx], 0  // end of es:edx?
jnz near l_nt_find_file_1

l_nt_find_file_8:
mov al, 0

l_nt_find_file_9:  
ret


// link
l_nt_find_file_60:
test take_link, 1
jz l_nt_find_file_608
  cmp byte ptr [es:edx], 0
  jz l_nt_find_file_8
  
l_nt_find_file_608:
//call nt_follow_link
test al, al
jnz l_nt_find_file_9
  jmp l_nt_find_file_1

nt_init:
mov nt_ldiskn, -1
ret

// IN: es:edx -> filenamez, esi -> files, al = ldiskn || 1, ebx = 0 || dirino
// OUT: al = 0 || erc, esi = fhandle
nt_fopen:
push esi
  call nt_find_file
pop esi
test al, al
jnz near l_nt_fopen_x

mov files.file[esi], ebx  // ino

push esi
  mov esi, ebx
  call nt_load_file
pop esi
test al, al
jnz near l_nt_fopen_x

// check not directory
cmp byte ptr nt_buffer[offset FileDescriptor.flags], 1  // regular file
jz l_nt_fopen_1
  mov al, ERC_FILE_NOT_FOUND
  jmp l_nt_fopen_x
  
l_nt_fopen_1:
// check read
mov al, files.mode[esi]
and al, 3Fh
cmp al, 3
jna l_nt_fopen_2
  mov al, ERC_READ_ONLY
  jmp l_nt_fopen_x
  
l_nt_fopen_2:
// load file info
xor eax, eax
mov dword ptr files.pos[esi], eax
mov dword ptr files.pos[esi + 4], eax

push esi
  mov eax, NTFS_ATR_FILE_NAME
  call nt_find_atr
  mov ebx, esi
pop esi
test ebx, ebx
jnz l_nt_fopen_3
  mov al, ERC_FS
  jmp l_nt_fopen_x
  
l_nt_fopen_3:
mov eax, dword ptr nt_filesize[0]
mov edx, dword ptr nt_filesize[4]
mov dword ptr files.size[esi], eax
mov dword ptr files.size[esi + 4], edx

push esi
  mov eax, NTFS_ATR_DATA
  call nt_find_atr
  mov ebx, esi
pop esi
test ebx, ebx
jnz l_nt_fopen_4
  mov al, ERC_FS
  jmp l_nt_fopen_x
  
l_nt_fopen_4:
test byte ptr [ebx + offset StandardHeader.non_resident], 1
jnz l_nt_fopen_5
  // resident
  mov eax, [ebx + offset StandardHeader.atr_len]
  xor edx, edx
  mov dword ptr files.size[esi], eax
  mov dword ptr files.size[esi + 4], edx
  
l_nt_fopen_5:
shr esi, 5 // assert sizeof OpenFileRec = 32
mov al, 0

l_nt_fopen_9:
ret

l_nt_fopen_x:
mov files.mode[esi], 0
xor esi, esi
jmp short l_nt_fopen_9

// IN: esi = offset to files, es:edi -> data, ecx = size
// OUT: al = 0 || erc, ecx = sizeread
nt_fread:
mov al, files.disk[esi]
cmp al, nt_ldiskn
jz l_nt_fread_1
  push esi
   push edi
    push ecx
     call nt_prepare
    pop ecx
   pop edi
  pop esi
  
l_nt_fread_1:
push esi
 push edi
  push ecx
   mov esi, files.file[esi]
   call nt_load_file
  pop ecx
 pop edi
pop esi

push edi
  mov ebx, dword ptr files.pos[esi]
  mov edx, dword ptr files.pos[esi + 4]
  
  mov edi, dword ptr files.size[esi + 4]
  mov eax, dword ptr files.size[esi]
  sub edi, edx
  sbb eax, ebx  // edi:eax = size - pos
  cmp edi, 0
  jnz l_nt_fread_2
    cmp eax, ecx
    jnb l_nt_fread_2
      mov ecx, eax
      
  l_nt_fread_2:
pop edi

push esi
 push ecx
  mov eax, NTFS_ATR_DATA
  call nt_find_atr  // keep edx, ebx, edi
 pop ecx
 call nt_read
pop esi
test al, al
jnz l_nt_fread_9
  mov ebx, dword ptr files.pos[esi]
  mov edx, dword ptr files.pos[esi + 4]
  add ebx, ecx
  adc edx, 0
  mov dword ptr files.pos[esi], ebx
  mov dword ptr files.pos[esi + 4], edx
  
  mov al, 0
  
l_nt_fread_9:
ret

// IN: esi = offset to files
nt_fclose:
mov files.mode[esi], 0
mov al, 0
ret

// IN: esi = offset to files, edx:ebx = file offset
nt_fsetpos:
cmp edx, dword ptr files.size[esi + 4]
jnz l_nt_fsetpos_1
  cmp ebx, dword ptr files.size[esi]
  
l_nt_fsetpos_1:
jna l_nt_fsetpos_2
  // pos > size
  mov ebx, dword ptr files.size[esi]
  mov edx, dword ptr files.size[esi + 4]
  
l_nt_fsetpos_2:
mov dword ptr files.pos[esi], ebx
mov dword ptr files.pos[esi + 4], edx
mov al, 0
ret

// IN: al = ldiskn, es:edx -> path
nt_cd:
xor ebx, ebx
call nt_find_file
or al, al
jnz l_nt_cd_9
  
  mov edx, p_current
  mov al, nt_ldiskn
  mov [es:edx + offset ThreadRec.curdisk], al
  mov [es:edx + offset ThreadRec.curdir], ebx
  mov al, 0
  
l_nt_cd_9:
ret

// IN: al = ldiskn, ebx = dir, es:edx -> dir(mask)
//     fs_rec, fs_srchofs, fs_dosplit
nt_find_first:
cmp al, nt_ldiskn
jz l_nt_find_first_01
  push edx
   push ebx
    call nt_prepare
   pop ebx
  pop edx

l_nt_find_first_01:
test fs_dosplit, 1
jz l_nt_find_first_2
  call fs_split  // KEEP ebx
  test al, al
  jnz near l_nt_find_first_9
  
l_nt_find_first_2:
// Find dir  IN: ebx
cmp byte ptr [es:edx], 0
jnz l_nt_find_first_3
  
  // no path
  test ebx, ebx
  jnz l_nt_find_first_4
    // root
    mov ebx, MFT_ROOT
    jmp short l_nt_find_first_4
  
l_nt_find_first_3:
  mov al, nt_ldiskn
  
  call nt_find_file
  
  cmp al, ERC_FILE_NOT_FOUND
  jnz l_nt_find_first_33
    mov al, ERC_PATH_NOT_FOUND
    
  l_nt_find_first_33:
  cmp al, ERC_LINK
  jz near l_nt_find_first_99
  
  test al, al
  jnz near l_nt_find_first_9
  
l_nt_find_first_4:
// set srch
mov esi, fs_srchofs
mov srch.File[esi], ebx

mov esi, ebx
call nt_load_file
test al, al
jnz l_nt_find_first_9

// index root
call nt_get_root_node
test al, al
jnz near l_nt_find_first_9

mov ebx, nt_rootnode
cmp ebx, NT_SMALL_INDEX
jnz l_nt_find_first_48
  // small index
  mov eax, esi
  mov ecx, edi
  jmp short l_nt_find_first_6

l_nt_find_first_48:
  // large index  IN: ebx = node
  call nt_load_node
  test al, al
  jnz l_nt_find_first_9
  
  mov eax, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_start_index_entry_list + PA_NT_NODEBUF]
  mov ecx, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_end_index_entry_list + PA_NT_NODEBUF]
  
l_nt_find_first_6:
// both
mov ebx, nt_rootnode
xor edx, edx

mov esi, fs_srchofs
mov dword ptr srch.Cluster[esi], ebx
mov dword ptr srch.Cluster[esi + 4], edx
mov srch.Offset[esi], eax
mov srch.Size[esi], ecx  // offset of end

call nt_find_next

test al, al
jz l_nt_find_first_99

l_nt_find_first_9:
mov esi, fs_srchofs
mov word ptr srch.ThreadId[esi], -1

l_nt_find_first_99:
ret

// IN: fs_rec, fs_srchofs, nt_ldiskn, nt_diskmain
// OUT: al = 0 || erc
// USES: fd_buffer
nt_find_next:
mov esi, fs_srchofs
mov al, srch.Disk[esi]
cmp al, nt_ldiskn
jz l_nt_find_next_1
  push esi
    call nt_prepare
  pop esi
  
l_nt_find_next_1:
mov esi, srch.File[esi]
call nt_load_file

mov esi, fs_srchofs
mov ebx, dword ptr srch.Cluster[esi]
mov nt_subnode, ebx
cmp ebx, NT_SMALL_INDEX
jz l_nt_find_next_11
  // large index
  call nt_load_node
  test al, al
  jnz near l_nt_find_next_9
  
l_nt_find_next_11:
// both
mov esi, fs_srchofs
mov ebx, srch.Offset[esi]
mov ecx, srch.Size[esi]  // offset of end

mov eax, dword ptr srch.Cluster[esi]
cmp eax, NT_SMALL_INDEX
jnz l_nt_find_next_15
  // small index
  cmp ebx, ecx
  jnb near l_nt_find_next_7
    jmp short l_nt_find_next_16

l_nt_find_next_15:
  // large index
  cmp ebx, ecx
  jnb near l_nt_find_next_6
  
  add ebx, PA_NT_NODEBUF + sizeof StandardIndexHeader
  add ecx, PA_NT_NODEBUF + sizeof StandardIndexHeader
  
  l_nt_find_next_16:
  // both
  movzx eax, word ptr [ebx + offset IndexEntry.index_entry_size]
  add eax, ebx
  mov edx, dword ptr [eax - 8]  // edx = subnode

  mov al, [ebx + offset IndexEntry.index_flags]
  test al, 1  // has subnode
  jz l_nt_find_next_18
    // has child
    mov ebx, edx
    mov nt_subnode, ebx
    call nt_load_node
    test al, al
    jnz near l_nt_find_next_9
    
    mov esi, fs_srchofs
    mov ebx, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_start_index_entry_list + PA_NT_NODEBUF]
    mov ecx, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_end_index_entry_list + PA_NT_NODEBUF]
    mov eax, nt_subnode
    mov srch.Offset[esi], ebx
    mov srch.Size[esi], ecx
    mov dword ptr srch.Cluster[esi], eax
    jmp l_nt_find_next_15
    
l_nt_find_next_18:
// found  IN: al, ebx, esi
test al, 2  // last
jnz near l_nt_find_next_6

l_nt_find_next_2:
movzx eax, word ptr [ebx + offset IndexEntry.index_entry_size]
add srch.Offset[esi], eax

movzx ecx, byte ptr [ebx + offset IndexEntry.filename_len]
mov esi, sizeof IndexEntry
add esi, ebx
mov edi, VA_SYSTEM + offset fs_utf8buf
mov fs_bigendian, 0
shl ecx, 1
push ebx
  call fs_toutf8
pop ebx
test al, al
jnz near l_nt_find_next_9

// IsMatch?
mov esi, fs_srchofs
add esi, offset srch.FileMask
mov edi, offset fs_utf8buf
push ebx
  call fs_ismatch
pop ebx
test al, al
jnz near l_nt_find_next_11

// Valid file?
mov eax, [ebx + offset IndexEntry.file_ref]
cmp eax, MFT_FIRST_FILE
jb near l_nt_find_next_11

// Not DOS?
mov al, [ebx + offset IndexEntry.namespace]
cmp al, 2  // DOS namespace
jz near l_nt_find_next_11

// * Found - copy to fs_rec *

// File name
mov esi, offset fs_utf8buf
mov edi, fs_rec
add edi, offset SearchRec.FileName

l_nt_find_next_25:
  mov al, [esi]
  mov [es:edi], al
  cmp al, 0
  jz l_nt_find_next_28
    inc esi
    inc edi
    jmp l_nt_find_next_25
    
l_nt_find_next_28:

// init fs_rec
mov edi, fs_rec
xor eax, eax
push edi
  mov ecx, 7
  rep stosd
pop edi

// time
mov eax, dword ptr [ebx + offset IndexEntry.created]
mov edx, dword ptr [ebx + offset IndexEntry.created + 4]
mov [es:edi + offset SearchRec.CreationTime], eax
mov [es:edi + offset SearchRec.CreationTime + 4], edx
mov eax, dword ptr [ebx + offset IndexEntry.modified]
mov edx, dword ptr [ebx + offset IndexEntry.modified + 4]
mov [es:edi + offset SearchRec.LastWriteTime], eax
mov [es:edi + offset SearchRec.LastWriteTime + 4], edx
mov eax, dword ptr [ebx + offset IndexEntry.accessed]
mov edx, dword ptr [ebx + offset IndexEntry.accessed + 4]
mov [es:edi + offset SearchRec.LastAccessTime], eax
mov [es:edi + offset SearchRec.LastAccessTime + 4], edx

// File size
mov eax, dword ptr [ebx + offset IndexEntry.real_size]
mov [es:edi + offset SearchRec.FileSize], eax
mov edx, dword ptr [ebx + offset IndexEntry.real_size + 4]
mov [es:edi + offset SearchRec.FileSize + 4], edx

// File attributes
mov eax, dword ptr [ebx + offset IndexEntry.file_flags]
test eax, 0x10000000
jz l_nt_find_next_3
  or eax, FILE_ATTRIBUTE_DIRECTORY
  
l_nt_find_next_3:
and eax, 0xFFFFFF
mov [es:edi + offset SearchRec.FileAttributes], eax

mov al, 0
jmp l_nt_find_next_9


l_nt_find_next_6:  // IN: ebx -> IndexEntry
// * end of node *
call nt_get_root_node
mov eax, nt_rootnode
cmp eax, nt_subnode
jz near l_nt_find_next_7

// copy the first name to fd_buffer
mov ebx, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_start_index_entry_list + PA_NT_NODEBUF]
add ebx, PA_NT_NODEBUF + sizeof StandardIndexHeader

movzx ecx, byte ptr [ebx + offset IndexEntry.filename_len]
mov esi, sizeof IndexEntry
add esi, ebx
mov edi, VA_SYSTEM + offset fd_buffer
mov fs_bigendian, 0
shl ecx, 1
call fs_toutf8

mov ebx, nt_rootnode

// find
l_nt_find_next_61:  // IN: ebx = node
mov nt_curnode, ebx
mov eax, nt_rootnode
cmp eax, nt_subnode
jz near l_nt_find_next_7

cmp ebx, NT_SMALL_INDEX
jnz l_nt_find_next_62
  // small
  mov eax, NTFS_ATR_INDEX_ROOT
  call nt_find_atr
  movzx eax, word ptr [esi + offset StandardHeader.atr_ofs]
  add esi, eax  // esi -> root index
  mov eax, [esi + offset IndexAtr.ofs_first_index_entry]
  mov edi, [esi + offset IndexAtr.index_entries_total_len]
  add esi, eax
  add edi, esi
  add esi, 16  // esi -> root index entry
  mov ebx, esi
  jmp short l_nt_find_next_65
  
l_nt_find_next_62:
  // large
  call nt_load_node
  mov ebx, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_start_index_entry_list + PA_NT_NODEBUF]
  add ebx, PA_NT_NODEBUF + sizeof StandardIndexHeader
  mov edi, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_end_index_entry_list + PA_NT_NODEBUF]
  add edi, PA_NT_NODEBUF + sizeof StandardIndexHeader
  
l_nt_find_next_65:
  cmp ebx, edi
  jb l_nt_find_next_67
  
    l_nt_find_next_66:
    mov al, ERC_FS
    jmp l_nt_find_next_9
    
  l_nt_find_next_67:
  mov al, [ebx + offset IndexEntry.index_flags]
  test al, 2  // last
  jnz l_nt_find_next_676
  // compare
  push edi
    movzx ecx, byte ptr [ebx + offset IndexEntry.filename_len]
    mov esi, sizeof IndexEntry
    add esi, ebx
    mov edi, VA_SYSTEM + offset fs_utf8buf
    push ebx
      mov fs_bigendian, 0
      shl ecx, 1
      call fs_toutf8
      mov esi, VA_SYSTEM + offset fs_utf8buf
      mov edx, VA_SYSTEM + offset fd_buffer
      call fs_cmp
    pop ebx
  pop edi
  
  cmp al, -1  // smaller
  jnz l_nt_find_next_68
    
    l_nt_find_next_676:
    mov al, [ebx + offset IndexEntry.index_flags]
    test al, 1  // has subnode
    jz l_nt_find_next_66
    
    // has child
    movzx esi, word ptr [ebx + offset IndexEntry.index_entry_size]
    add esi, ebx
    mov esi, dword ptr [esi - 8]  // esi = subnode
    cmp esi, nt_subnode
    jz l_nt_find_next_69
      mov ebx, esi
      jmp l_nt_find_next_61
    
  l_nt_find_next_68:
  cmp al, 0
  jz l_nt_find_next_66
  
  movzx ecx, word ptr [ebx + offset IndexEntry.index_entry_size]
  add ebx, ecx
  jmp l_nt_find_next_65
  
l_nt_find_next_69:
// parent node found (nt_curnode = parent, ebx -> indexentry)
mov al, [ebx + offset IndexEntry.index_flags]
test al, 2  // last
jz l_nt_find_next_697
  mov eax, nt_curnode
  mov nt_subnode, eax
  mov ebx, nt_rootnode
  jmp l_nt_find_next_61
  
l_nt_find_next_697:
mov eax, nt_curnode
cmp eax, NT_SMALL_INDEX
jnz l_nt_find_next_698
  // small
  mov ecx, edi
  mov edx, ebx
  jmp short l_nt_find_next_699
  
l_nt_find_next_698:
  // large
  mov ecx, dword ptr [sizeof StandardIndexHeader + offset NodeHeader.ofs_end_index_entry_list + PA_NT_NODEBUF]
  mov edx, ebx
  sub edx, PA_NT_NODEBUF + sizeof StandardIndexHeader

l_nt_find_next_699:
mov esi, fs_srchofs
mov srch.Offset[esi], edx
mov srch.Size[esi], ecx
mov dword ptr srch.Cluster[esi], eax
jmp l_nt_find_next_2


l_nt_find_next_7:
mov al, 1

l_nt_find_next_9:
ret

// IN: esi = offset to files
// OUT: al = erc, edx:ecx = ftime
nt_get_mtime:
mov al, files.disk[esi]
cmp al, nt_ldiskn
jz l_nt_get_mtime_2
  push esi
    call nt_prepare
  pop esi

l_nt_get_mtime_2:
mov esi, files.file[esi]
call nt_load_file
test al, al
jnz l_nt_get_mtime_6

mov eax, NTFS_ATR_STANDARD_INFORMATION
call nt_find_atr
mov al, ERC_FS
test esi, esi
jz l_nt_get_mtime_6

mov edx, dword ptr [esi + sizeof StandardHeader + offset StandardInformation.modified + 4]
mov ecx, dword ptr [esi + sizeof StandardHeader + offset StandardInformation.modified + 0]
mov al, 0
ret

l_nt_get_mtime_6:
xor edx, edx
xor ecx, ecx
ret

// IN: al = ldiskn
// OUT: al = erc, edx:ecx = free bytes
// USES: fd_buffer, nt_tmp8, nt_disksize, nt_tmp
nt_diskfree:
cmp al, nt_ldiskn
jz l_nt_diskfree_1
  call nt_prepare
  
l_nt_diskfree_1:
xor eax, eax
mov dword ptr nt_tmp8[0], eax
mov dword ptr nt_tmp8[4], eax

// get disk size
mov ah, 4  // get disk size
mov al, nt_ldiskn
call nt_diskmain  // out edx:eax

mov cl, nt_cluzlog
mov ebx, edx
shr edx, cl
shr eax, cl
xor cl, 31
inc cl
shl ebx, cl
or eax, ebx  // edx:eax = size clusters

mov esi, eax
and esi, 0xFFF  // esi = size clusters % 4096
mov cl, 12
mov ebx, edx
shr edx, cl
shr eax, cl
mov cl, 32 - 12
shl ebx, cl
or eax, ebx  // edx:eax = size clusters / 4096
mov dword ptr nt_disksize[0], eax
mov dword ptr nt_disksize[4], edx

// get bitmap
xor ebx, ebx
xor edx, edx

l_nt_diskfree_5:
mov nt_tmp, 512
cmp dword ptr nt_disksize[0], 0
jnz l_nt_diskfree_51
  cmp dword ptr nt_disksize[4], 0
  jnz l_nt_diskfree_51
    // nt_disksize = 0
    mov nt_tmp, esi
    shr nt_tmp, 3
    jmp short l_nt_diskfree_52
    
l_nt_diskfree_51:
sub dword ptr nt_disksize[0], 1
sbb dword ptr nt_disksize[4], 0

l_nt_diskfree_52:
mov ecx, nt_tmp
mov edi, VA_SYSTEM + offset fd_buffer
mov al, nt_ldiskn
mov ah, 2  // read
push ebx
 push edx
  push esi
    add ebx, dword ptr nt_bitmapbase[0]
    adc edx, dword ptr nt_bitmapbase[4]
    call nt_diskmain
  pop esi
 pop edx
pop ebx
test al, al
jnz near l_nt_diskfree_x

xor ecx, ecx

l_nt_diskfree_55:  // process fd_buffer, keep edx, ebx
  mov al, fd_buffer[ecx]
  cmp al, 0
  jnz l_nt_diskfree_56
    add dword ptr nt_tmp8[0], 8
    adc dword ptr nt_tmp8[4], 0
    jmp short l_nt_diskfree_58
    
  l_nt_diskfree_56:
  cmp al, 255
  jz l_nt_diskfree_58
    
    mov ah, 8
    l_nt_diskfree_575:
      test al, 1
      jnz l_nt_diskfree_578
        add dword ptr nt_tmp8[0], 1
        adc dword ptr nt_tmp8[4], 0
        
      l_nt_diskfree_578:
      shr al, 1
      dec ah
      test ah, ah
      jnz l_nt_diskfree_575
    
  l_nt_diskfree_58:
  inc ecx
  cmp ecx, nt_tmp
  jb l_nt_diskfree_55

add ebx, 512
adc edx, 0

cmp dword ptr nt_disksize[0], 0
jnz near l_nt_diskfree_5
  cmp dword ptr nt_disksize[4], 0
  jnz near l_nt_diskfree_5

// out
mov edx, dword ptr nt_tmp8[4]
mov eax, dword ptr nt_tmp8[0]
mov cl, nt_cluzlog
mov ebx, eax
shl eax, cl
shl edx, cl
xor cl, 31
inc cl
shr ebx, cl
or edx, ebx
xchg eax, ecx

mov al, 0

l_nt_diskfree_9:
ret

l_nt_diskfree_x:
xor edx, edx
xor ecx, ecx
ret

fs_init:
// Clear files
xor esi, esi

l_fs_init_1:
  mov files.mode[esi], 0
  add esi, sizeof OpenFileRec
  cmp esi, sizeof OpenFileRec * MAX_FILES
  jb l_fs_init_1

// Clear srchrec
xor esi, esi
xor eax, eax
dec eax  // eax = -1

l_fs_init_5:
  mov srch.ThreadId[esi], ax
  add esi, sizeof InSrchRec
  cmp esi, sizeof InSrchRec * MAX_SRCH
  jb l_fs_init_5

// Init subs
call FAT12_init
call cd_init
call e2_init
call nt_init
ret

// IN: al = mode, es:edx -> fname, ah = take_link, bl = hack
// OUT: esi = fhandle
// mode: 1 read, 3 write, 10h append, 20h rewrite
fs_fopen:
call fs_enter

mov fs_mode, al
mov take_link, ah
mov link_depth, 0
mov fs_hack, bl

l_fs_fopen_0:
// find place
xor esi, esi

l_fs_fopen_1:
cmp files.mode[esi], 0
jz l_fs_fopen_found
  add esi, sizeof OpenFileRec
  cmp esi, MAX_FILES * sizeof OpenFileRec
  jb l_fs_fopen_1

    mov al, ERC_TOO_MANY_OPEN_FILES
    jmp l_fs_fopen_9

l_fs_fopen_found:
// mode
mov files.mode[esi], al

// threadid
mov eax, p_current
sub eax, VA_THREADS
shr eax, 12  // assert sizeof ThreadRec = 4096
mov files.threadid[esi], ax

// get disk from path/cd
call fs_disk  // KEEP ecx, esi, edi
mov files.disk[esi], al

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_open_50
  pop eax
  push eax
  call fs_load_fsid  // KEEP edx, ebx, esi, edi

l_fs_open_50:
cmp al, FSID_EXT2
jnz l_fs_open_51
  // EXT2
  pop eax
  call e2_fopen
  jmp short l_fs_fopen_9

l_fs_open_51:
cmp al, FSID_NTFS
jnz l_fs_open_52
  // NTFS
  pop eax
  call nt_fopen
  jmp short l_fs_fopen_9

l_fs_open_52:
cmp al, FSID_FAT12
jnz l_fs_open_53
  // FAT12
  pop eax
  call FAT12_fopen
  jmp short l_fs_fopen_9

l_fs_open_53:
cmp al, FSID_CD
jnz l_fs_open_59
  // CD
  pop eax
  call cd_fopen
  jmp short l_fs_fopen_9

l_fs_open_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_fopen_9:
cmp al, ERC_LINK
jnz l_fs_fopen_99
  mov al, fs_mode
  jmp l_fs_fopen_0
  
l_fs_fopen_99:
call fs_leave
ret

// IN: esi = fhandle, es:edi -> data, ecx = size
fs_fread:
call fs_enter

call fs_check_thread_esi
or al, al
jnz l_fs_fread_9

// fsid
push edi
movzx edi, files.disk[esi]
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_fread_50
  mov al, files.disk[esi]
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_fread_50:
cmp al, FSID_EXT2
jnz l_fs_fread_51
  pop edi
  call e2_fread
  jmp short l_fs_fread_9

l_fs_fread_51:
cmp al, FSID_NTFS
jnz l_fs_fread_52
  pop edi
  call nt_fread
  jmp short l_fs_fread_9

l_fs_fread_52:
cmp al, FSID_FAT12
jnz l_fs_fread_53
  pop edi
  call FAT12_fread
  jmp short l_fs_fread_9

l_fs_fread_53:
cmp al, FSID_CD
jnz l_fs_fread_59
  pop edi
  call cd_fread
  jmp short l_fs_fread_9

l_fs_fread_59:
pop edi
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_fread_9:
call fs_leave
ret

// IN: esi = fhandle, es:edi -> data, ecx = size
fs_fwrite:
call fs_enter

call fs_check_thread_esi
or al, al
jnz l_fs_fwrite_9

// fsid
push edi
movzx edi, files.disk[esi]
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_fwrite_50
  mov al, files.disk[esi]
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_fwrite_50:
cmp al, FSID_EXT2
jnz l_fs_fwrite_51
  pop edi
  call e2_fwrite
  jmp short l_fs_fwrite_9

l_fs_fwrite_51:
cmp al, FSID_NTFS
jnz l_fs_fwrite_52
  pop edi
  //... NTFS_fwrite
  mov al, ERC_READ_ONLY
  jmp short l_fs_fwrite_9

l_fs_fwrite_52:
cmp al, FSID_FAT12
jnz l_fs_fwrite_53
  pop edi
  call FAT12_fwrite
  jmp short l_fs_fwrite_9

l_fs_fwrite_53:
cmp al, FSID_CD
jnz l_fs_fwrite_59
  mov al, ERC_READ_ONLY
  jmp short l_fs_fwrite_9

l_fs_fwrite_59:
pop edi
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_fwrite_9:
call fs_leave
ret

// IN: esi = fhandle, edx:ebx = file offset
fs_fsetpos:
call fs_enter

call fs_check_thread_esi
or al, al
jnz l_fs_fsetpos_9

// fsid
movzx edi, byte ptr files.disk[esi]
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_fsetpos_50
  mov al, files.disk[esi]
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_fsetpos_50:
cmp al, FSID_EXT2
jnz l_fs_fsetpos_51
  call e2_fsetpos
  jmp short l_fs_fsetpos_9

l_fs_fsetpos_51:
cmp al, FSID_NTFS
jnz l_fs_fsetpos_52
  call nt_fsetpos
  jmp short l_fs_fsetpos_9

l_fs_fsetpos_52:
cmp al, FSID_FAT12
jnz l_fs_fsetpos_53
  call FAT12_fsetpos
  jmp short l_fs_fsetpos_9

l_fs_fsetpos_53:
cmp al, FSID_CD
jnz l_fs_fsetpos_59
  call cd_fsetpos
  jmp short l_fs_fsetpos_9

l_fs_fsetpos_59:
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_fsetpos_9:
call fs_leave
ret

// IN: esi = fhandle
fs_fcut:
call fs_enter

call fs_check_thread_esi
or al, al
jnz l_fs_fcut_9

// fsid
movzx edi, files.disk[esi]
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_fcut_50
  mov al, files.disk[esi]
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_fcut_50:
cmp al, FSID_EXT2
jnz l_fs_fcut_51
  call e2_fcut
  jmp short l_fs_fcut_9

l_fs_fcut_51:
cmp al, FSID_NTFS
jnz l_fs_fcut_52
  //... NTFS_fcut
  mov al, ERC_READ_ONLY
  jmp short l_fs_fcut_9

l_fs_fcut_52:
cmp al, FSID_FAT12
jnz l_fs_fcut_59
  call FAT12_fcut
  jmp short l_fs_fcut_9

l_fs_fcut_59:
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_fcut_9:
call fs_leave
ret

// IN: esi = fhandle
fs_fclose:
call fs_enter

call fs_check_thread_esi
or al, al
jnz l_fs_fclose_9

// fsid
movzx edi, files.disk[esi]
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_fclose_50
  mov al, files.disk[esi]
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_fclose_50:
cmp al, FSID_EXT2
jnz l_fs_fclose_51
  call e2_fclose
  jmp short l_fs_fclose_9

l_fs_fclose_51:
cmp al, FSID_NTFS
jnz l_fs_fclose_52
  call nt_fclose
  jmp short l_fs_fclose_9

l_fs_fclose_52:
cmp al, FSID_FAT12
jnz l_fs_fclose_53
  call FAT12_fclose
  jmp short l_fs_fclose_9

l_fs_fclose_53:
cmp al, FSID_CD
jnz l_fs_fclose_59
  call cd_fclose
  jmp short l_fs_fclose_9

l_fs_fclose_59:
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_fclose_9:
call fs_leave
ret

// IN: es:edx -> path & dirname, ah = take_link
fs_md:
call fs_enter

mov take_link, ah
mov link_depth, 0

l_fs_md_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_md_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_md_50:
cmp al, FSID_EXT2
jnz l_fs_md_51
  pop eax
  call e2_md
  jmp short l_fs_md_9

l_fs_md_51:
cmp al, FSID_NTFS
jnz l_fs_md_52
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_md_9

l_fs_md_52:
cmp al, FSID_FAT12
jnz l_fs_md_53
  pop eax
  call FAT12_md
  jmp short l_fs_md_9

l_fs_md_53:
cmp al, FSID_CD
jnz l_fs_md_59
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_md_9

l_fs_md_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_md_9:
cmp al, ERC_LINK
jz l_fs_md_0

call fs_leave
ret

// IN: es:edx -> path, ah = take_link
fs_cd:
call fs_enter
sub esp, MAX_PATH

mov take_link, ah
mov link_depth, 0

l_fs_cd_0:
// merge
mov esi, p_current
add esi, offset ThreadRec.curdirtext

mov edi, esp
call fs_merge
or al, al
jnz near l_fs_cd_9

// disk
mov edx, esp
mov al, [es:edx]

and al, 31
add edx, 3

cmp byte[es:edx], 0
jnz l_fs_cd_2
  mov edi, p_current
  or al, 96
  mov [es:edi + offset ThreadRec.curdisk], al
  xor ebx, ebx
  mov [es:edi + offset ThreadRec.curdir], ebx
  mov al, 0
  jmp l_fs_cd_55
  
l_fs_cd_2:

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_cd_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_cd_50:
cmp al, FSID_EXT2
jnz l_fs_cd_51
  pop eax
  call e2_cd
  jmp short l_fs_cd_55

l_fs_cd_51:
cmp al, FSID_NTFS
jnz l_fs_cd_52
  pop eax
  call nt_cd
  jmp short l_fs_cd_55

l_fs_cd_52:
cmp al, FSID_FAT12
jnz l_fs_cd_53
  pop eax
  call FAT12_cd
  jmp short l_fs_cd_55

l_fs_cd_53:
cmp al, FSID_CD
jnz l_fs_cd_59
  pop eax
  call cd_cd
  //jmp short l_fs_cd_55

// Copy curdirtext
l_fs_cd_55:
or al, al
jnz l_fs_cd_9
  mov esi, esp
  mov edi, p_current
  add edi, offset ThreadRec.curdirtext
  mov ecx, MAX_PATH
  cld
  
  l_fs_cd_56:
    mov al, [es:esi]
    inc esi
    stosb
    cmp al, 0
    jz l_fs_cd_57
      loop l_fs_cd_56
  
  l_fs_cd_57:
  xor eax, eax
  jmp short l_fs_cd_9

l_fs_cd_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_cd_9:
cmp al, ERC_LINK
jz near l_fs_cd_0

add esp, MAX_PATH
call fs_leave
ret

// IN: es:edx -> filename, ah = take_link
fs_rm:
call fs_enter

mov take_link, ah
mov link_depth, 0

l_fs_rm_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_rm_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_rm_50:
cmp al, FSID_EXT2
jnz l_fs_rm_51
  pop eax
  call e2_rm
  jmp short l_fs_rm_9

l_fs_rm_51:
cmp al, FSID_NTFS
jnz l_fs_rm_52
  pop eax
  //... NTFS_rm
  mov al, ERC_READ_ONLY
  jmp short l_fs_rm_9

l_fs_rm_52:
cmp al, FSID_FAT12
jnz l_fs_rm_53
  pop eax
  call FAT12_rm
  jmp short l_fs_rm_9

l_fs_rm_53:
cmp al, FSID_CD
jnz l_fs_rm_59
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_rm_9

l_fs_rm_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_rm_9:
cmp al, ERC_LINK
jz l_fs_rm_0

call fs_leave
ret

// IN: es:edx -> filename, es:esi -> new filename, ah = take_link
fs_rename:
call fs_enter

mov take_link, ah
mov link_depth, 0

l_fs_rename_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_rename_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_rename_50:
cmp al, FSID_EXT2
jnz l_fs_rename_51
  pop eax
  call e2_rename
  jmp short l_fs_rename_9

l_fs_rename_51:
cmp al, FSID_NTFS
jnz l_fs_rename_52
  pop eax
  //... NTFS_rename
  mov al, ERC_READ_ONLY
  jmp short l_fs_rename_9

l_fs_rename_52:
cmp al, FSID_FAT12
jnz l_fs_rename_53
  pop eax
  call FAT12_rename
  jmp short l_fs_rename_9

l_fs_rename_53:
cmp al, FSID_CD
jnz l_fs_rename_59
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_rename_9

l_fs_rename_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_rename_9:
cmp al, ERC_LINK
jz l_fs_rename_0

call fs_leave
ret

// IN: es:edx -> filename, es:esi -> new path, ah = take_link
fs_move:
call fs_enter

mov take_link, ah
mov link_depth, 0

l_fs_move_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_move_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_move_50:
cmp al, FSID_EXT2
jnz l_fs_move_51
  pop eax
  call e2_move
  jmp short l_fs_move_9

l_fs_move_51:
cmp al, FSID_NTFS
jnz l_fs_move_52
  pop eax
  //... NTFS_move
  mov al, ERC_READ_ONLY
  jmp short l_fs_move_9

l_fs_move_52:
cmp al, FSID_FAT12
jnz l_fs_move_53
  pop eax
  call FAT12_move
  jmp short l_fs_move_9

l_fs_move_53:
cmp al, FSID_CD
jnz l_fs_move_59
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_move_9

l_fs_move_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_move_9:
cmp al, ERC_LINK
jz l_fs_move_0

call fs_leave
ret

// IN: edx -> path&mask, edi -> SearchRec, ah = take_link
fs_find_first:
call fs_enter

mov take_link, ah
mov link_depth, 0

mov ebx, p_current
sub ebx, VA_THREADS
shr ebx, 12  // assert sizeof ThreadRec = 4096

// Find free pos  IN: bx = threadid
xor esi, esi
xor eax, eax
dec eax

l_fs_first_3:
cmp esi, sizeof InSrchRec * MAX_SRCH
jnb l_fs_first_4
  cmp srch.ThreadId[esi], ax
  jz l_fs_first_5
    add esi, sizeof InSrchRec
    jmp l_fs_first_3
  
l_fs_first_4:
mov al, ERC_TOO_MANY_SEARCHES
jmp l_fs_first_9

l_fs_first_5:
mov srch.ThreadId[esi], bx
cmp edi, VA_SYSTEM
jb l_fs_first_508
  mov al, ERC_INVALID_SHANDLE
  jmp l_fs_first_9

l_fs_first_508:
mov dword ptr [es:edi + offset SearchRec.Reserved], esi
mov fs_rec, edi
mov fs_srchofs, esi
mov fs_dosplit, 1

l_fs_first_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx  KEEP esi
mov srch.Disk[esi], al

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_first_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_first_50:
cmp al, FSID_EXT2
jnz l_fs_first_51
  pop eax
  call e2_find_first
  jmp short l_fs_first_9

l_fs_first_51:
cmp al, FSID_NTFS
jnz l_fs_first_52
  pop eax
  call nt_find_first
  jmp short l_fs_first_9

l_fs_first_52:
cmp al, FSID_FAT12
jnz l_fs_first_53
  pop eax
  call FAT12_find_first
  jmp short l_fs_first_9

l_fs_first_53:
cmp al, FSID_CD
jnz l_fs_first_59
  pop eax
  call cd_find_first
  jmp short l_fs_first_9

l_fs_first_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_first_9:
cmp al, ERC_LINK
jnz l_fs_first_99
  mov fs_dosplit, 0
  mov esi, fs_srchofs
  jmp l_fs_first_0
  
l_fs_first_99:
call fs_leave
ret

// IN: es:edi -> SearchRec
fs_find_next:
call fs_enter

cmp edi, VA_SYSTEM
jnb l_fs_next_3

mov ebx, p_current
sub ebx, VA_THREADS
shr ebx, 12  // assert sizeof ThreadRec = 4096

mov esi, dword ptr [es:edi + offset SearchRec.Reserved]
cmp esi, sizeof InSrchRec * MAX_SRCH - sizeof InSrchRec
ja l_fs_next_3

cmp srch.ThreadId[esi], bx
jz l_fs_next_4

  l_fs_next_3:
  mov al, ERC_INVALID_SHANDLE
  jmp l_fs_next_9
  
l_fs_next_4:
mov fs_rec, edi
mov fs_srchofs, esi
mov al, srch.Disk[esi]

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_next_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_next_50:
cmp al, FSID_EXT2
jnz l_fs_next_51
  pop eax
  call e2_find_next
  jmp short l_fs_next_9

l_fs_next_51:
cmp al, FSID_NTFS
jnz l_fs_next_52
  pop eax
  call nt_find_next
  jmp short l_fs_next_9

l_fs_next_52:
cmp al, FSID_FAT12
jnz l_fs_next_53
  pop eax
  call FAT12_find_next
  jmp short l_fs_next_9

l_fs_next_53:
cmp al, FSID_CD
jnz l_fs_next_59
  pop eax
  call cd_find_next
  jmp short l_fs_next_9

l_fs_next_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_next_9:
call fs_leave
ret

// IN: es:edi -> SearchRec
fs_find_close:
call fs_enter

cmp edi, VA_SYSTEM
jnb l_fs_find_close_3

mov ebx, p_current
sub ebx, VA_THREADS
shr ebx, 12  // assert sizeof ThreadRec = 4096

mov esi, dword ptr [es:edi + offset SearchRec.Reserved]
cmp esi, sizeof InSrchRec * MAX_SRCH - sizeof InSrchRec
ja l_fs_find_close_3

cmp srch.ThreadId[esi], bx
jz l_fs_find_close_4

  l_fs_find_close_3:
  mov al, ERC_INVALID_SHANDLE
  jmp l_fs_find_close_9
  
l_fs_find_close_4:
mov word ptr srch.ThreadId[esi], -1
mov al, 0

l_fs_find_close_9:
call fs_leave
ret

// IN: es:edx -> filename, esi = atrbs
fs_chmod:
call fs_enter

l_fs_chmod_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_chmod_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_chmod_50:
cmp al, FSID_EXT2
jnz l_fs_chmod_51
  pop eax
  call e2_chmod
  jmp short l_fs_chmod_9

l_fs_chmod_51:
cmp al, FSID_NTFS
jnz l_fs_chmod_52
  pop eax
  //... NTFS_chmod
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_chmod_9

l_fs_chmod_52:
cmp al, FSID_FAT12
jnz l_fs_chmod_53
  pop eax
  call FAT12_chmod
  jmp short l_fs_chmod_9

l_fs_chmod_53:
cmp al, FSID_CD
jnz l_fs_chmod_59
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_chmod_9

l_fs_chmod_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_chmod_9:
cmp al, ERC_LINK
jz l_fs_chmod_0

call fs_leave
ret

// IN: esi = ldiskn
fs_resetdisk:
and esi, 31

call fs_enter

push esi

shl esi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[esi]
or al, al
jnz l_fs_reset_50
  pop eax
  push eax
  mov edi, esi
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_reset_50:
cmp al, FSID_EXT2
jnz l_fs_reset_51
  pop eax
  mov e2_ldiskn, -1
  mov disk_info.fsid[esi], 0
  mov al, 0
  jmp short l_fs_reset_9

l_fs_reset_51:
cmp al, FSID_NTFS
jnz l_fs_reset_52
  pop eax
  mov nt_ldiskn, -1
  mov disk_info.fsid[esi], 0
  mov al, 0
  jmp short l_fs_reset_9

l_fs_reset_52:
cmp al, FSID_FAT12
jnz l_fs_reset_53
  pop eax
  mov FAT12_ldiskn, -1
  jmp short l_fs_reset_9

l_fs_reset_53:
cmp al, FSID_CD
jnz l_fs_reset_59
  pop eax
  call cd_devicechange
  jmp short l_fs_reset_9

l_fs_reset_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_reset_9:
call fs_leave
ret

// IN: ebx = fhandle
// OUT: al = erc, edx:ecx = ftime
fs_get_mtime:
call fs_enter

mov esi, ebx
call fs_check_thread_esi
or al, al
jnz l_fs_get_mtime_9

// fsid
push edi
movzx edi, files.disk[esi]
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_get_mtime_50
  mov al, files.disk[esi]
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_get_mtime_50:
cmp al, FSID_EXT2
jnz l_fs_get_mtime_51
  pop edi
  // EXT2
  call e2_get_mtime
  jmp short l_fs_get_mtime_9

l_fs_get_mtime_51:
cmp al, FSID_NTFS
jnz l_fs_get_mtime_52
  pop edi
  // NTFS
  call nt_get_mtime
  jmp short l_fs_get_mtime_9

l_fs_get_mtime_52:
cmp al, FSID_FAT12
jnz l_fs_get_mtime_53
  pop edi
  // FAT12
  call FAT12_get_mtime
  jmp short l_fs_get_mtime_9

l_fs_get_mtime_53:
cmp al, FSID_CD
jnz l_fs_get_mtime_59
  pop edi
  call cd_get_mtime
  jmp short l_fs_get_mtime_9

l_fs_get_mtime_59:
pop edi
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_get_mtime_9:
call fs_leave
ret

// IN: ebx = fhandle, edx:ecx = ftime
// OUT: al = erc
fs_set_mtime:
call fs_enter

mov esi, ebx
call fs_check_thread_esi
or al, al
jnz l_fs_set_mtime_9

// fsid
push edi
movzx edi, files.disk[esi]
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_set_mtime_50
  mov al, files.disk[esi]
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_set_mtime_50:
cmp al, FSID_EXT2
jnz l_fs_set_mtime_51
  pop edi
  // EXT2
  call e2_set_mtime
  jmp short l_fs_set_mtime_9

l_fs_set_mtime_51:
cmp al, FSID_NTFS
jnz l_fs_set_mtime_52
  pop edi
  //... NTFS_set_mtime
  mov al, ERC_READ_ONLY
  jmp short l_fs_set_mtime_9

l_fs_set_mtime_52:
cmp al, FSID_FAT12
jnz l_fs_set_mtime_53
  pop edi
  // FAT12
  call FAT12_set_mtime
  jmp short l_fs_set_mtime_9

l_fs_set_mtime_53:
cmp al, FSID_CD
jnz l_fs_set_mtime_59
  pop edi
  mov al, ERC_READ_ONLY
  jmp short l_fs_set_mtime_9

l_fs_set_mtime_59:
pop edi
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_set_mtime_9:
call fs_leave
ret

// IN: esi = ldiskn
// OUT: al = erc, edx:ecx = free bytes
fs_diskfree:
call fs_enter

// fsid
mov eax, esi
and al, 31
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_diskfree_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_diskfree_50:
cmp al, FSID_EXT2
jnz l_fs_diskfree_51
  pop eax
  call e2_diskfree
  jmp short l_fs_diskfree_9

l_fs_diskfree_51:
cmp al, FSID_NTFS
jnz l_fs_diskfree_52
  pop eax
  call nt_diskfree
  jmp short l_fs_diskfree_9

l_fs_diskfree_52:
cmp al, FSID_FAT12
jnz l_fs_diskfree_53
  pop eax
  call FAT12_diskfree
  jmp short l_fs_diskfree_9

l_fs_diskfree_53:
cmp al, FSID_CD
jnz l_fs_diskfree_59
  pop eax
  xor ecx, ecx
  xor edx, edx
  mov al, 0
  jmp short l_fs_diskfree_9

l_fs_diskfree_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_diskfree_9:
call fs_leave
ret

// only starter, root
// IN: es:edx -> filenamez, esi = new owner
// OUT: al = erc
fs_chown:
call fs_enter

l_fs_chown_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_chown_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_chown_50:
cmp al, FSID_EXT2
jnz l_fs_chown_51
  pop eax
  call e2_chown
  jmp short l_fs_chown_9

l_fs_chown_51:
cmp al, FSID_NTFS
jnz l_fs_chown_52
  pop eax
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_chown_9

l_fs_chown_52:
cmp al, FSID_FAT12
jnz l_fs_chown_53
  pop eax
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_chown_9

l_fs_chown_53:
cmp al, FSID_CD
jnz l_fs_chown_59
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_chown_9

l_fs_chown_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_chown_9:
cmp al, ERC_LINK
jz l_fs_chown_0

call fs_leave
ret

// only starter, root or owner
// IN: es:edx -> filenamez, esi = new group
// OUT: al = erc
fs_chgrp:
call fs_enter

l_fs_chgrp_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_chgrp_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_chgrp_50:
cmp al, FSID_EXT2
jnz l_fs_chgrp_51
  pop eax
  call e2_chgrp
  jmp short l_fs_chgrp_9

l_fs_chgrp_51:
cmp al, FSID_NTFS
jnz l_fs_chgrp_52
  pop eax
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_chgrp_9

l_fs_chgrp_52:
cmp al, FSID_FAT12
jnz l_fs_chgrp_53
  pop eax
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_chgrp_9

l_fs_chgrp_53:
cmp al, FSID_CD
jnz l_fs_chgrp_59
  pop eax
  mov al, ERC_READ_ONLY
  jmp short l_fs_chgrp_9

l_fs_chgrp_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_chgrp_9:
cmp al, ERC_LINK
jz l_fs_chgrp_0

call fs_leave
ret

// IN: es:edx -> filenamez
// OUT: al = erc, ecx = uid, edx = gid
fs_fuidgid:
call fs_enter

mov take_link, 0
mov link_depth, 0

l_fs_fuidgid_0:
// get disk from path/cd
call fs_disk  // IN/OUT edx

// fsid
push eax
movzx edi, al
shl edi, 5  // assert sizeof DiskInfoRec = 32
mov al, disk_info.fsid[edi]
or al, al
jnz l_fs_fuidgid_50
  pop eax
  push eax
  call fs_load_fsid  // keep edx, ebx, esi, edi

l_fs_fuidgid_50:
cmp al, FSID_EXT2
jnz l_fs_fuidgid_51
  pop eax
  call e2_find_file
  test al, al
  jnz l_fs_fuidgid_506
    call e2_load_inode
    test al, al
    jnz l_fs_fuidgid_506
      movzx ecx, word ptr e2_inode.i_uid
      movzx edx, word ptr e2_inode.i_gid
      
      //mov bl, e2_ldiskn
      //shl ebx, 24
      //or ecx, ebx
      //or edx, ebx
      jmp short l_fs_fuidgid_9
      
  l_fs_fuidgid_506:
  cmp al, ERC_LINK
  jz l_fs_fuidgid_0

  xor ecx, ecx
  xor edx, edx
  jmp short l_fs_fuidgid_9

l_fs_fuidgid_51:
cmp al, FSID_NTFS
jnz l_fs_fuidgid_52
  pop eax
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_fuidgid_9

l_fs_fuidgid_52:
cmp al, FSID_FAT12
jnz l_fs_fuidgid_53
  pop eax
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_fuidgid_9

l_fs_fuidgid_53:
cmp al, FSID_CD
jnz l_fs_fuidgid_59
  pop eax
  mov al, ERC_NOT_IMPLEMENTED
  jmp short l_fs_fuidgid_9

l_fs_fuidgid_59:
pop eax
mov al, ERC_UNKNOWN_FILESYSTEM

l_fs_fuidgid_9:

call fs_leave
ret

get_user_fname: db "c:/users/users.sys\0"
get_group_fname: db "c:/users/groups.sys\0"

// IN: users_disk
// OUT: al = users_disk
// KEEP: ecx, edi
get_users_disk:
cmp users_disk, 0
jnz l_get_users_disk_9
  push ecx
   push edi
    mov users_disk, 'C'
    
    l_get_users_disk_5:
    mov al, users_disk
    mov [PA_KERNEL_CODE + offset get_user_fname], al
    mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset get_user_fname
    mov al, FOPEN_READ
    mov ah, 0  // fs_takelink
    mov bl, 0  // fs_hack
    call fs_fopen
    test al, al
    jz l_get_users_disk_6
      // errors to repeat
      cmp al, ERC_TOO_MANY_OPEN_FILES
      jnz l_get_users_disk_54
        
        l_get_users_disk_53:
        call p_noop
        jmp l_get_users_disk_5
        
      l_get_users_disk_54:
      cmp al, ERC_BUSY
      jz l_get_users_disk_53
      
      // next disk
      inc users_disk
      cmp users_disk, 'Z'
      jna l_get_users_disk_5
        // '['
        jmp l_get_users_disk_8
      
    l_get_users_disk_6:
    call fs_fclose
    
    l_get_users_disk_8:
   pop edi
  pop ecx
  
l_get_users_disk_9:
mov al, users_disk
ret

// IN: ecx = uid, edi -> byte[256]
get_user:
and ecx, 0xFFFFFF
call get_users_disk  // keep ecx, edi
mov [PA_KERNEL_CODE + offset get_user_fname], al
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset get_user_fname
mov al, FOPEN_READ
mov ah, 0  // fs_takelink
mov bl, 1  // fs_hack
push ecx
 push edi
  call fs_fopen
 pop edi
pop ecx
test al, al
jnz l_get_user_9

xor edx, edx
mov ebx, ecx
shl ebx, 8  // assert sizeof UserInfo = 256
push esi
 push edi
  call fs_fsetpos
 pop edi
pop esi

mov ecx, 256  // assert sizeof UserInfo = 256
push esi
 push edi
  call fs_fread
 pop edi
pop esi

push ecx
  add edi, 128
  mov ecx, 64
  xor eax, eax
  cld
  rep stosb
  
  call fs_fclose
pop ecx

l_get_user_9:
ret

// IN: ecx = gid, edi -> byte[256]
// USES: fd_buffer
get_group:
and ecx, 0xFFFFFF
call get_users_disk  // keep ecx, edi
mov [PA_KERNEL_CODE + offset get_group_fname], al
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset get_group_fname
mov al, FOPEN_READ
mov ah, 0  // fs_takelink
mov bl, 1  // fs_hack
push ecx
 push edi
  call fs_fopen
 pop edi
pop ecx
test al, al
jnz l_get_group_9

push edi
  
  l_get_group_5:
  jecxz l_get_group_6
    
    push ecx
    
      mov ecx, 256  // assert sizeof GroupInfo = 256
      mov edi, VA_SYSTEM + offset fd_buffer
      push esi
        call fs_fread
      pop esi
      
      push esi
        mov eax, dword ptr fd_buffer[256 - 4]
        shl eax, 2
        
        shl esi, 5 // assert sizeof OpenFileRec = 32
        mov ebx, dword ptr files.pos[esi]
        mov edx, dword ptr files.pos[esi + 4]
        add ebx, eax
        adc edx, 0
        shr esi, 5 // assert sizeof OpenFileRec = 32
        
        call fs_fsetpos
      pop esi
    
    pop ecx
    
    loop l_get_group_5  
    
  l_get_group_6:
pop edi

mov ecx, 256  // assert sizeof GroupInfo = 256
push esi
  call fs_fread
pop esi

push ecx
  call fs_fclose
pop ecx

l_get_group_9:
ret

logfn: db "c:/log.txt\0"

loginit:
mov al, FOPEN_CREATE
mov ah, 0  // fs_takelink
mov bl, 0  // fs_hack
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset logfn
call fs_fopen
call fs_fclose
// flush
movzx esi, byte ptr [cs:offset logfn]
mov ah, 39 
int 20h
ret

// IN: eax = number, ecx = system, esi = fhandle
// KEEP: esi
lognum:
sub esp, 36

// Parse digits from the number

push esi
  
  mov esi, esp
  add esi, 36
  
  cmp ecx, 2
  jnb l_lognum_1
    mov ecx, 10  // ecx must be >= 2
  
  l_lognum_1:
    xor edx, edx
    div ecx
    cmp dl, 10
    jnb l_lognum_2
      add dl, '0'
      jmp short l_lognum_3
    
    l_lognum_2:
    add dl, 55
    
    l_lognum_3:
    dec esi
    mov [ss:esi], dl
    test eax, eax
    jnz l_lognum_1
  
  mov dl, ' '
  dec esi
  mov [ss:esi], dl
  
  mov ecx, esp
  add ecx, 36
  sub ecx, esi  // ecx = len

  // Write it
  mov edi, esi
pop esi  
push esi
  // IN: esi = fhandle, es:edi -> data, ecx = size
  call fs_fwrite
pop esi

add esp, 36
ret

logeoln: db "\n\0"
logtid: db "tid\0"
logeip: db ", eip\0"
logacdb: db ", acdb\0"
logsbsd: db ", sbsd\0"

log:
pushad
  // IN: al = mode, es:edx -> fname, ah = take_link
  // OUT: esi = fhandle
  // mode: 1 read, 3 write, 10h append, 20h rewrite
  mov al, FOPEN_APPEND
  mov ah, 0  // fs_takelink
  mov bl, 0  // fs_hack
  mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset logfn
  call fs_fopen
  
  push esi
    // IN: esi = fhandle, es:edi -> data, ecx = size
    mov edi, VA_SYSTEM + PA_KERNEL_CODE + offset logtid
    mov ecx, 3
    call fs_fwrite
  pop esi
  mov eax, p_current
  sub eax, VA_THREADS
  shr eax, 12  // assert sizeof ThreadRec = 4096
  mov ecx, 16
  call lognum
  
  push esi
    // IN: esi = fhandle, es:edi -> data, ecx = size
    mov edi, VA_SYSTEM + PA_KERNEL_CODE + offset logeip
    mov ecx, 5
    call fs_fwrite
  pop esi
  mov eax, [ss:esp + (8 * 4)]
  mov ecx, 16
  call lognum
  
  push esi
    // IN: esi = fhandle, es:edi -> data, ecx = size
    mov edi, VA_SYSTEM + PA_KERNEL_CODE + offset logacdb
    mov ecx, 6
    call fs_fwrite
  pop esi
  mov eax, [ss:esp + (7 * 4)]
  mov ecx, 16
  call lognum
  mov eax, [ss:esp + (6 * 4)]
  mov ecx, 16
  call lognum
  mov eax, [ss:esp + (5 * 4)]
  mov ecx, 16
  call lognum
  mov eax, [ss:esp + (4 * 4)]
  mov ecx, 16
  call lognum
  
  push esi
    // IN: esi = fhandle, es:edi -> data, ecx = size
    mov edi, VA_SYSTEM + PA_KERNEL_CODE + offset logsbsd
    mov ecx, 6
    call fs_fwrite
  pop esi
  mov eax, [ss:esp + (3 * 4)]
  mov ecx, 16
  call lognum
  mov eax, [ss:esp + (2 * 4)]
  mov ecx, 16
  call lognum
  mov eax, [ss:esp + (1 * 4)]
  mov ecx, 16
  call lognum
  mov eax, [ss:esp + (0 * 4)]
  mov ecx, 16
  call lognum
  
  // close
  push esi
    // IN: esi = fhandle, es:edi -> data, ecx = size
    mov edi, VA_SYSTEM + PA_KERNEL_CODE + offset logeoln
    mov ecx, 1
    call fs_fwrite
  pop esi
  
  call fs_fclose
  
  // flush
  movzx esi, byte ptr [cs:offset logfn]
  mov ah, 39 
  int 20h
  
popad
ret

uns1 buf[1024]

printlog:
// print
mov al, FOPEN_READ
mov ah, 0
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset logfn
call fs_fopen
push esi
  // IN: esi = fhandle, es:edi -> data, ecx = size
  mov edi, VA_SYSTEM + offset buf
  push edi
    mov ecx, 1024
    call fs_fread
  pop esi
  mov bl, 0Bh
  call s_write
  
pop esi
call fs_fclose

// wait for esc
l_printlog_5:
in al, 60h
cmp al, 1
jnz l_printlog_5

ret

fdisk:
/*
mov dword ptr hd_buffer[1BEh + 8], 0
mov dword ptr hd_buffer[1BEh + 12], 400000h
mov hdt_pdiskn, 0
xor edx, edx
xor ebx, ebx
mov ecx, 1
mov edi, VA_SYSTEM + offset hd_buffer
// IN: hdt_pdiskn, edx:ebx = sector, ecx = count, es:edi -> buffer
// OUT: al = erc, edx:ebx = next sector
call h_sd_p_write
*/
ret

tms1: db "A\0"

test_mouse:
sti

__5:
call p_msg_get
cmp al, ERC_MSG_QUEUE_EMPTY
jz __5

cmp ecx, WM_MOUSEMOVE
jnz __6
  mov ecx, edx
  movsx ecx, cx
  shr edx, 16
  movsx edx, dx
  mov ebx, edx
  mov esi, ecx
  mov edi, ebx
  add esi, 40
  add edi, 40
  call g_paint
  jmp __5
  
__6:
cmp ecx, WM_KEYDOWN
jnz __5

mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset tms1
mov ecx, 1
mov bl, 0Ah
call s_write
jmp __5

ret

uns8 utime, utime2
SystemTime systime, systime2

test_dtm:
mov systime.wYear, 2028
mov systime.wMonth, 3
mov systime.wDay, 1
mov systime.wHour, 0
mov systime.wMinute, 0
mov systime.wSecond, 0
mov systime.wMilliseconds, 0
// IN: es:edi -> systemtime, es:esi -> ftime, max year = 32767
mov edi, offset systime + VA_SYSTEM
mov esi, offset utime + VA_SYSTEM
call t_systime2ftime

// IN: es:esi -> ftime, es:edi -> systemtime
mov edi, offset systime + VA_SYSTEM
mov esi, offset utime + VA_SYSTEM
call t_ftime2systime

// IN: eax = number, ecx = base, cur_pos, bl = color, ds
movzx eax, systime.wYear
mov ecx, 10
mov bl, 0Bh
call writen

movzx eax, systime.wMonth
mov ecx, 10
mov bl, 0Bh
call writen

movzx eax, systime.wDay
mov ecx, 10
mov bl, 0Bh
call writen

l91:jmp l91
ret

te2c_str1: db "abc/def\0"
te2c_str2: db "ABC\0"

test_ext2:
//call test_ext2_dir
//call test_ext2_view
ret

mov al, 3
call e2_prepare
call write_diskinfo
l1: jmp l1

/*
mov ebx, EXT2_ROOT_INO
call e2_load_inode
call winode

call ww
*/

//call test_ext2_alloc
//call test_ext2_alloc_inode
//call test_ext2_io
//call test_ext2_delete
//call test_ext2_md
//call test_ext2_link
//call test_ext2_backup
/*
mov al, 4  // D:
mov dl, 0  // no system
mov edi, 2 // block size 1 << 2 * 1024
call e2_format
mov al, 4  // D:
mov ah, 5  // flush
call e2_diskmain
*/
//l1: jmp l1

/*
// test_fs_cmp
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset te2c_str1
mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset te2c_str2
call fs_cmp
push edi
  movzx eax, al
  mov ecx, 16
  call writen
pop eax
mov ecx, 16
call writen
l1: jmp l1
*/

//mov ecx, 30 * 1024 * 1024
//call create_ramdisk
//call e2_prepare
ret

GROUPN = 0

int4 pos1

test_ext2_view:
mov al, 3
call e2_prepare
mov pos1, 0

l_test_ext2_view_5:
  // load left
  mov ebx, GROUPN
  call e2_load_group
  
  mov ebx, e2_gb.bg_block_bitmap
  //mov ebx, e2_gb.bg_inode_bitmap
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  mov edx, ebx
  shl ebx, cl
  xor cl, 31
  inc cl
  shr edx, cl
  mov eax, pos1
  shr eax, 3
  add ebx, eax
  adc edx, 0
  
  mov edi, VA_SYSTEM + offset fd_buffer
  mov ecx, 512
  mov al, e2_ldiskn
  mov ah, 2  // read
  call e2_diskmain
  
  l_test_ext2_view_6:
  // load right - inodes
  /*
  mov ebx, pos1
  call e2_load_inode
  mov esi, offset e2_inode
  mov edi, VA_SYSTEM + offset hd_buffer
  mov ecx, sizeof INode
  cld
  rep movsb
  xor eax, eax
  mov ecx, 512 - sizeof INode
  rep stosb
  */
  
  // load right - blocks
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  mov eax, pos1
  shl eax, cl
  mov edi, eax
  
  mov eax, e2_sb.s_inodes_per_group
  movzx edx, e2_sb.s_inode_size
  mul edx
  mov ebx, e2_gb.bg_inode_table
  mov edx, ebx
  shl ebx, cl
  xor cl, 31
  inc cl
  shr edx, cl
  add ebx, eax
  adc edx, 0
  add ebx, edi
  adc edx, 0
  
  mov edi, VA_SYSTEM + offset hd_buffer
  mov ecx, 512
  mov al, e2_ldiskn
  mov ah, 2  // read
  call e2_diskmain
  
  // write
  mov dl, 4
  mov dh, 2
  mov edi, VA_SYSTEM + offset fd_buffer
  call writesect
  mov dl, 44
  mov dh, 2
  mov edi, VA_SYSTEM + offset hd_buffer
  call writesect
  
  // keys
  l_test_ext2_view_7:
    mov edi, p_current
    call p_stop
    call p_msg_get
    cmp ecx, WM_KEYDOWN
    jnz l_test_ext2_view_7
  
  cmp dl, 75  // left
  jnz l_test_ext2_view_71
    cmp pos1, 0
    jz l_test_ext2_view_7
      dec pos1
      jmp l_test_ext2_view_5
    
  l_test_ext2_view_71:
  cmp dl, 77  // right
  jnz l_test_ext2_view_72
    inc pos1
    jmp l_test_ext2_view_5
    
  l_test_ext2_view_72:
  cmp dl, 72  // up
  jnz l_test_ext2_view_73
    cmp pos1, 32 * 8
    jb l_test_ext2_view_722
      sub pos1, 32 * 8
      jmp l_test_ext2_view_5
      
    l_test_ext2_view_722:
    mov pos1, 0
    jmp l_test_ext2_view_5
    
  l_test_ext2_view_73:
  cmp dl, 80  // down
  jnz l_test_ext2_view_74
    add pos1, 32 * 8
    jmp l_test_ext2_view_5
    
  l_test_ext2_view_74:
  //...
  
  cmp dl, 1
  jnz near l_test_ext2_view_7
  
ret

ted1: "boot\0"

test_ext2_dir:
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset ted1
mov al, 3  // C:
xor ebx, ebx
call e2_find_file

// IN: ebx = ino, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = 0 || erc, e2_inode, e2_inoa = disk offset of inode, e2_inon
call e2_load_inode

// IN: e2_inode, edx:ebx = file offset, ecx = size, es:edi -> data
// OUT: al = 0 || erc
xor edx, edx
xor ebx, ebx
mov ecx, e2_inode.i_size
mov edi, VA_SYSTEM + offset fd_buffer
call e2_read

// IN: dl = x, dh = y, es:edi -> buffer
mov dl, 44
mov dh, 2
mov edi, VA_SYSTEM + offset fd_buffer
call writesect

l_test_ext2_dir_5:
  mov edi, p_current
  call p_stop
  call p_msg_get
  cmp ecx, WM_KEYDOWN
  jnz l_test_ext2_dir_5

ret

test_ext2_alloc:
mov ecx, 30 * 1024 * 1024
call create_ramdisk
call write_diskinfo

call e2_prepare

xor esi, esi
call write_rd

mov ecx, 7780h //5

l_test_ext2_alloc_5:
push ecx
  xor ebx, ebx
  call e2_alloc
  mov eax, ebx
  mov ecx, 16
  call writen
pop ecx
loop l_test_ext2_alloc_5

xor esi, esi
call write_rd
call write_diskinfo

mov ebx, 43h  //... block id of allocated block
call e2_free

xor esi, esi
call write_rd
call write_diskinfo

xor ebx, ebx
call e2_alloc

xor esi, esi
call write_rd
call write_diskinfo

ret

test_ext2_alloc_inode:
mov ecx, 30 * 1024 * 1024
call create_ramdisk
call write_diskinfo

call e2_prepare

xor esi, esi
call write_rd

mov ecx, 5

l_test_ext2_alloc_inode_5:
push ecx
  xor ebx, ebx
  call e2_alloc_inode
  mov eax, ebx
  mov ecx, 16
  call writen
pop ecx
loop l_test_ext2_alloc_inode_5

mov esi, 1024
call write_rd
call write_diskinfo

mov ebx, 0Dh  //... inode id
call e2_free_inode

mov esi, 1024
call write_rd
call write_diskinfo

xor ebx, ebx
call e2_alloc_inode

mov esi, 1024
call write_rd
call write_diskinfo

ret

test_ext2_io:
mov ecx, 30 * 1024 * 1024
call create_ramdisk
mov al, e2_ldiskn
call e2_prepare

// IN: ebx = ino, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = 0 || erc, e2_inode, e2_inoa = disk offset of inode, e2_inon
mov ebx, EXT2_ROOT_INO
call e2_load_inode

xor edi, edi
mov ecx, 512 / 4
mov eax, 1

tio_5:
  mov dword ptr fd_buffer[edi], eax
  add edi, 4
  inc eax
  loop tio_5

mov ebx, 0 //2*256*256*1024

tio_6:
  mov eax, ebx
  shr eax, 9
  mov dword ptr fd_buffer[0], eax
  // IN: e2_inode, edx:ebx = file offset, ecx = size, es:edi -> data
  xor edx, edx
  mov ecx, 512
  mov edi, VA_SYSTEM + offset fd_buffer
  push ebx
    call e2_write
  pop ebx
  add ebx, 512
  cmp ebx, 512 * 1024 * 8
  jb tio_6

mov e2_inode.i_size, 512 * 1024 * 8
call e2_save_inode

//call write_blocks
call write_diskinfo

// zero fd_buffer
xor edi, edi
mov ecx, 512 / 4
xor eax, eax

tio_8:
  mov dword ptr fd_buffer[edi], eax
  add edi, 4
  loop tio_8

// read
xor edx, edx
mov ebx, 512*1024*8-512-256 //2*256*256*1024
mov ecx, 512
mov edi, VA_SYSTEM + offset fd_buffer
call e2_read

// IN: dl = x, dh = y, es:edi -> buffer
mov dl, 4
mov dh, 0
mov edi, VA_SYSTEM + offset fd_buffer
call writesect

ret

test_ext2_delete:
mov ecx, 30 * 1024 * 1024
call create_ramdisk
mov al, e2_ldiskn
call e2_prepare

// IN: ebx = ino, e2_sb, e2_ldiskn, e2_diskmain
// OUT: al = 0 || erc, e2_inode, e2_inoa = disk offset of inode, e2_inon
mov ebx, EXT2_ROOT_INO
call e2_load_inode

call write_diskinfo

xor edi, edi
mov ecx, 512 / 4
mov eax, 1

tdel_5:
  mov dword ptr fd_buffer[edi], eax
  add edi, 4
  inc eax
  loop tdel_5

mov ebx, 2*256*256*1024

tdel_6:
  mov eax, ebx
  shr eax, 9
  mov dword ptr fd_buffer[0], eax
  // IN: e2_inode, edx:ebx = file offset, ecx = size, es:edi -> data
  xor edx, edx
  mov ecx, 512
  mov edi, VA_SYSTEM + offset fd_buffer
  push ebx
    call e2_write
  pop ebx
  add ebx, 512
  cmp ebx, 512 * 1024 * 8
  jb tdel_6

mov e2_inode.i_size, 2*256*256*1024
call e2_save_inode

//call write_blocks
call write_diskinfo

// IN: edx:ebx = file pos, e2_inode, e2_sb, e2_ldiskn, e2_diskmain
mov ebx, 0 // 0, 2048, 512 * 1024 * 4
xor edx, edx
call e2_delete

call write_diskinfo

ret

test_ext2_md1: db "F:/abc\0"
test_ext2_md2: db "F:/testdir\0"
test_ext2_md3: db "F:/AB\0"
test_ext2_md4: db "F:/aB/abx\0"

test_ext2_md:
mov ecx, 30 * 1024 * 1024
call create_ramdisk
call e2_prepare

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset test_ext2_md1
call fs_md
movzx eax, al
mov ecx, 16
call writen

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset test_ext2_md2
call fs_md
movzx eax, al
mov ecx, 16
call writen

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset test_ext2_md3
call fs_md
movzx eax, al
mov ecx, 16
call writen

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset test_ext2_md4
call fs_md
movzx eax, al
mov ecx, 16
call writen

/*
call write_diskinfo
xor esi, esi
call write_rd
mov esi, 1024
call write_rd

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset test_ext2_md2
call fs_rm
movzx eax, al
mov ecx, 16
call writen

call write_diskinfo
xor esi, esi
call write_rd
mov esi, 1024
call write_rd

l1: jmp l1
*/
ret

uns2 telf1

tels1: db "F:/testdir/lnk1\0"
tels2: db "F:/ab/abx\0"
tels3: db "F:/testdir/lnk2\0"
tels4: db "lnk1/bootsect.dat\0"

test_ext2_link:
call test_ext2_md

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset tels1
mov esi, FOPEN_CREATE
call s_link_open
movzx eax, al
mov ecx, 16
call writen
push ebx
  mov esi, ebx
  mov edi, VA_SYSTEM + PA_KERNEL_CODE + offset tels2
  call tel_strlen
  // IN: esi = offset to files, es:edi -> data, ecx = size
  call fs_fwrite
  movzx eax, al
  mov ecx, 16
  call writen
pop esi
call fs_fclose
movzx eax, al
mov ecx, 16
call writen

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset tels3
mov esi, FOPEN_CREATE
call s_link_open
movzx eax, al
mov ecx, 16
call writen
push ebx
  mov esi, ebx
  mov edi, VA_SYSTEM + PA_KERNEL_CODE + offset tels4
  call tel_strlen
  // IN: esi = offset to files, es:edi -> data, ecx = size
  call fs_fwrite
  movzx eax, al
  mov ecx, 16
  call writen
pop esi
call fs_fclose
movzx eax, al
mov ecx, 16
call writen

//l1:jmp l1
ret

tel_strlen:
push edi
  xor ecx, ecx
  
  l_tel_strlen_5:
    mov al, [es:edi]
    cmp al, 0
    jz l_tel_strlen_8
      inc edi
      inc ecx
      jmp l_tel_strlen_5
      
  l_tel_strlen_8:
pop edi
ret

test_ext2_backup:
call test_ext2_md
//call write_diskinfo
mov al, rd_ldiskn
call e2_backup
//call write_diskinfo
//call ww
ret

LOGBLOCKSIZE = 0

// IN: ecx = ram disk size
create_ramdisk:
call h_rd_create
mov e2_ldiskn, al
mov edi, LOGBLOCKSIZE
call e2_format
ret

uns1 e2u_disk
uns1 e2u_buf[512]

e2ufn1: db "f:/file1.dat\0"
e2ufn2: db "f:/file2more.dat\0"
e2ufn3: db "f:/file3x.dat\0"
e2ufn4: db "f:/file4xa.dat\0"
e2ufn5: db "f:/file5xab.dat\0"

test_e2u:
// IN: ecx = RAM disk size (max 256 MiB)
// OUT: al = erc, dl = ldiskn
mov ecx, 30 * 1024 * 1024
call s_create_ramdisk
mov e2u_disk, dl

// * create files *

// IN: al = mode, es:edx -> fname
// OUT: esi = fhandle
// mode: 1 read, 3 write, 10h append, 20h rewrite
mov al, FOPEN_CREATE
mov ah, 0  // fs_takelink
mov bl, 0  // fs_hack
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset e2ufn1
call fs_fopen
call fs_fclose

mov al, FOPEN_CREATE
mov ah, 0  // fs_takelink
mov bl, 0  // fs_hack
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset e2ufn2
call fs_fopen
call fs_fclose

mov al, FOPEN_CREATE
mov ah, 0  // fs_takelink
mov bl, 0  // fs_hack
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset e2ufn3
call fs_fopen
call fs_fclose

mov al, FOPEN_CREATE
mov ah, 0  // fs_takelink
mov bl, 0  // fs_hack
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset e2ufn4
call fs_fopen
call fs_fclose

mov al, FOPEN_CREATE
mov ah, 0  // fs_takelink
mov bl, 0  // fs_hack
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset e2ufn5
call fs_fopen
call fs_fclose

// * delete * IN: es:edx -> filename
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset e2ufn2
call fs_rm

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset e2ufn4
call fs_rm

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset e2ufn3
call fs_rm

/*
// * write sect *
mov al, e2u_disk
call e2_prepare
mov ebx, EXT2_ROOT_INO
call e2_load_inode
xor ebx, ebx
xor edx, edx
mov ecx, 512
mov edi, VA_SYSTEM + offset e2u_buf
call e2_read
mov dl, 4
mov dh, 4
mov edi, VA_SYSTEM + offset e2u_buf
call writesect
*/

// * redure dir *
// BEFORE: e2_prepare, e2_load_inode
// KEEP: edx, e2_len
// USES: fd_buffer
mov al, e2u_disk
call e2_prepare
mov ebx, EXT2_ROOT_INO
call e2_load_inode

call e2_reduce_dir

/*
// * write sect *
mov al, e2u_disk
call e2_prepare
mov ebx, EXT2_ROOT_INO
call e2_load_inode
xor ebx, ebx
xor edx, edx
mov ecx, 512
mov edi, VA_SYSTEM + offset e2u_buf
call e2_read
mov dl, 44
mov dh, 4
mov edi, VA_SYSTEM + offset e2u_buf
call writesect

call ww
*/

ret

NUMBASE = 16
te2_str1: "\nino, fr, blks, fr, bpg, ipg, blz, res\n  \0"
te2_str2: "\ngroups, groupblocks\0"
te2_str3: "\nbbm, ibm, itab, frbl, fri, dirs\0"

// IN: e2_ldiskn, e2_diskmain, e2_sb
write_diskinfo:

// superblock
mov esi, offset te2_str1
call writec

mov eax, e2_sb.s_inodes_count
mov ecx, NUMBASE
call writen
mov eax, e2_sb.s_free_inodes_count
mov ecx, NUMBASE
call writen
mov eax, e2_sb.s_blocks_count
mov ecx, NUMBASE
call writen
mov eax, e2_sb.s_free_blocks_count
mov ecx, NUMBASE
call writen
mov eax, e2_sb.s_blocks_per_group
mov ecx, NUMBASE
call writen
mov eax, e2_sb.s_inodes_per_group
mov ecx, NUMBASE
call writen
mov eax, 1024
mov ecx, e2_sb.s_log_block_size
shl eax, cl
mov ecx, NUMBASE
call writen
mov eax, e2_sb.s_r_blocks_count
mov ecx, NUMBASE
call writen

// group blocks
/*
mov esi, offset te2_str2
call writec
mov eax, e2_groups
mov ecx, NUMBASE
call writen
mov eax, e2_gblocks
mov ecx, NUMBASE
call writen
*/

// calc groups
mov eax, e2_sb.s_blocks_count
mov ecx, e2_sb.s_blocks_per_group
dec eax
dec eax
xor edx, edx
div ecx
inc eax  // eax = groups
mov e2_groups, eax

// write groups
xor esi, esi
l_write_diskinfo_5:
  push esi
    mov esi, offset te2_str3
    call writec
  pop esi

  // groupblock
  push esi
    mov ebx, esi
    call e2_load_group
    
    mov eax, e2_gb.bg_block_bitmap
    mov ecx, NUMBASE
    call writen
    mov eax, e2_gb.bg_inode_bitmap
    mov ecx, NUMBASE
    call writen
    mov eax, e2_gb.bg_inode_table
    mov ecx, NUMBASE
    call writen
    movzx eax, e2_gb.bg_free_blocks_count
    mov ecx, NUMBASE
    call writen
    movzx eax, e2_gb.bg_free_inodes_count
    mov ecx, NUMBASE
    call writen
    movzx eax, e2_gb.bg_used_dirs_count
    mov ecx, NUMBASE
    call writen
    
  pop esi
  
  inc esi
  cmp esi, 20 //e2_groups
  jb near l_write_diskinfo_5

ret

write_rd_eoln: db "\nData\0"
WRITE_RD_COUNT = 8

// IN: esi = offset from bg_block_bitmap, e2_gblocks, e2_sb
write_rd:
add esi, rd_base
add esi, 2048  //... greater blocks
mov eax, e2_gblocks
mov cl, byte ptr e2_sb.s_log_block_size
add cl, 10
shl eax, cl
add esi, eax  // boot + sb + gbs

push esi
  mov esi, offset write_rd_eoln
  call writec
pop esi

mov ecx, WRITE_RD_COUNT

l_write_rd_15:
  push ecx
    mov eax, [es:esi]
    mov ecx, 16
    push esi
      call writen
    pop esi
  pop ecx
  add esi, 4
  loop l_write_rd_15

ret

winode_str1: db "\ndir\0"
winode_str2: db "\nsind\0"

// IN: e2_inode, e2_sb, e2_ldiskn, e2_disk, e2_diskmain
// USES: fd_buffer
winode:
pushad
  mov esi, offset winode_str1
  call writec
  
  mov esi, offset e2_inode.i_block
  mov ecx, 15
  
  l_winode_5:
    push ecx
      lodsd
      push esi
        mov ecx, 16
        call writen
     pop esi
    pop ecx
    loop l_winode_5
  
  mov ebx, e2_inode.i_block[SINGLE_INDIRECT]
  mov cl, byte ptr e2_sb.s_log_block_size
  add cl, 10
  shl ebx, cl
  xor edx, edx
  mov ecx, 15 * 4
  mov edi, VA_SYSTEM + offset fd_buffer
  mov al, e2_ldiskn
  mov ah, 2  // read
  call e2_diskmain
  
  mov esi, offset winode_str2
  call writec

  mov esi, offset fd_buffer
  mov ecx, 15
  
  l_winode_6:
    push ecx
      lodsd
      push esi
        mov ecx, 16
        call writen
     pop esi
    pop ecx
    loop l_winode_6
  
popad
ret

// IN: e2_inode
write_blocks:
mov esi, offset write_blocks_str
call writec

xor esi, esi

l_write_blocks_5:
  mov eax, e2_inode.i_block[esi]
  mov ecx, 16
  push esi
    call writen
  pop esi
  add esi, 4
  cmp esi, 4*15
  jb l_write_blocks_5


ret

write_blocks_str: db "\nBlocks\0"

test_nt:
//call test_nt_add_name
//call test_nt_write
//call test_nt_dir
call test_nt_view
ret

mov al, 3  // C:
call nt_prepare
movzx eax, al
mov ecx, 16
call writen

mov esi, 1Ch // 5 / 1Ch
call nt_load_file
movzx eax, al
mov ecx, 16
call writen

//call test_nt_insert_atr

//call test_nt_alloc

//call test_nt_read
//ret

call test_nt_find_file
ret

//call test_nt_atr

//call test_nt_nres

movzx eax, nt_cluzlog
mov ecx, dword ptr nt_mft
mov edx, dword ptr nt_mft[4]
movzx ebx, nt_mftrecsizelog
mov esi, dword ptr nt_mftmirr
mov edi, dword ptr nt_mftmirr[4]

call ww
ret

[dalign 32]
uns4 tnv_pos, tnv_ofs, tnv_size
bool tnv_non_resident

tnv1: db "documents and settings\0"
//tnv1: db "windows/globalization\0"
//tnv1: db "windows/system32\0"
//tnv1: db "boot.ini\0"
//tnv1: db "documents and settings/administrator/cookies/index.dat\0"
//tnv1: db "documents and settings/administrator\0"
//tnv1: db "documents and settings/administrator/cookies\0"

tnvfn: db "\n\nFile Number:\0"
tnvsig: db "\nSignature: \0"
tnvuso: db "\nUpdate Sequence Offset:\0"
tnvusc: db "  Update Sequence Count:\0"
tnvlfs: db "\nLog File Sequence Number:\0"
tnvdc: db "\nDelete Count:\0"
tnvhl: db "  Number of Hard Links:\0"
tnvaofs: db "\nOffset of the 1st Attribute:\0"
tnvflg: db "  Flags:\0"
tnvrz: db "\nReal Size:\0"
tnvaz: db "  Allocated Size:\0"
tnvbf: db "  Base File:\0"
tnvna: db "  Next Atr Id:\0"

tnvbr: db "\n\0"
tnvsp: db " \0"

tnv10: db "\n10h - Standard Information\0"
tnv20: db "\n20h - Attribute List\0"
tnv30: db "\n30h - File Name\0"
tnv40: db "\n40h - Object Id\0"
tnv50: db "\n50h - Security Descriptor\0"
tnv60: db "\n60h - Volume Name\0"
tnv70: db "\n70h - Volume Information\0"
tnv80: db "\n80h - Data\0"
tnv90: db "\n90h - Index Root\0"
tnvA0: db "\n0A0h - Index Allocation\0"
tnvB0: db "\n0B0h - Index Bitmap\0"
tnvC0: db "\n0C0h - Reparse Point\0"
tnvD0: db "\n0D0h - EA Information\0"
tnvE0: db "\n0E0h - EA\0"
tnvF0: db "\n0F0h - Property Set\0"
tnv100: db "\n100h - Logged Utility Stream\0"
tnvX: db "\nUnknown attribute\0"

tnvsize: db " Size:\0"
tnvnres: db " Non-res:\0"
tnvfs: db "Flags:\0"
tnvid: db " ID:\0"
tnvlen: db " Len:\0"
tnvofs: db " Ofs:\0"
tnvidx: db " Idx:\0"

tnvprompt: db "\nSelect id (enter = continue): \0"


test_nt_view:
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset tnv1
xor ebx, ebx
mov al, 4  // D:
call nt_find_file
push ebx
  movzx eax, al
  mov ecx, 16
  call writen
pop esi
call nt_load_file
movzx eax, al
mov ecx, 16
call writen

l_tnv_1:
mov esi, offset tnvfn
call writec
mov eax, nt_file
mov ecx, 16
call writen

mov esi, offset tnvsig
call writec
mov esi, VA_SYSTEM + offset nt_buffer + offset FileDescriptor.signature
mov ecx, 4
mov bl, 0Eh
call s_write

mov esi, offset tnvuso
call writec
movzx eax, word ptr nt_buffer[offset FileDescriptor.offset_update_seq]
mov ecx, 16
call writen

mov esi, offset tnvusc
call writec
movzx eax, word ptr nt_buffer[offset FileDescriptor.size_update_seq]
mov ecx, 16
call writen

mov esi, offset tnvlfs
call writec
mov eax, dword ptr nt_buffer[offset FileDescriptor.log_file_seq_n]
mov ecx, 16
call writen

mov esi, offset tnvdc
call writec
movzx eax, word ptr nt_buffer[offset FileDescriptor.del_count]
mov ecx, 16
call writen

mov esi, offset tnvhl
call writec
movzx eax, word ptr nt_buffer[offset FileDescriptor.hard_links]
mov ecx, 16
call writen

mov esi, offset tnvaofs
call writec
movzx eax, word ptr nt_buffer[offset FileDescriptor.first_atr_ofs]
mov ecx, 16
call writen

mov esi, offset tnvflg
call writec
movzx eax, word ptr nt_buffer[offset FileDescriptor.flags]
mov ecx, 16
call writen

mov esi, offset tnvrz
call writec
mov eax, dword ptr nt_buffer[offset FileDescriptor.real_size]
mov ecx, 16
call writen

mov esi, offset tnvaz
call writec
mov eax, dword ptr nt_buffer[offset FileDescriptor.allocated]
mov ecx, 16
call writen

mov esi, offset tnvbf
call writec
mov eax, dword ptr nt_buffer[offset FileDescriptor.base_file]
mov ecx, 16
call writen

mov esi, offset tnvna
call writec
movzx eax, word ptr nt_buffer[offset FileDescriptor.next_atr_id]
mov ecx, 16
call writen

// attributes
mov esi, offset tnvbr
call writec
movzx edi, word ptr nt_buffer[offset FileDescriptor.first_atr_ofs]
add edi, offset nt_buffer

l_tnv_20:
mov eax, [edi]
cmp eax, -1
jz near l_tnv_28
  push edi
   cmp eax, 10h
   jnz l_tnv_211
     mov esi, offset tnv10
     jmp l_tnv_219
     
   l_tnv_211:
   cmp eax, 20h
   jnz l_tnv_212
     mov esi, offset tnv20
     jmp l_tnv_219
     
   l_tnv_212:
   cmp eax, 30h
   jnz l_tnv_213
     mov esi, offset tnv30
     jmp l_tnv_219
     
   l_tnv_213:
   cmp eax, 40h
   jnz l_tnv_214
     mov esi, offset tnv40
     jmp l_tnv_219
     
   l_tnv_214:
   cmp eax, 50h
   jnz l_tnv_215
     mov esi, offset tnv50
     jmp l_tnv_219
     
   l_tnv_215:
   cmp eax, 60h
   jnz l_tnv_216
     mov esi, offset tnv60
     jmp l_tnv_219
     
   l_tnv_216:
   cmp eax, 70h
   jnz l_tnv_217
     mov esi, offset tnv70
     jmp l_tnv_219
     
   l_tnv_217:
   cmp eax, 80h
   jnz l_tnv_218
     mov esi, offset tnv80
     jmp short l_tnv_219
     
   l_tnv_218:
   cmp eax, 90h
   jnz l_tnv_21A
     mov esi, offset tnv90
     jmp short l_tnv_219
     
   l_tnv_21A:
   cmp eax, 0A0h
   jnz l_tnv_21B
     mov esi, offset tnvA0
     jmp short l_tnv_219
     
   l_tnv_21B:
   cmp eax, 0B0h
   jnz l_tnv_21C
     mov esi, offset tnvB0
     jmp short l_tnv_219
     
   l_tnv_21C:
   cmp eax, 0C0h
   jnz l_tnv_21D
     mov esi, offset tnvC0
     jmp short l_tnv_219
     
   l_tnv_21D:
   cmp eax, 0D0h
   jnz l_tnv_21E
     mov esi, offset tnvD0
     jmp short l_tnv_219
     
   l_tnv_21E:
   cmp eax, 0E0h
   jnz l_tnv_21F
     mov esi, offset tnvE0
     jmp short l_tnv_219
     
   l_tnv_21F:
   cmp eax, 0F0h
   jnz l_tnv_21G
     mov esi, offset tnvF0
     jmp short l_tnv_219
     
   l_tnv_21G:
   cmp eax, 100h
   jnz l_tnv_21H
     mov esi, offset tnv100
     jmp short l_tnv_219
     
   l_tnv_21H:
   mov esi, offset tnvX
   
   l_tnv_219:
   call writec
  pop edi

  push edi
    mov esi, offset tnvid
    call writec
  pop edi
  push edi
    movzx eax, word ptr [edi + offset StandardHeader.atr_id]
    mov ecx, 16
    call writen
  pop edi

  push edi
    mov esi, offset tnvsize
    call writec
  pop edi
  push edi
    mov eax, [edi + offset StandardHeader.atr_size]
    mov ecx, 16
    call writen
  pop edi
  
  push edi
    mov esi, offset tnvnres
    call writec
  pop edi
  push edi
    movzx eax, byte ptr [edi + offset StandardHeader.non_resident]
    mov ecx, 16
    call writen
  pop edi
  
  push edi
    mov esi, offset tnvsp
    call writec
  pop edi
  movzx ecx, byte ptr [edi + offset StandardHeader.name_len]
  shl ecx, 1
  movzx esi, word ptr [edi + offset StandardHeader.name_ofs]
  add esi, edi
  add esi, VA_SYSTEM
  mov bl, 0Bh
  push edi
    call s_write
  pop edi
  
  push edi
    mov esi, offset tnvfs
    call writec
  pop edi
  push edi
    movzx eax, word ptr [edi + offset StandardHeader.flags]
    mov ecx, 16
    call writen
  pop edi
/*
  push edi
    mov esi, offset tnvlen
    call writec
  pop edi
  push edi
    mov eax, [edi + offset StandardHeader.atr_len]
    mov ecx, 16
    call writen
  pop edi

  push edi
    mov esi, offset tnvofs
    call writec
  pop edi
  push edi
    movzx eax, word ptr [edi + offset StandardHeader.atr_ofs]
    mov ecx, 16
    call writen
  pop edi
*/
  push edi
    mov esi, offset tnvidx
    call writec
  pop edi
  push edi
    movzx eax, byte ptr [edi + offset StandardHeader.idx_flag]
    mov ecx, 16
    call writen
  pop edi

  mov eax, [edi + offset StandardHeader.atr_size]
  add edi, eax
  jmp l_tnv_20
  
l_tnv_28:
mov esi, offset tnvprompt
call writec

// main 1
l_tnv_35:
  mov edi, p_current
  call p_stop
  call p_msg_get
  cmp ecx, WM_KEYDOWN
  jnz l_tnv_35

cmp edx, 2  // 1
jb l_tnv_35
cmp edx, 10 // 9
jna l_tnv_38
  cmp edx, 11  // 0
  jz l_tnv_37
    cmp edx, 28  // enter
    jnz l_tnv_35
    
    jmp l_tnv_99
    
l_tnv_37:
mov edx, 1

l_tnv_38:
dec edx

// find edx in ids
movzx edi, word ptr nt_buffer[offset FileDescriptor.first_atr_ofs]
add edi, offset nt_buffer

l_tnv_45:
mov eax, [edi + offset StandardHeader.atr_type]
cmp eax, -1
jz l_tnv_28
  movzx eax, word ptr [edi + offset StandardHeader.atr_id]
  cmp eax, edx
  jz l_tnv_48
    mov eax, [edi + offset StandardHeader.atr_size]
    add edi, eax
    jmp l_tnv_45

l_tnv_48:
xor eax, eax
mov tnv_pos, eax
mov al, [edi + offset StandardHeader.non_resident]
mov tnv_non_resident, al
test al, 1
jnz l_tnv_61
  // resident
  movzx ebx, word ptr [edi + offset StandardHeader.atr_ofs]
  add ebx, edi
  mov tnv_ofs, ebx
  mov ecx, [edi + offset StandardHeader.atr_len]
  mov tnv_size, ecx
  jmp l_tnv_7
  
l_tnv_61:
  // non-resident
  xor eax, eax
  mov tnv_ofs, eax
  mov ecx, dword ptr [edi + offset DataAtr.atr_real_size]
  mov tnv_size, ecx
  mov nt_atrofs, edi

l_tnv_7:
cmp tnv_pos, 0
jnl l_tnv_711
  mov tnv_pos, 0
  
l_tnv_711:
mov eax, tnv_size
cmp eax, tnv_pos
ja l_tnv_712
  mov tnv_pos, eax
  
l_tnv_712:
xor eax, eax
mov edi, VA_SYSTEM + offset fd_buffer
mov ecx, 512 / 4
cld
rep stosd

mov ecx, 512
mov eax, tnv_size
sub eax, tnv_pos
cmp eax, ecx
jnb l_tnv_714
  mov ecx, eax
  
l_tnv_714:
push ecx
  test tnv_non_resident, 1
  jnz l_tnv_72
    // resident
    mov esi, tnv_ofs
    add esi, tnv_pos
    mov edi, VA_SYSTEM + offset fd_buffer
    rep movsb
    jmp l_tnv_73
    
  l_tnv_72:
    // non-resident
    mov esi, nt_atrofs
    xor edx, edx
    mov ebx, tnv_pos
    mov edi, VA_SYSTEM + offset fd_buffer
    call nt_read
  
  l_tnv_73:
  mov dl, 44  // *1
  mov dh, 2
  mov edi, VA_SYSTEM + offset fd_buffer
  call writesect
pop ecx
// write terminal char
cmp ecx, 512
jnb l_tnv_75
  mov edx, ecx
  and ecx, 31
  shr edx, 5
  mov dh, dl
  mov dl, cl
  add dl, 44  // *1
  add dh, 2
  mov al, dh
  mov cl, 80
  mul cl
  add al, dl
  adc ah, 0
  shl eax, 1
  movzx edi, ax
  push es
    push SELECTOR_TEXTVIDEO
    pop es
    mov ax, 6E20h
    mov [es:edi], ax
  pop es
  
// main 2
l_tnv_75:
  mov edi, p_current
  call p_stop
  call p_msg_get
  cmp ecx, WM_KEYDOWN
  jnz l_tnv_75

cmp dl, 1  // esc
jz near l_tnv_1

cmp dl, 73
jnz l_tnv_761
  sub tnv_pos, 512
  
l_tnv_761:
cmp dl, 81
jnz l_tnv_762
  add tnv_pos, 512
  
l_tnv_762:
cmp dl, 72
jnz l_tnv_763
  sub tnv_pos, 32
  
l_tnv_763:
cmp dl, 80
jnz l_tnv_764
  add tnv_pos, 32
  
l_tnv_764:
cmp dl, 75
jnz l_tnv_765
  dec tnv_pos
  
l_tnv_765:
cmp dl, 77
jnz l_tnv_766
  inc tnv_pos
  
l_tnv_766:
//...
jmp l_tnv_7

l_tnv_99:
ret

tndir1: db "windows\0"
tndireoln: db "\n\0"

TN_MAX_DEPTH = 64

uns4 tndepth, tnsize
uns4 tnscroll[TN_MAX_DEPTH], tnnode[TN_MAX_DEPTH], tnypos[TN_MAX_DEPTH]

cls:
mov dl, 0
mov dh, 0
mov cur_pos, dx
call cursorto
mov ecx, 80 * 25
mov edi, VA_SYSTEM + 0B8000h
mov ax, 0720h
cld
rep stosw
ret


test_nt_dir:
// IN: es:edx -> filenamez, ebx = 0 || dirino, al = ldiskn
// OUT: al = 0 || erc, ebx = ino, nt_parentino, nt_nameofs
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset tndir1
xor ebx, ebx
mov al, 4  // D:
call nt_find_file

mov esi, ebx
call nt_load_file

mov tndepth, 0
call nt_get_root_node
mov eax, nt_rootnode
mov tnnode[0], eax
mov tnypos[0], 0
mov tnscroll[0], 0

l_test_nt_dir_05:
mov edi, tndepth
shl edi, 2  // * 4
mov ebx, tnnode[edi]
// IN: ebx = node, nt_cluzlog, nt_buffer, nt_node
// OUT: al = erc, [PA_NT_NODEBUF]
// BEFORE: nt_prepare
call nt_load_node
test al, al
jnz near l_test_nt_dir_9
mov ecx, [PA_NT_NODEBUF + sizeof StandardIndexHeader + offset NodeHeader.ofs_end_index_entry_list]
sub ecx, [PA_NT_NODEBUF + sizeof StandardIndexHeader + offset NodeHeader.ofs_start_index_entry_list]
mov tnsize, ecx

l_test_nt_dir_1:
// scroll
mov edi, tndepth
shl edi, 2  // * 4
mov ecx, tnscroll[edi]
mov ebx, [PA_NT_NODEBUF + sizeof StandardIndexHeader + offset NodeHeader.ofs_start_index_entry_list]
add ebx, PA_NT_NODEBUF + sizeof StandardIndexHeader
mov esi, tnsize
add esi, ebx

l_test_nt_dir_15:
  jecxz l_test_nt_dir_18
    dec ecx
    cmp ebx, esi
    jnb l_test_nt_dir_18
      movzx eax, word ptr [ebx + offset IndexEntry.index_entry_size]
      add ebx, eax
      jmp short l_test_nt_dir_15

l_test_nt_dir_18:
// write
push ebx
  call cls
pop ebx
mov edx, [PA_NT_NODEBUF + sizeof StandardIndexHeader + offset NodeHeader.ofs_end_index_entry_list]
add edx, PA_NT_NODEBUF + sizeof StandardIndexHeader
mov ecx, 24

l_test_nt_dir_25:
  cmp ebx, edx
  jnb l_test_nt_dir_28
    push ebx
     push edx
      push ecx
        mov esi, ebx
        add esi, VA_SYSTEM + sizeof IndexEntry
        movzx ecx, byte ptr [ebx + offset IndexEntry.filename_len]
        shl ecx, 1
        push ebx
          mov bl, 0Ah
          // IN: es:esi -> str, ecx = len, bl = color
          call s_write
        pop ebx
        movzx eax, word ptr [ebx + offset IndexEntry.index_flags]
        mov ecx, 16
        call writen
        
        mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset tndireoln
        mov ecx, 1
        call s_write
      pop ecx
     pop edx
    pop ebx
    movzx eax, word ptr [ebx + offset IndexEntry.index_entry_size]
    add ebx, eax
    loop l_test_nt_dir_25
    
l_test_nt_dir_28:
  // set cursor position
  mov dl, 0
  mov edi, tndepth
  shl edi, 2
  mov eax, tnypos[edi]
  sub eax, tnscroll[edi]
  mov dh, al
  call cursorto
  // inkey
  l_test_nt_dir_295:
    mov ah, 5 // get system message
    int 20h
    or al, al
    jz l_test_nt_dir_298
      mov ah, 7 // get message
      int 20h
      or al, al
      jz l_test_nt_dir_298
        mov ah, 45 // get pid, tid; OUT: edi = tid
        int 20h
        mov ah, 35 // stop thread
        int 20h
        jmp short l_test_nt_dir_295
      
  l_test_nt_dir_298:
  cmp ecx, WM_KEYDOWN
  jnz l_test_nt_dir_295

// keys
mov edi, tndepth
shl edi, 2
cmp dl, 72  // up
jnz l_test_nt_dir_31
  cmp tnypos[edi], 0
  jz l_test_nt_dir_28
    dec tnypos[edi]
    
    l_test_nt_dir_301:
    mov eax, tnypos[edi]
    cmp eax, tnscroll[edi]
    jnl near l_test_nt_dir_28
      mov tnscroll[edi], eax
      jmp l_test_nt_dir_1
    
l_test_nt_dir_31:
cmp dl, 80  // down
jnz l_test_nt_dir_32
  inc tnypos[edi]
  
  l_test_nt_dir_311:
  mov eax, tnypos[edi]
  sub eax, tnscroll[edi]
  cmp eax, 24
  jl near l_test_nt_dir_28
    mov eax, tnypos[edi]
    sub eax, 24
    mov tnscroll[edi], eax
    jmp l_test_nt_dir_1
    
l_test_nt_dir_32:
cmp dl, 73  // pgup
jnz l_test_nt_dir_33
  sub tnypos[edi], 24
  cmp tnypos[edi], 0
  jnl l_test_nt_dir_301
    mov tnypos[edi], 0
    jmp l_test_nt_dir_301
    
l_test_nt_dir_33:
cmp dl, 81  // pgdown
jnz l_test_nt_dir_34
  add tnypos[edi], 24
  jmp l_test_nt_dir_311
  
l_test_nt_dir_34:
cmp dl, 75  // left
jnz l_test_nt_dir_35
  cmp tndepth, 0
  jng near l_test_nt_dir_28
    dec tndepth
    jmp l_test_nt_dir_05
    
l_test_nt_dir_35:
cmp dl, 77  // right
jnz l_test_nt_dir_36
  cmp tndepth, TN_MAX_DEPTH
  jnb near l_test_nt_dir_28
    mov ecx, tnypos[edi]
    mov ebx, [PA_NT_NODEBUF + sizeof StandardIndexHeader + offset NodeHeader.ofs_start_index_entry_list]
    add ebx, PA_NT_NODEBUF + sizeof StandardIndexHeader
    mov esi, tnsize
    add esi, ebx
    
    l_test_nt_dir_355:
      cmp ebx, esi
      jnb near l_test_nt_dir_28
        jecxz l_test_nt_dir_358
          dec ecx
          movzx eax, word ptr [ebx + offset IndexEntry.index_entry_size]
          add ebx, eax
          jmp short l_test_nt_dir_355
        
    l_test_nt_dir_358:
    test byte ptr [ebx + offset IndexEntry.index_flags], 1  // has subnode
    jz near l_test_nt_dir_28
    
    movzx ecx, word ptr [ebx + offset IndexEntry.index_entry_size]
    mov eax, [ebx + ecx - 8]
    
    inc tndepth
    mov edi, tndepth
    shl edi, 2
    mov tnnode[edi], eax
    mov tnypos[edi], 0
    mov tnscroll[edi], 0
    jmp l_test_nt_dir_05
  
l_test_nt_dir_36:
cmp dl, 1  // esc
jz l_test_nt_dir_99

//...

jmp l_test_nt_dir_28

l_test_nt_dir_9:
call ww

l_test_nt_dir_99:
ret

test_nt_read:

mov eax, NTFS_ATR_INDEX_ALLOCATION
call nt_find_atr

mov edx, 0
mov ebx, 2
mov ecx, 4096
mov edi, VA_SYSTEM + PA_NT_NODEBUF
call nt_read
movzx eax, al
mov ecx, 16
call writen

mov dl, 4
mov dh, 2
mov edi, VA_SYSTEM + PA_NT_NODEBUF
call writesect
mov dl, 44
mov dh, 2
mov edi, VA_SYSTEM + PA_NT_NODEBUF + 4096 - 512
call writesect

call ww

ret

tnff1: db "windows/system32\0"  //"windows/apppatch\0"

test_nt_find_file:
// IN: es:edx -> filenamez, ebx = 0 || dirino, al = ldiskn
// OUT: al = 0 || erc, ebx = ino, nt_parentino, nt_nameofs
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset tnff1
xor ebx, ebx
mov al, 3  // C:
call nt_find_file

call ww
ret

test_usb:
//call test_usb_alloc
//call test_usb_pci
//call test_usb_transfer

/*
sti

l03:
test usb_ready, 1
jz l03

int 3Ah
call wregs

l09:jmp l09
*/
ret

uns4 tua_1, tua_2, tua_3

test_usb_alloc:
mov ecx, 1
push ecx
  call h_usb_alloc
pop ecx
mov tua_1, ebx
call wregs

mov ecx, 15
push ecx
  call h_usb_alloc
pop ecx
call wregs

mov ecx, 16
push ecx
  call h_usb_alloc
pop ecx
call wregs

mov ecx, 17
push ecx
  call h_usb_alloc
pop ecx
mov tua_2, ebx
call wregs

mov ecx, 1
push ecx
  call h_usb_alloc
pop ecx
call wregs

mov ecx, 64
push ecx
  call h_usb_alloc
pop ecx
call wregs

mov ecx, 128
push ecx
  call h_usb_alloc
pop ecx
call wregs

mov ecx, 256
push ecx
  call h_usb_alloc
pop ecx
call wregs

mov ecx, 512
push ecx
  call h_usb_alloc
pop ecx
mov tua_3, ebx
call wregs

mov ecx, 1024*256
push ecx
  call h_usb_alloc
pop ecx
call wregs

// free
mov ebx, tua_1
mov ecx, 1
call h_usb_free

mov ebx, tua_2
mov ecx, 17
call h_usb_free

mov ebx, tua_3
mov ecx, 512
call h_usb_free

// realloc
mov ecx, 1
push ecx
  call h_usb_alloc
pop ecx
call wregs

mov ecx, 17
push ecx
  call h_usb_alloc
pop ecx
call wregs

mov ecx, 512
push ecx
  call h_usb_alloc
pop ecx
call wregs

// IN: dl = x, dh = y, es:edi -> buffer
mov dl, 44
mov dh, 0
mov edi, VA_USB
call writesect

// freeze
l0:jmp l0
ret

tup1: db "\nPCI"
tup2: db "\n... press any key\0"
int4 tupi


test_usb_pci:
sti
mov tupi, 0
mov ch, 0  // 0..255
call test_usb_pci_rcr
call waitkey
ret


test_usb_pci_rcr:
mov cl, 0  // 0..31
mov dh, 0  // 0..7

l_test_usb_pci_rcr_5:
mov dl, 12
call h_pci_get
shr eax, 16
/*
//$$$
pushad
  cmp al, 0FFh
  jz l_test_usb_pci_rcr_1
    movzx eax, al
    mov bl, 15
    mov ecx, 16
    call writen
    
  l_test_usb_pci_rcr_1:
popad
*/
and al, 127
cmp al, 0  // normal
jnz near l_test_usb_pci_rcr_71
  inc tupi
  cmp tupi, 20
  jna l_test_usb_pci_rcr_51
    mov tupi, 0
    pushad
      mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset tup2
      mov ecx, 18  // strlen(tup2)
      mov bl, 7
      call s_write
    popad
    call waitkey
    
  l_test_usb_pci_rcr_51:
  pushad
    mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset tup1
    mov ecx, 4  // strlen(tup1)
    mov bl, 10
    call s_write
    
    movzx eax, byte ptr [ss:esp + 25]
    mov ecx, 16
    call writen
    movzx eax, byte ptr [ss:esp + 24]
    mov ecx, 16
    call writen
    movzx eax, byte ptr [ss:esp + 21]
    mov ecx, 16
    call writen
  popad
  // class
  mov dl, 8
  call h_pci_get
  pushad
    mov ecx, 16
    mov bl, 14
    call writen
  popad
  // IRQ
  mov dl, 60
  call h_pci_get
  pushad
    //movzx eax, al
    mov ecx, 16
    mov bl, 7
    call writen
  popad
  
  l_test_usb_pci_rcr_6:
  inc dh
  cmp dh, 8
  jb near l_test_usb_pci_rcr_5
    mov dh, 0
    inc cl
    cmp cl, 32
    jb near l_test_usb_pci_rcr_5
      jmp l_test_usb_pci_rcr_9
  
l_test_usb_pci_rcr_71:
cmp al, 1  // PCI to PCI bridge
jnz l_test_usb_pci_rcr_72
  mov dl, 24
  call h_pci_get
  pushad
    mov ch, ah
    call test_usb_pci_rcr
  popad
  jmp l_test_usb_pci_rcr_6
  
l_test_usb_pci_rcr_72:
/*
//$$$
pushad
  movzx eax, al
  mov bl, 15
  mov ecx, 16
  call writen
popad
*/
jmp l_test_usb_pci_rcr_6

l_test_usb_pci_rcr_9:
ret

test_usb_transfer:
// wait for usb thread to initialize
sti

l_test_usb_transfer_1:
  mov al, usb_ready
  test al, al
  jz l_test_usb_transfer_1
  
// get controller
mov esi, usb_test_controller
test esi, esi
jnz l_test_usb_transfer_3
  mov eax, 0xEEE
  mov ecx, 16
  mov bl, 0Ch
  call writen
  l_test_usb_transfer_2: jmp l_test_usb_transfer_2
  
l_test_usb_transfer_3:
// open pseudo-pipe
xor eax, eax
push esi
  mov ecx, esp  // ecx -> pseudo-pipe
  shl eax, 20  // bit 20 = LowSpeedDevice
  push eax  // ignored (ErrorTD)
    push eax  // .Token field: DeviceAddress is zero, bit 20 = LowSpeedDevice
      
      push 0
       push 0
        push 64
         push 0
          push ecx
      call h_usb_open_pipe
      mov ebx, eax  // ebx -> UsbPipe
      
add esp, 12
//call wregs

// test callback
mov esi, usb_test_controller

//lea eax, [esi + offset UsbController.set_address_buffer]
push ebx
  
  push 0
   push 0
    push offset h_test_usb_transfer_callback
     push 0x40  // size
      push HEAP_START_KERNEL + 0x10000  // buffer
       push ebx  // UsbPipe
       
  call h_usb_normal_transfer_async
  
pop ebx

mov edi, [es:ebx + offset UsbPipe.last_td]

l_test_usb_transfer_45:
  call test_usb_wtd  // keep ebx, edi
  call test_usb_wu  // wu/wo, keep ebx, edi
  mov edi, [es:edi + offset UsbGtd.next_virt]
  cmp edi, [es:ebx + offset UsbPipe.last_td]
  jnz l_test_usb_transfer_45
  
mov eax, offset h_test_usb_transfer_callback
call ww

ret


h_test_usb_transfer_callback:
// 4 pipe:dword, 8 status:dword, 12 buffer:dword, 16 length:dword, 20 calldata:dword
call wregs
ret 20

tuwtd1: db "\nCallBk\0"
tuwtd2: db " UData\0"
tuwtd3: db " Next\0"
tuwtd4: db " Prev\0"
tuwtd5: db " Pipe\0"
tuwtd6: db " Buf\0"
tuwtd7: db " Len\0"

// IN: edi -> UsbGtd
test_usb_wtd:
push ebx
  
  mov bl, 0Ah
  push edi
    mov esi, offset tuwtd1
    call writec
    mov eax, [es:edi + offset UsbGtd.callback]
    mov ecx, 16
    call writen
  pop edi
  
  push edi
    mov esi, offset tuwtd2
    call writec
    mov eax, [es:edi + offset UsbGtd.user_data]
    mov ecx, 16
    call writen
  pop edi
  /*
  push edi
    mov esi, offset tuwtd3
    call writec
    mov eax, [es:edi + offset UsbGtd.next_virt]
    mov ecx, 16
    call writen
  pop edi
  
  push edi
    mov esi, offset tuwtd4
    call writec
    mov eax, [es:edi + offset UsbGtd.prev_virt]
    mov ecx, 16
    call writen
  pop edi
  */
  push edi
    mov esi, offset tuwtd5
    call writec
    mov eax, [es:edi + offset UsbGtd.pipe]
    mov ecx, 16
    call writen
  pop edi
  
  push edi
    mov esi, offset tuwtd6
    call writec
    mov eax, [es:edi + offset UsbGtd.buffer]
    mov ecx, 16
    call writen
  pop edi
  
  push edi
    mov esi, offset tuwtd7
    call writec
    mov eax, [es:edi + offset UsbGtd.length]
    mov ecx, 16
    call writen
  pop edi

pop ebx
ret

tuwu1: db "\n next_td\0"
tuwu2: db " status\0"
tuwu3: db " token\0"
tuwu4: db " buf\0"
tuwu5: db " origbuf\0"

// IN: ebx -> UsbPipe
test_usb_wu:
push ebx
  mov bl, 0Eh
  
  mov esi, offset tuwu1
  call writec
  mov eax, [es:edi + offset UhciGtd.next_td - sizeof UhciGtd]
  mov ecx, 16
  call writen
  
  mov esi, offset tuwu2
  call writec
  mov eax, [es:edi + offset UhciGtd.control_status - sizeof UhciGtd]
  mov ecx, 16
  call writen
  
  mov esi, offset tuwu3
  call writec
  mov eax, [es:edi + offset UhciGtd.token - sizeof UhciGtd]
  mov ecx, 16
  call writen
  
  mov esi, offset tuwu4
  call writec
  mov eax, [es:edi + offset UhciGtd.buffer - sizeof UhciGtd]
  mov ecx, 16
  call writen
  
  mov esi, offset tuwu5
  call writec
  mov eax, [es:edi + offset UhciGtd.orig_buffer_info - sizeof UhciGtd]
  mov ecx, 16
  call writen
  
pop ebx
ret

tuwo1: db "\n flags\0"
tuwo2: db " cur_buf_ptr\0"
tuwo3: db " next_td\0"
tuwo4: db " buf_end\0"

// IN: ebx -> UsbPipe
test_usb_wo:
push ebx
  mov bl, 0Eh
  
  mov esi, offset tuwo1
  call writec
  mov eax, [es:edi + offset OhciGtd.flags - sizeof OhciGtd]
  mov ecx, 16
  call writen
  
  mov esi, offset tuwo2
  call writec
  mov eax, [es:edi + offset OhciGtd.cur_buf_ptr - sizeof OhciGtd]
  mov ecx, 16
  call writen
  
  mov esi, offset tuwo3
  call writec
  mov eax, [es:edi + offset OhciGtd.next_td - sizeof OhciGtd]
  mov ecx, 16
  call writen
  
  mov esi, offset tuwo4
  call writec
  mov eax, [es:edi + offset OhciGtd.buf_end - sizeof OhciGtd]
  mov ecx, 16
  call writen
  
pop ebx
ret

//uns1 test_buf[8192]

test_msg_nl: db "\n\0"
msg_test_wrm: db "\nMSG =\0"

test_wrm:
// KEEP: all
// ebx = wndid:sender, ecx = msg, edx = wp, esi = lp
push esi
mov esi, offset msg_test_wrm
call writec
pop esi

push eax
 push ecx

  mov eax, ebx
  mov ecx, 16
  call writen

 pop eax
 push eax

  mov ecx, 16
  call writen
	
  mov eax, edx
  mov ecx, 16
  call writen
	
  mov eax, esi
  mov ecx, 16
  call writen

 pop ecx
pop eax
ret

test_win:
// IN: ebx = WINFLAGS, ecx = {int2 x, y}, edx = {int2 w, h}, esi = hwnd
// OUT: al = erc, dh:dl = wdesktop:winid
call printwin

xor esi, esi
mov ecx, -1
mov edx, -1
mov ebx, 1
call g_create_win
xor esi, esi
mov ecx, -1
mov edx, -1
mov ebx, 1
call g_create_win

call printwin

xor esi, esi
mov ecx, -1
mov edx, -1
mov ebx, WINFLAGS_ALWAYSONTOP | 1
call g_create_win

call printwin

xor esi, esi
mov ecx, -1
mov edx, -1
mov ebx, 1
call g_create_win

call printwin

sti
printwin0: jmp printwin0
ret


printwin:
movzx ecx, wcount

l_printwin_5:
  sub ecx, 1
  jc l_printwin_8
    push ecx
      movzx eax, wpos[ecx]
      mov ecx, 16
      mov bl, 0Eh
      call writen
    pop ecx
    jmp short l_printwin_5
    
l_printwin_8:
mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset test_msg_nl
mov ecx, 1
call s_write
ret

test_msg_inistr: db "Press a key\n\0"
test_msg_str: db "\nMSG\0"

proc1fn: db "/system/test1.exe\0"

test_msg:
/*
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset proc1fn
xor esi, esi
xor edi, edi
call p_create_process
mov edi, [es:edi + offset ProcessRec.mainthread]
call p_start
call p_noop
*/

// write inistr
mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset test_msg_inistr
call strlen
mov bl, 7
call s_write

sti

// main loop
l_test_msg_0:
mov edi, p_current
call p_stop

l_test_msg_1:

call p_msg_get
// OUT: al = 0 || errorcode, ebx = wndid:sender, ecx = msg, edx = wp, esi = lp
test al, al
jnz l_test_msg_0

push ebx
  push esi
    push edx
      push ecx
        mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset test_msg_str
        call strlen
        mov bl, 0Ah
        call s_write
      pop eax
      
      mov bl, 0Eh
      
      mov ecx, 16
      call writen
    pop eax
    mov bl, 0Ah
    mov ecx, 16
    call writen
  pop eax
  mov ecx, 16
  call writen
pop eax
mov bl, 7
mov ecx, 16
call writen

jmp l_test_msg_1
//ret

test_post:
// post Message
// IN: ebx = winid:threadid, ecx = msg, edx = wp, esi = lp
// OUT: al = 0 || errorcode
mov ebx, WIN_NONE << 16 + 0
mov ecx, 1

l_test_post_5:
mov edx, ecx
mov esi, ecx
push ecx
 push ebx
  call p_msg_post
 pop ebx
pop ecx
inc ecx
cmp ecx, 31  // 30 Y, 31 N
jb l_test_post_5

call test_msg
ret

tafn: db "/system/test1.exe\0"
taargs: db "arg1 arg2\0"
taev: db "var1=value1\0var2=2\0\0"

test_args:

//sti

// for test, comment 2 marked lines in p_create_process

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset tafn
mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset taargs
mov edi, VA_SYSTEM + PA_KERNEL_CODE + offset taev
call p_create_process

push edi
//  call test_global_var
pop edi

push edi
  mov edi, [es:edi + offset ProcessRec.mainthread]
  sub edi, VA_THREADS
  shr edi, 12
  call p_start
  
  mov ecx, 1000
  call p_sleep
  
//  call test_global_var

pop ebx
sub ebx, VA_PROCS
shr ebx, 9

call p_kill_process

//...

ret

tgv1: db " GV =\0"

test_global_var:
mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset tgv1
call strlen
mov bl, 7
call s_write

mov ebx, HEAP_START_GLOBAL

l_test_global_var_5:
  mov eax, ebx
  push ebx
    mov ecx, 16
    mov bl, 0Bh
    call writen
  pop ebx
  mov eax, [es:ebx + offset HeapRec.size]
  push ebx
    mov ecx, 16
    mov bl, 0Eh
    call writen
  pop ebx
  mov eax, [es:ebx + offset HeapRec.type]
  push ebx
    mov ecx, 16
    mov bl, 07h
    call writen
  pop ebx  
  mov ebx, [es:ebx + offset HeapRec.next]
  cmp ebx, HEAP_END_GLOBAL
  jb l_test_global_var_5

ret

KERNELDATASIZE = 0x10000 - 0x2000
uns1 LASTVAR
test_msg_kd1: db "\nKernel Data:\0"

test_kernel_data:
mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset test_msg_kd1
call strlen
mov bl, 0Ah
call s_write

mov eax, offset LASTVAR
mov ecx, 16
mov bl, 0Ah
call writen

mov eax, KERNELDATASIZE
mov ecx, 16
call writen

mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset test_msg_kd1
mov ecx, 1
mov bl, 0Ah
call s_write

ret

test_memory:

// MemInfo
mov esi, offset m_info
mov ecx, m_info_count

// (*
l_s_1:
push ecx

 push esi
  mov esi, offset test_msg_m
  call writec
 pop esi
 lodsd
 mov ecx, 16
 call writen
 lodsd
 mov ecx, 16
 call writen
 lodsd
 mov ecx, 16
 call writen
 lodsd
 mov ecx, 16
 call writen
 lodsd
 mov ecx, 16
 call writen
 lodsd
 mov ecx, 16
 call writen

pop ecx
loop l_s_1
// *)

mov esi, offset test_msg_m2
call writec
mov eax, m_lastbyte
mov ecx, 16
call writen

mov esi, offset test_msg_m3
call writec
mov eax, m_bitmap_base
mov ecx, 16
call writen

mov esi, offset test_msg_m4
call writec
mov eax, m_bitmap_size
mov ecx, 16
call writen

mov esi, offset test_msg_m5
call writec
mov eax, m_first_alloc
mov ecx, 16
call writen

// die
//test_memory_1: jmp test_memory_1

// Aloc, Free
mov esi, offset test_msg_m6
call writec

call m_alloc1
push esi
 mov eax, esi
 mov ecx, 16
 call writen

 call m_alloc1
 push esi
  mov eax, esi
  mov ecx, 16
  call writen

  mov cl, 1
  call m_alloc_dma
  push esi
   mov eax, esi
   mov ecx, 16
   call writen
/*
//$$$
push es
  mov dl, 14
  mov dh, 4
  push ds
  pop es
  mov edi, m_bitmap_base
  call writesect
pop es
*/
  pop esi
/*
  mov cl, 1
  call m_free_dma
  and eax, 255
  mov ecx, 10
  call writen
*/
 pop esi
/*
 call m_free1
 and eax, 255
 mov ecx, 10
 call writen
*/
pop esi
call m_free1
and eax, 255
mov ecx, 10
call writen

mov dl, 48
mov dh, 6
mov edi, m_bitmap_base
add edi, VA_SYSTEM
call writesect

mov esi, offset test_msg_nl2
call writec

// test getphysadr
mov ebx, 0x60000000
mov ecx, 4
call m_pages_alloc
movzx eax, al
mov ecx, 16
call writen

mov ebx, 0x60000000
call m_pages_getphysadr
mov eax, ebx
mov ecx, 16
call writen

mov ebx, 0x60000000 + 0x2000 + 1
call m_pages_getphysadr
mov eax, ebx
mov ecx, 16
call writen

mov ebx, 0x60000000 + 0x6000 + 1
call m_pages_getphysadr
mov eax, ebx
mov ecx, 16
call writen

// die
test_memory_1: jmp test_memory_1
ret


test_msg_m:   db "\nMem \0"
test_msg_m2:  db "\n\nm_lastbyte \0"
test_msg_m3:  db "\nm_bitmap_base \0"
test_msg_m4:  db "\nm_bitmap_size \0"
test_msg_m5:  db "\nm_first_alloc \0"
test_msg_m6:  db "\nAloc1 Aloc2 AlocDMA (FreeDMA Free2) Free1: \0"
test_msg_nl2: db "\n\n\0"

test_thread:
call p_create_thread
mov dword[es:edi + offset TssRec.eip], offset thread2
call p_start
ret

thread2:
sti
mov eax, cr3
mov ecx, 16
call writen

mov ecx, 5000
call p_sleep

mov ax, SELECTOR_TEXTVIDEO
mov es, ax
mov ax, 7120h
xor ebx, ebx
thread2_5:
  push eax
  pop eax
  mov [es:ebx], ax
  add al, 1
  add ebx, 2
  and ebx, 1023
  jmp thread2_5

testp1: db "/system/1.exe\0"
testp2: db "/system/2.exe\0"

test_process:

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset testp1
xor esi, esi
xor edi, edi
call p_create_process
movzx eax, al
mov ecx, 16
call writen

mov edi, [es:edi + offset ProcessRec.mainthread]
sub edi, VA_THREADS
shr edi, 12
call p_start

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset testp2
xor esi, esi
xor edi, edi
call p_create_process
movzx eax, al
mov ecx, 16
call writen

mov edi, [es:edi + offset ProcessRec.mainthread]
sub edi, VA_THREADS
shr edi, 12
call p_start

/*
call p_create_process
or al, al
jnz l_test_process_6

  mov edi, [es:edi + offset ProcessRec.mainthread]
  mov dword[es:edi + offset TssRec.eip], offset thread2
  call p_start
  
  call p_noop
  
  call test_msg
  jmp short l_test_process_9

l_test_process_6:
mov ecx, 16
call writen
*/

call test_msg

l_test_process_9:
ret

test_cd_str: db "system/keybs\0"
test_cd_str2: db "..\0"
test_cd_str3: db "/\0"

test_cd:
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset test_cd_str
call fs_cd

mov edi, p_current
mov eax, [es:edi + offset ThreadRec.curdir]
mov ecx, 16
call writen

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset test_cd_str2
call fs_cd

mov edi, p_current
mov eax, [es:edi + offset ThreadRec.curdir]
mov ecx, 16
call writen

mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset test_cd_str3
call fs_cd

mov edi, p_current
mov eax, [es:edi + offset ThreadRec.curdir]
mov ecx, 16
call writen

ret

test_search_1: db "e:/*m*\0"
test_search_2: db "\n\0"

uns1 temp

test_search:
mov ebx, 0x1000
mov ecx, 1
call m_pages_alloc

// First
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset test_search_1
mov edi, 0x1000
call fs_find_first

l_test_search_01:
  or al, al
  jnz near l_test_search_9
  
    mov esi, offset test_search_2
    call writec
    
    mov esi, 0x1000 + offset SearchRec.FileName
    
    l_test_search_1:
    mov al, [es:esi]
    or al, al
    jz l_test_search_2
      push esi
        mov temp, al
        mov esi, VA_SYSTEM + offset temp
        mov ecx, 1
        mov bl, 7
        call s_write
      pop esi
      inc esi
      jmp l_test_search_1
      
    l_test_search_2:
    
    // Next
    mov edi, 0x1000
    call fs_find_next
  
    jmp l_test_search_01
  
l_test_search_9:
//mov ecx, 16
//call writen //$$$

mov edi, p_current
call p_stop
ret

uns4 p1, p2, p3, p4

test_heap:
mov ecx, 0x18
call m_heap_alloc_local
mov p1, ebx

mov ecx, 0x1000
call m_heap_alloc_local
mov p2, ebx

call write_heap


mov ebx, p1
call m_heap_free_local

mov ecx, 0x40
call m_heap_alloc_local
mov p3, ebx

mov ecx, 0x10
call m_heap_alloc_local
mov p4, ebx

call write_heap


mov ebx, p3
call m_heap_free_local

mov esi, HEAP_START
mov edi, HEAP_END
mov ecx, 0xFFF0
call m_heap_alloc_aligned
mov p1, ebx

mov esi, offset msg_heap2
call writec

mov eax, edx
mov ecx, 16
call writen

mov ecx, 0x20
call m_heap_alloc_local
mov p2, ebx

call write_heap


mov ebx, p1
call m_heap_free_local

mov ecx, 0x10
call m_heap_alloc_local

call write_heap


call test_process

l_test_heap_9:
jmp l_test_heap_9
ret


msg_heap: db "\nHeap =\0"
msg_heap2: db " aligned\0"


write_heap:
mov esi, offset msg_heap
call writec

mov esi, HEAP_START
mov edi, HEAP_END

l_write_heap_1:
cmp esi, edi
jnb l_write_heap_2
  mov eax, esi
  mov ecx, 16
  call writen
  
  mov eax, [es:esi + offset HeapRec.size]
  mov ecx, 16
  call writen
  
  mov esi, [es:esi + offset HeapRec.next]
  jmp l_write_heap_1
  
l_write_heap_2:
ret

test_merge1: db "../dir1/../dir4\0"
test_merges: db "c:/dir2/dir3\0"

test_merge:
sub esp, MAX_PATH

mov esi, p_current
add esi, offset ThreadRec.curdirtext

push esi
  mov edi, esi
  mov esi, offset test_merges + PA_KERNEL_CODE
  mov ecx, 13
  rep movsb
pop esi

// IN: es:esi -> str, ecx = len, bl = color
push esi
  mov ecx, 80
  mov bl, 1Bh
  call s_write
pop esi

mov edi, esp
mov edx, offset test_merge1 + VA_SYSTEM + PA_KERNEL_CODE

call fs_merge
or al, al
jnz l_test_merge_9

// IN: es:esi -> str, ecx = len, bl = color
mov esi, esp
mov ecx, 80
mov bl, 1Eh
call s_write

l_test_merge_9:
jmp l_test_merge_9

add esp, MAX_PATH
ret

msg_chmod1: db "/system/starter.exe\0"

test_chmod:
mov edx, VA_SYSTEM + PA_KERNEL_CODE + offset msg_chmod1
mov esi, 14h
call fs_chmod

movzx eax, al
mov ecx, 16
call writen

ret

test_timer:
// IN: ecx = ms, edx = tcb:number
// OUT: al = 0 || errorcode, esi = base
// DESTROY: eax, ecx, edx, ebx, edi

//cli

mov esi, PA_TMR
mov ecx, 0x800
mov edx, 10000h  // threadid = 1
call h_timer_add

mov esi, PA_TMR
mov ecx, 0x5000
mov edx, 0  // threadid = 0
call h_timer_add

mov esi, PA_TMR
mov ecx, 0x300
mov edx, 30000h
call h_timer_add

mov esi, PA_TMR
mov ecx, 0x600
mov edx, 0
call h_timer_add

mov esi, PA_TMR
mov ecx, 0x20
mov edx, 0
call h_timer_add

call tmr_write

mov edi, p_current
call h_timer_remove_all

call tmr_write

l_timer_9: jmp l_timer_9
ret


msg_tmr_nl: db 1, "\n"

tmr_write:
pushfd
cli
mov esi, PA_TMR
mov edx, tmr_len
add edx, esi
l_tmr_write_5:
  cmp esi, edx
  jnb l_tmr_write_8
    mov eax, [esi]
    mov ecx, 16
    call writen
    
    mov eax, [esi + 4]
    mov ecx, 16
    call writen

    mov eax, [esi + 8]
    mov ecx, 16
    call writen

    mov eax, [esi + 12]
    mov ecx, 16
    call writen
    
    push esi
      mov esi, offset msg_tmr_nl
      call writec
    pop esi
    add esi, sizeof TmrRec
    jmp short l_tmr_write_5
    
l_tmr_write_8:
mov esi, offset msg_tmr_nl
call writec
popfd
ret

pci_str1: db "\nBUS\0"
pci_str2: db " SLOT\0"
pci_str3: db " FN\0"
pci_str4: db " =\0"

test_pci:
mov ch, 0
mov cl, 0
mov dh, 0
xor edi, edi

test_pci_5:
  mov edx, edi
  mov dh, dl  // dh = slot & function
  mov dl, 0
  call h_pci_get
  cmp eax, -1
  jz near test_pci_x
    push edi
     push eax
      push edx
       push ecx
        mov esi, offset pci_str1
        call writec
       pop ecx
       push ecx
        movzx eax, ch
        mov ecx, 16
        call writen
        mov esi, offset pci_str2
        call writec
       pop ecx
      pop edx
      push edx
       push ecx
        movzx eax, dh
        shr eax, 3
        mov ecx, 16
        call writen
        mov esi, offset pci_str3
        call writec
       pop ecx
      pop edx
      push edx
       push ecx
        movzx eax, dh
        and eax, 7
        mov ecx, 16
        call writen
        mov esi, offset pci_str4
        call writec
       pop ecx
      pop edx
     pop eax
    pop edi
    
    push ecx
     mov ecx, 16
     call writen  // device/vendor
    pop ecx
    mov dl, 0Ch
    call h_pci_get
    push ecx
      shr eax, 16
      movzx eax, al
      mov ecx, 16
      call writen  // header (80h = multifn)
    pop ecx
    mov dl, 8
    call h_pci_get
    push ecx
      mov ecx, 16
      call writen  // class/subclass/prog if/revision
    pop ecx
    mov dl, 24h
    call h_pci_get
    push ecx
      mov ecx, 16
      call writen  // BAR5
    pop ecx
  
  test_pci_x:
  inc edi
  cmp edi, 256
  jb near test_pci_5

test_pci_9: jmp test_pci_9
ret

test_sd:
/*
// test cd
mov ebx, 1

mov word ptr cd_packet[0], SCSI_COMMAND_READ10
mov eax, ebx
shr eax, 16
mov byte ptr cd_packet[2], ah
mov byte ptr cd_packet[3], al
mov byte ptr cd_packet[4], bh
mov byte ptr cd_packet[5], bl
mov byte ptr cd_packet[6], 0
mov byte ptr cd_packet[7], 1 / 256
mov byte ptr cd_packet[8], 1 & 255
mov byte ptr cd_packet[9], 0
mov word ptr cd_packet[10], 0
mov hdt_pdiskn, 61h
call h_sd_p_cd_read
movzx eax, al
mov ecx, 16
call writen

mov dl, 40
mov dh, 6
//mov edi, VA_SD + RA_SD_BUFFER
mov edi, VA_SYSTEM + offset cd_buffer
call writesect
lsdcd9: jmp lsdcd9
*/

// write info
mov eax, abar
mov ecx, 16
call writen
mov ebx, abar
add ebx, 100h
call m_phys_get
mov ecx, 16
call writen
mov ebx, abar
add ebx, 108h
call m_phys_get
mov ecx, 16
call writen
//l1:jmp l1

// make some dirt
mov edi, VA_SD + RA_SD_BUFFER
mov eax, 1234h
mov [es:edi], eax

// IN: edx:ebx = sector, ecx = count, es:edi -> buffer,
//     hdt_pdiskn
// OUT: edx:ebx = next sector
// DESTROY: eax, ecx, hdt_high, hdt_count_remain
mov hdt_pdiskn, 40h
xor edx, edx
mov ebx, 0
mov ecx, 1
mov edi, VA_SYSTEM + offset hd_buffer
call h_sd_p_read

/*
mov hdt_pdiskn, 40h
xor edx, edx
mov ebx, 0
mov ecx, 1
mov edi, VA_SYSTEM + PA_KERNEL_CODE
call h_sd_p_write
*/

mov dl, 40
mov dh, 6
//mov edi, VA_SD + RA_SD_BUFFER
mov edi, VA_SYSTEM + offset hd_buffer
call writesect

lsd9: jmp lsd9
ret

tg1:
dd 8
dd 20

dd 0,0,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080
dd 0,0,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080

dd 0x80808080,0x80808080,0x80808080,0x80808080,0x80808080,0x80808080,0x80808080,0x80808080
dd 0x80808080,0x80808080,0x80808080,0x80808080,0x80808080,0x80808080,0x80808080,0x80808080
dd 0x80808080,0x80808080,0x80808080,0x80808080,0x80808080,0x80808080,0x80808080,0x80808080
dd 0x80808080,0x80808080,0x80808080,0x80808080,0x80808080,0x80808080,0x80808080,0x80808080

dd 0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080
dd 0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080
dd 0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080
dd 0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080,0xC0808080

dd 0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080
dd 0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080
dd 0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080
dd 0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080,0xFF808080

times 8*20*4, 0


test_graphic:
/*
// Copy bg to screen
xor eax, eax
mov ax, 100
mov g_x1, ax
mov g_y1, ax

mov ax, g_info.xres
dec eax
sub eax, 100
mov g_x2, ax

mov ax, g_info.yres
dec eax
sub eax, 100
mov g_y2, ax

mov esi, g_bg
call g_full2scr

// Paint window
mov g_x1, 50
mov g_y1, 20
mov g_x2, 400
mov g_y2, 200

call g_copybg

mov g_x, 60
mov g_y, 100
mov esi, VA_SYSTEM + PA_KERNEL_CODE + offset tg1
xor edi, edi
call g_merge

mov esi, g_tmp
call g_full2scr
*/

/*
// create window
mov wcount, 1
mov wpos[0], 0
xor esi, esi
mov win.flags[esi], WINFLAGS_VALID
mov eax, cr3
mov win.cr3[esi], eax
mov win.hwnd[esi], 0
mov win.pbitmap[esi], VA_SYSTEM + PA_KERNEL_CODE + offset tg1
mov win.x[esi], 60
mov win.y[esi], 100
mov win.w[esi], 8
mov win.h[esi], 20
*/

// paint screen
mov ecx, 0
mov ebx, 0
mov esi, 639
mov edi, 479
call g_paint

//l_test_graphic_8: jmp short l_test_graphic_8
ret

